﻿; PB-ColorTool.pb
; 2016-09-16, Omi (Oma), w. color-picker-routines by wilbert, PureLust, netmaestro, infratec, idle
; for PB5.4x (Linux Gtk3)
;
; Installation: place in ...
; folder/
;       /PB_NamedColorLists.pb
;       /PB-ColorTool.pb
; set in 'Compiler options' / Compile/Run /
;       "Create temporary executable in the source directory"
;
;TODO; add, check & rework
;  -  improve search algorithm at the color limits (+/- tol., at the limits, dominant primary color) ?
;  -  check color picker on newer Windows, Macs (64-Bit) & more monitors
;  -  catching errors (esp. in color-list)
;  -  Input-check by RegEx ?
;  -  Colors in LIG as images, not text-background? (not invisible if selected)
;  -  Popup items disable ?
;  -  HSV, HSL-conversion ?
;  -  Change 'Compare panels from TextGadgets to Canvas. color in TextGadgets might be wrong with KDE etc.
;  -  Settings
;     + Mode: Deactivate picker after each pick
;     (- Search on DClick off)
;     + Sort list in LinkedList -> API needed for LIG-Header-Click -> Mac ? -> temp. done by popup on selection free LIG1
;     + Pref file:
;       + window coord.
;       + tolerance
;       + preset DQuotes
;       + fold state of data fields
;       + SOT
;       (- Fullrowselect in results (windows) - now always on)
;       + picker state
;       (- DClickSearch ON/OFF)
;     

EnableExplicit

;*** Macro "GtkSubSystem" return the Linux-SubSystem as string: 'gtk2' | 'gtk3'... ***
CompilerIf #PB_Compiler_OS = #PB_OS_Linux
	CompilerIf #PB_Compiler_Version >= 540
		CompilerIf Subsystem("gtk2")
			Macro GtkSubSytem : "gtk2" : EndMacro
		CompilerElse
			Macro GtkSubSytem : "gtk3" : EndMacro
		CompilerEndIf
	CompilerElse
		CompilerIf #PB_Compiler_Version < 400
			Debug "No Macros available on PB < 4.0" : End
		CompilerEndIf
		CompilerIf Subsystem("gtk3")
			Macro GtkSubSytem : "gtk3" : EndMacro
		CompilerElse
			Macro GtkSubSytem : "gtk2" : EndMacro
		CompilerEndIf
	CompilerEndIf
CompilerElse
	Macro GtkSubSytem : "" : EndMacro
CompilerEndIf

;- IMPORTS
CompilerIf #PB_Compiler_OS = #PB_OS_Linux
	CompilerIf GtkSubSytem= "gtk2"
		MessageRequester("", "Use gtk3 subsystem!" + #LF$ + "Programm terminated.")
		End	
	CompilerEndIf
	ImportC ""
		;color picker
		gdk_pixbuf_get_from_window(*window, x, y, width, height); gtk3
		gdk_pixbuf_get_pixels(*pixbuf)
		;spingadget
		gtk_adjustment_new(value.d, lower.d, upper.d, step_increment.d, page_increment.d, page_size.d)
		gtk_spin_button_new(*adjustment.GtkAdjustment, climb_rate.d, digits.i)
		gtk_spin_button_new_with_range(min.d, max.d, step_.d)
		gtk_spin_button_set_increments(*spin_button.GtkSpinButton, step_.d, page.d)
		gtk_spin_button_get_value.d(*widget.GtkWidget)
		gtk_entry_set_alignment(*entry.GtkEntry, xalign.f)
		g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
		gtk_widget_set_tooltip_text(*widget.GtkWidget, text.p-utf8)
	EndImport
CompilerElseIf #PB_Compiler_OS = #PB_OS_MacOS
	ImportC ""
		CGBitmapContextCreate(*bdata, width, height, bitsPerComponent, bytesPerRow, cs, bitmapInfo)
		CGColorSpaceCreateDeviceRGB()
		CGColorSpaceRelease(cs)
		CGContextRelease(c)
		CGImageRelease(image) 
	EndImport
CompilerEndIf


;- CONSTANTS
;- - Window
#Win_Main  = 0

;- - Gadgets
Enumeration Gadget
	#CBG_ColList
	#BIG_Settings
	
	#LIG1;                                                             color list & results (found colors) lists
	#LIG2
	#TxG_SrchBkgnd
	#TxG_CompBkgnd
	#IgG_ArrowU
	#IgG_L2D
	#IgG_R2D
	
	#StG_FndName;                                                      search gadgets
	#BIG_FndName
	#BIG_FndSelection
	#CBG_FndVal
	#BIG_FndVal
	#BIG_ArrBowL2B
	#IgG_ArrowL
	#BIG_Pipette
	#TxG_PickColor
	#IgG_Bracket
	#SpG_Tol
	#CvG_VFold
	
	#Frm_Data;                                                         data section
	#CtG_Data
	#StG_PbConst
	#StG_PbHexCol
	#StG_PbCol
	#StG_PbColAlpha
	#StG_ColCSS
	#StG_NameCSS
	#StG_ColRGB
	#StG_ColRGBA
	#BIG_DQuote
EndEnumeration


;- - Images
Enumeration Images
	#Img_Find1
	#Img_Find2
	#Img_Find3
	#Img_Settings
	#Img_Pipette
	#Img_Bracket
	#Img_Fold
	#Img_DQuote
	#Img_ArrowLImg
	#Img_ArrowBowfLtD
	#Img_ArrowBowfLtD2
	#Img_ArrowBowfRtD
	#Img_ArrowUImg
EndEnumeration

;- - Popups
Enumeration;                                                         Popup 'settings', left LIG
	#PuInfo
	#PuInf_AboutApp
	#PuInf_SortHdLine
	#PuInf_SortByName
	#PuInf_SortByValue
	#PuInf_Settings
	#PuInf_WinSOT
	#PuInf_PickerRst
	#PuInf_ColorSpy
EndEnumeration

Enumeration #PB_Compiler_EnumerationValue;                           Popup 'list sort', left LIG
	#PuSort
	#PuSort_HdLine
	#PuSort_ByName
	#PuSort_ByValue
EndEnumeration

Enumeration #PB_Compiler_EnumerationValue
	#PuCListL;                                                         Popup 'color list', left LIG
	#PuClL_CopySel
	#PuClL_CpPbConstname
	#PuClL_CpPbConstDef
	#PuClL_CpPbConstADef
	#PuClL_CpPbHxValue
	#PuClL_CpPbHxAValue
	#PuClL_CpHxValue
	#PuClL_CpCName
	#PuClL_CpRGB
	#PuClL_CpRGBA
	
	#PuClL_CopyLst
	#PuClL_CpLstAddComnt
	#PuClL_CpLstHxValue
	#PuClL_CpLstHxAValue
	
	#PuCListR;                                                         Popup 'found colors' list, right LIG
	#PuClR_CopySel
	#PuClR_CpPbConstname
	#PuClR_CpPbConstDef
	#PuClR_CpPbConstADef
	#PuClR_CpPbHxValue
	#PuClR_CpPbHxAValue
	#PuClR_CpHxValue
	#PuClR_CpCName
	#PuClR_CpRGB
	#PuClR_CpRGBA
	
	#PuClR_ScrlToInCLst
	#PuClR_SelInCLst
	#PuClR_SelInCLstAData
	#PuClR_Sel2Data
EndEnumeration

;- - Others
#App_Name  = "PB-ColorScout"
#HexChars  = "0123456789ABCDEF"
#IntChars  = "0123456789"
#TimerCSpy = 999
#PeriodCSpy= 100

;colors for UI (w/o alpha) ...
#LOff_Palegreen   = $CCFFCC
#VGA_Black        = $000000
#VGA_BrightCyan   = $FFFF55
#VGA_BrightRed    = $5555FF
#VGA_White        = $FFFFFF

;colors for images (with alpha) ...   
#CSS_Black        = $FF000000
#CSS_DarkTurquoise= $FFD1CE00
#CSS_Deepskyblue  = $FFFFBF00
#CSS_FireBrick    = $FF2222B2
#CSS_ForestGreen  = $FF228B22
#CSS_Gray         = $FF808080
#CSS_LightBlue    = $FFE6D8AD
#CSS_Red          = $FF0000FF
#CSS_RoyalBlue    = $FFE16941
#CSS_White        = $FFFFFFFF
#X11_Red3         = $FF0000CD
#X11_Skyblue3     = $FFCDA66C
#X11_Steelblue4   = $FF8B6436
#X11_Tomato       = $FF4763FF

;- GLOBALs
Global.i gEvent, gEventWin, gEventType, gEventMenu, gQuit
Global.i gPrevColor    = -1
Global.i gTempColor    = -1
Global.i gPrevCbGValue = -1
Global.i gListExpWComnt= #True
Global.i gSOT          = #False
Global.i gPickRst      = #False
Global.i gPrevSearch   = -1
Global.i gColorSpy     = #False
Global.i gSpGTol;                                                    (for Linux instead #SpG_Tol)
Global.s gErrorMessage

;- STRUCTURES
Structure COLORDATA
	PbColor.i;                                                         i.e. 4294901760 or -65536
	sPbHColor.s;                                                       i.e. $FF0000
	sPbHColorAlpha.s;                                                  i.e. $FFFF0000
	PbConstName.s;                                                     i.e. CSS_Blue
	ColorName.s;                                                       i.e. Blue
	HexColor.s;                                                        i.e. #0000FF
	RgbColor.s;                                                        i.e. rgb(255,  0,  0)
	RgbaColor.s;                                                       i.e. rgba(255,  0,  0, 255)
EndStructure

Structure COLORLIST
	List ColorList.COLORDATA()
	Prefix.s;                                                          i.e. #CSS_
	Info.s;                                                            description behind #CSS_*;
EndStructure
Global Dim cListName.COLORLIST(0)

Structure PREFERENCE
	WinX.i;                                                            Window x
	WinY.i;                                                            Window y
	WinW.i;                                                            Window width
	WinH.i;                                                            Window height
	Sticky.i;                                                          Window stay on top (sticky)
	CListIdx.i;                                                        Index of Color list ComboBox
	CTol.i;                                                            color tolerance for search
	CSpyOn.i;                                                          color spy on picker
	PickRst.i;                                                         reset button after each pick action
	DQuoteOn.i;                                                        Doublequote for some data in block
EndStructure
Global Pref.PREFERENCE

;- DECLAREs
Declare   Color_Copy2DataFields(Gadget, fSelection= -1)
Declare   Colors_CopyInLIG(ColSet)
Declare.i Colors_FindName(cName.s= "", SelectIt= #False)
Declare.s Color_PbVal2PbHex(Value.i)


;- FONTs
LoadFont(0, "Monospace", 10)

;- POPUPs
;- - ColorList
CreatePopupMenu(#PuCListL)
MenuItem(#PuClL_CopySel,        "Copy selection-color-data to clipboard ...")
DisableMenuItem(#PuCListL,      #PuClL_CopySel, #True)
MenuItem(#PuClL_CpPbConstname,  "PB-Constant name [#CSS_Beige]")
MenuItem(#PuClL_CpPbConstDef,   "PB-Constant definition [#CSS_Beige= $DCF5F5]")
MenuItem(#PuClL_CpPbConstADef,  "PB-Constant alpha def. [#CSS_Beige= $FFDCF5F5]")
MenuItem(#PuClL_CpPbHxValue,    "PB-HEX value [$bbggrr]")
MenuItem(#PuClL_CpPbHxAValue,   "PB-HEX alpha-value [$aabbggrr]")
MenuItem(#PuClL_CpHxValue,      "HEX-value [#rrggbb]")
MenuItem(#PuClL_CpCName,        ~"Color name [\"beige\"]")
MenuItem(#PuClL_CpRGB,          "RGB(,,)-value")
MenuItem(#PuClL_CpRGBA,         "RGBA(,,)-value")
MenuBar()
MenuItem(#PuClL_CopyLst,        "Copy curr. color-list to clipboard ...")
DisableMenuItem(#PuCListL,      #PuClL_CopyLst, #True)
MenuItem(#PuClL_CpLstAddComnt,  "Add commented data to defintion?")
MenuItem(#PuClL_CpLstHxValue,   "Constants + PB-HEX values")
MenuItem(#PuClL_CpLstHxAValue,  "Constants + PB-HEX alpha values")

;- - FoundColors (results)
CreatePopupMenu(#PuCListR)
MenuItem(#PuClR_CopySel,        "Copy selection-color-data to clipboard ...")
DisableMenuItem(#PuCListR,      #PuClR_CopySel, #True)
MenuItem(#PuClR_CpPbConstname,  "PB-Constant name [#CSS_Beige]")
MenuItem(#PuClR_CpPbConstDef,   "PB-Constant definition [#CSS_Beige= $DCF5F5]")
MenuItem(#PuClR_CpPbConstADef,  "PB-Constant alpha def. [#CSS_Beige= $FFDCF5F5]")
MenuItem(#PuClR_CpPbHxValue,    "PB-HEX value [$bbggrr]")
MenuItem(#PuClR_CpPbHxAValue,   "PB-HEX alpha-value [$aabbggrr]")
MenuItem(#PuClR_CpHxValue,      "HEX-value [#rrggbb]")
MenuItem(#PuClR_CpCName,        ~"Color name [\"beige\"]")
MenuItem(#PuClR_CpRGB,          "RGB(,,)-value")
MenuItem(#PuClR_CpRGBA,         "RGBA(,,)-value")
MenuBar()
MenuItem(#PuClR_ScrlToInCLst,   "Scroll color list to selection")
MenuItem(#PuClR_SelInCLst,      "Transfer selection to color list")
MenuItem(#PuClR_SelInCLstAData, "Transfer selection to color list + data fields")
MenuItem(#PuClR_Sel2Data,       "Transfer selection to data fields")

;- - Settings
CreatePopupMenu(#PuInfo)
MenuItem(#PuInf_AboutApp,       "About ...")
MenuBar()
MenuItem(#PuInf_SortHdLine,     "Sort current color List ...")
MenuItem(#PuInf_SortByName,     "by name")
MenuItem(#PuInf_SortByValue,    "by value")
MenuBar()
MenuItem(#PuInf_Settings,       "Settings ...")
MenuItem(#PuInf_WinSOT,         "Window stay on top")
MenuItem(#PuInf_PickerRst,      "'Button off' after each colorpick")
MenuItem(#PuInf_ColorSpy,       "'Color-Spy on' with colorpicker")
DisableMenuItem(#PuInfo,        #PuInf_SortHdLine, #True)
DisableMenuItem(#PuInfo,        #PuInf_Settings,   #True)

;- - Sort
CreatePopupMenu(#PuSort)
MenuItem(#PuSort_HdLine,        "Sort list ...")
MenuItem(#PuSort_ByName,        "by name")
MenuItem(#PuSort_ByValue,       "by value")
DisableMenuItem(#PuSort,        #PuSort_HdLine, #True)


;-
;- ICON Help Macros & Procs _______________________
Procedure.d Max(A.d, B.d)
	Protected Ret.d= B
	If A > B: Ret= A: EndIf
	ProcedureReturn Ret
EndProcedure

Procedure.d Min(A.d, B.d)
	Protected Ret.d= B
	If A < B: Ret= A: EndIf
	ProcedureReturn Ret
EndProcedure

Procedure.d Squeeze(Val.d, Min.d, Max.d)
	Val= Max(Val, Min)
	Val= Min(Val, Max)
	ProcedureReturn Val
EndProcedure

Procedure.i Color_Darken(Color.i, Fact.d)
	; [by Oma, 2016-04-21]
	Protected.i Red, Green, Blue, Alpha
	
	If Fact > 1.0 : Fact = 1.0 : EndIf
	Alpha = Alpha(Color)
	Red   = Red(Color)   * Fact
	Green = Green(Color) * Fact
	Blue  = Blue(Color)  * Fact
	
	ProcedureReturn RGBA(Red, Green, Blue, Alpha)
EndProcedure

Macro DrawMagnifyingGlass (_x_, _y_, _size_, _color1_, _color2_, _reflection_=#False)
	; [by Little John]
	
	MovePathCursor(_x_+0.39*_size_, _y_+0.61*_size_)
	AddPathLine   (_x_+0.08*_size_, _y_+0.92*_size_)
	StrokePath    (0.16 * _size_)
	
	VectorSourceColor(_color1_)
	AddPathCircle(_x_+0.65*_size_, _y_+0.35*_size_, 0.29*_size_)
	StrokePath   (0.07 * _size_)
	
	If _reflection_
		VectorSourceColor(_color2_)
		AddPathCircle(_x_+0.65*_size_, _y_+0.35*_size_, 0.17*_size_, -90.0, 0.0)
		StrokePath   (0.057 * _size_)
	EndIf
EndMacro

Macro ArrowBow(_color_, _rotation_, _flip_)
	If _flip_     : FlipCoordinatesY(p2)                : EndIf
	If _rotation_ : RotateCoordinates(p2, p2, rotation) : EndIf
	VectorSourceColor(#CSS_White)
	
	For I= 1 To 2
		MovePathCursor(p * 19, p * 7)
		AddPathLine   (p * 31, p * 19)
		AddPathLine   (p * 19, p * 31)
		ClosePath     ()
		FillPath      ()
		
		MovePathCursor(p4,     p)
		AddPathArc    (p4,     p * 19, p * 21, p * 19, p * 11)
		AddPathLine   (p * 24, p * 19)
		StrokePath    (p * 10)
		RotateCoordinates(p2, p2, -rotation)
		If flip
			TranslateCoordinates(-1, 1)
		Else
			TranslateCoordinates(-1, -1)
		EndIf
		RotateCoordinates(p2, p2, rotation)
		VectorSourceColor(color)
	Next I
EndMacro

Macro GradientFullsize_LT2RB(_colorbright_, _darken_)
	VectorSourceLinearGradient(0, 0, size, size)
	VectorSourceGradientColor (_colorbright_, 0.0)
	VectorSourceGradientColor (Color_Darken(_colorbright_, _darken_), 1.0)
EndMacro

Macro Cog()
	MovePathCursor(px - 3 * p, py + p * 0.5)
	AddPathLine   (px - 2 * p, py)
	AddPathLine   (px - p,     py - 3 * p)
	AddPathLine   (px + p,     py - 3 * p)
	AddPathLine   (px + 2 * p, py)
	AddPathLine   (px + 3 * p, py + p * 0.5)
EndMacro
;-
;- ICONs _______________________
Procedure.i CreateImg_Arrow(Image, Color, Rotation= -90.0)
	; by StarBootics
	Protected.d p2, p16, x1, x2, y
	Protected.i I, size= 16 
	
	If CreateImage(Image, 16, 16, 32, #PB_Image_Transparent)
		If StartVectorDrawing(ImageVectorOutput(Image, #PB_Unit_Pixel))
			p2 = size / 2.0
			p16= size / 16
			x1 = 0.1   * size
			x2 = 0.9   * size
			y  = 0.875 * p2
			
			TranslateCoordinates(1, 1)
			RotateCoordinates(p2, p2, rotation)
			VectorSourceColor(#CSS_White)
			For I= 0 To 1
				MovePathCursor(p2, 0)
				AddPathLine   (x1, y)
				AddPathLine   (x2, y)
				ClosePath()
				FillPath()
				MovePathCursor(p2, y)
				AddPathLine   (p2, size - p16)
				StrokePath    (size / 3)
				If rotation : RotateCoordinates(p2, p2, -rotation) : EndIf
				TranslateCoordinates(-1, -1)
				If rotation : RotateCoordinates(p2, p2, rotation) : EndIf
				VectorSourceColor(Color)
			Next I
			
			StopVectorDrawing()
		Else
			FreeImage(Image)
		EndIf
	EndIf
	ProcedureReturn ImageID(Image)
EndProcedure

Procedure.i CreateImg_ArrowBow(Image, Color, Rotation.d= 0, Flip.i= #True)
	; [Omi]
	Protected.i I, size= 16
	Protected.d p  = size / 32
	Protected.d p2 = size / 2
	Protected.d p4 = size / 4
	
	If CreateImage(Image, 16, 16, 32, #PB_Image_Transparent)
		If StartVectorDrawing(ImageVectorOutput(Image, #PB_Unit_Pixel))
			ArrowBow(color, rotation, flip)
		
			StopVectorDrawing()
		Else
			FreeImage(Image)
		EndIf
	EndIf
	ProcedureReturn ImageID(Image)
EndProcedure

Procedure.i CreateImg_Find(Image, flipHorizontally.i=#False)
	; [by Little John]
	If CreateImage(Image, 16, 16, 32, #PB_Image_Transparent)
		If StartVectorDrawing(ImageVectorOutput(Image, #PB_Unit_Pixel))
				If flipHorizontally
				  FlipCoordinatesX(8)
				EndIf
				VectorSourceColor(#CSS_White)
				DrawMagnifyingGlass(-1, 1, 16, #CSS_White, #CSS_White, #True)
				VectorSourceColor  (#CSS_Black)
				DrawMagnifyingGlass(0, 0, 16, #X11_Steelblue4, #CSS_Gray, #True)
				
				StopVectorDrawing()
		Else
			FreeImage(Image)
		EndIf
	EndIf
	ProcedureReturn ImageID(Image)
EndProcedure

Procedure.i CreateImg_Dquote(Image)
	;Omi
	Protected.i size= 16
	Protected.d p   = size / 32
	
	If CreateImage(Image, 16, 16, 32, #PB_Image_Transparent)
		If StartVectorDrawing(ImageVectorOutput(Image, #PB_Unit_Pixel))
			
			VectorSourceColor(#X11_Red3)
			MovePathCursor(p * 8,  p * 3)
			AddPathLine   (0,      p * 9, #PB_Path_Relative)
			AddPathLine   (p * 2, -p * 9, #PB_Path_Relative)
			ClosePath     ()
			MovePathCursor(p * 20, p * 3)
			AddPathLine   (0,      p * 9, #PB_Path_Relative)
			AddPathLine   (p * 2, -p * 9, #PB_Path_Relative)
			ClosePath     ()
			StrokePath    (p * 4, #PB_Path_RoundCorner)
				
			StopVectorDrawing()
		Else
			FreeImage(Image)
		EndIf
	EndIf
	ProcedureReturn ImageID(Image)
EndProcedure

Procedure.i CreateImg_Settings(Image)
	; [slightly modified after davido]
	Protected.i size= 16, M
	Protected.d d, p, h, px, py
	
	h = size / 2
	p = size / 32
	d = 9 * p
	px= h
	py= h - d
	
	If CreateImage(Image, 16, 16, 32, #PB_Image_Transparent)
		If StartVectorDrawing(ImageVectorOutput(Image, #PB_Unit_Pixel))
			GradientFullsize_LT2RB(#X11_Skyblue3, 0.5)
			
			AddPathCircle(h, h, d)
			StrokePath   (p * 4)
			ResetCoordinates()
			Cog()
			For M = 1 To 7
				RotateCoordinates(h, h, 45)
				Cog()
			Next M
			StrokePath(p * 3)
			
			StopVectorDrawing()
		Else
			FreeImage(Image)
		EndIf
	
	EndIf
	ProcedureReturn ImageID(Image)
EndProcedure

Procedure.i CreateImg_Pipette(Image)
	;Omi
	Protected.i size= 16
	Protected.d p   = size / 32.0
	Protected.d p2  = size / 2
	
	If CreateImage(Image, 16, 16, 32, #PB_Image_Transparent)
		If StartVectorDrawing(ImageVectorOutput(Image, #PB_Unit_Pixel))
			RotateCoordinates   (8,   8, 45.0)
			ScaleCoordinates    (1.2, 1.2)
			TranslateCoordinates(-1, -1)
			;bubble...
			VectorSourceColor(#X11_Red3)
			AddPathCircle (p2, p * 5, p * 5)
			FillPath      ()
			;body frame...
			VectorSourceColor(#CSS_RoyalBlue)
			AddPathBox    (p * 13.5, p * 11, p * 5, p * 14.5)
			StrokePath    (p)
			;bubble collar...
			VectorSourceColor(#CSS_Red)
			MovePathCursor(p2,     p *  9)
			AddPathLine   (0,      p * 2, #PB_Path_Relative)
			StrokePath    (p * 6)
			;body...
			VectorSourceColor(#CSS_LightBlue)
			MovePathCursor(p2,     p * 11)
			AddPathLine   (0,      p * 15, #PB_Path_Relative)
			StrokePath    (p * 5)
			;tip
			VectorSourceColor(#CSS_RoyalBlue)
			MovePathCursor(p * 13.5, p * 26)
			AddPathLine   (p2,       p * 32)
			AddPathLine   (p * 18.5, p * 26)
			ClosePath     ()
			FillPath      ()
			;tip top
			MovePathCursor(p * 15,   p * 29.5)
			AddPathLine   (p * 15.5, p * 32)
			AddPathLine   (p * 16.5, p * 32)
			AddPathLine   (p * 17,   p * 29.5)
			ClosePath     ()
			FillPath      ()
			
			StopVectorDrawing()
		Else
			FreeImage(Image)
		EndIf
	EndIf
	ProcedureReturn ImageID(Image)
EndProcedure

Procedure.i CreateCanvas_FoldDown(Canvas, Width, Color)
		If StartDrawing(CanvasOutput(Canvas))
			DrawingMode(#PB_2DDrawing_AlphaChannel)
			Box        (0, 0, Width - 32, 6, $0)
			DrawingMode(#PB_2DDrawing_AllChannels)
			RoundBox   (0, 0, Width - 32, 6, 2, 2, Color)
		
			StopDrawing()
		EndIf
	ProcedureReturn
EndProcedure

Procedure.i CreateImg_BracketCurly(Image, Color, Open=#False)
	; [org. by Omi]
	Protected.i size= 60
	Protected.d w   = size / 60
	Protected.d h   = size / 60
	Protected.d p2  = size / 2
	
	If CreateImage(Image, 14, 60, 32, #PB_Image_Transparent)
		If StartVectorDrawing(ImageVectorOutput(Image, #PB_Unit_Pixel))
			If Open
				FlipCoordinatesX(p2)
			EndIf
			VectorSourceColor(Color)
			MovePathCursor(w * 1.5,  h * 1.5)
			AddPathCurve  (w * 10.5, h *  5, w * 1.5 , h * 25, w * 10.5, p2)
			AddPathCurve  (w * 1.5,  h * 36, w * 10.5, h * 55, w * 1.5,  h * 58.5)
			StrokePath    (w * 3, #PB_Path_Preserve | #PB_Path_RoundEnd)
			
			StopVectorDrawing()
		Else
			FreeImage(Image)
		EndIf
	EndIf
	ProcedureReturn ImageID(Image)
EndProcedure

;-
;- Utilities _________________________
Procedure Entry_Blink(sGadget, Color);                               blocking way!
	SetGadgetColor(sGadget, #PB_Gadget_BackColor, Color)
	While WindowEvent() : Wend
	Delay(100)
	SetGadgetColor(sGadget, #PB_Gadget_BackColor, -1)
EndProcedure

Procedure.s String_RemoveQuotes(S.s, Remove= 0)
	If Remove : S= Trim(S, #DQUOTE$) : EndIf
	ProcedureReturn S
EndProcedure

Procedure.i String_IsNaturalNum(sString.s)
	Protected.i I, Natural= #True
	
	For I= 1 To Len(sString)
		If Not FindString(#IntChars, Mid(sString, I, 1))
			Natural= #False
			Break
		EndIf
	Next I
	If Natural
		If Len(sString) < 9
			If Val(sString) > $FFFFFF
				Natural = #False
				MessageRequester(#App_Name, "Value is too high!" + #LF$ + "Max. 16'777'215")
			Else
				SetGadgetText(#CBG_FndVal, Color_PbVal2PbHex(Val(sString)))
			EndIf
		Else
			Natural = #False
		EndIf
	EndIf
	If sString = "" : Natural= #False : EndIf
; 	If Natural = #False : SetGadgetText(#CbG_FndVal, "") : EndIf
	ProcedureReturn Natural
EndProcedure

Procedure.i PbHex_StringIsInvalid(sString.s)
	Protected.i I, InvalidHex= #False
	
	If sString <> ""
		If Len(sString) <> 7 Or Left(sString, 1) <> "$"
			InvalidHex= #True
		EndIf
		If Not InvalidHex
			For I= 2 To 7
				If Not FindString(#HexChars, UCase(Mid(sString, I, 1)))
					InvalidHex= #True
					Break
				EndIf
			Next I
		EndIf
		If InvalidHex : MessageRequester(#App_Name, "Invalid Hex string!" + #LF$ + "Function canceled.") : EndIf
	EndIf
	ProcedureReturn InvalidHex
EndProcedure

Procedure PbHex_Convert2Data(sString.s)
	SetGadgetText(#Frm_Data,       " Data of PB Hex value ... ")
	SetGadgetText(#StG_PbConst,    "-")
	SetGadgetText(#StG_PbHexCol,   UCase(sString))
	SetGadgetText(#StG_PbCol,      Str(Val(sString)))
	SetGadgetText(#StG_PbColAlpha, "$FF" + Mid(sString, 2))
	SetGadgetText(#StG_ColCSS,     "#" + Mid(sString, 6, 2) + Mid(sString, 4, 2) + Mid(sString, 2, 2))
	SetGadgetText(#StG_NameCSS,    "-")
	SetGadgetText(#StG_ColRGB,     "rgb(" + RSet(Str(Val("$" + Mid(sString, 6, 2))), 3) + 
	                               ","    + RSet(Str(Val("$" + Mid(sString, 4, 2))), 3) +
	                               ","    + RSet(Str(Val("$" + Mid(sString, 2, 2))), 3) + ")")
	SetGadgetText(#StG_ColRGBA,    "rgba(" + RSet(Str(Val("$" + Mid(sString, 6, 2))), 3) + 
	                               ","     + RSet(Str(Val("$" + Mid(sString, 4, 2))), 3) +
	                               ","     + RSet(Str(Val("$" + Mid(sString, 2, 2))), 3) + 
	                               ",255)")
EndProcedure

Procedure PreferenceRead()
	Pref\WinW    = 680
	Pref\WinH    = 428
	Pref\WinX    = (DesktopWidth(0)  - Pref\WinW) / 2
	Pref\WinY    = (DesktopHeight(0) - Pref\WinH) / 2
	Pref\Sticky  = 0
	Pref\CListIdx= 0
	Pref\CTol    = 10
	Pref\CSpyOn  = 0
	Pref\PickRst = 0
	Pref\DQuoteOn= 1
	If OpenPreferences(GetPathPart(ProgramFilename()) + "PB-ColorScout.ini")
		Pref\WinX      = Min(ReadPreferenceInteger("WinX",              Pref\WinX), DesktopWidth(0)- 100)
		Pref\WinY      = Min(ReadPreferenceInteger("WinY",              Pref\WinY), DesktopHeight(0)- 100)
		Pref\WinW      = ReadPreferenceInteger("WinWidth",              Pref\WinW)
		Pref\WinH      = ReadPreferenceInteger("WinHight",              Pref\WinH)
		Pref\Sticky    = ReadPreferenceInteger("StayOnTop",             Pref\Sticky)
		Pref\CListIdx  = ReadPreferenceInteger("ColorListIdx",          Pref\CListIdx)
		Pref\CTol      = Max(Min(ReadPreferenceInteger("CompTolerance", Pref\CTol), 50), 1)
		Pref\CSpyOn    = ReadPreferenceInteger("ColorSpy",              Pref\CSpyOn)
		Pref\PickRst   = ReadPreferenceInteger("PickerReset",           Pref\PickRst)
		Pref\DQuoteOn  = ReadPreferenceInteger("DataDQuotes",           Pref\DQuoteOn)
		
		gPickRst = Pref\PickRst
		gColorSpy= Pref\CSpyOn
		ClosePreferences()
	EndIf
EndProcedure

Procedure PreferenceSave()
	If CreatePreferences(GetPathPart(ProgramFilename()) + "PB-ColorScout.ini")
		PreferenceComment("PB-ColorScout-Settings")
		
		WritePreferenceInteger("WinX",          WindowX(#Win_Main))
		WritePreferenceInteger("WinY",          WindowY(#Win_Main))
		WritePreferenceInteger("WinWidth",      WindowWidth(#Win_Main))
		WritePreferenceInteger("WinHight",      WindowHeight(#Win_Main))
		WritePreferenceInteger("StayOnTop",     gSOT)
		
		WritePreferenceInteger("ColorListIdx",  GetGadgetState(#CBG_ColList))
		CompilerIf #PB_Compiler_OS = #PB_OS_Linux
			WritePreferenceInteger("CompTolerance", gtk_spin_button_get_value_as_int_(gSpGTol))
		CompilerElse
			WritePreferenceInteger("CompTolerance", GetGadgetState(#SpG_Tol))
		CompilerEndIf
		WritePreferenceInteger("ColorSpy",      gColorSpy)
		WritePreferenceInteger("DataDQuotes",   GetGadgetState(#BIG_DQuote))
		WritePreferenceInteger("PickerReset",   gPickRst)
		WritePreferenceInteger("DClickSearch",  1)
		ClosePreferences()
	Else
		MessageRequester(#App_Name, "Preference file could not be created.")
	EndIf
EndProcedure


;-
;- Clipboard functions _______________
Procedure Clipboard_ExpColorList(MainVal)
	Protected.i Length, ColSet= GetGadgetState(#CBG_ColList)
	Protected.s S, sLine
	
	ForEach cListName(ColSet)\ColorList();                                get max length of constant
		Length= Max(Len(cListName(ColSet)\ColorList()\PbConstName), Length)
	Next cListName(ColSet)\ColorList()
	
	S= ";" + LSet(cListName(ColSet)\Info, Length + 9, " ") + "  ";         set header
	If GetMenuItemState(#PuCListL, #PuClL_CpLstAddComnt)
		If MainVal = #PuClL_CpLstHxValue
			S+ #DQUOTE$ + "+Alpha:   API-color: RGB-Color:          RGBA-Color:              Colorname:"
		ElseIf MainVal = #PuClL_CpLstHxaValue
			S+ "  " + #DQUOTE$ + "PB col. API-color: RGB-Color:          RGBA-Color:              Colorname:"
		EndIf
	EndIf
	S+ #LF$
	
	ForEach cListName(ColSet)\ColorList()
		sLine= cListName(ColSet)\ColorList()\PbConstName
		sLine= LSet(sLine, Length, " ") + "= "
		If MainVal = #PuClL_CpLstHxValue;                                defined w. PB-HEX-value
			sLine+ cListName(ColSet)\ColorList()\sPbHColor
			If GetMenuItemState(#PuCListL, #PuClL_CpLstAddComnt);          add further data, commented 
				sLine+ ";  " + cListName(ColSet)\ColorList()\sPbHColorAlpha + "  "
				sLine+ cListName(ColSet)\ColorList()\HexColor + "  "
				sLine+ cListName(ColSet)\ColorList()\RgbColor + "  "
				sLine+ cListName(ColSet)\ColorList()\RgbaColor + "  "
				sLine+ cListName(ColSet)\ColorList()\ColorName
			EndIf
		ElseIf MainVal = #PuClL_CpLstHxaValue;                           defined w. PB-HEX-alpha-value
			sLine+ cListName(ColSet)\ColorList()\sPbHColorAlpha
			If GetMenuItemState(#PuCListL, #PuClL_CpLstAddComnt);          add further data, commented 
				sLine+ ";  " + cListName(ColSet)\ColorList()\sPbHColor + "  "
				sLine+ cListName(ColSet)\ColorList()\HexColor + "  "
				sLine+ cListName(ColSet)\ColorList()\RgbColor + "  "
				sLine+ cListName(ColSet)\ColorList()\RgbaColor + "  "
				sLine+ cListName(ColSet)\ColorList()\ColorName
			EndIf
		EndIf
		
		S+ sLine+ #LF$
	Next cListName(ColSet)\ColorList()
	SetClipboardText(S)
	MessageRequester(#App_Name, "The current colorlist now is available " + #LF$ + "in the clipboard for the PB-IDE!")
EndProcedure

Procedure Clipboard_ExpFromColorList(cbMEntry)
	Protected.i Selection= GetGadgetState(#LIG1)
	Protected.i ColSet   = GetGadgetState(#CBG_ColList)
	Protected.i Remove   = GetGadgetState(#BIG_DQuote) ! 1;            remove DQuotes
	Protected.s S
	
	If Selection > -1
		SelectElement(cListName(ColSet)\ColorList(), Selection)
		Select cbMEntry
			Case #PuClL_CpPbConstname
				S= cListName(ColSet)\ColorList()\PbConstName
			Case #PuClL_CpPbConstDef
				S=  cListName(ColSet)\ColorList()\PbConstName + "= " + cListName(ColSet)\ColorList()\sPbHColor
			Case #PuClL_CpPbConstADef
				S=  cListName(ColSet)\ColorList()\PbConstName + "= " + cListName(ColSet)\ColorList()\sPbHColorAlpha
			Case #PuClL_CpPbHxValue
				S=  cListName(ColSet)\ColorList()\sPbHColor
			Case #PuClL_CpPbHxAValue
				S=  cListName(ColSet)\ColorList()\sPbHColorAlpha
			Case #PuClL_CpHxValue
				S=  String_RemoveQuotes(cListName(ColSet)\ColorList()\HexColor, Remove)
			Case #PuClL_CpCName
				S=  String_RemoveQuotes(cListName(ColSet)\ColorList()\ColorName, Remove)
			Case #PuClL_CpRGB
				S=  String_RemoveQuotes(cListName(ColSet)\ColorList()\RgbColor, Remove)
			Case #PuClL_CpRGBA
				S=  String_RemoveQuotes(cListName(ColSet)\ColorList()\RgbaColor, Remove)
			Case #PuClL_CpLstHxValue
				Clipboard_ExpColorList(#PuClL_CpLstHxValue)
			Case #PuClL_CpLstHxAValue
				Clipboard_ExpColorList(#PuClL_CpLstHxAValue)
		EndSelect
		If S <> "" : SetClipboardText(S) : EndIf
	EndIf
EndProcedure


Procedure Clipboard_ExpFromColorsFound(cbMEntry)
	Protected.i Selection, fSelection= GetGadgetState(#LIG2)
	Protected.i ColSet    = GetGadgetState(#CBG_ColList)
	Protected.i Remove    = GetGadgetState(#BIG_DQuote) ! 1;           remove DQuotes
	Protected.s S, sPbHEX
	
	;todo
	;change to direct conversion (doesn't work after change of color list) - see PbHex_Convert2Data(sString.s) ...
	If fSelection > -1
		Selection= Colors_FindName(GetGadgetItemText(#LIG2, fSelection, 0), 0)
		sPbHEX= GetGadgetItemText(#LIG2, fSelection, 1)
		If Selection > -1
			SelectElement(cListName(ColSet)\ColorList(), Selection)
			Select cbMEntry
				Case #PuClR_CpPbConstname
					S= cListName(ColSet)\ColorList()\PbConstName
				Case #PuClR_CpPbConstDef
					S= cListName(ColSet)\ColorList()\PbConstName + "= " + cListName(ColSet)\ColorList()\sPbHColor
				Case #PuClR_CpPbConstADef
					S= cListName(ColSet)\ColorList()\PbConstName + "= " + cListName(ColSet)\ColorList()\sPbHColorAlpha
				Case #PuClR_CpCName
					S= String_RemoveQuotes(cListName(ColSet)\ColorList()\ColorName, Remove)
				Case #PuClR_ScrlToInCLst
					SetGadgetState(#LIG1, Selection)
					SetGadgetState(#LIG1, -1)
				Case #PuClR_SelInCLst
					SetGadgetState(#LIG1, Selection)
				Case #PuClR_SelInCLstAData
					SetGadgetState(#LIG1, Selection)
					PostEvent(#PB_Event_Gadget, #Win_Main, #LIG1, #PB_EventType_Change)
				Case #PuClR_Sel2Data
					Color_Copy2DataFields(#LIG1, Selection)
			EndSelect
		EndIf
		
		Select cbMEntry
			Case #PuClR_CpPbHxValue
				S= sPbHEX
			Case #PuClR_CpPbHxAValue
				S= "$FF" + Mid(sPbHEX, 2)
			Case #PuClR_CpHxValue
				S= "#" + Mid(sPbHEX, 6, 2) + Mid(sPbHEX, 4, 2) + Mid(sPbHEX, 2, 2)
			Case #PuClR_CpRGB
				S= "rgb(" + RSet(Str(Val("$" + Mid(sPbHEX, 6, 2))), 3) + 
				   ","    + RSet(Str(Val("$" + Mid(sPbHEX, 4, 2))), 3) + 
				   ","    + RSet(Str(Val("$" + Mid(sPbHEX, 2, 2))), 3) + ")"
			Case #PuClR_CpRGBA
				S= "rgba(" + RSet(Str(Val("$" + Mid(sPbHEX, 6, 2))), 3) + 
				   ","     + RSet(Str(Val("$" + Mid(sPbHEX, 4, 2))), 3) +
				   ","     + RSet(Str(Val("$" + Mid(sPbHEX, 2, 2))), 3) + 
				   ",255)"
			Default
				If Selection = -1
					Entry_Blink(#LIG2, #VGA_BrightRed)
				EndIf
		EndSelect
		SetClipboardText(S)
	EndIf
EndProcedure

;-
;- Load, extract, sort color lists ______
Procedure Load_ColorList()
	Protected.s sPrefix, sLine, sTemp, ExeDir= GetPathPart(ProgramFilename())
	Protected.s NameSpaces, ListInfos
	Protected.i I, From_, To_, Attach, All
	
	; /* Color file must be placed in exe-path. Use compiler - compiler/run / Create temp. exe in the source path */
	If ReadFile(0, ExeDir + "PB_NamedColorLists.pbi", #PB_UTF8)
		NameSpaces= ""
		ListInfos = ""
		While Not Eof(0)
			sLine= ReadString(0)
			; extract prefixes for lists
			If sLine = ";<IncludedNamespaces>"
				Repeat
					sLine= ReadString(0)
					If sLine = ";</IncludedNamespaces>" : Break : EndIf
					sLine= LTrim(sLine)
					If Left(sLine, 2) <> ";;";                 Deactivated list by double comment-sign 
						NameSpaces+ Mid(sLine, 2, FindString(sLine, "=")- 2) + ","
						From_= FindString(sLine, "=")+ 1
						To_  = FindString(sLine, ";", From_)- 1
						If To_ < 1 : To_= Len(sLine) : EndIf
						ListInfos+ LTrim(Mid(sLine, From_, To_- From_ + 1)) + #LF$
					EndIf
				ForEver
				NameSpaces= RTrim(NameSpaces, ",")
				ListInfos = RTrim(ListInfos, #LF$)
				Break
			EndIf
		Wend
		
		For I= 1 To CountString(NameSpaces, ",") + 1
			If ArraySize(cListName()) < I-1
				;new color list
				ReDim cListName.COLORLIST(I-1)
			EndIf
			FileSeek(0, 0)
			sPrefix= StringField(NameSpaces, I, ",")
			sTemp  = StringField(ListInfos, I, #LF$)
			cListName(I-1)\Prefix= sPrefix
			cListName(I-1)\Info  = sTemp
			
			While Not Eof(0)
				sLine= ReadString(0)
				If Left(sLine, Len(sPrefix)) = sPrefix
					; new color in list within array I-1
					AddElement(cListName(I-1)\ColorList())
					
					; read PB constant
					From_= FindString(sLine, "=")- 1
					cListName(I-1)\ColorList()\PbConstName= RTrim(Left(sLine, From_))
					; read PB color
					From_+ 3
					To_= FindString(sLine, ";", From_)
					cListName(I-1)\ColorList()\sPbHColor= Mid(sLine, From_, To_ - From_)
					cListName(I-1)\ColorList()\PbColor  = Val(Mid(sLine, From_, To_ - From_))
					
					; read remaining values
					sTemp= LTrim(Mid(sLine, To_+1))
					sTemp= ReplaceString(sTemp, "  " + #DQUOTE$, #TAB$ + #DQUOTE$); replaces '  "' with '[Tab]"'
					; split remaining infos
					Attach= CountString(sTemp, #TAB$) + 1
					; extract PB color alpha value
					cListName(I-1)\ColorList()\sPbHColorAlpha= StringField(sTemp, 1, #TAB$)
					; extract CSS Hex value
					cListName(I-1)\ColorList()\HexColor= StringField(sTemp, 2, #TAB$)
					; extract rgb color string
					If Attach > 2 : cListName(I-1)\ColorList()\RgbColor = StringField(sTemp, 3, #TAB$) : EndIf
					; extract rgba color string
					If Attach > 3 : cListName(I-1)\ColorList()\RgbaColor= StringField(sTemp, 4, #TAB$) : EndIf
					; extract color name
					If Attach > 4 : cListName(I-1)\ColorList()\ColorName  = StringField(sTemp, 5, #TAB$) : EndIf
				EndIf
			Wend
		Next I
		CloseFile(0)
		
		;add a list with a union all lists ...
		All= ArraySize(cListName())+ 1
		ReDim cListName.COLORLIST(All)
		
		For I= 0 To ArraySize(cListName())- 1
			ForEach cListName(I)\ColorList()
				AddElement(cListName(All)\ColorList())
				cListName(All)\ColorList()\PbConstName   = cListName(I)\ColorList()\PbConstName
				cListName(All)\ColorList()\sPbHColor     = cListName(I)\ColorList()\sPbHColor
				cListName(All)\ColorList()\PbColor       = cListName(I)\ColorList()\PbColor
				cListName(All)\ColorList()\sPbHColorAlpha= cListName(I)\ColorList()\sPbHColorAlpha
				cListName(All)\ColorList()\HexColor      = cListName(I)\ColorList()\HexColor
				cListName(All)\ColorList()\RgbColor      = cListName(I)\ColorList()\RgbColor
				cListName(All)\ColorList()\RgbaColor     = cListName(I)\ColorList()\RgbaColor
				cListName(All)\ColorList()\ColorName     = cListName(I)\ColorList()\ColorName
			Next cListName(I)\ColorList()
		Next I
		
		cListName(All)\Prefix= "All"
		cListName(All)\Info  = "All [" + ListSize(cListName(All)\ColorList()) + "]"
	Else
		MessageRequester(#App_Name, "File " + "PB_NamedColorLists.pbi" + " not found in exe-path!")
	EndIf
EndProcedure

Procedure Sort_ColorList(SortColumn)
	Protected.i ColSet= GetGadgetState(#CBG_ColList)
	
	If CountGadgetItems(#LIG1)
		If SortColumn= #PuSort_ByName
			SortStructuredList(cListName(ColSet)\ColorList(), #PB_Sort_Ascending, OffsetOf(COLORDATA\ColorName), TypeOf(COLORDATA\ColorName))
		ElseIf SortColumn= #PuSort_ByValue
			SortStructuredList(cListName(ColSet)\ColorList(), #PB_Sort_Descending, OffsetOf(COLORDATA\PbColor), TypeOf(COLORDATA\PbColor))
		EndIf
		Colors_CopyInLIG(ColSet)
	EndIf
EndProcedure

;-
;- Color functions ___________________
Procedure Colors_CopyInLIG(ColSet)
	Protected.i I
	Protected.i Red, Green, Blue
	
	ClearGadgetItems(#LIG1)
	ResetList(cListName(ColSet)\ColorList())
	For I= 0 To ListSize(cListName(ColSet)\ColorList())- 1
		NextElement(cListName(ColSet)\ColorList())
		AddGadgetItem(#LIG1, I, Trim(cListName(ColSet)\ColorList()\ColorName, #DQUOTE$) + #LF$ + cListName(ColSet)\ColorList()\sPbHColor)
		SetGadgetItemColor(#LIG1, I, #PB_Gadget_BackColor, cListName(ColSet)\ColorList()\PbColor, 1)
		Red  = Red  (cListName(ColSet)\ColorList()\PbColor)
		Green= Green(cListName(ColSet)\ColorList()\PbColor)
		Blue = Blue (cListName(ColSet)\ColorList()\PbColor)
		If Green > 220 Or (Red + Green + Blue) > 450;                    readable frontcolor for text
			SetGadgetItemColor(#LIG1, I, #PB_Gadget_FrontColor, $0, 1)
		Else
			SetGadgetItemColor(#LIG1, I, #PB_Gadget_FrontColor, #VGA_White, 1)
		EndIf
	Next I
	SetGadgetItemText(#LIG1, -1, "Color names in list: " + cListName(ColSet)\Prefix)
EndProcedure

Procedure Color_ChangeList(ColSet)
	Protected.i currColor, currItem= GetGadgetState(#LIG1)
	Protected.s currName
	
	If currItem > -1
		currColor= GetGadgetItemColor(#LIG1, currItem, #PB_Gadget_BackColor, 1)
		currName = GetGadgetItemText (#LIG1, currItem, 0)
	EndIf
	
	Colors_CopyInLIG(ColSet)
	gPrevColor   = -1
	gPrevCbGValue= -1
	If currItem > -1
		gTempColor= currColor
		gPrevColor= Colors_FindName(currName, 1)
		gTempColor= -1
	EndIf
EndProcedure

;- API
CompilerIf #PB_Compiler_OS = #PB_OS_Linux
	
	Procedure Color_PickFromMousePos()
		;from Wilbert: http://www.purebasic.fr/english/viewtopic.php?f=13&t=65438
		Protected.i pixbuf
		Protected   *buf.Ascii
		Protected.l c
		
		pixbuf= gdk_pixbuf_get_from_window(gdk_get_default_root_window_(), DesktopMouseX(), DesktopMouseY(), 1, 1)
		*buf  = gdk_pixbuf_get_pixels(pixbuf)
		c     = *buf\a
		*buf + 1
		c | *buf\a << 8
		*buf + 1
		c | *buf\a << 16
		g_object_unref_(pixbuf)
		ProcedureReturn c
	EndProcedure
	
	ProcedureC Callback_SearchInTreeView(*model, column, *key, iter, *search_data)
		;   every path (line) which partially agrees in systemsearch is sent to this function
		Protected.i Found= #True
		Protected.l Indices
		Protected.i path
		Protected.s Search= PeekS(*key, -1, #PB_UTF8);                   current search-string in UTF8-Format
		
		path   = gtk_tree_model_get_path_(*model, iter);                 get path from iter,
		Indices= PeekL(gtk_tree_path_get_indices_(path));                then index (LIG-line) from path
		
		If FindString(GetGadgetItemText(*search_data, Indices, column), Search, 1, #PB_String_NoCase); own check to verify the suggestion
			Found= #False
		EndIf
		gtk_tree_path_free_(path)
		ProcedureReturn Found;                                           #False = Ok !
	EndProcedure
	
	ProcedureC Callback_SButtonVChanged(*widget.GtkWidget, user_data); GtkSpinButtonWidget-Callback
		If *widget = gSpGTol
			
			If gPrevSearch = #BIG_FndSelection
				PostEvent(#PB_Event_Gadget, #Win_Main, #BIG_FndSelection)
			ElseIf gPrevSearch = #BIG_FndVal
				PostEvent(#PB_Event_Gadget, #Win_Main, #BIG_FndVal)
			EndIf
		EndIf
	EndProcedure
	
	Procedure SpinButtonGadget(Gadget, x, y, w, h, value.d, lower.d, upper.d, step_inc.d, page_inc.d, digits); GtkSpinButtonWidget
		Protected.i Container                = ContainerGadget(Gadget, x, y, w, h, #PB_Container_BorderLess)
		Protected   *adjustment.GtkAdjustment= gtk_adjustment_new(value, lower, upper, step_inc, page_inc, #Null)
		Protected   *sbutton.GtkWidget       = gtk_spin_button_new(*adjustment, 1.0, digits)
		
		If Gadget <> #PB_Any : Container= Gadget : EndIf
		gtk_spin_button_set_numeric_(*sbutton, #True)
		gtk_widget_set_size_request_(*sbutton, GadgetWidth(Container)- 4, -1);   expands width
		gtk_container_add_(GadgetID(Container), *sbutton)
		gtk_widget_show_(*sbutton)
		CloseGadgetList()
		ProcedureReturn *sbutton
	EndProcedure
	
CompilerElseIf #PB_Compiler_OS = #PB_OS_Windows
	
	Procedure.i Color_PickFromMousePos()
		; by PureLust for PureBasic-Forum - 18.09.2009 (with thanks to netmaestro)  ;)
		; extended by infratec, optimized by idle
		
		Protected.i HDC = GetDC_(0)
		Protected.i PixelColour, Red, Green, Blue, x, y
		Protected.s sPixelColour
		
		x           = DesktopMouseX()
		y           = DesktopMouseY()
		PixelColour = GetPixel_(hDC, x, y)
		Red         = Red(PixelColour)
		Green       = Green(PixelColour)
		Blue        = Blue(PixelColour)
		sPixelColour= "$" + RSet(Hex(Blue), 2, "0") + RSet(Hex(Green), 2, "0") + RSet(Hex(Red), 2, "0")
		
		ReleaseDC_(0, HDC)
		ProcedureReturn RGB(Red, Green, Blue)
	EndProcedure
	
CompilerElseIf #PB_Compiler_OS = #PB_OS_MacOS
	
	Procedure.i Color_PickFromMousePos()
		;from Wilbert: http://www.purebasic.fr/english/viewtopic.php?f=13&t=65438
		Protected.i image, csRGB, ctx
		Protected.l c
		Protected.d x, y, one= 1
		
		x    = DesktopMouseX()
		y    = DesktopMouseY()
		csRGB= CGColorSpaceCreateDeviceRGB()
		ctx  = CGBitmapContextCreate(@c, 1, 1, 8, 4, csRGB, 1)
		CGColorSpaceRelease(csRGB)
		!extern _CGContextDrawImage
		!extern _CGWindowListCreateImage
		!movsd xmm0, [p.v_x]
		!movsd xmm1, [p.v_y]
		!movsd xmm2, [p.v_one]
		!sub rsp, 32
		!movsd [rsp     ], xmm0
		!movsd [rsp +  8], xmm1
		!movsd [rsp + 16], xmm2
		!movsd [rsp + 24], xmm2
		!mov rdi, 1
		!xor rsi, rsi
		!xor rdx, rdx
		!call _CGWindowListCreateImage
		!add rsp, 32
		!mov [p.v_image], rax
		!mov rdi, [p.v_ctx]
		!mov rsi, rax
		!pxor xmm0, xmm0
		!movsd xmm2, [p.v_one]
		!sub rsp, 32
		!movupd [rsp], xmm0
		!movsd [rsp + 16], xmm2
		!movsd [rsp + 24], xmm2 
		!call _CGContextDrawImage
		!add rsp, 32
		CGImageRelease(image)
		CGContextRelease(ctx)
		ProcedureReturn c
	EndProcedure
	
CompilerEndIf

;- END_API
Procedure Color_Add2Combobox();                                      adds 10 recent searched values to ComboBox
	Protected.i I, Exists= #False, nItems= CountGadgetItems(#CBG_FndVal)
	
	For I= 0 To nItems- 1
		If GetGadgetItemText(#CBG_FndVal, I) = GetGadgetText(#CBG_FndVal);  same entry exists?
			Exists= #True
			Break
		EndIf
	Next I
	If Not Exists
		AddGadgetItem(#CBG_FndVal, 0, GetGadgetText(#CBG_FndVal));       color icons not supported for editable ComboBox on Mac OS
		If nItems > 9
			RemoveGadgetItem(#CBG_FndVal, nitems- 1)
		EndIf
	EndIf
EndProcedure

Procedure Color_ConvertNameInput()
	Protected.s Value= GetGadgetText(#StG_FndName)
	Protected.s S    = Value
	Protected.i Numeric
	
	S= Trim(S, #DQUOTE$)
	S= Trim(S, "'")
	If Left(S, 1) = "#";                                               pasted a HEX triplet
		If FindString(S, "_") And FindString(S, "_") < Len(S)
			S= Mid(S, FindString(S, "_")+ 1)
		ElseIf Len(S) > 1 And Val("$" + Mid(S, 2)) > 0;                  no underlines
			Numeric= #True
			S= ""
		EndIf
	ElseIf UCase(Left(RemoveString(S, " "), 4)) = "RGB(" Or UCase(Left(RemoveString(S, " "), 5)) = "RGBA("
		Numeric= #True
		S= ""
	EndIf
	If Numeric : MessageRequester(#App_Name, "No values possible!") : EndIf
	If S <> Value
		SetGadgetText(#StG_FndName, S)
	EndIf
EndProcedure

Procedure Color_Convert2PbHex()
	Protected.i I, Invalid= #False
	Protected.s S, PbHex, Value= GetGadgetText(#CBG_FndVal);          typed in or pasted value in value-ComboBox
	
	Value= RemoveString(Value, " ")
	Value= Trim(Value, #DQUOTE$);                                      remove doublequotes
	Value= Trim(Value, "'");                                           remove singlequotes
	While Left(Value, 2) = "$$";                                      replace $$xxx by $xxx
		Value= Mid(Value, 2)
		SetGadgetText(#CBG_FndVal, Value)
	Wend
	If String_IsNaturalNum(Value)
		
	ElseIf Len(Value) = 7;                                                 PB, CSS, API HEX color?
		If Left(Value, 1) = "#";                                         i.e. #rrggbb
			For I= 2 To 7
				If Not FindString(#HexChars, UCase(Mid(Value, I, 1)))
					Invalid= #True
					Break
				EndIf
			Next I
			If Not Invalid
				SetGadgetText(#CBG_FndVal, "$" + Mid(Value, 6, 2) + Mid(Value, 4, 2) + Mid(Value, 2, 2))
			EndIf
		EndIf
	ElseIf Len(Value) = 9;                                             PB, HEX alpha color?
		If UCase(Left(Value, 3)) = "$FF";                                i.e. $aabbggrr
			For I= 2 To 9
				If Not FindString(#HexChars, UCase(Mid(Value, I, 1)))
					Invalid= #True
					Break
				EndIf
			Next I
			If Not Invalid
				SetGadgetText(#CBG_FndVal, "$" + Mid(Value, 4))
			EndIf
		EndIf
	ElseIf Len(Value) >= 10
		If (UCase(Left(Value, 4)) = "RGB(" Or UCase(Left(Value, 5)) = "RGBA(") And Right(Value, 1) = ")";  rgb(,,) | rgba(,,,)
			S= RTrim(Mid(Value, FindString(Value, "(")+ 1), ")")
			If CountString(S, ",") = 2 Or CountString(S, ",") = 3
				PbHex= "$"
				For I= 3 To 1 Step -1
					PbHex+ Right("0" + Hex(Val(StringField(S, I, ","))), 2)
				Next I
				SetGadgetText(#CBG_FndVal, PbHex)
			EndIf
		EndIf
	EndIf
EndProcedure

Procedure.s Color_PbVal2PbHex(Value.i)
	Protected.s S
	
	S= "000000" + Hex(Value)
	S= "$" + Right(S, 6);                                              w/o alpha
	ProcedureReturn S
EndProcedure

Procedure Color_Copy2DataFields(Gadget, fSelection= -1)
	Protected.i Selection
	Protected.i ColSet   = GetGadgetState(#CBG_ColList)
	Protected.i Remove   = GetGadgetState(#BIG_DQuote) ! 1;            remove DQuotes
	
	If fSelection > -1
		Selection= fSelection
		SetGadgetText(#Frm_Data, " Data of selected found color ")
	Else
		Selection= GetGadgetState(Gadget)
		SetGadgetText(#Frm_Data, " Data of selected color ")
	EndIf
	
	If Selection > -1
		SelectElement(cListName(ColSet)\ColorList(), Selection)
		SetGadgetText(#StG_PbConst,    cListName(ColSet)\ColorList()\PbConstName)
		SetGadgetText(#StG_PbHexCol,   cListName(ColSet)\ColorList()\sPbHColor)
		SetGadgetText(#StG_PbCol,      Str(cListName(ColSet)\ColorList()\PbColor))
		SetGadgetText(#StG_PbColAlpha, cListName(ColSet)\ColorList()\sPbHColorAlpha)
		SetGadgetText(#StG_ColCSS,     String_RemoveQuotes(cListName(ColSet)\ColorList()\HexColor, Remove))
		SetGadgetText(#StG_NameCSS,    String_RemoveQuotes(cListName(ColSet)\ColorList()\ColorName, Remove))
		SetGadgetText(#StG_ColRGB,     String_RemoveQuotes(cListName(ColSet)\ColorList()\RgbColor, Remove))
		SetGadgetText(#StG_ColRGBA,    String_RemoveQuotes(cListName(ColSet)\ColorList()\RgbaColor, Remove))
	EndIf
EndProcedure

Procedure.i Colors_FindName(cName.s= "", SelectIt= 0)
	Protected.i I, Col, LIG2NewItem, Found= -1, ColSet= GetGadgetState(#CBG_ColList), LIG2State= GetGadgetState(#LIG2)
	Protected.i lItems= ListSize(cListName(ColSet)\ColorList())- 1
	
	If cName = "";                                                     name part from color name search input
		cName= GetGadgetText(#StG_FndName)
		For I= 0 To lItems
			If FindString(GetGadgetItemText(#LIG1, I, 0), cName, 1, #PB_String_NoCase)
				If Found = -1;                                               first find: clear old list
					ClearGadgetItems(#LIG2)
					SetGadgetState(#LIG1, I);                                  jump to first found color in color list
					SetGadgetState(#LIG1, -1);                                 then deselect it
					Found= I
				EndIf
				AddGadgetItem(#LIG2, -1, GetGadgetItemText(#LIG1, I, 0))
				LIG2NewItem= CountGadgetItems(#LIG2)-1
				SetGadgetItemColor(#LIG2, LIG2NewItem, #PB_Gadget_BackColor, GetGadgetItemColor(#LIG1, I, #PB_Gadget_BackColor, 1), 1)
				SetGadgetItemColor(#LIG2, LIG2NewItem, #PB_Gadget_FrontColor, GetGadgetItemColor(#LIG1, I, #PB_Gadget_FrontColor, 1), 1)
				SetGadgetItemText (#LIG2, LIG2NewItem, GetGadgetItemText(#LIG1, I, 1), 1)
			EndIf
		Next I
		If Found = -1 : Entry_Blink(#LIG2, #VGA_BrightRed) : EndIf
	Else;                                                              name from LIG2
		For I= 0 To lItems
			Col= GetGadgetItemColor(#LIG1, I, #PB_Gadget_BackColor, 1)
; 			Col= Val(GetGadgetItemText(#LIG1, I, 1))
			If Col = gTempColor Or Val(GetGadgetItemText(#LIG2, LIG2State, 1))
				If GetGadgetItemText(#LIG1, I, 0) = cName
					; SelectIt w. RightClick not supported. Later w. Popup?
					If SelectIt & 1 : SetGadgetState(#LIG1, I)  : EndIf;       Scroll to & select (very slow!)
					If SelectIt & 2 : SetGadgetState(#LIG1, -1) : EndIf;       Scroll to & deselect
					Found= I
					Break
				EndIf
			EndIf
		Next I
	EndIf
	ProcedureReturn Found
EndProcedure

Procedure Color_SetBkgndName(Gadget, Text.s)
	Protected.i Color, Red, Green, Blue
	
	GadgetToolTip(Gadget, Text)
	Color= GetGadgetColor(Gadget, #PB_Gadget_BackColor)
	Red  = Red  (Color)
	Green= Green(Color)
	Blue = Blue (Color)
	If Green > 220 Or (Red + Green + Blue) > 450;                      readable text color
		SetGadgetColor(Gadget, #PB_Gadget_FrontColor, #VGA_Black)
	Else
		SetGadgetColor(Gadget, #PB_Gadget_FrontColor, #VGA_White)
	EndIf
EndProcedure

Procedure.i Colors_ShowSimilar(sString.s= "")
	Protected.d Fact
	Protected.i sColor, sRed, sGreen, sBlue
	Protected.i Color, Red, Green, Blue
	Protected.i I, Tol, Valid= #True, ColSet= GetGadgetState(#CBG_ColList)
	
	CompilerIf #PB_Compiler_OS = #PB_OS_Linux
		Fact= gtk_spin_button_get_value_as_int_(gSpGTol) / 100
	CompilerElse
		Fact= ValD(GetGadgetText(#SpG_Tol)) / 100
	CompilerEndIf
	Tol= $FF * Fact
	
	If PbHex_StringIsInvalid(sString) : Valid= #False : ProcedureReturn Valid: EndIf
	
	If Fact < 0 Or Fact > 0.5
		MessageRequester(#App_Name, "The factor for the tolerance must be" + #LF$ + "between 1% and 50%! Function canceled.")
		Valid= #False
		ProcedureReturn Valid
	EndIf
	
	If GetGadgetState(#LIG1) > -1 Or sString > "";                     selection in color list OR PB HEX color as string
		ClearGadgetItems(#LIG2)
		If sString= ""
			sColor= GetGadgetItemColor(#LIG1, GetGadgetState(#LIG1), #PB_Gadget_BackColor, 1)
		Else
			sColor= Val(sString)
			If sColor < #VGA_Black Or sColor > #VGA_White
				MessageRequester(#App_Name, "No valid color! Function canceled.")
				Valid= #False
				ProcedureReturn Valid
			EndIf
			SetGadgetColor(#TxG_SrchBkgnd, #PB_Gadget_BackColor, sColor)
			SetGadgetText (#CBG_FndVal, UCase(sString))
			Color_Add2Combobox();                                          add a ComboBox-item
		EndIf
		sRed  = Red(sColor)
		sGreen= Green(sColor)
		sBlue = Blue(sColor)
		For I= 0 To ListSize(cListName(ColSet)\ColorList())- 1
			If I <> GetGadgetState(#LIG1)
				Color= GetGadgetItemColor(#LIG1, I, #PB_Gadget_BackColor, 1)
				Red  = Red(Color)
				Green= Green(Color)
				Blue = Blue(Color)
				If Red <= Min(sRed + Tol, 255) And Red >= Max(sRed - Tol, 0)
					If Green <= Min(sGreen + Tol, 255) And Green >= Max(sGreen - Tol, 0)
						If Blue <= Min(sBlue + Tol, 255) And Blue >= Max(sBlue - Tol, 0)
							AddGadgetItem(#LIG2, -1, GetGadgetItemText(#LIG1, I, 0))
							SetGadgetItemColor(#LIG2, CountGadgetItems(#LIG2)-1, #PB_Gadget_BackColor, GetGadgetItemColor(#LIG1, I, #PB_Gadget_BackColor, 1), 1)
							SetGadgetItemColor(#LIG2, CountGadgetItems(#LIG2)-1, #PB_Gadget_FrontColor, GetGadgetItemColor(#LIG1, I, #PB_Gadget_FrontColor, 1), 1)
							SetGadgetItemText(#LIG2, CountGadgetItems(#LIG2)-1, GetGadgetItemText(#LIG1, I, 1), 1)
							If sColor = Color;                                     hit
								SetGadgetItemColor(#LIG2, CountGadgetItems(#LIG2)-1, #PB_Gadget_BackColor, #LOff_Palegreen, 0)
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Next I
		If Not CountGadgetItems(#LIG2) : Entry_Blink(#LIG2, #VGA_BrightRed) : EndIf
		If sString : SetGadgetState(#LIG1, -1) : EndIf;                  optional deselect ?
	Else
		Valid= #False
	EndIf
	ProcedureReturn Valid
EndProcedure

Procedure Colors_UpdateFinds(EventType);                            Mac & Win
	Protected.i sgChanged= #False, LimValue
	
	If EventType = #PB_EventType_Change;                               input
		LimValue= Squeeze(Val(GetGadgetText(#SpG_Tol)), 1, 50);          squeeze to valid SpinGadget input range
		If LimValue <> GetGadgetState(#SpG_Tol);                         SpinGadget value changed
			sgChanged= #True
			If gPrevSearch = #BIG_FndSelection
				SetGadgetState(#SpG_Tol, LimValue)
			ElseIf gPrevSearch = #BIG_FndVal
				SetGadgetState(#SpG_Tol, LimValue)
			EndIf
		EndIf
	ElseIf EventType = #PB_EventType_Up Or EventType = #PB_EventType_Down; up / down
		sgChanged= #True
	EndIf
	If sgChanged;                                                      update finds
		If gPrevSearch = #BIG_FndSelection
			PostEvent(#PB_Event_Gadget, #Win_Main, #BIG_FndSelection)
		ElseIf gPrevSearch = #BIG_FndVal
			PostEvent(#PB_Event_Gadget, #Win_Main, #BIG_FndVal)
		EndIf
	EndIf
EndProcedure

;-
;-_ErrorHandler _____________
Procedure ErrorHandler()
	gErrorMessage = "A program error was detected:" + #LF$ + #LF$
	gErrorMessage + "Error Message:   " + ErrorMessage()   + #LF$
	gErrorMessage + "Error Code:      " + Str(ErrorCode()) + #LF$
	gErrorMessage + "Sourcecode line: " + Str(ErrorLine()) + #LF$
	
	MessageRequester(#App_Name + "-Error", gErrorMessage)
	End
EndProcedure

;-
;- Create Windows ____________________
Procedure Create_WinMain()
	Protected.i I
	
	If OpenWindow(#Win_Main, Pref\WinX, Pref\WinY, Pref\WinW, Pref\WinH, #App_Name, #PB_Window_SystemMenu | #PB_Window_MinimizeGadget)
		;Quasi-Toolbar
		TextGadget    (#PB_Any,        5,   9, 104,  22, "Select colorlist")
		ComboBoxGadget(#CBG_ColList, 110,   2, 256,  29)
		For I= 1 To ArraySize(cListName())+ 1;                           add color lists
			AddGadgetItem (#CBG_ColList,  -1, cListName(I-1)\Prefix + ": " + cListName(I-1)\Info)
		Next I
		If Pref\CListIdx < CountGadgetItems(#CBG_ColList)
			SetGadgetState   (#CBG_ColList, Pref\CListIdx)
		Else
			SetGadgetState   (#CBG_ColList, 0)
		EndIf
		ButtonImageGadget(#BIG_Settings, 642,   3,  32,  28, CreateImg_Settings(#Img_Settings))
		
		;Color list LIG
		ListIconGadget  (#LIG1,   5, 35, 305, 260, "Color names in list: ",  180, #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
		AddGadgetColumn (#LIG1,  1, "PB-Color (Hex)", 120)
		;Found colors (result) LIG
		ListIconGadget  (#LIG2, 384, 35, 290, 260, "Results (with name-part)", 190, #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
		AddGadgetColumn (#LIG2,  1, "PB-Color (Hex)", 95)
		Colors_CopyInLIG(GetGadgetState(#CBG_ColList))
		;Color compare panels
		TextGadget       (#TxG_SrchBkgnd,    312,  55,  35, 220, "    ");  the background color is used at the moment
		TextGadget       (#TxG_CompBkgnd,    347,  55,  35, 220, "    ")
		ImageGadget      (#IgG_L2D,          320,  38,  16,  16, CreateImg_ArrowBow(#Img_ArrowBowfLtD2, #X11_Skyblue3, 270.0))
		ImageGadget      (#IgG_R2D,          360,  38,  16,  16, CreateImg_ArrowBow(#Img_ArrowBowfRtD,  #X11_Skyblue3,  90.0, #False))
		ImageGadget      (#IgG_ArrowU,       320, 278,  16,  16, CreateImg_Arrow   (#Img_ArrowLImg,     #X11_Skyblue3,   0.0))
		
		;Find selection, value or picker
		;find name ...
		TextGadget       (#PB_Any,            10, 331, 178,  22, "part of name")
		TextGadget       (#TxG_PickColor,    316, 145,  27,  24, "");, #PB_Text_Border)
		StringGadget     (#StG_FndName,      189, 324, 190,  28, "")
		ButtonImageGadget(#BIG_FndName,      373, 323,  32,  29, CreateImg_Find(#Img_Find1, #True))
		CopyImage        (#Img_Find1, #Img_Find2)
		CopyImage        (#Img_Find1, #Img_Find3)
		;find selection ...
		TextGadget       (#PB_Any,            10, 361, 178,  22, "similar ones to selection")
		ButtonImageGadget(#BIG_FndSelection, 373, 354,  32,  29, ImageID(#Img_Find3))
		;find value ...
		TextGadget       (#PB_Any,            10, 391, 178,  22, "similar ones to PB-Hex-val.")
		ComboBoxGadget   (#CBG_FndVal,       189, 384, 190,  29, #PB_ComboBox_Editable)
		ButtonImageGadget(#BIG_FndVal,       373, 384,  32,  29, ImageID(#Img_Find3))
		ButtonImageGadget(#BIG_ArrBowL2B,    406, 384,  32,  29, CreateImg_ArrowBow(#Img_ArrowBowfLtD, #CSS_ForestGreen, 270.0))
		ImageGadget      (#IgG_ArrowL,       464, 390,  16,  16, CreateImg_Arrow(#Img_ArrowLImg,  #X11_Skyblue3))
		ButtonImageGadget(#BIG_Pipette,      482, 384,  36,  29, CreateImg_Pipette(#Img_Pipette), #PB_Button_Toggle)
		;set tolerance ...
		ImageGadget      (#IgG_Bracket,      540, 354,  14,  60, CreateImg_BracketCurly(#Img_Bracket, #X11_Skyblue3))
		TextGadget       (#PB_Any,           558, 354, 110,  22, "tolerance [± %]")
		CompilerIf #PB_Compiler_OS = #PB_OS_Linux
			gSpGTol= SpinButtonGadget(#PB_Any, 556, 370, 116,  26,  Pref\CTol,  1, 50, 1, 10, 0)
			gtk_entry_set_alignment(gSpGTol, 1.0)
		CompilerElse
			SpinGadget       (#SpG_Tol,        570, 370, 100,  26,  1, 50, #PB_Spin_Numeric)
			SetGadgetState   (#SpG_Tol,         Pref\CTol)
		CompilerEndIf
		FrameGadget        (#PB_Any,           2, 300, 675, 117, " Search in color list above for ... ")
		
		;fold data section
		CanvasGadget(#CvG_VFold, 16, 419, WindowWidth(#Win_Main) - 32, 6)
		CreateCanvas_FoldDown(#CvG_VFold, WindowWidth(#Win_Main), #CSS_DarkTurquoise)
		
		;data section
		ContainerGadget(#CtG_Data,             0, 426, 680, 143);        invisible to (un)-hide data gadgets
		If Pref\WinH < 500
			HideGadget(#CtG_Data, #True)
		Else
			CreateCanvas_FoldDown(#CvG_VFold, WindowWidth(#Win_Main), #X11_Tomato)
		EndIf
		TextGadget (#PB_Any,             5,  31, 103,  22, "PB constant", #PB_Text_Right)
		TextGadget (#PB_Any,             5,  59, 103,  22, "PB color", #PB_Text_Right)
		TextGadget (#PB_Any,           315,  59, 115,  22, "PB color + alpha", #PB_Text_Right)
		TextGadget (#PB_Any,             5,  87, 103,  22, "HEX color value", #PB_Text_Right)
		TextGadget (#PB_Any,           315,  87, 115,  22, "(CSS) color name", #PB_Text_Right)
		TextGadget (#PB_Any,             5, 115, 103,  22, "RGB color", #PB_Text_Right)
		TextGadget (#PB_Any,           315, 115, 115,  22, "RGBA color", #PB_Text_Right)
		TextGadget (#PB_Any,           204,  59,  14,  22, "=", #PB_Text_Center)
		StringGadget(#StG_PbConst,     110,  26, 226,  27, "", #PB_String_ReadOnly)
		StringGadget(#StG_PbHexCol,    110,  54,  90,  27, "", #PB_String_ReadOnly)
		StringGadget(#StG_PbCol,       220,  54,  90,  27, "", #PB_String_ReadOnly)
		StringGadget(#StG_PbColAlpha,  435,  54, 200,  27, "", #PB_String_ReadOnly)
		StringGadget(#StG_ColCSS,      110,  82, 200,  27, "", #PB_String_ReadOnly)
		StringGadget(#StG_NameCSS,     435,  82, 200,  27, "", #PB_String_ReadOnly)
		StringGadget(#StG_ColRGB,      110, 110, 200,  27, "", #PB_String_ReadOnly)
		StringGadget(#StG_ColRGBA,     435, 110, 200,  27, "", #PB_String_ReadOnly)
		ButtonImageGadget(#BIG_DQuote, 640,  83,  32,  54, CreateImg_Dquote(#Img_DQuote), #PB_Button_Toggle)
		
		SetGadgetFont(#CBG_FndVal,     FontID(0))
		SetGadgetFont(#StG_PbConst,    FontID(0))
		SetGadgetFont(#StG_PbHexCol,   FontID(0))
		SetGadgetFont(#StG_PbCol,      FontID(0))
		SetGadgetFont(#StG_PbColAlpha, FontID(0))
		SetGadgetFont(#StG_ColCSS,     FontID(0))
		SetGadgetFont(#StG_NameCSS,    FontID(0))
		SetGadgetFont(#StG_ColRGB,     FontID(0))
		SetGadgetFont(#StG_ColRGBA,    FontID(0))
		SetGadgetState(#BIG_DQuote,    Pref\DQuoteOn)
		
		FrameGadget(#Frm_Data, 2,  1, 675, 141, " Data of selected color ")
		CloseGadgetList()
		
		;place Icon behind ComboBox (Linux gtk3 prob.) and align
		ResizeGadget(#BIG_FndName,      191 + GadgetWidth(#CBG_FndVal), #PB_Ignore, #PB_Ignore, #PB_Ignore)
		ResizeGadget(#BIG_FndSelection, 191 + GadgetWidth(#CBG_FndVal), #PB_Ignore, #PB_Ignore, #PB_Ignore)
		ResizeGadget(#BIG_FndVal,       191 + GadgetWidth(#CBG_FndVal), #PB_Ignore, #PB_Ignore, #PB_Ignore)
		ResizeGadget(#BIG_ArrBowL2B, GadgetX(#BIG_FndVal) + GadgetWidth(#BIG_FndVal) + 2, #PB_Ignore, #PB_Ignore, #PB_Ignore)
		
		HideGadget  (#TxG_PickColor, #True)
		
		AddKeyboardShortcut(#Win_Main, #PB_Shortcut_Space,  #PB_Key_Space << 8);   for picker
		
		GadgetToolTip(#BIG_Settings,  "About-dialog, color sorting and basic settings")
		GadgetToolTip(#StG_FndName,   "Term for name search!" + #LF$ + "(Part of) color name to search within the current " + #LF$ + 
		                              "colors list and list them in the right one." + #LF$ + 
		                              "Usual constant names (i.e. #CSS_Beige) are autoconverted.")
		GadgetToolTip(#BIG_FndName,   "Starts search of the term in the StringGadget at the left " + #LF$ + 
		                              "and lists the found colors in the right ListIconGadget (Results).")
		GadgetToolTip(#BIG_FndSelection, "Lists the colors in the right ListIconGadget within the tolerance " + #LF$ + 
		                              "to each RGB value of the selected color in curr. color list. " + #LF$ + 
		                              "Tolerance is set in the SpinGadget. " + #LF$ + 
		                              "-> Same as a Doubleclick on an 'color list'-item!")
		GadgetToolTip(#CBG_FndVal,    "Term for value-search!" + #LF$ + 
		                              "Must be a PB-HEX-value with $ & 6 signs (without alpha) " + #LF$ + 
		                              "like '$FF00FF' as '$bbggrr' (at the moment). " + #LF$ + 
		                              "Converted to PB-HEX-Format '$bbggrr' on search start:" + #LF$ + 
		                              "Pasted types: '#rrggbb', '$aabbggrr', rgb(r,g,b), rgba(r,g,b,a) are " + #LF$ + 
		                              "auto-converted to PB-format w/o alpha!" + #LF$ + 
		                              "The last 10 entries are stored temporarily." + #LF$ + 
		                              "(I.e. search a named color for a value or a picked color.)")
		GadgetToolTip(#BIG_FndVal,    "Lists all colors in the right ListIconGadget " + #LF$ + "within the tolerance to each RGB value of the " + #LF$ + "given PB-HEX-value in the ComboBox at the left.")
		GadgetToolTip(#BIG_ArrBowL2B, "Converts the (PB-format-) HEX-value to the " + #LF$ + 
		                              "'unnamed' values in the data-fields. ")
		GadgetToolTip(#BIG_DQuote,    "Sets some values with quotation marks (as used in CSS) " + #LF$ + 
		                              "in data fields and clipboard.")
		GadgetToolTip(#BIG_Pipette,   "Activates the color picker! " + #LF$ + 
		                              "With 'SPACEBAR' you get the pixel-color at mouseposition. " + #LF$ + 
		                              "It's written to the PB-HEX-value in the ComboBox at the left. " + #LF$ + 
		                              "This Window must retain the focus! In 'Settings' ca you activate 'single' picks.")
		GadgetToolTip(#CvG_VFold,     "Unfold / fold the data part by click or mousewheel.")
		GadgetToolTip(#TxG_SrchBkgnd, "")
		GadgetToolTip(#TxG_SrchBkgnd, "")
		
		If Pref\Sticky
			StickyWindow(#Win_Main, Pref\Sticky)
			gSOT= Pref\Sticky
		EndIf
		
		CompilerIf #PB_Compiler_OS = #PB_OS_Linux
			g_signal_connect(gSpGTol, "value-changed", @Callback_SButtonVChanged(), 0)
			gtk_widget_set_tooltip_text(gSpGTol, "Sets the tolerance for each primary color (b | g | r) " + #LF$ + 
			                                     "for the similarity-search from value or selection." + #LF$ + 
			                                     "The found color list is updated immediately.")
			; search (next) in LIG1 (provisionally only Linux) ...
			gtk_tree_view_set_search_column_(GadgetID(#LIG1), 0);                                              set column 0 for search
			gtk_tree_view_set_search_equal_func_(GadgetID(#LIG1), @Callback_SearchInTreeView(), #LIG1, #Null); set function for verification
		CompilerElse
			GadgetToolTip(#SpG_Tol,     "Sets the tolerance for each primary color (b | g | r) " + #LF$ + 
			                            "for the similarity-search from value or selection." + #LF$ + 
			                            "The found-colors are updated immediately.")
		CompilerEndIf
	EndIf
EndProcedure
;-
;- MAIN ______________________________
OnErrorCall(@ErrorHandler())

ExamineDesktops()
PreferenceRead()

Load_ColorList()
Create_WinMain()

;-
;- - Event loop _____
Repeat
	gEvent   = WaitWindowEvent()
	gEventWin= EventWindow()
	
	If gEventWin = #Win_Main
		
		Select gEvent
				
				;--  Close
			Case #PB_Event_CloseWindow
				gQuit= #True
				
				;--  Gadget
			Case #PB_Event_Gadget
				
				Select EventGadget()
						
					Case #CBG_ColList;                                         ComboBox w. color list
						If EventType() = #PB_EventType_Change
							Color_ChangeList(GetGadgetState(#CBG_ColList))
							gPrevColor   = -1
							gPrevCbGValue= -1
						EndIf
						
					Case #BIG_FndSelection;                                    Find by selected item
						If GetGadgetState(#LIG1) < 0
							If gPrevColor > -1
								SetGadgetState(#LIG1, gPrevColor)
							EndIf
						EndIf
						If Colors_ShowSimilar()
							gPrevSearch= #BIG_FndSelection
							SetGadgetItemText(#LIG2, -1, "Results (from selection)", 0)
						EndIf
						
					Case #StG_FndName
						Select EventType()
								Case #PB_EventType_Change
									Color_ConvertNameInput()
								Case #PB_EventType_Focus
									AddKeyboardShortcut(#Win_Main, #PB_Shortcut_Return, #PB_Key_Return << 8)
								Case #PB_EventType_LostFocus;                        -> for direct input in SpinGadget
									RemoveKeyboardShortcut(#Win_Main, #PB_Shortcut_Return)
						EndSelect
						
					Case #BIG_FndName;                                         Find by part of name
						If GetGadgetText(#StG_FndName) <> ""
							If Colors_FindName() > -1
								gPrevSearch= #BIG_FndName
								SetGadgetItemText(#LIG2, -1, "Results (with name part)", 0)
							EndIf
						EndIf
						
					Case #BIG_FndVal;                                          Find by value
						SetGadgetState(#LIG1, -1)
						Color_Convert2PbHex()
						If Colors_ShowSimilar(GetGadgetText(#CBG_FndVal))
							GadgetToolTip(#TxG_SrchBkgnd, "color from value " + GetGadgetText(#CBG_FndVal))
							gPrevSearch= #BIG_FndVal
							SetGadgetItemText(#LIG2, -1, "Results (from value)", 0)
						EndIf
						
					Case #CBG_FndVal;                                          type/paste in or select stored values
						Select EventType()
							Case #PB_EventType_Change
								If GetGadgetState(#CBG_FndVal) <> gPrevCbGValue
									If Colors_ShowSimilar(GetGadgetText(#CBG_FndVal))
										GadgetToolTip(#TxG_SrchBkgnd, "color from value")
										gPrevCbGValue= GetGadgetState(#CBG_FndVal)
										SetGadgetItemText(#LIG2, -1, "Results (from value)", 0)
									EndIf
								EndIf
							Case #PB_EventType_Focus
								AddKeyboardShortcut(#Win_Main, #PB_Shortcut_Return, #PB_Key_Return << 8)
							Case #PB_EventType_LostFocus;                          -> for direct input in SpinGadget
								RemoveKeyboardShortcut(#Win_Main, #PB_Shortcut_Return)
						EndSelect
						
					Case #LIG1;                                                colortable
						gEventType= EventType()
						If gEventType = #PB_EventType_Change
							If GetGadgetState(#LIG1) > -1
								gPrevColor= GetGadgetState(#LIG1)
								SetGadgetText (#CBG_FndVal,        GetGadgetItemText(#LIG1, GetGadgetState(#LIG1), 1))
								SetGadgetColor(#TxG_SrchBkgnd,     #PB_Gadget_BackColor, GetGadgetItemColor(#LIG1, GetGadgetState(#LIG1), #PB_Gadget_BackColor, 1))
								Color_SetBkgndName(#TxG_SrchBkgnd, GetGadgetItemText(#LIG1, GetGadgetState(#LIG1), 0))
								Color_Copy2DataFields(#LIG1)
							EndIf
						ElseIf gEventType = #PB_EventType_RightClick;            popup in LIG1 (color list)
							If GetGadgetState(#LIG1) > -1
								DisplayPopupMenu(#PuCListL, WindowID(#Win_Main))
								SetMenuItemState(#PuCListL, #PuClL_CpLstAddComnt, gListExpWComnt)
							Else
								DisplayPopupMenu(#PuSort, WindowID(#Win_Main))
							EndIf
						ElseIf gEventType = #PB_EventType_LeftDoubleClick;       transfer selection to #LIG1
							If Colors_ShowSimilar()
								gPrevSearch= #BIG_FndSelection
								SetGadgetItemText(#LIG2, -1, "Results (from selection)", 0)
							EndIf
						EndIf
						
					Case #LIG2;                                                found colors
						gEventType= EventType()
						If gEventType = #PB_EventType_Change
							If GetGadgetState(#LIG2) > -1
								SetGadgetColor(#TxG_CompBkgnd, #PB_Gadget_BackColor, GetGadgetItemColor(#LIG2, GetGadgetState(#LIG2), #PB_Gadget_BackColor, 1))
								Color_SetBkgndName(#TxG_CompBkgnd, GetGadgetItemText(#LIG2, GetGadgetState(#LIG2), 0))
							EndIf
						ElseIf gEventType = #PB_EventType_RightClick;            popup in LIG2 (found colors)
							If GetGadgetState(#LIG2) > -1
								DisplayPopupMenu(#PuCListR, WindowID(#Win_Main))
							EndIf
						ElseIf gEventType = #PB_EventType_LeftDoubleClick;       transfer selection to #LIG1
							SetGadgetState(#LIG1, Colors_FindName(GetGadgetItemText(#LIG2, GetGadgetState(#LIG2), 0), 3))
							PostEvent(#PB_Event_Gadget, #Win_Main, #LIG1, #PB_EventType_Change)
						EndIf
						
					Case #BIG_ArrBowL2B;                                       value translated in data field
						If Not PbHex_StringIsInvalid(GetGadgetText(#CBG_FndVal))
							If GetGadgetText(#CBG_FndVal) <> ""
								PbHex_Convert2Data(GetGadgetText(#CBG_FndVal))
							Else
								MessageRequester(#App_Name, "No valid PB-HEX-value!")
							EndIf
						EndIf
						
					Case #SpG_Tol;                                             tolerance change
						Colors_UpdateFinds(EventType())
						
					Case #BIG_Settings
						CompilerIf #PB_Compiler_OS = #PB_OS_Windows Or #PB_Compiler_OS = #PB_OS_MacOS; GTK3-Warning if placed here in Linux
							SetMenuItemState(#PuInfo, #PuInf_WinSOT,    gSOT)
							SetMenuItemState(#PuInfo, #PuInf_PickerRst, gPickRst)
							SetMenuItemState(#PuInfo, #PuInf_ColorSpy,  gColorSpy)
						CompilerEndIf
						DisplayPopupMenu(#PuInfo, WindowID(#Win_Main))
						CompilerIf #PB_Compiler_OS = #PB_OS_Linux
							SetMenuItemState(#PuInfo, #PuInf_WinSOT,    gSOT)
							SetMenuItemState(#PuInfo, #PuInf_PickerRst, gPickRst)
							SetMenuItemState(#PuInfo, #PuInf_ColorSpy,  gColorSpy)
						CompilerEndIf
						
					Case #BIG_Pipette
						If GetGadgetState(#BIG_Pipette)
							If gColorSpy
								AddWindowTimer(#Win_Main, #TimerCSpy, #PeriodCSpy)
								HideGadget    (#TxG_PickColor, #False)
							EndIf
						Else
							If gColorSpy
								RemoveWindowTimer(#Win_Main, #TimerCSpy)
								HideGadget    (#TxG_PickColor, #True)
							EndIf
						EndIf
						
					Case #CvG_VFold;                                           (un)-folding of data section in window
						
						Select EventType()
								
							Case #PB_EventType_LeftClick
								If WindowHeight(#Win_Main) < 500;                        folded window
									ResizeWindow(#Win_Main, #PB_Ignore, #PB_Ignore, #PB_Ignore, 572)
									While WindowEvent() : Wend;                           avoids flicker ?
									HideGadget(#CtG_Data, #False)
									CreateCanvas_FoldDown(#CvG_VFold, WindowWidth(#Win_Main), #X11_Tomato)
								Else;                                                    unfolded window
									HideGadget(#CtG_Data, #True)
									ResizeWindow(#Win_Main, #PB_Ignore, #PB_Ignore, #PB_Ignore, 428)
									CreateCanvas_FoldDown(#CvG_VFold, WindowWidth(#Win_Main), #CSS_DarkTurquoise)
								EndIf
								
							Case #PB_EventType_MouseWheel
								If GetGadgetAttribute(#CvG_VFold, #PB_Canvas_WheelDelta) > 0
									HideGadget(#CtG_Data, #True)
									ResizeWindow(#Win_Main, #PB_Ignore, #PB_Ignore, #PB_Ignore, 428)
									CreateCanvas_FoldDown(#CvG_VFold, WindowWidth(#Win_Main), #CSS_DarkTurquoise)
								ElseIf GetGadgetAttribute(#CvG_VFold, #PB_Canvas_WheelDelta) < 0
									ResizeWindow(#Win_Main, #PB_Ignore, #PB_Ignore, #PB_Ignore, 572)
									While WindowEvent() : Wend;                           avoids flicker ?
									HideGadget(#CtG_Data, #False)
									CreateCanvas_FoldDown(#CvG_VFold, WindowWidth(#Win_Main), #X11_Tomato)
								EndIf
								
						EndSelect
						
				EndSelect
				
			Case #PB_Event_Menu
				
				gEventMenu= EventMenu()
				
				;--  Menu & Popups
				Select gEventMenu
						
					Case #PB_Key_Return << 8;                                  Return-key activates focused-string-associated Button
						
						Select GetActiveGadget()
								
							Case #StG_FndName;                                     search start for color name entry
								PostEvent(#PB_Event_Gadget, #Win_Main, #BIG_FndName)
								
							Case #CBG_FndVal;                                      search start for color value entry
								PostEvent(#PB_Event_Gadget, #Win_Main, #BIG_FndVal)
								
						EndSelect
						
					Case #PB_Key_Space << 8;                                   Space-key: get value from color picker
						If GetGadgetState(#BIG_Pipette)
							SetGadgetText(#CBG_FndVal, Color_PbVal2PbHex(Color_PickFromMousePos()))
							Entry_Blink(#CBG_FndVal, #VGA_BrightCyan)
							SetActiveGadget(#CBG_FndVal)
							If gPickRst
								SetGadgetState(#BIG_Pipette, #False)
								If gColorSpy
									RemoveWindowTimer(#Win_Main, #TimerCSpy)
									HideGadget       (#TxG_PickColor, #True)
								EndIf
							EndIf
						EndIf
						
					;popup on selected item in left color list
					Case #PuClL_CpPbConstname, #PuClL_CpPbConstDef, #PuClL_CpPbConstADef, #PuClL_CpPbHxValue, #PuClL_CpPbHxAValue, #PuClL_CpHxValue, 
					     #PuClL_CpCName, #PuClL_CpRGB, #PuClL_CpRGBA, #PuClL_CpLstHxValue, #PuClL_CpLstHxAValue
						Clipboard_ExpFromColorList(gEventMenu);                  popup item
						
					;popup checkbox: Export with commented values
					Case #PuClL_CpLstAddComnt
						gListExpWComnt= GetMenuItemState(#PuCListL, #PuClL_CpLstAddComnt) ! #True
						
					;popup on selected item in right list (found colors)
					Case #PuClR_CpPbConstname, #PuClR_CpPbConstDef, #PuClR_CpPbConstADef, #PuClR_CpPbHxValue, #PuClR_CpPbHxAValue, #PuClR_CpHxValue, 
					     #PuClR_CpCName, #PuClR_CpRGB, #PuClR_CpRGBA, #PuClR_ScrlToInCLst, #PuClR_SelInCLst, #PuClR_SelInCLstAData, #PuClR_Sel2Data
						Clipboard_ExpFromColorsFound(gEventMenu);                popup item
						
					Case #PuSort_ByName, #PuInf_SortByName;                    Rightclick in selectionfree LIG1 (not Windows), alternative Settings-Popup
						Sort_ColorList(#PuSort_ByName)
						
					Case #PuSort_ByValue, #PuInf_SortByValue;                  Rightclick in selectionfree LIG1 (not Windows), alternative Settings-Popup
						Sort_ColorList(#PuSort_ByValue)
						
					Case #PuInf_AboutApp
						MessageRequester(#App_Name + " - Info", "Find & compare colors from color lists (CSS, X11, RAL, ...)," + #LF$ + 
						                                        "- search by (part of) name or similar color values," + #LF$ + 
						                                        "- auto. conversion from pasted values to PB format ($bbggrr)," + #LF$ + 
						                                        "- color picker (by wilbert, PureLust, netmaestro, infratec, idle)," + #LF$ + 
						                                        "- transfer to some other formats, exports, ..." + #LF$ + "" + #LF$ + 
						                                        "V0.50, 2016-09-03 by Omi" + #LF$ + 
						                                        "for PureBasic V5.4x Lin/(Mac)/Win")
						
					Case #PuInf_WinSOT;                                        popup check Stay on top
						gSOT= GetMenuItemState(#PuInfo, #PuInf_WinSOT) ! #True
						StickyWindow(#Win_Main, gSOT)
						
					Case #PuInf_PickerRst;                                     popup check for picker button reset
						gPickRst= GetMenuItemState(#PuInfo, #PuInf_PickerRst) ! #True
						
					Case #PuInf_ColorSpy;                                      popup check for colorpicker-spy
						gColorSpy= GetMenuItemState(#PuInfo, #PuInf_ColorSpy) ! #True
						If GetGadgetState(#BIG_Pipette)
							If gColorSpy
								AddWindowTimer(#Win_Main, #TimerCSpy, #PeriodCSpy)
								HideGadget    (#TxG_PickColor, #False)
							Else
								RemoveWindowTimer(#Win_Main, #TimerCSpy)
								HideGadget    (#TxG_PickColor, #True)
							EndIf
						EndIf
				EndSelect
				
			Case #PB_Event_Timer
				
				If EventTimer() = #TimerCSpy
					If GetActiveWindow() = #Win_Main And gColorSpy
						If WindowMouseX(#Win_Main) = -1 Or WindowMouseY(#Win_Main) = -1
							SetGadgetColor(#TxG_PickColor, #PB_Gadget_BackColor, Color_PickFromMousePos())
						EndIf
					EndIf
				EndIf
				
		EndSelect
		
	EndIf
	
Until gQuit

If GetGadgetState(#BIG_Pipette) And gColorSpy
	RemoveWindowTimer(#Win_Main, #TimerCSpy)
EndIf

PreferenceSave()
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 1998
; FirstLine = 1976
; Folding = ------------
; EnableUnicode
; EnableXP
; Executable = ../PB-ColorScout
; CompileSourceDirectory