﻿;*** Color constants for PureBasic (BGR) and native (RGB) i.e. for CSS, Cairo, ... ***
;*** 2015-06-02, Charly Bauer (Omi)                                                ***

;<IncludedNamespaces>
;#CSS_=  CSS basic colors [≈140]
;#X11_=  X11 (ext. CSS colors) [≈550]; same names w. numbered shades, mainly darker
;#VGA_=  VGA basic colors [16]
;#RALe_= RAL eng. names [213]
;#RALg_= RAL ger. names [213]
;#RALne_= RAL num. + eng. names [213]
;#RALng_= RAL num. + ger. names [213]
;#CryStd_= Crayola Standard [163]
;#CryFlr_= Crayola Fluorescent [16]
;#CrySSw_= Crayola Silver Swirls [24]
;#CryMCt_= Crayola Multicultural [11]
;#CrayMSc_= Crayola Magic Scent [30]
;#CryGEM_= Crayola Gem Tones [16]
;#CryPlB_= Crayola Pearl Brite [16]
;#CryMet_= Crayola Metallic FX [16]
;#CryGel_= Crayola Gel FX [16]
;#CrySlS_= Crayola Silly Scents [16]
;#CryHnT_= Crayola Heads n Tails [16]
;#Res_= Resene Colorlist [1383]
;#Pnt_= Pantone Colorlist [3217]
;#LOff_= LibreOffice4 colors [174]
;#XKCD_= xkcd color list [949]
;#WIKI_= Wiki color collection [1298]
;</IncludedNamespaces>

;-CSS-Basic-Color-Definitions (140 + some duplicates with other names, similar to PB-CSS-List)
;  see http://www.w3schools.com/colors/colors_names.asp
;CSS-Colors               PB-Color:   "+Alpha:   API-color: RGB-Color:          RGBA-Color:              CSS-Colorname:
#CSS_AliceBlue            = $FFF8F0;  $FFFFF8F0  "#F0F8FF"  "rgb(240,248,255)"  "rgba(240,248,255,255)"  "AliceBlue"
#CSS_AntiqueWhite         = $D7EBFA;  $FFD7EBFA  "#FAEBD7"  "rgb(250,235,215)"  "rgba(250,235,215,255)"  "AntiqueWhite"
#CSS_Aqua                 = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(  0,255,255)"  "rgba(  0,255,255,255)"  "Aqua"
#CSS_Aquamarine           = $D4FF7F;  $FFD4FF7F  "#7FFFD4"  "rgb(127,255,212)"  "rgba(127,255,212,255)"  "Aquamarine"
#CSS_Azure                = $FFFFF0;  $FFFFFFF0  "#F0FFFF"  "rgb(240,255,255)"  "rgba(240,255,255,255)"  "Azure"
#CSS_Beige                = $DCF5F5;  $FFDCF5F5  "#F5F5DC"  "rgb(245,245,220)"  "rgba(245,245,220,255)"  "Beige"
#CSS_Bisque               = $C4E4FF;  $FFC4E4FF  "#FFE4C4"  "rgb(255,228,196)"  "rgba(255,228,196,255)"  "Bisque"
#CSS_Black                = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "Black"
#CSS_BlanchedAlmond       = $CDEBFF;  $FFCDEBFF  "#FFEBCD"  "rgb(255,235,205)"  "rgba(255,235,205,255)"  "BlanchedAlmond"
#CSS_Blue                 = $FF0000;  $FFFF0000  "#0000FF"  "rgb(  0,  0,255)"  "rgba(  0,  0,255,255)"  "Blue"
#CSS_BlueViolet           = $E22B8A;  $FFE22B8A  "#8A2BE2"  "rgb(138, 43,226)"  "rgba(138, 43,226,255)"  "BlueViolet"
#CSS_Brown                = $2A2AA5;  $FF2A2AA5  "#A52A2A"  "rgb(165, 42, 42)"  "rgba(165, 42, 42,255)"  "Brown"
#CSS_BurlyWood            = $87B8DE;  $FF87B8DE  "#DEB887"  "rgb(222,184,135)"  "rgba(222,184,135,255)"  "BurlyWood"
#CSS_CadetBlue            = $A09E5F;  $FFA09E5F  "#5F9EA0"  "rgb( 95,158,160)"  "rgba( 95,158,160,255)"  "CadetBlue"
#CSS_Chartreuse           = $00FF7F;  $FF00FF7F  "#7FFF00"  "rgb(127,255,  0)"  "rgba(127,255,  0,255)"  "Chartreuse"
#CSS_Chocolate            = $1E69D2;  $FF1E69D2  "#D2691E"  "rgb(210,105, 30)"  "rgba(210,105, 30,255)"  "Chocolate"
#CSS_Coral                = $507FFF;  $FF507FFF  "#FF7F50"  "rgb(255,127, 80)"  "rgba(255,127, 80,255)"  "Coral"
#CSS_CornflowerBlue       = $ED9564;  $FFED9564  "#6495ED"  "rgb(100,149,237)"  "rgba(100,149,237,255)"  "CornflowerBlue"
#CSS_Cornsilk             = $DCF8FF;  $FFDCF8FF  "#FFF8DC"  "rgb(255,248,220)"  "rgba(255,248,220,255)"  "Cornsilk"
#CSS_Crimson              = $3C14DC;  $FF3C14DC  "#DC143C"  "rgb(220, 20, 60)"  "rgba(220, 20, 60,255)"  "Crimson"
#CSS_Cyan                 = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(  0,255,255)"  "rgba(  0,255,255,255)"  "Cyan"
#CSS_DarkBlue             = $8B0000;  $FF8B0000  "#00008B"  "rgb(  0,  0,139)"  "rgba(  0,  0,139,255)"  "DarkBlue"
#CSS_DarkCyan             = $8B8B00;  $FF8B8B00  "#008B8B"  "rgb(  0,139,139)"  "rgba(  0,139,139,255)"  "DarkCyan"
#CSS_DarkGoldenRod        = $0B86B8;  $FF0B86B8  "#B8860B"  "rgb(184,134, 11)"  "rgba(184,134, 11,255)"  "DarkGoldenRod"
#CSS_DarkGray             = $A9A9A9;  $FFA9A9A9  "#A9A9A9"  "rgb(169,169,169)"  "rgba(169,169,169,255)"  "DarkGray"
#CSS_DarkGrey             = $A9A9A9;  $FFA9A9A9  "#A9A9A9"  "rgb(169,169,169)"  "rgba(169,169,169,255)"  "DarkGrey"
#CSS_DarkGreen            = $006400;  $FF006400  "#006400"  "rgb(  0,100,  0)"  "rgba(  0,100,  0,255)"  "DarkGreen"
#CSS_DarkKhaki            = $6BB7BD;  $FF6BB7BD  "#BDB76B"  "rgb(189,183,107)"  "rgba(189,183,107,255)"  "DarkKhaki"
#CSS_DarkMagenta          = $8B008B;  $FF8B008B  "#8B008B"  "rgb(139,  0,139)"  "rgba(139,  0,139,255)"  "DarkMagenta"
#CSS_DarkOliveGreen       = $2F6B55;  $FF2F6B55  "#556B2F"  "rgb( 85,107, 47)"  "rgba( 85,107, 47,255)"  "DarkOliveGreen"
#CSS_DarkOrange           = $008CFF;  $FF008CFF  "#FF8C00"  "rgb(255,140,  0)"  "rgba(255,140,  0,255)"  "DarkOrange"
#CSS_DarkOrchid           = $CC3299;  $FFCC3299  "#9932CC"  "rgb(153, 50,204)"  "rgba(153, 50,204,255)"  "DarkOrchid"
#CSS_DarkRed              = $00008B;  $FF00008B  "#8B0000"  "rgb(139,  0,  0)"  "rgba(139,  0,  0,255)"  "DarkRed"
#CSS_DarkSalmon           = $7A96E9;  $FF7A96E9  "#E9967A"  "rgb(233,150,122)"  "rgba(233,150,122,255)"  "DarkSalmon"
#CSS_DarkSeaGreen         = $8FBC8F;  $FF8FBC8F  "#8FBC8F"  "rgb(143,188,143)"  "rgba(143,188,143,255)"  "DarkSeaGreen"
#CSS_DarkSlateBlue        = $8B3D48;  $FF8B3D48  "#483D8B"  "rgb( 72, 61,139)"  "rgba( 72, 61,139,255)"  "DarkSlateBlue"
#CSS_DarkSlateGray        = $4F4F2F;  $FF4F4F2F  "#2F4F4F"  "rgb( 47, 79, 79)"  "rgba( 47, 79, 79,255)"  "DarkSlateGray"
#CSS_DarkSlateGrey        = $4F4F2F;  $FF4F4F2F  "#2F4F4F"  "rgb( 47, 79, 79)"  "rgba( 47, 79, 79,255)"  "DarkSlateGrey"
#CSS_DarkTurquoise        = $D1CE00;  $FFD1CE00  "#00CED1"  "rgb(  0,206,209)"  "rgba(  0,206,209,255)"  "DarkTurquoise"
#CSS_DarkViolet           = $D30094;  $FFD30094  "#9400D3"  "rgb(148,  0,211)"  "rgba(148,  0,211,255)"  "DarkViolet"
#CSS_DeepPink             = $9314FF;  $FF9314FF  "#FF1493"  "rgb(255, 20,147)"  "rgba(255, 20,147,255)"  "DeepPink"
#CSS_DeepSkyBlue          = $FFBF00;  $FFFFBF00  "#00BFFF"  "rgb(  0,191,255)"  "rgba(  0,191,255,255)"  "DeepSkyBlue"
#CSS_DimGray              = $696969;  $FF696969  "#696969"  "rgb(105,105,105)"  "rgba(105,105,105,255)"  "DimGray"
#CSS_DimGrey              = $696969;  $FF696969  "#696969"  "rgb(105,105,105)"  "rgba(105,105,105,255)"  "DimGrey"
#CSS_DodgerBlue           = $FF901E;  $FFFF901E  "#1E90FF"  "rgb( 30,144,255)"  "rgba( 30,144,255,255)"  "DodgerBlue"
#CSS_FireBrick            = $2222B2;  $FF2222B2  "#B22222"  "rgb(178, 34, 34)"  "rgba(178, 34, 34,255)"  "FireBrick"
#CSS_FloralWhite          = $F0FAFF;  $FFF0FAFF  "#FFFAF0"  "rgb(255,250,240)"  "rgba(255,250,240,255)"  "FloralWhite"
#CSS_ForestGreen          = $228B22;  $FF228B22  "#228B22"  "rgb( 34,139, 34)"  "rgba( 34,139, 34,255)"  "ForestGreen"
#CSS_Fuchsia              = $FF00FF;  $FFFF00FF  "#FF00FF"  "rgb(255,  0,255)"  "rgba(255,  0,255,255)"  "Fuchsia"
#CSS_Gainsboro            = $DCDCDC;  $FFDCDCDC  "#DCDCDC"  "rgb(220,220,220)"  "rgba(220,220,220,255)"  "Gainsboro"
#CSS_GhostWhite           = $FFF8F8;  $FFFFF8F8  "#F8F8FF"  "rgb(248,248,255)"  "rgba(248,248,255,255)"  "GhostWhite"
#CSS_Gold                 = $00D7FF;  $FF00D7FF  "#FFD700"  "rgb(255,215,  0)"  "rgba(255,215,  0,255)"  "Gold"
#CSS_GoldenRod            = $20A5DA;  $FF20A5DA  "#DAA520"  "rgb(218,165, 32)"  "rgba(218,165, 32,255)"  "GoldenRod"
#CSS_Gray                 = $808080;  $FF808080  "#808080"  "rgb(128,128,128)"  "rgba(128,128,128,255)"  "Gray"
#CSS_Grey                 = $808080;  $FF808080  "#808080"  "rgb(128,128,128)"  "rgba(128,128,128,255)"  "Grey"
#CSS_Green                = $008000;  $FF008000  "#008000"  "rgb(  0,128,  0)"  "rgba(  0,128,  0,255)"  "Green"
#CSS_GreenYellow          = $2FFFAD;  $FF2FFFAD  "#ADFF2F"  "rgb(173,255, 47)"  "rgba(173,255, 47,255)"  "GreenYellow"
#CSS_HoneyDew             = $F0FFF0;  $FFF0FFF0  "#F0FFF0"  "rgb(240,255,240)"  "rgba(240,255,240,255)"  "HoneyDew"
#CSS_HotPink              = $B469FF;  $FFB469FF  "#FF69B4"  "rgb(255,105,180)"  "rgba(255,105,180,255)"  "HotPink"
#CSS_IndianRed            = $5C5CCD;  $FF5C5CCD  "#CD5C5C"  "rgb(205, 92, 92)"  "rgba(205, 92, 92,255)"  "IndianRed"
#CSS_Indigo               = $82004B;  $FF82004B  "#4B0082"  "rgb( 75,  0,130)"  "rgba( 75,  0,130,255)"  "Indigo"
#CSS_Ivory                = $F0FFFF;  $FFF0FFFF  "#FFFFF0"  "rgb(255,255,240)"  "rgba(255,255,240,255)"  "Ivory"
#CSS_Khaki                = $8CE6F0;  $FF8CE6F0  "#F0E68C"  "rgb(240,230,140)"  "rgba(240,230,140,255)"  "Khaki"
#CSS_Lavender             = $FAE6E6;  $FFFAE6E6  "#E6E6FA"  "rgb(230,230,250)"  "rgba(230,230,250,255)"  "Lavender"
#CSS_LavenderBlush        = $F5F0FF;  $FFF5F0FF  "#FFF0F5"  "rgb(255,240,245)"  "rgba(255,240,245,255)"  "LavenderBlush"
#CSS_LawnGreen            = $00FC7C;  $FF00FC7C  "#7CFC00"  "rgb(124,252,  0)"  "rgba(124,252,  0,255)"  "LawnGreen"
#CSS_LemonChiffon         = $CDFAFF;  $FFCDFAFF  "#FFFACD"  "rgb(255,250,205)"  "rgba(255,250,205,255)"  "LemonChiffon"
#CSS_LightBlue            = $E6D8AD;  $FFE6D8AD  "#ADD8E6"  "rgb(173,216,230)"  "rgba(173,216,230,255)"  "LightBlue"
#CSS_LightCoral           = $8080F0;  $FF8080F0  "#F08080"  "rgb(240,128,128)"  "rgba(240,128,128,255)"  "LightCoral"
#CSS_LightCyan            = $FFFFE0;  $FFFFFFE0  "#E0FFFF"  "rgb(224,255,255)"  "rgba(224,255,255,255)"  "LightCyan"
#CSS_LightGoldenRodYellow = $D2FAFA;  $FFD2FAFA  "#FAFAD2"  "rgb(250,250,210)"  "rgba(250,250,210,255)"  "LightGoldenRodYellow"
#CSS_LightGray            = $D3D3D3;  $FFD3D3D3  "#D3D3D3"  "rgb(211,211,211)"  "rgba(211,211,211,255)"  "LightGray"
#CSS_LightGrey            = $D3D3D3;  $FFD3D3D3  "#D3D3D3"  "rgb(211,211,211)"  "rgba(211,211,211,255)"  "LightGrey"
#CSS_LightGreen           = $90EE90;  $FF90EE90  "#90EE90"  "rgb(144,238,144)"  "rgba(144,238,144,255)"  "LightGreen"
#CSS_LightPink            = $C1B6FF;  $FFC1B6FF  "#FFB6C1"  "rgb(255,182,193)"  "rgba(255,182,193,255)"  "LightPink"
#CSS_LightSalmon          = $7AA0FF;  $FF7AA0FF  "#FFA07A"  "rgb(255,160,122)"  "rgba(255,160,122,255)"  "LightSalmon"
#CSS_LightSeaGreen        = $AAB220;  $FFAAB220  "#20B2AA"  "rgb( 32,178,170)"  "rgba( 32,178,170,255)"  "LightSeaGreen"
#CSS_LightSkyBlue         = $FACE87;  $FFFACE87  "#87CEFA"  "rgb(135,206,250)"  "rgba(135,206,250,255)"  "LightSkyBlue"
#CSS_LightSlateGray       = $998877;  $FF998877  "#778899"  "rgb(119,136,153)"  "rgba(119,136,153,255)"  "LightSlateGray"
#CSS_LightSlateGrey       = $998877;  $FF998877  "#778899"  "rgb(119,136,153)"  "rgba(119,136,153,255)"  "LightSlateGrey"
#CSS_LightSteelBlue       = $DEC4B0;  $FFDEC4B0  "#B0C4DE"  "rgb(176,196,222)"  "rgba(176,196,222,255)"  "LightSteelBlue"
#CSS_LightYellow          = $E0FFFF;  $FFE0FFFF  "#FFFFE0"  "rgb(255,255,224)"  "rgba(255,255,224,255)"  "LightYellow"
#CSS_Lime                 = $00FF00;  $FF00FF00  "#00FF00"  "rgb(  0,255,  0)"  "rgba(  0,255,  0,255)"  "Lime"
#CSS_LimeGreen            = $32CD32;  $FF32CD32  "#32CD32"  "rgb( 50,205, 50)"  "rgba( 50,205, 50,255)"  "LimeGreen"
#CSS_Linen                = $E6F0FA;  $FFE6F0FA  "#FAF0E6"  "rgb(250,240,230)"  "rgba(250,240,230,255)"  "Linen"
#CSS_Magenta              = $FF00FF;  $FFFF00FF  "#FF00FF"  "rgb(255,  0,255)"  "rgba(255,  0,255,255)"  "Magenta"
#CSS_Maroon               = $000080;  $FF000080  "#800000"  "rgb(128,  0,  0)"  "rgba(128,  0,  0,255)"  "Maroon"
#CSS_MediumAquaMarine     = $AACD66;  $FFAACD66  "#66CDAA"  "rgb(102,205,170)"  "rgba(102,205,170,255)"  "MediumAquaMarine"
#CSS_MediumBlue           = $CD0000;  $FFCD0000  "#0000CD"  "rgb(  0,  0,205)"  "rgba(  0,  0,205,255)"  "MediumBlue"
#CSS_MediumOrchid         = $D355BA;  $FFD355BA  "#BA55D3"  "rgb(186, 85,211)"  "rgba(186, 85,211,255)"  "MediumOrchid"
#CSS_MediumPurple         = $DB7093;  $FFDB7093  "#9370DB"  "rgb(147,112,219)"  "rgba(147,112,219,255)"  "MediumPurple"
#CSS_MediumSeaGreen       = $71B33C;  $FF71B33C  "#3CB371"  "rgb( 60,179,113)"  "rgba( 60,179,113,255)"  "MediumSeaGreen"
#CSS_MediumSlateBlue      = $EE687B;  $FFEE687B  "#7B68EE"  "rgb(123,104,238)"  "rgba(123,104,238,255)"  "MediumSlateBlue"
#CSS_MediumSpringGreen    = $9AFA00;  $FF9AFA00  "#00FA9A"  "rgb(  0,250,154)"  "rgba(  0,250,154,255)"  "MediumSpringGreen"
#CSS_MediumTurquoise      = $CCD148;  $FFCCD148  "#48D1CC"  "rgb( 72,209,204)"  "rgba( 72,209,204,255)"  "MediumTurquoise"
#CSS_MediumVioletRed      = $8515C7;  $FF8515C7  "#C71585"  "rgb(199, 21,133)"  "rgba(199, 21,133,255)"  "MediumVioletRed"
#CSS_MidnightBlue         = $701919;  $FF701919  "#191970"  "rgb( 25, 25,112)"  "rgba( 25, 25,112,255)"  "MidnightBlue"
#CSS_MintCream            = $FAFFF5;  $FFFAFFF5  "#F5FFFA"  "rgb(245,255,250)"  "rgba(245,255,250,255)"  "MintCream"
#CSS_MistyRose            = $E1E4FF;  $FFE1E4FF  "#FFE4E1"  "rgb(255,228,225)"  "rgba(255,228,225,255)"  "MistyRose"
#CSS_Moccasin             = $B5E4FF;  $FFB5E4FF  "#FFE4B5"  "rgb(255,228,181)"  "rgba(255,228,181,255)"  "Moccasin"
#CSS_NavajoWhite          = $ADDEFF;  $FFADDEFF  "#FFDEAD"  "rgb(255,222,173)"  "rgba(255,222,173,255)"  "NavajoWhite"
#CSS_Navy                 = $800000;  $FF800000  "#000080"  "rgb(  0,  0,128)"  "rgba(  0,  0,128,255)"  "Navy"
#CSS_OldLace              = $E6F5FD;  $FFE6F5FD  "#FDF5E6"  "rgb(253,245,230)"  "rgba(253,245,230,255)"  "OldLace"
#CSS_Olive                = $008080;  $FF008080  "#808000"  "rgb(128,128,  0)"  "rgba(128,128,  0,255)"  "Olive"
#CSS_OliveDrab            = $238E6B;  $FF238E6B  "#6B8E23"  "rgb(107,142, 35)"  "rgba(107,142, 35,255)"  "OliveDrab"
#CSS_Orange               = $00A5FF;  $FF00A5FF  "#FFA500"  "rgb(255,165,  0)"  "rgba(255,165,  0,255)"  "Orange"
#CSS_OrangeRed            = $0045FF;  $FF0045FF  "#FF4500"  "rgb(255, 69,  0)"  "rgba(255, 69,  0,255)"  "OrangeRed"
#CSS_Orchid               = $D670DA;  $FFD670DA  "#DA70D6"  "rgb(218,112,214)"  "rgba(218,112,214,255)"  "Orchid"
#CSS_PaleGoldenRod        = $AAE8EE;  $FFAAE8EE  "#EEE8AA"  "rgb(238,232,170)"  "rgba(238,232,170,255)"  "PaleGoldenRod"
#CSS_PaleGreen            = $98FB98;  $FF98FB98  "#98FB98"  "rgb(152,251,152)"  "rgba(152,251,152,255)"  "PaleGreen"
#CSS_PaleTurquoise        = $EEEEAF;  $FFEEEEAF  "#AFEEEE"  "rgb(175,238,238)"  "rgba(175,238,238,255)"  "PaleTurquoise"
#CSS_PaleVioletRed        = $9370DB;  $FF9370DB  "#DB7093"  "rgb(219,112,147)"  "rgba(219,112,147,255)"  "PaleVioletRed"
#CSS_PapayaWhip           = $D5EFFF;  $FFD5EFFF  "#FFEFD5"  "rgb(255,239,213)"  "rgba(255,239,213,255)"  "PapayaWhip"
#CSS_PeachPuff            = $B9DAFF;  $FFB9DAFF  "#FFDAB9"  "rgb(255,218,185)"  "rgba(255,218,185,255)"  "PeachPuff"
#CSS_Peru                 = $3F85CD;  $FF3F85CD  "#CD853F"  "rgb(205,133, 63)"  "rgba(205,133, 63,255)"  "Peru"
#CSS_Pink                 = $CBC0FF;  $FFCBC0FF  "#FFC0CB"  "rgb(255,192,203)"  "rgba(255,192,203,255)"  "Pink"
#CSS_Plum                 = $DDA0DD;  $FFDDA0DD  "#DDA0DD"  "rgb(221,160,221)"  "rgba(221,160,221,255)"  "Plum"
#CSS_PowderBlue           = $E6E0B0;  $FFE6E0B0  "#B0E0E6"  "rgb(176,224,230)"  "rgba(176,224,230,255)"  "PowderBlue"
#CSS_Purple               = $800080;  $FF800080  "#800080"  "rgb(128,  0,128)"  "rgba(128,  0,128,255)"  "Purple"
#CSS_RebeccaPurple        = $993366;  $FF993366  "#663399"  "rgb(102, 51,153)"  "rgba(102, 51,153,255)"  "RebeccaPurple"
#CSS_Red                  = $0000FF;  $FF0000FF  "#FF0000"  "rgb(255,  0,  0)"  "rgba(255,  0,  0,255)"  "Red"
#CSS_RosyBrown            = $8F8FBC;  $FF8F8FBC  "#BC8F8F"  "rgb(188,143,143)"  "rgba(188,143,143,255)"  "RosyBrown"
#CSS_RoyalBlue            = $E16941;  $FFE16941  "#4169E1"  "rgb( 65,105,225)"  "rgba( 65,105,225,255)"  "RoyalBlue"
#CSS_SaddleBrown          = $13458B;  $FF13458B  "#8B4513"  "rgb(139, 69, 19)"  "rgba(139, 69, 19,255)"  "SaddleBrown"
#CSS_Salmon               = $7280FA;  $FF7280FA  "#FA8072"  "rgb(250,128,114)"  "rgba(250,128,114,255)"  "Salmon"
#CSS_SandyBrown           = $60A4F4;  $FF60A4F4  "#F4A460"  "rgb(244,164, 96)"  "rgba(244,164, 96,255)"  "SandyBrown"
#CSS_SeaGreen             = $578B2E;  $FF578B2E  "#2E8B57"  "rgb( 46,139, 87)"  "rgba( 46,139, 87,255)"  "SeaGreen"
#CSS_SeaShell             = $EEF5FF;  $FFEEF5FF  "#FFF5EE"  "rgb(255,245,238)"  "rgba(255,245,238,255)"  "SeaShell"
#CSS_Sienna               = $2D52A0;  $FF2D52A0  "#A0522D"  "rgb(160, 82, 45)"  "rgba(160, 82, 45,255)"  "Sienna"
#CSS_Silver               = $C0C0C0;  $FFC0C0C0  "#C0C0C0"  "rgb(192,192,192)"  "rgba(192,192,192,255)"  "Silver"
#CSS_SkyBlue              = $EBCE87;  $FFEBCE87  "#87CEEB"  "rgb(135,206,235)"  "rgba(135,206,235,255)"  "SkyBlue"
#CSS_SlateBlue            = $CD5A6A;  $FFCD5A6A  "#6A5ACD"  "rgb(106, 90,205)"  "rgba(106, 90,205,255)"  "SlateBlue"
#CSS_SlateGray            = $908070;  $FF908070  "#708090"  "rgb(112,128,144)"  "rgba(112,128,144,255)"  "SlateGray"
#CSS_SlateGrey            = $908070;  $FF908070  "#708090"  "rgb(112,128,144)"  "rgba(112,128,144,255)"  "SlateGrey"
#CSS_Snow                 = $FAFAFF;  $FFFAFAFF  "#FFFAFA"  "rgb(255,250,250)"  "rgba(255,250,250,255)"  "Snow"
#CSS_SpringGreen          = $7FFF00;  $FF7FFF00  "#00FF7F"  "rgb(  0,255,127)"  "rgba(  0,255,127,255)"  "SpringGreen"
#CSS_SteelBlue            = $B48246;  $FFB48246  "#4682B4"  "rgb( 70,130,180)"  "rgba( 70,130,180,255)"  "SteelBlue"
#CSS_Tan                  = $8CB4D2;  $FF8CB4D2  "#D2B48C"  "rgb(210,180,140)"  "rgba(210,180,140,255)"  "Tan"
#CSS_Teal                 = $808000;  $FF808000  "#008080"  "rgb(  0,128,128)"  "rgba(  0,128,128,255)"  "Teal"
#CSS_Thistle              = $D8BFD8;  $FFD8BFD8  "#D8BFD8"  "rgb(216,191,216)"  "rgba(216,191,216,255)"  "Thistle"
#CSS_Tomato               = $4763FF;  $FF4763FF  "#FF6347"  "rgb(255, 99, 71)"  "rgba(255, 99, 71,255)"  "Tomato"
#CSS_Turquoise            = $D0E040;  $FFD0E040  "#40E0D0"  "rgb( 64,224,208)"  "rgba( 64,224,208,255)"  "Turquoise"
#CSS_Violet               = $EE82EE;  $FFEE82EE  "#EE82EE"  "rgb(238,130,238)"  "rgba(238,130,238,255)"  "Violet"
#CSS_Wheat                = $B3DEF5;  $FFB3DEF5  "#F5DEB3"  "rgb(245,222,179)"  "rgba(245,222,179,255)"  "Wheat"
#CSS_White                = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "White"
#CSS_WhiteSmoke           = $F5F5F5;  $FFF5F5F5  "#F5F5F5"  "rgb(245,245,245)"  "rgba(245,245,245,255)"  "WhiteSmoke"
#CSS_Yellow               = $00FFFF;  $FF00FFFF  "#FFFF00"  "rgb(255,255,  0)"  "rgba(255,255,  0,255)"  "Yellow"
#CSS_YellowGreen          = $32CD9A;  $FF32CD9A  "#9ACD32"  "rgb(154,205, 50)"  "rgba(154,205, 50,255)"  "YellowGreen"

;-X11-Color-Definitions (≈550, full CSS w. shaded colors)
;  see http://www.farb-tabelle.de/en/table-of-color.htm
;-- White
;X11-White                PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_Antiquewhite        = $D7EBFA;  $FFD7EBFA  "#FAEBD7"  "rgb(250,235,215)"  "rgba(250,235,215,255)"  "AntiqueWhite"
#X11_Antiquewhite1       = $DBEFFF;  $FFDBEFFF  "#FFEFDB"  "rgb(255,239,219)"  "rgba(255,239,219,255)"  "AntiqueWhite1"
#X11_Antiquewhite2       = $CCDFEE;  $FFCCDFEE  "#EEDFCC"  "rgb(238,223,204)"  "rgba(238,223,204,255)"  "AntiqueWhite2"
#X11_Antiquewhite3       = $B0C0CD;  $FFB0C0CD  "#CDC0B0"  "rgb(205,192,176)"  "rgba(205,192,176,255)"  "AntiqueWhite3"
#X11_Antiquewhite4       = $78838B;  $FF78838B  "#8B8378"  "rgb(139,131,120)"  "rgba(139,131,120,255)"  "AntiqueWhite4"
#X11_Floralwhite         = $F0FAFF;  $FFF0FAFF  "#FFFAF0"  "rgb(255,250,240)"  "rgba(255,250,240,255)"  "FloralWhite"
#X11_Ghostwhite          = $FFF8F8;  $FFFFF8F8  "#F8F8FF"  "rgb(248,248,255)"  "rgba(248,248,255,255)"  "GhostWhite"
#X11_Navajowhite         = $ADDEFF;  $FFADDEFF  "#FFDEAD"  "rgb(255,222,173)"  "rgba(255,222,173,255)"  "NavajoWhite"
#X11_Navajowhite1        = $ADDEFF;  $FFADDEFF  "#FFDEAD"  "rgb(255,222,173)"  "rgba(255,222,173,255)"  "NavajoWhite1"
#X11_Navajowhite2        = $A1CFEE;  $FFA1CFEE  "#EECFA1"  "rgb(238,207,161)"  "rgba(238,207,161,255)"  "NavajoWhite2"
#X11_Navajowhite3        = $8BB3CD;  $FF8BB3CD  "#CDB38B"  "rgb(205,179,139)"  "rgba(205,179,139,255)"  "NavajoWhite3"
#X11_Navajowhite4        = $5E798B;  $FF5E798B  "#8B795E"  "rgb(139,121, 94)"  "rgba(139,121, 94,255)"  "NavajoWhite4"
#X11_Oldlace             = $E6F5FD;  $FFE6F5FD  "#FDF5E6"  "rgb(253,245,230)"  "rgba(253,245,230,255)"  "OldLace"
#X11_Whitesmoke          = $F5F5F5;  $FFF5F5F5  "#F5F5F5"  "rgb(245,245,245)"  "rgba(245,245,245,255)"  "WhiteSmoke"
#X11_Gainsboro           = $DCDCDC;  $FFDCDCDC  "#DCDCDC"  "rgb(220,220,220)"  "rgba(220,220,220,255)"  "Gainsboro"
#X11_Ivory               = $F0FFFF;  $FFF0FFFF  "#FFFFF0"  "rgb(255,255,240)"  "rgba(255,255,240,255)"  "Ivory"
#X11_Ivory1              = $F0FFFF;  $FFF0FFFF  "#FFFFF0"  "rgb(255,255,240)"  "rgba(255,255,240,255)"  "Ivory1"
#X11_Ivory2              = $E0EEEE;  $FFE0EEEE  "#EEEEE0"  "rgb(238,238,224)"  "rgba(238,238,224,255)"  "Ivory2"
#X11_Ivory3              = $C1CDCD;  $FFC1CDCD  "#CDCDC1"  "rgb(205,205,193)"  "rgba(205,205,193,255)"  "Ivory3"
#X11_Ivory4              = $838B8B;  $FF838B8B  "#8B8B83"  "rgb(139,139,131)"  "rgba(139,139,131,255)"  "Ivory4"
#X11_Linen               = $E6F0FA;  $FFE6F0FA  "#FAF0E6"  "rgb(250,240,230)"  "rgba(250,240,230,255)"  "Linen"
#X11_Seashell            = $EEF5FF;  $FFEEF5FF  "#FFF5EE"  "rgb(255,245,238)"  "rgba(255,245,238,255)"  "Seashell"
#X11_Seashell1           = $EEF5FF;  $FFEEF5FF  "#FFF5EE"  "rgb(255,245,238)"  "rgba(255,245,238,255)"  "Seashell1"
#X11_Seashell2           = $DEE5EE;  $FFDEE5EE  "#EEE5DE"  "rgb(238,229,222)"  "rgba(238,229,222,255)"  "Seashell2"
#X11_Seashell3           = $BFC5CD;  $FFBFC5CD  "#CDC5BF"  "rgb(205,197,191)"  "rgba(205,197,191,255)"  "Seashell3"
#X11_Seashell4           = $82868B;  $FF82868B  "#8B8682"  "rgb(139,134,130)"  "rgba(139,134,130,255)"  "Seashell4"
#X11_Snow                = $FAFAFF;  $FFFAFAFF  "#FFFAFA"  "rgb(255,250,250)"  "rgba(255,250,250,255)"  "Snow"
#X11_Snow1               = $FAFAFF;  $FFFAFAFF  "#FFFAFA"  "rgb(255,250,250)"  "rgba(255,250,250,255)"  "Snow1"
#X11_Snow2               = $E9E9EE;  $FFE9E9EE  "#EEE9E9"  "rgb(238,233,233)"  "rgba(238,233,233,255)"  "Snow2"
#X11_Snow3               = $C9C9CD;  $FFC9C9CD  "#CDC9C9"  "rgb(205,201,201)"  "rgba(205,201,201,255)"  "Snow3"
#X11_Snow4               = $89898B;  $FF89898B  "#8B8989"  "rgb(139,137,137)"  "rgba(139,137,137,255)"  "Snow4"
#X11_Wheat               = $B3DEF5;  $FFB3DEF5  "#F5DEB3"  "rgb(245,222,179)"  "rgba(245,222,179,255)"  "Wheat"
#X11_Wheat1              = $BAE7FF;  $FFBAE7FF  "#FFE7BA"  "rgb(255,231,186)"  "rgba(255,231,186,255)"  "Wheat1"
#X11_Wheat2              = $AED8EE;  $FFAED8EE  "#EED8AE"  "rgb(238,216,174)"  "rgba(238,216,174,255)"  "Wheat2"
#X11_Wheat3              = $96BACD;  $FF96BACD  "#CDBA96"  "rgb(205,186,150)"  "rgba(205,186,150,255)"  "Wheat3"
#X11_Wheat4              = $667E8B;  $FF667E8B  "#8B7E66"  "rgb(139,126,102)"  "rgba(139,126,102,255)"  "Wheat4"
#X11_White               = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "White"

;-- Gray
;X11-Grays                PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_Gray0               = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "Gray0"
#X11_Gray1               = $030303;  $FF030303  "#030303"  "rgb(  3,  3,  3)"  "rgba(  3,  3,  3,255)"  "Gray1"
#X11_Gray2               = $050505;  $FF050505  "#050505"  "rgb(  5,  5,  5)"  "rgba(  5,  5,  5,255)"  "Gray2"
#X11_Gray3               = $080808;  $FF080808  "#080808"  "rgb(  8,  8,  8)"  "rgba(  8,  8,  8,255)"  "Gray3"
#X11_Gray4               = $0A0A0A;  $FF0A0A0A  "#0A0A0A"  "rgb( 10, 10, 10)"  "rgba( 10, 10, 10,255)"  "Gray4"
#X11_Gray5               = $0D0D0D;  $FF0D0D0D  "#0D0D0D"  "rgb( 13, 13, 13)"  "rgba( 13, 13, 13,255)"  "Gray5"
#X11_Gray6               = $0F0F0F;  $FF0F0F0F  "#0F0F0F"  "rgb( 15, 15, 15)"  "rgba( 15, 15, 15,255)"  "Gray6"
#X11_Gray7               = $121212;  $FF121212  "#121212"  "rgb( 18, 18, 18)"  "rgba( 18, 18, 18,255)"  "Gray7"
#X11_Gray8               = $141414;  $FF141414  "#141414"  "rgb( 20, 20, 20)"  "rgba( 20, 20, 20,255)"  "Gray8"
#X11_Gray9               = $171717;  $FF171717  "#171717"  "rgb( 23, 23, 23)"  "rgba( 23, 23, 23,255)"  "Gray9"
#X11_Gray10              = $1A1A1A;  $FF1A1A1A  "#1A1A1A"  "rgb( 26, 26, 26)"  "rgba( 26, 26, 26,255)"  "Gray10"
#X11_Gray11              = $1C1C1C;  $FF1C1C1C  "#1C1C1C"  "rgb( 28, 28, 28)"  "rgba( 28, 28, 28,255)"  "Gray11"
#X11_Gray12              = $1F1F1F;  $FF1F1F1F  "#1F1F1F"  "rgb( 31, 31, 31)"  "rgba( 31, 31, 31,255)"  "Gray12"
#X11_Gray13              = $212121;  $FF212121  "#212121"  "rgb( 33, 33, 33)"  "rgba( 33, 33, 33,255)"  "Gray13"
#X11_Gray14              = $242424;  $FF242424  "#242424"  "rgb( 36, 36, 36)"  "rgba( 36, 36, 36,255)"  "Gray14"
#X11_Gray15              = $262626;  $FF262626  "#262626"  "rgb( 38, 38, 38)"  "rgba( 38, 38, 38,255)"  "Gray15"
#X11_Gray16              = $292929;  $FF292929  "#292929"  "rgb( 41, 41, 41)"  "rgba( 41, 41, 41,255)"  "Gray16"
#X11_Gray17              = $2B2B2B;  $FF2B2B2B  "#2B2B2B"  "rgb( 43, 43, 43)"  "rgba( 43, 43, 43,255)"  "Gray17"
#X11_Gray18              = $2E2E2E;  $FF2E2E2E  "#2E2E2E"  "rgb( 46, 46, 46)"  "rgba( 46, 46, 46,255)"  "Gray18"
#X11_Gray19              = $303030;  $FF303030  "#303030"  "rgb( 48, 48, 48)"  "rgba( 48, 48, 48,255)"  "Gray19"
#X11_Gray20              = $333333;  $FF333333  "#333333"  "rgb( 51, 51, 51)"  "rgba( 51, 51, 51,255)"  "Gray20"
#X11_Gray21              = $363636;  $FF363636  "#363636"  "rgb( 54, 54, 54)"  "rgba( 54, 54, 54,255)"  "Gray21"
#X11_Gray22              = $383838;  $FF383838  "#383838"  "rgb( 56, 56, 56)"  "rgba( 56, 56, 56,255)"  "Gray22"
#X11_Gray23              = $3B3B3B;  $FF3B3B3B  "#3B3B3B"  "rgb( 59, 59, 59)"  "rgba( 59, 59, 59,255)"  "Gray23"
#X11_Gray24              = $3D3D3D;  $FF3D3D3D  "#3D3D3D"  "rgb( 61, 61, 61)"  "rgba( 61, 61, 61,255)"  "Gray24"
#X11_Gray25              = $404040;  $FF404040  "#404040"  "rgb( 64, 64, 64)"  "rgba( 64, 64, 64,255)"  "Gray25"
#X11_Gray26              = $424242;  $FF424242  "#424242"  "rgb( 66, 66, 66)"  "rgba( 66, 66, 66,255)"  "Gray26"
#X11_Gray27              = $454545;  $FF454545  "#454545"  "rgb( 69, 69, 69)"  "rgba( 69, 69, 69,255)"  "Gray27"
#X11_Gray28              = $474747;  $FF474747  "#474747"  "rgb( 71, 71, 71)"  "rgba( 71, 71, 71,255)"  "Gray28"
#X11_Gray29              = $4A4A4A;  $FF4A4A4A  "#4A4A4A"  "rgb( 74, 74, 74)"  "rgba( 74, 74, 74,255)"  "Gray29"
#X11_Gray30              = $4D4D4D;  $FF4D4D4D  "#4D4D4D"  "rgb( 77, 77, 77)"  "rgba( 77, 77, 77,255)"  "Gray30"
#X11_Gray31              = $4F4F4F;  $FF4F4F4F  "#4F4F4F"  "rgb( 79, 79, 79)"  "rgba( 79, 79, 79,255)"  "Gray31"
#X11_Gray32              = $525252;  $FF525252  "#525252"  "rgb( 82, 82, 82)"  "rgba( 82, 82, 82,255)"  "Gray32"
#X11_Gray33              = $545454;  $FF545454  "#545454"  "rgb( 84, 84, 84)"  "rgba( 84, 84, 84,255)"  "Gray33"
#X11_Gray34              = $575757;  $FF575757  "#575757"  "rgb( 87, 87, 87)"  "rgba( 87, 87, 87,255)"  "Gray34"
#X11_Gray35              = $595959;  $FF595959  "#595959"  "rgb( 89, 89, 89)"  "rgba( 89, 89, 89,255)"  "Gray35"
#X11_Gray36              = $5C5C5C;  $FF5C5C5C  "#5C5C5C"  "rgb( 92, 92, 92)"  "rgba( 92, 92, 92,255)"  "Gray36"
#X11_Gray37              = $5E5E5E;  $FF5E5E5E  "#5E5E5E"  "rgb( 94, 94, 94)"  "rgba( 94, 94, 94,255)"  "Gray37"
#X11_Gray38              = $616161;  $FF616161  "#616161"  "rgb( 97, 97, 97)"  "rgba( 97, 97, 97,255)"  "Gray38"
#X11_Gray39              = $636363;  $FF636363  "#636363"  "rgb( 99, 99, 99)"  "rgba( 99, 99, 99,255)"  "Gray39"
#X11_Gray40              = $666666;  $FF666666  "#666666"  "rgb(102,102,102)"  "rgba(102,102,102,255)"  "Gray40"
#X11_Gray41              = $696969;  $FF696969  "#696969"  "rgb(105,105,105)"  "rgba(105,105,105,255)"  "Gray41"
#X11_Gray42              = $6B6B6B;  $FF6B6B6B  "#6B6B6B"  "rgb(107,107,107)"  "rgba(107,107,107,255)"  "Gray42"
#X11_Gray43              = $6E6E6E;  $FF6E6E6E  "#6E6E6E"  "rgb(110,110,110)"  "rgba(110,110,110,255)"  "Gray43"
#X11_Gray44              = $707070;  $FF707070  "#707070"  "rgb(112,112,112)"  "rgba(112,112,112,255)"  "Gray44"
#X11_Gray45              = $737373;  $FF737373  "#737373"  "rgb(115,115,115)"  "rgba(115,115,115,255)"  "Gray45"
#X11_Gray46              = $757575;  $FF757575  "#757575"  "rgb(117,117,117)"  "rgba(117,117,117,255)"  "Gray46"
#X11_Gray47              = $787878;  $FF787878  "#787878"  "rgb(120,120,120)"  "rgba(120,120,120,255)"  "Gray47"
#X11_Gray48              = $7A7A7A;  $FF7A7A7A  "#7A7A7A"  "rgb(122,122,122)"  "rgba(122,122,122,255)"  "Gray48"
#X11_Gray49              = $7D7D7D;  $FF7D7D7D  "#7D7D7D"  "rgb(125,125,125)"  "rgba(125,125,125,255)"  "Gray49"
#X11_Gray50              = $7F7F7F;  $FF7F7F7F  "#7F7F7F"  "rgb(127,127,127)"  "rgba(127,127,127,255)"  "Gray50"
#X11_Gray51              = $828282;  $FF828282  "#828282"  "rgb(130,130,130)"  "rgba(130,130,130,255)"  "Gray51"
#X11_Gray52              = $858585;  $FF858585  "#858585"  "rgb(133,133,133)"  "rgba(133,133,133,255)"  "Gray52"
#X11_Gray53              = $878787;  $FF878787  "#878787"  "rgb(135,135,135)"  "rgba(135,135,135,255)"  "Gray53"
#X11_Gray54              = $8A8A8A;  $FF8A8A8A  "#8A8A8A"  "rgb(138,138,138)"  "rgba(138,138,138,255)"  "Gray54"
#X11_Gray55              = $8C8C8C;  $FF8C8C8C  "#8C8C8C"  "rgb(140,140,140)"  "rgba(140,140,140,255)"  "Gray55"
#X11_Gray56              = $8F8F8F;  $FF8F8F8F  "#8F8F8F"  "rgb(143,143,143)"  "rgba(143,143,143,255)"  "Gray56"
#X11_Gray57              = $919191;  $FF919191  "#919191"  "rgb(145,145,145)"  "rgba(145,145,145,255)"  "Gray57"
#X11_Gray58              = $949494;  $FF949494  "#949494"  "rgb(148,148,148)"  "rgba(148,148,148,255)"  "Gray58"
#X11_Gray59              = $969696;  $FF969696  "#969696"  "rgb(150,150,150)"  "rgba(150,150,150,255)"  "Gray59"
#X11_Gray60              = $999999;  $FF999999  "#999999"  "rgb(153,153,153)"  "rgba(153,153,153,255)"  "Gray60"
#X11_Gray61              = $9C9C9C;  $FF9C9C9C  "#9C9C9C"  "rgb(156,156,156)"  "rgba(156,156,156,255)"  "Gray61"
#X11_Gray62              = $9E9E9E;  $FF9E9E9E  "#9E9E9E"  "rgb(158,158,158)"  "rgba(158,158,158,255)"  "Gray62"
#X11_Gray63              = $A1A1A1;  $FFA1A1A1  "#A1A1A1"  "rgb(161,161,161)"  "rgba(161,161,161,255)"  "Gray63"
#X11_Gray64              = $A3A3A3;  $FFA3A3A3  "#A3A3A3"  "rgb(163,163,163)"  "rgba(163,163,163,255)"  "Gray64"
#X11_Gray65              = $A6A6A6;  $FFA6A6A6  "#A6A6A6"  "rgb(166,166,166)"  "rgba(166,166,166,255)"  "Gray65"
#X11_Gray66              = $A8A8A8;  $FFA8A8A8  "#A8A8A8"  "rgb(168,168,168)"  "rgba(168,168,168,255)"  "Gray66"
#X11_Gray67              = $ABABAB;  $FFABABAB  "#ABABAB"  "rgb(171,171,171)"  "rgba(171,171,171,255)"  "Gray67"
#X11_Gray68              = $ADADAD;  $FFADADAD  "#ADADAD"  "rgb(173,173,173)"  "rgba(173,173,173,255)"  "Gray68"
#X11_Gray69              = $B0B0B0;  $FFB0B0B0  "#B0B0B0"  "rgb(176,176,176)"  "rgba(176,176,176,255)"  "Gray69"
#X11_Gray70              = $B3B3B3;  $FFB3B3B3  "#B3B3B3"  "rgb(179,179,179)"  "rgba(179,179,179,255)"  "Gray70"
#X11_Gray71              = $B5B5B5;  $FFB5B5B5  "#B5B5B5"  "rgb(181,181,181)"  "rgba(181,181,181,255)"  "Gray71"
#X11_Gray72              = $B8B8B8;  $FFB8B8B8  "#B8B8B8"  "rgb(184,184,184)"  "rgba(184,184,184,255)"  "Gray72"
#X11_Gray73              = $BABABA;  $FFBABABA  "#BABABA"  "rgb(186,186,186)"  "rgba(186,186,186,255)"  "Gray73"
#X11_Gray74              = $BDBDBD;  $FFBDBDBD  "#BDBDBD"  "rgb(189,189,189)"  "rgba(189,189,189,255)"  "Gray74"
#X11_Gray75              = $BFBFBF;  $FFBFBFBF  "#BFBFBF"  "rgb(191,191,191)"  "rgba(191,191,191,255)"  "Gray75"
#X11_Gray76              = $C2C2C2;  $FFC2C2C2  "#C2C2C2"  "rgb(194,194,194)"  "rgba(194,194,194,255)"  "Gray76"
#X11_Gray77              = $C4C4C4;  $FFC4C4C4  "#C4C4C4"  "rgb(196,196,196)"  "rgba(196,196,196,255)"  "Gray77"
#X11_Gray78              = $C7C7C7;  $FFC7C7C7  "#C7C7C7"  "rgb(199,199,199)"  "rgba(199,199,199,255)"  "Gray78"
#X11_Gray79              = $C9C9C9;  $FFC9C9C9  "#C9C9C9"  "rgb(201,201,201)"  "rgba(201,201,201,255)"  "Gray79"
#X11_Gray80              = $CCCCCC;  $FFCCCCCC  "#CCCCCC"  "rgb(204,204,204)"  "rgba(204,204,204,255)"  "Gray80"
#X11_Gray81              = $CFCFCF;  $FFCFCFCF  "#CFCFCF"  "rgb(207,207,207)"  "rgba(207,207,207,255)"  "Gray81"
#X11_Gray82              = $D1D1D1;  $FFD1D1D1  "#D1D1D1"  "rgb(209,209,209)"  "rgba(209,209,209,255)"  "Gray82"
#X11_Gray83              = $D4D4D4;  $FFD4D4D4  "#D4D4D4"  "rgb(212,212,212)"  "rgba(212,212,212,255)"  "Gray83"
#X11_Gray84              = $D6D6D6;  $FFD6D6D6  "#D6D6D6"  "rgb(214,214,214)"  "rgba(214,214,214,255)"  "Gray84"
#X11_Gray85              = $D9D9D9;  $FFD9D9D9  "#D9D9D9"  "rgb(217,217,217)"  "rgba(217,217,217,255)"  "Gray85"
#X11_Gray86              = $DBDBDB;  $FFDBDBDB  "#DBDBDB"  "rgb(219,219,219)"  "rgba(219,219,219,255)"  "Gray86"
#X11_Gray87              = $DEDEDE;  $FFDEDEDE  "#DEDEDE"  "rgb(222,222,222)"  "rgba(222,222,222,255)"  "Gray87"
#X11_Gray88              = $E0E0E0;  $FFE0E0E0  "#E0E0E0"  "rgb(224,224,224)"  "rgba(224,224,224,255)"  "Gray88"
#X11_Gray89              = $E3E3E3;  $FFE3E3E3  "#E3E3E3"  "rgb(227,227,227)"  "rgba(227,227,227,255)"  "Gray89"
#X11_Gray90              = $E5E5E5;  $FFE5E5E5  "#E5E5E5"  "rgb(229,229,229)"  "rgba(229,229,229,255)"  "Gray90"
#X11_Gray91              = $E8E8E8;  $FFE8E8E8  "#E8E8E8"  "rgb(232,232,232)"  "rgba(232,232,232,255)"  "Gray91"
#X11_Gray92              = $EBEBEB;  $FFEBEBEB  "#EBEBEB"  "rgb(235,235,235)"  "rgba(235,235,235,255)"  "Gray92"
#X11_Gray93              = $EDEDED;  $FFEDEDED  "#EDEDED"  "rgb(237,237,237)"  "rgba(237,237,237,255)"  "Gray93"
#X11_Gray94              = $F0F0F0;  $FFF0F0F0  "#F0F0F0"  "rgb(240,240,240)"  "rgba(240,240,240,255)"  "Gray94"
#X11_Gray95              = $F2F2F2;  $FFF2F2F2  "#F2F2F2"  "rgb(242,242,242)"  "rgba(242,242,242,255)"  "Gray95"
#X11_Gray96              = $F5F5F5;  $FFF5F5F5  "#F5F5F5"  "rgb(245,245,245)"  "rgba(245,245,245,255)"  "Gray96"
#X11_Gray97              = $F7F7F7;  $FFF7F7F7  "#F7F7F7"  "rgb(247,247,247)"  "rgba(247,247,247,255)"  "Gray97"
#X11_Gray98              = $FAFAFA;  $FFFAFAFA  "#FAFAFA"  "rgb(250,250,250)"  "rgba(250,250,250,255)"  "Gray98"
#X11_Gray99              = $FCFCFC;  $FFFCFCFC  "#FCFCFC"  "rgb(252,252,252)"  "rgba(252,252,252,255)"  "Gray99"
#X11_Gray100             = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "Gray100"
; +
;-- Gray-Adds
;X11-Gray-Adds            PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_DarkGray            = $A9A9A9;  $FFA9A9A9  "#A9A9A9"  "rgb(169,169,169)"  "rgba(169,169,169,255)"  "DarkGray"
#X11_DarkGrey            = $A9A9A9;  $FFA9A9A9  "#A9A9A9"  "rgb(169,169,169)"  "rgba(169,169,169,255)"  "DarkGrey"
#X11_Darkslategray       = $4F4F2F;  $FF4F4F2F  "#2F4F4F"  "rgb( 47, 79, 79)"  "rgba( 47, 79, 79,255)"  "DarkSlateGray"
#X11_Darkslategray1      = $FFFF97;  $FFFFFF97  "#97FFFF"  "rgb(151,255,255)"  "rgba(151,255,255,255)"  "DarkSlateGray1"
#X11_Darkslategray2      = $EEEE8D;  $FFEEEE8D  "#8DEEEE"  "rgb(141,238,238)"  "rgba(141,238,238,255)"  "DarkSlateGray2"
#X11_Darkslategray3      = $CDCD79;  $FFCDCD79  "#79CDCD"  "rgb(121,205,205)"  "rgba(121,205,205,255)"  "DarkSlateGray3"
#X11_Darkslategray4      = $8B8B52;  $FF8B8B52  "#528B8B"  "rgb( 82,139,139)"  "rgba( 82,139,139,255)"  "DarkSlateGray4"
#X11_Darkslategrey       = $4F4F2F;  $FF4F4F2F  "#2F4F4F"  "rgb( 47, 79, 79)"  "rgba( 47, 79, 79,255)"  "DarkSlateGrey"
#X11_Dimgray             = $696969;  $FF696969  "#696969"  "rgb(105,105,105)"  "rgba(105,105,105,255)"  "DimGray"
#X11_Dimgrey             = $696969;  $FF696969  "#696969"  "rgb(105,105,105)"  "rgba(105,105,105,255)"  "DimGrey"
#X11_Lightgray           = $D3D3D3;  $FFD3D3D3  "#D3D3D3"  "rgb(211,211,211)"  "rgba(211,211,211,255)"  "LightGray"
#X11_Lightgrey           = $D3D3D3;  $FFD3D3D3  "#D3D3D3"  "rgb(211,211,211)"  "rgba(211,211,211,255)"  "LightGrey"
#X11_Lightslategray      = $998877;  $FF998877  "#778899"  "rgb(119,136,153)"  "rgba(119,136,153,255)"  "LightSlateGray"
#X11_Lightslategrey      = $998877;  $FF998877  "#778899"  "rgb(119,136,153)"  "rgba(119,136,153,255)"  "LightSlateGrey"
#X11_Silver              = $C0C0C0;  $FFC0C0C0  "#C0C0C0"  "rgb(192,192,192)"  "rgba(192,192,192,255)"  "Silver"
#X11_Slategray           = $908070;  $FF908070  "#708090"  "rgb(112,128,144)"  "rgba(112,128,144,255)"  "SlateGray"
#X11_Slategray1          = $FFE2C6;  $FFFFE2C6  "#C6E2FF"  "rgb(198,226,255)"  "rgba(198,226,255,255)"  "SlateGray1"
#X11_Slategray2          = $EED3B9;  $FFEED3B9  "#B9D3EE"  "rgb(185,211,238)"  "rgba(185,211,238,255)"  "SlateGray2"
#X11_Slategray3          = $CDB69F;  $FFCDB69F  "#9FB6CD"  "rgb(159,182,205)"  "rgba(159,182,205,255)"  "SlateGray3"
#X11_Slategray4          = $8B7B6C;  $FF8B7B6C  "#6C7B8B"  "rgb(108,123,139)"  "rgba(108,123,139,255)"  "SlateGray4"
#X11_Slategrey           = $908070;  $FF908070  "#708090"  "rgb(112,128,144)"  "rgba(112,128,144,255)"  "SlateGrey"
#X11_Black               = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "Black"

;-- Red
;X11-Red                  PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_Darkred             = $00008B;  $FF00008B  "#8B0000"  "rgb(139,  0,  0)"  "rgba(139,  0,  0,255)"  "DarkRed"
#X11_Deeppink            = $9314FF;  $FF9314FF  "#FF1493"  "rgb(255, 20,147)"  "rgba(255, 20,147,255)"  "DeepPink"
#X11_Deeppink1           = $9314FF;  $FF9314FF  "#FF1493"  "rgb(255, 20,147)"  "rgba(255, 20,147,255)"  "DeepPink1"
#X11_Deeppink2           = $8912EE;  $FF8912EE  "#EE1289"  "rgb(238, 18,137)"  "rgba(238, 18,137,255)"  "DeepPink2"
#X11_Deeppink3           = $7610CD;  $FF7610CD  "#CD1076"  "rgb(205, 16,118)"  "rgba(205, 16,118,255)"  "DeepPink3"
#X11_Deeppink4           = $500A8B;  $FF500A8B  "#8B0A50"  "rgb(139, 10, 80)"  "rgba(139, 10, 80,255)"  "DeepPink4"
#X11_Hotpink             = $B469FF;  $FFB469FF  "#FF69B4"  "rgb(255,105,180)"  "rgba(255,105,180,255)"  "HotPink"
#X11_Hotpink1            = $B46EFF;  $FFB46EFF  "#FF6EB4"  "rgb(255,110,180)"  "rgba(255,110,180,255)"  "HotPink1"
#X11_Hotpink2            = $A76AEE;  $FFA76AEE  "#EE6AA7"  "rgb(238,106,167)"  "rgba(238,106,167,255)"  "HotPink2"
#X11_Hotpink3            = $9060CD;  $FF9060CD  "#CD6090"  "rgb(205, 96,144)"  "rgba(205, 96,144,255)"  "HotPink3"
#X11_Hotpink4            = $623A8B;  $FF623A8B  "#8B3A62"  "rgb(139, 58, 98)"  "rgba(139, 58, 98,255)"  "HotPink4"
#X11_Indianred           = $5C5CCD;  $FF5C5CCD  "#CD5C5C"  "rgb(205, 92, 92)"  "rgba(205, 92, 92,255)"  "IndianRed"
#X11_Indianred1          = $6A6AFF;  $FF6A6AFF  "#FF6A6A"  "rgb(255,106,106)"  "rgba(255,106,106,255)"  "IndianRed1"
#X11_Indianred2          = $6363EE;  $FF6363EE  "#EE6363"  "rgb(238, 99, 99)"  "rgba(238, 99, 99,255)"  "IndianRed2"
#X11_Indianred3          = $5555CD;  $FF5555CD  "#CD5555"  "rgb(205, 85, 85)"  "rgba(205, 85, 85,255)"  "IndianRed3"
#X11_Indianred4          = $3A3A8B;  $FF3A3A8B  "#8B3A3A"  "rgb(139, 58, 58)"  "rgba(139, 58, 58,255)"  "IndianRed4"
#X11_Lightpink           = $C1B6FF;  $FFC1B6FF  "#FFB6C1"  "rgb(255,182,193)"  "rgba(255,182,193,255)"  "LightPink"
#X11_Lightpink1          = $B9AEFF;  $FFB9AEFF  "#FFAEB9"  "rgb(255,174,185)"  "rgba(255,174,185,255)"  "LightPink1"
#X11_Lightpink2          = $ADA2EE;  $FFADA2EE  "#EEA2AD"  "rgb(238,162,173)"  "rgba(238,162,173,255)"  "LightPink2"
#X11_Lightpink3          = $958CCD;  $FF958CCD  "#CD8C95"  "rgb(205,140,149)"  "rgba(205,140,149,255)"  "LightPink3"
#X11_Lightpink4          = $655F8B;  $FF655F8B  "#8B5F65"  "rgb(139, 95,101)"  "rgba(139, 95,101,255)"  "LightPink4"
#X11_Mediumvioletred     = $8515C7;  $FF8515C7  "#C71585"  "rgb(199, 21,133)"  "rgba(199, 21,133,255)"  "MediumVioletRed"
#X11_Mistyrose           = $E1E4FF;  $FFE1E4FF  "#FFE4E1"  "rgb(255,228,225)"  "rgba(255,228,225,255)"  "MistyRose"
#X11_Mistyrose1          = $E1E4FF;  $FFE1E4FF  "#FFE4E1"  "rgb(255,228,225)"  "rgba(255,228,225,255)"  "MistyRose1"
#X11_Mistyrose2          = $D2D5EE;  $FFD2D5EE  "#EED5D2"  "rgb(238,213,210)"  "rgba(238,213,210,255)"  "MistyRose2"
#X11_Mistyrose3          = $B5B7CD;  $FFB5B7CD  "#CDB7B5"  "rgb(205,183,181)"  "rgba(205,183,181,255)"  "MistyRose3"
#X11_Mistyrose4          = $7B7D8B;  $FF7B7D8B  "#8B7D7B"  "rgb(139,125,123)"  "rgba(139,125,123,255)"  "MistyRose4"
#X11_Orangered           = $0045FF;  $FF0045FF  "#FF4500"  "rgb(255, 69,  0)"  "rgba(255, 69,  0,255)"  "OrangeRed"
#X11_Orangered1          = $0045FF;  $FF0045FF  "#FF4500"  "rgb(255, 69,  0)"  "rgba(255, 69,  0,255)"  "OrangeRed1"
#X11_Orangered2          = $0040EE;  $FF0040EE  "#EE4000"  "rgb(238, 64,  0)"  "rgba(238, 64,  0,255)"  "OrangeRed2"
#X11_Orangered3          = $0037CD;  $FF0037CD  "#CD3700"  "rgb(205, 55,  0)"  "rgba(205, 55,  0,255)"  "OrangeRed3"
#X11_Orangered4          = $00258B;  $FF00258B  "#8B2500"  "rgb(139, 37,  0)"  "rgba(139, 37,  0,255)"  "OrangeRed4"
#X11_Palevioletred       = $9370DB;  $FF9370DB  "#DB7093"  "rgb(219,112,147)"  "rgba(219,112,147,255)"  "PaleVioletRed"
#X11_Palevioletred1      = $AB82FF;  $FFAB82FF  "#FF82AB"  "rgb(255,130,171)"  "rgba(255,130,171,255)"  "PaleVioletRed1"
#X11_Palevioletred2      = $9F79EE;  $FF9F79EE  "#EE799F"  "rgb(238,121,159)"  "rgba(238,121,159,255)"  "PaleVioletRed2"
#X11_Palevioletred3      = $8968CD;  $FF8968CD  "#CD6889"  "rgb(205,104,137)"  "rgba(205,104,137,255)"  "PaleVioletRed3"
#X11_Palevioletred4      = $5D478B;  $FF5D478B  "#8B475D"  "rgb(139, 71, 93)"  "rgba(139, 71, 93,255)"  "PaleVioletRed4"
#X11_Violetred           = $9020D0;  $FF9020D0  "#D02090"  "rgb(208, 32,144)"  "rgba(208, 32,144,255)"  "VioletRed"
#X11_Violetred1          = $963EFF;  $FF963EFF  "#FF3E96"  "rgb(255, 62,150)"  "rgba(255, 62,150,255)"  "VioletRed1"
#X11_Violetred2          = $8C3AEE;  $FF8C3AEE  "#EE3A8C"  "rgb(238, 58,140)"  "rgba(238, 58,140,255)"  "VioletRed2"
#X11_Violetred3          = $7832CD;  $FF7832CD  "#CD3278"  "rgb(205, 50,120)"  "rgba(205, 50,120,255)"  "VioletRed3"
#X11_Violetred4          = $52228B;  $FF52228B  "#8B2252"  "rgb(139, 34, 82)"  "rgba(139, 34, 82,255)"  "VioletRed4"
#X11_Firebrick           = $2222B2;  $FF2222B2  "#B22222"  "rgb(178, 34, 34)"  "rgba(178, 34, 34,255)"  "Firebrick"
#X11_Firebrick1          = $3030FF;  $FF3030FF  "#FF3030"  "rgb(255, 48, 48)"  "rgba(255, 48, 48,255)"  "Firebrick1"
#X11_Firebrick2          = $2C2CEE;  $FF2C2CEE  "#EE2C2C"  "rgb(238, 44, 44)"  "rgba(238, 44, 44,255)"  "Firebrick2"
#X11_Firebrick3          = $2626CD;  $FF2626CD  "#CD2626"  "rgb(205, 38, 38)"  "rgba(205, 38, 38,255)"  "Firebrick3"
#X11_Firebrick4          = $1A1A8B;  $FF1A1A8B  "#8B1A1A"  "rgb(139, 26, 26)"  "rgba(139, 26, 26,255)"  "Firebrick4"
#X11_Pink                = $CBC0FF;  $FFCBC0FF  "#FFC0CB"  "rgb(255,192,203)"  "rgba(255,192,203,255)"  "Pink"
#X11_Pink1               = $C5B5FF;  $FFC5B5FF  "#FFB5C5"  "rgb(255,181,197)"  "rgba(255,181,197,255)"  "Pink1"
#X11_Pink2               = $B8A9EE;  $FFB8A9EE  "#EEA9B8"  "rgb(238,169,184)"  "rgba(238,169,184,255)"  "Pink2"
#X11_Pink3               = $9E91CD;  $FF9E91CD  "#CD919E"  "rgb(205,145,158)"  "rgba(205,145,158,255)"  "Pink3"
#X11_Pink4               = $6C638B;  $FF6C638B  "#8B636C"  "rgb(139, 99,108)"  "rgba(139, 99,108,255)"  "Pink4"
#X11_Red                 = $0000FF;  $FF0000FF  "#FF0000"  "rgb(255,  0,  0)"  "rgba(255,  0,  0,255)"  "Red"
#X11_Red1                = $0000FF;  $FF0000FF  "#FF0000"  "rgb(255,  0,  0)"  "rgba(255,  0,  0,255)"  "Red1"
#X11_Red2                = $0000EE;  $FF0000EE  "#EE0000"  "rgb(238,  0,  0)"  "rgba(238,  0,  0,255)"  "Red2"
#X11_Red3                = $0000CD;  $FF0000CD  "#CD0000"  "rgb(205,  0,  0)"  "rgba(205,  0,  0,255)"  "Red3"
#X11_Red4                = $00008B;  $FF00008B  "#8B0000"  "rgb(139,  0,  0)"  "rgba(139,  0,  0,255)"  "Red4"
#X11_Tomato              = $4763FF;  $FF4763FF  "#FF6347"  "rgb(255, 99, 71)"  "rgba(255, 99, 71,255)"  "Tomato"
#X11_Tomato1             = $4763FF;  $FF4763FF  "#FF6347"  "rgb(255, 99, 71)"  "rgba(255, 99, 71,255)"  "Tomato1"
#X11_Tomato2             = $425CEE;  $FF425CEE  "#EE5C42"  "rgb(238, 92, 66)"  "rgba(238, 92, 66,255)"  "Tomato2"
#X11_Tomato3             = $394FCD;  $FF394FCD  "#CD4F39"  "rgb(205, 79, 57)"  "rgba(205, 79, 57,255)"  "Tomato3"
#X11_Tomato4             = $26368B;  $FF26368B  "#8B3626"  "rgb(139, 54, 38)"  "rgba(139, 54, 38,255)"  "Tomato4"

;-- Green
;X11-Green                PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_Darkgreen           = $006400;  $FF006400  "#006400"  "rgb(  0,100,  0)"  "rgba(  0,100,  0,255)"  "DarkGreen"
#X11_Darkkhaki           = $6BB7BD;  $FF6BB7BD  "#BDB76B"  "rgb(189,183,107)"  "rgba(189,183,107,255)"  "DarkKhaki"
#X11_Darkolivegreen      = $2F6B55;  $FF2F6B55  "#556B2F"  "rgb( 85,107, 47)"  "rgba( 85,107, 47,255)"  "DarkOliveGreen"
#X11_Darkolivegreen1     = $70FFCA;  $FF70FFCA  "#CAFF70"  "rgb(202,255,112)"  "rgba(202,255,112,255)"  "DarkOliveGreen1"
#X11_Darkolivegreen2     = $68EEBC;  $FF68EEBC  "#BCEE68"  "rgb(188,238,104)"  "rgba(188,238,104,255)"  "DarkOliveGreen2"
#X11_Darkolivegreen3     = $5ACDA2;  $FF5ACDA2  "#A2CD5A"  "rgb(162,205, 90)"  "rgba(162,205, 90,255)"  "DarkOliveGreen3"
#X11_Darkolivegreen4     = $3D8B6E;  $FF3D8B6E  "#6E8B3D"  "rgb(110,139, 61)"  "rgba(110,139, 61,255)"  "DarkOliveGreen4"
#X11_Darkseagreen        = $8FBC8F;  $FF8FBC8F  "#8FBC8F"  "rgb(143,188,143)"  "rgba(143,188,143,255)"  "DarkSeaGreen"
#X11_Darkseagreen1       = $C1FFC1;  $FFC1FFC1  "#C1FFC1"  "rgb(193,255,193)"  "rgba(193,255,193,255)"  "DarkSeaGreen1"
#X11_Darkseagreen2       = $B4EEB4;  $FFB4EEB4  "#B4EEB4"  "rgb(180,238,180)"  "rgba(180,238,180,255)"  "DarkSeaGreen2"
#X11_Darkseagreen3       = $9BCD9B;  $FF9BCD9B  "#9BCD9B"  "rgb(155,205,155)"  "rgba(155,205,155,255)"  "DarkSeaGreen3"
#X11_Darkseagreen4       = $698B69;  $FF698B69  "#698B69"  "rgb(105,139,105)"  "rgba(105,139,105,255)"  "DarkSeaGreen4"
#X11_Forestgreen         = $228B22;  $FF228B22  "#228B22"  "rgb( 34,139, 34)"  "rgba( 34,139, 34,255)"  "ForestGreen"
#X11_Greenyellow         = $2FFFAD;  $FF2FFFAD  "#ADFF2F"  "rgb(173,255, 47)"  "rgba(173,255, 47,255)"  "GreenYellow"
#X11_Lawngreen           = $00FC7C;  $FF00FC7C  "#7CFC00"  "rgb(124,252,  0)"  "rgba(124,252,  0,255)"  "LawnGreen"
#X11_Lightgreen          = $90EE90;  $FF90EE90  "#90EE90"  "rgb(144,238,144)"  "rgba(144,238,144,255)"  "LightGreen"
#X11_Lightseagreen       = $AAB220;  $FFAAB220  "#20B2AA"  "rgb( 32,178,170)"  "rgba( 32,178,170,255)"  "LightSeaGreen"
#X11_Limegreen           = $32CD32;  $FF32CD32  "#32CD32"  "rgb( 50,205, 50)"  "rgba( 50,205, 50,255)"  "LimeGreen"
#X11_Mediumseagreen      = $71B33C;  $FF71B33C  "#3CB371"  "rgb( 60,179,113)"  "rgba( 60,179,113,255)"  "MediumSeaGreen"
#X11_Mediumspringgreen   = $9AFA00;  $FF9AFA00  "#00FA9A"  "rgb(  0,250,154)"  "rgba(  0,250,154,255)"  "MediumSpringGreen"
#X11_Mintcream           = $FAFFF5;  $FFFAFFF5  "#F5FFFA"  "rgb(245,255,250)"  "rgba(245,255,250,255)"  "MintCream"
#X11_Olivedrab           = $238E6B;  $FF238E6B  "#6B8E23"  "rgb(107,142, 35)"  "rgba(107,142, 35,255)"  "OliveDrab"
#X11_Olivedrab1          = $3EFFC0;  $FF3EFFC0  "#C0FF3E"  "rgb(192,255, 62)"  "rgba(192,255, 62,255)"  "OliveDrab1"
#X11_Olivedrab2          = $3AEEB3;  $FF3AEEB3  "#B3EE3A"  "rgb(179,238, 58)"  "rgba(179,238, 58,255)"  "OliveDrab2"
#X11_Olivedrab3          = $32CD9A;  $FF32CD9A  "#9ACD32"  "rgb(154,205, 50)"  "rgba(154,205, 50,255)"  "OliveDrab3"
#X11_Olivedrab4          = $228B69;  $FF228B69  "#698B22"  "rgb(105,139, 34)"  "rgba(105,139, 34,255)"  "OliveDrab4"
#X11_Palegreen           = $98FB98;  $FF98FB98  "#98FB98"  "rgb(152,251,152)"  "rgba(152,251,152,255)"  "PaleGreen"
#X11_Palegreen1          = $9AFF9A;  $FF9AFF9A  "#9AFF9A"  "rgb(154,255,154)"  "rgba(154,255,154,255)"  "PaleGreen1"
#X11_Palegreen2          = $90EE90;  $FF90EE90  "#90EE90"  "rgb(144,238,144)"  "rgba(144,238,144,255)"  "PaleGreen2"
#X11_Palegreen3          = $7CCD7C;  $FF7CCD7C  "#7CCD7C"  "rgb(124,205,124)"  "rgba(124,205,124,255)"  "PaleGreen3"
#X11_Palegreen4          = $548B54;  $FF548B54  "#548B54"  "rgb( 84,139, 84)"  "rgba( 84,139, 84,255)"  "PaleGreen4"
#X11_Seagreen            = $578B2E;  $FF578B2E  "#2E8B57"  "rgb( 46,139, 87)"  "rgba( 46,139, 87,255)"  "SeaGreen"
#X11_Seagreen1           = $9FFF54;  $FF9FFF54  "#54FF9F"  "rgb( 84,255,159)"  "rgba( 84,255,159,255)"  "SeaGreen1"
#X11_Seagreen2           = $94EE4E;  $FF94EE4E  "#4EEE94"  "rgb( 78,238,148)"  "rgba( 78,238,148,255)"  "SeaGreen2"
#X11_Seagreen3           = $80CD43;  $FF80CD43  "#43CD80"  "rgb( 67,205,128)"  "rgba( 67,205,128,255)"  "SeaGreen3"
#X11_Seagreen4           = $578B2E;  $FF578B2E  "#2E8B57"  "rgb( 46,139, 87)"  "rgba( 46,139, 87,255)"  "SeaGreen4"
#X11_Springgreen         = $7FFF00;  $FF7FFF00  "#00FF7F"  "rgb(  0,255,127)"  "rgba(  0,255,127,255)"  "SpringGreen"
#X11_Springgreen1        = $7FFF00;  $FF7FFF00  "#00FF7F"  "rgb(  0,255,127)"  "rgba(  0,255,127,255)"  "SpringGreen1"
#X11_Springgreen2        = $76EE00;  $FF76EE00  "#00EE76"  "rgb(  0,238,118)"  "rgba(  0,238,118,255)"  "SpringGreen2"
#X11_Springgreen3        = $66CD00;  $FF66CD00  "#00CD66"  "rgb(  0,205,102)"  "rgba(  0,205,102,255)"  "SpringGreen3"
#X11_Springgreen4        = $458B00;  $FF458B00  "#008B45"  "rgb(  0,139, 69)"  "rgba(  0,139, 69,255)"  "SpringGreen4"
#X11_Yellowgreen         = $32CD9A;  $FF32CD9A  "#9ACD32"  "rgb(154,205, 50)"  "rgba(154,205, 50,255)"  "YellowGreen"
#X11_Chartreuse          = $00FF7F;  $FF00FF7F  "#7FFF00"  "rgb(127,255,  0)"  "rgba(127,255,  0,255)"  "Chartreuse"
#X11_Chartreuse1         = $00FF7F;  $FF00FF7F  "#7FFF00"  "rgb(127,255,  0)"  "rgba(127,255,  0,255)"  "Chartreuse1"
#X11_Chartreuse2         = $00EE76;  $FF00EE76  "#76EE00"  "rgb(118,238,  0)"  "rgba(118,238,  0,255)"  "Chartreuse2"
#X11_Chartreuse3         = $00CD66;  $FF00CD66  "#66CD00"  "rgb(102,205,  0)"  "rgba(102,205,  0,255)"  "Chartreuse3"
#X11_Chartreuse4         = $008B45;  $FF008B45  "#458B00"  "rgb( 69,139,  0)"  "rgba( 69,139,  0,255)"  "Chartreuse4"
#X11_Green               = $00FF00;  $FF00FF00  "#00FF00"  "rgb(  0,255,  0)"  "rgba(  0,255,  0,255)"  "Green"
#X11_Green1              = $00FF00;  $FF00FF00  "#00FF00"  "rgb(  0,255,  0)"  "rgba(  0,255,  0,255)"  "Green1"
#X11_Green2              = $00EE00;  $FF00EE00  "#00EE00"  "rgb(  0,238,  0)"  "rgba(  0,238,  0,255)"  "Green2"
#X11_Green3              = $00CD00;  $FF00CD00  "#00CD00"  "rgb(  0,205,  0)"  "rgba(  0,205,  0,255)"  "Green3"
#X11_Green4              = $008B00;  $FF008B00  "#008B00"  "rgb(  0,139,  0)"  "rgba(  0,139,  0,255)"  "Green4"
#X11_Khaki               = $8CE6F0;  $FF8CE6F0  "#F0E68C"  "rgb(240,230,140)"  "rgba(240,230,140,255)"  "Khaki"
#X11_Khaki1              = $8FF6FF;  $FF8FF6FF  "#FFF68F"  "rgb(255,246,143)"  "rgba(255,246,143,255)"  "Khaki1"
#X11_Khaki2              = $85E6EE;  $FF85E6EE  "#EEE685"  "rgb(238,230,133)"  "rgba(238,230,133,255)"  "Khaki2"
#X11_Khaki3              = $73C6CD;  $FF73C6CD  "#CDC673"  "rgb(205,198,115)"  "rgba(205,198,115,255)"  "Khaki3"
#X11_Khaki4              = $4E868B;  $FF4E868B  "#8B864E"  "rgb(139,134, 78)"  "rgba(139,134, 78,255)"  "Khaki4"

;-- Blue
;X11-Blue                 PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_Aliceblue           = $FFF8F0;  $FFFFF8F0  "#F0F8FF"  "rgb(240,248,255)"  "rgba(240,248,255,255)"  "AliceBlue"
#X11_Aqua                = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(  0,255,255)"  "rgba(  0,255,255,255)"  "Aqua"
#X11_Blueviolet          = $E22B8A;  $FFE22B8A  "#8A2BE2"  "rgb(138, 43,226)"  "rgba(138, 43,226,255)"  "BlueViolet"
#X11_Cadetblue           = $A09E5F;  $FFA09E5F  "#5F9EA0"  "rgb( 95,158,160)"  "rgba( 95,158,160,255)"  "CadetBlue"
#X11_Cadetblue1          = $FFF598;  $FFFFF598  "#98F5FF"  "rgb(152,245,255)"  "rgba(152,245,255,255)"  "CadetBlue1"
#X11_Cadetblue2          = $EEE58E;  $FFEEE58E  "#8EE5EE"  "rgb(142,229,238)"  "rgba(142,229,238,255)"  "CadetBlue2"
#X11_Cadetblue3          = $CDC57A;  $FFCDC57A  "#7AC5CD"  "rgb(122,197,205)"  "rgba(122,197,205,255)"  "CadetBlue3"
#X11_Cadetblue4          = $8B8653;  $FF8B8653  "#53868B"  "rgb( 83,134,139)"  "rgba( 83,134,139,255)"  "CadetBlue4"
#X11_Cornflowerblue      = $ED9564;  $FFED9564  "#6495ED"  "rgb(100,149,237)"  "rgba(100,149,237,255)"  "CornflowerBlue"
#X11_Darkblue            = $8B0000;  $FF8B0000  "#00008B"  "rgb(  0,  0,139)"  "rgba(  0,  0,139,255)"  "DarkBlue"
#X11_Darkcyan            = $8B8B00;  $FF8B8B00  "#008B8B"  "rgb(  0,139,139)"  "rgba(  0,139,139,255)"  "DarkCyan"
#X11_Darkslateblue       = $8B3D48;  $FF8B3D48  "#483D8B"  "rgb( 72, 61,139)"  "rgba( 72, 61,139,255)"  "DarkSlateBlue"
#X11_Darkturquoise       = $D1CE00;  $FFD1CE00  "#00CED1"  "rgb(  0,206,209)"  "rgba(  0,206,209,255)"  "DarkTurquoise"
#X11_Deepskyblue         = $FFBF00;  $FFFFBF00  "#00BFFF"  "rgb(  0,191,255)"  "rgba(  0,191,255,255)"  "DeepSkyBlue"
#X11_Deepskyblue1        = $FFBF00;  $FFFFBF00  "#00BFFF"  "rgb(  0,191,255)"  "rgba(  0,191,255,255)"  "DeepSkyBlue1"
#X11_Deepskyblue2        = $EEB200;  $FFEEB200  "#00B2EE"  "rgb(  0,178,238)"  "rgba(  0,178,238,255)"  "DeepSkyBlue2"
#X11_Deepskyblue3        = $CD9A00;  $FFCD9A00  "#009ACD"  "rgb(  0,154,205)"  "rgba(  0,154,205,255)"  "DeepSkyBlue3"
#X11_Deepskyblue4        = $8B6800;  $FF8B6800  "#00688B"  "rgb(  0,104,139)"  "rgba(  0,104,139,255)"  "DeepSkyBlue4"
#X11_Dodgerblue          = $FF901E;  $FFFF901E  "#1E90FF"  "rgb( 30,144,255)"  "rgba( 30,144,255,255)"  "DodgerBlue"
#X11_Dodgerblue1         = $FF901E;  $FFFF901E  "#1E90FF"  "rgb( 30,144,255)"  "rgba( 30,144,255,255)"  "DodgerBlue1"
#X11_Dodgerblue2         = $EE861C;  $FFEE861C  "#1C86EE"  "rgb( 28,134,238)"  "rgba( 28,134,238,255)"  "DodgerBlue2"
#X11_Dodgerblue3         = $CD7418;  $FFCD7418  "#1874CD"  "rgb( 24,116,205)"  "rgba( 24,116,205,255)"  "DodgerBlue3"
#X11_Dodgerblue4         = $8B4E10;  $FF8B4E10  "#104E8B"  "rgb( 16, 78,139)"  "rgba( 16, 78,139,255)"  "DodgerBlue4"
#X11_Lightblue           = $E6D8AD;  $FFE6D8AD  "#ADD8E6"  "rgb(173,216,230)"  "rgba(173,216,230,255)"  "LightBlue"
#X11_Lightblue1          = $FFEFBF;  $FFFFEFBF  "#BFEFFF"  "rgb(191,239,255)"  "rgba(191,239,255,255)"  "LightBlue1"
#X11_Lightblue2          = $EEDFB2;  $FFEEDFB2  "#B2DFEE"  "rgb(178,223,238)"  "rgba(178,223,238,255)"  "LightBlue2"
#X11_Lightblue3          = $CDC09A;  $FFCDC09A  "#9AC0CD"  "rgb(154,192,205)"  "rgba(154,192,205,255)"  "LightBlue3"
#X11_Lightblue4          = $8B8368;  $FF8B8368  "#68838B"  "rgb(104,131,139)"  "rgba(104,131,139,255)"  "LightBlue4"
#X11_Lightcyan           = $FFFFE0;  $FFFFFFE0  "#E0FFFF"  "rgb(224,255,255)"  "rgba(224,255,255,255)"  "LightCyan"
#X11_Lightcyan1          = $FFFFE0;  $FFFFFFE0  "#E0FFFF"  "rgb(224,255,255)"  "rgba(224,255,255,255)"  "LightCyan1"
#X11_Lightcyan2          = $EEEED1;  $FFEEEED1  "#D1EEEE"  "rgb(209,238,238)"  "rgba(209,238,238,255)"  "LightCyan2"
#X11_Lightcyan3          = $CDCDB4;  $FFCDCDB4  "#B4CDCD"  "rgb(180,205,205)"  "rgba(180,205,205,255)"  "LightCyan3"
#X11_Lightcyan4          = $8B8B7A;  $FF8B8B7A  "#7A8B8B"  "rgb(122,139,139)"  "rgba(122,139,139,255)"  "LightCyan4"
#X11_Lightskyblue        = $FACE87;  $FFFACE87  "#87CEFA"  "rgb(135,206,250)"  "rgba(135,206,250,255)"  "LightSkyBlue"
#X11_Lightskyblue1       = $FFE2B0;  $FFFFE2B0  "#B0E2FF"  "rgb(176,226,255)"  "rgba(176,226,255,255)"  "LightSkyBlue1"
#X11_Lightskyblue2       = $EED3A4;  $FFEED3A4  "#A4D3EE"  "rgb(164,211,238)"  "rgba(164,211,238,255)"  "LightSkyBlue2"
#X11_Lightskyblue3       = $CDB68D;  $FFCDB68D  "#8DB6CD"  "rgb(141,182,205)"  "rgba(141,182,205,255)"  "LightSkyBlue3"
#X11_Lightskyblue4       = $8B7B60;  $FF8B7B60  "#607B8B"  "rgb( 96,123,139)"  "rgba( 96,123,139,255)"  "LightSkyBlue4"
#X11_Lightslateblue      = $FF7084;  $FFFF7084  "#8470FF"  "rgb(132,112,255)"  "rgba(132,112,255,255)"  "LightSlateBlue"
#X11_Lightsteelblue      = $DEC4B0;  $FFDEC4B0  "#B0C4DE"  "rgb(176,196,222)"  "rgba(176,196,222,255)"  "LightSteelBlue"
#X11_Lightsteelblue1     = $FFE1CA;  $FFFFE1CA  "#CAE1FF"  "rgb(202,225,255)"  "rgba(202,225,255,255)"  "LightSteelBlue1"
#X11_Lightsteelblue2     = $EED2BC;  $FFEED2BC  "#BCD2EE"  "rgb(188,210,238)"  "rgba(188,210,238,255)"  "LightSteelBlue2"
#X11_Lightsteelblue3     = $CDB5A2;  $FFCDB5A2  "#A2B5CD"  "rgb(162,181,205)"  "rgba(162,181,205,255)"  "LightSteelBlue3"
#X11_Lightsteelblue4     = $8B7B6E;  $FF8B7B6E  "#6E7B8B"  "rgb(110,123,139)"  "rgba(110,123,139,255)"  "LightSteelBlue4"
#X11_Mediumaquamarine    = $AACD66;  $FFAACD66  "#66CDAA"  "rgb(102,205,170)"  "rgba(102,205,170,255)"  "MediumAquamarine"
#X11_Mediumblue          = $CD0000;  $FFCD0000  "#0000CD"  "rgb(  0,  0,205)"  "rgba(  0,  0,205,255)"  "MediumBlue"
#X11_Mediumslateblue     = $EE687B;  $FFEE687B  "#7B68EE"  "rgb(123,104,238)"  "rgba(123,104,238,255)"  "MediumSlateBlue"
#X11_Mediumturquoise     = $CCD148;  $FFCCD148  "#48D1CC"  "rgb( 72,209,204)"  "rgba( 72,209,204,255)"  "MediumTurquoise"
#X11_Midnightblue        = $701919;  $FF701919  "#191970"  "rgb( 25, 25,112)"  "rgba( 25, 25,112,255)"  "MidnightBlue"
#X11_Navyblue            = $800000;  $FF800000  "#000080"  "rgb(  0,  0,128)"  "rgba(  0,  0,128,255)"  "NavyBlue"
#X11_Paleturquoise       = $EEEEAF;  $FFEEEEAF  "#AFEEEE"  "rgb(175,238,238)"  "rgba(175,238,238,255)"  "PaleTurquoise"
#X11_Paleturquoise1      = $FFFFBB;  $FFFFFFBB  "#BBFFFF"  "rgb(187,255,255)"  "rgba(187,255,255,255)"  "PaleTurquoise1"
#X11_Paleturquoise2      = $EEEEAE;  $FFEEEEAE  "#AEEEEE"  "rgb(174,238,238)"  "rgba(174,238,238,255)"  "PaleTurquoise2"
#X11_Paleturquoise3      = $CDCD96;  $FFCDCD96  "#96CDCD"  "rgb(150,205,205)"  "rgba(150,205,205,255)"  "PaleTurquoise3"
#X11_Paleturquoise4      = $8B8B66;  $FF8B8B66  "#668B8B"  "rgb(102,139,139)"  "rgba(102,139,139,255)"  "PaleTurquoise4"
#X11_Powderblue          = $E6E0B0;  $FFE6E0B0  "#B0E0E6"  "rgb(176,224,230)"  "rgba(176,224,230,255)"  "PowderBlue"
#X11_Royalblue           = $E16941;  $FFE16941  "#4169E1"  "rgb( 65,105,225)"  "rgba( 65,105,225,255)"  "RoyalBlue"
#X11_Royalblue1          = $FF7648;  $FFFF7648  "#4876FF"  "rgb( 72,118,255)"  "rgba( 72,118,255,255)"  "RoyalBlue1"
#X11_Royalblue2          = $EE6E43;  $FFEE6E43  "#436EEE"  "rgb( 67,110,238)"  "rgba( 67,110,238,255)"  "RoyalBlue2"
#X11_Royalblue3          = $CD5F3A;  $FFCD5F3A  "#3A5FCD"  "rgb( 58, 95,205)"  "rgba( 58, 95,205,255)"  "RoyalBlue3"
#X11_Royalblue4          = $8B4027;  $FF8B4027  "#27408B"  "rgb( 39, 64,139)"  "rgba( 39, 64,139,255)"  "RoyalBlue4"
#X11_Skyblue             = $EBCE87;  $FFEBCE87  "#87CEEB"  "rgb(135,206,235)"  "rgba(135,206,235,255)"  "SkyBlue"
#X11_Skyblue1            = $FFCE87;  $FFFFCE87  "#87CEFF"  "rgb(135,206,255)"  "rgba(135,206,255,255)"  "SkyBlue1"
#X11_Skyblue2            = $EEC07E;  $FFEEC07E  "#7EC0EE"  "rgb(126,192,238)"  "rgba(126,192,238,255)"  "SkyBlue2"
#X11_Skyblue3            = $CDA66C;  $FFCDA66C  "#6CA6CD"  "rgb(108,166,205)"  "rgba(108,166,205,255)"  "SkyBlue3"
#X11_Skyblue4            = $8B704A;  $FF8B704A  "#4A708B"  "rgb( 74,112,139)"  "rgba( 74,112,139,255)"  "SkyBlue4"
#X11_Slateblue           = $CD5A6A;  $FFCD5A6A  "#6A5ACD"  "rgb(106, 90,205)"  "rgba(106, 90,205,255)"  "SlateBlue"
#X11_Slateblue1          = $FF6F83;  $FFFF6F83  "#836FFF"  "rgb(131,111,255)"  "rgba(131,111,255,255)"  "SlateBlue1"
#X11_Slateblue2          = $EE677A;  $FFEE677A  "#7A67EE"  "rgb(122,103,238)"  "rgba(122,103,238,255)"  "SlateBlue2"
#X11_Slateblue3          = $CD5969;  $FFCD5969  "#6959CD"  "rgb(105, 89,205)"  "rgba(105, 89,205,255)"  "SlateBlue3"
#X11_Slateblue4          = $8B3C47;  $FF8B3C47  "#473C8B"  "rgb( 71, 60,139)"  "rgba( 71, 60,139,255)"  "SlateBlue4"
#X11_Steelblue           = $B48246;  $FFB48246  "#4682B4"  "rgb( 70,130,180)"  "rgba( 70,130,180,255)"  "SteelBlue"
#X11_Steelblue1          = $FFB863;  $FFFFB863  "#63B8FF"  "rgb( 99,184,255)"  "rgba( 99,184,255,255)"  "SteelBlue1"
#X11_Steelblue2          = $EEAC5C;  $FFEEAC5C  "#5CACEE"  "rgb( 92,172,238)"  "rgba( 92,172,238,255)"  "SteelBlue2"
#X11_Steelblue3          = $CD944F;  $FFCD944F  "#4F94CD"  "rgb( 79,148,205)"  "rgba( 79,148,205,255)"  "SteelBlue3"
#X11_Steelblue4          = $8B6436;  $FF8B6436  "#36648B"  "rgb( 54,100,139)"  "rgba( 54,100,139,255)"  "SteelBlue4"
#X11_Aquamarine          = $D4FF7F;  $FFD4FF7F  "#7FFFD4"  "rgb(127,255,212)"  "rgba(127,255,212,255)"  "Aquamarine"
#X11_Aquamarine1         = $D4FF7F;  $FFD4FF7F  "#7FFFD4"  "rgb(127,255,212)"  "rgba(127,255,212,255)"  "Aquamarine1"
#X11_Aquamarine2         = $C6EE76;  $FFC6EE76  "#76EEC6"  "rgb(118,238,198)"  "rgba(118,238,198,255)"  "Aquamarine2"
#X11_Aquamarine3         = $AACD66;  $FFAACD66  "#66CDAA"  "rgb(102,205,170)"  "rgba(102,205,170,255)"  "Aquamarine3"
#X11_Aquamarine4         = $748B45;  $FF748B45  "#458B74"  "rgb( 69,139,116)"  "rgba( 69,139,116,255)"  "Aquamarine4"
#X11_Azure               = $FFFFF0;  $FFFFFFF0  "#F0FFFF"  "rgb(240,255,255)"  "rgba(240,255,255,255)"  "Azure"
#X11_Azure1              = $FFFFF0;  $FFFFFFF0  "#F0FFFF"  "rgb(240,255,255)"  "rgba(240,255,255,255)"  "Azure1"
#X11_Azure2              = $EEEEE0;  $FFEEEEE0  "#E0EEEE"  "rgb(224,238,238)"  "rgba(224,238,238,255)"  "Azure2"
#X11_Azure3              = $CDCDC1;  $FFCDCDC1  "#C1CDCD"  "rgb(193,205,205)"  "rgba(193,205,205,255)"  "Azure3"
#X11_Azure4              = $8B8B83;  $FF8B8B83  "#838B8B"  "rgb(131,139,139)"  "rgba(131,139,139,255)"  "Azure4"
#X11_Blue                = $FF0000;  $FFFF0000  "#0000FF"  "rgb(  0,  0,255)"  "rgba(  0,  0,255,255)"  "Blue"
#X11_Blue1               = $FF0000;  $FFFF0000  "#0000FF"  "rgb(  0,  0,255)"  "rgba(  0,  0,255,255)"  "Blue1"
#X11_Blue2               = $EE0000;  $FFEE0000  "#0000EE"  "rgb(  0,  0,238)"  "rgba(  0,  0,238,255)"  "Blue2"
#X11_Blue3               = $CD0000;  $FFCD0000  "#0000CD"  "rgb(  0,  0,205)"  "rgba(  0,  0,205,255)"  "Blue3"
#X11_Blue4               = $8B0000;  $FF8B0000  "#00008B"  "rgb(  0,  0,139)"  "rgba(  0,  0,139,255)"  "Blue4"
#X11_Cyan                = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(  0,255,255)"  "rgba(  0,255,255,255)"  "Cyan"
#X11_Cyan1               = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(  0,255,255)"  "rgba(  0,255,255,255)"  "Cyan1"
#X11_Cyan2               = $EEEE00;  $FFEEEE00  "#00EEEE"  "rgb(  0,238,238)"  "rgba(  0,238,238,255)"  "Cyan2"
#X11_Cyan3               = $CDCD00;  $FFCDCD00  "#00CDCD"  "rgb(  0,205,205)"  "rgba(  0,205,205,255)"  "Cyan3"
#X11_Cyan4               = $8B8B00;  $FF8B8B00  "#008B8B"  "rgb(  0,139,139)"  "rgba(  0,139,139,255)"  "Cyan4"
#X11_Navy                = $800000;  $FF800000  "#000080"  "rgb(  0,  0,128)"  "rgba(  0,  0,128,255)"  "Navy"
#X11_Turquoise           = $D0E040;  $FFD0E040  "#40E0D0"  "rgb( 64,224,208)"  "rgba( 64,224,208,255)"  "Turquoise"
#X11_Turquoise1          = $FFF500;  $FFFFF500  "#00F5FF"  "rgb(  0,245,255)"  "rgba(  0,245,255,255)"  "Turquoise1"
#X11_Turquoise2          = $EEE500;  $FFEEE500  "#00E5EE"  "rgb(  0,229,238)"  "rgba(  0,229,238,255)"  "Turquoise2"
#X11_Turquoise3          = $CDC500;  $FFCDC500  "#00C5CD"  "rgb(  0,197,205)"  "rgba(  0,197,205,255)"  "Turquoise3"
#X11_Turquoise4          = $8B8600;  $FF8B8600  "#00868B"  "rgb(  0,134,139)"  "rgba(  0,134,139,255)"  "Turquoise4"

;-- Yellow
;X11-Yellow               PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_Blanchedalmond      = $CDEBFF;  $FFCDEBFF  "#FFEBCD"  "rgb(255,235,205)"  "rgba(255,235,205,255)"  "BlanchedAlmond"
#X11_Darkgoldenrod       = $0B86B8;  $FF0B86B8  "#B8860B"  "rgb(184,134, 11)"  "rgba(184,134, 11,255)"  "DarkGoldenrod"
#X11_Darkgoldenrod1      = $0FB9FF;  $FF0FB9FF  "#FFB90F"  "rgb(255,185, 15)"  "rgba(255,185, 15,255)"  "DarkGoldenrod1"
#X11_Darkgoldenrod2      = $0EADEE;  $FF0EADEE  "#EEAD0E"  "rgb(238,173, 14)"  "rgba(238,173, 14,255)"  "DarkGoldenrod2"
#X11_Darkgoldenrod3      = $0C95CD;  $FF0C95CD  "#CD950C"  "rgb(205,149, 12)"  "rgba(205,149, 12,255)"  "DarkGoldenrod3"
#X11_Darkgoldenrod4      = $08658B;  $FF08658B  "#8B6508"  "rgb(139,101,  8)"  "rgba(139,101,  8,255)"  "DarkGoldenrod4"
#X11_Lemonchiffon        = $CDFAFF;  $FFCDFAFF  "#FFFACD"  "rgb(255,250,205)"  "rgba(255,250,205,255)"  "LemonChiffon"
#X11_Lemonchiffon1       = $CDFAFF;  $FFCDFAFF  "#FFFACD"  "rgb(255,250,205)"  "rgba(255,250,205,255)"  "LemonChiffon1"
#X11_Lemonchiffon2       = $BFE9EE;  $FFBFE9EE  "#EEE9BF"  "rgb(238,233,191)"  "rgba(238,233,191,255)"  "LemonChiffon2"
#X11_Lemonchiffon3       = $A5C9CD;  $FFA5C9CD  "#CDC9A5"  "rgb(205,201,165)"  "rgba(205,201,165,255)"  "LemonChiffon3"
#X11_Lemonchiffon4       = $70898B;  $FF70898B  "#8B8970"  "rgb(139,137,112)"  "rgba(139,137,112,255)"  "LemonChiffon4"
#X11_Lightgoldenrod      = $82DDEE;  $FF82DDEE  "#EEDD82"  "rgb(238,221,130)"  "rgba(238,221,130,255)"  "LightGoldenrod"
#X11_Lightgoldenrod1     = $8BECFF;  $FF8BECFF  "#FFEC8B"  "rgb(255,236,139)"  "rgba(255,236,139,255)"  "LightGoldenrod1"
#X11_Lightgoldenrod2     = $82DCEE;  $FF82DCEE  "#EEDC82"  "rgb(238,220,130)"  "rgba(238,220,130,255)"  "LightGoldenrod2"
#X11_Lightgoldenrod3     = $70BECD;  $FF70BECD  "#CDBE70"  "rgb(205,190,112)"  "rgba(205,190,112,255)"  "LightGoldenrod3"
#X11_Lightgoldenrod4     = $4C818B;  $FF4C818B  "#8B814C"  "rgb(139,129, 76)"  "rgba(139,129, 76,255)"  "LightGoldenrod4"
#X11_Lightgoldenrodyellow= $D2FAFA;  $FFD2FAFA  "#FAFAD2"  "rgb(250,250,210)"  "rgba(250,250,210,255)"  "LightGoldenrodYellow"
#X11_Lightyellow         = $E0FFFF;  $FFE0FFFF  "#FFFFE0"  "rgb(255,255,224)"  "rgba(255,255,224,255)"  "LightYellow"
#X11_Lightyellow1        = $E0FFFF;  $FFE0FFFF  "#FFFFE0"  "rgb(255,255,224)"  "rgba(255,255,224,255)"  "LightYellow1"
#X11_Lightyellow2        = $D1EEEE;  $FFD1EEEE  "#EEEED1"  "rgb(238,238,209)"  "rgba(238,238,209,255)"  "LightYellow2"
#X11_Lightyellow3        = $B4CDCD;  $FFB4CDCD  "#CDCDB4"  "rgb(205,205,180)"  "rgba(205,205,180,255)"  "LightYellow3"
#X11_Lightyellow4        = $7A8B8B;  $FF7A8B8B  "#8B8B7A"  "rgb(139,139,122)"  "rgba(139,139,122,255)"  "LightYellow4"
#X11_Palegoldenrod       = $AAE8EE;  $FFAAE8EE  "#EEE8AA"  "rgb(238,232,170)"  "rgba(238,232,170,255)"  "PaleGoldenrod"
#X11_Papayawhip          = $D5EFFF;  $FFD5EFFF  "#FFEFD5"  "rgb(255,239,213)"  "rgba(255,239,213,255)"  "PapayaWhip"
#X11_Cornsilk            = $DCF8FF;  $FFDCF8FF  "#FFF8DC"  "rgb(255,248,220)"  "rgba(255,248,220,255)"  "Cornsilk"
#X11_Cornsilk1           = $DCF8FF;  $FFDCF8FF  "#FFF8DC"  "rgb(255,248,220)"  "rgba(255,248,220,255)"  "Cornsilk1"
#X11_Cornsilk2           = $CDE8EE;  $FFCDE8EE  "#EEE8CD"  "rgb(238,232,205)"  "rgba(238,232,205,255)"  "Cornsilk2"
#X11_Cornsilk3           = $B1C8CD;  $FFB1C8CD  "#CDC8B1"  "rgb(205,200,177)"  "rgba(205,200,177,255)"  "Cornsilk3"
#X11_Cornsilk4           = $78888B;  $FF78888B  "#8B8878"  "rgb(139,136,120)"  "rgba(139,136,120,255)"  "Cornsilk4"
#X11_Gold                = $00D7FF;  $FF00D7FF  "#FFD700"  "rgb(255,215,  0)"  "rgba(255,215,  0,255)"  "Gold"
#X11_Gold1               = $00D7FF;  $FF00D7FF  "#FFD700"  "rgb(255,215,  0)"  "rgba(255,215,  0,255)"  "Gold1"
#X11_Gold2               = $00C9EE;  $FF00C9EE  "#EEC900"  "rgb(238,201,  0)"  "rgba(238,201,  0,255)"  "Gold2"
#X11_Gold3               = $00ADCD;  $FF00ADCD  "#CDAD00"  "rgb(205,173,  0)"  "rgba(205,173,  0,255)"  "Gold3"
#X11_Gold4               = $00758B;  $FF00758B  "#8B7500"  "rgb(139,117,  0)"  "rgba(139,117,  0,255)"  "Gold4"
#X11_Goldenrod           = $20A5DA;  $FF20A5DA  "#DAA520"  "rgb(218,165, 32)"  "rgba(218,165, 32,255)"  "Goldenrod"
#X11_Goldenrod1          = $25C1FF;  $FF25C1FF  "#FFC125"  "rgb(255,193, 37)"  "rgba(255,193, 37,255)"  "Goldenrod1"
#X11_Goldenrod2          = $22B4EE;  $FF22B4EE  "#EEB422"  "rgb(238,180, 34)"  "rgba(238,180, 34,255)"  "Goldenrod2"
#X11_Goldenrod3          = $1D9BCD;  $FF1D9BCD  "#CD9B1D"  "rgb(205,155, 29)"  "rgba(205,155, 29,255)"  "Goldenrod3"
#X11_Goldenrod4          = $14698B;  $FF14698B  "#8B6914"  "rgb(139,105, 20)"  "rgba(139,105, 20,255)"  "Goldenrod4"
#X11_Moccasin            = $B5E4FF;  $FFB5E4FF  "#FFE4B5"  "rgb(255,228,181)"  "rgba(255,228,181,255)"  "Moccasin"
#X11_Yellow              = $00FFFF;  $FF00FFFF  "#FFFF00"  "rgb(255,255,  0)"  "rgba(255,255,  0,255)"  "Yellow"
#X11_Yellow1             = $00FFFF;  $FF00FFFF  "#FFFF00"  "rgb(255,255,  0)"  "rgba(255,255,  0,255)"  "Yellow1"
#X11_Yellow2             = $00EEEE;  $FF00EEEE  "#EEEE00"  "rgb(238,238,  0)"  "rgba(238,238,  0,255)"  "Yellow2"
#X11_Yellow3             = $00CDCD;  $FF00CDCD  "#CDCD00"  "rgb(205,205,  0)"  "rgba(205,205,  0,255)"  "Yellow3"
#X11_Yellow4             = $008B8B;  $FF008B8B  "#8B8B00"  "rgb(139,139,  0)"  "rgba(139,139,  0,255)"  "Yellow4"

;-- Orange
;X11-Orange               PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_Darkorange          = $008CFF;  $FF008CFF  "#FF8C00"  "rgb(255,140,  0)"  "rgba(255,140,  0,255)"  "DarkOrange"
#X11_Darkorange1         = $007FFF;  $FF007FFF  "#FF7F00"  "rgb(255,127,  0)"  "rgba(255,127,  0,255)"  "DarkOrange1"
#X11_Darkorange2         = $0076EE;  $FF0076EE  "#EE7600"  "rgb(238,118,  0)"  "rgba(238,118,  0,255)"  "DarkOrange2"
#X11_Darkorange3         = $0066CD;  $FF0066CD  "#CD6600"  "rgb(205,102,  0)"  "rgba(205,102,  0,255)"  "DarkOrange3"
#X11_Darkorange4         = $00458B;  $FF00458B  "#8B4500"  "rgb(139, 69,  0)"  "rgba(139, 69,  0,255)"  "DarkOrange4"
#X11_Darksalmon          = $7A96E9;  $FF7A96E9  "#E9967A"  "rgb(233,150,122)"  "rgba(233,150,122,255)"  "DarkSalmon"
#X11_Lightcoral          = $8080F0;  $FF8080F0  "#F08080"  "rgb(240,128,128)"  "rgba(240,128,128,255)"  "LightCoral"
#X11_Lightsalmon         = $7AA0FF;  $FF7AA0FF  "#FFA07A"  "rgb(255,160,122)"  "rgba(255,160,122,255)"  "LightSalmon"
#X11_Lightsalmon1        = $7AA0FF;  $FF7AA0FF  "#FFA07A"  "rgb(255,160,122)"  "rgba(255,160,122,255)"  "LightSalmon1"
#X11_Lightsalmon2        = $7295EE;  $FF7295EE  "#EE9572"  "rgb(238,149,114)"  "rgba(238,149,114,255)"  "LightSalmon2"
#X11_Lightsalmon3        = $6281CD;  $FF6281CD  "#CD8162"  "rgb(205,129, 98)"  "rgba(205,129, 98,255)"  "LightSalmon3"
#X11_Lightsalmon4        = $42578B;  $FF42578B  "#8B5742"  "rgb(139, 87, 66)"  "rgba(139, 87, 66,255)"  "LightSalmon4"
#X11_Peachpuff           = $B9DAFF;  $FFB9DAFF  "#FFDAB9"  "rgb(255,218,185)"  "rgba(255,218,185,255)"  "PeachPuff"
#X11_Peachpuff1          = $B9DAFF;  $FFB9DAFF  "#FFDAB9"  "rgb(255,218,185)"  "rgba(255,218,185,255)"  "PeachPuff1"
#X11_Peachpuff2          = $ADCBEE;  $FFADCBEE  "#EECBAD"  "rgb(238,203,173)"  "rgba(238,203,173,255)"  "PeachPuff2"
#X11_Peachpuff3          = $95AFCD;  $FF95AFCD  "#CDAF95"  "rgb(205,175,149)"  "rgba(205,175,149,255)"  "PeachPuff3"
#X11_Peachpuff4          = $65778B;  $FF65778B  "#8B7765"  "rgb(139,119,101)"  "rgba(139,119,101,255)"  "PeachPuff4"
#X11_Bisque              = $C4E4FF;  $FFC4E4FF  "#FFE4C4"  "rgb(255,228,196)"  "rgba(255,228,196,255)"  "Bisque"
#X11_Bisque1             = $C4E4FF;  $FFC4E4FF  "#FFE4C4"  "rgb(255,228,196)"  "rgba(255,228,196,255)"  "Bisque1"
#X11_Bisque2             = $B7D5EE;  $FFB7D5EE  "#EED5B7"  "rgb(238,213,183)"  "rgba(238,213,183,255)"  "Bisque2"
#X11_Bisque3             = $9EB7CD;  $FF9EB7CD  "#CDB79E"  "rgb(205,183,158)"  "rgba(205,183,158,255)"  "Bisque3"
#X11_Bisque4             = $6B7D8B;  $FF6B7D8B  "#8B7D6B"  "rgb(139,125,107)"  "rgba(139,125,107,255)"  "Bisque4"
#X11_Coral               = $507FFF;  $FF507FFF  "#FF7F50"  "rgb(255,127, 80)"  "rgba(255,127, 80,255)"  "Coral"
#X11_Coral1              = $5672FF;  $FF5672FF  "#FF7256"  "rgb(255,114, 86)"  "rgba(255,114, 86,255)"  "Coral1"
#X11_Coral2              = $506AEE;  $FF506AEE  "#EE6A50"  "rgb(238,106, 80)"  "rgba(238,106, 80,255)"  "Coral2"
#X11_Coral3              = $455BCD;  $FF455BCD  "#CD5B45"  "rgb(205, 91, 69)"  "rgba(205, 91, 69,255)"  "Coral3"
#X11_Coral4              = $2F3E8B;  $FF2F3E8B  "#8B3E2F"  "rgb(139, 62, 47)"  "rgba(139, 62, 47,255)"  "Coral4"
#X11_Honeydew            = $F0FFF0;  $FFF0FFF0  "#F0FFF0"  "rgb(240,255,240)"  "rgba(240,255,240,255)"  "Honeydew"
#X11_Honeydew1           = $F0FFF0;  $FFF0FFF0  "#F0FFF0"  "rgb(240,255,240)"  "rgba(240,255,240,255)"  "Honeydew1"
#X11_Honeydew2           = $E0EEE0;  $FFE0EEE0  "#E0EEE0"  "rgb(224,238,224)"  "rgba(224,238,224,255)"  "Honeydew2"
#X11_Honeydew3           = $C1CDC1;  $FFC1CDC1  "#C1CDC1"  "rgb(193,205,193)"  "rgba(193,205,193,255)"  "Honeydew3"
#X11_Honeydew4           = $838B83;  $FF838B83  "#838B83"  "rgb(131,139,131)"  "rgba(131,139,131,255)"  "Honeydew4"
#X11_Orange              = $00A5FF;  $FF00A5FF  "#FFA500"  "rgb(255,165,  0)"  "rgba(255,165,  0,255)"  "Orange"
#X11_Orange1             = $00A5FF;  $FF00A5FF  "#FFA500"  "rgb(255,165,  0)"  "rgba(255,165,  0,255)"  "Orange1"
#X11_Orange2             = $009AEE;  $FF009AEE  "#EE9A00"  "rgb(238,154,  0)"  "rgba(238,154,  0,255)"  "Orange2"
#X11_Orange3             = $0085CD;  $FF0085CD  "#CD8500"  "rgb(205,133,  0)"  "rgba(205,133,  0,255)"  "Orange3"
#X11_Orange4             = $005A8B;  $FF005A8B  "#8B5A00"  "rgb(139, 90,  0)"  "rgba(139, 90,  0,255)"  "Orange4"
#X11_Salmon              = $7280FA;  $FF7280FA  "#FA8072"  "rgb(250,128,114)"  "rgba(250,128,114,255)"  "Salmon"
#X11_Salmon1             = $698CFF;  $FF698CFF  "#FF8C69"  "rgb(255,140,105)"  "rgba(255,140,105,255)"  "Salmon1"
#X11_Salmon2             = $6282EE;  $FF6282EE  "#EE8262"  "rgb(238,130, 98)"  "rgba(238,130, 98,255)"  "Salmon2"
#X11_Salmon3             = $5470CD;  $FF5470CD  "#CD7054"  "rgb(205,112, 84)"  "rgba(205,112, 84,255)"  "Salmon3"
#X11_Salmon4             = $394C8B;  $FF394C8B  "#8B4C39"  "rgb(139, 76, 57)"  "rgba(139, 76, 57,255)"  "Salmon4"
#X11_Sienna              = $2D52A0;  $FF2D52A0  "#A0522D"  "rgb(160, 82, 45)"  "rgba(160, 82, 45,255)"  "Sienna"
#X11_Sienna1             = $4782FF;  $FF4782FF  "#FF8247"  "rgb(255,130, 71)"  "rgba(255,130, 71,255)"  "Sienna1"
#X11_Sienna2             = $4279EE;  $FF4279EE  "#EE7942"  "rgb(238,121, 66)"  "rgba(238,121, 66,255)"  "Sienna2"
#X11_Sienna3             = $3968CD;  $FF3968CD  "#CD6839"  "rgb(205,104, 57)"  "rgba(205,104, 57,255)"  "Sienna3"
#X11_Sienna4             = $26478B;  $FF26478B  "#8B4726"  "rgb(139, 71, 38)"  "rgba(139, 71, 38,255)"  "Sienna4"

;-- Violet
;X11-Violet               PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_Darkmagenta         = $8B008B;  $FF8B008B  "#8B008B"  "rgb(139,  0,139)"  "rgba(139,  0,139,255)"  "DarkMagenta"
#X11_Darkorchid          = $CC3299;  $FFCC3299  "#9932CC"  "rgb(153, 50,204)"  "rgba(153, 50,204,255)"  "DarkOrchid"
#X11_Darkorchid1         = $FF3EBF;  $FFFF3EBF  "#BF3EFF"  "rgb(191, 62,255)"  "rgba(191, 62,255,255)"  "DarkOrchid1"
#X11_Darkorchid2         = $EE3AB2;  $FFEE3AB2  "#B23AEE"  "rgb(178, 58,238)"  "rgba(178, 58,238,255)"  "DarkOrchid2"
#X11_Darkorchid3         = $CD329A;  $FFCD329A  "#9A32CD"  "rgb(154, 50,205)"  "rgba(154, 50,205,255)"  "DarkOrchid3"
#X11_Darkorchid4         = $8B2268;  $FF8B2268  "#68228B"  "rgb(104, 34,139)"  "rgba(104, 34,139,255)"  "DarkOrchid4"
#X11_Darkviolet          = $D30094;  $FFD30094  "#9400D3"  "rgb(148,  0,211)"  "rgba(148,  0,211,255)"  "DarkViolet"
#X11_Lavenderblush       = $F5F0FF;  $FFF5F0FF  "#FFF0F5"  "rgb(255,240,245)"  "rgba(255,240,245,255)"  "LavenderBlush"
#X11_Lavenderblush1      = $F5F0FF;  $FFF5F0FF  "#FFF0F5"  "rgb(255,240,245)"  "rgba(255,240,245,255)"  "LavenderBlush1"
#X11_Lavenderblush2      = $E5E0EE;  $FFE5E0EE  "#EEE0E5"  "rgb(238,224,229)"  "rgba(238,224,229,255)"  "LavenderBlush2"
#X11_Lavenderblush3      = $C5C1CD;  $FFC5C1CD  "#CDC1C5"  "rgb(205,193,197)"  "rgba(205,193,197,255)"  "LavenderBlush3"
#X11_Lavenderblush4      = $86838B;  $FF86838B  "#8B8386"  "rgb(139,131,134)"  "rgba(139,131,134,255)"  "LavenderBlush4"
#X11_Mediumorchid        = $D355BA;  $FFD355BA  "#BA55D3"  "rgb(186, 85,211)"  "rgba(186, 85,211,255)"  "MediumOrchid"
#X11_Mediumorchid1       = $FF66E0;  $FFFF66E0  "#E066FF"  "rgb(224,102,255)"  "rgba(224,102,255,255)"  "MediumOrchid1"
#X11_Mediumorchid2       = $EE5FD1;  $FFEE5FD1  "#D15FEE"  "rgb(209, 95,238)"  "rgba(209, 95,238,255)"  "MediumOrchid2"
#X11_Mediumorchid3       = $CD52B4;  $FFCD52B4  "#B452CD"  "rgb(180, 82,205)"  "rgba(180, 82,205,255)"  "MediumOrchid3"
#X11_Mediumorchid4       = $8B377A;  $FF8B377A  "#7A378B"  "rgb(122, 55,139)"  "rgba(122, 55,139,255)"  "MediumOrchid4"
#X11_Mediumpurple        = $DB7093;  $FFDB7093  "#9370DB"  "rgb(147,112,219)"  "rgba(147,112,219,255)"  "MediumPurple"
#X11_Mediumpurple1       = $FF82AB;  $FFFF82AB  "#AB82FF"  "rgb(171,130,255)"  "rgba(171,130,255,255)"  "MediumPurple1"
#X11_Mediumpurple2       = $EE799F;  $FFEE799F  "#9F79EE"  "rgb(159,121,238)"  "rgba(159,121,238,255)"  "MediumPurple2"
#X11_Mediumpurple3       = $CD6889;  $FFCD6889  "#8968CD"  "rgb(137,104,205)"  "rgba(137,104,205,255)"  "MediumPurple3"
#X11_Mediumpurple4       = $8B475D;  $FF8B475D  "#5D478B"  "rgb( 93, 71,139)"  "rgba( 93, 71,139,255)"  "MediumPurple4"
#X11_Lavender            = $FAE6E6;  $FFFAE6E6  "#E6E6FA"  "rgb(230,230,250)"  "rgba(230,230,250,255)"  "Lavender"
#X11_Magenta             = $FF00FF;  $FFFF00FF  "#FF00FF"  "rgb(255,  0,255)"  "rgba(255,  0,255,255)"  "Magenta"
#X11_Magenta1            = $FF00FF;  $FFFF00FF  "#FF00FF"  "rgb(255,  0,255)"  "rgba(255,  0,255,255)"  "Magenta1"
#X11_Magenta2            = $EE00EE;  $FFEE00EE  "#EE00EE"  "rgb(238,  0,238)"  "rgba(238,  0,238,255)"  "Magenta2"
#X11_Magenta3            = $CD00CD;  $FFCD00CD  "#CD00CD"  "rgb(205,  0,205)"  "rgba(205,  0,205,255)"  "Magenta3"
#X11_Magenta4            = $8B008B;  $FF8B008B  "#8B008B"  "rgb(139,  0,139)"  "rgba(139,  0,139,255)"  "Magenta4"
#X11_Maroon              = $6030B0;  $FF6030B0  "#B03060"  "rgb(176, 48, 96)"  "rgba(176, 48, 96,255)"  "Maroon"
#X11_Maroon1             = $B334FF;  $FFB334FF  "#FF34B3"  "rgb(255, 52,179)"  "rgba(255, 52,179,255)"  "Maroon1"
#X11_Maroon2             = $A730EE;  $FFA730EE  "#EE30A7"  "rgb(238, 48,167)"  "rgba(238, 48,167,255)"  "Maroon2"
#X11_Maroon3             = $9029CD;  $FF9029CD  "#CD2990"  "rgb(205, 41,144)"  "rgba(205, 41,144,255)"  "Maroon3"
#X11_Maroon4             = $621C8B;  $FF621C8B  "#8B1C62"  "rgb(139, 28, 98)"  "rgba(139, 28, 98,255)"  "Maroon4"
#X11_Orchid              = $D670DA;  $FFD670DA  "#DA70D6"  "rgb(218,112,214)"  "rgba(218,112,214,255)"  "Orchid"
#X11_Orchid1             = $FA83FF;  $FFFA83FF  "#FF83FA"  "rgb(255,131,250)"  "rgba(255,131,250,255)"  "Orchid1"
#X11_Orchid2             = $E97AEE;  $FFE97AEE  "#EE7AE9"  "rgb(238,122,233)"  "rgba(238,122,233,255)"  "Orchid2"
#X11_Orchid3             = $C969CD;  $FFC969CD  "#CD69C9"  "rgb(205,105,201)"  "rgba(205,105,201,255)"  "Orchid3"
#X11_Orchid4             = $89478B;  $FF89478B  "#8B4789"  "rgb(139, 71,137)"  "rgba(139, 71,137,255)"  "Orchid4"
#X11_Plum                = $DDA0DD;  $FFDDA0DD  "#DDA0DD"  "rgb(221,160,221)"  "rgba(221,160,221,255)"  "Plum"
#X11_Plum1               = $FFBBFF;  $FFFFBBFF  "#FFBBFF"  "rgb(255,187,255)"  "rgba(255,187,255,255)"  "Plum1"
#X11_Plum2               = $EEAEEE;  $FFEEAEEE  "#EEAEEE"  "rgb(238,174,238)"  "rgba(238,174,238,255)"  "Plum2"
#X11_Plum3               = $CD96CD;  $FFCD96CD  "#CD96CD"  "rgb(205,150,205)"  "rgba(205,150,205,255)"  "Plum3"
#X11_Plum4               = $8B668B;  $FF8B668B  "#8B668B"  "rgb(139,102,139)"  "rgba(139,102,139,255)"  "Plum4"
#X11_Purple              = $F020A0;  $FFF020A0  "#A020F0"  "rgb(160, 32,240)"  "rgba(160, 32,240,255)"  "Purple"
#X11_Purple1             = $FF309B;  $FFFF309B  "#9B30FF"  "rgb(155, 48,255)"  "rgba(155, 48,255,255)"  "Purple1"
#X11_Purple2             = $EE2C91;  $FFEE2C91  "#912CEE"  "rgb(145, 44,238)"  "rgba(145, 44,238,255)"  "Purple2"
#X11_Purple3             = $CD267D;  $FFCD267D  "#7D26CD"  "rgb(125, 38,205)"  "rgba(125, 38,205,255)"  "Purple3"
#X11_Purple4             = $8B1A55;  $FF8B1A55  "#551A8B"  "rgb( 85, 26,139)"  "rgba( 85, 26,139,255)"  "Purple4"
#X11_RebeccaPurple       = $993366;  $FF993366  "#663399"  "rgb(102, 51,153)"  "rgba(102, 51,153,255)"  "RebeccaPurple"
#X11_Thistle             = $D8BFD8;  $FFD8BFD8  "#D8BFD8"  "rgb(216,191,216)"  "rgba(216,191,216,255)"  "Thistle"
#X11_Thistle1            = $FFE1FF;  $FFFFE1FF  "#FFE1FF"  "rgb(255,225,255)"  "rgba(255,225,255,255)"  "Thistle1"
#X11_Thistle2            = $EED2EE;  $FFEED2EE  "#EED2EE"  "rgb(238,210,238)"  "rgba(238,210,238,255)"  "Thistle2"
#X11_Thistle3            = $CDB5CD;  $FFCDB5CD  "#CDB5CD"  "rgb(205,181,205)"  "rgba(205,181,205,255)"  "Thistle3"
#X11_Thistle4            = $8B7B8B;  $FF8B7B8B  "#8B7B8B"  "rgb(139,123,139)"  "rgba(139,123,139,255)"  "Thistle4"
#X11_Violet              = $EE82EE;  $FFEE82EE  "#EE82EE"  "rgb(238,130,238)"  "rgba(238,130,238,255)"  "Violet"

;-- Brown
;X11-Brown                PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              X11-Colorname:
#X11_Rosybrown           = $8F8FBC;  $FF8F8FBC  "#BC8F8F"  "rgb(188,143,143)"  "rgba(188,143,143,255)"  "RosyBrown"
#X11_Rosybrown1          = $C1C1FF;  $FFC1C1FF  "#FFC1C1"  "rgb(255,193,193)"  "rgba(255,193,193,255)"  "RosyBrown1"
#X11_Rosybrown2          = $B4B4EE;  $FFB4B4EE  "#EEB4B4"  "rgb(238,180,180)"  "rgba(238,180,180,255)"  "RosyBrown2"
#X11_Rosybrown3          = $9B9BCD;  $FF9B9BCD  "#CD9B9B"  "rgb(205,155,155)"  "rgba(205,155,155,255)"  "RosyBrown3"
#X11_Rosybrown4          = $69698B;  $FF69698B  "#8B6969"  "rgb(139,105,105)"  "rgba(139,105,105,255)"  "RosyBrown4"
#X11_Saddlebrown         = $13458B;  $FF13458B  "#8B4513"  "rgb(139, 69, 19)"  "rgba(139, 69, 19,255)"  "SaddleBrown"
#X11_Sandybrown          = $60A4F4;  $FF60A4F4  "#F4A460"  "rgb(244,164, 96)"  "rgba(244,164, 96,255)"  "SandyBrown"
#X11_Beige               = $DCF5F5;  $FFDCF5F5  "#F5F5DC"  "rgb(245,245,220)"  "rgba(245,245,220,255)"  "Beige"
#X11_Brown               = $2A2AA5;  $FF2A2AA5  "#A52A2A"  "rgb(165, 42, 42)"  "rgba(165, 42, 42,255)"  "Brown"
#X11_Brown1              = $4040FF;  $FF4040FF  "#FF4040"  "rgb(255, 64, 64)"  "rgba(255, 64, 64,255)"  "Brown1"
#X11_Brown2              = $3B3BEE;  $FF3B3BEE  "#EE3B3B"  "rgb(238, 59, 59)"  "rgba(238, 59, 59,255)"  "Brown2"
#X11_Brown3              = $3333CD;  $FF3333CD  "#CD3333"  "rgb(205, 51, 51)"  "rgba(205, 51, 51,255)"  "Brown3"
#X11_Brown4              = $23238B;  $FF23238B  "#8B2323"  "rgb(139, 35, 35)"  "rgba(139, 35, 35,255)"  "Brown4"
#X11_Burlywood           = $87B8DE;  $FF87B8DE  "#DEB887"  "rgb(222,184,135)"  "rgba(222,184,135,255)"  "Burlywood"
#X11_Burlywood1          = $9BD3FF;  $FF9BD3FF  "#FFD39B"  "rgb(255,211,155)"  "rgba(255,211,155,255)"  "Burlywood1"
#X11_Burlywood2          = $91C5EE;  $FF91C5EE  "#EEC591"  "rgb(238,197,145)"  "rgba(238,197,145,255)"  "Burlywood2"
#X11_Burlywood3          = $7DAACD;  $FF7DAACD  "#CDAA7D"  "rgb(205,170,125)"  "rgba(205,170,125,255)"  "Burlywood3"
#X11_Burlywood4          = $55738B;  $FF55738B  "#8B7355"  "rgb(139,115, 85)"  "rgba(139,115, 85,255)"  "Burlywood4"
#X11_Chocolate           = $1E69D2;  $FF1E69D2  "#D2691E"  "rgb(210,105, 30)"  "rgba(210,105, 30,255)"  "Chocolate"
#X11_Chocolate1          = $247FFF;  $FF247FFF  "#FF7F24"  "rgb(255,127, 36)"  "rgba(255,127, 36,255)"  "Chocolate1"
#X11_Chocolate2          = $2176EE;  $FF2176EE  "#EE7621"  "rgb(238,118, 33)"  "rgba(238,118, 33,255)"  "Chocolate2"
#X11_Chocolate3          = $1D66CD;  $FF1D66CD  "#CD661D"  "rgb(205,102, 29)"  "rgba(205,102, 29,255)"  "Chocolate3"
#X11_Chocolate4          = $13458B;  $FF13458B  "#8B4513"  "rgb(139, 69, 19)"  "rgba(139, 69, 19,255)"  "Chocolate4"
#X11_Peru                = $3F85CD;  $FF3F85CD  "#CD853F"  "rgb(205,133, 63)"  "rgba(205,133, 63,255)"  "Peru"
#X11_Tan                 = $8CB4D2;  $FF8CB4D2  "#D2B48C"  "rgb(210,180,140)"  "rgba(210,180,140,255)"  "Tan"
#X11_Tan1                = $4FA5FF;  $FF4FA5FF  "#FFA54F"  "rgb(255,165, 79)"  "rgba(255,165, 79,255)"  "Tan1"
#X11_Tan2                = $499AEE;  $FF499AEE  "#EE9A49"  "rgb(238,154, 73)"  "rgba(238,154, 73,255)"  "Tan2"
#X11_Tan3                = $3F85CD;  $FF3F85CD  "#CD853F"  "rgb(205,133, 63)"  "rgba(205,133, 63,255)"  "Tan3"
#X11_Tan4                = $2B5A8B;  $FF2B5A8B  "#8B5A2B"  "rgb(139, 90, 43)"  "rgba(139, 90, 43,255)"  "Tan4"


;-VGA-Basic-Color-Definitions (16)
;VGA-Colors       PB-Color:   "+Alpha:   API-color: RGB-Color:          RGBA-Color:              VGA-Colorname:
#VGA_Black        = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "Black"
#VGA_Blue         = $AA0000;  $FFAA0000  "#0000AA"  "rgb(  0,  0,170)"  "rgba(  0,  0,170,255)"  "Blue"
#VGA_Green        = $00AA00;  $FF00AA00  "#00AA00"  "rgb(  0,170,  0)"  "rgba(  0,170,  0,255)"  "Green"
#VGA_Cyan         = $AAAA00;  $FFAAAA00  "#00AAAA"  "rgb(  0,170,170)"  "rgba(  0,170,170,255)"  "Cyan"
#VGA_Red          = $0000AA;  $FF0000AA  "#AA0000"  "rgb(170,  0,  0)"  "rgba(170,  0,  0,255)"  "Red"
#VGA_Magenta      = $AA00AA;  $FFAA00AA  "#AA00AA"  "rgb(170,  0,170)"  "rgba(170,  0,170,255)"  "Magenta"
#VGA_Brown        = $0055AA;  $FF0055AA  "#AA5500"  "rgb(170, 85,  0)"  "rgba(170, 85,  0,255)"  "Brown"
#VGA_Gray         = $AAAAAA;  $FFAAAAAA  "#AAAAAA"  "rgb(170,170,170)"  "rgba(170,170,170,255)"  "Gray"
#VGA_DarkGray     = $555555;  $FF555555  "#555555"  "rgb( 85, 85, 85)"  "rgba( 85, 85, 85,255)"  "DarkGray"
#VGA_BrightBlue   = $FF5555;  $FFFF5555  "#5555FF"  "rgb( 85, 85,255)"  "rgba( 85, 85,255,255)"  "BrightBlue"
#VGA_BrightGreen  = $55FF55;  $FF55FF55  "#55FF55"  "rgb( 85,255, 85)"  "rgba( 85,255, 85,255)"  "BrightGreen"
#VGA_BrightCyan   = $FFFF55;  $FFFFFF55  "#55FFFF"  "rgb( 85,255,255)"  "rgba( 85,255,255,255)"  "BrightCyan"
#VGA_BrightRed    = $5555FF;  $FF5555FF  "#FF5555"  "rgb(255, 85, 85)"  "rgba(255, 85, 85,255)"  "BrightRed"
#VGA_BrightMagenta= $FF55FF;  $FFFF55FF  "#FF55FF"  "rgb(255, 85,255)"  "rgba(255, 85,255,255)"  "BrightMagenta"
#VGA_Yellow       = $55FFFF;  $FF55FFFF  "#FFFF55"  "rgb(255,255, 85)"  "rgba(255,255, 85,255)"  "Yellow"
#VGA_White        = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "White"


;-RALe-Colors, english names
;  see http://www.ralcolor.com/
;RALe-constant            PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              RAL-Colorname:
#RALe_GreenBeige          = $7FBDBE;  $FF7FBDBE  "#BEBD7F"  "rgb(125,189,127)"  "rgba(125,189,127,255)"  "GreenBeige"
#RALe_Beige               = $78B0C2;  $FF78B0C2  "#C2B078"  "rgb(127,176,120)"  "rgba(127,176,120,255)"  "Beige"
#RALe_SandYellow          = $64A6C6;  $FF64A6C6  "#C6A664"  "rgb(130,166,100)"  "rgba(130,166,100,255)"  "SandYellow"
#RALe_SignalYellow        = $01BEE5;  $FF01BEE5  "#E5BE01"  "rgb(150,190,  1)"  "rgba(150,190,  1,255)"  "SignalYellow"
#RALe_GoldenYellow        = $34A4CD;  $FF34A4CD  "#CDA434"  "rgb(134,164, 52)"  "rgba(134,164, 52,255)"  "GoldenYellow"
#RALe_HoneyYellow         = $0783A9;  $FF0783A9  "#A98307"  "rgb(111,131,  7)"  "rgba(111,131,  7,255)"  "HoneyYellow"
#RALe_MaizeYellow         = $10A0E4;  $FF10A0E4  "#E4A010"  "rgb(149,160, 16)"  "rgba(149,160, 16,255)"  "MaizeYellow"
#RALe_DaffodilYellow      = $009DDC;  $FF009DDC  "#DC9D00"  "rgb(144,157,  0)"  "rgba(144,157,  0,255)"  "DaffodilYellow"
#RALe_BrownBeige          = $42668A;  $FF42668A  "#8A6642"  "rgb(907,102, 66)"  "rgba(907,102, 66,255)"  "BrownBeige"
#RALe_LemonYellow         = $46B4C7;  $FF46B4C7  "#C7B446"  "rgb(130,180, 70)"  "rgba(130,180, 70,255)"  "LemonYellow"
#RALe_OysterWhite         = $CAE6EA;  $FFCAE6EA  "#EAE6CA"  "rgb(153,230,202)"  "rgba(153,230,202,255)"  "OysterWhite"
#RALe_Ivory               = $4FCCE1;  $FF4FCCE1  "#E1CC4F"  "rgb(147,204, 79)"  "rgba(147,204, 79,255)"  "Ivory"
#RALe_LightIvory          = $90D6E6;  $FF90D6E6  "#E6D690"  "rgb(151,214,144)"  "rgba(151,214,144,255)"  "LightIvory"
#RALe_SulfurYellow        = $21FFED;  $FF21FFED  "#EDFF21"  "rgb(155,255, 33)"  "rgba(155,255, 33,255)"  "SulfurYellow"
#RALe_SaffronYellow       = $33D0F5;  $FF33D0F5  "#F5D033"  "rgb(161,208, 51)"  "rgba(161,208, 51,255)"  "SaffronYellow"
#RALe_ZincYellow          = $2BF3F8;  $FF2BF3F8  "#F8F32B"  "rgb(163,243, 43)"  "rgba(163,243, 43,255)"  "ZincYellow"
#RALe_GreyBeige           = $64979E;  $FF64979E  "#9E9764"  "rgb(103,151,100)"  "rgba(103,151,100,255)"  "GreyBeige"
#RALe_OliveYellow         = $509999;  $FF509999  "#999950"  "rgb(100,153, 80)"  "rgba(100,153, 80,255)"  "OliveYellow"
#RALe_RapeYellow          = $0BDAF3;  $FF0BDAF3  "#F3DA0B"  "rgb(159,218, 11)"  "rgba(159,218, 11,255)"  "RapeYellow"
#RALe_TrafficYellow       = $01D2FA;  $FF01D2FA  "#FAD201"  "rgb(164,210,  1)"  "rgba(164,210,  1,255)"  "TrafficYellow"
#RALe_OchreYellow         = $4BA0AE;  $FF4BA0AE  "#AEA04B"  "rgb(114,160, 75)"  "rgba(114,160, 75,255)"  "OchreYellow"
#RALe_LuminousYellow      = $00FFFF;  $FF00FFFF  "#FFFF00"  "rgb(167,255,  0)"  "rgba(167,255,  0,255)"  "LuminousYellow"
#RALe_Curry               = $01919D;  $FF01919D  "#9D9101"  "rgb(103,145,  1)"  "rgba(103,145,  1,255)"  "Curry"
#RALe_MelonYellow         = $00A9F4;  $FF00A9F4  "#F4A900"  "rgb(160,169,  0)"  "rgba(160,169,  0,255)"  "MelonYellow"
#RALe_BroomYellow         = $01AED6;  $FF01AED6  "#D6AE01"  "rgb(140,174,  1)"  "rgba(140,174,  1,255)"  "BroomYellow"
#RALe_DahliaYellow        = $05A5F3;  $FF05A5F3  "#F3A505"  "rgb(159,165,  5)"  "rgba(159,165,  5,255)"  "DahliaYellow"
#RALe_PastelYellow        = $4AA9EF;  $FF4AA9EF  "#EFA94A"  "rgb(157,169, 74)"  "rgba(157,169, 74,255)"  "PastelYellow"
#RALe_PearlBeige          = $4D5D6A;  $FF4D5D6A  "#6A5D4D"  "rgb(697, 93, 77)"  "rgba(697, 93, 77,255)"  "PearlBeige"
#RALe_PearlGold           = $355370;  $FF355370  "#705335"  "rgb(736, 83, 53)"  "rgba(736, 83, 53,255)"  "PearlGold"
#RALe_SunYellow           = $189FF3;  $FF189FF3  "#F39F18"  "rgb(159,159, 24)"  "rgba(159,159, 24,255)"  "SunYellow"
#RALe_YellowOrange        = $0E76ED;  $FF0E76ED  "#ED760E"  "rgb(155,118, 14)"  "rgba(155,118, 14,255)"  "YellowOrange"
#RALe_RedOrange           = $203CC9;  $FF203CC9  "#C93C20"  "rgb(131, 60, 32)"  "rgba(131, 60, 32,255)"  "RedOrange"
#RALe_Vermilion           = $2128CB;  $FF2128CB  "#CB2821"  "rgb(133, 40, 33)"  "rgba(133, 40, 33,255)"  "Vermilion"
#RALe_PastelOrange        = $1475FF;  $FF1475FF  "#FF7514"  "rgb(167,117, 20)"  "rgba(167,117, 20,255)"  "PastelOrange"
#RALe_PureOrange          = $1146F4;  $FF1146F4  "#F44611"  "rgb(160, 70, 17)"  "rgba(160, 70, 17,255)"  "PureOrange"
#RALe_LuminousOrange      = $0123FF;  $FF0123FF  "#FF2301"  "rgb(167, 35,  1)"  "rgba(167, 35,  1,255)"  "LuminousOrange"
#RALe_LuminousBrightOrange= $20A4FF;  $FF20A4FF  "#FFA420"  "rgb(167,164, 32)"  "rgba(167,164, 32,255)"  "LuminousBrightOrange"
#RALe_BrightRedOrange     = $255EF7;  $FF255EF7  "#F75E25"  "rgb(162, 94, 37)"  "rgba(162, 94, 37,255)"  "BrightRedOrange"
#RALe_TrafficOrange       = $2140F5;  $FF2140F5  "#F54021"  "rgb(160, 64, 33)"  "rgba(160, 64, 33,255)"  "TrafficOrange"
#RALe_SignalOrange        = $204BD8;  $FF204BD8  "#D84B20"  "rgb(141, 75, 32)"  "rgba(141, 75, 32,255)"  "SignalOrange"
#RALe_DeepOrange          = $267CEC;  $FF267CEC  "#EC7C26"  "rgb(154,124, 38)"  "rgba(154,124, 38,255)"  "DeepOrange"
#RALe_SalmonRange         = $3751E5;  $FF3751E5  "#E55137"  "rgb(150, 81, 55)"  "rgba(150, 81, 55,255)"  "SalmonRange"
#RALe_PearlOrange         = $3158C3;  $FF3158C3  "#C35831"  "rgb(128, 88, 49)"  "rgba(128, 88, 49,255)"  "PearlOrange"
#RALe_FlameRed            = $1E2BAF;  $FF1E2BAF  "#AF2B1E"  "rgb(114, 43, 30)"  "rgba(114, 43, 30,255)"  "FlameRed"
#RALe_SignalRed           = $1920A5;  $FF1920A5  "#A52019"  "rgb(108, 32, 25)"  "rgba(108, 32, 25,255)"  "SignalRed"
#RALe_CarmineRed          = $1D23A2;  $FF1D23A2  "#A2231D"  "rgb(106, 35, 29)"  "rgba(106, 35, 29,255)"  "CarmineRed"
#RALe_RubyRed             = $1E119B;  $FF1E119B  "#9B111E"  "rgb(101, 17, 30)"  "rgba(101, 17, 30,255)"  "RubyRed"
#RALe_PurpleRed           = $1E1575;  $FF1E1575  "#75151E"  "rgb(767, 21, 30)"  "rgba(767, 21, 30,255)"  "PurpleRed"
#RALe_WineRed             = $29215E;  $FF29215E  "#5E2129"  "rgb(616, 33, 41)"  "rgba(616, 33, 41,255)"  "WineRed"
#RALe_BlackRed            = $272241;  $FF272241  "#412227"  "rgb(426, 34, 39)"  "rgba(426, 34, 39,255)"  "BlackRed"
#RALe_OxideRed            = $242464;  $FF242464  "#642424"  "rgb(656, 36, 36)"  "rgba(656, 36, 36,255)"  "OxideRed"
#RALe_BrownRed            = $191F78;  $FF191F78  "#781F19"  "rgb(787, 31, 25)"  "rgba(787, 31, 25,255)"  "BrownRed"
#RALe_BeigeRed            = $6B87C1;  $FF6B87C1  "#C1876B"  "rgb(126,135,107)"  "rgba(126,135,107,255)"  "BeigeRed"
#RALe_TomatoRed           = $1223A1;  $FF1223A1  "#A12312"  "rgb(105, 35, 18)"  "rgba(105, 35, 18,255)"  "TomatoRed"
#RALe_AntiquePink         = $706ED3;  $FF706ED3  "#D36E70"  "rgb(138,110,112)"  "rgba(138,110,112,255)"  "AntiquePink"
#RALe_LightPink           = $9A89EA;  $FF9A89EA  "#EA899A"  "rgb(153,137,154)"  "rgba(153,137,154,255)"  "LightPink"
#RALe_CoralRed            = $2128B3;  $FF2128B3  "#B32821"  "rgb(117, 40, 33)"  "rgba(117, 40, 33,255)"  "CoralRed"
#RALe_Rose                = $4432E6;  $FF4432E6  "#E63244"  "rgb(150, 50, 68)"  "rgba(150, 50, 68,255)"  "Rose"
#RALe_StrawberryRed       = $3230D5;  $FF3230D5  "#D53032"  "rgb(139, 48, 50)"  "rgba(139, 48, 50,255)"  "StrawberryRed"
#RALe_TrafficRed          = $0506CC;  $FF0506CC  "#CC0605"  "rgb(133,  6,  5)"  "rgba(133,  6,  5,255)"  "TrafficRed"
#RALe_SalmonPink          = $3050D9;  $FF3050D9  "#D95030"  "rgb(142, 80, 48)"  "rgba(142, 80, 48,255)"  "SalmonPink"
#RALe_LuminousRed         = $0000F8;  $FF0000F8  "#F80000"  "rgb(162,  0,  0)"  "rgba(162,  0,  0,255)"  "LuminousRed"
#RALe_Luminous            = $0000FE;  $FF0000FE  "#FE0000"  "rgb(166,  0,  0)"  "rgba(166,  0,  0,255)"  "Luminous"
#RALe_RaspberryRed        = $341DC5;  $FF341DC5  "#C51D34"  "rgb(129, 29, 52)"  "rgba(129, 29, 52,255)"  "RaspberryRed"
#RALe_PureRed             = $3432CB;  $FF3432CB  "#CB3234"  "rgb(133, 50, 52)"  "rgba(133, 50, 52,255)"  "PureRed"
#RALe_OrientRed           = $2824B3;  $FF2824B3  "#B32428"  "rgb(117, 36, 40)"  "rgba(117, 36, 40,255)"  "OrientRed"
#RALe_PearlRubyRed        = $221472;  $FF221472  "#721422"  "rgb(747, 20, 34)"  "rgba(747, 20, 34,255)"  "PearlRubyRed"
#RALe_PearlPink           = $434CB4;  $FF434CB4  "#B44C43"  "rgb(118, 76, 67)"  "rgba(118, 76, 67,255)"  "PearlPink"
#RALe_RedLilac            = $5B3F6D;  $FF5B3F6D  "#6D3F5B"  "rgb(715, 63, 91)"  "rgba(715, 63, 91,255)"  "RedLilac"
#RALe_RedViolet           = $3E2B92;  $FF3E2B92  "#922B3E"  "rgb(957, 43, 62)"  "rgba(957, 43, 62,255)"  "RedViolet"
#RALe_HeatherViolet       = $8A4CDE;  $FF8A4CDE  "#DE4C8A"  "rgb(145, 76,138)"  "rgba(145, 76,138,255)"  "HeatherViolet"
#RALe_ClaretViolet        = $341C64;  $FF341C64  "#641C34"  "rgb(656, 28, 52)"  "rgba(656, 28, 52,255)"  "ClaretViolet"
#RALe_BlueLilac           = $75466C;  $FF75466C  "#6C4675"  "rgb(709, 70,117)"  "rgba(709, 70,117,255)"  "BlueLilac"
#RALe_TrafficPurple       = $7234A0;  $FF7234A0  "#A03472"  "rgb(104, 52,114)"  "rgba(104, 52,114,255)"  "TrafficPurple"
#RALe_PurpleViolet        = $2C194A;  $FF2C194A  "#4A192C"  "rgb(485, 25, 44)"  "rgba(485, 25, 44,255)"  "PurpleViolet"
#RALe_SignalViolet        = $7D4E92;  $FF7D4E92  "#924E7D"  "rgb(958, 78,125)"  "rgba(958, 78,125,255)"  "SignalViolet"
#RALe_PastelViolet        = $9485A1;  $FF9485A1  "#A18594"  "rgb(105,133,148)"  "rgba(105,133,148,255)"  "PastelViolet"
#RALe_Telemagenta         = $7634CF;  $FF7634CF  "#CF3476"  "rgb(135, 52,118)"  "rgba(135, 52,118,255)"  "Telemagenta"
#RALe_PearlViolet         = $A17386;  $FFA17386  "#8673A1"  "rgb(881,115,161)"  "rgba(881,115,161,255)"  "PearlViolet"
#RALe_PearlBlackBerry     = $74686C;  $FF74686C  "#6C6874"  "rgb(710,104,116)"  "rgba(710,104,116,255)"  "PearlBlackBerry"
#RALe_VioletBlue          = $734D35;  $FF734D35  "#354D73"  "rgb(349, 77,115)"  "rgba(349, 77,115,255)"  "VioletBlue"
#RALe_GreenBlue           = $38341F;  $FF38341F  "#1F3438"  "rgb(204, 52, 56)"  "rgba(204, 52, 56,255)"  "GreenBlue"
#RALe_UltramarineBlue     = $4F2120;  $FF4F2120  "#20214F"  "rgb(210, 33, 79)"  "rgba(210, 33, 79,255)"  "UltramarineBlue"
#RALe_SaphireBlue         = $331E1D;  $FF331E1D  "#1D1E33"  "rgb(190, 30, 51)"  "rgba(190, 30, 51,255)"  "SaphireBlue"
#RALe_BlackBlue           = $1C1718;  $FF1C1718  "#18171C"  "rgb(157, 23, 28)"  "rgba(157, 23, 28,255)"  "BlackBlue"
#RALe_SignalBlue          = $60241E;  $FF60241E  "#1E2460"  "rgb(197, 36, 96)"  "rgba(197, 36, 96,255)"  "SignalBlue"
#RALe_BrillantBlue        = $8A5F3E;  $FF8A5F3E  "#3E5F8A"  "rgb(408, 95,138)"  "rgba(408, 95,138,255)"  "BrillantBlue"
#RALe_GreyBlue            = $2D2526;  $FF2D2526  "#26252D"  "rgb(249, 37, 45)"  "rgba(249, 37, 45,255)"  "GreyBlue"
#RALe_AzureBlue           = $695602;  $FF695602  "#025669"  "rgb(153, 86,105)"  "rgba(153, 86,105,255)"  "AzureBlue"
#RALe_GentianBlue         = $4B290E;  $FF4B290E  "#0E294B"  "rgb(928, 41, 75)"  "rgba(928, 41, 75,255)"  "GentianBlue"
#RALe_SteelBlue           = $241A23;  $FF241A23  "#231A24"  "rgb(230, 26, 36)"  "rgba(230, 26, 36,255)"  "SteelBlue"
#RALe_LightBlue           = $BD833B;  $FFBD833B  "#3B83BD"  "rgb(390,131,189)"  "rgba(390,131,189,255)"  "LightBlue"
#RALe_CobaltBlue          = $3D211E;  $FF3D211E  "#1E213D"  "rgb(197, 33, 61)"  "rgba(197, 33, 61,255)"  "CobaltBlue"
#RALe_PigeonBlue          = $8C6E60;  $FF8C6E60  "#606E8C"  "rgb(631,110,140)"  "rgba(631,110,140,255)"  "PigeonBlue"
#RALe_SkyBlue             = $B37122;  $FFB37122  "#2271B3"  "rgb(225,113,179)"  "rgba(225,113,179,255)"  "SkyBlue"
#RALe_TrafficBlue         = $713906;  $FF713906  "#063971"  "rgb(407, 57,113)"  "rgba(407, 57,113,255)"  "TrafficBlue"
#RALe_TurquoiseBlue       = $8F883F;  $FF8F883F  "#3F888F"  "rgb(416,136,143)"  "rgba(416,136,143,255)"  "TurquoiseBlue"
#RALe_CapriBlue           = $83551B;  $FF83551B  "#1B5583"  "rgb(179, 85,131)"  "rgba(179, 85,131,255)"  "CapriBlue"
#RALe_OceanBlue           = $4A331D;  $FF4A331D  "#1D334A"  "rgb(191, 51, 74)"  "rgba(191, 51, 74,255)"  "OceanBlue"
#RALe_WaterBlue           = $7B6D25;  $FF7B6D25  "#256D7B"  "rgb(245,109,123)"  "rgba(245,109,123,255)"  "WaterBlue"
#RALe_NightBlue           = $502825;  $FF502825  "#252850"  "rgb(243, 40, 80)"  "rgba(243, 40, 80,255)"  "NightBlue"
#RALe_DistantBlue         = $8D6749;  $FF8D6749  "#49678D"  "rgb(481,103,141)"  "rgba(481,103,141,255)"  "DistantBlue"
#RALe_PastelBlue          = $9B9B5D;  $FF9B9B5D  "#5D9B9B"  "rgb(613,155,155)"  "rgba(613,155,155,255)"  "PastelBlue"
#RALe_PearlGentianBlue    = $78642A;  $FF78642A  "#2A6478"  "rgb(277,100,120)"  "rgba(277,100,120,255)"  "PearlGentianBlue"
#RALe_PearlNightBlue      = $542C10;  $FF542C10  "#102C54"  "rgb(105, 44, 84)"  "rgba(105, 44, 84,255)"  "PearlNightBlue"
#RALe_PatinaGreen         = $506631;  $FF506631  "#316650"  "rgb(323,102, 80)"  "rgba(323,102, 80,255)"  "PatinaGreen"
#RALe_EmeraldGreen        = $337228;  $FF337228  "#287233"  "rgb(265,114, 51)"  "rgba(265,114, 51,255)"  "EmeraldGreen"
#RALe_LeafGreen           = $2C572D;  $FF2C572D  "#2D572C"  "rgb(297, 87, 44)"  "rgba(297, 87, 44,255)"  "LeafGreen"
#RALe_OliveGreen          = $324642;  $FF324642  "#424632"  "rgb(434, 70, 50)"  "rgba(434, 70, 50,255)"  "OliveGreen"
#RALe_BlueGreen           = $3D3A1F;  $FF3D3A1F  "#1F3A3D"  "rgb(204, 58, 61)"  "rgba(204, 58, 61,255)"  "BlueGreen"
#RALe_MossGreen           = $38452F;  $FF38452F  "#2F4538"  "rgb(309, 69, 56)"  "rgba(309, 69, 56,255)"  "MossGreen"
#RALe_GreyOlive           = $323B3E;  $FF323B3E  "#3E3B32"  "rgb(407, 59, 50)"  "rgba(407, 59, 50,255)"  "GreyOlive"
#RALe_BottleGreen         = $293B34;  $FF293B34  "#343B29"  "rgb(342, 59, 41)"  "rgba(342, 59, 41,255)"  "BottleGreen"
#RALe_BrownGreen          = $2A3539;  $FF2A3539  "#39352A"  "rgb(374, 53, 42)"  "rgba(374, 53, 42,255)"  "BrownGreen"
#RALe_FirGreen            = $2B3731;  $FF2B3731  "#31372B"  "rgb(322, 55, 43)"  "rgba(322, 55, 43,255)"  "FirGreen"
#RALe_GrassGreen          = $2D6835;  $FF2D6835  "#35682D"  "rgb(350,104, 45)"  "rgba(350,104, 45,255)"  "GrassGreen"
#RALe_ResedaGreen         = $467258;  $FF467258  "#587246"  "rgb(579,114, 70)"  "rgba(579,114, 70,255)"  "ResedaGreen"
#RALe_BlackGreen          = $403E34;  $FF403E34  "#343E40"  "rgb(342, 62, 64)"  "rgba(342, 62, 64,255)"  "BlackGreen"
#RALe_ReedGreen           = $56716C;  $FF56716C  "#6C7156"  "rgb(710,113, 86)"  "rgba(710,113, 86,255)"  "ReedGreen"
#RALe_YellowOlive         = $2E4047;  $FF2E4047  "#47402E"  "rgb(466, 64, 46)"  "rgba(466, 64, 46,255)"  "YellowOlive"
#RALe_BlackOlive          = $363C3B;  $FF363C3B  "#3B3C36"  "rgb(388, 60, 54)"  "rgba(388, 60, 54,255)"  "BlackOlive"
#RALe_TurquoiseGreen      = $45591E;  $FF45591E  "#1E5945"  "rgb(198, 89, 69)"  "rgba(198, 89, 69,255)"  "TurquoiseGreen"
#RALe_MayGreen            = $41914C;  $FF41914C  "#4C9141"  "rgb(501,145, 65)"  "rgba(501,145, 65,255)"  "MayGreen"
#RALe_YellowGreen         = $39A657;  $FF39A657  "#57A639"  "rgb(574,166, 57)"  "rgba(574,166, 57,255)"  "YellowGreen"
#RALe_PastelGreen         = $B6ECBD;  $FFB6ECBD  "#BDECB6"  "rgb(124,236,182)"  "rgba(124,236,182,255)"  "PastelGreen"
#RALe_ChromeGreen         = $233A2E;  $FF233A2E  "#2E3A23"  "rgb(302, 58, 35)"  "rgba(302, 58, 35,255)"  "ChromeGreen"
#RALe_PaleGreen           = $76AC89;  $FF76AC89  "#89AC76"  "rgb(902,172,118)"  "rgba(902,172,118,255)"  "PaleGreen"
#RALe_OliveDrab           = $1B2225;  $FF1B2225  "#25221B"  "rgb(243, 34, 27)"  "rgba(243, 34, 27,255)"  "OliveDrab"
#RALe_TrafficGreen        = $468430;  $FF468430  "#308446"  "rgb(317,132, 70)"  "rgba(317,132, 70,255)"  "TrafficGreen"
#RALe_FernGreen           = $2D643D;  $FF2D643D  "#3D642D"  "rgb(402,100, 45)"  "rgba(402,100, 45,255)"  "FernGreen"
#RALe_OpalGreen           = $525D01;  $FF525D01  "#015D52"  "rgb(894, 93, 82)"  "rgba(894, 93, 82,255)"  "OpalGreen"
#RALe_LightGreen          = $BEC384;  $FFBEC384  "#84C3BE"  "rgb(870,195,190)"  "rgba(870,195,190,255)"  "LightGreen"
#RALe_PineGreen           = $45552C;  $FF45552C  "#2C5545"  "rgb(290, 85, 69)"  "rgba(290, 85, 69,255)"  "PineGreen"
#RALe_MintGreen           = $3D6020;  $FF3D6020  "#20603D"  "rgb(212, 96, 61)"  "rgba(212, 96, 61,255)"  "MintGreen"
#RALe_SignalGreen         = $437F31;  $FF437F31  "#317F43"  "rgb(324,127, 67)"  "rgba(324,127, 67,255)"  "SignalGreen"
#RALe_MintTurquoise       = $767E49;  $FF767E49  "#497E76"  "rgb(481,126,118)"  "rgba(481,126,118,255)"  "MintTurquoise"
#RALe_PastelTurquoise     = $B5B57F;  $FFB5B57F  "#7FB5B5"  "rgb(836,181,181)"  "rgba(836,181,181,255)"  "PastelTurquoise"
#RALe_PearlGreen          = $2D541C;  $FF2D541C  "#1C542D"  "rgb(185, 84, 45)"  "rgba(185, 84, 45,255)"  "PearlGreen"
#RALe_PearlOpalGreen      = $373719;  $FF373719  "#193737"  "rgb(165, 55, 55)"  "rgba(165, 55, 55,255)"  "PearlOpalGreen"
#RALe_PureGreen           = $398F00;  $FF398F00  "#008F39"  "rgb(366,143, 57)"  "rgba(366,143, 57,255)"  "PureGreen"
#RALe_LuminousGreen       = $2DBB00;  $FF2DBB00  "#00BB2D"  "rgb(479,187, 45)"  "rgba(479,187, 45,255)"  "LuminousGreen"
#RALe_SquirrelGrey        = $8B8578;  $FF8B8578  "#78858B"  "rgb(789,133,139)"  "rgba(789,133,139,255)"  "SquirrelGrey"
#RALe_SilverGrey          = $97958A;  $FF97958A  "#8A9597"  "rgb(908,149,151)"  "rgba(908,149,151,255)"  "SilverGrey"
#RALe_OliveGrey           = $527B7E;  $FF527B7E  "#7E7B52"  "rgb(828,123, 82)"  "rgba(828,123, 82,255)"  "OliveGrey"
#RALe_MossGrey            = $59706C;  $FF59706C  "#6C7059"  "rgb(710,112, 89)"  "rgba(710,112, 89,255)"  "MossGrey"
#RALe_SignalGrey          = $929996;  $FF929996  "#969992"  "rgb(986,153,146)"  "rgba(986,153,146,255)"  "SignalGrey"
#RALe_MouseGrey           = $636B64;  $FF636B64  "#646B63"  "rgb(658,107, 99)"  "rgba(658,107, 99,255)"  "MouseGrey"
#RALe_BeigeGrey           = $52656D;  $FF52656D  "#6D6552"  "rgb(716,101, 82)"  "rgba(716,101, 82,255)"  "BeigeGrey"
#RALe_KhakiGrey           = $315F6A;  $FF315F6A  "#6A5F31"  "rgb(697, 95, 49)"  "rgba(697, 95, 49,255)"  "KhakiGrey"
#RALe_GreenGrey           = $45564D;  $FF45564D  "#4D5645"  "rgb(506, 86, 69)"  "rgba(506, 86, 69,255)"  "GreenGrey"
#RALe_TarpaulinGrey       = $4A514C;  $FF4A514C  "#4C514A"  "rgb(500, 81, 74)"  "rgba(500, 81, 74,255)"  "TarpaulinGrey"
#RALe_IronGrey            = $4D4B43;  $FF4D4B43  "#434B4D"  "rgb(441, 75, 77)"  "rgba(441, 75, 77,255)"  "IronGrey"
#RALe_BasaltGrey          = $54574E;  $FF54574E  "#4E5754"  "rgb(513, 87, 84)"  "rgba(513, 87, 84,255)"  "BasaltGrey"
#RALe_BrownGrey           = $314546;  $FF314546  "#464531"  "rgb(460, 69, 49)"  "rgba(460, 69, 49,255)"  "BrownGrey"
#RALe_SlateGrey           = $504743;  $FF504743  "#434750"  "rgb(440, 71, 80)"  "rgba(440, 71, 80,255)"  "SlateGrey"
#RALe_AnthraciteGrey      = $333129;  $FF333129  "#293133"  "rgb(269, 49, 51)"  "rgba(269, 49, 51,255)"  "AnthraciteGrey"
#RALe_BlackGrey           = $2B2823;  $FF2B2823  "#23282B"  "rgb(230, 40, 43)"  "rgba(230, 40, 43,255)"  "BlackGrey"
#RALe_UmbraGrey           = $2C2F33;  $FF2C2F33  "#332F2C"  "rgb(335, 47, 44)"  "rgba(335, 47, 44,255)"  "UmbraGrey"
#RALe_ConcreteGrey        = $5E6C68;  $FF5E6C68  "#686C5E"  "rgb(684,108, 94)"  "rgba(684,108, 94,255)"  "ConcreteGrey"
#RALe_GraphiteGrey        = $514A47;  $FF514A47  "#474A51"  "rgb(467, 74, 81)"  "rgba(467, 74, 81,255)"  "GraphiteGrey"
#RALe_GraniteGrey         = $3B352F;  $FF3B352F  "#2F353B"  "rgb(309, 53, 59)"  "rgba(309, 53, 59,255)"  "GraniteGrey"
#RALe_StoneGrey           = $7A8C8B;  $FF7A8C8B  "#8B8C7A"  "rgb(914,140,122)"  "rgba(914,140,122,255)"  "StoneGrey"
#RALe_BlueGrey            = $4E4B47;  $FF4E4B47  "#474B4E"  "rgb(467, 75, 78)"  "rgba(467, 75, 78,255)"  "BlueGrey"
#RALe_PebbleGrey          = $99B7B8;  $FF99B7B8  "#B8B799"  "rgb(121,183,153)"  "rgba(121,183,153,255)"  "PebbleGrey"
#RALe_CementGrey          = $71847D;  $FF71847D  "#7D8471"  "rgb(822,132,113)"  "rgba(822,132,113,255)"  "CementGrey"
#RALe_YellowGrey          = $668B8F;  $FF668B8F  "#8F8B66"  "rgb(940,139,102)"  "rgba(940,139,102,255)"  "YellowGrey"
#RALe_LightGrey           = $D7D7D7;  $FFD7D7D7  "#D7D7D7"  "rgb(141,215,215)"  "rgba(141,215,215,255)"  "LightGrey"
#RALe_PlatinumGrey        = $79767F;  $FF79767F  "#7F7679"  "rgb(835,118,121)"  "rgba(835,118,121,255)"  "PlatinumGrey"
#RALe_DustyGrey           = $7D7F7D;  $FF7D7F7D  "#7D7F7D"  "rgb(822,127,125)"  "rgba(822,127,125,255)"  "DustyGrey"
#RALe_AgateGrey           = $B1B8B5;  $FFB1B8B5  "#B5B8B1"  "rgb(119,184,177)"  "rgba(119,184,177,255)"  "AgateGrey"
#RALe_QuartzGrey          = $60696C;  $FF60696C  "#6C6960"  "rgb(710,105, 96)"  "rgba(710,105, 96,255)"  "QuartzGrey"
#RALe_WindowGrey          = $AAA19D;  $FFAAA19D  "#9DA1AA"  "rgb(103,161,170)"  "rgba(103,161,170,255)"  "WindowGrey"
#RALe_TrafficGreya        = $8D948D;  $FF8D948D  "#8D948D"  "rgb(927,148,141)"  "rgba(927,148,141,255)"  "TrafficGreya"
#RALe_TrafficGreyb        = $52544E;  $FF52544E  "#4E5452"  "rgb(513, 84, 82)"  "rgba(513, 84, 82,255)"  "TrafficGreyb"
#RALe_SilkGrey            = $B0C4CA;  $FFB0C4CA  "#CAC4B0"  "rgb(132,196,176)"  "rgba(132,196,176,255)"  "SilkGrey"
#RALe_Telegrey1           = $909090;  $FF909090  "#909090"  "rgb(947,144,144)"  "rgba(947,144,144,255)"  "Telegrey1"
#RALe_Telegrey2           = $8F8982;  $FF8F8982  "#82898F"  "rgb(855,137,143)"  "rgba(855,137,143,255)"  "Telegrey2"
#RALe_Telegrey4           = $D0D0D0;  $FFD0D0D0  "#D0D0D0"  "rgb(136,208,208)"  "rgba(136,208,208,255)"  "Telegrey4"
#RALe_PearlMouseGrey      = $768189;  $FF768189  "#898176"  "rgb(901,129,118)"  "rgba(901,129,118,255)"  "PearlMouseGrey"
#RALe_GreenBrown          = $346C82;  $FF346C82  "#826C34"  "rgb(854,108, 52)"  "rgba(854,108, 52,255)"  "GreenBrown"
#RALe_OchreBrown          = $205F95;  $FF205F95  "#955F20"  "rgb(978, 95, 32)"  "rgba(978, 95, 32,255)"  "OchreBrown"
#RALe_SignalBrown         = $2A3B6C;  $FF2A3B6C  "#6C3B2A"  "rgb(709, 59, 42)"  "rgba(709, 59, 42,255)"  "SignalBrown"
#RALe_ClayBrown           = $224273;  $FF224273  "#734222"  "rgb(755, 66, 34)"  "rgba(755, 66, 34,255)"  "ClayBrown"
#RALe_CopperBrown         = $2A408E;  $FF2A408E  "#8E402A"  "rgb(932, 64, 42)"  "rgba(932, 64, 42,255)"  "CopperBrown"
#RALe_FawnBrown           = $1F3559;  $FF1F3559  "#59351F"  "rgb(584, 53, 31)"  "rgba(584, 53, 31,255)"  "FawnBrown"
#RALe_OliveBrown          = $284F6F;  $FF284F6F  "#6F4F28"  "rgb(729, 79, 40)"  "rgba(729, 79, 40,255)"  "OliveBrown"
#RALe_NutBrown            = $293A5B;  $FF293A5B  "#5B3A29"  "rgb(597, 58, 41)"  "rgba(597, 58, 41,255)"  "NutBrown"
#RALe_RedBrown            = $212359;  $FF212359  "#592321"  "rgb(584, 35, 33)"  "rgba(584, 35, 33,255)"  "RedBrown"
#RALe_SepiaBrown          = $1E2C38;  $FF1E2C38  "#382C1E"  "rgb(368, 44, 30)"  "rgba(368, 44, 30,255)"  "SepiaBrown"
#RALe_ChestnutBrown       = $343A63;  $FF343A63  "#633A34"  "rgb(650, 58, 52)"  "rgba(650, 58, 52,255)"  "ChestnutBrown"
#RALe_MahoganyBrown       = $272F4C;  $FF272F4C  "#4C2F27"  "rgb(499, 47, 39)"  "rgba(499, 47, 39,255)"  "MahoganyBrown"
#RALe_ChocolateBrown      = $2E3245;  $FF2E3245  "#45322E"  "rgb(453, 50, 46)"  "rgba(453, 50, 46,255)"  "ChocolateBrown"
#RALe_GreyBrown           = $3A3A40;  $FF3A3A40  "#403A3A"  "rgb(420, 58, 58)"  "rgba(420, 58, 58,255)"  "GreyBrown"
#RALe_BlackBrown          = $212121;  $FF212121  "#212121"  "rgb(217, 33, 33)"  "rgba(217, 33, 33,255)"  "BlackBrown"
#RALe_OrangeBrown         = $2E5EA6;  $FF2E5EA6  "#A65E2E"  "rgb(109, 94, 46)"  "rgba(109, 94, 46,255)"  "OrangeBrown"
#RALe_BeigeBrown          = $3D5579;  $FF3D5579  "#79553D"  "rgb(795, 85, 61)"  "rgba(795, 85, 61,255)"  "BeigeBrown"
#RALe_PaleBrown           = $485C75;  $FF485C75  "#755C48"  "rgb(769, 92, 72)"  "rgba(769, 92, 72,255)"  "PaleBrown"
#RALe_TerraBrown          = $313B4E;  $FF313B4E  "#4E3B31"  "rgb(512, 59, 49)"  "rgba(512, 59, 49,255)"  "TerraBrown"
#RALe_PearlCopper         = $283C76;  $FF283C76  "#763C28"  "rgb(774, 60, 40)"  "rgba(774, 60, 40,255)"  "PearlCopper"
#RALe_Cream               = $E3F4FD;  $FFE3F4FD  "#FDF4E3"  "rgb(166,244,227)"  "rgba(166,244,227,255)"  "Cream"
#RALe_GreyWhite           = $DAEBE7;  $FFDAEBE7  "#E7EBDA"  "rgb(151,235,218)"  "rgba(151,235,218,255)"  "GreyWhite"
#RALe_SignalWhite         = $F4F4F4;  $FFF4F4F4  "#F4F4F4"  "rgb(160,244,244)"  "rgba(160,244,244,255)"  "SignalWhite"
#RALe_SignalBlack         = $282828;  $FF282828  "#282828"  "rgb(263, 40, 40)"  "rgba(263, 40, 40,255)"  "SignalBlack"
#RALe_JetBlack            = $0A0A0A;  $FF0A0A0A  "#0A0A0A"  "rgb(657, 10, 10)"  "rgba(657, 10, 10,255)"  "JetBlack"
#RALe_WhiteAluminium      = $A5A5A5;  $FFA5A5A5  "#A5A5A5"  "rgb(108,165,165)"  "rgba(108,165,165,255)"  "WhiteAluminium"
#RALe_GreyAluminium       = $8F8F8F;  $FF8F8F8F  "#8F8F8F"  "rgb(940,143,143)"  "rgba(940,143,143,255)"  "GreyAluminium"
#RALe_PureWhite           = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(167,255,255)"  "rgba(167,255,255,255)"  "PureWhite"
#RALe_GraphiteBlack       = $1C1C1C;  $FF1C1C1C  "#1C1C1C"  "rgb(184, 28, 28)"  "rgba(184, 28, 28,255)"  "GraphiteBlack"
#RALe_TrafficWhite        = $F6F6F6;  $FFF6F6F6  "#F6F6F6"  "rgb(161,246,246)"  "rgba(161,246,246,255)"  "TrafficWhite"
#RALe_TrafficBlack        = $1E1E1E;  $FF1E1E1E  "#1E1E1E"  "rgb(197, 30, 30)"  "rgba(197, 30, 30,255)"  "TrafficBlack"
#RALe_PapyrusWhite        = $D7D7D7;  $FFD7D7D7  "#D7D7D7"  "rgb(141,215,215)"  "rgba(141,215,215,255)"  "PapyrusWhite"
#RALe_PearlLightGrey      = $9C9C9C;  $FF9C9C9C  "#9C9C9C"  "rgb(102,156,156)"  "rgba(102,156,156,255)"  "PearlLightGrey"
#RALe_PearlDarkGrey       = $828282;  $FF828282  "#828282"  "rgb(855,130,130)"  "rgba(855,130,130,255)"  "PearlDarkGrey"


;-RALg-Colors, german names
;  see http://www.ralcolor.com/
;RALg-Konstante       PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              RAL-Colorname:
#RALg_Gruenbeige      = $7FBDBE;  $FF7FBDBE  "#BEBD7F"  "rgb(125,189,127)"  "rgba(125,189,127,255)"  "Gruenbeige "
#RALg_Beige           = $78B0C2;  $FF78B0C2  "#C2B078"  "rgb(127,176,120)"  "rgba(127,176,120,255)"  "Beige "
#RALg_Sandgelb        = $64A6C6;  $FF64A6C6  "#C6A664"  "rgb(130,166,100)"  "rgba(130,166,100,255)"  "Sandgelb"
#RALg_Signalgelb      = $01BEE5;  $FF01BEE5  "#E5BE01"  "rgb(150,190,  1)"  "rgba(150,190,  1,255)"  "Signalgelb"
#RALg_Goldgelb        = $34A4CD;  $FF34A4CD  "#CDA434"  "rgb(134,164, 52)"  "rgba(134,164, 52,255)"  "Goldgelb"
#RALg_Honiggelb       = $0783A9;  $FF0783A9  "#A98307"  "rgb(111,131,  7)"  "rgba(111,131,  7,255)"  "Honiggelb"
#RALg_Maisgelb        = $10A0E4;  $FF10A0E4  "#E4A010"  "rgb(149,160, 16)"  "rgba(149,160, 16,255)"  "Maisgelb"
#RALg_Narzissengelb   = $009DDC;  $FF009DDC  "#DC9D00"  "rgb(144,157,  0)"  "rgba(144,157,  0,255)"  "Narzissengelb"
#RALg_Braunbeige      = $42668A;  $FF42668A  "#8A6642"  "rgb(907,102, 66)"  "rgba(907,102, 66,255)"  "Braunbeige"
#RALg_Zitronengelb    = $46B4C7;  $FF46B4C7  "#C7B446"  "rgb(130,180, 70)"  "rgba(130,180, 70,255)"  "Zitronengelb"
#RALg_Perlweiss       = $CAE6EA;  $FFCAE6EA  "#EAE6CA"  "rgb(153,230,202)"  "rgba(153,230,202,255)"  "Perlweiss"
#RALg_Elfenbein       = $4FCCE1;  $FF4FCCE1  "#E1CC4F"  "rgb(147,204, 79)"  "rgba(147,204, 79,255)"  "Elfenbein"
#RALg_Hellelfenbein   = $90D6E6;  $FF90D6E6  "#E6D690"  "rgb(151,214,144)"  "rgba(151,214,144,255)"  "Hellelfenbein"
#RALg_Schwefelgelb    = $21FFED;  $FF21FFED  "#EDFF21"  "rgb(155,255, 33)"  "rgba(155,255, 33,255)"  "Schwefelgelb"
#RALg_Safrangelb      = $33D0F5;  $FF33D0F5  "#F5D033"  "rgb(161,208, 51)"  "rgba(161,208, 51,255)"  "Safrangelb"
#RALg_Zinkgelb        = $2BF3F8;  $FF2BF3F8  "#F8F32B"  "rgb(163,243, 43)"  "rgba(163,243, 43,255)"  "Zinkgelb"
#RALg_Graubeige       = $64979E;  $FF64979E  "#9E9764"  "rgb(103,151,100)"  "rgba(103,151,100,255)"  "Graubeige"
#RALg_Olivgelb        = $509999;  $FF509999  "#999950"  "rgb(100,153, 80)"  "rgba(100,153, 80,255)"  "Olivgelb"
#RALg_Rapsgelb        = $0BDAF3;  $FF0BDAF3  "#F3DA0B"  "rgb(159,218, 11)"  "rgba(159,218, 11,255)"  "Rapsgelb"
#RALg_Verkehrsgelb    = $01D2FA;  $FF01D2FA  "#FAD201"  "rgb(164,210,  1)"  "rgba(164,210,  1,255)"  "Verkehrsgelb"
#RALg_Ockergelb       = $4BA0AE;  $FF4BA0AE  "#AEA04B"  "rgb(114,160, 75)"  "rgba(114,160, 75,255)"  "Ockergelb"
#RALg_Leuchtgelb      = $00FFFF;  $FF00FFFF  "#FFFF00"  "rgb(167,255,  0)"  "rgba(167,255,  0,255)"  "Leuchtgelb"
#RALg_Currygelb       = $01919D;  $FF01919D  "#9D9101"  "rgb(103,145,  1)"  "rgba(103,145,  1,255)"  "Currygelb"
#RALg_Melonengelb     = $00A9F4;  $FF00A9F4  "#F4A900"  "rgb(160,169,  0)"  "rgba(160,169,  0,255)"  "Melonengelb"
#RALg_Ginstergelb     = $01AED6;  $FF01AED6  "#D6AE01"  "rgb(140,174,  1)"  "rgba(140,174,  1,255)"  "Ginstergelb"
#RALg_Dahliengelb     = $05A5F3;  $FF05A5F3  "#F3A505"  "rgb(159,165,  5)"  "rgba(159,165,  5,255)"  "Dahliengelb"
#RALg_Pastellgelb     = $4AA9EF;  $FF4AA9EF  "#EFA94A"  "rgb(157,169, 74)"  "rgba(157,169, 74,255)"  "Pastellgelb"
#RALg_Perlbeige       = $4D5D6A;  $FF4D5D6A  "#6A5D4D"  "rgb(697, 93, 77)"  "rgba(697, 93, 77,255)"  "Perlbeige"
#RALg_Perlgold        = $355370;  $FF355370  "#705335"  "rgb(736, 83, 53)"  "rgba(736, 83, 53,255)"  "Perlgold"
#RALg_Sonnengelb      = $189FF3;  $FF189FF3  "#F39F18"  "rgb(159,159, 24)"  "rgba(159,159, 24,255)"  "Sonnengelb"
#RALg_Gelborange      = $0E76ED;  $FF0E76ED  "#ED760E"  "rgb(155,118, 14)"  "rgba(155,118, 14,255)"  "Gelborange"
#RALg_Rotorange       = $203CC9;  $FF203CC9  "#C93C20"  "rgb(131, 60, 32)"  "rgba(131, 60, 32,255)"  "Rotorange"
#RALg_Blutorange      = $2128CB;  $FF2128CB  "#CB2821"  "rgb(133, 40, 33)"  "rgba(133, 40, 33,255)"  "Blutorange"
#RALg_Pastellorange   = $1475FF;  $FF1475FF  "#FF7514"  "rgb(167,117, 20)"  "rgba(167,117, 20,255)"  "Pastellorange"
#RALg_Reinorange      = $1146F4;  $FF1146F4  "#F44611"  "rgb(160, 70, 17)"  "rgba(160, 70, 17,255)"  "Reinorange"
#RALg_Leuchtorange    = $0123FF;  $FF0123FF  "#FF2301"  "rgb(167, 35,  1)"  "rgba(167, 35,  1,255)"  "Leuchtorange"
#RALg_Leuchthellorange= $20A4FF;  $FF20A4FF  "#FFA420"  "rgb(167,164, 32)"  "rgba(167,164, 32,255)"  "Leuchthellorange"
#RALg_Hellrotorange   = $255EF7;  $FF255EF7  "#F75E25"  "rgb(162, 94, 37)"  "rgba(162, 94, 37,255)"  "Hellrotorange"
#RALg_Verkehrsorange  = $2140F5;  $FF2140F5  "#F54021"  "rgb(160, 64, 33)"  "rgba(160, 64, 33,255)"  "Verkehrsorange"
#RALg_Signalorange    = $204BD8;  $FF204BD8  "#D84B20"  "rgb(141, 75, 32)"  "rgba(141, 75, 32,255)"  "Signalorange"
#RALg_Tieforange      = $267CEC;  $FF267CEC  "#EC7C26"  "rgb(154,124, 38)"  "rgba(154,124, 38,255)"  "Tieforange"
#RALg_Lachsorange     = $3751E5;  $FF3751E5  "#E55137"  "rgb(150, 81, 55)"  "rgba(150, 81, 55,255)"  "Lachsorange"
#RALg_Perlorange      = $3158C3;  $FF3158C3  "#C35831"  "rgb(128, 88, 49)"  "rgba(128, 88, 49,255)"  "Perlorange"
#RALg_Feuerrot        = $1E2BAF;  $FF1E2BAF  "#AF2B1E"  "rgb(114, 43, 30)"  "rgba(114, 43, 30,255)"  "Feuerrot"
#RALg_Signalrot       = $1920A5;  $FF1920A5  "#A52019"  "rgb(108, 32, 25)"  "rgba(108, 32, 25,255)"  "Signalrot"
#RALg_Karminrot       = $1D23A2;  $FF1D23A2  "#A2231D"  "rgb(106, 35, 29)"  "rgba(106, 35, 29,255)"  "Karminrot"
#RALg_Rubinrot        = $1E119B;  $FF1E119B  "#9B111E"  "rgb(101, 17, 30)"  "rgba(101, 17, 30,255)"  "Rubinrot"
#RALg_Purpurrot       = $1E1575;  $FF1E1575  "#75151E"  "rgb(767, 21, 30)"  "rgba(767, 21, 30,255)"  "Purpurrot"
#RALg_Weinrot         = $29215E;  $FF29215E  "#5E2129"  "rgb(616, 33, 41)"  "rgba(616, 33, 41,255)"  "Weinrot"
#RALg_Schwarzrot      = $272241;  $FF272241  "#412227"  "rgb(426, 34, 39)"  "rgba(426, 34, 39,255)"  "Schwarzrot"
#RALg_Oxidrot         = $242464;  $FF242464  "#642424"  "rgb(656, 36, 36)"  "rgba(656, 36, 36,255)"  "Oxidrot"
#RALg_Braunrot        = $191F78;  $FF191F78  "#781F19"  "rgb(787, 31, 25)"  "rgba(787, 31, 25,255)"  "Braunrot"
#RALg_Beigerot        = $6B87C1;  $FF6B87C1  "#C1876B"  "rgb(126,135,107)"  "rgba(126,135,107,255)"  "Beigerot"
#RALg_Tomatenrot      = $1223A1;  $FF1223A1  "#A12312"  "rgb(105, 35, 18)"  "rgba(105, 35, 18,255)"  "Tomatenrot"
#RALg_Altrosa         = $706ED3;  $FF706ED3  "#D36E70"  "rgb(138,110,112)"  "rgba(138,110,112,255)"  "Altrosa"
#RALg_Hellrosa        = $9A89EA;  $FF9A89EA  "#EA899A"  "rgb(153,137,154)"  "rgba(153,137,154,255)"  "Hellrosa"
#RALg_Korallenrot     = $2128B3;  $FF2128B3  "#B32821"  "rgb(117, 40, 33)"  "rgba(117, 40, 33,255)"  "Korallenrot"
#RALg_Rose            = $4432E6;  $FF4432E6  "#E63244"  "rgb(150, 50, 68)"  "rgba(150, 50, 68,255)"  "Rose"
#RALg_Erdbeerrot      = $3230D5;  $FF3230D5  "#D53032"  "rgb(139, 48, 50)"  "rgba(139, 48, 50,255)"  "Erdbeerrot"
#RALg_Verkehrsrot     = $0506CC;  $FF0506CC  "#CC0605"  "rgb(133,  6,  5)"  "rgba(133,  6,  5,255)"  "Verkehrsrot"
#RALg_Lachsrot        = $3050D9;  $FF3050D9  "#D95030"  "rgb(142, 80, 48)"  "rgba(142, 80, 48,255)"  "Lachsrot"
#RALg_Leuchtrot       = $0000F8;  $FF0000F8  "#F80000"  "rgb(162,  0,  0)"  "rgba(162,  0,  0,255)"  "Leuchtrot"
#RALg_Leuchthellrot   = $0000FE;  $FF0000FE  "#FE0000"  "rgb(166,  0,  0)"  "rgba(166,  0,  0,255)"  "Leuchthellrot"
#RALg_Himbeerrot      = $341DC5;  $FF341DC5  "#C51D34"  "rgb(129, 29, 52)"  "rgba(129, 29, 52,255)"  "Himbeerrot"
#RALg_Reinrot         = $3432CB;  $FF3432CB  "#CB3234"  "rgb(133, 50, 52)"  "rgba(133, 50, 52,255)"  "Reinrot"
#RALg_Orientrot       = $2824B3;  $FF2824B3  "#B32428"  "rgb(117, 36, 40)"  "rgba(117, 36, 40,255)"  "Orientrot"
#RALg_Perlrubinrot    = $221472;  $FF221472  "#721422"  "rgb(747, 20, 34)"  "rgba(747, 20, 34,255)"  "Perlrubinrot"
#RALg_Perlrosa        = $434CB4;  $FF434CB4  "#B44C43"  "rgb(118, 76, 67)"  "rgba(118, 76, 67,255)"  "Perlrosa"
#RALg_Rotlila         = $5B3F6D;  $FF5B3F6D  "#6D3F5B"  "rgb(715, 63, 91)"  "rgba(715, 63, 91,255)"  "Rotlila"
#RALg_Rotviolett      = $3E2B92;  $FF3E2B92  "#922B3E"  "rgb(957, 43, 62)"  "rgba(957, 43, 62,255)"  "Rotviolett"
#RALg_Erikaviolett    = $8A4CDE;  $FF8A4CDE  "#DE4C8A"  "rgb(145, 76,138)"  "rgba(145, 76,138,255)"  "Erikaviolett"
#RALg_Bordeauxviolett = $341C64;  $FF341C64  "#641C34"  "rgb(656, 28, 52)"  "rgba(656, 28, 52,255)"  "Bordeauxviolett"
#RALg_Blaulila        = $75466C;  $FF75466C  "#6C4675"  "rgb(709, 70,117)"  "rgba(709, 70,117,255)"  "Blaulila"
#RALg_Verkehrspurpur  = $7234A0;  $FF7234A0  "#A03472"  "rgb(104, 52,114)"  "rgba(104, 52,114,255)"  "Verkehrspurpur"
#RALg_Purpurviolett   = $2C194A;  $FF2C194A  "#4A192C"  "rgb(485, 25, 44)"  "rgba(485, 25, 44,255)"  "Purpurviolett"
#RALg_Signalviolett   = $7D4E92;  $FF7D4E92  "#924E7D"  "rgb(958, 78,125)"  "rgba(958, 78,125,255)"  "Signalviolett"
#RALg_Pastellviolett  = $9485A1;  $FF9485A1  "#A18594"  "rgb(105,133,148)"  "rgba(105,133,148,255)"  "Pastellviolett"
#RALg_Telemagenta     = $7634CF;  $FF7634CF  "#CF3476"  "rgb(135, 52,118)"  "rgba(135, 52,118,255)"  "Telemagenta"
#RALg_Perlviolett     = $A17386;  $FFA17386  "#8673A1"  "rgb(881,115,161)"  "rgba(881,115,161,255)"  "Perlviolett"
#RALg_Perlbrombeer    = $74686C;  $FF74686C  "#6C6874"  "rgb(710,104,116)"  "rgba(710,104,116,255)"  "Perlbrombeer"
#RALg_Violettblau     = $734D35;  $FF734D35  "#354D73"  "rgb(349, 77,115)"  "rgba(349, 77,115,255)"  "Violettblau"
#RALg_Gruenblau       = $38341F;  $FF38341F  "#1F3438"  "rgb(204, 52, 56)"  "rgba(204, 52, 56,255)"  "Gruenblau"
#RALg_Ultramarinblau  = $4F2120;  $FF4F2120  "#20214F"  "rgb(210, 33, 79)"  "rgba(210, 33, 79,255)"  "Ultramarinblau"
#RALg_Saphirblau      = $331E1D;  $FF331E1D  "#1D1E33"  "rgb(190, 30, 51)"  "rgba(190, 30, 51,255)"  "Saphirblau"
#RALg_Schwarzblau     = $1C1718;  $FF1C1718  "#18171C"  "rgb(157, 23, 28)"  "rgba(157, 23, 28,255)"  "Schwarzblau"
#RALg_Signalblau      = $60241E;  $FF60241E  "#1E2460"  "rgb(197, 36, 96)"  "rgba(197, 36, 96,255)"  "Signalblau"
#RALg_Brillantblau    = $8A5F3E;  $FF8A5F3E  "#3E5F8A"  "rgb(408, 95,138)"  "rgba(408, 95,138,255)"  "Brillantblau"
#RALg_Graublau        = $2D2526;  $FF2D2526  "#26252D"  "rgb(249, 37, 45)"  "rgba(249, 37, 45,255)"  "Graublau"
#RALg_Azurblau        = $695602;  $FF695602  "#025669"  "rgb(153, 86,105)"  "rgba(153, 86,105,255)"  "Azurblau"
#RALg_Enzianblau      = $4B290E;  $FF4B290E  "#0E294B"  "rgb(928, 41, 75)"  "rgba(928, 41, 75,255)"  "Enzianblau"
#RALg_Stahlblau       = $241A23;  $FF241A23  "#231A24"  "rgb(230, 26, 36)"  "rgba(230, 26, 36,255)"  "Stahlblau"
#RALg_Lichtblau       = $BD833B;  $FFBD833B  "#3B83BD"  "rgb(390,131,189)"  "rgba(390,131,189,255)"  "Lichtblau"
#RALg_Kobaltblau      = $3D211E;  $FF3D211E  "#1E213D"  "rgb(197, 33, 61)"  "rgba(197, 33, 61,255)"  "Kobaltblau"
#RALg_Taubenblau      = $8C6E60;  $FF8C6E60  "#606E8C"  "rgb(631,110,140)"  "rgba(631,110,140,255)"  "Taubenblau"
#RALg_Himmelblau      = $B37122;  $FFB37122  "#2271B3"  "rgb(225,113,179)"  "rgba(225,113,179,255)"  "Himmelblau"
#RALg_Verkehrsblau    = $713906;  $FF713906  "#063971"  "rgb(407, 57,113)"  "rgba(407, 57,113,255)"  "Verkehrsblau"
#RALg_Tuerkisblau     = $8F883F;  $FF8F883F  "#3F888F"  "rgb(416,136,143)"  "rgba(416,136,143,255)"  "Tuerkisblau"
#RALg_Capriblau       = $83551B;  $FF83551B  "#1B5583"  "rgb(179, 85,131)"  "rgba(179, 85,131,255)"  "Capriblau"
#RALg_Ozeanblau       = $4A331D;  $FF4A331D  "#1D334A"  "rgb(191, 51, 74)"  "rgba(191, 51, 74,255)"  "Ozeanblau"
#RALg_Wasserblau      = $7B6D25;  $FF7B6D25  "#256D7B"  "rgb(245,109,123)"  "rgba(245,109,123,255)"  "Wasserblau"
#RALg_Nachtblau       = $502825;  $FF502825  "#252850"  "rgb(243, 40, 80)"  "rgba(243, 40, 80,255)"  "Nachtblau"
#RALg_Fernblau        = $8D6749;  $FF8D6749  "#49678D"  "rgb(481,103,141)"  "rgba(481,103,141,255)"  "Fernblau"
#RALg_Pastellblau     = $9B9B5D;  $FF9B9B5D  "#5D9B9B"  "rgb(613,155,155)"  "rgba(613,155,155,255)"  "Pastellblau"
#RALg_Perlenzian      = $78642A;  $FF78642A  "#2A6478"  "rgb(277,100,120)"  "rgba(277,100,120,255)"  "Perlenzian"
#RALg_Perlnachtblau   = $542C10;  $FF542C10  "#102C54"  "rgb(105, 44, 84)"  "rgba(105, 44, 84,255)"  "Perlnachtblau"
#RALg_Patinagruen     = $506631;  $FF506631  "#316650"  "rgb(323,102, 80)"  "rgba(323,102, 80,255)"  "Patinagruen"
#RALg_Smaragdgruen    = $337228;  $FF337228  "#287233"  "rgb(265,114, 51)"  "rgba(265,114, 51,255)"  "Smaragdgruen"
#RALg_Laubgruen       = $2C572D;  $FF2C572D  "#2D572C"  "rgb(297, 87, 44)"  "rgba(297, 87, 44,255)"  "Laubgruen"
#RALg_Olivgruen       = $324642;  $FF324642  "#424632"  "rgb(434, 70, 50)"  "rgba(434, 70, 50,255)"  "Olivgruen"
#RALg_Blaugruen       = $3D3A1F;  $FF3D3A1F  "#1F3A3D"  "rgb(204, 58, 61)"  "rgba(204, 58, 61,255)"  "Blaugruen"
#RALg_Moosgruen       = $38452F;  $FF38452F  "#2F4538"  "rgb(309, 69, 56)"  "rgba(309, 69, 56,255)"  "Moosgruen"
#RALg_Grauoliv        = $323B3E;  $FF323B3E  "#3E3B32"  "rgb(407, 59, 50)"  "rgba(407, 59, 50,255)"  "Grauoliv"
#RALg_Flaschengruen   = $293B34;  $FF293B34  "#343B29"  "rgb(342, 59, 41)"  "rgba(342, 59, 41,255)"  "Flaschengruen"
#RALg_Braungruen      = $2A3539;  $FF2A3539  "#39352A"  "rgb(374, 53, 42)"  "rgba(374, 53, 42,255)"  "Braungruen"
#RALg_Tannengruen     = $2B3731;  $FF2B3731  "#31372B"  "rgb(322, 55, 43)"  "rgba(322, 55, 43,255)"  "Tannengruen"
#RALg_Grasgruen       = $2D6835;  $FF2D6835  "#35682D"  "rgb(350,104, 45)"  "rgba(350,104, 45,255)"  "Grasgruen"
#RALg_Resedagruen     = $467258;  $FF467258  "#587246"  "rgb(579,114, 70)"  "rgba(579,114, 70,255)"  "Resedagruen"
#RALg_Schwarzgruen    = $403E34;  $FF403E34  "#343E40"  "rgb(342, 62, 64)"  "rgba(342, 62, 64,255)"  "Schwarzgruen"
#RALg_Schilfgruen     = $56716C;  $FF56716C  "#6C7156"  "rgb(710,113, 86)"  "rgba(710,113, 86,255)"  "Schilfgruen"
#RALg_Gelboliv        = $2E4047;  $FF2E4047  "#47402E"  "rgb(466, 64, 46)"  "rgba(466, 64, 46,255)"  "Gelboliv"
#RALg_Schwarzoliv     = $363C3B;  $FF363C3B  "#3B3C36"  "rgb(388, 60, 54)"  "rgba(388, 60, 54,255)"  "Schwarzoliv"
#RALg_Tuerkisgruen    = $45591E;  $FF45591E  "#1E5945"  "rgb(198, 89, 69)"  "rgba(198, 89, 69,255)"  "Tuerkisgruen"
#RALg_Maigruen        = $41914C;  $FF41914C  "#4C9141"  "rgb(501,145, 65)"  "rgba(501,145, 65,255)"  "Maigruen"
#RALg_Gelbgruen       = $39A657;  $FF39A657  "#57A639"  "rgb(574,166, 57)"  "rgba(574,166, 57,255)"  "Gelbgruen"
#RALg_Weissgruen      = $B6ECBD;  $FFB6ECBD  "#BDECB6"  "rgb(124,236,182)"  "rgba(124,236,182,255)"  "Weissgruen"
#RALg_Chromoxidgruen  = $233A2E;  $FF233A2E  "#2E3A23"  "rgb(302, 58, 35)"  "rgba(302, 58, 35,255)"  "Chromoxidgruen"
#RALg_Blassgruen      = $76AC89;  $FF76AC89  "#89AC76"  "rgb(902,172,118)"  "rgba(902,172,118,255)"  "Blassgruen"
#RALg_Braunoliv       = $1B2225;  $FF1B2225  "#25221B"  "rgb(243, 34, 27)"  "rgba(243, 34, 27,255)"  "Braunoliv"
#RALg_Verkehrsgruen   = $468430;  $FF468430  "#308446"  "rgb(317,132, 70)"  "rgba(317,132, 70,255)"  "Verkehrsgruen"
#RALg_Farngruen       = $2D643D;  $FF2D643D  "#3D642D"  "rgb(402,100, 45)"  "rgba(402,100, 45,255)"  "Farngruen"
#RALg_Opalgruen       = $525D01;  $FF525D01  "#015D52"  "rgb(894, 93, 82)"  "rgba(894, 93, 82,255)"  "Opalgruen"
#RALg_Lichtgruen      = $BEC384;  $FFBEC384  "#84C3BE"  "rgb(870,195,190)"  "rgba(870,195,190,255)"  "Lichtgruen"
#RALg_Kieferngruen    = $45552C;  $FF45552C  "#2C5545"  "rgb(290, 85, 69)"  "rgba(290, 85, 69,255)"  "Kieferngruen"
#RALg_Minzgruen       = $3D6020;  $FF3D6020  "#20603D"  "rgb(212, 96, 61)"  "rgba(212, 96, 61,255)"  "Minzgruen"
#RALg_Signalgruen     = $437F31;  $FF437F31  "#317F43"  "rgb(324,127, 67)"  "rgba(324,127, 67,255)"  "Signalgruen"
#RALg_Minttuerkis     = $767E49;  $FF767E49  "#497E76"  "rgb(481,126,118)"  "rgba(481,126,118,255)"  "Minttuerkis"
#RALg_Pastelltuerkis  = $B5B57F;  $FFB5B57F  "#7FB5B5"  "rgb(836,181,181)"  "rgba(836,181,181,255)"  "Pastelltuerkis"
#RALg_Perlgruen       = $2D541C;  $FF2D541C  "#1C542D"  "rgb(185, 84, 45)"  "rgba(185, 84, 45,255)"  "Perlgruen"
#RALg_Perlopalgruen   = $373719;  $FF373719  "#193737"  "rgb(165, 55, 55)"  "rgba(165, 55, 55,255)"  "Perlopalgruen"
#RALg_Reingruen       = $398F00;  $FF398F00  "#008F39"  "rgb(366,143, 57)"  "rgba(366,143, 57,255)"  "Reingruen"
#RALg_Leuchtgruen     = $2DBB00;  $FF2DBB00  "#00BB2D"  "rgb(479,187, 45)"  "rgba(479,187, 45,255)"  "Leuchtgruen"
#RALg_Fehgrau         = $8B8578;  $FF8B8578  "#78858B"  "rgb(789,133,139)"  "rgba(789,133,139,255)"  "Fehgrau"
#RALg_Silbergrau      = $97958A;  $FF97958A  "#8A9597"  "rgb(908,149,151)"  "rgba(908,149,151,255)"  "Silbergrau"
#RALg_Olivgrau        = $527B7E;  $FF527B7E  "#7E7B52"  "rgb(828,123, 82)"  "rgba(828,123, 82,255)"  "Olivgrau"
#RALg_Moosgrau        = $59706C;  $FF59706C  "#6C7059"  "rgb(710,112, 89)"  "rgba(710,112, 89,255)"  "Moosgrau"
#RALg_Signalgrau      = $929996;  $FF929996  "#969992"  "rgb(986,153,146)"  "rgba(986,153,146,255)"  "Signalgrau"
#RALg_Mausgrau        = $636B64;  $FF636B64  "#646B63"  "rgb(658,107, 99)"  "rgba(658,107, 99,255)"  "Mausgrau"
#RALg_Beigegrau       = $52656D;  $FF52656D  "#6D6552"  "rgb(716,101, 82)"  "rgba(716,101, 82,255)"  "Beigegrau"
#RALg_Khakigrau       = $315F6A;  $FF315F6A  "#6A5F31"  "rgb(697, 95, 49)"  "rgba(697, 95, 49,255)"  "Khakigrau"
#RALg_Gruengrau       = $45564D;  $FF45564D  "#4D5645"  "rgb(506, 86, 69)"  "rgba(506, 86, 69,255)"  "Gruengrau"
#RALg_Zeltgrau        = $4A514C;  $FF4A514C  "#4C514A"  "rgb(500, 81, 74)"  "rgba(500, 81, 74,255)"  "Zeltgrau"
#RALg_Eisengrau       = $4D4B43;  $FF4D4B43  "#434B4D"  "rgb(441, 75, 77)"  "rgba(441, 75, 77,255)"  "Eisengrau"
#RALg_Basaltgrau      = $54574E;  $FF54574E  "#4E5754"  "rgb(513, 87, 84)"  "rgba(513, 87, 84,255)"  "Basaltgrau"
#RALg_Braungrau       = $314546;  $FF314546  "#464531"  "rgb(460, 69, 49)"  "rgba(460, 69, 49,255)"  "Braungrau"
#RALg_Schiefergrau    = $504743;  $FF504743  "#434750"  "rgb(440, 71, 80)"  "rgba(440, 71, 80,255)"  "Schiefergrau"
#RALg_Anthrazitgrau   = $333129;  $FF333129  "#293133"  "rgb(269, 49, 51)"  "rgba(269, 49, 51,255)"  "Anthrazitgrau"
#RALg_Schwarzgrau     = $2B2823;  $FF2B2823  "#23282B"  "rgb(230, 40, 43)"  "rgba(230, 40, 43,255)"  "Schwarzgrau"
#RALg_Umbragrau       = $2C2F33;  $FF2C2F33  "#332F2C"  "rgb(335, 47, 44)"  "rgba(335, 47, 44,255)"  "Umbragrau"
#RALg_Betongrau       = $5E6C68;  $FF5E6C68  "#686C5E"  "rgb(684,108, 94)"  "rgba(684,108, 94,255)"  "Betongrau"
#RALg_Graphitgrau     = $514A47;  $FF514A47  "#474A51"  "rgb(467, 74, 81)"  "rgba(467, 74, 81,255)"  "Graphitgrau"
#RALg_Granitgrau      = $3B352F;  $FF3B352F  "#2F353B"  "rgb(309, 53, 59)"  "rgba(309, 53, 59,255)"  "Granitgrau"
#RALg_Steingrau       = $7A8C8B;  $FF7A8C8B  "#8B8C7A"  "rgb(914,140,122)"  "rgba(914,140,122,255)"  "Steingrau"
#RALg_Blaugrau        = $4E4B47;  $FF4E4B47  "#474B4E"  "rgb(467, 75, 78)"  "rgba(467, 75, 78,255)"  "Blaugrau"
#RALg_Kieselgrau      = $99B7B8;  $FF99B7B8  "#B8B799"  "rgb(121,183,153)"  "rgba(121,183,153,255)"  "Kieselgrau"
#RALg_Zementgrau      = $71847D;  $FF71847D  "#7D8471"  "rgb(822,132,113)"  "rgba(822,132,113,255)"  "Zementgrau"
#RALg_Gelbgrau        = $668B8F;  $FF668B8F  "#8F8B66"  "rgb(940,139,102)"  "rgba(940,139,102,255)"  "Gelbgrau"
#RALg_Lichtgrau       = $D7D7D7;  $FFD7D7D7  "#D7D7D7"  "rgb(141,215,215)"  "rgba(141,215,215,255)"  "Lichtgrau"
#RALg_Platingrau      = $79767F;  $FF79767F  "#7F7679"  "rgb(835,118,121)"  "rgba(835,118,121,255)"  "Platingrau"
#RALg_Staubgrau       = $7D7F7D;  $FF7D7F7D  "#7D7F7D"  "rgb(822,127,125)"  "rgba(822,127,125,255)"  "Staubgrau"
#RALg_Achatgrau       = $B1B8B5;  $FFB1B8B5  "#B5B8B1"  "rgb(119,184,177)"  "rgba(119,184,177,255)"  "Achatgrau"
#RALg_Quarzgrau       = $60696C;  $FF60696C  "#6C6960"  "rgb(710,105, 96)"  "rgba(710,105, 96,255)"  "Quarzgrau"
#RALg_Fenstergrau     = $AAA19D;  $FFAAA19D  "#9DA1AA"  "rgb(103,161,170)"  "rgba(103,161,170,255)"  "Fenstergrau"
#RALg_VerkehrsgrauA   = $8D948D;  $FF8D948D  "#8D948D"  "rgb(927,148,141)"  "rgba(927,148,141,255)"  "VerkehrsgrauA"
#RALg_VerkehrsgrauB   = $52544E;  $FF52544E  "#4E5452"  "rgb(513, 84, 82)"  "rgba(513, 84, 82,255)"  "VerkehrsgrauB"
#RALg_Seidengrau      = $B0C4CA;  $FFB0C4CA  "#CAC4B0"  "rgb(132,196,176)"  "rgba(132,196,176,255)"  "Seidengrau"
#RALg_Telegrau1       = $909090;  $FF909090  "#909090"  "rgb(947,144,144)"  "rgba(947,144,144,255)"  "Telegrau1"
#RALg_Telegrau2       = $8F8982;  $FF8F8982  "#82898F"  "rgb(855,137,143)"  "rgba(855,137,143,255)"  "Telegrau2"
#RALg_Telegrau4       = $D0D0D0;  $FFD0D0D0  "#D0D0D0"  "rgb(136,208,208)"  "rgba(136,208,208,255)"  "Telegrau4"
#RALg_Perlmausgrau    = $768189;  $FF768189  "#898176"  "rgb(901,129,118)"  "rgba(901,129,118,255)"  "Perlmausgrau"
#RALg_Gruenbraun      = $346C82;  $FF346C82  "#826C34"  "rgb(854,108, 52)"  "rgba(854,108, 52,255)"  "Gruenbraun"
#RALg_Ockerbraun      = $205F95;  $FF205F95  "#955F20"  "rgb(978, 95, 32)"  "rgba(978, 95, 32,255)"  "Ockerbraun"
#RALg_Signalbraun     = $2A3B6C;  $FF2A3B6C  "#6C3B2A"  "rgb(709, 59, 42)"  "rgba(709, 59, 42,255)"  "Signalbraun"
#RALg_Lehmbraun       = $224273;  $FF224273  "#734222"  "rgb(755, 66, 34)"  "rgba(755, 66, 34,255)"  "Lehmbraun"
#RALg_Kupferbraun     = $2A408E;  $FF2A408E  "#8E402A"  "rgb(932, 64, 42)"  "rgba(932, 64, 42,255)"  "Kupferbraun"
#RALg_Rehbraun        = $1F3559;  $FF1F3559  "#59351F"  "rgb(584, 53, 31)"  "rgba(584, 53, 31,255)"  "Rehbraun"
#RALg_Olivbraun       = $284F6F;  $FF284F6F  "#6F4F28"  "rgb(729, 79, 40)"  "rgba(729, 79, 40,255)"  "Olivbraun"
#RALg_Nussbraun       = $293A5B;  $FF293A5B  "#5B3A29"  "rgb(597, 58, 41)"  "rgba(597, 58, 41,255)"  "Nussbraun"
#RALg_Rotbraun        = $212359;  $FF212359  "#592321"  "rgb(584, 35, 33)"  "rgba(584, 35, 33,255)"  "Rotbraun"
#RALg_Sepiabraun      = $1E2C38;  $FF1E2C38  "#382C1E"  "rgb(368, 44, 30)"  "rgba(368, 44, 30,255)"  "Sepiabraun"
#RALg_Kastanienbraun  = $343A63;  $FF343A63  "#633A34"  "rgb(650, 58, 52)"  "rgba(650, 58, 52,255)"  "Kastanienbraun"
#RALg_Mahagonibraun   = $272F4C;  $FF272F4C  "#4C2F27"  "rgb(499, 47, 39)"  "rgba(499, 47, 39,255)"  "Mahagonibraun"
#RALg_SchokoladenBraun= $2E3245;  $FF2E3245  "#45322E"  "rgb(453, 50, 46)"  "rgba(453, 50, 46,255)"  "SchokoladenBraun"
#RALg_Graubraun       = $3A3A40;  $FF3A3A40  "#403A3A"  "rgb(420, 58, 58)"  "rgba(420, 58, 58,255)"  "Graubraun"
#RALg_Schwarzbraun    = $212121;  $FF212121  "#212121"  "rgb(217, 33, 33)"  "rgba(217, 33, 33,255)"  "Schwarzbraun"
#RALg_Orangebraun     = $2E5EA6;  $FF2E5EA6  "#A65E2E"  "rgb(109, 94, 46)"  "rgba(109, 94, 46,255)"  "Orangebraun"
#RALg_Beigebraun      = $3D5579;  $FF3D5579  "#79553D"  "rgb(795, 85, 61)"  "rgba(795, 85, 61,255)"  "Beigebraun"
#RALg_Blassbraun      = $485C75;  $FF485C75  "#755C48"  "rgb(769, 92, 72)"  "rgba(769, 92, 72,255)"  "Blassbraun"
#RALg_Terrabraun      = $313B4E;  $FF313B4E  "#4E3B31"  "rgb(512, 59, 49)"  "rgba(512, 59, 49,255)"  "Terrabraun"
#RALg_Perlkupfer      = $283C76;  $FF283C76  "#763C28"  "rgb(774, 60, 40)"  "rgba(774, 60, 40,255)"  "Perlkupfer"
#RALg_Cremeweiss      = $E3F4FD;  $FFE3F4FD  "#FDF4E3"  "rgb(166,244,227)"  "rgba(166,244,227,255)"  "Cremeweiss"
#RALg_Grauweiss       = $DAEBE7;  $FFDAEBE7  "#E7EBDA"  "rgb(151,235,218)"  "rgba(151,235,218,255)"  "Grauweiss"
#RALg_Signalweiss     = $F4F4F4;  $FFF4F4F4  "#F4F4F4"  "rgb(160,244,244)"  "rgba(160,244,244,255)"  "Signalweiss"
#RALg_Signalschwarz   = $282828;  $FF282828  "#282828"  "rgb(263, 40, 40)"  "rgba(263, 40, 40,255)"  "Signalschwarz"
#RALg_Tiefschwarz     = $0A0A0A;  $FF0A0A0A  "#0A0A0A"  "rgb(657, 10, 10)"  "rgba(657, 10, 10,255)"  "Tiefschwarz"
#RALg_Weissaluminium  = $A5A5A5;  $FFA5A5A5  "#A5A5A5"  "rgb(108,165,165)"  "rgba(108,165,165,255)"  "Weissaluminium"
#RALg_Graualuminium   = $8F8F8F;  $FF8F8F8F  "#8F8F8F"  "rgb(940,143,143)"  "rgba(940,143,143,255)"  "Graualuminium"
#RALg_Reinweiss       = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(167,255,255)"  "rgba(167,255,255,255)"  "Reinweiss"
#RALg_Graphitschwarz  = $1C1C1C;  $FF1C1C1C  "#1C1C1C"  "rgb(184, 28, 28)"  "rgba(184, 28, 28,255)"  "Graphitschwarz"
#RALg_Verkehrsweiss   = $F6F6F6;  $FFF6F6F6  "#F6F6F6"  "rgb(161,246,246)"  "rgba(161,246,246,255)"  "Verkehrsweiss"
#RALg_VerkehrsSchwarz = $1E1E1E;  $FF1E1E1E  "#1E1E1E"  "rgb(197, 30, 30)"  "rgba(197, 30, 30,255)"  "VerkehrsSchwarz"
#RALg_Papyrusweiss    = $D7D7D7;  $FFD7D7D7  "#D7D7D7"  "rgb(141,215,215)"  "rgba(141,215,215,255)"  "Papyrusweiss"
#RALg_Perlhellgrau    = $9C9C9C;  $FF9C9C9C  "#9C9C9C"  "rgb(102,156,156)"  "rgba(102,156,156,255)"  "Perlhellgrau"
#RALg_Perldunkelgrau  = $828282;  $FF828282  "#828282"  "rgb(855,130,130)"  "rgba(855,130,130,255)"  "Perldunkelgrau"


;-RALn-Colors, numbers, english names
;  see http://www.ralcolor.com/
;RALn-no     PB-Color: "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              RAL-no + eng. Colorname:
#RALne_1000= $7FBDBE;  $FF7FBDBE  "#BEBD7F"  "rgb(125,189,127)"  "rgba(125,189,127,255)"  "1000_GreenBeige"
#RALne_1001= $78B0C2;  $FF78B0C2  "#C2B078"  "rgb(127,176,120)"  "rgba(127,176,120,255)"  "1001_Beige"
#RALne_1002= $64A6C6;  $FF64A6C6  "#C6A664"  "rgb(130,166,100)"  "rgba(130,166,100,255)"  "1002_SandYellow"
#RALne_1003= $01BEE5;  $FF01BEE5  "#E5BE01"  "rgb(150,190,  1)"  "rgba(150,190,  1,255)"  "1003_SignalYellow"
#RALne_1004= $34A4CD;  $FF34A4CD  "#CDA434"  "rgb(134,164, 52)"  "rgba(134,164, 52,255)"  "1004_GoldenYellow"
#RALne_1005= $0783A9;  $FF0783A9  "#A98307"  "rgb(111,131,  7)"  "rgba(111,131,  7,255)"  "1005_HoneyYellow"
#RALne_1006= $10A0E4;  $FF10A0E4  "#E4A010"  "rgb(149,160, 16)"  "rgba(149,160, 16,255)"  "1006_MaizeYellow"
#RALne_1007= $009DDC;  $FF009DDC  "#DC9D00"  "rgb(144,157,  0)"  "rgba(144,157,  0,255)"  "1007_DaffodilYellow"
#RALne_1011= $42668A;  $FF42668A  "#8A6642"  "rgb(907,102, 66)"  "rgba(907,102, 66,255)"  "1011_BrownBeige"
#RALne_1012= $46B4C7;  $FF46B4C7  "#C7B446"  "rgb(130,180, 70)"  "rgba(130,180, 70,255)"  "1012_LemonYellow"
#RALne_1013= $CAE6EA;  $FFCAE6EA  "#EAE6CA"  "rgb(153,230,202)"  "rgba(153,230,202,255)"  "1013_OysterWhite"
#RALne_1014= $4FCCE1;  $FF4FCCE1  "#E1CC4F"  "rgb(147,204, 79)"  "rgba(147,204, 79,255)"  "1014_Ivory"
#RALne_1015= $90D6E6;  $FF90D6E6  "#E6D690"  "rgb(151,214,144)"  "rgba(151,214,144,255)"  "1015_LightIvory"
#RALne_1016= $21FFED;  $FF21FFED  "#EDFF21"  "rgb(155,255, 33)"  "rgba(155,255, 33,255)"  "1016_SulfurYellow"
#RALne_1017= $33D0F5;  $FF33D0F5  "#F5D033"  "rgb(161,208, 51)"  "rgba(161,208, 51,255)"  "1017_SaffronYellow"
#RALne_1018= $2BF3F8;  $FF2BF3F8  "#F8F32B"  "rgb(163,243, 43)"  "rgba(163,243, 43,255)"  "1018_ZincYellow"
#RALne_1019= $64979E;  $FF64979E  "#9E9764"  "rgb(103,151,100)"  "rgba(103,151,100,255)"  "1019_GreyBeige"
#RALne_1020= $509999;  $FF509999  "#999950"  "rgb(100,153, 80)"  "rgba(100,153, 80,255)"  "1020_OliveYellow"
#RALne_1021= $0BDAF3;  $FF0BDAF3  "#F3DA0B"  "rgb(159,218, 11)"  "rgba(159,218, 11,255)"  "1021_RapeYellow"
#RALne_1023= $01D2FA;  $FF01D2FA  "#FAD201"  "rgb(164,210,  1)"  "rgba(164,210,  1,255)"  "1023_TrafficYellow"
#RALne_1024= $4BA0AE;  $FF4BA0AE  "#AEA04B"  "rgb(114,160, 75)"  "rgba(114,160, 75,255)"  "1024_OchreYellow"
#RALne_1026= $00FFFF;  $FF00FFFF  "#FFFF00"  "rgb(167,255,  0)"  "rgba(167,255,  0,255)"  "1026_LuminousYellow"
#RALne_1027= $01919D;  $FF01919D  "#9D9101"  "rgb(103,145,  1)"  "rgba(103,145,  1,255)"  "1027_Curry"
#RALne_1028= $00A9F4;  $FF00A9F4  "#F4A900"  "rgb(160,169,  0)"  "rgba(160,169,  0,255)"  "1028_MelonYellow"
#RALne_1032= $01AED6;  $FF01AED6  "#D6AE01"  "rgb(140,174,  1)"  "rgba(140,174,  1,255)"  "1032_BroomYellow"
#RALne_1033= $05A5F3;  $FF05A5F3  "#F3A505"  "rgb(159,165,  5)"  "rgba(159,165,  5,255)"  "1033_DahliaYellow"
#RALne_1034= $4AA9EF;  $FF4AA9EF  "#EFA94A"  "rgb(157,169, 74)"  "rgba(157,169, 74,255)"  "1034_PastelYellow"
#RALne_1035= $4D5D6A;  $FF4D5D6A  "#6A5D4D"  "rgb(697, 93, 77)"  "rgba(697, 93, 77,255)"  "1035_PearlBeige"
#RALne_1036= $355370;  $FF355370  "#705335"  "rgb(736, 83, 53)"  "rgba(736, 83, 53,255)"  "1036_PearlGold"
#RALne_1037= $189FF3;  $FF189FF3  "#F39F18"  "rgb(159,159, 24)"  "rgba(159,159, 24,255)"  "1037_SunYellow"
#RALne_2000= $0E76ED;  $FF0E76ED  "#ED760E"  "rgb(155,118, 14)"  "rgba(155,118, 14,255)"  "2000_YellowOrange"
#RALne_2001= $203CC9;  $FF203CC9  "#C93C20"  "rgb(131, 60, 32)"  "rgba(131, 60, 32,255)"  "2001_RedOrange"
#RALne_2002= $2128CB;  $FF2128CB  "#CB2821"  "rgb(133, 40, 33)"  "rgba(133, 40, 33,255)"  "2002_Vermilion"
#RALne_2003= $1475FF;  $FF1475FF  "#FF7514"  "rgb(167,117, 20)"  "rgba(167,117, 20,255)"  "2003_PastelOrange"
#RALne_2004= $1146F4;  $FF1146F4  "#F44611"  "rgb(160, 70, 17)"  "rgba(160, 70, 17,255)"  "2004_PureOrange"
#RALne_2005= $0123FF;  $FF0123FF  "#FF2301"  "rgb(167, 35,  1)"  "rgba(167, 35,  1,255)"  "2005_LuminousOrange"
#RALne_2007= $20A4FF;  $FF20A4FF  "#FFA420"  "rgb(167,164, 32)"  "rgba(167,164, 32,255)"  "2007_LuminousBrightOrange"
#RALne_2008= $255EF7;  $FF255EF7  "#F75E25"  "rgb(162, 94, 37)"  "rgba(162, 94, 37,255)"  "2008_BrightRedOrange"
#RALne_2009= $2140F5;  $FF2140F5  "#F54021"  "rgb(160, 64, 33)"  "rgba(160, 64, 33,255)"  "2009_TrafficOrange"
#RALne_2010= $204BD8;  $FF204BD8  "#D84B20"  "rgb(141, 75, 32)"  "rgba(141, 75, 32,255)"  "2010_SignalOrange"
#RALne_2011= $267CEC;  $FF267CEC  "#EC7C26"  "rgb(154,124, 38)"  "rgba(154,124, 38,255)"  "2011_DeepOrange"
#RALne_2012= $3751E5;  $FF3751E5  "#E55137"  "rgb(150, 81, 55)"  "rgba(150, 81, 55,255)"  "2012_SalmonRange"
#RALne_2013= $3158C3;  $FF3158C3  "#C35831"  "rgb(128, 88, 49)"  "rgba(128, 88, 49,255)"  "2013_PearlOrange"
#RALne_3000= $1E2BAF;  $FF1E2BAF  "#AF2B1E"  "rgb(114, 43, 30)"  "rgba(114, 43, 30,255)"  "3000_FlameRed"
#RALne_3001= $1920A5;  $FF1920A5  "#A52019"  "rgb(108, 32, 25)"  "rgba(108, 32, 25,255)"  "3001_SignalRed"
#RALne_3002= $1D23A2;  $FF1D23A2  "#A2231D"  "rgb(106, 35, 29)"  "rgba(106, 35, 29,255)"  "3002_CarmineRed"
#RALne_3003= $1E119B;  $FF1E119B  "#9B111E"  "rgb(101, 17, 30)"  "rgba(101, 17, 30,255)"  "3003_RubyRed"
#RALne_3004= $1E1575;  $FF1E1575  "#75151E"  "rgb(767, 21, 30)"  "rgba(767, 21, 30,255)"  "3004_PurpleRed"
#RALne_3005= $29215E;  $FF29215E  "#5E2129"  "rgb(616, 33, 41)"  "rgba(616, 33, 41,255)"  "3005_WineRed"
#RALne_3007= $272241;  $FF272241  "#412227"  "rgb(426, 34, 39)"  "rgba(426, 34, 39,255)"  "3007_BlackRed"
#RALne_3009= $242464;  $FF242464  "#642424"  "rgb(656, 36, 36)"  "rgba(656, 36, 36,255)"  "3009_OxideRed"
#RALne_3011= $191F78;  $FF191F78  "#781F19"  "rgb(787, 31, 25)"  "rgba(787, 31, 25,255)"  "3011_BrownRed"
#RALne_3012= $6B87C1;  $FF6B87C1  "#C1876B"  "rgb(126,135,107)"  "rgba(126,135,107,255)"  "3012_BeigeRed"
#RALne_3013= $1223A1;  $FF1223A1  "#A12312"  "rgb(105, 35, 18)"  "rgba(105, 35, 18,255)"  "3013_TomatoRed"
#RALne_3014= $706ED3;  $FF706ED3  "#D36E70"  "rgb(138,110,112)"  "rgba(138,110,112,255)"  "3014_AntiquePink"
#RALne_3015= $9A89EA;  $FF9A89EA  "#EA899A"  "rgb(153,137,154)"  "rgba(153,137,154,255)"  "3015_LightPink"
#RALne_3016= $2128B3;  $FF2128B3  "#B32821"  "rgb(117, 40, 33)"  "rgba(117, 40, 33,255)"  "3016_CoralRed"
#RALne_3017= $4432E6;  $FF4432E6  "#E63244"  "rgb(150, 50, 68)"  "rgba(150, 50, 68,255)"  "3017_Rose"
#RALne_3018= $3230D5;  $FF3230D5  "#D53032"  "rgb(139, 48, 50)"  "rgba(139, 48, 50,255)"  "3018_StrawberryRed"
#RALne_3020= $0506CC;  $FF0506CC  "#CC0605"  "rgb(133,  6,  5)"  "rgba(133,  6,  5,255)"  "3020_TrafficRed"
#RALne_3022= $3050D9;  $FF3050D9  "#D95030"  "rgb(142, 80, 48)"  "rgba(142, 80, 48,255)"  "3022_SalmonPink"
#RALne_3024= $0000F8;  $FF0000F8  "#F80000"  "rgb(162,  0,  0)"  "rgba(162,  0,  0,255)"  "3024_LuminousRed"
#RALne_3026= $0000FE;  $FF0000FE  "#FE0000"  "rgb(166,  0,  0)"  "rgba(166,  0,  0,255)"  "3026_Luminous"
#RALne_3027= $341DC5;  $FF341DC5  "#C51D34"  "rgb(129, 29, 52)"  "rgba(129, 29, 52,255)"  "3027_RaspberryRed"
#RALne_3028= $3432CB;  $FF3432CB  "#CB3234"  "rgb(133, 50, 52)"  "rgba(133, 50, 52,255)"  "3028_PureRed"
#RALne_3031= $2824B3;  $FF2824B3  "#B32428"  "rgb(117, 36, 40)"  "rgba(117, 36, 40,255)"  "3031_OrientRed"
#RALne_3032= $221472;  $FF221472  "#721422"  "rgb(747, 20, 34)"  "rgba(747, 20, 34,255)"  "3032_PearlRubyRed"
#RALne_3033= $434CB4;  $FF434CB4  "#B44C43"  "rgb(118, 76, 67)"  "rgba(118, 76, 67,255)"  "3033_PearlPink"
#RALne_4001= $5B3F6D;  $FF5B3F6D  "#6D3F5B"  "rgb(715, 63, 91)"  "rgba(715, 63, 91,255)"  "4001_RedLilac"
#RALne_4002= $3E2B92;  $FF3E2B92  "#922B3E"  "rgb(957, 43, 62)"  "rgba(957, 43, 62,255)"  "4002_RedViolet"
#RALne_4003= $8A4CDE;  $FF8A4CDE  "#DE4C8A"  "rgb(145, 76,138)"  "rgba(145, 76,138,255)"  "4003_HeatherViolet"
#RALne_4004= $341C64;  $FF341C64  "#641C34"  "rgb(656, 28, 52)"  "rgba(656, 28, 52,255)"  "4004_ClaretViolet"
#RALne_4005= $75466C;  $FF75466C  "#6C4675"  "rgb(709, 70,117)"  "rgba(709, 70,117,255)"  "4005_BlueLilac"
#RALne_4006= $7234A0;  $FF7234A0  "#A03472"  "rgb(104, 52,114)"  "rgba(104, 52,114,255)"  "4006_TrafficPurple"
#RALne_4007= $2C194A;  $FF2C194A  "#4A192C"  "rgb(485, 25, 44)"  "rgba(485, 25, 44,255)"  "4007_PurpleViolet"
#RALne_4008= $7D4E92;  $FF7D4E92  "#924E7D"  "rgb(958, 78,125)"  "rgba(958, 78,125,255)"  "4008_SignalViolet"
#RALne_4009= $9485A1;  $FF9485A1  "#A18594"  "rgb(105,133,148)"  "rgba(105,133,148,255)"  "4009_PastelViolet"
#RALne_4010= $7634CF;  $FF7634CF  "#CF3476"  "rgb(135, 52,118)"  "rgba(135, 52,118,255)"  "4010_Telemagenta"
#RALne_4011= $A17386;  $FFA17386  "#8673A1"  "rgb(881,115,161)"  "rgba(881,115,161,255)"  "4011_PearlViolet"
#RALne_4012= $74686C;  $FF74686C  "#6C6874"  "rgb(710,104,116)"  "rgba(710,104,116,255)"  "4012_PearlBlackBerry"
#RALne_5000= $734D35;  $FF734D35  "#354D73"  "rgb(349, 77,115)"  "rgba(349, 77,115,255)"  "5000_VioletBlue"
#RALne_5001= $38341F;  $FF38341F  "#1F3438"  "rgb(204, 52, 56)"  "rgba(204, 52, 56,255)"  "5001_GreenBlue"
#RALne_5002= $4F2120;  $FF4F2120  "#20214F"  "rgb(210, 33, 79)"  "rgba(210, 33, 79,255)"  "5002_UltramarineBlue"
#RALne_5003= $331E1D;  $FF331E1D  "#1D1E33"  "rgb(190, 30, 51)"  "rgba(190, 30, 51,255)"  "5003_SaphireBlue"
#RALne_5004= $1C1718;  $FF1C1718  "#18171C"  "rgb(157, 23, 28)"  "rgba(157, 23, 28,255)"  "5004_BlackBlue"
#RALne_5005= $60241E;  $FF60241E  "#1E2460"  "rgb(197, 36, 96)"  "rgba(197, 36, 96,255)"  "5005_SignalBlue"
#RALne_5007= $8A5F3E;  $FF8A5F3E  "#3E5F8A"  "rgb(408, 95,138)"  "rgba(408, 95,138,255)"  "5007_BrillantBlue"
#RALne_5008= $2D2526;  $FF2D2526  "#26252D"  "rgb(249, 37, 45)"  "rgba(249, 37, 45,255)"  "5008_GreyBlue"
#RALne_5009= $695602;  $FF695602  "#025669"  "rgb(153, 86,105)"  "rgba(153, 86,105,255)"  "5009_AzureBlue"
#RALne_5010= $4B290E;  $FF4B290E  "#0E294B"  "rgb(928, 41, 75)"  "rgba(928, 41, 75,255)"  "5010_GentianBlue"
#RALne_5011= $241A23;  $FF241A23  "#231A24"  "rgb(230, 26, 36)"  "rgba(230, 26, 36,255)"  "5011_SteelBlue"
#RALne_5012= $BD833B;  $FFBD833B  "#3B83BD"  "rgb(390,131,189)"  "rgba(390,131,189,255)"  "5012_LightBlue"
#RALne_5013= $3D211E;  $FF3D211E  "#1E213D"  "rgb(197, 33, 61)"  "rgba(197, 33, 61,255)"  "5013_CobaltBlue"
#RALne_5014= $8C6E60;  $FF8C6E60  "#606E8C"  "rgb(631,110,140)"  "rgba(631,110,140,255)"  "5014_PigeonBlue"
#RALne_5015= $B37122;  $FFB37122  "#2271B3"  "rgb(225,113,179)"  "rgba(225,113,179,255)"  "5015_SkyBlue"
#RALne_5017= $713906;  $FF713906  "#063971"  "rgb(407, 57,113)"  "rgba(407, 57,113,255)"  "5017_TrafficBlue"
#RALne_5018= $8F883F;  $FF8F883F  "#3F888F"  "rgb(416,136,143)"  "rgba(416,136,143,255)"  "5018_TurquoiseBlue"
#RALne_5019= $83551B;  $FF83551B  "#1B5583"  "rgb(179, 85,131)"  "rgba(179, 85,131,255)"  "5019_CapriBlue"
#RALne_5020= $4A331D;  $FF4A331D  "#1D334A"  "rgb(191, 51, 74)"  "rgba(191, 51, 74,255)"  "5020_OceanBlue"
#RALne_5021= $7B6D25;  $FF7B6D25  "#256D7B"  "rgb(245,109,123)"  "rgba(245,109,123,255)"  "5021_WaterBlue"
#RALne_5022= $502825;  $FF502825  "#252850"  "rgb(243, 40, 80)"  "rgba(243, 40, 80,255)"  "5022_NightBlue"
#RALne_5023= $8D6749;  $FF8D6749  "#49678D"  "rgb(481,103,141)"  "rgba(481,103,141,255)"  "5023_DistantBlue"
#RALne_5024= $9B9B5D;  $FF9B9B5D  "#5D9B9B"  "rgb(613,155,155)"  "rgba(613,155,155,255)"  "5024_PastelBlue"
#RALne_5025= $78642A;  $FF78642A  "#2A6478"  "rgb(277,100,120)"  "rgba(277,100,120,255)"  "5025_PearlGentianBlue"
#RALne_5026= $542C10;  $FF542C10  "#102C54"  "rgb(105, 44, 84)"  "rgba(105, 44, 84,255)"  "5026_PearlNightBlue"
#RALne_6000= $506631;  $FF506631  "#316650"  "rgb(323,102, 80)"  "rgba(323,102, 80,255)"  "6000_PatinaGreen"
#RALne_6001= $337228;  $FF337228  "#287233"  "rgb(265,114, 51)"  "rgba(265,114, 51,255)"  "6001_EmeraldGreen"
#RALne_6002= $2C572D;  $FF2C572D  "#2D572C"  "rgb(297, 87, 44)"  "rgba(297, 87, 44,255)"  "6002_LeafGreen"
#RALne_6003= $324642;  $FF324642  "#424632"  "rgb(434, 70, 50)"  "rgba(434, 70, 50,255)"  "6003_OliveGreen"
#RALne_6004= $3D3A1F;  $FF3D3A1F  "#1F3A3D"  "rgb(204, 58, 61)"  "rgba(204, 58, 61,255)"  "6004_BlueGreen"
#RALne_6005= $38452F;  $FF38452F  "#2F4538"  "rgb(309, 69, 56)"  "rgba(309, 69, 56,255)"  "6005_MossGreen"
#RALne_6006= $323B3E;  $FF323B3E  "#3E3B32"  "rgb(407, 59, 50)"  "rgba(407, 59, 50,255)"  "6006_GreyOlive"
#RALne_6007= $293B34;  $FF293B34  "#343B29"  "rgb(342, 59, 41)"  "rgba(342, 59, 41,255)"  "6007_BottleGreen"
#RALne_6008= $2A3539;  $FF2A3539  "#39352A"  "rgb(374, 53, 42)"  "rgba(374, 53, 42,255)"  "6008_BrownGreen"
#RALne_6009= $2B3731;  $FF2B3731  "#31372B"  "rgb(322, 55, 43)"  "rgba(322, 55, 43,255)"  "6009_FirGreen"
#RALne_6010= $2D6835;  $FF2D6835  "#35682D"  "rgb(350,104, 45)"  "rgba(350,104, 45,255)"  "6010_GrassGreen"
#RALne_6011= $467258;  $FF467258  "#587246"  "rgb(579,114, 70)"  "rgba(579,114, 70,255)"  "6011_ResedaGreen"
#RALne_6012= $403E34;  $FF403E34  "#343E40"  "rgb(342, 62, 64)"  "rgba(342, 62, 64,255)"  "6012_BlackGreen"
#RALne_6013= $56716C;  $FF56716C  "#6C7156"  "rgb(710,113, 86)"  "rgba(710,113, 86,255)"  "6013_ReedGreen"
#RALne_6014= $2E4047;  $FF2E4047  "#47402E"  "rgb(466, 64, 46)"  "rgba(466, 64, 46,255)"  "6014_YellowOlive"
#RALne_6015= $363C3B;  $FF363C3B  "#3B3C36"  "rgb(388, 60, 54)"  "rgba(388, 60, 54,255)"  "6015_BlackOlive"
#RALne_6016= $45591E;  $FF45591E  "#1E5945"  "rgb(198, 89, 69)"  "rgba(198, 89, 69,255)"  "6016_TurquoiseGreen"
#RALne_6017= $41914C;  $FF41914C  "#4C9141"  "rgb(501,145, 65)"  "rgba(501,145, 65,255)"  "6017_MayGreen"
#RALne_6018= $39A657;  $FF39A657  "#57A639"  "rgb(574,166, 57)"  "rgba(574,166, 57,255)"  "6018_YellowGreen"
#RALne_6019= $B6ECBD;  $FFB6ECBD  "#BDECB6"  "rgb(124,236,182)"  "rgba(124,236,182,255)"  "6019_PastelGreen"
#RALne_6020= $233A2E;  $FF233A2E  "#2E3A23"  "rgb(302, 58, 35)"  "rgba(302, 58, 35,255)"  "6020_ChromeGreen"
#RALne_6021= $76AC89;  $FF76AC89  "#89AC76"  "rgb(902,172,118)"  "rgba(902,172,118,255)"  "6021_PaleGreen"
#RALne_6022= $1B2225;  $FF1B2225  "#25221B"  "rgb(243, 34, 27)"  "rgba(243, 34, 27,255)"  "6022_OliveDrab"
#RALne_6024= $468430;  $FF468430  "#308446"  "rgb(317,132, 70)"  "rgba(317,132, 70,255)"  "6024_TrafficGreen"
#RALne_6025= $2D643D;  $FF2D643D  "#3D642D"  "rgb(402,100, 45)"  "rgba(402,100, 45,255)"  "6025_FernGreen"
#RALne_6026= $525D01;  $FF525D01  "#015D52"  "rgb(894, 93, 82)"  "rgba(894, 93, 82,255)"  "6026_OpalGreen"
#RALne_6027= $BEC384;  $FFBEC384  "#84C3BE"  "rgb(870,195,190)"  "rgba(870,195,190,255)"  "6027_LightGreen"
#RALne_6028= $45552C;  $FF45552C  "#2C5545"  "rgb(290, 85, 69)"  "rgba(290, 85, 69,255)"  "6028_PineGreen"
#RALne_6029= $3D6020;  $FF3D6020  "#20603D"  "rgb(212, 96, 61)"  "rgba(212, 96, 61,255)"  "6029_MintGreen"
#RALne_6032= $437F31;  $FF437F31  "#317F43"  "rgb(324,127, 67)"  "rgba(324,127, 67,255)"  "6032_SignalGreen"
#RALne_6033= $767E49;  $FF767E49  "#497E76"  "rgb(481,126,118)"  "rgba(481,126,118,255)"  "6033_MintTurquoise"
#RALne_6034= $B5B57F;  $FFB5B57F  "#7FB5B5"  "rgb(836,181,181)"  "rgba(836,181,181,255)"  "6034_PastelTurquoise"
#RALne_6035= $2D541C;  $FF2D541C  "#1C542D"  "rgb(185, 84, 45)"  "rgba(185, 84, 45,255)"  "6035_PearlGreen"
#RALne_6036= $373719;  $FF373719  "#193737"  "rgb(165, 55, 55)"  "rgba(165, 55, 55,255)"  "6036_PearlOpalGreen"
#RALne_6037= $398F00;  $FF398F00  "#008F39"  "rgb(366,143, 57)"  "rgba(366,143, 57,255)"  "6037_PureGreen"
#RALne_6038= $2DBB00;  $FF2DBB00  "#00BB2D"  "rgb(479,187, 45)"  "rgba(479,187, 45,255)"  "6038_LuminousGreen"
#RALne_7000= $8B8578;  $FF8B8578  "#78858B"  "rgb(789,133,139)"  "rgba(789,133,139,255)"  "7000_SquirrelGrey"
#RALne_7001= $97958A;  $FF97958A  "#8A9597"  "rgb(908,149,151)"  "rgba(908,149,151,255)"  "7001_SilverGrey"
#RALne_7002= $527B7E;  $FF527B7E  "#7E7B52"  "rgb(828,123, 82)"  "rgba(828,123, 82,255)"  "7002_OliveGrey"
#RALne_7003= $59706C;  $FF59706C  "#6C7059"  "rgb(710,112, 89)"  "rgba(710,112, 89,255)"  "7003_MossGrey"
#RALne_7004= $929996;  $FF929996  "#969992"  "rgb(986,153,146)"  "rgba(986,153,146,255)"  "7004_SignalGrey"
#RALne_7005= $636B64;  $FF636B64  "#646B63"  "rgb(658,107, 99)"  "rgba(658,107, 99,255)"  "7005_MouseGrey"
#RALne_7006= $52656D;  $FF52656D  "#6D6552"  "rgb(716,101, 82)"  "rgba(716,101, 82,255)"  "7006_BeigeGrey"
#RALne_7008= $315F6A;  $FF315F6A  "#6A5F31"  "rgb(697, 95, 49)"  "rgba(697, 95, 49,255)"  "7008_KhakiGrey"
#RALne_7009= $45564D;  $FF45564D  "#4D5645"  "rgb(506, 86, 69)"  "rgba(506, 86, 69,255)"  "7009_GreenGrey"
#RALne_7010= $4A514C;  $FF4A514C  "#4C514A"  "rgb(500, 81, 74)"  "rgba(500, 81, 74,255)"  "7010_TarpaulinGrey"
#RALne_7011= $4D4B43;  $FF4D4B43  "#434B4D"  "rgb(441, 75, 77)"  "rgba(441, 75, 77,255)"  "7011_IronGrey"
#RALne_7012= $54574E;  $FF54574E  "#4E5754"  "rgb(513, 87, 84)"  "rgba(513, 87, 84,255)"  "7012_BasaltGrey"
#RALne_7013= $314546;  $FF314546  "#464531"  "rgb(460, 69, 49)"  "rgba(460, 69, 49,255)"  "7013_BrownGrey"
#RALne_7015= $504743;  $FF504743  "#434750"  "rgb(440, 71, 80)"  "rgba(440, 71, 80,255)"  "7015_SlateGrey"
#RALne_7016= $333129;  $FF333129  "#293133"  "rgb(269, 49, 51)"  "rgba(269, 49, 51,255)"  "7016_AnthraciteGrey"
#RALne_7021= $2B2823;  $FF2B2823  "#23282B"  "rgb(230, 40, 43)"  "rgba(230, 40, 43,255)"  "7021_BlackGrey"
#RALne_7022= $2C2F33;  $FF2C2F33  "#332F2C"  "rgb(335, 47, 44)"  "rgba(335, 47, 44,255)"  "7022_UmbraGrey"
#RALne_7023= $5E6C68;  $FF5E6C68  "#686C5E"  "rgb(684,108, 94)"  "rgba(684,108, 94,255)"  "7023_ConcreteGrey"
#RALne_7024= $514A47;  $FF514A47  "#474A51"  "rgb(467, 74, 81)"  "rgba(467, 74, 81,255)"  "7024_GraphiteGrey"
#RALne_7026= $3B352F;  $FF3B352F  "#2F353B"  "rgb(309, 53, 59)"  "rgba(309, 53, 59,255)"  "7026_GraniteGrey"
#RALne_7030= $7A8C8B;  $FF7A8C8B  "#8B8C7A"  "rgb(914,140,122)"  "rgba(914,140,122,255)"  "7030_StoneGrey"
#RALne_7031= $4E4B47;  $FF4E4B47  "#474B4E"  "rgb(467, 75, 78)"  "rgba(467, 75, 78,255)"  "7031_BlueGrey"
#RALne_7032= $99B7B8;  $FF99B7B8  "#B8B799"  "rgb(121,183,153)"  "rgba(121,183,153,255)"  "7032_PebbleGrey"
#RALne_7033= $71847D;  $FF71847D  "#7D8471"  "rgb(822,132,113)"  "rgba(822,132,113,255)"  "7033_CementGrey"
#RALne_7034= $668B8F;  $FF668B8F  "#8F8B66"  "rgb(940,139,102)"  "rgba(940,139,102,255)"  "7034_YellowGrey"
#RALne_7035= $D7D7D7;  $FFD7D7D7  "#D7D7D7"  "rgb(141,215,215)"  "rgba(141,215,215,255)"  "7035_LightGrey"
#RALne_7036= $79767F;  $FF79767F  "#7F7679"  "rgb(835,118,121)"  "rgba(835,118,121,255)"  "7036_PlatinumGrey"
#RALne_7037= $7D7F7D;  $FF7D7F7D  "#7D7F7D"  "rgb(822,127,125)"  "rgba(822,127,125,255)"  "7037_DustyGrey"
#RALne_7038= $B1B8B5;  $FFB1B8B5  "#B5B8B1"  "rgb(119,184,177)"  "rgba(119,184,177,255)"  "7038_AgateGrey"
#RALne_7039= $60696C;  $FF60696C  "#6C6960"  "rgb(710,105, 96)"  "rgba(710,105, 96,255)"  "7039_QuartzGrey"
#RALne_7040= $AAA19D;  $FFAAA19D  "#9DA1AA"  "rgb(103,161,170)"  "rgba(103,161,170,255)"  "7040_WindowGrey"
#RALne_7042= $8D948D;  $FF8D948D  "#8D948D"  "rgb(927,148,141)"  "rgba(927,148,141,255)"  "7042_TrafficGreya"
#RALne_7043= $52544E;  $FF52544E  "#4E5452"  "rgb(513, 84, 82)"  "rgba(513, 84, 82,255)"  "7043_TrafficGreyb"
#RALne_7044= $B0C4CA;  $FFB0C4CA  "#CAC4B0"  "rgb(132,196,176)"  "rgba(132,196,176,255)"  "7044_SilkGrey"
#RALne_7045= $909090;  $FF909090  "#909090"  "rgb(947,144,144)"  "rgba(947,144,144,255)"  "7045_Telegrey1"
#RALne_7046= $8F8982;  $FF8F8982  "#82898F"  "rgb(855,137,143)"  "rgba(855,137,143,255)"  "7046_Telegrey2"
#RALne_7047= $D0D0D0;  $FFD0D0D0  "#D0D0D0"  "rgb(136,208,208)"  "rgba(136,208,208,255)"  "7047_Telegrey4"
#RALne_7048= $768189;  $FF768189  "#898176"  "rgb(901,129,118)"  "rgba(901,129,118,255)"  "7048_PearlMouseGrey"
#RALne_8000= $346C82;  $FF346C82  "#826C34"  "rgb(854,108, 52)"  "rgba(854,108, 52,255)"  "8000_GreenBrown"
#RALne_8001= $205F95;  $FF205F95  "#955F20"  "rgb(978, 95, 32)"  "rgba(978, 95, 32,255)"  "8001_OchreBrown"
#RALne_8002= $2A3B6C;  $FF2A3B6C  "#6C3B2A"  "rgb(709, 59, 42)"  "rgba(709, 59, 42,255)"  "8002_SignalBrown"
#RALne_8003= $224273;  $FF224273  "#734222"  "rgb(755, 66, 34)"  "rgba(755, 66, 34,255)"  "8003_ClayBrown"
#RALne_8004= $2A408E;  $FF2A408E  "#8E402A"  "rgb(932, 64, 42)"  "rgba(932, 64, 42,255)"  "8004_CopperBrown"
#RALne_8007= $1F3559;  $FF1F3559  "#59351F"  "rgb(584, 53, 31)"  "rgba(584, 53, 31,255)"  "8007_FawnBrown"
#RALne_8008= $284F6F;  $FF284F6F  "#6F4F28"  "rgb(729, 79, 40)"  "rgba(729, 79, 40,255)"  "8008_OliveBrown"
#RALne_8011= $293A5B;  $FF293A5B  "#5B3A29"  "rgb(597, 58, 41)"  "rgba(597, 58, 41,255)"  "8011_NutBrown"
#RALne_8012= $212359;  $FF212359  "#592321"  "rgb(584, 35, 33)"  "rgba(584, 35, 33,255)"  "8012_RedBrown"
#RALne_8014= $1E2C38;  $FF1E2C38  "#382C1E"  "rgb(368, 44, 30)"  "rgba(368, 44, 30,255)"  "8014_SepiaBrown"
#RALne_8015= $343A63;  $FF343A63  "#633A34"  "rgb(650, 58, 52)"  "rgba(650, 58, 52,255)"  "8015_ChestnutBrown"
#RALne_8016= $272F4C;  $FF272F4C  "#4C2F27"  "rgb(499, 47, 39)"  "rgba(499, 47, 39,255)"  "8016_MahoganyBrown"
#RALne_8017= $2E3245;  $FF2E3245  "#45322E"  "rgb(453, 50, 46)"  "rgba(453, 50, 46,255)"  "8017_ChocolateBrown"
#RALne_8019= $3A3A40;  $FF3A3A40  "#403A3A"  "rgb(420, 58, 58)"  "rgba(420, 58, 58,255)"  "8019_GreyBrown"
#RALne_8022= $212121;  $FF212121  "#212121"  "rgb(217, 33, 33)"  "rgba(217, 33, 33,255)"  "8022_BlackBrown"
#RALne_8023= $2E5EA6;  $FF2E5EA6  "#A65E2E"  "rgb(109, 94, 46)"  "rgba(109, 94, 46,255)"  "8023_OrangeBrown"
#RALne_8024= $3D5579;  $FF3D5579  "#79553D"  "rgb(795, 85, 61)"  "rgba(795, 85, 61,255)"  "8024_BeigeBrown"
#RALne_8025= $485C75;  $FF485C75  "#755C48"  "rgb(769, 92, 72)"  "rgba(769, 92, 72,255)"  "8025_PaleBrown"
#RALne_8028= $313B4E;  $FF313B4E  "#4E3B31"  "rgb(512, 59, 49)"  "rgba(512, 59, 49,255)"  "8028_TerraBrown"
#RALne_8029= $283C76;  $FF283C76  "#763C28"  "rgb(774, 60, 40)"  "rgba(774, 60, 40,255)"  "8029_PearlCopper"
#RALne_9001= $E3F4FD;  $FFE3F4FD  "#FDF4E3"  "rgb(166,244,227)"  "rgba(166,244,227,255)"  "9001_Cream"
#RALne_9002= $DAEBE7;  $FFDAEBE7  "#E7EBDA"  "rgb(151,235,218)"  "rgba(151,235,218,255)"  "9002_GreyWhite"
#RALne_9003= $F4F4F4;  $FFF4F4F4  "#F4F4F4"  "rgb(160,244,244)"  "rgba(160,244,244,255)"  "9003_SignalWhite"
#RALne_9004= $282828;  $FF282828  "#282828"  "rgb(263, 40, 40)"  "rgba(263, 40, 40,255)"  "9004_SignalBlack"
#RALne_9005= $0A0A0A;  $FF0A0A0A  "#0A0A0A"  "rgb(657, 10, 10)"  "rgba(657, 10, 10,255)"  "9005_JetBlack"
#RALne_9006= $A5A5A5;  $FFA5A5A5  "#A5A5A5"  "rgb(108,165,165)"  "rgba(108,165,165,255)"  "9006_WhiteAluminium"
#RALne_9007= $8F8F8F;  $FF8F8F8F  "#8F8F8F"  "rgb(940,143,143)"  "rgba(940,143,143,255)"  "9007_GreyAluminium"
#RALne_9010= $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(167,255,255)"  "rgba(167,255,255,255)"  "9010_PureWhite"
#RALne_9011= $1C1C1C;  $FF1C1C1C  "#1C1C1C"  "rgb(184, 28, 28)"  "rgba(184, 28, 28,255)"  "9011_GraphiteBlack"
#RALne_9016= $F6F6F6;  $FFF6F6F6  "#F6F6F6"  "rgb(161,246,246)"  "rgba(161,246,246,255)"  "9016_TrafficWhite"
#RALne_9017= $1E1E1E;  $FF1E1E1E  "#1E1E1E"  "rgb(197, 30, 30)"  "rgba(197, 30, 30,255)"  "9017_TrafficBlack"
#RALne_9018= $D7D7D7;  $FFD7D7D7  "#D7D7D7"  "rgb(141,215,215)"  "rgba(141,215,215,255)"  "9018_PapyrusWhite"
#RALne_9022= $9C9C9C;  $FF9C9C9C  "#9C9C9C"  "rgb(102,156,156)"  "rgba(102,156,156,255)"  "9022_PearlLightGrey"
#RALne_9023= $828282;  $FF828282  "#828282"  "rgb(855,130,130)"  "rgba(855,130,130,255)"  "9023_PearlDarkGrey"


;-RALn-Colors, numbers, german names
;  see http://www.ralcolor.com/
;RALn-no     PB-Color: "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              RAL-no + ger. Colorname:
#RALng_1000= $7FBDBE;  $FF7FBDBE  "#BEBD7F"  "rgb(190,189,127)"  "rgba(190,189,127,255)"  "1000_Gruenbeige "
#RALng_1001= $78B0C2;  $FF78B0C2  "#C2B078"  "rgb(194,176,120)"  "rgba(194,176,120,255)"  "1001_Beige "
#RALng_1002= $64A6C6;  $FF64A6C6  "#C6A664"  "rgb(198,166,100)"  "rgba(198,166,100,255)"  "1002_Sandgelb"
#RALng_1003= $01BEE5;  $FF01BEE5  "#E5BE01"  "rgb(229,190,  1)"  "rgba(229,190,  1,255)"  "1003_Signalgelb"
#RALng_1004= $34A4CD;  $FF34A4CD  "#CDA434"  "rgb(205,164, 52)"  "rgba(205,164, 52,255)"  "1004_Goldgelb"
#RALng_1005= $0783A9;  $FF0783A9  "#A98307"  "rgb(169,131,  7)"  "rgba(169,131,  7,255)"  "1005_Honiggelb"
#RALng_1006= $10A0E4;  $FF10A0E4  "#E4A010"  "rgb(228,160, 16)"  "rgba(228,160, 16,255)"  "1006_Maisgelb"
#RALng_1007= $009DDC;  $FF009DDC  "#DC9D00"  "rgb(220,157,  0)"  "rgba(220,157,  0,255)"  "1007_Narzissengelb"
#RALng_1011= $42668A;  $FF42668A  "#8A6642"  "rgb(138,102, 66)"  "rgba(138,102, 66,255)"  "1011_Braunbeige"
#RALng_1012= $46B4C7;  $FF46B4C7  "#C7B446"  "rgb(199,180, 70)"  "rgba(199,180, 70,255)"  "1012_Zitronengelb"
#RALng_1013= $CAE6EA;  $FFCAE6EA  "#EAE6CA"  "rgb(234,230,202)"  "rgba(234,230,202,255)"  "1013_Perlweiss"
#RALng_1014= $4FCCE1;  $FF4FCCE1  "#E1CC4F"  "rgb(225,204, 79)"  "rgba(225,204, 79,255)"  "1014_Elfenbein"
#RALng_1015= $90D6E6;  $FF90D6E6  "#E6D690"  "rgb(230,214,144)"  "rgba(230,214,144,255)"  "1015_Hellelfenbein"
#RALng_1016= $21FFED;  $FF21FFED  "#EDFF21"  "rgb(237,255, 33)"  "rgba(237,255, 33,255)"  "1016_Schwefelgelb"
#RALng_1017= $33D0F5;  $FF33D0F5  "#F5D033"  "rgb(245,208, 51)"  "rgba(245,208, 51,255)"  "1017_Safrangelb"
#RALng_1018= $2BF3F8;  $FF2BF3F8  "#F8F32B"  "rgb(248,243, 43)"  "rgba(248,243, 43,255)"  "1018_Zinkgelb"
#RALng_1019= $64979E;  $FF64979E  "#9E9764"  "rgb(158,151,100)"  "rgba(158,151,100,255)"  "1019_Graubeige"
#RALng_1020= $509999;  $FF509999  "#999950"  "rgb(153,153, 80)"  "rgba(153,153, 80,255)"  "1020_Olivgelb"
#RALng_1021= $0BDAF3;  $FF0BDAF3  "#F3DA0B"  "rgb(243,218, 11)"  "rgba(243,218, 11,255)"  "1021_Rapsgelb"
#RALng_1023= $01D2FA;  $FF01D2FA  "#FAD201"  "rgb(250,210,  1)"  "rgba(250,210,  1,255)"  "1023_Verkehrsgelb"
#RALng_1024= $4BA0AE;  $FF4BA0AE  "#AEA04B"  "rgb(174,160, 75)"  "rgba(174,160, 75,255)"  "1024_Ockergelb"
#RALng_1026= $00FFFF;  $FF00FFFF  "#FFFF00"  "rgb(255,255,  0)"  "rgba(255,255,  0,255)"  "1026_Leuchtgelb"
#RALng_1027= $01919D;  $FF01919D  "#9D9101"  "rgb(157,145,  1)"  "rgba(157,145,  1,255)"  "1027_Currygelb"
#RALng_1028= $00A9F4;  $FF00A9F4  "#F4A900"  "rgb(244,169,  0)"  "rgba(244,169,  0,255)"  "1028_Melonengelb"
#RALng_1032= $01AED6;  $FF01AED6  "#D6AE01"  "rgb(214,174,  1)"  "rgba(214,174,  1,255)"  "1032_Ginstergelb"
#RALng_1033= $05A5F3;  $FF05A5F3  "#F3A505"  "rgb(243,165,  5)"  "rgba(243,165,  5,255)"  "1033_Dahliengelb"
#RALng_1034= $4AA9EF;  $FF4AA9EF  "#EFA94A"  "rgb(239,169, 74)"  "rgba(239,169, 74,255)"  "1034_Pastellgelb"
#RALng_1035= $4D5D6A;  $FF4D5D6A  "#6A5D4D"  "rgb(106, 93, 77)"  "rgba(106, 93, 77,255)"  "1035_Perlbeige"
#RALng_1036= $355370;  $FF355370  "#705335"  "rgb(112, 83, 53)"  "rgba(112, 83, 53,255)"  "1036_Perlgold"
#RALng_1037= $189FF3;  $FF189FF3  "#F39F18"  "rgb(243,159, 24)"  "rgba(243,159, 24,255)"  "1037_Sonnengelb"
#RALng_2000= $0E76ED;  $FF0E76ED  "#ED760E"  "rgb(237,118, 14)"  "rgba(237,118, 14,255)"  "2000_Gelborange"
#RALng_2001= $203CC9;  $FF203CC9  "#C93C20"  "rgb(201, 60, 32)"  "rgba(201, 60, 32,255)"  "2001_Rotorange"
#RALng_2002= $2128CB;  $FF2128CB  "#CB2821"  "rgb(203, 40, 33)"  "rgba(203, 40, 33,255)"  "2002_Blutorange"
#RALng_2003= $1475FF;  $FF1475FF  "#FF7514"  "rgb(255,117, 20)"  "rgba(255,117, 20,255)"  "2003_Pastellorange"
#RALng_2004= $1146F4;  $FF1146F4  "#F44611"  "rgb(244, 70, 17)"  "rgba(244, 70, 17,255)"  "2004_Reinorange"
#RALng_2005= $0123FF;  $FF0123FF  "#FF2301"  "rgb(255, 35,  1)"  "rgba(255, 35,  1,255)"  "2005_Leuchtorange"
#RALng_2007= $20A4FF;  $FF20A4FF  "#FFA420"  "rgb(255,164, 32)"  "rgba(255,164, 32,255)"  "2007_Leuchthellorange"
#RALng_2008= $255EF7;  $FF255EF7  "#F75E25"  "rgb(247, 94, 37)"  "rgba(247, 94, 37,255)"  "2008_Hellrotorange"
#RALng_2009= $2140F5;  $FF2140F5  "#F54021"  "rgb(245, 64, 33)"  "rgba(245, 64, 33,255)"  "2009_Verkehrsorange"
#RALng_2010= $204BD8;  $FF204BD8  "#D84B20"  "rgb(216, 75, 32)"  "rgba(216, 75, 32,255)"  "2010_Signalorange"
#RALng_2011= $267CEC;  $FF267CEC  "#EC7C26"  "rgb(236,124, 38)"  "rgba(236,124, 38,255)"  "2011_Tieforange"
#RALng_2012= $3751E5;  $FF3751E5  "#E55137"  "rgb(229, 81, 55)"  "rgba(229, 81, 55,255)"  "2012_Lachsorange"
#RALng_2013= $3158C3;  $FF3158C3  "#C35831"  "rgb(195, 88, 49)"  "rgba(195, 88, 49,255)"  "2013_Perlorange"
#RALng_3000= $1E2BAF;  $FF1E2BAF  "#AF2B1E"  "rgb(175, 43, 30)"  "rgba(175, 43, 30,255)"  "3000_Feuerrot"
#RALng_3001= $1920A5;  $FF1920A5  "#A52019"  "rgb(165, 32, 25)"  "rgba(165, 32, 25,255)"  "3001_Signalrot"
#RALng_3002= $1D23A2;  $FF1D23A2  "#A2231D"  "rgb(162, 35, 29)"  "rgba(162, 35, 29,255)"  "3002_Karminrot"
#RALng_3003= $1E119B;  $FF1E119B  "#9B111E"  "rgb(155, 17, 30)"  "rgba(155, 17, 30,255)"  "3003_Rubinrot"
#RALng_3004= $1E1575;  $FF1E1575  "#75151E"  "rgb(117, 21, 30)"  "rgba(117, 21, 30,255)"  "3004_Purpurrot"
#RALng_3005= $29215E;  $FF29215E  "#5E2129"  "rgb( 94, 33, 41)"  "rgba( 94, 33, 41,255)"  "3005_Weinrot"
#RALng_3007= $272241;  $FF272241  "#412227"  "rgb( 65, 34, 39)"  "rgba( 65, 34, 39,255)"  "3007_Schwarzrot"
#RALng_3009= $242464;  $FF242464  "#642424"  "rgb(100, 36, 36)"  "rgba(100, 36, 36,255)"  "3009_Oxidrot"
#RALng_3011= $191F78;  $FF191F78  "#781F19"  "rgb(120, 31, 25)"  "rgba(120, 31, 25,255)"  "3011_Braunrot"
#RALng_3012= $6B87C1;  $FF6B87C1  "#C1876B"  "rgb(193,135,107)"  "rgba(193,135,107,255)"  "3012_Beigerot"
#RALng_3013= $1223A1;  $FF1223A1  "#A12312"  "rgb(161, 35, 18)"  "rgba(161, 35, 18,255)"  "3013_Tomatenrot"
#RALng_3014= $706ED3;  $FF706ED3  "#D36E70"  "rgb(211,110,112)"  "rgba(211,110,112,255)"  "3014_Altrosa"
#RALng_3015= $9A89EA;  $FF9A89EA  "#EA899A"  "rgb(234,137,154)"  "rgba(234,137,154,255)"  "3015_Hellrosa"
#RALng_3016= $2128B3;  $FF2128B3  "#B32821"  "rgb(179, 40, 33)"  "rgba(179, 40, 33,255)"  "3016_Korallenrot"
#RALng_3017= $4432E6;  $FF4432E6  "#E63244"  "rgb(230, 50, 68)"  "rgba(230, 50, 68,255)"  "3017_Rose"
#RALng_3018= $3230D5;  $FF3230D5  "#D53032"  "rgb(213, 48, 50)"  "rgba(213, 48, 50,255)"  "3018_Erdbeerrot"
#RALng_3020= $0506CC;  $FF0506CC  "#CC0605"  "rgb(204,  6,  5)"  "rgba(204,  6,  5,255)"  "3020_Verkehrsrot"
#RALng_3022= $3050D9;  $FF3050D9  "#D95030"  "rgb(217, 80, 48)"  "rgba(217, 80, 48,255)"  "3022_Lachsrot"
#RALng_3024= $0000F8;  $FF0000F8  "#F80000"  "rgb(248,  0,  0)"  "rgba(248,  0,  0,255)"  "3024_Leuchtrot"
#RALng_3026= $0000FE;  $FF0000FE  "#FE0000"  "rgb(254,  0,  0)"  "rgba(254,  0,  0,255)"  "3026_Leuchthellrot"
#RALng_3027= $341DC5;  $FF341DC5  "#C51D34"  "rgb(197, 29, 52)"  "rgba(197, 29, 52,255)"  "3027_Himbeerrot"
#RALng_3028= $3432CB;  $FF3432CB  "#CB3234"  "rgb(203, 50, 52)"  "rgba(203, 50, 52,255)"  "3028_Reinrot"
#RALng_3031= $2824B3;  $FF2824B3  "#B32428"  "rgb(179, 36, 40)"  "rgba(179, 36, 40,255)"  "3031_Orientrot"
#RALng_3032= $221472;  $FF221472  "#721422"  "rgb(114, 20, 34)"  "rgba(114, 20, 34,255)"  "3032_Perlrubinrot"
#RALng_3033= $434CB4;  $FF434CB4  "#B44C43"  "rgb(180, 76, 67)"  "rgba(180, 76, 67,255)"  "3033_Perlrosa"
#RALng_4001= $5B3F6D;  $FF5B3F6D  "#6D3F5B"  "rgb(109, 63, 91)"  "rgba(109, 63, 91,255)"  "4001_Rotlila"
#RALng_4002= $3E2B92;  $FF3E2B92  "#922B3E"  "rgb(146, 43, 62)"  "rgba(146, 43, 62,255)"  "4002_Rotviolett"
#RALng_4003= $8A4CDE;  $FF8A4CDE  "#DE4C8A"  "rgb(222, 76,138)"  "rgba(222, 76,138,255)"  "4003_Erikaviolett"
#RALng_4004= $341C64;  $FF341C64  "#641C34"  "rgb(100, 28, 52)"  "rgba(100, 28, 52,255)"  "4004_Bordeauxviolett"
#RALng_4005= $75466C;  $FF75466C  "#6C4675"  "rgb(108, 70,117)"  "rgba(108, 70,117,255)"  "4005_Blaulila"
#RALng_4006= $7234A0;  $FF7234A0  "#A03472"  "rgb(160, 52,114)"  "rgba(160, 52,114,255)"  "4006_Verkehrspurpur"
#RALng_4007= $2C194A;  $FF2C194A  "#4A192C"  "rgb( 74, 25, 44)"  "rgba( 74, 25, 44,255)"  "4007_Purpurviolett"
#RALng_4008= $7D4E92;  $FF7D4E92  "#924E7D"  "rgb(146, 78,125)"  "rgba(146, 78,125,255)"  "4008_Signalviolett"
#RALng_4009= $9485A1;  $FF9485A1  "#A18594"  "rgb(161,133,148)"  "rgba(161,133,148,255)"  "4009_Pastellviolett"
#RALng_4010= $7634CF;  $FF7634CF  "#CF3476"  "rgb(207, 52,118)"  "rgba(207, 52,118,255)"  "4010_Telemagenta"
#RALng_4011= $A17386;  $FFA17386  "#8673A1"  "rgb(134,115,161)"  "rgba(134,115,161,255)"  "4011_Perlviolett"
#RALng_4012= $74686C;  $FF74686C  "#6C6874"  "rgb(108,104,116)"  "rgba(108,104,116,255)"  "4012_Perlbrombeer"
#RALng_5000= $734D35;  $FF734D35  "#354D73"  "rgb( 53, 77,115)"  "rgba( 53, 77,115,255)"  "5000_Violettblau"
#RALng_5001= $38341F;  $FF38341F  "#1F3438"  "rgb( 31, 52, 56)"  "rgba( 31, 52, 56,255)"  "5001_Gruenblau"
#RALng_5002= $4F2120;  $FF4F2120  "#20214F"  "rgb( 32, 33, 79)"  "rgba( 32, 33, 79,255)"  "5002_Ultramarinblau"
#RALng_5003= $331E1D;  $FF331E1D  "#1D1E33"  "rgb( 29, 30, 51)"  "rgba( 29, 30, 51,255)"  "5003_Saphirblau"
#RALng_5004= $1C1718;  $FF1C1718  "#18171C"  "rgb( 24, 23, 28)"  "rgba( 24, 23, 28,255)"  "5004_Schwarzblau"
#RALng_5005= $60241E;  $FF60241E  "#1E2460"  "rgb( 30, 36, 96)"  "rgba( 30, 36, 96,255)"  "5005_Signalblau"
#RALng_5007= $8A5F3E;  $FF8A5F3E  "#3E5F8A"  "rgb( 62, 95,138)"  "rgba( 62, 95,138,255)"  "5007_Brillantblau"
#RALng_5008= $2D2526;  $FF2D2526  "#26252D"  "rgb( 38, 37, 45)"  "rgba( 38, 37, 45,255)"  "5008_Graublau"
#RALng_5009= $695602;  $FF695602  "#025669"  "rgb(  2, 86,105)"  "rgba(  2, 86,105,255)"  "5009_Azurblau"
#RALng_5010= $4B290E;  $FF4B290E  "#0E294B"  "rgb( 14, 41, 75)"  "rgba( 14, 41, 75,255)"  "5010_Enzianblau"
#RALng_5011= $241A23;  $FF241A23  "#231A24"  "rgb( 35, 26, 36)"  "rgba( 35, 26, 36,255)"  "5011_Stahlblau"
#RALng_5012= $BD833B;  $FFBD833B  "#3B83BD"  "rgb( 59,131,189)"  "rgba( 59,131,189,255)"  "5012_Lichtblau"
#RALng_5013= $3D211E;  $FF3D211E  "#1E213D"  "rgb( 30, 33, 61)"  "rgba( 30, 33, 61,255)"  "5013_Kobaltblau"
#RALng_5014= $8C6E60;  $FF8C6E60  "#606E8C"  "rgb( 96,110,140)"  "rgba( 96,110,140,255)"  "5014_Taubenblau"
#RALng_5015= $B37122;  $FFB37122  "#2271B3"  "rgb( 34,113,179)"  "rgba( 34,113,179,255)"  "5015_Himmelblau"
#RALng_5017= $713906;  $FF713906  "#063971"  "rgb(  6, 57,113)"  "rgba(  6, 57,113,255)"  "5017_Verkehrsblau"
#RALng_5018= $8F883F;  $FF8F883F  "#3F888F"  "rgb( 63,136,143)"  "rgba( 63,136,143,255)"  "5018_Tuerkisblau"
#RALng_5019= $83551B;  $FF83551B  "#1B5583"  "rgb( 27, 85,131)"  "rgba( 27, 85,131,255)"  "5019_Capriblau"
#RALng_5020= $4A331D;  $FF4A331D  "#1D334A"  "rgb( 29, 51, 74)"  "rgba( 29, 51, 74,255)"  "5020_Ozeanblau"
#RALng_5021= $7B6D25;  $FF7B6D25  "#256D7B"  "rgb( 37,109,123)"  "rgba( 37,109,123,255)"  "5021_Wasserblau"
#RALng_5022= $502825;  $FF502825  "#252850"  "rgb( 37, 40, 80)"  "rgba( 37, 40, 80,255)"  "5022_Nachtblau"
#RALng_5023= $8D6749;  $FF8D6749  "#49678D"  "rgb( 73,103,141)"  "rgba( 73,103,141,255)"  "5023_Fernblau"
#RALng_5024= $9B9B5D;  $FF9B9B5D  "#5D9B9B"  "rgb( 93,155,155)"  "rgba( 93,155,155,255)"  "5024_Pastellblau"
#RALng_5025= $78642A;  $FF78642A  "#2A6478"  "rgb( 42,100,120)"  "rgba( 42,100,120,255)"  "5025_Perlenzian"
#RALng_5026= $542C10;  $FF542C10  "#102C54"  "rgb( 16, 44, 84)"  "rgba( 16, 44, 84,255)"  "5026_Perlnachtblau"
#RALng_6000= $506631;  $FF506631  "#316650"  "rgb( 49,102, 80)"  "rgba( 49,102, 80,255)"  "6000_Patinagruen"
#RALng_6001= $337228;  $FF337228  "#287233"  "rgb( 40,114, 51)"  "rgba( 40,114, 51,255)"  "6001_Smaragdgruen"
#RALng_6002= $2C572D;  $FF2C572D  "#2D572C"  "rgb( 45, 87, 44)"  "rgba( 45, 87, 44,255)"  "6002_Laubgruen"
#RALng_6003= $324642;  $FF324642  "#424632"  "rgb( 66, 70, 50)"  "rgba( 66, 70, 50,255)"  "6003_Olivgruen"
#RALng_6004= $3D3A1F;  $FF3D3A1F  "#1F3A3D"  "rgb( 31, 58, 61)"  "rgba( 31, 58, 61,255)"  "6004_Blaugruen"
#RALng_6005= $38452F;  $FF38452F  "#2F4538"  "rgb( 47, 69, 56)"  "rgba( 47, 69, 56,255)"  "6005_Moosgruen"
#RALng_6006= $323B3E;  $FF323B3E  "#3E3B32"  "rgb( 62, 59, 50)"  "rgba( 62, 59, 50,255)"  "6006_Grauoliv"
#RALng_6007= $293B34;  $FF293B34  "#343B29"  "rgb( 52, 59, 41)"  "rgba( 52, 59, 41,255)"  "6007_Flaschengruen"
#RALng_6008= $2A3539;  $FF2A3539  "#39352A"  "rgb( 57, 53, 42)"  "rgba( 57, 53, 42,255)"  "6008_Braungruen"
#RALng_6009= $2B3731;  $FF2B3731  "#31372B"  "rgb( 49, 55, 43)"  "rgba( 49, 55, 43,255)"  "6009_Tannengruen"
#RALng_6010= $2D6835;  $FF2D6835  "#35682D"  "rgb( 53,104, 45)"  "rgba( 53,104, 45,255)"  "6010_Grasgruen"
#RALng_6011= $467258;  $FF467258  "#587246"  "rgb( 88,114, 70)"  "rgba( 88,114, 70,255)"  "6011_Resedagruen"
#RALng_6012= $403E34;  $FF403E34  "#343E40"  "rgb( 52, 62, 64)"  "rgba( 52, 62, 64,255)"  "6012_Schwarzgruen"
#RALng_6013= $56716C;  $FF56716C  "#6C7156"  "rgb(108,113, 86)"  "rgba(108,113, 86,255)"  "6013_Schilfgruen"
#RALng_6014= $2E4047;  $FF2E4047  "#47402E"  "rgb( 71, 64, 46)"  "rgba( 71, 64, 46,255)"  "6014_Gelboliv"
#RALng_6015= $363C3B;  $FF363C3B  "#3B3C36"  "rgb( 59, 60, 54)"  "rgba( 59, 60, 54,255)"  "6015_Schwarzoliv"
#RALng_6016= $45591E;  $FF45591E  "#1E5945"  "rgb( 30, 89, 69)"  "rgba( 30, 89, 69,255)"  "6016_Tuerkisgruen"
#RALng_6017= $41914C;  $FF41914C  "#4C9141"  "rgb( 76,145, 65)"  "rgba( 76,145, 65,255)"  "6017_Maigruen"
#RALng_6018= $39A657;  $FF39A657  "#57A639"  "rgb( 87,166, 57)"  "rgba( 87,166, 57,255)"  "6018_Gelbgruen"
#RALng_6019= $B6ECBD;  $FFB6ECBD  "#BDECB6"  "rgb(189,236,182)"  "rgba(189,236,182,255)"  "6019_Weissgruen"
#RALng_6020= $233A2E;  $FF233A2E  "#2E3A23"  "rgb( 46, 58, 35)"  "rgba( 46, 58, 35,255)"  "6020_Chromoxidgruen"
#RALng_6021= $76AC89;  $FF76AC89  "#89AC76"  "rgb(137,172,118)"  "rgba(137,172,118,255)"  "6021_Blassgruen"
#RALng_6022= $1B2225;  $FF1B2225  "#25221B"  "rgb( 37, 34, 27)"  "rgba( 37, 34, 27,255)"  "6022_Braunoliv"
#RALng_6024= $468430;  $FF468430  "#308446"  "rgb( 48,132, 70)"  "rgba( 48,132, 70,255)"  "6024_Verkehrsgruen"
#RALng_6025= $2D643D;  $FF2D643D  "#3D642D"  "rgb( 61,100, 45)"  "rgba( 61,100, 45,255)"  "6025_Farngruen"
#RALng_6026= $525D01;  $FF525D01  "#015D52"  "rgb(  1, 93, 82)"  "rgba(  1, 93, 82,255)"  "6026_Opalgruen"
#RALng_6027= $BEC384;  $FFBEC384  "#84C3BE"  "rgb(132,195,190)"  "rgba(132,195,190,255)"  "6027_Lichtgruen"
#RALng_6028= $45552C;  $FF45552C  "#2C5545"  "rgb( 44, 85, 69)"  "rgba( 44, 85, 69,255)"  "6028_Kieferngruen"
#RALng_6029= $3D6020;  $FF3D6020  "#20603D"  "rgb( 32, 96, 61)"  "rgba( 32, 96, 61,255)"  "6029_Minzgruen"
#RALng_6032= $437F31;  $FF437F31  "#317F43"  "rgb( 49,127, 67)"  "rgba( 49,127, 67,255)"  "6032_Signalgruen"
#RALng_6033= $767E49;  $FF767E49  "#497E76"  "rgb( 73,126,118)"  "rgba( 73,126,118,255)"  "6033_Minttuerkis"
#RALng_6034= $B5B57F;  $FFB5B57F  "#7FB5B5"  "rgb(127,181,181)"  "rgba(127,181,181,255)"  "6034_Pastelltuerkis"
#RALng_6035= $2D541C;  $FF2D541C  "#1C542D"  "rgb( 28, 84, 45)"  "rgba( 28, 84, 45,255)"  "6035_Perlgruen"
#RALng_6036= $373719;  $FF373719  "#193737"  "rgb( 25, 55, 55)"  "rgba( 25, 55, 55,255)"  "6036_Perlopalgruen"
#RALng_6037= $398F00;  $FF398F00  "#008F39"  "rgb(  0,143, 57)"  "rgba(  0,143, 57,255)"  "6037_Reingruen"
#RALng_6038= $2DBB00;  $FF2DBB00  "#00BB2D"  "rgb(  0,187, 45)"  "rgba(  0,187, 45,255)"  "6038_Leuchtgruen"
#RALng_7000= $8B8578;  $FF8B8578  "#78858B"  "rgb(120,133,139)"  "rgba(120,133,139,255)"  "7000_Fehgrau"
#RALng_7001= $97958A;  $FF97958A  "#8A9597"  "rgb(138,149,151)"  "rgba(138,149,151,255)"  "7001_Silbergrau"
#RALng_7002= $527B7E;  $FF527B7E  "#7E7B52"  "rgb(126,123, 82)"  "rgba(126,123, 82,255)"  "7002_Olivgrau"
#RALng_7003= $59706C;  $FF59706C  "#6C7059"  "rgb(108,112, 89)"  "rgba(108,112, 89,255)"  "7003_Moosgrau"
#RALng_7004= $929996;  $FF929996  "#969992"  "rgb(150,153,146)"  "rgba(150,153,146,255)"  "7004_Signalgrau"
#RALng_7005= $636B64;  $FF636B64  "#646B63"  "rgb(100,107, 99)"  "rgba(100,107, 99,255)"  "7005_Mausgrau"
#RALng_7006= $52656D;  $FF52656D  "#6D6552"  "rgb(109,101, 82)"  "rgba(109,101, 82,255)"  "7006_Beigegrau"
#RALng_7008= $315F6A;  $FF315F6A  "#6A5F31"  "rgb(106, 95, 49)"  "rgba(106, 95, 49,255)"  "7008_Khakigrau"
#RALng_7009= $45564D;  $FF45564D  "#4D5645"  "rgb( 77, 86, 69)"  "rgba( 77, 86, 69,255)"  "7009_Gruengrau"
#RALng_7010= $4A514C;  $FF4A514C  "#4C514A"  "rgb( 76, 81, 74)"  "rgba( 76, 81, 74,255)"  "7010_Zeltgrau"
#RALng_7011= $4D4B43;  $FF4D4B43  "#434B4D"  "rgb( 67, 75, 77)"  "rgba( 67, 75, 77,255)"  "7011_Eisengrau"
#RALng_7012= $54574E;  $FF54574E  "#4E5754"  "rgb( 78, 87, 84)"  "rgba( 78, 87, 84,255)"  "7012_Basaltgrau"
#RALng_7013= $314546;  $FF314546  "#464531"  "rgb( 70, 69, 49)"  "rgba( 70, 69, 49,255)"  "7013_Braungrau"
#RALng_7015= $504743;  $FF504743  "#434750"  "rgb( 67, 71, 80)"  "rgba( 67, 71, 80,255)"  "7015_Schiefergrau"
#RALng_7016= $333129;  $FF333129  "#293133"  "rgb( 41, 49, 51)"  "rgba( 41, 49, 51,255)"  "7016_Anthrazitgrau"
#RALng_7021= $2B2823;  $FF2B2823  "#23282B"  "rgb( 35, 40, 43)"  "rgba( 35, 40, 43,255)"  "7021_Schwarzgrau"
#RALng_7022= $2C2F33;  $FF2C2F33  "#332F2C"  "rgb( 51, 47, 44)"  "rgba( 51, 47, 44,255)"  "7022_Umbragrau"
#RALng_7023= $5E6C68;  $FF5E6C68  "#686C5E"  "rgb(104,108, 94)"  "rgba(104,108, 94,255)"  "7023_Betongrau"
#RALng_7024= $514A47;  $FF514A47  "#474A51"  "rgb( 71, 74, 81)"  "rgba( 71, 74, 81,255)"  "7024_Graphitgrau"
#RALng_7026= $3B352F;  $FF3B352F  "#2F353B"  "rgb( 47, 53, 59)"  "rgba( 47, 53, 59,255)"  "7026_Granitgrau"
#RALng_7030= $7A8C8B;  $FF7A8C8B  "#8B8C7A"  "rgb(139,140,122)"  "rgba(139,140,122,255)"  "7030_Steingrau"
#RALng_7031= $4E4B47;  $FF4E4B47  "#474B4E"  "rgb( 71, 75, 78)"  "rgba( 71, 75, 78,255)"  "7031_Blaugrau"
#RALng_7032= $99B7B8;  $FF99B7B8  "#B8B799"  "rgb(184,183,153)"  "rgba(184,183,153,255)"  "7032_Kieselgrau"
#RALng_7033= $71847D;  $FF71847D  "#7D8471"  "rgb(125,132,113)"  "rgba(125,132,113,255)"  "7033_Zementgrau"
#RALng_7034= $668B8F;  $FF668B8F  "#8F8B66"  "rgb(143,139,102)"  "rgba(143,139,102,255)"  "7034_Gelbgrau"
#RALng_7035= $D7D7D7;  $FFD7D7D7  "#D7D7D7"  "rgb(215,215,215)"  "rgba(215,215,215,255)"  "7035_Lichtgrau"
#RALng_7036= $79767F;  $FF79767F  "#7F7679"  "rgb(127,118,121)"  "rgba(127,118,121,255)"  "7036_Platingrau"
#RALng_7037= $7D7F7D;  $FF7D7F7D  "#7D7F7D"  "rgb(125,127,125)"  "rgba(125,127,125,255)"  "7037_Staubgrau"
#RALng_7038= $B1B8B5;  $FFB1B8B5  "#B5B8B1"  "rgb(181,184,177)"  "rgba(181,184,177,255)"  "7038_Achatgrau"
#RALng_7039= $60696C;  $FF60696C  "#6C6960"  "rgb(108,105, 96)"  "rgba(108,105, 96,255)"  "7039_Quarzgrau"
#RALng_7040= $AAA19D;  $FFAAA19D  "#9DA1AA"  "rgb(157,161,170)"  "rgba(157,161,170,255)"  "7040_Fenstergrau"
#RALng_7042= $8D948D;  $FF8D948D  "#8D948D"  "rgb(141,148,141)"  "rgba(141,148,141,255)"  "7042_VerkehrsgrauA"
#RALng_7043= $52544E;  $FF52544E  "#4E5452"  "rgb( 78, 84, 82)"  "rgba( 78, 84, 82,255)"  "7043_VerkehrsgrauB"
#RALng_7044= $B0C4CA;  $FFB0C4CA  "#CAC4B0"  "rgb(202,196,176)"  "rgba(202,196,176,255)"  "7044_Seidengrau"
#RALng_7045= $909090;  $FF909090  "#909090"  "rgb(144,144,144)"  "rgba(144,144,144,255)"  "7045_Telegrau1"
#RALng_7046= $8F8982;  $FF8F8982  "#82898F"  "rgb(130,137,143)"  "rgba(130,137,143,255)"  "7046_Telegrau2"
#RALng_7047= $D0D0D0;  $FFD0D0D0  "#D0D0D0"  "rgb(208,208,208)"  "rgba(208,208,208,255)"  "7047_Telegrau4"
#RALng_7048= $768189;  $FF768189  "#898176"  "rgb(137,129,118)"  "rgba(137,129,118,255)"  "7048_Perlmausgrau"
#RALng_8000= $346C82;  $FF346C82  "#826C34"  "rgb(130,108, 52)"  "rgba(130,108, 52,255)"  "8000_Gruenbraun"
#RALng_8001= $205F95;  $FF205F95  "#955F20"  "rgb(149, 95, 32)"  "rgba(149, 95, 32,255)"  "8001_Ockerbraun"
#RALng_8002= $2A3B6C;  $FF2A3B6C  "#6C3B2A"  "rgb(108, 59, 42)"  "rgba(108, 59, 42,255)"  "8002_Signalbraun"
#RALng_8003= $224273;  $FF224273  "#734222"  "rgb(115, 66, 34)"  "rgba(115, 66, 34,255)"  "8003_Lehmbraun"
#RALng_8004= $2A408E;  $FF2A408E  "#8E402A"  "rgb(142, 64, 42)"  "rgba(142, 64, 42,255)"  "8004_Kupferbraun"
#RALng_8007= $1F3559;  $FF1F3559  "#59351F"  "rgb( 89, 53, 31)"  "rgba( 89, 53, 31,255)"  "8007_Rehbraun"
#RALng_8008= $284F6F;  $FF284F6F  "#6F4F28"  "rgb(111, 79, 40)"  "rgba(111, 79, 40,255)"  "8008_Olivbraun"
#RALng_8011= $293A5B;  $FF293A5B  "#5B3A29"  "rgb( 91, 58, 41)"  "rgba( 91, 58, 41,255)"  "8011_Nussbraun"
#RALng_8012= $212359;  $FF212359  "#592321"  "rgb( 89, 35, 33)"  "rgba( 89, 35, 33,255)"  "8012_Rotbraun"
#RALng_8014= $1E2C38;  $FF1E2C38  "#382C1E"  "rgb( 56, 44, 30)"  "rgba( 56, 44, 30,255)"  "8014_Sepiabraun"
#RALng_8015= $343A63;  $FF343A63  "#633A34"  "rgb( 99, 58, 52)"  "rgba( 99, 58, 52,255)"  "8015_Kastanienbraun"
#RALng_8016= $272F4C;  $FF272F4C  "#4C2F27"  "rgb( 76, 47, 39)"  "rgba( 76, 47, 39,255)"  "8016_Mahagonibraun"
#RALng_8017= $2E3245;  $FF2E3245  "#45322E"  "rgb( 69, 50, 46)"  "rgba( 69, 50, 46,255)"  "8017_SchokoladenBraun"
#RALng_8019= $3A3A40;  $FF3A3A40  "#403A3A"  "rgb( 64, 58, 58)"  "rgba( 64, 58, 58,255)"  "8019_Graubraun"
#RALng_8022= $212121;  $FF212121  "#212121"  "rgb( 33, 33, 33)"  "rgba( 33, 33, 33,255)"  "8022_Schwarzbraun"
#RALng_8023= $2E5EA6;  $FF2E5EA6  "#A65E2E"  "rgb(166, 94, 46)"  "rgba(166, 94, 46,255)"  "8023_Orangebraun"
#RALng_8024= $3D5579;  $FF3D5579  "#79553D"  "rgb(121, 85, 61)"  "rgba(121, 85, 61,255)"  "8024_Beigebraun"
#RALng_8025= $485C75;  $FF485C75  "#755C48"  "rgb(117, 92, 72)"  "rgba(117, 92, 72,255)"  "8025_Blassbraun"
#RALng_8028= $313B4E;  $FF313B4E  "#4E3B31"  "rgb( 78, 59, 49)"  "rgba( 78, 59, 49,255)"  "8028_Terrabraun"
#RALng_8029= $283C76;  $FF283C76  "#763C28"  "rgb(118, 60, 40)"  "rgba(118, 60, 40,255)"  "8029_Perlkupfer"
#RALng_9001= $E3F4FD;  $FFE3F4FD  "#FDF4E3"  "rgb(253,244,227)"  "rgba(253,244,227,255)"  "9001_Cremeweiss"
#RALng_9002= $DAEBE7;  $FFDAEBE7  "#E7EBDA"  "rgb(231,235,218)"  "rgba(231,235,218,255)"  "9002_Grauweiss"
#RALng_9003= $F4F4F4;  $FFF4F4F4  "#F4F4F4"  "rgb(244,244,244)"  "rgba(244,244,244,255)"  "9003_Signalweiss"
#RALng_9004= $282828;  $FF282828  "#282828"  "rgb( 40, 40, 40)"  "rgba( 40, 40, 40,255)"  "9004_Signalschwarz"
#RALng_9005= $0A0A0A;  $FF0A0A0A  "#0A0A0A"  "rgb( 10, 10, 10)"  "rgba( 10, 10, 10,255)"  "9005_Tiefschwarz"
#RALng_9006= $A5A5A5;  $FFA5A5A5  "#A5A5A5"  "rgb(165,165,165)"  "rgba(165,165,165,255)"  "9006_Weissaluminium"
#RALng_9007= $8F8F8F;  $FF8F8F8F  "#8F8F8F"  "rgb(143,143,143)"  "rgba(143,143,143,255)"  "9007_Graualuminium"
#RALng_9010= $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "9010_Reinweiss"
#RALng_9011= $1C1C1C;  $FF1C1C1C  "#1C1C1C"  "rgb( 28, 28, 28)"  "rgba( 28, 28, 28,255)"  "9011_Graphitschwarz"
#RALng_9016= $F6F6F6;  $FFF6F6F6  "#F6F6F6"  "rgb(246,246,246)"  "rgba(246,246,246,255)"  "9016_Verkehrsweiss"
#RALng_9017= $1E1E1E;  $FF1E1E1E  "#1E1E1E"  "rgb( 30, 30, 30)"  "rgba( 30, 30, 30,255)"  "9017_VerkehrsSchwarz"
#RALng_9018= $D7D7D7;  $FFD7D7D7  "#D7D7D7"  "rgb(215,215,215)"  "rgba(215,215,215,255)"  "9018_Papyrusweiss"
#RALng_9022= $9C9C9C;  $FF9C9C9C  "#9C9C9C"  "rgb(156,156,156)"  "rgba(156,156,156,255)"  "9022_Perlhellgrau"
#RALng_9023= $828282;  $FF828282  "#828282"  "rgb(130,130,130)"  "rgba(130,130,130,255)"  "9023_Perldunkelgrau"

;-Crayola-Crayon-Colors
;-- Crayon Standard
;  see https://en.wikipedia.org/wiki/List_of_Crayola_crayon_colors#Standard_colors
;#CryStd                       PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CryStd_Red                    = $3F0AED;  $FF3F0AED  "#ED0A3F"  "rgb(237, 10, 63)"  "rgba(237, 10, 63,255)"  "Red"
#CryStd_Maroon                 = $4821C3;  $FF4821C3  "#C32148"  "rgb(195, 33, 72)"  "rgba(195, 33, 72,255)"  "Maroon"
#CryStd_Scarlet                = $350EFD;  $FF350EFD  "#FD0E35"  "rgb(253, 14, 53)"  "rgba(253, 14, 53,255)"  "Scarlet"
#CryStd_BrickRed               = $422DC6;  $FF422DC6  "#C62D42"  "rgb(198, 45, 66)"  "rgba(198, 45, 66,255)"  "BrickRed"
#CryStd_EnglishVermilion       = $4B47CC;  $FF4B47CC  "#CC474B"  "rgb(204, 71, 75)"  "rgba(204, 71, 75,255)"  "EnglishVermilion"
#CryStd_MadderLake             = $3633CC;  $FF3633CC  "#CC3336"  "rgb(204, 51, 54)"  "rgba(204, 51, 54,255)"  "MadderLake"
#CryStd_PermanentGeraniumLake  = $2C2CE1;  $FF2C2CE1  "#E12C2C"  "rgb(225, 44, 44)"  "rgba(225, 44, 44,255)"  "PermanentGeraniumLake"
#CryStd_MaximumRed             = $2121D9;  $FF2121D9  "#D92121"  "rgb(217, 33, 33)"  "rgba(217, 33, 33,255)"  "MaximumRed"
#CryStd_IndianRed              = $484EB9;  $FF484EB9  "#B94E48"  "rgb(185, 78, 72)"  "rgba(185, 78, 72,255)"  "IndianRed"
#CryStd_Orange_Red             = $4953FF;  $FF4953FF  "#FF5349"  "rgb(255, 83, 73)"  "rgba(255, 83, 73,255)"  "Orange_Red"
#CryStd_SunsetOrange           = $404CFE;  $FF404CFE  "#FE4C40"  "rgb(254, 76, 64)"  "rgba(254, 76, 64,255)"  "SunsetOrange"
#CryStd_Bittersweet            = $5E6FFE;  $FF5E6FFE  "#FE6F5E"  "rgb(254,111, 94)"  "rgba(254,111, 94,255)"  "Bittersweet"
#CryStd_DarkVenetianRed        = $243BB3;  $FF243BB3  "#B33B24"  "rgb(179, 59, 36)"  "rgba(179, 59, 36,255)"  "DarkVenetianRed"
#CryStd_VenetianRed            = $3D55CC;  $FF3D55CC  "#CC553D"  "rgb(204, 85, 61)"  "rgba(204, 85, 61,255)"  "VenetianRed"
#CryStd_LightVenetianRed       = $5C73E6;  $FF5C73E6  "#E6735C"  "rgb(230,115, 92)"  "rgba(230,115, 92,255)"  "LightVenetianRed"
#CryStd_VividTangerine         = $8099FF;  $FF8099FF  "#FF9980"  "rgb(255,153,128)"  "rgba(255,153,128,255)"  "VividTangerine"
#CryStd_MiddleRed              = $738EE5;  $FF738EE5  "#E58E73"  "rgb(229,142,115)"  "rgba(229,142,115,255)"  "MiddleRed"
#CryStd_BurntOrange            = $497FFF;  $FF497FFF  "#FF7F49"  "rgb(255,127, 73)"  "rgba(255,127, 73,255)"  "BurntOrange"
#CryStd_Red_Orange             = $1F68FF;  $FF1F68FF  "#FF681F"  "rgb(255,104, 31)"  "rgba(255,104, 31,255)"  "Red_Orange"
#CryStd_Orange                 = $3388FF;  $FF3388FF  "#FF8833"  "rgb(255,136, 51)"  "rgba(255,136, 51,255)"  "Orange"
#CryStd_MacaroniandCheese      = $7BB9FF;  $FF7BB9FF  "#FFB97B"  "rgb(255,185,123)"  "rgba(255,185,123,255)"  "MacaroniandCheese"
#CryStd_MiddleYellowRed        = $76B1EC;  $FF76B1EC  "#ECB176"  "rgb(236,177,118)"  "rgba(236,177,118,255)"  "MiddleYellowRed"
#CryStd_MangoTango             = $0072E7;  $FF0072E7  "#E77200"  "rgb(231,114,  0)"  "rgba(231,114,  0,255)"  "MangoTango"
#CryStd_Yellow_Orange          = $42AEFF;  $FF42AEFF  "#FFAE42"  "rgb(255,174, 66)"  "rgba(255,174, 66,255)"  "Yellow_Orange"
#CryStd_MaximumYellowRed       = $49BAF2;  $FF49BAF2  "#F2BA49"  "rgb(242,186, 73)"  "rgba(242,186, 73,255)"  "MaximumYellowRed"
#CryStd_BananaMania            = $B2E7FB;  $FFB2E7FB  "#FBE7B2"  "rgb(251,231,178)"  "rgba(251,231,178,255)"  "BananaMania"
#CryStd_Maize                  = $49C6F2;  $FF49C6F2  "#F2C649"  "rgb(242,198, 73)"  "rgba(242,198, 73,255)"  "Maize"
#CryStd_Orange_Yellow          = $68D5F8;  $FF68D5F8  "#F8D568"  "rgb(248,213,104)"  "rgba(248,213,104,255)"  "Orange_Yellow"
#CryStd_Goldenrod              = $67D6FC;  $FF67D6FC  "#FCD667"  "rgb(252,214,103)"  "rgba(252,214,103,255)"  "Goldenrod"
#CryStd_Dandelion              = $5DD8FE;  $FF5DD8FE  "#FED85D"  "rgb(254,216, 93)"  "rgba(254,216, 93,255)"  "Dandelion"
#CryStd_Yellow                 = $70E8FB;  $FF70E8FB  "#FBE870"  "rgb(251,232,112)"  "rgba(251,232,112,255)"  "Yellow"
#CryStd_Green_Yellow           = $88E7F1;  $FF88E7F1  "#F1E788"  "rgb(241,231,136)"  "rgba(241,231,136,255)"  "Green_Yellow"
#CryStd_MiddleYellow           = $00EBFF;  $FF00EBFF  "#FFEB00"  "rgb(255,235,  0)"  "rgba(255,235,  0,255)"  "MiddleYellow"
#CryStd_OliveGreen             = $5CB3B5;  $FF5CB3B5  "#B5B35C"  "rgb(181,179, 92)"  "rgba(181,179, 92,255)"  "OliveGreen"
#CryStd_SpringGreen            = $BDEBEC;  $FFBDEBEC  "#ECEBBD"  "rgb(236,235,189)"  "rgba(236,235,189,255)"  "SpringGreen"
#CryStd_MaximumYellow          = $37FAFA;  $FF37FAFA  "#FAFA37"  "rgb(250,250, 55)"  "rgba(250,250, 55,255)"  "MaximumYellow"
#CryStd_Canary                 = $99FFFF;  $FF99FFFF  "#FFFF99"  "rgb(255,255,153)"  "rgba(255,255,153,255)"  "Canary"
#CryStd_LemonYellow            = $9FFFFF;  $FF9FFFFF  "#FFFF9F"  "rgb(255,255,159)"  "rgba(255,255,159,255)"  "LemonYellow"
#CryStd_MaximumGreenYellow     = $50E6D9;  $FF50E6D9  "#D9E650"  "rgb(217,230, 80)"  "rgba(217,230, 80,255)"  "MaximumGreenYellow"
#CryStd_MiddleGreenYellow      = $60BFAC;  $FF60BFAC  "#ACBF60"  "rgb(172,191, 96)"  "rgba(172,191, 96,255)"  "MiddleGreenYellow"
#CryStd_Inchworm               = $13E3AF;  $FF13E3AF  "#AFE313"  "rgb(175,227, 19)"  "rgba(175,227, 19,255)"  "Inchworm"
#CryStd_LightChromeGreen       = $4BE6BE;  $FF4BE6BE  "#BEE64B"  "rgb(190,230, 75)"  "rgba(190,230, 75,255)"  "LightChromeGreen"
#CryStd_Yellow_Green           = $7AE1C5;  $FF7AE1C5  "#C5E17A"  "rgb(197,225,122)"  "rgba(197,225,122,255)"  "Yellow_Green"
#CryStd_MaximumGreen           = $318C5E;  $FF318C5E  "#5E8C31"  "rgb( 94,140, 49)"  "rgba( 94,140, 49,255)"  "MaximumGreen"
#CryStd_Asparagus              = $5BA07B;  $FF5BA07B  "#7BA05B"  "rgb(123,160, 91)"  "rgba(123,160, 91,255)"  "Asparagus"
#CryStd_GrannySmithApple       = $93E09D;  $FF93E09D  "#9DE093"  "rgb(157,224,147)"  "rgba(157,224,147,255)"  "GrannySmithApple"
#CryStd_Fern                   = $6CB763;  $FF6CB763  "#63B76C"  "rgb( 99,183,108)"  "rgba( 99,183,108,255)"  "Fern"
#CryStd_MiddleGreen            = $578C4D;  $FF578C4D  "#4D8C57"  "rgb( 77,140, 87)"  "rgba( 77,140, 87,255)"  "MiddleGreen"
#CryStd_Green                  = $55A63A;  $FF55A63A  "#3AA655"  "rgb( 58,166, 85)"  "rgba( 58,166, 85,255)"  "Green"
#CryStd_MediumChromeGreen      = $7CA66C;  $FF7CA66C  "#6CA67C"  "rgb(108,166,124)"  "rgba(108,166,124,255)"  "MediumChromeGreen"
#CryStd_ForestGreen            = $77A75F;  $FF77A75F  "#5FA777"  "rgb( 95,167,119)"  "rgba( 95,167,119,255)"  "ForestGreen"
#CryStd_SeaGreen               = $B8DF93;  $FFB8DF93  "#93DFB8"  "rgb(147,223,184)"  "rgba(147,223,184,255)"  "SeaGreen"
#CryStd_Shamrock               = $99CC33;  $FF99CC33  "#33CC99"  "rgb( 51,204,153)"  "rgba( 51,204,153,255)"  "Shamrock"
#CryStd_MountainMeadow         = $85B31A;  $FF85B31A  "#1AB385"  "rgb( 26,179,133)"  "rgba( 26,179,133,255)"  "MountainMeadow"
#CryStd_JungleGreen            = $87AB29;  $FF87AB29  "#29AB87"  "rgb( 41,171,135)"  "rgba( 41,171,135,255)"  "JungleGreen"
#CryStd_CaribbeanGreen         = $99CC00;  $FF99CC00  "#00CC99"  "rgb(  0,204,153)"  "rgba(  0,204,153,255)"  "CaribbeanGreen"
#CryStd_TropicalRainForest     = $5E7500;  $FF5E7500  "#00755E"  "rgb(  0,117, 94)"  "rgba(  0,117, 94,255)"  "TropicalRainForest"
#CryStd_MiddleBlueGreen        = $CCD98D;  $FFCCD98D  "#8DD9CC"  "rgb(141,217,204)"  "rgba(141,217,204,255)"  "MiddleBlueGreen"
#CryStd_PineGreen              = $6F7801;  $FF6F7801  "#01786F"  "rgb(  1,120,111)"  "rgba(  1,120,111,255)"  "PineGreen"
#CryStd_MaximumBlueGreen       = $BFBF30;  $FFBFBF30  "#30BFBF"  "rgb( 48,191,191)"  "rgba( 48,191,191,255)"  "MaximumBlueGreen"
#CryStd_RobinsEggBlue          = $CCCC00;  $FFCCCC00  "#00CCCC"  "rgb(  0,204,204)"  "rgba(  0,204,204,255)"  "RobinsEggBlue"
#CryStd_TealBlue               = $808000;  $FF808000  "#008080"  "rgb(  0,128,128)"  "rgba(  0,128,128,255)"  "TealBlue"
#CryStd_LightBlue              = $D8D88F;  $FFD8D88F  "#8FD8D8"  "rgb(143,216,216)"  "rgba(143,216,216,255)"  "LightBlue"
#CryStd_Aquamarine             = $E8E095;  $FFE8E095  "#95E0E8"  "rgb(149,224,232)"  "rgba(149,224,232,255)"  "Aquamarine"
#CryStd_TurquoiseBlue          = $E7DA6C;  $FFE7DA6C  "#6CDAE7"  "rgb(108,218,231)"  "rgba(108,218,231,255)"  "TurquoiseBlue"
#CryStd_OuterSpace             = $3A382D;  $FF3A382D  "#2D383A"  "rgb( 45, 56, 58)"  "rgba( 45, 56, 58,255)"  "OuterSpace"
#CryStd_SkyBlue                = $EAD776;  $FFEAD776  "#76D7EA"  "rgb(118,215,234)"  "rgba(118,215,234,255)"  "SkyBlue"
#CryStd_MiddleBlue             = $E6D47E;  $FFE6D47E  "#7ED4E6"  "rgb(126,212,230)"  "rgba(126,212,230,255)"  "MiddleBlue"
#CryStd_Blue_Green             = $B79500;  $FFB79500  "#0095B7"  "rgb(  0,149,183)"  "rgba(  0,149,183,255)"  "Blue_Green"
#CryStd_PacificBlue            = $C49D00;  $FFC49D00  "#009DC4"  "rgb(  0,157,196)"  "rgba(  0,157,196,255)"  "PacificBlue"
#CryStd_Cerulean               = $D3A402;  $FFD3A402  "#02A4D3"  "rgb(  2,164,211)"  "rgba(  2,164,211,255)"  "Cerulean"
#CryStd_MaximumBlue            = $CCAB47;  $FFCCAB47  "#47ABCC"  "rgb( 71,171,204)"  "rgba( 71,171,204,255)"  "MaximumBlue"
#CryStd_BlueI                  = $D09749;  $FFD09749  "#4997D0"  "rgb( 73,151,208)"  "rgba( 73,151,208,255)"  "BlueI"
#CryStd_CeruleanBlue           = $CC9A33;  $FFCC9A33  "#339ACC"  "rgb( 51,154,204)"  "rgba( 51,154,204,255)"  "CeruleanBlue"
#CryStd_Cornflower             = $EACC93;  $FFEACC93  "#93CCEA"  "rgb(147,204,234)"  "rgba(147,204,234,255)"  "Cornflower"
#CryStd_Green_Blue             = $C88728;  $FFC88728  "#2887C8"  "rgb( 40,135,200)"  "rgba( 40,135,200,255)"  "Green_Blue"
#CryStd_MidnightBlue           = $8C4600;  $FF8C4600  "#00468C"  "rgb(  0, 70,140)"  "rgba(  0, 70,140,255)"  "MidnightBlue"
#CryStd_NavyBlue               = $CC6600;  $FFCC6600  "#0066CC"  "rgb(  0,102,204)"  "rgba(  0,102,204,255)"  "NavyBlue"
#CryStd_Denim                  = $BD6015;  $FFBD6015  "#1560BD"  "rgb( 21, 96,189)"  "rgba( 21, 96,189,255)"  "Denim"
#CryStd_Blue3                  = $FF6600;  $FFFF6600  "#0066FF"  "rgb(  0,102,255)"  "rgba(  0,102,255,255)"  "Blue3"
#CryStd_CadetBlue              = $C3B2A9;  $FFC3B2A9  "#A9B2C3"  "rgb(169,178,195)"  "rgba(169,178,195,255)"  "CadetBlue"
#CryStd_Periwinkle             = $E6CDC3;  $FFE6CDC3  "#C3CDE6"  "rgb(195,205,230)"  "rgba(195,205,230,255)"  "Periwinkle"
#CryStd_Blue2                  = $E67045;  $FFE67045  "#4570E6"  "rgb( 69,112,230)"  "rgba( 69,112,230,255)"  "Blue2"
#CryStd_WildBlueYonder         = $B8897A;  $FFB8897A  "#7A89B8"  "rgb(122,137,184)"  "rgba(122,137,184,255)"  "WildBlueYonder"
#CryStd_Indigo                 = $C6694F;  $FFC6694F  "#4F69C6"  "rgb( 79,105,198)"  "rgba( 79,105,198,255)"  "Indigo"
#CryStd_Manatee                = $A1908D;  $FFA1908D  "#8D90A1"  "rgb(141,144,161)"  "rgba(141,144,161,255)"  "Manatee"
#CryStd_CobaltBlue             = $C8908C;  $FFC8908C  "#8C90C8"  "rgb(140,144,200)"  "rgba(140,144,200,255)"  "CobaltBlue"
#CryStd_CelestialBlue          = $CC7070;  $FFCC7070  "#7070CC"  "rgb(112,112,204)"  "rgba(112,112,204,255)"  "CelestialBlue"
#CryStd_BlueBell               = $CC9999;  $FFCC9999  "#9999CC"  "rgb(153,153,204)"  "rgba(153,153,204,255)"  "BlueBell"
#CryStd_MaximumBluePurple      = $E6ACAC;  $FFE6ACAC  "#ACACE6"  "rgb(172,172,230)"  "rgba(172,172,230,255)"  "MaximumBluePurple"
#CryStd_Violet_Blue            = $C86E76;  $FFC86E76  "#766EC8"  "rgb(118,110,200)"  "rgba(118,110,200,255)"  "Violet_Blue"
#CryStd_Blue_Violet            = $B75664;  $FFB75664  "#6456B7"  "rgb(100, 86,183)"  "rgba(100, 86,183,255)"  "Blue_Violet"
#CryStd_UltramarineBlue        = $BF263F;  $FFBF263F  "#3F26BF"  "rgb( 63, 38,191)"  "rgba( 63, 38,191,255)"  "UltramarineBlue"
#CryStd_MiddleBluePurple       = $BE728B;  $FFBE728B  "#8B72BE"  "rgb(139,114,190)"  "rgba(139,114,190,255)"  "MiddleBluePurple"
#CryStd_PurpleHeart            = $C12D65;  $FFC12D65  "#652DC1"  "rgb(101, 45,193)"  "rgba(101, 45,193,255)"  "PurpleHeart"
#CryStd_RoyalPurple            = $A03F6B;  $FFA03F6B  "#6B3FA0"  "rgb(107, 63,160)"  "rgba(107, 63,160,255)"  "RoyalPurple"
#CryStd_Violet2                = $A35983;  $FFA35983  "#8359A3"  "rgb(131, 89,163)"  "rgba(131, 89,163,255)"  "Violet2"
#CryStd_MediumViolet           = $B3478F;  $FFB3478F  "#8F47B3"  "rgb(143, 71,179)"  "rgba(143, 71,179,255)"  "MediumViolet"
#CryStd_Wisteria               = $DCA0C9;  $FFDCA0C9  "#C9A0DC"  "rgb(201,160,220)"  "rgba(201,160,220,255)"  "Wisteria"
#CryStd_Lavender1              = $CC8FBF;  $FFCC8FBF  "#BF8FCC"  "rgb(191,143,204)"  "rgba(191,143,204,255)"  "Lavender1"
#CryStd_VividViolet            = $903780;  $FF903780  "#803790"  "rgb(128, 55,144)"  "rgba(128, 55,144,255)"  "VividViolet"
#CryStd_MaximumPurple          = $803373;  $FF803373  "#733380"  "rgb(115, 51,128)"  "rgba(115, 51,128,255)"  "MaximumPurple"
#CryStd_PurpleMountainsMajesty = $DDAED6;  $FFDDAED6  "#D6AEDD"  "rgb(214,174,221)"  "rgba(214,174,221,255)"  "PurpleMountainsMajesty"
#CryStd_Fuchsia                = $C154C1;  $FFC154C1  "#C154C1"  "rgb(193, 84,193)"  "rgba(193, 84,193,255)"  "Fuchsia"
#CryStd_PinkFlamingo           = $FD74FC;  $FFFD74FC  "#FC74FD"  "rgb(252,116,253)"  "rgba(252,116,253,255)"  "PinkFlamingo"
#CryStd_Violet1                = $6C2E73;  $FF6C2E73  "#732E6C"  "rgb(115, 46,108)"  "rgba(115, 46,108,255)"  "Violet1"
#CryStd_BrilliantRose          = $CE67E6;  $FFCE67E6  "#E667CE"  "rgb(230,103,206)"  "rgba(230,103,206,255)"  "BrilliantRose"
#CryStd_Orchid                 = $D29CE2;  $FFD29CE2  "#E29CD2"  "rgb(226,156,210)"  "rgba(226,156,210,255)"  "Orchid"
#CryStd_Plum                   = $79318E;  $FF79318E  "#8E3179"  "rgb(142, 49,121)"  "rgba(142, 49,121,255)"  "Plum"
#CryStd_MediumRose             = $BE6CD9;  $FFBE6CD9  "#D96CBE"  "rgb(217,108,190)"  "rgba(217,108,190,255)"  "MediumRose"
#CryStd_Thistle                = $D7B0EB;  $FFD7B0EB  "#EBB0D7"  "rgb(235,176,215)"  "rgba(235,176,215,255)"  "Thistle"
#CryStd_Mulberry               = $9B50C8;  $FF9B50C8  "#C8509B"  "rgb(200, 80,155)"  "rgba(200, 80,155,255)"  "Mulberry"
#CryStd_Red_Violet             = $8533BB;  $FF8533BB  "#BB3385"  "rgb(187, 51,133)"  "rgba(187, 51,133,255)"  "Red_Violet"
#CryStd_MiddlePurple           = $B582D9;  $FFB582D9  "#D982B5"  "rgb(217,130,181)"  "rgba(217,130,181,255)"  "MiddlePurple"
#CryStd_MaximumRedPurple       = $793AA6;  $FF793AA6  "#A63A79"  "rgb(166, 58,121)"  "rgba(166, 58,121,255)"  "MaximumRedPurple"
#CryStd_JazzberryJam           = $5E0BA5;  $FF5E0BA5  "#A50B5E"  "rgb(165, 11, 94)"  "rgba(165, 11, 94,255)"  "JazzberryJam"
#CryStd_Eggplant               = $514061;  $FF514061  "#614051"  "rgb( 97, 64, 81)"  "rgba( 97, 64, 81,255)"  "Eggplant"
#CryStd_Magenta                = $A653F6;  $FFA653F6  "#F653A6"  "rgb(246, 83,166)"  "rgba(246, 83,166,255)"  "Magenta"
#CryStd_Cerise                 = $8732DA;  $FF8732DA  "#DA3287"  "rgb(218, 50,135)"  "rgba(218, 50,135,255)"  "Cerise"
#CryStd_WildStrawberry         = $9933FF;  $FF9933FF  "#FF3399"  "rgb(255, 51,153)"  "rgba(255, 51,153,255)"  "WildStrawberry"
#CryStd_Lavender2              = $D2AEFB;  $FFD2AEFB  "#FBAED2"  "rgb(251,174,210)"  "rgba(251,174,210,255)"  "Lavender2"
#CryStd_CottonCandy            = $D5B7FF;  $FFD5B7FF  "#FFB7D5"  "rgb(255,183,213)"  "rgba(255,183,213,255)"  "CottonCandy"
#CryStd_CarnationPink          = $C9A6FF;  $FFC9A6FF  "#FFA6C9"  "rgb(255,166,201)"  "rgba(255,166,201,255)"  "CarnationPink"
#CryStd_Violet_Red             = $8A46F7;  $FF8A46F7  "#F7468A"  "rgb(247, 70,138)"  "rgba(247, 70,138,255)"  "Violet_Red"
#CryStd_Razzmatazz             = $5C0BE3;  $FF5C0BE3  "#E30B5C"  "rgb(227, 11, 92)"  "rgba(227, 11, 92,255)"  "Razzmatazz"
#CryStd_PigPink                = $E4D7FD;  $FFE4D7FD  "#FDD7E4"  "rgb(253,215,228)"  "rgba(253,215,228,255)"  "PigPink"
#CryStd_Carmine                = $6B2EE6;  $FF6B2EE6  "#E62E6B"  "rgb(230, 46,107)"  "rgba(230, 46,107,255)"  "Carmine"
#CryStd_Blush                  = $7950DB;  $FF7950DB  "#DB5079"  "rgb(219, 80,121)"  "rgba(219, 80,121,255)"  "Blush"
#CryStd_TickleMePink           = $A580FC;  $FFA580FC  "#FC80A5"  "rgb(252,128,165)"  "rgba(252,128,165,255)"  "TickleMePink"
#CryStd_Mauvelous              = $A991F0;  $FFA991F0  "#F091A9"  "rgb(240,145,169)"  "rgba(240,145,169,255)"  "Mauvelous"
#CryStd_Salmon                 = $A491FF;  $FFA491FF  "#FF91A4"  "rgb(255,145,164)"  "rgba(255,145,164,255)"  "Salmon"
#CryStd_MiddleRedPurple        = $5353A5;  $FF5353A5  "#A55353"  "rgb(165, 83, 83)"  "rgba(165, 83, 83,255)"  "MiddleRedPurple"
#CryStd_Mahogany               = $3534CA;  $FF3534CA  "#CA3435"  "rgb(202, 52, 53)"  "rgba(202, 52, 53,255)"  "Mahogany"
#CryStd_Melon                  = $ADBAFE;  $FFADBAFE  "#FEBAAD"  "rgb(254,186,173)"  "rgba(254,186,173,255)"  "Melon"
#CryStd_PinkSherbert           = $8EA3F7;  $FF8EA3F7  "#F7A38E"  "rgb(247,163,142)"  "rgba(247,163,142,255)"  "PinkSherbert"
#CryStd_BurntSienna            = $5174E9;  $FF5174E9  "#E97451"  "rgb(233,116, 81)"  "rgba(233,116, 81,255)"  "BurntSienna"
#CryStd_Brown                  = $3E59AF;  $FF3E59AF  "#AF593E"  "rgb(175, 89, 62)"  "rgba(175, 89, 62,255)"  "Brown"
#CryStd_Sepia                  = $405B9E;  $FF405B9E  "#9E5B40"  "rgb(158, 91, 64)"  "rgba(158, 91, 64,255)"  "Sepia"
#CryStd_FuzzyWuzzy             = $1F4287;  $FF1F4287  "#87421F"  "rgb(135, 66, 31)"  "rgba(135, 66, 31,255)"  "FuzzyWuzzy"
#CryStd_Beaver                 = $5B6F92;  $FF5B6F92  "#926F5B"  "rgb(146,111, 91)"  "rgba(146,111, 91,255)"  "Beaver"
#CryStd_Tumbleweed             = $81A6DE;  $FF81A6DE  "#DEA681"  "rgb(222,166,129)"  "rgba(222,166,129,255)"  "Tumbleweed"
#CryStd_RawSienna              = $467DD2;  $FF467DD2  "#D27D46"  "rgb(210,125, 70)"  "rgba(210,125, 70,255)"  "RawSienna"
#CryStd_VanDykeBrown           = $284266;  $FF284266  "#664228"  "rgb(102, 66, 40)"  "rgba(102, 66, 40,255)"  "VanDykeBrown"
#CryStd_Tan                    = $6C9AD9;  $FF6C9AD9  "#D99A6C"  "rgb(217,154,108)"  "rgba(217,154,108,255)"  "Tan"
#CryStd_DesertSand             = $AFC9ED;  $FFAFC9ED  "#EDC9AF"  "rgb(237,201,175)"  "rgba(237,201,175,255)"  "DesertSand"
#CryStd_Peach                  = $A4CBFF;  $FFA4CBFF  "#FFCBA4"  "rgb(255,203,164)"  "rgba(255,203,164,255)"  "Peach"
#CryStd_BurntUmber             = $335580;  $FF335580  "#805533"  "rgb(128, 85, 51)"  "rgba(128, 85, 51,255)"  "BurntUmber"
#CryStd_Apricot                = $B1D5FD;  $FFB1D5FD  "#FDD5B1"  "rgb(253,213,177)"  "rgba(253,213,177,255)"  "Apricot"
#CryStd_Almond                 = $C4D9EE;  $FFC4D9EE  "#EED9C4"  "rgb(238,217,196)"  "rgba(238,217,196,255)"  "Almond"
#CryStd_RawUmber               = $335266;  $FF335266  "#665233"  "rgb(102, 82, 51)"  "rgba(102, 82, 51,255)"  "RawUmber"
#CryStd_Shadow                 = $507083;  $FF507083  "#837050"  "rgb(131,112, 80)"  "rgba(131,112, 80,255)"  "Shadow"
#CryStd_RawSienna1             = $5CBCE6;  $FF5CBCE6  "#E6BC5C"  "rgb(230,188, 92)"  "rgba(230,188, 92,255)"  "RawSienna1"
#CryStd_Timberwolf             = $CFD6D9;  $FFCFD6D9  "#D9D6CF"  "rgb(217,214,207)"  "rgba(217,214,207,255)"  "Timberwolf"
#CryStd_Gold1                  = $6E9292;  $FF6E9292  "#92926E"  "rgb(146,146,110)"  "rgba(146,146,110,255)"  "Gold1"
#CryStd_Gold2                  = $8ABEE6;  $FF8ABEE6  "#E6BE8A"  "rgb(230,190,138)"  "rgba(230,190,138,255)"  "Gold2"
#CryStd_Silver                 = $BBC0C9;  $FFBBC0C9  "#C9C0BB"  "rgb(201,192,187)"  "rgba(201,192,187,255)"  "Silver"
#CryStd_Copper                 = $678ADA;  $FF678ADA  "#DA8A67"  "rgb(218,138,103)"  "rgba(218,138,103,255)"  "Copper"
#CryStd_AntiqueBrass           = $658AC8;  $FF658AC8  "#C88A65"  "rgb(200,138,101)"  "rgba(200,138,101,255)"  "AntiqueBrass"
#CryStd_Black                  = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "Black"
#CryStd_CharcoalGray           = $626A73;  $FF626A73  "#736A62"  "rgb(115,106, 98)"  "rgba(115,106, 98,255)"  "CharcoalGray"
#CryStd_Gray                   = $80868B;  $FF80868B  "#8B8680"  "rgb(139,134,128)"  "rgba(139,134,128,255)"  "Gray"
#CryStd_Blue_Gray              = $CDC8C8;  $FFCDC8C8  "#C8C8CD"  "rgb(200,200,205)"  "rgba(200,200,205,255)"  "Blue_Gray"
#CryStd_White                  = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "White"

;-- Crayon Fluorescent
;#CryFlr                PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CryFlr_RadicalRed      = $5E35FF;  $FF5E35FF  "#FF355E"  "rgb(255, 53, 94)"  "rgba(255, 53, 94,255)"  "RadicalRed"
#CryFlr_WildWatermelon  = $785BFD;  $FF785BFD  "#FD5B78"  "rgb(253, 91,120)"  "rgba(253, 91,120,255)"  "WildWatermelon"
#CryFlr_OutrageousOrange= $3760FF;  $FF3760FF  "#FF6037"  "rgb(255, 96, 55)"  "rgba(255, 96, 55,255)"  "OutrageousOrange"
#CryFlr_AtomicTangerine = $6699FF;  $FF6699FF  "#FF9966"  "rgb(255,153,102)"  "rgba(255,153,102,255)"  "AtomicTangerine"
#CryFlr_NeonCarrot      = $3399FF;  $FF3399FF  "#FF9933"  "rgb(255,153, 51)"  "rgba(255,153, 51,255)"  "NeonCarrot"
#CryFlr_Sunglow         = $33CCFF;  $FF33CCFF  "#FFCC33"  "rgb(255,204, 51)"  "rgba(255,204, 51,255)"  "Sunglow"
#CryFlr_LaserLemon      = $66FFFF;  $FF66FFFF  "#FFFF66"  "rgb(255,255,102)"  "rgba(255,255,102,255)"  "LaserLemon"
#CryFlr_UnmellowYellow  = $66FFFF;  $FF66FFFF  "#FFFF66"  "rgb(255,255,102)"  "rgba(255,255,102,255)"  "UnmellowYellow"
#CryFlr_ElectricLime    = $00FFCC;  $FF00FFCC  "#CCFF00"  "rgb(204,255,  0)"  "rgba(204,255,  0,255)"  "ElectricLime"
#CryFlr_ScreaminGreen   = $66FF66;  $FF66FF66  "#66FF66"  "rgb(102,255,102)"  "rgba(102,255,102,255)"  "ScreaminGreen"
#CryFlr_MagicMint       = $D1F0AA;  $FFD1F0AA  "#AAF0D1"  "rgb(170,240,209)"  "rgba(170,240,209,255)"  "MagicMint"
#CryFlr_BlizzardBlue    = $E6BF50;  $FFE6BF50  "#50BFE6"  "rgb( 80,191,230)"  "rgba( 80,191,230,255)"  "BlizzardBlue"
#CryFlr_ShockingPink    = $FF6EFF;  $FFFF6EFF  "#FF6EFF"  "rgb(255,110,255)"  "rgba(255,110,255,255)"  "ShockingPink"
#CryFlr_RazzleDazzleRose= $D234EE;  $FFD234EE  "#EE34D2"  "rgb(238, 52,210)"  "rgba(238, 52,210,255)"  "RazzleDazzleRose"
#CryFlr_HotMagenta      = $CC00FF;  $FFCC00FF  "#FF00CC"  "rgb(255,  0,204)"  "rgba(255,  0,204,255)"  "HotMagenta"
#CryFlr_PurplePizzazz   = $CC00FF;  $FFCC00FF  "#FF00CC"  "rgb(255,  0,204)"  "rgba(255,  0,204,255)"  "PurplePizzazz"

;-- Crayon Silver Swirls
;#CrySSw                 PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CrySSw_AztecGold       = $5399C3;  $FF5399C3  "#C39953"  "rgb(195,153, 83)"  "rgba(195,153, 83,255)"  "AztecGold"
#CrySSw_BurnishedBrown  = $747AA1;  $FF747AA1  "#A17A74"  "rgb(161,122,116)"  "rgba(161,122,116,255)"  "BurnishedBrown"
#CrySSw_CeruleanFrost   = $C39B6D;  $FFC39B6D  "#6D9BC3"  "rgb(109,155,195)"  "rgba(109,155,195,255)"  "CeruleanFrost"
#CrySSw_CinnamonSatin   = $7E60CD;  $FF7E60CD  "#CD607E"  "rgb(205, 96,126)"  "rgba(205, 96,126,255)"  "CinnamonSatin"
#CrySSw_CopperPenny     = $696FAD;  $FF696FAD  "#AD6F69"  "rgb(173,111,105)"  "rgba(173,111,105,255)"  "CopperPenny"
#CrySSw_CosmicCobalt    = $882D2E;  $FF882D2E  "#2E2D88"  "rgb( 46, 45,136)"  "rgba( 46, 45,136,255)"  "CosmicCobalt"
#CrySSw_GlossyGrape     = $B392AB;  $FFB392AB  "#AB92B3"  "rgb(171,146,179)"  "rgba(171,146,179,255)"  "GlossyGrape"
#CrySSw_GraniteGray     = $676767;  $FF676767  "#676767"  "rgb(103,103,103)"  "rgba(103,103,103,255)"  "GraniteGray"
#CrySSw_GreenSheen      = $A1AE6E;  $FFA1AE6E  "#6EAEA1"  "rgb(110,174,161)"  "rgba(110,174,161,255)"  "GreenSheen"
#CrySSw_LilacLuster     = $AA98AE;  $FFAA98AE  "#AE98AA"  "rgb(174,152,170)"  "rgba(174,152,170,255)"  "LilacLuster"
#CrySSw_MistyMoss       = $77B4BB;  $FF77B4BB  "#BBB477"  "rgb(187,180,119)"  "rgba(187,180,119,255)"  "MistyMoss"
#CrySSw_MysticMaroon    = $7943AD;  $FF7943AD  "#AD4379"  "rgb(173, 67,121)"  "rgba(173, 67,121,255)"  "MysticMaroon"
#CrySSw_PearlyPurple    = $A268B7;  $FFA268B7  "#B768A2"  "rgb(183,104,162)"  "rgba(183,104,162,255)"  "PearlyPurple"
#CrySSw_PewterBlue      = $B7A88B;  $FFB7A88B  "#8BA8B7"  "rgb(139,168,183)"  "rgba(139,168,183,255)"  "PewterBlue"
#CrySSw_PolishedPine    = $93A45D;  $FF93A45D  "#5DA493"  "rgb( 93,164,147)"  "rgba( 93,164,147,255)"  "PolishedPine"
#CrySSw_QuickSilver     = $A6A6A6;  $FFA6A6A6  "#A6A6A6"  "rgb(166,166,166)"  "rgba(166,166,166,255)"  "QuickSilver"
#CrySSw_RoseDust        = $6F5E9E;  $FF6F5E9E  "#9E5E6F"  "rgb(158, 94,111)"  "rgba(158, 94,111,255)"  "RoseDust"
#CrySSw_RustyRed        = $432CDA;  $FF432CDA  "#DA2C43"  "rgb(218, 44, 67)"  "rgba(218, 44, 67,255)"  "RustyRed"
#CrySSw_ShadowBlue      = $A58B77;  $FFA58B77  "#778BA5"  "rgb(119,139,165)"  "rgba(119,139,165,255)"  "ShadowBlue"
#CrySSw_ShinyShamrock   = $78A75F;  $FF78A75F  "#5FA778"  "rgb( 95,167,120)"  "rgba( 95,167,120,255)"  "ShinyShamrock"
#CrySSw_SteelTeal       = $8B8A5F;  $FF8B8A5F  "#5F8A8B"  "rgb( 95,138,139)"  "rgba( 95,138,139,255)"  "SteelTeal"
#CrySSw_SugarPlum       = $754E91;  $FF754E91  "#914E75"  "rgb(145, 78,117)"  "rgba(145, 78,117,255)"  "SugarPlum"
#CrySSw_TwilightLavender= $6B498A;  $FF6B498A  "#8A496B"  "rgb(138, 73,107)"  "rgba(138, 73,107,255)"  "TwilightLavender"
#CrySSw_WintergreenDream= $7D8856;  $FF7D8856  "#56887D"  "rgb( 86,136,125)"  "rgba( 86,136,125,255)"  "WintergreenDream"

;-- Crayon Multicultural
;#CryMCt              PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CryMCt_AztecGold     = $5399C3;  $FF5399C3  "#C39953"  "rgb(195,153, 83)"  "rgba(195,153, 83,255)"  "AztecGold"
#CryMCt_BurnishedBrown= $747AA1;  $FF747AA1  "#A17A74"  "rgb(161,122,116)"  "rgba(161,122,116,255)"  "BurnishedBrown"
#CryMCt_CeruleanFrost = $C39B6D;  $FFC39B6D  "#6D9BC3"  "rgb(109,155,195)"  "rgba(109,155,195,255)"  "CeruleanFrost"
#CryMCt_Apricot       = $B1D5FD;  $FFB1D5FD  "#FDD5B1"  "rgb(253,213,177)"  "rgba(253,213,177,255)"  "Apricot"
#CryMCt_Black         = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "Black"
#CryMCt_BurntSienna   = $5174E9;  $FF5174E9  "#E97451"  "rgb(233,116, 81)"  "rgba(233,116, 81,255)"  "BurntSienna"
#CryMCt_Mahogany      = $3534CA;  $FF3534CA  "#CA3435"  "rgb(202, 52, 53)"  "rgba(202, 52, 53,255)"  "Mahogany"
#CryMCt_Peach         = $A4CBFF;  $FFA4CBFF  "#FFCBA4"  "rgb(255,203,164)"  "rgba(255,203,164,255)"  "Peach"
#CryMCt_Sepia         = $405B9E;  $FF405B9E  "#9E5B40"  "rgb(158, 91, 64)"  "rgba(158, 91, 64,255)"  "Sepia"
#CryMCt_Tan           = $6C9AD9;  $FF6C9AD9  "#D99A6C"  "rgb(217,154,108)"  "rgba(217,154,108,255)"  "Tan"
#CryMCt_White         = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "White"

;-- Crayon Magic Scent
;#CrayMSc             PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CrayMSc_BabyPowder   = $FAFEFE;  $FFFAFEFE  "#FEFEFA"  "rgb(254,254,250)"  "rgba(254,254,250,255)"  "BabyPowder"
#CrayMSc_Banana       = $2AD1FF;  $FF2AD1FF  "#FFD12A"  "rgb(255,209, 42)"  "rgba(255,209, 42,255)"  "Banana"
#CrayMSc_Blueberry    = $F7864F;  $FFF7864F  "#4F86F7"  "rgb( 79,134,247)"  "rgba( 79,134,247,255)"  "Blueberry"
#CrayMSc_BubbleGum    = $F8D3FF;  $FFF8D3FF  "#FFD3F8"  "rgb(255,211,248)"  "rgba(255,211,248,255)"  "BubbleGum"
#CrayMSc_CedarChest   = $495AC9;  $FF495AC9  "#C95A49"  "rgb(201, 90, 73)"  "rgba(201, 90, 73,255)"  "CedarChest"
#CrayMSc_Cherry       = $4726DA;  $FF4726DA  "#DA2647"  "rgb(218, 38, 71)"  "rgba(218, 38, 71,255)"  "Cherry"
#CrayMSc_Chocolate    = $6082BD;  $FF6082BD  "#BD8260"  "rgb(189,130, 96)"  "rgba(189,130, 96,255)"  "Chocolate"
#CrayMSc_Coconut      = $FEFEFE;  $FFFEFEFE  "#FEFEFE"  "rgb(254,254,254)"  "rgba(254,254,254,255)"  "Coconut"
#CrayMSc_Daffodil     = $31FFFF;  $FF31FFFF  "#FFFF31"  "rgb(255,255, 49)"  "rgba(255,255, 49,255)"  "Daffodil"
#CrayMSc_Dirt         = $53769B;  $FF53769B  "#9B7653"  "rgb(155,118, 83)"  "rgba(155,118, 83,255)"  "Dirt"
#CrayMSc_Eucalyptus   = $A8D744;  $FFA8D744  "#44D7A8"  "rgb( 68,215,168)"  "rgba( 68,215,168,255)"  "Eucalyptus"
#CrayMSc_FreshAir     = $FFE7A6;  $FFFFE7A6  "#A6E7FF"  "rgb(166,231,255)"  "rgba(166,231,255,255)"  "FreshAir"
#CrayMSc_Grape        = $A82D6F;  $FFA82D6F  "#6F2DA8"  "rgb(111, 45,168)"  "rgba(111, 45,168,255)"  "Grape"
#CrayMSc_JellyBean    = $4E61DA;  $FF4E61DA  "#DA614E"  "rgb(218, 97, 78)"  "rgba(218, 97, 78,255)"  "JellyBean"
#CrayMSc_LeatherJacket= $293525;  $FF293525  "#253529"  "rgb( 37, 53, 41)"  "rgba( 37, 53, 41,255)"  "LeatherJacket"
#CrayMSc_Lemon        = $38FFFF;  $FF38FFFF  "#FFFF38"  "rgb(255,255, 56)"  "rgba(255,255, 56,255)"  "Lemon"
#CrayMSc_Licorice     = $10111A;  $FF10111A  "#1A1110"  "rgb( 26, 17, 16)"  "rgba( 26, 17, 16,255)"  "Licorice"
#CrayMSc_Lilac        = $EF91DB;  $FFEF91DB  "#DB91EF"  "rgb(219,145,239)"  "rgba(219,145,239,255)"  "Lilac"
#CrayMSc_Lime         = $02F3B2;  $FF02F3B2  "#B2F302"  "rgb(178,243,  2)"  "rgba(178,243,  2,255)"  "Lime"
#CrayMSc_Lumber       = $CDE4FF;  $FFCDE4FF  "#FFE4CD"  "rgb(255,228,205)"  "rgba(255,228,205,255)"  "Lumber"
#CrayMSc_NewCar       = $C64F21;  $FFC64F21  "#214FC6"  "rgb( 33, 79,198)"  "rgba( 33, 79,198,255)"  "NewCar"
#CrayMSc_Orange       = $6688FF;  $FF6688FF  "#FF8866"  "rgb(255,136,102)"  "rgba(255,136,102,255)"  "Orange"
#CrayMSc_Peach        = $B9D0FF;  $FFB9D0FF  "#FFD0B9"  "rgb(255,208,185)"  "rgba(255,208,185,255)"  "Peach"
#CrayMSc_Pine         = $7DA245;  $FF7DA245  "#45A27D"  "rgb( 69,162,125)"  "rgba( 69,162,125,255)"  "Pine"
#CrayMSc_Rose         = $5050FF;  $FF5050FF  "#FF5050"  "rgb(255, 80, 80)"  "rgba(255, 80, 80,255)"  "Rose"
#CrayMSc_Shampoo      = $F1CFFF;  $FFF1CFFF  "#FFCFF1"  "rgb(255,207,241)"  "rgba(255,207,241,255)"  "Shampoo"
#CrayMSc_Smoke        = $768273;  $FF768273  "#738276"  "rgb(115,130,118)"  "rgba(115,130,118,255)"  "Smoke"
#CrayMSc_Soap         = $EFC8CE;  $FFEFC8CE  "#CEC8EF"  "rgb(206,200,239)"  "rgba(206,200,239,255)"  "Soap"
#CrayMSc_Strawberry   = $8D5AFC;  $FF8D5AFC  "#FC5A8D"  "rgb(252, 90,141)"  "rgba(252, 90,141,255)"  "Strawberry"
#CrayMSc_Tulip        = $8D87FF;  $FF8D87FF  "#FF878D"  "rgb(255,135,141)"  "rgba(255,135,141,255)"  "Tulip"

;-- Crayon Gem Tones
;#CryGEM           PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CryGEM_Amethyst   = $9A6064;  $FF9A6064  "#64609A"  "rgb(100, 96,154)"  "rgba(100, 96,154,255)"  "Amethyst"
#CryGEM_Citrine    = $093793;  $FF093793  "#933709"  "rgb(147, 55,  9)"  "rgba(147, 55,  9,255)"  "Citrine"
#CryGEM_Emerald    = $89A914;  $FF89A914  "#14A989"  "rgb( 20,169,137)"  "rgba( 20,169,137,255)"  "Emerald"
#CryGEM_Jade       = $849A46;  $FF849A46  "#469A84"  "rgb( 70,154,132)"  "rgba( 70,154,132,255)"  "Jade"
#CryGEM_Jasper     = $4053D0;  $FF4053D0  "#D05340"  "rgb(208, 83, 64)"  "rgba(208, 83, 64,255)"  "Jasper"
#CryGEM_LapisLazuli= $B96C43;  $FFB96C43  "#436CB9"  "rgb( 67,108,185)"  "rgba( 67,108,185,255)"  "LapisLazuli"
#CryGEM_Malachite  = $969446;  $FF969446  "#469496"  "rgb( 70,148,150)"  "rgba( 70,148,150,255)"  "Malachite"
#CryGEM_Moonstone  = $C1A83A;  $FFC1A83A  "#3AA8C1"  "rgb( 58,168,193)"  "rgba( 58,168,193,255)"  "Moonstone"
#CryGEM_Onyx       = $393835;  $FF393835  "#353839"  "rgb( 53, 56, 57)"  "rgba( 53, 56, 57,255)"  "Onyx"
#CryGEM_Peridot    = $48ADAB;  $FF48ADAB  "#ABAD48"  "rgb(171,173, 72)"  "rgba(171,173, 72,255)"  "Peridot"
#CryGEM_PinkPearl  = $8070B0;  $FF8070B0  "#B07080"  "rgb(176,112,128)"  "rgba(176,112,128,255)"  "PinkPearl"
#CryGEM_RoseQuartz = $9C55BD;  $FF9C55BD  "#BD559C"  "rgb(189, 85,156)"  "rgba(189, 85,156,255)"  "RoseQuartz"
#CryGEM_Ruby       = $6940AA;  $FF6940AA  "#AA4069"  "rgb(170, 64,105)"  "rgba(170, 64,105,255)"  "Ruby"
#CryGEM_Sapphire   = $A15D2D;  $FFA15D2D  "#2D5DA1"  "rgb( 45, 93,161)"  "rgba( 45, 93,161,255)"  "Sapphire"
#CryGEM_SmokeyTopaz= $0D2A83;  $FF0D2A83  "#832A0D"  "rgb(131, 42, 13)"  "rgba(131, 42, 13,255)"  "SmokeyTopaz"
#CryGEM_TigersEye  = $1769B5;  $FF1769B5  "#B56917"  "rgb(181,105, 23)"  "rgba(181,105, 23,255)"  "TigersEye"

;-- Crayon Pearl Brite
;#CryPlB                   PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CryPlB_AquaPearl          = $D7BE5F;  $FFD7BE5F  "#5FBED7"  "rgb( 95,190,215)"  "rgba( 95,190,215,255)"  "AquaPearl"
#CryPlB_BlackCoralPearl    = $6F6254;  $FF6F6254  "#54626F"  "rgb( 84, 98,111)"  "rgba( 84, 98,111,255)"  "BlackCoralPearl"
#CryPlB_CaribbeanGreenPearl= $8EDA6A;  $FF8EDA6A  "#6ADA8E"  "rgb(106,218,142)"  "rgba(106,218,142,255)"  "CaribbeanGreenPearl"
#CryPlB_CulturedPearl      = $F5F5F5;  $FFF5F5F5  "#F5F5F5"  "rgb(245,245,245)"  "rgba(245,245,245,255)"  "CulturedPearl"
#CryPlB_KeyLimePearl       = $8CF4E8;  $FF8CF4E8  "#E8F48C"  "rgb(232,244,140)"  "rgba(232,244,140,255)"  "KeyLimePearl"
#CryPlB_MandarinPearl      = $487AF3;  $FF487AF3  "#F37A48"  "rgb(243,122, 72)"  "rgba(243,122, 72,255)"  "MandarinPearl"
#CryPlB_MidnightPearl      = $702670;  $FF702670  "#702670"  "rgb(112, 38,112)"  "rgba(112, 38,112,255)"  "MidnightPearl"
#CryPlB_MysticPearl        = $8252D6;  $FF8252D6  "#D65282"  "rgb(214, 82,130)"  "rgba(214, 82,130,255)"  "MysticPearl"
#CryPlB_OceanBluePearl     = $B5424F;  $FFB5424F  "#4F42B5"  "rgb( 79, 66,181)"  "rgba( 79, 66,181,255)"  "OceanBluePearl"
#CryPlB_OceanGreenPearl    = $91BF48;  $FF91BF48  "#48BF91"  "rgb( 72,191,145)"  "rgba( 72,191,145,255)"  "OceanGreenPearl"
#CryPlB_OrchidPearl        = $59427B;  $FF59427B  "#7B4259"  "rgb(123, 66, 89)"  "rgba(123, 66, 89,255)"  "OrchidPearl"
#CryPlB_RosePearl          = $6538F0;  $FF6538F0  "#F03865"  "rgb(240, 56,101)"  "rgba(240, 56,101,255)"  "RosePearl"
#CryPlB_SalmonPearl        = $4A44F1;  $FF4A44F1  "#F1444A"  "rgb(241, 68, 74)"  "rgba(241, 68, 74,255)"  "SalmonPearl"
#CryPlB_SunnyPearl         = $7AF2F2;  $FF7AF2F2  "#F2F27A"  "rgb(242,242,122)"  "rgba(242,242,122,255)"  "SunnyPearl"
#CryPlB_SunsetPearl        = $79CCF1;  $FF79CCF1  "#F1CC79"  "rgb(241,204,121)"  "rgba(241,204,121,255)"  "SunsetPearl"
#CryPlB_TurquoisePearl     = $D0BC3B;  $FFD0BC3B  "#3BBCD0"  "rgb( 59,188,208)"  "rgba( 59,188,208,255)"  "TurquoisePearl"

;-- Crayon Metallic FX
;#CryMet                   PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CryMet_AlloyOrange        = $1062C4;  $FF1062C4  "#C46210"  "rgb(196, 98, 16)"  "rgba(196, 98, 16,255)"  "AlloyOrange"
#CryMet_BdazzledBlue       = $94582E;  $FF94582E  "#2E5894"  "rgb( 46, 88,148)"  "rgba( 46, 88,148,255)"  "BdazzledBlue"
#CryMet_BigDipORuby        = $42259C;  $FF42259C  "#9C2542"  "rgb(156, 37, 66)"  "rgba(156, 37, 66,255)"  "BigDipORuby"
#CryMet_BittersweetShimmer = $514FBF;  $FF514FBF  "#BF4F51"  "rgb(191, 79, 81)"  "rgba(191, 79, 81,255)"  "BittersweetShimmer"
#CryMet_BlastOffBronze     = $6471A5;  $FF6471A5  "#A57164"  "rgb(165,113,100)"  "rgba(165,113,100,255)"  "BlastOffBronze"
#CryMet_CyberGrape         = $7C4258;  $FF7C4258  "#58427C"  "rgb( 88, 66,124)"  "rgba( 88, 66,124,255)"  "CyberGrape"
#CryMet_DeepSpaceSparkle   = $6C644A;  $FF6C644A  "#4A646C"  "rgb( 74,100,108)"  "rgba( 74,100,108,255)"  "DeepSpaceSparkle"
#CryMet_GoldFusion         = $4E7585;  $FF4E7585  "#85754E"  "rgb(133,117, 78)"  "rgba(133,117, 78,255)"  "GoldFusion"
#CryMet_IlluminatingEmerald= $779131;  $FF779131  "#319177"  "rgb( 49,145,119)"  "rgba( 49,145,119,255)"  "IlluminatingEmerald"
#CryMet_MetallicSeaweed    = $8C7E0A;  $FF8C7E0A  "#0A7E8C"  "rgb( 10,126,140)"  "rgba( 10,126,140,255)"  "MetallicSeaweed"
#CryMet_MetallicSunburst   = $387C9C;  $FF387C9C  "#9C7C38"  "rgb(156,124, 56)"  "rgba(156,124, 56,255)"  "MetallicSunburst"
#CryMet_RazzmicBerry       = $854E8D;  $FF854E8D  "#8D4E85"  "rgb(141, 78,133)"  "rgba(141, 78,133,255)"  "RazzmicBerry"
#CryMet_SheenGreen         = $00D48F;  $FF00D48F  "#8FD400"  "rgb(143,212,  0)"  "rgba(143,212,  0,255)"  "SheenGreen"
#CryMet_ShimmeringBlush    = $9586D9;  $FF9586D9  "#D98695"  "rgb(217,134,149)"  "rgba(217,134,149,255)"  "ShimmeringBlush"
#CryMet_SonicSilver        = $757575;  $FF757575  "#757575"  "rgb(117,117,117)"  "rgba(117,117,117,255)"  "SonicSilver"
#CryMet_SteelBlue          = $AB8100;  $FFAB8100  "#0081AB"  "rgb(  0,129,171)"  "rgba(  0,129,171,255)"  "SteelBlue"

;-- Crayon Gel FX
;#CryGel      PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CryGel_FFBF7F= $7FBFFF;  $FF7FBFFF  "#FFBF7F"  "rgb(255,191,127)"  "rgba(255,191,127,255)"  "Gel_FFBF7F"
#CryGel_00D0B5= $B5D000;  $FFB5D000  "#00D0B5"  "rgb(  0,208,181)"  "rgba(  0,208,181,255)"  "Gel_00D0B5"
#CryGel_7853A8= $A85378;  $FFA85378  "#7853A8"  "rgb(120, 83,168)"  "rgba(120, 83,168,255)"  "Gel_7853A8"
#CryGel_63A5C3= $C3A563;  $FFC3A563  "#63A5C3"  "rgb( 99,165,195)"  "rgba( 99,165,195,255)"  "Gel_63A5C3"
#CryGel_0081FF= $FF8100;  $FFFF8100  "#0081FF"  "rgb(  0,129,255)"  "rgba(  0,129,255,255)"  "Gel_0081FF"
#CryGel_FF3399= $9933FF;  $FF9933FF  "#FF3399"  "rgb(255, 51,153)"  "rgba(255, 51,153,255)"  "Gel_FF3399"
#CryGel_CF0060= $6000CF;  $FF6000CF  "#CF0060"  "rgb(207,  0, 96)"  "rgba(207,  0, 96,255)"  "Gel_CF0060"
#CryGel_FFFFFF= $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "Gel_FFFFFF"
#CryGel_FF6699= $9966FF;  $FF9966FF  "#FF6699"  "rgb(255,102,153)"  "rgba(255,102,153,255)"  "Gel_FF6699"
#CryGel_8F5873= $73588F;  $FF73588F  "#8F5873"  "rgb(143, 88,115)"  "rgba(143, 88,115,255)"  "Gel_8F5873"
#CryGel_F26D7D= $7D6DF2;  $FF7D6DF2  "#F26D7D"  "rgb(242,109,125)"  "rgba(242,109,125,255)"  "Gel_F26D7D"
#CryGel_6666CC= $CC6666;  $FFCC6666  "#6666CC"  "rgb(102,102,204)"  "rgba(102,102,204,255)"  "Gel_6666CC"
#CryGel_F58345= $4583F5;  $FF4583F5  "#F58345"  "rgb(245,131, 69)"  "rgba(245,131, 69,255)"  "Gel_F58345"
#CryGel_FFFF66= $66FFFF;  $FF66FFFF  "#FFFF66"  "rgb(255,255,102)"  "rgba(255,255,102,255)"  "Gel_FFFF66"
#CryGel_99FF99= $99FF99;  $FF99FF99  "#99FF99"  "rgb(153,255,153)"  "rgba(153,255,153,255)"  "Gel_99FF99"
#CryGel_12E3DB= $DBE312;  $FFDBE312  "#12E3DB"  "rgb( 18,227,219)"  "rgba( 18,227,219,255)"  "Gel_12E3DB"

;-- Crayon Silly Scents
;#CrySlS               PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CrySlS_AlienArmpit    = $02DE84;  $FF02DE84  "#84DE02"  "rgb(132,222,  2)"  "rgba(132,222,  2,255)"  "AlienArmpit"
#CrySlS_BigFootFeet    = $5A8EE8;  $FF5A8EE8  "#E88E5A"  "rgb(232,142, 90)"  "rgba(232,142, 90,255)"  "BigFootFeet"
#CrySlS_BoogerBuster   = $6AE2DD;  $FF6AE2DD  "#DDE26A"  "rgb(221,226,106)"  "rgba(221,226,106,255)"  "BoogerBuster"
#CrySlS_DingyDungeon   = $5131C5;  $FF5131C5  "#C53151"  "rgb(197, 49, 81)"  "rgba(197, 49, 81,255)"  "DingyDungeon"
#CrySlS_GargoyleGas    = $46DFFF;  $FF46DFFF  "#FFDF46"  "rgb(255,223, 70)"  "rgba(255,223, 70,255)"  "GargoyleGas"
#CrySlS_GiantsClub     = $525CB0;  $FF525CB0  "#B05C52"  "rgb(176, 92, 82)"  "rgba(176, 92, 82,255)"  "GiantsClub"
#CrySlS_MagicPotion    = $6644FF;  $FF6644FF  "#FF4466"  "rgb(255, 68,102)"  "rgba(255, 68,102,255)"  "MagicPotion"
#CrySlS_MummysTomb     = $848E82;  $FF848E82  "#828E84"  "rgb(130,142,132)"  "rgba(130,142,132,255)"  "MummysTomb"
#CrySlS_OgreOdor       = $4052FD;  $FF4052FD  "#FD5240"  "rgb(253, 82, 64)"  "rgba(253, 82, 64,255)"  "OgreOdor"
#CrySlS_PixiePowder    = $851239;  $FF851239  "#391285"  "rgb( 57, 18,133)"  "rgba( 57, 18,133,255)"  "PixiePowder"
#CrySlS_PrincessPerfume= $CF85FF;  $FFCF85FF  "#FF85CF"  "rgb(255,133,207)"  "rgba(255,133,207,255)"  "PrincessPerfume"
#CrySlS_SasquatchSocks = $8146FF;  $FF8146FF  "#FF4681"  "rgb(255, 70,129)"  "rgba(255, 70,129,255)"  "SasquatchSocks"
#CrySlS_SeaSerpent     = $CFC74B;  $FFCFC74B  "#4BC7CF"  "rgb( 75,199,207)"  "rgba( 75,199,207,255)"  "SeaSerpent"
#CrySlS_SmashedPumpkin = $3A6DFF;  $FF3A6DFF  "#FF6D3A"  "rgb(255,109, 58)"  "rgba(255,109, 58,255)"  "SmashedPumpkin"
#CrySlS_SunburntCyclops= $4C40FF;  $FF4C40FF  "#FF404C"  "rgb(255, 64, 76)"  "rgba(255, 64, 76,255)"  "SunburntCyclops"
#CrySlS_WinterWizard   = $FFE6A0;  $FFFFE6A0  "#A0E6FF"  "rgb(160,230,255)"  "rgba(160,230,255,255)"  "WinterWizard"

;-- Crayon Heads n Tails
;#CryHnT              PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#CryHnT_SizzlingRed   = $5538FF;  $FF5538FF  "#FF3855"  "rgb(255, 56, 85)"  "rgba(255, 56, 85,255)"  "SizzlingRed"
#CryHnT_RedSalsa      = $4A3AFD;  $FF4A3AFD  "#FD3A4A"  "rgb(253, 58, 74)"  "rgba(253, 58, 74,255)"  "RedSalsa"
#CryHnT_TartOrange    = $464DFB;  $FF464DFB  "#FB4D46"  "rgb(251, 77, 70)"  "rgba(251, 77, 70,255)"  "TartOrange"
#CryHnT_OrangeSoda    = $3D5BFA;  $FF3D5BFA  "#FA5B3D"  "rgb(250, 91, 61)"  "rgba(250, 91, 61,255)"  "OrangeSoda"
#CryHnT_BrightYellow  = $1DAAFF;  $FF1DAAFF  "#FFAA1D"  "rgb(255,170, 29)"  "rgba(255,170, 29,255)"  "BrightYellow"
#CryHnT_YellowSunshine= $00F7FF;  $FF00F7FF  "#FFF700"  "rgb(255,247,  0)"  "rgba(255,247,  0,255)"  "YellowSunshine"
#CryHnT_SlimyGreen    = $179629;  $FF179629  "#299617"  "rgb( 41,150, 23)"  "rgba( 41,150, 23,255)"  "SlimyGreen"
#CryHnT_GreenLizard   = $32F4A7;  $FF32F4A7  "#A7F432"  "rgb(167,244, 50)"  "rgba(167,244, 50,255)"  "GreenLizard"
#CryHnT_DenimBlue     = $B64322;  $FFB64322  "#2243B6"  "rgb( 34, 67,182)"  "rgba( 34, 67,182,255)"  "DenimBlue"
#CryHnT_BlueJeans     = $ECAD5D;  $FFECAD5D  "#5DADEC"  "rgb( 93,173,236)"  "rgba( 93,173,236,255)"  "BlueJeans"
#CryHnT_PlumpPurple   = $B24659;  $FFB24659  "#5946B2"  "rgb( 89, 70,178)"  "rgba( 89, 70,178,255)"  "PlumpPurple"
#CryHnT_PurplePlum    = $B6519C;  $FFB6519C  "#9C51B6"  "rgb(156, 81,182)"  "rgba(156, 81,182,255)"  "PurplePlum"
#CryHnT_SweetBrown    = $3137A8;  $FF3137A8  "#A83731"  "rgb(168, 55, 49)"  "rgba(168, 55, 49,255)"  "SweetBrown"
#CryHnT_BrownSugar    = $4D6EAF;  $FF4D6EAF  "#AF6E4D"  "rgb(175,110, 77)"  "rgba(175,110, 77,255)"  "BrownSugar"
#CryHnT_EerieBlack    = $1B1B1B;  $FF1B1B1B  "#1B1B1B"  "rgb( 27, 27, 27)"  "rgba( 27, 27, 27,255)"  "EerieBlack"
#CryHnT_BlackShadows  = $B2AFBF;  $FFB2AFBF  "#BFAFB2"  "rgb(191,175,178)"  "rgba(191,175,178,255)"  "BlackShadows"

;-Resene-Colors
;  see http://people.csail.mit.edu/jaffer/Color/resenecolours.txt
;#Res                   PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Crayon name:
#Res_Abbey              = $564F4C;  $FF564F4C  "#4C4F56"  "rgb( 76, 79, 86)"  "rgba( 76, 79, 86,255)"  "Abbey"
#Res_Acadia             = $04141B;  $FF04141B  "#1B1404"  "rgb( 27, 20,  4)"  "rgba( 27, 20,  4,255)"  "Acadia"
#Res_Acapulco           = $A1B07C;  $FFA1B07C  "#7CB0A1"  "rgb(124,176,161)"  "rgba(124,176,161,255)"  "Acapulco"
#Res_Acorn              = $1B5D6A;  $FF1B5D6A  "#6A5D1B"  "rgb(106, 93, 27)"  "rgba(106, 93, 27,255)"  "Acorn"
#Res_AeroBlue           = $E5FFC9;  $FFE5FFC9  "#C9FFE5"  "rgb(201,255,229)"  "rgba(201,255,229,255)"  "AeroBlue"
#Res_Affair             = $934671;  $FF934671  "#714693"  "rgb(113, 70,147)"  "rgba(113, 70,147,255)"  "Affair"
#Res_AfghanTan          = $0A5686;  $FF0A5686  "#86560A"  "rgb(134, 86, 10)"  "rgba(134, 86, 10,255)"  "AfghanTan"
#Res_Akaroa             = $A8C4D4;  $FFA8C4D4  "#D4C4A8"  "rgb(212,196,168)"  "rgba(212,196,168,255)"  "Akaroa"
#Res_Alabaster          = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "Alabaster"
#Res_AlbescentWhite     = $D3E9F5;  $FFD3E9F5  "#F5E9D3"  "rgb(245,233,211)"  "rgba(245,233,211,255)"  "AlbescentWhite"
#Res_AlertTan           = $03479B;  $FF03479B  "#9B4703"  "rgb(155, 71,  3)"  "rgba(155, 71,  3,255)"  "AlertTan"
#Res_Allports           = $A37600;  $FFA37600  "#0076A3"  "rgb(  0,118,163)"  "rgba(  0,118,163,255)"  "Allports"
#Res_AlmondFrost        = $717B90;  $FF717B90  "#907B71"  "rgb(144,123,113)"  "rgba(144,123,113,255)"  "AlmondFrost"
#Res_Alpine             = $2C8FAF;  $FF2C8FAF  "#AF8F2C"  "rgb(175,143, 44)"  "rgba(175,143, 44,255)"  "Alpine"
#Res_Alto               = $DBDBDB;  $FFDBDBDB  "#DBDBDB"  "rgb(219,219,219)"  "rgba(219,219,219,255)"  "Alto"
#Res_Aluminium          = $B6ACA9;  $FFB6ACA9  "#A9ACB6"  "rgb(169,172,182)"  "rgba(169,172,182,255)"  "Aluminium"
#Res_Amazon             = $577A3B;  $FF577A3B  "#3B7A57"  "rgb( 59,122, 87)"  "rgba( 59,122, 87,255)"  "Amazon"
#Res_Americano          = $6E7587;  $FF6E7587  "#87756E"  "rgb(135,117,110)"  "rgba(135,117,110,255)"  "Americano"
#Res_AmethystSmoke      = $B497A3;  $FFB497A3  "#A397B4"  "rgb(163,151,180)"  "rgba(163,151,180,255)"  "AmethystSmoke"
#Res_Amour              = $F3EAF9;  $FFF3EAF9  "#F9EAF3"  "rgb(249,234,243)"  "rgba(249,234,243,255)"  "Amour"
#Res_Amulet             = $809F7B;  $FF809F7B  "#7B9F80"  "rgb(123,159,128)"  "rgba(123,159,128,255)"  "Amulet"
#Res_Anakiwa            = $FFE59D;  $FFFFE59D  "#9DE5FF"  "rgb(157,229,255)"  "rgba(157,229,255,255)"  "Anakiwa"
#Res_AntiqueBrass       = $074A70;  $FF074A70  "#704A07"  "rgb(112, 74,  7)"  "rgba(112, 74,  7,255)"  "AntiqueBrass"
#Res_Anzac              = $46B6E0;  $FF46B6E0  "#E0B646"  "rgb(224,182, 70)"  "rgba(224,182, 70,255)"  "Anzac"
#Res_Apache             = $6FBEDF;  $FF6FBEDF  "#DFBE6F"  "rgb(223,190,111)"  "rgba(223,190,111,255)"  "Apache"
#Res_Apple              = $3DA84F;  $FF3DA84F  "#4FA83D"  "rgb( 79,168, 61)"  "rgba( 79,168, 61,255)"  "Apple"
#Res_AppleBlossom       = $434DAF;  $FF434DAF  "#AF4D43"  "rgb(175, 77, 67)"  "rgba(175, 77, 67,255)"  "AppleBlossom"
#Res_AppleGreen         = $ECF3E2;  $FFECF3E2  "#E2F3EC"  "rgb(226,243,236)"  "rgba(226,243,236,255)"  "AppleGreen"
#Res_Apricot            = $7393EB;  $FF7393EB  "#EB9373"  "rgb(235,147,115)"  "rgba(235,147,115,255)"  "Apricot"
#Res_ApricotWhite       = $ECFEFF;  $FFECFEFF  "#FFFEEC"  "rgb(255,254,236)"  "rgba(255,254,236,255)"  "ApricotWhite"
#Res_Aqua               = $D7DAA1;  $FFD7DAA1  "#A1DAD7"  "rgb(161,218,215)"  "rgba(161,218,215,255)"  "Aqua"
#Res_AquaHaze           = $F5F5ED;  $FFF5F5ED  "#EDF5F5"  "rgb(237,245,245)"  "rgba(237,245,245,255)"  "AquaHaze"
#Res_AquaSpring         = $F5F9EA;  $FFF5F9EA  "#EAF9F5"  "rgb(234,249,245)"  "rgba(234,249,245,255)"  "AquaSpring"
#Res_AquaSqueeze        = $F2F5E8;  $FFF2F5E8  "#E8F5F2"  "rgb(232,245,242)"  "rgba(232,245,242,255)"  "AquaSqueeze"
#Res_Aquamarine         = $434B01;  $FF434B01  "#014B43"  "rgb(  1, 75, 67)"  "rgba(  1, 75, 67,255)"  "Aquamarine"
#Res_Arapawa            = $6C0C11;  $FF6C0C11  "#110C6C"  "rgb( 17, 12,108)"  "rgba( 17, 12,108,255)"  "Arapawa"
#Res_Armadillo          = $373E43;  $FF373E43  "#433E37"  "rgb( 67, 62, 55)"  "rgba( 67, 62, 55,255)"  "Armadillo"
#Res_Arrowtown          = $718794;  $FF718794  "#948771"  "rgb(148,135,113)"  "rgba(148,135,113,255)"  "Arrowtown"
#Res_Ash                = $B5C3C6;  $FFB5C3C6  "#C6C3B5"  "rgb(198,195,181)"  "rgba(198,195,181,255)"  "Ash"
#Res_AshBrown           = $05192E;  $FF05192E  "#2E1905"  "rgb( 46, 25,  5)"  "rgba( 46, 25,  5,255)"  "AshBrown"
#Res_Asphalt            = $060A13;  $FF060A13  "#130A06"  "rgb( 19, 10,  6)"  "rgba( 19, 10,  6,255)"  "Asphalt"
#Res_Astra              = $B9EAFA;  $FFB9EAFA  "#FAEAB9"  "rgb(250,234,185)"  "rgba(250,234,185,255)"  "Astra"
#Res_Astral             = $A07D32;  $FFA07D32  "#327DA0"  "rgb( 50,125,160)"  "rgba( 50,125,160,255)"  "Astral"
#Res_Astronaut          = $773A28;  $FF773A28  "#283A77"  "rgb( 40, 58,119)"  "rgba( 40, 58,119,255)"  "Astronaut"
#Res_AstronautBlue      = $623E01;  $FF623E01  "#013E62"  "rgb(  1, 62, 98)"  "rgba(  1, 62, 98,255)"  "AstronautBlue"
#Res_AthensGrey         = $F3F0EE;  $FFF3F0EE  "#EEF0F3"  "rgb(238,240,243)"  "rgba(238,240,243,255)"  "AthensGrey"
#Res_AthsSpecial        = $CEEBEC;  $FFCEEBEC  "#ECEBCE"  "rgb(236,235,206)"  "rgba(236,235,206,255)"  "AthsSpecial"
#Res_Atlantis           = $2DCD97;  $FF2DCD97  "#97CD2D"  "rgb(151,205, 45)"  "rgba(151,205, 45,255)"  "Atlantis"
#Res_Atoll              = $756F0A;  $FF756F0A  "#0A6F75"  "rgb( 10,111,117)"  "rgba( 10,111,117,255)"  "Atoll"
#Res_Atomic             = $594431;  $FF594431  "#314459"  "rgb( 49, 68, 89)"  "rgba( 49, 68, 89,255)"  "Atomic"
#Res_AuChico            = $5D6097;  $FF5D6097  "#97605D"  "rgb(151, 96, 93)"  "rgba(151, 96, 93,255)"  "AuChico"
#Res_Aubergine          = $10093B;  $FF10093B  "#3B0910"  "rgb( 59,  9, 16)"  "rgba( 59,  9, 16,255)"  "Aubergine"
#Res_AustralianMint     = $BEFFF5;  $FFBEFFF5  "#F5FFBE"  "rgb(245,255,190)"  "rgba(245,255,190,255)"  "AustralianMint"
#Res_Avocado            = $658D88;  $FF658D88  "#888D65"  "rgb(136,141,101)"  "rgba(136,141,101,255)"  "Avocado"
#Res_Axolotl            = $49664E;  $FF49664E  "#4E6649"  "rgb( 78,102, 73)"  "rgba( 78,102, 73,255)"  "Axolotl"
#Res_Azalea             = $DAC8F7;  $FFDAC8F7  "#F7C8DA"  "rgb(247,200,218)"  "rgba(247,200,218,255)"  "Azalea"
#Res_Aztec              = $191C0D;  $FF191C0D  "#0D1C19"  "rgb( 13, 28, 25)"  "rgba( 13, 28, 25,255)"  "Aztec"
#Res_Azure              = $A15B31;  $FFA15B31  "#315BA1"  "rgb( 49, 91,161)"  "rgba( 49, 91,161,255)"  "Azure"
#Res_BahamaBlue         = $956302;  $FF956302  "#026395"  "rgb(  2, 99,149)"  "rgba(  2, 99,149,255)"  "BahamaBlue"
#Res_Bahia              = $0CCBA5;  $FF0CCBA5  "#A5CB0C"  "rgb(165,203, 12)"  "rgba(165,203, 12,255)"  "Bahia"
#Res_BajaWhite          = $D1F8FF;  $FFD1F8FF  "#FFF8D1"  "rgb(255,248,209)"  "rgba(255,248,209,255)"  "BajaWhite"
#Res_BaliHai            = $AF9F85;  $FFAF9F85  "#859FAF"  "rgb(133,159,175)"  "rgba(133,159,175,255)"  "BaliHai"
#Res_BalticSea          = $30262A;  $FF30262A  "#2A2630"  "rgb( 42, 38, 48)"  "rgba( 42, 38, 48,255)"  "BalticSea"
#Res_Bamboo             = $0463DA;  $FF0463DA  "#DA6304"  "rgb(218, 99,  4)"  "rgba(218, 99,  4,255)"  "Bamboo"
#Res_Bandicoot          = $708485;  $FF708485  "#858470"  "rgb(133,132,112)"  "rgba(133,132,112,255)"  "Bandicoot"
#Res_Banjul             = $060A13;  $FF060A13  "#130A06"  "rgb( 19, 10,  6)"  "rgba( 19, 10,  6,255)"  "Banjul"
#Res_Barberry           = $17D7DE;  $FF17D7DE  "#DED717"  "rgb(222,215, 23)"  "rgba(222,215, 23,255)"  "Barberry"
#Res_BarleyCorn         = $5B8BA6;  $FF5B8BA6  "#A68B5B"  "rgb(166,139, 91)"  "rgba(166,139, 91,255)"  "BarleyCorn"
#Res_BarleyWhite        = $CEF4FF;  $FFCEF4FF  "#FFF4CE"  "rgb(255,244,206)"  "rgba(255,244,206,255)"  "BarleyWhite"
#Res_Barossa            = $2D0144;  $FF2D0144  "#44012D"  "rgb( 68,  1, 45)"  "rgba( 68,  1, 45,255)"  "Barossa"
#Res_Bastille           = $302129;  $FF302129  "#292130"  "rgb( 41, 33, 48)"  "rgba( 41, 33, 48,255)"  "Bastille"
#Res_BattleshipGrey     = $728F82;  $FF728F82  "#828F72"  "rgb(130,143,114)"  "rgba(130,143,114,255)"  "BattleshipGrey"
#Res_BayLeaf            = $8DA97D;  $FF8DA97D  "#7DA98D"  "rgb(125,169,141)"  "rgba(125,169,141,255)"  "BayLeaf"
#Res_BayofMany          = $813A27;  $FF813A27  "#273A81"  "rgb( 39, 58,129)"  "rgba( 39, 58,129,255)"  "BayofMany"
#Res_Bazaar             = $7B7798;  $FF7B7798  "#98777B"  "rgb(152,119,123)"  "rgba(152,119,123,255)"  "Bazaar"
#Res_Bean               = $020C3D;  $FF020C3D  "#3D0C02"  "rgb( 61, 12,  2)"  "rgba( 61, 12,  2,255)"  "Bean"
#Res_BeautyBush         = $BEC1EE;  $FFBEC1EE  "#EEC1BE"  "rgb(238,193,190)"  "rgba(238,193,190,255)"  "BeautyBush"
#Res_Beeswax            = $C7F2FE;  $FFC7F2FE  "#FEF2C7"  "rgb(254,242,199)"  "rgba(254,242,199,255)"  "Beeswax"
#Res_Bermuda            = $C6D87D;  $FFC6D87D  "#7DD8C6"  "rgb(125,216,198)"  "rgba(125,216,198,255)"  "Bermuda"
#Res_BermudaGrey        = $A28B6B;  $FFA28B6B  "#6B8BA2"  "rgb(107,139,162)"  "rgba(107,139,162,255)"  "BermudaGrey"
#Res_BerylGreen         = $C0E5DE;  $FFC0E5DE  "#DEE5C0"  "rgb(222,229,192)"  "rgba(222,229,192,255)"  "BerylGreen"
#Res_Bianca             = $F3FBFC;  $FFF3FBFC  "#FCFBF3"  "rgb(252,251,243)"  "rgba(252,251,243,255)"  "Bianca"
#Res_BigStone           = $402A16;  $FF402A16  "#162A40"  "rgb( 22, 42, 64)"  "rgba( 22, 42, 64,255)"  "BigStone"
#Res_Bilbao             = $147C32;  $FF147C32  "#327C14"  "rgb( 50,124, 20)"  "rgba( 50,124, 20,255)"  "Bilbao"
#Res_BilobaFlower       = $EAA1B2;  $FFEAA1B2  "#B2A1EA"  "rgb(178,161,234)"  "rgba(178,161,234,255)"  "BilobaFlower"
#Res_Birch              = $213037;  $FF213037  "#373021"  "rgb( 55, 48, 33)"  "rgba( 55, 48, 33,255)"  "Birch"
#Res_BirdFlower         = $16CDD4;  $FF16CDD4  "#D4CD16"  "rgb(212,205, 22)"  "rgba(212,205, 22,255)"  "BirdFlower"
#Res_Biscay             = $62311B;  $FF62311B  "#1B3162"  "rgb( 27, 49, 98)"  "rgba( 27, 49, 98,255)"  "Biscay"
#Res_Bismark            = $837149;  $FF837149  "#497183"  "rgb( 73,113,131)"  "rgba( 73,113,131,255)"  "Bismark"
#Res_BisonHide          = $A4B7C1;  $FFA4B7C1  "#C1B7A4"  "rgb(193,183,164)"  "rgba(193,183,164,255)"  "BisonHide"
#Res_Bitter             = $748986;  $FF748986  "#868974"  "rgb(134,137,116)"  "rgba(134,137,116,255)"  "Bitter"
#Res_BitterLemon        = $0DE0CA;  $FF0DE0CA  "#CAE00D"  "rgb(202,224, 13)"  "rgba(202,224, 13,255)"  "BitterLemon"
#Res_Bizarre            = $DADEEE;  $FFDADEEE  "#EEDEDA"  "rgb(238,222,218)"  "rgba(238,222,218,255)"  "Bizarre"
#Res_BlackBean          = $101908;  $FF101908  "#081910"  "rgb(  8, 25, 16)"  "rgba(  8, 25, 16,255)"  "BlackBean"
#Res_BlackForest        = $04130B;  $FF04130B  "#0B1304"  "rgb( 11, 19,  4)"  "rgba( 11, 19,  4,255)"  "BlackForest"
#Res_BlackHaze          = $F7F7F6;  $FFF7F7F6  "#F6F7F7"  "rgb(246,247,247)"  "rgba(246,247,247,255)"  "BlackHaze"
#Res_BlackMagic         = $061725;  $FF061725  "#251706"  "rgb( 37, 23,  6)"  "rgba( 37, 23,  6,255)"  "BlackMagic"
#Res_BlackMarlin        = $1C2C3E;  $FF1C2C3E  "#3E2C1C"  "rgb( 62, 44, 28)"  "rgba( 62, 44, 28,255)"  "BlackMarlin"
#Res_BlackPearl         = $221304;  $FF221304  "#041322"  "rgb(  4, 19, 34)"  "rgba(  4, 19, 34,255)"  "BlackPearl"
#Res_BlackPepper        = $180E0E;  $FF180E0E  "#0E0E18"  "rgb( 14, 14, 24)"  "rgba( 14, 14, 24,255)"  "BlackPepper"
#Res_BlackRock          = $32030D;  $FF32030D  "#0D0332"  "rgb( 13,  3, 50)"  "rgba( 13,  3, 50,255)"  "BlackRock"
#Res_BlackRose          = $2D0367;  $FF2D0367  "#67032D"  "rgb(103,  3, 45)"  "rgba(103,  3, 45,255)"  "BlackRose"
#Res_BlackRussian       = $1C000A;  $FF1C000A  "#0A001C"  "rgb( 10,  0, 28)"  "rgba( 10,  0, 28,255)"  "BlackRussian"
#Res_BlackSqueeze       = $FAFAF2;  $FFFAFAF2  "#F2FAFA"  "rgb(242,250,250)"  "rgba(242,250,250,255)"  "BlackSqueeze"
#Res_BlackWhite         = $F6FEFF;  $FFF6FEFF  "#FFFEF6"  "rgb(255,254,246)"  "rgba(255,254,246,255)"  "BlackWhite"
#Res_Blackberry         = $35014D;  $FF35014D  "#4D0135"  "rgb( 77,  1, 53)"  "rgba( 77,  1, 53,255)"  "Blackberry"
#Res_Blackcurrant       = $3A2932;  $FF3A2932  "#32293A"  "rgb( 50, 41, 58)"  "rgba( 50, 41, 58,255)"  "Blackcurrant"
#Res_Blackwood          = $051126;  $FF051126  "#261105"  "rgb( 38, 17,  5)"  "rgba( 38, 17,  5,255)"  "Blackwood"
#Res_Blanc              = $D3E9F5;  $FFD3E9F5  "#F5E9D3"  "rgb(245,233,211)"  "rgba(245,233,211,255)"  "Blanc"
#Res_BleachWhite        = $D8F3FE;  $FFD8F3FE  "#FEF3D8"  "rgb(254,243,216)"  "rgba(254,243,216,255)"  "BleachWhite"
#Res_BleachedCedar      = $33212C;  $FF33212C  "#2C2133"  "rgb( 44, 33, 51)"  "rgba( 44, 33, 51,255)"  "BleachedCedar"
#Res_Blossom            = $BCB4DC;  $FFBCB4DC  "#DCB4BC"  "rgb(220,180,188)"  "rgba(220,180,188,255)"  "Blossom"
#Res_BlueBark           = $221304;  $FF221304  "#041322"  "rgb(  4, 19, 34)"  "rgba(  4, 19, 34,255)"  "BlueBark"
#Res_BlueBayoux         = $796649;  $FF796649  "#496679"  "rgb( 73,102,121)"  "rgba( 73,102,121,255)"  "BlueBayoux"
#Res_BlueBell           = $780822;  $FF780822  "#220878"  "rgb( 34,  8,120)"  "rgba( 34,  8,120,255)"  "BlueBell"
#Res_BlueChalk          = $FFE9F1;  $FFFFE9F1  "#F1E9FF"  "rgb(241,233,255)"  "rgba(241,233,255,255)"  "BlueChalk"
#Res_BlueCharcoal       = $1A0D01;  $FF1A0D01  "#010D1A"  "rgb(  1, 13, 26)"  "rgba(  1, 13, 26,255)"  "BlueCharcoal"
#Res_BlueChill          = $90890C;  $FF90890C  "#0C8990"  "rgb( 12,137,144)"  "rgba( 12,137,144,255)"  "BlueChill"
#Res_BlueDiamond        = $740438;  $FF740438  "#380474"  "rgb( 56,  4,116)"  "rgba( 56,  4,116,255)"  "BlueDiamond"
#Res_BlueDianne         = $524820;  $FF524820  "#204852"  "rgb( 32, 72, 82)"  "rgba( 32, 72, 82,255)"  "BlueDianne"
#Res_BlueGem            = $8C0E2C;  $FF8C0E2C  "#2C0E8C"  "rgb( 44, 14,140)"  "rgba( 44, 14,140,255)"  "BlueGem"
#Res_BlueHaze           = $D8BEBF;  $FFD8BEBF  "#BFBED8"  "rgb(191,190,216)"  "rgba(191,190,216,255)"  "BlueHaze"
#Res_BlueLagoon         = $877901;  $FF877901  "#017987"  "rgb(  1,121,135)"  "rgba(  1,121,135,255)"  "BlueLagoon"
#Res_BlueMarguerite     = $C66676;  $FFC66676  "#7666C6"  "rgb(118,102,198)"  "rgba(118,102,198,255)"  "BlueMarguerite"
#Res_BlueRomance        = $DEF6D2;  $FFDEF6D2  "#D2F6DE"  "rgb(210,246,222)"  "rgba(210,246,222,255)"  "BlueRomance"
#Res_BlueSmoke          = $818874;  $FF818874  "#748881"  "rgb(116,136,129)"  "rgba(116,136,129,255)"  "BlueSmoke"
#Res_BlueStone          = $626101;  $FF626101  "#016162"  "rgb(  1, 97, 98)"  "rgba(  1, 97, 98,255)"  "BlueStone"
#Res_BlueWhale          = $4C2E04;  $FF4C2E04  "#042E4C"  "rgb(  4, 46, 76)"  "rgba(  4, 46, 76,255)"  "BlueWhale"
#Res_BlueZodiac         = $4D2613;  $FF4D2613  "#13264D"  "rgb( 19, 38, 77)"  "rgba( 19, 38, 77,255)"  "BlueZodiac"
#Res_Blumine            = $7A5818;  $FF7A5818  "#18587A"  "rgb( 24, 88,122)"  "rgba( 24, 88,122,255)"  "Blumine"
#Res_Blush              = $6846B4;  $FF6846B4  "#B44668"  "rgb(180, 70,104)"  "rgba(180, 70,104,255)"  "Blush"
#Res_BokaraGrey         = $08121C;  $FF08121C  "#1C1208"  "rgb( 28, 18,  8)"  "rgba( 28, 18,  8,255)"  "BokaraGrey"
#Res_Bombay             = $B8B1AF;  $FFB8B1AF  "#AFB1B8"  "rgb(175,177,184)"  "rgba(175,177,184,255)"  "Bombay"
#Res_BonJour            = $E1E0E5;  $FFE1E0E5  "#E5E0E1"  "rgb(229,224,225)"  "rgba(229,224,225,255)"  "BonJour"
#Res_BondiBlue          = $8E4702;  $FF8E4702  "#02478E"  "rgb(  2, 71,142)"  "rgba(  2, 71,142,255)"  "BondiBlue"
#Res_Bone               = $C0D1E4;  $FFC0D1E4  "#E4D1C0"  "rgb(228,209,192)"  "rgba(228,209,192,255)"  "Bone"
#Res_Bordeaux           = $20015C;  $FF20015C  "#5C0120"  "rgb( 92,  1, 32)"  "rgba( 92,  1, 32,255)"  "Bordeaux"
#Res_Bossanova          = $5A2A4E;  $FF5A2A4E  "#4E2A5A"  "rgb( 78, 42, 90)"  "rgba( 78, 42, 90,255)"  "Bossanova"
#Res_BostonBlue         = $B4913B;  $FFB4913B  "#3B91B4"  "rgb( 59,145,180)"  "rgba( 59,145,180,255)"  "BostonBlue"
#Res_Botticelli         = $E5DDC7;  $FFE5DDC7  "#C7DDE5"  "rgb(199,221,229)"  "rgba(199,221,229,255)"  "Botticelli"
#Res_BottleGreen        = $243609;  $FF243609  "#093624"  "rgb(  9, 54, 36)"  "rgba(  9, 54, 36,255)"  "BottleGreen"
#Res_Boulder            = $7A7A7A;  $FF7A7A7A  "#7A7A7A"  "rgb(122,122,122)"  "rgba(122,122,122,255)"  "Boulder"
#Res_Bouquet            = $9E80AE;  $FF9E80AE  "#AE809E"  "rgb(174,128,158)"  "rgba(174,128,158,255)"  "Bouquet"
#Res_Bourbon            = $1E6FBA;  $FF1E6FBA  "#BA6F1E"  "rgb(186,111, 30)"  "rgba(186,111, 30,255)"  "Bourbon"
#Res_Bracken            = $042A4A;  $FF042A4A  "#4A2A04"  "rgb( 74, 42,  4)"  "rgba( 74, 42,  4,255)"  "Bracken"
#Res_Brandy             = $96C1DE;  $FF96C1DE  "#DEC196"  "rgb(222,193,150)"  "rgba(222,193,150,255)"  "Brandy"
#Res_BrandyPunch        = $2984CD;  $FF2984CD  "#CD8429"  "rgb(205,132, 41)"  "rgba(205,132, 41,255)"  "BrandyPunch"
#Res_BrandyRose         = $8389BB;  $FF8389BB  "#BB8983"  "rgb(187,137,131)"  "rgba(187,137,131,255)"  "BrandyRose"
#Res_Brazil             = $216288;  $FF216288  "#886221"  "rgb(136, 98, 33)"  "rgba(136, 98, 33,255)"  "Brazil"
#Res_BreakerBay         = $9FA15D;  $FF9FA15D  "#5DA19F"  "rgb( 93,161,159)"  "rgba( 93,161,159,255)"  "BreakerBay"
#Res_BridalHeath        = $F4FAFF;  $FFF4FAFF  "#FFFAF4"  "rgb(255,250,244)"  "rgba(255,250,244,255)"  "BridalHeath"
#Res_Bridesmaid         = $ECF0FE;  $FFECF0FE  "#FEF0EC"  "rgb(254,240,236)"  "rgba(254,240,236,255)"  "Bridesmaid"
#Res_BrightGrey         = $51413C;  $FF51413C  "#3C4151"  "rgb( 60, 65, 81)"  "rgba( 60, 65, 81,255)"  "BrightGrey"
#Res_BrightRed          = $0000B1;  $FF0000B1  "#B10000"  "rgb(177,  0,  0)"  "rgba(177,  0,  0,255)"  "BrightRed"
#Res_BrightSun          = $3CD3FE;  $FF3CD3FE  "#FED33C"  "rgb(254,211, 60)"  "rgba(254,211, 60,255)"  "BrightSun"
#Res_Bronco             = $96A1AB;  $FF96A1AB  "#ABA196"  "rgb(171,161,150)"  "rgba(171,161,150,255)"  "Bronco"
#Res_Bronze             = $09213F;  $FF09213F  "#3F2109"  "rgb( 63, 33,  9)"  "rgba( 63, 33,  9,255)"  "Bronze"
#Res_BronzeOlive        = $0C424E;  $FF0C424E  "#4E420C"  "rgb( 78, 66, 12)"  "rgba( 78, 66, 12,255)"  "BronzeOlive"
#Res_Bronzetone         = $0F404D;  $FF0F404D  "#4D400F"  "rgb( 77, 64, 15)"  "rgba( 77, 64, 15,255)"  "Bronzetone"
#Res_Broom              = $13ECFF;  $FF13ECFF  "#FFEC13"  "rgb(255,236, 19)"  "rgba(255,236, 19,255)"  "Broom"
#Res_BrownBramble       = $042859;  $FF042859  "#592804"  "rgb( 89, 40,  4)"  "rgba( 89, 40,  4,255)"  "BrownBramble"
#Res_BrownDerby         = $152649;  $FF152649  "#492615"  "rgb( 73, 38, 21)"  "rgba( 73, 38, 21,255)"  "BrownDerby"
#Res_BrownPod           = $011840;  $FF011840  "#401801"  "rgb( 64, 24,  1)"  "rgba( 64, 24,  1,255)"  "BrownPod"
#Res_Bubbles            = $FFFEE7;  $FFFFFEE7  "#E7FEFF"  "rgb(231,254,255)"  "rgba(231,254,255,255)"  "Bubbles"
#Res_Buccaneer          = $302F62;  $FF302F62  "#622F30"  "rgb( 98, 47, 48)"  "rgba( 98, 47, 48,255)"  "Buccaneer"
#Res_Bud                = $9CAEA8;  $FF9CAEA8  "#A8AE9C"  "rgb(168,174,156)"  "rgba(168,174,156,255)"  "Bud"
#Res_BuddhaGold         = $04A0C1;  $FF04A0C1  "#C1A004"  "rgb(193,160,  4)"  "rgba(193,160,  4,255)"  "BuddhaGold"
#Res_BulgarianRose      = $070648;  $FF070648  "#480607"  "rgb( 72,  6,  7)"  "rgba( 72,  6,  7,255)"  "BulgarianRose"
#Res_BullShot           = $1E4D86;  $FF1E4D86  "#864D1E"  "rgb(134, 77, 30)"  "rgba(134, 77, 30,255)"  "BullShot"
#Res_Bunker             = $17110D;  $FF17110D  "#0D1117"  "rgb( 13, 17, 23)"  "rgba( 13, 17, 23,255)"  "Bunker"
#Res_Bunting            = $4C1F15;  $FF4C1F15  "#151F4C"  "rgb( 21, 31, 76)"  "rgba( 21, 31, 76,255)"  "Bunting"
#Res_Burgundy           = $050F77;  $FF050F77  "#770F05"  "rgb(119, 15,  5)"  "rgba(119, 15,  5,255)"  "Burgundy"
#Res_Burnham            = $202E00;  $FF202E00  "#002E20"  "rgb(  0, 46, 32)"  "rgba(  0, 46, 32,255)"  "Burnham"
#Res_BurningSand        = $7693D9;  $FF7693D9  "#D99376"  "rgb(217,147,118)"  "rgba(217,147,118,255)"  "BurningSand"
#Res_BurntCrimson       = $0B0065;  $FF0B0065  "#65000B"  "rgb(101,  0, 11)"  "rgba(101,  0, 11,255)"  "BurntCrimson"
#Res_Bush               = $1C2E0D;  $FF1C2E0D  "#0D2E1C"  "rgb( 13, 46, 28)"  "rgba( 13, 46, 28,255)"  "Bush"
#Res_Buttercup          = $16ADF3;  $FF16ADF3  "#F3AD16"  "rgb(243,173, 22)"  "rgba(243,173, 22,255)"  "Buttercup"
#Res_ButteredRum        = $0D75A1;  $FF0D75A1  "#A1750D"  "rgb(161,117, 13)"  "rgba(161,117, 13,255)"  "ButteredRum"
#Res_ButterflyBush      = $9A4E62;  $FF9A4E62  "#624E9A"  "rgb( 98, 78,154)"  "rgba( 98, 78,154,255)"  "ButterflyBush"
#Res_Buttermilk         = $B5F1FF;  $FFB5F1FF  "#FFF1B5"  "rgb(255,241,181)"  "rgba(255,241,181,255)"  "Buttermilk"
#Res_ButteryWhite       = $EAFCFF;  $FFEAFCFF  "#FFFCEA"  "rgb(255,252,234)"  "rgba(255,252,234,255)"  "ButteryWhite"
#Res_CabSav             = $180A4D;  $FF180A4D  "#4D0A18"  "rgb( 77, 10, 24)"  "rgba( 77, 10, 24,255)"  "CabSav"
#Res_Cabaret            = $7249D9;  $FF7249D9  "#D94972"  "rgb(217, 73,114)"  "rgba(217, 73,114,255)"  "Cabaret"
#Res_CabbagePont        = $3A4C3F;  $FF3A4C3F  "#3F4C3A"  "rgb( 63, 76, 58)"  "rgba( 63, 76, 58,255)"  "CabbagePont"
#Res_Cactus             = $567158;  $FF567158  "#587156"  "rgb( 88,113, 86)"  "rgba( 88,113, 86,255)"  "Cactus"
#Res_Cadillac           = $6A4CB0;  $FF6A4CB0  "#B04C6A"  "rgb(176, 76,106)"  "rgba(176, 76,106,255)"  "Cadillac"
#Res_CafeRoyale         = $0C446F;  $FF0C446F  "#6F440C"  "rgb(111, 68, 12)"  "rgba(111, 68, 12,255)"  "CafeRoyale"
#Res_Calico             = $95C0E0;  $FF95C0E0  "#E0C095"  "rgb(224,192,149)"  "rgba(224,192,149,255)"  "Calico"
#Res_California         = $049DFE;  $FF049DFE  "#FE9D04"  "rgb(254,157,  4)"  "rgba(254,157,  4,255)"  "California"
#Res_Calypso            = $8D7231;  $FF8D7231  "#31728D"  "rgb( 49,114,141)"  "rgba( 49,114,141,255)"  "Calypso"
#Res_Camarone           = $1A5800;  $FF1A5800  "#00581A"  "rgb(  0, 88, 26)"  "rgba(  0, 88, 26,255)"  "Camarone"
#Res_Camelot            = $563489;  $FF563489  "#893456"  "rgb(137, 52, 86)"  "rgba(137, 52, 86,255)"  "Camelot"
#Res_Cameo              = $9BB9D9;  $FF9BB9D9  "#D9B99B"  "rgb(217,185,155)"  "rgba(217,185,155,255)"  "Cameo"
#Res_Camouflage         = $10393C;  $FF10393C  "#3C3910"  "rgb( 60, 57, 16)"  "rgba( 60, 57, 16,255)"  "Camouflage"
#Res_CanCan             = $A491D5;  $FFA491D5  "#D591A4"  "rgb(213,145,164)"  "rgba(213,145,164,255)"  "CanCan"
#Res_Canary             = $62FBF3;  $FF62FBF3  "#F3FB62"  "rgb(243,251, 98)"  "rgba(243,251, 98,255)"  "Canary"
#Res_Candlelight        = $17D9FC;  $FF17D9FC  "#FCD917"  "rgb(252,217, 23)"  "rgba(252,217, 23,255)"  "Candlelight"
#Res_CannonBlack        = $061725;  $FF061725  "#251706"  "rgb( 37, 23,  6)"  "rgba( 37, 23,  6,255)"  "CannonBlack"
#Res_CannonPink         = $674389;  $FF674389  "#894367"  "rgb(137, 67,103)"  "rgba(137, 67,103,255)"  "CannonPink"
#Res_Canvas             = $89A5A8;  $FF89A5A8  "#A8A589"  "rgb(168,165,137)"  "rgba(168,165,137,255)"  "Canvas"
#Res_CapeCod            = $43443C;  $FF43443C  "#3C4443"  "rgb( 60, 68, 67)"  "rgba( 60, 68, 67,255)"  "CapeCod"
#Res_CapeHoney          = $ACE5FE;  $FFACE5FE  "#FEE5AC"  "rgb(254,229,172)"  "rgba(254,229,172,255)"  "CapeHoney"
#Res_CapePalliser       = $4566A2;  $FF4566A2  "#A26645"  "rgb(162,102, 69)"  "rgba(162,102, 69,255)"  "CapePalliser"
#Res_Caper              = $B4EDDC;  $FFB4EDDC  "#DCEDB4"  "rgb(220,237,180)"  "rgba(220,237,180,255)"  "Caper"
#Res_Capri              = $782A06;  $FF782A06  "#062A78"  "rgb(  6, 42,120)"  "rgba(  6, 42,120,255)"  "Capri"
#Res_Caramel            = $AFDDFF;  $FFAFDDFF  "#FFDDAF"  "rgb(255,221,175)"  "rgba(255,221,175,255)"  "Caramel"
#Res_Cararra            = $E8EEEE;  $FFE8EEEE  "#EEEEE8"  "rgb(238,238,232)"  "rgba(238,238,232,255)"  "Cararra"
#Res_CardinGreen        = $1C3601;  $FF1C3601  "#01361C"  "rgb(  1, 54, 28)"  "rgba(  1, 54, 28,255)"  "CardinGreen"
#Res_Cardinal           = $5E058C;  $FF5E058C  "#8C055E"  "rgb(140,  5, 94)"  "rgba(140,  5, 94,255)"  "Cardinal"
#Res_CareysPink         = $AA9ED2;  $FFAA9ED2  "#D29EAA"  "rgb(210,158,170)"  "rgba(210,158,170,255)"  "CareysPink"
#Res_Carissma           = $A888EA;  $FFA888EA  "#EA88A8"  "rgb(234,136,168)"  "rgba(234,136,168,255)"  "Carissma"
#Res_Carla              = $D8FFF3;  $FFD8FFF3  "#F3FFD8"  "rgb(243,255,216)"  "rgba(243,255,216,255)"  "Carla"
#Res_CarnabyTan         = $012E5C;  $FF012E5C  "#5C2E01"  "rgb( 92, 46,  1)"  "rgba( 92, 46,  1,255)"  "CarnabyTan"
#Res_CarouselPink       = $EDE0F9;  $FFEDE0F9  "#F9E0ED"  "rgb(249,224,237)"  "rgba(249,224,237,255)"  "CarouselPink"
#Res_Casablanca         = $53B8F8;  $FF53B8F8  "#F8B853"  "rgb(248,184, 83)"  "rgba(248,184, 83,255)"  "Casablanca"
#Res_Casal              = $68612F;  $FF68612F  "#2F6168"  "rgb( 47, 97,104)"  "rgba( 47, 97,104,255)"  "Casal"
#Res_Cascade            = $A5A98B;  $FFA5A98B  "#8BA9A5"  "rgb(139,169,165)"  "rgba(139,169,165,255)"  "Cascade"
#Res_Cashmere           = $A5BEE6;  $FFA5BEE6  "#E6BEA5"  "rgb(230,190,165)"  "rgba(230,190,165,255)"  "Cashmere"
#Res_Casper             = $D1BEAD;  $FFD1BEAD  "#ADBED1"  "rgb(173,190,209)"  "rgba(173,190,209,255)"  "Casper"
#Res_Castro             = $1F0052;  $FF1F0052  "#52001F"  "rgb( 82,  0, 31)"  "rgba( 82,  0, 31,255)"  "Castro"
#Res_CatalinaBlue       = $782A06;  $FF782A06  "#062A78"  "rgb(  6, 42,120)"  "rgba(  6, 42,120,255)"  "CatalinaBlue"
#Res_CatskillWhite      = $F7F6EE;  $FFF7F6EE  "#EEF6F7"  "rgb(238,246,247)"  "rgba(238,246,247,255)"  "CatskillWhite"
#Res_CavernPink         = $BEBEE3;  $FFBEBEE3  "#E3BEBE"  "rgb(227,190,190)"  "rgba(227,190,190,255)"  "CavernPink"
#Res_CeSoir             = $B57197;  $FFB57197  "#9771B5"  "rgb(151,113,181)"  "rgba(151,113,181,255)"  "CeSoir"
#Res_Cedar              = $141C3E;  $FF141C3E  "#3E1C14"  "rgb( 62, 28, 20)"  "rgba( 62, 28, 20,255)"  "Cedar"
#Res_CedarWoodFinish    = $001A71;  $FF001A71  "#711A00"  "rgb(113, 26,  0)"  "rgba(113, 26,  0,255)"  "CedarWoodFinish"
#Res_Celery             = $5DC2B8;  $FF5DC2B8  "#B8C25D"  "rgb(184,194, 93)"  "rgba(184,194, 93,255)"  "Celery"
#Res_Celeste            = $CAD2D1;  $FFCAD2D1  "#D1D2CA"  "rgb(209,210,202)"  "rgba(209,210,202,255)"  "Celeste"
#Res_Cello              = $5B381E;  $FF5B381E  "#1E385B"  "rgb( 30, 56, 91)"  "rgba( 30, 56, 91,255)"  "Cello"
#Res_Celtic             = $223216;  $FF223216  "#163222"  "rgb( 22, 50, 34)"  "rgba( 22, 50, 34,255)"  "Celtic"
#Res_Cement             = $62768D;  $FF62768D  "#8D7662"  "rgb(141,118, 98)"  "rgba(141,118, 98,255)"  "Cement"
#Res_Ceramic            = $F9FFFC;  $FFF9FFFC  "#FCFFF9"  "rgb(252,255,249)"  "rgba(252,255,249,255)"  "Ceramic"
#Res_Chablis            = $F3F4FF;  $FFF3F4FF  "#FFF4F3"  "rgb(255,244,243)"  "rgba(255,244,243,255)"  "Chablis"
#Res_ChaletGreen        = $3D6E51;  $FF3D6E51  "#516E3D"  "rgb( 81,110, 61)"  "rgba( 81,110, 61,255)"  "ChaletGreen"
#Res_Chalky             = $94D7EE;  $FF94D7EE  "#EED794"  "rgb(238,215,148)"  "rgba(238,215,148,255)"  "Chalky"
#Res_Chambray           = $8C4E35;  $FF8C4E35  "#354E8C"  "rgb( 53, 78,140)"  "rgba( 53, 78,140,255)"  "Chambray"
#Res_Chamois            = $B1DCED;  $FFB1DCED  "#EDDCB1"  "rgb(237,220,177)"  "rgba(237,220,177,255)"  "Chamois"
#Res_Champagne          = $CCECFA;  $FFCCECFA  "#FAECCC"  "rgb(250,236,204)"  "rgba(250,236,204,255)"  "Champagne"
#Res_Chantilly          = $DFC3F8;  $FFDFC3F8  "#F8C3DF"  "rgb(248,195,223)"  "rgba(248,195,223,255)"  "Chantilly"
#Res_Charade            = $372929;  $FF372929  "#292937"  "rgb( 41, 41, 55)"  "rgba( 41, 41, 55,255)"  "Charade"
#Res_Chardon            = $F1F3FF;  $FFF1F3FF  "#FFF3F1"  "rgb(255,243,241)"  "rgba(255,243,241,255)"  "Chardon"
#Res_Chardonnay         = $8CCDFF;  $FF8CCDFF  "#FFCD8C"  "rgb(255,205,140)"  "rgba(255,205,140,255)"  "Chardonnay"
#Res_Charlotte          = $F9EEBA;  $FFF9EEBA  "#BAEEF9"  "rgb(186,238,249)"  "rgba(186,238,249,255)"  "Charlotte"
#Res_Charm              = $9474D4;  $FF9474D4  "#D47494"  "rgb(212,116,148)"  "rgba(212,116,148,255)"  "Charm"
#Res_ChateauGreen       = $60A840;  $FF60A840  "#40A860"  "rgb( 64,168, 96)"  "rgba( 64,168, 96,255)"  "ChateauGreen"
#Res_Chatelle           = $C7B3BD;  $FFC7B3BD  "#BDB3C7"  "rgb(189,179,199)"  "rgba(189,179,199,255)"  "Chatelle"
#Res_ChathamsBlue       = $795517;  $FF795517  "#175579"  "rgb( 23, 85,121)"  "rgba( 23, 85,121,255)"  "ChathamsBlue"
#Res_ChelseaCucumber    = $5DAA83;  $FF5DAA83  "#83AA5D"  "rgb(131,170, 93)"  "rgba(131,170, 93,255)"  "ChelseaCucumber"
#Res_ChelseaGem         = $02539E;  $FF02539E  "#9E5302"  "rgb(158, 83,  2)"  "rgba(158, 83,  2,255)"  "ChelseaGem"
#Res_Chenin             = $6FCDDF;  $FF6FCDDF  "#DFCD6F"  "rgb(223,205,111)"  "rgba(223,205,111,255)"  "Chenin"
#Res_Cherokee           = $98DAFC;  $FF98DAFC  "#FCDA98"  "rgb(252,218,152)"  "rgba(252,218,152,255)"  "Cherokee"
#Res_CherryPie          = $59032A;  $FF59032A  "#2A0359"  "rgb( 42,  3, 89)"  "rgba( 42,  3, 89,255)"  "CherryPie"
#Res_Cherrywood         = $141A65;  $FF141A65  "#651A14"  "rgb(101, 26, 20)"  "rgba(101, 26, 20,255)"  "Cherrywood"
#Res_Cherub             = $E9D9F8;  $FFE9D9F8  "#F8D9E9"  "rgb(248,217,233)"  "rgba(248,217,233,255)"  "Cherub"
#Res_ChetwodeBlue       = $D98185;  $FFD98185  "#8581D9"  "rgb(133,129,217)"  "rgba(133,129,217,255)"  "ChetwodeBlue"
#Res_Chicago            = $585C5D;  $FF585C5D  "#5D5C58"  "rgb( 93, 92, 88)"  "rgba( 93, 92, 88,255)"  "Chicago"
#Res_Chiffon            = $C8FFF1;  $FFC8FFF1  "#F1FFC8"  "rgb(241,255,200)"  "rgba(241,255,200,255)"  "Chiffon"
#Res_ChileanFire        = $0377F7;  $FF0377F7  "#F77703"  "rgb(247,119,  3)"  "rgba(247,119,  3,255)"  "ChileanFire"
#Res_ChileanHeath       = $E6FDFF;  $FFE6FDFF  "#FFFDE6"  "rgb(255,253,230)"  "rgba(255,253,230,255)"  "ChileanHeath"
#Res_ChinaIvory         = $E7FFFC;  $FFE7FFFC  "#FCFFE7"  "rgb(252,255,231)"  "rgba(252,255,231,255)"  "ChinaIvory"
#Res_Chino              = $A7C7CE;  $FFA7C7CE  "#CEC7A7"  "rgb(206,199,167)"  "rgba(206,199,167,255)"  "Chino"
#Res_Chinook            = $BDE3A8;  $FFBDE3A8  "#A8E3BD"  "rgb(168,227,189)"  "rgba(168,227,189,255)"  "Chinook"
#Res_Chocolate          = $020237;  $FF020237  "#370202"  "rgb( 55,  2,  2)"  "rgba( 55,  2,  2,255)"  "Chocolate"
#Res_Christalle         = $6B0333;  $FF6B0333  "#33036B"  "rgb( 51,  3,107)"  "rgba( 51,  3,107,255)"  "Christalle"
#Res_Christi            = $12A767;  $FF12A767  "#67A712"  "rgb(103,167, 18)"  "rgba(103,167, 18,255)"  "Christi"
#Res_Christine          = $0A73E7;  $FF0A73E7  "#E7730A"  "rgb(231,115, 10)"  "rgba(231,115, 10,255)"  "Christine"
#Res_ChromeWhite        = $D4F1E8;  $FFD4F1E8  "#E8F1D4"  "rgb(232,241,212)"  "rgba(232,241,212,255)"  "ChromeWhite"
#Res_Cigar              = $1A3F77;  $FF1A3F77  "#773F1A"  "rgb(119, 63, 26)"  "rgba(119, 63, 26,255)"  "Cigar"
#Res_Cinder             = $180E0E;  $FF180E0E  "#0E0E18"  "rgb( 14, 14, 24)"  "rgba( 14, 14, 24,255)"  "Cinder"
#Res_Cinderella         = $DCE1FD;  $FFDCE1FD  "#FDE1DC"  "rgb(253,225,220)"  "rgba(253,225,220,255)"  "Cinderella"
#Res_Cinnamon           = $003F7B;  $FF003F7B  "#7B3F00"  "rgb(123, 63,  0)"  "rgba(123, 63,  0,255)"  "Cinnamon"
#Res_Cioccolato         = $0C2855;  $FF0C2855  "#55280C"  "rgb( 85, 40, 12)"  "rgba( 85, 40, 12,255)"  "Cioccolato"
#Res_CitrineWhite       = $D6F7FA;  $FFD6F7FA  "#FAF7D6"  "rgb(250,247,214)"  "rgba(250,247,214,255)"  "CitrineWhite"
#Res_Citron             = $1FA99E;  $FF1FA99E  "#9EA91F"  "rgb(158,169, 31)"  "rgba(158,169, 31,255)"  "Citron"
#Res_Citrus             = $0AC5A1;  $FF0AC5A1  "#A1C50A"  "rgb(161,197, 10)"  "rgba(161,197, 10,255)"  "Citrus"
#Res_Clairvoyant        = $560648;  $FF560648  "#480656"  "rgb( 72,  6, 86)"  "rgba( 72,  6, 86,255)"  "Clairvoyant"
#Res_ClamShell          = $AFB6D4;  $FFAFB6D4  "#D4B6AF"  "rgb(212,182,175)"  "rgba(212,182,175,255)"  "ClamShell"
#Res_Claret             = $34177F;  $FF34177F  "#7F1734"  "rgb(127, 23, 52)"  "rgba(127, 23, 52,255)"  "Claret"
#Res_ClassicRose        = $E7CCFB;  $FFE7CCFB  "#FBCCE7"  "rgb(251,204,231)"  "rgba(251,204,231,255)"  "ClassicRose"
#Res_ClayCreek          = $60838A;  $FF60838A  "#8A8360"  "rgb(138,131, 96)"  "rgba(138,131, 96,255)"  "ClayCreek"
#Res_ClearDay           = $FDFFE9;  $FFFDFFE9  "#E9FFFD"  "rgb(233,255,253)"  "rgba(233,255,253,255)"  "ClearDay"
#Res_Clementine         = $006EE9;  $FF006EE9  "#E96E00"  "rgb(233,110,  0)"  "rgba(233,110,  0,255)"  "Clementine"
#Res_Clinker            = $091D37;  $FF091D37  "#371D09"  "rgb( 55, 29,  9)"  "rgba( 55, 29,  9,255)"  "Clinker"
#Res_Cloud              = $BFC4C7;  $FFBFC4C7  "#C7C4BF"  "rgb(199,196,191)"  "rgba(199,196,191,255)"  "Cloud"
#Res_CloudBurst         = $542E20;  $FF542E20  "#202E54"  "rgb( 32, 46, 84)"  "rgba( 32, 46, 84,255)"  "CloudBurst"
#Res_Cloudy             = $9FA5AC;  $FF9FA5AC  "#ACA59F"  "rgb(172,165,159)"  "rgba(172,165,159,255)"  "Cloudy"
#Res_Clover             = $104938;  $FF104938  "#384910"  "rgb( 56, 73, 16)"  "rgba( 56, 73, 16,255)"  "Clover"
#Res_Cobalt             = $782A06;  $FF782A06  "#062A78"  "rgb(  6, 42,120)"  "rgba(  6, 42,120,255)"  "Cobalt"
#Res_CocoaBean          = $1C1C48;  $FF1C1C48  "#481C1C"  "rgb( 72, 28, 28)"  "rgba( 72, 28, 28,255)"  "CocoaBean"
#Res_CocoaBrown         = $1E1F30;  $FF1E1F30  "#301F1E"  "rgb( 48, 31, 30)"  "rgba( 48, 31, 30,255)"  "CocoaBrown"
#Res_CoconutCream       = $DCF7F8;  $FFDCF7F8  "#F8F7DC"  "rgb(248,247,220)"  "rgba(248,247,220,255)"  "CoconutCream"
#Res_CodGrey            = $0B0B0B;  $FF0B0B0B  "#0B0B0B"  "rgb( 11, 11, 11)"  "rgba( 11, 11, 11,255)"  "CodGrey"
#Res_Coffee             = $556570;  $FF556570  "#706555"  "rgb(112,101, 85)"  "rgba(112,101, 85,255)"  "Coffee"
#Res_CoffeeBean         = $0E142A;  $FF0E142A  "#2A140E"  "rgb( 42, 20, 14)"  "rgba( 42, 20, 14,255)"  "CoffeeBean"
#Res_Cognac             = $1D389F;  $FF1D389F  "#9F381D"  "rgb(159, 56, 29)"  "rgba(159, 56, 29,255)"  "Cognac"
#Res_Cola               = $00253F;  $FF00253F  "#3F2500"  "rgb( 63, 37,  0)"  "rgba( 63, 37,  0,255)"  "Cola"
#Res_ColdPurple         = $D9A0AB;  $FFD9A0AB  "#ABA0D9"  "rgb(171,160,217)"  "rgba(171,160,217,255)"  "ColdPurple"
#Res_ColdTurkey         = $BABACE;  $FFBABACE  "#CEBABA"  "rgb(206,186,186)"  "rgba(206,186,186,255)"  "ColdTurkey"
#Res_ColonialWhite      = $BCEDFF;  $FFBCEDFF  "#FFEDBC"  "rgb(255,237,188)"  "rgba(255,237,188,255)"  "ColonialWhite"
#Res_Comet              = $755D5C;  $FF755D5C  "#5C5D75"  "rgb( 92, 93,117)"  "rgba( 92, 93,117,255)"  "Comet"
#Res_Como               = $667C51;  $FF667C51  "#517C66"  "rgb( 81,124,102)"  "rgba( 81,124,102,255)"  "Como"
#Res_Conch              = $D2D9C9;  $FFD2D9C9  "#C9D9D2"  "rgb(201,217,210)"  "rgba(201,217,210,255)"  "Conch"
#Res_Concord            = $7A7B7C;  $FF7A7B7C  "#7C7B7A"  "rgb(124,123,122)"  "rgba(124,123,122,255)"  "Concord"
#Res_Concrete           = $F2F2F2;  $FFF2F2F2  "#F2F2F2"  "rgb(242,242,242)"  "rgba(242,242,242,255)"  "Concrete"
#Res_Confetti           = $5AD7E9;  $FF5AD7E9  "#E9D75A"  "rgb(233,215, 90)"  "rgba(233,215, 90,255)"  "Confetti"
#Res_CongoBrown         = $373759;  $FF373759  "#593737"  "rgb( 89, 55, 55)"  "rgba( 89, 55, 55,255)"  "CongoBrown"
#Res_Conifer            = $4DDDAC;  $FF4DDDAC  "#ACDD4D"  "rgb(172,221, 77)"  "rgba(172,221, 77,255)"  "Conifer"
#Res_Contessa           = $6B72C6;  $FF6B72C6  "#C6726B"  "rgb(198,114,107)"  "rgba(198,114,107,255)"  "Contessa"
#Res_CopperCanyon       = $153A7E;  $FF153A7E  "#7E3A15"  "rgb(126, 58, 21)"  "rgba(126, 58, 21,255)"  "CopperCanyon"
#Res_CopperRust         = $474794;  $FF474794  "#944747"  "rgb(148, 71, 71)"  "rgba(148, 71, 71,255)"  "CopperRust"
#Res_Coral              = $A2BCC7;  $FFA2BCC7  "#C7BCA2"  "rgb(199,188,162)"  "rgba(199,188,162,255)"  "Coral"
#Res_CoralCandy         = $D6DCFF;  $FFD6DCFF  "#FFDCD6"  "rgb(255,220,214)"  "rgba(255,220,214,255)"  "CoralCandy"
#Res_CoralTree          = $6B6BA8;  $FF6B6BA8  "#A86B6B"  "rgb(168,107,107)"  "rgba(168,107,107,255)"  "CoralTree"
#Res_Corduroy           = $686E60;  $FF686E60  "#606E68"  "rgb( 96,110,104)"  "rgba( 96,110,104,255)"  "Corduroy"
#Res_Coriander          = $B0D0C4;  $FFB0D0C4  "#C4D0B0"  "rgb(196,208,176)"  "rgba(196,208,176,255)"  "Coriander"
#Res_Cork               = $1D2940;  $FF1D2940  "#40291D"  "rgb( 64, 41, 29)"  "rgba( 64, 41, 29,255)"  "Cork"
#Res_Corn               = $05BFE7;  $FF05BFE7  "#E7BF05"  "rgb(231,191,  5)"  "rgba(231,191,  5,255)"  "Corn"
#Res_CornField          = $CDFAF8;  $FFCDFAF8  "#F8FACD"  "rgb(248,250,205)"  "rgba(248,250,205,255)"  "CornField"
#Res_CornHarvest        = $0B6B8B;  $FF0B6B8B  "#8B6B0B"  "rgb(139,107, 11)"  "rgba(139,107, 11,255)"  "CornHarvest"
#Res_Cornflower         = $ACB0FF;  $FFACB0FF  "#FFB0AC"  "rgb(255,176,172)"  "rgba(255,176,172,255)"  "Cornflower"
#Res_Corvette           = $A2D3FA;  $FFA2D3FA  "#FAD3A2"  "rgb(250,211,162)"  "rgba(250,211,162,255)"  "Corvette"
#Res_Cosmic             = $5D3976;  $FF5D3976  "#76395D"  "rgb(118, 57, 93)"  "rgba(118, 57, 93,255)"  "Cosmic"
#Res_Cosmos             = $D9D8FF;  $FFD9D8FF  "#FFD8D9"  "rgb(255,216,217)"  "rgba(255,216,217,255)"  "Cosmos"
#Res_CostaDelSol        = $305D61;  $FF305D61  "#615D30"  "rgb( 97, 93, 48)"  "rgba( 97, 93, 48,255)"  "CostaDelSol"
#Res_CottonSeed         = $B6BDC2;  $FFB6BDC2  "#C2BDB6"  "rgb(194,189,182)"  "rgba(194,189,182,255)"  "CottonSeed"
#Res_CountyGreen        = $1A3701;  $FF1A3701  "#01371A"  "rgb(  1, 55, 26)"  "rgba(  1, 55, 26,255)"  "CountyGreen"
#Res_CoveGrey           = $571605;  $FF571605  "#051657"  "rgb(  5, 22, 87)"  "rgba(  5, 22, 87,255)"  "CoveGrey"
#Res_Cowboy             = $2D284D;  $FF2D284D  "#4D282D"  "rgb( 77, 40, 45)"  "rgba( 77, 40, 45,255)"  "Cowboy"
#Res_CrabApple          = $1227A0;  $FF1227A0  "#A02712"  "rgb(160, 39, 18)"  "rgba(160, 39, 18,255)"  "CrabApple"
#Res_Crail              = $4051B9;  $FF4051B9  "#B95140"  "rgb(185, 81, 64)"  "rgba(185, 81, 64,255)"  "Crail"
#Res_Cranberry          = $6C31B6;  $FF6C31B6  "#B6316C"  "rgb(182, 49,108)"  "rgba(182, 49,108,255)"  "Cranberry"
#Res_CraterBrown        = $252446;  $FF252446  "#462425"  "rgb( 70, 36, 37)"  "rgba( 70, 36, 37,255)"  "CraterBrown"
#Res_CreamBrulee        = $A0E5FF;  $FFA0E5FF  "#FFE5A0"  "rgb(255,229,160)"  "rgba(255,229,160,255)"  "CreamBrulee"
#Res_CreamCan           = $5CC8F5;  $FF5CC8F5  "#F5C85C"  "rgb(245,200, 92)"  "rgba(245,200, 92,255)"  "CreamCan"
#Res_CremeDeBanane      = $99FCFF;  $FF99FCFF  "#FFFC99"  "rgb(255,252,153)"  "rgba(255,252,153,255)"  "CremeDeBanane"
#Res_Creole             = $040F1E;  $FF040F1E  "#1E0F04"  "rgb( 30, 15,  4)"  "rgba( 30, 15,  4,255)"  "Creole"
#Res_Crete              = $297873;  $FF297873  "#737829"  "rgb(115,120, 41)"  "rgba(115,120, 41,255)"  "Crete"
#Res_Crocodile          = $586D73;  $FF586D73  "#736D58"  "rgb(115,109, 88)"  "rgba(115,109, 88,255)"  "Crocodile"
#Res_CrownofThorns      = $1F1F77;  $FF1F1F77  "#771F1F"  "rgb(119, 31, 31)"  "rgba(119, 31, 31,255)"  "CrownofThorns"
#Res_Crowshead          = $08121C;  $FF08121C  "#1C1208"  "rgb( 28, 18,  8)"  "rgba( 28, 18,  8,255)"  "Crowshead"
#Res_Cruise             = $DFECB5;  $FFDFECB5  "#B5ECDF"  "rgb(181,236,223)"  "rgba(181,236,223,255)"  "Cruise"
#Res_Crusoe             = $164800;  $FF164800  "#004816"  "rgb(  0, 72, 22)"  "rgba(  0, 72, 22,255)"  "Crusoe"
#Res_Crusta             = $337BFD;  $FF337BFD  "#FD7B33"  "rgb(253,123, 51)"  "rgba(253,123, 51,255)"  "Crusta"
#Res_CubanTan           = $0E142A;  $FF0E142A  "#2A140E"  "rgb( 42, 20, 14)"  "rgba( 42, 20, 14,255)"  "CubanTan"
#Res_Cumin              = $214392;  $FF214392  "#924321"  "rgb(146, 67, 33)"  "rgba(146, 67, 33,255)"  "Cumin"
#Res_Cumulus            = $D5FFFD;  $FFD5FFFD  "#FDFFD5"  "rgb(253,255,213)"  "rgba(253,255,213,255)"  "Cumulus"
#Res_Cupid              = $DABEFB;  $FFDABEFB  "#FBBEDA"  "rgb(251,190,218)"  "rgba(251,190,218,255)"  "Cupid"
#Res_CuriousBlue        = $D19625;  $FFD19625  "#2596D1"  "rgb( 37,150,209)"  "rgba( 37,150,209,255)"  "CuriousBlue"
#Res_CuttySark          = $727650;  $FF727650  "#507672"  "rgb( 80,118,114)"  "rgba( 80,118,114,255)"  "CuttySark"
#Res_Cyprus             = $403E00;  $FF403E00  "#003E40"  "rgb(  0, 62, 64)"  "rgba(  0, 62, 64,255)"  "Cyprus"
#Res_Daintree           = $312701;  $FF312701  "#012731"  "rgb(  1, 39, 49)"  "rgba(  1, 39, 49,255)"  "Daintree"
#Res_DairyCream         = $BCE4F9;  $FFBCE4F9  "#F9E4BC"  "rgb(249,228,188)"  "rgba(249,228,188,255)"  "DairyCream"
#Res_DaisyBush          = $98234F;  $FF98234F  "#4F2398"  "rgb( 79, 35,152)"  "rgba( 79, 35,152,255)"  "DaisyBush"
#Res_Dallas             = $264B6E;  $FF264B6E  "#6E4B26"  "rgb(110, 75, 38)"  "rgba(110, 75, 38,255)"  "Dallas"
#Res_Danube             = $D19360;  $FFD19360  "#6093D1"  "rgb( 96,147,209)"  "rgba( 96,147,209,255)"  "Danube"
#Res_DarkEbony          = $05203C;  $FF05203C  "#3C2005"  "rgb( 60, 32,  5)"  "rgba( 60, 32,  5,255)"  "DarkEbony"
#Res_DarkOak            = $182761;  $FF182761  "#612718"  "rgb( 97, 39, 24)"  "rgba( 97, 39, 24,255)"  "DarkOak"
#Res_DarkRimu           = $263D5F;  $FF263D5F  "#5F3D26"  "rgb( 95, 61, 38)"  "rgba( 95, 61, 38,255)"  "DarkRimu"
#Res_DarkRum            = $102041;  $FF102041  "#412010"  "rgb( 65, 32, 16)"  "rgba( 65, 32, 16,255)"  "DarkRum"
#Res_DarkSlate          = $514839;  $FF514839  "#394851"  "rgb( 57, 72, 81)"  "rgba( 57, 72, 81,255)"  "DarkSlate"
#Res_DarkTan            = $101066;  $FF101066  "#661010"  "rgb(102, 16, 16)"  "rgba(102, 16, 16,255)"  "DarkTan"
#Res_Dawn               = $9AA2A6;  $FF9AA2A6  "#A6A29A"  "rgb(166,162,154)"  "rgba(166,162,154,255)"  "Dawn"
#Res_DawnPink           = $E5E9F3;  $FFE5E9F3  "#F3E9E5"  "rgb(243,233,229)"  "rgba(243,233,229,255)"  "DawnPink"
#Res_DeYork             = $88C47A;  $FF88C47A  "#7AC488"  "rgb(122,196,136)"  "rgba(122,196,136,255)"  "DeYork"
#Res_Deco               = $97DAD2;  $FF97DAD2  "#D2DA97"  "rgb(210,218,151)"  "rgba(210,218,151,255)"  "Deco"
#Res_DeepBlush          = $9876E4;  $FF9876E4  "#E47698"  "rgb(228,118,152)"  "rgba(228,118,152,255)"  "DeepBlush"
#Res_DeepBronze         = $04304A;  $FF04304A  "#4A3004"  "rgb( 74, 48,  4)"  "rgba( 74, 48,  4,255)"  "DeepBronze"
#Res_DeepCove           = $401005;  $FF401005  "#051040"  "rgb(  5, 16, 64)"  "rgba(  5, 16, 64,255)"  "DeepCove"
#Res_DeepFir            = $002900;  $FF002900  "#002900"  "rgb(  0, 41,  0)"  "rgba(  0, 41,  0,255)"  "DeepFir"
#Res_DeepKoamaru        = $7B121B;  $FF7B121B  "#1B127B"  "rgb( 27, 18,123)"  "rgba( 27, 18,123,255)"  "DeepKoamaru"
#Res_DeepOak            = $102041;  $FF102041  "#412010"  "rgb( 65, 32, 16)"  "rgba( 65, 32, 16,255)"  "DeepOak"
#Res_DeepSea            = $6B8201;  $FF6B8201  "#01826B"  "rgb(  1,130,107)"  "rgba(  1,130,107,255)"  "DeepSea"
#Res_DeepTeal           = $323500;  $FF323500  "#003532"  "rgb(  0, 53, 50)"  "rgba(  0, 53, 50,255)"  "DeepTeal"
#Res_DelRio             = $959AB0;  $FF959AB0  "#B09A95"  "rgb(176,154,149)"  "rgba(176,154,149,255)"  "DelRio"
#Res_Dell               = $136439;  $FF136439  "#396413"  "rgb( 57,100, 19)"  "rgba( 57,100, 19,255)"  "Dell"
#Res_Delta              = $9DA4A4;  $FF9DA4A4  "#A4A49D"  "rgb(164,164,157)"  "rgba(164,164,157,255)"  "Delta"
#Res_Deluge             = $A86375;  $FFA86375  "#7563A8"  "rgb(117, 99,168)"  "rgba(117, 99,168,255)"  "Deluge"
#Res_Derby              = $D8EEFF;  $FFD8EEFF  "#FFEED8"  "rgb(255,238,216)"  "rgba(255,238,216,255)"  "Derby"
#Res_Desert             = $2060AE;  $FF2060AE  "#AE6020"  "rgb(174, 96, 32)"  "rgba(174, 96, 32,255)"  "Desert"
#Res_DesertStorm        = $F7F8F8;  $FFF7F8F8  "#F8F8F7"  "rgb(248,248,247)"  "rgba(248,248,247,255)"  "DesertStorm"
#Res_Dew                = $FEFFEA;  $FFFEFFEA  "#EAFFFE"  "rgb(234,255,254)"  "rgba(234,255,254,255)"  "Dew"
#Res_DiSerria           = $5E99DB;  $FF5E99DB  "#DB995E"  "rgb(219,153, 94)"  "rgba(219,153, 94,255)"  "DiSerria"
#Res_Diesel             = $000013;  $FF000013  "#130000"  "rgb( 19,  0,  0)"  "rgba( 19,  0,  0,255)"  "Diesel"
#Res_Dingley            = $47775D;  $FF47775D  "#5D7747"  "rgb( 93,119, 71)"  "rgba( 93,119, 71,255)"  "Dingley"
#Res_Disco              = $501587;  $FF501587  "#871550"  "rgb(135, 21, 80)"  "rgba(135, 21, 80,255)"  "Disco"
#Res_Dixie              = $1894E2;  $FF1894E2  "#E29418"  "rgb(226,148, 24)"  "rgba(226,148, 24,255)"  "Dixie"
#Res_Dolly              = $8BFFF9;  $FF8BFFF9  "#F9FF8B"  "rgb(249,255,139)"  "rgba(249,255,139,255)"  "Dolly"
#Res_Dolphin            = $776064;  $FF776064  "#646077"  "rgb(100, 96,119)"  "rgba(100, 96,119,255)"  "Dolphin"
#Res_Domino             = $5E778E;  $FF5E778E  "#8E775E"  "rgb(142,119, 94)"  "rgba(142,119, 94,255)"  "Domino"
#Res_DonJuan            = $514C5D;  $FF514C5D  "#5D4C51"  "rgb( 93, 76, 81)"  "rgba( 93, 76, 81,255)"  "DonJuan"
#Res_DonkeyBrown        = $7992A6;  $FF7992A6  "#A69279"  "rgb(166,146,121)"  "rgba(166,146,121,255)"  "DonkeyBrown"
#Res_Dorado             = $55576B;  $FF55576B  "#6B5755"  "rgb(107, 87, 85)"  "rgba(107, 87, 85,255)"  "Dorado"
#Res_DoubleColonialWhite= $ADE3EE;  $FFADE3EE  "#EEE3AD"  "rgb(238,227,173)"  "rgba(238,227,173,255)"  "DoubleColonialWhite"
#Res_DoublePearlLusta   = $D0F4FC;  $FFD0F4FC  "#FCF4D0"  "rgb(252,244,208)"  "rgba(252,244,208,255)"  "DoublePearlLusta"
#Res_DoubleSpanishWhite = $B9D7E6;  $FFB9D7E6  "#E6D7B9"  "rgb(230,215,185)"  "rgba(230,215,185,255)"  "DoubleSpanishWhite"
#Res_DoveGrey           = $6C6C6D;  $FF6C6C6D  "#6D6C6C"  "rgb(109,108,108)"  "rgba(109,108,108,255)"  "DoveGrey"
#Res_Downriver          = $562209;  $FF562209  "#092256"  "rgb(  9, 34, 86)"  "rgba(  9, 34, 86,255)"  "Downriver"
#Res_Downy              = $C5D06F;  $FFC5D06F  "#6FD0C5"  "rgb(111,208,197)"  "rgba(111,208,197,255)"  "Downy"
#Res_Driftwood          = $5187AF;  $FF5187AF  "#AF8751"  "rgb(175,135, 81)"  "rgba(175,135, 81,255)"  "Driftwood"
#Res_Drover             = $ADF7FD;  $FFADF7FD  "#FDF7AD"  "rgb(253,247,173)"  "rgba(253,247,173,255)"  "Drover"
#Res_Dune               = $333538;  $FF333538  "#383533"  "rgb( 56, 53, 51)"  "rgba( 56, 53, 51,255)"  "Dune"
#Res_DustStorm          = $C9CCE5;  $FFC9CCE5  "#E5CCC9"  "rgb(229,204,201)"  "rgba(229,204,201,255)"  "DustStorm"
#Res_DustyGrey          = $9B98A8;  $FF9B98A8  "#A8989B"  "rgb(168,152,155)"  "rgba(168,152,155,255)"  "DustyGrey"
#Res_DutchWhite         = $D1F8FF;  $FFD1F8FF  "#FFF8D1"  "rgb(255,248,209)"  "rgba(255,248,209,255)"  "DutchWhite"
#Res_Eagle              = $A4BAB6;  $FFA4BAB6  "#B6BAA4"  "rgb(182,186,164)"  "rgba(182,186,164,255)"  "Eagle"
#Res_EarlsGreen         = $3BB9C9;  $FF3BB9C9  "#C9B93B"  "rgb(201,185, 59)"  "rgba(201,185, 59,255)"  "EarlsGreen"
#Res_EarlyDawn          = $E6F9FF;  $FFE6F9FF  "#FFF9E6"  "rgb(255,249,230)"  "rgba(255,249,230,255)"  "EarlyDawn"
#Res_EastBay            = $7D4C41;  $FF7D4C41  "#414C7D"  "rgb( 65, 76,125)"  "rgba( 65, 76,125,255)"  "EastBay"
#Res_EastSide           = $CE91AC;  $FFCE91AC  "#AC91CE"  "rgb(172,145,206)"  "rgba(172,145,206,255)"  "EastSide"
#Res_EasternBlue        = $B09A1E;  $FFB09A1E  "#1E9AB0"  "rgb( 30,154,176)"  "rgba( 30,154,176,255)"  "EasternBlue"
#Res_Ebb                = $E3E3E9;  $FFE3E3E9  "#E9E3E3"  "rgb(233,227,227)"  "rgba(233,227,227,255)"  "Ebb"
#Res_Ebony              = $1D0B0C;  $FF1D0B0C  "#0C0B1D"  "rgb( 12, 11, 29)"  "rgba( 12, 11, 29,255)"  "Ebony"
#Res_EbonyClay          = $3B2826;  $FF3B2826  "#26283B"  "rgb( 38, 40, 59)"  "rgba( 38, 40, 59,255)"  "EbonyClay"
#Res_EchoBlue           = $D9BDAF;  $FFD9BDAF  "#AFBDD9"  "rgb(175,189,217)"  "rgba(175,189,217,255)"  "EchoBlue"
#Res_Eclipse            = $171C31;  $FF171C31  "#311C17"  "rgb( 49, 28, 23)"  "rgba( 49, 28, 23,255)"  "Eclipse"
#Res_EcruWhite          = $E5F3F5;  $FFE5F3F5  "#F5F3E5"  "rgb(245,243,229)"  "rgba(245,243,229,255)"  "EcruWhite"
#Res_Ecstasy            = $1478FA;  $FF1478FA  "#FA7814"  "rgb(250,120, 20)"  "rgba(250,120, 20,255)"  "Ecstasy"
#Res_Eden               = $525810;  $FF525810  "#105852"  "rgb( 16, 88, 82)"  "rgba( 16, 88, 82,255)"  "Eden"
#Res_Edgewater          = $D7E3C8;  $FFD7E3C8  "#C8E3D7"  "rgb(200,227,215)"  "rgba(200,227,215,255)"  "Edgewater"
#Res_Edward             = $ABAEA2;  $FFABAEA2  "#A2AEAB"  "rgb(162,174,171)"  "rgba(162,174,171,255)"  "Edward"
#Res_EggSour            = $DDF4FF;  $FFDDF4FF  "#FFF4DD"  "rgb(255,244,221)"  "rgba(255,244,221,255)"  "EggSour"
#Res_EggWhite           = $C1EFFF;  $FFC1EFFF  "#FFEFC1"  "rgb(255,239,193)"  "rgba(255,239,193,255)"  "EggWhite"
#Res_ElPaso             = $08171E;  $FF08171E  "#1E1708"  "rgb( 30, 23,  8)"  "rgba( 30, 23,  8,255)"  "ElPaso"
#Res_ElSalva            = $333E8F;  $FF333E8F  "#8F3E33"  "rgb(143, 62, 51)"  "rgba(143, 62, 51,255)"  "ElSalva"
#Res_Elephant           = $473412;  $FF473412  "#123447"  "rgb( 18, 52, 71)"  "rgba( 18, 52, 71,255)"  "Elephant"
#Res_ElfGreen           = $708308;  $FF708308  "#088370"  "rgb(  8,131,112)"  "rgba(  8,131,112,255)"  "ElfGreen"
#Res_Elm                = $7D7C1C;  $FF7D7C1C  "#1C7C7D"  "rgb( 28,124,125)"  "rgba( 28,124,125,255)"  "Elm"
#Res_Embers             = $1227A0;  $FF1227A0  "#A02712"  "rgb(160, 39, 18)"  "rgba(160, 39, 18,255)"  "Embers"
#Res_Eminence           = $82306C;  $FF82306C  "#6C3082"  "rgb(108, 48,130)"  "rgba(108, 48,130,255)"  "Eminence"
#Res_Emperor            = $494651;  $FF494651  "#514649"  "rgb( 81, 70, 73)"  "rgba( 81, 70, 73,255)"  "Emperor"
#Res_Empress            = $777381;  $FF777381  "#817377"  "rgb(129,115,119)"  "rgba(129,115,119,255)"  "Empress"
#Res_Endeavour          = $A75600;  $FFA75600  "#0056A7"  "rgb(  0, 86,167)"  "rgba(  0, 86,167,255)"  "Endeavour"
#Res_EnergyYellow       = $5CDDF8;  $FF5CDDF8  "#F8DD5C"  "rgb(248,221, 92)"  "rgba(248,221, 92,255)"  "EnergyYellow"
#Res_EnglishHolly       = $152D02;  $FF152D02  "#022D15"  "rgb(  2, 45, 21)"  "rgba(  2, 45, 21,255)"  "EnglishHolly"
#Res_EnglishWalnut      = $232B3E;  $FF232B3E  "#3E2B23"  "rgb( 62, 43, 35)"  "rgba( 62, 43, 35,255)"  "EnglishWalnut"
#Res_Envy               = $90A68B;  $FF90A68B  "#8BA690"  "rgb(139,166,144)"  "rgba(139,166,144,255)"  "Envy"
#Res_Equator            = $64BCE1;  $FF64BCE1  "#E1BC64"  "rgb(225,188,100)"  "rgba(225,188,100,255)"  "Equator"
#Res_Espresso           = $182761;  $FF182761  "#612718"  "rgb( 97, 39, 24)"  "rgba( 97, 39, 24,255)"  "Espresso"
#Res_Eternity           = $0E1A21;  $FF0E1A21  "#211A0E"  "rgb( 33, 26, 14)"  "rgba( 33, 26, 14,255)"  "Eternity"
#Res_Eucalyptus         = $5B8A27;  $FF5B8A27  "#278A5B"  "rgb( 39,138, 91)"  "rgba( 39,138, 91,255)"  "Eucalyptus"
#Res_Eunry              = $9DA3CF;  $FF9DA3CF  "#CFA39D"  "rgb(207,163,157)"  "rgba(207,163,157,255)"  "Eunry"
#Res_EveningSea         = $464E02;  $FF464E02  "#024E46"  "rgb(  2, 78, 70)"  "rgba(  2, 78, 70,255)"  "EveningSea"
#Res_Everglade          = $2E401C;  $FF2E401C  "#1C402E"  "rgb( 28, 64, 46)"  "rgba( 28, 64, 46,255)"  "Everglade"
#Res_FairPink           = $ECEFFF;  $FFECEFFF  "#FFEFEC"  "rgb(255,239,236)"  "rgba(255,239,236,255)"  "FairPink"
#Res_Falcon             = $6D627F;  $FF6D627F  "#7F626D"  "rgb(127, 98,109)"  "rgba(127, 98,109,255)"  "Falcon"
#Res_Fantasy            = $F0F3FA;  $FFF0F3FA  "#FAF3F0"  "rgb(250,243,240)"  "rgba(250,243,240,255)"  "Fantasy"
#Res_Fedora             = $786A79;  $FF786A79  "#796A78"  "rgb(121,106,120)"  "rgba(121,106,120,255)"  "Fedora"
#Res_Feijoa             = $8CDD9F;  $FF8CDD9F  "#9FDD8C"  "rgb(159,221,140)"  "rgba(159,221,140,255)"  "Feijoa"
#Res_Fern               = $0D480A;  $FF0D480A  "#0A480D"  "rgb( 10, 72, 13)"  "rgba( 10, 72, 13,255)"  "Fern"
#Res_FernFrond          = $207265;  $FF207265  "#657220"  "rgb(101,114, 32)"  "rgba(101,114, 32,255)"  "FernFrond"
#Res_Ferra              = $504F70;  $FF504F70  "#704F50"  "rgb(112, 79, 80)"  "rgba(112, 79, 80,255)"  "Ferra"
#Res_Festival           = $6CE9FB;  $FF6CE9FB  "#FBE96C"  "rgb(251,233,108)"  "rgba(251,233,108,255)"  "Festival"
#Res_Feta               = $EAFCF0;  $FFEAFCF0  "#F0FCEA"  "rgb(240,252,234)"  "rgba(240,252,234,255)"  "Feta"
#Res_FieryOrange        = $1352B3;  $FF1352B3  "#B35213"  "rgb(179, 82, 19)"  "rgba(179, 82, 19,255)"  "FieryOrange"
#Res_FijiGreen          = $207265;  $FF207265  "#657220"  "rgb(101,114, 32)"  "rgba(101,114, 32,255)"  "FijiGreen"
#Res_Finch              = $496662;  $FF496662  "#626649"  "rgb( 98,102, 73)"  "rgba( 98,102, 73,255)"  "Finch"
#Res_Finlandia          = $566D55;  $FF566D55  "#556D56"  "rgb( 85,109, 86)"  "rgba( 85,109, 86,255)"  "Finlandia"
#Res_Finn               = $542D69;  $FF542D69  "#692D54"  "rgb(105, 45, 84)"  "rgba(105, 45, 84,255)"  "Finn"
#Res_Fiord              = $695140;  $FF695140  "#405169"  "rgb( 64, 81,105)"  "rgba( 64, 81,105,255)"  "Fiord"
#Res_Fire               = $0342AA;  $FF0342AA  "#AA4203"  "rgb(170, 66,  3)"  "rgba(170, 66,  3,255)"  "Fire"
#Res_FireBush           = $2899E8;  $FF2899E8  "#E89928"  "rgb(232,153, 40)"  "rgba(232,153, 40,255)"  "FireBush"
#Res_Firefly            = $302A0E;  $FF302A0E  "#0E2A30"  "rgb( 14, 42, 48)"  "rgba( 14, 42, 48,255)"  "Firefly"
#Res_FlamePea           = $385BDA;  $FF385BDA  "#DA5B38"  "rgb(218, 91, 56)"  "rgba(218, 91, 56,255)"  "FlamePea"
#Res_FlameRed           = $1E03C7;  $FF1E03C7  "#C7031E"  "rgb(199,  3, 30)"  "rgba(199,  3, 30,255)"  "FlameRed"
#Res_Flamenco           = $077DFF;  $FF077DFF  "#FF7D07"  "rgb(255,125,  7)"  "rgba(255,125,  7,255)"  "Flamenco"
#Res_Flamingo           = $2A55F2;  $FF2A55F2  "#F2552A"  "rgb(242, 85, 42)"  "rgba(242, 85, 42,255)"  "Flamingo"
#Res_Flax               = $65827B;  $FF65827B  "#7B8265"  "rgb(123,130,101)"  "rgba(123,130,101,255)"  "Flax"
#Res_Flint              = $616A6F;  $FF616A6F  "#6F6A61"  "rgb(111,106, 97)"  "rgba(111,106, 97,255)"  "Flint"
#Res_Flirt              = $6D00A2;  $FF6D00A2  "#A2006D"  "rgb(162,  0,109)"  "rgba(162,  0,109,255)"  "Flirt"
#Res_Foam               = $FAFCD8;  $FFFAFCD8  "#D8FCFA"  "rgb(216,252,250)"  "rgba(216,252,250,255)"  "Foam"
#Res_Fog                = $FFD0D7;  $FFFFD0D7  "#D7D0FF"  "rgb(215,208,255)"  "rgba(215,208,255,255)"  "Fog"
#Res_FoggyGrey          = $B6CACB;  $FFB6CACB  "#CBCAB6"  "rgb(203,202,182)"  "rgba(203,202,182,255)"  "FoggyGrey"
#Res_ForestGreen        = $092D18;  $FF092D18  "#182D09"  "rgb( 24, 45,  9)"  "rgba( 24, 45,  9,255)"  "ForestGreen"
#Res_ForgetMeNot        = $EEF1FF;  $FFEEF1FF  "#FFF1EE"  "rgb(255,241,238)"  "rgba(255,241,238,255)"  "ForgetMeNot"
#Res_FountainBlue       = $BEB456;  $FFBEB456  "#56B4BE"  "rgb( 86,180,190)"  "rgba( 86,180,190,255)"  "FountainBlue"
#Res_Frangipani         = $B3DEFF;  $FFB3DEFF  "#FFDEB3"  "rgb(255,222,179)"  "rgba(255,222,179,255)"  "Frangipani"
#Res_FrenchGrey         = $C6BDBD;  $FFC6BDBD  "#BDBDC6"  "rgb(189,189,198)"  "rgba(189,189,198,255)"  "FrenchGrey"
#Res_FrenchLilac        = $EEC7EC;  $FFEEC7EC  "#ECC7EE"  "rgb(236,199,238)"  "rgba(236,199,238,255)"  "FrenchLilac"
#Res_FrenchPass         = $FDEDBD;  $FFFDEDBD  "#BDEDFD"  "rgb(189,237,253)"  "rgba(189,237,253,255)"  "FrenchPass"
#Res_FriarGrey          = $797E80;  $FF797E80  "#807E79"  "rgb(128,126,121)"  "rgba(128,126,121,255)"  "FriarGrey"
#Res_FringyFlower       = $C1E2B1;  $FFC1E2B1  "#B1E2C1"  "rgb(177,226,193)"  "rgba(177,226,193,255)"  "FringyFlower"
#Res_Froly              = $8475F5;  $FF8475F5  "#F57584"  "rgb(245,117,132)"  "rgba(245,117,132,255)"  "Froly"
#Res_Frost              = $DDF5ED;  $FFDDF5ED  "#EDF5DD"  "rgb(237,245,221)"  "rgba(237,245,221,255)"  "Frost"
#Res_FrostedMint        = $F8FFDB;  $FFF8FFDB  "#DBFFF8"  "rgb(219,255,248)"  "rgba(219,255,248,255)"  "FrostedMint"
#Res_Frostee            = $E7F6E4;  $FFE7F6E4  "#E4F6E7"  "rgb(228,246,231)"  "rgba(228,246,231,255)"  "Frostee"
#Res_FruitSalad         = $5D9D4F;  $FF5D9D4F  "#4F9D5D"  "rgb( 79,157, 93)"  "rgba( 79,157, 93,255)"  "FruitSalad"
#Res_Fuchsia            = $C1587A;  $FFC1587A  "#7A58C1"  "rgb(122, 88,193)"  "rgba(122, 88,193,255)"  "Fuchsia"
#Res_Fuego              = $0DDEBE;  $FF0DDEBE  "#BEDE0D"  "rgb(190,222, 13)"  "rgba(190,222, 13,255)"  "Fuego"
#Res_FuelYellow         = $27A9EC;  $FF27A9EC  "#ECA927"  "rgb(236,169, 39)"  "rgba(236,169, 39,255)"  "FuelYellow"
#Res_FunBlue            = $A85919;  $FFA85919  "#1959A8"  "rgb( 25, 89,168)"  "rgba( 25, 89,168,255)"  "FunBlue"
#Res_FunGreen           = $396D01;  $FF396D01  "#016D39"  "rgb(  1,109, 57)"  "rgba(  1,109, 57,255)"  "FunGreen"
#Res_FuscousGrey        = $4D5354;  $FF4D5354  "#54534D"  "rgb( 84, 83, 77)"  "rgba( 84, 83, 77,255)"  "FuscousGrey"
#Res_GableGreen         = $313516;  $FF313516  "#163531"  "rgb( 22, 53, 49)"  "rgba( 22, 53, 49,255)"  "GableGreen"
#Res_Gallery            = $EFEFEF;  $FFEFEFEF  "#EFEFEF"  "rgb(239,239,239)"  "rgba(239,239,239,255)"  "Gallery"
#Res_Galliano           = $0CB2DC;  $FF0CB2DC  "#DCB20C"  "rgb(220,178, 12)"  "rgba(220,178, 12,255)"  "Galliano"
#Res_Geebung            = $1B8FD1;  $FF1B8FD1  "#D18F1B"  "rgb(209,143, 27)"  "rgba(209,143, 27,255)"  "Geebung"
#Res_Genoa              = $6B7315;  $FF6B7315  "#15736B"  "rgb( 21,115,107)"  "rgba( 21,115,107,255)"  "Genoa"
#Res_Geraldine          = $8989FB;  $FF8989FB  "#FB8989"  "rgb(251,137,137)"  "rgba(251,137,137,255)"  "Geraldine"
#Res_Geyser             = $E2DFD4;  $FFE2DFD4  "#D4DFE2"  "rgb(212,223,226)"  "rgba(212,223,226,255)"  "Geyser"
#Res_Ghost              = $D5C9C7;  $FFD5C9C7  "#C7C9D5"  "rgb(199,201,213)"  "rgba(199,201,213,255)"  "Ghost"
#Res_Gigas              = $943C52;  $FF943C52  "#523C94"  "rgb( 82, 60,148)"  "rgba( 82, 60,148,255)"  "Gigas"
#Res_Gimblet            = $6AB5B8;  $FF6AB5B8  "#B8B56A"  "rgb(184,181,106)"  "rgba(184,181,106,255)"  "Gimblet"
#Res_Gin                = $EBF2E8;  $FFEBF2E8  "#E8F2EB"  "rgb(232,242,235)"  "rgba(232,242,235,255)"  "Gin"
#Res_GinFizz            = $E2F9FF;  $FFE2F9FF  "#FFF9E2"  "rgb(255,249,226)"  "rgba(255,249,226,255)"  "GinFizz"
#Res_Givry              = $BFE4F8;  $FFBFE4F8  "#F8E4BF"  "rgb(248,228,191)"  "rgba(248,228,191,255)"  "Givry"
#Res_Glacier            = $C4B380;  $FFC4B380  "#80B3C4"  "rgb(128,179,196)"  "rgba(128,179,196,255)"  "Glacier"
#Res_GladeGreen         = $5F8461;  $FF5F8461  "#61845F"  "rgb( 97,132, 95)"  "rgba( 97,132, 95,255)"  "GladeGreen"
#Res_GoBen              = $4E6D72;  $FF4E6D72  "#726D4E"  "rgb(114,109, 78)"  "rgba(114,109, 78,255)"  "GoBen"
#Res_Goblin             = $527D3D;  $FF527D3D  "#3D7D52"  "rgb( 61,125, 82)"  "rgba( 61,125, 82,255)"  "Goblin"
#Res_GoldDrop           = $0082F1;  $FF0082F1  "#F18200"  "rgb(241,130,  0)"  "rgba(241,130,  0,255)"  "GoldDrop"
#Res_GoldTips           = $13BADE;  $FF13BADE  "#DEBA13"  "rgb(222,186, 19)"  "rgba(222,186, 19,255)"  "GoldTips"
#Res_GoldenBell         = $1389E2;  $FF1389E2  "#E28913"  "rgb(226,137, 19)"  "rgba(226,137, 19,255)"  "GoldenBell"
#Res_GoldenDream        = $2DD5F0;  $FF2DD5F0  "#F0D52D"  "rgb(240,213, 45)"  "rgba(240,213, 45,255)"  "GoldenDream"
#Res_GoldenFizz         = $3DFBF5;  $FF3DFBF5  "#F5FB3D"  "rgb(245,251, 61)"  "rgba(245,251, 61,255)"  "GoldenFizz"
#Res_GoldenGlow         = $95E2FD;  $FF95E2FD  "#FDE295"  "rgb(253,226,149)"  "rgba(253,226,149,255)"  "GoldenGlow"
#Res_GoldenSand         = $7DDBF0;  $FF7DDBF0  "#F0DB7D"  "rgb(240,219,125)"  "rgba(240,219,125,255)"  "GoldenSand"
#Res_GoldenTainoi       = $5CCCFF;  $FF5CCCFF  "#FFCC5C"  "rgb(255,204, 92)"  "rgba(255,204, 92,255)"  "GoldenTainoi"
#Res_Gondola            = $141426;  $FF141426  "#261414"  "rgb( 38, 20, 20)"  "rgba( 38, 20, 20,255)"  "Gondola"
#Res_GordonsGreen       = $07110B;  $FF07110B  "#0B1107"  "rgb( 11, 17,  7)"  "rgba( 11, 17,  7,255)"  "GordonsGreen"
#Res_Gorse              = $4FF1FF;  $FF4FF1FF  "#FFF14F"  "rgb(255,241, 79)"  "rgba(255,241, 79,255)"  "Gorse"
#Res_Gossamer           = $819B06;  $FF819B06  "#069B81"  "rgb(  6,155,129)"  "rgba(  6,155,129,255)"  "Gossamer"
#Res_Gossip             = $B0F8D2;  $FFB0F8D2  "#D2F8B0"  "rgb(210,248,176)"  "rgba(210,248,176,255)"  "Gossip"
#Res_Gothic             = $A1926D;  $FFA1926D  "#6D92A1"  "rgb(109,146,161)"  "rgba(109,146,161,255)"  "Gothic"
#Res_GovernorBay        = $B33C2F;  $FFB33C2F  "#2F3CB3"  "rgb( 47, 60,179)"  "rgba( 47, 60,179,255)"  "GovernorBay"
#Res_GrainBrown         = $B7D5E4;  $FFB7D5E4  "#E4D5B7"  "rgb(228,213,183)"  "rgba(228,213,183,255)"  "GrainBrown"
#Res_Grandis            = $8CD3FF;  $FF8CD3FF  "#FFD38C"  "rgb(255,211,140)"  "rgba(255,211,140,255)"  "Grandis"
#Res_GraniteGreen       = $74898D;  $FF74898D  "#8D8974"  "rgb(141,137,116)"  "rgba(141,137,116,255)"  "GraniteGreen"
#Res_GrannyApple        = $E3F6D5;  $FFE3F6D5  "#D5F6E3"  "rgb(213,246,227)"  "rgba(213,246,227,255)"  "GrannyApple"
#Res_GrannySmith        = $A0A084;  $FFA0A084  "#84A0A0"  "rgb(132,160,160)"  "rgba(132,160,160,255)"  "GrannySmith"
#Res_Grape              = $511A38;  $FF511A38  "#381A51"  "rgb( 56, 26, 81)"  "rgba( 56, 26, 81,255)"  "Grape"
#Res_Graphite           = $071625;  $FF071625  "#251607"  "rgb( 37, 22,  7)"  "rgba( 37, 22,  7,255)"  "Graphite"
#Res_GrassHopper        = $31767C;  $FF31767C  "#7C7631"  "rgb(124,118, 49)"  "rgba(124,118, 49,255)"  "GrassHopper"
#Res_Gravel             = $4B444A;  $FF4B444A  "#4A444B"  "rgb( 74, 68, 75)"  "rgba( 74, 68, 75,255)"  "Gravel"
#Res_GreenHouse         = $0F5024;  $FF0F5024  "#24500F"  "rgb( 36, 80, 15)"  "rgba( 36, 80, 15,255)"  "GreenHouse"
#Res_GreenKelp          = $1C3125;  $FF1C3125  "#25311C"  "rgb( 37, 49, 28)"  "rgba( 37, 49, 28,255)"  "GreenKelp"
#Res_GreenLeaf          = $0D6A43;  $FF0D6A43  "#436A0D"  "rgb( 67,106, 13)"  "rgba( 67,106, 13,255)"  "GreenLeaf"
#Res_GreenMist          = $B0D3CB;  $FFB0D3CB  "#CBD3B0"  "rgb(203,211,176)"  "rgba(203,211,176,255)"  "GreenMist"
#Res_GreenPea           = $42611D;  $FF42611D  "#1D6142"  "rgb( 29, 97, 66)"  "rgba( 29, 97, 66,255)"  "GreenPea"
#Res_GreenSmoke         = $6EAFA4;  $FF6EAFA4  "#A4AF6E"  "rgb(164,175,110)"  "rgba(164,175,110,255)"  "GreenSmoke"
#Res_GreenSpring        = $B1C1B8;  $FFB1C1B8  "#B8C1B1"  "rgb(184,193,177)"  "rgba(184,193,177,255)"  "GreenSpring"
#Res_GreenVogue         = $522B03;  $FF522B03  "#032B52"  "rgb(  3, 43, 82)"  "rgba(  3, 43, 82,255)"  "GreenVogue"
#Res_GreenWaterloo      = $051410;  $FF051410  "#101405"  "rgb( 16, 20,  5)"  "rgba( 16, 20,  5,255)"  "GreenWaterloo"
#Res_GreenWhite         = $E0EBE8;  $FFE0EBE8  "#E8EBE0"  "rgb(232,235,224)"  "rgba(232,235,224,255)"  "GreenWhite"
#Res_Greenstone         = $403E00;  $FF403E00  "#003E40"  "rgb(  0, 62, 64)"  "rgba(  0, 62, 64,255)"  "Greenstone"
#Res_Grenadier          = $0046D5;  $FF0046D5  "#D54600"  "rgb(213, 70,  0)"  "rgba(213, 70,  0,255)"  "Grenadier"
#Res_GreyChateau        = $B3AAA2;  $FFB3AAA2  "#A2AAB3"  "rgb(162,170,179)"  "rgba(162,170,179,255)"  "GreyChateau"
#Res_GreyGreen          = $364945;  $FF364945  "#454936"  "rgb( 69, 73, 54)"  "rgba( 69, 73, 54,255)"  "GreyGreen"
#Res_GreyNickel         = $BDC3C3;  $FFBDC3C3  "#C3C3BD"  "rgb(195,195,189)"  "rgba(195,195,189,255)"  "GreyNickel"
#Res_GreyNurse          = $E6ECE7;  $FFE6ECE7  "#E7ECE6"  "rgb(231,236,230)"  "rgba(231,236,230,255)"  "GreyNurse"
#Res_GreyOlive          = $91A4A9;  $FF91A4A9  "#A9A491"  "rgb(169,164,145)"  "rgba(169,164,145,255)"  "GreyOlive"
#Res_GreySuit           = $CDBEC1;  $FFCDBEC1  "#C1BECD"  "rgb(193,190,205)"  "rgba(193,190,205,255)"  "GreySuit"
#Res_GuardsmanRed       = $0101BA;  $FF0101BA  "#BA0101"  "rgb(186,  1,  1)"  "rgba(186,  1,  1,255)"  "GuardsmanRed"
#Res_GulfBlue           = $571605;  $FF571605  "#051657"  "rgb(  5, 22, 87)"  "rgba(  5, 22, 87,255)"  "GulfBlue"
#Res_GulfStream         = $AEB380;  $FFAEB380  "#80B3AE"  "rgb(128,179,174)"  "rgba(128,179,174,255)"  "GulfStream"
#Res_GullGrey           = $B7AC9D;  $FFB7AC9D  "#9DACB7"  "rgb(157,172,183)"  "rgba(157,172,183,255)"  "GullGrey"
#Res_GumLeaf            = $BFD3B6;  $FFBFD3B6  "#B6D3BF"  "rgb(182,211,191)"  "rgba(182,211,191,255)"  "GumLeaf"
#Res_Gumbo              = $A6A17C;  $FFA6A17C  "#7CA1A6"  "rgb(124,161,166)"  "rgba(124,161,166,255)"  "Gumbo"
#Res_GunPowder          = $574241;  $FF574241  "#414257"  "rgb( 65, 66, 87)"  "rgba( 65, 66, 87,255)"  "GunPowder"
#Res_Gunmetal           = $150D02;  $FF150D02  "#020D15"  "rgb(  2, 13, 21)"  "rgba(  2, 13, 21,255)"  "Gunmetal"
#Res_Gunsmoke           = $858682;  $FF858682  "#828685"  "rgb(130,134,133)"  "rgba(130,134,133,255)"  "Gunsmoke"
#Res_Gurkha             = $77959A;  $FF77959A  "#9A9577"  "rgb(154,149,119)"  "rgba(154,149,119,255)"  "Gurkha"
#Res_Hacienda           = $1B8198;  $FF1B8198  "#98811B"  "rgb(152,129, 27)"  "rgba(152,129, 27,255)"  "Hacienda"
#Res_HairyHeath         = $142A6B;  $FF142A6B  "#6B2A14"  "rgb(107, 42, 20)"  "rgba(107, 42, 20,255)"  "HairyHeath"
#Res_Haiti              = $35101B;  $FF35101B  "#1B1035"  "rgb( 27, 16, 53)"  "rgba( 27, 16, 53,255)"  "Haiti"
#Res_HalfandHalf        = $E1FEFF;  $FFE1FEFF  "#FFFEE1"  "rgb(255,254,225)"  "rgba(255,254,225,255)"  "HalfandHalf"
#Res_HalfBaked          = $CCC485;  $FFCCC485  "#85C4CC"  "rgb(133,196,204)"  "rgba(133,196,204,255)"  "HalfBaked"
#Res_HalfColonialWhite  = $D3F6FD;  $FFD3F6FD  "#FDF6D3"  "rgb(253,246,211)"  "rgba(253,246,211,255)"  "HalfColonialWhite"
#Res_HalfDutchWhite     = $DEF7FE;  $FFDEF7FE  "#FEF7DE"  "rgb(254,247,222)"  "rgba(254,247,222,255)"  "HalfDutchWhite"
#Res_HalfPearlLusta     = $EAFCFF;  $FFEAFCFF  "#FFFCEA"  "rgb(255,252,234)"  "rgba(255,252,234,255)"  "HalfPearlLusta"
#Res_HalfSpanishWhite   = $DBF4FE;  $FFDBF4FE  "#FEF4DB"  "rgb(254,244,219)"  "rgba(254,244,219,255)"  "HalfSpanishWhite"
#Res_Hampton            = $AFD8E5;  $FFAFD8E5  "#E5D8AF"  "rgb(229,216,175)"  "rgba(229,216,175,255)"  "Hampton"
#Res_Harp               = $EAF2E6;  $FFEAF2E6  "#E6F2EA"  "rgb(230,242,234)"  "rgba(230,242,234,255)"  "Harp"
#Res_HarvestGold        = $74B9E0;  $FF74B9E0  "#E0B974"  "rgb(224,185,116)"  "rgba(224,185,116,255)"  "HarvestGold"
#Res_Havana             = $151534;  $FF151534  "#341515"  "rgb( 52, 21, 21)"  "rgba( 52, 21, 21,255)"  "Havana"
#Res_HavelockBlue       = $D99055;  $FFD99055  "#5590D9"  "rgb( 85,144,217)"  "rgba( 85,144,217,255)"  "HavelockBlue"
#Res_HawaiianTan        = $16569D;  $FF16569D  "#9D5616"  "rgb(157, 86, 22)"  "rgba(157, 86, 22,255)"  "HawaiianTan"
#Res_HawkesBlue         = $FCE2D4;  $FFFCE2D4  "#D4E2FC"  "rgb(212,226,252)"  "rgba(212,226,252,255)"  "HawkesBlue"
#Res_Heath              = $121054;  $FF121054  "#541012"  "rgb( 84, 16, 18)"  "rgba( 84, 16, 18,255)"  "Heath"
#Res_Heather            = $D0C3B7;  $FFD0C3B7  "#B7C3D0"  "rgb(183,195,208)"  "rgba(183,195,208,255)"  "Heather"
#Res_HeatheredGrey      = $95B0B6;  $FF95B0B6  "#B6B095"  "rgb(182,176,149)"  "rgba(182,176,149,255)"  "HeatheredGrey"
#Res_HeavyMetal         = $28322B;  $FF28322B  "#2B3228"  "rgb( 43, 50, 40)"  "rgba( 43, 50, 40,255)"  "HeavyMetal"
#Res_Hemlock            = $3B5D5E;  $FF3B5D5E  "#5E5D3B"  "rgb( 94, 93, 59)"  "rgba( 94, 93, 59,255)"  "Hemlock"
#Res_Hemp               = $747890;  $FF747890  "#907874"  "rgb(144,120,116)"  "rgba(144,120,116,255)"  "Hemp"
#Res_Hibiscus           = $6C31B6;  $FF6C31B6  "#B6316C"  "rgb(182, 49,108)"  "rgba(182, 49,108,255)"  "Hibiscus"
#Res_Highball           = $398D90;  $FF398D90  "#908D39"  "rgb(144,141, 57)"  "rgba(144,141, 57,255)"  "Highball"
#Res_Highland           = $638E6F;  $FF638E6F  "#6F8E63"  "rgb(111,142, 99)"  "rgba(111,142, 99,255)"  "Highland"
#Res_Hillary            = $86A5AC;  $FF86A5AC  "#ACA586"  "rgb(172,165,134)"  "rgba(172,165,134,255)"  "Hillary"
#Res_Himalaya           = $1B5D6A;  $FF1B5D6A  "#6A5D1B"  "rgb(106, 93, 27)"  "rgba(106, 93, 27,255)"  "Himalaya"
#Res_HintofGreen        = $E9FFE6;  $FFE9FFE6  "#E6FFE9"  "rgb(230,255,233)"  "rgba(230,255,233,255)"  "HintofGreen"
#Res_HintofGrey         = $F9FFFC;  $FFF9FFFC  "#FCFFF9"  "rgb(252,255,249)"  "rgba(252,255,249,255)"  "HintofGrey"
#Res_HintofRed          = $F9F9F9;  $FFF9F9F9  "#F9F9F9"  "rgb(249,249,249)"  "rgba(249,249,249,255)"  "HintofRed"
#Res_HintofYellow       = $E4FDFA;  $FFE4FDFA  "#FAFDE4"  "rgb(250,253,228)"  "rgba(250,253,228,255)"  "HintofYellow"
#Res_HippieBlue         = $AF9A58;  $FFAF9A58  "#589AAF"  "rgb( 88,154,175)"  "rgba( 88,154,175,255)"  "HippieBlue"
#Res_HippieGreen        = $4B8253;  $FF4B8253  "#53824B"  "rgb( 83,130, 75)"  "rgba( 83,130, 75,255)"  "HippieGreen"
#Res_HippiePink         = $6045AE;  $FF6045AE  "#AE4560"  "rgb(174, 69, 96)"  "rgba(174, 69, 96,255)"  "HippiePink"
#Res_HitGrey            = $B5ADA1;  $FFB5ADA1  "#A1ADB5"  "rgb(161,173,181)"  "rgba(161,173,181,255)"  "HitGrey"
#Res_HitPink            = $81ABFF;  $FF81ABFF  "#FFAB81"  "rgb(255,171,129)"  "rgba(255,171,129,255)"  "HitPink"
#Res_HokeyPokey         = $28A5C8;  $FF28A5C8  "#C8A528"  "rgb(200,165, 40)"  "rgba(200,165, 40,255)"  "HokeyPokey"
#Res_Hoki               = $9F8665;  $FF9F8665  "#65869F"  "rgb(101,134,159)"  "rgba(101,134,159,255)"  "Hoki"
#Res_Holly              = $131D01;  $FF131D01  "#011D13"  "rgb(  1, 29, 19)"  "rgba(  1, 29, 19,255)"  "Holly"
#Res_HoneyFlower        = $701C4F;  $FF701C4F  "#4F1C70"  "rgb( 79, 28,112)"  "rgba( 79, 28,112,255)"  "HoneyFlower"
#Res_Honeysuckle        = $84FCED;  $FF84FCED  "#EDFC84"  "rgb(237,252,132)"  "rgba(237,252,132,255)"  "Honeysuckle"
#Res_Hopbush            = $A16DD0;  $FFA16DD0  "#D06DA1"  "rgb(208,109,161)"  "rgba(208,109,161,255)"  "Hopbush"
#Res_Horizon            = $A0875A;  $FFA0875A  "#5A87A0"  "rgb( 90,135,160)"  "rgba( 90,135,160,255)"  "Horizon"
#Res_HorsesNeck         = $134960;  $FF134960  "#604913"  "rgb( 96, 73, 19)"  "rgba( 96, 73, 19,255)"  "HorsesNeck"
#Res_HotChile           = $23078B;  $FF23078B  "#8B0723"  "rgb(139,  7, 35)"  "rgba(139,  7, 35,255)"  "HotChile"
#Res_HotCurry           = $216288;  $FF216288  "#886221"  "rgb(136, 98, 33)"  "rgba(136, 98, 33,255)"  "HotCurry"
#Res_HotPurple          = $560648;  $FF560648  "#480656"  "rgb( 72,  6, 86)"  "rgba( 72,  6, 86,255)"  "HotPurple"
#Res_HotToddy           = $0780B3;  $FF0780B3  "#B38007"  "rgb(179,128,  7)"  "rgba(179,128,  7,255)"  "HotToddy"
#Res_HummingBird        = $F3F9CF;  $FFF3F9CF  "#CFF9F3"  "rgb(207,249,243)"  "rgba(207,249,243,255)"  "HummingBird"
#Res_HunterGreen        = $101D16;  $FF101D16  "#161D10"  "rgb( 22, 29, 16)"  "rgba( 22, 29, 16,255)"  "HunterGreen"
#Res_Hurricane          = $7B7C87;  $FF7B7C87  "#877C7B"  "rgb(135,124,123)"  "rgba(135,124,123,255)"  "Hurricane"
#Res_Husk               = $58A4B7;  $FF58A4B7  "#B7A458"  "rgb(183,164, 88)"  "rgba(183,164, 88,255)"  "Husk"
#Res_IceCold            = $E7F4B1;  $FFE7F4B1  "#B1F4E7"  "rgb(177,244,231)"  "rgba(177,244,231,255)"  "IceCold"
#Res_Iceberg            = $F0F4DA;  $FFF0F4DA  "#DAF4F0"  "rgb(218,244,240)"  "rgba(218,244,240,255)"  "Iceberg"
#Res_Illusion           = $C9A4F6;  $FFC9A4F6  "#F6A4C9"  "rgb(246,164,201)"  "rgba(246,164,201,255)"  "Illusion"
#Res_IndianTan          = $011E4D;  $FF011E4D  "#4D1E01"  "rgb( 77, 30,  1)"  "rgba( 77, 30,  1,255)"  "IndianTan"
#Res_Indochine          = $036BC2;  $FF036BC2  "#C26B03"  "rgb(194,107,  3)"  "rgba(194,107,  3,255)"  "Indochine"
#Res_IrishCoffee        = $263D5F;  $FF263D5F  "#5F3D26"  "rgb( 95, 61, 38)"  "rgba( 95, 61, 38,255)"  "IrishCoffee"
#Res_Iroko              = $203143;  $FF203143  "#433120"  "rgb( 67, 49, 32)"  "rgba( 67, 49, 32,255)"  "Iroko"
#Res_Iron               = $D9D7D4;  $FFD9D7D4  "#D4D7D9"  "rgb(212,215,217)"  "rgba(212,215,217,255)"  "Iron"
#Res_Ironbark           = $101F41;  $FF101F41  "#411F10"  "rgb( 65, 31, 16)"  "rgba( 65, 31, 16,255)"  "Ironbark"
#Res_IronsideGrey       = $626667;  $FF626667  "#676662"  "rgb(103,102, 98)"  "rgba(103,102, 98,255)"  "IronsideGrey"
#Res_Ironstone          = $3C4886;  $FF3C4886  "#86483C"  "rgb(134, 72, 60)"  "rgba(134, 72, 60,255)"  "Ironstone"
#Res_IslandSpice        = $EEFCFF;  $FFEEFCFF  "#FFFCEE"  "rgb(255,252,238)"  "rgba(255,252,238,255)"  "IslandSpice"
#Res_Jacaranda          = $29032E;  $FF29032E  "#2E0329"  "rgb( 46,  3, 41)"  "rgba( 46,  3, 41,255)"  "Jacaranda"
#Res_Jacarta            = $6A2A3A;  $FF6A2A3A  "#3A2A6A"  "rgb( 58, 42,106)"  "rgba( 58, 42,106,255)"  "Jacarta"
#Res_JackoBean          = $05192E;  $FF05192E  "#2E1905"  "rgb( 46, 25,  5)"  "rgba( 46, 25,  5,255)"  "JackoBean"
#Res_JacksonsPurple     = $8D2020;  $FF8D2020  "#20208D"  "rgb( 32, 32,141)"  "rgba( 32, 32,141,255)"  "JacksonsPurple"
#Res_Jade               = $777942;  $FF777942  "#427977"  "rgb( 66,121,119)"  "rgba( 66,121,119,255)"  "Jade"
#Res_Jaffa              = $3F86EF;  $FF3F86EF  "#EF863F"  "rgb(239,134, 63)"  "rgba(239,134, 63,255)"  "Jaffa"
#Res_JaggedIce          = $E5E8C2;  $FFE5E8C2  "#C2E8E5"  "rgb(194,232,229)"  "rgba(194,232,229,255)"  "JaggedIce"
#Res_Jagger             = $570E35;  $FF570E35  "#350E57"  "rgb( 53, 14, 87)"  "rgba( 53, 14, 87,255)"  "Jagger"
#Res_Jaguar             = $100108;  $FF100108  "#080110"  "rgb(  8,  1, 16)"  "rgba(  8,  1, 16,255)"  "Jaguar"
#Res_Jambalaya          = $13305B;  $FF13305B  "#5B3013"  "rgb( 91, 48, 19)"  "rgba( 91, 48, 19,255)"  "Jambalaya"
#Res_Janna              = $D3EBF4;  $FFD3EBF4  "#F4EBD3"  "rgb(244,235,211)"  "rgba(244,235,211,255)"  "Janna"
#Res_JapaneseLaurel     = $06690A;  $FF06690A  "#0A6906"  "rgb( 10,105,  6)"  "rgba( 10,105,  6,255)"  "JapaneseLaurel"
#Res_JapaneseMaple      = $090178;  $FF090178  "#780109"  "rgb(120,  1,  9)"  "rgba(120,  1,  9,255)"  "JapaneseMaple"
#Res_Japonica           = $637CD8;  $FF637CD8  "#D87C63"  "rgb(216,124, 99)"  "rgba(216,124, 99,255)"  "Japonica"
#Res_Jarrah             = $151534;  $FF151534  "#341515"  "rgb( 52, 21, 21)"  "rgba( 52, 21, 21,255)"  "Jarrah"
#Res_Java               = $C2C21F;  $FFC2C21F  "#1FC2C2"  "rgb( 31,194,194)"  "rgba( 31,194,194,255)"  "Java"
#Res_Jazz               = $090178;  $FF090178  "#780109"  "rgb(120,  1,  9)"  "rgba(120,  1,  9,255)"  "Jazz"
#Res_JellyBean          = $9A7B29;  $FF9A7B29  "#297B9A"  "rgb( 41,123,154)"  "rgba( 41,123,154,255)"  "JellyBean"
#Res_JetStream          = $CED2B5;  $FFCED2B5  "#B5D2CE"  "rgb(181,210,206)"  "rgba(181,210,206,255)"  "JetStream"
#Res_Jewel              = $406B12;  $FF406B12  "#126B40"  "rgb( 18,107, 64)"  "rgba( 18,107, 64,255)"  "Jewel"
#Res_Joanna             = $E5F3F5;  $FFE5F3F5  "#F5F3E5"  "rgb(245,243,229)"  "rgba(245,243,229,255)"  "Joanna"
#Res_Jon                = $1F1F3B;  $FF1F1F3B  "#3B1F1F"  "rgb( 59, 31, 31)"  "rgba( 59, 31, 31,255)"  "Jon"
#Res_Jonquil            = $9AFFEE;  $FF9AFFEE  "#EEFF9A"  "rgb(238,255,154)"  "rgba(238,255,154,255)"  "Jonquil"
#Res_JordyBlue          = $F1B98A;  $FFF1B98A  "#8AB9F1"  "rgb(138,185,241)"  "rgba(138,185,241,255)"  "JordyBlue"
#Res_JudgeGrey          = $334354;  $FF334354  "#544333"  "rgb( 84, 67, 51)"  "rgba( 84, 67, 51,255)"  "JudgeGrey"
#Res_Jumbo              = $827B7C;  $FF827B7C  "#7C7B82"  "rgb(124,123,130)"  "rgba(124,123,130,255)"  "Jumbo"
#Res_JungleGreen        = $151E28;  $FF151E28  "#281E15"  "rgb( 40, 30, 21)"  "rgba( 40, 30, 21,255)"  "JungleGreen"
#Res_JungleMist         = $D3CFB4;  $FFD3CFB4  "#B4CFD3"  "rgb(180,207,211)"  "rgba(180,207,211,255)"  "JungleMist"
#Res_Juniper            = $92926D;  $FF92926D  "#6D9292"  "rgb(109,146,146)"  "rgba(109,146,146,255)"  "Juniper"
#Res_JustRight          = $B9CDEC;  $FFB9CDEC  "#ECCDB9"  "rgb(236,205,185)"  "rgba(236,205,185,255)"  "JustRight"
#Res_Kabul              = $3E485E;  $FF3E485E  "#5E483E"  "rgb( 94, 72, 62)"  "rgba( 94, 72, 62,255)"  "Kabul"
#Res_KaitokeGreen       = $204600;  $FF204600  "#004620"  "rgb(  0, 70, 32)"  "rgba(  0, 70, 32,255)"  "KaitokeGreen"
#Res_Kangaroo           = $BDC8C6;  $FFBDC8C6  "#C6C8BD"  "rgb(198,200,189)"  "rgba(198,200,189,255)"  "Kangaroo"
#Res_Karaka             = $09161E;  $FF09161E  "#1E1609"  "rgb( 30, 22,  9)"  "rgba( 30, 22,  9,255)"  "Karaka"
#Res_Karry              = $D4EAFF;  $FFD4EAFF  "#FFEAD4"  "rgb(255,234,212)"  "rgba(255,234,212,255)"  "Karry"
#Res_KashmirBlue        = $967050;  $FF967050  "#507096"  "rgb( 80,112,150)"  "rgba( 80,112,150,255)"  "KashmirBlue"
#Res_Kelp               = $364945;  $FF364945  "#454936"  "rgb( 69, 73, 54)"  "rgba( 69, 73, 54,255)"  "Kelp"
#Res_KenyanCopper       = $051C7C;  $FF051C7C  "#7C1C05"  "rgb(124, 28,  5)"  "rgba(124, 28,  5,255)"  "KenyanCopper"
#Res_Keppel             = $9EB03A;  $FF9EB03A  "#3AB09E"  "rgb( 58,176,158)"  "rgba( 58,176,158,255)"  "Keppel"
#Res_Kidnapper          = $D4EAE1;  $FFD4EAE1  "#E1EAD4"  "rgb(225,234,212)"  "rgba(225,234,212,255)"  "Kidnapper"
#Res_Kilamanjaro        = $020C24;  $FF020C24  "#240C02"  "rgb( 36, 12,  2)"  "rgba( 36, 12,  2,255)"  "Kilamanjaro"
#Res_Killarney          = $476A3A;  $FF476A3A  "#3A6A47"  "rgb( 58,106, 71)"  "rgba( 58,106, 71,255)"  "Killarney"
#Res_Kimberly           = $9F6C73;  $FF9F6C73  "#736C9F"  "rgb(115,108,159)"  "rgba(115,108,159,255)"  "Kimberly"
#Res_KingfisherDaisy    = $80043E;  $FF80043E  "#3E0480"  "rgb( 62,  4,128)"  "rgba( 62,  4,128,255)"  "KingfisherDaisy"
#Res_Kobi               = $C49FE7;  $FFC49FE7  "#E79FC4"  "rgb(231,159,196)"  "rgba(231,159,196,255)"  "Kobi"
#Res_Kokoda             = $576D6E;  $FF576D6E  "#6E6D57"  "rgb(110,109, 87)"  "rgba(110,109, 87,255)"  "Kokoda"
#Res_Korma              = $0E4B8F;  $FF0E4B8F  "#8F4B0E"  "rgb(143, 75, 14)"  "rgba(143, 75, 14,255)"  "Korma"
#Res_Koromiko           = $5FBDFF;  $FF5FBDFF  "#FFBD5F"  "rgb(255,189, 95)"  "rgba(255,189, 95,255)"  "Koromiko"
#Res_Kournikova         = $72E7FF;  $FF72E7FF  "#FFE772"  "rgb(255,231,114)"  "rgba(255,231,114,255)"  "Kournikova"
#Res_Kumera             = $216288;  $FF216288  "#886221"  "rgb(136, 98, 33)"  "rgba(136, 98, 33,255)"  "Kumera"
#Res_LaPalma            = $168736;  $FF168736  "#368716"  "rgb( 54,135, 22)"  "rgba( 54,135, 22,255)"  "LaPalma"
#Res_LaRioja            = $10C1B3;  $FF10C1B3  "#B3C110"  "rgb(179,193, 16)"  "rgba(179,193, 16,255)"  "LaRioja"
#Res_LasPalmas          = $10E6C6;  $FF10E6C6  "#C6E610"  "rgb(198,230, 16)"  "rgba(198,230, 16,255)"  "LasPalmas"
#Res_Laser              = $68B5C8;  $FF68B5C8  "#C8B568"  "rgb(200,181,104)"  "rgba(200,181,104,255)"  "Laser"
#Res_Laurel             = $789374;  $FF789374  "#749378"  "rgb(116,147,120)"  "rgba(116,147,120,255)"  "Laurel"
#Res_Lavender           = $E699A8;  $FFE699A8  "#A899E6"  "rgb(168,153,230)"  "rgba(168,153,230,255)"  "Lavender"
#Res_Leather            = $597096;  $FF597096  "#967059"  "rgb(150,112, 89)"  "rgba(150,112, 89,255)"  "Leather"
#Res_Lemon              = $1CD8F4;  $FF1CD8F4  "#F4D81C"  "rgb(244,216, 28)"  "rgba(244,216, 28,255)"  "Lemon"
#Res_LemonGinger        = $229EAC;  $FF229EAC  "#AC9E22"  "rgb(172,158, 34)"  "rgba(172,158, 34,255)"  "LemonGinger"
#Res_LemonGrass         = $8F9E9B;  $FF8F9E9B  "#9B9E8F"  "rgb(155,158,143)"  "rgba(155,158,143,255)"  "LemonGrass"
#Res_Licorice           = $562209;  $FF562209  "#092256"  "rgb(  9, 34, 86)"  "rgba(  9, 34, 86,255)"  "Licorice"
#Res_LightningYellow    = $1EC0FC;  $FF1EC0FC  "#FCC01E"  "rgb(252,192, 30)"  "rgba(252,192, 30,255)"  "LightningYellow"
#Res_LilacBush          = $D37498;  $FFD37498  "#9874D3"  "rgb(152,116,211)"  "rgba(152,116,211,255)"  "LilacBush"
#Res_Lily               = $BFAAC8;  $FFBFAAC8  "#C8AABF"  "rgb(200,170,191)"  "rgba(200,170,191,255)"  "Lily"
#Res_LilyWhite          = $FFF8E7;  $FFFFF8E7  "#E7F8FF"  "rgb(231,248,255)"  "rgba(231,248,255,255)"  "LilyWhite"
#Res_Lima               = $17BD76;  $FF17BD76  "#76BD17"  "rgb(118,189, 23)"  "rgba(118,189, 23,255)"  "Lima"
#Res_Lime               = $21C9BF;  $FF21C9BF  "#BFC921"  "rgb(191,201, 33)"  "rgba(191,201, 33,255)"  "Lime"
#Res_Limeade            = $029D6F;  $FF029D6F  "#6F9D02"  "rgb(111,157,  2)"  "rgba(111,157,  2,255)"  "Limeade"
#Res_LimedAsh           = $637D74;  $FF637D74  "#747D63"  "rgb(116,125, 99)"  "rgba(116,125, 99,255)"  "LimedAsh"
#Res_LimedGum           = $213942;  $FF213942  "#423921"  "rgb( 66, 57, 33)"  "rgba( 66, 57, 33,255)"  "LimedGum"
#Res_LimedOak           = $568AAC;  $FF568AAC  "#AC8A56"  "rgb(172,138, 86)"  "rgba(172,138, 86,255)"  "LimedOak"
#Res_LimedSpruce        = $514839;  $FF514839  "#394851"  "rgb( 57, 72, 81)"  "rgba( 57, 72, 81,255)"  "LimedSpruce"
#Res_Limerick           = $09C29D;  $FF09C29D  "#9DC209"  "rgb(157,194,  9)"  "rgba(157,194,  9,255)"  "Limerick"
#Res_Linen              = $D4E4E6;  $FFD4E4E6  "#E6E4D4"  "rgb(230,228,212)"  "rgba(230,228,212,255)"  "Linen"
#Res_LinkWater          = $F5E4D9;  $FFF5E4D9  "#D9E4F5"  "rgb(217,228,245)"  "rgba(217,228,245,255)"  "LinkWater"
#Res_Lipstick           = $6305AB;  $FF6305AB  "#AB0563"  "rgb(171,  5, 99)"  "rgba(171,  5, 99,255)"  "Lipstick"
#Res_LisbonBrown        = $213942;  $FF213942  "#423921"  "rgb( 66, 57, 33)"  "rgba( 66, 57, 33,255)"  "LisbonBrown"
#Res_LividBrown         = $2E284D;  $FF2E284D  "#4D282E"  "rgb( 77, 40, 46)"  "rgba( 77, 40, 46,255)"  "LividBrown"
#Res_Loafer             = $DEF4EE;  $FFDEF4EE  "#EEF4DE"  "rgb(238,244,222)"  "rgba(238,244,222,255)"  "Loafer"
#Res_Loblolly           = $CEC9BD;  $FFCEC9BD  "#BDC9CE"  "rgb(189,201,206)"  "rgba(189,201,206,255)"  "Loblolly"
#Res_Lochinvar          = $848C2C;  $FF848C2C  "#2C8C84"  "rgb( 44,140,132)"  "rgba( 44,140,132,255)"  "Lochinvar"
#Res_Lochmara           = $C77E00;  $FFC77E00  "#007EC7"  "rgb(  0,126,199)"  "rgba(  0,126,199,255)"  "Lochmara"
#Res_Locust             = $8EAFA8;  $FF8EAFA8  "#A8AF8E"  "rgb(168,175,142)"  "rgba(168,175,142,255)"  "Locust"
#Res_LogCabin           = $1D2A24;  $FF1D2A24  "#242A1D"  "rgb( 36, 42, 29)"  "rgba( 36, 42, 29,255)"  "LogCabin"
#Res_Logan              = $CDA9AA;  $FFCDA9AA  "#AAA9CD"  "rgb(170,169,205)"  "rgba(170,169,205,255)"  "Logan"
#Res_Lola               = $DBCFDF;  $FFDBCFDF  "#DFCFDB"  "rgb(223,207,219)"  "rgba(223,207,219,255)"  "Lola"
#Res_LondonHue          = $C3A6BE;  $FFC3A6BE  "#BEA6C3"  "rgb(190,166,195)"  "rgba(190,166,195,255)"  "LondonHue"
#Res_Lonestar           = $01016D;  $FF01016D  "#6D0101"  "rgb(109,  1,  1)"  "rgba(109,  1,  1,255)"  "Lonestar"
#Res_Lotus              = $3C3C86;  $FF3C3C86  "#863C3C"  "rgb(134, 60, 60)"  "rgba(134, 60, 60,255)"  "Lotus"
#Res_Loulou             = $410B46;  $FF410B46  "#460B41"  "rgb( 70, 11, 65)"  "rgba( 70, 11, 65,255)"  "Loulou"
#Res_Lucky              = $1C9FAF;  $FF1C9FAF  "#AF9F1C"  "rgb(175,159, 28)"  "rgba(175,159, 28,255)"  "Lucky"
#Res_LuckyPoint         = $681A1A;  $FF681A1A  "#1A1A68"  "rgb( 26, 26,104)"  "rgba( 26, 26,104,255)"  "LuckyPoint"
#Res_LunarGreen         = $3A493C;  $FF3A493C  "#3C493A"  "rgb( 60, 73, 58)"  "rgba( 60, 73, 58,255)"  "LunarGreen"
#Res_Lusty              = $071B99;  $FF071B99  "#991B07"  "rgb(153, 27,  7)"  "rgba(153, 27,  7,255)"  "Lusty"
#Res_LuxorGold          = $2C88A7;  $FF2C88A7  "#A7882C"  "rgb(167,136, 44)"  "rgba(167,136, 44,255)"  "LuxorGold"
#Res_Lynch              = $9A7E69;  $FF9A7E69  "#697E9A"  "rgb(105,126,154)"  "rgba(105,126,154,255)"  "Lynch"
#Res_Mabel              = $FFF7D9;  $FFFFF7D9  "#D9F7FF"  "rgb(217,247,255)"  "rgba(217,247,255,255)"  "Mabel"
#Res_Madang             = $BEF0B7;  $FFBEF0B7  "#B7F0BE"  "rgb(183,240,190)"  "rgba(183,240,190,255)"  "Madang"
#Res_Madison            = $5D2509;  $FF5D2509  "#09255D"  "rgb(  9, 37, 93)"  "rgba(  9, 37, 93,255)"  "Madison"
#Res_Madras             = $02303F;  $FF02303F  "#3F3002"  "rgb( 63, 48,  2)"  "rgba( 63, 48,  2,255)"  "Madras"
#Res_Magnolia           = $FFF4F8;  $FFFFF4F8  "#F8F4FF"  "rgb(248,244,255)"  "rgba(248,244,255,255)"  "Magnolia"
#Res_Mahogany           = $06064E;  $FF06064E  "#4E0606"  "rgb( 78,  6,  6)"  "rgba( 78,  6,  6,255)"  "Mahogany"
#Res_MaiTai             = $0866B0;  $FF0866B0  "#B06608"  "rgb(176,102,  8)"  "rgba(176,102,  8,255)"  "MaiTai"
#Res_Maire              = $060A13;  $FF060A13  "#130A06"  "rgb( 19, 10,  6)"  "rgba( 19, 10,  6,255)"  "Maire"
#Res_Maize              = $A0D5F5;  $FFA0D5F5  "#F5D5A0"  "rgb(245,213,160)"  "rgba(245,213,160,255)"  "Maize"
#Res_Makara             = $6D7D89;  $FF6D7D89  "#897D6D"  "rgb(137,125,109)"  "rgba(137,125,109,255)"  "Makara"
#Res_Mako               = $544944;  $FF544944  "#444954"  "rgb( 68, 73, 84)"  "rgba( 68, 73, 84,255)"  "Mako"
#Res_MalachiteGreen     = $658D88;  $FF658D88  "#888D65"  "rgb(136,141,101)"  "rgba(136,141,101,255)"  "MalachiteGreen"
#Res_Malibu             = $F7C87D;  $FFF7C87D  "#7DC8F7"  "rgb(125,200,247)"  "rgba(125,200,247,255)"  "Malibu"
#Res_Mallard            = $183423;  $FF183423  "#233418"  "rgb( 35, 52, 24)"  "rgba( 35, 52, 24,255)"  "Mallard"
#Res_Malta              = $A1B2BD;  $FFA1B2BD  "#BDB2A1"  "rgb(189,178,161)"  "rgba(189,178,161,255)"  "Malta"
#Res_Mamba              = $90818E;  $FF90818E  "#8E8190"  "rgb(142,129,144)"  "rgba(142,129,144,255)"  "Mamba"
#Res_Mandalay           = $1B78AD;  $FF1B78AD  "#AD781B"  "rgb(173,120, 27)"  "rgba(173,120, 27,255)"  "Mandalay"
#Res_Mandy              = $6554E2;  $FF6554E2  "#E25465"  "rgb(226, 84,101)"  "rgba(226, 84,101,255)"  "Mandy"
#Res_MandysPink         = $B2C3F2;  $FFB2C3F2  "#F2C3B2"  "rgb(242,195,178)"  "rgba(242,195,178,255)"  "MandysPink"
#Res_Manhattan          = $99C9F5;  $FF99C9F5  "#F5C999"  "rgb(245,201,153)"  "rgba(245,201,153,255)"  "Manhattan"
#Res_Mantis             = $65C374;  $FF65C374  "#74C365"  "rgb(116,195,101)"  "rgba(116,195,101,255)"  "Mantis"
#Res_Mantle             = $909C8B;  $FF909C8B  "#8B9C90"  "rgb(139,156,144)"  "rgba(139,156,144,255)"  "Mantle"
#Res_Manz               = $78EFEE;  $FF78EFEE  "#EEEF78"  "rgb(238,239,120)"  "rgba(238,239,120,255)"  "Manz"
#Res_MardiGras          = $360035;  $FF360035  "#350036"  "rgb( 53,  0, 54)"  "rgba( 53,  0, 54,255)"  "MardiGras"
#Res_Marigold           = $288DB9;  $FF288DB9  "#B98D28"  "rgb(185,141, 40)"  "rgba(185,141, 40,255)"  "Marigold"
#Res_Mariner            = $CD6A28;  $FFCD6A28  "#286ACD"  "rgb( 40,106,205)"  "rgba( 40,106,205,255)"  "Mariner"
#Res_Marlin             = $0E142A;  $FF0E142A  "#2A140E"  "rgb( 42, 20, 14)"  "rgba( 42, 20, 14,255)"  "Marlin"
#Res_Maroon             = $030342;  $FF030342  "#420303"  "rgb( 66,  3,  3)"  "rgba( 66,  3,  3,255)"  "Maroon"
#Res_Marshland          = $080F0B;  $FF080F0B  "#0B0F08"  "rgb( 11, 15,  8)"  "rgba( 11, 15,  8,255)"  "Marshland"
#Res_Martini            = $9EA0AF;  $FF9EA0AF  "#AFA09E"  "rgb(175,160,158)"  "rgba(175,160,158,255)"  "Martini"
#Res_Martinique         = $503036;  $FF503036  "#363050"  "rgb( 54, 48, 80)"  "rgba( 54, 48, 80,255)"  "Martinique"
#Res_Marzipan           = $9DDBF8;  $FF9DDBF8  "#F8DB9D"  "rgb(248,219,157)"  "rgba(248,219,157,255)"  "Marzipan"
#Res_Masala             = $383B40;  $FF383B40  "#403B38"  "rgb( 64, 59, 56)"  "rgba( 64, 59, 56,255)"  "Masala"
#Res_Mash               = $1D2940;  $FF1D2940  "#40291D"  "rgb( 64, 41, 29)"  "rgba( 64, 41, 29,255)"  "Mash"
#Res_Matisse            = $9D651B;  $FF9D651B  "#1B659D"  "rgb( 27,101,157)"  "rgba( 27,101,157,255)"  "Matisse"
#Res_Matrix             = $545DB0;  $FF545DB0  "#B05D54"  "rgb(176, 93, 84)"  "rgba(176, 93, 84,255)"  "Matrix"
#Res_Matterhorn         = $413B4E;  $FF413B4E  "#4E3B41"  "rgb( 78, 59, 65)"  "rgba( 78, 59, 65,255)"  "Matterhorn"
#Res_Maverick           = $D5C2D8;  $FFD5C2D8  "#D8C2D5"  "rgb(216,194,213)"  "rgba(216,194,213,255)"  "Maverick"
#Res_McKenzie           = $5187AF;  $FF5187AF  "#AF8751"  "rgb(175,135, 81)"  "rgba(175,135, 81,255)"  "McKenzie"
#Res_Melanie            = $D5C2E4;  $FFD5C2E4  "#E4C2D5"  "rgb(228,194,213)"  "rgba(228,194,213,255)"  "Melanie"
#Res_Melanzane          = $290530;  $FF290530  "#300529"  "rgb( 48,  5, 41)"  "rgba( 48,  5, 41,255)"  "Melanzane"
#Res_Melrose            = $FFC1C7;  $FFFFC1C7  "#C7C1FF"  "rgb(199,193,255)"  "rgba(199,193,255,255)"  "Melrose"
#Res_Meranti            = $0F1E5D;  $FF0F1E5D  "#5D1E0F"  "rgb( 93, 30, 15)"  "rgba( 93, 30, 15,255)"  "Meranti"
#Res_Mercury            = $E5E5E5;  $FFE5E5E5  "#E5E5E5"  "rgb(229,229,229)"  "rgba(229,229,229,255)"  "Mercury"
#Res_Merino             = $E6F0F6;  $FFE6F0F6  "#F6F0E6"  "rgb(246,240,230)"  "rgba(246,240,230,255)"  "Merino"
#Res_Merlin             = $373C41;  $FF373C41  "#413C37"  "rgb( 65, 60, 55)"  "rgba( 65, 60, 55,255)"  "Merlin"
#Res_Merlot             = $231983;  $FF231983  "#831923"  "rgb(131, 25, 35)"  "rgba(131, 25, 35,255)"  "Merlot"
#Res_MetallicBronze     = $1B3749;  $FF1B3749  "#49371B"  "rgb( 73, 55, 27)"  "rgba( 73, 55, 27,255)"  "MetallicBronze"
#Res_MetallicCopper     = $1D2971;  $FF1D2971  "#71291D"  "rgb(113, 41, 29)"  "rgba(113, 41, 29,255)"  "MetallicCopper"
#Res_Meteor             = $127DD0;  $FF127DD0  "#D07D12"  "rgb(208,125, 18)"  "rgba(208,125, 18,255)"  "Meteor"
#Res_Meteorite          = $761F3C;  $FF761F3C  "#3C1F76"  "rgb( 60, 31,118)"  "rgba( 60, 31,118,255)"  "Meteorite"
#Res_MexicanRed         = $2525A7;  $FF2525A7  "#A72525"  "rgb(167, 37, 37)"  "rgba(167, 37, 37,255)"  "MexicanRed"
#Res_MidGrey            = $6E5F5F;  $FF6E5F5F  "#5F5F6E"  "rgb( 95, 95,110)"  "rgba( 95, 95,110,255)"  "MidGrey"
#Res_Midnight           = $351601;  $FF351601  "#011635"  "rgb(  1, 22, 53)"  "rgba(  1, 22, 53,255)"  "Midnight"
#Res_MidnightExpress    = $410700;  $FF410700  "#000741"  "rgb(  0,  7, 65)"  "rgba(  0,  7, 65,255)"  "MidnightExpress"
#Res_MidnightMoss       = $041004;  $FF041004  "#041004"  "rgb(  4, 16,  4)"  "rgba(  4, 16,  4,255)"  "MidnightMoss"
#Res_Mikado             = $10252D;  $FF10252D  "#2D2510"  "rgb( 45, 37, 16)"  "rgba( 45, 37, 16,255)"  "Mikado"
#Res_Milan              = $A4FFFA;  $FFA4FFFA  "#FAFFA4"  "rgb(250,255,164)"  "rgba(250,255,164,255)"  "Milan"
#Res_MilanoRed          = $0411B8;  $FF0411B8  "#B81104"  "rgb(184, 17,  4)"  "rgba(184, 17,  4,255)"  "MilanoRed"
#Res_MilkPunch          = $D4F6FF;  $FFD4F6FF  "#FFF6D4"  "rgb(255,246,212)"  "rgba(255,246,212,255)"  "MilkPunch"
#Res_MilkWhite          = $E6F0F6;  $FFE6F0F6  "#F6F0E6"  "rgb(246,240,230)"  "rgba(246,240,230,255)"  "MilkWhite"
#Res_Millbrook          = $334459;  $FF334459  "#594433"  "rgb( 89, 68, 51)"  "rgba( 89, 68, 51,255)"  "Millbrook"
#Res_Mimosa             = $D3FDF8;  $FFD3FDF8  "#F8FDD3"  "rgb(248,253,211)"  "rgba(248,253,211,255)"  "Mimosa"
#Res_Mindaro            = $88F9E3;  $FF88F9E3  "#E3F988"  "rgb(227,249,136)"  "rgba(227,249,136,255)"  "Mindaro"
#Res_MineShaft          = $323232;  $FF323232  "#323232"  "rgb( 50, 50, 50)"  "rgba( 50, 50, 50,255)"  "MineShaft"
#Res_MineralGreen       = $535D3F;  $FF535D3F  "#3F5D53"  "rgb( 63, 93, 83)"  "rgba( 63, 93, 83,255)"  "MineralGreen"
#Res_Ming               = $7D7436;  $FF7D7436  "#36747D"  "rgb( 54,116,125)"  "rgba( 54,116,125,255)"  "Ming"
#Res_Minsk              = $7F303F;  $FF7F303F  "#3F307F"  "rgb( 63, 48,127)"  "rgba( 63, 48,127,255)"  "Minsk"
#Res_MintJulep          = $C1EEF1;  $FFC1EEF1  "#F1EEC1"  "rgb(241,238,193)"  "rgba(241,238,193,255)"  "MintJulep"
#Res_MintTulip          = $EBF4C4;  $FFEBF4C4  "#C4F4EB"  "rgb(196,244,235)"  "rgba(196,244,235,255)"  "MintTulip"
#Res_Mirage             = $281916;  $FF281916  "#161928"  "rgb( 22, 25, 40)"  "rgba( 22, 25, 40,255)"  "Mirage"
#Res_Mischka            = $DDD2D1;  $FFDDD2D1  "#D1D2DD"  "rgb(209,210,221)"  "rgba(209,210,221,255)"  "Mischka"
#Res_MistGrey           = $BCC4C4;  $FFBCC4C4  "#C4C4BC"  "rgb(196,196,188)"  "rgba(196,196,188,255)"  "MistGrey"
#Res_Mobster            = $89757F;  $FF89757F  "#7F7589"  "rgb(127,117,137)"  "rgba(127,117,137,255)"  "Mobster"
#Res_Moccaccino         = $141D6E;  $FF141D6E  "#6E1D14"  "rgb(110, 29, 20)"  "rgba(110, 29, 20,255)"  "Moccaccino"
#Res_Mocha              = $192D78;  $FF192D78  "#782D19"  "rgb(120, 45, 25)"  "rgba(120, 45, 25,255)"  "Mocha"
#Res_Mojo               = $3747C0;  $FF3747C0  "#C04737"  "rgb(192, 71, 55)"  "rgba(192, 71, 55,255)"  "Mojo"
#Res_MonaLisa           = $94A1FF;  $FF94A1FF  "#FFA194"  "rgb(255,161,148)"  "rgba(255,161,148,255)"  "MonaLisa"
#Res_Monarch            = $23078B;  $FF23078B  "#8B0723"  "rgb(139,  7, 35)"  "rgba(139,  7, 35,255)"  "Monarch"
#Res_Mondo              = $303C4A;  $FF303C4A  "#4A3C30"  "rgb( 74, 60, 48)"  "rgba( 74, 60, 48,255)"  "Mondo"
#Res_Mongoose           = $7FA2B5;  $FF7FA2B5  "#B5A27F"  "rgb(181,162,127)"  "rgba(181,162,127,255)"  "Mongoose"
#Res_Monsoon            = $89838A;  $FF89838A  "#8A8389"  "rgb(138,131,137)"  "rgba(138,131,137,255)"  "Monsoon"
#Res_Montana            = $301E29;  $FF301E29  "#291E30"  "rgb( 41, 30, 48)"  "rgba( 41, 30, 48,255)"  "Montana"
#Res_MonteCarlo         = $C6D083;  $FFC6D083  "#83D0C6"  "rgb(131,208,198)"  "rgba(131,208,198,255)"  "MonteCarlo"
#Res_Monza              = $1E03C7;  $FF1E03C7  "#C7031E"  "rgb(199,  3, 30)"  "rgba(199,  3, 30,255)"  "Monza"
#Res_MoodyBlue          = $D3767F;  $FFD3767F  "#7F76D3"  "rgb(127,118,211)"  "rgba(127,118,211,255)"  "MoodyBlue"
#Res_MoonGlow           = $DAFEFC;  $FFDAFEFC  "#FCFEDA"  "rgb(252,254,218)"  "rgba(252,254,218,255)"  "MoonGlow"
#Res_MoonMist           = $CCDDDC;  $FFCCDDDC  "#DCDDCC"  "rgb(220,221,204)"  "rgba(220,221,204,255)"  "MoonMist"
#Res_MoonRaker          = $F6CED6;  $FFF6CED6  "#D6CEF6"  "rgb(214,206,246)"  "rgba(214,206,246,255)"  "MoonRaker"
#Res_MoonYellow         = $17D9FC;  $FF17D9FC  "#FCD917"  "rgb(252,217, 23)"  "rgba(252,217, 23,255)"  "MoonYellow"
#Res_MorningGlory       = $E0DE9E;  $FFE0DE9E  "#9EDEE0"  "rgb(158,222,224)"  "rgba(158,222,224,255)"  "MorningGlory"
#Res_MoroccoBrown       = $001D44;  $FF001D44  "#441D00"  "rgb( 68, 29,  0)"  "rgba( 68, 29,  0,255)"  "MoroccoBrown"
#Res_Mortar             = $514350;  $FF514350  "#504351"  "rgb( 80, 67, 81)"  "rgba( 80, 67, 81,255)"  "Mortar"
#Res_Mosaic             = $473412;  $FF473412  "#123447"  "rgb( 18, 52, 71)"  "rgba( 18, 52, 71,255)"  "Mosaic"
#Res_Mosque             = $6E6A03;  $FF6E6A03  "#036A6E"  "rgb(  3,106,110)"  "rgba(  3,106,110,255)"  "Mosque"
#Res_MountainMist       = $969395;  $FF969395  "#959396"  "rgb(149,147,150)"  "rgba(149,147,150,255)"  "MountainMist"
#Res_MuddyWaters        = $5C8EB7;  $FF5C8EB7  "#B78E5C"  "rgb(183,142, 92)"  "rgba(183,142, 92,255)"  "MuddyWaters"
#Res_Muesli             = $5B8BAA;  $FF5B8BAA  "#AA8B5B"  "rgb(170,139, 91)"  "rgba(170,139, 91,255)"  "Muesli"
#Res_Mulberry           = $36055C;  $FF36055C  "#5C0536"  "rgb( 92,  5, 54)"  "rgba( 92,  5, 54,255)"  "Mulberry"
#Res_MuleFawn           = $2F478C;  $FF2F478C  "#8C472F"  "rgb(140, 71, 47)"  "rgba(140, 71, 47,255)"  "MuleFawn"
#Res_MulledWine         = $62454E;  $FF62454E  "#4E4562"  "rgb( 78, 69, 98)"  "rgba( 78, 69, 98,255)"  "MulledWine"
#Res_Mustard            = $0D6474;  $FF0D6474  "#74640D"  "rgb(116,100, 13)"  "rgba(116,100, 13,255)"  "Mustard"
#Res_MyPink             = $8891D6;  $FF8891D6  "#D69188"  "rgb(214,145,136)"  "rgba(214,145,136,255)"  "MyPink"
#Res_MySin              = $1FB3FF;  $FF1FB3FF  "#FFB31F"  "rgb(255,179, 31)"  "rgba(255,179, 31,255)"  "MySin"
#Res_Mystic             = $EDEBE2;  $FFEDEBE2  "#E2EBED"  "rgb(226,235,237)"  "rgba(226,235,237,255)"  "Mystic"
#Res_Nandor             = $525D4B;  $FF525D4B  "#4B5D52"  "rgb( 75, 93, 82)"  "rgba( 75, 93, 82,255)"  "Nandor"
#Res_Napa               = $94A4AC;  $FF94A4AC  "#ACA494"  "rgb(172,164,148)"  "rgba(172,164,148,255)"  "Napa"
#Res_Narvik             = $F1F9ED;  $FFF1F9ED  "#EDF9F1"  "rgb(237,249,241)"  "rgba(237,249,241,255)"  "Narvik"
#Res_Natural            = $0A5686;  $FF0A5686  "#86560A"  "rgb(134, 86, 10)"  "rgba(134, 86, 10,255)"  "Natural"
#Res_Nebula             = $D6DBCB;  $FFD6DBCB  "#CBDBD6"  "rgb(203,219,214)"  "rgba(203,219,214,255)"  "Nebula"
#Res_Negroni            = $C5E2FF;  $FFC5E2FF  "#FFE2C5"  "rgb(255,226,197)"  "rgba(255,226,197,255)"  "Negroni"
#Res_Nepal              = $C1AB8E;  $FFC1AB8E  "#8EABC1"  "rgb(142,171,193)"  "rgba(142,171,193,255)"  "Nepal"
#Res_Neptune            = $BBB77C;  $FFBBB77C  "#7CB7BB"  "rgb(124,183,187)"  "rgba(124,183,187,255)"  "Neptune"
#Res_Nero               = $000614;  $FF000614  "#140600"  "rgb( 20,  6,  0)"  "rgba( 20,  6,  0,255)"  "Nero"
#Res_NeutralGreen       = $86A5AC;  $FF86A5AC  "#ACA586"  "rgb(172,165,134)"  "rgba(172,165,134,255)"  "NeutralGreen"
#Res_Nevada             = $756E64;  $FF756E64  "#646E75"  "rgb(100,110,117)"  "rgba(100,110,117,255)"  "Nevada"
#Res_NewAmber           = $01387B;  $FF01387B  "#7B3801"  "rgb(123, 56,  1)"  "rgba(123, 56,  1,255)"  "NewAmber"
#Res_NewOrleans         = $9DD6F3;  $FF9DD6F3  "#F3D69D"  "rgb(243,214,157)"  "rgba(243,214,157,255)"  "NewOrleans"
#Res_NewYorkPink        = $7F83D7;  $FF7F83D7  "#D7837F"  "rgb(215,131,127)"  "rgba(215,131,127,255)"  "NewYorkPink"
#Res_Niagara            = $89A106;  $FF89A106  "#06A189"  "rgb(  6,161,137)"  "rgba(  6,161,137,255)"  "Niagara"
#Res_NightRider         = $0F121F;  $FF0F121F  "#1F120F"  "rgb( 31, 18, 15)"  "rgba( 31, 18, 15,255)"  "NightRider"
#Res_NightShadz         = $5A37AA;  $FF5A37AA  "#AA375A"  "rgb(170, 55, 90)"  "rgba(170, 55, 90,255)"  "NightShadz"
#Res_Nightclub          = $450066;  $FF450066  "#660045"  "rgb(102,  0, 69)"  "rgba(102,  0, 69,255)"  "Nightclub"
#Res_NileBlue           = $513719;  $FF513719  "#193751"  "rgb( 25, 55, 81)"  "rgba( 25, 55, 81,255)"  "NileBlue"
#Res_Nobel              = $B1B1B7;  $FFB1B1B7  "#B7B1B1"  "rgb(183,177,177)"  "rgba(183,177,177,255)"  "Nobel"
#Res_Nomad              = $A2B1BA;  $FFA2B1BA  "#BAB1A2"  "rgb(186,177,162)"  "rgba(186,177,162,255)"  "Nomad"
#Res_Nordic             = $312701;  $FF312701  "#012731"  "rgb(  1, 39, 49)"  "rgba(  1, 39, 49,255)"  "Nordic"
#Res_Norway             = $9FBDA8;  $FF9FBDA8  "#A8BD9F"  "rgb(168,189,159)"  "rgba(168,189,159,255)"  "Norway"
#Res_Nugget             = $2299C5;  $FF2299C5  "#C59922"  "rgb(197,153, 34)"  "rgba(197,153, 34,255)"  "Nugget"
#Res_Nutmeg             = $2C4281;  $FF2C4281  "#81422C"  "rgb(129, 66, 44)"  "rgba(129, 66, 44,255)"  "Nutmeg"
#Res_NutmegWoodFinish   = $003668;  $FF003668  "#683600"  "rgb(104, 54,  0)"  "rgba(104, 54,  0,255)"  "NutmegWoodFinish"
#Res_Oasis              = $CEEFFE;  $FFCEEFFE  "#FEEFCE"  "rgb(254,239,206)"  "rgba(254,239,206,255)"  "Oasis"
#Res_Observatory        = $6F8602;  $FF6F8602  "#02866F"  "rgb(  2,134,111)"  "rgba(  2,134,111,255)"  "Observatory"
#Res_OceanGreen         = $78AA41;  $FF78AA41  "#41AA78"  "rgb( 65,170,120)"  "rgba( 65,170,120,255)"  "OceanGreen"
#Res_OffGreen           = $F3F8E6;  $FFF3F8E6  "#E6F8F3"  "rgb(230,248,243)"  "rgba(230,248,243,255)"  "OffGreen"
#Res_OffYellow          = $E3F9FE;  $FFE3F9FE  "#FEF9E3"  "rgb(254,249,227)"  "rgba(254,249,227,255)"  "OffYellow"
#Res_Oil                = $151E28;  $FF151E28  "#281E15"  "rgb( 40, 30, 21)"  "rgba( 40, 30, 21,255)"  "Oil"
#Res_OiledCedar         = $051C7C;  $FF051C7C  "#7C1C05"  "rgb(124, 28,  5)"  "rgba(124, 28,  5,255)"  "OiledCedar"
#Res_OldBrick           = $1E1E90;  $FF1E1E90  "#901E1E"  "rgb(144, 30, 30)"  "rgba(144, 30, 30,255)"  "OldBrick"
#Res_OldCopper          = $2F4A72;  $FF2F4A72  "#724A2F"  "rgb(114, 74, 47)"  "rgba(114, 74, 47,255)"  "OldCopper"
#Res_OliveGreen         = $162E24;  $FF162E24  "#242E16"  "rgb( 36, 46, 22)"  "rgba( 36, 46, 22,255)"  "OliveGreen"
#Res_OliveHaze          = $70848B;  $FF70848B  "#8B8470"  "rgb(139,132,112)"  "rgba(139,132,112,255)"  "OliveHaze"
#Res_Olivetone          = $106E71;  $FF106E71  "#716E10"  "rgb(113,110, 16)"  "rgba(113,110, 16,255)"  "Olivetone"
#Res_Onahau             = $FFF4CD;  $FFFFF4CD  "#CDF4FF"  "rgb(205,244,255)"  "rgba(205,244,255,255)"  "Onahau"
#Res_Onion              = $0E272F;  $FF0E272F  "#2F270E"  "rgb( 47, 39, 14)"  "rgba( 47, 39, 14,255)"  "Onion"
#Res_Opal               = $C2C6A9;  $FFC2C6A9  "#A9C6C2"  "rgb(169,198,194)"  "rgba(169,198,194,255)"  "Opal"
#Res_Opium              = $706F8E;  $FF706F8E  "#8E6F70"  "rgb(142,111,112)"  "rgba(142,111,112,255)"  "Opium"
#Res_Oracle             = $757437;  $FF757437  "#377475"  "rgb( 55,116,117)"  "rgba( 55,116,117,255)"  "Oracle"
#Res_OrangeRoughy       = $1957C4;  $FF1957C4  "#C45719"  "rgb(196, 87, 25)"  "rgba(196, 87, 25,255)"  "OrangeRoughy"
#Res_OrangeWhite        = $EDFCFE;  $FFEDFCFE  "#FEFCED"  "rgb(254,252,237)"  "rgba(254,252,237,255)"  "OrangeWhite"
#Res_OrchidWhite        = $F3FDFF;  $FFF3FDFF  "#FFFDF3"  "rgb(255,253,243)"  "rgba(255,253,243,255)"  "OrchidWhite"
#Res_Oregon             = $03479B;  $FF03479B  "#9B4703"  "rgb(155, 71,  3)"  "rgba(155, 71,  3,255)"  "Oregon"
#Res_Orient             = $855E01;  $FF855E01  "#015E85"  "rgb(  1, 94,133)"  "rgba(  1, 94,133,255)"  "Orient"
#Res_OrientalPink       = $9191C6;  $FF9191C6  "#C69191"  "rgb(198,145,145)"  "rgba(198,145,145,255)"  "OrientalPink"
#Res_Orinoco            = $D4FBF3;  $FFD4FBF3  "#F3FBD4"  "rgb(243,251,212)"  "rgba(243,251,212,255)"  "Orinoco"
#Res_OsloGrey           = $918D87;  $FF918D87  "#878D91"  "rgb(135,141,145)"  "rgba(135,141,145,255)"  "OsloGrey"
#Res_Ottoman            = $EDF8E9;  $FFEDF8E9  "#E9F8ED"  "rgb(233,248,237)"  "rgba(233,248,237,255)"  "Ottoman"
#Res_OuterSpace         = $401005;  $FF401005  "#051040"  "rgb(  5, 16, 64)"  "rgba(  5, 16, 64,255)"  "OuterSpace"
#Res_OxfordBlue         = $554538;  $FF554538  "#384555"  "rgb( 56, 69, 85)"  "rgba( 56, 69, 85,255)"  "OxfordBlue"
#Res_Oxley              = $869E77;  $FF869E77  "#779E86"  "rgb(119,158,134)"  "rgba(119,158,134,255)"  "Oxley"
#Res_OysterBay          = $FFFADA;  $FFFFFADA  "#DAFAFF"  "rgb(218,250,255)"  "rgba(218,250,255,255)"  "OysterBay"
#Res_OysterPink         = $CDCEE9;  $FFCDCEE9  "#E9CECD"  "rgb(233,206,205)"  "rgba(233,206,205,255)"  "OysterPink"
#Res_Paarl              = $2955A6;  $FF2955A6  "#A65529"  "rgb(166, 85, 41)"  "rgba(166, 85, 41,255)"  "Paarl"
#Res_Pablo              = $616F77;  $FF616F77  "#776F61"  "rgb(119,111, 97)"  "rgba(119,111, 97,255)"  "Pablo"
#Res_Pacifika           = $208177;  $FF208177  "#778120"  "rgb(119,129, 32)"  "rgba(119,129, 32,255)"  "Pacifika"
#Res_Paco               = $101F41;  $FF101F41  "#411F10"  "rgb( 65, 31, 16)"  "rgba( 65, 31, 16,255)"  "Paco"
#Res_Padua              = $C4E6AD;  $FFC4E6AD  "#ADE6C4"  "rgb(173,230,196)"  "rgba(173,230,196,255)"  "Padua"
#Res_PaleLeaf           = $B9D3C0;  $FFB9D3C0  "#C0D3B9"  "rgb(192,211,185)"  "rgba(192,211,185,255)"  "PaleLeaf"
#Res_PaleOyster         = $778D98;  $FF778D98  "#988D77"  "rgb(152,141,119)"  "rgba(152,141,119,255)"  "PaleOyster"
#Res_PalePrim           = $B8FEFD;  $FFB8FEFD  "#FDFEB8"  "rgb(253,254,184)"  "rgba(253,254,184,255)"  "PalePrim"
#Res_PaleRose           = $F2E1FF;  $FFF2E1FF  "#FFE1F2"  "rgb(255,225,242)"  "rgba(255,225,242,255)"  "PaleRose"
#Res_PaleSky            = $83776E;  $FF83776E  "#6E7783"  "rgb(110,119,131)"  "rgba(110,119,131,255)"  "PaleSky"
#Res_PaleSlate          = $C1BFC3;  $FFC1BFC3  "#C3BFC1"  "rgb(195,191,193)"  "rgba(195,191,193,255)"  "PaleSlate"
#Res_PalmGreen          = $0F2309;  $FF0F2309  "#09230F"  "rgb(  9, 35, 15)"  "rgba(  9, 35, 15,255)"  "PalmGreen"
#Res_PalmLeaf           = $0E3319;  $FF0E3319  "#19330E"  "rgb( 25, 51, 14)"  "rgba( 25, 51, 14,255)"  "PalmLeaf"
#Res_Pampas             = $EEF2F4;  $FFEEF2F4  "#F4F2EE"  "rgb(244,242,238)"  "rgba(244,242,238,255)"  "Pampas"
#Res_Panache            = $EEF6EA;  $FFEEF6EA  "#EAF6EE"  "rgb(234,246,238)"  "rgba(234,246,238,255)"  "Panache"
#Res_Pancho             = $ABCDED;  $FFABCDED  "#EDCDAB"  "rgb(237,205,171)"  "rgba(237,205,171,255)"  "Pancho"
#Res_Panda              = $213942;  $FF213942  "#423921"  "rgb( 66, 57, 33)"  "rgba( 66, 57, 33,255)"  "Panda"
#Res_Paprika            = $26028D;  $FF26028D  "#8D0226"  "rgb(141,  2, 38)"  "rgba(141,  2, 38,255)"  "Paprika"
#Res_Paradiso           = $827D31;  $FF827D31  "#317D82"  "rgb( 49,125,130)"  "rgba( 49,125,130,255)"  "Paradiso"
#Res_Parchment          = $D2E9F1;  $FFD2E9F1  "#F1E9D2"  "rgb(241,233,210)"  "rgba(241,233,210,255)"  "Parchment"
#Res_ParisDaisy         = $6EF4FF;  $FF6EF4FF  "#FFF46E"  "rgb(255,244,110)"  "rgba(255,244,110,255)"  "ParisDaisy"
#Res_ParisM             = $6A0526;  $FF6A0526  "#26056A"  "rgb( 38,  5,106)"  "rgba( 38,  5,106,255)"  "ParisM"
#Res_ParisWhite         = $D4DCCA;  $FFD4DCCA  "#CADCD4"  "rgb(202,220,212)"  "rgba(202,220,212,255)"  "ParisWhite"
#Res_Parsley            = $194F13;  $FF194F13  "#134F19"  "rgb( 19, 79, 25)"  "rgba( 19, 79, 25,255)"  "Parsley"
#Res_Patina             = $8F9A63;  $FF8F9A63  "#639A8F"  "rgb( 99,154,143)"  "rgba( 99,154,143,255)"  "Patina"
#Res_PattensBlue        = $FFF5DE;  $FFFFF5DE  "#DEF5FF"  "rgb(222,245,255)"  "rgba(222,245,255,255)"  "PattensBlue"
#Res_Paua               = $680326;  $FF680326  "#260368"  "rgb( 38,  3,104)"  "rgba( 38,  3,104,255)"  "Paua"
#Res_Pavlova            = $98C4D7;  $FF98C4D7  "#D7C498"  "rgb(215,196,152)"  "rgba(215,196,152,255)"  "Pavlova"
#Res_PeaSoup            = $D2E5CF;  $FFD2E5CF  "#CFE5D2"  "rgb(207,229,210)"  "rgba(207,229,210,255)"  "PeaSoup"
#Res_Peach              = $DBF0FF;  $FFDBF0FF  "#FFF0DB"  "rgb(255,240,219)"  "rgba(255,240,219,255)"  "Peach"
#Res_PeachSchnapps      = $D6DCFF;  $FFD6DCFF  "#FFDCD6"  "rgb(255,220,214)"  "rgba(255,220,214,255)"  "PeachSchnapps"
#Res_Peanut             = $162F78;  $FF162F78  "#782F16"  "rgb(120, 47, 22)"  "rgba(120, 47, 22,255)"  "Peanut"
#Res_PearlBush          = $D5E0E8;  $FFD5E0E8  "#E8E0D5"  "rgb(232,224,213)"  "rgba(232,224,213,255)"  "PearlBush"
#Res_PearlLusta         = $DCF4FC;  $FFDCF4FC  "#FCF4DC"  "rgb(252,244,220)"  "rgba(252,244,220,255)"  "PearlLusta"
#Res_Peat               = $566B71;  $FF566B71  "#716B56"  "rgb(113,107, 86)"  "rgba(113,107, 86,255)"  "Peat"
#Res_Pelorous           = $BFAB3E;  $FFBFAB3E  "#3EABBF"  "rgb( 62,171,191)"  "rgba( 62,171,191,255)"  "Pelorous"
#Res_Peppermint         = $E1F5E3;  $FFE1F5E3  "#E3F5E1"  "rgb(227,245,225)"  "rgba(227,245,225,255)"  "Peppermint"
#Res_Perano             = $F2BEA9;  $FFF2BEA9  "#A9BEF2"  "rgb(169,190,242)"  "rgba(169,190,242,255)"  "Perano"
#Res_Perfume            = $F8BED0;  $FFF8BED0  "#D0BEF8"  "rgb(208,190,248)"  "rgba(208,190,248,255)"  "Perfume"
#Res_PeriglacialBlue    = $D6E6E1;  $FFD6E6E1  "#E1E6D6"  "rgb(225,230,214)"  "rgba(225,230,214,255)"  "PeriglacialBlue"
#Res_PersianPlum        = $1C1C70;  $FF1C1C70  "#701C1C"  "rgb(112, 28, 28)"  "rgba(112, 28, 28,255)"  "PersianPlum"
#Res_PersianRed         = $170C52;  $FF170C52  "#520C17"  "rgb( 82, 12, 23)"  "rgba( 82, 12, 23,255)"  "PersianRed"
#Res_Persimmon          = $536BFF;  $FF536BFF  "#FF6B53"  "rgb(255,107, 83)"  "rgba(255,107, 83,255)"  "Persimmon"
#Res_PeruTan            = $023A7F;  $FF023A7F  "#7F3A02"  "rgb(127, 58,  2)"  "rgba(127, 58,  2,255)"  "PeruTan"
#Res_Pesto              = $31767C;  $FF31767C  "#7C7631"  "rgb(124,118, 49)"  "rgba(124,118, 49,255)"  "Pesto"
#Res_PetiteOrchid       = $9096DB;  $FF9096DB  "#DB9690"  "rgb(219,150,144)"  "rgba(219,150,144,255)"  "PetiteOrchid"
#Res_Pewter             = $A1A896;  $FFA1A896  "#96A8A1"  "rgb(150,168,161)"  "rgba(150,168,161,255)"  "Pewter"
#Res_Pharlap            = $7B80A3;  $FF7B80A3  "#A3807B"  "rgb(163,128,123)"  "rgba(163,128,123,255)"  "Pharlap"
#Res_Picasso            = $9DF3FF;  $FF9DF3FF  "#FFF39D"  "rgb(255,243,157)"  "rgba(255,243,157,255)"  "Picasso"
#Res_PickledAspen       = $3A4C3F;  $FF3A4C3F  "#3F4C3A"  "rgb( 63, 76, 58)"  "rgba( 63, 76, 58,255)"  "PickledAspen"
#Res_PickledBean        = $26486E;  $FF26486E  "#6E4826"  "rgb(110, 72, 38)"  "rgba(110, 72, 38,255)"  "PickledBean"
#Res_PickledBluewood    = $594431;  $FF594431  "#314459"  "rgb( 49, 68, 89)"  "rgba( 49, 68, 89,255)"  "PickledBluewood"
#Res_PictonBlue         = $E8B145;  $FFE8B145  "#45B1E8"  "rgb( 69,177,232)"  "rgba( 69,177,232,255)"  "PictonBlue"
#Res_PigeonPost         = $D9BDAF;  $FFD9BDAF  "#AFBDD9"  "rgb(175,189,217)"  "rgba(175,189,217,255)"  "PigeonPost"
#Res_PineCone           = $545E6D;  $FF545E6D  "#6D5E54"  "rgb(109, 94, 84)"  "rgba(109, 94, 84,255)"  "PineCone"
#Res_PineGlade          = $90CDC7;  $FF90CDC7  "#C7CD90"  "rgb(199,205,144)"  "rgba(199,205,144,255)"  "PineGlade"
#Res_PineTree           = $041F17;  $FF041F17  "#171F04"  "rgb( 23, 31,  4)"  "rgba( 23, 31,  4,255)"  "PineTree"
#Res_PinkFlare          = $C8C0E1;  $FFC8C0E1  "#E1C0C8"  "rgb(225,192,200)"  "rgba(225,192,200,255)"  "PinkFlare"
#Res_PinkLace           = $F4DDFF;  $FFF4DDFF  "#FFDDF4"  "rgb(255,221,244)"  "rgba(255,221,244,255)"  "PinkLace"
#Res_PinkLady           = $D8F1FF;  $FFD8F1FF  "#FFF1D8"  "rgb(255,241,216)"  "rgba(255,241,216,255)"  "PinkLady"
#Res_PinkSwan           = $B7B5BE;  $FFB7B5BE  "#BEB5B7"  "rgb(190,181,183)"  "rgba(190,181,183,255)"  "PinkSwan"
#Res_Piper              = $2363C9;  $FF2363C9  "#C96323"  "rgb(201, 99, 35)"  "rgba(201, 99, 35,255)"  "Piper"
#Res_Pipi               = $CCF4FE;  $FFCCF4FE  "#FEF4CC"  "rgb(254,244,204)"  "rgba(254,244,204,255)"  "Pipi"
#Res_Pippin             = $DFE1FF;  $FFDFE1FF  "#FFE1DF"  "rgb(255,225,223)"  "rgba(255,225,223,255)"  "Pippin"
#Res_PirateGold         = $037FBA;  $FF037FBA  "#BA7F03"  "rgb(186,127,  3)"  "rgba(186,127,  3,255)"  "PirateGold"
#Res_Pistachio          = $09C29D;  $FF09C29D  "#9DC209"  "rgb(157,194,  9)"  "rgba(157,194,  9,255)"  "Pistachio"
#Res_PixieGreen         = $B6D8C0;  $FFB6D8C0  "#C0D8B6"  "rgb(192,216,182)"  "rgba(192,216,182,255)"  "PixieGreen"
#Res_Pizazz             = $0090FF;  $FF0090FF  "#FF9000"  "rgb(255,144,  0)"  "rgba(255,144,  0,255)"  "Pizazz"
#Res_Pizza              = $1594C9;  $FF1594C9  "#C99415"  "rgb(201,148, 21)"  "rgba(201,148, 21,255)"  "Pizza"
#Res_Plantation         = $4B5027;  $FF4B5027  "#27504B"  "rgb( 39, 80, 75)"  "rgba( 39, 80, 75,255)"  "Plantation"
#Res_Planter            = $305D61;  $FF305D61  "#615D30"  "rgb( 97, 93, 48)"  "rgba( 97, 93, 48,255)"  "Planter"
#Res_Plum               = $560041;  $FF560041  "#410056"  "rgb( 65,  0, 86)"  "rgba( 65,  0, 86,255)"  "Plum"
#Res_Pohutukawa         = $1C028F;  $FF1C028F  "#8F021C"  "rgb(143,  2, 28)"  "rgba(143,  2, 28,255)"  "Pohutukawa"
#Res_Polar              = $F6F9E5;  $FFF6F9E5  "#E5F9F6"  "rgb(229,249,246)"  "rgba(229,249,246,255)"  "Polar"
#Res_PoloBlue           = $CCA88D;  $FFCCA88D  "#8DA8CC"  "rgb(141,168,204)"  "rgba(141,168,204,255)"  "PoloBlue"
#Res_Pompadour          = $450066;  $FF450066  "#660045"  "rgb(102,  0, 69)"  "rgba(102,  0, 69,255)"  "Pompadour"
#Res_Porcelain          = $F3F2EF;  $FFF3F2EF  "#EFF2F3"  "rgb(239,242,243)"  "rgba(239,242,243,255)"  "Porcelain"
#Res_Porsche            = $69AEEA;  $FF69AEEA  "#EAAE69"  "rgb(234,174,105)"  "rgba(234,174,105,255)"  "Porsche"
#Res_PortGore           = $4F1F25;  $FF4F1F25  "#251F4F"  "rgb( 37, 31, 79)"  "rgba( 37, 31, 79,255)"  "PortGore"
#Res_Portafino          = $B4FFFF;  $FFB4FFFF  "#FFFFB4"  "rgb(255,255,180)"  "rgba(255,255,180,255)"  "Portafino"
#Res_Portage            = $EE9F8B;  $FFEE9F8B  "#8B9FEE"  "rgb(139,159,238)"  "rgba(139,159,238,255)"  "Portage"
#Res_Portica            = $63E6F9;  $FF63E6F9  "#F9E663"  "rgb(249,230, 99)"  "rgba(249,230, 99,255)"  "Portica"
#Res_PotPourri          = $E2E7F5;  $FFE2E7F5  "#F5E7E2"  "rgb(245,231,226)"  "rgba(245,231,226,255)"  "PotPourri"
#Res_PottersClay        = $38578C;  $FF38578C  "#8C5738"  "rgb(140, 87, 56)"  "rgba(140, 87, 56,255)"  "PottersClay"
#Res_PowderBlue         = $C2C9BC;  $FFC2C9BC  "#BCC9C2"  "rgb(188,201,194)"  "rgba(188,201,194,255)"  "PowderBlue"
#Res_PrairieSand        = $20389A;  $FF20389A  "#9A3820"  "rgb(154, 56, 32)"  "rgba(154, 56, 32,255)"  "PrairieSand"
#Res_Prelude            = $E5C0D0;  $FFE5C0D0  "#D0C0E5"  "rgb(208,192,229)"  "rgba(208,192,229,255)"  "Prelude"
#Res_Prim               = $ECE2F0;  $FFECE2F0  "#F0E2EC"  "rgb(240,226,236)"  "rgba(240,226,236,255)"  "Prim"
#Res_Primrose           = $99EAED;  $FF99EAED  "#EDEA99"  "rgb(237,234,153)"  "rgba(237,234,153,255)"  "Primrose"
#Res_Promenade          = $E7FFFC;  $FFE7FFFC  "#FCFFE7"  "rgb(252,255,231)"  "rgba(252,255,231,255)"  "Promenade"
#Res_ProvincialPink     = $F1F5FE;  $FFF1F5FE  "#FEF5F1"  "rgb(254,245,241)"  "rgba(254,245,241,255)"  "ProvincialPink"
#Res_PrussianBlue       = $533100;  $FF533100  "#003153"  "rgb(  0, 49, 83)"  "rgba(  0, 49, 83,255)"  "PrussianBlue"
#Res_Pueblo             = $142C7D;  $FF142C7D  "#7D2C14"  "rgb(125, 44, 20)"  "rgba(125, 44, 20,255)"  "Pueblo"
#Res_PuertoRico         = $AAC13F;  $FFAAC13F  "#3FC1AA"  "rgb( 63,193,170)"  "rgba( 63,193,170,255)"  "PuertoRico"
#Res_Pumice             = $C4CAC2;  $FFC4CAC2  "#C2CAC4"  "rgb(194,202,196)"  "rgba(194,202,196,255)"  "Pumice"
#Res_Pumpkin            = $0B61B1;  $FF0B61B1  "#B1610B"  "rgb(177, 97, 11)"  "rgba(177, 97, 11,255)"  "Pumpkin"
#Res_Punch              = $3343DC;  $FF3343DC  "#DC4333"  "rgb(220, 67, 51)"  "rgba(220, 67, 51,255)"  "Punch"
#Res_Punga              = $143D4D;  $FF143D4D  "#4D3D14"  "rgb( 77, 61, 20)"  "rgba( 77, 61, 20,255)"  "Punga"
#Res_Putty              = $8CCDE7;  $FF8CCDE7  "#E7CD8C"  "rgb(231,205,140)"  "rgba(231,205,140,255)"  "Putty"
#Res_QuarterPearlLusta  = $F4FDFF;  $FFF4FDFF  "#FFFDF4"  "rgb(255,253,244)"  "rgba(255,253,244,255)"  "QuarterPearlLusta"
#Res_QuarterSpanishWhite= $E1F2F7;  $FFE1F2F7  "#F7F2E1"  "rgb(247,242,225)"  "rgba(247,242,225,255)"  "QuarterSpanishWhite"
#Res_Quicksand          = $8E97BD;  $FF8E97BD  "#BD978E"  "rgb(189,151,142)"  "rgba(189,151,142,255)"  "Quicksand"
#Res_QuillGrey          = $D1D6D6;  $FFD1D6D6  "#D6D6D1"  "rgb(214,214,209)"  "rgba(214,214,209,255)"  "QuillGrey"
#Res_Quincy             = $2D3F62;  $FF2D3F62  "#623F2D"  "rgb( 98, 63, 45)"  "rgba( 98, 63, 45,255)"  "Quincy"
#Res_RacingGreen        = $11190C;  $FF11190C  "#0C1911"  "rgb( 12, 25, 17)"  "rgba( 12, 25, 17,255)"  "RacingGreen"
#Res_Raffia             = $B8DAEA;  $FFB8DAEA  "#EADAB8"  "rgb(234,218,184)"  "rgba(234,218,184,255)"  "Raffia"
#Res_RainForest         = $208177;  $FF208177  "#778120"  "rgb(119,129, 32)"  "rgba(119,129, 32,255)"  "RainForest"
#Res_Raincloud          = $947C7B;  $FF947C7B  "#7B7C94"  "rgb(123,124,148)"  "rgba(123,124,148,255)"  "Raincloud"
#Res_Rainee             = $ACC8B9;  $FFACC8B9  "#B9C8AC"  "rgb(185,200,172)"  "rgba(185,200,172,255)"  "Rainee"
#Res_Rajah              = $68B6F7;  $FF68B6F7  "#F7B668"  "rgb(247,182,104)"  "rgba(247,182,104,255)"  "Rajah"
#Res_Rangitoto          = $22322E;  $FF22322E  "#2E3222"  "rgb( 46, 50, 34)"  "rgba( 46, 50, 34,255)"  "Rangitoto"
#Res_RangoonGreen       = $131E1C;  $FF131E1C  "#1C1E13"  "rgb( 28, 30, 19)"  "rgba( 28, 30, 19,255)"  "RangoonGreen"
#Res_Raven              = $897B72;  $FF897B72  "#727B89"  "rgb(114,123,137)"  "rgba(114,123,137,255)"  "Raven"
#Res_Rebel              = $06123C;  $FF06123C  "#3C1206"  "rgb( 60, 18,  6)"  "rgba( 60, 18,  6,255)"  "Rebel"
#Res_RedBeech           = $01387B;  $FF01387B  "#7B3801"  "rgb(123, 56,  1)"  "rgba(123, 56,  1,255)"  "RedBeech"
#Res_RedBerry           = $00008E;  $FF00008E  "#8E0000"  "rgb(142,  0,  0)"  "rgba(142,  0,  0,255)"  "RedBerry"
#Res_RedDamask          = $416ADA;  $FF416ADA  "#DA6A41"  "rgb(218,106, 65)"  "rgba(218,106, 65,255)"  "RedDamask"
#Res_RedDevil           = $110186;  $FF110186  "#860111"  "rgb(134,  1, 17)"  "rgba(134,  1, 17,255)"  "RedDevil"
#Res_RedOxide           = $02096E;  $FF02096E  "#6E0902"  "rgb(110,  9,  2)"  "rgba(110,  9,  2,255)"  "RedOxide"
#Res_RedRobin           = $1F3480;  $FF1F3480  "#80341F"  "rgb(128, 52, 31)"  "rgba(128, 52, 31,255)"  "RedRobin"
#Res_RedStage           = $045FD0;  $FF045FD0  "#D05F04"  "rgb(208, 95,  4)"  "rgba(208, 95,  4,255)"  "RedStage"
#Res_Redwood            = $0F1E5D;  $FF0F1E5D  "#5D1E0F"  "rgb( 93, 30, 15)"  "rgba( 93, 30, 15,255)"  "Redwood"
#Res_Reef               = $A2FFC9;  $FFA2FFC9  "#C9FFA2"  "rgb(201,255,162)"  "rgba(201,255,162,255)"  "Reef"
#Res_ReefGold           = $1C829F;  $FF1C829F  "#9F821C"  "rgb(159,130, 28)"  "rgba(159,130, 28,255)"  "ReefGold"
#Res_RegalBlue          = $6A3F01;  $FF6A3F01  "#013F6A"  "rgb(  1, 63,106)"  "rgba(  1, 63,106,255)"  "RegalBlue"
#Res_RegentGrey         = $9F9486;  $FF9F9486  "#86949F"  "rgb(134,148,159)"  "rgba(134,148,159,255)"  "RegentGrey"
#Res_RegentStBlue       = $E6D6AA;  $FFE6D6AA  "#AAD6E6"  "rgb(170,214,230)"  "rgba(170,214,230,255)"  "RegentStBlue"
#Res_Remy               = $F3EBFE;  $FFF3EBFE  "#FEEBF3"  "rgb(254,235,243)"  "rgba(254,235,243,255)"  "Remy"
#Res_RenoSand           = $1565A8;  $FF1565A8  "#A86515"  "rgb(168,101, 21)"  "rgba(168,101, 21,255)"  "RenoSand"
#Res_ResolutionBlue     = $872300;  $FF872300  "#002387"  "rgb(  0, 35,135)"  "rgba(  0, 35,135,255)"  "ResolutionBlue"
#Res_Revolver           = $32162C;  $FF32162C  "#2C1632"  "rgb( 44, 22, 50)"  "rgba( 44, 22, 50,255)"  "Revolver"
#Res_Rhino              = $623F2E;  $FF623F2E  "#2E3F62"  "rgb( 46, 63, 98)"  "rgba( 46, 63, 98,255)"  "Rhino"
#Res_Ribbon             = $450066;  $FF450066  "#660045"  "rgb(102,  0, 69)"  "rgba(102,  0, 69,255)"  "Ribbon"
#Res_RiceCake           = $F0FEFF;  $FFF0FEFF  "#FFFEF0"  "rgb(255,254,240)"  "rgba(255,254,240,255)"  "RiceCake"
#Res_RiceFlower         = $E2FFEE;  $FFE2FFEE  "#EEFFE2"  "rgb(238,255,226)"  "rgba(238,255,226,255)"  "RiceFlower"
#Res_RichGold           = $0753A8;  $FF0753A8  "#A85307"  "rgb(168, 83,  7)"  "rgba(168, 83,  7,255)"  "RichGold"
#Res_RioGrande          = $09D0BB;  $FF09D0BB  "#BBD009"  "rgb(187,208,  9)"  "rgba(187,208,  9,255)"  "RioGrande"
#Res_Riptide            = $D8E68B;  $FFD8E68B  "#8BE6D8"  "rgb(139,230,216)"  "rgba(139,230,216,255)"  "Riptide"
#Res_RiverBed           = $594C43;  $FF594C43  "#434C59"  "rgb( 67, 76, 89)"  "rgba( 67, 76, 89,255)"  "RiverBed"
#Res_RobRoy             = $74C6EA;  $FF74C6EA  "#EAC674"  "rgb(234,198,116)"  "rgba(234,198,116,255)"  "RobRoy"
#Res_RobinsEggBlue      = $B3C8BD;  $FFB3C8BD  "#BDC8B3"  "rgb(189,200,179)"  "rgba(189,200,179,255)"  "RobinsEggBlue"
#Res_Rock               = $33384D;  $FF33384D  "#4D3833"  "rgb( 77, 56, 51)"  "rgba( 77, 56, 51,255)"  "Rock"
#Res_RockBlue           = $CDB19E;  $FFCDB19E  "#9EB1CD"  "rgb(158,177,205)"  "rgba(158,177,205,255)"  "RockBlue"
#Res_RockSalt           = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "RockSalt"
#Res_RockSpray          = $0C45BA;  $FF0C45BA  "#BA450C"  "rgb(186, 69, 12)"  "rgba(186, 69, 12,255)"  "RockSpray"
#Res_RodeoDust          = $9BB2C9;  $FF9BB2C9  "#C9B29B"  "rgb(201,178,155)"  "rgba(201,178,155,255)"  "RodeoDust"
#Res_RollingStone       = $837D74;  $FF837D74  "#747D83"  "rgb(116,125,131)"  "rgba(116,125,131,255)"  "RollingStone"
#Res_Roman              = $6063DE;  $FF6063DE  "#DE6360"  "rgb(222, 99, 96)"  "rgba(222, 99, 96,255)"  "Roman"
#Res_RomanCoffee        = $4C5D79;  $FF4C5D79  "#795D4C"  "rgb(121, 93, 76)"  "rgba(121, 93, 76,255)"  "RomanCoffee"
#Res_Romance            = $FDFEFF;  $FFFDFEFF  "#FFFEFD"  "rgb(255,254,253)"  "rgba(255,254,253,255)"  "Romance"
#Res_Romantic           = $B7D2FF;  $FFB7D2FF  "#FFD2B7"  "rgb(255,210,183)"  "rgba(255,210,183,255)"  "Romantic"
#Res_Ronchi             = $4EC5EC;  $FF4EC5EC  "#ECC54E"  "rgb(236,197, 78)"  "rgba(236,197, 78,255)"  "Ronchi"
#Res_RoofTerracotta     = $202FA6;  $FF202FA6  "#A62F20"  "rgb(166, 47, 32)"  "rgba(166, 47, 32,255)"  "RoofTerracotta"
#Res_Rope               = $1E4D8E;  $FF1E4D8E  "#8E4D1E"  "rgb(142, 77, 30)"  "rgba(142, 77, 30,255)"  "Rope"
#Res_Rose               = $B4BCE7;  $FFB4BCE7  "#E7BCB4"  "rgb(231,188,180)"  "rgba(231,188,180,255)"  "Rose"
#Res_RoseBud            = $A3B2FB;  $FFA3B2FB  "#FBB2A3"  "rgb(251,178,163)"  "rgba(251,178,163,255)"  "RoseBud"
#Res_RoseBudCherry      = $470B80;  $FF470B80  "#800B47"  "rgb(128, 11, 71)"  "rgba(128, 11, 71,255)"  "RoseBudCherry"
#Res_RoseofSharon       = $0055BF;  $FF0055BF  "#BF5500"  "rgb(191, 85,  0)"  "rgba(191, 85,  0,255)"  "RoseofSharon"
#Res_RoseWhite          = $F5F6FF;  $FFF5F6FF  "#FFF6F5"  "rgb(255,246,245)"  "rgba(255,246,245,255)"  "RoseWhite"
#Res_Rosewood           = $0B0065;  $FF0B0065  "#65000B"  "rgb(101,  0, 11)"  "rgba(101,  0, 11,255)"  "Rosewood"
#Res_Roti               = $4BA8C6;  $FF4BA8C6  "#C6A84B"  "rgb(198,168, 75)"  "rgba(198,168, 75,255)"  "Roti"
#Res_Rouge              = $6C3BA2;  $FF6C3BA2  "#A23B6C"  "rgb(162, 59,108)"  "rgba(162, 59,108,255)"  "Rouge"
#Res_RoyalHeath         = $7234AB;  $FF7234AB  "#AB3472"  "rgb(171, 52,114)"  "rgba(171, 52,114,255)"  "RoyalHeath"
#Res_Rum                = $896979;  $FF896979  "#796989"  "rgb(121,105,137)"  "rgba(121,105,137,255)"  "Rum"
#Res_RumSwizzle         = $E4F8F9;  $FFE4F8F9  "#F9F8E4"  "rgb(249,248,228)"  "rgba(249,248,228,255)"  "RumSwizzle"
#Res_Russett            = $575A75;  $FF575A75  "#755A57"  "rgb(117, 90, 87)"  "rgba(117, 90, 87,255)"  "Russett"
#Res_RusticRed          = $040448;  $FF040448  "#480404"  "rgb( 72,  4,  4)"  "rgba( 72,  4,  4,255)"  "RusticRed"
#Res_RustyNail          = $0A5686;  $FF0A5686  "#86560A"  "rgb(134, 86, 10)"  "rgba(134, 86, 10,255)"  "RustyNail"
#Res_Saddle             = $24304C;  $FF24304C  "#4C3024"  "rgb( 76, 48, 36)"  "rgba( 76, 48, 36,255)"  "Saddle"
#Res_SaddleBrown        = $013458;  $FF013458  "#583401"  "rgb( 88, 52,  1)"  "rgba( 88, 52,  1,255)"  "SaddleBrown"
#Res_Saffron            = $58BFF9;  $FF58BFF9  "#F9BF58"  "rgb(249,191, 88)"  "rgba(249,191, 88,255)"  "Saffron"
#Res_Sage               = $87A59E;  $FF87A59E  "#9EA587"  "rgb(158,165,135)"  "rgba(158,165,135,255)"  "Sage"
#Res_Sahara             = $14A2B7;  $FF14A2B7  "#B7A214"  "rgb(183,162, 20)"  "rgba(183,162, 20,255)"  "Sahara"
#Res_Sail               = $F9E0B8;  $FFF9E0B8  "#B8E0F9"  "rgb(184,224,249)"  "rgba(184,224,249,255)"  "Sail"
#Res_Salem              = $4B7F09;  $FF4B7F09  "#097F4B"  "rgb(  9,127, 75)"  "rgba(  9,127, 75,255)"  "Salem"
#Res_Salomie            = $8DDBFE;  $FF8DDBFE  "#FEDB8D"  "rgb(254,219,141)"  "rgba(254,219,141,255)"  "Salomie"
#Res_SaltBox            = $6E5E68;  $FF6E5E68  "#685E6E"  "rgb(104, 94,110)"  "rgba(104, 94,110,255)"  "SaltBox"
#Res_Saltpan            = $F2F7F1;  $FFF2F7F1  "#F1F7F2"  "rgb(241,247,242)"  "rgba(241,247,242,255)"  "Saltpan"
#Res_Sambuca            = $10203A;  $FF10203A  "#3A2010"  "rgb( 58, 32, 16)"  "rgba( 58, 32, 16,255)"  "Sambuca"
#Res_SanFelix           = $07620B;  $FF07620B  "#0B6207"  "rgb( 11, 98,  7)"  "rgba( 11, 98,  7,255)"  "SanFelix"
#Res_SanJuan            = $6A4B30;  $FF6A4B30  "#304B6A"  "rgb( 48, 75,106)"  "rgba( 48, 75,106,255)"  "SanJuan"
#Res_SanMarino          = $AC6C45;  $FFAC6C45  "#456CAC"  "rgb( 69,108,172)"  "rgba( 69,108,172,255)"  "SanMarino"
#Res_SandDune           = $656F82;  $FF656F82  "#826F65"  "rgb(130,111,101)"  "rgba(130,111,101,255)"  "SandDune"
#Res_Sandal             = $6F8DAA;  $FF6F8DAA  "#AA8D6F"  "rgb(170,141,111)"  "rgba(170,141,111,255)"  "Sandal"
#Res_Sandrift           = $7A91AB;  $FF7A91AB  "#AB917A"  "rgb(171,145,122)"  "rgba(171,145,122,255)"  "Sandrift"
#Res_Sandstone          = $626D79;  $FF626D79  "#796D62"  "rgb(121,109, 98)"  "rgba(121,109, 98,255)"  "Sandstone"
#Res_Sandwisp           = $A2E7F5;  $FFA2E7F5  "#F5E7A2"  "rgb(245,231,162)"  "rgba(245,231,162,255)"  "Sandwisp"
#Res_SandyBeach         = $C8EAFF;  $FFC8EAFF  "#FFEAC8"  "rgb(255,234,200)"  "rgba(255,234,200,255)"  "SandyBeach"
#Res_Sangria            = $0A0092;  $FF0A0092  "#92000A"  "rgb(146,  0, 10)"  "rgba(146,  0, 10,255)"  "Sangria"
#Res_SanguineBrown      = $383D8D;  $FF383D8D  "#8D3D38"  "rgb(141, 61, 56)"  "rgba(141, 61, 56,255)"  "SanguineBrown"
#Res_SantaFe            = $526DB1;  $FF526DB1  "#B16D52"  "rgb(177,109, 82)"  "rgba(177,109, 82,255)"  "SantaFe"
#Res_SantasGrey         = $B1A09F;  $FFB1A09F  "#9FA0B1"  "rgb(159,160,177)"  "rgba(159,160,177,255)"  "SantasGrey"
#Res_Sapling            = $A4D4DE;  $FFA4D4DE  "#DED4A4"  "rgb(222,212,164)"  "rgba(222,212,164,255)"  "Sapling"
#Res_Sapphire           = $9E512F;  $FF9E512F  "#2F519E"  "rgb( 47, 81,158)"  "rgba( 47, 81,158,255)"  "Sapphire"
#Res_Saratoga           = $105B55;  $FF105B55  "#555B10"  "rgb( 85, 91, 16)"  "rgba( 85, 91, 16,255)"  "Saratoga"
#Res_Sauvignon          = $F3F5FF;  $FFF3F5FF  "#FFF5F3"  "rgb(255,245,243)"  "rgba(255,245,243,255)"  "Sauvignon"
#Res_Sazerac            = $E0F4FF;  $FFE0F4FF  "#FFF4E0"  "rgb(255,244,224)"  "rgba(255,244,224,255)"  "Sazerac"
#Res_Scampi             = $A65F67;  $FFA65F67  "#675FA6"  "rgb(103, 95,166)"  "rgba(103, 95,166,255)"  "Scampi"
#Res_Scandal            = $F4FACF;  $FFF4FACF  "#CFFAF4"  "rgb(207,250,244)"  "rgba(207,250,244,255)"  "Scandal"
#Res_ScarletGum         = $601543;  $FF601543  "#431560"  "rgb( 67, 21, 96)"  "rgba( 67, 21, 96,255)"  "ScarletGum"
#Res_Scarlett           = $150095;  $FF150095  "#950015"  "rgb(149,  0, 21)"  "rgba(149,  0, 21,255)"  "Scarlett"
#Res_ScarpaFlow         = $625558;  $FF625558  "#585562"  "rgb( 88, 85, 98)"  "rgba( 88, 85, 98,255)"  "ScarpaFlow"
#Res_Schist             = $97B4A9;  $FF97B4A9  "#A9B497"  "rgb(169,180,151)"  "rgba(169,180,151,255)"  "Schist"
#Res_Schooner           = $7E848B;  $FF7E848B  "#8B847E"  "rgb(139,132,126)"  "rgba(139,132,126,255)"  "Schooner"
#Res_Scooter            = $D4BF2E;  $FFD4BF2E  "#2EBFD4"  "rgb( 46,191,212)"  "rgba( 46,191,212,255)"  "Scooter"
#Res_Scorpion           = $625F69;  $FF625F69  "#695F62"  "rgb(105, 95, 98)"  "rgba(105, 95, 98,255)"  "Scorpion"
#Res_ScotchMist         = $DCFBFF;  $FFDCFBFF  "#FFFBDC"  "rgb(255,251,220)"  "rgba(255,251,220,255)"  "ScotchMist"
#Res_Scrub              = $22322E;  $FF22322E  "#2E3222"  "rgb( 46, 50, 34)"  "rgba( 46, 50, 34,255)"  "Scrub"
#Res_SeaBuckthorn       = $29A1FB;  $FF29A1FB  "#FBA129"  "rgb(251,161, 41)"  "rgba(251,161, 41,255)"  "SeaBuckthorn"
#Res_SeaFog             = $F9FFFC;  $FFF9FFFC  "#FCFFF9"  "rgb(252,255,249)"  "rgba(252,255,249,255)"  "SeaFog"
#Res_SeaGreen           = $595809;  $FF595809  "#095859"  "rgb(  9, 88, 89)"  "rgba(  9, 88, 89,255)"  "SeaGreen"
#Res_SeaMist            = $CADBC5;  $FFCADBC5  "#C5DBCA"  "rgb(197,219,202)"  "rgba(197,219,202,255)"  "SeaMist"
#Res_SeaNymph           = $9CA378;  $FF9CA378  "#78A39C"  "rgb(120,163,156)"  "rgba(120,163,156,255)"  "SeaNymph"
#Res_SeaPink            = $9E98ED;  $FF9E98ED  "#ED989E"  "rgb(237,152,158)"  "rgba(237,152,158,255)"  "SeaPink"
#Res_Seagull            = $EACC80;  $FFEACC80  "#80CCEA"  "rgb(128,204,234)"  "rgba(128,204,234,255)"  "Seagull"
#Res_Seance             = $8F1E73;  $FF8F1E73  "#731E8F"  "rgb(115, 30,143)"  "rgba(115, 30,143,255)"  "Seance"
#Res_Seashell           = $F1F1F1;  $FFF1F1F1  "#F1F1F1"  "rgb(241,241,241)"  "rgba(241,241,241,255)"  "Seashell"
#Res_Seaweed            = $112F1B;  $FF112F1B  "#1B2F11"  "rgb( 27, 47, 17)"  "rgba( 27, 47, 17,255)"  "Seaweed"
#Res_Selago             = $FDEEF0;  $FFFDEEF0  "#F0EEFD"  "rgb(240,238,253)"  "rgba(240,238,253,255)"  "Selago"
#Res_Sepia              = $02022B;  $FF02022B  "#2B0202"  "rgb( 43,  2,  2)"  "rgba( 43,  2,  2,255)"  "Sepia"
#Res_Serenade           = $E8F4FF;  $FFE8F4FF  "#FFF4E8"  "rgb(255,244,232)"  "rgba(255,244,232,255)"  "Serenade"
#Res_ShadowGreen        = $B8C29A;  $FFB8C29A  "#9AC2B8"  "rgb(154,194,184)"  "rgba(154,194,184,255)"  "ShadowGreen"
#Res_ShadyLady          = $A9A5AA;  $FFA9A5AA  "#AAA5A9"  "rgb(170,165,169)"  "rgba(170,165,169,255)"  "ShadyLady"
#Res_Shakespeare        = $D1AB4E;  $FFD1AB4E  "#4EABD1"  "rgb( 78,171,209)"  "rgba( 78,171,209,255)"  "Shakespeare"
#Res_Shalimar           = $BAFFFB;  $FFBAFFFB  "#FBFFBA"  "rgb(251,255,186)"  "rgba(251,255,186,255)"  "Shalimar"
#Res_Shark              = $2C2725;  $FF2C2725  "#25272C"  "rgb( 37, 39, 44)"  "rgba( 37, 39, 44,255)"  "Shark"
#Res_SherpaBlue         = $504900;  $FF504900  "#004950"  "rgb(  0, 73, 80)"  "rgba(  0, 73, 80,255)"  "SherpaBlue"
#Res_SherwoodGreen      = $2C4002;  $FF2C4002  "#02402C"  "rgb(  2, 64, 44)"  "rgba(  2, 64, 44,255)"  "SherwoodGreen"
#Res_Shilo              = $B3B9E8;  $FFB3B9E8  "#E8B9B3"  "rgb(232,185,179)"  "rgba(232,185,179,255)"  "Shilo"
#Res_ShingleFawn        = $314E6B;  $FF314E6B  "#6B4E31"  "rgb(107, 78, 49)"  "rgba(107, 78, 49,255)"  "ShingleFawn"
#Res_ShipCove           = $BA8B78;  $FFBA8B78  "#788BBA"  "rgb(120,139,186)"  "rgba(120,139,186,255)"  "ShipCove"
#Res_ShipGrey           = $443A3E;  $FF443A3E  "#3E3A44"  "rgb( 62, 58, 68)"  "rgba( 62, 58, 68,255)"  "ShipGrey"
#Res_Shiraz             = $3109B2;  $FF3109B2  "#B20931"  "rgb(178,  9, 49)"  "rgba(178,  9, 49,255)"  "Shiraz"
#Res_Shocking           = $C092E2;  $FFC092E2  "#E292C0"  "rgb(226,146,192)"  "rgba(226,146,192,255)"  "Shocking"
#Res_ShuttleGrey        = $72665F;  $FF72665F  "#5F6672"  "rgb( 95,102,114)"  "rgba( 95,102,114,255)"  "ShuttleGrey"
#Res_Siam               = $546A64;  $FF546A64  "#646A54"  "rgb(100,106, 84)"  "rgba(100,106, 84,255)"  "Siam"
#Res_Sidecar            = $BBE7F3;  $FFBBE7F3  "#F3E7BB"  "rgb(243,231,187)"  "rgba(243,231,187,255)"  "Sidecar"
#Res_Silk               = $A8B1BD;  $FFA8B1BD  "#BDB1A8"  "rgb(189,177,168)"  "rgba(189,177,168,255)"  "Silk"
#Res_SilverChalice      = $ACACAC;  $FFACACAC  "#ACACAC"  "rgb(172,172,172)"  "rgba(172,172,172,255)"  "SilverChalice"
#Res_SilverSand         = $C2C1BF;  $FFC2C1BF  "#BFC1C2"  "rgb(191,193,194)"  "rgba(191,193,194,255)"  "SilverSand"
#Res_SilverTree         = $8FB566;  $FF8FB566  "#66B58F"  "rgb(102,181,143)"  "rgba(102,181,143,255)"  "SilverTree"
#Res_Sinbad             = $D3D79F;  $FFD3D79F  "#9FD7D3"  "rgb(159,215,211)"  "rgba(159,215,211,255)"  "Sinbad"
#Res_Siren              = $3A017A;  $FF3A017A  "#7A013A"  "rgb(122,  1, 58)"  "rgba(122,  1, 58,255)"  "Siren"
#Res_Sirocco            = $808071;  $FF808071  "#718080"  "rgb(113,128,128)"  "rgba(113,128,128,255)"  "Sirocco"
#Res_Sisal              = $BACBD3;  $FFBACBD3  "#D3CBBA"  "rgb(211,203,186)"  "rgba(211,203,186,255)"  "Sisal"
#Res_Skeptic            = $DAE6CA;  $FFDAE6CA  "#CAE6DA"  "rgb(202,230,218)"  "rgba(202,230,218,255)"  "Skeptic"
#Res_Slugger            = $102041;  $FF102041  "#412010"  "rgb( 65, 32, 16)"  "rgba( 65, 32, 16,255)"  "Slugger"
#Res_SmaltBlue          = $8F8051;  $FF8F8051  "#51808F"  "rgb( 81,128,143)"  "rgba( 81,128,143,255)"  "SmaltBlue"
#Res_SmokeTree          = $0463DA;  $FF0463DA  "#DA6304"  "rgb(218, 99,  4)"  "rgba(218, 99,  4,255)"  "SmokeTree"
#Res_SmokeyAsh          = $373C41;  $FF373C41  "#413C37"  "rgb( 65, 60, 55)"  "rgba( 65, 60, 55,255)"  "SmokeyAsh"
#Res_Smoky              = $735B60;  $FF735B60  "#605B73"  "rgb( 96, 91,115)"  "rgba( 96, 91,115,255)"  "Smoky"
#Res_SnowDrift          = $F7FAF7;  $FFF7FAF7  "#F7FAF7"  "rgb(247,250,247)"  "rgba(247,250,247,255)"  "SnowDrift"
#Res_SnowFlurry         = $D1FFE4;  $FFD1FFE4  "#E4FFD1"  "rgb(228,255,209)"  "rgba(228,255,209,255)"  "SnowFlurry"
#Res_SnowyMint          = $DBFFD6;  $FFDBFFD6  "#D6FFDB"  "rgb(214,255,219)"  "rgba(214,255,219,255)"  "SnowyMint"
#Res_Snuff              = $EDD8E2;  $FFEDD8E2  "#E2D8ED"  "rgb(226,216,237)"  "rgba(226,216,237,255)"  "Snuff"
#Res_Soapstone          = $F9FBFF;  $FFF9FBFF  "#FFFBF9"  "rgb(255,251,249)"  "rgba(255,251,249,255)"  "Soapstone"
#Res_SoftAmber          = $B4C6D1;  $FFB4C6D1  "#D1C6B4"  "rgb(209,198,180)"  "rgba(209,198,180,255)"  "SoftAmber"
#Res_SoftPeach          = $EFEDF5;  $FFEFEDF5  "#F5EDEF"  "rgb(245,237,239)"  "rgba(245,237,239,255)"  "SoftPeach"
#Res_SolidPink          = $433889;  $FF433889  "#893843"  "rgb(137, 56, 67)"  "rgba(137, 56, 67,255)"  "SolidPink"
#Res_Solitaire          = $E2F8FE;  $FFE2F8FE  "#FEF8E2"  "rgb(254,248,226)"  "rgba(254,248,226,255)"  "Solitaire"
#Res_Solitude           = $FFF6EA;  $FFFFF6EA  "#EAF6FF"  "rgb(234,246,255)"  "rgba(234,246,255,255)"  "Solitude"
#Res_Sorbus             = $077CFD;  $FF077CFD  "#FD7C07"  "rgb(253,124,  7)"  "rgba(253,124,  7,255)"  "Sorbus"
#Res_SorrellBrown       = $8FB9CE;  $FF8FB9CE  "#CEB98F"  "rgb(206,185,143)"  "rgba(206,185,143,255)"  "SorrellBrown"
#Res_SourDough          = $A8BED1;  $FFA8BED1  "#D1BEA8"  "rgb(209,190,168)"  "rgba(209,190,168,255)"  "SourDough"
#Res_SoyaBean           = $51606A;  $FF51606A  "#6A6051"  "rgb(106, 96, 81)"  "rgba(106, 96, 81,255)"  "SoyaBean"
#Res_SpaceShuttle       = $203143;  $FF203143  "#433120"  "rgb( 67, 49, 32)"  "rgba( 67, 49, 32,255)"  "SpaceShuttle"
#Res_SpanishGreen       = $859881;  $FF859881  "#819885"  "rgb(129,152,133)"  "rgba(129,152,133,255)"  "SpanishGreen"
#Res_SpanishWhite       = $D3EBF4;  $FFD3EBF4  "#F4EBD3"  "rgb(244,235,211)"  "rgba(244,235,211,255)"  "SpanishWhite"
#Res_Spectra            = $575A2F;  $FF575A2F  "#2F5A57"  "rgb( 47, 90, 87)"  "rgba( 47, 90, 87,255)"  "Spectra"
#Res_Spice              = $2E446A;  $FF2E446A  "#6A442E"  "rgb(106, 68, 46)"  "rgba(106, 68, 46,255)"  "Spice"
#Res_SpicyMix           = $425388;  $FF425388  "#885342"  "rgb(136, 83, 66)"  "rgba(136, 83, 66,255)"  "SpicyMix"
#Res_SpicyPink          = $716E81;  $FF716E81  "#816E71"  "rgb(129,110,113)"  "rgba(129,110,113,255)"  "SpicyPink"
#Res_Spindle            = $EAD1B6;  $FFEAD1B6  "#B6D1EA"  "rgb(182,209,234)"  "rgba(182,209,234,255)"  "Spindle"
#Res_Splash             = $C1EFFF;  $FFC1EFFF  "#FFEFC1"  "rgb(255,239,193)"  "rgba(255,239,193,255)"  "Splash"
#Res_Spray              = $ECDE79;  $FFECDE79  "#79DEEC"  "rgb(121,222,236)"  "rgba(121,222,236,255)"  "Spray"
#Res_SpringGreen        = $638357;  $FF638357  "#578363"  "rgb( 87,131, 99)"  "rgba( 87,131, 99,255)"  "SpringGreen"
#Res_SpringRain         = $B1CBAC;  $FFB1CBAC  "#ACCBB1"  "rgb(172,203,177)"  "rgba(172,203,177,255)"  "SpringRain"
#Res_SpringSun          = $DCFFF6;  $FFDCFFF6  "#F6FFDC"  "rgb(246,255,220)"  "rgba(246,255,220,255)"  "SpringSun"
#Res_SpringWood         = $F1F6F8;  $FFF1F6F8  "#F8F6F1"  "rgb(248,246,241)"  "rgba(248,246,241,255)"  "SpringWood"
#Res_Sprout             = $B0D7C1;  $FFB0D7C1  "#C1D7B0"  "rgb(193,215,176)"  "rgba(193,215,176,255)"  "Sprout"
#Res_SpunPearl          = $B7ABAA;  $FFB7ABAA  "#AAABB7"  "rgb(170,171,183)"  "rgba(170,171,183,255)"  "SpunPearl"
#Res_Squirrel           = $76818F;  $FF76818F  "#8F8176"  "rgb(143,129,118)"  "rgba(143,129,118,255)"  "Squirrel"
#Res_StTropaz           = $9B562D;  $FF9B562D  "#2D569B"  "rgb( 45, 86,155)"  "rgba( 45, 86,155,255)"  "StTropaz"
#Res_Stack              = $8A8F8A;  $FF8A8F8A  "#8A8F8A"  "rgb(138,143,138)"  "rgba(138,143,138,255)"  "Stack"
#Res_StarDust           = $9C9F9F;  $FF9C9F9F  "#9F9F9C"  "rgb(159,159,156)"  "rgba(159,159,156,255)"  "StarDust"
#Res_StarkWhite         = $BDD7E5;  $FFBDD7E5  "#E5D7BD"  "rgb(229,215,189)"  "rgba(229,215,189,255)"  "StarkWhite"
#Res_Starship           = $45F2EC;  $FF45F2EC  "#ECF245"  "rgb(236,242, 69)"  "rgba(236,242, 69,255)"  "Starship"
#Res_SteelGrey          = $352326;  $FF352326  "#262335"  "rgb( 38, 35, 53)"  "rgba( 38, 35, 53,255)"  "SteelGrey"
#Res_Stiletto           = $36339C;  $FF36339C  "#9C3336"  "rgb(156, 51, 54)"  "rgba(156, 51, 54,255)"  "Stiletto"
#Res_Stinger            = $0B6B8B;  $FF0B6B8B  "#8B6B0B"  "rgb(139,107, 11)"  "rgba(139,107, 11,255)"  "Stinger"
#Res_Stonewall          = $738592;  $FF738592  "#928573"  "rgb(146,133,115)"  "rgba(146,133,115,255)"  "Stonewall"
#Res_StormDust          = $636464;  $FF636464  "#646463"  "rgb(100,100, 99)"  "rgba(100,100, 99,255)"  "StormDust"
#Res_StormGrey          = $867471;  $FF867471  "#717486"  "rgb(113,116,134)"  "rgba(113,116,134,255)"  "StormGrey"
#Res_Stratos            = $410700;  $FF410700  "#000741"  "rgb(  0,  7, 65)"  "rgba(  0,  7, 65,255)"  "Stratos"
#Res_Straw              = $8DBFD4;  $FF8DBFD4  "#D4BF8D"  "rgb(212,191,141)"  "rgba(212,191,141,255)"  "Straw"
#Res_Strikemaster       = $876395;  $FF876395  "#956387"  "rgb(149, 99,135)"  "rgba(149, 99,135,255)"  "Strikemaster"
#Res_Stromboli          = $525D32;  $FF525D32  "#325D52"  "rgb( 50, 93, 82)"  "rgba( 50, 93, 82,255)"  "Stromboli"
#Res_Studio             = $B24A71;  $FFB24A71  "#714AB2"  "rgb(113, 74,178)"  "rgba(113, 74,178,255)"  "Studio"
#Res_Submarine          = $C9C7BA;  $FFC9C7BA  "#BAC7C9"  "rgb(186,199,201)"  "rgba(186,199,201,255)"  "Submarine"
#Res_SugarCane          = $F6FFF9;  $FFF6FFF9  "#F9FFF6"  "rgb(249,255,246)"  "rgba(249,255,246,255)"  "SugarCane"
#Res_Sulu               = $7CF0C1;  $FF7CF0C1  "#C1F07C"  "rgb(193,240,124)"  "rgba(193,240,124,255)"  "Sulu"
#Res_SummerGreen        = $ABBB96;  $FFABBB96  "#96BBAB"  "rgb(150,187,171)"  "rgba(150,187,171,255)"  "SummerGreen"
#Res_Sun                = $13ACFB;  $FF13ACFB  "#FBAC13"  "rgb(251,172, 19)"  "rgba(251,172, 19,255)"  "Sun"
#Res_Sundance           = $5BB3C9;  $FF5BB3C9  "#C9B35B"  "rgb(201,179, 91)"  "rgba(201,179, 91,255)"  "Sundance"
#Res_Sundown            = $B3B1FF;  $FFB3B1FF  "#FFB1B3"  "rgb(255,177,179)"  "rgba(255,177,179,255)"  "Sundown"
#Res_Sunflower          = $22D4E4;  $FF22D4E4  "#E4D422"  "rgb(228,212, 34)"  "rgba(228,212, 34,255)"  "Sunflower"
#Res_Sunglo             = $6568E1;  $FF6568E1  "#E16865"  "rgb(225,104,101)"  "rgba(225,104,101,255)"  "Sunglo"
#Res_Sunset             = $3343DC;  $FF3343DC  "#DC4333"  "rgb(220, 67, 51)"  "rgba(220, 67, 51,255)"  "Sunset"
#Res_Sunshade           = $2C9EFF;  $FF2C9EFF  "#FF9E2C"  "rgb(255,158, 44)"  "rgba(255,158, 44,255)"  "Sunshade"
#Res_Supernova          = $01C9FF;  $FF01C9FF  "#FFC901"  "rgb(255,201,  1)"  "rgba(255,201,  1,255)"  "Supernova"
#Res_Surf               = $C1D7BB;  $FFC1D7BB  "#BBD7C1"  "rgb(187,215,193)"  "rgba(187,215,193,255)"  "Surf"
#Res_SurfCrest          = $D2E5CF;  $FFD2E5CF  "#CFE5D2"  "rgb(207,229,210)"  "rgba(207,229,210,255)"  "SurfCrest"
#Res_SurfieGreen        = $797A0C;  $FF797A0C  "#0C7A79"  "rgb( 12,122,121)"  "rgba( 12,122,121,255)"  "SurfieGreen"
#Res_Sushi              = $39AB87;  $FF39AB87  "#87AB39"  "rgb(135,171, 57)"  "rgba(135,171, 57,255)"  "Sushi"
#Res_SuvaGrey           = $878388;  $FF878388  "#888387"  "rgb(136,131,135)"  "rgba(136,131,135,255)"  "SuvaGrey"
#Res_Swamp              = $1C1B00;  $FF1C1B00  "#001B1C"  "rgb(  0, 27, 28)"  "rgba(  0, 27, 28,255)"  "Swamp"
#Res_SwansDown          = $EAF0DC;  $FFEAF0DC  "#DCF0EA"  "rgb(220,240,234)"  "rgba(220,240,234,255)"  "SwansDown"
#Res_SweetCorn          = $8CEAFB;  $FF8CEAFB  "#FBEA8C"  "rgb(251,234,140)"  "rgba(251,234,140,255)"  "SweetCorn"
#Res_SweetPink          = $A29FFD;  $FFA29FFD  "#FD9FA2"  "rgb(253,159,162)"  "rgba(253,159,162,255)"  "SweetPink"
#Res_Swirl              = $C5CDD3;  $FFC5CDD3  "#D3CDC5"  "rgb(211,205,197)"  "rgba(211,205,197,255)"  "Swirl"
#Res_SwissCoffee        = $D5D6DD;  $FFD5D6DD  "#DDD6D5"  "rgb(221,214,213)"  "rgba(221,214,213,255)"  "SwissCoffee"
#Res_Sycamore           = $398D90;  $FF398D90  "#908D39"  "rgb(144,141, 57)"  "rgba(144,141, 57,255)"  "Sycamore"
#Res_Tabasco            = $1227A0;  $FF1227A0  "#A02712"  "rgb(160, 39, 18)"  "rgba(160, 39, 18,255)"  "Tabasco"
#Res_Tacao              = $81B3ED;  $FF81B3ED  "#EDB381"  "rgb(237,179,129)"  "rgba(237,179,129,255)"  "Tacao"
#Res_Tacha              = $62C5D6;  $FF62C5D6  "#D6C562"  "rgb(214,197, 98)"  "rgba(214,197, 98,255)"  "Tacha"
#Res_TahitiGold         = $077CE9;  $FF077CE9  "#E97C07"  "rgb(233,124,  7)"  "rgba(233,124,  7,255)"  "TahitiGold"
#Res_TahunaSands        = $C8F0EE;  $FFC8F0EE  "#EEF0C8"  "rgb(238,240,200)"  "rgba(238,240,200,255)"  "TahunaSands"
#Res_TallPoppy          = $292DB3;  $FF292DB3  "#B32D29"  "rgb(179, 45, 41)"  "rgba(179, 45, 41,255)"  "TallPoppy"
#Res_Tallow             = $89A5A8;  $FF89A5A8  "#A8A589"  "rgb(168,165,137)"  "rgba(168,165,137,255)"  "Tallow"
#Res_Tamarillo          = $131699;  $FF131699  "#991613"  "rgb(153, 22, 19)"  "rgba(153, 22, 19,255)"  "Tamarillo"
#Res_Tamarind           = $151534;  $FF151534  "#341515"  "rgb( 52, 21, 21)"  "rgba( 52, 21, 21,255)"  "Tamarind"
#Res_Tana               = $C1DCD9;  $FFC1DCD9  "#D9DCC1"  "rgb(217,220,193)"  "rgba(217,220,193,255)"  "Tana"
#Res_Tangaroa           = $3C1603;  $FF3C1603  "#03163C"  "rgb(  3, 22, 60)"  "rgba(  3, 22, 60,255)"  "Tangaroa"
#Res_Tangerine          = $006EE9;  $FF006EE9  "#E96E00"  "rgb(233,110,  0)"  "rgba(233,110,  0,255)"  "Tangerine"
#Res_Tango              = $1C7AED;  $FF1C7AED  "#ED7A1C"  "rgb(237,122, 28)"  "rgba(237,122, 28,255)"  "Tango"
#Res_Tapa               = $74787B;  $FF74787B  "#7B7874"  "rgb(123,120,116)"  "rgba(123,120,116,255)"  "Tapa"
#Res_Tapestry           = $815EB0;  $FF815EB0  "#B05E81"  "rgb(176, 94,129)"  "rgba(176, 94,129,255)"  "Tapestry"
#Res_Tara               = $E8F6E1;  $FFE8F6E1  "#E1F6E8"  "rgb(225,246,232)"  "rgba(225,246,232,255)"  "Tara"
#Res_Tarawera           = $503A07;  $FF503A07  "#073A50"  "rgb(  7, 58, 80)"  "rgba(  7, 58, 80,255)"  "Tarawera"
#Res_Tasman             = $CFDCCF;  $FFCFDCCF  "#CFDCCF"  "rgb(207,220,207)"  "rgba(207,220,207,255)"  "Tasman"
#Res_TaupeGrey          = $95AFB3;  $FF95AFB3  "#B3AF95"  "rgb(179,175,149)"  "rgba(179,175,149,255)"  "TaupeGrey"
#Res_TawnyPort          = $452569;  $FF452569  "#692545"  "rgb(105, 37, 69)"  "rgba(105, 37, 69,255)"  "TawnyPort"
#Res_TaxBreak           = $8F8051;  $FF8F8051  "#51808F"  "rgb( 81,128,143)"  "rgba( 81,128,143,255)"  "TaxBreak"
#Res_TePapaGreen        = $3C431E;  $FF3C431E  "#1E433C"  "rgb( 30, 67, 60)"  "rgba( 30, 67, 60,255)"  "TePapaGreen"
#Res_Tea                = $B0BAC1;  $FFB0BAC1  "#C1BAB0"  "rgb(193,186,176)"  "rgba(193,186,176,255)"  "Tea"
#Res_Teak               = $6194B1;  $FF6194B1  "#B19461"  "rgb(177,148, 97)"  "rgba(177,148, 97,255)"  "Teak"
#Res_TeakWoodFinish     = $142A6B;  $FF142A6B  "#6B2A14"  "rgb(107, 42, 20)"  "rgba(107, 42, 20,255)"  "TeakWoodFinish"
#Res_TealBlue           = $594204;  $FF594204  "#044259"  "rgb(  4, 66, 89)"  "rgba(  4, 66, 89,255)"  "TealBlue"
#Res_Temptress          = $0B003B;  $FF0B003B  "#3B000B"  "rgb( 59,  0, 11)"  "rgba( 59,  0, 11,255)"  "Temptress"
#Res_Tequila            = $C7E6FF;  $FFC7E6FF  "#FFE6C7"  "rgb(255,230,199)"  "rgba(255,230,199,255)"  "Tequila"
#Res_Texas              = $9CF9F8;  $FF9CF9F8  "#F8F99C"  "rgb(248,249,156)"  "rgba(248,249,156,255)"  "Texas"
#Res_TexasRose          = $55B5FF;  $FF55B5FF  "#FFB555"  "rgb(255,181, 85)"  "rgba(255,181, 85,255)"  "TexasRose"
#Res_Thatch             = $989DB6;  $FF989DB6  "#B69D98"  "rgb(182,157,152)"  "rgba(182,157,152,255)"  "Thatch"
#Res_ThatchGreen        = $193D40;  $FF193D40  "#403D19"  "rgb( 64, 61, 25)"  "rgba( 64, 61, 25,255)"  "ThatchGreen"
#Res_Thistle            = $A8CACC;  $FFA8CACC  "#CCCAA8"  "rgb(204,202,168)"  "rgba(204,202,168,255)"  "Thistle"
#Res_Thunder            = $2F2933;  $FF2F2933  "#33292F"  "rgb( 51, 41, 47)"  "rgba( 51, 41, 47,255)"  "Thunder"
#Res_Thunderbird        = $182BC0;  $FF182BC0  "#C02B18"  "rgb(192, 43, 24)"  "rgba(192, 43, 24,255)"  "Thunderbird"
#Res_TiaMaria           = $0E44C1;  $FF0E44C1  "#C1440E"  "rgb(193, 68, 14)"  "rgba(193, 68, 14,255)"  "TiaMaria"
#Res_Tiara              = $D1D1C3;  $FFD1D1C3  "#C3D1D1"  "rgb(195,209,209)"  "rgba(195,209,209,255)"  "Tiara"
#Res_Tiber              = $373506;  $FF373506  "#063537"  "rgb(  6, 53, 55)"  "rgba(  6, 53, 55,255)"  "Tiber"
#Res_Tidal              = $ADFFF1;  $FFADFFF1  "#F1FFAD"  "rgb(241,255,173)"  "rgba(241,255,173,255)"  "Tidal"
#Res_Tide               = $B0B8BF;  $FFB0B8BF  "#BFB8B0"  "rgb(191,184,176)"  "rgba(191,184,176,255)"  "Tide"
#Res_TimberGreen        = $2C3216;  $FF2C3216  "#16322C"  "rgb( 22, 50, 44)"  "rgba( 22, 50, 44,255)"  "TimberGreen"
#Res_TitanWhite         = $FFEEF0;  $FFFFEEF0  "#F0EEFF"  "rgb(240,238,255)"  "rgba(240,238,255,255)"  "TitanWhite"
#Res_Toast              = $616E9A;  $FF616E9A  "#9A6E61"  "rgb(154,110, 97)"  "rgba(154,110, 97,255)"  "Toast"
#Res_TobaccoBrown       = $475D71;  $FF475D71  "#715D47"  "rgb(113, 93, 71)"  "rgba(113, 93, 71,255)"  "TobaccoBrown"
#Res_Tobago             = $232B3E;  $FF232B3E  "#3E2B23"  "rgb( 62, 43, 35)"  "rgba( 62, 43, 35,255)"  "Tobago"
#Res_Toledo             = $20003A;  $FF20003A  "#3A0020"  "rgb( 58,  0, 32)"  "rgba( 58,  0, 32,255)"  "Toledo"
#Res_Tolopea            = $45021B;  $FF45021B  "#1B0245"  "rgb( 27,  2, 69)"  "rgba( 27,  2, 69,255)"  "Tolopea"
#Res_TomThumb           = $3B583F;  $FF3B583F  "#3F583B"  "rgb( 63, 88, 59)"  "rgba( 63, 88, 59,255)"  "TomThumb"
#Res_TonysPink          = $8C9FE7;  $FF8C9FE7  "#E79F8C"  "rgb(231,159,140)"  "rgba(231,159,140,255)"  "TonysPink"
#Res_Topaz              = $8A777C;  $FF8A777C  "#7C778A"  "rgb(124,119,138)"  "rgba(124,119,138,255)"  "Topaz"
#Res_ToreaBay           = $9E2D0F;  $FF9E2D0F  "#0F2D9E"  "rgb( 15, 45,158)"  "rgba( 15, 45,158,255)"  "ToreaBay"
#Res_ToryBlue           = $AA5014;  $FFAA5014  "#1450AA"  "rgb( 20, 80,170)"  "rgba( 20, 80,170,255)"  "ToryBlue"
#Res_Tosca              = $3F3F8D;  $FF3F3F8D  "#8D3F3F"  "rgb(141, 63, 63)"  "rgba(141, 63, 63,255)"  "Tosca"
#Res_TotemPole          = $071B99;  $FF071B99  "#991B07"  "rgb(153, 27,  7)"  "rgba(153, 27,  7,255)"  "TotemPole"
#Res_TouchWood          = $213037;  $FF213037  "#373021"  "rgb( 55, 48, 33)"  "rgba( 55, 48, 33,255)"  "TouchWood"
#Res_TowerGrey          = $BFBDA9;  $FFBFBDA9  "#A9BDBF"  "rgb(169,189,191)"  "rgba(169,189,191,255)"  "TowerGrey"
#Res_Tradewind          = $ACB35F;  $FFACB35F  "#5FB3AC"  "rgb( 95,179,172)"  "rgba( 95,179,172,255)"  "Tradewind"
#Res_Tranquil           = $FFFFE6;  $FFFFFFE6  "#E6FFFF"  "rgb(230,255,255)"  "rgba(230,255,255,255)"  "Tranquil"
#Res_Travertine         = $E8FDFF;  $FFE8FDFF  "#FFFDE8"  "rgb(255,253,232)"  "rgba(255,253,232,255)"  "Travertine"
#Res_TreePoppy          = $1D9CFC;  $FF1D9CFC  "#FC9C1D"  "rgb(252,156, 29)"  "rgba(252,156, 29,255)"  "TreePoppy"
#Res_Treehouse          = $20283B;  $FF20283B  "#3B2820"  "rgb( 59, 40, 32)"  "rgba( 59, 40, 32,255)"  "Treehouse"
#Res_TrendyGreen        = $1A887C;  $FF1A887C  "#7C881A"  "rgb(124,136, 26)"  "rgba(124,136, 26,255)"  "TrendyGreen"
#Res_TrendyPink         = $95648C;  $FF95648C  "#8C6495"  "rgb(140,100,149)"  "rgba(140,100,149,255)"  "TrendyPink"
#Res_Trinidad           = $034EE6;  $FF034EE6  "#E64E03"  "rgb(230, 78,  3)"  "rgba(230, 78,  3,255)"  "Trinidad"
#Res_TropicalBlue       = $F9DDC3;  $FFF9DDC3  "#C3DDF9"  "rgb(195,221,249)"  "rgba(195,221,249,255)"  "TropicalBlue"
#Res_Trout              = $5A4E4A;  $FF5A4E4A  "#4A4E5A"  "rgb( 74, 78, 90)"  "rgba( 74, 78, 90,255)"  "Trout"
#Res_TrueV              = $D6738A;  $FFD6738A  "#8A73D6"  "rgb(138,115,214)"  "rgba(138,115,214,255)"  "TrueV"
#Res_Tuatara            = $343536;  $FF343536  "#363534"  "rgb( 54, 53, 52)"  "rgba( 54, 53, 52,255)"  "Tuatara"
#Res_TuftBush           = $CDDDFF;  $FFCDDDFF  "#FFDDCD"  "rgb(255,221,205)"  "rgba(255,221,205,255)"  "TuftBush"
#Res_TulipTree          = $3BB3EA;  $FF3BB3EA  "#EAB33B"  "rgb(234,179, 59)"  "rgba(234,179, 59,255)"  "TulipTree"
#Res_Tumbleweed         = $0E2937;  $FF0E2937  "#37290E"  "rgb( 55, 41, 14)"  "rgba( 55, 41, 14,255)"  "Tumbleweed"
#Res_Tuna               = $423535;  $FF423535  "#353542"  "rgb( 53, 53, 66)"  "rgba( 53, 53, 66,255)"  "Tuna"
#Res_Tundora            = $44424A;  $FF44424A  "#4A4244"  "rgb( 74, 66, 68)"  "rgba( 74, 66, 68,255)"  "Tundora"
#Res_Turbo              = $00E6FA;  $FF00E6FA  "#FAE600"  "rgb(250,230,  0)"  "rgba(250,230,  0,255)"  "Turbo"
#Res_TurkishRose        = $8172B5;  $FF8172B5  "#B57281"  "rgb(181,114,129)"  "rgba(181,114,129,255)"  "TurkishRose"
#Res_Turmeric           = $48BBCA;  $FF48BBCA  "#CABB48"  "rgb(202,187, 72)"  "rgba(202,187, 72,255)"  "Turmeric"
#Res_TurtleGreen        = $0B382A;  $FF0B382A  "#2A380B"  "rgb( 42, 56, 11)"  "rgba( 42, 56, 11,255)"  "TurtleGreen"
#Res_Tuscany            = $2E5EBD;  $FF2E5EBD  "#BD5E2E"  "rgb(189, 94, 46)"  "rgba(189, 94, 46,255)"  "Tuscany"
#Res_Tusk               = $C3F3EE;  $FFC3F3EE  "#EEF3C3"  "rgb(238,243,195)"  "rgba(238,243,195,255)"  "Tusk"
#Res_Tussock            = $4B99C5;  $FF4B99C5  "#C5994B"  "rgb(197,153, 75)"  "rgba(197,153, 75,255)"  "Tussock"
#Res_Tutu               = $F9F1FF;  $FFF9F1FF  "#FFF1F9"  "rgb(255,241,249)"  "rgba(255,241,249,255)"  "Tutu"
#Res_Twilight           = $DECFE4;  $FFDECFE4  "#E4CFDE"  "rgb(228,207,222)"  "rgba(228,207,222,255)"  "Twilight"
#Res_TwilightBlue       = $FFFDEE;  $FFFFFDEE  "#EEFDFF"  "rgb(238,253,255)"  "rgba(238,253,255,255)"  "TwilightBlue"
#Res_Twine              = $5D95C2;  $FF5D95C2  "#C2955D"  "rgb(194,149, 93)"  "rgba(194,149, 93,255)"  "Twine"
#Res_Valencia           = $3744D8;  $FF3744D8  "#D84437"  "rgb(216, 68, 55)"  "rgba(216, 68, 55,255)"  "Valencia"
#Res_Valentino          = $420E35;  $FF420E35  "#350E42"  "rgb( 53, 14, 66)"  "rgba( 53, 14, 66,255)"  "Valentino"
#Res_Valhalla           = $4F192B;  $FF4F192B  "#2B194F"  "rgb( 43, 25, 79)"  "rgba( 43, 25, 79,255)"  "Valhalla"
#Res_VanCleef           = $0C1749;  $FF0C1749  "#49170C"  "rgb( 73, 23, 12)"  "rgba( 73, 23, 12,255)"  "VanCleef"
#Res_Vanilla            = $A8BED1;  $FFA8BED1  "#D1BEA8"  "rgb(209,190,168)"  "rgba(209,190,168,255)"  "Vanilla"
#Res_VanillaIce         = $DFD9F3;  $FFDFD9F3  "#F3D9DF"  "rgb(243,217,223)"  "rgba(243,217,223,255)"  "VanillaIce"
#Res_Varden             = $DFF6FF;  $FFDFF6FF  "#FFF6DF"  "rgb(255,246,223)"  "rgba(255,246,223,255)"  "Varden"
#Res_VenetianRed        = $0F0172;  $FF0F0172  "#72010F"  "rgb(114,  1, 15)"  "rgba(114,  1, 15,255)"  "VenetianRed"
#Res_VeniceBlue         = $895905;  $FF895905  "#055989"  "rgb(  5, 89,137)"  "rgba(  5, 89,137,255)"  "VeniceBlue"
#Res_Venus              = $908592;  $FF908592  "#928590"  "rgb(146,133,144)"  "rgba(146,133,144,255)"  "Venus"
#Res_Verdigris          = $375E5D;  $FF375E5D  "#5D5E37"  "rgb( 93, 94, 55)"  "rgba( 93, 94, 55,255)"  "Verdigris"
#Res_VerdunGreen        = $005449;  $FF005449  "#495400"  "rgb( 73, 84,  0)"  "rgba( 73, 84,  0,255)"  "VerdunGreen"
#Res_Vesuvius           = $0B4AB1;  $FF0B4AB1  "#B14A0B"  "rgb(177, 74, 11)"  "rgba(177, 74, 11,255)"  "Vesuvius"
#Res_Victoria           = $914453;  $FF914453  "#534491"  "rgb( 83, 68,145)"  "rgba( 83, 68,145,255)"  "Victoria"
#Res_VidaLoca           = $199054;  $FF199054  "#549019"  "rgb( 84,144, 25)"  "rgba( 84,144, 25,255)"  "VidaLoca"
#Res_Viking             = $DBCC64;  $FFDBCC64  "#64CCDB"  "rgb(100,204,219)"  "rgba(100,204,219,255)"  "Viking"
#Res_VinRouge           = $613D98;  $FF613D98  "#983D61"  "rgb(152, 61, 97)"  "rgba(152, 61, 97,255)"  "VinRouge"
#Res_Viola              = $A98FCB;  $FFA98FCB  "#CB8FA9"  "rgb(203,143,169)"  "rgba(203,143,169,255)"  "Viola"
#Res_ViolentViolet      = $5E0C29;  $FF5E0C29  "#290C5E"  "rgb( 41, 12, 94)"  "rgba( 41, 12, 94,255)"  "ViolentViolet"
#Res_Violet             = $400A24;  $FF400A24  "#240A40"  "rgb( 36, 10, 64)"  "rgba( 36, 10, 64,255)"  "Violet"
#Res_ViridianGreen      = $758967;  $FF758967  "#678975"  "rgb(103,137,117)"  "rgba(103,137,117,255)"  "ViridianGreen"
#Res_VisVis             = $A1EFFF;  $FFA1EFFF  "#FFEFA1"  "rgb(255,239,161)"  "rgba(255,239,161,255)"  "VisVis"
#Res_VistaBlue          = $B4D68F;  $FFB4D68F  "#8FD6B4"  "rgb(143,214,180)"  "rgba(143,214,180,255)"  "VistaBlue"
#Res_VistaWhite         = $F7F8FC;  $FFF7F8FC  "#FCF8F7"  "rgb(252,248,247)"  "rgba(252,248,247,255)"  "VistaWhite"
#Res_Volcano            = $141A65;  $FF141A65  "#651A14"  "rgb(101, 26, 20)"  "rgba(101, 26, 20,255)"  "Volcano"
#Res_Voodoo             = $553453;  $FF553453  "#533455"  "rgb( 83, 52, 85)"  "rgba( 83, 52, 85,255)"  "Voodoo"
#Res_Vulcan             = $1D1210;  $FF1D1210  "#10121D"  "rgb( 16, 18, 29)"  "rgba( 16, 18, 29,255)"  "Vulcan"
#Res_Wafer              = $C6CBDE;  $FFC6CBDE  "#DECBC6"  "rgb(222,203,198)"  "rgba(222,203,198,255)"  "Wafer"
#Res_WaikawaGrey        = $9C6E5A;  $FF9C6E5A  "#5A6E9C"  "rgb( 90,110,156)"  "rgba( 90,110,156,255)"  "WaikawaGrey"
#Res_Waiouru            = $0D3C36;  $FF0D3C36  "#363C0D"  "rgb( 54, 60, 13)"  "rgba( 54, 60, 13,255)"  "Waiouru"
#Res_Walnut             = $1A3F77;  $FF1A3F77  "#773F1A"  "rgb(119, 63, 26)"  "rgba(119, 63, 26,255)"  "Walnut"
#Res_WanWhite           = $F9FFFC;  $FFF9FFFC  "#FCFFF9"  "rgb(252,255,249)"  "rgba(252,255,249,255)"  "WanWhite"
#Res_Wasabi             = $258A78;  $FF258A78  "#788A25"  "rgb(120,138, 37)"  "rgba(120,138, 37,255)"  "Wasabi"
#Res_WaterLeaf          = $DEE9A1;  $FFDEE9A1  "#A1E9DE"  "rgb(161,233,222)"  "rgba(161,233,222,255)"  "WaterLeaf"
#Res_Watercourse        = $576F05;  $FF576F05  "#056F57"  "rgb(  5,111, 87)"  "rgba(  5,111, 87,255)"  "Watercourse"
#Res_Waterloo           = $947C7B;  $FF947C7B  "#7B7C94"  "rgb(123,124,148)"  "rgba(123,124,148,255)"  "Waterloo"
#Res_Wattle             = $47D7DC;  $FF47D7DC  "#DCD747"  "rgb(220,215, 71)"  "rgba(220,215, 71,255)"  "Wattle"
#Res_Watusi             = $CFDDFF;  $FFCFDDFF  "#FFDDCF"  "rgb(255,221,207)"  "rgba(255,221,207,255)"  "Watusi"
#Res_WaxFlower          = $A8C0FF;  $FFA8C0FF  "#FFC0A8"  "rgb(255,192,168)"  "rgba(255,192,168,255)"  "WaxFlower"
#Res_WePeep             = $E6DBF7;  $FFE6DBF7  "#F7DBE6"  "rgb(247,219,230)"  "rgba(247,219,230,255)"  "WePeep"
#Res_Wedgewood          = $9E7F4E;  $FF9E7F4E  "#4E7F9E"  "rgb( 78,127,158)"  "rgba( 78,127,158,255)"  "Wedgewood"
#Res_WellRead           = $3233B4;  $FF3233B4  "#B43332"  "rgb(180, 51, 50)"  "rgba(180, 51, 50,255)"  "WellRead"
#Res_WestCoast          = $195162;  $FF195162  "#625119"  "rgb( 98, 81, 25)"  "rgba( 98, 81, 25,255)"  "WestCoast"
#Res_WestSide           = $0F91FF;  $FF0F91FF  "#FF910F"  "rgb(255,145, 15)"  "rgba(255,145, 15,255)"  "WestSide"
#Res_Westar             = $D2D9DC;  $FFD2D9DC  "#DCD9D2"  "rgb(220,217,210)"  "rgba(220,217,210,255)"  "Westar"
#Res_WesternRed         = $23078B;  $FF23078B  "#8B0723"  "rgb(139,  7, 35)"  "rgba(139,  7, 35,255)"  "WesternRed"
#Res_Wewak              = $AB9BF1;  $FFAB9BF1  "#F19BAB"  "rgb(241,155,171)"  "rgba(241,155,171,255)"  "Wewak"
#Res_Wheatfield         = $CFEDF3;  $FFCFEDF3  "#F3EDCF"  "rgb(243,237,207)"  "rgba(243,237,207,255)"  "Wheatfield"
#Res_Whiskey            = $6F9AD5;  $FF6F9AD5  "#D59A6F"  "rgb(213,154,111)"  "rgba(213,154,111,255)"  "Whiskey"
#Res_WhiskeySour        = $5E99DB;  $FF5E99DB  "#DB995E"  "rgb(219,153, 94)"  "rgba(219,153, 94,255)"  "WhiskeySour"
#Res_Whisper            = $FAF5F7;  $FFFAF5F7  "#F7F5FA"  "rgb(247,245,250)"  "rgba(247,245,250,255)"  "Whisper"
#Res_WhiteIce           = $F1F9DD;  $FFF1F9DD  "#DDF9F1"  "rgb(221,249,241)"  "rgba(221,249,241,255)"  "WhiteIce"
#Res_WhiteLilac         = $FCF7F8;  $FFFCF7F8  "#F8F7FC"  "rgb(248,247,252)"  "rgba(248,247,252,255)"  "WhiteLilac"
#Res_WhiteLinen         = $E8F0F8;  $FFE8F0F8  "#F8F0E8"  "rgb(248,240,232)"  "rgba(248,240,232,255)"  "WhiteLinen"
#Res_WhiteNectar        = $E7FFFC;  $FFE7FFFC  "#FCFFE7"  "rgb(252,255,231)"  "rgba(252,255,231,255)"  "WhiteNectar"
#Res_WhitePointer       = $FFF8FE;  $FFFFF8FE  "#FEF8FF"  "rgb(254,248,255)"  "rgba(254,248,255,255)"  "WhitePointer"
#Res_WhiteRock          = $D4E8EA;  $FFD4E8EA  "#EAE8D4"  "rgb(234,232,212)"  "rgba(234,232,212,255)"  "WhiteRock"
#Res_WildRice           = $90E0EC;  $FF90E0EC  "#ECE090"  "rgb(236,224,144)"  "rgba(236,224,144,255)"  "WildRice"
#Res_WildSand           = $F4F4F4;  $FFF4F4F4  "#F4F4F4"  "rgb(244,244,244)"  "rgba(244,244,244,255)"  "WildSand"
#Res_WildWillow         = $6AC4B9;  $FF6AC4B9  "#B9C46A"  "rgb(185,196,106)"  "rgba(185,196,106,255)"  "WildWillow"
#Res_William            = $6C683A;  $FF6C683A  "#3A686C"  "rgb( 58,104,108)"  "rgba( 58,104,108,255)"  "William"
#Res_WillowBrook        = $DAECDF;  $FFDAECDF  "#DFECDA"  "rgb(223,236,218)"  "rgba(223,236,218,255)"  "WillowBrook"
#Res_WillowGrove        = $5D7465;  $FF5D7465  "#65745D"  "rgb(101,116, 93)"  "rgba(101,116, 93,255)"  "WillowGrove"
#Res_Windsor            = $78083C;  $FF78083C  "#3C0878"  "rgb( 60,  8,120)"  "rgba( 60,  8,120,255)"  "Windsor"
#Res_WineBerry          = $351D59;  $FF351D59  "#591D35"  "rgb( 89, 29, 53)"  "rgba( 89, 29, 53,255)"  "WineBerry"
#Res_WinterHazel        = $95D1D5;  $FF95D1D5  "#D5D195"  "rgb(213,209,149)"  "rgba(213,209,149,255)"  "WinterHazel"
#Res_WispPink           = $F8F4FE;  $FFF8F4FE  "#FEF4F8"  "rgb(254,244,248)"  "rgba(254,244,248,255)"  "WispPink"
#Res_Wisteria           = $B57197;  $FFB57197  "#9771B5"  "rgb(151,113,181)"  "rgba(151,113,181,255)"  "Wisteria"
#Res_Wistful            = $D3A6A4;  $FFD3A6A4  "#A4A6D3"  "rgb(164,166,211)"  "rgba(164,166,211,255)"  "Wistful"
#Res_WitchHaze          = $99FCFF;  $FF99FCFF  "#FFFC99"  "rgb(255,252,153)"  "rgba(255,252,153,255)"  "WitchHaze"
#Res_WoodBark           = $051126;  $FF051126  "#261105"  "rgb( 38, 17,  5)"  "rgba( 38, 17,  5,255)"  "WoodBark"
#Res_Woodburn           = $05203C;  $FF05203C  "#3C2005"  "rgb( 60, 32,  5)"  "rgba( 60, 32,  5,255)"  "Woodburn"
#Res_Woodland           = $28534D;  $FF28534D  "#4D5328"  "rgb( 77, 83, 40)"  "rgba( 77, 83, 40,255)"  "Woodland"
#Res_Woodrush           = $0F2A30;  $FF0F2A30  "#302A0F"  "rgb( 48, 42, 15)"  "rgba( 48, 42, 15,255)"  "Woodrush"
#Res_Woodsmoke          = $0F0D0C;  $FF0F0D0C  "#0C0D0F"  "rgb( 12, 13, 15)"  "rgba( 12, 13, 15,255)"  "Woodsmoke"
#Res_WoodyBay           = $302129;  $FF302129  "#292130"  "rgb( 41, 33, 48)"  "rgba( 41, 33, 48,255)"  "WoodyBay"
#Res_WoodyBrown         = $313148;  $FF313148  "#483131"  "rgb( 72, 49, 49)"  "rgba( 72, 49, 49,255)"  "WoodyBrown"
#Res_Xanadu             = $788673;  $FF788673  "#738678"  "rgb(115,134,120)"  "rgba(115,134,120,255)"  "Xanadu"
#Res_YellowMetal        = $386371;  $FF386371  "#716338"  "rgb(113, 99, 56)"  "rgba(113, 99, 56,255)"  "YellowMetal"
#Res_YellowSea          = $04A9FE;  $FF04A9FE  "#FEA904"  "rgb(254,169,  4)"  "rgba(254,169,  4,255)"  "YellowSea"
#Res_YourPink           = $C0C3FF;  $FFC0C3FF  "#FFC3C0"  "rgb(255,195,192)"  "rgba(255,195,192,255)"  "YourPink"
#Res_YukonGold          = $08667B;  $FF08667B  "#7B6608"  "rgb(123,102,  8)"  "rgba(123,102,  8,255)"  "YukonGold"
#Res_Yuma               = $91C2CE;  $FF91C2CE  "#CEC291"  "rgb(206,194,145)"  "rgba(206,194,145,255)"  "Yuma"
#Res_Zambezi            = $585568;  $FF585568  "#685558"  "rgb(104, 85, 88)"  "rgba(104, 85, 88,255)"  "Zambezi"
#Res_Zanah              = $D6ECDA;  $FFD6ECDA  "#DAECD6"  "rgb(218,236,214)"  "rgba(218,236,214,255)"  "Zanah"
#Res_Zest               = $1B84E5;  $FF1B84E5  "#E5841B"  "rgb(229,132, 27)"  "rgba(229,132, 27,255)"  "Zest"
#Res_Zeus               = $192329;  $FF192329  "#292319"  "rgb( 41, 35, 25)"  "rgba( 41, 35, 25,255)"  "Zeus"
#Res_Ziggurat           = $E2DBBF;  $FFE2DBBF  "#BFDBE2"  "rgb(191,219,226)"  "rgba(191,219,226,255)"  "Ziggurat"
#Res_Zircon             = $FFF8F4;  $FFFFF8F4  "#F4F8FF"  "rgb(244,248,255)"  "rgba(244,248,255,255)"  "Zircon"
#Res_Zombie             = $9BD6E4;  $FF9BD6E4  "#E4D69B"  "rgb(228,214,155)"  "rgba(228,214,155,255)"  "Zombie"
#Res_Zorba              = $919BA5;  $FF919BA5  "#A59B91"  "rgb(165,155,145)"  "rgba(165,155,145,255)"  "Zorba"
#Res_Zuccini            = $224004;  $FF224004  "#044022"  "rgb(  4, 64, 34)"  "rgba(  4, 64, 34,255)"  "Zuccini"
#Res_Zumthor            = $FFF6ED;  $FFFFF6ED  "#EDF6FF"  "rgb(237,246,255)"  "rgba(237,246,255,255)"  "Zumthor"
#Res_Zydeco             = $2C4002;  $FF2C4002  "#02402C"  "rgb(  2, 64, 44)"  "rgba(  2, 64, 44,255)"  "Zydeco"

;-Pantone-Colors
;  see http://color2u.cocolog-nifty.com/color4u/2012/02/pantone-tpx-col.html
;Pantone               PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              Pantone Colorname/-no.:
#Pnt_100C              = $7AECF3;  $FF7AECF3  "#F3EC7A"  "rgb(243,236,122)"  "rgba(243,236,122,255)"  "100C"
#Pnt_101C              = $5AECF5;  $FF5AECF5  "#F5EC5A"  "rgb(245,236, 90)"  "rgba(245,236, 90,255)"  "101C"
#Pnt_102C              = $00E7FA;  $FF00E7FA  "#FAE700"  "rgb(250,231,  0)"  "rgba(250,231,  0,255)"  "102C"
#Pnt_103C              = $00ACC6;  $FF00ACC6  "#C6AC00"  "rgb(198,172,  0)"  "rgba(198,172,  0,255)"  "103C"
#Pnt_104C              = $009AAE;  $FF009AAE  "#AE9A00"  "rgb(174,154,  0)"  "rgba(174,154,  0,255)"  "104C"
#Pnt_105C              = $247A86;  $FF247A86  "#867A24"  "rgb(134,122, 36)"  "rgba(134,122, 36,255)"  "105C"
#Pnt_106C              = $54E6F7;  $FF54E6F7  "#F7E654"  "rgb(247,230, 84)"  "rgba(247,230, 84,255)"  "106C"
#Pnt_107C              = $1EE1F9;  $FF1EE1F9  "#F9E11E"  "rgb(249,225, 30)"  "rgba(249,225, 30,255)"  "107C"
#Pnt_108C              = $00D9FC;  $FF00D9FC  "#FCD900"  "rgb(252,217,  0)"  "rgba(252,217,  0,255)"  "108C"
#Pnt_109C              = $00D1FE;  $FF00D1FE  "#FED100"  "rgb(254,209,  0)"  "rgba(254,209,  0,255)"  "109C"
#Pnt_110C              = $00A9D7;  $FF00A9D7  "#D7A900"  "rgb(215,169,  0)"  "rgba(215,169,  0,255)"  "110C"
#Pnt_111C              = $008DAB;  $FF008DAB  "#AB8D00"  "rgb(171,141,  0)"  "rgba(171,141,  0,255)"  "111C"
#Pnt_112C              = $008096;  $FF008096  "#968000"  "rgb(150,128,  0)"  "rgba(150,128,  0,255)"  "112C"
#Pnt_113C              = $4DE0F8;  $FF4DE0F8  "#F8E04D"  "rgb(248,224, 77)"  "rgba(248,224, 77,255)"  "113C"
#Pnt_114C              = $42DEF9;  $FF42DEF9  "#F9DE42"  "rgb(249,222, 66)"  "rgba(249,222, 66,255)"  "114C"
#Pnt_115C              = $41DCFA;  $FF41DCFA  "#FADC41"  "rgb(250,220, 65)"  "rgba(250,220, 65,255)"  "115C"
#Pnt_116C              = $00CBFE;  $FF00CBFE  "#FECB00"  "rgb(254,203,  0)"  "rgba(254,203,  0,255)"  "116C"
#Pnt_117C              = $0099C7;  $FF0099C7  "#C79900"  "rgb(199,153,  0)"  "rgba(199,153,  0,255)"  "117C"
#Pnt_118C              = $0088AD;  $FF0088AD  "#AD8800"  "rgb(173,136,  0)"  "rgba(173,136,  0,255)"  "118C"
#Pnt_119C              = $1E7386;  $FF1E7386  "#86731E"  "rgb(134,115, 30)"  "rgba(134,115, 30,255)"  "119C"
#Pnt_120C              = $6EDEF8;  $FF6EDEF8  "#F8DE6E"  "rgb(248,222,110)"  "rgba(248,222,110,255)"  "120C"
#Pnt_1205C             = $98E4F8;  $FF98E4F8  "#F8E498"  "rgb(248,228,152)"  "rgba(248,228,152,255)"  "1205C"
#Pnt_121C              = $63DAFA;  $FF63DAFA  "#FADA63"  "rgb(250,218, 99)"  "rgba(250,218, 99,255)"  "121C"
#Pnt_1215C             = $80DDFA;  $FF80DDFA  "#FADD80"  "rgb(250,221,128)"  "rgba(250,221,128,255)"  "1215C"
#Pnt_122C              = $50D4FC;  $FF50D4FC  "#FCD450"  "rgb(252,212, 80)"  "rgba(252,212, 80,255)"  "122C"
#Pnt_1225C             = $4FCBFF;  $FF4FCBFF  "#FFCB4F"  "rgb(255,203, 79)"  "rgba(255,203, 79,255)"  "1225C"
#Pnt_123C              = $2FC8FD;  $FF2FC8FD  "#FDC82F"  "rgb(253,200, 47)"  "rgba(253,200, 47,255)"  "123C"
#Pnt_1235C             = $12B6FF;  $FF12B6FF  "#FFB612"  "rgb(255,182, 18)"  "rgba(255,182, 18,255)"  "1235C"
#Pnt_124C              = $00ABEA;  $FF00ABEA  "#EAAB00"  "rgb(234,171,  0)"  "rgba(234,171,  0,255)"  "124C"
#Pnt_1245C             = $1792C5;  $FF1792C5  "#C59217"  "rgb(197,146, 23)"  "rgba(197,146, 23,255)"  "1245C"
#Pnt_125C              = $008BB8;  $FF008BB8  "#B88B00"  "rgb(184,139,  0)"  "rgba(184,139,  0,255)"  "125C"
#Pnt_1255C             = $2284AB;  $FF2284AB  "#AB8422"  "rgb(171,132, 34)"  "rgba(171,132, 34,255)"  "1255C"
#Pnt_126C              = $0C7C9E;  $FF0C7C9E  "#9E7C0C"  "rgb(158,124, 12)"  "rgba(158,124, 12,255)"  "126C"
#Pnt_1265C             = $226885;  $FF226885  "#856822"  "rgb(133,104, 34)"  "rgba(133,104, 34,255)"  "1265C"
#Pnt_127C              = $74DFF2;  $FF74DFF2  "#F2DF74"  "rgb(242,223,116)"  "rgba(242,223,116,255)"  "127C"
#Pnt_128C              = $53D6F2;  $FF53D6F2  "#F2D653"  "rgb(242,214, 83)"  "rgba(242,214, 83,255)"  "128C"
#Pnt_129C              = $45CFF3;  $FF45CFF3  "#F3CF45"  "rgb(243,207, 69)"  "rgba(243,207, 69,255)"  "129C"
#Pnt_130C              = $00ABF0;  $FF00ABF0  "#F0AB00"  "rgb(240,171,  0)"  "rgba(240,171,  0,255)"  "130C"
#Pnt_131C              = $008ECE;  $FF008ECE  "#CE8E00"  "rgb(206,142,  0)"  "rgba(206,142,  0,255)"  "131C"
#Pnt_132C              = $0077A1;  $FF0077A1  "#A17700"  "rgb(161,119,  0)"  "rgba(161,119,  0,255)"  "132C"
#Pnt_133C              = $18586D;  $FF18586D  "#6D5818"  "rgb(109, 88, 24)"  "rgba(109, 88, 24,255)"  "133C"
#Pnt_134C              = $76D4FB;  $FF76D4FB  "#FBD476"  "rgb(251,212,118)"  "rgba(251,212,118,255)"  "134C"
#Pnt_1345C             = $89D1FC;  $FF89D1FC  "#FCD189"  "rgb(252,209,137)"  "rgba(252,209,137,255)"  "1345C"
#Pnt_135C              = $50C5FF;  $FF50C5FF  "#FFC550"  "rgb(255,197, 80)"  "rgba(255,197, 80,255)"  "135C"
#Pnt_1355C             = $74C6FF;  $FF74C6FF  "#FFC674"  "rgb(255,198,116)"  "rgba(255,198,116,255)"  "1355C"
#Pnt_136C              = $3DBCFF;  $FF3DBCFF  "#FFBC3D"  "rgb(255,188, 61)"  "rgba(255,188, 61,255)"  "136C"
#Pnt_1365C             = $52B6FF;  $FF52B6FF  "#FFB652"  "rgb(255,182, 82)"  "rgba(255,182, 82,255)"  "1365C"
#Pnt_137C              = $00A1FF;  $FF00A1FF  "#FFA100"  "rgb(255,161,  0)"  "rgba(255,161,  0,255)"  "137C"
#Pnt_1375C             = $2FA0FF;  $FF2FA0FF  "#FFA02F"  "rgb(255,160, 47)"  "rgba(255,160, 47,255)"  "1375C"
#Pnt_138C              = $007ADF;  $FF007ADF  "#DF7A00"  "rgb(223,122,  0)"  "rgba(223,122,  0,255)"  "138C"
#Pnt_1385C             = $0076D4;  $FF0076D4  "#D47600"  "rgb(212,118,  0)"  "rgba(212,118,  0,255)"  "1385C"
#Pnt_139C              = $006FB0;  $FF006FB0  "#B06F00"  "rgb(176,111,  0)"  "rgba(176,111,  0,255)"  "139C"
#Pnt_1395C             = $14619C;  $FF14619C  "#9C6114"  "rgb(156, 97, 20)"  "rgba(156, 97, 20,255)"  "1395C"
#Pnt_140C              = $185475;  $FF185475  "#755418"  "rgb(117, 84, 24)"  "rgba(117, 84, 24,255)"  "140C"
#Pnt_1405C             = $1C496A;  $FF1C496A  "#6A491C"  "rgb(106, 73, 28)"  "rgba(106, 73, 28,255)"  "1405C"
#Pnt_141C              = $65CBEF;  $FF65CBEF  "#EFCB65"  "rgb(239,203,101)"  "rgba(239,203,101,255)"  "141C"
#Pnt_142C              = $47BDEF;  $FF47BDEF  "#EFBD47"  "rgb(239,189, 71)"  "rgba(239,189, 71,255)"  "142C"
#Pnt_143C              = $30AFEE;  $FF30AFEE  "#EEAF30"  "rgb(238,175, 48)"  "rgba(238,175, 48,255)"  "143C"
#Pnt_144C              = $0083E9;  $FF0083E9  "#E98300"  "rgb(233,131,  0)"  "rgba(233,131,  0,255)"  "144C"
#Pnt_145C              = $0077CA;  $FF0077CA  "#CA7700"  "rgb(202,119,  0)"  "rgba(202,119,  0,255)"  "145C"
#Pnt_146C              = $09649C;  $FF09649C  "#9C6409"  "rgb(156,100,  9)"  "rgba(156,100,  9,255)"  "146C"
#Pnt_147C              = $2A5A6E;  $FF2A5A6E  "#6E5A2A"  "rgb(110, 90, 42)"  "rgba(110, 90, 42,255)"  "147C"
#Pnt_148C              = $92CEFB;  $FF92CEFB  "#FBCE92"  "rgb(251,206,146)"  "rgba(251,206,146,255)"  "148C"
#Pnt_1485C             = $70B0FF;  $FF70B0FF  "#FFB070"  "rgb(255,176,112)"  "rgba(255,176,112,255)"  "1485C"
#Pnt_149C              = $80C4FD;  $FF80C4FD  "#FDC480"  "rgb(253,196,128)"  "rgba(253,196,128,255)"  "149C"
#Pnt_1495C             = $3391FF;  $FF3391FF  "#FF9133"  "rgb(255,145, 51)"  "rgba(255,145, 51,255)"  "1495C"
#Pnt_150C              = $52A9FF;  $FF52A9FF  "#FFA952"  "rgb(255,169, 82)"  "rgba(255,169, 82,255)"  "150C"
#Pnt_1505C             = $006EFF;  $FF006EFF  "#FF6E00"  "rgb(255,110,  0)"  "rgba(255,110,  0,255)"  "1505C"
#Pnt_151C              = $0079FF;  $FF0079FF  "#FF7900"  "rgb(255,121,  0)"  "rgba(255,121,  0,255)"  "151C"
#Pnt_152C              = $0070E1;  $FF0070E1  "#E17000"  "rgb(225,112,  0)"  "rgba(225,112,  0,255)"  "152C"
#Pnt_1525C             = $004CC5;  $FF004CC5  "#C54C00"  "rgb(197, 76,  0)"  "rgba(197, 76,  0,255)"  "1525C"
#Pnt_153C              = $0E65BB;  $FF0E65BB  "#BB650E"  "rgb(187,101, 14)"  "rgba(187,101, 14,255)"  "153C"
#Pnt_1535C             = $0E4291;  $FF0E4291  "#91420E"  "rgb(145, 66, 14)"  "rgba(145, 66, 14,255)"  "1535C"
#Pnt_154C              = $145295;  $FF145295  "#955214"  "rgb(149, 82, 20)"  "rgba(149, 82, 20,255)"  "154C"
#Pnt_1545C             = $192E54;  $FF192E54  "#542E19"  "rgb( 84, 46, 25)"  "rgba( 84, 46, 25,255)"  "1545C"
#Pnt_155C              = $A5D6EE;  $FFA5D6EE  "#EED6A5"  "rgb(238,214,165)"  "rgba(238,214,165,255)"  "155C"
#Pnt_1555C             = $9CC1FF;  $FF9CC1FF  "#FFC19C"  "rgb(255,193,156)"  "rgba(255,193,156,255)"  "1555C"
#Pnt_156C              = $82C1EC;  $FF82C1EC  "#ECC182"  "rgb(236,193,130)"  "rgba(236,193,130,255)"  "156C"
#Pnt_1565C             = $7BAAFF;  $FF7BAAFF  "#FFAA7B"  "rgb(255,170,123)"  "rgba(255,170,123,255)"  "1565C"
#Pnt_157C              = $4A99E9;  $FF4A99E9  "#E9994A"  "rgb(233,153, 74)"  "rgba(233,153, 74,255)"  "157C"
#Pnt_1575C             = $4988FF;  $FF4988FF  "#FF8849"  "rgb(255,136, 73)"  "rgba(255,136, 73,255)"  "1575C"
#Pnt_158C              = $2272E3;  $FF2272E3  "#E37222"  "rgb(227,114, 34)"  "rgba(227,114, 34,255)"  "158C"
#Pnt_1585C             = $226DFF;  $FF226DFF  "#FF6D22"  "rgb(255,109, 34)"  "rgba(255,109, 34,255)"  "1585C"
#Pnt_159C              = $125BC7;  $FF125BC7  "#C75B12"  "rgb(199, 91, 18)"  "rgba(199, 91, 18,255)"  "159C"
#Pnt_1595C             = $195CD5;  $FF195CD5  "#D55C19"  "rgb(213, 92, 25)"  "rgba(213, 92, 25,255)"  "1595C"
#Pnt_160C              = $16519D;  $FF16519D  "#9D5116"  "rgb(157, 81, 22)"  "rgba(157, 81, 22,255)"  "160C"
#Pnt_1605C             = $2250A2;  $FF2250A2  "#A25022"  "rgb(162, 80, 34)"  "rgba(162, 80, 34,255)"  "1605C"
#Pnt_161C              = $1B3C62;  $FF1B3C62  "#623C1B"  "rgb( 98, 60, 27)"  "rgba( 98, 60, 27,255)"  "161C"
#Pnt_1615C             = $1E4386;  $FF1E4386  "#86431E"  "rgb(134, 67, 30)"  "rgba(134, 67, 30,255)"  "1615C"
#Pnt_162C              = $A2C2FF;  $FFA2C2FF  "#FFC2A2"  "rgb(255,194,162)"  "rgba(255,194,162,255)"  "162C"
#Pnt_1625C             = $8AA4FF;  $FF8AA4FF  "#FFA48A"  "rgb(255,164,138)"  "rgba(255,164,138,255)"  "1625C"
#Pnt_163C              = $719EFF;  $FF719EFF  "#FF9E71"  "rgb(255,158,113)"  "rgba(255,158,113,255)"  "163C"
#Pnt_1635C             = $708FFF;  $FF708FFF  "#FF8F70"  "rgb(255,143,112)"  "rgba(255,143,112,255)"  "1635C"
#Pnt_164C              = $457FFF;  $FF457FFF  "#FF7F45"  "rgb(255,127, 69)"  "rgba(255,127, 69,255)"  "164C"
#Pnt_1645C             = $426DFF;  $FF426DFF  "#FF6D42"  "rgb(255,109, 66)"  "rgba(255,109, 66,255)"  "1645C"
#Pnt_165C              = $1963FF;  $FF1963FF  "#FF6319"  "rgb(255, 99, 25)"  "rgba(255, 99, 25,255)"  "165C"
#Pnt_1655C             = $144FFB;  $FF144FFB  "#FB4F14"  "rgb(251, 79, 20)"  "rgba(251, 79, 20,255)"  "1655C"
#Pnt_166C              = $0652E0;  $FF0652E0  "#E05206"  "rgb(224, 82,  6)"  "rgba(224, 82,  6,255)"  "166C"
#Pnt_1665C             = $1448DD;  $FF1448DD  "#DD4814"  "rgb(221, 72, 20)"  "rgba(221, 72, 20,255)"  "1665C"
#Pnt_167C              = $194FBD;  $FF194FBD  "#BD4F19"  "rgb(189, 79, 25)"  "rgba(189, 79, 25,255)"  "167C"
#Pnt_1675C             = $1F3FA3;  $FF1F3FA3  "#A33F1F"  "rgb(163, 63, 31)"  "rgba(163, 63, 31,255)"  "1675C"
#Pnt_168C              = $19326E;  $FF19326E  "#6E3219"  "rgb(110, 50, 25)"  "rgba(110, 50, 25,255)"  "168C"
#Pnt_1685C             = $203883;  $FF203883  "#833820"  "rgb(131, 56, 32)"  "rgba(131, 56, 32,255)"  "1685C"
#Pnt_169C              = $AEB7FF;  $FFAEB7FF  "#FFB7AE"  "rgb(255,183,174)"  "rgba(255,183,174,255)"  "169C"
#Pnt_170C              = $7C8BFF;  $FF7C8BFF  "#FF8B7C"  "rgb(255,139,124)"  "rgba(255,139,124,255)"  "170C"
#Pnt_171C              = $3E5CFF;  $FF3E5CFF  "#FF5C3E"  "rgb(255, 92, 62)"  "rgba(255, 92, 62,255)"  "171C"
#Pnt_172C              = $1C46F9;  $FF1C46F9  "#F9461C"  "rgb(249, 70, 28)"  "rgba(249, 70, 28,255)"  "172C"
#Pnt_173C              = $2A49D2;  $FF2A49D2  "#D2492A"  "rgb(210, 73, 42)"  "rgba(210, 73, 42,255)"  "173C"
#Pnt_174C              = $263B9A;  $FF263B9A  "#9A3B26"  "rgb(154, 59, 38)"  "rgba(154, 59, 38,255)"  "174C"
#Pnt_175C              = $2D3870;  $FF2D3870  "#70382D"  "rgb(112, 56, 45)"  "rgba(112, 56, 45,255)"  "175C"
#Pnt_176C              = $B7B0FF;  $FFB7B0FF  "#FFB0B7"  "rgb(255,176,183)"  "rgba(255,176,183,255)"  "176C"
#Pnt_1765C             = $AF9EFE;  $FFAF9EFE  "#FE9EAF"  "rgb(254,158,175)"  "rgba(254,158,175,255)"  "1765C"
#Pnt_1767C             = $C2B1FA;  $FFC2B1FA  "#FAB1C2"  "rgb(250,177,194)"  "rgba(250,177,194,255)"  "1767C"
#Pnt_177C              = $8D81FF;  $FF8D81FF  "#FF818D"  "rgb(255,129,141)"  "rgba(255,129,141,255)"  "177C"
#Pnt_1775C             = $9E8AFE;  $FF9E8AFE  "#FE8A9E"  "rgb(254,138,158)"  "rgba(254,138,158,255)"  "1775C"
#Pnt_1777C             = $8063FA;  $FF8063FA  "#FA6380"  "rgb(250, 99,128)"  "rgba(250, 99,128,255)"  "1777C"
#Pnt_178C              = $5F58FF;  $FF5F58FF  "#FF585F"  "rgb(255, 88, 95)"  "rgba(255, 88, 95,255)"  "178C"
#Pnt_1785C             = $5943F5;  $FF5943F5  "#F54359"  "rgb(245, 67, 89)"  "rgba(245, 67, 89,255)"  "1785C"
#Pnt_1787C             = $5B3FF5;  $FF5B3FF5  "#F53F5B"  "rgb(245, 63, 91)"  "rgba(245, 63, 91,255)"  "1787C"
#Pnt_1788C             = $3928EA;  $FF3928EA  "#EA2839"  "rgb(234, 40, 57)"  "rgba(234, 40, 57,255)"  "1788C"
#Pnt_179C              = $3138DE;  $FF3138DE  "#DE3831"  "rgb(222, 56, 49)"  "rgba(222, 56, 49,255)"  "179C"
#Pnt_1795C             = $2C20CD;  $FF2C20CD  "#CD202C"  "rgb(205, 32, 44)"  "rgba(205, 32, 44,255)"  "1795C"
#Pnt_1797C             = $2E26C4;  $FF2E26C4  "#C4262E"  "rgb(196, 38, 46)"  "rgba(196, 38, 46,255)"  "1797C"
#Pnt_180C              = $3236BD;  $FF3236BD  "#BD3632"  "rgb(189, 54, 50)"  "rgba(189, 54, 50,255)"  "180C"
#Pnt_1805C             = $2F27AA;  $FF2F27AA  "#AA272F"  "rgb(170, 39, 47)"  "rgba(170, 39, 47,255)"  "1805C"
#Pnt_1807C             = $39309E;  $FF39309E  "#9E3039"  "rgb(158, 48, 57)"  "rgba(158, 48, 57,255)"  "1807C"
#Pnt_181C              = $27297B;  $FF27297B  "#7B2927"  "rgb(123, 41, 39)"  "rgba(123, 41, 39,255)"  "181C"
#Pnt_1815C             = $272378;  $FF272378  "#782327"  "rgb(120, 35, 39)"  "rgba(120, 35, 39,255)"  "1815C"
#Pnt_1817C             = $32305E;  $FF32305E  "#5E3032"  "rgb( 94, 48, 50)"  "rgba( 94, 48, 50,255)"  "1817C"
#Pnt_182C              = $CABBF9;  $FFCABBF9  "#F9BBCA"  "rgb(249,187,202)"  "rgba(249,187,202,255)"  "182C"
#Pnt_183C              = $AB93FA;  $FFAB93FA  "#FA93AB"  "rgb(250,147,171)"  "rgba(250,147,171,255)"  "183C"
#Pnt_184C              = $7A58F4;  $FF7A58F4  "#F4587A"  "rgb(244, 88,122)"  "rgba(244, 88,122,255)"  "184C"
#Pnt_185C              = $3400E0;  $FF3400E0  "#E00034"  "rgb(224,  0, 52)"  "rgba(224,  0, 52,255)"  "185C"
#Pnt_186C              = $300CC6;  $FF300CC6  "#C60C30"  "rgb(198, 12, 48)"  "rgba(198, 12, 48,255)"  "186C"
#Pnt_187C              = $3019A7;  $FF3019A7  "#A71930"  "rgb(167, 25, 48)"  "rgba(167, 25, 48,255)"  "187C"
#Pnt_188C              = $322477;  $FF322477  "#772432"  "rgb(119, 36, 50)"  "rgba(119, 36, 50,255)"  "188C"
#Pnt_189C              = $BBA3F6;  $FFBBA3F6  "#F6A3BB"  "rgb(246,163,187)"  "rgba(246,163,187,255)"  "189C"
#Pnt_1895C             = $CEBBF3;  $FFCEBBF3  "#F3BBCE"  "rgb(243,187,206)"  "rgba(243,187,206,255)"  "1895C"
#Pnt_190C              = $9B78F3;  $FF9B78F3  "#F3789B"  "rgb(243,120,155)"  "rgba(243,120,155,255)"  "190C"
#Pnt_1905C             = $BC9EF3;  $FFBC9EF3  "#F39EBC"  "rgb(243,158,188)"  "rgba(243,158,188,255)"  "1905C"
#Pnt_191C              = $7143EC;  $FF7143EC  "#EC4371"  "rgb(236, 67,113)"  "rgba(236, 67,113,255)"  "191C"
#Pnt_1915C             = $8450EA;  $FF8450EA  "#EA5084"  "rgb(234, 80,132)"  "rgba(234, 80,132,255)"  "1915C"
#Pnt_192C              = $490EE1;  $FF490EE1  "#E10E49"  "rgb(225, 14, 73)"  "rgba(225, 14, 73,255)"  "192C"
#Pnt_1925C             = $5104DC;  $FF5104DC  "#DC0451"  "rgb(220,  4, 81)"  "rgba(220,  4, 81,255)"  "1925C"
#Pnt_193C              = $3E13BB;  $FF3E13BB  "#BB133E"  "rgb(187, 19, 62)"  "rgba(187, 19, 62,255)"  "193C"
#Pnt_1935C             = $4500C3;  $FF4500C3  "#C30045"  "rgb(195,  0, 69)"  "rgba(195,  0, 69,255)"  "1935C"
#Pnt_194C              = $3F2397;  $FF3F2397  "#97233F"  "rgb(151, 35, 63)"  "rgba(151, 35, 63,255)"  "194C"
#Pnt_1945C             = $4011A5;  $FF4011A5  "#A51140"  "rgb(165, 17, 64)"  "rgba(165, 17, 64,255)"  "1945C"
#Pnt_195C              = $413177;  $FF413177  "#773141"  "rgb(119, 49, 65)"  "rgba(119, 49, 65,255)"  "195C"
#Pnt_1955C             = $3D1B8D;  $FF3D1B8D  "#8D1B3D"  "rgb(141, 27, 61)"  "rgba(141, 27, 61,255)"  "1955C"
#Pnt_196C              = $CBC5E9;  $FFCBC5E9  "#E9C5CB"  "rgb(233,197,203)"  "rgba(233,197,203,255)"  "196C"
#Pnt_197C              = $AA9AE5;  $FFAA9AE5  "#E59AAA"  "rgb(229,154,170)"  "rgba(229,154,170,255)"  "197C"
#Pnt_198C              = $694DDB;  $FF694DDB  "#DB4D69"  "rgb(219, 77,105)"  "rgba(219, 77,105,255)"  "198C"
#Pnt_199C              = $3A10D0;  $FF3A10D0  "#D0103A"  "rgb(208, 16, 58)"  "rgba(208, 16, 58,255)"  "199C"
#Pnt_200C              = $3412B7;  $FF3412B7  "#B71234"  "rgb(183, 18, 52)"  "rgba(183, 18, 52,255)"  "200C"
#Pnt_201C              = $321E98;  $FF321E98  "#981E32"  "rgb(152, 30, 50)"  "rgba(152, 30, 50,255)"  "201C"
#Pnt_202C              = $332482;  $FF332482  "#822433"  "rgb(130, 36, 51)"  "rgba(130, 36, 51,255)"  "202C"
#Pnt_203C              = $C6AEE7;  $FFC6AEE7  "#E7AEC6"  "rgb(231,174,198)"  "rgba(231,174,198,255)"  "203C"
#Pnt_204C              = $A67EE2;  $FFA67EE2  "#E27EA6"  "rgb(226,126,166)"  "rgba(226,126,166,255)"  "204C"
#Pnt_205C              = $7E48DA;  $FF7E48DA  "#DA487E"  "rgb(218, 72,126)"  "rgba(218, 72,126,255)"  "205C"
#Pnt_206C              = $4400CB;  $FF4400CB  "#CB0044"  "rgb(203,  0, 68)"  "rgba(203,  0, 68,255)"  "206C"
#Pnt_207C              = $4002A7;  $FF4002A7  "#A70240"  "rgb(167,  2, 64)"  "rgba(167,  2, 64,255)"  "207C"
#Pnt_208C              = $452388;  $FF452388  "#882345"  "rgb(136, 35, 69)"  "rgba(136, 35, 69,255)"  "208C"
#Pnt_209C              = $3D276E;  $FF3D276E  "#6E273D"  "rgb(110, 39, 61)"  "rgba(110, 39, 61,255)"  "209C"
#Pnt_210C              = $CAA1F9;  $FFCAA1F9  "#F9A1CA"  "rgb(249,161,202)"  "rgba(249,161,202,255)"  "210C"
#Pnt_211C              = $B47AF7;  $FFB47AF7  "#F77AB4"  "rgb(247,122,180)"  "rgba(247,122,180,255)"  "211C"
#Pnt_212C              = $984DF0;  $FF984DF0  "#F04D98"  "rgb(240, 77,152)"  "rgba(240, 77,152,255)"  "212C"
#Pnt_213C              = $7617E2;  $FF7617E2  "#E21776"  "rgb(226, 23,118)"  "rgba(226, 23,118,255)"  "213C"
#Pnt_214C              = $6200C9;  $FF6200C9  "#C90062"  "rgb(201,  0, 98)"  "rgba(201,  0, 98,255)"  "214C"
#Pnt_215C              = $5610A7;  $FF5610A7  "#A71056"  "rgb(167, 16, 86)"  "rgba(167, 16, 86,255)"  "215C"
#Pnt_216C              = $48237C;  $FF48237C  "#7C2348"  "rgb(124, 35, 72)"  "rgba(124, 35, 72,255)"  "216C"
#Pnt_217C              = $D8BDEA;  $FFD8BDEA  "#EABDD8"  "rgb(234,189,216)"  "rgba(234,189,216,255)"  "217C"
#Pnt_218C              = $B26EE2;  $FFB26EE2  "#E26EB2"  "rgb(226,110,178)"  "rgba(226,110,178,255)"  "218C"
#Pnt_219C              = $851FD7;  $FF851FD7  "#D71F85"  "rgb(215, 31,133)"  "rgba(215, 31,133,255)"  "219C"
#Pnt_220C              = $5000A3;  $FF5000A3  "#A30050"  "rgb(163,  0, 80)"  "rgba(163,  0, 80,255)"  "220C"
#Pnt_221C              = $4B0091;  $FF4B0091  "#91004B"  "rgb(145,  0, 75)"  "rgba(145,  0, 75,255)"  "221C"
#Pnt_222C              = $411A6A;  $FF411A6A  "#6A1A41"  "rgb(106, 26, 65)"  "rgba(106, 26, 65,255)"  "222C"
#Pnt_223C              = $CD92F0;  $FFCD92F0  "#F092CD"  "rgb(240,146,205)"  "rgba(240,146,205,255)"  "223C"
#Pnt_224C              = $B967EB;  $FFB967EB  "#EB67B9"  "rgb(235,103,185)"  "rgba(235,103,185,255)"  "224C"
#Pnt_225C              = $9A24E0;  $FF9A24E0  "#E0249A"  "rgb(224, 36,154)"  "rgba(224, 36,154,255)"  "225C"
#Pnt_226C              = $7200CF;  $FF7200CF  "#CF0072"  "rgb(207,  0,114)"  "rgba(207,  0,114,255)"  "226C"
#Pnt_227C              = $6100A9;  $FF6100A9  "#A90061"  "rgb(169,  0, 97)"  "rgba(169,  0, 97,255)"  "227C"
#Pnt_228C              = $510083;  $FF510083  "#830051"  "rgb(131,  0, 81)"  "rgba(131,  0, 81,255)"  "228C"
#Pnt_229C              = $462066;  $FF462066  "#662046"  "rgb(102, 32, 70)"  "rgba(102, 32, 70,255)"  "229C"
#Pnt_230C              = $D5A3F7;  $FFD5A3F7  "#F7A3D5"  "rgb(247,163,213)"  "rgba(247,163,213,255)"  "230C"
#Pnt_231C              = $C675F3;  $FFC675F3  "#F375C6"  "rgb(243,117,198)"  "rgba(243,117,198,255)"  "231C"
#Pnt_232C              = $AE3BEA;  $FFAE3BEA  "#EA3BAE"  "rgb(234, 59,174)"  "rgba(234, 59,174,255)"  "232C"
#Pnt_233C              = $8400C5;  $FF8400C5  "#C50084"  "rgb(197,  0,132)"  "rgba(197,  0,132,255)"  "233C"
#Pnt_234C              = $6B00A1;  $FF6B00A1  "#A1006B"  "rgb(161,  0,107)"  "rgba(161,  0,107,255)"  "234C"
#Pnt_235C              = $570085;  $FF570085  "#850057"  "rgb(133,  0, 87)"  "rgba(133,  0, 87,255)"  "235C"
#Pnt_236C              = $DEADF3;  $FFDEADF3  "#F3ADDE"  "rgb(243,173,222)"  "rgba(243,173,222,255)"  "236C"
#Pnt_2365C             = $E1C2EF;  $FFE1C2EF  "#EFC2E1"  "rgb(239,194,225)"  "rgba(239,194,225,255)"  "2365C"
#Pnt_237C              = $D38BEF;  $FFD38BEF  "#EF8BD3"  "rgb(239,139,211)"  "rgba(239,139,211,255)"  "237C"
#Pnt_2375C             = $C970E1;  $FFC970E1  "#E170C9"  "rgb(225,112,201)"  "rgba(225,112,201,255)"  "2375C"
#Pnt_238C              = $BF5BE4;  $FFBF5BE4  "#E45BBF"  "rgb(228, 91,191)"  "rgba(228, 91,191,255)"  "238C"
#Pnt_2385C             = $B12DD1;  $FFB12DD1  "#D12DB1"  "rgb(209, 45,177)"  "rgba(209, 45,177,255)"  "2385C"
#Pnt_239C              = $AF39DA;  $FFAF39DA  "#DA39AF"  "rgb(218, 57,175)"  "rgba(218, 57,175,255)"  "239C"
#Pnt_2395C             = $9E00C3;  $FF9E00C3  "#C3009E"  "rgb(195,  0,158)"  "rgba(195,  0,158,255)"  "2395C"
#Pnt_240C              = $9622BF;  $FF9622BF  "#BF2296"  "rgb(191, 34,150)"  "rgba(191, 34,150,255)"  "240C"
#Pnt_2405C             = $8400A4;  $FF8400A4  "#A40084"  "rgb(164,  0,132)"  "rgba(164,  0,132,255)"  "2405C"
#Pnt_241C              = $7E1AA3;  $FF7E1AA3  "#A31A7E"  "rgb(163, 26,126)"  "rgba(163, 26,126,255)"  "241C"
#Pnt_2415C             = $750092;  $FF750092  "#920075"  "rgb(146,  0,117)"  "rgba(146,  0,117,255)"  "2415C"
#Pnt_242C              = $592077;  $FF592077  "#772059"  "rgb(119, 32, 89)"  "rgba(119, 32, 89,255)"  "242C"
#Pnt_2425C             = $63007D;  $FF63007D  "#7D0063"  "rgb(125,  0, 99)"  "rgba(125,  0, 99,255)"  "2425C"
#Pnt_243C              = $E3BCEB;  $FFE3BCEB  "#EBBCE3"  "rgb(235,188,227)"  "rgba(235,188,227,255)"  "243C"
#Pnt_244C              = $DB9FE5;  $FFDB9FE5  "#E59FDB"  "rgb(229,159,219)"  "rgba(229,159,219,255)"  "244C"
#Pnt_245C              = $D381DE;  $FFD381DE  "#DE81D3"  "rgb(222,129,211)"  "rgba(222,129,211,255)"  "245C"
#Pnt_246C              = $AC1DC2;  $FFAC1DC2  "#C21DAC"  "rgb(194, 29,172)"  "rgba(194, 29,172,255)"  "246C"
#Pnt_247C              = $9D05B1;  $FF9D05B1  "#B1059D"  "rgb(177,  5,157)"  "rgba(177,  5,157,255)"  "247C"
#Pnt_248C              = $89189B;  $FF89189B  "#9B1889"  "rgb(155, 24,137)"  "rgba(155, 24,137,255)"  "248C"
#Pnt_249C              = $642875;  $FF642875  "#752864"  "rgb(117, 40,100)"  "rgba(117, 40,100,255)"  "249C"
#Pnt_250C              = $E3C1E7;  $FFE3C1E7  "#E7C1E3"  "rgb(231,193,227)"  "rgba(231,193,227,255)"  "250C"
#Pnt_251C              = $DD9DDC;  $FFDD9DDC  "#DC9DDD"  "rgb(220,157,221)"  "rgba(220,157,221,255)"  "251C"
#Pnt_252C              = $CD66C9;  $FFCD66C9  "#C966CD"  "rgb(201,102,205)"  "rgba(201,102,205,255)"  "252C"
#Pnt_253C              = $AA26A6;  $FFAA26A6  "#A626AA"  "rgb(166, 38,170)"  "rgba(166, 38,170,255)"  "253C"
#Pnt_254C              = $982D95;  $FF982D95  "#952D98"  "rgb(149, 45,152)"  "rgba(149, 45,152,255)"  "254C"
#Pnt_255C              = $6B2C6E;  $FF6B2C6E  "#6E2C6B"  "rgb(110, 44,107)"  "rgba(110, 44,107,255)"  "255C"
#Pnt_256C              = $DFC7DC;  $FFDFC7DC  "#DCC7DF"  "rgb(220,199,223)"  "rgba(220,199,223,255)"  "256C"
#Pnt_2562C             = $E2AAD4;  $FFE2AAD4  "#D4AAE2"  "rgb(212,170,226)"  "rgba(212,170,226,255)"  "2562C"
#Pnt_2563C             = $D7A5C9;  $FFD7A5C9  "#C9A5D7"  "rgb(201,165,215)"  "rgba(201,165,215,255)"  "2563C"
#Pnt_2567C             = $D69DBB;  $FFD69DBB  "#BB9DD6"  "rgb(187,157,214)"  "rgba(187,157,214,255)"  "2567C"
#Pnt_257C              = $D2A8CB;  $FFD2A8CB  "#CBA8D2"  "rgb(203,168,210)"  "rgba(203,168,210,255)"  "257C"
#Pnt_2572C             = $DA8BC4;  $FFDA8BC4  "#C48BDA"  "rgb(196,139,218)"  "rgba(196,139,218,255)"  "2572C"
#Pnt_2573C             = $C782B3;  $FFC782B3  "#B382C7"  "rgb(179,130,199)"  "rgba(179,130,199,255)"  "2573C"
#Pnt_2577C             = $C97CA4;  $FFC97CA4  "#A47CC9"  "rgb(164,124,201)"  "rgba(164,124,201,255)"  "2577C"
#Pnt_258C              = $9E5093;  $FF9E5093  "#93509E"  "rgb(147, 80,158)"  "rgba(147, 80,158,255)"  "258C"
#Pnt_2582C             = $C44DA4;  $FFC44DA4  "#A44DC4"  "rgb(164, 77,196)"  "rgba(164, 77,196,255)"  "2582C"
#Pnt_2583C             = $B55F9C;  $FFB55F9C  "#9C5FB5"  "rgb(156, 95,181)"  "rgba(156, 95,181,255)"  "2583C"
#Pnt_2587C             = $B04B82;  $FFB04B82  "#824BB0"  "rgb(130, 75,176)"  "rgba(130, 75,176,255)"  "2587C"
#Pnt_259C              = $7B266E;  $FF7B266E  "#6E267B"  "rgb(110, 38,123)"  "rgba(110, 38,123,255)"  "259C"
#Pnt_2592C             = $B3238F;  $FFB3238F  "#8F23B3"  "rgb(143, 35,179)"  "rgba(143, 35,179,255)"  "2592C"
#Pnt_2593C             = $9B3780;  $FF9B3780  "#80379B"  "rgb(128, 55,155)"  "rgba(128, 55,155,255)"  "2593C"
#Pnt_2597C             = $8C0657;  $FF8C0657  "#57068C"  "rgb( 87,  6,140)"  "rgba( 87,  6,140,255)"  "2597C"
#Pnt_260C              = $672562;  $FF672562  "#622567"  "rgb( 98, 37,103)"  "rgba( 98, 37,103,255)"  "260C"
#Pnt_2602C             = $9A107C;  $FF9A107C  "#7C109A"  "rgb(124, 16,154)"  "rgba(124, 16,154,255)"  "2602C"
#Pnt_2603C             = $85256E;  $FF85256E  "#6E2585"  "rgb(110, 37,133)"  "rgba(110, 37,133,255)"  "2603C"
#Pnt_2607C             = $7B0B4F;  $FF7B0B4F  "#4F0B7B"  "rgb( 79, 11,123)"  "rgba( 79, 11,123,255)"  "2607C"
#Pnt_261C              = $5A245A;  $FF5A245A  "#5A245A"  "rgb( 90, 36, 90)"  "rgba( 90, 36, 90,255)"  "261C"
#Pnt_2612C             = $7C1F6B;  $FF7C1F6B  "#6B1F7C"  "rgb(107, 31,124)"  "rgba(107, 31,124,255)"  "2612C"
#Pnt_2613C             = $761D63;  $FF761D63  "#631D76"  "rgb( 99, 29,118)"  "rgba( 99, 29,118,255)"  "2613C"
#Pnt_2617C             = $6F0E49;  $FF6F0E49  "#490E6F"  "rgb( 73, 14,111)"  "rgba( 73, 14,111,255)"  "2617C"
#Pnt_262C              = $4F2853;  $FF4F2853  "#53284F"  "rgb( 83, 40, 79)"  "rgba( 83, 40, 79,255)"  "262C"
#Pnt_2622C             = $612D5E;  $FF612D5E  "#5E2D61"  "rgb( 94, 45, 97)"  "rgba( 94, 45, 97,255)"  "2622C"
#Pnt_2623C             = $691F5B;  $FF691F5B  "#5B1F69"  "rgb( 91, 31,105)"  "rgba( 91, 31,105,255)"  "2623C"
#Pnt_2627C             = $5F1442;  $FF5F1442  "#42145F"  "rgb( 66, 20, 95)"  "rgba( 66, 20, 95,255)"  "2627C"
#Pnt_263C              = $E9CFDB;  $FFE9CFDB  "#DBCFE9"  "rgb(219,207,233)"  "rgba(219,207,233,255)"  "263C"
#Pnt_2635C             = $E3B9C5;  $FFE3B9C5  "#C5B9E3"  "rgb(197,185,227)"  "rgba(197,185,227,255)"  "2635C"
#Pnt_264C              = $E5AFC1;  $FFE5AFC1  "#C1AFE5"  "rgb(193,175,229)"  "rgba(193,175,229,255)"  "264C"
#Pnt_2645C             = $DB98AC;  $FFDB98AC  "#AC98DB"  "rgb(172,152,219)"  "rgba(172,152,219,255)"  "2645C"
#Pnt_265C              = $D06C8C;  $FFD06C8C  "#8C6CD0"  "rgb(140,108,208)"  "rgba(140,108,208,255)"  "265C"
#Pnt_2655C             = $D17892;  $FFD17892  "#9278D1"  "rgb(146,120,209)"  "rgba(146,120,209,255)"  "2655C"
#Pnt_266C              = $B73966;  $FFB73966  "#6639B7"  "rgb(102, 57,183)"  "rgba(102, 57,183,255)"  "266C"
#Pnt_2665C             = $C65C7D;  $FFC65C7D  "#7D5CC6"  "rgb(125, 92,198)"  "rgba(125, 92,198,255)"  "2665C"
#Pnt_267C              = $982352;  $FF982352  "#522398"  "rgb( 82, 35,152)"  "rgba( 82, 35,152,255)"  "267C"
#Pnt_268C              = $7F2D4F;  $FF7F2D4F  "#4F2D7F"  "rgb( 79, 45,127)"  "rgba( 79, 45,127,255)"  "268C"
#Pnt_2685C             = $83003B;  $FF83003B  "#3B0083"  "rgb( 59,  0,131)"  "rgba( 59,  0,131,255)"  "2685C"
#Pnt_269C              = $6A304B;  $FF6A304B  "#4B306A"  "rgb( 75, 48,106)"  "rgba( 75, 48,106,255)"  "269C"
#Pnt_2695C             = $541C33;  $FF541C33  "#331C54"  "rgb( 51, 28, 84)"  "rgba( 51, 28, 84,255)"  "2695C"
#Pnt_270C              = $DDB6B3;  $FFDDB6B3  "#B3B6DD"  "rgb(179,182,221)"  "rgba(179,182,221,255)"  "270C"
#Pnt_2705C             = $DFA4A5;  $FFDFA4A5  "#A5A4DF"  "rgb(165,164,223)"  "rgba(165,164,223,255)"  "2705C"
#Pnt_2706C             = $E7D1CA;  $FFE7D1CA  "#CAD1E7"  "rgb(202,209,231)"  "rgba(202,209,231,255)"  "2706C"
#Pnt_2707C             = $EBD7C5;  $FFEBD7C5  "#C5D7EB"  "rgb(197,215,235)"  "rgba(197,215,235,255)"  "2707C"
#Pnt_2708C             = $E6C8B3;  $FFE6C8B3  "#B3C8E6"  "rgb(179,200,230)"  "rgba(179,200,230,255)"  "2708C"
#Pnt_271C              = $CE9390;  $FFCE9390  "#9093CE"  "rgb(144,147,206)"  "rgba(144,147,206,255)"  "271C"
#Pnt_2715C             = $D58488;  $FFD58488  "#8884D5"  "rgb(136,132,213)"  "rgba(136,132,213,255)"  "2715C"
#Pnt_2716C             = $E2AB9D;  $FFE2AB9D  "#9DABE2"  "rgb(157,171,226)"  "rgba(157,171,226,255)"  "2716C"
#Pnt_2717C             = $EBC5A8;  $FFEBC5A8  "#A8C5EB"  "rgb(168,197,235)"  "rgba(168,197,235,255)"  "2717C"
#Pnt_2718C             = $D7855A;  $FFD7855A  "#5A85D7"  "rgb( 90,133,215)"  "rgba( 90,133,215,255)"  "2718C"
#Pnt_272C              = $C07775;  $FFC07775  "#7577C0"  "rgb(117,119,192)"  "rgba(117,119,192,255)"  "272C"
#Pnt_2725C             = $C45964;  $FFC45964  "#6459C4"  "rgb(100, 89,196)"  "rgba(100, 89,196,255)"  "2725C"
#Pnt_2726C             = $C55C4C;  $FFC55C4C  "#4C5CC5"  "rgb( 76, 92,197)"  "rgba( 76, 92,197,255)"  "2726C"
#Pnt_2727C             = $DB7E3D;  $FFDB7E3D  "#3D7EDB"  "rgb( 61,126,219)"  "rgba( 61,126,219,255)"  "2727C"
#Pnt_2728C             = $BC4D0F;  $FFBC4D0F  "#0F4DBC"  "rgb( 15, 77,188)"  "rgba( 15, 77,188,255)"  "2728C"
#Pnt_273C              = $731724;  $FF731724  "#241773"  "rgb( 36, 23,115)"  "rgba( 36, 23,115,255)"  "273C"
#Pnt_2735C             = $910028;  $FF910028  "#280091"  "rgb( 40,  0,145)"  "rgba( 40,  0,145,255)"  "2735C"
#Pnt_2736C             = $A92625;  $FFA92625  "#2526A9"  "rgb( 37, 38,169)"  "rgba( 37, 38,169,255)"  "2736C"
#Pnt_2738C             = $961B00;  $FF961B00  "#001B96"  "rgb(  0, 27,150)"  "rgba(  0, 27,150,255)"  "2738C"
#Pnt_274C              = $5D141F;  $FF5D141F  "#1F145D"  "rgb( 31, 20, 93)"  "rgba( 31, 20, 93,255)"  "274C"
#Pnt_2745C             = $780024;  $FF780024  "#240078"  "rgb( 36,  0,120)"  "rgba( 36,  0,120,255)"  "2745C"
#Pnt_2746C             = $922421;  $FF922421  "#212492"  "rgb( 33, 36,146)"  "rgba( 33, 36,146,255)"  "2746C"
#Pnt_2747C             = $7A2500;  $FF7A2500  "#00257A"  "rgb(  0, 37,122)"  "rgba(  0, 37,122,255)"  "2747C"
#Pnt_2748C             = $731F03;  $FF731F03  "#031F73"  "rgb(  3, 31,115)"  "rgba(  3, 31,115,255)"  "2748C"
#Pnt_275C              = $56161E;  $FF56161E  "#1E1656"  "rgb( 30, 22, 86)"  "rgba( 30, 22, 86,255)"  "275C"
#Pnt_2755C             = $6A0721;  $FF6A0721  "#21076A"  "rgb( 33,  7,106)"  "rgba( 33,  7,106,255)"  "2755C"
#Pnt_2756C             = $6D201A;  $FF6D201A  "#1A206D"  "rgb( 26, 32,109)"  "rgba( 26, 32,109,255)"  "2756C"
#Pnt_2757C             = $632600;  $FF632600  "#002663"  "rgb(  0, 38, 99)"  "rgba(  0, 38, 99,255)"  "2757C"
#Pnt_2758C             = $65220B;  $FF65220B  "#0B2265"  "rgb( 11, 34,101)"  "rgba( 11, 34,101,255)"  "2758C"
#Pnt_276C              = $3E1C20;  $FF3E1C20  "#201C3E"  "rgb( 32, 28, 62)"  "rgba( 32, 28, 62,255)"  "276C"
#Pnt_2765C             = $520E1C;  $FF520E1C  "#1C0E52"  "rgb( 28, 14, 82)"  "rgba( 28, 14, 82,255)"  "2765C"
#Pnt_2766C             = $55211A;  $FF55211A  "#1A2155"  "rgb( 26, 33, 85)"  "rgba( 26, 33, 85,255)"  "2766C"
#Pnt_2767C             = $492B18;  $FF492B18  "#182B49"  "rgb( 24, 43, 73)"  "rgba( 24, 43, 73,255)"  "2767C"
#Pnt_2768C             = $4B200F;  $FF4B200F  "#0F204B"  "rgb( 15, 32, 75)"  "rgba( 15, 32, 75,255)"  "2768C"
#Pnt_277C              = $E6CAAA;  $FFE6CAAA  "#AACAE6"  "rgb(170,202,230)"  "rgba(170,202,230,255)"  "277C"
#Pnt_278C              = $E5BA8E;  $FFE5BA8E  "#8EBAE5"  "rgb(142,186,229)"  "rgba(142,186,229,255)"  "278C"
#Pnt_279C              = $DB924B;  $FFDB924B  "#4B92DB"  "rgb( 75,146,219)"  "rgba( 75,146,219,255)"  "279C"
#Pnt_280C              = $762700;  $FF762700  "#002776"  "rgb(  0, 39,118)"  "rgba(  0, 39,118,255)"  "280C"
#Pnt_281C              = $642600;  $FF642600  "#002664"  "rgb(  0, 38,100)"  "rgba(  0, 38,100,255)"  "281C"
#Pnt_282C              = $472100;  $FF472100  "#002147"  "rgb(  0, 33, 71)"  "rgba(  0, 33, 71,255)"  "282C"
#Pnt_283C              = $EAC698;  $FFEAC698  "#98C6EA"  "rgb(152,198,234)"  "rgba(152,198,234,255)"  "283C"
#Pnt_284C              = $E4AD6A;  $FFE4AD6A  "#6AADE4"  "rgb(106,173,228)"  "rgba(106,173,228,255)"  "284C"
#Pnt_285C              = $CF7300;  $FFCF7300  "#0073CF"  "rgb(  0,115,207)"  "rgba(  0,115,207,255)"  "285C"
#Pnt_286C              = $A63900;  $FFA63900  "#0039A6"  "rgb(  0, 57,166)"  "rgba(  0, 57,166,255)"  "286C"
#Pnt_287C              = $8D3300;  $FF8D3300  "#00338D"  "rgb(  0, 51,141)"  "rgba(  0, 51,141,255)"  "287C"
#Pnt_288C              = $772C00;  $FF772C00  "#002C77"  "rgb(  0, 44,119)"  "rgba(  0, 44,119,255)"  "288C"
#Pnt_289C              = $442200;  $FF442200  "#002244"  "rgb(  0, 34, 68)"  "rgba(  0, 34, 68,255)"  "289C"
#Pnt_290C              = $EADEC2;  $FFEADEC2  "#C2DEEA"  "rgb(194,222,234)"  "rgba(194,222,234,255)"  "290C"
#Pnt_2905C             = $E7CA8F;  $FFE7CA8F  "#8FCAE7"  "rgb(143,202,231)"  "rgba(143,202,231,255)"  "2905C"
#Pnt_291C              = $EBCFA0;  $FFEBCFA0  "#A0CFEB"  "rgb(160,207,235)"  "rgba(160,207,235,255)"  "291C"
#Pnt_2915C             = $E4B65E;  $FFE4B65E  "#5EB6E4"  "rgb( 94,182,228)"  "rgba( 94,182,228,255)"  "2915C"
#Pnt_292C              = $E5B163;  $FFE5B163  "#63B1E5"  "rgb( 99,177,229)"  "rgba( 99,177,229,255)"  "292C"
#Pnt_2925C             = $DB9800;  $FFDB9800  "#0098DB"  "rgb(  0,152,219)"  "rgba(  0,152,219,255)"  "2925C"
#Pnt_293C              = $AD4600;  $FFAD4600  "#0046AD"  "rgb(  0, 70,173)"  "rgba(  0, 70,173,255)"  "293C"
#Pnt_2935C             = $BB5B00;  $FFBB5B00  "#005BBB"  "rgb(  0, 91,187)"  "rgba(  0, 91,187,255)"  "2935C"
#Pnt_294C              = $783400;  $FF783400  "#003478"  "rgb(  0, 52,120)"  "rgba(  0, 52,120,255)"  "294C"
#Pnt_2945C             = $9F5400;  $FF9F5400  "#00549F"  "rgb(  0, 84,159)"  "rgba(  0, 84,159,255)"  "2945C"
#Pnt_295C              = $5F2F00;  $FF5F2F00  "#002F5F"  "rgb(  0, 47, 95)"  "rgba(  0, 47, 95,255)"  "295C"
#Pnt_2955C             = $693C00;  $FF693C00  "#003C69"  "rgb(  0, 60,105)"  "rgba(  0, 60,105,255)"  "2955C"
#Pnt_296C              = $2F1E03;  $FF2F1E03  "#031E2F"  "rgb(  3, 30, 47)"  "rgba(  3, 30, 47,255)"  "296C"
#Pnt_2965C             = $452B00;  $FF452B00  "#002B45"  "rgb(  0, 43, 69)"  "rgba(  0, 43, 69,255)"  "2965C"
#Pnt_297C              = $E7C772;  $FFE7C772  "#72C7E7"  "rgb(114,199,231)"  "rgba(114,199,231,255)"  "297C"
#Pnt_2975C             = $E8DBA3;  $FFE8DBA3  "#A3DBE8"  "rgb(163,219,232)"  "rgba(163,219,232,255)"  "2975C"
#Pnt_298C              = $E4B73D;  $FFE4B73D  "#3DB7E4"  "rgb( 61,183,228)"  "rgba( 61,183,228,255)"  "298C"
#Pnt_2985C             = $E8C65B;  $FFE8C65B  "#5BC6E8"  "rgb( 91,198,232)"  "rgba( 91,198,232,255)"  "2985C"
#Pnt_299C              = $DEA100;  $FFDEA100  "#00A1DE"  "rgb(  0,161,222)"  "rgba(  0,161,222,255)"  "299C"
#Pnt_2995C             = $E0A900;  $FFE0A900  "#00A9E0"  "rgb(  0,169,224)"  "rgba(  0,169,224,255)"  "2995C"
#Pnt_300C              = $BD6500;  $FFBD6500  "#0065BD"  "rgb(  0,101,189)"  "rgba(  0,101,189,255)"  "300C"
#Pnt_3005C             = $C97A00;  $FFC97A00  "#007AC9"  "rgb(  0,122,201)"  "rgba(  0,122,201,255)"  "3005C"
#Pnt_301C              = $935200;  $FF935200  "#005293"  "rgb(  0, 82,147)"  "rgba(  0, 82,147,255)"  "301C"
#Pnt_3015C             = $A16600;  $FFA16600  "#0066A1"  "rgb(  0,102,161)"  "rgba(  0,102,161,255)"  "3015C"
#Pnt_302C              = $654100;  $FF654100  "#004165"  "rgb(  0, 65,101)"  "rgba(  0, 65,101,255)"  "302C"
#Pnt_3025C             = $725100;  $FF725100  "#005172"  "rgb(  0, 81,114)"  "rgba(  0, 81,114,255)"  "3025C"
#Pnt_303C              = $453100;  $FF453100  "#003145"  "rgb(  0, 49, 69)"  "rgba(  0, 49, 69,255)"  "303C"
#Pnt_3035C             = $534100;  $FF534100  "#004153"  "rgb(  0, 65, 83)"  "rgba(  0, 65, 83,255)"  "3035C"
#Pnt_304C              = $E9DEA1;  $FFE9DEA1  "#A1DEE9"  "rgb(161,222,233)"  "rgba(161,222,233,255)"  "304C"
#Pnt_305C              = $E9CF65;  $FFE9CF65  "#65CFE9"  "rgb(101,207,233)"  "rgba(101,207,233,255)"  "305C"
#Pnt_306C              = $E4B900;  $FFE4B900  "#00B9E4"  "rgb(  0,185,228)"  "rgba(  0,185,228,255)"  "306C"
#Pnt_307C              = $B07500;  $FFB07500  "#0075B0"  "rgb(  0,117,176)"  "rgba(  0,117,176,255)"  "307C"
#Pnt_308C              = $825B00;  $FF825B00  "#005B82"  "rgb(  0, 91,130)"  "rgba(  0, 91,130,255)"  "308C"
#Pnt_309C              = $4C3D00;  $FF4C3D00  "#003D4C"  "rgb(  0, 61, 76)"  "rgba(  0, 61, 76,255)"  "309C"
#Pnt_310C              = $E4D46F;  $FFE4D46F  "#6FD4E4"  "rgb(111,212,228)"  "rgba(111,212,228,255)"  "310C"
#Pnt_3105C             = $E0D671;  $FFE0D671  "#71D6E0"  "rgb(113,214,224)"  "rgba(113,214,224,255)"  "3105C"
#Pnt_311C              = $DEC60C;  $FFDEC60C  "#0CC6DE"  "rgb( 12,198,222)"  "rgba( 12,198,222,255)"  "311C"
#Pnt_3115C             = $D7C600;  $FFD7C600  "#00C6D7"  "rgb(  0,198,215)"  "rgba(  0,198,215,255)"  "3115C"
#Pnt_312C              = $D0AD00;  $FFD0AD00  "#00ADD0"  "rgb(  0,173,208)"  "rgba(  0,173,208,255)"  "312C"
#Pnt_3125C             = $CAB000;  $FFCAB000  "#00B0CA"  "rgb(  0,176,202)"  "rgba(  0,176,202,255)"  "3125C"
#Pnt_313C              = $C39800;  $FFC39800  "#0098C3"  "rgb(  0,152,195)"  "rgba(  0,152,195,255)"  "313C"
#Pnt_3135C             = $B39400;  $FFB39400  "#0094B3"  "rgb(  0,148,179)"  "rgba(  0,148,179,255)"  "3135C"
#Pnt_314C              = $A98300;  $FFA98300  "#0083A9"  "rgb(  0,131,169)"  "rgba(  0,131,169,255)"  "314C"
#Pnt_3145C             = $927C00;  $FF927C00  "#007C92"  "rgb(  0,124,146)"  "rgba(  0,124,146,255)"  "3145C"
#Pnt_315C              = $836900;  $FF836900  "#006983"  "rgb(  0,105,131)"  "rgba(  0,105,131,255)"  "315C"
#Pnt_3155C             = $786700;  $FF786700  "#006778"  "rgb(  0,103,120)"  "rgba(  0,103,120,255)"  "3155C"
#Pnt_316C              = $534900;  $FF534900  "#004953"  "rgb(  0, 73, 83)"  "rgba(  0, 73, 83,255)"  "316C"
#Pnt_3165C             = $5C5000;  $FF5C5000  "#00505C"  "rgb(  0, 80, 92)"  "rgba(  0, 80, 92,255)"  "3165C"
#Pnt_317C              = $E6E7BB;  $FFE6E7BB  "#BBE7E6"  "rgb(187,231,230)"  "rgba(187,231,230,255)"  "317C"
#Pnt_318C              = $E2DF8F;  $FFE2DF8F  "#8FDFE2"  "rgb(143,223,226)"  "rgba(143,223,226,255)"  "318C"
#Pnt_319C              = $D5CF3F;  $FFD5CF3F  "#3FCFD5"  "rgb( 63,207,213)"  "rgba( 63,207,213,255)"  "319C"
#Pnt_320C              = $A69A00;  $FFA69A00  "#009AA6"  "rgb(  0,154,166)"  "rgba(  0,154,166,255)"  "320C"
#Pnt_321C              = $958B00;  $FF958B00  "#008B95"  "rgb(  0,139,149)"  "rgba(  0,139,149,255)"  "321C"
#Pnt_322C              = $7A7400;  $FF7A7400  "#00747A"  "rgb(  0,116,122)"  "rgba(  0,116,122,255)"  "322C"
#Pnt_323C              = $656200;  $FF656200  "#006265"  "rgb(  0, 98,101)"  "rgba(  0, 98,101,255)"  "323C"
#Pnt_324C              = $D9DC9C;  $FFD9DC9C  "#9CDCD9"  "rgb(156,220,217)"  "rgba(156,220,217,255)"  "324C"
#Pnt_3242C             = $D4DC72;  $FFD4DC72  "#72DCD4"  "rgb(114,220,212)"  "rgba(114,220,212,255)"  "3242C"
#Pnt_3245C             = $D3E080;  $FFD3E080  "#80E0D3"  "rgb(128,224,211)"  "rgba(128,224,211,255)"  "3245C"
#Pnt_3248C             = $C5D57F;  $FFC5D57F  "#7FD5C5"  "rgb(127,213,197)"  "rgba(127,213,197,255)"  "3248C"
#Pnt_325C              = $CACE63;  $FFCACE63  "#63CECA"  "rgb( 99,206,202)"  "rgba( 99,206,202,255)"  "325C"
#Pnt_3252C             = $CDD547;  $FFCDD547  "#47D5CD"  "rgb( 71,213,205)"  "rgba( 71,213,205,255)"  "3252C"
#Pnt_3255C             = $C5D63A;  $FFC5D63A  "#3AD6C5"  "rgb( 58,214,197)"  "rgba( 58,214,197,255)"  "3255C"
#Pnt_3258C             = $B5C950;  $FFB5C950  "#50C9B5"  "rgb( 80,201,181)"  "rgba( 80,201,181,255)"  "3258C"
#Pnt_326C              = $A9B200;  $FFA9B200  "#00B2A9"  "rgb(  0,178,169)"  "rgba(  0,178,169,255)"  "326C"
#Pnt_3262C             = $B5C000;  $FFB5C000  "#00C0B5"  "rgb(  0,192,181)"  "rgba(  0,192,181,255)"  "3262C"
#Pnt_3265C             = $B2C700;  $FFB2C700  "#00C7B2"  "rgb(  0,199,178)"  "rgba(  0,199,178,255)"  "3265C"
#Pnt_3268C             = $92B000;  $FF92B000  "#00B092"  "rgb(  0,176,146)"  "rgba(  0,176,146,255)"  "3268C"
#Pnt_327C              = $708700;  $FF708700  "#008770"  "rgb(  0,135,112)"  "rgba(  0,135,112,255)"  "327C"
#Pnt_3272C             = $99A500;  $FF99A500  "#00A599"  "rgb(  0,165,153)"  "rgba(  0,165,153,255)"  "3272C"
#Pnt_3275C             = $99B200;  $FF99B200  "#00B299"  "rgb(  0,178,153)"  "rgba(  0,178,153,255)"  "3275C"
#Pnt_3278C             = $749B00;  $FF749B00  "#009B74"  "rgb(  0,155,116)"  "rgba(  0,155,116,255)"  "3278C"
#Pnt_328C              = $637300;  $FF637300  "#007363"  "rgb(  0,115, 99)"  "rgba(  0,115, 99,255)"  "328C"
#Pnt_3282C             = $7C8700;  $FF7C8700  "#00877C"  "rgb(  0,135,124)"  "rgba(  0,135,124,255)"  "3282C"
#Pnt_3285C             = $819500;  $FF819500  "#009581"  "rgb(  0,149,129)"  "rgba(  0,149,129,255)"  "3285C"
#Pnt_3288C             = $668500;  $FF668500  "#008566"  "rgb(  0,133,102)"  "rgba(  0,133,102,255)"  "3288C"
#Pnt_329C              = $5A6700;  $FF5A6700  "#00675A"  "rgb(  0,103, 90)"  "rgba(  0,103, 90,255)"  "329C"
#Pnt_3292C             = $555D00;  $FF555D00  "#005D55"  "rgb(  0, 93, 85)"  "rgba(  0, 93, 85,255)"  "3292C"
#Pnt_3295C             = $697B00;  $FF697B00  "#007B69"  "rgb(  0,123,105)"  "rgba(  0,123,105,255)"  "3295C"
#Pnt_3298C             = $556D00;  $FF556D00  "#006D55"  "rgb(  0,109, 85)"  "rgba(  0,109, 85,255)"  "3298C"
#Pnt_330C              = $515700;  $FF515700  "#005751"  "rgb(  0, 87, 81)"  "rgba(  0, 87, 81,255)"  "330C"
#Pnt_3302C             = $464D00;  $FF464D00  "#004D46"  "rgb(  0, 77, 70)"  "rgba(  0, 77, 70,255)"  "3302C"
#Pnt_3305C             = $434E02;  $FF434E02  "#024E43"  "rgb(  2, 78, 67)"  "rgba(  2, 78, 67,255)"  "3305C"
#Pnt_3308C             = $384400;  $FF384400  "#004438"  "rgb(  0, 68, 56)"  "rgba(  0, 68, 56,255)"  "3308C"
#Pnt_331C              = $DBE9B0;  $FFDBE9B0  "#B0E9DB"  "rgb(176,233,219)"  "rgba(176,233,219,255)"  "331C"
#Pnt_332C              = $D7E7A1;  $FFD7E7A1  "#A1E7D7"  "rgb(161,231,215)"  "rgba(161,231,215,255)"  "332C"
#Pnt_333C              = $C3DB4B;  $FFC3DB4B  "#4BDBC3"  "rgb( 75,219,195)"  "rgba( 75,219,195,255)"  "333C"
#Pnt_334C              = $769B00;  $FF769B00  "#009B76"  "rgb(  0,155,118)"  "rgba(  0,155,118,255)"  "334C"
#Pnt_335C              = $647F00;  $FF647F00  "#007F64"  "rgb(  0,127,100)"  "rgba(  0,127,100,255)"  "335C"
#Pnt_336C              = $516700;  $FF516700  "#006751"  "rgb(  0,103, 81)"  "rgba(  0,103, 81,255)"  "336C"
#Pnt_337C              = $C6DC9A;  $FFC6DC9A  "#9ADCC6"  "rgb(154,220,198)"  "rgba(154,220,198,255)"  "337C"
#Pnt_3375C             = $C1E281;  $FFC1E281  "#81E2C1"  "rgb(129,226,193)"  "rgba(129,226,193,255)"  "3375C"
#Pnt_338C              = $B6D276;  $FFB6D276  "#76D2B6"  "rgb(118,210,182)"  "rgba(118,210,182,255)"  "338C"
#Pnt_3385C             = $B0DA50;  $FFB0DA50  "#50DAB0"  "rgb( 80,218,176)"  "rgba( 80,218,176,255)"  "3385C"
#Pnt_339C              = $88B500;  $FF88B500  "#00B588"  "rgb(  0,181,136)"  "rgba(  0,181,136,255)"  "339C"
#Pnt_3395C             = $8BC700;  $FF8BC700  "#00C78B"  "rgb(  0,199,139)"  "rgba(  0,199,139,255)"  "3395C"
#Pnt_340C              = $5F9800;  $FF5F9800  "#00985F"  "rgb(  0,152, 95)"  "rgba(  0,152, 95,255)"  "340C"
#Pnt_3405C             = $65AE00;  $FF65AE00  "#00AE65"  "rgb(  0,174,101)"  "rgba(  0,174,101,255)"  "3405C"
#Pnt_341C              = $577D00;  $FF577D00  "#007D57"  "rgb(  0,125, 87)"  "rgba(  0,125, 87,255)"  "341C"
#Pnt_3415C             = $4D7A00;  $FF4D7A00  "#007A4D"  "rgb(  0,122, 77)"  "rgba(  0,122, 77,255)"  "3415C"
#Pnt_342C              = $4D6A00;  $FF4D6A00  "#006A4D"  "rgb(  0,106, 77)"  "rgba(  0,106, 77,255)"  "342C"
#Pnt_3425C             = $436600;  $FF436600  "#006643"  "rgb(  0,102, 67)"  "rgba(  0,102, 67,255)"  "3425C"
#Pnt_343C              = $425603;  $FF425603  "#035642"  "rgb(  3, 86, 66)"  "rgba(  3, 86, 66,255)"  "343C"
#Pnt_3435C             = $314702;  $FF314702  "#024731"  "rgb(  2, 71, 49)"  "rgba(  2, 71, 49,255)"  "3435C"
#Pnt_344C              = $BEDFAA;  $FFBEDFAA  "#AADFBE"  "rgb(170,223,190)"  "rgba(170,223,190,255)"  "344C"
#Pnt_345C              = $AED891;  $FFAED891  "#91D8AE"  "rgb(145,216,174)"  "rgba(145,216,174,255)"  "345C"
#Pnt_346C              = $9BCE72;  $FF9BCE72  "#72CE9B"  "rgb(114,206,155)"  "rgba(114,206,155,255)"  "346C"
#Pnt_347C              = $489B00;  $FF489B00  "#009B48"  "rgb(  0,155, 72)"  "rgba(  0,155, 72,255)"  "347C"
#Pnt_348C              = $428500;  $FF428500  "#008542"  "rgb(  0,133, 66)"  "rgba(  0,133, 66,255)"  "348C"
#Pnt_349C              = $3C6900;  $FF3C6900  "#00693C"  "rgb(  0,105, 60)"  "rgba(  0,105, 60,255)"  "349C"
#Pnt_350C              = $364E28;  $FF364E28  "#284E36"  "rgb( 40, 78, 54)"  "rgba( 40, 78, 54,255)"  "350C"
#Pnt_351C              = $BCE6A6;  $FFBCE6A6  "#A6E6BC"  "rgb(166,230,188)"  "rgba(166,230,188,255)"  "351C"
#Pnt_352C              = $AFE28F;  $FFAFE28F  "#8FE2AF"  "rgb(143,226,175)"  "rgba(143,226,175,255)"  "352C"
#Pnt_353C              = $A6DF7E;  $FFA6DF7E  "#7EDFA6"  "rgb(126,223,166)"  "rgba(126,223,166,255)"  "353C"
#Pnt_354C              = $3FAF00;  $FF3FAF00  "#00AF3F"  "rgb(  0,175, 63)"  "rgba(  0,175, 63,255)"  "354C"
#Pnt_355C              = $3A9B00;  $FF3A9B00  "#009B3A"  "rgb(  0,155, 58)"  "rgba(  0,155, 58,255)"  "355C"
#Pnt_356C              = $347900;  $FF347900  "#007934"  "rgb(  0,121, 52)"  "rgba(  0,121, 52,255)"  "356C"
#Pnt_357C              = $375927;  $FF375927  "#275937"  "rgb( 39, 89, 55)"  "rgba( 39, 89, 55,255)"  "357C"
#Pnt_358C              = $92DCA9;  $FF92DCA9  "#A9DC92"  "rgb(169,220,146)"  "rgba(169,220,146,255)"  "358C"
#Pnt_359C              = $8BDAA1;  $FF8BDAA1  "#A1DA8B"  "rgb(161,218,139)"  "rgba(161,218,139,255)"  "359C"
#Pnt_360C              = $50C261;  $FF50C261  "#61C250"  "rgb( 97,194, 80)"  "rgba( 97,194, 80,255)"  "360C"
#Pnt_361C              = $33B234;  $FF33B234  "#34B233"  "rgb( 52,178, 51)"  "rgba( 52,178, 51,255)"  "361C"
#Pnt_362C              = $359C3F;  $FF359C3F  "#3F9C35"  "rgb( 63,156, 53)"  "rgba( 63,156, 53,255)"  "362C"
#Pnt_363C              = $2E8A3C;  $FF2E8A3C  "#3C8A2E"  "rgb( 60,138, 46)"  "rgba( 60,138, 46,255)"  "363C"
#Pnt_364C              = $307742;  $FF307742  "#427730"  "rgb( 66,119, 48)"  "rgba( 66,119, 48,255)"  "364C"
#Pnt_365C              = $9AE5C8;  $FF9AE5C8  "#C8E59A"  "rgb(200,229,154)"  "rgba(200,229,154,255)"  "365C"
#Pnt_366C              = $8AE1BD;  $FF8AE1BD  "#BDE18A"  "rgb(189,225,138)"  "rgba(189,225,138,255)"  "366C"
#Pnt_367C              = $67D8A5;  $FF67D8A5  "#A5D867"  "rgb(165,216,103)"  "rgba(165,216,103,255)"  "367C"
#Pnt_368C              = $28BE69;  $FF28BE69  "#69BE28"  "rgb(105,190, 40)"  "rgba(105,190, 40,255)"  "368C"
#Pnt_369C              = $18A658;  $FF18A658  "#58A618"  "rgb( 88,166, 24)"  "rgba( 88,166, 24,255)"  "369C"
#Pnt_370C              = $228F5B;  $FF228F5B  "#5B8F22"  "rgb( 91,143, 34)"  "rgba( 91,143, 34,255)"  "370C"
#Pnt_371C              = $2B6853;  $FF2B6853  "#53682B"  "rgb( 83,104, 43)"  "rgba( 83,104, 43,255)"  "371C"
#Pnt_372C              = $9CECD9;  $FF9CECD9  "#D9EC9C"  "rgb(217,236,156)"  "rgba(217,236,156,255)"  "372C"
#Pnt_373C              = $8AEBD0;  $FF8AEBD0  "#D0EB8A"  "rgb(208,235,138)"  "rgba(208,235,138,255)"  "373C"
#Pnt_374C              = $6FE7C3;  $FF6FE7C3  "#C3E76F"  "rgb(195,231,111)"  "rgba(195,231,111,255)"  "374C"
#Pnt_375C              = $00D492;  $FF00D492  "#92D400"  "rgb(146,212,  0)"  "rgba(146,212,  0,255)"  "375C"
#Pnt_376C              = $00B87A;  $FF00B87A  "#7AB800"  "rgb(122,184,  0)"  "rgba(122,184,  0,255)"  "376C"
#Pnt_377C              = $009673;  $FF009673  "#739600"  "rgb(115,150,  0)"  "rgba(115,150,  0,255)"  "377C"
#Pnt_378C              = $1C6055;  $FF1C6055  "#55601C"  "rgb( 85, 96, 28)"  "rgba( 85, 96, 28,255)"  "378C"
#Pnt_379C              = $6EE9E0;  $FF6EE9E0  "#E0E96E"  "rgb(224,233,110)"  "rgba(224,233,110,255)"  "379C"
#Pnt_380C              = $42E3D6;  $FF42E3D6  "#D6E342"  "rgb(214,227, 66)"  "rgba(214,227, 66,255)"  "380C"
#Pnt_381C              = $03DDC9;  $FF03DDC9  "#C9DD03"  "rgb(201,221,  3)"  "rgba(201,221,  3,255)"  "381C"
#Pnt_382C              = $00D6BE;  $FF00D6BE  "#BED600"  "rgb(190,214,  0)"  "rgba(190,214,  0,255)"  "382C"
#Pnt_383C              = $00ADA2;  $FF00ADA2  "#A2AD00"  "rgb(162,173,  0)"  "rgba(162,173,  0,255)"  "383C"
#Pnt_384C              = $00938E;  $FF00938E  "#8E9300"  "rgb(142,147,  0)"  "rgba(142,147,  0,255)"  "384C"
#Pnt_385C              = $206E72;  $FF206E72  "#726E20"  "rgb(114,110, 32)"  "rgba(114,110, 32,255)"  "385C"
#Pnt_386C              = $6FEBE8;  $FF6FEBE8  "#E8EB6F"  "rgb(232,235,111)"  "rgba(232,235,111,255)"  "386C"
#Pnt_387C              = $30E8E0;  $FF30E8E0  "#E0E830"  "rgb(224,232, 48)"  "rgba(224,232, 48,255)"  "387C"
#Pnt_388C              = $06E5D9;  $FF06E5D9  "#D9E506"  "rgb(217,229,  6)"  "rgba(217,229,  6,255)"  "388C"
#Pnt_389C              = $00DCCC;  $FF00DCCC  "#CCDC00"  "rgb(204,220,  0)"  "rgba(204,220,  0,255)"  "389C"
#Pnt_390C              = $00BFB6;  $FF00BFB6  "#B6BF00"  "rgb(182,191,  0)"  "rgba(182,191,  0,255)"  "390C"
#Pnt_391C              = $009A9C;  $FF009A9C  "#9C9A00"  "rgb(156,154,  0)"  "rgba(156,154,  0,255)"  "391C"
#Pnt_392C              = $007A7F;  $FF007A7F  "#7F7A00"  "rgb(127,122,  0)"  "rgba(127,122,  0,255)"  "392C"
#Pnt_393C              = $83ECEE;  $FF83ECEE  "#EEEC83"  "rgb(238,236,131)"  "rgba(238,236,131,255)"  "393C"
#Pnt_3935C             = $72EEF2;  $FF72EEF2  "#F2EE72"  "rgb(242,238,114)"  "rgba(242,238,114,255)"  "3935C"
#Pnt_394C              = $45E9EB;  $FF45E9EB  "#EBE945"  "rgb(235,233, 69)"  "rgba(235,233, 69,255)"  "394C"
#Pnt_3945C             = $00E8F1;  $FF00E8F1  "#F1E800"  "rgb(241,232,  0)"  "rgba(241,232,  0,255)"  "3945C"
#Pnt_395C              = $00E6E7;  $FF00E6E7  "#E7E600"  "rgb(231,230,  0)"  "rgba(231,230,  0,255)"  "395C"
#Pnt_3955C             = $00DFEA;  $FF00DFEA  "#EADF00"  "rgb(234,223,  0)"  "rgba(234,223,  0,255)"  "3955C"
#Pnt_396C              = $00DFDF;  $FF00DFDF  "#DFDF00"  "rgb(223,223,  0)"  "rgba(223,223,  0,255)"  "396C"
#Pnt_3965C             = $00D7E4;  $FF00D7E4  "#E4D700"  "rgb(228,215,  0)"  "rgba(228,215,  0,255)"  "3965C"
#Pnt_397C              = $00BBC1;  $FF00BBC1  "#C1BB00"  "rgb(193,187,  0)"  "rgba(193,187,  0,255)"  "397C"
#Pnt_3975C             = $00A3B5;  $FF00A3B5  "#B5A300"  "rgb(181,163,  0)"  "rgba(181,163,  0,255)"  "3975C"
#Pnt_398C              = $00A4AE;  $FF00A4AE  "#AEA400"  "rgb(174,164,  0)"  "rgba(174,164,  0,255)"  "398C"
#Pnt_3985C             = $008797;  $FF008797  "#978700"  "rgb(151,135,  0)"  "rgba(151,135,  0,255)"  "3985C"
#Pnt_399C              = $00919C;  $FF00919C  "#9C9100"  "rgb(156,145,  0)"  "rgba(156,145,  0,255)"  "399C"
#Pnt_3995C             = $155D69;  $FF155D69  "#695D15"  "rgb(105, 93, 21)"  "rgba(105, 93, 21,255)"  "3995C"
#Pnt_400C              = $BFC7CB;  $FFBFC7CB  "#CBC7BF"  "rgb(203,199,191)"  "rgba(203,199,191,255)"  "400C"
#Pnt_401C              = $A9B1B6;  $FFA9B1B6  "#B6B1A9"  "rgb(182,177,169)"  "rgba(182,177,169,255)"  "401C"
#Pnt_402C              = $9BA3A9;  $FF9BA3A9  "#A9A39B"  "rgb(169,163,155)"  "rgba(169,163,155,255)"  "402C"
#Pnt_403C              = $818B92;  $FF818B92  "#928B81"  "rgb(146,139,129)"  "rgba(146,139,129,255)"  "403C"
#Pnt_404C              = $656F77;  $FF656F77  "#776F65"  "rgb(119,111,101)"  "rgba(119,111,101,255)"  "404C"
#Pnt_405C              = $4F575F;  $FF4F575F  "#5F574F"  "rgb( 95, 87, 79)"  "rgba( 95, 87, 79,255)"  "405C"
#Pnt_406C              = $C0C6CD;  $FFC0C6CD  "#CDC6C0"  "rgb(205,198,192)"  "rgba(205,198,192,255)"  "406C"
#Pnt_407C              = $A6ACB5;  $FFA6ACB5  "#B5ACA6"  "rgb(181,172,166)"  "rgba(181,172,166,255)"  "407C"
#Pnt_408C              = $9197A2;  $FF9197A2  "#A29791"  "rgb(162,151,145)"  "rgba(162,151,145,255)"  "408C"
#Pnt_409C              = $7B818D;  $FF7B818D  "#8D817B"  "rgb(141,129,123)"  "rgba(141,129,123,255)"  "409C"
#Pnt_410C              = $656A76;  $FF656A76  "#766A65"  "rgb(118,106,101)"  "rgba(118,106,101,255)"  "410C"
#Pnt_411C              = $4B4F5D;  $FF4B4F5D  "#5D4F4B"  "rgb( 93, 79, 75)"  "rgba( 93, 79, 75,255)"  "411C"
#Pnt_412C              = $2A2B33;  $FF2A2B33  "#332B2A"  "rgb( 51, 43, 42)"  "rgba( 51, 43, 42,255)"  "412C"
#Pnt_413C              = $BCC6C6;  $FFBCC6C6  "#C6C6BC"  "rgb(198,198,188)"  "rgba(198,198,188,255)"  "413C"
#Pnt_414C              = $A6B1B0;  $FFA6B1B0  "#B0B1A6"  "rgb(176,177,166)"  "rgba(176,177,166,255)"  "414C"
#Pnt_415C              = $8F9A99;  $FF8F9A99  "#999A8F"  "rgb(153,154,143)"  "rgba(153,154,143,255)"  "415C"
#Pnt_416C              = $7A8483;  $FF7A8483  "#83847A"  "rgb(131,132,122)"  "rgba(131,132,122,255)"  "416C"
#Pnt_417C              = $646F6D;  $FF646F6D  "#6D6F64"  "rgb(109,111,100)"  "rgba(109,111,100,255)"  "417C"
#Pnt_418C              = $4F5857;  $FF4F5857  "#57584F"  "rgb( 87, 88, 79)"  "rgba( 87, 88, 79,255)"  "418C"
#Pnt_419C              = $1C1E1C;  $FF1C1E1C  "#1C1E1C"  "rgb( 28, 30, 28)"  "rgba( 28, 30, 28,255)"  "419C"
#Pnt_420C              = $CBCFCE;  $FFCBCFCE  "#CECFCB"  "rgb(206,207,203)"  "rgba(206,207,203,255)"  "420C"
#Pnt_421C              = $B3B6B5;  $FFB3B6B5  "#B5B6B3"  "rgb(181,182,179)"  "rgba(181,182,179,255)"  "421C"
#Pnt_422C              = $A3A4A2;  $FFA3A4A2  "#A2A4A3"  "rgb(162,164,163)"  "rgba(162,164,163,255)"  "422C"
#Pnt_423C              = $8F908E;  $FF8F908E  "#8E908F"  "rgb(142,144,143)"  "rgba(142,144,143,255)"  "423C"
#Pnt_424C              = $706F6C;  $FF706F6C  "#6C6F70"  "rgb(108,111,112)"  "rgba(108,111,112,255)"  "424C"
#Pnt_425C              = $5C5A56;  $FF5C5A56  "#565A5C"  "rgb( 86, 90, 92)"  "rgba( 86, 90, 92,255)"  "425C"
#Pnt_426C              = $1F1D19;  $FF1F1D19  "#191D1F"  "rgb( 25, 29, 31)"  "rgba( 25, 29, 31,255)"  "426C"
#Pnt_427C              = $D3D4D1;  $FFD3D4D1  "#D1D4D3"  "rgb(209,212,211)"  "rgba(209,212,211,255)"  "427C"
#Pnt_428C              = $C8C8C3;  $FFC8C8C3  "#C3C8C8"  "rgb(195,200,200)"  "rgba(195,200,200,255)"  "428C"
#Pnt_429C              = $AFACA5;  $FFAFACA5  "#A5ACAF"  "rgb(165,172,175)"  "rgba(165,172,175,255)"  "429C"
#Pnt_430C              = $8F8A81;  $FF8F8A81  "#818A8F"  "rgb(129,138,143)"  "rgba(129,138,143,255)"  "430C"
#Pnt_431C              = $716A5E;  $FF716A5E  "#5E6A71"  "rgb( 94,106,113)"  "rgba( 94,106,113,255)"  "431C"
#Pnt_432C              = $4A4237;  $FF4A4237  "#37424A"  "rgb( 55, 66, 74)"  "rgba( 55, 66, 74,255)"  "432C"
#Pnt_433C              = $2A241B;  $FF2A241B  "#1B242A"  "rgb( 27, 36, 42)"  "rgba( 27, 36, 42,255)"  "433C"
#Pnt_434C              = $C3C3CF;  $FFC3C3CF  "#CFC3C3"  "rgb(207,195,195)"  "rgba(207,195,195,255)"  "434C"
#Pnt_435C              = $B5B2C2;  $FFB5B2C2  "#C2B2B5"  "rgb(194,178,181)"  "rgba(194,178,181,255)"  "435C"
#Pnt_436C              = $A49FB2;  $FFA49FB2  "#B29FA4"  "rgb(178,159,164)"  "rgba(178,159,164,255)"  "436C"
#Pnt_437C              = $6F6880;  $FF6F6880  "#80686F"  "rgb(128,104,111)"  "rgba(128,104,111,255)"  "437C"
#Pnt_438C              = $403C51;  $FF403C51  "#513C40"  "rgb( 81, 60, 64)"  "rgba( 81, 60, 64,255)"  "438C"
#Pnt_439C              = $323142;  $FF323142  "#423132"  "rgb( 66, 49, 50)"  "rgba( 66, 49, 50,255)"  "439C"
#Pnt_440C              = $262631;  $FF262631  "#312626"  "rgb( 49, 38, 38)"  "rgba( 49, 38, 38,255)"  "440C"
#Pnt_441C              = $C2C5BE;  $FFC2C5BE  "#BEC5C2"  "rgb(190,197,194)"  "rgba(190,197,194,255)"  "441C"
#Pnt_442C              = $B1B2A9;  $FFB1B2A9  "#A9B2B1"  "rgb(169,178,177)"  "rgba(169,178,177,255)"  "442C"
#Pnt_443C              = $9E9D94;  $FF9E9D94  "#949D9E"  "rgb(148,157,158)"  "rgba(148,157,158,255)"  "443C"
#Pnt_444C              = $817F74;  $FF817F74  "#747F81"  "rgb(116,127,129)"  "rgba(116,127,129,255)"  "444C"
#Pnt_445C              = $57534D;  $FF57534D  "#4D5357"  "rgb( 77, 83, 87)"  "rgba( 77, 83, 87,255)"  "445C"
#Pnt_446C              = $454540;  $FF454540  "#404545"  "rgb( 64, 69, 69)"  "rgba( 64, 69, 69,255)"  "446C"
#Pnt_447C              = $353735;  $FF353735  "#353735"  "rgb( 53, 55, 53)"  "rgba( 53, 55, 53,255)"  "447C"
#Pnt_448C              = $2C454B;  $FF2C454B  "#4B452C"  "rgb( 75, 69, 44)"  "rgba( 75, 69, 44,255)"  "448C"
#Pnt_4485C             = $1F495B;  $FF1F495B  "#5B491F"  "rgb( 91, 73, 31)"  "rgba( 91, 73, 31,255)"  "4485C"
#Pnt_449C              = $26474C;  $FF26474C  "#4C4726"  "rgb( 76, 71, 38)"  "rgba( 76, 71, 38,255)"  "449C"
#Pnt_4495C             = $2C6E81;  $FF2C6E81  "#816E2C"  "rgb(129,110, 44)"  "rgba(129,110, 44,255)"  "4495C"
#Pnt_450C              = $254C4F;  $FF254C4F  "#4F4C25"  "rgb( 79, 76, 37)"  "rgba( 79, 76, 37,255)"  "450C"
#Pnt_4505C             = $428698;  $FF428698  "#988642"  "rgb(152,134, 66)"  "rgba(152,134, 66,255)"  "4505C"
#Pnt_451C              = $6E999A;  $FF6E999A  "#9A996E"  "rgb(154,153,110)"  "rgba(154,153,110,255)"  "451C"
#Pnt_4515C             = $6CA7B4;  $FF6CA7B4  "#B4A76C"  "rgb(180,167,108)"  "rgba(180,167,108,255)"  "4515C"
#Pnt_452C              = $8CB3B3;  $FF8CB3B3  "#B3B38C"  "rgb(179,179,140)"  "rgba(179,179,140,255)"  "452C"
#Pnt_4525C             = $89BCC6;  $FF89BCC6  "#C6BC89"  "rgb(198,188,137)"  "rgba(198,188,137,255)"  "4525C"
#Pnt_453C              = $A0C2C2;  $FFA0C2C2  "#C2C2A0"  "rgb(194,194,160)"  "rgba(194,194,160,255)"  "453C"
#Pnt_4535C             = $9DC9D1;  $FF9DC9D1  "#D1C99D"  "rgb(209,201,157)"  "rgba(209,201,157,255)"  "4535C"
#Pnt_454C              = $B4D1D0;  $FFB4D1D0  "#D0D1B4"  "rgb(208,209,180)"  "rgba(208,209,180,255)"  "454C"
#Pnt_4545C             = $B2D6DC;  $FFB2D6DC  "#DCD6B2"  "rgb(220,214,178)"  "rgba(220,214,178,255)"  "4545C"
#Pnt_455C              = $1C5565;  $FF1C5565  "#65551C"  "rgb(101, 85, 28)"  "rgba(101, 85, 28,255)"  "455C"
#Pnt_456C              = $19849A;  $FF19849A  "#9A8419"  "rgb(154,132, 25)"  "rgba(154,132, 25,255)"  "456C"
#Pnt_457C              = $0194B1;  $FF0194B1  "#B19401"  "rgb(177,148,  1)"  "rgba(177,148,  1,255)"  "457C"
#Pnt_458C              = $69CDDD;  $FF69CDDD  "#DDCD69"  "rgb(221,205,105)"  "rgba(221,205,105,255)"  "458C"
#Pnt_459C              = $78D4E2;  $FF78D4E2  "#E2D478"  "rgb(226,212,120)"  "rgba(226,212,120,255)"  "459C"
#Pnt_460C              = $8FDCE6;  $FF8FDCE6  "#E6DC8F"  "rgb(230,220,143)"  "rgba(230,220,143,255)"  "460C"
#Pnt_461C              = $A9E4EA;  $FFA9E4EA  "#EAE4A9"  "rgb(234,228,169)"  "rgba(234,228,169,255)"  "461C"
#Pnt_462C              = $284558;  $FF284558  "#584528"  "rgb( 88, 69, 40)"  "rgba( 88, 69, 40,255)"  "462C"
#Pnt_4625C             = $1B2B51;  $FF1B2B51  "#512B1B"  "rgb( 81, 43, 27)"  "rgba( 81, 43, 27,255)"  "4625C"
#Pnt_463C              = $234D6C;  $FF234D6C  "#6C4D23"  "rgb(108, 77, 35)"  "rgba(108, 77, 35,255)"  "463C"
#Pnt_4635C             = $3A5E93;  $FF3A5E93  "#935E3A"  "rgb(147, 94, 58)"  "rgba(147, 94, 58,255)"  "4635C"
#Pnt_464C              = $265C82;  $FF265C82  "#825C26"  "rgb(130, 92, 38)"  "rgba(130, 92, 38,255)"  "464C"
#Pnt_4645C             = $5B7DAE;  $FF5B7DAE  "#AE7D5B"  "rgb(174,125, 91)"  "rgba(174,125, 91,255)"  "4645C"
#Pnt_465C              = $5D99B3;  $FF5D99B3  "#B3995D"  "rgb(179,153, 93)"  "rgba(179,153, 93,255)"  "465C"
#Pnt_4655C             = $7192BD;  $FF7192BD  "#BD9271"  "rgb(189,146,113)"  "rgba(189,146,113,255)"  "4655C"
#Pnt_466C              = $7FB3C7;  $FF7FB3C7  "#C7B37F"  "rgb(199,179,127)"  "rgba(199,179,127,255)"  "466C"
#Pnt_4665C             = $8CA9CE;  $FF8CA9CE  "#CEA98C"  "rgb(206,169,140)"  "rgba(206,169,140,255)"  "4665C"
#Pnt_467C              = $95C2D2;  $FF95C2D2  "#D2C295"  "rgb(210,194,149)"  "rgba(210,194,149,255)"  "467C"
#Pnt_4675C             = $A8C0DB;  $FFA8C0DB  "#DBC0A8"  "rgb(219,192,168)"  "rgba(219,192,168,255)"  "4675C"
#Pnt_468C              = $AFD3DD;  $FFAFD3DD  "#DDD3AF"  "rgb(221,211,175)"  "rgba(221,211,175,255)"  "468C"
#Pnt_4685C             = $B8CDE2;  $FFB8CDE2  "#E2CDB8"  "rgb(226,205,184)"  "rgba(226,205,184,255)"  "4685C"
#Pnt_469C              = $1D3560;  $FF1D3560  "#60351D"  "rgb( 96, 53, 29)"  "rgba( 96, 53, 29,255)"  "469C"
#Pnt_4695C             = $242D52;  $FF242D52  "#522D24"  "rgb( 82, 45, 36)"  "rgba( 82, 45, 36,255)"  "4695C"
#Pnt_470C              = $24539D;  $FF24539D  "#9D5324"  "rgb(157, 83, 36)"  "rgba(157, 83, 36,255)"  "470C"
#Pnt_4705C             = $394A77;  $FF394A77  "#774A39"  "rgb(119, 74, 57)"  "rgba(119, 74, 57,255)"  "4705C"
#Pnt_471C              = $1A54B2;  $FF1A54B2  "#B2541A"  "rgb(178, 84, 26)"  "rgba(178, 84, 26,255)"  "471C"
#Pnt_4715C             = $5B6D96;  $FF5B6D96  "#966D5B"  "rgb(150,109, 91)"  "rgba(150,109, 91,255)"  "4715C"
#Pnt_472C              = $6C9BE3;  $FF6C9BE3  "#E39B6C"  "rgb(227,155,108)"  "rgba(227,155,108,255)"  "472C"
#Pnt_4725C             = $7688AB;  $FF7688AB  "#AB8876"  "rgb(171,136,118)"  "rgba(171,136,118,255)"  "4725C"
#Pnt_473C              = $9CBEEF;  $FF9CBEEF  "#EFBE9C"  "rgb(239,190,156)"  "rgba(239,190,156,255)"  "473C"
#Pnt_4735C             = $94A4C0;  $FF94A4C0  "#C0A494"  "rgb(192,164,148)"  "rgba(192,164,148,255)"  "4735C"
#Pnt_474C              = $A2C4F1;  $FFA2C4F1  "#F1C4A2"  "rgb(241,196,162)"  "rgba(241,196,162,255)"  "474C"
#Pnt_4745C             = $A7B6CD;  $FFA7B6CD  "#CDB6A7"  "rgb(205,182,167)"  "rgba(205,182,167,255)"  "4745C"
#Pnt_475C              = $AFCDF1;  $FFAFCDF1  "#F1CDAF"  "rgb(241,205,175)"  "rgba(241,205,175,255)"  "475C"
#Pnt_4755C             = $B9C7D8;  $FFB9C7D8  "#D8C7B9"  "rgb(216,199,185)"  "rgba(216,199,185,255)"  "4755C"
#Pnt_476C              = $27334C;  $FF27334C  "#4C3327"  "rgb( 76, 51, 39)"  "rgba( 76, 51, 39,255)"  "476C"
#Pnt_477C              = $26355D;  $FF26355D  "#5D3526"  "rgb( 93, 53, 38)"  "rgba( 93, 53, 38,255)"  "477C"
#Pnt_478C              = $293D70;  $FF293D70  "#703D29"  "rgb(112, 61, 41)"  "rgba(112, 61, 41,255)"  "478C"
#Pnt_479C              = $6581A8;  $FF6581A8  "#A88165"  "rgb(168,129,101)"  "rgba(168,129,101,255)"  "479C"
#Pnt_480C              = $96ACC7;  $FF96ACC7  "#C7AC96"  "rgb(199,172,150)"  "rgba(199,172,150,255)"  "480C"
#Pnt_481C              = $A9BED3;  $FFA9BED3  "#D3BEA9"  "rgb(211,190,169)"  "rgba(211,190,169,255)"  "481C"
#Pnt_482C              = $B5C9DA;  $FFB5C9DA  "#DAC9B5"  "rgb(218,201,181)"  "rgba(218,201,181,255)"  "482C"
#Pnt_483C              = $273367;  $FF273367  "#673327"  "rgb(103, 51, 39)"  "rgba(103, 51, 39,255)"  "483C"
#Pnt_484C              = $223298;  $FF223298  "#983222"  "rgb(152, 50, 34)"  "rgba(152, 50, 34,255)"  "484C"
#Pnt_485C              = $1E2BD5;  $FF1E2BD5  "#D52B1E"  "rgb(213, 43, 30)"  "rgba(213, 43, 30,255)"  "485C"
#Pnt_486C              = $778FE7;  $FF778FE7  "#E78F77"  "rgb(231,143,119)"  "rgba(231,143,119,255)"  "486C"
#Pnt_487C              = $8FA6E9;  $FF8FA6E9  "#E9A68F"  "rgb(233,166,143)"  "rgba(233,166,143,255)"  "487C"
#Pnt_488C              = $A9BDEB;  $FFA9BDEB  "#EBBDA9"  "rgb(235,189,169)"  "rgba(235,189,169,255)"  "488C"
#Pnt_489C              = $B8CAEB;  $FFB8CAEB  "#EBCAB8"  "rgb(235,202,184)"  "rgba(235,202,184,255)"  "489C"
#Pnt_490C              = $2F2B5B;  $FF2F2B5B  "#5B2B2F"  "rgb( 91, 43, 47)"  "rgba( 91, 43, 47,255)"  "490C"
#Pnt_491C              = $373078;  $FF373078  "#783037"  "rgb(120, 48, 55)"  "rgba(120, 48, 55,255)"  "491C"
#Pnt_492C              = $3D348A;  $FF3D348A  "#8A343D"  "rgb(138, 52, 61)"  "rgba(138, 52, 61,255)"  "492C"
#Pnt_493C              = $9683D7;  $FF9683D7  "#D78396"  "rgb(215,131,150)"  "rgba(215,131,150,255)"  "493C"
#Pnt_494C              = $AFA0E5;  $FFAFA0E5  "#E5A0AF"  "rgb(229,160,175)"  "rgba(229,160,175,255)"  "494C"
#Pnt_495C              = $C4B8ED;  $FFC4B8ED  "#EDB8C4"  "rgb(237,184,196)"  "rgba(237,184,196,255)"  "495C"
#Pnt_496C              = $CDC4F0;  $FFCDC4F0  "#F0C4CD"  "rgb(240,196,205)"  "rgba(240,196,205,255)"  "496C"
#Pnt_497C              = $2D2E4E;  $FF2D2E4E  "#4E2E2D"  "rgb( 78, 46, 45)"  "rgba( 78, 46, 45,255)"  "497C"
#Pnt_4975C             = $252345;  $FF252345  "#452325"  "rgb( 69, 35, 37)"  "rgba( 69, 35, 37,255)"  "4975C"
#Pnt_498C              = $353768;  $FF353768  "#683735"  "rgb(104, 55, 53)"  "rgba(104, 55, 53,255)"  "498C"
#Pnt_4985C             = $544C84;  $FF544C84  "#844C54"  "rgb(132, 76, 84)"  "rgba(132, 76, 84,255)"  "4985C"
#Pnt_499C              = $373B75;  $FF373B75  "#753B37"  "rgb(117, 59, 55)"  "rgba(117, 59, 55,255)"  "499C"
#Pnt_4995C             = $70669D;  $FF70669D  "#9D6670"  "rgb(157,102,112)"  "rgba(157,102,112,255)"  "4995C"
#Pnt_500C              = $8F85C5;  $FF8F85C5  "#C5858F"  "rgb(197,133,143)"  "rgba(197,133,143,255)"  "500C"
#Pnt_5005C             = $8C84B6;  $FF8C84B6  "#B6848C"  "rgb(182,132,140)"  "rgba(182,132,140,255)"  "5005C"
#Pnt_501C              = $AEA7DB;  $FFAEA7DB  "#DBA7AE"  "rgb(219,167,174)"  "rgba(219,167,174,255)"  "501C"
#Pnt_5015C             = $ADA7CF;  $FFADA7CF  "#CFA7AD"  "rgb(207,167,173)"  "rgba(207,167,173,255)"  "5015C"
#Pnt_502C              = $C4BFE6;  $FFC4BFE6  "#E6BFC4"  "rgb(230,191,196)"  "rgba(230,191,196,255)"  "502C"
#Pnt_5025C             = $BEBBDA;  $FFBEBBDA  "#DABBBE"  "rgb(218,187,190)"  "rgba(218,187,190,255)"  "5025C"
#Pnt_503C              = $CDCAEA;  $FFCDCAEA  "#EACACD"  "rgb(234,202,205)"  "rgba(234,202,205,255)"  "503C"
#Pnt_5035C             = $CBCAE2;  $FFCBCAE2  "#E2CACB"  "rgb(226,202,203)"  "rgba(226,202,203,255)"  "5035C"
#Pnt_504C              = $352C59;  $FF352C59  "#592C35"  "rgb( 89, 44, 53)"  "rgba( 89, 44, 53,255)"  "504C"
#Pnt_505C              = $3E2C6F;  $FF3E2C6F  "#6F2C3E"  "rgb(111, 44, 62)"  "rgba(111, 44, 62,255)"  "505C"
#Pnt_506C              = $4A3383;  $FF4A3383  "#83334A"  "rgb(131, 51, 74)"  "rgba(131, 51, 74,255)"  "506C"
#Pnt_507C              = $A890D4;  $FFA890D4  "#D490A8"  "rgb(212,144,168)"  "rgba(212,144,168,255)"  "507C"
#Pnt_508C              = $BEABE3;  $FFBEABE3  "#E3ABBE"  "rgb(227,171,190)"  "rgba(227,171,190,255)"  "508C"
#Pnt_509C              = $C7B7E8;  $FFC7B7E8  "#E8B7C7"  "rgb(232,183,199)"  "rgba(232,183,199,255)"  "509C"
#Pnt_510C              = $CCC0EB;  $FFCCC0EB  "#EBC0CC"  "rgb(235,192,204)"  "rgba(235,192,204,255)"  "510C"
#Pnt_511C              = $50275E;  $FF50275E  "#5E2750"  "rgb( 94, 39, 80)"  "rgba( 94, 39, 80,255)"  "511C"
#Pnt_5115C             = $42294B;  $FF42294B  "#4B2942"  "rgb( 75, 41, 66)"  "rgba( 75, 41, 66,255)"  "5115C"
#Pnt_512C              = $6F2177;  $FF6F2177  "#77216F"  "rgb(119, 33,111)"  "rgba(119, 33,111,255)"  "512C"
#Pnt_5125C             = $61406A;  $FF61406A  "#6A4061"  "rgb(106, 64, 97)"  "rgba(106, 64, 97,255)"  "5125C"
#Pnt_513C              = $8D258E;  $FF8D258E  "#8E258D"  "rgb(142, 37,141)"  "rgba(142, 37,141,255)"  "513C"
#Pnt_5135C             = $7F5F86;  $FF7F5F86  "#865F7F"  "rgb(134, 95,127)"  "rgba(134, 95,127,255)"  "5135C"
#Pnt_514C              = $C88AD2;  $FFC88AD2  "#D28AC8"  "rgb(210,138,200)"  "rgba(210,138,200,255)"  "514C"
#Pnt_5145C             = $9A7F9F;  $FF9A7F9F  "#9F7F9A"  "rgb(159,127,154)"  "rgba(159,127,154,255)"  "5145C"
#Pnt_515C              = $D7AAE1;  $FFD7AAE1  "#E1AAD7"  "rgb(225,170,215)"  "rgba(225,170,215,255)"  "515C"
#Pnt_5155C             = $BEACC2;  $FFBEACC2  "#C2ACBE"  "rgb(194,172,190)"  "rgba(194,172,190,255)"  "5155C"
#Pnt_516C              = $DDBCE8;  $FFDDBCE8  "#E8BCDD"  "rgb(232,188,221)"  "rgba(232,188,221,255)"  "516C"
#Pnt_5165C             = $D1C5D5;  $FFD1C5D5  "#D5C5D1"  "rgb(213,197,209)"  "rgba(213,197,209,255)"  "5165C"
#Pnt_517C              = $DFC7EA;  $FFDFC7EA  "#EAC7DF"  "rgb(234,199,223)"  "rgba(234,199,223,255)"  "517C"
#Pnt_5175C             = $D4CCD9;  $FFD4CCD9  "#D9CCD4"  "rgb(217,204,212)"  "rgba(217,204,212,255)"  "5175C"
#Pnt_518C              = $4C324F;  $FF4C324F  "#4F324C"  "rgb( 79, 50, 76)"  "rgba( 79, 50, 76,255)"  "518C"
#Pnt_5185C             = $42324A;  $FF42324A  "#4A3242"  "rgb( 74, 50, 66)"  "rgba( 74, 50, 66,255)"  "5185C"
#Pnt_519C              = $603159;  $FF603159  "#593160"  "rgb( 89, 49, 96)"  "rgba( 89, 49, 96,255)"  "519C"
#Pnt_5195C             = $594464;  $FF594464  "#644459"  "rgb(100, 68, 89)"  "rgba(100, 68, 89,255)"  "5195C"
#Pnt_520C              = $773A69;  $FF773A69  "#693A77"  "rgb(105, 58,119)"  "rgba(105, 58,119,255)"  "520C"
#Pnt_5205C             = $7C6889;  $FF7C6889  "#89687C"  "rgb(137,104,124)"  "rgba(137,104,124,255)"  "5205C"
#Pnt_521C              = $B88AAB;  $FFB88AAB  "#AB8AB8"  "rgb(171,138,184)"  "rgba(171,138,184,255)"  "521C"
#Pnt_5215C             = $A394AF;  $FFA394AF  "#AF94A3"  "rgb(175,148,163)"  "rgba(175,148,163,255)"  "5215C"
#Pnt_522C              = $CAA5BE;  $FFCAA5BE  "#BEA5CA"  "rgb(190,165,202)"  "rgba(190,165,202,255)"  "522C"
#Pnt_5225C             = $B9AFC4;  $FFB9AFC4  "#C4AFB9"  "rgb(196,175,185)"  "rgba(196,175,185,255)"  "5225C"
#Pnt_523C              = $D4B7CC;  $FFD4B7CC  "#CCB7D4"  "rgb(204,183,212)"  "rgba(204,183,212,255)"  "523C"
#Pnt_5235C             = $C8C0D2;  $FFC8C0D2  "#D2C0C8"  "rgb(210,192,200)"  "rgba(210,192,200,255)"  "5235C"
#Pnt_524C              = $DCC8D7;  $FFDCC8D7  "#D7C8DC"  "rgb(215,200,220)"  "rgba(215,200,220,255)"  "524C"
#Pnt_5245C             = $D7D4DF;  $FFD7D4DF  "#DFD4D7"  "rgb(223,212,215)"  "rgba(223,212,215,255)"  "5245C"
#Pnt_525C              = $602E53;  $FF602E53  "#532E60"  "rgb( 83, 46, 96)"  "rgba( 83, 46, 96,255)"  "525C"
#Pnt_5255C             = $452427;  $FF452427  "#272445"  "rgb( 39, 36, 69)"  "rgba( 39, 36, 69,255)"  "5255C"
#Pnt_526C              = $862D65;  $FF862D65  "#652D86"  "rgb(101, 45,134)"  "rgba(101, 45,134,255)"  "526C"
#Pnt_5265C             = $653B40;  $FF653B40  "#403B65"  "rgb( 64, 59,101)"  "rgba( 64, 59,101,255)"  "5265C"
#Pnt_527C              = $A52E72;  $FFA52E72  "#722EA5"  "rgb(114, 46,165)"  "rgba(114, 46,165,255)"  "527C"
#Pnt_5275C             = $7B5155;  $FF7B5155  "#55517B"  "rgb( 85, 81,123)"  "rgba( 85, 81,123,255)"  "5275C"
#Pnt_528C              = $D080AD;  $FFD080AD  "#AD80D0"  "rgb(173,128,208)"  "rgba(173,128,208,255)"  "528C"
#Pnt_5285C             = $A48386;  $FFA48386  "#8683A4"  "rgb(134,131,164)"  "rgba(134,131,164,255)"  "5285C"
#Pnt_529C              = $DCA3C5;  $FFDCA3C5  "#C5A3DC"  "rgb(197,163,220)"  "rgba(197,163,220,255)"  "529C"
#Pnt_5295C             = $C3ADAF;  $FFC3ADAF  "#AFADC3"  "rgb(175,173,195)"  "rgba(175,173,195,255)"  "5295C"
#Pnt_530C              = $E2B8D3;  $FFE2B8D3  "#D3B8E2"  "rgb(211,184,226)"  "rgba(211,184,226,255)"  "530C"
#Pnt_5305C             = $CFBFC0;  $FFCFBFC0  "#C0BFCF"  "rgb(192,191,207)"  "rgba(192,191,207,255)"  "5305C"
#Pnt_531C              = $E4C6DD;  $FFE4C6DD  "#DDC6E4"  "rgb(221,198,228)"  "rgba(221,198,228,255)"  "531C"
#Pnt_5315C             = $DBD3D2;  $FFDBD3D2  "#D2D3DB"  "rgb(210,211,219)"  "rgba(210,211,219,255)"  "5315C"
#Pnt_532C              = $392C29;  $FF392C29  "#292C39"  "rgb( 41, 44, 57)"  "rgba( 41, 44, 57,255)"  "532C"
#Pnt_533C              = $4D3121;  $FF4D3121  "#21314D"  "rgb( 33, 49, 77)"  "rgba( 33, 49, 77,255)"  "533C"
#Pnt_534C              = $6A3F26;  $FF6A3F26  "#263F6A"  "rgb( 38, 63,106)"  "rgba( 38, 63,106,255)"  "534C"
#Pnt_535C              = $BDA292;  $FFBDA292  "#92A2BD"  "rgb(146,162,189)"  "rgba(146,162,189,255)"  "535C"
#Pnt_536C              = $C9B3A4;  $FFC9B3A4  "#A4B3C9"  "rgb(164,179,201)"  "rgba(164,179,201,255)"  "536C"
#Pnt_537C              = $D6C9BE;  $FFD6C9BE  "#BEC9D6"  "rgb(190,201,214)"  "rgba(190,201,214,255)"  "537C"
#Pnt_538C              = $DDD5CE;  $FFDDD5CE  "#CED5DD"  "rgb(206,213,221)"  "rgba(206,213,221,255)"  "538C"
#Pnt_539C              = $422A00;  $FF422A00  "#002A42"  "rgb(  0, 42, 66)"  "rgba(  0, 42, 66,255)"  "539C"
#Pnt_5395C             = $2F2003;  $FF2F2003  "#03202F"  "rgb(  3, 32, 47)"  "rgba(  3, 32, 47,255)"  "5395C"
#Pnt_540C              = $593300;  $FF593300  "#003359"  "rgb(  0, 51, 89)"  "rgba(  0, 51, 89,255)"  "540C"
#Pnt_5405C             = $7D6944;  $FF7D6944  "#44697D"  "rgb( 68,105,125)"  "rgba( 68,105,125,255)"  "5405C"
#Pnt_541C              = $723F00;  $FF723F00  "#003F72"  "rgb(  0, 63,114)"  "rgba(  0, 63,114,255)"  "541C"
#Pnt_5415C             = $927F5C;  $FF927F5C  "#5C7F92"  "rgb( 92,127,146)"  "rgba( 92,127,146,255)"  "5415C"
#Pnt_542C              = $C8A064;  $FFC8A064  "#64A0C8"  "rgb(100,160,200)"  "rgba(100,160,200,255)"  "542C"
#Pnt_5425C             = $AA9A7D;  $FFAA9A7D  "#7D9AAA"  "rgb(125,154,170)"  "rgba(125,154,170,255)"  "5425C"
#Pnt_543C              = $DEC39E;  $FFDEC39E  "#9EC3DE"  "rgb(158,195,222)"  "rgba(158,195,222,255)"  "543C"
#Pnt_5435C             = $C6BCA6;  $FFC6BCA6  "#A6BCC6"  "rgb(166,188,198)"  "rgba(166,188,198,255)"  "5435C"
#Pnt_544C              = $E3D2B7;  $FFE3D2B7  "#B7D2E3"  "rgb(183,210,227)"  "rgba(183,210,227,255)"  "544C"
#Pnt_5445C             = $D0C9B9;  $FFD0C9B9  "#B9C9D0"  "rgb(185,201,208)"  "rgba(185,201,208,255)"  "5445C"
#Pnt_545C              = $E4D9C4;  $FFE4D9C4  "#C4D9E4"  "rgb(196,217,228)"  "rgba(196,217,228,255)"  "545C"
#Pnt_5455C             = $D7D3C6;  $FFD7D3C6  "#C6D3D7"  "rgb(198,211,215)"  "rgba(198,211,215,255)"  "5455C"
#Pnt_546C              = $3B3300;  $FF3B3300  "#00333B"  "rgb(  0, 51, 59)"  "rgba(  0, 51, 59,255)"  "546C"
#Pnt_5463C             = $362D00;  $FF362D00  "#002D36"  "rgb(  0, 45, 54)"  "rgba(  0, 45, 54,255)"  "5463C"
#Pnt_5467C             = $32361C;  $FF32361C  "#1C3632"  "rgb( 28, 54, 50)"  "rgba( 28, 54, 50,255)"  "5467C"
#Pnt_547C              = $463900;  $FF463900  "#003946"  "rgb(  0, 57, 70)"  "rgba(  0, 57, 70,255)"  "547C"
#Pnt_5473C             = $706515;  $FF706515  "#156570"  "rgb( 21,101,112)"  "rgba( 21,101,112,255)"  "5473C"
#Pnt_5477C             = $575D3E;  $FF575D3E  "#3E5D57"  "rgb( 62, 93, 87)"  "rgba( 62, 93, 87,255)"  "5477C"
#Pnt_548C              = $504200;  $FF504200  "#004250"  "rgb(  0, 66, 80)"  "rgba(  0, 66, 80,255)"  "548C"
#Pnt_5483C             = $999158;  $FF999158  "#589199"  "rgb( 88,145,153)"  "rgba( 88,145,153,255)"  "5483C"
#Pnt_5487C             = $777D62;  $FF777D62  "#627D77"  "rgb( 98,125,119)"  "rgba( 98,125,119,255)"  "5487C"
#Pnt_549C              = $AE9C5E;  $FFAE9C5E  "#5E9CAE"  "rgb( 94,156,174)"  "rgba( 94,156,174,255)"  "549C"
#Pnt_5493C             = $B4AF83;  $FFB4AF83  "#83AFB4"  "rgb(131,175,180)"  "rgba(131,175,180,255)"  "5493C"
#Pnt_5497C             = $999F89;  $FF999F89  "#899F99"  "rgb(137,159,153)"  "rgba(137,159,153,255)"  "5497C"
#Pnt_550C              = $C6B88C;  $FFC6B88C  "#8CB8C6"  "rgb(140,184,198)"  "rgba(140,184,198,255)"  "550C"
#Pnt_5503C             = $C2BF99;  $FFC2BF99  "#99BFC2"  "rgb(153,191,194)"  "rgba(153,191,194,255)"  "5503C"
#Pnt_5507C             = $B4B8A7;  $FFB4B8A7  "#A7B8B4"  "rgb(167,184,180)"  "rgba(167,184,180,255)"  "5507C"
#Pnt_551C              = $CFC6A1;  $FFCFC6A1  "#A1C6CF"  "rgb(161,198,207)"  "rgba(161,198,207,255)"  "551C"
#Pnt_5513C             = $D1D0B5;  $FFD1D0B5  "#B5D0D1"  "rgb(181,208,209)"  "rgba(181,208,209,255)"  "5513C"
#Pnt_5517C             = $C3C7BA;  $FFC3C7BA  "#BAC7C3"  "rgb(186,199,195)"  "rgba(186,199,195,255)"  "5517C"
#Pnt_552C              = $DBD6BE;  $FFDBD6BE  "#BED6DB"  "rgb(190,214,219)"  "rgba(190,214,219,255)"  "552C"
#Pnt_5523C             = $D7D9C3;  $FFD7D9C3  "#C3D9D7"  "rgb(195,217,215)"  "rgba(195,217,215,255)"  "5523C"
#Pnt_5527C             = $D0D4C9;  $FFD0D4C9  "#C9D4D0"  "rgb(201,212,208)"  "rgba(201,212,208,255)"  "5527C"
#Pnt_553C              = $324321;  $FF324321  "#214332"  "rgb( 33, 67, 50)"  "rgba( 33, 67, 50,255)"  "553C"
#Pnt_5535C             = $313720;  $FF313720  "#203731"  "rgb( 32, 55, 49)"  "rgba( 32, 55, 49,255)"  "5535C"
#Pnt_554C              = $425C1D;  $FF425C1D  "#1D5C42"  "rgb( 29, 92, 66)"  "rgba( 29, 92, 66,255)"  "554C"
#Pnt_5545C             = $606C49;  $FF606C49  "#496C60"  "rgb( 73,108, 96)"  "rgba( 73,108, 96,255)"  "5545C"
#Pnt_555C              = $496C20;  $FF496C20  "#206C49"  "rgb( 32,108, 73)"  "rgba( 32,108, 73,255)"  "555C"
#Pnt_5555C             = $7F8A6A;  $FF7F8A6A  "#6A8A7F"  "rgb(106,138,127)"  "rgba(106,138,127,255)"  "5555C"
#Pnt_556C              = $89A470;  $FF89A470  "#70A489"  "rgb(112,164,137)"  "rgba(112,164,137,255)"  "556C"
#Pnt_5565C             = $9CA68B;  $FF9CA68B  "#8BA69C"  "rgb(139,166,156)"  "rgba(139,166,156,255)"  "5565C"
#Pnt_557C              = $A3BA91;  $FFA3BA91  "#91BAA3"  "rgb(145,186,163)"  "rgba(145,186,163,255)"  "557C"
#Pnt_5575C             = $AFB9A1;  $FFAFB9A1  "#A1B9AF"  "rgb(161,185,175)"  "rgba(161,185,175,255)"  "5575C"
#Pnt_558C              = $B6C9AA;  $FFB6C9AA  "#AAC9B6"  "rgb(170,201,182)"  "rgba(170,201,182,255)"  "558C"
#Pnt_5585C             = $C3CCB9;  $FFC3CCB9  "#B9CCC3"  "rgb(185,204,195)"  "rgba(185,204,195,255)"  "5585C"
#Pnt_559C              = $C3D4BC;  $FFC3D4BC  "#BCD4C3"  "rgb(188,212,195)"  "rgba(188,212,195,255)"  "559C"
#Pnt_5595C             = $D1D9CB;  $FFD1D9CB  "#CBD9D1"  "rgb(203,217,209)"  "rgba(203,217,209,255)"  "5595C"
#Pnt_560C              = $3A4223;  $FF3A4223  "#23423A"  "rgb( 35, 66, 58)"  "rgba( 35, 66, 58,255)"  "560C"
#Pnt_5605C             = $2A3720;  $FF2A3720  "#20372A"  "rgb( 32, 55, 42)"  "rgba( 32, 55, 42,255)"  "5605C"
#Pnt_561C              = $545E17;  $FF545E17  "#175E54"  "rgb( 23, 94, 84)"  "rgba( 23, 94, 84,255)"  "561C"
#Pnt_5615C             = $5D7059;  $FF5D7059  "#59705D"  "rgb( 89,112, 93)"  "rgba( 89,112, 93,255)"  "5615C"
#Pnt_562C              = $6E770D;  $FF6E770D  "#0D776E"  "rgb( 13,119,110)"  "rgba( 13,119,110,255)"  "562C"
#Pnt_5625C             = $748671;  $FF748671  "#718674"  "rgb(113,134,116)"  "rgba(113,134,116,255)"  "5625C"
#Pnt_563C              = $B2BB7B;  $FFB2BB7B  "#7BBBB2"  "rgb(123,187,178)"  "rgba(123,187,178,255)"  "563C"
#Pnt_5635C             = $97A796;  $FF97A796  "#96A797"  "rgb(150,167,151)"  "rgba(150,167,151,255)"  "5635C"
#Pnt_564C              = $C3CC99;  $FFC3CC99  "#99CCC3"  "rgb(153,204,195)"  "rgba(153,204,195,255)"  "564C"
#Pnt_5645C             = $ADBBAD;  $FFADBBAD  "#ADBBAD"  "rgb(173,187,173)"  "rgba(173,187,173,255)"  "5645C"
#Pnt_565C              = $D2DAB5;  $FFD2DAB5  "#B5DAD2"  "rgb(181,218,210)"  "rgba(181,218,210,255)"  "565C"
#Pnt_5655C             = $B9C6BB;  $FFB9C6BB  "#BBC6B9"  "rgb(187,198,185)"  "rgba(187,198,185,255)"  "5655C"
#Pnt_566C              = $DCE3C9;  $FFDCE3C9  "#C9E3DC"  "rgb(201,227,220)"  "rgba(201,227,220,255)"  "566C"
#Pnt_5665C             = $C5D1C7;  $FFC5D1C7  "#C7D1C5"  "rgb(199,209,197)"  "rgba(199,209,197,255)"  "5665C"
#Pnt_567C              = $3B451C;  $FF3B451C  "#1C453B"  "rgb( 28, 69, 59)"  "rgba( 28, 69, 59,255)"  "567C"
#Pnt_568C              = $5B6800;  $FF5B6800  "#00685B"  "rgb(  0,104, 91)"  "rgba(  0,104, 91,255)"  "568C"
#Pnt_569C              = $768500;  $FF768500  "#008576"  "rgb(  0,133,118)"  "rgba(  0,133,118,255)"  "569C"
#Pnt_570C              = $BDCA79;  $FFBDCA79  "#79CABD"  "rgb(121,202,189)"  "rgba(121,202,189,255)"  "570C"
#Pnt_571C              = $D0DAA1;  $FFD0DAA1  "#A1DAD0"  "rgb(161,218,208)"  "rgba(161,218,208,255)"  "571C"
#Pnt_572C              = $D6E0B2;  $FFD6E0B2  "#B2E0D6"  "rgb(178,224,214)"  "rgba(178,224,214,255)"  "572C"
#Pnt_573C              = $DAE3BF;  $FFDAE3BF  "#BFE3DA"  "rgb(191,227,218)"  "rgba(191,227,218,255)"  "573C"
#Pnt_574C              = $255143;  $FF255143  "#435125"  "rgb( 67, 81, 37)"  "rgba( 67, 81, 37,255)"  "574C"
#Pnt_5743C             = $294A40;  $FF294A40  "#404A29"  "rgb( 64, 74, 41)"  "rgba( 64, 74, 41,255)"  "5743C"
#Pnt_5747C             = $19453E;  $FF19453E  "#3E4519"  "rgb( 62, 69, 25)"  "rgba( 62, 69, 25,255)"  "5747C"
#Pnt_575C              = $307655;  $FF307655  "#557630"  "rgb( 85,118, 48)"  "rgba( 85,118, 48,255)"  "575C"
#Pnt_5753C             = $34635B;  $FF34635B  "#5B6334"  "rgb( 91, 99, 52)"  "rgba( 91, 99, 52,255)"  "5753C"
#Pnt_5757C             = $29706A;  $FF29706A  "#6A7029"  "rgb(106,112, 41)"  "rgba(106,112, 41,255)"  "5757C"
#Pnt_576C              = $3A9269;  $FF3A9269  "#69923A"  "rgb(105,146, 58)"  "rgba(105,146, 58,255)"  "576C"
#Pnt_5763C             = $45766E;  $FF45766E  "#6E7645"  "rgb(110,118, 69)"  "rgba(110,118, 69,255)"  "5763C"
#Pnt_5767C             = $4B8F89;  $FF4B8F89  "#898F4B"  "rgb(137,143, 75)"  "rgba(137,143, 75,255)"  "5767C"
#Pnt_577C              = $85C7AB;  $FF85C7AB  "#ABC785"  "rgb(171,199,133)"  "rgba(171,199,133,255)"  "577C"
#Pnt_5773C             = $6B9890;  $FF6B9890  "#90986B"  "rgb(144,152,107)"  "rgba(144,152,107,255)"  "5773C"
#Pnt_5777C             = $6BA8A3;  $FF6BA8A3  "#A3A86B"  "rgb(163,168,107)"  "rgba(163,168,107,255)"  "5777C"
#Pnt_578C              = $95CFB8;  $FF95CFB8  "#B8CF95"  "rgb(184,207,149)"  "rgba(184,207,149,255)"  "578C"
#Pnt_5783C             = $89B0A9;  $FF89B0A9  "#A9B089"  "rgb(169,176,137)"  "rgba(169,176,137,255)"  "5783C"
#Pnt_5787C             = $92C2BE;  $FF92C2BE  "#BEC292"  "rgb(190,194,146)"  "rgba(190,194,146,255)"  "5787C"
#Pnt_579C              = $9FD5C1;  $FF9FD5C1  "#C1D59F"  "rgb(193,213,159)"  "rgba(193,213,159,255)"  "579C"
#Pnt_5793C             = $9CBEB9;  $FF9CBEB9  "#B9BE9C"  "rgb(185,190,156)"  "rgba(185,190,156,255)"  "5793C"
#Pnt_5797C             = $A3CDCA;  $FFA3CDCA  "#CACDA3"  "rgb(202,205,163)"  "rgba(202,205,163,255)"  "5797C"
#Pnt_580C              = $AEDBCC;  $FFAEDBCC  "#CCDBAE"  "rgb(204,219,174)"  "rgba(204,219,174,255)"  "580C"
#Pnt_5803C             = $B3CFCB;  $FFB3CFCB  "#CBCFB3"  "rgb(203,207,179)"  "rgba(203,207,179,255)"  "5803C"
#Pnt_5807C             = $BADAD8;  $FFBADAD8  "#D8DABA"  "rgb(216,218,186)"  "rgba(216,218,186,255)"  "5807C"
#Pnt_581C              = $17565B;  $FF17565B  "#5B5617"  "rgb( 91, 86, 23)"  "rgba( 91, 86, 23,255)"  "581C"
#Pnt_5815C             = $1A474B;  $FF1A474B  "#4B471A"  "rgb( 75, 71, 26)"  "rgba( 75, 71, 26,255)"  "5815C"
#Pnt_582C              = $008887;  $FF008887  "#878800"  "rgb(135,136,  0)"  "rgba(135,136,  0,255)"  "582C"
#Pnt_5825C             = $347C82;  $FF347C82  "#827C34"  "rgb(130,124, 52)"  "rgba(130,124, 52,255)"  "5825C"
#Pnt_583C              = $00B4A8;  $FF00B4A8  "#A8B400"  "rgb(168,180,  0)"  "rgba(168,180,  0,255)"  "583C"
#Pnt_5835C             = $599BA0;  $FF599BA0  "#A09B59"  "rgb(160,155, 89)"  "rgba(160,155, 89,255)"  "5835C"
#Pnt_584C              = $4BD6CE;  $FF4BD6CE  "#CED64B"  "rgb(206,214, 75)"  "rgba(206,214, 75,255)"  "584C"
#Pnt_5845C             = $6CAAAE;  $FF6CAAAE  "#AEAA6C"  "rgb(174,170,108)"  "rgba(174,170,108,255)"  "5845C"
#Pnt_585C              = $71DFDA;  $FF71DFDA  "#DADF71"  "rgb(218,223,113)"  "rgba(218,223,113,255)"  "585C"
#Pnt_5855C             = $8EC1C4;  $FF8EC1C4  "#C4C18E"  "rgb(196,193,142)"  "rgba(196,193,142,255)"  "5855C"
#Pnt_586C              = $83E3DF;  $FF83E3DF  "#DFE383"  "rgb(223,227,131)"  "rgba(223,227,131,255)"  "586C"
#Pnt_5865C             = $A0CCCE;  $FFA0CCCE  "#CECCA0"  "rgb(206,204,160)"  "rgba(206,204,160,255)"  "5865C"
#Pnt_587C              = $96E6E3;  $FF96E6E3  "#E3E696"  "rgb(227,230,150)"  "rgba(227,230,150,255)"  "587C"
#Pnt_5875C             = $AED4D6;  $FFAED4D6  "#D6D4AE"  "rgb(214,212,174)"  "rgba(214,212,174,255)"  "5875C"
#Pnt_600C              = $AAEBED;  $FFAAEBED  "#EDEBAA"  "rgb(237,235,170)"  "rgba(237,235,170,255)"  "600C"
#Pnt_601C              = $9CEAED;  $FF9CEAED  "#EDEA9C"  "rgb(237,234,156)"  "rgba(237,234,156,255)"  "601C"
#Pnt_602C              = $8CE9ED;  $FF8CE9ED  "#EDE98C"  "rgb(237,233,140)"  "rgba(237,233,140,255)"  "602C"
#Pnt_603C              = $54E3EC;  $FF54E3EC  "#ECE354"  "rgb(236,227, 84)"  "rgba(236,227, 84,255)"  "603C"
#Pnt_604C              = $29DEEA;  $FF29DEEA  "#EADE29"  "rgb(234,222, 41)"  "rgba(234,222, 41,255)"  "604C"
#Pnt_605C              = $00CDE1;  $FF00CDE1  "#E1CD00"  "rgb(225,205,  0)"  "rgba(225,205,  0,255)"  "605C"
#Pnt_606C              = $00BAD4;  $FF00BAD4  "#D4BA00"  "rgb(212,186,  0)"  "rgba(212,186,  0,255)"  "606C"
#Pnt_607C              = $B1E8EB;  $FFB1E8EB  "#EBE8B1"  "rgb(235,232,177)"  "rgba(235,232,177,255)"  "607C"
#Pnt_608C              = $9FE6E9;  $FF9FE6E9  "#E9E69F"  "rgb(233,230,159)"  "rgba(233,230,159,255)"  "608C"
#Pnt_609C              = $88E1E7;  $FF88E1E7  "#E7E188"  "rgb(231,225,136)"  "rgba(231,225,136,255)"  "609C"
#Pnt_610C              = $60D7E0;  $FF60D7E0  "#E0D760"  "rgb(224,215, 96)"  "rgba(224,215, 96,255)"  "610C"
#Pnt_611C              = $33C8D5;  $FF33C8D5  "#D5C833"  "rgb(213,200, 51)"  "rgba(213,200, 51,255)"  "611C"
#Pnt_612C              = $00B0C2;  $FF00B0C2  "#C2B000"  "rgb(194,176,  0)"  "rgba(194,176,  0,255)"  "612C"
#Pnt_613C              = $009BB1;  $FF009BB1  "#B19B00"  "rgb(177,155,  0)"  "rgba(177,155,  0,255)"  "613C"
#Pnt_614C              = $AEDEE1;  $FFAEDEE1  "#E1DEAE"  "rgb(225,222,174)"  "rgba(225,222,174,255)"  "614C"
#Pnt_615C              = $9CD6DA;  $FF9CD6DA  "#DAD69C"  "rgb(218,214,156)"  "rgba(218,214,156,255)"  "615C"
#Pnt_616C              = $8BCDD3;  $FF8BCDD3  "#D3CD8B"  "rgb(211,205,139)"  "rgba(211,205,139,255)"  "616C"
#Pnt_617C              = $70BFC6;  $FF70BFC6  "#C6BF70"  "rgb(198,191,112)"  "rgba(198,191,112,255)"  "617C"
#Pnt_618C              = $44A4AE;  $FF44A4AE  "#AEA444"  "rgb(174,164, 68)"  "rgba(174,164, 68,255)"  "618C"
#Pnt_619C              = $2E8F9B;  $FF2E8F9B  "#9B8F2E"  "rgb(155,143, 46)"  "rgba(155,143, 46,255)"  "619C"
#Pnt_620C              = $1B7B88;  $FF1B7B88  "#887B1B"  "rgb(136,123, 27)"  "rgba(136,123, 27,255)"  "620C"
#Pnt_621C              = $D6DFD1;  $FFD6DFD1  "#D1DFD6"  "rgb(209,223,214)"  "rgba(209,223,214,255)"  "621C"
#Pnt_622C              = $C4CEB7;  $FFC4CEB7  "#B7CEC4"  "rgb(183,206,196)"  "rgba(183,206,196,255)"  "622C"
#Pnt_623C              = $B0BC9D;  $FFB0BC9D  "#9DBCB0"  "rgb(157,188,176)"  "rgba(157,188,176,255)"  "623C"
#Pnt_624C              = $95A27C;  $FF95A27C  "#7CA295"  "rgb(124,162,149)"  "rgba(124,162,149,255)"  "624C"
#Pnt_625C              = $758557;  $FF758557  "#578575"  "rgb( 87,133,117)"  "rgba( 87,133,117,255)"  "625C"
#Pnt_626C              = $4F5E2C;  $FF4F5E2C  "#2C5E4F"  "rgb( 44, 94, 79)"  "rgba( 44, 94, 79,255)"  "626C"
#Pnt_627C              = $2C3513;  $FF2C3513  "#13352C"  "rgb( 19, 53, 44)"  "rgba( 19, 53, 44,255)"  "627C"
#Pnt_628C              = $E5E2C1;  $FFE5E2C1  "#C1E2E5"  "rgb(193,226,229)"  "rgba(193,226,229,255)"  "628C"
#Pnt_629C              = $E0D8A1;  $FFE0D8A1  "#A1D8E0"  "rgb(161,216,224)"  "rgba(161,216,224,255)"  "629C"
#Pnt_630C              = $DBCD85;  $FFDBCD85  "#85CDDB"  "rgb(133,205,219)"  "rgba(133,205,219,255)"  "630C"
#Pnt_631C              = $CEB63C;  $FFCEB63C  "#3CB6CE"  "rgb( 60,182,206)"  "rgba( 60,182,206,255)"  "631C"
#Pnt_632C              = $BB9B00;  $FFBB9B00  "#009BBB"  "rgb(  0,155,187)"  "rgba(  0,155,187,255)"  "632C"
#Pnt_633C              = $A37E00;  $FFA37E00  "#007EA3"  "rgb(  0,126,163)"  "rgba(  0,126,163,255)"  "633C"
#Pnt_634C              = $906800;  $FF906800  "#006890"  "rgb(  0,104,144)"  "rgba(  0,104,144,255)"  "634C"
#Pnt_635C              = $E6DEAC;  $FFE6DEAC  "#ACDEE6"  "rgb(172,222,230)"  "rgba(172,222,230,255)"  "635C"
#Pnt_636C              = $E7D790;  $FFE7D790  "#90D7E7"  "rgb(144,215,231)"  "rgba(144,215,231,255)"  "636C"
#Pnt_637C              = $E2C652;  $FFE2C652  "#52C6E2"  "rgb( 82,198,226)"  "rgba( 82,198,226,255)"  "637C"
#Pnt_638C              = $D8AF00;  $FFD8AF00  "#00AFD8"  "rgb(  0,175,216)"  "rgba(  0,175,216,255)"  "638C"
#Pnt_639C              = $CC9900;  $FFCC9900  "#0099CC"  "rgb(  0,153,204)"  "rgba(  0,153,204,255)"  "639C"
#Pnt_640C              = $BB8200;  $FFBB8200  "#0082BB"  "rgb(  0,130,187)"  "rgba(  0,130,187,255)"  "640C"
#Pnt_641C              = $B07300;  $FFB07300  "#0073B0"  "rgb(  0,115,176)"  "rgba(  0,115,176,255)"  "641C"
#Pnt_642C              = $E4DED3;  $FFE4DED3  "#D3DEE4"  "rgb(211,222,228)"  "rgba(211,222,228,255)"  "642C"
#Pnt_643C              = $DFD3C3;  $FFDFD3C3  "#C3D3DF"  "rgb(195,211,223)"  "rgba(195,211,223,255)"  "643C"
#Pnt_644C              = $CCB193;  $FFCCB193  "#93B1CC"  "rgb(147,177,204)"  "rgba(147,177,204,255)"  "644C"
#Pnt_645C              = $BC9A73;  $FFBC9A73  "#739ABC"  "rgb(115,154,188)"  "rgba(115,154,188,255)"  "645C"
#Pnt_646C              = $AB8254;  $FFAB8254  "#5482AB"  "rgb( 84,130,171)"  "rgba( 84,130,171,255)"  "646C"
#Pnt_647C              = $885716;  $FF885716  "#165788"  "rgb( 22, 87,136)"  "rgba( 22, 87,136,255)"  "647C"
#Pnt_648C              = $572800;  $FF572800  "#002857"  "rgb(  0, 40, 87)"  "rgba(  0, 40, 87,255)"  "648C"
#Pnt_649C              = $E6DFD7;  $FFE6DFD7  "#D7DFE6"  "rgb(215,223,230)"  "rgba(215,223,230,255)"  "649C"
#Pnt_650C              = $E0D2C5;  $FFE0D2C5  "#C5D2E0"  "rgb(197,210,224)"  "rgba(197,210,224,255)"  "650C"
#Pnt_651C              = $CEB29B;  $FFCEB29B  "#9BB2CE"  "rgb(155,178,206)"  "rgba(155,178,206,255)"  "651C"
#Pnt_652C              = $B79070;  $FFB79070  "#7090B7"  "rgb(112,144,183)"  "rgba(112,144,183,255)"  "652C"
#Pnt_653C              = $8A5721;  $FF8A5721  "#21578A"  "rgb( 33, 87,138)"  "rgba( 33, 87,138,255)"  "653C"
#Pnt_654C              = $5F2C00;  $FF5F2C00  "#002C5F"  "rgb(  0, 44, 95)"  "rgba(  0, 44, 95,255)"  "654C"
#Pnt_655C              = $4E2000;  $FF4E2000  "#00204E"  "rgb(  0, 32, 78)"  "rgba(  0, 32, 78,255)"  "655C"
#Pnt_656C              = $EAE3DA;  $FFEAE3DA  "#DAE3EA"  "rgb(218,227,234)"  "rgba(218,227,234,255)"  "656C"
#Pnt_657C              = $E8D6C6;  $FFE8D6C6  "#C6D6E8"  "rgb(198,214,232)"  "rgba(198,214,232,255)"  "657C"
#Pnt_658C              = $E3C1A7;  $FFE3C1A7  "#A7C1E3"  "rgb(167,193,227)"  "rgba(167,193,227,255)"  "658C"
#Pnt_659C              = $D39A6F;  $FFD39A6F  "#6F9AD3"  "rgb(111,154,211)"  "rgba(111,154,211,255)"  "659C"
#Pnt_660C              = $BB6E2A;  $FFBB6E2A  "#2A6EBB"  "rgb( 42,110,187)"  "rgba( 42,110,187,255)"  "660C"
#Pnt_661C              = $913500;  $FF913500  "#003591"  "rgb(  0, 53,145)"  "rgba(  0, 53,145,255)"  "661C"
#Pnt_662C              = $771D00;  $FF771D00  "#001D77"  "rgb(  0, 29,119)"  "rgba(  0, 29,119,255)"  "662C"
#Pnt_663C              = $E3DCE0;  $FFE3DCE0  "#E0DCE3"  "rgb(224,220,227)"  "rgba(224,220,227,255)"  "663C"
#Pnt_664C              = $E2D8DC;  $FFE2D8DC  "#DCD8E2"  "rgb(220,216,226)"  "rgba(220,216,226,255)"  "664C"
#Pnt_665C              = $D2BDC6;  $FFD2BDC6  "#C6BDD2"  "rgb(198,189,210)"  "rgba(198,189,210,255)"  "665C"
#Pnt_666C              = $B492A0;  $FFB492A0  "#A092B4"  "rgb(160,146,180)"  "rgba(160,146,180,255)"  "666C"
#Pnt_667C              = $926578;  $FF926578  "#786592"  "rgb(120,101,146)"  "rgba(120,101,146,255)"  "667C"
#Pnt_668C              = $7D4D61;  $FF7D4D61  "#614D7D"  "rgb( 97, 77,125)"  "rgba( 97, 77,125,255)"  "668C"
#Pnt_669C              = $5D2D41;  $FF5D2D41  "#412D5D"  "rgb( 65, 45, 93)"  "rgba( 65, 45, 93,255)"  "669C"
#Pnt_670C              = $E1D4E9;  $FFE1D4E9  "#E9D4E1"  "rgb(233,212,225)"  "rgba(233,212,225,255)"  "670C"
#Pnt_671C              = $D8C0E5;  $FFD8C0E5  "#E5C0D8"  "rgb(229,192,216)"  "rgba(229,192,216,255)"  "671C"
#Pnt_672C              = $C8A3DE;  $FFC8A3DE  "#DEA3C8"  "rgb(222,163,200)"  "rgba(222,163,200,255)"  "672C"
#Pnt_673C              = $B888D6;  $FFB888D6  "#D688B8"  "rgb(214,136,184)"  "rgba(214,136,184,255)"  "673C"
#Pnt_674C              = $9B5EC5;  $FF9B5EC5  "#C55E9B"  "rgb(197, 94,155)"  "rgba(197, 94,155,255)"  "674C"
#Pnt_675C              = $7329AC;  $FF7329AC  "#AC2973"  "rgb(172, 41,115)"  "rgba(172, 41,115,255)"  "675C"
#Pnt_676C              = $540297;  $FF540297  "#970254"  "rgb(151,  2, 84)"  "rgba(151,  2, 84,255)"  "676C"
#Pnt_677C              = $DBD0E4;  $FFDBD0E4  "#E4D0DB"  "rgb(228,208,219)"  "rgba(228,208,219,255)"  "677C"
#Pnt_678C              = $D7C7E0;  $FFD7C7E0  "#E0C7D7"  "rgb(224,199,215)"  "rgba(224,199,215,255)"  "678C"
#Pnt_679C              = $D1BEDD;  $FFD1BEDD  "#DDBED1"  "rgb(221,190,209)"  "rgba(221,190,209,255)"  "679C"
#Pnt_680C              = $B596C8;  $FFB596C8  "#C896B5"  "rgb(200,150,181)"  "rgba(200,150,181,255)"  "680C"
#Pnt_681C              = $9A74B3;  $FF9A74B3  "#B3749A"  "rgb(179,116,154)"  "rgba(179,116,154,255)"  "681C"
#Pnt_682C              = $754995;  $FF754995  "#954975"  "rgb(149, 73,117)"  "rgba(149, 73,117,255)"  "682C"
#Pnt_683C              = $532977;  $FF532977  "#772953"  "rgb(119, 41, 83)"  "rgba(119, 41, 83,255)"  "683C"
#Pnt_684C              = $D2C5E3;  $FFD2C5E3  "#E3C5D2"  "rgb(227,197,210)"  "rgba(227,197,210,255)"  "684C"
#Pnt_685C              = $CAB7DE;  $FFCAB7DE  "#DEB7CA"  "rgb(222,183,202)"  "rgba(222,183,202,255)"  "685C"
#Pnt_686C              = $BEA5D5;  $FFBEA5D5  "#D5A5BE"  "rgb(213,165,190)"  "rgba(213,165,190,255)"  "686C"
#Pnt_687C              = $A786C2;  $FFA786C2  "#C286A7"  "rgb(194,134,167)"  "rgba(194,134,167,255)"  "687C"
#Pnt_688C              = $926AB0;  $FF926AB0  "#B06A92"  "rgb(176,106,146)"  "rgba(176,106,146,255)"  "688C"
#Pnt_689C              = $6D3F8F;  $FF6D3F8F  "#8F3F6D"  "rgb(143, 63,109)"  "rgba(143, 63,109,255)"  "689C"
#Pnt_690C              = $451F64;  $FF451F64  "#641F45"  "rgb(100, 31, 69)"  "rgba(100, 31, 69,255)"  "690C"
#Pnt_691C              = $D7D3E9;  $FFD7D3E9  "#E9D3D7"  "rgb(233,211,215)"  "rgba(233,211,215,255)"  "691C"
#Pnt_692C              = $C7C2E2;  $FFC7C2E2  "#E2C2C7"  "rgb(226,194,199)"  "rgba(226,194,199,255)"  "692C"
#Pnt_693C              = $B3AAD8;  $FFB3AAD8  "#D8AAB3"  "rgb(216,170,179)"  "rgba(216,170,179,255)"  "693C"
#Pnt_694C              = $998DC6;  $FF998DC6  "#C68D99"  "rgb(198,141,153)"  "rgba(198,141,153,255)"  "694C"
#Pnt_695C              = $7E6FB2;  $FF7E6FB2  "#B26F7E"  "rgb(178,111,126)"  "rgba(178,111,126,255)"  "695C"
#Pnt_696C              = $53448E;  $FF53448E  "#8E4453"  "rgb(142, 68, 83)"  "rgba(142, 68, 83,255)"  "696C"
#Pnt_697C              = $473C82;  $FF473C82  "#823C47"  "rgb(130, 60, 71)"  "rgba(130, 60, 71,255)"  "697C"
#Pnt_698C              = $DBD6EF;  $FFDBD6EF  "#EFD6DB"  "rgb(239,214,219)"  "rgba(239,214,219,255)"  "698C"
#Pnt_699C              = $CEC5EF;  $FFCEC5EF  "#EFC5CE"  "rgb(239,197,206)"  "rgba(239,197,206,255)"  "699C"
#Pnt_700C              = $B9AAEB;  $FFB9AAEB  "#EBAAB9"  "rgb(235,170,185)"  "rgba(235,170,185,255)"  "700C"
#Pnt_701C              = $9E8AE2;  $FF9E8AE2  "#E28A9E"  "rgb(226,138,158)"  "rgba(226,138,158,255)"  "701C"
#Pnt_702C              = $7960D0;  $FF7960D0  "#D06079"  "rgb(208, 96,121)"  "rgba(208, 96,121,255)"  "702C"
#Pnt_703C              = $4F38B5;  $FF4F38B5  "#B5384F"  "rgb(181, 56, 79)"  "rgba(181, 56, 79,255)"  "703C"
#Pnt_704C              = $382BA2;  $FF382BA2  "#A22B38"  "rgb(162, 43, 56)"  "rgba(162, 43, 56,255)"  "704C"
#Pnt_705C              = $DFDBF1;  $FFDFDBF1  "#F1DBDF"  "rgb(241,219,223)"  "rgba(241,219,223,255)"  "705C"
#Pnt_706C              = $D3C9F3;  $FFD3C9F3  "#F3C9D3"  "rgb(243,201,211)"  "rgba(243,201,211,255)"  "706C"
#Pnt_707C              = $C1B2F4;  $FFC1B2F4  "#F4B2C1"  "rgb(244,178,193)"  "rgba(244,178,193,255)"  "707C"
#Pnt_708C              = $A38CF2;  $FFA38CF2  "#F28CA3"  "rgb(242,140,163)"  "rgba(242,140,163,255)"  "708C"
#Pnt_709C              = $8266EA;  $FF8266EA  "#EA6682"  "rgb(234,102,130)"  "rgba(234,102,130,255)"  "709C"
#Pnt_710C              = $6145DE;  $FF6145DE  "#DE4561"  "rgb(222, 69, 97)"  "rgba(222, 69, 97,255)"  "710C"
#Pnt_711C              = $442FCF;  $FF442FCF  "#CF2F44"  "rgb(207, 47, 68)"  "rgba(207, 47, 68,255)"  "711C"
#Pnt_712C              = $A6CCF8;  $FFA6CCF8  "#F8CCA6"  "rgb(248,204,166)"  "rgba(248,204,166,255)"  "712C"
#Pnt_713C              = $96C3FA;  $FF96C3FA  "#FAC396"  "rgb(250,195,150)"  "rgba(250,195,150,255)"  "713C"
#Pnt_714C              = $73AFFB;  $FF73AFFB  "#FBAF73"  "rgb(251,175,115)"  "rgba(251,175,115,255)"  "714C"
#Pnt_715C              = $4092F6;  $FF4092F6  "#F69240"  "rgb(246,146, 64)"  "rgba(246,146, 64,255)"  "715C"
#Pnt_716C              = $087AEC;  $FF087AEC  "#EC7A08"  "rgb(236,122,  8)"  "rgba(236,122,  8,255)"  "716C"
#Pnt_717C              = $005ED9;  $FF005ED9  "#D95E00"  "rgb(217, 94,  0)"  "rgba(217, 94,  0,255)"  "717C"
#Pnt_718C              = $004EC8;  $FF004EC8  "#C84E00"  "rgb(200, 78,  0)"  "rgba(200, 78,  0,255)"  "718C"
#Pnt_719C              = $B3CFED;  $FFB3CFED  "#EDCFB3"  "rgb(237,207,179)"  "rgba(237,207,179,255)"  "719C"
#Pnt_720C              = $9BBFE9;  $FF9BBFE9  "#E9BF9B"  "rgb(233,191,155)"  "rgba(233,191,155,255)"  "720C"
#Pnt_721C              = $81AEE2;  $FF81AEE2  "#E2AE81"  "rgb(226,174,129)"  "rgba(226,174,129,255)"  "721C"
#Pnt_722C              = $4E89CD;  $FF4E89CD  "#CD894E"  "rgb(205,137, 78)"  "rgba(205,137, 78,255)"  "722C"
#Pnt_723C              = $2E6FBA;  $FF2E6FBA  "#BA6F2E"  "rgb(186,111, 46)"  "rgba(186,111, 46,255)"  "723C"
#Pnt_724C              = $094A95;  $FF094A95  "#954A09"  "rgb(149, 74,  9)"  "rgba(149, 74,  9,255)"  "724C"
#Pnt_725C              = $0D3D80;  $FF0D3D80  "#803D0D"  "rgb(128, 61, 13)"  "rgba(128, 61, 13,255)"  "725C"
#Pnt_726C              = $B1CBE5;  $FFB1CBE5  "#E5CBB1"  "rgb(229,203,177)"  "rgba(229,203,177,255)"  "726C"
#Pnt_727C              = $9AB9DD;  $FF9AB9DD  "#DDB99A"  "rgb(221,185,154)"  "rgba(221,185,154,255)"  "727C"
#Pnt_728C              = $85A9D3;  $FF85A9D3  "#D3A985"  "rgb(211,169,133)"  "rgba(211,169,133,255)"  "728C"
#Pnt_729C              = $5E8ABD;  $FF5E8ABD  "#BD8A5E"  "rgb(189,138, 94)"  "rgba(189,138, 94,255)"  "729C"
#Pnt_730C              = $3E6FA7;  $FF3E6FA7  "#A76F3E"  "rgb(167,111, 62)"  "rgba(167,111, 62,255)"  "730C"
#Pnt_731C              = $143D72;  $FF143D72  "#723D14"  "rgb(114, 61, 20)"  "rgba(114, 61, 20,255)"  "731C"
#Pnt_732C              = $16335F;  $FF16335F  "#5F3316"  "rgb( 95, 51, 22)"  "rgba( 95, 51, 22,255)"  "732C"
#Pnt_7401C             = $BBE3F1;  $FFBBE3F1  "#F1E3BB"  "rgb(241,227,187)"  "rgba(241,227,187,255)"  "7401C"
#Pnt_7402C             = $9CDDEB;  $FF9CDDEB  "#EBDD9C"  "rgb(235,221,156)"  "rgba(235,221,156,255)"  "7402C"
#Pnt_7403C             = $79CEE8;  $FF79CEE8  "#E8CE79"  "rgb(232,206,121)"  "rgba(232,206,121,255)"  "7403C"
#Pnt_7404C             = $11D3F3;  $FF11D3F3  "#F3D311"  "rgb(243,211, 17)"  "rgba(243,211, 17,255)"  "7404C"
#Pnt_7405C             = $00C2EC;  $FF00C2EC  "#ECC200"  "rgb(236,194,  0)"  "rgba(236,194,  0,255)"  "7405C"
#Pnt_7406C             = $00B7EB;  $FF00B7EB  "#EBB700"  "rgb(235,183,  0)"  "rgba(235,183,  0,255)"  "7406C"
#Pnt_7407C             = $4A9BCA;  $FF4A9BCA  "#CA9B4A"  "rgb(202,155, 74)"  "rgba(202,155, 74,255)"  "7407C"
#Pnt_7408C             = $00AFF2;  $FF00AFF2  "#F2AF00"  "rgb(242,175,  0)"  "rgba(242,175,  0,255)"  "7408C"
#Pnt_7409C             = $00AFEE;  $FF00AFEE  "#EEAF00"  "rgb(238,175,  0)"  "rgba(238,175,  0,255)"  "7409C"
#Pnt_7410C             = $71A6FA;  $FF71A6FA  "#FAA671"  "rgb(250,166,113)"  "rgba(250,166,113,255)"  "7410C"
#Pnt_7411C             = $58A3E1;  $FF58A3E1  "#E1A358"  "rgb(225,163, 88)"  "rgba(225,163, 88,255)"  "7411C"
#Pnt_7412C             = $317ACD;  $FF317ACD  "#CD7A31"  "rgb(205,122, 49)"  "rgba(205,122, 49,255)"  "7412C"
#Pnt_7413C             = $227BD4;  $FF227BD4  "#D47B22"  "rgb(212,123, 34)"  "rgba(212,123, 34,255)"  "7413C"
#Pnt_7414C             = $1B62B7;  $FF1B62B7  "#B7621B"  "rgb(183, 98, 27)"  "rgba(183, 98, 27,255)"  "7414C"
#Pnt_7415C             = $A4BAE3;  $FFA4BAE3  "#E3BAA4"  "rgb(227,186,164)"  "rgba(227,186,164,255)"  "7415C"
#Pnt_7416C             = $4B68E0;  $FF4B68E0  "#E0684B"  "rgb(224,104, 75)"  "rgba(224,104, 75,255)"  "7416C"
#Pnt_7417C             = $3450DC;  $FF3450DC  "#DC5034"  "rgb(220, 80, 52)"  "rgba(220, 80, 52,255)"  "7417C"
#Pnt_7418C             = $524DC2;  $FF524DC2  "#C24D52"  "rgb(194, 77, 82)"  "rgba(194, 77, 82,255)"  "7418C"
#Pnt_7419C             = $5A47A8;  $FF5A47A8  "#A8475A"  "rgb(168, 71, 90)"  "rgba(168, 71, 90,255)"  "7419C"
#Pnt_7420C             = $401F98;  $FF401F98  "#981F40"  "rgb(152, 31, 64)"  "rgba(152, 31, 64,255)"  "7420C"
#Pnt_7421C             = $2D175E;  $FF2D175E  "#5E172D"  "rgb( 94, 23, 45)"  "rgba( 94, 23, 45,255)"  "7421C"
#Pnt_7422C             = $DAD5F0;  $FFDAD5F0  "#F0D5DA"  "rgb(240,213,218)"  "rgba(240,213,218,255)"  "7422C"
#Pnt_7423C             = $8A66DF;  $FF8A66DF  "#DF668A"  "rgb(223,102,138)"  "rgba(223,102,138,255)"  "7423C"
#Pnt_7424C             = $7E3DDA;  $FF7E3DDA  "#DA3D7E"  "rgb(218, 61,126)"  "rgba(218, 61,126,255)"  "7424C"
#Pnt_7425C             = $5A29B7;  $FF5A29B7  "#B7295A"  "rgb(183, 41, 90)"  "rgba(183, 41, 90,255)"  "7425C"
#Pnt_7426C             = $4819AA;  $FF4819AA  "#AA1948"  "rgb(170, 25, 72)"  "rgba(170, 25, 72,255)"  "7426C"
#Pnt_7427C             = $2E1796;  $FF2E1796  "#96172E"  "rgb(150, 23, 46)"  "rgba(150, 23, 46,255)"  "7427C"
#Pnt_7428C             = $412D6D;  $FF412D6D  "#6D2D41"  "rgb(109, 45, 65)"  "rgba(109, 45, 65,255)"  "7428C"
#Pnt_7429C             = $D1C4E3;  $FFD1C4E3  "#E3C4D1"  "rgb(227,196,209)"  "rgba(227,196,209,255)"  "7429C"
#Pnt_7430C             = $C2AFDB;  $FFC2AFDB  "#DBAFC2"  "rgb(219,175,194)"  "rgba(219,175,194,255)"  "7430C"
#Pnt_7431C             = $A589CB;  $FFA589CB  "#CB89A5"  "rgb(203,137,165)"  "rgba(203,137,165,255)"  "7431C"
#Pnt_7432C             = $8361B5;  $FF8361B5  "#B56183"  "rgb(181, 97,131)"  "rgba(181, 97,131,255)"  "7432C"
#Pnt_7433C             = $6940A8;  $FF6940A8  "#A84069"  "rgb(168, 64,105)"  "rgba(168, 64,105,255)"  "7433C"
#Pnt_7434C             = $563196;  $FF563196  "#963156"  "rgb(150, 49, 86)"  "rgba(150, 49, 86,255)"  "7434C"
#Pnt_7435C             = $4E2482;  $FF4E2482  "#82244E"  "rgb(130, 36, 78)"  "rgba(130, 36, 78,255)"  "7435C"
#Pnt_7436C             = $E3D7E8;  $FFE3D7E8  "#E8D7E3"  "rgb(232,215,227)"  "rgba(232,215,227,255)"  "7436C"
#Pnt_7437C             = $D1B2CC;  $FFD1B2CC  "#CCB2D1"  "rgb(204,178,209)"  "rgba(204,178,209,255)"  "7437C"
#Pnt_7438C             = $D59ACF;  $FFD59ACF  "#CF9AD5"  "rgb(207,154,213)"  "rgba(207,154,213,255)"  "7438C"
#Pnt_7439C             = $BB90B3;  $FFBB90B3  "#B390BB"  "rgb(179,144,187)"  "rgba(179,144,187,255)"  "7439C"
#Pnt_7440C             = $AA7AA1;  $FFAA7AA1  "#A17AAA"  "rgb(161,122,170)"  "rgba(161,122,170,255)"  "7440C"
#Pnt_7441C             = $C26097;  $FFC26097  "#9760C2"  "rgb(151, 96,194)"  "rgba(151, 96,194,255)"  "7441C"
#Pnt_7442C             = $BA3786;  $FFBA3786  "#8637BA"  "rgb(134, 55,186)"  "rgba(134, 55,186,255)"  "7442C"
#Pnt_7443C             = $E5D9D8;  $FFE5D9D8  "#D8D9E5"  "rgb(216,217,229)"  "rgba(216,217,229,255)"  "7443C"
#Pnt_7444C             = $DBBAB6;  $FFDBBAB6  "#B6BADB"  "rgb(182,186,219)"  "rgba(182,186,219,255)"  "7444C"
#Pnt_7445C             = $C6A2A5;  $FFC6A2A5  "#A5A2C6"  "rgb(165,162,198)"  "rgba(165,162,198,255)"  "7445C"
#Pnt_7446C             = $CB8D8F;  $FFCB8D8F  "#8F8DCB"  "rgb(143,141,203)"  "rgba(143,141,203,255)"  "7446C"
#Pnt_7447C             = $7A445A;  $FF7A445A  "#5A447A"  "rgb( 90, 68,122)"  "rgba( 90, 68,122,255)"  "7447C"
#Pnt_7448C             = $51364A;  $FF51364A  "#4A3651"  "rgb( 74, 54, 81)"  "rgba( 74, 54, 81,255)"  "7448C"
#Pnt_7449C             = $39263C;  $FF39263C  "#3C2639"  "rgb( 60, 38, 57)"  "rgba( 60, 38, 57,255)"  "7449C"
#Pnt_7450C             = $DBC3BC;  $FFDBC3BC  "#BCC3DB"  "rgb(188,195,219)"  "rgba(188,195,219,255)"  "7450C"
#Pnt_7451C             = $E0A889;  $FFE0A889  "#89A8E0"  "rgb(137,168,224)"  "rgba(137,168,224,255)"  "7451C"
#Pnt_7452C             = $DB9381;  $FFDB9381  "#8193DB"  "rgb(129,147,219)"  "rgba(129,147,219,255)"  "7452C"
#Pnt_7453C             = $D9A47B;  $FFD9A47B  "#7BA4D9"  "rgb(123,164,217)"  "rgba(123,164,217,255)"  "7453C"
#Pnt_7454C             = $B59364;  $FFB59364  "#6493B5"  "rgb(100,147,181)"  "rgba(100,147,181,255)"  "7454C"
#Pnt_7455C             = $AF6040;  $FFAF6040  "#4060AF"  "rgb( 64, 96,175)"  "rgba( 64, 96,175,255)"  "7455C"
#Pnt_7456C             = $B67367;  $FFB67367  "#6773B6"  "rgb(103,115,182)"  "rgba(103,115,182,255)"  "7456C"
#Pnt_7457C             = $E9E3CA;  $FFE9E3CA  "#CAE3E9"  "rgb(202,227,233)"  "rgba(202,227,233,255)"  "7457C"
#Pnt_7458C             = $CCB572;  $FFCCB572  "#72B5CC"  "rgb(114,181,204)"  "rgba(114,181,204,255)"  "7458C"
#Pnt_7459C             = $B49530;  $FFB49530  "#3095B4"  "rgb( 48,149,180)"  "rgba( 48,149,180,255)"  "7459C"
#Pnt_7460C             = $C48900;  $FFC48900  "#0089C4"  "rgb(  0,137,196)"  "rgba(  0,137,196,255)"  "7460C"
#Pnt_7461C             = $BE8300;  $FFBE8300  "#0083BE"  "rgb(  0,131,190)"  "rgba(  0,131,190,255)"  "7461C"
#Pnt_7462C             = $8B5A00;  $FF8B5A00  "#005A8B"  "rgb(  0, 90,139)"  "rgba(  0, 90,139,255)"  "7462C"
#Pnt_7463C             = $503100;  $FF503100  "#003150"  "rgb(  0, 49, 80)"  "rgba(  0, 49, 80,255)"  "7463C"
#Pnt_7464C             = $D2D6A0;  $FFD2D6A0  "#A0D6D2"  "rgb(160,214,210)"  "rgba(160,214,210,255)"  "7464C"
#Pnt_7465C             = $B5C435;  $FFB5C435  "#35C4B5"  "rgb( 53,196,181)"  "rgba( 53,196,181,255)"  "7465C"
#Pnt_7466C             = $BEB300;  $FFBEB300  "#00B3BE"  "rgb(  0,179,190)"  "rgba(  0,179,190,255)"  "7466C"
#Pnt_7467C             = $B4A800;  $FFB4A800  "#00A8B4"  "rgb(  0,168,180)"  "rgba(  0,168,180,255)"  "7467C"
#Pnt_7468C             = $9A7500;  $FF9A7500  "#00759A"  "rgb(  0,117,154)"  "rgba(  0,117,154,255)"  "7468C"
#Pnt_7469C             = $845C00;  $FF845C00  "#005C84"  "rgb(  0, 92,132)"  "rgba(  0, 92,132,255)"  "7469C"
#Pnt_7470C             = $6E5E00;  $FF6E5E00  "#005E6E"  "rgb(  0, 94,110)"  "rgba(  0, 94,110,255)"  "7470C"
#Pnt_7471C             = $D6DE80;  $FFD6DE80  "#80DED6"  "rgb(128,222,214)"  "rgba(128,222,214,255)"  "7471C"
#Pnt_7472C             = $B7BB5B;  $FFB7BB5B  "#5BBBB7"  "rgb( 91,187,183)"  "rgba( 91,187,183,255)"  "7472C"
#Pnt_7473C             = $8B9D1E;  $FF8B9D1E  "#1E9D8B"  "rgb( 30,157,139)"  "rgba( 30,157,139,255)"  "7473C"
#Pnt_7474C             = $877A00;  $FF877A00  "#007A87"  "rgb(  0,122,135)"  "rgba(  0,122,135,255)"  "7474C"
#Pnt_7475C             = $807F47;  $FF807F47  "#477F80"  "rgb( 71,127,128)"  "rgba( 71,127,128,255)"  "7475C"
#Pnt_7476C             = $575100;  $FF575100  "#005157"  "rgb(  0, 81, 87)"  "rgba(  0, 81, 87,255)"  "7476C"
#Pnt_7477C             = $5F5022;  $FF5F5022  "#22505F"  "rgb( 34, 80, 95)"  "rgba( 34, 80, 95,255)"  "7477C"
#Pnt_7478C             = $C2E6A2;  $FFC2E6A2  "#A2E6C2"  "rgb(162,230,194)"  "rgba(162,230,194,255)"  "7478C"
#Pnt_7479C             = $7ED132;  $FF7ED132  "#32D17E"  "rgb( 50,209,126)"  "rgba( 50,209,126,255)"  "7479C"
#Pnt_7480C             = $73C400;  $FF73C400  "#00C473"  "rgb(  0,196,115)"  "rgba(  0,196,115,255)"  "7480C"
#Pnt_7481C             = $4CBA00;  $FF4CBA00  "#00BA4C"  "rgb(  0,186, 76)"  "rgba(  0,186, 76,255)"  "7481C"
#Pnt_7482C             = $51A500;  $FF51A500  "#00A551"  "rgb(  0,165, 81)"  "rgba(  0,165, 81,255)"  "7482C"
#Pnt_7483C             = $375E27;  $FF375E27  "#275E37"  "rgb( 39, 94, 55)"  "rgba( 39, 94, 55,255)"  "7483C"
#Pnt_7484C             = $3C5800;  $FF3C5800  "#00583C"  "rgb(  0, 88, 60)"  "rgba(  0, 88, 60,255)"  "7484C"
#Pnt_7485C             = $CDE5DA;  $FFCDE5DA  "#DAE5CD"  "rgb(218,229,205)"  "rgba(218,229,205,255)"  "7485C"
#Pnt_7486C             = $A4E5C5;  $FFA4E5C5  "#C5E5A4"  "rgb(197,229,164)"  "rgba(197,229,164,255)"  "7486C"
#Pnt_7487C             = $71E099;  $FF71E099  "#99E071"  "rgb(153,224,113)"  "rgba(153,224,113,255)"  "7487C"
#Pnt_7488C             = $50D776;  $FF50D776  "#76D750"  "rgb(118,215, 80)"  "rgba(118,215, 80,255)"  "7488C"
#Pnt_7489C             = $55AF73;  $FF55AF73  "#73AF55"  "rgb(115,175, 85)"  "rgba(115,175, 85,255)"  "7489C"
#Pnt_7490C             = $3B966A;  $FF3B966A  "#6A963B"  "rgb(106,150, 59)"  "rgba(106,150, 59,255)"  "7490C"
#Pnt_7491C             = $398673;  $FF398673  "#738639"  "rgb(115,134, 57)"  "rgba(115,134, 57,255)"  "7491C"
#Pnt_7492C             = $8AD2C7;  $FF8AD2C7  "#C7D28A"  "rgb(199,210,138)"  "rgba(199,210,138,255)"  "7492C"
#Pnt_7493C             = $96C6BA;  $FF96C6BA  "#BAC696"  "rgb(186,198,150)"  "rgba(186,198,150,255)"  "7493C"
#Pnt_7494C             = $8FB29E;  $FF8FB29E  "#9EB28F"  "rgb(158,178,143)"  "rgba(158,178,143,255)"  "7494C"
#Pnt_7495C             = $379687;  $FF379687  "#879637"  "rgb(135,150, 55)"  "rgba(135,150, 55,255)"  "7495C"
#Pnt_7496C             = $107F6A;  $FF107F6A  "#6A7F10"  "rgb(106,127, 16)"  "rgba(106,127, 16,255)"  "7496C"
#Pnt_7497C             = $526E75;  $FF526E75  "#756E52"  "rgb(117,110, 82)"  "rgba(117,110, 82,255)"  "7497C"
#Pnt_7498C             = $2B564E;  $FF2B564E  "#4E562B"  "rgb( 78, 86, 43)"  "rgba( 78, 86, 43,255)"  "7498C"
#Pnt_7499C             = $C4E8ED;  $FFC4E8ED  "#EDE8C4"  "rgb(237,232,196)"  "rgba(237,232,196,255)"  "7499C"
#Pnt_7500C             = $B7D8E1;  $FFB7D8E1  "#E1D8B7"  "rgb(225,216,183)"  "rgba(225,216,183,255)"  "7500C"
#Pnt_7501C             = $ACCEDB;  $FFACCEDB  "#DBCEAC"  "rgb(219,206,172)"  "rgba(219,206,172,255)"  "7501C"
#Pnt_7502C             = $96BFD3;  $FF96BFD3  "#D3BF96"  "rgb(211,191,150)"  "rgba(211,191,150,255)"  "7502C"
#Pnt_7503C             = $709EA7;  $FF709EA7  "#A79E70"  "rgb(167,158,112)"  "rgba(167,158,112,255)"  "7503C"
#Pnt_7504C             = $5B7891;  $FF5B7891  "#91785B"  "rgb(145,120, 91)"  "rgba(145,120, 91,255)"  "7504C"
#Pnt_7505C             = $446383;  $FF446383  "#836344"  "rgb(131, 99, 68)"  "rgba(131, 99, 68,255)"  "7505C"
#Pnt_7506C             = $BBDEEC;  $FFBBDEEC  "#ECDEBB"  "rgb(236,222,187)"  "rgba(236,222,187,255)"  "7506C"
#Pnt_7507C             = $A5D6F7;  $FFA5D6F7  "#F7D6A5"  "rgb(247,214,165)"  "rgba(247,214,165,255)"  "7507C"
#Pnt_7508C             = $8BC0E3;  $FF8BC0E3  "#E3C08B"  "rgb(227,192,139)"  "rgba(227,192,139,255)"  "7508C"
#Pnt_7509C             = $6DACD9;  $FF6DACD9  "#D9AC6D"  "rgb(217,172,109)"  "rgba(217,172,109,255)"  "7509C"
#Pnt_7510C             = $428FC8;  $FF428FC8  "#C88F42"  "rgb(200,143, 66)"  "rgba(200,143, 66,255)"  "7510C"
#Pnt_7511C             = $166FB2;  $FF166FB2  "#B26F16"  "rgb(178,111, 22)"  "rgba(178,111, 22,255)"  "7511C"
#Pnt_7512C             = $0F5CA0;  $FF0F5CA0  "#A05C0F"  "rgb(160, 92, 15)"  "rgba(160, 92, 15,255)"  "7512C"
#Pnt_7513C             = $AEBFE6;  $FFAEBFE6  "#E6BFAE"  "rgb(230,191,174)"  "rgba(230,191,174,255)"  "7513C"
#Pnt_7514C             = $90A8D7;  $FF90A8D7  "#D7A890"  "rgb(215,168,144)"  "rgba(215,168,144,255)"  "7514C"
#Pnt_7515C             = $7292C9;  $FF7292C9  "#C99272"  "rgb(201,146,114)"  "rgba(201,146,114,255)"  "7515C"
#Pnt_7516C             = $2E549A;  $FF2E549A  "#9A542E"  "rgb(154, 84, 46)"  "rgba(154, 84, 46,255)"  "7516C"
#Pnt_7517C             = $1E4285;  $FF1E4285  "#85421E"  "rgb(133, 66, 30)"  "rgba(133, 66, 30,255)"  "7517C"
#Pnt_7518C             = $47506D;  $FF47506D  "#6D5047"  "rgb(109, 80, 71)"  "rgba(109, 80, 71,255)"  "7518C"
#Pnt_7519C             = $455263;  $FF455263  "#635245"  "rgb( 99, 82, 69)"  "rgba( 99, 82, 69,255)"  "7519C"
#Pnt_7520C             = $B7C4EA;  $FFB7C4EA  "#EAC4B7"  "rgb(234,196,183)"  "rgba(234,196,183,255)"  "7520C"
#Pnt_7521C             = $93A6C6;  $FF93A6C6  "#C6A693"  "rgb(198,166,147)"  "rgba(198,166,147,255)"  "7521C"
#Pnt_7522C             = $5C73B6;  $FF5C73B6  "#B6735C"  "rgb(182,115, 92)"  "rgba(182,115, 92,255)"  "7522C"
#Pnt_7523C             = $5E67AC;  $FF5E67AC  "#AC675E"  "rgb(172,103, 94)"  "rgba(172,103, 94,255)"  "7523C"
#Pnt_7524C             = $4C59A5;  $FF4C59A5  "#A5594C"  "rgb(165, 89, 76)"  "rgba(165, 89, 76,255)"  "7524C"
#Pnt_7525C             = $516E9B;  $FF516E9B  "#9B6E51"  "rgb(155,110, 81)"  "rgba(155,110, 81,255)"  "7525C"
#Pnt_7526C             = $1E3C8D;  $FF1E3C8D  "#8D3C1E"  "rgb(141, 60, 30)"  "rgba(141, 60, 30,255)"  "7526C"
#Pnt_7527C             = $CBD7DA;  $FFCBD7DA  "#DAD7CB"  "rgb(218,215,203)"  "rgba(218,215,203,255)"  "7527C"
#Pnt_7528C             = $B6C0CA;  $FFB6C0CA  "#CAC0B6"  "rgb(202,192,182)"  "rgba(202,192,182,255)"  "7528C"
#Pnt_7529C             = $A6B1BD;  $FFA6B1BD  "#BDB1A6"  "rgb(189,177,166)"  "rgba(189,177,166,255)"  "7529C"
#Pnt_7530C             = $8F9CAA;  $FF8F9CAA  "#AA9C8F"  "rgb(170,156,143)"  "rgba(170,156,143,255)"  "7530C"
#Pnt_7531C             = $637385;  $FF637385  "#857363"  "rgb(133,115, 99)"  "rgba(133,115, 99,255)"  "7531C"
#Pnt_7532C             = $465566;  $FF465566  "#665546"  "rgb(102, 85, 70)"  "rgba(102, 85, 70,255)"  "7532C"
#Pnt_7533C             = $313C4A;  $FF313C4A  "#4A3C31"  "rgb( 74, 60, 49)"  "rgba( 74, 60, 49,255)"  "7533C"
#Pnt_7534C             = $C7D3D7;  $FFC7D3D7  "#D7D3C7"  "rgb(215,211,199)"  "rgba(215,211,199,255)"  "7534C"
#Pnt_7535C             = $A6B9BE;  $FFA6B9BE  "#BEB9A6"  "rgb(190,185,166)"  "rgba(190,185,166,255)"  "7535C"
#Pnt_7536C             = $8EA3AA;  $FF8EA3AA  "#AAA38E"  "rgb(170,163,142)"  "rgba(170,163,142,255)"  "7536C"
#Pnt_7537C             = $ABB4AE;  $FFABB4AE  "#AEB4AB"  "rgb(174,180,171)"  "rgba(174,180,171,255)"  "7537C"
#Pnt_7538C             = $99A29C;  $FF99A29C  "#9CA299"  "rgb(156,162,153)"  "rgba(156,162,153,255)"  "7538C"
#Pnt_7539C             = $979B98;  $FF979B98  "#989B97"  "rgb(152,155,151)"  "rgba(152,155,151,255)"  "7539C"
#Pnt_7540C             = $67615E;  $FF67615E  "#5E6167"  "rgb( 94, 97,103)"  "rgba( 94, 97,103,255)"  "7540C"
#Pnt_7541C             = $E6E6E0;  $FFE6E6E0  "#E0E6E6"  "rgb(224,230,230)"  "rgba(224,230,230,255)"  "7541C"
#Pnt_7542C             = $C6C0AC;  $FFC6C0AC  "#ACC0C6"  "rgb(172,192,198)"  "rgba(172,192,198,255)"  "7542C"
#Pnt_7543C             = $B5AEA4;  $FFB5AEA4  "#A4AEB5"  "rgb(164,174,181)"  "rgba(164,174,181,255)"  "7543C"
#Pnt_7544C             = $A09689;  $FFA09689  "#8996A0"  "rgb(137,150,160)"  "rgba(137,150,160,255)"  "7544C"
#Pnt_7545C             = $6F6251;  $FF6F6251  "#51626F"  "rgb( 81, 98,111)"  "rgba( 81, 98,111,255)"  "7545C"
#Pnt_7546C             = $584A39;  $FF584A39  "#394A58"  "rgb( 57, 74, 88)"  "rgba( 57, 74, 88,255)"  "7546C"
#Pnt_7547C             = $32271A;  $FF32271A  "#1A2732"  "rgb( 26, 39, 50)"  "rgba( 26, 39, 50,255)"  "7547C"
#Pnt_8003C             = $6E7A86;  $FF6E7A86  "#867A6E"  "rgb(134,122,110)"  "rgba(134,122,110,255)"  "8003C"
#Pnt_801C              = $D8B000;  $FFD8B000  "#00B0D8"  "rgb(  0,176,216)"  "rgba(  0,176,216,255)"  "801C"
#Pnt_802C              = $3CDB5A;  $FF3CDB5A  "#5ADB3C"  "rgb( 90,219, 60)"  "rgba( 90,219, 60,255)"  "802C"
#Pnt_8021C             = $6A7793;  $FF6A7793  "#93776A"  "rgb(147,119,106)"  "rgba(147,119,106,255)"  "8021C"
#Pnt_803C              = $18E8FF;  $FF18E8FF  "#FFE818"  "rgb(255,232, 24)"  "rgba(255,232, 24,255)"  "803C"
#Pnt_804C              = $3898FF;  $FF3898FF  "#FF9838"  "rgb(255,152, 56)"  "rgba(255,152, 56,255)"  "804C"
#Pnt_805C              = $5A53FF;  $FF5A53FF  "#FF535A"  "rgb(255, 83, 90)"  "rgba(255, 83, 90,255)"  "805C"
#Pnt_806C              = $A410FF;  $FFA410FF  "#FF10A4"  "rgb(255, 16,164)"  "rgba(255, 16,164,255)"  "806C"
#Pnt_8062C             = $7D7095;  $FF7D7095  "#95707D"  "rgb(149,112,125)"  "rgba(149,112,125,255)"  "8062C"
#Pnt_807C              = $B200D7;  $FFB200D7  "#D700B2"  "rgb(215,  0,178)"  "rgba(215,  0,178,255)"  "807C"
#Pnt_808C              = $8FB200;  $FF8FB200  "#00B28F"  "rgb(  0,178,143)"  "rgba(  0,178,143,255)"  "808C"
#Pnt_809C              = $00E0E2;  $FF00E0E2  "#E2E000"  "rgb(226,224,  0)"  "rgba(226,224,  0,255)"  "809C"
#Pnt_810C              = $0DC6FF;  $FF0DC6FF  "#FFC60D"  "rgb(255,198, 13)"  "rgba(255,198, 13,255)"  "810C"
#Pnt_8100C             = $8B7886;  $FF8B7886  "#86788B"  "rgb(134,120,139)"  "rgba(134,120,139,255)"  "8100C"
#Pnt_811C              = $3F66FF;  $FF3F66FF  "#FF663F"  "rgb(255,102, 63)"  "rgba(255,102, 63,255)"  "811C"
#Pnt_812C              = $6C25FF;  $FF6C25FF  "#FF256C"  "rgb(255, 37,108)"  "rgba(255, 37,108,255)"  "812C"
#Pnt_813C              = $AA05E9;  $FFAA05E9  "#E905AA"  "rgb(233,  5,170)"  "rgba(233,  5,170,255)"  "813C"
#Pnt_814C              = $CB5B7D;  $FFCB5B7D  "#7D5BCB"  "rgb(125, 91,203)"  "rgba(125, 91,203,255)"  "814C"
#Pnt_8201C             = $918062;  $FF918062  "#628091"  "rgb( 98,128,145)"  "rgba( 98,128,145,255)"  "8201C"
#Pnt_8281C             = $898B72;  $FF898B72  "#728B89"  "rgb(114,139,137)"  "rgba(114,139,137,255)"  "8281C"
#Pnt_8321C             = $738A7B;  $FF738A7B  "#7B8A73"  "rgb(123,138,115)"  "rgba(123,138,115,255)"  "8321C"
#Pnt_871C              = $4B7C90;  $FF4B7C90  "#907C4B"  "rgb(144,124, 75)"  "rgba(144,124, 75,255)"  "871C"
#Pnt_872C              = $4A748D;  $FF4A748D  "#8D744A"  "rgb(141,116, 74)"  "rgba(141,116, 74,255)"  "872C"
#Pnt_873C              = $4D7795;  $FF4D7795  "#95774D"  "rgb(149,119, 77)"  "rgba(149,119, 77,255)"  "873C"
#Pnt_874C              = $4D6E8E;  $FF4D6E8E  "#8E6E4D"  "rgb(142,110, 77)"  "rgba(142,110, 77,255)"  "874C"
#Pnt_875C              = $4B678C;  $FF4B678C  "#8C674B"  "rgb(140,103, 75)"  "rgba(140,103, 75,255)"  "875C"
#Pnt_876C              = $4B6694;  $FF4B6694  "#94664B"  "rgb(148,102, 75)"  "rgba(148,102, 75,255)"  "876C"
#Pnt_877C              = $8B8885;  $FF8B8885  "#85888B"  "rgb(133,136,139)"  "rgba(133,136,139,255)"  "877C"
#Pnt_Black2C           = $25363C;  $FF25363C  "#3C3625"  "rgb( 60, 54, 37)"  "rgba( 60, 54, 37,255)"  "Black2C"
#Pnt_Black3C           = $262C25;  $FF262C25  "#252C26"  "rgb( 37, 44, 38)"  "rgba( 37, 44, 38,255)"  "Black3C"
#Pnt_Black4C           = $242D38;  $FF242D38  "#382D24"  "rgb( 56, 45, 36)"  "rgba( 56, 45, 36,255)"  "Black4C"
#Pnt_Black5C           = $353144;  $FF353144  "#443135"  "rgb( 68, 49, 53)"  "rgba( 68, 49, 53,255)"  "Black5C"
#Pnt_Black6C           = $241C11;  $FF241C11  "#111C24"  "rgb( 17, 28, 36)"  "rgba( 17, 28, 36,255)"  "Black6C"
#Pnt_Black7C           = $343536;  $FF343536  "#363534"  "rgb( 54, 53, 52)"  "rgba( 54, 53, 52,255)"  "Black7C"
#Pnt_BlackC            = $23262A;  $FF23262A  "#2A2623"  "rgb( 42, 38, 35)"  "rgba( 42, 38, 35,255)"  "BlackC"
#Pnt_Blue72C           = $A81800;  $FFA81800  "#0018A8"  "rgb(  0, 24,168)"  "rgba(  0, 24,168,255)"  "Blue72C"
#Pnt_CoolGray1C        = $DDE1E0;  $FFDDE1E0  "#E0E1DD"  "rgb(224,225,221)"  "rgba(224,225,221,255)"  "CoolGray1C"
#Pnt_CoolGray10C       = $656361;  $FF656361  "#616365"  "rgb( 97, 99,101)"  "rgba( 97, 99,101,255)"  "CoolGray10C"
#Pnt_CoolGray11C       = $534F4D;  $FF534F4D  "#4D4F53"  "rgb( 77, 79, 83)"  "rgba( 77, 79, 83,255)"  "CoolGray11C"
#Pnt_CoolGray2C        = $D2D6D5;  $FFD2D6D5  "#D5D6D2"  "rgb(213,214,210)"  "rgba(213,214,210,255)"  "CoolGray2C"
#Pnt_CoolGray3C        = $C8CAC9;  $FFC8CAC9  "#C9CAC8"  "rgb(201,202,200)"  "rgba(201,202,200,255)"  "CoolGray3C"
#Pnt_CoolGray4C        = $BCBDBC;  $FFBCBDBC  "#BCBDBC"  "rgb(188,189,188)"  "rgba(188,189,188,255)"  "CoolGray4C"
#Pnt_CoolGray5C        = $B3B4B2;  $FFB3B4B2  "#B2B4B3"  "rgb(178,180,179)"  "rgba(178,180,179,255)"  "CoolGray5C"
#Pnt_CoolGray6C        = $AFAFAD;  $FFAFAFAD  "#ADAFAF"  "rgb(173,175,175)"  "rgba(173,175,175,255)"  "CoolGray6C"
#Pnt_CoolGray7C        = $9C9B9A;  $FF9C9B9A  "#9A9B9C"  "rgb(154,155,156)"  "rgba(154,155,156,255)"  "CoolGray7C"
#Pnt_CoolGray8C        = $8E8D8B;  $FF8E8D8B  "#8B8D8E"  "rgb(139,141,142)"  "rgba(139,141,142,255)"  "CoolGray8C"
#Pnt_CoolGray9C        = $787674;  $FF787674  "#747678"  "rgb(116,118,120)"  "rgba(116,118,120,255)"  "CoolGray9C"
#Pnt_GreenC            = $83AD00;  $FF83AD00  "#00AD83"  "rgb(  0,173,131)"  "rgba(  0,173,131,255)"  "GreenC"
#Pnt_HexachromeBlackC  = $212120;  $FF212120  "#202121"  "rgb( 32, 33, 33)"  "rgba( 32, 33, 33,255)"  "HexachromeBlackC"
#Pnt_HexachromeCyanC   = $D08F00;  $FFD08F00  "#008FD0"  "rgb(  0,143,208)"  "rgba(  0,143,208,255)"  "HexachromeCyanC"
#Pnt_HexachromeGreenC  = $4AB000;  $FF4AB000  "#00B04A"  "rgb(  0,176, 74)"  "rgba(  0,176, 74,255)"  "HexachromeGreenC"
#Pnt_HexachromeMagentaC= $9000DE;  $FF9000DE  "#DE0090"  "rgb(222,  0,144)"  "rgba(222,  0,144,255)"  "HexachromeMagentaC"
#Pnt_HexachromeOrangeC = $007CFF;  $FF007CFF  "#FF7C00"  "rgb(255,124,  0)"  "rgba(255,124,  0,255)"  "HexachromeOrangeC"
#Pnt_HexachromeYellowC = $00E0FF;  $FF00E0FF  "#FFE000"  "rgb(255,224,  0)"  "rgba(255,224,  0,255)"  "HexachromeYellowC"
#Pnt_Orange21C         = $0058FF;  $FF0058FF  "#FF5800"  "rgb(255, 88,  0)"  "rgba(255, 88,  0,255)"  "Orange21C"
#Pnt_ProcessBlackC     = $1E1E1E;  $FF1E1E1E  "#1E1E1E"  "rgb( 30, 30, 30)"  "rgba( 30, 30, 30,255)"  "ProcessBlackC"
#Pnt_ProcessBlueC      = $CE8800;  $FFCE8800  "#0088CE"  "rgb(  0,136,206)"  "rgba(  0,136,206,255)"  "ProcessBlueC"
#Pnt_ProcessCyanC      = $DA9F00;  $FFDA9F00  "#009FDA"  "rgb(  0,159,218)"  "rgba(  0,159,218,255)"  "ProcessCyanC"
#Pnt_ProcessMagentaC   = $7400D1;  $FF7400D1  "#D10074"  "rgb(209,  0,116)"  "rgba(209,  0,116,255)"  "ProcessMagentaC"
#Pnt_ProcessYellowC    = $00E3F9;  $FF00E3F9  "#F9E300"  "rgb(249,227,  0)"  "rgba(249,227,  0,255)"  "ProcessYellowC"
#Pnt_PurpleC           = $BB34B6;  $FFBB34B6  "#B634BB"  "rgb(182, 52,187)"  "rgba(182, 52,187,255)"  "PurpleC"
#Pnt_Red32C            = $3929ED;  $FF3929ED  "#ED2939"  "rgb(237, 41, 57)"  "rgba(237, 41, 57,255)"  "Red32C"
#Pnt_ReflexBlueC       = $952300;  $FF952300  "#002395"  "rgb(  0, 35,149)"  "rgba(  0, 35,149,255)"  "ReflexBlueC"
#Pnt_RhodamineRedC     = $9D11E0;  $FF9D11E0  "#E0119D"  "rgb(224, 17,157)"  "rgba(224, 17,157,255)"  "RhodamineRedC"
#Pnt_RubineRedC        = $5D00CA;  $FF5D00CA  "#CA005D"  "rgb(202,  0, 93)"  "rgba(202,  0, 93,255)"  "RubineRedC"
#Pnt_VioletC           = $A1084B;  $FFA1084B  "#4B08A1"  "rgb( 75,  8,161)"  "rgba( 75,  8,161,255)"  "VioletC"
#Pnt_WarmGray1C        = $D8DEE0;  $FFD8DEE0  "#E0DED8"  "rgb(224,222,216)"  "rgba(224,222,216,255)"  "WarmGray1C"
#Pnt_WarmGray10C       = $626A76;  $FF626A76  "#766A62"  "rgb(118,106, 98)"  "rgba(118,106, 98,255)"  "WarmGray10C"
#Pnt_WarmGray11C       = $535C67;  $FF535C67  "#675C53"  "rgb(103, 92, 83)"  "rgba(103, 92, 83,255)"  "WarmGray11C"
#Pnt_WarmGray2C        = $CAD2D5;  $FFCAD2D5  "#D5D2CA"  "rgb(213,210,202)"  "rgba(213,210,202,255)"  "WarmGray2C"
#Pnt_WarmGray3C        = $BAC2C7;  $FFBAC2C7  "#C7C2BA"  "rgb(199,194,186)"  "rgba(199,194,186,255)"  "WarmGray3C"
#Pnt_WarmGray4C        = $A9B1B7;  $FFA9B1B7  "#B7B1A9"  "rgb(183,177,169)"  "rgba(183,177,169,255)"  "WarmGray4C"
#Pnt_WarmGray5C        = $9FA7AE;  $FF9FA7AE  "#AEA79F"  "rgb(174,167,159)"  "rgba(174,167,159,255)"  "WarmGray5C"
#Pnt_WarmGray6C        = $959DA5;  $FF959DA5  "#A59D95"  "rgb(165,157,149)"  "rgba(165,157,149,255)"  "WarmGray6C"
#Pnt_WarmGray7C        = $868F98;  $FF868F98  "#988F86"  "rgb(152,143,134)"  "rgba(152,143,134,255)"  "WarmGray7C"
#Pnt_WarmGray8C        = $78818B;  $FF78818B  "#8B8178"  "rgb(139,129,120)"  "rgba(139,129,120,255)"  "WarmGray8C"
#Pnt_WarmGray9C        = $6F7882;  $FF6F7882  "#82786F"  "rgb(130,120,111)"  "rgba(130,120,111,255)"  "WarmGray9C"
#Pnt_WarmRedC          = $3A40F7;  $FF3A40F7  "#F7403A"  "rgb(247, 64, 58)"  "rgba(247, 64, 58,255)"  "WarmRedC"
#Pnt_Yellow12C         = $00D5FF;  $FF00D5FF  "#FFD500"  "rgb(255,213,  0)"  "rgba(255,213,  0,255)"  "Yellow12C"
#Pnt_YellowC           = $00DFFE;  $FF00DFFE  "#FEDF00"  "rgb(254,223,  0)"  "rgba(254,223,  0,255)"  "YellowC"
#Pnt_11_0104      = $DFEFEF;  $FFDFEFEF  "#EFEFDF"  "rgb(239,239,223)"  "rgba(239,239,223,255)"  "11-0104TPX_VanillaIce"
#Pnt_11_0105      = $D7EAEF;  $FFD7EAEF  "#EFEAD7"  "rgb(239,234,215)"  "rgba(239,234,215,255)"  "11-0105TPX_AntiqueWhite"
#Pnt_11_0107      = $DCEFF2;  $FFDCEFF2  "#F2EFDC"  "rgb(242,239,220)"  "rgba(242,239,220,255)"  "11-0107TPX_Papyrus"
#Pnt_11_0205      = $D5EFEF;  $FFD5EFEF  "#EFEFD5"  "rgb(239,239,213)"  "rgba(239,239,213,255)"  "11-0205TPX_GlassGreen"
#Pnt_11_0304      = $DAE6DF;  $FFDAE6DF  "#DFE6DA"  "rgb(223,230,218)"  "rgba(223,230,218,255)"  "11-0304TPX_WaterLily"
#Pnt_11_0410      = $CEEAE8;  $FFCEEAE8  "#E8EACE"  "rgb(232,234,206)"  "rgba(232,234,206,255)"  "11-0410TPX_SylvanGreen"
#Pnt_11_0507      = $D8EDF2;  $FFD8EDF2  "#F2EDD8"  "rgb(242,237,216)"  "rgba(242,237,216,255)"  "11-0507TPX_WinterWhite"
#Pnt_11_0510      = $D3EEF5;  $FFD3EEF5  "#F5EED3"  "rgb(245,238,211)"  "rgba(245,238,211,255)"  "11-0510TPX_Afterglow"
#Pnt_11_0603      = $D9DFE7;  $FFD9DFE7  "#E7DFD9"  "rgb(231,223,217)"  "rgba(231,223,217,255)"  "11-0603TPX_PastelParchment"
#Pnt_11_0605      = $E0E8F1;  $FFE0E8F1  "#F1E8E0"  "rgb(241,232,224)"  "rgba(241,232,224,255)"  "11-0605TPX_JetStream"
#Pnt_11_0606      = $E1EDF0;  $FFE1EDF0  "#F0EDE1"  "rgb(240,237,225)"  "rgba(240,237,225,255)"  "11-0606TPX_Pristine"
#Pnt_11_0609      = $D0EFEF;  $FFD0EFEF  "#EFEFD0"  "rgb(239,239,208)"  "rgba(239,239,208,255)"  "11-0609TPX_EtherealGreen"
#Pnt_11_0615      = $D7EEF4;  $FFD7EEF4  "#F4EED7"  "rgb(244,238,215)"  "rgba(244,238,215,255)"  "11-0615TPX_PearSorbet"
#Pnt_11_0616      = $ADE6F3;  $FFADE6F3  "#F3E6AD"  "rgb(243,230,173)"  "rgba(243,230,173,255)"  "11-0616TPX_PastelYellow"
#Pnt_11_0617      = $C4EEF6;  $FFC4EEF6  "#F6EEC4"  "rgb(246,238,196)"  "rgba(246,238,196,255)"  "11-0617TPX_TransparentYellow"
#Pnt_11_0618      = $B0EEF0;  $FFB0EEF0  "#F0EEB0"  "rgb(240,238,176)"  "rgba(240,238,176,255)"  "11-0618TPX_WaxYellow"
#Pnt_11_0619      = $CBEBF6;  $FFCBEBF6  "#F6EBCB"  "rgb(246,235,203)"  "rgba(246,235,203,255)"  "11-0619TPX_Flan"
#Pnt_11_0620      = $98EDEF;  $FF98EDEF  "#EFED98"  "rgb(239,237,152)"  "rgba(239,237,152,255)"  "11-0620TPX_ElfinYellow"
#Pnt_11_0622      = $B9EBED;  $FFB9EBED  "#EDEBB9"  "rgb(237,235,185)"  "rgba(237,235,185,255)"  "11-0622TPX_YellowIris"
#Pnt_11_0701      = $E2EDF0;  $FFE2EDF0  "#F0EDE2"  "rgb(240,237,226)"  "rgba(240,237,226,255)"  "11-0701TPX_WhisperWhite"
#Pnt_11_0710      = $B2EEEF;  $FFB2EEEF  "#EFEEB2"  "rgb(239,238,178)"  "rgba(239,238,178,255)"  "11-0710TPX_TenderYellow"
#Pnt_11_0809      = $D1E4F2;  $FFD1E4F2  "#F2E4D1"  "rgb(242,228,209)"  "rgba(242,228,209,255)"  "11-0809TPX_Ecru"
#Pnt_11_0907      = $D2E4F0;  $FFD2E4F0  "#F0E4D2"  "rgb(240,228,210)"  "rgba(240,228,210,255)"  "11-0907TPX_PearledIvory"
#Pnt_11_1001      = $E8ECF3;  $FFE8ECF3  "#F3ECE8"  "rgb(243,236,232)"  "rgba(243,236,232,255)"  "11-1001TPX_WhiteAlyssum"
#Pnt_11_1005      = $E1E6ED;  $FFE1E6ED  "#EDE6E1"  "rgb(237,230,225)"  "rgba(237,230,225,255)"  "11-1005TPX_BridalBlush"
#Pnt_11_1305      = $DCE5F4;  $FFDCE5F4  "#F4E5DC"  "rgb(244,229,220)"  "rgba(244,229,220,255)"  "11-1305TPX_AngelWing"
#Pnt_11_1306      = $DCE5F3;  $FFDCE5F3  "#F3E5DC"  "rgb(243,229,220)"  "rgba(243,229,220,255)"  "11-1306TPX_CreamPink"
#Pnt_11_1404      = $E1E9F3;  $FFE1E9F3  "#F3E9E1"  "rgb(243,233,225)"  "rgba(243,233,225,255)"  "11-1404TPX_PowderPuff"
#Pnt_11_1408      = $DBDDF3;  $FFDBDDF3  "#F3DDDB"  "rgb(243,221,219)"  "rgba(243,221,219,255)"  "11-1408TPX_Rosewater"
#Pnt_11_2309      = $E6E9F4;  $FFE6E9F4  "#F4E9E6"  "rgb(244,233,230)"  "rgba(244,233,230,255)"  "11-2309TPX_PetalPink"
#Pnt_11_2409      = $E5E6EF;  $FFE5E6EF  "#EFE6E5"  "rgb(239,230,229)"  "rgba(239,230,229,255)"  "11-2409TPX_Delicacy"
#Pnt_11_2511      = $E6E1F2;  $FFE6E1F2  "#F2E1E6"  "rgb(242,225,230)"  "rgba(242,225,230,255)"  "11-2511TPX_ShrinkingViolet"
#Pnt_11_4202      = $ECEFED;  $FFECEFED  "#EDEFEC"  "rgb(237,239,236)"  "rgba(237,239,236,255)"  "11-4202TPX_StarWhite"
#Pnt_11_4301      = $E2E7E6;  $FFE2E7E6  "#E6E7E2"  "rgb(230,231,226)"  "rgba(230,231,226,255)"  "11-4301TPX_LilyWhite"
#Pnt_11_4303      = $E5EAE6;  $FFE5EAE6  "#E6EAE5"  "rgb(230,234,229)"  "rgba(230,234,229,255)"  "11-4303TPX_MysticBlue"
#Pnt_11_4601      = $ECEBE5;  $FFECEBE5  "#E5EBEC"  "rgb(229,235,236)"  "rgba(229,235,236,255)"  "11-4601TPX_BitOfBlue"
#Pnt_11_4604      = $E9EADF;  $FFE9EADF  "#DFEAE9"  "rgb(223,234,233)"  "rgba(223,234,233,255)"  "11-4604TPX_BillowingSail"
#Pnt_11_4802      = $E6EBE5;  $FFE6EBE5  "#E5EBE6"  "rgb(229,235,230)"  "rgba(229,235,230,255)"  "11-4802TPX_SummerShower"
#Pnt_11_4803      = $E2EBE5;  $FFE2EBE5  "#E5EBE2"  "rgb(229,235,226)"  "rgba(229,235,226,255)"  "11-4803TPX_Ice"
#Pnt_11_4804      = $E4EDE6;  $FFE4EDE6  "#E6EDE4"  "rgb(230,237,228)"  "rgba(230,237,228,255)"  "11-4804TPX_LightestSky"
#Pnt_11_4805      = $E8EDDD;  $FFE8EDDD  "#DDEDE8"  "rgb(221,237,232)"  "rgba(221,237,232,255)"  "11-4805TPX_HintOfMint"
#Pnt_12_0000      = $C9DAE4;  $FFC9DAE4  "#E4DAC9"  "rgb(228,218,201)"  "rgba(228,218,201,255)"  "12-0000TPX_WhiteSwan"
#Pnt_12_0104      = $CCDFE2;  $FFCCDFE2  "#E2DFCC"  "rgb(226,223,204)"  "rgba(226,223,204,255)"  "12-0104TPX_WhiteAsparagus"
#Pnt_12_0105      = $C2D4D8;  $FFC2D4D8  "#D8D4C2"  "rgb(216,212,194)"  "rgba(216,212,194,255)"  "12-0105TPX_BoneWhite"
#Pnt_12_0106      = $C5DFD5;  $FFC5DFD5  "#D5DFC5"  "rgb(213,223,197)"  "rgba(213,223,197,255)"  "12-0106TPX_MeadowMist"
#Pnt_12_0108      = $CEE2D9;  $FFCEE2D9  "#D9E2CE"  "rgb(217,226,206)"  "rgba(217,226,206,255)"  "12-0108TPX_CanaryGreen"
#Pnt_12_0109      = $CDE9D8;  $FFCDE9D8  "#D8E9CD"  "rgb(216,233,205)"  "rgba(216,233,205,255)"  "12-0109TPX_Ambrosia"
#Pnt_12_0225      = $AFEAB3;  $FFAFEAB3  "#B3EAAF"  "rgb(179,234,175)"  "rgba(179,234,175,255)"  "12-0225TPX_PatinaGreen"
#Pnt_12_0304      = $CAD9E2;  $FFCAD9E2  "#E2D9CA"  "rgb(226,217,202)"  "rgba(226,217,202,255)"  "12-0304TPX_WhitecapGray"
#Pnt_12_0311      = $B8D5D5;  $FFB8D5D5  "#D5D5B8"  "rgb(213,213,184)"  "rgba(213,213,184,255)"  "12-0311TPX_AsparagusGreen"
#Pnt_12_0312      = $C0ECDD;  $FFC0ECDD  "#DDECC0"  "rgb(221,236,192)"  "rgba(221,236,192,255)"  "12-0312TPX_LimeCream"
#Pnt_12_0313      = $B4DDCC;  $FFB4DDCC  "#CCDDB4"  "rgb(204,221,180)"  "rgba(204,221,180,255)"  "12-0313TPX_SeafoamGreen"
#Pnt_12_0315      = $B4DFD6;  $FFB4DFD6  "#D6DFB4"  "rgb(214,223,180)"  "rgba(214,223,180,255)"  "12-0315TPX_WhiteJade"
#Pnt_12_0317      = $B2D4C2;  $FFB2D4C2  "#C2D4B2"  "rgb(194,212,178)"  "rgba(194,212,178,255)"  "12-0317TPX_Gleam"
#Pnt_12_0322      = $A1DFCA;  $FFA1DFCA  "#CADFA1"  "rgb(202,223,161)"  "rgba(202,223,161,255)"  "12-0322TPX_Butterfly"
#Pnt_12_0404      = $CED9DB;  $FFCED9DB  "#DBD9CE"  "rgb(219,217,206)"  "rgba(219,217,206,255)"  "12-0404TPX_LightGray"
#Pnt_12_0418      = $A5CED4;  $FFA5CED4  "#D4CEA5"  "rgb(212,206,165)"  "rgba(212,206,165,255)"  "12-0418TPX_Hay"
#Pnt_12_0426      = $8ED7D3;  $FF8ED7D3  "#D3D78E"  "rgb(211,215,142)"  "rgba(211,215,142,255)"  "12-0426TPX_MellowGreen"
#Pnt_12_0435      = $7AD9CC;  $FF7AD9CC  "#CCD97A"  "rgb(204,217,122)"  "rgba(204,217,122,255)"  "12-0435TPX_DaiquiriGreen"
#Pnt_12_0520      = $A6EDEA;  $FFA6EDEA  "#EAEDA6"  "rgb(234,237,166)"  "rgba(234,237,166,255)"  "12-0520TPX_PaleLimeYellow"
#Pnt_12_0521      = $A7E3E2;  $FFA7E3E2  "#E2E3A7"  "rgb(226,227,167)"  "rgba(226,227,167,255)"  "12-0521TPX_YoungWheat"
#Pnt_12_0524      = $9CE0E0;  $FF9CE0E0  "#E0E09C"  "rgb(224,224,156)"  "rgba(224,224,156,255)"  "12-0524TPX_Citron"
#Pnt_12_0525      = $A6ECE3;  $FFA6ECE3  "#E3ECA6"  "rgb(227,236,166)"  "rgba(227,236,166,255)"  "12-0525TPX_LuminaryGreen"
#Pnt_12_0530      = $8DE8E7;  $FF8DE8E7  "#E7E88D"  "rgb(231,232,141)"  "rgba(231,232,141,255)"  "12-0530TPX_Charlock"
#Pnt_12_0601      = $D6E3EC;  $FFD6E3EC  "#ECE3D6"  "rgb(236,227,214)"  "rgba(236,227,214,255)"  "12-0601TPX_Eggnog"
#Pnt_12_0605      = $BED5DF;  $FFBED5DF  "#DFD5BE"  "rgb(223,213,190)"  "rgba(223,213,190,255)"  "12-0605TPX_Angora"
#Pnt_12_0607      = $C8E8E7;  $FFC8E8E7  "#E7E8C8"  "rgb(231,232,200)"  "rgba(231,232,200,255)"  "12-0607TPX_GreenEssence"
#Pnt_12_0619      = $9CD0D5;  $FF9CD0D5  "#D5D09C"  "rgb(213,208,156)"  "rgba(213,208,156,255)"  "12-0619TPX_DustyYellow"
#Pnt_12_0626      = $90D5DB;  $FF90D5DB  "#DBD590"  "rgb(219,213,144)"  "rgba(219,213,144,255)"  "12-0626TPX_LemonGrass"
#Pnt_12_0633      = $7DDEE1;  $FF7DDEE1  "#E1DE7D"  "rgb(225,222,125)"  "rgba(225,222,125,255)"  "12-0633TPX_CanaryYellow"
#Pnt_12_0642      = $5BDFF4;  $FF5BDFF4  "#F4DF5B"  "rgb(244,223, 91)"  "rgba(244,223, 91,255)"  "12-0642TPX_Aurora"
#Pnt_12_0643      = $2CE7F8;  $FF2CE7F8  "#F8E72C"  "rgb(248,231, 44)"  "rgba(248,231, 44,255)"  "12-0643TPX_BlazingYellow"
#Pnt_12_0703      = $C6DDE4;  $FFC6DDE4  "#E4DDC6"  "rgb(228,221,198)"  "rgba(228,221,198,255)"  "12-0703TPX_Seedpearl"
#Pnt_12_0704      = $CCE0ED;  $FFCCE0ED  "#EDE0CC"  "rgb(237,224,204)"  "rgba(237,224,204,255)"  "12-0704TPX_WhiteSmoke"
#Pnt_12_0709      = $BBD6EA;  $FFBBD6EA  "#EAD6BB"  "rgb(234,214,187)"  "rgba(234,214,187,255)"  "12-0709TPX_Macadamia"
#Pnt_12_0710      = $C7E2F0;  $FFC7E2F0  "#F0E2C7"  "rgb(240,226,199)"  "rgba(240,226,199,255)"  "12-0710TPX_Navajo"
#Pnt_12_0711      = $BEEAF6;  $FFBEEAF6  "#F6EABE"  "rgb(246,234,190)"  "rgba(246,234,190,255)"  "12-0711TPX_LemonMeringue"
#Pnt_12_0712      = $C6E7F4;  $FFC6E7F4  "#F4E7C6"  "rgb(244,231,198)"  "rgba(244,231,198,255)"  "12-0712TPX_Vanilla"
#Pnt_12_0713      = $C2E8F2;  $FFC2E8F2  "#F2E8C2"  "rgb(242,232,194)"  "rgba(242,232,194,255)"  "12-0713TPX_AlmondOil"
#Pnt_12_0714      = $B3DBF4;  $FFB3DBF4  "#F4DBB3"  "rgb(244,219,179)"  "rgba(244,219,179,255)"  "12-0714TPX_Cornhusk"
#Pnt_12_0715      = $ADE1F4;  $FFADE1F4  "#F4E1AD"  "rgb(244,225,173)"  "rgba(244,225,173,255)"  "12-0715TPX_DoubleCream"
#Pnt_12_0717      = $CCEAF5;  $FFCCEAF5  "#F5EACC"  "rgb(245,234,204)"  "rgba(245,234,204,255)"  "12-0717TPX_AniseFlower"
#Pnt_12_0718      = $B7DAF0;  $FFB7DAF0  "#F0DAB7"  "rgb(240,218,183)"  "rgba(240,218,183,255)"  "12-0718TPX_PineappleSlice"
#Pnt_12_0720      = $9CDEF1;  $FF9CDEF1  "#F1DE9C"  "rgb(241,222,156)"  "rgba(241,222,156,255)"  "12-0720TPX_MellowYellow"
#Pnt_12_0721      = $9AE8F2;  $FF9AE8F2  "#F2E89A"  "rgb(242,232,154)"  "rgba(242,232,154,255)"  "12-0721TPX_Lemonade"
#Pnt_12_0722      = $A5E1F0;  $FFA5E1F0  "#F0E1A5"  "rgb(240,225,165)"  "rgba(240,225,165,255)"  "12-0722TPX_FrenchVanilla"
#Pnt_12_0727      = $82E1FD;  $FF82E1FD  "#FDE182"  "rgb(253,225,130)"  "rgba(253,225,130,255)"  "12-0727TPX_Sunshine"
#Pnt_12_0729      = $B2D9F4;  $FFB2D9F4  "#F4D9B2"  "rgb(244,217,178)"  "rgba(244,217,178,255)"  "12-0729TPX_Sundress"
#Pnt_12_0736      = $74D9F8;  $FF74D9F8  "#F8D974"  "rgb(248,217,116)"  "rgba(248,217,116,255)"  "12-0736TPX_LemonDrop"
#Pnt_12_0737      = $A6E8F7;  $FFA6E8F7  "#F7E8A6"  "rgb(247,232,166)"  "rgba(247,232,166,255)"  "12-0737TPX_Goldfinch"
#Pnt_12_0738      = $6DDBF1;  $FF6DDBF1  "#F1DB6D"  "rgb(241,219,109)"  "rgba(241,219,109,255)"  "12-0738TPX_YellowCream"
#Pnt_12_0740      = $7CEDF3;  $FF7CEDF3  "#F3ED7C"  "rgb(243,237,124)"  "rgba(243,237,124,255)"  "12-0740TPX_Limelight"
#Pnt_12_0741      = $83EEE2;  $FF83EEE2  "#E2EE83"  "rgb(226,238,131)"  "rgba(226,238,131,255)"  "12-0741TPX_SunnyLime"
#Pnt_12_0752      = $37E3FB;  $FF37E3FB  "#FBE337"  "rgb(251,227, 55)"  "rgba(251,227, 55,255)"  "12-0752TPX_Buttercup"
#Pnt_12_0758      = $9CE1FB;  $FF9CE1FB  "#FBE19C"  "rgb(251,225,156)"  "rgba(251,225,156,255)"  "12-0758TPX_Yarrow"
#Pnt_12_0804      = $C7E1E8;  $FFC7E1E8  "#E8E1C7"  "rgb(232,225,199)"  "rgba(232,225,199,255)"  "12-0804TPX_CloudCream"
#Pnt_12_0806      = $BFE2EC;  $FFBFE2EC  "#ECE2BF"  "rgb(236,226,191)"  "rgba(236,226,191,255)"  "12-0806TPX_Rutabaga"
#Pnt_12_0807      = $BFD4EB;  $FFBFD4EB  "#EBD4BF"  "rgb(235,212,191)"  "rgba(235,212,191,255)"  "12-0807TPX_SunKiss"
#Pnt_12_0811      = $BCD9F0;  $FFBCD9F0  "#F0D9BC"  "rgb(240,217,188)"  "rgba(240,217,188,255)"  "12-0811TPX_Dawn"
#Pnt_12_0812      = $BFE1F0;  $FFBFE1F0  "#F0E1BF"  "rgb(240,225,191)"  "rgba(240,225,191,255)"  "12-0812TPX_AlabasterGleam"
#Pnt_12_0813      = $B4D6F1;  $FFB4D6F1  "#F1D6B4"  "rgb(241,214,180)"  "rgba(241,214,180,255)"  "12-0813TPX_AutumnBlonde"
#Pnt_12_0815      = $BEE5F1;  $FFBEE5F1  "#F1E5BE"  "rgb(241,229,190)"  "rgba(241,229,190,255)"  "12-0815TPX_VanillaCustard"
#Pnt_12_0817      = $A6D5F1;  $FFA6D5F1  "#F1D5A6"  "rgb(241,213,166)"  "rgba(241,213,166,255)"  "12-0817TPX_ApricotGelato"
#Pnt_12_0822      = $9ED2F7;  $FF9ED2F7  "#F7D29E"  "rgb(247,210,158)"  "rgba(247,210,158,255)"  "12-0822TPX_GoldenFleece"
#Pnt_12_0824      = $97E3F9;  $FF97E3F9  "#F9E397"  "rgb(249,227,151)"  "rgba(249,227,151,255)"  "12-0824TPX_PaleBanana"
#Pnt_12_0825      = $8EE1F9;  $FF8EE1F9  "#F9E18E"  "rgb(249,225,142)"  "rgba(249,225,142,255)"  "12-0825TPX_Popcorn"
#Pnt_12_0826      = $95DBFC;  $FF95DBFC  "#FCDB95"  "rgb(252,219,149)"  "rgba(252,219,149,255)"  "12-0826TPX_GoldenHaze"
#Pnt_12_0910      = $B4D8E9;  $FFB4D8E9  "#E9D8B4"  "rgb(233,216,180)"  "rgba(233,216,180,255)"  "12-0910TPX_Lamb'SWool"
#Pnt_12_0911      = $BBD5F4;  $FFBBD5F4  "#F4D5BB"  "rgb(244,213,187)"  "rgba(244,213,187,255)"  "12-0911TPX_Nude"
#Pnt_12_0912      = $B8D6F8;  $FFB8D6F8  "#F8D6B8"  "rgb(248,214,184)"  "rgba(248,214,184,255)"  "12-0912TPX_TenderPeach"
#Pnt_12_0913      = $B5D0F4;  $FFB5D0F4  "#F4D0B5"  "rgb(244,208,181)"  "rgba(244,208,181,255)"  "12-0913TPX_Alesan"
#Pnt_12_0915      = $BBD1FB;  $FFBBD1FB  "#FBD1BB"  "rgb(251,209,187)"  "rgba(251,209,187,255)"  "12-0915TPX_PalePeach"
#Pnt_12_0917      = $B0D1FE;  $FFB0D1FE  "#FED1B0"  "rgb(254,209,176)"  "rgba(254,209,176,255)"  "12-0917TPX_BleachedApricot"
#Pnt_12_0921      = $8EBDE7;  $FF8EBDE7  "#E7BD8E"  "rgb(231,189,142)"  "rgba(231,189,142,255)"  "12-0921TPX_GoldenStraw"
#Pnt_12_1005      = $BFD4E9;  $FFBFD4E9  "#E9D4BF"  "rgb(233,212,191)"  "rgba(233,212,191,255)"  "12-1005TPX_NovellePeach"
#Pnt_12_1006      = $C7DAEB;  $FFC7DAEB  "#EBDAC7"  "rgb(235,218,199)"  "rgba(235,218,199,255)"  "12-1006TPX_MotherOfPearl"
#Pnt_12_1007      = $BDD1E8;  $FFBDD1E8  "#E8D1BD"  "rgb(232,209,189)"  "rgba(232,209,189,255)"  "12-1007TPX_PastelRoseTan"
#Pnt_12_1008      = $C3D8F0;  $FFC3D8F0  "#F0D8C3"  "rgb(240,216,195)"  "rgba(240,216,195,255)"  "12-1008TPX_Linen"
#Pnt_12_1009      = $CBDDF6;  $FFCBDDF6  "#F6DDCB"  "rgb(246,221,203)"  "rgba(246,221,203,255)"  "12-1009TPX_VanillaCream"
#Pnt_12_1010      = $CAD8F9;  $FFCAD8F9  "#F9D8CA"  "rgb(249,216,202)"  "rgba(249,216,202,255)"  "12-1010TPX_ScallopShell"
#Pnt_12_1011      = $B9D1F3;  $FFB9D1F3  "#F3D1B9"  "rgb(243,209,185)"  "rgba(243,209,185,255)"  "12-1011TPX_PeachPurée"
#Pnt_12_1106      = $E0EAF4;  $FFE0EAF4  "#F4EAE0"  "rgb(244,234,224)"  "rgba(244,234,224,255)"  "12-1106TPX_SheerPink"
#Pnt_12_1107      = $CFDDF1;  $FFCFDDF1  "#F1DDCF"  "rgb(241,221,207)"  "rgba(241,221,207,255)"  "12-1107TPX_PinkChampagne"
#Pnt_12_1108      = $D6E4EF;  $FFD6E4EF  "#EFE4D6"  "rgb(239,228,214)"  "rgba(239,228,214,255)"  "12-1108TPX_Dew"
#Pnt_12_1206      = $CAD4E9;  $FFCAD4E9  "#E9D4CA"  "rgb(233,212,202)"  "rgba(233,212,202,255)"  "12-1206TPX_SilverPeony"
#Pnt_12_1207      = $C8D1F3;  $FFC8D1F3  "#F3D1C8"  "rgb(243,209,200)"  "rgba(243,209,200,255)"  "12-1207TPX_PearlBlush"
#Pnt_12_1209      = $D0DCF2;  $FFD0DCF2  "#F2DCD0"  "rgb(242,220,208)"  "rgba(242,220,208,255)"  "12-1209TPX_SoftPink"
#Pnt_12_1212      = $CCD1F8;  $FFCCD1F8  "#F8D1CC"  "rgb(248,209,204)"  "rgba(248,209,204,255)"  "12-1212TPX_VeiledRose"
#Pnt_12_1304      = $DADDF5;  $FFDADDF5  "#F5DDDA"  "rgb(245,221,218)"  "rgba(245,221,218,255)"  "12-1304TPX_Pearl"
#Pnt_12_1305      = $E3E0F4;  $FFE3E0F4  "#F4E0E3"  "rgb(244,224,227)"  "rgba(244,224,227,255)"  "12-1305TPX_HeavenlyPink"
#Pnt_12_1310      = $E0D5F8;  $FFE0D5F8  "#F8D5E0"  "rgb(248,213,224)"  "rgba(248,213,224,255)"  "12-1310TPX_BlushingBride"
#Pnt_12_1403      = $BDD1DF;  $FFBDD1DF  "#DFD1BD"  "rgb(223,209,189)"  "rgba(223,209,189,255)"  "12-1403TPX_Tapioca"
#Pnt_12_1404      = $BECCDB;  $FFBECCDB  "#DBCCBE"  "rgb(219,204,190)"  "rgba(219,204,190,255)"  "12-1404TPX_PinkTint"
#Pnt_12_1605      = $D5D6EF;  $FFD5D6EF  "#EFD6D5"  "rgb(239,214,213)"  "rgba(239,214,213,255)"  "12-1605TPX_CrystalPink"
#Pnt_12_1706      = $D8D6F6;  $FFD8D6F6  "#F6D6D8"  "rgb(246,214,216)"  "rgba(246,214,216,255)"  "12-1706TPX_PinkDogwood"
#Pnt_12_1708      = $CBC8F9;  $FFCBC8F9  "#F9C8CB"  "rgb(249,200,203)"  "rgba(249,200,203,255)"  "12-1708TPX_CrystalRose"
#Pnt_12_2102      = $DBDBEB;  $FFDBDBEB  "#EBDBDB"  "rgb(235,219,219)"  "rgba(235,219,219,255)"  "12-2102TPX_MauveMorn"
#Pnt_12_2103      = $DFE1EB;  $FFDFE1EB  "#EBE1DF"  "rgb(235,225,223)"  "rgba(235,225,223,255)"  "12-2103TPX_AlmostMauve"
#Pnt_12_2902      = $D2D3E4;  $FFD2D3E4  "#E4D3D2"  "rgb(228,211,210)"  "rgba(228,211,210,255)"  "12-2902TPX_MauveChalk"
#Pnt_12_2903      = $D6C9E1;  $FFD6C9E1  "#E1C9D6"  "rgb(225,201,214)"  "rgba(225,201,214,255)"  "12-2903TPX_LightLilac"
#Pnt_12_2904      = $DDDAEF;  $FFDDDAEF  "#EFDADD"  "rgb(239,218,221)"  "rgba(239,218,221,255)"  "12-2904TPX_PrimrosePink"
#Pnt_12_2905      = $DED0EA;  $FFDED0EA  "#EAD0DE"  "rgb(234,208,222)"  "rgba(234,208,222,255)"  "12-2905TPX_CradlePink"
#Pnt_12_2906      = $E1DAF3;  $FFE1DAF3  "#F3DAE1"  "rgb(243,218,225)"  "rgba(243,218,225,255)"  "12-2906TPX_BarelyPink"
#Pnt_12_4302      = $DFE5E3;  $FFDFE5E3  "#E3E5DF"  "rgb(227,229,223)"  "rgba(227,229,223,255)"  "12-4302TPX_VaporousGray"
#Pnt_12_4304      = $E3E8E1;  $FFE3E8E1  "#E1E8E3"  "rgb(225,232,227)"  "rgba(225,232,227,255)"  "12-4304TPX_Bluewash"
#Pnt_12_4305      = $E2E4D7;  $FFE2E4D7  "#D7E4E2"  "rgb(215,228,226)"  "rgba(215,228,226,255)"  "12-4305TPX_SpaBlue"
#Pnt_12_4306      = $E1E2DE;  $FFE1E2DE  "#DEE2E1"  "rgb(222,226,225)"  "rgba(222,226,225,255)"  "12-4306TPX_BarelyBlue"
#Pnt_12_4604      = $E6E7D0;  $FFE6E7D0  "#D0E7E6"  "rgb(208,231,230)"  "rgba(208,231,230,255)"  "12-4604TPX_Skylight"
#Pnt_12_4607      = $DCD9BF;  $FFDCD9BF  "#BFD9DC"  "rgb(191,217,220)"  "rgba(191,217,220,255)"  "12-4607TPX_PastelBlue"
#Pnt_12_4608      = $E3D9AB;  $FFE3D9AB  "#ABD9E3"  "rgb(171,217,227)"  "rgba(171,217,227,255)"  "12-4608TPX_Clearwater"
#Pnt_12_4609      = $DCD2B5;  $FFDCD2B5  "#B5D2DC"  "rgb(181,210,220)"  "rgba(181,210,220,255)"  "12-4609TPX_StarlightBlue"
#Pnt_12_4610      = $E1E0CA;  $FFE1E0CA  "#CAE0E1"  "rgb(202,224,225)"  "rgba(202,224,225,255)"  "12-4610TPX_WhisperingBlue"
#Pnt_12_4705      = $DCDFD6;  $FFDCDFD6  "#D6DFDC"  "rgb(214,223,220)"  "rgba(214,223,220,255)"  "12-4705TPX_BlueBlush"
#Pnt_12_4805      = $E4E1CF;  $FFE4E1CF  "#CFE1E4"  "rgb(207,225,228)"  "rgba(207,225,228,255)"  "12-4805TPX_WanBlue"
#Pnt_12_4806      = $DADACA;  $FFDADACA  "#CADADA"  "rgb(202,218,218)"  "rgba(202,218,218,255)"  "12-4806TPX_ChalkBlue"
#Pnt_12_5201      = $D5E1DF;  $FFD5E1DF  "#DFE1D5"  "rgb(223,225,213)"  "rgba(223,225,213,255)"  "12-5201TPX_Icicle"
#Pnt_12_5202      = $C9DADF;  $FFC9DADF  "#DFDAC9"  "rgb(223,218,201)"  "rgba(223,218,201,255)"  "12-5202TPX_Turtledove"
#Pnt_12_5203      = $D9DED4;  $FFD9DED4  "#D4DED9"  "rgb(212,222,217)"  "rgba(212,222,217,255)"  "12-5203TPX_Murmur"
#Pnt_12_5204      = $DCE0CC;  $FFDCE0CC  "#CCE0DC"  "rgb(204,224,220)"  "rgba(204,224,220,255)"  "12-5204TPX_MorningMist"
#Pnt_12_5206      = $E3E2C6;  $FFE3E2C6  "#C6E2E3"  "rgb(198,226,227)"  "rgba(198,226,227,255)"  "12-5206TPX_BlueGlass"
#Pnt_12_5209      = $E7EDC9;  $FFE7EDC9  "#C9EDE7"  "rgb(201,237,231)"  "rgba(201,237,231,255)"  "12-5209TPX_SoothingSea"
#Pnt_12_5303      = $D7DBCD;  $FFD7DBCD  "#CDDBD7"  "rgb(205,219,215)"  "rgba(205,219,215,255)"  "12-5303TPX_SproutGreen"
#Pnt_12_5403      = $DADED2;  $FFDADED2  "#D2DEDA"  "rgb(210,222,218)"  "rgba(210,222,218,255)"  "12-5403TPX_BlueFlower"
#Pnt_12_5404      = $DCE8E3;  $FFDCE8E3  "#E3E8DC"  "rgb(227,232,220)"  "rgba(227,232,220,255)"  "12-5404TPX_WhisperGreen"
#Pnt_12_5406      = $DAE2C6;  $FFDAE2C6  "#C6E2DA"  "rgb(198,226,218)"  "rgba(198,226,218,255)"  "12-5406TPX_OpalBlue"
#Pnt_12_5407      = $E2ECD7;  $FFE2ECD7  "#D7ECE2"  "rgb(215,236,226)"  "rgba(215,236,226,255)"  "12-5407TPX_AquaGlass"
#Pnt_12_5408      = $DFE7C4;  $FFDFE7C4  "#C4E7DF"  "rgb(196,231,223)"  "rgba(196,231,223,255)"  "12-5408TPX_MoonlightJade"
#Pnt_12_5409      = $E3E9BF;  $FFE3E9BF  "#BFE9E3"  "rgb(191,233,227)"  "rgba(191,233,227,255)"  "12-5409TPX_FairAqua"
#Pnt_12_5410      = $E2E4B6;  $FFE2E4B6  "#B6E4E2"  "rgb(182,228,226)"  "rgba(182,228,226,255)"  "12-5410TPX_BleachedAqua"
#Pnt_12_5504      = $D9E5CF;  $FFD9E5CF  "#CFE5D9"  "rgb(207,229,217)"  "rgba(207,229,217,255)"  "12-5504TPX_ClearlyAqua"
#Pnt_12_5505      = $D9DEC5;  $FFD9DEC5  "#C5DED9"  "rgb(197,222,217)"  "rgba(197,222,217,255)"  "12-5505TPX_Glacier"
#Pnt_12_5506      = $D5E0C5;  $FFD5E0C5  "#C5E0D5"  "rgb(197,224,213)"  "rgba(197,224,213,255)"  "12-5506TPX_DustyAqua"
#Pnt_12_5507      = $DAEABF;  $FFDAEABF  "#BFEADA"  "rgb(191,234,218)"  "rgba(191,234,218,255)"  "12-5507TPX_Bay"
#Pnt_12_5508      = $E8ECDB;  $FFE8ECDB  "#DBECE8"  "rgb(219,236,232)"  "rgba(219,236,232,255)"  "12-5508TPX_HushedGreen"
#Pnt_12_5603      = $D5DDD5;  $FFD5DDD5  "#D5DDD5"  "rgb(213,221,213)"  "rgba(213,221,213,255)"  "12-5603TPX_ZephyrBlue"
#Pnt_12_5808      = $D6E7BC;  $FFD6E7BC  "#BCE7D6"  "rgb(188,231,214)"  "rgba(188,231,214,255)"  "12-5808TPX_Honeydew"
#Pnt_12_6204      = $C8D7D7;  $FFC8D7D7  "#D7D7C8"  "rgb(215,215,200)"  "rgba(215,215,200,255)"  "12-6204TPX_SilverGreen"
#Pnt_12_6205      = $D1DBCE;  $FFD1DBCE  "#CEDBD1"  "rgb(206,219,209)"  "rgba(206,219,209,255)"  "12-6205TPX_MilkyGreen"
#Pnt_12_6206      = $D9E5DD;  $FFD9E5DD  "#DDE5D9"  "rgb(221,229,217)"  "rgba(221,229,217,255)"  "12-6206TPX_FairestJade"
#Pnt_12_6207      = $DCE6DD;  $FFDCE6DD  "#DDE6DC"  "rgb(221,230,220)"  "rgba(221,230,220,255)"  "12-6207TPX_Frost"
#Pnt_12_6208      = $D9E4DC;  $FFD9E4DC  "#DCE4D9"  "rgb(220,228,217)"  "rgba(220,228,217,255)"  "12-6208TPX_PhantomGreen"
#Pnt_13_0000      = $C9D1D6;  $FFC9D1D6  "#D6D1C9"  "rgb(214,209,201)"  "rgba(214,209,201,255)"  "13-0000TPX_Moonbeam"
#Pnt_13_0002      = $D4D7DC;  $FFD4D7DC  "#DCD7D4"  "rgb(220,215,212)"  "rgba(220,215,212,255)"  "13-0002TPX_WhiteSand"
#Pnt_13_0107      = $BFD2C2;  $FFBFD2C2  "#C2D2BF"  "rgb(194,210,191)"  "rgba(194,210,191,255)"  "13-0107TPX_Dewkist"
#Pnt_13_0111      = $B2D2C0;  $FFB2D2C0  "#C0D2B2"  "rgb(192,210,178)"  "rgba(192,210,178,255)"  "13-0111TPX_Seacrest"
#Pnt_13_0116      = $B2D7B4;  $FFB2D7B4  "#B4D7B2"  "rgb(180,215,178)"  "rgba(180,215,178,255)"  "13-0116TPX_PastelGreen"
#Pnt_13_0117      = $ADDDA0;  $FFADDDA0  "#A0DDAD"  "rgb(160,221,173)"  "rgba(160,221,173,255)"  "13-0117TPX_GreenAsh"
#Pnt_13_0210      = $B5CDC2;  $FFB5CDC2  "#C2CDB5"  "rgb(194,205,181)"  "rgba(194,205,181,255)"  "13-0210TPX_FogGreen"
#Pnt_13_0212      = $B5D1C7;  $FFB5D1C7  "#C7D1B5"  "rgb(199,209,181)"  "rgba(199,209,181,255)"  "13-0212TPX_TenderGreens"
#Pnt_13_0215      = $A5D5C2;  $FFA5D5C2  "#C2D5A5"  "rgb(194,213,165)"  "rgba(194,213,165,255)"  "13-0215TPX_Reed"
#Pnt_13_0220      = $A0EBB6;  $FFA0EBB6  "#B6EBA0"  "rgb(182,235,160)"  "rgba(182,235,160,255)"  "13-0220TPX_ParadiseGreen"
#Pnt_13_0221      = $9FDBAE;  $FF9FDBAE  "#AEDB9F"  "rgb(174,219,159)"  "rgba(174,219,159,255)"  "13-0221TPX_PistachioGreen"
#Pnt_13_0317      = $99D4C6;  $FF99D4C6  "#C6D499"  "rgb(198,212,153)"  "rgba(198,212,153,255)"  "13-0317TPX_LilyGreen"
#Pnt_13_0319      = $9BE2D4;  $FF9BE2D4  "#D4E29B"  "rgb(212,226,155)"  "rgba(212,226,155,255)"  "13-0319TPX_ShadowLime"
#Pnt_13_0324      = $8ED5BF;  $FF8ED5BF  "#BFD58E"  "rgb(191,213,142)"  "rgba(191,213,142,255)"  "13-0324TPX_LettuceGreen"
#Pnt_13_0331      = $84D2B6;  $FF84D2B6  "#B6D284"  "rgb(182,210,132)"  "rgba(182,210,132,255)"  "13-0331TPX_SapGreen"
#Pnt_13_0333      = $8CD4DF;  $FF8CD4DF  "#DFD48C"  "rgb(223,212,140)"  "rgba(223,212,140,255)"  "13-0333TPX_LimaBean"
#Pnt_13_0401      = $B5C5CC;  $FFB5C5CC  "#CCC5B5"  "rgb(204,197,181)"  "rgba(204,197,181,255)"  "13-0401TPX_Oatmeal"
#Pnt_13_0403      = $B5C0C7;  $FFB5C0C7  "#C7C0B5"  "rgb(199,192,181)"  "rgba(199,192,181,255)"  "13-0403TPX_GrayMorn"
#Pnt_13_0442      = $61CFB5;  $FF61CFB5  "#B5CF61"  "rgb(181,207, 97)"  "rgba(181,207, 97,255)"  "13-0442TPX_GreenGlow"
#Pnt_13_0513      = $B8D4DA;  $FFB8D4DA  "#DAD4B8"  "rgb(218,212,184)"  "rgba(218,212,184,255)"  "13-0513TPX_FrozenDew"
#Pnt_13_0522      = $94D0CE;  $FF94D0CE  "#CED094"  "rgb(206,208,148)"  "rgba(206,208,148,255)"  "13-0522TPX_PaleGreen"
#Pnt_13_0530      = $8BD7D2;  $FF8BD7D2  "#D2D78B"  "rgb(210,215,139)"  "rgba(210,215,139,255)"  "13-0530TPX_LimeSherbet"
#Pnt_13_0532      = $75CDC7;  $FF75CDC7  "#C7CD75"  "rgb(199,205,117)"  "rgba(199,205,117,255)"  "13-0532TPX_CeleryGreen"
#Pnt_13_0535      = $7DECCB;  $FF7DECCB  "#CBEC7D"  "rgb(203,236,125)"  "rgba(203,236,125,255)"  "13-0535TPX_SharpGreen"
#Pnt_13_0540      = $62D8CB;  $FF62D8CB  "#CBD862"  "rgb(203,216, 98)"  "rgba(203,216, 98,255)"  "13-0540TPX_WildLime"
#Pnt_13_0550      = $33D8BF;  $FF33D8BF  "#BFD833"  "rgb(191,216, 51)"  "rgba(191,216, 51,255)"  "13-0550TPX_LimePunch"
#Pnt_13_0607      = $B8CBD6;  $FFB8CBD6  "#D6CBB8"  "rgb(214,203,184)"  "rgba(214,203,184,255)"  "13-0607TPX_Fog"
#Pnt_13_0608      = $B4D3D0;  $FFB4D3D0  "#D0D3B4"  "rgb(208,211,180)"  "rgba(208,211,180,255)"  "13-0608TPX_AloeWash"
#Pnt_13_0611      = $B1D0D4;  $FFB1D0D4  "#D4D0B1"  "rgb(212,208,177)"  "rgba(212,208,177,255)"  "13-0611TPX_Moth"
#Pnt_13_0613      = $ACD0DC;  $FFACD0DC  "#DCD0AC"  "rgb(220,208,172)"  "rgba(220,208,172,255)"  "13-0613TPX_ChinoGreen"
#Pnt_13_0614      = $A9DBE0;  $FFA9DBE0  "#E0DBA9"  "rgb(224,219,169)"  "rgba(224,219,169,255)"  "13-0614TPX_GardenGlade"
#Pnt_13_0624      = $90D1D7;  $FF90D1D7  "#D7D190"  "rgb(215,209,144)"  "rgba(215,209,144,255)"  "13-0624TPX_GoldenMist"
#Pnt_13_0632      = $7DD3D8;  $FF7DD3D8  "#D8D37D"  "rgb(216,211,125)"  "rgba(216,211,125,255)"  "13-0632TPX_Endive"
#Pnt_13_0633      = $94DBE3;  $FF94DBE3  "#E3DB94"  "rgb(227,219,148)"  "rgba(227,219,148,255)"  "13-0633TPX_Chardonnay"
#Pnt_13_0640      = $61D1DD;  $FF61D1DD  "#DDD161"  "rgb(221,209, 97)"  "rgba(221,209, 97,255)"  "13-0640TPX_Acacia"
#Pnt_13_0645      = $5CDBD5;  $FF5CDBD5  "#D5DB5C"  "rgb(213,219, 92)"  "rgba(213,219, 92,255)"  "13-0645TPX_Limeade"
#Pnt_13_0648      = $4FD3DF;  $FF4FD3DF  "#DFD34F"  "rgb(223,211, 79)"  "rgba(223,211, 79,255)"  "13-0648TPX_GreenSheen"
#Pnt_13_0650      = $0DD7D3;  $FF0DD7D3  "#D3D70D"  "rgb(211,215, 13)"  "rgba(211,215, 13,255)"  "13-0650TPX_SulphurSpring"
#Pnt_13_0711      = $B1CED6;  $FFB1CED6  "#D6CEB1"  "rgb(214,206,177)"  "rgba(214,206,177,255)"  "13-0711TPX_Putty"
#Pnt_13_0715      = $A7CDDB;  $FFA7CDDB  "#DBCDA7"  "rgb(219,205,167)"  "rgba(219,205,167,255)"  "13-0715TPX_SeaMist"
#Pnt_13_0720      = $8BD9EA;  $FF8BD9EA  "#EAD98B"  "rgb(234,217,139)"  "rgba(234,217,139,255)"  "13-0720TPX_Custard"
#Pnt_13_0725      = $85CADE;  $FF85CADE  "#DECA85"  "rgb(222,202,133)"  "rgba(222,202,133,255)"  "13-0725TPX_Raffia"
#Pnt_13_0739      = $64C5E1;  $FF64C5E1  "#E1C564"  "rgb(225,197,100)"  "rgba(225,197,100,255)"  "13-0739TPX_CreamGold"
#Pnt_13_0746      = $41D0F2;  $FF41D0F2  "#F2D041"  "rgb(242,208, 65)"  "rgba(242,208, 65,255)"  "13-0746TPX_Maize"
#Pnt_13_0752      = $1AC7F5;  $FF1AC7F5  "#F5C71A"  "rgb(245,199, 26)"  "rgba(245,199, 26,255)"  "13-0752TPX_Lemon"
#Pnt_13_0755      = $55CFF3;  $FF55CFF3  "#F3CF55"  "rgb(243,207, 85)"  "rgba(243,207, 85,255)"  "13-0755TPX_PrimroseYellow"
#Pnt_13_0756      = $95E6F9;  $FF95E6F9  "#F9E695"  "rgb(249,230,149)"  "rgba(249,230,149,255)"  "13-0756TPX_LemonZest"
#Pnt_13_0758      = $00D1FF;  $FF00D1FF  "#FFD100"  "rgb(255,209,  0)"  "rgba(255,209,  0,255)"  "13-0758TPX_Dandelion"
#Pnt_13_0759      = $7ED5F6;  $FF7ED5F6  "#F6D57E"  "rgb(246,213,126)"  "rgba(246,213,126,255)"  "13-0759TPX_SolarPower"
#Pnt_13_0814      = $B1D8EB;  $FFB1D8EB  "#EBD8B1"  "rgb(235,216,177)"  "rgba(235,216,177,255)"  "13-0814TPX_SummerMelon"
#Pnt_13_0815      = $A8D5E8;  $FFA8D5E8  "#E8D5A8"  "rgb(232,213,168)"  "rgba(232,213,168,255)"  "13-0815TPX_BananaCrepe"
#Pnt_13_0822      = $A4DAF1;  $FFA4DAF1  "#F1DAA4"  "rgb(241,218,164)"  "rgba(241,218,164,255)"  "13-0822TPX_Sunlight"
#Pnt_13_0840      = $71DAFF;  $FF71DAFF  "#FFDA71"  "rgb(255,218,113)"  "rgba(255,218,113,255)"  "13-0840TPX_Snapdragon"
#Pnt_13_0850      = $58D8FF;  $FF58D8FF  "#FFD858"  "rgb(255,216, 88)"  "rgba(255,216, 88,255)"  "13-0850TPX_AspenGold"
#Pnt_13_0858      = $01DCFF;  $FF01DCFF  "#FFDC01"  "rgb(255,220,  1)"  "rgba(255,220,  1,255)"  "13-0858TPX_VibrantYellow"
#Pnt_13_0859      = $00C6FF;  $FF00C6FF  "#FFC600"  "rgb(255,198,  0)"  "rgba(255,198,  0,255)"  "13-0859TPX_LemonChrome"
#Pnt_13_0905      = $C8D7DF;  $FFC8D7DF  "#DFD7C8"  "rgb(223,215,200)"  "rgba(223,215,200,255)"  "13-0905TPX_Birch"
#Pnt_13_0907      = $BED0DB;  $FFBED0DB  "#DBD0BE"  "rgb(219,208,190)"  "rgba(219,208,190,255)"  "13-0907TPX_Sandshell"
#Pnt_13_0908      = $BDD2DD;  $FFBDD2DD  "#DDD2BD"  "rgb(221,210,189)"  "rgba(221,210,189,255)"  "13-0908TPX_Parchment"
#Pnt_13_0915      = $A2CDDE;  $FFA2CDDE  "#DECDA2"  "rgb(222,205,162)"  "rgba(222,205,162,255)"  "13-0915TPX_ReedYellow"
#Pnt_13_0916      = $A8D5EB;  $FFA8D5EB  "#EBD5A8"  "rgb(235,213,168)"  "rgba(235,213,168,255)"  "13-0916TPX_Chamomile"
#Pnt_13_0917      = $A3D6EC;  $FFA3D6EC  "#ECD6A3"  "rgb(236,214,163)"  "rgba(236,214,163,255)"  "13-0917TPX_ItalianStraw"
#Pnt_13_0922      = $91CBE3;  $FF91CBE3  "#E3CB91"  "rgb(227,203,145)"  "rgba(227,203,145,255)"  "13-0922TPX_Straw"
#Pnt_13_0932      = $74C3EE;  $FF74C3EE  "#EEC374"  "rgb(238,195,116)"  "rgba(238,195,116,255)"  "13-0932TPX_Cornsilk"
#Pnt_13_0935      = $7CCBFF;  $FF7CCBFF  "#FFCB7C"  "rgb(255,203,124)"  "rgba(255,203,124,255)"  "13-0935TPX_Flax"
#Pnt_13_0939      = $63BCF3;  $FF63BCF3  "#F3BC63"  "rgb(243,188, 99)"  "rgba(243,188, 99,255)"  "13-0939TPX_GoldenCream"
#Pnt_13_0940      = $68C6FA;  $FF68C6FA  "#FAC668"  "rgb(250,198,104)"  "rgba(250,198,104,255)"  "13-0940TPX_SunsetGold"
#Pnt_13_0941      = $72D3FF;  $FF72D3FF  "#FFD372"  "rgb(255,211,114)"  "rgba(255,211,114,255)"  "13-0941TPX_BananaCream"
#Pnt_13_0942      = $55B7FB;  $FF55B7FB  "#FBB755"  "rgb(251,183, 85)"  "rgba(251,183, 85,255)"  "13-0942TPX_AmberYellow"
#Pnt_13_0945      = $64C8FF;  $FF64C8FF  "#FFC864"  "rgb(255,200,100)"  "rgba(255,200,100,255)"  "13-0945TPX_PaleMarigold"
#Pnt_13_0947      = $4FBCFF;  $FF4FBCFF  "#FFBC4F"  "rgb(255,188, 79)"  "rgba(255,188, 79,255)"  "13-0947TPX_Banana"
#Pnt_13_1006      = $B3CDDB;  $FFB3CDDB  "#DBCDB3"  "rgb(219,205,179)"  "rgba(219,205,179,255)"  "13-1006TPX_CrèmeBrûlée"
#Pnt_13_1007      = $B3CED7;  $FFB3CED7  "#D7CEB3"  "rgb(215,206,179)"  "rgba(215,206,179,255)"  "13-1007TPX_OysterWhite"
#Pnt_13_1008      = $B5CDDD;  $FFB5CDDD  "#DDCDB5"  "rgb(221,205,181)"  "rgba(221,205,181,255)"  "13-1008TPX_BleachedSand"
#Pnt_13_1009      = $AACBDB;  $FFAACBDB  "#DBCBAA"  "rgb(219,203,170)"  "rgba(219,203,170,255)"  "13-1009TPX_Biscotti"
#Pnt_13_1010      = $B8D5EC;  $FFB8D5EC  "#ECD5B8"  "rgb(236,213,184)"  "rgba(236,213,184,255)"  "13-1010TPX_GraySand"
#Pnt_13_1011      = $ACC6DE;  $FFACC6DE  "#DEC6AC"  "rgb(222,198,172)"  "rgba(222,198,172,255)"  "13-1011TPX_IvoryCream"
#Pnt_13_1012      = $A0B8CD;  $FFA0B8CD  "#CDB8A0"  "rgb(205,184,160)"  "rgba(205,184,160,255)"  "13-1012TPX_FrostedAlmond"
#Pnt_13_1013      = $A7C4E4;  $FFA7C4E4  "#E4C4A7"  "rgb(228,196,167)"  "rgba(228,196,167,255)"  "13-1013TPX_Appleblossom"
#Pnt_13_1014      = $A0C2DF;  $FFA0C2DF  "#DFC2A0"  "rgb(223,194,160)"  "rgba(223,194,160,255)"  "13-1014TPX_MellowBuff"
#Pnt_13_1015      = $9CC1DF;  $FF9CC1DF  "#DFC19C"  "rgb(223,193,156)"  "rgba(223,193,156,255)"  "13-1015TPX_HoneyPeach"
#Pnt_13_1016      = $A6C7E3;  $FFA6C7E3  "#E3C7A6"  "rgb(227,199,166)"  "rgba(227,199,166,255)"  "13-1016TPX_Wheat"
#Pnt_13_1017      = $A9CBF5;  $FFA9CBF5  "#F5CBA9"  "rgb(245,203,169)"  "rgba(245,203,169,255)"  "13-1017TPX_AlmondCream"
#Pnt_13_1018      = $8EBDE5;  $FF8EBDE5  "#E5BD8E"  "rgb(229,189,142)"  "rgba(229,189,142,255)"  "13-1018TPX_DesertDust"
#Pnt_13_1019      = $9DC7FC;  $FF9DC7FC  "#FCC79D"  "rgb(252,199,157)"  "rgba(252,199,157,255)"  "13-1019TPX_CreamBlush"
#Pnt_13_1020      = $9DC4FF;  $FF9DC4FF  "#FFC49D"  "rgb(255,196,157)"  "rgba(255,196,157,255)"  "13-1020TPX_ApricotIce"
#Pnt_13_1021      = $A2C1FC;  $FFA2C1FC  "#FCC1A2"  "rgb(252,193,162)"  "rgba(252,193,162,255)"  "13-1021TPX_PrairieSunset"
#Pnt_13_1022      = $9AC3F5;  $FF9AC3F5  "#F5C39A"  "rgb(245,195,154)"  "rgba(245,195,154,255)"  "13-1022TPX_CaramelCream"
#Pnt_13_1023      = $96C1FF;  $FF96C1FF  "#FFC196"  "rgb(255,193,150)"  "rgba(255,193,150,255)"  "13-1023TPX_PeachFuzz"
#Pnt_13_1024      = $94C5ED;  $FF94C5ED  "#EDC594"  "rgb(237,197,148)"  "rgba(237,197,148,255)"  "13-1024TPX_Buff"
#Pnt_13_1025      = $97D5FD;  $FF97D5FD  "#FDD597"  "rgb(253,213,151)"  "rgba(253,213,151,255)"  "13-1025TPX_Impala"
#Pnt_13_1026      = $B2D4FF;  $FFB2D4FF  "#FFD4B2"  "rgb(255,212,178)"  "rgba(255,212,178,255)"  "13-1026TPX_Creampuff"
#Pnt_13_1027      = $85BFF5;  $FF85BFF5  "#F5BF85"  "rgb(245,191,133)"  "rgba(245,191,133,255)"  "13-1027TPX_ApricotCream"
#Pnt_13_1030      = $8CC5FB;  $FF8CC5FB  "#FBC58C"  "rgb(251,197,140)"  "rgba(251,197,140,255)"  "13-1030TPX_Sunburst"
#Pnt_13_1031      = $9CD2FE;  $FF9CD2FE  "#FED29C"  "rgb(254,210,156)"  "rgba(254,210,156,255)"  "13-1031TPX_ApricotSherbet"
#Pnt_13_1106      = $BECFDF;  $FFBECFDF  "#DFCFBE"  "rgb(223,207,190)"  "rgba(223,207,190,255)"  "13-1106TPX_SandDollar"
#Pnt_13_1107      = $C2CFDE;  $FFC2CFDE  "#DECFC2"  "rgb(222,207,194)"  "rgba(222,207,194,255)"  "13-1107TPX_WhisperPink"
#Pnt_13_1108      = $B7C8E4;  $FFB7C8E4  "#E4C8B7"  "rgb(228,200,183)"  "rgba(228,200,183,255)"  "13-1108TPX_CreamTan"
#Pnt_13_1109      = $B2C7EB;  $FFB2C7EB  "#EBC7B2"  "rgb(235,199,178)"  "rgba(235,199,178,255)"  "13-1109TPX_Bisque"
#Pnt_13_1114      = $AEC9F3;  $FFAEC9F3  "#F3C9AE"  "rgb(243,201,174)"  "rgba(243,201,174,255)"  "13-1114TPX_Bellini"
#Pnt_13_1310      = $C2C5F5;  $FFC2C5F5  "#F5C5C2"  "rgb(245,197,194)"  "rgba(245,197,194,255)"  "13-1310TPX_EnglishRose"
#Pnt_13_1318      = $B6C7FF;  $FFB6C7FF  "#FFC7B6"  "rgb(255,199,182)"  "rgba(255,199,182,255)"  "13-1318TPX_TropicalPeach"
#Pnt_13_1404      = $C6D1EF;  $FFC6D1EF  "#EFD1C6"  "rgb(239,209,198)"  "rgba(239,209,198,255)"  "13-1404TPX_PaleDogwood"
#Pnt_13_1405      = $CDD7E7;  $FFCDD7E7  "#E7D7CD"  "rgb(231,215,205)"  "rgba(231,215,205,255)"  "13-1405TPX_Shell"
#Pnt_13_1406      = $C9D3F0;  $FFC9D3F0  "#F0D3C9"  "rgb(240,211,201)"  "rgba(240,211,201,255)"  "13-1406TPX_CloudPink"
#Pnt_13_1407      = $D0D7F6;  $FFD0D7F6  "#F6D7D0"  "rgb(246,215,208)"  "rgba(246,215,208,255)"  "13-1407TPX_CreolePink"
#Pnt_13_1408      = $C1C7F0;  $FFC1C7F0  "#F0C7C1"  "rgb(240,199,193)"  "rgba(240,199,193,255)"  "13-1408TPX_ChintzRose"
#Pnt_13_1409      = $C7CBF8;  $FFC7CBF8  "#F8CBC7"  "rgb(248,203,199)"  "rgba(248,203,199,255)"  "13-1409TPX_SeashellPink"
#Pnt_13_1504      = $C8CFE6;  $FFC8CFE6  "#E6CFC8"  "rgb(230,207,200)"  "rgba(230,207,200,255)"  "13-1504TPX_PeachBlush"
#Pnt_13_1510      = $BDC4FD;  $FFBDC4FD  "#FDC4BD"  "rgb(253,196,189)"  "rgba(253,196,189,255)"  "13-1510TPX_ImpatiensPink"
#Pnt_13_1513      = $C5C8FB;  $FFC5C8FB  "#FBC8C5"  "rgb(251,200,197)"  "rgba(251,200,197,255)"  "13-1513TPX_GossamerPink"
#Pnt_13_1904      = $D1C9E9;  $FFD1C9E9  "#E9C9D1"  "rgb(233,201,209)"  "rgba(233,201,209,255)"  "13-1904TPX_ChalkPink"
#Pnt_13_1906      = $D4C5F8;  $FFD4C5F8  "#F8C5D4"  "rgb(248,197,212)"  "rgba(248,197,212,255)"  "13-1906TPX_RoseShadow"
#Pnt_13_2004      = $CECBEA;  $FFCECBEA  "#EACBCE"  "rgb(234,203,206)"  "rgba(234,203,206,255)"  "13-2004TPX_Potpourri"
#Pnt_13_2005      = $C8C6F5;  $FFC8C6F5  "#F5C6C8"  "rgb(245,198,200)"  "rgba(245,198,200,255)"  "13-2005TPX_StrawberryCream"
#Pnt_13_2006      = $CCBFF5;  $FFCCBFF5  "#F5BFCC"  "rgb(245,191,204)"  "rgba(245,191,204,255)"  "13-2006TPX_AlmondBlossom"
#Pnt_13_2010      = $CDBDF2;  $FFCDBDF2  "#F2BDCD"  "rgb(242,189,205)"  "rgba(242,189,205,255)"  "13-2010TPX_OrchidPink"
#Pnt_13_2802      = $C5D1FF;  $FFC5D1FF  "#FFD1C5"  "rgb(255,209,197)"  "rgba(255,209,197,255)"  "13-2802TPX_FairyTale"
#Pnt_13_2803      = $D2CBE4;  $FFD2CBE4  "#E4CBD2"  "rgb(228,203,210)"  "rgba(228,203,210,255)"  "13-2803TPX_PaleLilac"
#Pnt_13_2804      = $D2C5EA;  $FFD2C5EA  "#EAC5D2"  "rgb(234,197,210)"  "rgba(234,197,210,255)"  "13-2804TPX_ParfaitPink"
#Pnt_13_2805      = $D6C2EA;  $FFD6C2EA  "#EAC2D6"  "rgb(234,194,214)"  "rgba(234,194,214,255)"  "13-2805TPX_PinkMist"
#Pnt_13_2806      = $DAC2EE;  $FFDAC2EE  "#EEC2DA"  "rgb(238,194,218)"  "rgba(238,194,218,255)"  "13-2806TPX_PinkLady"
#Pnt_13_2807      = $D2DBFD;  $FFD2DBFD  "#FDDBD2"  "rgb(253,219,210)"  "rgba(253,219,210,255)"  "13-2807TPX_Ballerina"
#Pnt_13_3405      = $DECAE3;  $FFDECAE3  "#E3CADE"  "rgb(227,202,222)"  "rgba(227,202,222,255)"  "13-3405TPX_LilacSnow"
#Pnt_13_3406      = $DFD2DF;  $FFDFD2DF  "#DFD2DF"  "rgb(223,210,223)"  "rgba(223,210,223,255)"  "13-3406TPX_OrchidIce"
#Pnt_13_3801      = $C9D1DC;  $FFC9D1DC  "#DCD1C9"  "rgb(220,209,201)"  "rgba(220,209,201,255)"  "13-3801TPX_CrystalGray"
#Pnt_13_3802      = $DFD5DD;  $FFDFD5DD  "#DDD5DF"  "rgb(221,213,223)"  "rgba(221,213,223,255)"  "13-3802TPX_OrchidTint"
#Pnt_13_3803      = $CFCED7;  $FFCFCED7  "#D7CECF"  "rgb(215,206,207)"  "rgba(215,206,207,255)"  "13-3803TPX_LilacAsh"
#Pnt_13_3804      = $D3CCD6;  $FFD3CCD6  "#D6CCD3"  "rgb(214,204,211)"  "rgba(214,204,211,255)"  "13-3804TPX_GrayLilac"
#Pnt_13_3805      = $D7C4CE;  $FFD7C4CE  "#CEC4D7"  "rgb(206,196,215)"  "rgba(206,196,215,255)"  "13-3805TPX_OrchidHush"
#Pnt_13_3820      = $DDC9D5;  $FFDDC9D5  "#D5C9DD"  "rgb(213,201,221)"  "rgba(213,201,221,255)"  "13-3820TPX_LavenderFog"
#Pnt_13_3920      = $D3C0CB;  $FFD3C0CB  "#CBC0D3"  "rgb(203,192,211)"  "rgba(203,192,211,255)"  "13-3920TPX_HalogenBlue"
#Pnt_13_4103      = $E0D7CA;  $FFE0D7CA  "#CAD7E0"  "rgb(202,215,224)"  "rgba(202,215,224,255)"  "13-4103TPX_IllusionBlue"
#Pnt_13_4105      = $DED5D5;  $FFDED5D5  "#D5D5DE"  "rgb(213,213,222)"  "rgba(213,213,222,255)"  "13-4105TPX_LilacHint"
#Pnt_13_4108      = $D6D4DE;  $FFD6D4DE  "#DED4D6"  "rgb(222,212,214)"  "rgba(222,212,214,255)"  "13-4108TPX_NimbusCloud"
#Pnt_13_4110      = $D9CBC3;  $FFD9CBC3  "#C3CBD9"  "rgb(195,203,217)"  "rgba(195,203,217,255)"  "13-4110TPX_ArcticIce"
#Pnt_13_4111      = $D2C5CC;  $FFD2C5CC  "#CCC5D2"  "rgb(204,197,210)"  "rgba(204,197,210,255)"  "13-4111TPX_PleinAir"
#Pnt_13_4200      = $DAC4BB;  $FFDAC4BB  "#BBC4DA"  "rgb(187,196,218)"  "rgba(187,196,218,255)"  "13-4200TPX_Omphalodes"
#Pnt_13_4303      = $CFD0CB;  $FFCFD0CB  "#CBD0CF"  "rgb(203,208,207)"  "rgba(203,208,207,255)"  "13-4303TPX_DawnBlue"
#Pnt_13_4304      = $DDCFBF;  $FFDDCFBF  "#BFCFDD"  "rgb(191,207,221)"  "rgba(191,207,221,255)"  "13-4304TPX_BalladBlue"
#Pnt_13_4305      = $D0D6D1;  $FFD0D6D1  "#D1D6D0"  "rgb(209,214,208)"  "rgba(209,214,208,255)"  "13-4305TPX_FoggyDew"
#Pnt_13_4308      = $DACAB6;  $FFDACAB6  "#B6CADA"  "rgb(182,202,218)"  "rgba(182,202,218,255)"  "13-4308TPX_BabyBlue"
#Pnt_13_4403      = $C3CECF;  $FFC3CECF  "#CFCEC3"  "rgb(207,206,195)"  "rgba(207,206,195,255)"  "13-4403TPX_SilverBirch"
#Pnt_13_4404      = $D6D4C8;  $FFD6D4C8  "#C8D4D6"  "rgb(200,212,214)"  "rgba(200,212,214,255)"  "13-4404TPX_IceFlow"
#Pnt_13_4405      = $D1D2BF;  $FFD1D2BF  "#BFD2D1"  "rgb(191,210,209)"  "rgba(191,210,209,255)"  "13-4405TPX_MistyBlue"
#Pnt_13_4409      = $DED3AC;  $FFDED3AC  "#ACD3DE"  "rgb(172,211,222)"  "rgba(172,211,222,255)"  "13-4409TPX_BlueGlow"
#Pnt_13_4411      = $DECCA1;  $FFDECCA1  "#A1CCDE"  "rgb(161,204,222)"  "rgba(161,204,222,255)"  "13-4411TPX_CrystalBlue"
#Pnt_13_4804      = $D9D9C6;  $FFD9D9C6  "#C6D9D9"  "rgb(198,217,217)"  "rgba(198,217,217,255)"  "13-4804TPX_PaleBlue"
#Pnt_13_4809      = $DBD3A5;  $FFDBD3A5  "#A5D3DB"  "rgb(165,211,219)"  "rgba(165,211,219,255)"  "13-4809TPX_Plume"
#Pnt_13_4909      = $E0E2AA;  $FFE0E2AA  "#AAE2E0"  "rgb(170,226,224)"  "rgba(170,226,224,255)"  "13-4909TPX_BlueLight"
#Pnt_13_4910      = $DDDDA1;  $FFDDDDA1  "#A1DDDD"  "rgb(161,221,221)"  "rgba(161,221,221,255)"  "13-4910TPX_BlueTint"
#Pnt_13_5304      = $BBC6CC;  $FFBBC6CC  "#CCC6BB"  "rgb(204,198,187)"  "rgba(204,198,187,255)"  "13-5304TPX_RainyDay"
#Pnt_13_5305      = $C6CEC1;  $FFC6CEC1  "#C1CEC6"  "rgb(193,206,198)"  "rgba(193,206,198,255)"  "13-5305TPX_PaleAqua"
#Pnt_13_5306      = $D2D4AE;  $FFD2D4AE  "#AED4D2"  "rgb(174,212,210)"  "rgba(174,212,210,255)"  "13-5306TPX_IcyMorn"
#Pnt_13_5309      = $C7C797;  $FFC7C797  "#97C7C7"  "rgb(151,199,199)"  "rgba(151,199,199,255)"  "13-5309TPX_PastelTurquoise"
#Pnt_13_5313      = $D7DB85;  $FFD7DB85  "#85DBD7"  "rgb(133,219,215)"  "rgba(133,219,215,255)"  "13-5313TPX_ArubaBlue"
#Pnt_13_5409      = $CEDB9F;  $FFCEDB9F  "#9FDBCE"  "rgb(159,219,206)"  "rgba(159,219,206,255)"  "13-5409TPX_Yucca"
#Pnt_13_5412      = $CFE298;  $FFCFE298  "#98E2CF"  "rgb(152,226,207)"  "rgba(152,226,207,255)"  "13-5412TPX_BeachGlass"
#Pnt_13_5414      = $C3D97E;  $FFC3D97E  "#7ED9C3"  "rgb(126,217,195)"  "rgba(126,217,195,255)"  "13-5414TPX_IceGreen"
#Pnt_13_5714      = $BFDD88;  $FFBFDD88  "#88DDBF"  "rgb(136,221,191)"  "rgba(136,221,191,255)"  "13-5714TPX_Cabbage"
#Pnt_13_5907      = $BED0B0;  $FFBED0B0  "#B0D0BE"  "rgb(176,208,190)"  "rgba(176,208,190,255)"  "13-5907TPX_GossamerGreen"
#Pnt_13_5911      = $BDD1A9;  $FFBDD1A9  "#A9D1BD"  "rgb(169,209,189)"  "rgba(169,209,189,255)"  "13-5911TPX_Bird'SEggGreen"
#Pnt_13_6006      = $C7D8CF;  $FFC7D8CF  "#CFD8C7"  "rgb(207,216,199)"  "rgba(207,216,199,255)"  "13-6006TPX_AlmostAqua"
#Pnt_13_6007      = $BED8C0;  $FFBED8C0  "#C0D8BE"  "rgb(192,216,190)"  "rgba(192,216,190,255)"  "13-6007TPX_Spray"
#Pnt_13_6008      = $CBDCBF;  $FFCBDCBF  "#BFDCCB"  "rgb(191,220,203)"  "rgba(191,220,203,255)"  "13-6008TPX_MistyJade"
#Pnt_13_6009      = $CEE1AC;  $FFCEE1AC  "#ACE1CE"  "rgb(172,225,206)"  "rgba(172,225,206,255)"  "13-6009TPX_BrookGreen"
#Pnt_13_6105      = $C1D2CD;  $FFC1D2CD  "#CDD2C1"  "rgb(205,210,193)"  "rgba(205,210,193,255)"  "13-6105TPX_CeladonTint"
#Pnt_13_6106      = $C1CFC6;  $FFC1CFC6  "#C6CFC1"  "rgb(198,207,193)"  "rgba(198,207,193,255)"  "13-6106TPX_GreenTint"
#Pnt_13_6107      = $BED0BE;  $FFBED0BE  "#BED0BE"  "rgb(190,208,190)"  "rgba(190,208,190,255)"  "13-6107TPX_GreenLily"
#Pnt_13_6108      = $B8CCB5;  $FFB8CCB5  "#B5CCB8"  "rgb(181,204,184)"  "rgba(181,204,184,255)"  "13-6108TPX_Celadon"
#Pnt_13_6110      = $B9D0A8;  $FFB9D0A8  "#A8D0B9"  "rgb(168,208,185)"  "rgba(168,208,185,255)"  "13-6110TPX_MistGreen"
#Pnt_13_6208      = $B0C9B7;  $FFB0C9B7  "#B7C9B0"  "rgb(183,201,176)"  "rgba(183,201,176,255)"  "13-6208TPX_BokChoy"
#Pnt_14_0000      = $B8BFC6;  $FFB8BFC6  "#C6BFB8"  "rgb(198,191,184)"  "rgba(198,191,184,255)"  "14-0000TPX_SilverGray"
#Pnt_14_0002      = $B6C0C6;  $FFB6C0C6  "#C6C0B6"  "rgb(198,192,182)"  "rgba(198,192,182,255)"  "14-0002TPX_PumiceStone"
#Pnt_14_0105      = $AAC0C3;  $FFAAC0C3  "#C3C0AA"  "rgb(195,192,170)"  "rgba(195,192,170,255)"  "14-0105TPX_Overcast"
#Pnt_14_0108      = $AEC5CA;  $FFAEC5CA  "#CAC5AE"  "rgb(202,197,174)"  "rgba(202,197,174,255)"  "14-0108TPX_CastleWall"
#Pnt_14_0114      = $A2C3B3;  $FFA2C3B3  "#B3C3A2"  "rgb(179,195,162)"  "rgba(179,195,162,255)"  "14-0114TPX_CeladonGreen"
#Pnt_14_0115      = $9EC8B3;  $FF9EC8B3  "#B3C89E"  "rgb(179,200,158)"  "rgba(179,200,158,255)"  "14-0115TPX_FoamGreen"
#Pnt_14_0116      = $A5C1A8;  $FFA5C1A8  "#A8C1A5"  "rgb(168,193,165)"  "rgba(168,193,165,255)"  "14-0116TPX_Margarita"
#Pnt_14_0121      = $97CAAA;  $FF97CAAA  "#AACA97"  "rgb(170,202,151)"  "rgba(170,202,151,255)"  "14-0121TPX_NileGreen"
#Pnt_14_0123      = $8DC89E;  $FF8DC89E  "#9EC88D"  "rgb(158,200,141)"  "rgba(158,200,141,255)"  "14-0123TPX_ArcadianGreen"
#Pnt_14_0127      = $8AC289;  $FF8AC289  "#89C28A"  "rgb(137,194,138)"  "rgba(137,194,138,255)"  "14-0127TPX_Greengage"
#Pnt_14_0156      = $7CD778;  $FF7CD778  "#78D77C"  "rgb(120,215,124)"  "rgba(120,215,124,255)"  "14-0156TPX_SummerGreen"
#Pnt_14_0210      = $9FB5BB;  $FF9FB5BB  "#BBB59F"  "rgb(187,181,159)"  "rgba(187,181,159,255)"  "14-0210TPX_TidalFoam"
#Pnt_14_0216      = $98BEB7;  $FF98BEB7  "#B7BE98"  "rgb(183,190,152)"  "rgba(183,190,152,255)"  "14-0216TPX_Lint"
#Pnt_14_0217      = $A0CBBE;  $FFA0CBBE  "#BECBA0"  "rgb(190,203,160)"  "rgba(190,203,160,255)"  "14-0217TPX_Seedling"
#Pnt_14_0223      = $86BDB4;  $FF86BDB4  "#B4BD86"  "rgb(180,189,134)"  "rgba(180,189,134,255)"  "14-0223TPX_Nile"
#Pnt_14_0226      = $80C7A5;  $FF80C7A5  "#A5C780"  "rgb(165,199,128)"  "rgba(165,199,128,255)"  "14-0226TPX_OpalineGreen"
#Pnt_14_0232      = $77CAA5;  $FF77CAA5  "#A5CA77"  "rgb(165,202,119)"  "rgba(165,202,119,255)"  "14-0232TPX_JadeLime"
#Pnt_14_0244      = $64C9A4;  $FF64C9A4  "#A4C964"  "rgb(164,201,100)"  "rgba(164,201,100,255)"  "14-0244TPX_BrightLimeGreen"
#Pnt_14_0418      = $96BBBA;  $FF96BBBA  "#BABB96"  "rgb(186,187,150)"  "rgba(186,187,150,255)"  "14-0418TPX_Bog"
#Pnt_14_0425      = $86C1C1;  $FF86C1C1  "#C1C186"  "rgb(193,193,134)"  "rgba(193,193,134,255)"  "14-0425TPX_Beechnut"
#Pnt_14_0434      = $6BBDB7;  $FF6BBDB7  "#B7BD6B"  "rgb(183,189,107)"  "rgba(183,189,107,255)"  "14-0434TPX_GreenBanana"
#Pnt_14_0445      = $4ABCB0;  $FF4ABCB0  "#B0BC4A"  "rgb(176,188, 74)"  "rgba(176,188, 74,255)"  "14-0445TPX_BrightChartreuse"
#Pnt_14_0446      = $46D1B9;  $FF46D1B9  "#B9D146"  "rgb(185,209, 70)"  "rgba(185,209, 70,255)"  "14-0446TPX_TenderShoots"
#Pnt_14_0452      = $2CC4A1;  $FF2CC4A1  "#A1C42C"  "rgb(161,196, 44)"  "rgba(161,196, 44,255)"  "14-0452TPX_LimeGreen"
#Pnt_14_0615      = $A4C9CB;  $FFA4C9CB  "#CBC9A4"  "rgb(203,201,164)"  "rgba(203,201,164,255)"  "14-0615TPX_GreenHaze"
#Pnt_14_0626      = $7EBCCD;  $FF7EBCCD  "#CDBC7E"  "rgb(205,188,126)"  "rgba(205,188,126,255)"  "14-0626TPX_DriedMoss"
#Pnt_14_0627      = $82C4CF;  $FF82C4CF  "#CFC482"  "rgb(207,196,130)"  "rgba(207,196,130,255)"  "14-0627TPX_ShadowGreen"
#Pnt_14_0636      = $7BCED6;  $FF7BCED6  "#D6CE7B"  "rgb(214,206,123)"  "rgba(214,206,123,255)"  "14-0636TPX_MutedLime"
#Pnt_14_0647      = $4DC5D3;  $FF4DC5D3  "#D3C54D"  "rgb(211,197, 77)"  "rgba(211,197, 77,255)"  "14-0647TPX_Celery"
#Pnt_14_0708      = $A5BAC2;  $FFA5BAC2  "#C2BAA5"  "rgb(194,186,165)"  "rgba(194,186,165,255)"  "14-0708TPX_Cement"
#Pnt_14_0721      = $7FB4C5;  $FF7FB4C5  "#C5B47F"  "rgb(197,180,127)"  "rgba(197,180,127,255)"  "14-0721TPX_Hemp"
#Pnt_14_0740      = $50B4D6;  $FF50B4D6  "#D6B450"  "rgb(214,180, 80)"  "rgba(214,180, 80,255)"  "14-0740TPX_Bamboo"
#Pnt_14_0754      = $3FC1E8;  $FF3FC1E8  "#E8C13F"  "rgb(232,193, 63)"  "rgba(232,193, 63,255)"  "14-0754TPX_SuperLemon"
#Pnt_14_0755      = $25BBE4;  $FF25BBE4  "#E4BB25"  "rgb(228,187, 37)"  "rgba(228,187, 37,255)"  "14-0755TPX_Sulphur"
#Pnt_14_0756      = $00D3F6;  $FF00D3F6  "#F6D300"  "rgb(246,211,  0)"  "rgba(246,211,  0,255)"  "14-0756TPX_EmpireYellow"
#Pnt_14_0760      = $00D3FF;  $FF00D3FF  "#FFD300"  "rgb(255,211,  0)"  "rgba(255,211,  0,255)"  "14-0760TPX_CyberYellow"
#Pnt_14_0826      = $7DBED3;  $FF7DBED3  "#D3BE7D"  "rgb(211,190,125)"  "rgba(211,190,125,255)"  "14-0826TPX_Pampas"
#Pnt_14_0827      = $7FCDE5;  $FF7FCDE5  "#E5CD7F"  "rgb(229,205,127)"  "rgba(229,205,127,255)"  "14-0827TPX_DuskyCitron"
#Pnt_14_0837      = $60B9DB;  $FF60B9DB  "#DBB960"  "rgb(219,185, 96)"  "rgba(219,185, 96,255)"  "14-0837TPX_MistedYellow"
#Pnt_14_0846      = $4BB0E3;  $FF4BB0E3  "#E3B04B"  "rgb(227,176, 75)"  "rgba(227,176, 75,255)"  "14-0846TPX_YolkYellow"
#Pnt_14_0847      = $6BC3F3;  $FF6BC3F3  "#F3C36B"  "rgb(243,195,107)"  "rgba(243,195,107,255)"  "14-0847TPX_BuffYellow"
#Pnt_14_0848      = $50C0EF;  $FF50C0EF  "#EFC050"  "rgb(239,192, 80)"  "rgba(239,192, 80,255)"  "14-0848TPX_Mimosa"
#Pnt_14_0850      = $49C8FF;  $FF49C8FF  "#FFC849"  "rgb(255,200, 73)"  "rgba(255,200, 73,255)"  "14-0850TPX_Daffodil"
#Pnt_14_0851      = $92DDFC;  $FF92DDFC  "#FCDD92"  "rgb(252,221,146)"  "rgba(252,221,146,255)"  "14-0851TPX_SamoanSun"
#Pnt_14_0852      = $24C3F6;  $FF24C3F6  "#F6C324"  "rgb(246,195, 36)"  "rgba(246,195, 36,255)"  "14-0852TPX_Freesia"
#Pnt_14_0925      = $93C7D7;  $FF93C7D7  "#D7C793"  "rgb(215,199,147)"  "rgba(215,199,147,255)"  "14-0925TPX_Parsnip"
#Pnt_14_0935      = $80C2DE;  $FF80C2DE  "#DEC280"  "rgb(222,194,128)"  "rgba(222,194,128,255)"  "14-0935TPX_Jojoba"
#Pnt_14_0936      = $89C3E4;  $FF89C3E4  "#E4C389"  "rgb(228,195,137)"  "rgba(228,195,137,255)"  "14-0936TPX_SaharaSun"
#Pnt_14_0941      = $4AA9EE;  $FF4AA9EE  "#EEA94A"  "rgb(238,169, 74)"  "rgba(238,169, 74,255)"  "14-0941TPX_Beeswax"
#Pnt_14_0951      = $16A9E9;  $FF16A9E9  "#E9A916"  "rgb(233,169, 22)"  "rgba(233,169, 22,255)"  "14-0951TPX_GoldenRod"
#Pnt_14_0955      = $25B0FF;  $FF25B0FF  "#FFB025"  "rgb(255,176, 37)"  "rgba(255,176, 37,255)"  "14-0955TPX_Citrus"
#Pnt_14_0957      = $07C0FF;  $FF07C0FF  "#FFC007"  "rgb(255,192,  7)"  "rgba(255,192,  7,255)"  "14-0957TPX_SpectraYellow"
#Pnt_14_1012      = $809BB4;  $FF809BB4  "#B49B80"  "rgb(180,155,128)"  "rgba(180,155,128,255)"  "14-1012TPX_ChampagneBeige"
#Pnt_14_1014      = $A0C1CA;  $FFA0C1CA  "#CAC1A0"  "rgb(202,193,160)"  "rgba(202,193,160,255)"  "14-1014TPX_Gravel"
#Pnt_14_1025      = $7BB7CC;  $FF7BB7CC  "#CCB77B"  "rgb(204,183,123)"  "rgba(204,183,123,255)"  "14-1025TPX_Cocoon"
#Pnt_14_1031      = $6EB2D5;  $FF6EB2D5  "#D5B26E"  "rgb(213,178,110)"  "rgba(213,178,110,255)"  "14-1031TPX_Rattan"
#Pnt_14_1036      = $59ACD8;  $FF59ACD8  "#D8AC59"  "rgb(216,172, 89)"  "rgba(216,172, 89,255)"  "14-1036TPX_Ochre"
#Pnt_14_1038      = $7EB7DA;  $FF7EB7DA  "#DAB77E"  "rgb(218,183,126)"  "rgba(218,183,126,255)"  "14-1038TPX_NewWheat"
#Pnt_14_1041      = $5AAAE0;  $FF5AAAE0  "#E0AA5A"  "rgb(224,170, 90)"  "rgba(224,170, 90,255)"  "14-1041TPX_GoldenApricot"
#Pnt_14_1045      = $51AEF1;  $FF51AEF1  "#F1AE51"  "rgb(241,174, 81)"  "rgba(241,174, 81,255)"  "14-1045TPX_Amber"
#Pnt_14_1050      = $4AADFF;  $FF4AADFF  "#FFAD4A"  "rgb(255,173, 74)"  "rgba(255,173, 74,255)"  "14-1050TPX_Marigold"
#Pnt_14_1051      = $5EB7FF;  $FF5EB7FF  "#FFB75E"  "rgb(255,183, 94)"  "rgba(255,183, 94,255)"  "14-1051TPX_WarmApricot"
#Pnt_14_1064      = $00ACFF;  $FF00ACFF  "#FFAC00"  "rgb(255,172,  0)"  "rgba(255,172,  0,255)"  "14-1064TPX_Saffron"
#Pnt_14_1106      = $ADBCC3;  $FFADBCC3  "#C3BCAD"  "rgb(195,188,173)"  "rgba(195,188,173,255)"  "14-1106TPX_Peyote"
#Pnt_14_1107      = $A5B9C1;  $FFA5B9C1  "#C1B9A5"  "rgb(193,185,165)"  "rgba(193,185,165,255)"  "14-1107TPX_OysterGray"
#Pnt_14_1108      = $ACC9D4;  $FFACC9D4  "#D4C9AC"  "rgb(212,201,172)"  "rgba(212,201,172,255)"  "14-1108TPX_WoodAsh"
#Pnt_14_1110      = $9BC0D3;  $FF9BC0D3  "#D3C09B"  "rgb(211,192,155)"  "rgba(211,192,155,255)"  "14-1110TPX_Boulder"
#Pnt_14_1112      = $99BBCD;  $FF99BBCD  "#CDBB99"  "rgb(205,187,153)"  "rgba(205,187,153,255)"  "14-1112TPX_Pebble"
#Pnt_14_1113      = $9CC2DA;  $FF9CC2DA  "#DAC29C"  "rgb(218,194,156)"  "rgba(218,194,156,255)"  "14-1113TPX_Marzipan"
#Pnt_14_1116      = $93B8D1;  $FF93B8D1  "#D1B893"  "rgb(209,184,147)"  "rgba(209,184,147,255)"  "14-1116TPX_AlmondBuff"
#Pnt_14_1118      = $95B8D4;  $FF95B8D4  "#D4B895"  "rgb(212,184,149)"  "rgba(212,184,149,255)"  "14-1118TPX_Beige"
#Pnt_14_1119      = $9EC4E5;  $FF9EC4E5  "#E5C49E"  "rgb(229,196,158)"  "rgba(229,196,158,255)"  "14-1119TPX_WinterWheat"
#Pnt_14_1120      = $A5C7E7;  $FFA5C7E7  "#E7C7A5"  "rgb(231,199,165)"  "rgba(231,199,165,255)"  "14-1120TPX_ApricotIllusion"
#Pnt_14_1122      = $8FB6DB;  $FF8FB6DB  "#DBB68F"  "rgb(219,182,143)"  "rgba(219,182,143,255)"  "14-1122TPX_Sheepskin"
#Pnt_14_1127      = $87B5E1;  $FF87B5E1  "#E1B587"  "rgb(225,181,135)"  "rgba(225,181,135,255)"  "14-1127TPX_DesertMist"
#Pnt_14_1128      = $79BEFF;  $FF79BEFF  "#FFBE79"  "rgb(255,190,121)"  "rgba(255,190,121,255)"  "14-1128TPX_BuffOrange"
#Pnt_14_1133      = $73ABF0;  $FF73ABF0  "#F0AB73"  "rgb(240,171,115)"  "rgba(240,171,115,255)"  "14-1133TPX_ApricotNectar"
#Pnt_14_1135      = $7EB1FF;  $FF7EB1FF  "#FFB17E"  "rgb(255,177,126)"  "rgba(255,177,126,255)"  "14-1135TPX_SalmonBuff"
#Pnt_14_1139      = $69A6FA;  $FF69A6FA  "#FAA669"  "rgb(250,166,105)"  "rgba(250,166,105,255)"  "14-1139TPX_Pumpkin"
#Pnt_14_1159      = $26A3FF;  $FF26A3FF  "#FFA326"  "rgb(255,163, 38)"  "rgba(255,163, 38,255)"  "14-1159TPX_Zinnia"
#Pnt_14_1209      = $A2B7CB;  $FFA2B7CB  "#CBB7A2"  "rgb(203,183,162)"  "rgba(203,183,162,255)"  "14-1209TPX_SmokeGray"
#Pnt_14_1210      = $ACC3D7;  $FFACC3D7  "#D7C3AC"  "rgb(215,195,172)"  "rgba(215,195,172,255)"  "14-1210TPX_ShiftingSand"
#Pnt_14_1212      = $A1B7D1;  $FFA1B7D1  "#D1B7A1"  "rgb(209,183,161)"  "rgba(209,183,161,255)"  "14-1212TPX_Frappé"
#Pnt_14_1213      = $9AB2D2;  $FF9AB2D2  "#D2B29A"  "rgb(210,178,154)"  "rgba(210,178,154,255)"  "14-1213TPX_ToastedAlmond"
#Pnt_14_1217      = $9DB9DE;  $FF9DB9DE  "#DEB99D"  "rgb(222,185,157)"  "rgba(222,185,157,255)"  "14-1217TPX_Amberlight"
#Pnt_14_1219      = $ACC1FB;  $FFACC1FB  "#FBC1AC"  "rgb(251,193,172)"  "rgba(251,193,172,255)"  "14-1219TPX_PeachParfait"
#Pnt_14_1220      = $8FAFE7;  $FF8FAFE7  "#E7AF8F"  "rgb(231,175,143)"  "rgba(231,175,143,255)"  "14-1220TPX_PeachNougat"
#Pnt_14_1224      = $87ACEF;  $FF87ACEF  "#EFAC87"  "rgb(239,172,135)"  "rgba(239,172,135,255)"  "14-1224TPX_CoralSands"
#Pnt_14_1225      = $9AC0FA;  $FF9AC0FA  "#FAC09A"  "rgb(250,192,154)"  "rgba(250,192,154,255)"  "14-1225TPX_BeachSand"
#Pnt_14_1227      = $86ADF2;  $FF86ADF2  "#F2AD86"  "rgb(242,173,134)"  "rgba(242,173,134,255)"  "14-1227TPX_Peach"
#Pnt_14_1228      = $A2BBFF;  $FFA2BBFF  "#FFBBA2"  "rgb(255,187,162)"  "rgba(255,187,162,255)"  "14-1228TPX_PeachNectar"
#Pnt_14_1230      = $86B0F9;  $FF86B0F9  "#F9B086"  "rgb(249,176,134)"  "rgba(249,176,134,255)"  "14-1230TPX_ApricotWash"
#Pnt_14_1231      = $81B4FF;  $FF81B4FF  "#FFB481"  "rgb(255,180,129)"  "rgba(255,180,129,255)"  "14-1231TPX_PeachCobbler"
#Pnt_14_1305      = $A0ABBC;  $FFA0ABBC  "#BCABA0"  "rgb(188,171,160)"  "rgba(188,171,160,255)"  "14-1305TPX_Mushroom"
#Pnt_14_1307      = $A8B4CF;  $FFA8B4CF  "#CFB4A8"  "rgb(207,180,168)"  "rgba(207,180,168,255)"  "14-1307TPX_RoseDust"
#Pnt_14_1309      = $B9C0DD;  $FFB9C0DD  "#DDC0B9"  "rgb(221,192,185)"  "rgba(221,192,185,255)"  "14-1309TPX_PeachWhip"
#Pnt_14_1310      = $AAB7D7;  $FFAAB7D7  "#D7B7AA"  "rgb(215,183,170)"  "rgba(215,183,170,255)"  "14-1310TPX_CameoRose"
#Pnt_14_1311      = $ADB9E0;  $FFADB9E0  "#E0B9AD"  "rgb(224,185,173)"  "rgba(224,185,173,255)"  "14-1311TPX_EveningSand"
#Pnt_14_1312      = $B3BFE6;  $FFB3BFE6  "#E6BFB3"  "rgb(230,191,179)"  "rgba(230,191,179,255)"  "14-1312TPX_PaleBlush"
#Pnt_14_1313      = $A3B3DD;  $FFA3B3DD  "#DDB3A3"  "rgb(221,179,163)"  "rgba(221,179,163,255)"  "14-1313TPX_RoseCloud"
#Pnt_14_1314      = $ABBDE2;  $FFABBDE2  "#E2BDAB"  "rgb(226,189,171)"  "rgba(226,189,171,255)"  "14-1314TPX_SpanishVilla"
#Pnt_14_1316      = $9DADE1;  $FF9DADE1  "#E1AD9D"  "rgb(225,173,157)"  "rgba(225,173,157,255)"  "14-1316TPX_DustyPink"
#Pnt_14_1318      = $9CACEA;  $FF9CACEA  "#EAAC9C"  "rgb(234,172,156)"  "rgba(234,172,156,255)"  "14-1318TPX_CoralPink"
#Pnt_14_1323      = $97ACF6;  $FF97ACF6  "#F6AC97"  "rgb(246,172,151)"  "rgba(246,172,151,255)"  "14-1323TPX_Salmon"
#Pnt_14_1324      = $A8B3FC;  $FFA8B3FC  "#FCB3A8"  "rgb(252,179,168)"  "rgba(252,179,168,255)"  "14-1324TPX_PeachBud"
#Pnt_14_1418      = $B1BCFA;  $FFB1BCFA  "#FABCB1"  "rgb(250,188,177)"  "rgba(250,188,177,255)"  "14-1418TPX_PeachMelba"
#Pnt_14_1419      = $A9B5F9;  $FFA9B5F9  "#F9B5A9"  "rgb(249,181,169)"  "rgba(249,181,169,255)"  "14-1419TPX_PeachPearl"
#Pnt_14_1420      = $A9B1FA;  $FFA9B1FA  "#FAB1A9"  "rgb(250,177,169)"  "rgba(250,177,169,255)"  "14-1420TPX_ApricotBlush"
#Pnt_14_1506      = $B2BAD6;  $FFB2BAD6  "#D6BAB2"  "rgb(214,186,178)"  "rgba(214,186,178,255)"  "14-1506TPX_RoseSmoke"
#Pnt_14_1508      = $B4B5DC;  $FFB4B5DC  "#DCB5B4"  "rgb(220,181,180)"  "rgba(220,181,180,255)"  "14-1508TPX_SilverPink"
#Pnt_14_1511      = $BAB8ED;  $FFBAB8ED  "#EDB8BA"  "rgb(237,184,186)"  "rgba(237,184,186,255)"  "14-1511TPX_PowderPink"
#Pnt_14_1513      = $AEB0EE;  $FFAEB0EE  "#EEB0AE"  "rgb(238,176,174)"  "rgba(238,176,174,255)"  "14-1513TPX_Blossom"
#Pnt_14_1521      = $A5A8F5;  $FFA5A8F5  "#F5A8A5"  "rgb(245,168,165)"  "rgba(245,168,165,255)"  "14-1521TPX_PeachesN'Cream"
#Pnt_14_1714      = $B0ACF1;  $FFB0ACF1  "#F1ACB0"  "rgb(241,172,176)"  "rgba(241,172,176,255)"  "14-1714TPX_QuartzPink"
#Pnt_14_1905      = $C3C3E5;  $FFC3C3E5  "#E5C3C3"  "rgb(229,195,195)"  "rgba(229,195,195,255)"  "14-1905TPX_Lotus"
#Pnt_14_1907      = $BAB9E1;  $FFBAB9E1  "#E1B9BA"  "rgb(225,185,186)"  "rgba(225,185,186,255)"  "14-1907TPX_Peachskin"
#Pnt_14_1909      = $C1B7E8;  $FFC1B7E8  "#E8B7C1"  "rgb(232,183,193)"  "rgba(232,183,193,255)"  "14-1909TPX_CoralBlush"
#Pnt_14_1911      = $C4B4F4;  $FFC4B4F4  "#F4B4C4"  "rgb(244,180,196)"  "rgba(244,180,196,255)"  "14-1911TPX_CandyPink"
#Pnt_14_2305      = $B7A8D8;  $FFB7A8D8  "#D8A8B7"  "rgb(216,168,183)"  "rgba(216,168,183,255)"  "14-2305TPX_PinkNectar"
#Pnt_14_2307      = $BBAADC;  $FFBBAADC  "#DCAABB"  "rgb(220,170,187)"  "rgba(220,170,187,255)"  "14-2307TPX_CameoPink"
#Pnt_14_2311      = $C8A5EF;  $FFC8A5EF  "#EFA5C8"  "rgb(239,165,200)"  "rgba(239,165,200,255)"  "14-2311TPX_PrismPink"
#Pnt_14_2710      = $CEB0EA;  $FFCEB0EA  "#EAB0CE"  "rgb(234,176,206)"  "rgba(234,176,206,255)"  "14-2710TPX_LilacSachet"
#Pnt_14_2808      = $D3B8E7;  $FFD3B8E7  "#E7B8D3"  "rgb(231,184,211)"  "rgba(231,184,211,255)"  "14-2808TPX_SweetLilac"
#Pnt_14_3204      = $C2AFCF;  $FFC2AFCF  "#CFAFC2"  "rgb(207,175,194)"  "rgba(207,175,194,255)"  "14-3204TPX_FragrantLilac"
#Pnt_14_3206      = $D1B9D4;  $FFD1B9D4  "#D4B9D1"  "rgb(212,185,209)"  "rgba(212,185,209,255)"  "14-3206TPX_WinsomeOrchid"
#Pnt_14_3207      = $D1B2DB;  $FFD1B2DB  "#DBB2D1"  "rgb(219,178,209)"  "rgba(219,178,209,255)"  "14-3207TPX_PinkLavender"
#Pnt_14_3209      = $CCA4DB;  $FFCCA4DB  "#DBA4CC"  "rgb(219,164,204)"  "rgba(219,164,204,255)"  "14-3209TPX_PastelLavender"
#Pnt_14_3612      = $D5B0C6;  $FFD5B0C6  "#C6B0D5"  "rgb(198,176,213)"  "rgba(198,176,213,255)"  "14-3612TPX_OrchidBloom"
#Pnt_14_3710      = $CFB3BE;  $FFCFB3BE  "#BEB3CF"  "rgb(190,179,207)"  "rgba(190,179,207,255)"  "14-3710TPX_OrchidPetal"
#Pnt_14_3803      = $C3C4D1;  $FFC3C4D1  "#D1C4C3"  "rgb(209,196,195)"  "rgba(209,196,195,255)"  "14-3803TPX_HushedViolet"
#Pnt_14_3805      = $C0B3BD;  $FFC0B3BD  "#BDB3C0"  "rgb(189,179,192)"  "rgba(189,179,192,255)"  "14-3805TPX_Iris"
#Pnt_14_3812      = $D5B2BE;  $FFD5B2BE  "#BEB2D5"  "rgb(190,178,213)"  "rgba(190,178,213,255)"  "14-3812TPX_PastelLilac"
#Pnt_14_3903      = $C4BBC2;  $FFC4BBC2  "#C2BBC4"  "rgb(194,187,196)"  "rgba(194,187,196,255)"  "14-3903TPX_LilacMarble"
#Pnt_14_3904      = $CAB9BC;  $FFCAB9BC  "#BCB9CA"  "rgb(188,185,202)"  "rgba(188,185,202,255)"  "14-3904TPX_EveningHaze"
#Pnt_14_3905      = $D3BFC2;  $FFD3BFC2  "#C2BFD3"  "rgb(194,191,211)"  "rgba(194,191,211,255)"  "14-3905TPX_LavenderBlue"
#Pnt_14_3907      = $CBB8BC;  $FFCBB8BC  "#BCB8CB"  "rgb(188,184,203)"  "rgba(188,184,203,255)"  "14-3907TPX_Thistle"
#Pnt_14_3911      = $D8B9BB;  $FFD8B9BB  "#BBB9D8"  "rgb(187,185,216)"  "rgba(187,185,216,255)"  "14-3911TPX_PurpleHeather"
#Pnt_14_3949      = $CEBAC6;  $FFCEBAC6  "#C6BACE"  "rgb(198,186,206)"  "rgba(198,186,206,255)"  "14-3949TPX_XenonBlue"
#Pnt_14_4002      = $C6C7CA;  $FFC6C7CA  "#CAC7C6"  "rgb(202,199,198)"  "rgba(202,199,198,255)"  "14-4002TPX_WindChime"
#Pnt_14_4102      = $CCCBC6;  $FFCCCBC6  "#C6CBCC"  "rgb(198,203,204)"  "rgba(198,203,204,255)"  "14-4102TPX_GlacierGray"
#Pnt_14_4103      = $C3C4C0;  $FFC3C4C0  "#C0C4C3"  "rgb(192,196,195)"  "rgba(192,196,195,255)"  "14-4103TPX_GrayViolet"
#Pnt_14_4105      = $C1B9CA;  $FFC1B9CA  "#CAB9C1"  "rgb(202,185,193)"  "rgba(202,185,193,255)"  "14-4105TPX_MicroChip"
#Pnt_14_4106      = $CDC0B9;  $FFCDC0B9  "#B9C0CD"  "rgb(185,192,205)"  "rgba(185,192,205,255)"  "14-4106TPX_GrayDawn"
#Pnt_14_4110      = $DAC2B7;  $FFDAC2B7  "#B7C2DA"  "rgb(183,194,218)"  "rgba(183,194,218,255)"  "14-4110TPX_Heather"
#Pnt_14_4112      = $D9C0AC;  $FFD9C0AC  "#ACC0D9"  "rgb(172,192,217)"  "rgba(172,192,217,255)"  "14-4112TPX_Skyway"
#Pnt_14_4115      = $D4B8A2;  $FFD4B8A2  "#A2B8D4"  "rgb(162,184,212)"  "rgba(162,184,212,255)"  "14-4115TPX_CashmereBlue"
#Pnt_14_4121      = $D9B592;  $FFD9B592  "#92B5D9"  "rgb(146,181,217)"  "rgba(146,181,217,255)"  "14-4121TPX_BlueBell"
#Pnt_14_4201      = $CCCAC8;  $FFCCCAC8  "#C8CACC"  "rgb(200,202,204)"  "rgba(200,202,204,255)"  "14-4201TPX_LunarRock"
#Pnt_14_4203      = $BFBEBD;  $FFBFBEBD  "#BDBEBF"  "rgb(189,190,191)"  "rgba(189,190,191,255)"  "14-4203TPX_VaporBlue"
#Pnt_14_4206      = $C1BAAE;  $FFC1BAAE  "#AEBAC1"  "rgb(174,186,193)"  "rgba(174,186,193,255)"  "14-4206TPX_PearlBlue"
#Pnt_14_4210      = $C8B7A4;  $FFC8B7A4  "#A4B7C8"  "rgb(164,183,200)"  "rgba(164,183,200,255)"  "14-4210TPX_CelestialBlue"
#Pnt_14_4214      = $D1B396;  $FFD1B396  "#96B3D1"  "rgb(150,179,209)"  "rgba(150,179,209,255)"  "14-4214TPX_PowderBlue"
#Pnt_14_4306      = $BCB9A0;  $FFBCB9A0  "#A0B9BC"  "rgb(160,185,188)"  "rgba(160,185,188,255)"  "14-4306TPX_CloudBlue"
#Pnt_14_4307      = $CDC0A6;  $FFCDC0A6  "#A6C0CD"  "rgb(166,192,205)"  "rgba(166,192,205,255)"  "14-4307TPX_WinterSky"
#Pnt_14_4310      = $D4A772;  $FFD4A772  "#72A7D4"  "rgb(114,167,212)"  "rgba(114,167,212,255)"  "14-4310TPX_BlueTopaz"
#Pnt_14_4311      = $D7BFAA;  $FFD7BFAA  "#AABFD7"  "rgb(170,191,215)"  "rgba(170,191,215,255)"  "14-4311TPX_CorydalisBlue"
#Pnt_14_4313      = $D8C69D;  $FFD8C69D  "#9DC6D8"  "rgb(157,198,216)"  "rgba(157,198,216,255)"  "14-4313TPX_Aquamarine"
#Pnt_14_4317      = $D4B9A8;  $FFD4B9A8  "#A8B9D4"  "rgb(168,185,212)"  "rgba(168,185,212,255)"  "14-4317TPX_CoolBlue"
#Pnt_14_4318      = $D6BE8C;  $FFD6BE8C  "#8CBED6"  "rgb(140,190,214)"  "rgba(140,190,214,255)"  "14-4318TPX_SkyBlue"
#Pnt_14_4500      = $B9C2C4;  $FFB9C2C4  "#C4C2B9"  "rgb(196,194,185)"  "rgba(196,194,185,255)"  "14-4500TPX_Moonstruck"
#Pnt_14_4501      = $AEBAC0;  $FFAEBAC0  "#C0BAAE"  "rgb(192,186,174)"  "rgba(192,186,174,255)"  "14-4501TPX_SilverLining"
#Pnt_14_4502      = $BFC4BC;  $FFBFC4BC  "#BCC4BF"  "rgb(188,196,191)"  "rgba(188,196,191,255)"  "14-4502TPX_Mercury"
#Pnt_14_4503      = $BBBFB5;  $FFBBBFB5  "#B5BFBB"  "rgb(181,191,187)"  "rgba(181,191,187,255)"  "14-4503TPX_Metal"
#Pnt_14_4504      = $C9CABB;  $FFC9CABB  "#BBCAC9"  "rgb(187,202,201)"  "rgba(187,202,201,255)"  "14-4504TPX_SkyGray"
#Pnt_14_4505      = $C5C9BD;  $FFC5C9BD  "#BDC9C5"  "rgb(189,201,197)"  "rgba(189,201,197,255)"  "14-4505TPX_Smoke"
#Pnt_14_4506      = $BFBCA4;  $FFBFBCA4  "#A4BCBF"  "rgb(164,188,191)"  "rgba(164,188,191,255)"  "14-4506TPX_Ether"
#Pnt_14_4508      = $CCC19B;  $FFCCC19B  "#9BC1CC"  "rgb(155,193,204)"  "rgba(155,193,204,255)"  "14-4508TPX_Stratosphere"
#Pnt_14_4510      = $CEC398;  $FFCEC398  "#98C3CE"  "rgb(152,195,206)"  "rgba(152,195,206,255)"  "14-4510TPX_Aquatic"
#Pnt_14_4511      = $D2B17D;  $FFD2B17D  "#7DB1D2"  "rgb(125,177,210)"  "rgba(125,177,210,255)"  "14-4511TPX_GulfStream"
#Pnt_14_4512      = $CCC08E;  $FFCCC08E  "#8EC0CC"  "rgb(142,192,204)"  "rgba(142,192,204,255)"  "14-4512TPX_PorcelainBlue"
#Pnt_14_4516      = $D7C685;  $FFD7C685  "#85C6D7"  "rgb(133,198,215)"  "rgba(133,198,215,255)"  "14-4516TPX_PetitFour"
#Pnt_14_4522      = $D8BC43;  $FFD8BC43  "#43BCD8"  "rgb( 67,188,216)"  "rgba( 67,188,216,255)"  "14-4522TPX_BachelorButton"
#Pnt_14_4804      = $BBC0B8;  $FFBBC0B8  "#B8C0BB"  "rgb(184,192,187)"  "rgba(184,192,187,255)"  "14-4804TPX_BlueFox"
#Pnt_14_4807      = $C3C7AE;  $FFC3C7AE  "#AEC7C3"  "rgb(174,199,195)"  "rgba(174,199,195,255)"  "14-4807TPX_SurfSpray"
#Pnt_14_4809      = $C8CB9E;  $FFC8CB9E  "#9ECBC8"  "rgb(158,203,200)"  "rgba(158,203,200,255)"  "14-4809TPX_EggshellBlue"
#Pnt_14_4810      = $C8C29A;  $FFC8C29A  "#9AC2C8"  "rgb(154,194,200)"  "rgba(154,194,200,255)"  "14-4810TPX_CanalBlue"
#Pnt_14_4811      = $CDCD7F;  $FFCDCD7F  "#7FCDCD"  "rgb(127,205,205)"  "rgba(127,205,205,255)"  "14-4811TPX_AquaSky"
#Pnt_14_4812      = $D9B973;  $FFD9B973  "#73B9D9"  "rgb(115,185,217)"  "rgba(115,185,217,255)"  "14-4812TPX_AquaSplash"
#Pnt_14_4814      = $D2C983;  $FFD2C983  "#83C9D2"  "rgb(131,201,210)"  "rgba(131,201,210,255)"  "14-4814TPX_AngelBlue"
#Pnt_14_4816      = $D5CB62;  $FFD5CB62  "#62CBD5"  "rgb( 98,203,213)"  "rgba( 98,203,213,255)"  "14-4816TPX_BlueRadiance"
#Pnt_14_4908      = $BCC4A8;  $FFBCC4A8  "#A8C4BC"  "rgb(168,196,188)"  "rgba(168,196,188,255)"  "14-4908TPX_HarborGray"
#Pnt_14_5002      = $9B9B99;  $FF9B9B99  "#999B9B"  "rgb(153,155,155)"  "rgba(153,155,155,255)"  "14-5002TPX_Silver"
#Pnt_14_5413      = $B4C57C;  $FFB4C57C  "#7CC5B4"  "rgb(124,197,180)"  "rgba(124,197,180,255)"  "14-5413TPX_Holiday"
#Pnt_14_5416      = $B3CB56;  $FFB3CB56  "#56CBB3"  "rgb( 86,203,179)"  "rgba( 86,203,179,255)"  "14-5416TPX_Bermuda"
#Pnt_14_5420      = $BAD05A;  $FFBAD05A  "#5AD0BA"  "rgb( 90,208,186)"  "rgba( 90,208,186,255)"  "14-5420TPX_Cockatoo"
#Pnt_14_5706      = $B7C3AD;  $FFB7C3AD  "#ADC3B7"  "rgb(173,195,183)"  "rgba(173,195,183,255)"  "14-5706TPX_SiltGreen"
#Pnt_14_5707      = $B7C6AD;  $FFB7C6AD  "#ADC6B7"  "rgb(173,198,183)"  "rgba(173,198,183,255)"  "14-5707TPX_AquaFoam"
#Pnt_14_5711      = $B8C98F;  $FFB8C98F  "#8FC9B8"  "rgb(143,201,184)"  "rgba(143,201,184,255)"  "14-5711TPX_OceanWave"
#Pnt_14_5713      = $B1C176;  $FFB1C176  "#76C1B1"  "rgb(118,193,177)"  "rgba(118,193,177,255)"  "14-5713TPX_Cascade"
#Pnt_14_5714      = $B6CF7D;  $FFB6CF7D  "#7DCFB6"  "rgb(125,207,182)"  "rgba(125,207,182,255)"  "14-5714TPX_LuciteGreen"
#Pnt_14_5718      = $B4D16E;  $FFB4D16E  "#6ED1B4"  "rgb(110,209,180)"  "rgba(110,209,180,255)"  "14-5718TPX_Opal"
#Pnt_14_5721      = $A6C333;  $FFA6C333  "#33C3A6"  "rgb( 51,195,166)"  "rgba( 51,195,166,255)"  "14-5721TPX_ElectricGreen"
#Pnt_14_6007      = $B5C3B8;  $FFB5C3B8  "#B8C3B5"  "rgb(184,195,181)"  "rgba(184,195,181,255)"  "14-6007TPX_SeaFoam"
#Pnt_14_6008      = $BACBB1;  $FFBACBB1  "#B1CBBA"  "rgb(177,203,186)"  "rgba(177,203,186,255)"  "14-6008TPX_SubtleGreen"
#Pnt_14_6011      = $ACC29B;  $FFACC29B  "#9BC2AC"  "rgb(155,194,172)"  "rgba(155,194,172,255)"  "14-6011TPX_GrayedJade"
#Pnt_14_6017      = $A1BE81;  $FFA1BE81  "#81BEA1"  "rgb(129,190,161)"  "rgba(129,190,161,255)"  "14-6017TPX_NeptuneGreen"
#Pnt_14_6305      = $AABBBF;  $FFAABBBF  "#BFBBAA"  "rgb(191,187,170)"  "rgba(191,187,170,255)"  "14-6305TPX_Pelican"
#Pnt_14_6308      = $A4BABA;  $FFA4BABA  "#BABAA4"  "rgb(186,186,164)"  "rgba(186,186,164,255)"  "14-6308TPX_Alfalfa"
#Pnt_14_6312      = $ACC2A7;  $FFACC2A7  "#A7C2AC"  "rgb(167,194,172)"  "rgba(167,194,172,255)"  "14-6312TPX_CameoGreen"
#Pnt_14_6316      = $9DC39F;  $FF9DC39F  "#9FC39D"  "rgb(159,195,157)"  "rgba(159,195,157,255)"  "14-6316TPX_Sprucestone"
#Pnt_14_6319      = $93BE8D;  $FF93BE8D  "#8DBE93"  "rgb(141,190,147)"  "rgba(141,190,147,255)"  "14-6319TPX_Meadow"
#Pnt_14_6324      = $81B17E;  $FF81B17E  "#7EB181"  "rgb(126,177,129)"  "rgba(126,177,129,255)"  "14-6324TPX_Peapod"
#Pnt_14_6327      = $81B37B;  $FF81B37B  "#7BB381"  "rgb(123,179,129)"  "rgba(123,179,129,255)"  "14-6327TPX_ZephyrGreen"
#Pnt_14_6329      = $81B873;  $FF81B873  "#73B881"  "rgb(115,184,129)"  "rgba(115,184,129,255)"  "14-6329TPX_AbsintheGreen"
#Pnt_14_6330      = $A2D76D;  $FFA2D76D  "#6DD7A2"  "rgb(109,215,162)"  "rgba(109,215,162,255)"  "14-6330TPX_SpringBud"
#Pnt_14_6340      = $8CD36B;  $FF8CD36B  "#6BD38C"  "rgb(107,211,140)"  "rgba(107,211,140,255)"  "14-6340TPX_SpringBouquet"
#Pnt_14_6408      = $95A6A7;  $FF95A6A7  "#A7A695"  "rgb(167,166,149)"  "rgba(167,166,149,255)"  "14-6408TPX_AbbeyStone"
#Pnt_15_0000      = $A5AAAE;  $FFA5AAAE  "#AEAAA5"  "rgb(174,170,165)"  "rgba(174,170,165,255)"  "15-0000TPX_Dove"
#Pnt_15_0146      = $51CC71;  $FF51CC71  "#71CC51"  "rgb(113,204, 81)"  "rgba(113,204, 81,255)"  "15-0146TPX_GreenFlash"
#Pnt_15_0309      = $93A8AF;  $FF93A8AF  "#AFA893"  "rgb(175,168,147)"  "rgba(175,168,147,255)"  "15-0309TPX_SprayGreen"
#Pnt_15_0318      = $85ACB1;  $FF85ACB1  "#B1AC85"  "rgb(177,172,133)"  "rgba(177,172,133,255)"  "15-0318TPX_SageGreen"
#Pnt_15_0326      = $79B2A4;  $FF79B2A4  "#A4B279"  "rgb(164,178,121)"  "rgba(164,178,121,255)"  "15-0326TPX_Tarragon"
#Pnt_15_0332      = $6DB0A2;  $FF6DB0A2  "#A2B06D"  "rgb(162,176,109)"  "rgba(162,176,109,255)"  "15-0332TPX_LeafGreen"
#Pnt_15_0336      = $5AAB93;  $FF5AAB93  "#93AB5A"  "rgb(147,171, 90)"  "rgba(147,171, 90,255)"  "15-0336TPX_HerbalGarden"
#Pnt_15_0341      = $4CB38F;  $FF4CB38F  "#8FB34C"  "rgb(143,179, 76)"  "rgba(143,179, 76,255)"  "15-0341TPX_ParrotGreen"
#Pnt_15_0343      = $4DB591;  $FF4DB591  "#91B54D"  "rgb(145,181, 77)"  "rgba(145,181, 77,255)"  "15-0343TPX_Greenery"
#Pnt_15_0513      = $8FA8AE;  $FF8FA8AE  "#AEA88F"  "rgb(174,168,143)"  "rgba(174,168,143,255)"  "15-0513TPX_Eucalyptus"
#Pnt_15_0522      = $88ADB7;  $FF88ADB7  "#B7AD88"  "rgb(183,173,136)"  "rgba(183,173,136,255)"  "15-0522TPX_PaleOliveGreen"
#Pnt_15_0523      = $83B5B0;  $FF83B5B0  "#B0B583"  "rgb(176,181,131)"  "rgba(176,181,131,255)"  "15-0523TPX_WinterPear"
#Pnt_15_0525      = $7CAFB1;  $FF7CAFB1  "#B1AF7C"  "rgb(177,175,124)"  "rgba(177,175,124,255)"  "15-0525TPX_WeepingWillow"
#Pnt_15_0531      = $68ACA5;  $FF68ACA5  "#A5AC68"  "rgb(165,172,104)"  "rgba(165,172,104,255)"  "15-0531TPX_SweetPea"
#Pnt_15_0533      = $6FBEC4;  $FF6FBEC4  "#C4BE6F"  "rgb(196,190,111)"  "rgba(196,190,111,255)"  "15-0533TPX_LindenGreen"
#Pnt_15_0535      = $58B2B1;  $FF58B2B1  "#B1B258"  "rgb(177,178, 88)"  "rgba(177,178, 88,255)"  "15-0535TPX_Palm"
#Pnt_15_0538      = $50B3AC;  $FF50B3AC  "#ACB350"  "rgb(172,179, 80)"  "rgba(172,179, 80,255)"  "15-0538TPX_GreenOasis"
#Pnt_15_0543      = $3AB8BA;  $FF3AB8BA  "#BAB83A"  "rgb(186,184, 58)"  "rgba(186,184, 58,255)"  "15-0543TPX_AppleGreen"
#Pnt_15_0545      = $45CC81;  $FF45CC81  "#81CC45"  "rgb(129,204, 69)"  "rgba(129,204, 69,255)"  "15-0545TPX_JasmineGreen"
#Pnt_15_0548      = $23ABB5;  $FF23ABB5  "#B5AB23"  "rgb(181,171, 35)"  "rgba(181,171, 35,255)"  "15-0548TPX_Citronelle"
#Pnt_15_0628      = $74B1B6;  $FF74B1B6  "#B6B174"  "rgb(182,177,116)"  "rgba(182,177,116,255)"  "15-0628TPX_LeekGreen"
#Pnt_15_0636      = $60B1BA;  $FF60B1BA  "#BAB160"  "rgb(186,177, 96)"  "rgba(186,177, 96,255)"  "15-0636TPX_GoldenGreen"
#Pnt_15_0643      = $3BADBE;  $FF3BADBE  "#BEAD3B"  "rgb(190,173, 59)"  "rgba(190,173, 59,255)"  "15-0643TPX_CressGreen"
#Pnt_15_0646      = $33B5C7;  $FF33B5C7  "#C7B533"  "rgb(199,181, 51)"  "rgba(199,181, 51,255)"  "15-0646TPX_WarmOlive"
#Pnt_15_0703      = $ACABB3;  $FFACABB3  "#B3ABAC"  "rgb(179,171,172)"  "rgba(179,171,172,255)"  "15-0703TPX_AshesOfRoses"
#Pnt_15_0719      = $7EACBD;  $FF7EACBD  "#BDAC7E"  "rgb(189,172,126)"  "rgba(189,172,126,255)"  "15-0719TPX_SilverFern"
#Pnt_15_0730      = $68A9BE;  $FF68A9BE  "#BEA968"  "rgb(190,169,104)"  "rgba(190,169,104,255)"  "15-0730TPX_SouthernMoss"
#Pnt_15_0732      = $63ADC4;  $FF63ADC4  "#C4AD63"  "rgb(196,173, 99)"  "rgba(196,173, 99,255)"  "15-0732TPX_Olivenite"
#Pnt_15_0743      = $46A6C5;  $FF46A6C5  "#C5A646"  "rgb(197,166, 70)"  "rgba(197,166, 70,255)"  "15-0743TPX_OilYellow"
#Pnt_15_0751      = $1DA0CC;  $FF1DA0CC  "#CCA01D"  "rgb(204,160, 29)"  "rgba(204,160, 29,255)"  "15-0751TPX_LemonCurry"
#Pnt_15_0850      = $31ABD4;  $FF31ABD4  "#D4AB31"  "rgb(212,171, 49)"  "rgba(212,171, 49,255)"  "15-0850TPX_CeylonYellow"
#Pnt_15_0927      = $5F8BB7;  $FF5F8BB7  "#B78B5F"  "rgb(183,139, 95)"  "rgba(183,139, 95,255)"  "15-0927TPX_PaleGold"
#Pnt_15_0942      = $4D9EC2;  $FF4D9EC2  "#C29E4D"  "rgb(194,158, 77)"  "rgba(194,158, 77,255)"  "15-0942TPX_Sauterne"
#Pnt_15_0948      = $3696C5;  $FF3696C5  "#C59636"  "rgb(197,150, 54)"  "rgba(197,150, 54,255)"  "15-0948TPX_ChineseYellow"
#Pnt_15_0953      = $1C8FCC;  $FF1C8FCC  "#CC8F1C"  "rgb(204,143, 28)"  "rgba(204,143, 28,255)"  "15-0953TPX_GoldenYellow"
#Pnt_15_0955      = $00ADEF;  $FF00ADEF  "#EFAD00"  "rgb(239,173,  0)"  "rgba(239,173,  0,255)"  "15-0955TPX_OldGold"
#Pnt_15_1046      = $3C9ED6;  $FF3C9ED6  "#D69E3C"  "rgb(214,158, 60)"  "rgba(214,158, 60,255)"  "15-1046TPX_MineralYellow"
#Pnt_15_1049      = $3BA2E9;  $FF3BA2E9  "#E9A23B"  "rgb(233,162, 59)"  "rgba(233,162, 59,255)"  "15-1049TPX_Artisan'SGold"
#Pnt_15_1050      = $369EDE;  $FF369EDE  "#DE9E36"  "rgb(222,158, 54)"  "rgba(222,158, 54,255)"  "15-1050TPX_GoldenGlow"
#Pnt_15_1054      = $239BF1;  $FF239BF1  "#F19B23"  "rgb(241,155, 35)"  "rgba(241,155, 35,255)"  "15-1054TPX_CadmiumYellow"
#Pnt_15_1058      = $189DFB;  $FF189DFB  "#FB9D18"  "rgb(251,157, 24)"  "rgba(251,157, 24,255)"  "15-1058TPX_RadiantYellow"
#Pnt_15_1062      = $00B1FF;  $FF00B1FF  "#FFB100"  "rgb(255,177,  0)"  "rgba(255,177,  0,255)"  "15-1062TPX_GoldFusion"
#Pnt_15_1114      = $899FBF;  $FF899FBF  "#BF9F89"  "rgb(191,159,137)"  "rgba(191,159,137,255)"  "15-1114TPX_Travertine"
#Pnt_15_1116      = $8DA9B8;  $FF8DA9B8  "#B8A98D"  "rgb(184,169,141)"  "rgba(184,169,141,255)"  "15-1116TPX_Safari"
#Pnt_15_1119      = $80AABF;  $FF80AABF  "#BFAA80"  "rgb(191,170,128)"  "rgba(191,170,128,255)"  "15-1119TPX_TaosTaupe"
#Pnt_15_1132      = $69A9C9;  $FF69A9C9  "#C9A969"  "rgb(201,169,105)"  "rgba(201,169,105,255)"  "15-1132TPX_FallLeaf"
#Pnt_15_1142      = $49A1D5;  $FF49A1D5  "#D5A149"  "rgb(213,161, 73)"  "rgba(213,161, 73,255)"  "15-1142TPX_HoneyGold"
#Pnt_15_1145      = $62AEF7;  $FF62AEF7  "#F7AE62"  "rgb(247,174, 98)"  "rgba(247,174, 98,255)"  "15-1145TPX_Chamois"
#Pnt_15_1147      = $4095E0;  $FF4095E0  "#E09540"  "rgb(224,149, 64)"  "rgba(224,149, 64,255)"  "15-1147TPX_Butterscotch"
#Pnt_15_1150      = $1585E6;  $FF1585E6  "#E68515"  "rgb(230,133, 21)"  "rgba(230,133, 21,255)"  "15-1150TPX_DarkCheddar"
#Pnt_15_1153      = $2E93F2;  $FF2E93F2  "#F2932E"  "rgb(242,147, 46)"  "rgba(242,147, 46,255)"  "15-1153TPX_Apricot"
#Pnt_15_1157      = $178AFC;  $FF178AFC  "#FC8A17"  "rgb(252,138, 23)"  "rgba(252,138, 23,255)"  "15-1157TPX_FlameOrange"
#Pnt_15_1160      = $4AA4FF;  $FF4AA4FF  "#FFA44A"  "rgb(255,164, 74)"  "rgba(255,164, 74,255)"  "15-1160TPX_BlazingOrange"
#Pnt_15_1164      = $008DFF;  $FF008DFF  "#FF8D00"  "rgb(255,141,  0)"  "rgba(255,141,  0,255)"  "15-1164TPX_BrightMarigold"
#Pnt_15_1213      = $86A6BC;  $FF86A6BC  "#BCA686"  "rgb(188,166,134)"  "rgba(188,166,134,255)"  "15-1213TPX_CandiedGinger"
#Pnt_15_1214      = $8CABC0;  $FF8CABC0  "#C0AB8C"  "rgb(192,171,140)"  "rgba(192,171,140,255)"  "15-1214TPX_WarmSand"
#Pnt_15_1215      = $8CA6BB;  $FF8CA6BB  "#BBA68C"  "rgb(187,166,140)"  "rgba(187,166,140,255)"  "15-1215TPX_Sesame"
#Pnt_15_1216      = $90B2C0;  $FF90B2C0  "#C0B290"  "rgb(192,178,144)"  "rgba(192,178,144,255)"  "15-1216TPX_PaleKhaki"
#Pnt_15_1217      = $94B6C6;  $FF94B6C6  "#C6B694"  "rgb(198,182,148)"  "rgba(198,182,148,255)"  "15-1217TPX_MojaveDesert"
#Pnt_15_1218      = $A0C0D7;  $FFA0C0D7  "#D7C0A0"  "rgb(215,192,160)"  "rgba(215,192,160,255)"  "15-1218TPX_Semolina"
#Pnt_15_1220      = $7FA8C4;  $FF7FA8C4  "#C4A87F"  "rgb(196,168,127)"  "rgba(196,168,127,255)"  "15-1220TPX_Lattè"
#Pnt_15_1225      = $7FAACD;  $FF7FAACD  "#CDAA7F"  "rgb(205,170,127)"  "rgba(205,170,127,255)"  "15-1225TPX_Sand"
#Pnt_15_1231      = $72A3D5;  $FF72A3D5  "#D5A372"  "rgb(213,163,114)"  "rgba(213,163,114,255)"  "15-1231TPX_Clay"
#Pnt_15_1234      = $669DE0;  $FF669DE0  "#E09D66"  "rgb(224,157,102)"  "rgba(224,157,102,255)"  "15-1234TPX_GoldEarth"
#Pnt_15_1237      = $5C96DE;  $FF5C96DE  "#DE965C"  "rgb(222,150, 92)"  "rgba(222,150, 92,255)"  "15-1237TPX_ApricotTan"
#Pnt_15_1239      = $80A4FF;  $FF80A4FF  "#FFA480"  "rgb(255,164,128)"  "rgba(255,164,128,255)"  "15-1239TPX_Canteloupe"
#Pnt_15_1242      = $5F95F0;  $FF5F95F0  "#F0955F"  "rgb(240,149, 95)"  "rgba(240,149, 95,255)"  "15-1242TPX_Muskmelon"
#Pnt_15_1245      = $68A6FF;  $FF68A6FF  "#FFA668"  "rgb(255,166,104)"  "rgba(255,166,104,255)"  "15-1245TPX_MockOrange"
#Pnt_15_1247      = $5692F7;  $FF5692F7  "#F79256"  "rgb(247,146, 86)"  "rgba(247,146, 86,255)"  "15-1247TPX_Tangerine"
#Pnt_15_1263      = $0084FF;  $FF0084FF  "#FF8400"  "rgb(255,132,  0)"  "rgba(255,132,  0,255)"  "15-1263TPX_AutumnGlory"
#Pnt_15_1304      = $98ACC3;  $FF98ACC3  "#C3AC98"  "rgb(195,172,152)"  "rgba(195,172,152,255)"  "15-1304TPX_Humus"
#Pnt_15_1305      = $A1B0B9;  $FFA1B0B9  "#B9B0A1"  "rgb(185,176,161)"  "rgba(185,176,161,255)"  "15-1305TPX_FeatherGray"
#Pnt_15_1306      = $95AAB6;  $FF95AAB6  "#B6AA95"  "rgb(182,170,149)"  "rgba(182,170,149,255)"  "15-1306TPX_OxfordTan"
#Pnt_15_1307      = $9BABC4;  $FF9BABC4  "#C4AB9B"  "rgb(196,171,155)"  "rgba(196,171,155,255)"  "15-1307TPX_WhitePepper"
#Pnt_15_1308      = $9AAEBE;  $FF9AAEBE  "#BEAE9A"  "rgb(190,174,154)"  "rgba(190,174,154,255)"  "15-1308TPX_Doeskin"
#Pnt_15_1309      = $9CAEC1;  $FF9CAEC1  "#C1AE9C"  "rgb(193,174,156)"  "rgba(193,174,156,255)"  "15-1309TPX_Moonlight"
#Pnt_15_1314      = $8EA9C5;  $FF8EA9C5  "#C5A98E"  "rgb(197,169,142)"  "rgba(197,169,142,255)"  "15-1314TPX_CubanSand"
#Pnt_15_1315      = $94A9C7;  $FF94A9C7  "#C7A994"  "rgb(199,169,148)"  "rgba(199,169,148,255)"  "15-1315TPX_RugbyTan"
#Pnt_15_1316      = $8EA4C9;  $FF8EA4C9  "#C9A48E"  "rgb(201,164,142)"  "rgba(201,164,142,255)"  "15-1316TPX_MapleSugar"
#Pnt_15_1317      = $859EC2;  $FF859EC2  "#C29E85"  "rgb(194,158,133)"  "rgba(194,158,133,255)"  "15-1317TPX_Sirocco"
#Pnt_15_1318      = $95ADDD;  $FF95ADDD  "#DDAD95"  "rgb(221,173,149)"  "rgba(221,173,149,255)"  "15-1318TPX_PinkSand"
#Pnt_15_1319      = $9AB4E5;  $FF9AB4E5  "#E5B49A"  "rgb(229,180,154)"  "rgba(229,180,154,255)"  "15-1319TPX_AlmostApricot"
#Pnt_15_1322      = $819BD0;  $FF819BD0  "#D09B81"  "rgb(208,155,129)"  "rgba(208,155,129,255)"  "15-1322TPX_DustyCoral"
#Pnt_15_1327      = $7B9DDF;  $FF7B9DDF  "#DF9D7B"  "rgb(223,157,123)"  "rgba(223,157,123,255)"  "15-1327TPX_PeachBloom"
#Pnt_15_1331      = $81A4FB;  $FF81A4FB  "#FBA481"  "rgb(251,164,129)"  "rgba(251,164,129,255)"  "15-1331TPX_CoralReef"
#Pnt_15_1333      = $7692E2;  $FF7692E2  "#E29276"  "rgb(226,146,118)"  "rgba(226,146,118,255)"  "15-1333TPX_CanyonSunset"
#Pnt_15_1334      = $7697EB;  $FF7697EB  "#EB9776"  "rgb(235,151,118)"  "rgba(235,151,118,255)"  "15-1334TPX_ShellCoral"
#Pnt_15_1340      = $6C92F5;  $FF6C92F5  "#F5926C"  "rgb(245,146,108)"  "rgba(245,146,108,255)"  "15-1340TPX_CadmiumOrange"
#Pnt_15_1415      = $A5AEE4;  $FFA5AEE4  "#E4AEA5"  "rgb(228,174,165)"  "rgba(228,174,165,255)"  "15-1415TPX_CoralCloud"
#Pnt_15_1423      = $939EFA;  $FF939EFA  "#FA9E93"  "rgb(250,158,147)"  "rgba(250,158,147,255)"  "15-1423TPX_PeachAmber"
#Pnt_15_1433      = $88A1FE;  $FF88A1FE  "#FEA188"  "rgb(254,161,136)"  "rgba(254,161,136,255)"  "15-1433TPX_PapayaPunch"
#Pnt_15_1435      = $909AFF;  $FF909AFF  "#FF9A90"  "rgb(255,154,144)"  "rgba(255,154,144,255)"  "15-1435TPX_DesertFlower"
#Pnt_15_1506      = $9698B8;  $FF9698B8  "#B89896"  "rgb(184,152,150)"  "rgba(184,152,150,255)"  "15-1506TPX_Etherea"
#Pnt_15_1511      = $91A1C3;  $FF91A1C3  "#C3A191"  "rgb(195,161,145)"  "rgba(195,161,145,255)"  "15-1511TPX_MahoganyRose"
#Pnt_15_1512      = $9FA6CC;  $FF9FA6CC  "#CCA69F"  "rgb(204,166,159)"  "rgba(204,166,159,255)"  "15-1512TPX_MistyRose"
#Pnt_15_1515      = $A4AADE;  $FFA4AADE  "#DEAAA4"  "rgb(222,170,164)"  "rgba(222,170,164,255)"  "15-1515TPX_MellowRose"
#Pnt_15_1516      = $99A2D4;  $FF99A2D4  "#D4A299"  "rgb(212,162,153)"  "rgba(212,162,153,255)"  "15-1516TPX_PeachBeige"
#Pnt_15_1523      = $889AE0;  $FF889AE0  "#E09A88"  "rgb(224,154,136)"  "rgba(224,154,136,255)"  "15-1523TPX_Shrimp"
#Pnt_15_1530      = $8495F9;  $FF8495F9  "#F99584"  "rgb(249,149,132)"  "rgba(249,149,132,255)"  "15-1530TPX_PeachPink"
#Pnt_15_1607      = $A4A4C5;  $FFA4A4C5  "#C5A4A4"  "rgb(197,164,164)"  "rgba(197,164,164,255)"  "15-1607TPX_PaleMauve"
#Pnt_15_1611      = $A4A2D7;  $FFA4A2D7  "#D7A2A4"  "rgb(215,162,164)"  "rgba(215,162,164,255)"  "15-1611TPX_BridalRose"
#Pnt_15_1614      = $9E95D0;  $FF9E95D0  "#D0959E"  "rgb(208,149,158)"  "rgba(208,149,158,255)"  "15-1614TPX_Blush"
#Pnt_15_1621      = $A0A1F6;  $FFA0A1F6  "#F6A1A0"  "rgb(246,161,160)"  "rgba(246,161,160,255)"  "15-1621TPX_CandlelightPeach"
#Pnt_15_1624      = $988CFB;  $FF988CFB  "#FB8C98"  "rgb(251,140,152)"  "rgba(251,140,152,255)"  "15-1624TPX_ConchShell"
#Pnt_15_1626      = $9488FF;  $FF9488FF  "#FF8894"  "rgb(255,136,148)"  "rgba(255,136,148,255)"  "15-1626TPX_SalmonRose"
#Pnt_15_1717      = $A9A2EE;  $FFA9A2EE  "#EEA2A9"  "rgb(238,162,169)"  "rgba(238,162,169,255)"  "15-1717TPX_PinkIcing"
#Pnt_15_1816      = $AE9FED;  $FFAE9FED  "#ED9FAE"  "rgb(237,159,174)"  "rgba(237,159,174,255)"  "15-1816TPX_Peony"
#Pnt_15_1821      = $A196F4;  $FFA196F4  "#F496A1"  "rgb(244,150,161)"  "rgba(244,150,161,255)"  "15-1821TPX_FlamingoPink"
#Pnt_15_1905      = $B5AFC6;  $FFB5AFC6  "#C6AFB5"  "rgb(198,175,181)"  "rgba(198,175,181,255)"  "15-1905TPX_BurnishedLilac"
#Pnt_15_1906      = $ABA2CC;  $FFABA2CC  "#CCA2AB"  "rgb(204,162,171)"  "rgba(204,162,171,255)"  "15-1906TPX_Zephyr"
#Pnt_15_1912      = $B099E2;  $FFB099E2  "#E299B0"  "rgb(226,153,176)"  "rgba(226,153,176,255)"  "15-1912TPX_SeaPink"
#Pnt_15_1920      = $A281EB;  $FFA281EB  "#EB81A2"  "rgb(235,129,162)"  "rgba(235,129,162,255)"  "15-1920TPX_MorningGlory"
#Pnt_15_1922      = $A38FF5;  $FFA38FF5  "#F58FA3"  "rgb(245,143,163)"  "rgba(245,143,163,255)"  "15-1922TPX_GeraniumPink"
#Pnt_15_2205      = $B4A4C1;  $FFB4A4C1  "#C1A4B4"  "rgb(193,164,180)"  "rgba(193,164,180,255)"  "15-2205TPX_DawnPink"
#Pnt_15_2210      = $AE94D1;  $FFAE94D1  "#D194AE"  "rgb(209,148,174)"  "rgba(209,148,174,255)"  "15-2210TPX_OrchidSmoke"
#Pnt_15_2214      = $B78FE3;  $FFB78FE3  "#E38FB7"  "rgb(227,143,183)"  "rgba(227,143,183,255)"  "15-2214TPX_Rosebloom"
#Pnt_15_2215      = $BE9AE9;  $FFBE9AE9  "#E99ABE"  "rgb(233,154,190)"  "rgba(233,154,190,255)"  "15-2215TPX_BegoniaPink"
#Pnt_15_2216      = $B388F3;  $FFB388F3  "#F388B3"  "rgb(243,136,179)"  "rgba(243,136,179,255)"  "15-2216TPX_SachetPink"
#Pnt_15_2217      = $AA80E6;  $FFAA80E6  "#E680AA"  "rgb(230,128,170)"  "rgba(230,128,170,255)"  "15-2217TPX_AuroraPink"
#Pnt_15_2705      = $B5AAC4;  $FFB5AAC4  "#C4AAB5"  "rgb(196,170,181)"  "rgba(196,170,181,255)"  "15-2705TPX_KeepsakeLilac"
#Pnt_15_2706      = $B4B1C3;  $FFB4B1C3  "#C3B1B4"  "rgb(195,177,180)"  "rgba(195,177,180,255)"  "15-2706TPX_VioletIce"
#Pnt_15_2718      = $BB8BE0;  $FFBB8BE0  "#E08BBB"  "rgb(224,139,187)"  "rgba(224,139,187,255)"  "15-2718TPX_FuchsiaPink"
#Pnt_15_2913      = $CC9DDF;  $FFCC9DDF  "#DF9DCC"  "rgb(223,157,204)"  "rgba(223,157,204,255)"  "15-2913TPX_LilacChiffon"
#Pnt_15_3207      = $BA9FC4;  $FFBA9FC4  "#C49FBA"  "rgb(196,159,186)"  "rgba(196,159,186,255)"  "15-3207TPX_MauveMist"
#Pnt_15_3214      = $CB9BD3;  $FFCB9BD3  "#D39BCB"  "rgb(211,155,203)"  "rgba(211,155,203,255)"  "15-3214TPX_Orchid"
#Pnt_15_3412      = $D5ADD2;  $FFD5ADD2  "#D2ADD5"  "rgb(210,173,213)"  "rgba(210,173,213,255)"  "15-3412TPX_OrchidBouquet"
#Pnt_15_3507      = $C1A8BA;  $FFC1A8BA  "#BAA8C1"  "rgb(186,168,193)"  "rgba(186,168,193,255)"  "15-3507TPX_LavenderFrost"
#Pnt_15_3508      = $C5ACC1;  $FFC5ACC1  "#C1ACC5"  "rgb(193,172,197)"  "rgba(193,172,197,255)"  "15-3508TPX_FairOrchid"
#Pnt_15_3620      = $CEA0BB;  $FFCEA0BB  "#BBA0CE"  "rgb(187,160,206)"  "rgba(187,160,206,255)"  "15-3620TPX_Lavendula"
#Pnt_15_3800      = $A0A1B8;  $FFA0A1B8  "#B8A1A0"  "rgb(184,161,160)"  "rgba(184,161,160,255)"  "15-3800TPX_Porpoise"
#Pnt_15_3802      = $ADA9B7;  $FFADA9B7  "#B7A9AD"  "rgb(183,169,173)"  "rgba(183,169,173,255)"  "15-3802TPX_CloudGray"
#Pnt_15_3807      = $C9B8BC;  $FFC9B8BC  "#BCB8C9"  "rgb(188,184,201)"  "rgba(188,184,201,255)"  "15-3807TPX_MistyLilac"
#Pnt_15_3817      = $D4A4B2;  $FFD4A4B2  "#B2A4D4"  "rgb(178,164,212)"  "rgba(178,164,212,255)"  "15-3817TPX_Lavender"
#Pnt_15_3908      = $BAA9BC;  $FFBAA9BC  "#BCA9BA"  "rgb(188,169,186)"  "rgba(188,169,186,255)"  "15-3908TPX_IcelandicBlue"
#Pnt_15_3909      = $C9ACA8;  $FFC9ACA8  "#A8ACC9"  "rgb(168,172,201)"  "rgba(168,172,201,255)"  "15-3909TPX_CosmicSky"
#Pnt_15_3910      = $BFA4A4;  $FFBFA4A4  "#A4A4BF"  "rgb(164,164,191)"  "rgba(164,164,191,255)"  "15-3910TPX_LanguidLavender"
#Pnt_15_3912      = $AE99AE;  $FFAE99AE  "#AE99AE"  "rgb(174,153,174)"  "rgba(174,153,174,255)"  "15-3912TPX_Aleutian"
#Pnt_15_3915      = $D4B2A0;  $FFD4B2A0  "#A0B2D4"  "rgb(160,178,212)"  "rgba(160,178,212,255)"  "15-3915TPX_KentuckyBlue"
#Pnt_15_3920      = $D7AE8D;  $FFD7AE8D  "#8DAED7"  "rgb(141,174,215)"  "rgba(141,174,215,255)"  "15-3920TPX_PlacidBlue"
#Pnt_15_3930      = $D99E7C;  $FFD99E7C  "#7C9ED9"  "rgb(124,158,217)"  "rgba(124,158,217,255)"  "15-3930TPX_VistaBlue"
#Pnt_15_3932      = $B28E98;  $FFB28E98  "#988EB2"  "rgb(152,142,178)"  "rgba(152,142,178,255)"  "15-3932TPX_BelAirBlue"
#Pnt_15_4003      = $B6BAB2;  $FFB6BAB2  "#B2BAB6"  "rgb(178,186,182)"  "rgba(178,186,182,255)"  "15-4003TPX_StormGray"
#Pnt_15_4005      = $D2BE9F;  $FFD2BE9F  "#9FBED2"  "rgb(159,190,210)"  "rgba(159,190,210,255)"  "15-4005TPX_DreamBlue"
#Pnt_15_4008      = $BFAD99;  $FFBFAD99  "#99ADBF"  "rgb(153,173,191)"  "rgba(153,173,191,255)"  "15-4008TPX_BlueFog"
#Pnt_15_4020      = $D4B498;  $FFD4B498  "#98B4D4"  "rgb(152,180,212)"  "rgba(152,180,212,255)"  "15-4020TPX_Cerulean"
#Pnt_15_4030      = $C8AAB0;  $FFC8AAB0  "#B0AAC8"  "rgb(176,170,200)"  "rgba(176,170,200,255)"  "15-4030TPX_ChambrayBlue"
#Pnt_15_4101      = $B3B1AB;  $FFB3B1AB  "#ABB1B3"  "rgb(171,177,179)"  "rgba(171,177,179,255)"  "15-4101TPX_High-Rise"
#Pnt_15_4105      = $D7BC9C;  $FFD7BC9C  "#9CBCD7"  "rgb(156,188,215)"  "rgba(156,188,215,255)"  "15-4105TPX_AngelFalls"
#Pnt_15_4225      = $D6AC6D;  $FFD6AC6D  "#6DACD6"  "rgb(109,172,214)"  "rgba(109,172,214,255)"  "15-4225TPX_AlaskanBlue"
#Pnt_15_4305      = $AAA59A;  $FFAAA59A  "#9AA5AA"  "rgb(154,165,170)"  "rgba(154,165,170,255)"  "15-4305TPX_Quarry"
#Pnt_15_4306      = $AAA5B3;  $FFAAA5B3  "#B3A5AA"  "rgb(179,165,170)"  "rgba(179,165,170,255)"  "15-4306TPX_BelgianBlock"
#Pnt_15_4307      = $8F8294;  $FF8F8294  "#94828F"  "rgb(148,130,143)"  "rgba(148,130,143,255)"  "15-4307TPX_Tradewinds"
#Pnt_15_4309      = $C6BB9F;  $FFC6BB9F  "#9FBBC6"  "rgb(159,187,198)"  "rgba(159,187,198,255)"  "15-4309TPX_SterlingBlue"
#Pnt_15_4312      = $C1AF8D;  $FFC1AF8D  "#8DAFC1"  "rgb(141,175,193)"  "rgba(141,175,193,255)"  "15-4312TPX_Forget-Me-Not"
#Pnt_15_4319      = $CDB17C;  $FFCDB17C  "#7CB1CD"  "rgb(124,177,205)"  "rgba(124,177,205,255)"  "15-4319TPX_AirBlue"
#Pnt_15_4323      = $D5AB5D;  $FFD5AB5D  "#5DABD5"  "rgb( 93,171,213)"  "rgba( 93,171,213,255)"  "15-4323TPX_EtherealBlue"
#Pnt_15_4415      = $BEAA71;  $FFBEAA71  "#71AABE"  "rgb(113,170,190)"  "rgba(113,170,190,255)"  "15-4415TPX_MilkyBlue"
#Pnt_15_4421      = $D2AF5E;  $FFD2AF5E  "#5EAFD2"  "rgb( 94,175,210)"  "rgba( 94,175,210,255)"  "15-4421TPX_BlueGrotto"
#Pnt_15_4427      = $CCA94E;  $FFCCA94E  "#4EA9CC"  "rgb( 78,169,204)"  "rgba( 78,169,204,255)"  "15-4427TPX_NorseBlue"
#Pnt_15_4502      = $ADB3BA;  $FFADB3BA  "#BAB3AD"  "rgb(186,179,173)"  "rgba(186,179,173,255)"  "15-4502TPX_SilverCloud"
#Pnt_15_4503      = $A5AEB6;  $FFA5AEB6  "#B6AEA5"  "rgb(182,174,165)"  "rgba(182,174,165,255)"  "15-4503TPX_ChateauGray"
#Pnt_15_4702      = $ACB0A4;  $FFACB0A4  "#A4B0AC"  "rgb(164,176,172)"  "rgba(164,176,172,255)"  "15-4702TPX_PuritanGray"
#Pnt_15_4703      = $AAADA1;  $FFAAADA1  "#A1ADAA"  "rgb(161,173,170)"  "rgba(161,173,170,255)"  "15-4703TPX_MirageGray"
#Pnt_15_4704      = $AEB3A9;  $FFAEB3A9  "#A9B3AE"  "rgb(169,179,174)"  "rgba(169,179,174,255)"  "15-4704TPX_Pigeon"
#Pnt_15_4706      = $AFAF99;  $FFAFAF99  "#99AFAF"  "rgb(153,175,175)"  "rgba(153,175,175,255)"  "15-4706TPX_GrayMist"
#Pnt_15_4707      = $B9BA9E;  $FFB9BA9E  "#9EBAB9"  "rgb(158,186,185)"  "rgba(158,186,185,255)"  "15-4707TPX_BlueHaze"
#Pnt_15_4712      = $B7AF6D;  $FFB7AF6D  "#6DAFB7"  "rgb(109,175,183)"  "rgba(109,175,183,255)"  "15-4712TPX_MarineBlue"
#Pnt_15_4714      = $B99459;  $FFB99459  "#5994B9"  "rgb( 89,148,185)"  "rgba( 89,148,185,255)"  "15-4714TPX_Aquarelle"
#Pnt_15_4715      = $B4B06A;  $FFB4B06A  "#6AB0B4"  "rgb(106,176,180)"  "rgba(106,176,180,255)"  "15-4715TPX_AquaSea"
#Pnt_15_4717      = $B0A263;  $FFB0A263  "#63A2B0"  "rgb( 99,162,176)"  "rgba( 99,162,176,255)"  "15-4717TPX_Aqua"
#Pnt_15_4720      = $D0B33B;  $FFD0B33B  "#3BB3D0"  "rgb( 59,179,208)"  "rgba( 59,179,208,255)"  "15-4720TPX_RiverBlue"
#Pnt_15_4722      = $CBBD42;  $FFCBBD42  "#42BDCB"  "rgb( 66,189,203)"  "rgba( 66,189,203,255)"  "15-4722TPX_Capri"
#Pnt_15_4825      = $C7BD2A;  $FFC7BD2A  "#2ABDC7"  "rgb( 42,189,199)"  "rgba( 42,189,199,255)"  "15-4825TPX_BlueCuracao"
#Pnt_15_5205      = $A8B0A2;  $FFA8B0A2  "#A2B0A8"  "rgb(162,176,168)"  "rgba(162,176,168,255)"  "15-5205TPX_AquaGray"
#Pnt_15_5207      = $ABAB82;  $FFABAB82  "#82ABAB"  "rgb(130,171,171)"  "rgba(130,171,171,255)"  "15-5207TPX_Aquifer"
#Pnt_15_5209      = $BBB882;  $FFBBB882  "#82B8BB"  "rgb(130,184,187)"  "rgba(130,184,187,255)"  "15-5209TPX_AquaHaze"
#Pnt_15_5210      = $ADA978;  $FFADA978  "#78A9AD"  "rgb(120,169,173)"  "rgba(120,169,173,255)"  "15-5210TPX_NileBlue"
#Pnt_15_5217      = $B0B455;  $FFB0B455  "#55B4B0"  "rgb( 85,180,176)"  "rgba( 85,180,176,255)"  "15-5217TPX_BlueTurquoise"
#Pnt_15_5218      = $BAC06C;  $FFBAC06C  "#6CC0BA"  "rgb(108,192,186)"  "rgba(108,192,186,255)"  "15-5218TPX_PoolBlue"
#Pnt_15_5416      = $AAC148;  $FFAAC148  "#48C1AA"  "rgb( 72,193,170)"  "rgba( 72,193,170,255)"  "15-5416TPX_FloridaKeys"
#Pnt_15_5421      = $A1BC00;  $FFA1BC00  "#00BCA1"  "rgb(  0,188,161)"  "rgba(  0,188,161,255)"  "15-5421TPX_AquaGreen"
#Pnt_15_5425      = $A1B500;  $FFA1B500  "#00B5A1"  "rgb(  0,181,161)"  "rgba(  0,181,161,255)"  "15-5425TPX_Atlantis"
#Pnt_15_5516      = $A6B441;  $FFA6B441  "#41B4A6"  "rgb( 65,180,166)"  "rgba( 65,180,166,255)"  "15-5516TPX_Waterfall"
#Pnt_15_5519      = $ACB845;  $FFACB845  "#45B8AC"  "rgb( 69,184,172)"  "rgba( 69,184,172,255)"  "15-5519TPX_Turquoise"
#Pnt_15_5534      = $5BA300;  $FF5BA300  "#00A35B"  "rgb(  0,163, 91)"  "rgba(  0,163, 91,255)"  "15-5534TPX_BrightGreen"
#Pnt_15_5704      = $ADB6B1;  $FFADB6B1  "#B1B6AD"  "rgb(177,182,173)"  "rgba(177,182,173,255)"  "15-5704TPX_MineralGray"
#Pnt_15_5706      = $A7B5A1;  $FFA7B5A1  "#A1B5A7"  "rgb(161,181,167)"  "rgba(161,181,167,255)"  "15-5706TPX_FrostyGreen"
#Pnt_15_5711      = $A4BB7D;  $FFA4BB7D  "#7DBBA4"  "rgb(125,187,164)"  "rgba(125,187,164,255)"  "15-5711TPX_DustyJadeGreen"
#Pnt_15_5718      = $A3C647;  $FFA3C647  "#47C6A3"  "rgb( 71,198,163)"  "rgba( 71,198,163,255)"  "15-5718TPX_BiscayGreen"
#Pnt_15_5728      = $92B900;  $FF92B900  "#00B992"  "rgb(  0,185,146)"  "rgba(  0,185,146,255)"  "15-5728TPX_MintLeaf"
#Pnt_15_5812      = $AFC49B;  $FFAFC49B  "#9BC4AF"  "rgb(155,196,175)"  "rgba(155,196,175,255)"  "15-5812TPX_Lichen"
#Pnt_15_5819      = $A2C261;  $FFA2C261  "#61C2A2"  "rgb( 97,194,162)"  "rgba( 97,194,162,255)"  "15-5819TPX_Spearmint"
#Pnt_15_6114      = $A2C397;  $FFA2C397  "#97C3A2"  "rgb(151,195,162)"  "rgba(151,195,162,255)"  "15-6114TPX_Hemlock"
#Pnt_15_6120      = $8CB57E;  $FF8CB57E  "#7EB58C"  "rgb(126,181,140)"  "rgba(126,181,140,255)"  "15-6120TPX_Ming"
#Pnt_15_6123      = $93BD61;  $FF93BD61  "#61BD93"  "rgb( 97,189,147)"  "rgba( 97,189,147,255)"  "15-6123TPX_JadeCream"
#Pnt_15_6304      = $A4AFAE;  $FFA4AFAE  "#AEAFA4"  "rgb(174,175,164)"  "rgba(174,175,164,255)"  "15-6304TPX_PussywillowGray"
#Pnt_15_6307      = $A5B5B4;  $FFA5B5B4  "#B4B5A5"  "rgb(180,181,165)"  "rgba(180,181,165,255)"  "15-6307TPX_AgateGray"
#Pnt_15_6310      = $9CB6AD;  $FF9CB6AD  "#ADB69C"  "rgb(173,182,156)"  "rgba(173,182,156,255)"  "15-6310TPX_Swamp"
#Pnt_15_6313      = $9DBAA9;  $FF9DBAA9  "#A9BA9D"  "rgb(169,186,157)"  "rgba(169,186,157,255)"  "15-6313TPX_LaurelGreen"
#Pnt_15_6315      = $A4BEA5;  $FFA4BEA5  "#A5BEA4"  "rgb(165,190,164)"  "rgba(165,190,164,255)"  "15-6315TPX_SmokeGreen"
#Pnt_15_6316      = $89B290;  $FF89B290  "#90B289"  "rgb(144,178,137)"  "rgba(144,178,137,255)"  "15-6316TPX_FairGreen"
#Pnt_15_6317      = $9BC4A2;  $FF9BC4A2  "#A2C49B"  "rgb(162,196,155)"  "rgba(162,196,155,255)"  "15-6317TPX_QuietGreen"
#Pnt_15_6322      = $86B37D;  $FF86B37D  "#7DB386"  "rgb(125,179,134)"  "rgba(125,179,134,255)"  "15-6322TPX_LightGrassGreen"
#Pnt_15_6340      = $75C540;  $FF75C540  "#40C575"  "rgb( 64,197,117)"  "rgba( 64,197,117,255)"  "15-6340TPX_IrishGreen"
#Pnt_15_6410      = $91A9AB;  $FF91A9AB  "#ABA991"  "rgb(171,169,145)"  "rgba(171,169,145,255)"  "15-6410TPX_MossGray"
#Pnt_15_6414      = $92B2A2;  $FF92B2A2  "#A2B292"  "rgb(162,178,146)"  "rgba(162,178,146,255)"  "15-6414TPX_Reseda"
#Pnt_15_6423      = $7CAD8E;  $FF7CAD8E  "#8EAD7C"  "rgb(142,173,124)"  "rgba(142,173,124,255)"  "15-6423TPX_ForestShade"
#Pnt_15_6428      = $67A880;  $FF67A880  "#80A867"  "rgb(128,168,103)"  "rgba(128,168,103,255)"  "15-6428TPX_GreenTea"
#Pnt_15_6432      = $6AA574;  $FF6AA574  "#74A56A"  "rgb(116,165,106)"  "rgba(116,165,106,255)"  "15-6432TPX_Shamrock"
#Pnt_15_6437      = $65B67B;  $FF65B67B  "#7BB665"  "rgb(123,182,101)"  "rgba(123,182,101,255)"  "15-6437TPX_GrassGreen"
#Pnt_15_6442      = $61B67B;  $FF61B67B  "#7BB661"  "rgb(123,182, 97)"  "rgba(123,182, 97,255)"  "15-6442TPX_BudGreen"
#Pnt_16_0000      = $9C9D9E;  $FF9C9D9E  "#9E9D9C"  "rgb(158,157,156)"  "rgba(158,157,156,255)"  "16-0000TPX_Paloma"
#Pnt_16_0110      = $99ACA3;  $FF99ACA3  "#A3AC99"  "rgb(163,172,153)"  "rgba(163,172,153,255)"  "16-0110TPX_DesertSage"
#Pnt_16_0123      = $71A58C;  $FF71A58C  "#8CA571"  "rgb(140,165,113)"  "rgba(140,165,113,255)"  "16-0123TPX_Tendril"
#Pnt_16_0205      = $8793A7;  $FF8793A7  "#A79387"  "rgb(167,147,135)"  "rgba(167,147,135,255)"  "16-0205TPX_VintageKhaki"
#Pnt_16_0207      = $919EA0;  $FF919EA0  "#A09E91"  "rgb(160,158,145)"  "rgba(160,158,145,255)"  "16-0207TPX_LondonFog"
#Pnt_16_0213      = $859D9A;  $FF859D9A  "#9A9D85"  "rgb(154,157,133)"  "rgba(154,157,133,255)"  "16-0213TPX_Tea"
#Pnt_16_0220      = $7A9D84;  $FF7A9D84  "#849D7A"  "rgb(132,157,122)"  "rgba(132,157,122,255)"  "16-0220TPX_Mistletoe"
#Pnt_16_0224      = $69967B;  $FF69967B  "#7B9669"  "rgb(123,150,105)"  "rgba(123,150,105,255)"  "16-0224TPX_GreenEyes"
#Pnt_16_0228      = $629874;  $FF629874  "#749862"  "rgb(116,152, 98)"  "rgba(116,152, 98,255)"  "16-0228TPX_JadeGreen"
#Pnt_16_0230      = $3DB79D;  $FF3DB79D  "#9DB73D"  "rgb(157,183, 61)"  "rgba(157,183, 61,255)"  "16-0230TPX_MacawGreen"
#Pnt_16_0233      = $54966D;  $FF54966D  "#6D9654"  "rgb(109,150, 84)"  "rgba(109,150, 84,255)"  "16-0233TPX_MeadowGreen"
#Pnt_16_0235      = $57AE7B;  $FF57AE7B  "#7BAE57"  "rgb(123,174, 87)"  "rgba(123,174, 87,255)"  "16-0235TPX_Kiwi"
#Pnt_16_0237      = $4F9F75;  $FF4F9F75  "#759F4F"  "rgb(117,159, 79)"  "rgba(117,159, 79,255)"  "16-0237TPX_Foliage"
#Pnt_16_0421      = $6B918F;  $FF6B918F  "#8F916B"  "rgb(143,145,107)"  "rgba(143,145,107,255)"  "16-0421TPX_Sage"
#Pnt_16_0430      = $629E99;  $FF629E99  "#999E62"  "rgb(153,158, 98)"  "rgba(153,158, 98,255)"  "16-0430TPX_Fern"
#Pnt_16_0435      = $4AAA9D;  $FF4AAA9D  "#9DAA4A"  "rgb(157,170, 74)"  "rgba(157,170, 74,255)"  "16-0435TPX_DarkCitron"
#Pnt_16_0439      = $4B9C8E;  $FF4B9C8E  "#8E9C4B"  "rgb(142,156, 75)"  "rgba(142,156, 75,255)"  "16-0439TPX_SpinachGreen"
#Pnt_16_0518      = $7B9DA4;  $FF7B9DA4  "#A49D7B"  "rgb(164,157,123)"  "rgba(164,157,123,255)"  "16-0518TPX_GrayGreen"
#Pnt_16_0526      = $639093;  $FF639093  "#939063"  "rgb(147,144, 99)"  "rgba(147,144, 99,255)"  "16-0526TPX_Cedar"
#Pnt_16_0532      = $539C9C;  $FF539C9C  "#9C9C53"  "rgb(156,156, 83)"  "rgba(156,156, 83,255)"  "16-0532TPX_Moss"
#Pnt_16_0540      = $47A3A3;  $FF47A3A3  "#A3A347"  "rgb(163,163, 71)"  "rgba(163,163, 71,255)"  "16-0540TPX_Oasis"
#Pnt_16_0613      = $86A1A4;  $FF86A1A4  "#A4A186"  "rgb(164,161,134)"  "rgba(164,161,134,255)"  "16-0613TPX_Elm"
#Pnt_16_0632      = $518F9D;  $FF518F9D  "#9D8F51"  "rgb(157,143, 81)"  "rgba(157,143, 81,255)"  "16-0632TPX_Willow"
#Pnt_16_0639      = $4297AD;  $FF4297AD  "#AD9742"  "rgb(173,151, 66)"  "rgba(173,151, 66,255)"  "16-0639TPX_GoldenOlive"
#Pnt_16_0713      = $7A959E;  $FF7A959E  "#9E957A"  "rgb(158,149,122)"  "rgba(158,149,122,255)"  "16-0713TPX_SlateGreen"
#Pnt_16_0726      = $5E8FA1;  $FF5E8FA1  "#A18F5E"  "rgb(161,143, 94)"  "rgba(161,143, 94,255)"  "16-0726TPX_Khaki"
#Pnt_16_0730      = $5E9FB6;  $FF5E9FB6  "#B69F5E"  "rgb(182,159, 94)"  "rgba(182,159, 94,255)"  "16-0730TPX_AntiqueGold"
#Pnt_16_0737      = $519AA8;  $FF519AA8  "#A89A51"  "rgb(168,154, 81)"  "rgba(168,154, 81,255)"  "16-0737TPX_BurnishedGold"
#Pnt_16_0742      = $318EAF;  $FF318EAF  "#AF8E31"  "rgb(175,142, 49)"  "rgba(175,142, 49,255)"  "16-0742TPX_GreenSulphur"
#Pnt_16_0806      = $8E9CA4;  $FF8E9CA4  "#A49C8E"  "rgb(164,156,142)"  "rgba(164,156,142,255)"  "16-0806TPX_Goat"
#Pnt_16_0836      = $579BB4;  $FF579BB4  "#B49B57"  "rgb(180,155, 87)"  "rgba(180,155, 87,255)"  "16-0836TPX_RichGold"
#Pnt_16_0840      = $1EA1BD;  $FF1EA1BD  "#BDA11E"  "rgb(189,161, 30)"  "rgba(189,161, 30,255)"  "16-0840TPX_AntiqueMoss"
#Pnt_16_0847      = $308DAD;  $FF308DAD  "#AD8D30"  "rgb(173,141, 48)"  "rgba(173,141, 48,255)"  "16-0847TPX_OliveOil"
#Pnt_16_0906      = $92A0AB;  $FF92A0AB  "#ABA092"  "rgb(171,160,146)"  "rgba(171,160,146,255)"  "16-0906TPX_SimplyTaupe"
#Pnt_16_0920      = $8FACCA;  $FF8FACCA  "#CAAC8F"  "rgb(202,172,143)"  "rgba(202,172,143,255)"  "16-0920TPX_Curds&Amp;Whey"
#Pnt_16_0924      = $7EA5BF;  $FF7EA5BF  "#BFA57E"  "rgb(191,165,126)"  "rgba(191,165,126,255)"  "16-0924TPX_Croissant"
#Pnt_16_0928      = $699CBC;  $FF699CBC  "#BC9C69"  "rgb(188,156,105)"  "rgba(188,156,105,255)"  "16-0928TPX_Curry"
#Pnt_16_0940      = $649CC6;  $FF649CC6  "#C69C64"  "rgb(198,156,100)"  "rgba(198,156,100,255)"  "16-0940TPX_Taffy"
#Pnt_16_0945      = $4B99C4;  $FF4B99C4  "#C4994B"  "rgb(196,153, 75)"  "rgba(196,153, 75,255)"  "16-0945TPX_Tinsel"
#Pnt_16_0946      = $3793BC;  $FF3793BC  "#BC9337"  "rgb(188,147, 55)"  "rgba(188,147, 55,255)"  "16-0946TPX_Honey"
#Pnt_16_0947      = $4AA1D1;  $FF4AA1D1  "#D1A14A"  "rgb(209,161, 74)"  "rgba(209,161, 74,255)"  "16-0947TPX_BrightGold"
#Pnt_16_0948      = $3488B4;  $FF3488B4  "#B48834"  "rgb(180,136, 52)"  "rgba(180,136, 52,255)"  "16-0948TPX_HarvestGold"
#Pnt_16_0950      = $4192C6;  $FF4192C6  "#C69241"  "rgb(198,146, 65)"  "rgba(198,146, 65,255)"  "16-0950TPX_Narcissus"
#Pnt_16_0952      = $1E98CA;  $FF1E98CA  "#CA981E"  "rgb(202,152, 30)"  "rgba(202,152, 30,255)"  "16-0952TPX_NuggetGold"
#Pnt_16_0953      = $1F94C4;  $FF1F94C4  "#C4941F"  "rgb(196,148, 31)"  "rgba(196,148, 31,255)"  "16-0953TPX_TawnyOlive"
#Pnt_16_0954      = $1F8BBC;  $FF1F8BBC  "#BC8B1F"  "rgb(188,139, 31)"  "rgba(188,139, 31,255)"  "16-0954TPX_Arrowwood"
#Pnt_16_1010      = $7796AB;  $FF7796AB  "#AB9677"  "rgb(171,150,119)"  "rgba(171,150,119,255)"  "16-1010TPX_Incense"
#Pnt_16_1054      = $2790D3;  $FF2790D3  "#D39027"  "rgb(211,144, 39)"  "rgba(211,144, 39,255)"  "16-1054TPX_Sunflower"
#Pnt_16_1104      = $8F9AB7;  $FF8F9AB7  "#B79A8F"  "rgb(183,154,143)"  "rgba(183,154,143,255)"  "16-1104TPX_Crockery"
#Pnt_16_1105      = $8B9EA7;  $FF8B9EA7  "#A79E8B"  "rgb(167,158,139)"  "rgba(167,158,139,255)"  "16-1105TPX_PlazaTaupe"
#Pnt_16_1106      = $8498A2;  $FF8498A2  "#A29884"  "rgb(162,152,132)"  "rgba(162,152,132,255)"  "16-1106TPX_Tuffet"
#Pnt_16_1107      = $88969C;  $FF88969C  "#9C9688"  "rgb(156,150,136)"  "rgba(156,150,136,255)"  "16-1107TPX_Aluminum"
#Pnt_16_1108      = $819EA8;  $FF819EA8  "#A89E81"  "rgb(168,158,129)"  "rgba(168,158,129,255)"  "16-1108TPX_Twill"
#Pnt_16_1109      = $7B88A0;  $FF7B88A0  "#A0887B"  "rgb(160,136,123)"  "rgba(160,136,123,255)"  "16-1109TPX_Greige"
#Pnt_16_1110      = $7799A5;  $FF7799A5  "#A59977"  "rgb(165,153,119)"  "rgba(165,153,119,255)"  "16-1110TPX_OliveGray"
#Pnt_16_1118      = $799BA6;  $FF799BA6  "#A69B79"  "rgb(166,155,121)"  "rgba(166,155,121,255)"  "16-1118TPX_Sponge"
#Pnt_16_1120      = $85A1BF;  $FF85A1BF  "#BFA185"  "rgb(191,161,133)"  "rgba(191,161,133,255)"  "16-1120TPX_Starfish"
#Pnt_16_1126      = $5C91AB;  $FF5C91AB  "#AB915C"  "rgb(171,145, 92)"  "rgba(171,145, 92,255)"  "16-1126TPX_Antelope"
#Pnt_16_1133      = $5190B2;  $FF5190B2  "#B29051"  "rgb(178,144, 81)"  "rgba(178,144, 81,255)"  "16-1133TPX_MustardGold"
#Pnt_16_1139      = $488EBC;  $FF488EBC  "#BC8E48"  "rgb(188,142, 72)"  "rgba(188,142, 72,255)"  "16-1139TPX_AmberGold"
#Pnt_16_1140      = $3B8BD3;  $FF3B8BD3  "#D38B3B"  "rgb(211,139, 59)"  "rgba(211,139, 59,255)"  "16-1140TPX_Yam"
#Pnt_16_1142      = $539CE0;  $FF539CE0  "#E09C53"  "rgb(224,156, 83)"  "rgba(224,156, 83,255)"  "16-1142TPX_GoldenNugget"
#Pnt_16_1143      = $5093CC;  $FF5093CC  "#CC9350"  "rgb(204,147, 80)"  "rgba(204,147, 80,255)"  "16-1143TPX_HoneyYellow"
#Pnt_16_1144      = $5D9DD0;  $FF5D9DD0  "#D09D5D"  "rgb(208,157, 93)"  "rgba(208,157, 93,255)"  "16-1144TPX_OakBuff"
#Pnt_16_1148      = $4389CF;  $FF4389CF  "#CF8943"  "rgb(207,137, 67)"  "rgba(207,137, 67,255)"  "16-1148TPX_Nugget"
#Pnt_16_1149      = $3198D9;  $FF3198D9  "#D99831"  "rgb(217,152, 49)"  "rgba(217,152, 49,255)"  "16-1149TPX_DesertSun"
#Pnt_16_1150      = $3D83D3;  $FF3D83D3  "#D3833D"  "rgb(211,131, 61)"  "rgba(211,131, 61,255)"  "16-1150TPX_Topaz"
#Pnt_16_1164      = $00A6E9;  $FF00A6E9  "#E9A600"  "rgb(233,166,  0)"  "rgba(233,166,  0,255)"  "16-1164TPX_OrangePepper"
#Pnt_16_1210      = $899EAF;  $FF899EAF  "#AF9E89"  "rgb(175,158,137)"  "rgba(175,158,137,255)"  "16-1210TPX_LightTaupe"
#Pnt_16_1212      = $879FB1;  $FF879FB1  "#B19F87"  "rgb(177,159,135)"  "rgba(177,159,135,255)"  "16-1212TPX_Nomad"
#Pnt_16_1219      = $8599C0;  $FF8599C0  "#C09985"  "rgb(192,153,133)"  "rgba(192,153,133,255)"  "16-1219TPX_Tuscany"
#Pnt_16_1220      = $8095C4;  $FF8095C4  "#C49580"  "rgb(196,149,128)"  "rgba(196,149,128,255)"  "16-1220TPX_CaféCrème"
#Pnt_16_1221      = $7F93B3;  $FF7F93B3  "#B3937F"  "rgb(179,147,127)"  "rgba(179,147,127,255)"  "16-1221TPX_Roebuck"
#Pnt_16_1235      = $658ABC;  $FF658ABC  "#BC8A65"  "rgb(188,138,101)"  "rgba(188,138,101,255)"  "16-1235TPX_Sandstorm"
#Pnt_16_1253      = $397ADD;  $FF397ADD  "#DD7A39"  "rgb(221,122, 57)"  "rgba(221,122, 57,255)"  "16-1253TPX_OrangeOchre"
#Pnt_16_1255      = $1F76E5;  $FF1F76E5  "#E5761F"  "rgb(229,118, 31)"  "rgba(229,118, 31,255)"  "16-1255TPX_RussetOrange"
#Pnt_16_1257      = $3582F3;  $FF3582F3  "#F38235"  "rgb(243,130, 53)"  "rgba(243,130, 53,255)"  "16-1257TPX_SunOrange"
#Pnt_16_1260      = $3765D2;  $FF3765D2  "#D26537"  "rgb(210,101, 55)"  "rgba(210,101, 55,255)"  "16-1260TPX_HarvestPumpkin"
#Pnt_16_1305      = $9CA5AD;  $FF9CA5AD  "#ADA59C"  "rgb(173,165,156)"  "rgba(173,165,156,255)"  "16-1305TPX_String"
#Pnt_16_1310      = $7C92AE;  $FF7C92AE  "#AE927C"  "rgb(174,146,124)"  "rgba(174,146,124,255)"  "16-1310TPX_Natural"
#Pnt_16_1315      = $7393A6;  $FF7393A6  "#A69373"  "rgb(166,147,115)"  "rgba(166,147,115,255)"  "16-1315TPX_Cornstalk"
#Pnt_16_1317      = $869BB9;  $FF869BB9  "#B99B86"  "rgb(185,155,134)"  "rgba(185,155,134,255)"  "16-1317TPX_Brush"
#Pnt_16_1318      = $8497B2;  $FF8497B2  "#B29784"  "rgb(178,151,132)"  "rgba(178,151,132,255)"  "16-1318TPX_WarmTaupe"
#Pnt_16_1320      = $869FB8;  $FF869FB8  "#B89F86"  "rgb(184,159,134)"  "rgba(184,159,134,255)"  "16-1320TPX_Nougat"
#Pnt_16_1323      = $6E88B1;  $FF6E88B1  "#B1886E"  "rgb(177,136,110)"  "rgba(177,136,110,255)"  "16-1323TPX_Macaroon"
#Pnt_16_1324      = $6D9AB5;  $FF6D9AB5  "#B59A6D"  "rgb(181,154,109)"  "rgba(181,154,109,255)"  "16-1324TPX_Lark"
#Pnt_16_1325      = $4E6BAD;  $FF4E6BAD  "#AD6B4E"  "rgb(173,107, 78)"  "rgba(173,107, 78,255)"  "16-1325TPX_Copper"
#Pnt_16_1326      = $6499B5;  $FF6499B5  "#B59964"  "rgb(181,153,100)"  "rgba(181,153,100,255)"  "16-1326TPX_PrairieSand"
#Pnt_16_1327      = $6483BB;  $FF6483BB  "#BB8364"  "rgb(187,131,100)"  "rgba(187,131,100,255)"  "16-1327TPX_ToastedNut"
#Pnt_16_1328      = $6B8DC7;  $FF6B8DC7  "#C78D6B"  "rgb(199,141,107)"  "rgba(199,141,107,255)"  "16-1328TPX_Sandstone"
#Pnt_16_1329      = $7F90E1;  $FF7F90E1  "#E1907F"  "rgb(225,144,127)"  "rgba(225,144,127,255)"  "16-1329TPX_CoralHaze"
#Pnt_16_1330      = $8495D1;  $FF8495D1  "#D19584"  "rgb(209,149,132)"  "rgba(209,149,132,255)"  "16-1330TPX_MutedClay"
#Pnt_16_1331      = $7699CC;  $FF7699CC  "#CC9976"  "rgb(204,153,118)"  "rgba(204,153,118,255)"  "16-1331TPX_Toast"
#Pnt_16_1332      = $6283C7;  $FF6283C7  "#C78362"  "rgb(199,131, 98)"  "rgba(199,131, 98,255)"  "16-1332TPX_Pheasant"
#Pnt_16_1333      = $6590BA;  $FF6590BA  "#BA9065"  "rgb(186,144,101)"  "rgba(186,144,101,255)"  "16-1333TPX_Doe"
#Pnt_16_1334      = $7299BA;  $FF7299BA  "#BA9972"  "rgb(186,153,114)"  "rgba(186,153,114,255)"  "16-1334TPX_Tan"
#Pnt_16_1336      = $5A85B6;  $FF5A85B6  "#B6855A"  "rgb(182,133, 90)"  "rgba(182,133, 90,255)"  "16-1336TPX_Biscuit"
#Pnt_16_1337      = $5782D7;  $FF5782D7  "#D78257"  "rgb(215,130, 87)"  "rgba(215,130, 87,255)"  "16-1337TPX_CoralGold"
#Pnt_16_1338      = $618CE2;  $FF618CE2  "#E28C61"  "rgb(226,140, 97)"  "rgba(226,140, 97,255)"  "16-1338TPX_CopperTan"
#Pnt_16_1340      = $5F80D1;  $FF5F80D1  "#D1805F"  "rgb(209,128, 95)"  "rgba(209,128, 95,255)"  "16-1340TPX_BrandiedMelon"
#Pnt_16_1341      = $658FC4;  $FF658FC4  "#C48F65"  "rgb(196,143,101)"  "rgba(196,143,101,255)"  "16-1341TPX_Butterum"
#Pnt_16_1342      = $4F8ED3;  $FF4F8ED3  "#D38E4F"  "rgb(211,142, 79)"  "rgba(211,142, 79,255)"  "16-1342TPX_Buckskin"
#Pnt_16_1343      = $5088F4;  $FF5088F4  "#F48850"  "rgb(244,136, 80)"  "rgba(244,136, 80,255)"  "16-1343TPX_AutumnSunset"
#Pnt_16_1344      = $537DE6;  $FF537DE6  "#E67D53"  "rgb(230,125, 83)"  "rgba(230,125, 83,255)"  "16-1344TPX_DustyOrange"
#Pnt_16_1346      = $427ACA;  $FF427ACA  "#CA7A42"  "rgb(202,122, 66)"  "rgba(202,122, 66,255)"  "16-1346TPX_GoldenOchre"
#Pnt_16_1349      = $4572F2;  $FF4572F2  "#F27245"  "rgb(242,114, 69)"  "rgba(242,114, 69,255)"  "16-1349TPX_CoralRose"
#Pnt_16_1350      = $3D79DC;  $FF3D79DC  "#DC793D"  "rgb(220,121, 61)"  "rgba(220,121, 61,255)"  "16-1350TPX_Amberglow"
#Pnt_16_1356      = $1F74F3;  $FF1F74F3  "#F3741F"  "rgb(243,116, 31)"  "rgba(243,116, 31,255)"  "16-1356TPX_PersimmonOrange"
#Pnt_16_1357      = $4D89FF;  $FF4D89FF  "#FF894D"  "rgb(255,137, 77)"  "rgba(255,137, 77,255)"  "16-1357TPX_BirdOfParadise"
#Pnt_16_1359      = $317DFE;  $FF317DFE  "#FE7D31"  "rgb(254,125, 49)"  "rgba(254,125, 49,255)"  "16-1359TPX_OrangePeel"
#Pnt_16_1360      = $5688FF;  $FF5688FF  "#FF8856"  "rgb(255,136, 86)"  "rgba(255,136, 86,255)"  "16-1360TPX_Nectarine"
#Pnt_16_1361      = $386AF8;  $FF386AF8  "#F86A38"  "rgb(248,106, 56)"  "rgba(248,106, 56,255)"  "16-1361TPX_Carrot"
#Pnt_16_1362      = $3663FC;  $FF3663FC  "#FC6336"  "rgb(252, 99, 54)"  "rgba(252, 99, 54,255)"  "16-1362TPX_VermillionOrange"
#Pnt_16_1363      = $009CFF;  $FF009CFF  "#FF9C00"  "rgb(255,156,  0)"  "rgba(255,156,  0,255)"  "16-1363TPX_Puffin'SBill"
#Pnt_16_1364      = $2D6DFF;  $FF2D6DFF  "#FF6D2D"  "rgb(255,109, 45)"  "rgba(255,109, 45,255)"  "16-1364TPX_VibrantOrange"
#Pnt_16_1406      = $9098A3;  $FF9098A3  "#A39890"  "rgb(163,152,144)"  "rgba(163,152,144,255)"  "16-1406TPX_Atmosphere"
#Pnt_16_1407      = $8A9AA6;  $FF8A9AA6  "#A69A8A"  "rgb(166,154,138)"  "rgba(166,154,138,255)"  "16-1407TPX_Cobblestone"
#Pnt_16_1412      = $7F8DA4;  $FF7F8DA4  "#A48D7F"  "rgb(164,141,127)"  "rgba(164,141,127,255)"  "16-1412TPX_Stucco"
#Pnt_16_1414      = $7489A2;  $FF7489A2  "#A28974"  "rgb(162,137,116)"  "rgba(162,137,116,255)"  "16-1414TPX_Chanterelle"
#Pnt_16_1415      = $7B8DA6;  $FF7B8DA6  "#A68D7B"  "rgb(166,141,123)"  "rgba(166,141,123,255)"  "16-1415TPX_Almondine"
#Pnt_16_1422      = $7187B8;  $FF7187B8  "#B88771"  "rgb(184,135,113)"  "rgba(184,135,113,255)"  "16-1422TPX_Cork"
#Pnt_16_1429      = $526EB1;  $FF526EB1  "#B16E52"  "rgb(177,110, 82)"  "rgba(177,110, 82,255)"  "16-1429TPX_Sunburn"
#Pnt_16_1431      = $7682CE;  $FF7682CE  "#CE8276"  "rgb(206,130,118)"  "rgba(206,130,118,255)"  "16-1431TPX_CanyonClay"
#Pnt_16_1432      = $4E78AB;  $FF4E78AB  "#AB784E"  "rgb(171,120, 78)"  "rgba(171,120, 78,255)"  "16-1432TPX_Almond"
#Pnt_16_1434      = $9298E2;  $FF9298E2  "#E29892"  "rgb(226,152,146)"  "rgba(226,152,146,255)"  "16-1434TPX_CoralAlmond"
#Pnt_16_1435      = $5C77D1;  $FF5C77D1  "#D1775C"  "rgb(209,119, 92)"  "rgba(209,119, 92,255)"  "16-1435TPX_Carnelian"
#Pnt_16_1439      = $5176BF;  $FF5176BF  "#BF7651"  "rgb(191,118, 81)"  "rgba(191,118, 81,255)"  "16-1439TPX_Caramel"
#Pnt_16_1440      = $5367C7;  $FF5367C7  "#C76753"  "rgb(199,103, 83)"  "rgba(199,103, 83,255)"  "16-1440TPX_Langoustino"
#Pnt_16_1441      = $4F6AD1;  $FF4F6AD1  "#D16A4F"  "rgb(209,106, 79)"  "rgba(209,106, 79,255)"  "16-1441TPX_Arabesque"
#Pnt_16_1442      = $6687F7;  $FF6687F7  "#F78766"  "rgb(247,135,102)"  "rgba(247,135,102,255)"  "16-1442TPX_Melon"
#Pnt_16_1443      = $497DCF;  $FF497DCF  "#CF7D49"  "rgb(207,125, 73)"  "rgba(207,125, 73,255)"  "16-1443TPX_ApricotBuff"
#Pnt_16_1448      = $2B62C7;  $FF2B62C7  "#C7622B"  "rgb(199, 98, 43)"  "rgba(199, 98, 43,255)"  "16-1448TPX_BurntOrange"
#Pnt_16_1449      = $0F7EC6;  $FF0F7EC6  "#C67E0F"  "rgb(198,126, 15)"  "rgba(198,126, 15,255)"  "16-1449TPX_GoldFlame"
#Pnt_16_1450      = $516EDF;  $FF516EDF  "#DF6E51"  "rgb(223,110, 81)"  "rgba(223,110, 81,255)"  "16-1450TPX_Flamingo"
#Pnt_16_1451      = $4C62F6;  $FF4C62F6  "#F6624C"  "rgb(246, 98, 76)"  "rgba(246, 98, 76,255)"  "16-1451TPX_Nasturtium"
#Pnt_16_1452      = $466BF1;  $FF466BF1  "#F16B46"  "rgb(241,107, 70)"  "rgba(241,107, 70,255)"  "16-1452TPX_Firecracker"
#Pnt_16_1454      = $396DD9;  $FF396DD9  "#D96D39"  "rgb(217,109, 57)"  "rgba(217,109, 57,255)"  "16-1454TPX_JaffaOrange"
#Pnt_16_1459      = $3D69E9;  $FF3D69E9  "#E9693D"  "rgb(233,105, 61)"  "rgba(233,105, 61,255)"  "16-1459TPX_MandarinOrange"
#Pnt_16_1462      = $2E67F2;  $FF2E67F2  "#F2672E"  "rgb(242,103, 46)"  "rgba(242,103, 46,255)"  "16-1462TPX_GoldenPoppy"
#Pnt_16_1506      = $9295A8;  $FF9295A8  "#A89592"  "rgb(168,149,146)"  "rgba(168,149,146,255)"  "16-1506TPX_Bark"
#Pnt_16_1508      = $969CB9;  $FF969CB9  "#B99C96"  "rgb(185,156,150)"  "rgba(185,156,150,255)"  "16-1508TPX_AdobeRose"
#Pnt_16_1509      = $A0A5BA;  $FFA0A5BA  "#BAA5A0"  "rgb(186,165,160)"  "rgba(186,165,160,255)"  "16-1509TPX_ShadowGray"
#Pnt_16_1510      = $9397B0;  $FF9397B0  "#B09793"  "rgb(176,151,147)"  "rgba(176,151,147,255)"  "16-1510TPX_Fawn"
#Pnt_16_1511      = $9396CF;  $FF9396CF  "#CF9693"  "rgb(207,150,147)"  "rgba(207,150,147,255)"  "16-1511TPX_RoseTan"
#Pnt_16_1516      = $818AC0;  $FF818AC0  "#C08A81"  "rgb(192,138,129)"  "rgba(192,138,129,255)"  "16-1516TPX_CameoBrown"
#Pnt_16_1518      = $8386CB;  $FF8386CB  "#CB8683"  "rgb(203,134,131)"  "rgba(203,134,131,255)"  "16-1518TPX_Rosette"
#Pnt_16_1520      = $8E93DE;  $FF8E93DE  "#DE938E"  "rgb(222,147,142)"  "rgba(222,147,142,255)"  "16-1520TPX_LobsterBisque"
#Pnt_16_1522      = $7C86C4;  $FF7C86C4  "#C4867C"  "rgb(196,134,124)"  "rgba(196,134,124,255)"  "16-1522TPX_RoseDawn"
#Pnt_16_1526      = $757FCE;  $FF757FCE  "#CE7F75"  "rgb(206,127,117)"  "rgba(206,127,117,255)"  "16-1526TPX_TerraCotta"
#Pnt_16_1529      = $818AED;  $FF818AED  "#ED8A81"  "rgb(237,138,129)"  "rgba(237,138,129,255)"  "16-1529TPX_BurntCoral"
#Pnt_16_1532      = $6C77D4;  $FF6C77D4  "#D4776C"  "rgb(212,119,108)"  "rgba(212,119,108,255)"  "16-1532TPX_Crabapple"
#Pnt_16_1539      = $6672EC;  $FF6672EC  "#EC7266"  "rgb(236,114,102)"  "rgba(236,114,102,255)"  "16-1539TPX_Coral"
#Pnt_16_1541      = $6374F7;  $FF6374F7  "#F77463"  "rgb(247,116, 99)"  "rgba(247,116, 99,255)"  "16-1541TPX_Camellia"
#Pnt_16_1542      = $7183FF;  $FF7183FF  "#FF8371"  "rgb(255,131,113)"  "rgba(255,131,113,255)"  "16-1542TPX_FreshSalmon"
#Pnt_16_1543      = $7282FF;  $FF7282FF  "#FF8272"  "rgb(255,130,114)"  "rgba(255,130,114,255)"  "16-1543TPX_FusionCoral"
#Pnt_16_1544      = $6B78F5;  $FF6B78F5  "#F5786B"  "rgb(245,120,107)"  "rgba(245,120,107,255)"  "16-1544TPX_Persimmon"
#Pnt_16_1546      = $6872FA;  $FF6872FA  "#FA7268"  "rgb(250,114,104)"  "rgba(250,114,104,255)"  "16-1546TPX_LivingCoral"
#Pnt_16_1610      = $8F86CB;  $FF8F86CB  "#CB868F"  "rgb(203,134,143)"  "rgba(203,134,143,255)"  "16-1610TPX_BrandiedApricot"
#Pnt_16_1617      = $8E86D0;  $FF8E86D0  "#D0868E"  "rgb(208,134,142)"  "rgba(208,134,142,255)"  "16-1617TPX_Mauveglow"
#Pnt_16_1620      = $7B6DDB;  $FF7B6DDB  "#DB6D7B"  "rgb(219,109,123)"  "rgba(219,109,123,255)"  "16-1620TPX_TeaRose"
#Pnt_16_1624      = $787AD9;  $FF787AD9  "#D97A78"  "rgb(217,122,120)"  "rgba(217,122,120,255)"  "16-1624TPX_Lantana"
#Pnt_16_1626      = $8780E0;  $FF8780E0  "#E08087"  "rgb(224,128,135)"  "rgba(224,128,135,255)"  "16-1626TPX_PeachBlossom"
#Pnt_16_1632      = $8580F2;  $FF8580F2  "#F28085"  "rgb(242,128,133)"  "rgba(242,128,133,255)"  "16-1632TPX_ShellPink"
#Pnt_16_1640      = $7B70EC;  $FF7B70EC  "#EC707B"  "rgb(236,112,123)"  "rgba(236,112,123,255)"  "16-1640TPX_SugarCoral"
#Pnt_16_1641      = $7773F2;  $FF7773F2  "#F27377"  "rgb(242,115,119)"  "rgba(242,115,119,255)"  "16-1641TPX_GeorgiaPeach"
#Pnt_16_1703      = $9598AB;  $FF9598AB  "#AB9895"  "rgb(171,152,149)"  "rgba(171,152,149,255)"  "16-1703TPX_Sphinx"
#Pnt_16_1707      = $9491AD;  $FF9491AD  "#AD9194"  "rgb(173,145,148)"  "rgba(173,145,148,255)"  "16-1707TPX_DeauvilleMauve"
#Pnt_16_1708      = $9E8DBB;  $FF9E8DBB  "#BB8D9E"  "rgb(187,141,158)"  "rgba(187,141,158,255)"  "16-1708TPX_Lilas"
#Pnt_16_1710      = $8793D6;  $FF8793D6  "#D69387"  "rgb(214,147,135)"  "rgba(214,147,135,255)"  "16-1710TPX_Foxglove"
#Pnt_16_1712      = $9D88C0;  $FF9D88C0  "#C0889D"  "rgb(192,136,157)"  "rgba(192,136,157,255)"  "16-1712TPX_Polignac"
#Pnt_16_1715      = $9D84CF;  $FF9D84CF  "#CF849D"  "rgb(207,132,157)"  "rgba(207,132,157,255)"  "16-1715TPX_WildRose"
#Pnt_16_1720      = $8F86E3;  $FF8F86E3  "#E3868F"  "rgb(227,134,143)"  "rgba(227,134,143,255)"  "16-1720TPX_StrawberryIce"
#Pnt_16_1723      = $8F76E8;  $FF8F76E8  "#E8768F"  "rgb(232,118,143)"  "rgba(232,118,143,255)"  "16-1723TPX_Confetti"
#Pnt_16_1731      = $907BF8;  $FF907BF8  "#F87B90"  "rgb(248,123,144)"  "rgba(248,123,144,255)"  "16-1731TPX_StrawberryPink"
#Pnt_16_1735      = $9473F9;  $FF9473F9  "#F97394"  "rgb(249,115,148)"  "rgba(249,115,148,255)"  "16-1735TPX_PinkLemonade"
#Pnt_16_1806      = $928FAE;  $FF928FAE  "#AE8F92"  "rgb(174,143,146)"  "rgba(174,143,146,255)"  "16-1806TPX_Woodrose"
#Pnt_16_2107      = $9F86B1;  $FF9F86B1  "#B1869F"  "rgb(177,134,159)"  "rgba(177,134,159,255)"  "16-2107TPX_OrchidHaze"
#Pnt_16_2111      = $9A7EB3;  $FF9A7EB3  "#B37E9A"  "rgb(179,126,154)"  "rgba(179,126,154,255)"  "16-2111TPX_MauveOrchid"
#Pnt_16_2120      = $A270D7;  $FFA270D7  "#D770A2"  "rgb(215,112,162)"  "rgba(215,112,162,255)"  "16-2120TPX_WildOrchid"
#Pnt_16_2124      = $A579EE;  $FFA579EE  "#EE79A5"  "rgb(238,121,165)"  "rgba(238,121,165,255)"  "16-2124TPX_PinkCarnation"
#Pnt_16_2126      = $9A67E6;  $FF9A67E6  "#E6679A"  "rgb(230,103,154)"  "rgba(230,103,154,255)"  "16-2126TPX_AzaleaPink"
#Pnt_16_2215      = $A386CF;  $FFA386CF  "#CF86A3"  "rgb(207,134,163)"  "rgba(207,134,163,255)"  "16-2215TPX_CashmereRose"
#Pnt_16_2614      = $B590D2;  $FFB590D2  "#D290B5"  "rgb(210,144,181)"  "rgba(210,144,181,255)"  "16-2614TPX_MoonliteMauve"
#Pnt_16_3110      = $B38BB8;  $FFB38BB8  "#B88BB3"  "rgb(184,139,179)"  "rgba(184,139,179,255)"  "16-3110TPX_SmokyGrape"
#Pnt_16_3115      = $B281C5;  $FFB281C5  "#C581B2"  "rgb(197,129,178)"  "rgba(197,129,178,255)"  "16-3115TPX_Crocus"
#Pnt_16_3116      = $B881CD;  $FFB881CD  "#CD81B8"  "rgb(205,129,184)"  "rgba(205,129,184,255)"  "16-3116TPX_OperaMauve"
#Pnt_16_3118      = $C38ADB;  $FFC38ADB  "#DB8AC3"  "rgb(219,138,195)"  "rgba(219,138,195,255)"  "16-3118TPX_Cyclamen"
#Pnt_16_3205      = $A99CB8;  $FFA99CB8  "#B89CA9"  "rgb(184,156,169)"  "rgba(184,156,169,255)"  "16-3205TPX_MauveShadows"
#Pnt_16_3304      = $A193A5;  $FFA193A5  "#A593A1"  "rgb(165,147,161)"  "rgba(165,147,161,255)"  "16-3304TPX_SeaFog"
#Pnt_16_3307      = $AA91B0;  $FFAA91B0  "#B091AA"  "rgb(176,145,170)"  "rgba(176,145,170,255)"  "16-3307TPX_LavenderMist"
#Pnt_16_3310      = $B18FB3;  $FFB18FB3  "#B38FB1"  "rgb(179,143,177)"  "rgba(179,143,177,255)"  "16-3310TPX_LavenderHerb"
#Pnt_16_3320      = $BA81C0;  $FFBA81C0  "#C081BA"  "rgb(192,129,186)"  "rgba(192,129,186,255)"  "16-3320TPX_Violet"
#Pnt_16_3416      = $C793C6;  $FFC793C6  "#C693C7"  "rgb(198,147,199)"  "rgba(198,147,199,255)"  "16-3416TPX_VioletTulle"
#Pnt_16_3520      = $BE84B2;  $FFBE84B2  "#B284BE"  "rgb(178,132,190)"  "rgba(178,132,190,255)"  "16-3520TPX_AfricanViolet"
#Pnt_16_3521      = $C8A0BE;  $FFC8A0BE  "#BEA0C8"  "rgb(190,160,200)"  "rgba(190,160,200,255)"  "16-3521TPX_Lupine"
#Pnt_16_3525      = $B28BAA;  $FFB28BAA  "#AA8BB2"  "rgb(170,139,178)"  "rgba(170,139,178,255)"  "16-3525TPX_RegalOrchid"
#Pnt_16_3617      = $CB97BD;  $FFCB97BD  "#BD97CB"  "rgb(189,151,203)"  "rgba(189,151,203,255)"  "16-3617TPX_SheerLilac"
#Pnt_16_3800      = $8C8EAA;  $FF8C8EAA  "#AA8E8C"  "rgb(170,142,140)"  "rgba(170,142,140,255)"  "16-3800TPX_Satellite"
#Pnt_16_3801      = $9D9EA4;  $FF9D9EA4  "#A49E9D"  "rgb(164,158,157)"  "rgba(164,158,157,255)"  "16-3801TPX_OpalGray"
#Pnt_16_3802      = $9D9EA1;  $FF9D9EA1  "#A19E9D"  "rgb(161,158,157)"  "rgba(161,158,157,255)"  "16-3802TPX_Ash"
#Pnt_16_3803      = $A7A1A7;  $FFA7A1A7  "#A7A1A7"  "rgb(167,161,167)"  "rgba(167,161,167,255)"  "16-3803TPX_GullGray"
#Pnt_16_3810      = $B69BA2;  $FFB69BA2  "#A29BB6"  "rgb(162,155,182)"  "rgba(162,155,182,255)"  "16-3810TPX_Wisteria"
#Pnt_16_3812      = $B39399;  $FFB39399  "#9993B3"  "rgb(153,147,179)"  "rgba(153,147,179,255)"  "16-3812TPX_HeirloomLilac"
#Pnt_16_3815      = $C093A8;  $FFC093A8  "#A893C0"  "rgb(168,147,192)"  "rgba(168,147,192,255)"  "16-3815TPX_Viola"
#Pnt_16_3817      = $988BB8;  $FF988BB8  "#B88B98"  "rgb(184,139,152)"  "rgba(184,139,152,255)"  "16-3817TPX_Rhapsody"
#Pnt_16_3823      = $C8909B;  $FFC8909B  "#9B90C8"  "rgb(155,144,200)"  "rgba(155,144,200,255)"  "16-3823TPX_VioletTulip"
#Pnt_16_3850      = $A49DB4;  $FFA49DB4  "#B49DA4"  "rgb(180,157,164)"  "rgba(180,157,164,255)"  "16-3850TPX_SilverSconce"
#Pnt_16_3907      = $AB9E9E;  $FFAB9E9E  "#9E9EAB"  "rgb(158,158,171)"  "rgba(158,158,171,255)"  "16-3907TPX_DappleGray"
#Pnt_16_3911      = $AE9A9F;  $FFAE9A9F  "#9F9AAE"  "rgb(159,154,174)"  "rgba(159,154,174,255)"  "16-3911TPX_LavenderAura"
#Pnt_16_3915      = $9895A9;  $FF9895A9  "#A99598"  "rgb(169,149,152)"  "rgba(169,149,152,255)"  "16-3915TPX_Alloy"
#Pnt_16_3916      = $9C90A7;  $FF9C90A7  "#A7909C"  "rgb(167,144,156)"  "rgba(167,144,156,255)"  "16-3916TPX_Sleet"
#Pnt_16_3919      = $B89B8F;  $FFB89B8F  "#8F9BB8"  "rgb(143,155,184)"  "rgba(143,155,184,255)"  "16-3919TPX_Eventide"
#Pnt_16_3920      = $C49C8A;  $FFC49C8A  "#8A9CC4"  "rgb(138,156,196)"  "rgba(138,156,196,255)"  "16-3920TPX_LavenderLustre"
#Pnt_16_3921      = $B89CA9;  $FFB89CA9  "#A99CB8"  "rgb(169,156,184)"  "rgba(169,156,184,255)"  "16-3921TPX_BlueHeron"
#Pnt_16_3922      = $BDA2AE;  $FFBDA2AE  "#AEA2BD"  "rgb(174,162,189)"  "rgba(174,162,189,255)"  "16-3922TPX_BrunneraBlue"
#Pnt_16_3925      = $CF998F;  $FFCF998F  "#8F99CF"  "rgb(143,153,207)"  "rgba(143,153,207,255)"  "16-3925TPX_EasterEgg"
#Pnt_16_3929      = $CE9782;  $FFCE9782  "#8297CE"  "rgb(130,151,206)"  "rgba(130,151,206,255)"  "16-3929TPX_Grapemist"
#Pnt_16_3930      = $C29A94;  $FFC29A94  "#949AC2"  "rgb(148,154,194)"  "rgba(148,154,194,255)"  "16-3930TPX_ThistleDown"
#Pnt_16_3931      = $C79D9B;  $FFC79D9B  "#9B9DC7"  "rgb(155,157,199)"  "rgba(155,157,199,255)"  "16-3931TPX_SweetLavender"
#Pnt_16_4010      = $AF9B87;  $FFAF9B87  "#879BAF"  "rgb(135,155,175)"  "rgba(135,155,175,255)"  "16-4010TPX_DustyBlue"
#Pnt_16_4013      = $AD9B86;  $FFAD9B86  "#869BAD"  "rgb(134,155,173)"  "rgba(134,155,173,255)"  "16-4013TPX_AshleyBlue"
#Pnt_16_4019      = $BD9A81;  $FFBD9A81  "#819ABD"  "rgb(129,154,189)"  "rgba(129,154,189,255)"  "16-4019TPX_ForeverBlue"
#Pnt_16_4020      = $CD9A75;  $FFCD9A75  "#759ACD"  "rgb(117,154,205)"  "rgba(117,154,205,255)"  "16-4020TPX_DellaRobbiaBlue"
#Pnt_16_4021      = $B58F70;  $FFB58F70  "#708FB5"  "rgb(112,143,181)"  "rgba(112,143,181,255)"  "16-4021TPX_Allure"
#Pnt_16_4030      = $BB8F9D;  $FFBB8F9D  "#9D8FBB"  "rgb(157,143,187)"  "rgba(157,143,187,255)"  "16-4030TPX_Hydrangea"
#Pnt_16_4031      = $CF9273;  $FFCF9273  "#7392CF"  "rgb(115,146,207)"  "rgba(115,146,207,255)"  "16-4031TPX_CornflowerBlue"
#Pnt_16_4032      = $C78C63;  $FFC78C63  "#638CC7"  "rgb( 99,140,199)"  "rgba( 99,140,199,255)"  "16-4032TPX_Provence"
#Pnt_16_4109      = $A69B84;  $FFA69B84  "#849BA6"  "rgb(132,155,166)"  "rgba(132,155,166,255)"  "16-4109TPX_Arona"
#Pnt_16_4114      = $A89E81;  $FFA89E81  "#819EA8"  "rgb(129,158,168)"  "rgba(129,158,168,255)"  "16-4114TPX_StoneBlue"
#Pnt_16_4120      = $BFA17D;  $FFBFA17D  "#7DA1BF"  "rgb(125,161,191)"  "rgba(125,161,191,255)"  "16-4120TPX_DuskBlue"
#Pnt_16_4127      = $C29E66;  $FFC29E66  "#669EC2"  "rgb(102,158,194)"  "rgba(102,158,194,255)"  "16-4127TPX_HeritageBlue"
#Pnt_16_4132      = $DCA06C;  $FFDCA06C  "#6CA0DC"  "rgb(108,160,220)"  "rgba(108,160,220,255)"  "16-4132TPX_LittleBoyBlue"
#Pnt_16_4134      = $D6A352;  $FFD6A352  "#52A3D6"  "rgb( 82,163,214)"  "rgba( 82,163,214,255)"  "16-4134TPX_BonnieBlue"
#Pnt_16_4400      = $8F8FA7;  $FF8F8FA7  "#A78F8F"  "rgb(167,143,143)"  "rgba(167,143,143,255)"  "16-4400TPX_MourningDove"
#Pnt_16_4402      = $989B9A;  $FF989B9A  "#9A9B98"  "rgb(154,155,152)"  "rgba(154,155,152,255)"  "16-4402TPX_Drizzle"
#Pnt_16_4404      = $9C9C8A;  $FF9C9C8A  "#8A9C9C"  "rgb(138,156,156)"  "rgba(138,156,156,255)"  "16-4404TPX_Abyss"
#Pnt_16_4408      = $A19E8A;  $FFA19E8A  "#8A9EA1"  "rgb(138,158,161)"  "rgba(138,158,161,255)"  "16-4408TPX_Slate"
#Pnt_16_4411      = $AFA588;  $FFAFA588  "#88A5AF"  "rgb(136,165,175)"  "rgba(136,165,175,255)"  "16-4411TPX_Tourmaline"
#Pnt_16_4414      = $ACA278;  $FFACA278  "#78A2AC"  "rgb(120,162,172)"  "rgba(120,162,172,255)"  "16-4414TPX_CameoBlue"
#Pnt_16_4421      = $C9AF58;  $FFC9AF58  "#58AFC9"  "rgb( 88,175,201)"  "rgba( 88,175,201,255)"  "16-4421TPX_BlueMist"
#Pnt_16_4427      = $C4A328;  $FFC4A328  "#28A3C4"  "rgb( 40,163,196)"  "rgba( 40,163,196,255)"  "16-4427TPX_HorizonBlue"
#Pnt_16_4519      = $B39D60;  $FFB39D60  "#609DB3"  "rgb( 96,157,179)"  "rgba( 96,157,179,255)"  "16-4519TPX_DelphiniumBlue"
#Pnt_16_4525      = $BAA44E;  $FFBAA44E  "#4EA4BA"  "rgb( 78,164,186)"  "rgba( 78,164,186,255)"  "16-4525TPX_MauiBlue"
#Pnt_16_4529      = $CBA600;  $FFCBA600  "#00A6CB"  "rgb(  0,166,203)"  "rgba(  0,166,203,255)"  "16-4529TPX_CyanBlue"
#Pnt_16_4530      = $D8B036;  $FFD8B036  "#36B0D8"  "rgb( 54,176,216)"  "rgba( 54,176,216,255)"  "16-4530TPX_Aquarius"
#Pnt_16_4535      = $D9B600;  $FFD9B600  "#00B6D9"  "rgb(  0,182,217)"  "rgba(  0,182,217,255)"  "16-4535TPX_BlueAtoll"
#Pnt_16_4610      = $AFA26A;  $FFAFA26A  "#6AA2AF"  "rgb(106,162,175)"  "rgba(106,162,175,255)"  "16-4610TPX_Stillwater"
#Pnt_16_4612      = $AA9F68;  $FFAA9F68  "#689FAA"  "rgb(104,159,170)"  "rgba(104,159,170,255)"  "16-4612TPX_ReefWaters"
#Pnt_16_4702      = $999C95;  $FF999C95  "#959C99"  "rgb(149,156,153)"  "rgba(149,156,153,255)"  "16-4702TPX_Limestone"
#Pnt_16_4703      = $9B99AE;  $FF9B99AE  "#AE999B"  "rgb(174,153,155)"  "rgba(174,153,155,255)"  "16-4703TPX_GhostGray"
#Pnt_16_4706      = $999887;  $FF999887  "#879899"  "rgb(135,152,153)"  "rgba(135,152,153,255)"  "16-4706TPX_SilverBlue"
#Pnt_16_4712      = $91916B;  $FF91916B  "#6B9191"  "rgb(107,145,145)"  "rgba(107,145,145,255)"  "16-4712TPX_MineralBlue"
#Pnt_16_4719      = $A29B54;  $FFA29B54  "#549BA2"  "rgb( 84,155,162)"  "rgba( 84,155,162,255)"  "16-4719TPX_Porcelain"
#Pnt_16_4725      = $CAB200;  $FFCAB200  "#00B2CA"  "rgb(  0,178,202)"  "rgba(  0,178,202,255)"  "16-4725TPX_ScubaBlue"
#Pnt_16_4728      = $B4A400;  $FFB4A400  "#00A4B4"  "rgb(  0,164,180)"  "rgba(  0,164,180,255)"  "16-4728TPX_PeacockBlue"
#Pnt_16_4834      = $B5A400;  $FFB5A400  "#00A4B5"  "rgb(  0,164,181)"  "rgba(  0,164,181,255)"  "16-4834TPX_Bluebird"
#Pnt_16_5101      = $958DA7;  $FF958DA7  "#A78D95"  "rgb(167,141,149)"  "rgba(167,141,149,255)"  "16-5101TPX_WetWeather"
#Pnt_16_5106      = $A5AA8F;  $FFA5AA8F  "#8FAAA5"  "rgb(143,170,165)"  "rgba(143,170,165,255)"  "16-5106TPX_BlueSurf"
#Pnt_16_5109      = $9CA571;  $FF9CA571  "#71A59C"  "rgb(113,165,156)"  "rgba(113,165,156,255)"  "16-5109TPX_Wasabi"
#Pnt_16_5112      = $A1A26D;  $FFA1A26D  "#6DA2A1"  "rgb(109,162,161)"  "rgba(109,162,161,255)"  "16-5112TPX_Canton"
#Pnt_16_5114      = $A1A164;  $FFA1A164  "#64A1A1"  "rgb(100,161,161)"  "rgba(100,161,161,255)"  "16-5114TPX_DustyTurquoise"
#Pnt_16_5119      = $959C4C;  $FF959C4C  "#4C9C95"  "rgb( 76,156,149)"  "rgba( 76,156,149,255)"  "16-5119TPX_SeaBlue"
#Pnt_16_5121      = $A09B54;  $FFA09B54  "#549BA0"  "rgb( 84,155,160)"  "rgba( 84,155,160,255)"  "16-5121TPX_Meadowbrook"
#Pnt_16_5123      = $9D9A1A;  $FF9D9A1A  "#1A9A9D"  "rgb( 26,154,157)"  "rgba( 26,154,157,255)"  "16-5123TPX_Baltic"
#Pnt_16_5127      = $ACAF00;  $FFACAF00  "#00AFAC"  "rgb(  0,175,172)"  "rgba(  0,175,172,255)"  "16-5127TPX_Ceramic"
#Pnt_16_5304      = $99A08D;  $FF99A08D  "#8DA099"  "rgb(141,160,153)"  "rgba(141,160,153,255)"  "16-5304TPX_Jadeite"
#Pnt_16_5412      = $9AA15D;  $FF9AA15D  "#5DA19A"  "rgb( 93,161,154)"  "rgba( 93,161,154,255)"  "16-5412TPX_AgateGreen"
#Pnt_16_5418      = $9BA04B;  $FF9BA04B  "#4BA09B"  "rgb( 75,160,155)"  "rgba( 75,160,155,255)"  "16-5418TPX_Lagoon"
#Pnt_16_5421      = $86A000;  $FF86A000  "#00A086"  "rgb(  0,160,134)"  "rgba(  0,160,134,255)"  "16-5421TPX_SeaGreen"
#Pnt_16_5422      = $9EA72A;  $FF9EA72A  "#2AA79E"  "rgb( 42,167,158)"  "rgba( 42,167,158,255)"  "16-5422TPX_BrightAqua"
#Pnt_16_5425      = $9BB200;  $FF9BB200  "#00B29B"  "rgb(  0,178,155)"  "rgba(  0,178,155,255)"  "16-5425TPX_PoolGreen"
#Pnt_16_5427      = $95AF00;  $FF95AF00  "#00AF95"  "rgb(  0,175,149)"  "rgba(  0,175,149,255)"  "16-5427TPX_Billiard"
#Pnt_16_5431      = $89A900;  $FF89A900  "#00A989"  "rgb(  0,169,137)"  "rgba(  0,169,137,255)"  "16-5431TPX_PeacockGreen"
#Pnt_16_5515      = $889364;  $FF889364  "#649388"  "rgb(100,147,136)"  "rgba(100,147,136,255)"  "16-5515TPX_BerylGreen"
#Pnt_16_5533      = $8CA600;  $FF8CA600  "#00A68C"  "rgb(  0,166,140)"  "rgba(  0,166,140,255)"  "16-5533TPX_Arcadia"
#Pnt_16_5721      = $889F3D;  $FF889F3D  "#3D9F88"  "rgb( 61,159,136)"  "rgba( 61,159,136,255)"  "16-5721TPX_MarineGreen"
#Pnt_16_5803      = $989D9E;  $FF989D9E  "#9E9D98"  "rgb(158,157,152)"  "rgba(158,157,152,255)"  "16-5803TPX_FlintGray"
#Pnt_16_5804      = $92988A;  $FF92988A  "#8A9892"  "rgb(138,152,146)"  "rgba(138,152,146,255)"  "16-5804TPX_SlateGray"
#Pnt_16_5806      = $8D9584;  $FF8D9584  "#84958D"  "rgb(132,149,141)"  "rgba(132,149,141,255)"  "16-5806TPX_GreenMilieu"
#Pnt_16_5807      = $828F7E;  $FF828F7E  "#7E8F82"  "rgb(126,143,130)"  "rgba(126,143,130,255)"  "16-5807TPX_LilyPad"
#Pnt_16_5808      = $8F9C88;  $FF8F9C88  "#889C8F"  "rgb(136,156,143)"  "rgba(136,156,143,255)"  "16-5808TPX_IcebergGreen"
#Pnt_16_5810      = $7E8F7B;  $FF7E8F7B  "#7B8F7E"  "rgb(123,143,126)"  "rgba(123,143,126,255)"  "16-5810TPX_GreenBay"
#Pnt_16_5815      = $8A9D71;  $FF8A9D71  "#719D8A"  "rgb(113,157,138)"  "rgba(113,157,138,255)"  "16-5815TPX_Feldspar"
#Pnt_16_5820      = $81A056;  $FF81A056  "#56A081"  "rgb( 86,160,129)"  "rgba( 86,160,129,255)"  "16-5820TPX_GreenSpruce"
#Pnt_16_5825      = $8AAD33;  $FF8AAD33  "#33AD8A"  "rgb( 51,173,138)"  "rgba( 51,173,138,255)"  "16-5825TPX_GumdropGreen"
#Pnt_16_5904      = $9AA095;  $FF9AA095  "#95A09A"  "rgb(149,160,154)"  "rgba(149,160,154,255)"  "16-5904TPX_WroughtIron"
#Pnt_16_5907      = $93A383;  $FF93A383  "#83A393"  "rgb(131,163,147)"  "rgba(131,163,147,255)"  "16-5907TPX_GraniteGreen"
#Pnt_16_5917      = $849867;  $FF849867  "#679884"  "rgb(103,152,132)"  "rgba(103,152,132,255)"  "16-5917TPX_MalachiteGreen"
#Pnt_16_5919      = $8BA272;  $FF8BA272  "#72A28B"  "rgb(114,162,139)"  "rgba(114,162,139,255)"  "16-5919TPX_CrèmeDeMenthe"
#Pnt_16_5924      = $82A152;  $FF82A152  "#52A182"  "rgb( 82,161,130)"  "rgba( 82,161,130,255)"  "16-5924TPX_WinterGreen"
#Pnt_16_5930      = $75A531;  $FF75A531  "#31A575"  "rgb( 49,165,117)"  "rgba( 49,165,117,255)"  "16-5930TPX_MingGreen"
#Pnt_16_5932      = $76A100;  $FF76A100  "#00A176"  "rgb(  0,161,118)"  "rgba(  0,161,118,255)"  "16-5932TPX_HollyGreen"
#Pnt_16_5938      = $78AB00;  $FF78AB00  "#00AB78"  "rgb(  0,171,120)"  "rgba(  0,171,120,255)"  "16-5938TPX_Mint"
#Pnt_16_5942      = $78AC00;  $FF78AC00  "#00AC78"  "rgb(  0,172,120)"  "rgba(  0,172,120,255)"  "16-5942TPX_Blarney"
#Pnt_16_6008      = $879790;  $FF879790  "#909787"  "rgb(144,151,135)"  "rgba(144,151,135,255)"  "16-6008TPX_Seagrass"
#Pnt_16_6030      = $92BA64;  $FF92BA64  "#64BA92"  "rgb(100,186,146)"  "rgba(100,186,146,255)"  "16-6030TPX_Katydid"
#Pnt_16_6116      = $739271;  $FF739271  "#719273"  "rgb(113,146,115)"  "rgba(113,146,115,255)"  "16-6116TPX_ShaleGreen"
#Pnt_16_6127      = $6A9C40;  $FF6A9C40  "#409C6A"  "rgb( 64,156,106)"  "rgba( 64,156,106,255)"  "16-6127TPX_Greenbriar"
#Pnt_16_6138      = $5C9D19;  $FF5C9D19  "#199D5C"  "rgb( 25,157, 92)"  "rgba( 25,157, 92,255)"  "16-6138TPX_KellyGreen"
#Pnt_16_6216      = $829F82;  $FF829F82  "#829F82"  "rgb(130,159,130)"  "rgba(130,159,130,255)"  "16-6216TPX_Basil"
#Pnt_16_6240      = $66B51F;  $FF66B51F  "#1FB566"  "rgb( 31,181,102)"  "rgba( 31,181,102,255)"  "16-6240TPX_IslandGreen"
#Pnt_16_6318      = $79A07A;  $FF79A07A  "#7AA079"  "rgb(122,160,121)"  "rgba(122,160,121,255)"  "16-6318TPX_MineralGreen"
#Pnt_16_6324      = $72A070;  $FF72A070  "#70A072"  "rgb(112,160,114)"  "rgba(112,160,114,255)"  "16-6324TPX_Jadesheen"
#Pnt_16_6329      = $6B9E6D;  $FF6B9E6D  "#6D9E6B"  "rgb(109,158,107)"  "rgba(109,158,107,255)"  "16-6329TPX_Peppermint"
#Pnt_16_6339      = $59AA55;  $FF59AA55  "#55AA59"  "rgb( 85,170, 89)"  "rgba( 85,170, 89,255)"  "16-6339TPX_VibrantGreen"
#Pnt_16_6340      = $41B132;  $FF41B132  "#32B141"  "rgb( 50,177, 65)"  "rgba( 50,177, 65,255)"  "16-6340TPX_ClassicGreen"
#Pnt_16_6444      = $60B949;  $FF60B949  "#49B960"  "rgb( 73,185, 96)"  "rgba( 73,185, 96,255)"  "16-6444TPX_PoisonGreen"
#Pnt_17_0000      = $878484;  $FF878484  "#848487"  "rgb(132,132,135)"  "rgba(132,132,135,255)"  "17-0000TPX_FrostGray"
#Pnt_17_0115      = $6E877D;  $FF6E877D  "#7D876E"  "rgb(125,135,110)"  "rgba(125,135,110,255)"  "17-0115TPX_OilGreen"
#Pnt_17_0119      = $688E6C;  $FF688E6C  "#6C8E68"  "rgb(108,142,104)"  "rgba(108,142,104,255)"  "17-0119TPX_TurfGreen"
#Pnt_17_0123      = $669264;  $FF669264  "#649266"  "rgb(100,146,102)"  "rgba(100,146,102,255)"  "17-0123TPX_StoneGreen"
#Pnt_17_0133      = $4E8E63;  $FF4E8E63  "#638E4E"  "rgb( 99,142, 78)"  "rgba( 99,142, 78,255)"  "17-0133TPX_FluoriteGreen"
#Pnt_17_0145      = $40874B;  $FF40874B  "#4B8740"  "rgb( 75,135, 64)"  "rgba( 75,135, 64,255)"  "17-0145TPX_OnlineLime"
#Pnt_17_0205      = $878D90;  $FF878D90  "#908D87"  "rgb(144,141,135)"  "rgba(144,141,135,255)"  "17-0205TPX_ElephantSkin"
#Pnt_17_0207      = $808B8B;  $FF808B8B  "#8B8B80"  "rgb(139,139,128)"  "rgba(139,139,128,255)"  "17-0207TPX_RockRidge"
#Pnt_17_0210      = $728C73;  $FF728C73  "#738C72"  "rgb(115,140,114)"  "rgba(115,140,114,255)"  "17-0210TPX_LodenFrost"
#Pnt_17_0215      = $749A7D;  $FF749A7D  "#7D9A74"  "rgb(125,154,116)"  "rgba(125,154,116,255)"  "17-0215TPX_AspenGreen"
#Pnt_17_0220      = $668C70;  $FF668C70  "#708C66"  "rgb(112,140,102)"  "rgba(112,140,102,255)"  "17-0220TPX_Watercress"
#Pnt_17_0230      = $4E8D66;  $FF4E8D66  "#668D4E"  "rgb(102,141, 78)"  "rgba(102,141, 78,255)"  "17-0230TPX_ForestGreen"
#Pnt_17_0235      = $509370;  $FF509370  "#709350"  "rgb(112,147, 80)"  "rgba(112,147, 80,255)"  "17-0235TPX_PiquantGreen"
#Pnt_17_0324      = $619281;  $FF619281  "#819261"  "rgb(129,146, 97)"  "rgba(129,146, 97,255)"  "17-0324TPX_Epsom"
#Pnt_17_0330      = $4B877E;  $FF4B877E  "#7E874B"  "rgb(126,135, 75)"  "rgba(126,135, 75,255)"  "17-0330TPX_TurtleGreen"
#Pnt_17_0336      = $44937B;  $FF44937B  "#7B9344"  "rgb(123,147, 68)"  "rgba(123,147, 68,255)"  "17-0336TPX_Peridot"
#Pnt_17_0510      = $7D9197;  $FF7D9197  "#97917D"  "rgb(151,145,125)"  "rgba(151,145,125,255)"  "17-0510TPX_SilverSage"
#Pnt_17_0517      = $5E7078;  $FF5E7078  "#78705E"  "rgb(120,112, 94)"  "rgba(120,112, 94,255)"  "17-0517TPX_DuskyGreen"
#Pnt_17_0525      = $628A85;  $FF628A85  "#858A62"  "rgb(133,138, 98)"  "rgba(133,138, 98,255)"  "17-0525TPX_Mosstone"
#Pnt_17_0535      = $53888A;  $FF53888A  "#8A8853"  "rgb(138,136, 83)"  "rgba(138,136, 83,255)"  "17-0535TPX_GreenOlive"
#Pnt_17_0610      = $798A8B;  $FF798A8B  "#8B8A79"  "rgb(139,138,121)"  "rgba(139,138,121,255)"  "17-0610TPX_LaurelOak"
#Pnt_17_0613      = $6D7D7D;  $FF6D7D7D  "#7D7D6D"  "rgb(125,125,109)"  "rgba(125,125,109,255)"  "17-0613TPX_Vetiver"
#Pnt_17_0618      = $647A7F;  $FF647A7F  "#7F7A64"  "rgb(127,122,100)"  "rgba(127,122,100,255)"  "17-0618TPX_Mermaid"
#Pnt_17_0620      = $5D777F;  $FF5D777F  "#7F775D"  "rgb(127,119, 93)"  "rgba(127,119, 93,255)"  "17-0620TPX_Aloe"
#Pnt_17_0625      = $658890;  $FF658890  "#908865"  "rgb(144,136,101)"  "rgba(144,136,101,255)"  "17-0625TPX_Boa"
#Pnt_17_0627      = $5D7F84;  $FF5D7F84  "#847F5D"  "rgb(132,127, 93)"  "rgba(132,127, 93,255)"  "17-0627TPX_DriedHerb"
#Pnt_17_0636      = $4A7C86;  $FF4A7C86  "#867C4A"  "rgb(134,124, 74)"  "rgba(134,124, 74,255)"  "17-0636TPX_GreenMoss"
#Pnt_17_0808      = $6A7888;  $FF6A7888  "#88786A"  "rgb(136,120,106)"  "rgba(136,120,106,255)"  "17-0808TPX_TaupeGray"
#Pnt_17_0836      = $427D91;  $FF427D91  "#917D42"  "rgb(145,125, 66)"  "rgba(145,125, 66,255)"  "17-0836TPX_EcruOlive"
#Pnt_17_0839      = $1F8DAF;  $FF1F8DAF  "#AF8D1F"  "rgb(175,141, 31)"  "rgba(175,141, 31,255)"  "17-0839TPX_GoldenPalm"
#Pnt_17_0840      = $3F879F;  $FF3F879F  "#9F873F"  "rgb(159,135, 63)"  "rgba(159,135, 63,255)"  "17-0840TPX_AmberGreen"
#Pnt_17_0843      = $417F9F;  $FF417F9F  "#9F7F41"  "rgb(159,127, 65)"  "rgba(159,127, 65,255)"  "17-0843TPX_BronzeMist"
#Pnt_17_0909      = $637280;  $FF637280  "#807263"  "rgb(128,114, 99)"  "rgba(128,114, 99,255)"  "17-0909TPX_Fossil"
#Pnt_17_0929      = $54839A;  $FF54839A  "#9A8354"  "rgb(154,131, 84)"  "rgba(154,131, 84,255)"  "17-0929TPX_FennelSeed"
#Pnt_17_0935      = $3D6D84;  $FF3D6D84  "#846D3D"  "rgb(132,109, 61)"  "rgba(132,109, 61,255)"  "17-0935TPX_DullGold"
#Pnt_17_0942      = $447496;  $FF447496  "#967444"  "rgb(150,116, 68)"  "rgba(150,116, 68,255)"  "17-0942TPX_MedalBronze"
#Pnt_17_1009      = $778B96;  $FF778B96  "#968B77"  "rgb(150,139,119)"  "rgba(150,139,119,255)"  "17-1009TPX_Dune"
#Pnt_17_1019      = $5F7D89;  $FF5F7D89  "#897D5F"  "rgb(137,125, 95)"  "rgba(137,125, 95,255)"  "17-1019TPX_Elmwood"
#Pnt_17_1022      = $688A9A;  $FF688A9A  "#9A8A68"  "rgb(154,138,104)"  "rgba(154,138,104,255)"  "17-1022TPX_Kelp"
#Pnt_17_1028      = $577E93;  $FF577E93  "#937E57"  "rgb(147,126, 87)"  "rgba(147,126, 87,255)"  "17-1028TPX_AntiqueBronze"
#Pnt_17_1036      = $417192;  $FF417192  "#927141"  "rgb(146,113, 65)"  "rgba(146,113, 65,255)"  "17-1036TPX_Bistre"
#Pnt_17_1038      = $6B85A4;  $FF6B85A4  "#A4856B"  "rgb(164,133,107)"  "rgba(164,133,107,255)"  "17-1038TPX_Tiger'SEye"
#Pnt_17_1040      = $458BBF;  $FF458BBF  "#BF8B45"  "rgb(191,139, 69)"  "rgba(191,139, 69,255)"  "17-1040TPX_SpruceYellow"
#Pnt_17_1044      = $4B6E96;  $FF4B6E96  "#966E4B"  "rgb(150,110, 75)"  "rgba(150,110, 75,255)"  "17-1044TPX_Chipmunk"
#Pnt_17_1045      = $5786AE;  $FF5786AE  "#AE8657"  "rgb(174,134, 87)"  "rgba(174,134, 87,255)"  "17-1045TPX_AppleCinnamon"
#Pnt_17_1046      = $2E75C1;  $FF2E75C1  "#C1752E"  "rgb(193,117, 46)"  "rgba(193,117, 46,255)"  "17-1046TPX_GoldenOak"
#Pnt_17_1047      = $4D8EB8;  $FF4D8EB8  "#B88E4D"  "rgb(184,142, 77)"  "rgba(184,142, 77,255)"  "17-1047TPX_HoneyMustard"
#Pnt_17_1048      = $277BBD;  $FF277BBD  "#BD7B27"  "rgb(189,123, 39)"  "rgba(189,123, 39,255)"  "17-1048TPX_IncaGold"
#Pnt_17_1107      = $798D95;  $FF798D95  "#958D79"  "rgb(149,141,121)"  "rgba(149,141,121,255)"  "17-1107TPX_SenecaRock"
#Pnt_17_1109      = $78909B;  $FF78909B  "#9B9078"  "rgb(155,144,120)"  "rgba(155,144,120,255)"  "17-1109TPX_Chinchilla"
#Pnt_17_1113      = $6A828E;  $FF6A828E  "#8E826A"  "rgb(142,130,106)"  "rgba(142,130,106,255)"  "17-1113TPX_Coriander"
#Pnt_17_1118      = $5A7484;  $FF5A7484  "#84745A"  "rgb(132,116, 90)"  "rgba(132,116, 90,255)"  "17-1118TPX_LeadGray"
#Pnt_17_1125      = $4B799A;  $FF4B799A  "#9A794B"  "rgb(154,121, 75)"  "rgba(154,121, 75,255)"  "17-1125TPX_Dijon"
#Pnt_17_1128      = $40729A;  $FF40729A  "#9A7240"  "rgb(154,114, 64)"  "rgba(154,114, 64,255)"  "17-1128TPX_BoneBrown"
#Pnt_17_1129      = $3D7EA7;  $FF3D7EA7  "#A77E3D"  "rgb(167,126, 61)"  "rgba(167,126, 61,255)"  "17-1129TPX_WoodThrush"
#Pnt_17_1134      = $4D749F;  $FF4D749F  "#9F744D"  "rgb(159,116, 77)"  "rgba(159,116, 77,255)"  "17-1134TPX_BrownSugar"
#Pnt_17_1137      = $4772A6;  $FF4772A6  "#A67247"  "rgb(166,114, 71)"  "rgba(166,114, 71,255)"  "17-1137TPX_Cashew"
#Pnt_17_1140      = $058ED0;  $FF058ED0  "#D08E05"  "rgb(208,142,  5)"  "rgba(208,142,  5,255)"  "17-1140TPX_Marmalade"
#Pnt_17_1143      = $4E73AE;  $FF4E73AE  "#AE734E"  "rgb(174,115, 78)"  "rgba(174,115, 78,255)"  "17-1143TPX_Hazel"
#Pnt_17_1147      = $4C67A6;  $FF4C67A6  "#A6674C"  "rgb(166,103, 76)"  "rgba(166,103, 76,255)"  "17-1147TPX_AmberBrown"
#Pnt_17_1210      = $848D95;  $FF848D95  "#958D84"  "rgb(149,141,132)"  "rgba(149,141,132,255)"  "17-1210TPX_MoonRock"
#Pnt_17_1212      = $76808C;  $FF76808C  "#8C8076"  "rgb(140,128,118)"  "rgba(140,128,118,255)"  "17-1212TPX_Fungi"
#Pnt_17_1223      = $7189AA;  $FF7189AA  "#AA8971"  "rgb(170,137,113)"  "rgba(170,137,113,255)"  "17-1223TPX_Praline"
#Pnt_17_1224      = $6681AD;  $FF6681AD  "#AD8166"  "rgb(173,129,102)"  "rgba(173,129,102,255)"  "17-1224TPX_Camel"
#Pnt_17_1225      = $6D87B0;  $FF6D87B0  "#B0876D"  "rgb(176,135,109)"  "rgba(176,135,109,255)"  "17-1225TPX_TawnyBirch"
#Pnt_17_1226      = $6A83A9;  $FF6A83A9  "#A9836A"  "rgb(169,131,106)"  "rgba(169,131,106,255)"  "17-1226TPX_TawnyBrown"
#Pnt_17_1227      = $6A80A9;  $FF6A80A9  "#A9806A"  "rgb(169,128,106)"  "rgba(169,128,106,255)"  "17-1227TPX_CaféAuLait"
#Pnt_17_1230      = $6277A3;  $FF6277A3  "#A37762"  "rgb(163,119, 98)"  "rgba(163,119, 98,255)"  "17-1230TPX_MochaMousse"
#Pnt_17_1310      = $6B7D8A;  $FF6B7D8A  "#8A7D6B"  "rgb(138,125,107)"  "rgba(138,125,107,255)"  "17-1310TPX_TimberWolf"
#Pnt_17_1311      = $7881A1;  $FF7881A1  "#A18178"  "rgb(161,129,120)"  "rgba(161,129,120,255)"  "17-1311TPX_DesertTaupe"
#Pnt_17_1312      = $768A99;  $FF768A99  "#998A76"  "rgb(153,138,118)"  "rgba(153,138,118,255)"  "17-1312TPX_SilverMink"
#Pnt_17_1316      = $6D81A7;  $FF6D81A7  "#A7816D"  "rgb(167,129,109)"  "rgba(167,129,109,255)"  "17-1316TPX_Portabella"
#Pnt_17_1319      = $6C839B;  $FF6C839B  "#9B836C"  "rgb(155,131,108)"  "rgba(155,131,108,255)"  "17-1319TPX_Amphora"
#Pnt_17_1320      = $6A89A7;  $FF6A89A7  "#A7896A"  "rgb(167,137,106)"  "rgba(167,137,106,255)"  "17-1320TPX_Tannin"
#Pnt_17_1321      = $607591;  $FF607591  "#917560"  "rgb(145,117, 96)"  "rgba(145,117, 96,255)"  "17-1321TPX_Woodsmoke"
#Pnt_17_1322      = $667FA0;  $FF667FA0  "#A07F66"  "rgb(160,127,102)"  "rgba(160,127,102,255)"  "17-1322TPX_Burro"
#Pnt_17_1327      = $537396;  $FF537396  "#967353"  "rgb(150,115, 83)"  "rgba(150,115, 83,255)"  "17-1327TPX_TobaccoBrown"
#Pnt_17_1328      = $6084AD;  $FF6084AD  "#AD8460"  "rgb(173,132, 96)"  "rgba(173,132, 96,255)"  "17-1328TPX_IndianTan"
#Pnt_17_1330      = $5274A1;  $FF5274A1  "#A17452"  "rgb(161,116, 82)"  "rgba(161,116, 82,255)"  "17-1330TPX_Lion"
#Pnt_17_1336      = $496FA8;  $FF496FA8  "#A86F49"  "rgb(168,111, 73)"  "rgba(168,111, 73,255)"  "17-1336TPX_Bran"
#Pnt_17_1340      = $3C62A4;  $FF3C62A4  "#A4623C"  "rgb(164, 98, 60)"  "rgba(164, 98, 60,255)"  "17-1340TPX_Adobe"
#Pnt_17_1341      = $6C80CE;  $FF6C80CE  "#CE806C"  "rgb(206,128,108)"  "rgba(206,128,108,255)"  "17-1341TPX_TawnyOrange"
#Pnt_17_1342      = $1D75B1;  $FF1D75B1  "#B1751D"  "rgb(177,117, 29)"  "rgba(177,117, 29,255)"  "17-1342TPX_Autumnal"
#Pnt_17_1347      = $4B65B0;  $FF4B65B0  "#B0654B"  "rgb(176,101, 75)"  "rgba(176,101, 75,255)"  "17-1347TPX_AutumnLeaf"
#Pnt_17_1349      = $00A4F6;  $FF00A4F6  "#F6A400"  "rgb(246,164,  0)"  "rgba(246,164,  0,255)"  "17-1349TPX_Exuberance"
#Pnt_17_1350      = $0D77FF;  $FF0D77FF  "#FF770D"  "rgb(255,119, 13)"  "rgba(255,119, 13,255)"  "17-1350TPX_OrangePopsicle"
#Pnt_17_1353      = $3C65C3;  $FF3C65C3  "#C3653C"  "rgb(195,101, 60)"  "rgba(195,101, 60,255)"  "17-1353TPX_ApricotOrange"
#Pnt_17_1360      = $2CA5F9;  $FF2CA5F9  "#F9A52C"  "rgb(249,165, 44)"  "rgba(249,165, 44,255)"  "17-1360TPX_CelosiaOrange"
#Pnt_17_1410      = $667384;  $FF667384  "#847366"  "rgb(132,115,102)"  "rgba(132,115,102,255)"  "17-1410TPX_PineBark"
#Pnt_17_1417      = $637594;  $FF637594  "#947563"  "rgb(148,117, 99)"  "rgba(148,117, 99,255)"  "17-1417TPX_BeaverFur"
#Pnt_17_1418      = $6D7D95;  $FF6D7D95  "#957D6D"  "rgb(149,125,109)"  "rgba(149,125,109,255)"  "17-1418TPX_GingerSnap"
#Pnt_17_1422      = $5D6E8F;  $FF5D6E8F  "#8F6E5D"  "rgb(143,110, 93)"  "rgba(143,110, 93,255)"  "17-1422TPX_RawUmber"
#Pnt_17_1424      = $686FB3;  $FF686FB3  "#B36F68"  "rgb(179,111,104)"  "rgba(179,111,104,255)"  "17-1424TPX_BrickDust"
#Pnt_17_1430      = $5370A5;  $FF5370A5  "#A57053"  "rgb(165,112, 83)"  "rgba(165,112, 83,255)"  "17-1430TPX_PecanBrown"
#Pnt_17_1436      = $536EB8;  $FF536EB8  "#B86E53"  "rgb(184,110, 83)"  "rgba(184,110, 83,255)"  "17-1436TPX_RawSienna"
#Pnt_17_1444      = $4E5FC7;  $FF4E5FC7  "#C75F4E"  "rgb(199, 95, 78)"  "rgba(199, 95, 78,255)"  "17-1444TPX_Ginger"
#Pnt_17_1446      = $4A5EB7;  $FF4A5EB7  "#B75E4A"  "rgb(183, 94, 74)"  "rgba(183, 94, 74,255)"  "17-1446TPX_Mango"
#Pnt_17_1449      = $007CE0;  $FF007CE0  "#E07C00"  "rgb(224,124,  0)"  "rgba(224,124,  0,255)"  "17-1449TPX_PureedPumpkin"
#Pnt_17_1452      = $198FE7;  $FF198FE7  "#E78F19"  "rgb(231,143, 25)"  "rgba(231,143, 25,255)"  "17-1452TPX_Koi"
#Pnt_17_1456      = $445DE1;  $FF445DE1  "#E15D44"  "rgb(225, 93, 68)"  "rgba(225, 93, 68,255)"  "17-1456TPX_Tigerlily"
#Pnt_17_1461      = $0096FB;  $FF0096FB  "#FB9600"  "rgb(251,150,  0)"  "rgba(251,150,  0,255)"  "17-1461TPX_Orangeade"
#Pnt_17_1462      = $2C51F4;  $FF2C51F4  "#F4512C"  "rgb(244, 81, 44)"  "rgba(244, 81, 44,255)"  "17-1462TPX_Flame"
#Pnt_17_1463      = $008AFE;  $FF008AFE  "#FE8A00"  "rgb(254,138,  0)"  "rgba(254,138,  0,255)"  "17-1463TPX_TangerineTango"
#Pnt_17_1464      = $2753EF;  $FF2753EF  "#EF5327"  "rgb(239, 83, 39)"  "rgba(239, 83, 39,255)"  "17-1464TPX_RedOrange"
#Pnt_17_1500      = $7B7F82;  $FF7B7F82  "#827F7B"  "rgb(130,127,123)"  "rgba(130,127,123,255)"  "17-1500TPX_SteepleGray"
#Pnt_17_1501      = $8D8E8B;  $FF8D8E8B  "#8B8E8D"  "rgb(139,142,141)"  "rgba(139,142,141,255)"  "17-1501TPX_WildDove"
#Pnt_17_1502      = $858486;  $FF858486  "#868485"  "rgb(134,132,133)"  "rgba(134,132,133,255)"  "17-1502TPX_Cloudburst"
#Pnt_17_1503      = $77728F;  $FF77728F  "#8F7277"  "rgb(143,114,119)"  "rgba(143,114,119,255)"  "17-1503TPX_StormFront"
#Pnt_17_1505      = $8D8598;  $FF8D8598  "#98858D"  "rgb(152,133,141)"  "rgba(152,133,141,255)"  "17-1505TPX_Quail"
#Pnt_17_1506      = $777C88;  $FF777C88  "#887C77"  "rgb(136,124,119)"  "rgba(136,124,119,255)"  "17-1506TPX_Cinder"
#Pnt_17_1510      = $757891;  $FF757891  "#917875"  "rgb(145,120,117)"  "rgba(145,120,117,255)"  "17-1510TPX_Antler"
#Pnt_17_1511      = $7B6F97;  $FF7B6F97  "#976F7B"  "rgb(151,111,123)"  "rgba(151,111,123,255)"  "17-1511TPX_WistfulMauve"
#Pnt_17_1512      = $847AA6;  $FF847AA6  "#A67A84"  "rgb(166,122,132)"  "rgba(166,122,132,255)"  "17-1512TPX_NostalgiaRose"
#Pnt_17_1514      = $7F7FB2;  $FF7F7FB2  "#B27F7F"  "rgb(178,127,127)"  "rgba(178,127,127,255)"  "17-1514TPX_AshRose"
#Pnt_17_1516      = $6E719A;  $FF6E719A  "#9A716E"  "rgb(154,113,110)"  "rgba(154,113,110,255)"  "17-1516TPX_Burlwood"
#Pnt_17_1518      = $787AB2;  $FF787AB2  "#B27A78"  "rgb(178,122,120)"  "rgba(178,122,120,255)"  "17-1518TPX_OldRose"
#Pnt_17_1520      = $6B6FB0;  $FF6B6FB0  "#B06F6B"  "rgb(176,111,107)"  "rgba(176,111,107,255)"  "17-1520TPX_CanyonRose"
#Pnt_17_1522      = $6D5CAB;  $FF6D5CAB  "#AB5C6D"  "rgb(171, 92,109)"  "rgba(171, 92,109,255)"  "17-1522TPX_Mauvewood"
#Pnt_17_1524      = $7278BA;  $FF7278BA  "#BA7872"  "rgb(186,120,114)"  "rgba(186,120,114,255)"  "17-1524TPX_DesertSand"
#Pnt_17_1525      = $5F69A3;  $FF5F69A3  "#A3695F"  "rgb(163,105, 95)"  "rgba(163,105, 95,255)"  "17-1525TPX_CedarWood"
#Pnt_17_1532      = $5966AD;  $FF5966AD  "#AD6659"  "rgb(173,102, 89)"  "rgba(173,102, 89,255)"  "17-1532TPX_Aragon"
#Pnt_17_1537      = $5954AE;  $FF5954AE  "#AE5459"  "rgb(174, 84, 89)"  "rgba(174, 84, 89,255)"  "17-1537TPX_MineralRed"
#Pnt_17_1540      = $5868C4;  $FF5868C4  "#C46858"  "rgb(196,104, 88)"  "rgba(196,104, 88,255)"  "17-1540TPX_ApricotBrandy"
#Pnt_17_1544      = $5059C1;  $FF5059C1  "#C15950"  "rgb(193, 89, 80)"  "rgba(193, 89, 80,255)"  "17-1544TPX_BurntSienna"
#Pnt_17_1545      = $4F48B7;  $FF4F48B7  "#B7484F"  "rgb(183, 72, 79)"  "rgba(183, 72, 79,255)"  "17-1545TPX_Cranberry"
#Pnt_17_1547      = $5C66E4;  $FF5C66E4  "#E4665C"  "rgb(228,102, 92)"  "rgba(228,102, 92,255)"  "17-1547TPX_Emberglow"
#Pnt_17_1553      = $454BC8;  $FF454BC8  "#C84B45"  "rgb(200, 75, 69)"  "rgba(200, 75, 69,255)"  "17-1553TPX_Paprika"
#Pnt_17_1558      = $3D41DA;  $FF3D41DA  "#DA413D"  "rgb(218, 65, 61)"  "rgba(218, 65, 61,255)"  "17-1558TPX_Grenadine"
#Pnt_17_1562      = $3A4DE7;  $FF3A4DE7  "#E74D3A"  "rgb(231, 77, 58)"  "rgba(231, 77, 58,255)"  "17-1562TPX_MandarinRed"
#Pnt_17_1563      = $3241E3;  $FF3241E3  "#E34132"  "rgb(227, 65, 50)"  "rgba(227, 65, 50,255)"  "17-1563TPX_CherryTomato"
#Pnt_17_1564      = $3A44DC;  $FF3A44DC  "#DC443A"  "rgb(220, 68, 58)"  "rgba(220, 68, 58,255)"  "17-1564TPX_Fiesta"
#Pnt_17_1605      = $8F849C;  $FF8F849C  "#9C848F"  "rgb(156,132,143)"  "rgba(156,132,143,255)"  "17-1605TPX_Elderberry"
#Pnt_17_1608      = $846FAD;  $FF846FAD  "#AD6F84"  "rgb(173,111,132)"  "rgba(173,111,132,255)"  "17-1608TPX_HeatherRose"
#Pnt_17_1609      = $727FC7;  $FF727FC7  "#C77F72"  "rgb(199,127,114)"  "rgba(199,127,114,255)"  "17-1609TPX_MesaRose"
#Pnt_17_1610      = $87769C;  $FF87769C  "#9C7687"  "rgb(156,118,135)"  "rgba(156,118,135,255)"  "17-1610TPX_DuskyOrchid"
#Pnt_17_1612      = $7B6399;  $FF7B6399  "#99637B"  "rgb(153, 99,123)"  "rgba(153, 99,123,255)"  "17-1612TPX_MellowMauve"
#Pnt_17_1614      = $675A96;  $FF675A96  "#965A67"  "rgb(150, 90,103)"  "rgba(150, 90,103,255)"  "17-1614TPX_DecoRose"
#Pnt_17_1623      = $7259A5;  $FF7259A5  "#A55972"  "rgb(165, 89,114)"  "rgba(165, 89,114,255)"  "17-1623TPX_RoseWine"
#Pnt_17_1633      = $5E4AB3;  $FF5E4AB3  "#B34A5E"  "rgb(179, 74, 94)"  "rgba(179, 74, 94,255)"  "17-1633TPX_HollyBerry"
#Pnt_17_1635      = $6358D8;  $FF6358D8  "#D85863"  "rgb(216, 88, 99)"  "rgba(216, 88, 99,255)"  "17-1635TPX_RoseOfSharon"
#Pnt_17_1641      = $5346BA;  $FF5346BA  "#BA4653"  "rgb(186, 70, 83)"  "rgba(186, 70, 83,255)"  "17-1641TPX_Chrysanthemum"
#Pnt_17_1643      = $6D6AE4;  $FF6D6AE4  "#E46A6D"  "rgb(228,106,109)"  "rgba(228,106,109,255)"  "17-1643TPX_PorcelainRose"
#Pnt_17_1644      = $6764D6;  $FF6764D6  "#D66467"  "rgb(214,100,103)"  "rgba(214,100,103,255)"  "17-1644TPX_SpicedCoral"
#Pnt_17_1647      = $6B63EA;  $FF6B63EA  "#EA636B"  "rgb(234, 99,107)"  "rgba(234, 99,107,255)"  "17-1647TPX_Dubarry"
#Pnt_17_1654      = $4531CB;  $FF4531CB  "#CB3145"  "rgb(203, 49, 69)"  "rgba(203, 49, 69,255)"  "17-1654TPX_Poinsettia"
#Pnt_17_1656      = $5656ED;  $FF5656ED  "#ED5656"  "rgb(237, 86, 86)"  "rgba(237, 86, 86,255)"  "17-1656TPX_HotCoral"
#Pnt_17_1663      = $4B39D6;  $FF4B39D6  "#D6394B"  "rgb(214, 57, 75)"  "rgba(214, 57, 75,255)"  "17-1663TPX_Bittersweet"
#Pnt_17_1664      = $4438DB;  $FF4438DB  "#DB3844"  "rgb(219, 56, 68)"  "rgba(219, 56, 68,255)"  "17-1664TPX_PoppyRed"
#Pnt_17_1710      = $84689A;  $FF84689A  "#9A6884"  "rgb(154,104,132)"  "rgba(154,104,132,255)"  "17-1710TPX_Bordeaux"
#Pnt_17_1718      = $827BB7;  $FF827BB7  "#B77B82"  "rgb(183,123,130)"  "rgba(183,123,130,255)"  "17-1718TPX_DustyRose"
#Pnt_17_1723      = $6D50A1;  $FF6D50A1  "#A1506D"  "rgb(161, 80,109)"  "rgba(161, 80,109,255)"  "17-1723TPX_Malaga"
#Pnt_17_1736      = $7B69E5;  $FF7B69E5  "#E5697B"  "rgb(229,105,123)"  "rgba(229,105,123,255)"  "17-1736TPX_SunkistCoral"
#Pnt_17_1740      = $644AC1;  $FF644AC1  "#C14A64"  "rgb(193, 74,100)"  "rgba(193, 74,100,255)"  "17-1740TPX_ClaretRed"
#Pnt_17_1744      = $735DEC;  $FF735DEC  "#EC5D73"  "rgb(236, 93,115)"  "rgba(236, 93,115,255)"  "17-1744TPX_CalypsoCoral"
#Pnt_17_1753      = $5A3ED7;  $FF5A3ED7  "#D73E5A"  "rgb(215, 62, 90)"  "rgba(215, 62, 90,255)"  "17-1753TPX_Geranium"
#Pnt_17_1755      = $623EE6;  $FF623EE6  "#E63E62"  "rgb(230, 62, 98)"  "rgba(230, 62, 98,255)"  "17-1755TPX_ParadisePink"
#Pnt_17_1818      = $7E5EA6;  $FF7E5EA6  "#A65E7E"  "rgb(166, 94,126)"  "rgba(166, 94,126,255)"  "17-1818TPX_RedViolet"
#Pnt_17_1831      = $6F46BB;  $FF6F46BB  "#BB466F"  "rgb(187, 70,111)"  "rgba(187, 70,111,255)"  "17-1831TPX_Carmine"
#Pnt_17_1842      = $5D30D3;  $FF5D30D3  "#D3305D"  "rgb(211, 48, 93)"  "rgba(211, 48, 93,255)"  "17-1842TPX_Azalea"
#Pnt_17_1927      = $7B69D0;  $FF7B69D0  "#D0697B"  "rgb(208,105,123)"  "rgba(208,105,123,255)"  "17-1927TPX_DesertRose"
#Pnt_17_1928      = $9171E8;  $FF9171E8  "#E87191"  "rgb(232,113,145)"  "rgba(232,113,145,255)"  "17-1928TPX_Bubblegum"
#Pnt_17_1929      = $7F65CD;  $FF7F65CD  "#CD657F"  "rgb(205,101,127)"  "rgba(205,101,127,255)"  "17-1929TPX_RaptureRose"
#Pnt_17_1930      = $8560F1;  $FF8560F1  "#F16085"  "rgb(241, 96,133)"  "rgba(241, 96,133,255)"  "17-1930TPX_CamelliaRose"
#Pnt_17_1937      = $8559E9;  $FF8559E9  "#E95985"  "rgb(233, 89,133)"  "rgba(233, 89,133,255)"  "17-1937TPX_HotPink"
#Pnt_17_2031      = $7A44C3;  $FF7A44C3  "#C3447A"  "rgb(195, 68,122)"  "rgba(195, 68,122,255)"  "17-2031TPX_FuchsiaRose"
#Pnt_17_2033      = $8552DE;  $FF8552DE  "#DE5285"  "rgb(222, 82,133)"  "rgba(222, 82,133,255)"  "17-2033TPX_FandangoPink"
#Pnt_17_2036      = $7E41D0;  $FF7E41D0  "#D0417E"  "rgb(208, 65,126)"  "rgba(208, 65,126,255)"  "17-2036TPX_Magenta"
#Pnt_17_2120      = $9774D2;  $FF9774D2  "#D27497"  "rgb(210,116,151)"  "rgba(210,116,151,255)"  "17-2120TPX_ChateauRose"
#Pnt_17_2127      = $8D5FD7;  $FF8D5FD7  "#D75F8D"  "rgb(215, 95,141)"  "rgba(215, 95,141,255)"  "17-2127TPX_ShockingPink"
#Pnt_17_2227      = $7B42BE;  $FF7B42BE  "#BE427B"  "rgb(190, 66,123)"  "rgba(190, 66,123,255)"  "17-2227TPX_LilacRose"
#Pnt_17_2230      = $915ADD;  $FF915ADD  "#DD5A91"  "rgb(221, 90,145)"  "rgba(221, 90,145,255)"  "17-2230TPX_CarmineRose"
#Pnt_17_2520      = $9160C6;  $FF9160C6  "#C66091"  "rgb(198, 96,145)"  "rgba(198, 96,145,255)"  "17-2520TPX_IbisRose"
#Pnt_17_2601      = $8B8891;  $FF8B8891  "#91888B"  "rgb(145,136,139)"  "rgba(145,136,139,255)"  "17-2601TPX_Zinc"
#Pnt_17_2617      = $8753A8;  $FF8753A8  "#A85387"  "rgb(168, 83,135)"  "rgba(168, 83,135,255)"  "17-2617TPX_DahliaMauve"
#Pnt_17_2624      = $924CC2;  $FF924CC2  "#C24C92"  "rgb(194, 76,146)"  "rgba(194, 76,146,255)"  "17-2624TPX_RoseViolet"
#Pnt_17_2625      = $A96BCF;  $FFA96BCF  "#CF6BA9"  "rgb(207,107,169)"  "rgba(207,107,169,255)"  "17-2625TPX_SuperPink"
#Pnt_17_2627      = $A361D3;  $FFA361D3  "#D361A3"  "rgb(211, 97,163)"  "rgba(211, 97,163,255)"  "17-2627TPX_PhloxPink"
#Pnt_17_3014      = $9F70AA;  $FF9F70AA  "#AA709F"  "rgb(170,112,159)"  "rgba(170,112,159,255)"  "17-3014TPX_Mulberry"
#Pnt_17_3020      = $A76CBC;  $FFA76CBC  "#BC6CA7"  "rgb(188,108,167)"  "rgba(188,108,167,255)"  "17-3020TPX_SpringCrocus"
#Pnt_17_3023      = $A15DB6;  $FFA15DB6  "#B65DA1"  "rgb(182, 93,161)"  "rgba(182, 93,161,255)"  "17-3023TPX_Rosebud"
#Pnt_17_3313      = $9B759E;  $FF9B759E  "#9E759B"  "rgb(158,117,155)"  "rgba(158,117,155,255)"  "17-3313TPX_DustyLavender"
#Pnt_17_3323      = $AA66AA;  $FFAA66AA  "#AA66AA"  "rgb(170,102,170)"  "rgba(170,102,170,255)"  "17-3323TPX_IrisOrchid"
#Pnt_17_3410      = $94769C;  $FF94769C  "#9C7694"  "rgb(156,118,148)"  "rgba(156,118,148,255)"  "17-3410TPX_Valerian"
#Pnt_17_3612      = $9A7790;  $FF9A7790  "#90779A"  "rgb(144,119,154)"  "rgba(144,119,154,255)"  "17-3612TPX_OrchidMist"
#Pnt_17_3615      = $A6798B;  $FFA6798B  "#8B79A6"  "rgb(139,121,166)"  "rgba(139,121,166,255)"  "17-3615TPX_ChalkViolet"
#Pnt_17_3617      = $9583B4;  $FF9583B4  "#B48395"  "rgb(180,131,149)"  "rgba(180,131,149,255)"  "17-3617TPX_EnglishLavender"
#Pnt_17_3619      = $A5698F;  $FFA5698F  "#8F69A5"  "rgb(143,105,165)"  "rgba(143,105,165,255)"  "17-3619TPX_Hyacinth"
#Pnt_17_3628      = $AB6491;  $FFAB6491  "#9164AB"  "rgb(145,100,171)"  "rgba(145,100,171,255)"  "17-3628TPX_AmethystOrchid"
#Pnt_17_3725      = $C0849B;  $FFC0849B  "#9B84C0"  "rgb(155,132,192)"  "rgba(155,132,192,255)"  "17-3725TPX_Bougainvillea"
#Pnt_17_3730      = $B27788;  $FFB27788  "#8877B2"  "rgb(136,119,178)"  "rgba(136,119,178,255)"  "17-3730TPX_PaisleyPurple"
#Pnt_17_3802      = $918C90;  $FF918C90  "#908C91"  "rgb(144,140,145)"  "rgba(144,140,145,255)"  "17-3802TPX_Gull"
#Pnt_17_3808      = $988C9B;  $FF988C9B  "#9B8C98"  "rgb(155,140,152)"  "rgba(155,140,152,255)"  "17-3808TPX_Nirvana"
#Pnt_17_3810      = $97838C;  $FF97838C  "#8C8397"  "rgb(140,131,151)"  "rgba(140,131,151,255)"  "17-3810TPX_PurpleAsh"
#Pnt_17_3812      = $9E828A;  $FF9E828A  "#8A829E"  "rgb(138,130,158)"  "rgba(138,130,158,255)"  "17-3812TPX_Dusk"
#Pnt_17_3817      = $A48188;  $FFA48188  "#8881A4"  "rgb(136,129,164)"  "rgba(136,129,164,255)"  "17-3817TPX_Daybreak"
#Pnt_17_3826      = $AA7680;  $FFAA7680  "#8076AA"  "rgb(128,118,170)"  "rgba(128,118,170,255)"  "17-3826TPX_AsterPurple"
#Pnt_17_3834      = $B06F7F;  $FFB06F7F  "#7F6FB0"  "rgb(127,111,176)"  "rgba(127,111,176,255)"  "17-3834TPX_DahliaPurple"
#Pnt_17_3906      = $9A8D91;  $FF9A8D91  "#918D9A"  "rgb(145,141,154)"  "rgba(145,141,154,255)"  "17-3906TPX_MinimalGray"
#Pnt_17_3907      = $867996;  $FF867996  "#967986"  "rgb(150,121,134)"  "rgba(150,121,134,255)"  "17-3907TPX_Quicksilver"
#Pnt_17_3910      = $A28F95;  $FFA28F95  "#958FA2"  "rgb(149,143,162)"  "rgba(149,143,162,255)"  "17-3910TPX_LavenderGray"
#Pnt_17_3911      = $7E7B94;  $FF7E7B94  "#947B7E"  "rgb(148,123,126)"  "rgba(148,123,126,255)"  "17-3911TPX_SilverFiligree"
#Pnt_17_3915      = $9B8073;  $FF9B8073  "#73809B"  "rgb(115,128,155)"  "rgba(115,128,155,255)"  "17-3915TPX_Tempest"
#Pnt_17_3917      = $A08376;  $FFA08376  "#7683A0"  "rgb(118,131,160)"  "rgba(118,131,160,255)"  "17-3917TPX_Stonewash"
#Pnt_17_3918      = $9B7D6D;  $FF9B7D6D  "#6D7D9B"  "rgb(109,125,155)"  "rgba(109,125,155,255)"  "17-3918TPX_CountryBlue"
#Pnt_17_3919      = $B79186;  $FFB79186  "#8691B7"  "rgb(134,145,183)"  "rgba(134,145,183,255)"  "17-3919TPX_PurpleImpression"
#Pnt_17_3920      = $A4806E;  $FFA4806E  "#6E80A4"  "rgb(110,128,164)"  "rgba(110,128,164,255)"  "17-3920TPX_EnglishManor"
#Pnt_17_3922      = $9F7A6F;  $FF9F7A6F  "#6F7A9F"  "rgb(111,122,159)"  "rgba(111,122,159,255)"  "17-3922TPX_BlueIce"
#Pnt_17_3923      = $9D7661;  $FF9D7661  "#61769D"  "rgb( 97,118,157)"  "rgba( 97,118,157,255)"  "17-3923TPX_ColonyBlue"
#Pnt_17_3924      = $A87C74;  $FFA87C74  "#747CA8"  "rgb(116,124,168)"  "rgba(116,124,168,255)"  "17-3924TPX_LavenderViolet"
#Pnt_17_3925      = $B58D8A;  $FFB58D8A  "#8A8DB5"  "rgb(138,141,181)"  "rgba(138,141,181,255)"  "17-3925TPX_PersianViolet"
#Pnt_17_3930      = $CB9086;  $FFCB9086  "#8690CB"  "rgb(134,144,203)"  "rgba(134,144,203,255)"  "17-3930TPX_Jacaranda"
#Pnt_17_3932      = $BF837A;  $FFBF837A  "#7A83BF"  "rgb(122,131,191)"  "rgba(122,131,191,255)"  "17-3932TPX_DeepPeriwinkle"
#Pnt_17_3933      = $947E99;  $FF947E99  "#997E94"  "rgb(153,126,148)"  "rgba(153,126,148,255)"  "17-3933TPX_SilverBullet"
#Pnt_17_3934      = $C27F69;  $FFC27F69  "#697FC2"  "rgb(105,127,194)"  "rgba(105,127,194,255)"  "17-3934TPX_PersianJewel"
#Pnt_17_3936      = $BF8663;  $FFBF8663  "#6386BF"  "rgb( 99,134,191)"  "rgba( 99,134,191,255)"  "17-3936TPX_BlueBonnet"
#Pnt_17_4014      = $817B98;  $FF817B98  "#987B81"  "rgb(152,123,129)"  "rgba(152,123,129,255)"  "17-4014TPX_Titanium"
#Pnt_17_4015      = $987B66;  $FF987B66  "#667B98"  "rgb(102,123,152)"  "rgba(102,123,152,255)"  "17-4015TPX_Infinity"
#Pnt_17_4020      = $A08768;  $FFA08768  "#6887A0"  "rgb(104,135,160)"  "rgba(104,135,160,255)"  "17-4020TPX_BlueShadow"
#Pnt_17_4021      = $A88F77;  $FFA88F77  "#778FA8"  "rgb(119,143,168)"  "rgba(119,143,168,255)"  "17-4021TPX_FadedDenim"
#Pnt_17_4023      = $977C57;  $FF977C57  "#577C97"  "rgb( 87,124,151)"  "rgba( 87,124,151,255)"  "17-4023TPX_BlueHeaven"
#Pnt_17_4027      = $A67756;  $FFA67756  "#5677A6"  "rgb( 86,119,166)"  "rgba( 86,119,166,255)"  "17-4027TPX_Riviera"
#Pnt_17_4030      = $BA895D;  $FFBA895D  "#5D89BA"  "rgb( 93,137,186)"  "rgba( 93,137,186,255)"  "17-4030TPX_SilverLakeBlue"
#Pnt_17_4037      = $C27C5A;  $FFC27C5A  "#5A7CC2"  "rgb( 90,124,194)"  "rgba( 90,124,194,255)"  "17-4037TPX_Ultramarine"
#Pnt_17_4041      = $CD8853;  $FFCD8853  "#5388CD"  "rgb( 83,136,205)"  "rgba( 83,136,205,255)"  "17-4041TPX_Marina"
#Pnt_17_4111      = $988A73;  $FF988A73  "#738A98"  "rgb(115,138,152)"  "rgba(115,138,152,255)"  "17-4111TPX_Citadel"
#Pnt_17_4123      = $A98C57;  $FFA98C57  "#578CA9"  "rgb( 87,140,169)"  "rgba( 87,140,169,255)"  "17-4123TPX_Niagara"
#Pnt_17_4131      = $AC813D;  $FFAC813D  "#3D81AC"  "rgb( 61,129,172)"  "rgba( 61,129,172,255)"  "17-4131TPX_CendreBlue"
#Pnt_17_4139      = $C68A45;  $FFC68A45  "#458AC6"  "rgb( 69,138,198)"  "rgba( 69,138,198,255)"  "17-4139TPX_AzureBlue"
#Pnt_17_4247      = $C18300;  $FFC18300  "#0083C1"  "rgb(  0,131,193)"  "rgba(  0,131,193,255)"  "17-4247TPX_DivaBlue"
#Pnt_17_4320      = $9F8D5F;  $FF9F8D5F  "#5F8D9F"  "rgb( 95,141,159)"  "rgba( 95,141,159,255)"  "17-4320TPX_AdriaticBlue"
#Pnt_17_4328      = $A68833;  $FFA68833  "#3388A6"  "rgb( 51,136,166)"  "rgba( 51,136,166,255)"  "17-4328TPX_BlueMoon"
#Pnt_17_4336      = $C38B00;  $FFC38B00  "#008BC3"  "rgb(  0,139,195)"  "rgba(  0,139,195,255)"  "17-4336TPX_Blithe"
#Pnt_17_4402      = $8C8E89;  $FF8C8E89  "#898E8C"  "rgb(137,142,140)"  "rgba(137,142,140,255)"  "17-4402TPX_NeutralGray"
#Pnt_17_4405      = $87837A;  $FF87837A  "#7A8387"  "rgb(122,131,135)"  "rgba(122,131,135,255)"  "17-4405TPX_Monument"
#Pnt_17_4408      = $8F8876;  $FF8F8876  "#76888F"  "rgb(118,136,143)"  "rgba(118,136,143,255)"  "17-4408TPX_Lead"
#Pnt_17_4412      = $938A67;  $FF938A67  "#678A93"  "rgb(103,138,147)"  "rgba(103,138,147,255)"  "17-4412TPX_SmokeBlue"
#Pnt_17_4421      = $917B35;  $FF917B35  "#357B91"  "rgb( 53,123,145)"  "rgba( 53,123,145,255)"  "17-4421TPX_Larkspur"
#Pnt_17_4427      = $A8851B;  $FFA8851B  "#1B85A8"  "rgb( 27,133,168)"  "rgba( 27,133,168,255)"  "17-4427TPX_Bluejay"
#Pnt_17_4432      = $B78C00;  $FFB78C00  "#008CB7"  "rgb(  0,140,183)"  "rgba(  0,140,183,255)"  "17-4432TPX_VividBlue"
#Pnt_17_4433      = $C28A00;  $FFC28A00  "#008AC2"  "rgb(  0,138,194)"  "rgba(  0,138,194,255)"  "17-4433TPX_DresdenBlue"
#Pnt_17_4435      = $CA9200;  $FFCA9200  "#0092CA"  "rgb(  0,146,202)"  "rgba(  0,146,202,255)"  "17-4435TPX_MalibuBlue"
#Pnt_17_4440      = $B78900;  $FFB78900  "#0089B7"  "rgb(  0,137,183)"  "rgba(  0,137,183,255)"  "17-4440TPX_BlueDanube"
#Pnt_17_4540      = $C69500;  $FFC69500  "#0095C6"  "rgb(  0,149,198)"  "rgba(  0,149,198,255)"  "17-4540TPX_HawaiianOcean"
#Pnt_17_4716      = $8C7B44;  $FF8C7B44  "#447B8C"  "rgb( 68,123,140)"  "rgba( 68,123,140,255)"  "17-4716TPX_StormBlue"
#Pnt_17_4724      = $918112;  $FF918112  "#128191"  "rgb( 18,129,145)"  "rgba( 18,129,145,255)"  "17-4724TPX_PagodaBlue"
#Pnt_17_4728      = $9C8500;  $FF9C8500  "#00859C"  "rgb(  0,133,156)"  "rgba(  0,133,156,255)"  "17-4728TPX_AlgiersBlue"
#Pnt_17_4730      = $A28500;  $FFA28500  "#0085A2"  "rgb(  0,133,162)"  "rgba(  0,133,162,255)"  "17-4730TPX_CaneelBay"
#Pnt_17_4735      = $9D8900;  $FF9D8900  "#00899D"  "rgb(  0,137,157)"  "rgba(  0,137,157,255)"  "17-4735TPX_CapriBreeze"
#Pnt_17_4818      = $93904E;  $FF93904E  "#4E9093"  "rgb( 78,144,147)"  "rgba( 78,144,147,255)"  "17-4818TPX_BristolBlue"
#Pnt_17_4911      = $8E8863;  $FF8E8863  "#63888E"  "rgb( 99,136,142)"  "rgba( 99,136,142,255)"  "17-4911TPX_Arctic"
#Pnt_17_4919      = $898641;  $FF898641  "#418689"  "rgb( 65,134,137)"  "rgba( 65,134,137,255)"  "17-4919TPX_Teal"
#Pnt_17_4928      = $978D00;  $FF978D00  "#008D97"  "rgb(  0,141,151)"  "rgba(  0,141,151,255)"  "17-4928TPX_LakeBlue"
#Pnt_17_5024      = $7E8000;  $FF7E8000  "#00807E"  "rgb(  0,128,126)"  "rgba(  0,128,126,255)"  "17-5024TPX_TealBlue"
#Pnt_17_5025      = $858500;  $FF858500  "#008585"  "rgb(  0,133,133)"  "rgba(  0,133,133,255)"  "17-5025TPX_Navigate"
#Pnt_17_5029      = $848600;  $FF848600  "#008684"  "rgb(  0,134,132)"  "rgba(  0,134,132,255)"  "17-5029TPX_DeepPeacockBlue"
#Pnt_17_5034      = $8A8C00;  $FF8A8C00  "#008C8A"  "rgb(  0,140,138)"  "rgba(  0,140,138,255)"  "17-5034TPX_Lapis"
#Pnt_17_5102      = $908F8A;  $FF908F8A  "#8A8F90"  "rgb(138,143,144)"  "rgba(138,143,144,255)"  "17-5102TPX_Griffin"
#Pnt_17_5107      = $848976;  $FF848976  "#768984"  "rgb(118,137,132)"  "rgba(118,137,132,255)"  "17-5107TPX_ChinoisGreen"
#Pnt_17_5110      = $848466;  $FF848466  "#668484"  "rgb(102,132,132)"  "rgba(102,132,132,255)"  "17-5110TPX_Trellis"
#Pnt_17_5111      = $8B8E63;  $FF8B8E63  "#638E8B"  "rgb( 99,142,139)"  "rgba( 99,142,139,255)"  "17-5111TPX_OilBlue"
#Pnt_17_5117      = $848231;  $FF848231  "#318284"  "rgb( 49,130,132)"  "rgba( 49,130,132,255)"  "17-5117TPX_Green-BlueSlate"
#Pnt_17_5122      = $929333;  $FF929333  "#339392"  "rgb( 51,147,146)"  "rgba( 51,147,146,255)"  "17-5122TPX_LatigoBay"
#Pnt_17_5126      = $989600;  $FF989600  "#009698"  "rgb(  0,150,152)"  "rgba(  0,150,152,255)"  "17-5126TPX_ViridianGreen"
#Pnt_17_5130      = $8A9500;  $FF8A9500  "#00958A"  "rgb(  0,149,138)"  "rgba(  0,149,138,255)"  "17-5130TPX_Columbia"
#Pnt_17_5330      = $839400;  $FF839400  "#009483"  "rgb(  0,148,131)"  "rgba(  0,148,131,255)"  "17-5330TPX_DynastyGreen"
#Pnt_17_5335      = $8E9F00;  $FF8E9F00  "#009F8E"  "rgb(  0,159,142)"  "rgba(  0,159,142,255)"  "17-5335TPX_SpectraGreen"
#Pnt_17_5421      = $838B15;  $FF838B15  "#158B83"  "rgb( 21,139,131)"  "rgba( 21,139,131,255)"  "17-5421TPX_PorcelainGreen"
#Pnt_17_5430      = $758700;  $FF758700  "#008775"  "rgb(  0,135,117)"  "rgba(  0,135,117,255)"  "17-5430TPX_Alhambra"
#Pnt_17_5513      = $767D49;  $FF767D49  "#497D76"  "rgb( 73,125,118)"  "rgba( 73,125,118,255)"  "17-5513TPX_DeepSea"
#Pnt_17_5528      = $6C8000;  $FF6C8000  "#00806C"  "rgb(  0,128,108)"  "rgba(  0,128,108,255)"  "17-5528TPX_Greenlake"
#Pnt_17_5633      = $769500;  $FF769500  "#009576"  "rgb(  0,149,118)"  "rgba(  0,149,118,255)"  "17-5633TPX_DeepGreen"
#Pnt_17_5638      = $7FA300;  $FF7FA300  "#00A37F"  "rgb(  0,163,127)"  "rgba(  0,163,127,255)"  "17-5638TPX_VividGreen"
#Pnt_17_5641      = $749800;  $FF749800  "#009874"  "rgb(  0,152,116)"  "rgba(  0,152,116,255)"  "17-5641TPX_Emerald"
#Pnt_17_5722      = $70803F;  $FF70803F  "#3F8070"  "rgb( 63,128,112)"  "rgba( 63,128,112,255)"  "17-5722TPX_BottleGreen"
#Pnt_17_5734      = $698500;  $FF698500  "#008569"  "rgb(  0,133,105)"  "rgba(  0,133,105,255)"  "17-5734TPX_Viridis"
#Pnt_17_5735      = $6A9200;  $FF6A9200  "#00926A"  "rgb(  0,146,106)"  "rgba(  0,146,106,255)"  "17-5735TPX_Parakeet"
#Pnt_17_5912      = $627758;  $FF627758  "#587762"  "rgb( 88,119, 98)"  "rgba( 88,119, 98,255)"  "17-5912TPX_DarkIvy"
#Pnt_17_5923      = $658042;  $FF658042  "#428065"  "rgb( 66,128,101)"  "rgba( 66,128,101,255)"  "17-5923TPX_PineGreen"
#Pnt_17_5936      = $759D00;  $FF759D00  "#009D75"  "rgb(  0,157,117)"  "rgba(  0,157,117,255)"  "17-5936TPX_SimplyGreen"
#Pnt_17_5937      = $71A500;  $FF71A500  "#00A571"  "rgb(  0,165,113)"  "rgba(  0,165,113,255)"  "17-5937TPX_DeepMint"
#Pnt_17_6009      = $616D5C;  $FF616D5C  "#5C6D61"  "rgb( 92,109, 97)"  "rgba( 92,109, 97,255)"  "17-6009TPX_LaurelWreath"
#Pnt_17_6030      = $4F8700;  $FF4F8700  "#00874F"  "rgb(  0,135, 79)"  "rgba(  0,135, 79,255)"  "17-6030TPX_JellyBean"
#Pnt_17_6153      = $469200;  $FF469200  "#009246"  "rgb(  0,146, 70)"  "rgba(  0,146, 70,255)"  "17-6153TPX_FernGreen"
#Pnt_17_6206      = $838F87;  $FF838F87  "#878F83"  "rgb(135,143,131)"  "rgba(135,143,131,255)"  "17-6206TPX_Shadow"
#Pnt_17_6212      = $6A7C69;  $FF6A7C69  "#697C6A"  "rgb(105,124,106)"  "rgba(105,124,106,255)"  "17-6212TPX_SeaSpray"
#Pnt_17_6219      = $678552;  $FF678552  "#528567"  "rgb( 82,133,103)"  "rgba( 82,133,103,255)"  "17-6219TPX_DeepGrassGreen"
#Pnt_17_6229      = $56854A;  $FF56854A  "#4A8556"  "rgb( 74,133, 86)"  "rgba( 74,133, 86,255)"  "17-6229TPX_MediumGreen"
#Pnt_17_6319      = $698C69;  $FF698C69  "#698C69"  "rgb(105,140,105)"  "rgba(105,140,105,255)"  "17-6319TPX_Kashmir"
#Pnt_17_6323      = $6F866E;  $FF6F866E  "#6E866F"  "rgb(110,134,111)"  "rgba(110,134,111,255)"  "17-6323TPX_HedgeGreen"
#Pnt_17_6333      = $4F8151;  $FF4F8151  "#51814F"  "rgb( 81,129, 79)"  "rgba( 81,129, 79,255)"  "17-6333TPX_MintGreen"
#Pnt_18_0000      = $6A6866;  $FF6A6866  "#66686A"  "rgb(102,104,106)"  "rgba(102,104,106,255)"  "18-0000TPX_SmokedPearl"
#Pnt_18_0108      = $436B56;  $FF436B56  "#566B43"  "rgb( 86,107, 67)"  "rgba( 86,107, 67,255)"  "18-0108TPX_Dill"
#Pnt_18_0110      = $5B845F;  $FF5B845F  "#5F845B"  "rgb( 95,132, 91)"  "rgba( 95,132, 91,255)"  "18-0110TPX_EnglishIvy"
#Pnt_18_0117      = $4D7158;  $FF4D7158  "#58714D"  "rgb( 88,113, 77)"  "rgba( 88,113, 77,255)"  "18-0117TPX_VineyardGreen"
#Pnt_18_0119      = $3F7052;  $FF3F7052  "#52703F"  "rgb( 82,112, 63)"  "rgba( 82,112, 63,255)"  "18-0119TPX_WillowBough"
#Pnt_18_0121      = $537454;  $FF537454  "#547453"  "rgb( 84,116, 83)"  "rgba( 84,116, 83,255)"  "18-0121TPX_ElmGreen"
#Pnt_18_0125      = $446F4B;  $FF446F4B  "#4B6F44"  "rgb( 75,111, 68)"  "rgba( 75,111, 68,255)"  "18-0125TPX_ArtichokeGreen"
#Pnt_18_0130      = $3F7152;  $FF3F7152  "#52713F"  "rgb( 82,113, 63)"  "rgba( 82,113, 63,255)"  "18-0130TPX_Cactus"
#Pnt_18_0135      = $386E4E;  $FF386E4E  "#4E6E38"  "rgb( 78,110, 56)"  "rgba( 78,110, 56,255)"  "18-0135TPX_Treetop"
#Pnt_18_0201      = $625E59;  $FF625E59  "#595E62"  "rgb( 89, 94, 98)"  "rgba( 89, 94, 98,255)"  "18-0201TPX_Castlerock"
#Pnt_18_0228      = $366259;  $FF366259  "#596236"  "rgb( 89, 98, 54)"  "rgba( 89, 98, 54,255)"  "18-0228TPX_Pesto"
#Pnt_18_0306      = $5A5D5A;  $FF5A5D5A  "#5A5D5A"  "rgb( 90, 93, 90)"  "rgba( 90, 93, 90,255)"  "18-0306TPX_Gunmetal"
#Pnt_18_0312      = $576B67;  $FF576B67  "#676B57"  "rgb(103,107, 87)"  "rgba(103,107, 87,255)"  "18-0312TPX_DeepLichenGreen"
#Pnt_18_0316      = $586F66;  $FF586F66  "#666F58"  "rgb(102,111, 88)"  "rgba(102,111, 88,255)"  "18-0316TPX_Olivine"
#Pnt_18_0317      = $495F52;  $FF495F52  "#525F49"  "rgb( 82, 95, 73)"  "rgba( 82, 95, 73,255)"  "18-0317TPX_BronzeGreen"
#Pnt_18_0322      = $415B52;  $FF415B52  "#525B41"  "rgb( 82, 91, 65)"  "rgba( 82, 91, 65,255)"  "18-0322TPX_Cypress"
#Pnt_18_0324      = $507B76;  $FF507B76  "#767B50"  "rgb(118,123, 80)"  "rgba(118,123, 80,255)"  "18-0324TPX_CallisteGreen"
#Pnt_18_0328      = $3B6C62;  $FF3B6C62  "#626C3B"  "rgb( 98,108, 59)"  "rgba( 98,108, 59,255)"  "18-0328TPX_CedarGreen"
#Pnt_18_0332      = $437C70;  $FF437C70  "#707C43"  "rgb(112,124, 67)"  "rgba(112,124, 67,255)"  "18-0332TPX_Grasshopper"
#Pnt_18_0403      = $595A5D;  $FF595A5D  "#5D5A59"  "rgb( 93, 90, 89)"  "rgba( 93, 90, 89,255)"  "18-0403TPX_DarkGullGray"
#Pnt_18_0420      = $4F635C;  $FF4F635C  "#5C634F"  "rgb( 92, 99, 79)"  "rgba( 92, 99, 79,255)"  "18-0420TPX_FourLeafClover"
#Pnt_18_0422      = $56736D;  $FF56736D  "#6D7356"  "rgb(109,115, 86)"  "rgba(109,115, 86,255)"  "18-0422TPX_LodenGreen"
#Pnt_18_0426      = $4D6B69;  $FF4D6B69  "#696B4D"  "rgb(105,107, 77)"  "rgba(105,107, 77,255)"  "18-0426TPX_CapuletOlive"
#Pnt_18_0430      = $396366;  $FF396366  "#666339"  "rgb(102, 99, 57)"  "rgba(102, 99, 57,255)"  "18-0430TPX_Avocado"
#Pnt_18_0435      = $39716B;  $FF39716B  "#6B7139"  "rgb(107,113, 57)"  "rgba(107,113, 57,255)"  "18-0435TPX_CallaGreen"
#Pnt_18_0503      = $666766;  $FF666766  "#666766"  "rgb(102,103,102)"  "rgba(102,103,102,255)"  "18-0503TPX_Gargoyle"
#Pnt_18_0510      = $666C66;  $FF666C66  "#666C66"  "rgb(102,108,102)"  "rgba(102,108,102,255)"  "18-0510TPX_CastorGray"
#Pnt_18_0513      = $545D64;  $FF545D64  "#645D54"  "rgb(100, 93, 84)"  "rgba(100, 93, 84,255)"  "18-0513TPX_BungeeCord"
#Pnt_18_0515      = $596566;  $FF596566  "#666559"  "rgb(102,101, 89)"  "rgba(102,101, 89,255)"  "18-0515TPX_DustyOlive"
#Pnt_18_0521      = $55686A;  $FF55686A  "#6A6855"  "rgb(106,104, 85)"  "rgba(106,104, 85,255)"  "18-0521TPX_BurntOlive"
#Pnt_18_0523      = $4A586F;  $FF4A586F  "#6F584A"  "rgb(111, 88, 74)"  "rgba(111, 88, 74,255)"  "18-0523TPX_WinterMoss"
#Pnt_18_0525      = $56827E;  $FF56827E  "#7E8256"  "rgb(126,130, 86)"  "rgba(126,130, 86,255)"  "18-0525TPX_Iguana"
#Pnt_18_0527      = $486F70;  $FF486F70  "#706F48"  "rgb(112,111, 72)"  "rgba(112,111, 72,255)"  "18-0527TPX_OliveBranch"
#Pnt_18_0538      = $40807F;  $FF40807F  "#7F8040"  "rgb(127,128, 64)"  "rgba(127,128, 64,255)"  "18-0538TPX_Woodbine"
#Pnt_18_0601      = $6A6A6A;  $FF6A6A6A  "#6A6A6A"  "rgb(106,106,106)"  "rgba(106,106,106,255)"  "18-0601TPX_CharcoalGray"
#Pnt_18_0615      = $4D5F63;  $FF4D5F63  "#635F4D"  "rgb( 99, 95, 77)"  "rgba( 99, 95, 77,255)"  "18-0615TPX_StoneGray"
#Pnt_18_0617      = $5E747D;  $FF5E747D  "#7D745E"  "rgb(125,116, 94)"  "rgba(125,116, 94,255)"  "18-0617TPX_CovertGreen"
#Pnt_18_0622      = $466E74;  $FF466E74  "#746E46"  "rgb(116,110, 70)"  "rgba(116,110, 70,255)"  "18-0622TPX_OliveDrab"
#Pnt_18_0627      = $2A5665;  $FF2A5665  "#65562A"  "rgb(101, 86, 42)"  "rgba(101, 86, 42,255)"  "18-0627TPX_FirGreen"
#Pnt_18_0629      = $4A6E78;  $FF4A6E78  "#786E4A"  "rgb(120,110, 74)"  "rgba(120,110, 74,255)"  "18-0629TPX_Lizard"
#Pnt_18_0724      = $52727F;  $FF52727F  "#7F7252"  "rgb(127,114, 82)"  "rgba(127,114, 82,255)"  "18-0724TPX_GothicOlive"
#Pnt_18_0820      = $455E67;  $FF455E67  "#675E45"  "rgb(103, 94, 69)"  "rgba(103, 94, 69,255)"  "18-0820TPX_Capers"
#Pnt_18_0825      = $416471;  $FF416471  "#716441"  "rgb(113,100, 65)"  "rgba(113,100, 65,255)"  "18-0825TPX_Nutria"
#Pnt_18_0830      = $43677B;  $FF43677B  "#7B6743"  "rgb(123,103, 67)"  "rgba(123,103, 67,255)"  "18-0830TPX_Butternut"
#Pnt_18_0832      = $36657B;  $FF36657B  "#7B6536"  "rgb(123,101, 54)"  "rgba(123,101, 54,255)"  "18-0832TPX_Plantation"
#Pnt_18_0835      = $377C9A;  $FF377C9A  "#9A7C37"  "rgb(154,124, 55)"  "rgba(154,124, 55,255)"  "18-0835TPX_DriedTobacco"
#Pnt_18_0840      = $2A5F7E;  $FF2A5F7E  "#7E5F2A"  "rgb(126, 95, 42)"  "rgba(126, 95, 42,255)"  "18-0840TPX_Tapenade"
#Pnt_18_0920      = $476071;  $FF476071  "#716047"  "rgb(113, 96, 71)"  "rgba(113, 96, 71,255)"  "18-0920TPX_Kangaroo"
#Pnt_18_0928      = $40576C;  $FF40576C  "#6C5740"  "rgb(108, 87, 64)"  "rgba(108, 87, 64,255)"  "18-0928TPX_Sepia"
#Pnt_18_0930      = $42556A;  $FF42556A  "#6A5542"  "rgb(106, 85, 66)"  "rgba(106, 85, 66,255)"  "18-0930TPX_CoffeeLiqueúr"
#Pnt_18_0933      = $426182;  $FF426182  "#826142"  "rgb(130, 97, 66)"  "rgba(130, 97, 66,255)"  "18-0933TPX_Rubber"
#Pnt_18_0935      = $2672A8;  $FF2672A8  "#A87226"  "rgb(168,114, 38)"  "rgba(168,114, 38,255)"  "18-0935TPX_BuckthornBrown"
#Pnt_18_0937      = $345F81;  $FF345F81  "#815F34"  "rgb(129, 95, 52)"  "rgba(129, 95, 52,255)"  "18-0937TPX_BronzeBrown"
#Pnt_18_0939      = $3B6F91;  $FF3B6F91  "#916F3B"  "rgb(145,111, 59)"  "rgba(145,111, 59,255)"  "18-0939TPX_Cumin"
#Pnt_18_0940      = $2C6791;  $FF2C6791  "#91672C"  "rgb(145,103, 44)"  "rgba(145,103, 44,255)"  "18-0940TPX_GoldenBrown"
#Pnt_18_0950      = $34679A;  $FF34679A  "#9A6734"  "rgb(154,103, 52)"  "rgba(154,103, 52,255)"  "18-0950TPX_CathaySpice"
#Pnt_18_1015      = $516171;  $FF516171  "#716151"  "rgb(113, 97, 81)"  "rgba(113, 97, 81,255)"  "18-1015TPX_Shitake"
#Pnt_18_1016      = $485A68;  $FF485A68  "#685A48"  "rgb(104, 90, 72)"  "rgba(104, 90, 72,255)"  "18-1016TPX_Cub"
#Pnt_18_1017      = $637391;  $FF637391  "#917363"  "rgb(145,115, 99)"  "rgba(145,115, 99,255)"  "18-1017TPX_Caribou"
#Pnt_18_1018      = $4C657C;  $FF4C657C  "#7C654C"  "rgb(124,101, 76)"  "rgba(124,101, 76,255)"  "18-1018TPX_Otter"
#Pnt_18_1022      = $47677F;  $FF47677F  "#7F6747"  "rgb(127,103, 71)"  "rgba(127,103, 71,255)"  "18-1022TPX_Ermine"
#Pnt_18_1027      = $3B4D66;  $FF3B4D66  "#664D3B"  "rgb(102, 77, 59)"  "rgba(102, 77, 59,255)"  "18-1027TPX_Bison"
#Pnt_18_1029      = $54759D;  $FF54759D  "#9D7554"  "rgb(157,117, 84)"  "rgba(157,117, 84,255)"  "18-1029TPX_ToastedCoconut"
#Pnt_18_1030      = $536B91;  $FF536B91  "#916B53"  "rgb(145,107, 83)"  "rgba(145,107, 83,255)"  "18-1030TPX_Thrush"
#Pnt_18_1031      = $385171;  $FF385171  "#715138"  "rgb(113, 81, 56)"  "rgba(113, 81, 56,255)"  "18-1031TPX_Toffee"
#Pnt_18_1033      = $3C5676;  $FF3C5676  "#76563C"  "rgb(118, 86, 60)"  "rgba(118, 86, 60,255)"  "18-1033TPX_Dachshund"
#Pnt_18_1048      = $304C71;  $FF304C71  "#714C30"  "rgb(113, 76, 48)"  "rgba(113, 76, 48,255)"  "18-1048TPX_Monk'SRobe"
#Pnt_18_1108      = $707795;  $FF707795  "#957770"  "rgb(149,119,112)"  "rgba(149,119,112,255)"  "18-1108TPX_FallenRock"
#Pnt_18_1110      = $69767F;  $FF69767F  "#7F7669"  "rgb(127,118,105)"  "rgba(127,118,105,255)"  "18-1110TPX_Brindle"
#Pnt_18_1112      = $5C6A76;  $FF5C6A76  "#766A5C"  "rgb(118,106, 92)"  "rgba(118,106, 92,255)"  "18-1112TPX_Walnut"
#Pnt_18_1124      = $41526F;  $FF41526F  "#6F5241"  "rgb(111, 82, 65)"  "rgba(111, 82, 65,255)"  "18-1124TPX_Partridge"
#Pnt_18_1130      = $465476;  $FF465476  "#765446"  "rgb(118, 84, 70)"  "rgba(118, 84, 70,255)"  "18-1130TPX_Aztec"
#Pnt_18_1137      = $4B5E85;  $FF4B5E85  "#855E4B"  "rgb(133, 94, 75)"  "rgba(133, 94, 75,255)"  "18-1137TPX_Rawhide"
#Pnt_18_1140      = $3F558A;  $FF3F558A  "#8A553F"  "rgb(138, 85, 63)"  "rgba(138, 85, 63,255)"  "18-1140TPX_MochaBisque"
#Pnt_18_1142      = $355693;  $FF355693  "#935635"  "rgb(147, 86, 53)"  "rgba(147, 86, 53,255)"  "18-1142TPX_LeatherBrown"
#Pnt_18_1148      = $216497;  $FF216497  "#976421"  "rgb(151,100, 33)"  "rgba(151,100, 33,255)"  "18-1148TPX_CaramelCafé"
#Pnt_18_1154      = $315993;  $FF315993  "#935931"  "rgb(147, 89, 49)"  "rgba(147, 89, 49,255)"  "18-1154TPX_GlazedGinger"
#Pnt_18_1160      = $356DA9;  $FF356DA9  "#A96D35"  "rgb(169,109, 53)"  "rgba(169,109, 53,255)"  "18-1160TPX_SudanBrown"
#Pnt_18_1163      = $1679AE;  $FF1679AE  "#AE7916"  "rgb(174,121, 22)"  "rgba(174,121, 22,255)"  "18-1163TPX_PumpkinSpice"
#Pnt_18_1210      = $787B9A;  $FF787B9A  "#9A7B78"  "rgb(154,123,120)"  "rgba(154,123,120,255)"  "18-1210TPX_Driftwood"
#Pnt_18_1222      = $43506B;  $FF43506B  "#6B5043"  "rgb(107, 80, 67)"  "rgba(107, 80, 67,255)"  "18-1222TPX_CocoaBrown"
#Pnt_18_1229      = $4F5E86;  $FF4F5E86  "#865E4F"  "rgb(134, 94, 79)"  "rgba(134, 94, 79,255)"  "18-1229TPX_CarobBrown"
#Pnt_18_1230      = $394B83;  $FF394B83  "#834B39"  "rgb(131, 75, 57)"  "rgba(131, 75, 57,255)"  "18-1230TPX_CoconutShell"
#Pnt_18_1235      = $4F5D8D;  $FF4F5D8D  "#8D5D4F"  "rgb(141, 93, 79)"  "rgba(141, 93, 79,255)"  "18-1235TPX_Russet"
#Pnt_18_1238      = $455487;  $FF455487  "#875445"  "rgb(135, 84, 69)"  "rgba(135, 84, 69,255)"  "18-1238TPX_RusticBrown"
#Pnt_18_1239      = $455E9B;  $FF455E9B  "#9B5E45"  "rgb(155, 94, 69)"  "rgba(155, 94, 69,255)"  "18-1239TPX_Sierra"
#Pnt_18_1242      = $415488;  $FF415488  "#885441"  "rgb(136, 84, 65)"  "rgba(136, 84, 65,255)"  "18-1242TPX_BrownPatina"
#Pnt_18_1244      = $364E8A;  $FF364E8A  "#8A4E36"  "rgb(138, 78, 54)"  "rgba(138, 78, 54,255)"  "18-1244TPX_GingerBread"
#Pnt_18_1246      = $1669A7;  $FF1669A7  "#A76916"  "rgb(167,105, 22)"  "rgba(167,105, 22,255)"  "18-1246TPX_Umber"
#Pnt_18_1248      = $3A58B0;  $FF3A58B0  "#B0583A"  "rgb(176, 88, 58)"  "rgba(176, 88, 58,255)"  "18-1248TPX_Rust"
#Pnt_18_1249      = $0086CC;  $FF0086CC  "#CC8600"  "rgb(204,134,  0)"  "rgba(204,134,  0,255)"  "18-1249TPX_HawaiianSunset"
#Pnt_18_1250      = $35529F;  $FF35529F  "#9F5235"  "rgb(159, 82, 53)"  "rgba(159, 82, 53,255)"  "18-1250TPX_BombayBrown"
#Pnt_18_1304      = $606385;  $FF606385  "#856360"  "rgb(133, 99, 96)"  "rgba(133, 99, 96,255)"  "18-1304TPX_Falcon"
#Pnt_18_1306      = $5D606E;  $FF5D606E  "#6E605D"  "rgb(110, 96, 93)"  "rgba(110, 96, 93,255)"  "18-1306TPX_Iron"
#Pnt_18_1312      = $565C71;  $FF565C71  "#715C56"  "rgb(113, 92, 86)"  "rgba(113, 92, 86,255)"  "18-1312TPX_DeepTaupe"
#Pnt_18_1314      = $54607C;  $FF54607C  "#7C6054"  "rgb(124, 96, 84)"  "rgba(124, 96, 84,255)"  "18-1314TPX_Acorn"
#Pnt_18_1320      = $535E85;  $FF535E85  "#855E53"  "rgb(133, 94, 83)"  "rgba(133, 94, 83,255)"  "18-1320TPX_Clove"
#Pnt_18_1321      = $606F8D;  $FF606F8D  "#8D6F60"  "rgb(141,111, 96)"  "rgba(141,111, 96,255)"  "18-1321TPX_Brownie"
#Pnt_18_1326      = $535C7D;  $FF535C7D  "#7D5C53"  "rgb(125, 92, 83)"  "rgba(125, 92, 83,255)"  "18-1326TPX_Nutmeg"
#Pnt_18_1336      = $586398;  $FF586398  "#986358"  "rgb(152, 99, 88)"  "rgba(152, 99, 88,255)"  "18-1336TPX_CopperBrown"
#Pnt_18_1340      = $026DB1;  $FF026DB1  "#B16D02"  "rgb(177,109,  2)"  "rgba(177,109,  2,255)"  "18-1340TPX_Potter'SClay"
#Pnt_18_1343      = $49589C;  $FF49589C  "#9C5849"  "rgb(156, 88, 73)"  "rgba(156, 88, 73,255)"  "18-1343TPX_Auburn"
#Pnt_18_1345      = $136CAF;  $FF136CAF  "#AF6C13"  "rgb(175,108, 19)"  "rgba(175,108, 19,255)"  "18-1345TPX_CinnamonStick"
#Pnt_18_1346      = $4D58AD;  $FF4D58AD  "#AD584D"  "rgb(173, 88, 77)"  "rgba(173, 88, 77,255)"  "18-1346TPX_Bruschetta"
#Pnt_18_1350      = $424EA0;  $FF424EA0  "#A04E42"  "rgb(160, 78, 66)"  "rgba(160, 78, 66,255)"  "18-1350TPX_BurntBrick"
#Pnt_18_1354      = $3D4EB4;  $FF3D4EB4  "#B44E3D"  "rgb(180, 78, 61)"  "rgba(180, 78, 61,255)"  "18-1354TPX_BurntOchre"
#Pnt_18_1355      = $1F62D0;  $FF1F62D0  "#D0621F"  "rgb(208, 98, 31)"  "rgba(208, 98, 31,255)"  "18-1355TPX_RooibosTea"
#Pnt_18_1404      = $605A68;  $FF605A68  "#685A60"  "rgb(104, 90, 96)"  "rgba(104, 90, 96,255)"  "18-1404TPX_Sparrow"
#Pnt_18_1405      = $62586E;  $FF62586E  "#6E5862"  "rgb(110, 88, 98)"  "rgba(110, 88, 98,255)"  "18-1405TPX_Flint"
#Pnt_18_1409      = $59586B;  $FF59586B  "#6B5859"  "rgb(107, 88, 89)"  "rgba(107, 88, 89,255)"  "18-1409TPX_Peppercorn"
#Pnt_18_1411      = $5A4C6D;  $FF5A4C6D  "#6D4C5A"  "rgb(109, 76, 90)"  "rgba(109, 76, 90,255)"  "18-1411TPX_PlumWine"
#Pnt_18_1415      = $4F506F;  $FF4F506F  "#6F504F"  "rgb(111, 80, 79)"  "rgba(111, 80, 79,255)"  "18-1415TPX_Marron"
#Pnt_18_1418      = $5D5080;  $FF5D5080  "#80505D"  "rgb(128, 80, 93)"  "rgba(128, 80, 93,255)"  "18-1418TPX_CrushedBerry"
#Pnt_18_1420      = $554D7D;  $FF554D7D  "#7D4D55"  "rgb(125, 77, 85)"  "rgba(125, 77, 85,255)"  "18-1420TPX_WildGinger"
#Pnt_18_1421      = $596188;  $FF596188  "#886159"  "rgb(136, 97, 89)"  "rgba(136, 97, 89,255)"  "18-1421TPX_Cognac"
#Pnt_18_1425      = $474A81;  $FF474A81  "#814A47"  "rgb(129, 74, 71)"  "rgba(129, 74, 71,255)"  "18-1425TPX_Mahogany"
#Pnt_18_1426      = $514E86;  $FF514E86  "#864E51"  "rgb(134, 78, 81)"  "rgba(134, 78, 81,255)"  "18-1426TPX_AppleButter"
#Pnt_18_1433      = $4D5996;  $FF4D5996  "#96594D"  "rgb(150, 89, 77)"  "rgba(150, 89, 77,255)"  "18-1433TPX_Chutney"
#Pnt_18_1434      = $5158A0;  $FF5158A0  "#A05851"  "rgb(160, 88, 81)"  "rgba(160, 88, 81,255)"  "18-1434TPX_EtruscanRed"
#Pnt_18_1435      = $6769A2;  $FF6769A2  "#A26967"  "rgb(162,105,103)"  "rgba(162,105,103,255)"  "18-1435TPX_WitheredRose"
#Pnt_18_1436      = $6970B1;  $FF6970B1  "#B17069"  "rgb(177,112,105)"  "rgba(177,112,105,255)"  "18-1436TPX_LightMahogany"
#Pnt_18_1438      = $515295;  $FF515295  "#955251"  "rgb(149, 82, 81)"  "rgba(149, 82, 81,255)"  "18-1438TPX_Marsala"
#Pnt_18_1441      = $4757A0;  $FF4757A0  "#A05747"  "rgb(160, 87, 71)"  "rgba(160, 87, 71,255)"  "18-1441TPX_BakedClay"
#Pnt_18_1442      = $3D418F;  $FF3D418F  "#8F413D"  "rgb(143, 65, 61)"  "rgba(143, 65, 61,255)"  "18-1442TPX_RedOchre"
#Pnt_18_1443      = $525AA4;  $FF525AA4  "#A45A52"  "rgb(164, 90, 82)"  "rgba(164, 90, 82,255)"  "18-1443TPX_Redwood"
#Pnt_18_1444      = $44489D;  $FF44489D  "#9D4844"  "rgb(157, 72, 68)"  "rgba(157, 72, 68,255)"  "18-1444TPX_TandoriSpice"
#Pnt_18_1445      = $3448DB;  $FF3448DB  "#DB4834"  "rgb(219, 72, 52)"  "rgba(219, 72, 52,255)"  "18-1445TPX_SpicyOrange"
#Pnt_18_1447      = $485DC3;  $FF485DC3  "#C35D48"  "rgb(195, 93, 72)"  "rgba(195, 93, 72,255)"  "18-1447TPX_OrangeRust"
#Pnt_18_1448      = $4653BF;  $FF4653BF  "#BF5346"  "rgb(191, 83, 70)"  "rgba(191, 83, 70,255)"  "18-1448TPX_Chili"
#Pnt_18_1449      = $3A3D93;  $FF3A3D93  "#933D3A"  "rgb(147, 61, 58)"  "rgba(147, 61, 58,255)"  "18-1449TPX_Ketchup"
#Pnt_18_1450      = $465BBB;  $FF465BBB  "#BB5B46"  "rgb(187, 91, 70)"  "rgba(187, 91, 70,255)"  "18-1450TPX_MeccaOrange"
#Pnt_18_1451      = $4658B0;  $FF4658B0  "#B05846"  "rgb(176, 88, 70)"  "rgba(176, 88, 70,255)"  "18-1451TPX_AutumnGlaze"
#Pnt_18_1454      = $3845BD;  $FF3845BD  "#BD4538"  "rgb(189, 69, 56)"  "rgba(189, 69, 56,255)"  "18-1454TPX_RedClay"
#Pnt_18_1512      = $5D5880;  $FF5D5880  "#80585D"  "rgb(128, 88, 93)"  "rgba(128, 88, 93,255)"  "18-1512TPX_RoseBrown"
#Pnt_18_1531      = $43448C;  $FF43448C  "#8C4443"  "rgb(140, 68, 67)"  "rgba(140, 68, 67,255)"  "18-1531TPX_BarnRed"
#Pnt_18_1535      = $5060B8;  $FF5060B8  "#B86050"  "rgb(184, 96, 80)"  "rgba(184, 96, 80,255)"  "18-1535TPX_GingerSpice"
#Pnt_18_1536      = $4E55AC;  $FF4E55AC  "#AC554E"  "rgb(172, 85, 78)"  "rgba(172, 85, 78,255)"  "18-1536TPX_Tabasco"
#Pnt_18_1537      = $4156A4;  $FF4156A4  "#A45641"  "rgb(164, 86, 65)"  "rgba(164, 86, 65,255)"  "18-1537TPX_CopperCoin"
#Pnt_18_1540      = $414599;  $FF414599  "#994541"  "rgb(153, 69, 65)"  "rgba(153, 69, 65,255)"  "18-1540TPX_Cinnabar"
#Pnt_18_1547      = $2C3093;  $FF2C3093  "#93302C"  "rgb(147, 48, 44)"  "rgba(147, 48, 44,255)"  "18-1547TPX_BossaNova"
#Pnt_18_1550      = $3E3AB9;  $FF3E3AB9  "#B93A3E"  "rgb(185, 58, 62)"  "rgba(185, 58, 62,255)"  "18-1550TPX_AuroraRed"
#Pnt_18_1555      = $2829B8;  $FF2829B8  "#B82928"  "rgb(184, 41, 40)"  "rgba(184, 41, 40,255)"  "18-1555TPX_MoltenLava"
#Pnt_18_1561      = $2C39D5;  $FF2C39D5  "#D5392C"  "rgb(213, 57, 44)"  "rgba(213, 57, 44,255)"  "18-1561TPX_Orange.Com"
#Pnt_18_1564      = $007AED;  $FF007AED  "#ED7A00"  "rgb(237,122,  0)"  "rgba(237,122,  0,255)"  "18-1564TPX_Poinciana"
#Pnt_18_1612      = $605E7E;  $FF605E7E  "#7E5E60"  "rgb(126, 94, 96)"  "rgba(126, 94, 96,255)"  "18-1612TPX_RoseTaupe"
#Pnt_18_1613      = $5C4D82;  $FF5C4D82  "#824D5C"  "rgb(130, 77, 92)"  "rgba(130, 77, 92,255)"  "18-1613TPX_RenaissanceRose"
#Pnt_18_1614      = $5C4F7D;  $FF5C4F7D  "#7D4F5C"  "rgb(125, 79, 92)"  "rgba(125, 79, 92,255)"  "18-1614TPX_Nocturne"
#Pnt_18_1616      = $585086;  $FF585086  "#865058"  "rgb(134, 80, 88)"  "rgba(134, 80, 88,255)"  "18-1616TPX_RoanRouge"
#Pnt_18_1619      = $5B4B85;  $FF5B4B85  "#854B5B"  "rgb(133, 75, 91)"  "rgba(133, 75, 91,255)"  "18-1619TPX_Maroon"
#Pnt_18_1629      = $6463BA;  $FF6463BA  "#BA6364"  "rgb(186, 99,100)"  "rgba(186, 99,100,255)"  "18-1629TPX_FadedRose"
#Pnt_18_1630      = $5E5DAC;  $FF5E5DAC  "#AC5D5E"  "rgb(172, 93, 94)"  "rgba(172, 93, 94,255)"  "18-1630TPX_DustyCedar"
#Pnt_18_1631      = $584799;  $FF584799  "#994758"  "rgb(153, 71, 88)"  "rgba(153, 71, 88,255)"  "18-1631TPX_EarthRed"
#Pnt_18_1633      = $5D4EB0;  $FF5D4EB0  "#B04E5D"  "rgb(176, 78, 93)"  "rgba(176, 78, 93,255)"  "18-1633TPX_GarnetRose"
#Pnt_18_1634      = $6352AF;  $FF6352AF  "#AF5263"  "rgb(175, 82, 99)"  "rgba(175, 82, 99,255)"  "18-1634TPX_BaroqueRose"
#Pnt_18_1635      = $6858B5;  $FF6858B5  "#B55868"  "rgb(181, 88,104)"  "rgba(181, 88,104,255)"  "18-1635TPX_SlateRose"
#Pnt_18_1643      = $4B3EA5;  $FF4B3EA5  "#A53E4B"  "rgb(165, 62, 75)"  "rgba(165, 62, 75,255)"  "18-1643TPX_Cardinal"
#Pnt_18_1648      = $4942AF;  $FF4942AF  "#AF4249"  "rgb(175, 66, 73)"  "rgba(175, 66, 73,255)"  "18-1648TPX_BakedApple"
#Pnt_18_1649      = $615DDC;  $FF615DDC  "#DC5D61"  "rgb(220, 93, 97)"  "rgba(220, 93, 97,255)"  "18-1649TPX_DeepSeaCoral"
#Pnt_18_1651      = $524ADA;  $FF524ADA  "#DA4A52"  "rgb(218, 74, 82)"  "rgba(218, 74, 82,255)"  "18-1651TPX_Cayenne"
#Pnt_18_1652      = $4A38BF;  $FF4A38BF  "#BF384A"  "rgb(191, 56, 74)"  "rgba(191, 56, 74,255)"  "18-1652TPX_RococcoRed"
#Pnt_18_1655      = $3A2ABC;  $FF3A2ABC  "#BC2A3A"  "rgb(188, 42, 58)"  "rgba(188, 42, 58,255)"  "18-1655TPX_MarsRed"
#Pnt_18_1657      = $0858E3;  $FF0858E3  "#E35808"  "rgb(227, 88,  8)"  "rgba(227, 88,  8,255)"  "18-1657TPX_Salsa"
#Pnt_18_1658      = $372EA2;  $FF372EA2  "#A22E37"  "rgb(162, 46, 55)"  "rgba(162, 46, 55,255)"  "18-1658TPX_PompeianRed"
#Pnt_18_1660      = $3E2ACD;  $FF3E2ACD  "#CD2A3E"  "rgb(205, 42, 62)"  "rgba(205, 42, 62,255)"  "18-1660TPX_Tomato"
#Pnt_18_1661      = $4D37C3;  $FF4D37C3  "#C3374D"  "rgb(195, 55, 77)"  "rgba(195, 55, 77,255)"  "18-1661TPX_TomatoPuree"
#Pnt_18_1662      = $372BCE;  $FF372BCE  "#CE2B37"  "rgb(206, 43, 55)"  "rgba(206, 43, 55,255)"  "18-1662TPX_FlameScarlet"
#Pnt_18_1663      = $3922BE;  $FF3922BE  "#BE2239"  "rgb(190, 34, 57)"  "rgba(190, 34, 57,255)"  "18-1663TPX_ChineseRed"
#Pnt_18_1664      = $3126D1;  $FF3126D1  "#D12631"  "rgb(209, 38, 49)"  "rgba(209, 38, 49,255)"  "18-1664TPX_FieryRed"
#Pnt_18_1703      = $6D636A;  $FF6D636A  "#6A636D"  "rgb(106, 99,109)"  "rgba(106, 99,109,255)"  "18-1703TPX_Shark"
#Pnt_18_1706      = $67576A;  $FF67576A  "#6A5767"  "rgb(106, 87,103)"  "rgba(106, 87,103,255)"  "18-1706TPX_BlackPlum"
#Pnt_18_1709      = $6C5884;  $FF6C5884  "#84586C"  "rgb(132, 88,108)"  "rgba(132, 88,108,255)"  "18-1709TPX_Tulipwood"
#Pnt_18_1710      = $76618D;  $FF76618D  "#8D6176"  "rgb(141, 97,118)"  "rgba(141, 97,118,255)"  "18-1710TPX_GrapeNectar"
#Pnt_18_1716      = $644D7F;  $FF644D7F  "#7F4D64"  "rgb(127, 77,100)"  "rgba(127, 77,100,255)"  "18-1716TPX_Damson"
#Pnt_18_1718      = $614E86;  $FF614E86  "#864E61"  "rgb(134, 78, 97)"  "rgba(134, 78, 97,255)"  "18-1718TPX_HawthornRose"
#Pnt_18_1720      = $664A8B;  $FF664A8B  "#8B4A66"  "rgb(139, 74,102)"  "rgba(139, 74,102,255)"  "18-1720TPX_VioletQuartz"
#Pnt_18_1725      = $5F498F;  $FF5F498F  "#8F495F"  "rgb(143, 73, 95)"  "rgba(143, 73, 95,255)"  "18-1725TPX_DryRose"
#Pnt_18_1741      = $5731B6;  $FF5731B6  "#B63157"  "rgb(182, 49, 87)"  "rgba(182, 49, 87,255)"  "18-1741TPX_RaspberryWine"
#Pnt_18_1754      = $5C2DD7;  $FF5C2DD7  "#D72D5C"  "rgb(215, 45, 92)"  "rgba(215, 45, 92,255)"  "18-1754TPX_Raspberry"
#Pnt_18_1755      = $6541E4;  $FF6541E4  "#E44165"  "rgb(228, 65,101)"  "rgba(228, 65,101,255)"  "18-1755TPX_RougeRed"
#Pnt_18_1756      = $5933DC;  $FF5933DC  "#DC3359"  "rgb(220, 51, 89)"  "rgba(220, 51, 89,255)"  "18-1756TPX_Teaberry"
#Pnt_18_1760      = $4517B6;  $FF4517B6  "#B61745"  "rgb(182, 23, 69)"  "rgba(182, 23, 69,255)"  "18-1760TPX_Barberry"
#Pnt_18_1761      = $3F12B5;  $FF3F12B5  "#B5123F"  "rgb(181, 18, 63)"  "rgba(181, 18, 63,255)"  "18-1761TPX_SkiPatrol"
#Pnt_18_1762      = $4735D5;  $FF4735D5  "#D53547"  "rgb(213, 53, 71)"  "rgba(213, 53, 71,255)"  "18-1762TPX_Hibiscus"
#Pnt_18_1763      = $311DC8;  $FF311DC8  "#C81D31"  "rgb(200, 29, 49)"  "rgba(200, 29, 49,255)"  "18-1763TPX_HighRiskRed"
#Pnt_18_1764      = $4222C5;  $FF4222C5  "#C52242"  "rgb(197, 34, 66)"  "rgba(197, 34, 66,255)"  "18-1764TPX_Lollipop"
#Pnt_18_1807      = $736F89;  $FF736F89  "#896F73"  "rgb(137,111,115)"  "rgba(137,111,115,255)"  "18-1807TPX_TwilightMauve"
#Pnt_18_1852      = $561EC2;  $FF561EC2  "#C21E56"  "rgb(194, 30, 86)"  "rgba(194, 30, 86,255)"  "18-1852TPX_RoseRed"
#Pnt_18_1856      = $5415C5;  $FF5415C5  "#C51554"  "rgb(197, 21, 84)"  "rgba(197, 21, 84,255)"  "18-1856TPX_VirtualPink"
#Pnt_18_1945      = $5A18BE;  $FF5A18BE  "#BE185A"  "rgb(190, 24, 90)"  "rgba(190, 24, 90,255)"  "18-1945TPX_BrightRose"
#Pnt_18_1950      = $2961EE;  $FF2961EE  "#EE6129"  "rgb(238, 97, 41)"  "rgba(238, 97, 41,255)"  "18-1950TPX_Jazzy"
#Pnt_18_2027      = $4F2F81;  $FF4F2F81  "#812F4F"  "rgb(129, 47, 79)"  "rgba(129, 47, 79,255)"  "18-2027TPX_Beaujolais"
#Pnt_18_2043      = $713ACC;  $FF713ACC  "#CC3A71"  "rgb(204, 58,113)"  "rgba(204, 58,113,255)"  "18-2043TPX_RaspberrySorbet"
#Pnt_18_2109      = $766B8A;  $FF766B8A  "#8A6B76"  "rgb(138,107,118)"  "rgba(138,107,118,255)"  "18-2109TPX_GrapeShake"
#Pnt_18_2120      = $7650D6;  $FF7650D6  "#D65076"  "rgb(214, 80,118)"  "rgba(214, 80,118,255)"  "18-2120TPX_Honeysuckle"
#Pnt_18_2133      = $7C4ECD;  $FF7C4ECD  "#CD4E7C"  "rgb(205, 78,124)"  "rgba(205, 78,124,255)"  "18-2133TPX_PinkFlambé"
#Pnt_18_2140      = $4974FF;  $FF4974FF  "#FF7449"  "rgb(255,116, 73)"  "rgba(255,116, 73,255)"  "18-2140TPX_Cabaret"
#Pnt_18_2143      = $702FCB;  $FF702FCB  "#CB2F70"  "rgb(203, 47,112)"  "rgba(203, 47,112,255)"  "18-2143TPX_BeetrootPurple"
#Pnt_18_2320      = $773B92;  $FF773B92  "#923B77"  "rgb(146, 59,119)"  "rgba(146, 59,119,255)"  "18-2320TPX_Clover"
#Pnt_18_2326      = $763FAB;  $FF763FAB  "#AB3F76"  "rgb(171, 63,118)"  "rgba(171, 63,118,255)"  "18-2326TPX_CactusFlower"
#Pnt_18_2328      = $7F3AB3;  $FF7F3AB3  "#B33A7F"  "rgb(179, 58,127)"  "rgba(179, 58,127,255)"  "18-2328TPX_FuchsiaRed"
#Pnt_18_2333      = $8B45C7;  $FF8B45C7  "#C7458B"  "rgb(199, 69,139)"  "rgba(199, 69,139,255)"  "18-2333TPX_RaspberryRose"
#Pnt_18_2336      = $7B39BA;  $FF7B39BA  "#BA397B"  "rgb(186, 57,123)"  "rgba(186, 57,123,255)"  "18-2336TPX_VeryBerry"
#Pnt_18_2436      = $7B39CC;  $FF7B39CC  "#CC397B"  "rgb(204, 57,123)"  "rgba(204, 57,123,255)"  "18-2436TPX_FuchsiaPurple"
#Pnt_18_2525      = $76459F;  $FF76459F  "#9F4576"  "rgb(159, 69,118)"  "rgba(159, 69,118,255)"  "18-2525TPX_MagentaHaze"
#Pnt_18_2527      = $6D3299;  $FF6D3299  "#99326D"  "rgb(153, 50,109)"  "rgba(153, 50,109,255)"  "18-2527TPX_BatonRouge"
#Pnt_18_2929      = $75398F;  $FF75398F  "#8F3975"  "rgb(143, 57,117)"  "rgba(143, 57,117,255)"  "18-2929TPX_PurpleWine"
#Pnt_18_3011      = $765A83;  $FF765A83  "#835A76"  "rgb(131, 90,118)"  "rgba(131, 90,118,255)"  "18-3011TPX_ArgylePurple"
#Pnt_18_3012      = $73587A;  $FF73587A  "#7A5873"  "rgb(122, 88,115)"  "rgba(122, 88,115,255)"  "18-3012TPX_PurpleGumdrop"
#Pnt_18_3013      = $664B72;  $FF664B72  "#724B66"  "rgb(114, 75,102)"  "rgba(114, 75,102,255)"  "18-3013TPX_BerryConserve"
#Pnt_18_3015      = $774B82;  $FF774B82  "#824B77"  "rgb(130, 75,119)"  "rgba(130, 75,119,255)"  "18-3015TPX_Amethyst"
#Pnt_18_3022      = $7B4194;  $FF7B4194  "#94417B"  "rgb(148, 65,123)"  "rgba(148, 65,123,255)"  "18-3022TPX_DeepOrchid"
#Pnt_18_3025      = $8E5098;  $FF8E5098  "#98508E"  "rgb(152, 80,142)"  "rgba(152, 80,142,255)"  "18-3025TPX_StrikingPurple"
#Pnt_18_3027      = $934FAE;  $FF934FAE  "#AE4F93"  "rgb(174, 79,147)"  "rgba(174, 79,147,255)"  "18-3027TPX_PurpleOrchid"
#Pnt_18_3211      = $7F6783;  $FF7F6783  "#83677F"  "rgb(131,103,127)"  "rgba(131,103,127,255)"  "18-3211TPX_Grapeade"
#Pnt_18_3218      = $81557E;  $FF81557E  "#7E5581"  "rgb(126, 85,129)"  "rgba(126, 85,129,255)"  "18-3218TPX_ConcordGrape"
#Pnt_18_3220      = $896F8F;  $FF896F8F  "#8F6F89"  "rgb(143,111,137)"  "rgba(143,111,137,255)"  "18-3220TPX_VeryGrape"
#Pnt_18_3224      = $A363B1;  $FFA363B1  "#B163A3"  "rgb(177, 99,163)"  "rgba(177, 99,163,255)"  "18-3224TPX_RadiantOrchid"
#Pnt_18_3230      = $9057A5;  $FF9057A5  "#A55790"  "rgb(165, 87,144)"  "rgba(165, 87,144,255)"  "18-3230TPX_MeadowMauve"
#Pnt_18_3324      = $834486;  $FF834486  "#864483"  "rgb(134, 68,131)"  "rgba(134, 68,131,255)"  "18-3324TPX_Dahlia"
#Pnt_18_3331      = $914D93;  $FF914D93  "#934D91"  "rgb(147, 77,145)"  "rgba(147, 77,145,255)"  "18-3331TPX_HyacinthViolet"
#Pnt_18_3339      = $84429F;  $FF84429F  "#9F4284"  "rgb(159, 66,132)"  "rgba(159, 66,132,255)"  "18-3339TPX_VividViola"
#Pnt_18_3410      = $5C485B;  $FF5C485B  "#5B485C"  "rgb( 91, 72, 92)"  "rgba( 91, 72, 92,255)"  "18-3410TPX_VintageViolet"
#Pnt_18_3415      = $785C75;  $FF785C75  "#755C78"  "rgb(117, 92,120)"  "rgba(117, 92,120,255)"  "18-3415TPX_GrapeJam"
#Pnt_18_3418      = $886085;  $FF886085  "#856088"  "rgb(133, 96,136)"  "rgba(133, 96,136,255)"  "18-3418TPX_ChineseViolet"
#Pnt_18_3513      = $7A5B6E;  $FF7A5B6E  "#6E5B7A"  "rgb(110, 91,122)"  "rgba(110, 91,122,255)"  "18-3513TPX_GrapeCompote"
#Pnt_18_3518      = $7D506B;  $FF7D506B  "#6B507D"  "rgb(107, 80,125)"  "rgba(107, 80,125,255)"  "18-3518TPX_PatricianPurple"
#Pnt_18_3520      = $8C5675;  $FF8C5675  "#75568C"  "rgb(117, 86,140)"  "rgba(117, 86,140,255)"  "18-3520TPX_PurpleHeart"
#Pnt_18_3522      = $85567B;  $FF85567B  "#7B5685"  "rgb(123, 86,133)"  "rgba(123, 86,133,255)"  "18-3522TPX_CrushedGrape"
#Pnt_18_3531      = $904C75;  $FF904C75  "#754C90"  "rgb(117, 76,144)"  "rgba(117, 76,144,255)"  "18-3531TPX_RoyalLilac"
#Pnt_18_3533      = $9B558B;  $FF9B558B  "#8B559B"  "rgb(139, 85,155)"  "rgba(139, 85,155,255)"  "18-3533TPX_Dewberry"
#Pnt_18_3615      = $774559;  $FF774559  "#594577"  "rgb( 89, 69,119)"  "rgba( 89, 69,119,255)"  "18-3615TPX_ImperialPalace"
#Pnt_18_3620      = $624D83;  $FF624D83  "#834D62"  "rgb(131, 77, 98)"  "rgba(131, 77, 98,255)"  "18-3620TPX_Mystical"
#Pnt_18_3628      = $8575AD;  $FF8575AD  "#AD7585"  "rgb(173,117,133)"  "rgba(173,117,133,255)"  "18-3628TPX_Bellflower"
#Pnt_18_3633      = $9A5277;  $FF9A5277  "#77529A"  "rgb(119, 82,154)"  "rgba(119, 82,154,255)"  "18-3633TPX_DeepLavender"
#Pnt_18_3635      = $614D82;  $FF614D82  "#824D61"  "rgb(130, 77, 97)"  "rgba(130, 77, 97,255)"  "18-3635TPX_PicassoLily"
#Pnt_18_3710      = $82727B;  $FF82727B  "#7B7282"  "rgb(123,114,130)"  "rgba(123,114,130,255)"  "18-3710TPX_GrayRidge"
#Pnt_18_3712      = $7D6972;  $FF7D6972  "#72697D"  "rgb(114,105,125)"  "rgba(114,105,125,255)"  "18-3712TPX_PurpleSage"
#Pnt_18_3714      = $6D515C;  $FF6D515C  "#5C516D"  "rgb( 92, 81,109)"  "rgba( 92, 81,109,255)"  "18-3714TPX_MulledGrape"
#Pnt_18_3715      = $745D6B;  $FF745D6B  "#6B5D74"  "rgb(107, 93,116)"  "rgba(107, 93,116,255)"  "18-3715TPX_MontanaGrape"
#Pnt_18_3718      = $98707D;  $FF98707D  "#7D7098"  "rgb(125,112,152)"  "rgba(125,112,152,255)"  "18-3718TPX_PurpleHaze"
#Pnt_18_3737      = $9A576D;  $FF9A576D  "#6D579A"  "rgb(109, 87,154)"  "rgba(109, 87,154,255)"  "18-3737TPX_PassionFlower"
#Pnt_18_3812      = $7A6268;  $FF7A6268  "#68627A"  "rgb(104, 98,122)"  "rgba(104, 98,122,255)"  "18-3812TPX_Cadet"
#Pnt_18_3817      = $836564;  $FF836564  "#646583"  "rgb(100,101,131)"  "rgba(100,101,131,255)"  "18-3817TPX_Heron"
#Pnt_18_3820      = $8E6565;  $FF8E6565  "#65658E"  "rgb(101,101,142)"  "rgba(101,101,142,255)"  "18-3820TPX_TwilightPurple"
#Pnt_18_3828      = $986365;  $FF986365  "#656398"  "rgb(101, 99,152)"  "rgba(101, 99,152,255)"  "18-3828TPX_CorsicanBlue"
#Pnt_18_3833      = $9E6563;  $FF9E6563  "#63659E"  "rgb( 99,101,158)"  "rgba( 99,101,158,255)"  "18-3833TPX_DustedPeri"
#Pnt_18_3834      = $996A70;  $FF996A70  "#706A99"  "rgb(112,106,153)"  "rgba(112,106,153,255)"  "18-3834TPX_Veronica"
#Pnt_18_3838      = $945364;  $FF945364  "#645394"  "rgb(100, 83,148)"  "rgba(100, 83,148,255)"  "18-3838TPX_UltraViolet"
#Pnt_18_3840      = $A25964;  $FFA25964  "#6459A2"  "rgb(100, 89,162)"  "rgba(100, 89,162,255)"  "18-3840TPX_PurpleOpulence"
#Pnt_18_3905      = $655D61;  $FF655D61  "#615D65"  "rgb( 97, 93,101)"  "rgba( 97, 93,101,255)"  "18-3905TPX_Excalibur"
#Pnt_18_3907      = $605877;  $FF605877  "#775860"  "rgb(119, 88, 96)"  "rgba(119, 88, 96,255)"  "18-3907TPX_Tornado"
#Pnt_18_3910      = $76645C;  $FF76645C  "#5C6476"  "rgb( 92,100,118)"  "rgba( 92,100,118,255)"  "18-3910TPX_FolkstoneGray"
#Pnt_18_3912      = $6B5873;  $FF6B5873  "#73586B"  "rgb(115, 88,107)"  "rgba(115, 88,107,255)"  "18-3912TPX_Grisaille"
#Pnt_18_3916      = $837264;  $FF837264  "#647283"  "rgb(100,114,131)"  "rgba(100,114,131,255)"  "18-3916TPX_FlintStone"
#Pnt_18_3918      = $7A6753;  $FF7A6753  "#53677A"  "rgb( 83,103,122)"  "rgba( 83,103,122,255)"  "18-3918TPX_ChinaBlue"
#Pnt_18_3920      = $835D4D;  $FF835D4D  "#4D5D83"  "rgb( 77, 93,131)"  "rgba( 77, 93,131,255)"  "18-3920TPX_CoastalFjord"
#Pnt_18_3921      = $7E5941;  $FF7E5941  "#41597E"  "rgb( 65, 89,126)"  "rgba( 65, 89,126,255)"  "18-3921TPX_BijouBlue"
#Pnt_18_3922      = $8F7153;  $FF8F7153  "#53718F"  "rgb( 83,113,143)"  "rgba( 83,113,143,255)"  "18-3922TPX_CoronetBlue"
#Pnt_18_3927      = $8F695F;  $FF8F695F  "#5F698F"  "rgb( 95,105,143)"  "rgba( 95,105,143,255)"  "18-3927TPX_VelvetMorning"
#Pnt_18_3928      = $916449;  $FF916449  "#496491"  "rgb( 73,100,145)"  "rgba( 73,100,145,255)"  "18-3928TPX_DutchBlue"
#Pnt_18_3930      = $A17468;  $FFA17468  "#6874A1"  "rgb(104,116,161)"  "rgba(104,116,161,255)"  "18-3930TPX_BleachedDenim"
#Pnt_18_3932      = $845C50;  $FF845C50  "#505C84"  "rgb( 80, 92,132)"  "rgba( 80, 92,132,255)"  "18-3932TPX_Marlin"
#Pnt_18_3933      = $836D8B;  $FF836D8B  "#8B6D83"  "rgb(139,109,131)"  "rgba(139,109,131,255)"  "18-3933TPX_BlueGranite"
#Pnt_18_3935      = $B87B65;  $FFB87B65  "#657BB8"  "rgb(101,123,184)"  "rgba(101,123,184,255)"  "18-3935TPX_Wedgewood"
#Pnt_18_3937      = $A77250;  $FFA77250  "#5072A7"  "rgb( 80,114,167)"  "rgba( 80,114,167,255)"  "18-3937TPX_BlueYonder"
#Pnt_18_3943      = $A65E5B;  $FFA65E5B  "#5B5EA6"  "rgb( 91, 94,166)"  "rgba( 91, 94,166,255)"  "18-3943TPX_BlueIris"
#Pnt_18_3944      = $A26058;  $FFA26058  "#5860A2"  "rgb( 88, 96,162)"  "rgba( 88, 96,162,255)"  "18-3944TPX_VioletStorm"
#Pnt_18_3945      = $AD5F46;  $FFAD5F46  "#465FAD"  "rgb( 70, 95,173)"  "rgba( 70, 95,173,255)"  "18-3945TPX_AmparoBlue"
#Pnt_18_3946      = $B06552;  $FFB06552  "#5265B0"  "rgb( 82,101,176)"  "rgba( 82,101,176,255)"  "18-3946TPX_BajaBlue"
#Pnt_18_3949      = $A74D2E;  $FFA74D2E  "#2E4DA7"  "rgb( 46, 77,167)"  "rgba( 46, 77,167,255)"  "18-3949TPX_DazzlingBlue"
#Pnt_18_3963      = $81403E;  $FF81403E  "#3E4081"  "rgb( 62, 64,129)"  "rgba( 62, 64,129,255)"  "18-3963TPX_SpectrumBlue"
#Pnt_18_4005      = $706C6A;  $FF706C6A  "#6A6C70"  "rgb(106,108,112)"  "rgba(106,108,112,255)"  "18-4005TPX_SteelGray"
#Pnt_18_4006      = $6D637F;  $FF6D637F  "#7F636D"  "rgb(127, 99,109)"  "rgba(127, 99,109,255)"  "18-4006TPX_QuietShade"
#Pnt_18_4011      = $746F5B;  $FF746F5B  "#5B6F74"  "rgb( 91,111,116)"  "rgba( 91,111,116,255)"  "18-4011TPX_GoblinBlue"
#Pnt_18_4016      = $76708E;  $FF76708E  "#8E7076"  "rgb(142,112,118)"  "rgba(142,112,118,255)"  "18-4016TPX_DecemberSky"
#Pnt_18_4018      = $745E40;  $FF745E40  "#405E74"  "rgb( 64, 94,116)"  "rgba( 64, 94,116,255)"  "18-4018TPX_RealTeal"
#Pnt_18_4020      = $8F7354;  $FF8F7354  "#54738F"  "rgb( 84,115,143)"  "rgba( 84,115,143,255)"  "18-4020TPX_Captain'SBlue"
#Pnt_18_4023      = $7A603A;  $FF7A603A  "#3A607A"  "rgb( 58, 96,122)"  "rgba( 58, 96,122,255)"  "18-4023TPX_BlueAshes"
#Pnt_18_4025      = $866E51;  $FF866E51  "#516E86"  "rgb( 81,110,134)"  "rgba( 81,110,134,255)"  "18-4025TPX_CopenBlue"
#Pnt_18_4026      = $7A5E39;  $FF7A5E39  "#395E7A"  "rgb( 57, 94,122)"  "rgba( 57, 94,122,255)"  "18-4026TPX_Stellar"
#Pnt_18_4027      = $88694F;  $FF88694F  "#4F6988"  "rgb( 79,105,136)"  "rgba( 79,105,136,255)"  "18-4027TPX_MoonlightBlue"
#Pnt_18_4028      = $685265;  $FF685265  "#655268"  "rgb(101, 82,104)"  "rgba(101, 82,104,255)"  "18-4028TPX_BeringSea"
#Pnt_18_4029      = $8A5D37;  $FF8A5D37  "#375D8A"  "rgb( 55, 93,138)"  "rgba( 55, 93,138,255)"  "18-4029TPX_FederalBlue"
#Pnt_18_4032      = $90672A;  $FF90672A  "#2A6790"  "rgb( 42,103,144)"  "rgba( 42,103,144,255)"  "18-4032TPX_DeepWater"
#Pnt_18_4034      = $835345;  $FF835345  "#455383"  "rgb( 69, 83,131)"  "rgba( 69, 83,131,255)"  "18-4034TPX_VallartaBlue"
#Pnt_18_4036      = $AD814E;  $FFAD814E  "#4E81AD"  "rgb( 78,129,173)"  "rgba( 78,129,173,255)"  "18-4036TPX_ParisianBlue"
#Pnt_18_4039      = $BC7C4D;  $FFBC7C4D  "#4D7CBC"  "rgb( 77,124,188)"  "rgba( 77,124,188,255)"  "18-4039TPX_Regatta"
#Pnt_18_4041      = $996438;  $FF996438  "#386499"  "rgb( 56,100,153)"  "rgba( 56,100,153,255)"  "18-4041TPX_StarSapphire"
#Pnt_18_4043      = $AD6732;  $FFAD6732  "#3267AD"  "rgb( 50,103,173)"  "rgba( 50,103,173,255)"  "18-4043TPX_PalaceBlue"
#Pnt_18_4045      = $9F6316;  $FF9F6316  "#16639F"  "rgb( 22, 99,159)"  "rgba( 22, 99,159,255)"  "18-4045TPX_Daphne"
#Pnt_18_4051      = $A76027;  $FFA76027  "#2760A7"  "rgb( 39, 96,167)"  "rgba( 39, 96,167,255)"  "18-4051TPX_StrongBlue"
#Pnt_18_4105      = $797E7B;  $FF797E7B  "#7B7E79"  "rgb(123,126,121)"  "rgba(123,126,121,255)"  "18-4105TPX_MoonMist"
#Pnt_18_4140      = $B97812;  $FFB97812  "#1278B9"  "rgb( 18,120,185)"  "rgba( 18,120,185,255)"  "18-4140TPX_FrenchBlue"
#Pnt_18_4141      = $B17331;  $FFB17331  "#3173B1"  "rgb( 49,115,177)"  "rgba( 49,115,177,255)"  "18-4141TPX_Campanula"
#Pnt_18_4148      = $A45D15;  $FFA45D15  "#155DA4"  "rgb( 21, 93,164)"  "rgba( 21, 93,164,255)"  "18-4148TPX_VictoriaBlue"
#Pnt_18_4214      = $6E5A7B;  $FF6E5A7B  "#7B5A6E"  "rgb(123, 90,110)"  "rgba(123, 90,110,255)"  "18-4214TPX_StormyWeather"
#Pnt_18_4215      = $7D6E58;  $FF7D6E58  "#586E7D"  "rgb( 88,110,125)"  "rgba( 88,110,125,255)"  "18-4215TPX_BlueMirage"
#Pnt_18_4217      = $837152;  $FF837152  "#527183"  "rgb( 82,113,131)"  "rgba( 82,113,131,255)"  "18-4217TPX_Bluestone"
#Pnt_18_4220      = $937D5A;  $FF937D5A  "#5A7D93"  "rgb( 90,125,147)"  "rgba( 90,125,147,255)"  "18-4220TPX_ProvincialBlue"
#Pnt_18_4222      = $80673A;  $FF80673A  "#3A6780"  "rgb( 58,103,128)"  "rgba( 58,103,128,255)"  "18-4222TPX_Bluesteel"
#Pnt_18_4225      = $7F672D;  $FF7F672D  "#2D677F"  "rgb( 45,103,127)"  "rgba( 45,103,127,255)"  "18-4225TPX_SaxonyBlue"
#Pnt_18_4231      = $806112;  $FF806112  "#126180"  "rgb( 18, 97,128)"  "rgba( 18, 97,128,255)"  "18-4231TPX_BlueSapphire"
#Pnt_18_4232      = $8F6C24;  $FF8F6C24  "#246C8F"  "rgb( 36,108,143)"  "rgba( 36,108,143,255)"  "18-4232TPX_Faience"
#Pnt_18_4244      = $AD6700;  $FFAD6700  "#0067AD"  "rgb(  0,103,173)"  "rgba(  0,103,173,255)"  "18-4244TPX_DirectoireBlue"
#Pnt_18_4247      = $BE7800;  $FFBE7800  "#0078BE"  "rgb(  0,120,190)"  "rgba(  0,120,190,255)"  "18-4247TPX_BrilliantBlue"
#Pnt_18_4252      = $BD7B00;  $FFBD7B00  "#007BBD"  "rgb(  0,123,189)"  "rgba(  0,123,189,255)"  "18-4252TPX_BlueAster"
#Pnt_18_4320      = $85734E;  $FF85734E  "#4E7385"  "rgb( 78,115,133)"  "rgba( 78,115,133,255)"  "18-4320TPX_AegeanBlue"
#Pnt_18_4330      = $B48200;  $FFB48200  "#0082B4"  "rgb(  0,130,180)"  "rgba(  0,130,180,255)"  "18-4330TPX_SwedishBlue"
#Pnt_18_4334      = $A87B1A;  $FFA87B1A  "#1A7BA8"  "rgb( 26,123,168)"  "rgba( 26,123,168,255)"  "18-4334TPX_MediterranianBlue"
#Pnt_18_4417      = $72643D;  $FF72643D  "#3D6472"  "rgb( 61,100,114)"  "rgba( 61,100,114,255)"  "18-4417TPX_Tapestry"
#Pnt_18_4432      = $8C6A00;  $FF8C6A00  "#006A8C"  "rgb(  0,106,140)"  "rgba(  0,106,140,255)"  "18-4432TPX_TurkishTile"
#Pnt_18_4434      = $7B3E0B;  $FF7B3E0B  "#0B3E7B"  "rgb( 11, 62,123)"  "rgba( 11, 62,123,255)"  "18-4434TPX_MykonosBlue"
#Pnt_18_4440      = $BC8100;  $FFBC8100  "#0081BC"  "rgb(  0,129,188)"  "rgba(  0,129,188,255)"  "18-4440TPX_Cloisonné"
#Pnt_18_4510      = $7C7965;  $FF7C7965  "#65797C"  "rgb(101,121,124)"  "rgba(101,121,124,255)"  "18-4510TPX_Trooper"
#Pnt_18_4522      = $736629;  $FF736629  "#296673"  "rgb( 41,102,115)"  "rgba( 41,102,115,255)"  "18-4522TPX_ColonialBlue"
#Pnt_18_4525      = $A28400;  $FFA28400  "#0084A2"  "rgb(  0,132,162)"  "rgba(  0,132,162,255)"  "18-4525TPX_CaribbeanSea"
#Pnt_18_4528      = $917500;  $FF917500  "#007591"  "rgb(  0,117,145)"  "rgba(  0,117,145,255)"  "18-4528TPX_MosaicBlue"
#Pnt_18_4530      = $8B6B06;  $FF8B6B06  "#066B8B"  "rgb(  6,107,139)"  "rgba(  6,107,139,255)"  "18-4530TPX_Celestial"
#Pnt_18_4535      = $B58200;  $FFB58200  "#0082B5"  "rgb(  0,130,181)"  "rgba(  0,130,181,255)"  "18-4535TPX_BlueJewel"
#Pnt_18_4537      = $AF7C00;  $FFAF7C00  "#007CAF"  "rgb(  0,124,175)"  "rgba(  0,124,175,255)"  "18-4537TPX_MethylBlue"
#Pnt_18_4612      = $717050;  $FF717050  "#507071"  "rgb( 80,112,113)"  "rgba( 80,112,113,255)"  "18-4612TPX_NorthAtlantic"
#Pnt_18_4711      = $81816D;  $FF81816D  "#6D8181"  "rgb(109,129,129)"  "rgba(109,129,129,255)"  "18-4711TPX_StormySea"
#Pnt_18_4718      = $73683E;  $FF73683E  "#3E6873"  "rgb( 62,104,115)"  "rgba( 62,104,115,255)"  "18-4718TPX_Hydro"
#Pnt_18_4726      = $847700;  $FF847700  "#007784"  "rgb(  0,119,132)"  "rgba(  0,119,132,255)"  "18-4726TPX_BiscayBay"
#Pnt_18_4728      = $7A6F00;  $FF7A6F00  "#006F7A"  "rgb(  0,111,122)"  "rgba(  0,111,122,255)"  "18-4728TPX_HarborBlue"
#Pnt_18_4733      = $927D00;  $FF927D00  "#007D92"  "rgb(  0,125,146)"  "rgba(  0,125,146,255)"  "18-4733TPX_EnamelBlue"
#Pnt_18_4735      = $988D00;  $FF988D00  "#008D98"  "rgb(  0,141,152)"  "rgba(  0,141,152,255)"  "18-4735TPX_TileBlue"
#Pnt_18_4834      = $6B6400;  $FF6B6400  "#00646B"  "rgb(  0,100,107)"  "rgba(  0,100,107,255)"  "18-4834TPX_DeepLake"
#Pnt_18_4930      = $878B00;  $FF878B00  "#008B87"  "rgb(  0,139,135)"  "rgba(  0,139,135,255)"  "18-4930TPX_TropicalGreen"
#Pnt_18_4936      = $737100;  $FF737100  "#007173"  "rgb(  0,113,115)"  "rgba(  0,113,115,255)"  "18-4936TPX_Fanfare"
#Pnt_18_5020      = $6C7300;  $FF6C7300  "#00736C"  "rgb(  0,115,108)"  "rgba(  0,115,108,255)"  "18-5020TPX_Parasailing"
#Pnt_18_5102      = $726E8B;  $FF726E8B  "#8B6E72"  "rgb(139,110,114)"  "rgba(139,110,114,255)"  "18-5102TPX_BrushedNickel"
#Pnt_18_5105      = $6D6D65;  $FF6D6D65  "#656D6D"  "rgb(101,109,109)"  "rgba(101,109,109,255)"  "18-5105TPX_SedonaSage"
#Pnt_18_5112      = $6C6B4A;  $FF6C6B4A  "#4A6B6C"  "rgb( 74,107,108)"  "rgba( 74,107,108,255)"  "18-5112TPX_SeaPine"
#Pnt_18_5115      = $6E6E3B;  $FF6E6E3B  "#3B6E6E"  "rgb( 59,110,110)"  "rgba( 59,110,110,255)"  "18-5115TPX_NorthSea"
#Pnt_18_5121      = $737427;  $FF737427  "#277473"  "rgb( 39,116,115)"  "rgba( 39,116,115,255)"  "18-5121TPX_Bayou"
#Pnt_18_5128      = $7E8100;  $FF7E8100  "#00817E"  "rgb(  0,129,126)"  "rgba(  0,129,126,255)"  "18-5128TPX_BlueGrass"
#Pnt_18_5203      = $636260;  $FF636260  "#606263"  "rgb( 96, 98, 99)"  "rgba( 96, 98, 99,255)"  "18-5203TPX_Pewter"
#Pnt_18_5210      = $555477;  $FF555477  "#775455"  "rgb(119, 84, 85)"  "rgba(119, 84, 85,255)"  "18-5210TPX_EiffelTower"
#Pnt_18_5308      = $696E48;  $FF696E48  "#486E69"  "rgb( 72,110,105)"  "rgba( 72,110,105,255)"  "18-5308TPX_BlueSpruce"
#Pnt_18_5315      = $595C26;  $FF595C26  "#265C59"  "rgb( 38, 92, 89)"  "rgba( 38, 92, 89,255)"  "18-5315TPX_Bayberry"
#Pnt_18_5322      = $575F00;  $FF575F00  "#005F57"  "rgb(  0, 95, 87)"  "rgba(  0, 95, 87,255)"  "18-5322TPX_AlpineGreen"
#Pnt_18_5338      = $577200;  $FF577200  "#007257"  "rgb(  0,114, 87)"  "rgba(  0,114, 87,255)"  "18-5338TPX_UltramarineGreen"
#Pnt_18_5410      = $676B4F;  $FF676B4F  "#4F6B67"  "rgb( 79,107,103)"  "rgba( 79,107,103,255)"  "18-5410TPX_SilverPine"
#Pnt_18_5418      = $63692B;  $FF63692B  "#2B6963"  "rgb( 43,105, 99)"  "rgba( 43,105, 99,255)"  "18-5418TPX_AntiqueGreen"
#Pnt_18_5424      = $637100;  $FF637100  "#007163"  "rgb(  0,113, 99)"  "rgba(  0,113, 99,255)"  "18-5424TPX_CadmiumGreen"
#Pnt_18_5606      = $666455;  $FF666455  "#556466"  "rgb( 85,100,102)"  "rgba( 85,100,102,255)"  "18-5606TPX_BalsamGreen"
#Pnt_18_5610      = $87804C;  $FF87804C  "#4C8087"  "rgb( 76,128,135)"  "rgba( 76,128,135,255)"  "18-5610TPX_BrittanyBlue"
#Pnt_18_5611      = $5E6553;  $FF5E6553  "#53655E"  "rgb( 83,101, 94)"  "rgba( 83,101, 94,255)"  "18-5611TPX_DarkForest"
#Pnt_18_5612      = $707451;  $FF707451  "#517470"  "rgb( 81,116,112)"  "rgba( 81,116,112,255)"  "18-5612TPX_SagebrushGreen"
#Pnt_18_5616      = $545D31;  $FF545D31  "#315D54"  "rgb( 49, 93, 84)"  "rgba( 49, 93, 84,255)"  "18-5616TPX_PosyGreen"
#Pnt_18_5618      = $707438;  $FF707438  "#387470"  "rgb( 56,116,112)"  "rgba( 56,116,112,255)"  "18-5618TPX_DeepJungle"
#Pnt_18_5619      = $646B00;  $FF646B00  "#006B64"  "rgb(  0,107,100)"  "rgba(  0,107,100,255)"  "18-5619TPX_Tidepool"
#Pnt_18_5620      = $6B7323;  $FF6B7323  "#23736B"  "rgb( 35,115,107)"  "rgba( 35,115,107,255)"  "18-5620TPX_Ivy"
#Pnt_18_5621      = $627239;  $FF627239  "#397262"  "rgb( 57,114, 98)"  "rgba( 57,114, 98,255)"  "18-5621TPX_Fir"
#Pnt_18_5622      = $6D8150;  $FF6D8150  "#50816D"  "rgb( 80,129,109)"  "rgba( 80,129,109,255)"  "18-5622TPX_FrostySpruce"
#Pnt_18_5624      = $607500;  $FF607500  "#007560"  "rgb(  0,117, 96)"  "rgba(  0,117, 96,255)"  "18-5624TPX_ShadyGlade"
#Pnt_18_5633      = $5E7E00;  $FF5E7E00  "#007E5E"  "rgb(  0,126, 94)"  "rgba(  0,126, 94,255)"  "18-5633TPX_Bosphorus"
#Pnt_18_5642      = $699000;  $FF699000  "#009069"  "rgb(  0,144,105)"  "rgba(  0,144,105,255)"  "18-5642TPX_GolfGreen"
#Pnt_18_5718      = $5B6542;  $FF5B6542  "#42655B"  "rgb( 66,101, 91)"  "rgba( 66,101, 91,255)"  "18-5718TPX_SmokePine"
#Pnt_18_5725      = $546017;  $FF546017  "#176054"  "rgb( 23, 96, 84)"  "rgba( 23, 96, 84,255)"  "18-5725TPX_GalapagosGreen"
#Pnt_18_5806      = $6B6D7C;  $FF6B6D7C  "#7C6D6B"  "rgb(124,109,107)"  "rgba(124,109,107,255)"  "18-5806TPX_AgaveGreen"
#Pnt_18_5841      = $638500;  $FF638500  "#008563"  "rgb(  0,133, 99)"  "rgba(  0,133, 99,255)"  "18-5841TPX_PepperGreen"
#Pnt_18_5913      = $454E33;  $FF454E33  "#334E45"  "rgb( 51, 78, 69)"  "rgba( 51, 78, 69,255)"  "18-5913TPX_GardenTopiary"
#Pnt_18_6011      = $5D6A51;  $FF5D6A51  "#516A5D"  "rgb( 81,106, 93)"  "rgba( 81,106, 93,255)"  "18-6011TPX_DuckGreen"
#Pnt_18_6018      = $5B713B;  $FF5B713B  "#3B715B"  "rgb( 59,113, 91)"  "rgba( 59,113, 91,255)"  "18-6018TPX_FoliageGreen"
#Pnt_18_6022      = $618935;  $FF618935  "#358961"  "rgb( 53,137, 97)"  "rgba( 53,137, 97,255)"  "18-6022TPX_Leprechaun"
#Pnt_18_6024      = $4B731C;  $FF4B731C  "#1C734B"  "rgb( 28,115, 75)"  "rgba( 28,115, 75,255)"  "18-6024TPX_Amazon"
#Pnt_18_6030      = $745C00;  $FF745C00  "#005C74"  "rgb(  0, 92,116)"  "rgba(  0, 92,116,255)"  "18-6030TPX_JollyGreen"
#Pnt_18_6114      = $5A6D4F;  $FF5A6D4F  "#4F6D5A"  "rgb( 79,109, 90)"  "rgba( 79,109, 90,255)"  "18-6114TPX_Myrtle"
#Pnt_18_6216      = $637B5A;  $FF637B5A  "#5A7B63"  "rgb( 90,123, 99)"  "rgba( 90,123, 99,255)"  "18-6216TPX_Comfrey"
#Pnt_18_6320      = $4D6F43;  $FF4D6F43  "#436F4D"  "rgb( 67,111, 77)"  "rgba( 67,111, 77,255)"  "18-6320TPX_Fairway"
#Pnt_18_6330      = $45703F;  $FF45703F  "#3F7045"  "rgb( 63,112, 69)"  "rgba( 63,112, 69,255)"  "18-6330TPX_Juniper"
#Pnt_19_0000      = $353635;  $FF353635  "#353635"  "rgb( 53, 54, 53)"  "rgba( 53, 54, 53,255)"  "19-0000TPX_Raven"
#Pnt_19_0201      = $46405C;  $FF46405C  "#5C4046"  "rgb( 92, 64, 70)"  "rgba( 92, 64, 70,255)"  "19-0201TPX_Asphalt"
#Pnt_19_0230      = $375C48;  $FF375C48  "#485C37"  "rgb( 72, 92, 55)"  "rgba( 72, 92, 55,255)"  "19-0230TPX_GardenGreen"
#Pnt_19_0303      = $333334;  $FF333334  "#343333"  "rgb( 52, 51, 51)"  "rgba( 52, 51, 51,255)"  "19-0303TPX_JetBlack"
#Pnt_19_0307      = $434558;  $FF434558  "#584543"  "rgb( 88, 69, 67)"  "rgba( 88, 69, 67,255)"  "19-0307TPX_ClimbingIvy"
#Pnt_19_0309      = $4E5A51;  $FF4E5A51  "#515A4E"  "rgb( 81, 90, 78)"  "rgba( 81, 90, 78,255)"  "19-0309TPX_Thyme"
#Pnt_19_0312      = $535F59;  $FF535F59  "#595F53"  "rgb( 89, 95, 83)"  "rgba( 89, 95, 83,255)"  "19-0312TPX_Beetle"
#Pnt_19_0315      = $415240;  $FF415240  "#405241"  "rgb( 64, 82, 65)"  "rgba( 64, 82, 65,255)"  "19-0315TPX_BlackForest"
#Pnt_19_0323      = $415950;  $FF415950  "#505941"  "rgb( 80, 89, 65)"  "rgba( 80, 89, 65,255)"  "19-0323TPX_Chive"
#Pnt_19_0405      = $3E4142;  $FF3E4142  "#42413E"  "rgb( 66, 65, 62)"  "rgba( 66, 65, 62,255)"  "19-0405TPX_Beluga"
#Pnt_19_0414      = $3B4542;  $FF3B4542  "#42453B"  "rgb( 66, 69, 59)"  "rgba( 66, 69, 59,255)"  "19-0414TPX_ForestNight"
#Pnt_19_0415      = $363F38;  $FF363F38  "#383F36"  "rgb( 56, 63, 54)"  "rgba( 56, 63, 54,255)"  "19-0415TPX_DuffelBag"
#Pnt_19_0417      = $304235;  $FF304235  "#354230"  "rgb( 53, 66, 48)"  "rgba( 53, 66, 48,255)"  "19-0417TPX_KombuGreen"
#Pnt_19_0419      = $384C44;  $FF384C44  "#444C38"  "rgb( 68, 76, 56)"  "rgba( 68, 76, 56,255)"  "19-0419TPX_RifleGreen"
#Pnt_19_0506      = $383E3C;  $FF383E3C  "#3C3E38"  "rgb( 60, 62, 56)"  "rgba( 60, 62, 56,255)"  "19-0506TPX_BlackInk"
#Pnt_19_0508      = $3E3F3E;  $FF3E3F3E  "#3E3F3E"  "rgb( 62, 63, 62)"  "rgba( 62, 63, 62,255)"  "19-0508TPX_Peat"
#Pnt_19_0509      = $313C36;  $FF313C36  "#363C31"  "rgb( 54, 60, 49)"  "rgba( 54, 60, 49,255)"  "19-0509TPX_Rosin"
#Pnt_19_0511      = $445251;  $FF445251  "#515244"  "rgb( 81, 82, 68)"  "rgba( 81, 82, 68,255)"  "19-0511TPX_GrapeLeaf"
#Pnt_19_0512      = $485758;  $FF485758  "#585748"  "rgb( 88, 87, 72)"  "rgba( 88, 87, 72,255)"  "19-0512TPX_IvyGreen"
#Pnt_19_0515      = $475456;  $FF475456  "#565447"  "rgb( 86, 84, 71)"  "rgba( 86, 84, 71,255)"  "19-0515TPX_OliveNight"
#Pnt_19_0516      = $3C525A;  $FF3C525A  "#5A523C"  "rgb( 90, 82, 60)"  "rgba( 90, 82, 60,255)"  "19-0516TPX_DarkOlive"
#Pnt_19_0608      = $383D41;  $FF383D41  "#413D38"  "rgb( 65, 61, 56)"  "rgba( 65, 61, 56,255)"  "19-0608TPX_BlackOlive"
#Pnt_19_0614      = $2E3841;  $FF2E3841  "#41382E"  "rgb( 65, 56, 46)"  "rgba( 65, 56, 46,255)"  "19-0614TPX_Wren"
#Pnt_19_0617      = $425461;  $FF425461  "#615442"  "rgb( 97, 84, 66)"  "rgba( 97, 84, 66,255)"  "19-0617TPX_Teak"
#Pnt_19_0618      = $324B54;  $FF324B54  "#544B32"  "rgb( 84, 75, 50)"  "rgba( 84, 75, 50,255)"  "19-0618TPX_Beech"
#Pnt_19_0622      = $405B64;  $FF405B64  "#645B40"  "rgb(100, 91, 64)"  "rgba(100, 91, 64,255)"  "19-0622TPX_MilitaryOlive"
#Pnt_19_0712      = $333942;  $FF333942  "#423933"  "rgb( 66, 57, 51)"  "rgba( 66, 57, 51,255)"  "19-0712TPX_Demitasse"
#Pnt_19_0808      = $595D7F;  $FF595D7F  "#7F5D59"  "rgb(127, 93, 89)"  "rgba(127, 93, 89,255)"  "19-0808TPX_Morel"
#Pnt_19_0809      = $4E5B67;  $FF4E5B67  "#675B4E"  "rgb(103, 91, 78)"  "rgba(103, 91, 78,255)"  "19-0809TPX_ChocolateChip"
#Pnt_19_0810      = $4A555B;  $FF4A555B  "#5B554A"  "rgb( 91, 85, 74)"  "rgba( 91, 85, 74,255)"  "19-0810TPX_MajorBrown"
#Pnt_19_0812      = $353940;  $FF353940  "#403935"  "rgb( 64, 57, 53)"  "rgba( 64, 57, 53,255)"  "19-0812TPX_TurkishCoffee"
#Pnt_19_0814      = $2F3A47;  $FF2F3A47  "#473A2F"  "rgb( 71, 58, 47)"  "rgba( 71, 58, 47,255)"  "19-0814TPX_SlateBlack"
#Pnt_19_0815      = $344657;  $FF344657  "#574634"  "rgb( 87, 70, 52)"  "rgba( 87, 70, 52,255)"  "19-0815TPX_DesertPalm"
#Pnt_19_0820      = $44525C;  $FF44525C  "#5C5244"  "rgb( 92, 82, 68)"  "rgba( 92, 82, 68,255)"  "19-0820TPX_Canteen"
#Pnt_19_0822      = $404D52;  $FF404D52  "#524D40"  "rgb( 82, 77, 64)"  "rgba( 82, 77, 64,255)"  "19-0822TPX_Tarmac"
#Pnt_19_0840      = $303555;  $FF303555  "#553530"  "rgb( 85, 53, 48)"  "rgba( 85, 53, 48,255)"  "19-0840TPX_Delicioso"
#Pnt_19_0910      = $37395C;  $FF37395C  "#5C3937"  "rgb( 92, 57, 55)"  "rgba( 92, 57, 55,255)"  "19-0910TPX_Mulch"
#Pnt_19_0912      = $313744;  $FF313744  "#443731"  "rgb( 68, 55, 49)"  "rgba( 68, 55, 49,255)"  "19-0912TPX_ChocolateBrown"
#Pnt_19_0915      = $30323C;  $FF30323C  "#3C3230"  "rgb( 60, 50, 48)"  "rgba( 60, 50, 48,255)"  "19-0915TPX_CoffeeBean"
#Pnt_19_0916      = $3F5172;  $FF3F5172  "#72513F"  "rgb(114, 81, 63)"  "rgba(114, 81, 63,255)"  "19-0916TPX_RainDrum"
#Pnt_19_1012      = $404459;  $FF404459  "#594440"  "rgb( 89, 68, 64)"  "rgba( 89, 68, 64,255)"  "19-1012TPX_FrenchRoast"
#Pnt_19_1015      = $3D424E;  $FF3D424E  "#4E423D"  "rgb( 78, 66, 61)"  "rgba( 78, 66, 61,255)"  "19-1015TPX_Bracken"
#Pnt_19_1016      = $323541;  $FF323541  "#413532"  "rgb( 65, 53, 50)"  "rgba( 65, 53, 50,255)"  "19-1016TPX_Java"
#Pnt_19_1018      = $292754;  $FF292754  "#542729"  "rgb( 84, 39, 41)"  "rgba( 84, 39, 41,255)"  "19-1018TPX_Ganache"
#Pnt_19_1020      = $334357;  $FF334357  "#574333"  "rgb( 87, 67, 51)"  "rgba( 87, 67, 51,255)"  "19-1020TPX_DarkEarth"
#Pnt_19_1034      = $3B5C75;  $FF3B5C75  "#755C3B"  "rgb(117, 92, 59)"  "rgba(117, 92, 59,255)"  "19-1034TPX_Breen"
#Pnt_19_1101      = $303035;  $FF303035  "#353030"  "rgb( 53, 48, 48)"  "rgba( 53, 48, 48,255)"  "19-1101TPX_AfterDark"
#Pnt_19_1102      = $323134;  $FF323134  "#343132"  "rgb( 52, 49, 50)"  "rgba( 52, 49, 50,255)"  "19-1102TPX_Licorice"
#Pnt_19_1103      = $302F4D;  $FF302F4D  "#4D2F30"  "rgb( 77, 47, 48)"  "rgba( 77, 47, 48,255)"  "19-1103TPX_Espresso"
#Pnt_19_1106      = $2B2D50;  $FF2B2D50  "#502D2B"  "rgb( 80, 45, 43)"  "rgba( 80, 45, 43,255)"  "19-1106TPX_Mole'"
#Pnt_19_1109      = $2D2E50;  $FF2D2E50  "#502E2D"  "rgb( 80, 46, 45)"  "rgba( 80, 46, 45,255)"  "19-1109TPX_ChocolateTorte"
#Pnt_19_1111      = $34343D;  $FF34343D  "#3D3434"  "rgb( 61, 52, 52)"  "rgba( 61, 52, 52,255)"  "19-1111TPX_BlackCoffee"
#Pnt_19_1116      = $354256;  $FF354256  "#564235"  "rgb( 86, 66, 53)"  "rgba( 86, 66, 53,255)"  "19-1116TPX_Carafe"
#Pnt_19_1118      = $3C4355;  $FF3C4355  "#55433C"  "rgb( 85, 67, 60)"  "rgba( 85, 67, 60,255)"  "19-1118TPX_Chestnut"
#Pnt_19_1121      = $3C475E;  $FF3C475E  "#5E473C"  "rgb( 94, 71, 60)"  "rgba( 94, 71, 60,255)"  "19-1121TPX_Pinecone"
#Pnt_19_1213      = $3B3F52;  $FF3B3F52  "#523F3B"  "rgb( 82, 63, 59)"  "rgba( 82, 63, 59,255)"  "19-1213TPX_ShoppingBag"
#Pnt_19_1217      = $424D69;  $FF424D69  "#694D42"  "rgb(105, 77, 66)"  "rgba(105, 77, 66,255)"  "19-1217TPX_Mustang"
#Pnt_19_1218      = $394258;  $FF394258  "#584239"  "rgb( 88, 66, 57)"  "rgba( 88, 66, 57,255)"  "19-1218TPX_PottingSoil"
#Pnt_19_1220      = $3C4465;  $FF3C4465  "#65443C"  "rgb(101, 68, 60)"  "rgba(101, 68, 60,255)"  "19-1220TPX_Cappuccino"
#Pnt_19_1228      = $464E73;  $FF464E73  "#734E46"  "rgb(115, 78, 70)"  "rgba(115, 78, 70,255)"  "19-1228TPX_RootBeer"
#Pnt_19_1230      = $3B496E;  $FF3B496E  "#6E493B"  "rgb(110, 73, 59)"  "rgba(110, 73, 59,255)"  "19-1230TPX_FriarBrown"
#Pnt_19_1235      = $3A4160;  $FF3A4160  "#60413A"  "rgb( 96, 65, 58)"  "rgba( 96, 65, 58,255)"  "19-1235TPX_Brunette"
#Pnt_19_1241      = $3A4B77;  $FF3A4B77  "#774B3A"  "rgb(119, 75, 58)"  "rgba(119, 75, 58,255)"  "19-1241TPX_TortoiseShell"
#Pnt_19_1245      = $3A4689;  $FF3A4689  "#89463A"  "rgb(137, 70, 58)"  "rgba(137, 70, 58,255)"  "19-1245TPX_ArabianSpice"
#Pnt_19_1250      = $2E3D8D;  $FF2E3D8D  "#8D3D2E"  "rgb(141, 61, 46)"  "rgba(141, 61, 46,255)"  "19-1250TPX_Picante"
#Pnt_19_1314      = $333441;  $FF333441  "#413433"  "rgb( 65, 52, 51)"  "rgba( 65, 52, 51,255)"  "19-1314TPX_SealBrown"
#Pnt_19_1317      = $363650;  $FF363650  "#503636"  "rgb( 80, 54, 54)"  "rgba( 80, 54, 54,255)"  "19-1317TPX_BitterChocolate"
#Pnt_19_1320      = $424471;  $FF424471  "#714442"  "rgb(113, 68, 66)"  "rgba(113, 68, 66,255)"  "19-1320TPX_Sable"
#Pnt_19_1321      = $383759;  $FF383759  "#593738"  "rgb( 89, 55, 56)"  "rgba( 89, 55, 56,255)"  "19-1321TPX_RumRaisin"
#Pnt_19_1322      = $3E3E59;  $FF3E3E59  "#593E3E"  "rgb( 89, 62, 62)"  "rgba( 89, 62, 62,255)"  "19-1322TPX_BrownStone"
#Pnt_19_1325      = $40416B;  $FF40416B  "#6B4140"  "rgb(107, 65, 64)"  "rgba(107, 65, 64,255)"  "19-1325TPX_HotChocolate"
#Pnt_19_1327      = $3D3A62;  $FF3D3A62  "#623A3D"  "rgb( 98, 58, 61)"  "rgba( 98, 58, 61,255)"  "19-1327TPX_Andorra"
#Pnt_19_1331      = $3C3A6C;  $FF3C3A6C  "#6C3A3C"  "rgb(108, 58, 60)"  "rgba(108, 58, 60,255)"  "19-1331TPX_MadderBrown"
#Pnt_19_1333      = $3D4A80;  $FF3D4A80  "#804A3D"  "rgb(128, 74, 61)"  "rgba(128, 74, 61,255)"  "19-1333TPX_Sequoia"
#Pnt_19_1334      = $3F467F;  $FF3F467F  "#7F463F"  "rgb(127, 70, 63)"  "rgba(127, 70, 63,255)"  "19-1334TPX_Henna"
#Pnt_19_1337      = $26428A;  $FF26428A  "#8A4226"  "rgb(138, 66, 38)"  "rgba(138, 66, 38,255)"  "19-1337TPX_FiredBrick"
#Pnt_19_1338      = $3C3A75;  $FF3C3A75  "#753A3C"  "rgb(117, 58, 60)"  "rgba(117, 58, 60,255)"  "19-1338TPX_RussetBrown"
#Pnt_19_1420      = $393B54;  $FF393B54  "#543B39"  "rgb( 84, 59, 57)"  "rgba( 84, 59, 57,255)"  "19-1420TPX_DeepMahogany"
#Pnt_19_1430      = $444C72;  $FF444C72  "#724C44"  "rgb(114, 76, 68)"  "rgba(114, 76, 68,255)"  "19-1430TPX_Mink"
#Pnt_19_1431      = $3D4164;  $FF3D4164  "#64413D"  "rgb(100, 65, 61)"  "rgba(100, 65, 61,255)"  "19-1431TPX_Fudgesickle"
#Pnt_19_1436      = $3E446A;  $FF3E446A  "#6A443E"  "rgb(106, 68, 62)"  "rgba(106, 68, 62,255)"  "19-1436TPX_Cinnamon"
#Pnt_19_1518      = $3C3A4F;  $FF3C3A4F  "#4F3A3C"  "rgb( 79, 58, 60)"  "rgba( 79, 58, 60,255)"  "19-1518TPX_Puce"
#Pnt_19_1521      = $443E60;  $FF443E60  "#603E44"  "rgb( 96, 62, 68)"  "rgba( 96, 62, 68,255)"  "19-1521TPX_RedMahogany"
#Pnt_19_1522      = $3A305D;  $FF3A305D  "#5D303A"  "rgb( 93, 48, 58)"  "rgba( 93, 48, 58,255)"  "19-1522TPX_Zinfandel"
#Pnt_19_1524      = $474170;  $FF474170  "#704147"  "rgb(112, 65, 71)"  "rgba(112, 65, 71,255)"  "19-1524TPX_OxbloodRed"
#Pnt_19_1525      = $3F3967;  $FF3F3967  "#67393F"  "rgb(103, 57, 63)"  "rgba(103, 57, 63,255)"  "19-1525TPX_Port"
#Pnt_19_1526      = $3F3761;  $FF3F3761  "#61373F"  "rgb( 97, 55, 63)"  "rgba( 97, 55, 63,255)"  "19-1526TPX_ChocolateTruffle"
#Pnt_19_1528      = $3F345C;  $FF3F345C  "#5C343F"  "rgb( 92, 52, 63)"  "rgba( 92, 52, 63,255)"  "19-1528TPX_WindsorWine"
#Pnt_19_1530      = $4A3E85;  $FF4A3E85  "#853E4A"  "rgb(133, 62, 74)"  "rgba(133, 62, 74,255)"  "19-1530TPX_BurntRusset"
#Pnt_19_1531      = $1E3FA1;  $FF1E3FA1  "#A13F1E"  "rgb(161, 63, 30)"  "rgba(161, 63, 30,255)"  "19-1531TPX_Sun-DriedTomato"
#Pnt_19_1532      = $3F3B83;  $FF3F3B83  "#833B3F"  "rgb(131, 59, 63)"  "rgba(131, 59, 63,255)"  "19-1532TPX_Rosewood"
#Pnt_19_1533      = $4C4A89;  $FF4C4A89  "#894A4C"  "rgb(137, 74, 76)"  "rgba(137, 74, 76,255)"  "19-1533TPX_Cowhide"
#Pnt_19_1535      = $253C94;  $FF253C94  "#943C25"  "rgb(148, 60, 37)"  "rgba(148, 60, 37,255)"  "19-1535TPX_Syrah"
#Pnt_19_1540      = $383C7D;  $FF383C7D  "#7D3C38"  "rgb(125, 60, 56)"  "rgba(125, 60, 56,255)"  "19-1540TPX_BurntHenna"
#Pnt_19_1543      = $453D8C;  $FF453D8C  "#8C3D45"  "rgb(140, 61, 69)"  "rgba(140, 61, 69,255)"  "19-1543TPX_BrickRed"
#Pnt_19_1555      = $1942AA;  $FF1942AA  "#AA4219"  "rgb(170, 66, 25)"  "rgba(170, 66, 25,255)"  "19-1555TPX_RedDahlia"
#Pnt_19_1557      = $35239B;  $FF35239B  "#9B2335"  "rgb(155, 35, 53)"  "rgba(155, 35, 53,255)"  "19-1557TPX_ChiliPepper"
#Pnt_19_1559      = $1754CE;  $FF1754CE  "#CE5417"  "rgb(206, 84, 23)"  "rgba(206, 84, 23,255)"  "19-1559TPX_ScarletSage"
#Pnt_19_1606      = $4A4157;  $FF4A4157  "#57414A"  "rgb( 87, 65, 74)"  "rgba( 87, 65, 74,255)"  "19-1606TPX_Raisin"
#Pnt_19_1608      = $53415E;  $FF53415E  "#5E4153"  "rgb( 94, 65, 83)"  "rgba( 94, 65, 83,255)"  "19-1608TPX_PrunePurple"
#Pnt_19_1617      = $473B65;  $FF473B65  "#653B47"  "rgb(101, 59, 71)"  "rgba(101, 59, 71,255)"  "19-1617TPX_Burgundy"
#Pnt_19_1619      = $3E3848;  $FF3E3848  "#48383E"  "rgb( 72, 56, 62)"  "rgba( 72, 56, 62,255)"  "19-1619TPX_Fudge"
#Pnt_19_1620      = $494259;  $FF494259  "#594249"  "rgb( 89, 66, 73)"  "rgba( 89, 66, 73,255)"  "19-1620TPX_Huckleberry"
#Pnt_19_1621      = $49425B;  $FF49425B  "#5B4249"  "rgb( 91, 66, 73)"  "rgba( 91, 66, 73,255)"  "19-1621TPX_CatawbaGrape"
#Pnt_19_1623      = $443C5A;  $FF443C5A  "#5A3C44"  "rgb( 90, 60, 68)"  "rgba( 90, 60, 68,255)"  "19-1623TPX_VineyardWine"
#Pnt_19_1624      = $473F56;  $FF473F56  "#563F47"  "rgb( 86, 63, 71)"  "rgba( 86, 63, 71,255)"  "19-1624TPX_Sassafras"
#Pnt_19_1625      = $3E3956;  $FF3E3956  "#56393E"  "rgb( 86, 57, 62)"  "rgba( 86, 57, 62,255)"  "19-1625TPX_DecadentChocolate"
#Pnt_19_1627      = $3E3358;  $FF3E3358  "#58333E"  "rgb( 88, 51, 62)"  "rgba( 88, 51, 62,255)"  "19-1627TPX_PortRoyale"
#Pnt_19_1629      = $3D3577;  $FF3D3577  "#77353D"  "rgb(119, 53, 61)"  "rgba(119, 53, 61,255)"  "19-1629TPX_RubyWine"
#Pnt_19_1650      = $3D307D;  $FF3D307D  "#7D303D"  "rgb(125, 48, 61)"  "rgba(125, 48, 61,255)"  "19-1650TPX_BikingRed"
#Pnt_19_1652      = $213DA9;  $FF213DA9  "#A93D21"  "rgb(169, 61, 33)"  "rgba(169, 61, 33,255)"  "19-1652TPX_Rhubarb"
#Pnt_19_1655      = $433594;  $FF433594  "#943543"  "rgb(148, 53, 67)"  "rgba(148, 53, 67,255)"  "19-1655TPX_Garnet"
#Pnt_19_1656      = $392885;  $FF392885  "#852839"  "rgb(133, 40, 57)"  "rgba(133, 40, 57,255)"  "19-1656TPX_RioRed"
#Pnt_19_1662      = $1959D3;  $FF1959D3  "#D35919"  "rgb(211, 89, 25)"  "rgba(211, 89, 25,255)"  "19-1662TPX_Samba"
#Pnt_19_1663      = $3D28B8;  $FF3D28B8  "#B8283D"  "rgb(184, 40, 61)"  "rgba(184, 40, 61,255)"  "19-1663TPX_RibbonRed"
#Pnt_19_1664      = $3C24BC;  $FF3C24BC  "#BC243C"  "rgb(188, 36, 60)"  "rgba(188, 36, 60,255)"  "19-1664TPX_TrueRed"
#Pnt_19_1716      = $4C3B5D;  $FF4C3B5D  "#5D3B4C"  "rgb( 93, 59, 76)"  "rgba( 93, 59, 76,255)"  "19-1716TPX_MauveWine"
#Pnt_19_1718      = $433650;  $FF433650  "#503643"  "rgb( 80, 54, 67)"  "rgba( 80, 54, 67,255)"  "19-1718TPX_Fig"
#Pnt_19_1724      = $24378F;  $FF24378F  "#8F3724"  "rgb(143, 55, 36)"  "rgba(143, 55, 36,255)"  "19-1724TPX_Cabernet"
#Pnt_19_1725      = $3B2E67;  $FF3B2E67  "#672E3B"  "rgb(103, 46, 59)"  "rgba(103, 46, 59,255)"  "19-1725TPX_TawnyPort"
#Pnt_19_1726      = $3F326A;  $FF3F326A  "#6A323F"  "rgb(106, 50, 63)"  "rgba(106, 50, 63,255)"  "19-1726TPX_Cordovan"
#Pnt_19_1757      = $0052EB;  $FF0052EB  "#EB5200"  "rgb(235, 82,  0)"  "rgba(235, 82,  0,255)"  "19-1757TPX_BarbadosCherry"
#Pnt_19_1758      = $0B52DA;  $FF0B52DA  "#DA520B"  "rgb(218, 82, 11)"  "rgba(218, 82, 11,255)"  "19-1758TPX_HauteRed"
#Pnt_19_1759      = $4635A3;  $FF4635A3  "#A33546"  "rgb(163, 53, 70)"  "rgba(163, 53, 70,255)"  "19-1759TPX_AmericanBeauty"
#Pnt_19_1760      = $452CB5;  $FF452CB5  "#B52C45"  "rgb(181, 44, 69)"  "rgba(181, 44, 69,255)"  "19-1760TPX_Scarlet"
#Pnt_19_1761      = $3612AD;  $FF3612AD  "#AD1236"  "rgb(173, 18, 54)"  "rgba(173, 18, 54,255)"  "19-1761TPX_TangoRed"
#Pnt_19_1762      = $421CAD;  $FF421CAD  "#AD1C42"  "rgb(173, 28, 66)"  "rgba(173, 28, 66,255)"  "19-1762TPX_Crimson"
#Pnt_19_1763      = $361BB8;  $FF361BB8  "#B81B36"  "rgb(184, 27, 54)"  "rgba(184, 27, 54,255)"  "19-1763TPX_FormulaOne"
#Pnt_19_1764      = $4125B0;  $FF4125B0  "#B02541"  "rgb(176, 37, 65)"  "rgba(176, 37, 65,255)"  "19-1764TPX_LipstickRed"
#Pnt_19_1840      = $4A3698;  $FF4A3698  "#98364A"  "rgb(152, 54, 74)"  "rgba(152, 54, 74,255)"  "19-1840TPX_DeepClaret"
#Pnt_19_1850      = $4E2D9A;  $FF4E2D9A  "#9A2D4E"  "rgb(154, 45, 78)"  "rgba(154, 45, 78,255)"  "19-1850TPX_RedBud"
#Pnt_19_1860      = $4A22A1;  $FF4A22A1  "#A1224A"  "rgb(161, 34, 74)"  "rgba(161, 34, 74,255)"  "19-1860TPX_PersianRed"
#Pnt_19_1862      = $3A2498;  $FF3A2498  "#98243A"  "rgb(152, 36, 58)"  "rgba(152, 36, 58,255)"  "19-1862TPX_JesterRed"
#Pnt_19_1863      = $1B4FC5;  $FF1B4FC5  "#C54F1B"  "rgb(197, 79, 27)"  "rgba(197, 79, 27,255)"  "19-1863TPX_Scooter"
#Pnt_19_1930      = $263F8F;  $FF263F8F  "#8F3F26"  "rgb(143, 63, 38)"  "rgba(143, 63, 38,255)"  "19-1930TPX_Pomegranate"
#Pnt_19_1934      = $43347D;  $FF43347D  "#7D3443"  "rgb(125, 52, 67)"  "rgba(125, 52, 67,255)"  "19-1934TPX_TibetanRed"
#Pnt_19_1940      = $402F7A;  $FF402F7A  "#7A2F40"  "rgb(122, 47, 64)"  "rgba(122, 47, 64,255)"  "19-1940TPX_RumbaRed"
#Pnt_19_1955      = $4C1F9F;  $FF4C1F9F  "#9F1F4C"  "rgb(159, 31, 76)"  "rgba(159, 31, 76,255)"  "19-1955TPX_Cerise"
#Pnt_19_2009      = $5A435A;  $FF5A435A  "#5A435A"  "rgb( 90, 67, 90)"  "rgba( 90, 67, 90,255)"  "19-2009TPX_Hortensia"
#Pnt_19_2014      = $4F3E60;  $FF4F3E60  "#603E4F"  "rgb( 96, 62, 79)"  "rgba( 96, 62, 79,255)"  "19-2014TPX_Prune"
#Pnt_19_2024      = $463174;  $FF463174  "#743146"  "rgb(116, 49, 70)"  "rgba(116, 49, 70,255)"  "19-2024TPX_Rhododendron"
#Pnt_19_2025      = $4D317E;  $FF4D317E  "#7E314D"  "rgb(126, 49, 77)"  "rgba(126, 49, 77,255)"  "19-2025TPX_RedPlum"
#Pnt_19_2030      = $492A7F;  $FF492A7F  "#7F2A49"  "rgb(127, 42, 73)"  "rgba(127, 42, 73,255)"  "19-2030TPX_BeetRed"
#Pnt_19_2033      = $4D2C86;  $FF4D2C86  "#862C4D"  "rgb(134, 44, 77)"  "rgba(134, 44, 77,255)"  "19-2033TPX_Anemone"
#Pnt_19_2039      = $2F5AD4;  $FF2F5AD4  "#D45A2F"  "rgb(212, 90, 47)"  "rgba(212, 90, 47,255)"  "19-2039TPX_Granita"
#Pnt_19_2041      = $3159D0;  $FF3159D0  "#D05931"  "rgb(208, 89, 49)"  "rgba(208, 89, 49,255)"  "19-2041TPX_CherriesJubilee"
#Pnt_19_2045      = $365BCF;  $FF365BCF  "#CF5B36"  "rgb(207, 91, 54)"  "rgba(207, 91, 54,255)"  "19-2045TPX_Vivacious"
#Pnt_19_2047      = $58319D;  $FF58319D  "#9D3158"  "rgb(157, 49, 88)"  "rgba(157, 49, 88,255)"  "19-2047TPX_Sangria"
#Pnt_19_2118      = $40384B;  $FF40384B  "#4B3840"  "rgb( 75, 56, 64)"  "rgba( 75, 56, 64,255)"  "19-2118TPX_Winetasting"
#Pnt_19_2311      = $4F435F;  $FF4F435F  "#5F434F"  "rgb( 95, 67, 79)"  "rgba( 95, 67, 79,255)"  "19-2311TPX_Eggplant"
#Pnt_19_2312      = $514164;  $FF514164  "#644151"  "rgb(100, 65, 81)"  "rgba(100, 65, 81,255)"  "19-2312TPX_CrushedViolets"
#Pnt_19_2315      = $4A3559;  $FF4A3559  "#59354A"  "rgb( 89, 53, 74)"  "rgba( 89, 53, 74,255)"  "19-2315TPX_GrapeWine"
#Pnt_19_2410      = $53346B;  $FF53346B  "#6B3453"  "rgb(107, 52, 83)"  "rgba(107, 52, 83,255)"  "19-2410TPX_Amaranth"
#Pnt_19_2428      = $573172;  $FF573172  "#723157"  "rgb(114, 49, 87)"  "rgba(114, 49, 87,255)"  "19-2428TPX_MagentaPurple"
#Pnt_19_2430      = $4E326D;  $FF4E326D  "#6D324E"  "rgb(109, 50, 78)"  "rgba(109, 50, 78,255)"  "19-2430TPX_PurplePotion"
#Pnt_19_2431      = $603287;  $FF603287  "#873260"  "rgb(135, 50, 96)"  "rgba(135, 50, 96,255)"  "19-2431TPX_Boysenberry"
#Pnt_19_2432      = $5A3082;  $FF5A3082  "#82305A"  "rgb(130, 48, 90)"  "rgba(130, 48, 90,255)"  "19-2432TPX_RaspberryRadiance"
#Pnt_19_2434      = $7337A2;  $FF7337A2  "#A23773"  "rgb(162, 55,115)"  "rgba(162, 55,115,255)"  "19-2434TPX_FestivalFuchsia"
#Pnt_19_2514      = $4A3551;  $FF4A3551  "#51354A"  "rgb( 81, 53, 74)"  "rgba( 81, 53, 74,255)"  "19-2514TPX_ItalianPlum"
#Pnt_19_2520      = $45314E;  $FF45314E  "#4E3145"  "rgb( 78, 49, 69)"  "rgba( 78, 49, 69,255)"  "19-2520TPX_PotentPurple"
#Pnt_19_2524      = $532F62;  $FF532F62  "#622F53"  "rgb( 98, 47, 83)"  "rgba( 98, 47, 83,255)"  "19-2524TPX_DarkPurple"
#Pnt_19_2630      = $753995;  $FF753995  "#953975"  "rgb(149, 57,117)"  "rgba(149, 57,117,255)"  "19-2630TPX_WildAster"
#Pnt_19_2814      = $664560;  $FF664560  "#604566"  "rgb( 96, 69,102)"  "rgba( 96, 69,102,255)"  "19-2814TPX_Wineberry"
#Pnt_19_2816      = $4A354D;  $FF4A354D  "#4D354A"  "rgb( 77, 53, 74)"  "rgba( 77, 53, 74,255)"  "19-2816TPX_BlackberryWine"
#Pnt_19_2820      = $673871;  $FF673871  "#713867"  "rgb(113, 56,103)"  "rgba(113, 56,103,255)"  "19-2820TPX_Phlox"
#Pnt_19_2924      = $753B85;  $FF753B85  "#853B75"  "rgb(133, 59,117)"  "rgba(133, 59,117,255)"  "19-2924TPX_Hollyhock"
#Pnt_19_3022      = $5E3863;  $FF5E3863  "#63385E"  "rgb( 99, 56, 94)"  "rgba( 99, 56, 94,255)"  "19-3022TPX_Gloxinia"
#Pnt_19_3138      = $804189;  $FF804189  "#894180"  "rgb(137, 65,128)"  "rgba(137, 65,128,255)"  "19-3138TPX_Byzantium"
#Pnt_19_3215      = $5C3E50;  $FF5C3E50  "#503E5C"  "rgb( 80, 62, 92)"  "rgba( 80, 62, 92,255)"  "19-3215TPX_Indigo"
#Pnt_19_3217      = $4C2D4C;  $FF4C2D4C  "#4C2D4C"  "rgb( 76, 45, 76)"  "rgba( 76, 45, 76,255)"  "19-3217TPX_ShadowPurple"
#Pnt_19_3218      = $533651;  $FF533651  "#513653"  "rgb( 81, 54, 83)"  "rgba( 81, 54, 83,255)"  "19-3218TPX_PlumPurple"
#Pnt_19_3220      = $60395C;  $FF60395C  "#5C3960"  "rgb( 92, 57, 96)"  "rgba( 92, 57, 96,255)"  "19-3220TPX_Plum"
#Pnt_19_3223      = $6A456D;  $FF6A456D  "#6D456A"  "rgb(109, 69,106)"  "rgba(109, 69,106,255)"  "19-3223TPX_PurplePassion"
#Pnt_19_3230      = $62336D;  $FF62336D  "#6D3362"  "rgb(109, 51, 98)"  "rgba(109, 51, 98,255)"  "19-3230TPX_GrapeJuice"
#Pnt_19_3316      = $493A48;  $FF493A48  "#483A49"  "rgb( 72, 58, 73)"  "rgba( 72, 58, 73,255)"  "19-3316TPX_PlumPerfect"
#Pnt_19_3323      = $563D57;  $FF563D57  "#573D56"  "rgb( 87, 61, 86)"  "rgba( 87, 61, 86,255)"  "19-3323TPX_DeepPurple"
#Pnt_19_3325      = $724676;  $FF724676  "#764672"  "rgb(118, 70,114)"  "rgba(118, 70,114,255)"  "19-3325TPX_WoodViolet"
#Pnt_19_3336      = $7C3F7D;  $FF7C3F7D  "#7D3F7C"  "rgb(125, 63,124)"  "rgba(125, 63,124,255)"  "19-3336TPX_SparklingGrape"
#Pnt_19_3424      = $764A72;  $FF764A72  "#724A76"  "rgb(114, 74,118)"  "rgba(114, 74,118,255)"  "19-3424TPX_SunsetPurple"
#Pnt_19_3438      = $844779;  $FF844779  "#794784"  "rgb(121, 71,132)"  "rgba(121, 71,132,255)"  "19-3438TPX_BrightViolet"
#Pnt_19_3514      = $64375A;  $FF64375A  "#5A3764"  "rgb( 90, 55,100)"  "rgba( 90, 55,100,255)"  "19-3514TPX_Majesty"
#Pnt_19_3518      = $5D3554;  $FF5D3554  "#54355D"  "rgb( 84, 53, 93)"  "rgba( 84, 53, 93,255)"  "19-3518TPX_GrapeRoyale"
#Pnt_19_3519      = $4D3546;  $FF4D3546  "#46354D"  "rgb( 70, 53, 77)"  "rgba( 70, 53, 77,255)"  "19-3519TPX_PurplePennant"
#Pnt_19_3520      = $4E2F43;  $FF4E2F43  "#432F4E"  "rgb( 67, 47, 78)"  "rgba( 67, 47, 78,255)"  "19-3520TPX_BlackberryCordial"
#Pnt_19_3526      = $854D73;  $FF854D73  "#734D85"  "rgb(115, 77,133)"  "rgba(115, 77,133,255)"  "19-3526TPX_MeadowViolet"
#Pnt_19_3528      = $63365A;  $FF63365A  "#5A3663"  "rgb( 90, 54, 99)"  "rgba( 90, 54, 99,255)"  "19-3528TPX_ImperialPurple"
#Pnt_19_3536      = $81416F;  $FF81416F  "#6F4181"  "rgb(111, 65,129)"  "rgba(111, 65,129,255)"  "19-3536TPX_AmaranthPurple"
#Pnt_19_3540      = $713B69;  $FF713B69  "#693B71"  "rgb(105, 59,113)"  "rgba(105, 59,113,255)"  "19-3540TPX_PurpleMagic"
#Pnt_19_3542      = $814269;  $FF814269  "#694281"  "rgb(105, 66,129)"  "rgba(105, 66,129,255)"  "19-3542TPX_Pansy"
#Pnt_19_3617      = $49323D;  $FF49323D  "#3D3249"  "rgb( 61, 50, 73)"  "rgba( 61, 50, 73,255)"  "19-3617TPX_Mysterioso"
#Pnt_19_3619      = $55414D;  $FF55414D  "#4D4155"  "rgb( 77, 65, 85)"  "rgba( 77, 65, 85,255)"  "19-3619TPX_SweetGrape"
#Pnt_19_3620      = $6C4454;  $FF6C4454  "#54446C"  "rgb( 84, 68,108)"  "rgba( 84, 68,108,255)"  "19-3620TPX_PurpleReign"
#Pnt_19_3622      = $6B4A5B;  $FF6B4A5B  "#5B4A6B"  "rgb( 91, 74,107)"  "rgba( 91, 74,107,255)"  "19-3622TPX_Loganberry"
#Pnt_19_3628      = $402F5F;  $FF402F5F  "#5F2F40"  "rgb( 95, 47, 64)"  "rgba( 95, 47, 64,255)"  "19-3628TPX_Acai"
#Pnt_19_3632      = $6A3953;  $FF6A3953  "#53396A"  "rgb( 83, 57,106)"  "rgba( 83, 57,106,255)"  "19-3632TPX_Petunia"
#Pnt_19_3638      = $553C70;  $FF553C70  "#703C55"  "rgb(112, 60, 85)"  "rgba(112, 60, 85,255)"  "19-3638TPX_TillandsiaPurple"
#Pnt_19_3640      = $533047;  $FF533047  "#473053"  "rgb( 71, 48, 83)"  "rgba( 71, 48, 83,255)"  "19-3640TPX_CrownJewel"
#Pnt_19_3642      = $80455D;  $FF80455D  "#5D4580"  "rgb( 93, 69,128)"  "rgba( 93, 69,128,255)"  "19-3642TPX_RoyalPurple"
#Pnt_19_3712      = $49393F;  $FF49393F  "#3F3949"  "rgb( 63, 57, 73)"  "rgba( 63, 57, 73,255)"  "19-3712TPX_Nightshade"
#Pnt_19_3713      = $30283E;  $FF30283E  "#3E2830"  "rgb( 62, 40, 48)"  "rgba( 62, 40, 48,255)"  "19-3713TPX_DeepWell"
#Pnt_19_3714      = $573F50;  $FF573F50  "#503F57"  "rgb( 80, 63, 87)"  "rgba( 80, 63, 87,255)"  "19-3714TPX_NavyCosmos"
#Pnt_19_3716      = $583D48;  $FF583D48  "#483D58"  "rgb( 72, 61, 88)"  "rgba( 72, 61, 88,255)"  "19-3716TPX_PurplePlumeria"
#Pnt_19_3720      = $4F313F;  $FF4F313F  "#3F314F"  "rgb( 63, 49, 79)"  "rgba( 63, 49, 79,255)"  "19-3720TPX_GothicGrape"
#Pnt_19_3722      = $68414C;  $FF68414C  "#4C4168"  "rgb( 76, 65,104)"  "rgba( 76, 65,104,255)"  "19-3722TPX_MulberryPurple"
#Pnt_19_3725      = $543C44;  $FF543C44  "#443C54"  "rgb( 68, 60, 84)"  "rgba( 68, 60, 84,255)"  "19-3725TPX_PurpleVelvet"
#Pnt_19_3728      = $5D3B49;  $FF5D3B49  "#493B5D"  "rgb( 73, 59, 93)"  "rgba( 73, 59, 93,255)"  "19-3728TPX_Grape"
#Pnt_19_3730      = $7F4959;  $FF7F4959  "#59497F"  "rgb( 89, 73,127)"  "rgba( 89, 73,127,255)"  "19-3730TPX_GentianViolet"
#Pnt_19_3731      = $5D3543;  $FF5D3543  "#43355D"  "rgb( 67, 53, 93)"  "rgba( 67, 53, 93,255)"  "19-3731TPX_ParachutePurple"
#Pnt_19_3737      = $753B51;  $FF753B51  "#513B75"  "rgb( 81, 59,117)"  "rgba( 81, 59,117,255)"  "19-3737TPX_Heliotrope"
#Pnt_19_3748      = $874558;  $FF874558  "#584587"  "rgb( 88, 69,135)"  "rgba( 88, 69,135,255)"  "19-3748TPX_PrismViolet"
#Pnt_19_3803      = $5B595C;  $FF5B595C  "#5C595B"  "rgb( 92, 89, 91)"  "rgba( 92, 89, 91,255)"  "19-3803TPX_PlumKitten"
#Pnt_19_3810      = $492E2D;  $FF492E2D  "#2D2E49"  "rgb( 45, 46, 73)"  "rgba( 45, 46, 73,255)"  "19-3810TPX_Eclipse"
#Pnt_19_3815      = $35263C;  $FF35263C  "#3C2635"  "rgb( 60, 38, 53)"  "rgba( 60, 38, 53,255)"  "19-3815TPX_EveningBlue"
#Pnt_19_3830      = $4D2C2D;  $FF4D2C2D  "#2D2C4D"  "rgb( 45, 44, 77)"  "rgba( 45, 44, 77,255)"  "19-3830TPX_AstralAura"
#Pnt_19_3832      = $71403E;  $FF71403E  "#3E4071"  "rgb( 62, 64,113)"  "rgba( 62, 64,113,255)"  "19-3832TPX_NavyBlue"
#Pnt_19_3839      = $633E3D;  $FF633E3D  "#3D3E63"  "rgb( 61, 62, 99)"  "rgba( 61, 62, 99,255)"  "19-3839TPX_BlueRibbon"
#Pnt_19_3842      = $754549;  $FF754549  "#494575"  "rgb( 73, 69,117)"  "rgba( 73, 69,117,255)"  "19-3842TPX_DeepWisteria"
#Pnt_19_3847      = $80424C;  $FF80424C  "#4C4280"  "rgb( 76, 66,128)"  "rgba( 76, 66,128,255)"  "19-3847TPX_DeepBlue"
#Pnt_19_3850      = $8B464E;  $FF8B464E  "#4E468B"  "rgb( 78, 70,139)"  "rgba( 78, 70,139,255)"  "19-3850TPX_Liberty"
#Pnt_19_3864      = $7A3F32;  $FF7A3F32  "#323F7A"  "rgb( 50, 63,122)"  "rgba( 50, 63,122,255)"  "19-3864TPX_MazarineBlue"
#Pnt_19_3900      = $514A6E;  $FF514A6E  "#6E4A51"  "rgb(110, 74, 81)"  "rgba(110, 74, 81,255)"  "19-3900TPX_Pavement"
#Pnt_19_3901      = $504768;  $FF504768  "#684750"  "rgb(104, 71, 80)"  "rgba(104, 71, 80,255)"  "19-3901TPX_Magnet"
#Pnt_19_3903      = $423D43;  $FF423D43  "#433D42"  "rgb( 67, 61, 66)"  "rgba( 67, 61, 66,255)"  "19-3903TPX_Shale"
#Pnt_19_3905      = $585358;  $FF585358  "#585358"  "rgb( 88, 83, 88)"  "rgba( 88, 83, 88,255)"  "19-3905TPX_Rabbit"
#Pnt_19_3906      = $4E4B46;  $FF4E4B46  "#464B4E"  "rgb( 70, 75, 78)"  "rgba( 70, 75, 78,255)"  "19-3906TPX_DarkShadow"
#Pnt_19_3907      = $494262;  $FF494262  "#624249"  "rgb( 98, 66, 73)"  "rgba( 98, 66, 73,255)"  "19-3907TPX_ForgedIron"
#Pnt_19_3908      = $473E3F;  $FF473E3F  "#3F3E47"  "rgb( 63, 62, 71)"  "rgba( 63, 62, 71,255)"  "19-3908TPX_NineIron"
#Pnt_19_3909      = $272742;  $FF272742  "#422727"  "rgb( 66, 39, 39)"  "rgba( 66, 39, 39,255)"  "19-3909TPX_BlackBean"
#Pnt_19_3910      = $534C67;  $FF534C67  "#674C53"  "rgb(103, 76, 83)"  "rgba(103, 76, 83,255)"  "19-3910TPX_IronGate"
#Pnt_19_3915      = $564241;  $FF564241  "#414256"  "rgb( 65, 66, 86)"  "rgba( 65, 66, 86,255)"  "19-3915TPX_Graystone"
#Pnt_19_3918      = $494060;  $FF494060  "#604049"  "rgb( 96, 64, 73)"  "rgba( 96, 64, 73,255)"  "19-3918TPX_Periscope"
#Pnt_19_3919      = $6E5852;  $FF6E5852  "#52586E"  "rgb( 82, 88,110)"  "rgba( 82, 88,110,255)"  "19-3919TPX_NightshadowBlue"
#Pnt_19_3920      = $49332F;  $FF49332F  "#2F3349"  "rgb( 47, 51, 73)"  "rgba( 47, 51, 73,255)"  "19-3920TPX_Peacoat"
#Pnt_19_3921      = $453126;  $FF453126  "#263145"  "rgb( 38, 49, 69)"  "rgba( 38, 49, 69,255)"  "19-3921TPX_BlackIris"
#Pnt_19_3922      = $302633;  $FF302633  "#332630"  "rgb( 51, 38, 48)"  "rgba( 51, 38, 48,255)"  "19-3922TPX_SkyCaptain"
#Pnt_19_3923      = $37283A;  $FF37283A  "#3A2837"  "rgb( 58, 40, 55)"  "rgba( 58, 40, 55,255)"  "19-3923TPX_NavyBlazer"
#Pnt_19_3924      = $31273B;  $FF31273B  "#3B2731"  "rgb( 59, 39, 49)"  "rgba( 59, 39, 49,255)"  "19-3924TPX_NightSky"
#Pnt_19_3925      = $573A34;  $FF573A34  "#343A57"  "rgb( 52, 58, 87)"  "rgba( 52, 58, 87,255)"  "19-3925TPX_PatriotBlue"
#Pnt_19_3926      = $684F4A;  $FF684F4A  "#4A4F68"  "rgb( 74, 79,104)"  "rgba( 74, 79,104,255)"  "19-3926TPX_CrownBlue"
#Pnt_19_3927      = $433754;  $FF433754  "#543743"  "rgb( 84, 55, 67)"  "rgba( 84, 55, 67,255)"  "19-3927TPX_Graphite"
#Pnt_19_3928      = $705448;  $FF705448  "#485470"  "rgb( 72, 84,112)"  "rgba( 72, 84,112,255)"  "19-3928TPX_BlueIndigo"
#Pnt_19_3929      = $644D66;  $FF644D66  "#664D64"  "rgb(102, 77,100)"  "rgba(102, 77,100,255)"  "19-3929TPX_VintageIndigo"
#Pnt_19_3933      = $54362F;  $FF54362F  "#2F3654"  "rgb( 47, 54, 84)"  "rgba( 47, 54, 84,255)"  "19-3933TPX_MedievalBlue"
#Pnt_19_3935      = $65443E;  $FF65443E  "#3E4465"  "rgb( 62, 68,101)"  "rgba( 62, 68,101,255)"  "19-3935TPX_DeepCobalt"
#Pnt_19_3936      = $774E4C;  $FF774E4C  "#4C4E77"  "rgb( 76, 78,119)"  "rgba( 76, 78,119,255)"  "19-3936TPX_SkipperBlue"
#Pnt_19_3938      = $663F30;  $FF663F30  "#303F66"  "rgb( 48, 63,102)"  "rgba( 48, 63,102,255)"  "19-3938TPX_TwilightBlue"
#Pnt_19_3939      = $61352E;  $FF61352E  "#2E3561"  "rgb( 46, 53, 97)"  "rgba( 46, 53, 97,255)"  "19-3939TPX_Blueprint"
#Pnt_19_3940      = $5A352D;  $FF5A352D  "#2D355A"  "rgb( 45, 53, 90)"  "rgba( 45, 53, 90,255)"  "19-3940TPX_BlueDepths"
#Pnt_19_3947      = $7E4A4C;  $FF7E4A4C  "#4C4A7E"  "rgb( 76, 74,126)"  "rgba( 76, 74,126,255)"  "19-3947TPX_OrientBlue"
#Pnt_19_3950      = $874B3B;  $FF874B3B  "#3B4B87"  "rgb( 59, 75,135)"  "rgba( 59, 75,135,255)"  "19-3950TPX_DeepUltramarine"
#Pnt_19_3951      = $7F403D;  $FF7F403D  "#3D407F"  "rgb( 61, 64,127)"  "rgba( 61, 64,127,255)"  "19-3951TPX_ClematisBlue"
#Pnt_19_3952      = $863E2F;  $FF863E2F  "#2F3E86"  "rgb( 47, 62,134)"  "rgba( 47, 62,134,255)"  "19-3952TPX_SurfTheWeb"
#Pnt_19_3953      = $542C3E;  $FF542C3E  "#3E2C54"  "rgb( 62, 44, 84)"  "rgba( 62, 44, 84,255)"  "19-3953TPX_SodaliteBlue"
#Pnt_19_3955      = $8C443F;  $FF8C443F  "#3F448C"  "rgb( 63, 68,140)"  "rgba( 63, 68,140,255)"  "19-3955TPX_RoyalBlue"
#Pnt_19_3964      = $623646;  $FF623646  "#463662"  "rgb( 70, 54, 98)"  "rgba( 70, 54, 98,255)"  "19-3964TPX_MonacoBlue"
#Pnt_19_4004      = $2C283A;  $FF2C283A  "#3A282C"  "rgb( 58, 40, 44)"  "rgba( 58, 40, 44,255)"  "19-4004TPX_TapShoe"
#Pnt_19_4005      = $38322E;  $FF38322E  "#2E3238"  "rgb( 46, 50, 56)"  "rgba( 46, 50, 56,255)"  "19-4005TPX_StretchLimo"
#Pnt_19_4006      = $322F2C;  $FF322F2C  "#2C2F32"  "rgb( 44, 47, 50)"  "rgba( 44, 47, 50,255)"  "19-4006TPX_Caviar"
#Pnt_19_4007      = $36302D;  $FF36302D  "#2D3036"  "rgb( 45, 48, 54)"  "rgba( 45, 48, 54,255)"  "19-4007TPX_Anthracite"
#Pnt_19_4008      = $282740;  $FF282740  "#402728"  "rgb( 64, 39, 40)"  "rgba( 64, 39, 40,255)"  "19-4008TPX_Meteorite"
#Pnt_19_4009      = $3D2F46;  $FF3D2F46  "#462F3D"  "rgb( 70, 47, 61)"  "rgba( 70, 47, 61,255)"  "19-4009TPX_OuterSpace"
#Pnt_19_4010      = $40352C;  $FF40352C  "#2C3540"  "rgb( 44, 53, 64)"  "rgba( 44, 53, 64,255)"  "19-4010TPX_TotalEclipse"
#Pnt_19_4011      = $312738;  $FF312738  "#382731"  "rgb( 56, 39, 49)"  "rgba( 56, 39, 49,255)"  "19-4011TPX_Salute"
#Pnt_19_4012      = $362939;  $FF362939  "#392936"  "rgb( 57, 41, 54)"  "rgba( 57, 41, 54,255)"  "19-4012TPX_Carbon"
#Pnt_19_4013      = $3D3532;  $FF3D3532  "#32353D"  "rgb( 50, 53, 61)"  "rgba( 50, 53, 61,255)"  "19-4013TPX_DarkNavy"
#Pnt_19_4014      = $544941;  $FF544941  "#414954"  "rgb( 65, 73, 84)"  "rgba( 65, 73, 84,255)"  "19-4014TPX_OmbreBlue"
#Pnt_19_4015      = $3B3533;  $FF3B3533  "#33353B"  "rgb( 51, 53, 59)"  "rgba( 51, 53, 59,255)"  "19-4015TPX_BlueGraphite"
#Pnt_19_4019      = $4E433C;  $FF4E433C  "#3C434E"  "rgb( 60, 67, 78)"  "rgba( 60, 67, 78,255)"  "19-4019TPX_IndiaInk"
#Pnt_19_4020      = $332735;  $FF332735  "#352733"  "rgb( 53, 39, 51)"  "rgba( 53, 39, 51,255)"  "19-4020TPX_DarkSapphire"
#Pnt_19_4021      = $3C2D42;  $FF3C2D42  "#422D3C"  "rgb( 66, 45, 60)"  "rgba( 66, 45, 60,255)"  "19-4021TPX_Blueberry"
#Pnt_19_4022      = $3C304A;  $FF3C304A  "#4A303C"  "rgb( 74, 48, 60)"  "rgba( 74, 48, 60,255)"  "19-4022TPX_ParisianNight"
#Pnt_19_4023      = $4B3E37;  $FF4B3E37  "#373E4B"  "rgb( 55, 62, 75)"  "rgba( 55, 62, 75,255)"  "19-4023TPX_BlueNights"
#Pnt_19_4024      = $473327;  $FF473327  "#273347"  "rgb( 39, 51, 71)"  "rgba( 39, 51, 71,255)"  "19-4024TPX_DressBlues"
#Pnt_19_4025      = $514036;  $FF514036  "#364051"  "rgb( 54, 64, 81)"  "rgba( 54, 64, 81,255)"  "19-4025TPX_MoodIndigo"
#Pnt_19_4026      = $6B4F38;  $FF6B4F38  "#384F6B"  "rgb( 56, 79,107)"  "rgba( 56, 79,107,255)"  "19-4026TPX_EnsignBlue"
#Pnt_19_4027      = $593625;  $FF593625  "#253659"  "rgb( 37, 54, 89)"  "rgba( 37, 54, 89,255)"  "19-4027TPX_EstateBlue"
#Pnt_19_4028      = $5A4332;  $FF5A4332  "#32435A"  "rgb( 50, 67, 90)"  "rgba( 50, 67, 90,255)"  "19-4028TPX_InsigniaBlue"
#Pnt_19_4030      = $795440;  $FF795440  "#405479"  "rgb( 64, 84,121)"  "rgba( 64, 84,121,255)"  "19-4030TPX_TrueNavy"
#Pnt_19_4033      = $4F2D22;  $FF4F2D22  "#222D4F"  "rgb( 34, 45, 79)"  "rgba( 34, 45, 79,255)"  "19-4033TPX_Poseidon"
#Pnt_19_4035      = $775432;  $FF775432  "#325477"  "rgb( 50, 84,119)"  "rgba( 50, 84,119,255)"  "19-4035TPX_DarkBlue"
#Pnt_19_4037      = $915E35;  $FF915E35  "#355E91"  "rgb( 53, 94,145)"  "rgba( 53, 94,145,255)"  "19-4037TPX_BrightCobalt"
#Pnt_19_4039      = $8D5B3A;  $FF8D5B3A  "#3A5B8D"  "rgb( 58, 91,141)"  "rgba( 58, 91,141,255)"  "19-4039TPX_Delft"
#Pnt_19_4044      = $78452C;  $FF78452C  "#2C4578"  "rgb( 44, 69,120)"  "rgba( 44, 69,120,255)"  "19-4044TPX_Limoges"
#Pnt_19_4049      = $8C4D00;  $FF8C4D00  "#004D8C"  "rgb(  0, 77,140)"  "rgba(  0, 77,140,255)"  "19-4049TPX_SnorkelBlue"
#Pnt_19_4050      = $8F4D16;  $FF8F4D16  "#164D8F"  "rgb( 22, 77,143)"  "rgba( 22, 77,143,255)"  "19-4050TPX_NauticalBlue"
#Pnt_19_4052      = $894E1D;  $FF894E1D  "#1D4E89"  "rgb( 29, 78,137)"  "rgba( 29, 78,137,255)"  "19-4052TPX_ClassicBlue"
#Pnt_19_4053      = $985425;  $FF985425  "#255498"  "rgb( 37, 84,152)"  "rgba( 37, 84,152,255)"  "19-4053TPX_TurkishSea"
#Pnt_19_4056      = $93542E;  $FF93542E  "#2E5493"  "rgb( 46, 84,147)"  "rgba( 46, 84,147,255)"  "19-4056TPX_OlympianBlue"
#Pnt_19_4057      = $7F4828;  $FF7F4828  "#28487F"  "rgb( 40, 72,127)"  "rgba( 40, 72,127,255)"  "19-4057TPX_TrueBlue"
#Pnt_19_4104      = $49423D;  $FF49423D  "#3D4249"  "rgb( 61, 66, 73)"  "rgba( 61, 66, 73,255)"  "19-4104TPX_Ebony"
#Pnt_19_4110      = $504436;  $FF504436  "#364450"  "rgb( 54, 68, 80)"  "rgba( 54, 68, 80,255)"  "19-4110TPX_MidnightNavy"
#Pnt_19_4118      = $5E4835;  $FF5E4835  "#35485E"  "rgb( 53, 72, 94)"  "rgba( 53, 72, 94,255)"  "19-4118TPX_DarkDenim"
#Pnt_19_4121      = $4E3547;  $FF4E3547  "#47354E"  "rgb( 71, 53, 78)"  "rgba( 71, 53, 78,255)"  "19-4121TPX_BlueWingTeal"
#Pnt_19_4125      = $574327;  $FF574327  "#274357"  "rgb( 39, 67, 87)"  "rgba( 39, 67, 87,255)"  "19-4125TPX_MajolicaBlue"
#Pnt_19_4127      = $785D31;  $FF785D31  "#315D78"  "rgb( 49, 93,120)"  "rgba( 49, 93,120,255)"  "19-4127TPX_Midnight"
#Pnt_19_4150      = $9F5811;  $FF9F5811  "#11589F"  "rgb( 17, 88,159)"  "rgba( 17, 88,159,255)"  "19-4150TPX_PrincessBlue"
#Pnt_19_4151      = $9F5C00;  $FF9F5C00  "#005C9F"  "rgb(  0, 92,159)"  "rgba(  0, 92,159,255)"  "19-4151TPX_Skydiver"
#Pnt_19_4203      = $35322E;  $FF35322E  "#2E3235"  "rgb( 46, 50, 53)"  "rgba( 46, 50, 53,255)"  "19-4203TPX_MoonlessNight"
#Pnt_19_4205      = $3B3734;  $FF3B3734  "#34373B"  "rgb( 52, 55, 59)"  "rgba( 52, 55, 59,255)"  "19-4205TPX_Phantom"
#Pnt_19_4215      = $594E68;  $FF594E68  "#684E59"  "rgb(104, 78, 89)"  "rgba(104, 78, 89,255)"  "19-4215TPX_Turbulence"
#Pnt_19_4218      = $35294E;  $FF35294E  "#4E2935"  "rgb( 78, 41, 53)"  "rgba( 78, 41, 53,255)"  "19-4218TPX_Vulcan"
#Pnt_19_4220      = $5B5344;  $FF5B5344  "#44535B"  "rgb( 68, 83, 91)"  "rgba( 68, 83, 91,255)"  "19-4220TPX_DarkSlate"
#Pnt_19_4227      = $6C5A3E;  $FF6C5A3E  "#3E5A6C"  "rgb( 62, 90,108)"  "rgba( 62, 90,108,255)"  "19-4227TPX_IndianTeal"
#Pnt_19_4229      = $605442;  $FF605442  "#425460"  "rgb( 66, 84, 96)"  "rgba( 66, 84, 96,255)"  "19-4229TPX_OrionBlue"
#Pnt_19_4234      = $6F5716;  $FF6F5716  "#16576F"  "rgb( 22, 87,111)"  "rgba( 22, 87,111,255)"  "19-4234TPX_InkBlue"
#Pnt_19_4241      = $694F1C;  $FF694F1C  "#1C4F69"  "rgb( 28, 79,105)"  "rgba( 28, 79,105,255)"  "19-4241TPX_MoroccanBlue"
#Pnt_19_4245      = $9A5900;  $FF9A5900  "#00599A"  "rgb(  0, 89,154)"  "rgba(  0, 89,154,255)"  "19-4245TPX_ImperialBlue"
#Pnt_19_4305      = $35342F;  $FF35342F  "#2F3435"  "rgb( 47, 52, 53)"  "rgba( 47, 52, 53,255)"  "19-4305TPX_PirateBlack"
#Pnt_19_4316      = $605439;  $FF605439  "#395460"  "rgb( 57, 84, 96)"  "rgba( 57, 84, 96,255)"  "19-4316TPX_Stargazer"
#Pnt_19_4318      = $74613D;  $FF74613D  "#3D6174"  "rgb( 61, 97,116)"  "rgba( 61, 97,116,255)"  "19-4318TPX_MallardBlue"
#Pnt_19_4324      = $624E25;  $FF624E25  "#254E62"  "rgb( 37, 78, 98)"  "rgba( 37, 78, 98,255)"  "19-4324TPX_LegionBlue"
#Pnt_19_4326      = $4A3332;  $FF4A3332  "#32334A"  "rgb( 50, 51, 74)"  "rgba( 50, 51, 74,255)"  "19-4326TPX_ReflectingPond"
#Pnt_19_4329      = $6F5A11;  $FF6F5A11  "#115A6F"  "rgb( 17, 90,111)"  "rgba( 17, 90,111,255)"  "19-4329TPX_Corsair"
#Pnt_19_4340      = $785E00;  $FF785E00  "#005E78"  "rgb(  0, 94,120)"  "rgba(  0, 94,120,255)"  "19-4340TPX_LyonsBlue"
#Pnt_19_4342      = $825F00;  $FF825F00  "#005F82"  "rgb(  0, 95,130)"  "rgba(  0, 95,130,255)"  "19-4342TPX_Seaport"
#Pnt_19_4517      = $665A33;  $FF665A33  "#335A66"  "rgb( 51, 90,102)"  "rgba( 51, 90,102,255)"  "19-4517TPX_Mediterranea"
#Pnt_19_4524      = $605900;  $FF605900  "#005960"  "rgb(  0, 89, 96)"  "rgba(  0, 89, 96,255)"  "19-4524TPX_ShadedSpruce"
#Pnt_19_4526      = $695818;  $FF695818  "#185869"  "rgb( 24, 88,105)"  "rgba( 24, 88,105,255)"  "19-4526TPX_BlueCoral"
#Pnt_19_4535      = $786500;  $FF786500  "#006578"  "rgb(  0,101,120)"  "rgba(  0,101,120,255)"  "19-4535TPX_OceanDepths"
#Pnt_19_4726      = $5C522D;  $FF5C522D  "#2D525C"  "rgb( 45, 82, 92)"  "rgba( 45, 82, 92,255)"  "19-4726TPX_AtlanticDeep"
#Pnt_19_4818      = $616041;  $FF616041  "#416061"  "rgb( 65, 96, 97)"  "rgba( 65, 96, 97,255)"  "19-4818TPX_MallardGreen"
#Pnt_19_4820      = $605A37;  $FF605A37  "#375A60"  "rgb( 55, 90, 96)"  "rgba( 55, 90, 96,255)"  "19-4820TPX_Balsam"
#Pnt_19_4826      = $6C5F26;  $FF6C5F26  "#265F6C"  "rgb( 38, 95,108)"  "rgba( 38, 95,108,255)"  "19-4826TPX_Dragonfly"
#Pnt_19_4906      = $464734;  $FF464734  "#344746"  "rgb( 52, 71, 70)"  "rgba( 52, 71, 70,255)"  "19-4906TPX_GreenGables"
#Pnt_19_4914      = $504917;  $FF504917  "#174950"  "rgb( 23, 73, 80)"  "rgba( 23, 73, 80,255)"  "19-4914TPX_DeepTeal"
#Pnt_19_4916      = $605B25;  $FF605B25  "#255B60"  "rgb( 37, 91, 96)"  "rgba( 37, 91, 96,255)"  "19-4916TPX_Pacific"
#Pnt_19_4922      = $656400;  $FF656400  "#006465"  "rgb(  0,100,101)"  "rgba(  0,100,101,255)"  "19-4922TPX_TealGreen"
#Pnt_19_5004      = $535248;  $FF535248  "#485253"  "rgb( 72, 82, 83)"  "rgba( 72, 82, 83,255)"  "19-5004TPX_UrbanChic"
#Pnt_19_5212      = $474736;  $FF474736  "#364747"  "rgb( 54, 71, 71)"  "rgba( 54, 71, 71,255)"  "19-5212TPX_DarkestSpruce"
#Pnt_19_5217      = $5C5E0C;  $FF5C5E0C  "#0C5E5C"  "rgb( 12, 94, 92)"  "rgba( 12, 94, 92,255)"  "19-5217TPX_Storm"
#Pnt_19_5220      = $45341B;  $FF45341B  "#1B3445"  "rgb( 27, 52, 69)"  "rgba( 27, 52, 69,255)"  "19-5220TPX_BotanicalGarden"
#Pnt_19_5226      = $626100;  $FF626100  "#006162"  "rgb(  0, 97, 98)"  "rgba(  0, 97, 98,255)"  "19-5226TPX_Everglade"
#Pnt_19_5320      = $444520;  $FF444520  "#204544"  "rgb( 32, 69, 68)"  "rgba( 32, 69, 68,255)"  "19-5320TPX_PonderosaPine"
#Pnt_19_5350      = $35293A;  $FF35293A  "#3A2935"  "rgb( 58, 41, 53)"  "rgba( 58, 41, 53,255)"  "19-5350TPX_Scarab"
#Pnt_19_5406      = $372F28;  $FF372F28  "#282F37"  "rgb( 40, 47, 55)"  "rgba( 40, 47, 55,255)"  "19-5406TPX_PineGrove"
#Pnt_19_5408      = $4A502C;  $FF4A502C  "#2C504A"  "rgb( 44, 80, 74)"  "rgba( 44, 80, 74,255)"  "19-5408TPX_BistroGreen"
#Pnt_19_5411      = $4C5238;  $FF4C5238  "#38524C"  "rgb( 56, 82, 76)"  "rgba( 56, 82, 76,255)"  "19-5411TPX_TrekkingGreen"
#Pnt_19_5413      = $5A5C2D;  $FF5A5C2D  "#2D5C5A"  "rgb( 45, 92, 90)"  "rgba( 45, 92, 90,255)"  "19-5413TPX_Jasper"
#Pnt_19_5414      = $46471C;  $FF46471C  "#1C4746"  "rgb( 28, 71, 70)"  "rgba( 28, 71, 70,255)"  "19-5414TPX_JuneBug"
#Pnt_19_5420      = $4F5D15;  $FF4F5D15  "#155D4F"  "rgb( 21, 93, 79)"  "rgba( 21, 93, 79,255)"  "19-5420TPX_Evergreen"
#Pnt_19_5511      = $495735;  $FF495735  "#355749"  "rgb( 53, 87, 73)"  "rgba( 53, 87, 73,255)"  "19-5511TPX_HunterGreen"
#Pnt_19_5513      = $455033;  $FF455033  "#335045"  "rgb( 51, 80, 69)"  "rgba( 51, 80, 69,255)"  "19-5513TPX_DarkGreen"
#Pnt_19_5621      = $534B5D;  $FF534B5D  "#5D4B53"  "rgb( 93, 75, 83)"  "rgba( 93, 75, 83,255)"  "19-5621TPX_Cilantro"
#Pnt_19_5708      = $373730;  $FF373730  "#303737"  "rgb( 48, 55, 55)"  "rgba( 48, 55, 55,255)"  "19-5708TPX_JetSet"
#Pnt_19_5914      = $4E5240;  $FF4E5240  "#40524E"  "rgb( 64, 82, 78)"  "rgba( 64, 82, 78,255)"  "19-5914TPX_JungleGreen"
#Pnt_19_5917      = $39422A;  $FF39422A  "#2A4239"  "rgb( 42, 66, 57)"  "rgba( 42, 66, 57,255)"  "19-5917TPX_Sycamore"
#Pnt_19_5918      = $383543;  $FF383543  "#433538"  "rgb( 67, 53, 56)"  "rgba( 67, 53, 56,255)"  "19-5918TPX_MountainView"
#Pnt_19_5920      = $464F37;  $FF464F37  "#374F46"  "rgb( 55, 79, 70)"  "rgba( 55, 79, 70,255)"  "19-5920TPX_Pineneedle"
#Pnt_19_6026      = $526923;  $FF526923  "#236952"  "rgb( 35,105, 82)"  "rgba( 35,105, 82,255)"  "19-6026TPX_VerdantGreen"
#Pnt_19_6050      = $4B403A;  $FF4B403A  "#3A404B"  "rgb( 58, 64, 75)"  "rgba( 58, 64, 75,255)"  "19-6050TPX_Eden"
#Pnt_19_6110      = $3B4137;  $FF3B4137  "#37413B"  "rgb( 55, 65, 59)"  "rgba( 55, 65, 59,255)"  "19-6110TPX_DeepForest"
#Pnt_19_6311      = $324C2C;  $FF324C2C  "#2C4C32"  "rgb( 44, 76, 50)"  "rgba( 44, 76, 50,255)"  "19-6311TPX_GreenerPastures"

;-LOff-Colors, LibrOffice colors
;LOff                     PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              RAL-no + ger. Colorname:
#LOff_Black               = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "Black"
#LOff_White               = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "White"
#LOff_Gray1               = $EEEEEE;  $FFEEEEEE  "#EEEEEE"  "rgb(238,238,238)"  "rgba(238,238,238,255)"  "Gray1"
#LOff_Gray2               = $DDDDDD;  $FFDDDDDD  "#DDDDDD"  "rgb(221,221,221)"  "rgba(221,221,221,255)"  "Gray2"
#LOff_Gray3               = $CCCCCC;  $FFCCCCCC  "#CCCCCC"  "rgb(204,204,204)"  "rgba(204,204,204,255)"  "Gray3"
#LOff_Gray4               = $B2B2B2;  $FFB2B2B2  "#B2B2B2"  "rgb(178,178,178)"  "rgba(178,178,178,255)"  "Gray4"
#LOff_Gray5               = $999999;  $FF999999  "#999999"  "rgb(153,153,153)"  "rgba(153,153,153,255)"  "Gray5"
#LOff_Gray6               = $808080;  $FF808080  "#808080"  "rgb(128,128,128)"  "rgba(128,128,128,255)"  "Gray6"
#LOff_Gray7               = $666666;  $FF666666  "#666666"  "rgb(102,102,102)"  "rgba(102,102,102,255)"  "Gray7"
#LOff_Gray8               = $333333;  $FF333333  "#333333"  "rgb( 51, 51, 51)"  "rgba( 51, 51, 51,255)"  "Gray8"
#LOff_Gray9               = $1C1C1C;  $FF1C1C1C  "#1C1C1C"  "rgb( 28, 28, 28)"  "rgba( 28, 28, 28,255)"  "Gray9"
#LOff_Gray10              = $111111;  $FF111111  "#111111"  "rgb( 17, 17, 17)"  "rgba( 17, 17, 17,255)"  "Gray10"
#LOff_Yellow              = $99FFFF;  $FF99FFFF  "#FFFF99"  "rgb(255,255,153)"  "rgba(255,255,153,255)"  "Yellow"
#LOff_Orange              = $0066FF;  $FF0066FF  "#FF6600"  "rgb(255,102,  0)"  "rgba(255,102,  0,255)"  "Orange"
#LOff_Red                 = $3333FF;  $FF3333FF  "#FF3333"  "rgb(255, 51, 51)"  "rgba(255, 51, 51,255)"  "Red"
#LOff_Pink                = $CC00FF;  $FFCC00FF  "#FF00CC"  "rgb(255,  0,204)"  "rgba(255,  0,204,255)"  "Pink"
#LOff_Magenta             = $FF33FF;  $FFFF33FF  "#FF33FF"  "rgb(255, 51,255)"  "rgba(255, 51,255,255)"  "Magenta"
#LOff_Purple              = $FF0099;  $FFFF0099  "#9900FF"  "rgb(153,  0,255)"  "rgba(153,  0,255,255)"  "Purple"
#LOff_Blue                = $FF6666;  $FFFF6666  "#6666FF"  "rgb(102,102,255)"  "rgba(102,102,255,255)"  "Blue"
#LOff_Skyblue             = $FFCC00;  $FFFFCC00  "#00CCFF"  "rgb(  0,204,255)"  "rgba(  0,204,255,255)"  "Skyblue"
#LOff_Cyan                = $FFFF66;  $FFFFFF66  "#66FFFF"  "rgb(102,255,255)"  "rgba(102,255,255,255)"  "Cyan"
#LOff_Turquoise           = $99FF33;  $FF99FF33  "#33FF99"  "rgb( 51,255,153)"  "rgba( 51,255,153,255)"  "Turquoise"
#LOff_Green               = $66FF99;  $FF66FF99  "#99FF66"  "rgb(153,255,102)"  "rgba(153,255,102,255)"  "Green"
#LOff_Yellowgreen         = $00FFCC;  $FF00FFCC  "#CCFF00"  "rgb(204,255,  0)"  "rgba(204,255,  0,255)"  "Yellowgreen"
#LOff_Yellow1             = $66FFFF;  $FF66FFFF  "#FFFF66"  "rgb(255,255,102)"  "rgba(255,255,102,255)"  "Yellow1"
#LOff_Orange1             = $00CCFF;  $FF00CCFF  "#FFCC00"  "rgb(255,204,  0)"  "rgba(255,204,  0,255)"  "Orange1"
#LOff_Red1                = $9999FF;  $FF9999FF  "#FF9999"  "rgb(255,153,153)"  "rgba(255,153,153,255)"  "Red1"
#LOff_Pink1               = $CC66FF;  $FFCC66FF  "#FF66CC"  "rgb(255,102,204)"  "rgba(255,102,204,255)"  "Pink1"
#LOff_Magenta1            = $FF99FF;  $FFFF99FF  "#FF99FF"  "rgb(255,153,255)"  "rgba(255,153,255,255)"  "Magenta1"
#LOff_Purple1             = $FF66CC;  $FFFF66CC  "#CC66FF"  "rgb(204,102,255)"  "rgba(204,102,255,255)"  "Purple1"
#LOff_Blue1               = $FF9999;  $FFFF9999  "#9999FF"  "rgb(153,153,255)"  "rgba(153,153,255,255)"  "Blue1"
#LOff_Skyblue1            = $FF9999;  $FFFF9999  "#9999FF"  "rgb(153,153,255)"  "rgba(153,153,255,255)"  "Skyblue1"
#LOff_Cyan1               = $FFFF99;  $FFFFFF99  "#99FFFF"  "rgb(153,255,255)"  "rgba(153,255,255,255)"  "Cyan1"
#LOff_Turquoise1          = $99FF66;  $FF99FF66  "#66FF99"  "rgb(102,255,153)"  "rgba(102,255,153,255)"  "Turquoise1"
#LOff_Green1              = $99FF99;  $FF99FF99  "#99FF99"  "rgb(153,255,153)"  "rgba(153,255,153,255)"  "Green1"
#LOff_Yellowgreen1        = $66FFCC;  $FF66FFCC  "#CCFF66"  "rgb(204,255,102)"  "rgba(204,255,102,255)"  "Yellowgreen1"
#LOff_Yellow2             = $00FFFF;  $FF00FFFF  "#FFFF00"  "rgb(255,255,  0)"  "rgba(255,255,  0,255)"  "Yellow2"
#LOff_Orange2             = $0099FF;  $FF0099FF  "#FF9900"  "rgb(255,153,  0)"  "rgba(255,153,  0,255)"  "Orange2"
#LOff_Red2                = $6666FF;  $FF6666FF  "#FF6666"  "rgb(255,102,102)"  "rgba(255,102,102,255)"  "Red2"
#LOff_Pink2               = $9933FF;  $FF9933FF  "#FF3399"  "rgb(255, 51,153)"  "rgba(255, 51,153,255)"  "Pink2"
#LOff_Magenta2            = $FF66FF;  $FFFF66FF  "#FF66FF"  "rgb(255,102,255)"  "rgba(255,102,255,255)"  "Magenta2"
#LOff_Purple2             = $FF3399;  $FFFF3399  "#9933FF"  "rgb(153, 51,255)"  "rgba(153, 51,255,255)"  "Purple2"
#LOff_Blue2               = $FF3333;  $FFFF3333  "#3333FF"  "rgb( 51, 51,255)"  "rgba( 51, 51,255,255)"  "Blue2"
#LOff_Skyblue2            = $FF9933;  $FFFF9933  "#3399FF"  "rgb( 51,153,255)"  "rgba( 51,153,255,255)"  "Skyblue2"
#LOff_Cyan2               = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(  0,255,255)"  "rgba(  0,255,255,255)"  "Cyan2"
#LOff_Turquoise2          = $66FF00;  $FF66FF00  "#00FF66"  "rgb(  0,255,102)"  "rgba(  0,255,102,255)"  "Turquoise2"
#LOff_Green2              = $66FF66;  $FF66FF66  "#66FF66"  "rgb(102,255,102)"  "rgba(102,255,102,255)"  "Green2"
#LOff_Yellowgreen2        = $33FF99;  $FF33FF99  "#99FF33"  "rgb(153,255, 51)"  "rgba(153,255, 51,255)"  "Yellowgreen2"
#LOff_Yellow3             = $0099CC;  $FF0099CC  "#CC9900"  "rgb(204,153,  0)"  "rgba(204,153,  0,255)"  "Yellow3"
#LOff_Orange3             = $0033FF;  $FF0033FF  "#FF3300"  "rgb(255, 51,  0)"  "rgba(255, 51,  0,255)"  "Orange3"
#LOff_Red3                = $0000FF;  $FF0000FF  "#FF0000"  "rgb(255,  0,  0)"  "rgba(255,  0,  0,255)"  "Red3"
#LOff_Pink3               = $6600FF;  $FF6600FF  "#FF0066"  "rgb(255,  0,102)"  "rgba(255,  0,102,255)"  "Pink3"
#LOff_Magenta3            = $FF00FF;  $FFFF00FF  "#FF00FF"  "rgb(255,  0,255)"  "rgba(255,  0,255,255)"  "Magenta3"
#LOff_Purple3             = $FF0066;  $FFFF0066  "#6600FF"  "rgb(102,  0,255)"  "rgba(102,  0,255,255)"  "Purple3"
#LOff_Blue3               = $FF0000;  $FFFF0000  "#0000FF"  "rgb(  0,  0,255)"  "rgba(  0,  0,255,255)"  "Blue3"
#LOff_Skyblue3            = $FF6600;  $FFFF6600  "#0066FF"  "rgb(  0,102,255)"  "rgba(  0,102,255,255)"  "Skyblue3"
#LOff_Cyan3               = $CCCC00;  $FFCCCC00  "#00CCCC"  "rgb(  0,204,204)"  "rgba(  0,204,204,255)"  "Cyan3"
#LOff_Turquoise3          = $33CC00;  $FF33CC00  "#00CC33"  "rgb(  0,204, 51)"  "rgba(  0,204, 51,255)"  "Turquoise3"
#LOff_Green3              = $00CC00;  $FF00CC00  "#00CC00"  "rgb(  0,204,  0)"  "rgba(  0,204,  0,255)"  "Green3"
#LOff_Yellowgreen3        = $00FF66;  $FF00FF66  "#66FF00"  "rgb(102,255,  0)"  "rgba(102,255,  0,255)"  "Yellowgreen3"
#LOff_Yellow4             = $006699;  $FF006699  "#996600"  "rgb(153,102,  0)"  "rgba(153,102,  0,255)"  "Yellow4"
#LOff_Orange4             = $0033CC;  $FF0033CC  "#CC3300"  "rgb(204, 51,  0)"  "rgba(204, 51,  0,255)"  "Orange4"
#LOff_Red4                = $0000CC;  $FF0000CC  "#CC0000"  "rgb(204,  0,  0)"  "rgba(204,  0,  0,255)"  "Red4"
#LOff_Pink4               = $6600CC;  $FF6600CC  "#CC0066"  "rgb(204,  0,102)"  "rgba(204,  0,102,255)"  "Pink4"
#LOff_Magenta4            = $CC00CC;  $FFCC00CC  "#CC00CC"  "rgb(204,  0,204)"  "rgba(204,  0,204,255)"  "Magenta4"
#LOff_Purple4             = $CC0066;  $FFCC0066  "#6600CC"  "rgb(102,  0,204)"  "rgba(102,  0,204,255)"  "Purple4"
#LOff_Blue4               = $CC0000;  $FFCC0000  "#0000CC"  "rgb(  0,  0,204)"  "rgba(  0,  0,204,255)"  "Blue4"
#LOff_Skyblue4            = $CC6600;  $FFCC6600  "#0066CC"  "rgb(  0,102,204)"  "rgba(  0,102,204,255)"  "Skyblue4"
#LOff_Cyan4               = $999900;  $FF999900  "#009999"  "rgb(  0,153,153)"  "rgba(  0,153,153,255)"  "Cyan4"
#LOff_Turquoise4          = $339900;  $FF339900  "#009933"  "rgb(  0,153, 51)"  "rgba(  0,153, 51,255)"  "Turquoise4"
#LOff_Green4              = $009900;  $FF009900  "#009900"  "rgb(  0,153,  0)"  "rgba(  0,153,  0,255)"  "Green4"
#LOff_Yellowgreen4        = $00CC66;  $FF00CC66  "#66CC00"  "rgb(102,204,  0)"  "rgba(102,204,  0,255)"  "Yellowgreen4"
#LOff_Yellow5             = $003366;  $FF003366  "#663300"  "rgb(102, 51,  0)"  "rgba(102, 51,  0,255)"  "Yellow5"
#LOff_Orange5             = $001980;  $FF001980  "#801900"  "rgb(128, 25,  0)"  "rgba(128, 25,  0,255)"  "Orange5"
#LOff_Red5                = $000099;  $FF000099  "#990000"  "rgb(153,  0,  0)"  "rgba(153,  0,  0,255)"  "Red5"
#LOff_Pink5               = $660099;  $FF660099  "#990066"  "rgb(153,  0,102)"  "rgba(153,  0,102,255)"  "Pink5"
#LOff_Magenta5            = $990099;  $FF990099  "#990099"  "rgb(153,  0,153)"  "rgba(153,  0,153,255)"  "Magenta5"
#LOff_Purple5             = $990033;  $FF990033  "#330099"  "rgb( 51,  0,153)"  "rgba( 51,  0,153,255)"  "Purple5"
#LOff_Blue5               = $990000;  $FF990000  "#000099"  "rgb(  0,  0,153)"  "rgba(  0,  0,153,255)"  "Blue5"
#LOff_Skyblue5            = $996600;  $FF996600  "#006699"  "rgb(  0,102,153)"  "rgba(  0,102,153,255)"  "Skyblue5"
#LOff_Cyan5               = $666600;  $FF666600  "#006666"  "rgb(  0,102,102)"  "rgba(  0,102,102,255)"  "Cyan5"
#LOff_Turquoise5          = $267800;  $FF267800  "#007826"  "rgb(  0,120, 38)"  "rgba(  0,120, 38,255)"  "Turquoise5"
#LOff_Green5              = $006600;  $FF006600  "#006600"  "rgb(  0,102,  0)"  "rgba(  0,102,  0,255)"  "Green5"
#LOff_Yellowgreen5        = $009966;  $FF009966  "#669900"  "rgb(102,153,  0)"  "rgba(102,153,  0,255)"  "Yellowgreen5"
#LOff_Yellow6             = $003333;  $FF003333  "#333300"  "rgb( 51, 51,  0)"  "rgba( 51, 51,  0,255)"  "Yellow6"
#LOff_Orange6             = $001946;  $FF001946  "#461900"  "rgb( 70, 25,  0)"  "rgba( 70, 25,  0,255)"  "Orange6"
#LOff_Red6                = $000033;  $FF000033  "#330000"  "rgb( 51,  0,  0)"  "rgba( 51,  0,  0,255)"  "Red6"
#LOff_Pink6               = $330033;  $FF330033  "#330033"  "rgb( 51,  0, 51)"  "rgba( 51,  0, 51,255)"  "Pink6"
#LOff_Magenta6            = $660066;  $FF660066  "#660066"  "rgb(102,  0,102)"  "rgba(102,  0,102,255)"  "Magenta6"
#LOff_Purple6             = $330000;  $FF330000  "#000033"  "rgb(  0,  0, 51)"  "rgba(  0,  0, 51,255)"  "Purple6"
#LOff_Blue6               = $660000;  $FF660000  "#000066"  "rgb(  0,  0,102)"  "rgba(  0,  0,102,255)"  "Blue6"
#LOff_Skyblue6            = $800000;  $FF800000  "#000080"  "rgb(  0,  0,128)"  "rgba(  0,  0,128,255)"  "Skyblue6"
#LOff_Cyan6               = $333300;  $FF333300  "#003333"  "rgb(  0, 51, 51)"  "rgba(  0, 51, 51,255)"  "Cyan6"
#LOff_Turquoise6          = $1A3300;  $FF1A3300  "#00331A"  "rgb(  0, 51, 26)"  "rgba(  0, 51, 26,255)"  "Turquoise6"
#LOff_Green6              = $003300;  $FF003300  "#003300"  "rgb(  0, 51,  0)"  "rgba(  0, 51,  0,255)"  "Green6"
#LOff_Yellowgreen6        = $003319;  $FF003319  "#193300"  "rgb( 25, 51,  0)"  "rgba( 25, 51,  0,255)"  "Yellowgreen6"
#LOff_Yellow7             = $336666;  $FF336666  "#666633"  "rgb(102,102, 51)"  "rgba(102,102, 51,255)"  "Yellow7"
#LOff_Orange7             = $001966;  $FF001966  "#661900"  "rgb(102, 25,  0)"  "rgba(102, 25,  0,255)"  "Orange7"
#LOff_Red7                = $333366;  $FF333366  "#663333"  "rgb(102, 51, 51)"  "rgba(102, 51, 51,255)"  "Red7"
#LOff_Pink7               = $330066;  $FF330066  "#660033"  "rgb(102,  0, 51)"  "rgba(102,  0, 51,255)"  "Pink7"
#LOff_Magenta7            = $663366;  $FF663366  "#663366"  "rgb(102, 51,102)"  "rgba(102, 51,102,255)"  "Magenta7"
#LOff_Purple7             = $660033;  $FF660033  "#330066"  "rgb( 51,  0,102)"  "rgba( 51,  0,102,255)"  "Purple7"
#LOff_Blue7               = $663333;  $FF663333  "#333366"  "rgb( 51, 51,102)"  "rgba( 51, 51,102,255)"  "Blue7"
#LOff_Skyblue7            = $663300;  $FF663300  "#003366"  "rgb(  0, 51,102)"  "rgba(  0, 51,102,255)"  "Skyblue7"
#LOff_Cyan7               = $666633;  $FF666633  "#336666"  "rgb( 51,102,102)"  "rgba( 51,102,102,255)"  "Cyan7"
#LOff_Turquoise7          = $336600;  $FF336600  "#006633"  "rgb(  0,102, 51)"  "rgba(  0,102, 51,255)"  "Turquoise7"
#LOff_Green7              = $336633;  $FF336633  "#336633"  "rgb( 51,102, 51)"  "rgba( 51,102, 51,255)"  "Green7"
#LOff_Yellowgreen7        = $006633;  $FF006633  "#336600"  "rgb( 51,102,  0)"  "rgba( 51,102,  0,255)"  "Yellowgreen7"
#LOff_Yellow8             = $669999;  $FF669999  "#999966"  "rgb(153,153,102)"  "rgba(153,153,102,255)"  "Yellow8"
#LOff_Orange8             = $336699;  $FF336699  "#996633"  "rgb(153,102, 51)"  "rgba(153,102, 51,255)"  "Orange8"
#LOff_Red8                = $666699;  $FF666699  "#996666"  "rgb(153,102,102)"  "rgba(153,102,102,255)"  "Red8"
#LOff_Pink8               = $663399;  $FF663399  "#993366"  "rgb(153, 51,102)"  "rgba(153, 51,102,255)"  "Pink8"
#LOff_Magenta8            = $996699;  $FF996699  "#996699"  "rgb(153,102,153)"  "rgba(153,102,153,255)"  "Magenta8"
#LOff_Purple8             = $993366;  $FF993366  "#663399"  "rgb(102, 51,153)"  "rgba(102, 51,153,255)"  "Purple8"
#LOff_Blue8               = $996666;  $FF996666  "#666699"  "rgb(102,102,153)"  "rgba(102,102,153,255)"  "Blue8"
#LOff_Skyblue8            = $996633;  $FF996633  "#336699"  "rgb( 51,102,153)"  "rgba( 51,102,153,255)"  "Skyblue8"
#LOff_Cyan8               = $999966;  $FF999966  "#669999"  "rgb(102,153,153)"  "rgba(102,153,153,255)"  "Cyan8"
#LOff_Turquoise8          = $669933;  $FF669933  "#339966"  "rgb( 51,153,102)"  "rgba( 51,153,102,255)"  "Turquoise8"
#LOff_Green8              = $669966;  $FF669966  "#669966"  "rgb(102,153,102)"  "rgba(102,153,102,255)"  "Green8"
#LOff_Yellowgreen8        = $339966;  $FF339966  "#669933"  "rgb(102,153, 51)"  "rgba(102,153, 51,255)"  "Yellowgreen8"
#LOff_Yellow9             = $99CCCC;  $FF99CCCC  "#CCCC99"  "rgb(204,204,153)"  "rgba(204,204,153,255)"  "Yellow9"
#LOff_Orange9             = $6699CC;  $FF6699CC  "#CC9966"  "rgb(204,153,102)"  "rgba(204,153,102,255)"  "Orange9"
#LOff_Red9                = $9999CC;  $FF9999CC  "#CC9999"  "rgb(204,153,153)"  "rgba(204,153,153,255)"  "Red9"
#LOff_Pink9               = $9966CC;  $FF9966CC  "#CC6699"  "rgb(204,102,153)"  "rgba(204,102,153,255)"  "Pink9"
#LOff_Magenta9            = $CC99CC;  $FFCC99CC  "#CC99CC"  "rgb(204,153,204)"  "rgba(204,153,204,255)"  "Magenta9"
#LOff_Purple9             = $CC6699;  $FFCC6699  "#9966CC"  "rgb(153,102,204)"  "rgba(153,102,204,255)"  "Purple9"
#LOff_Blue9               = $CC9999;  $FFCC9999  "#9999CC"  "rgb(153,153,204)"  "rgba(153,153,204,255)"  "Blue9"
#LOff_Skyblue9            = $CC9966;  $FFCC9966  "#6699CC"  "rgb(102,153,204)"  "rgba(102,153,204,255)"  "Skyblue9"
#LOff_Cyan9               = $CCCC99;  $FFCCCC99  "#99CCCC"  "rgb(153,204,204)"  "rgba(153,204,204,255)"  "Cyan9"
#LOff_Turquoise9          = $99CC66;  $FF99CC66  "#66CC99"  "rgb(102,204,153)"  "rgba(102,204,153,255)"  "Turquoise9"
#LOff_Green9              = $99CC99;  $FF99CC99  "#99CC99"  "rgb(153,204,153)"  "rgba(153,204,153,255)"  "Green9"
#LOff_Yellowgreen9        = $66CC99;  $FF66CC99  "#99CC66"  "rgb(153,204,102)"  "rgba(153,204,102,255)"  "Yellowgreen9"
#LOff_Yellow10            = $CCFFFF;  $FFCCFFFF  "#FFFFCC"  "rgb(255,255,204)"  "rgba(255,255,204,255)"  "Yellow10"
#LOff_Orange10            = $99CCFF;  $FF99CCFF  "#FFCC99"  "rgb(255,204,153)"  "rgba(255,204,153,255)"  "Orange10"
#LOff_Red10               = $CCCCFF;  $FFCCCCFF  "#FFCCCC"  "rgb(255,204,204)"  "rgba(255,204,204,255)"  "Red10"
#LOff_Pink10              = $CC99FF;  $FFCC99FF  "#FF99CC"  "rgb(255,153,204)"  "rgba(255,153,204,255)"  "Pink10"
#LOff_Magenta10           = $FFCCFF;  $FFFFCCFF  "#FFCCFF"  "rgb(255,204,255)"  "rgba(255,204,255,255)"  "Magenta10"
#LOff_Purple10            = $FF99CC;  $FFFF99CC  "#CC99FF"  "rgb(204,153,255)"  "rgba(204,153,255,255)"  "Purple10"
#LOff_Blue10              = $FFCCCC;  $FFFFCCCC  "#CCCCFF"  "rgb(204,204,255)"  "rgba(204,204,255,255)"  "Blue10"
#LOff_Skyblue10           = $FFCC99;  $FFFFCC99  "#99CCFF"  "rgb(153,204,255)"  "rgba(153,204,255,255)"  "Skyblue10"
#LOff_Cyan10              = $FFFFCC;  $FFFFFFCC  "#CCFFFF"  "rgb(204,255,255)"  "rgba(204,255,255,255)"  "Cyan10"
#LOff_Turquoise10         = $CCFF99;  $FFCCFF99  "#99FFCC"  "rgb(153,255,204)"  "rgba(153,255,204,255)"  "Turquoise10"
#LOff_Green10             = $CCFFCC;  $FFCCFFCC  "#CCFFCC"  "rgb(204,255,204)"  "rgba(204,255,204,255)"  "Green10"
#LOff_Yellowgreen10       = $99FFCC;  $FF99FFCC  "#CCFF99"  "rgb(204,255,153)"  "rgba(204,255,153,255)"  "Yellowgreen10"
#LOff_Bluegray            = $FFE6E6;  $FFFFE6E6  "#E6E6FF"  "rgb(230,230,255)"  "rgba(230,230,255,255)"  "Bluegray"
#LOff_Blueclassic         = $F5E7CF;  $FFF5E7CF  "#CFE7F5"  "rgb(207,231,245)"  "rgba(207,231,245,255)"  "Blueclassic"
#LOff_Violet              = $FF9999;  $FFFF9999  "#9999FF"  "rgb(153,153,255)"  "rgba(153,153,255,255)"  "Violet"
#LOff_Bordeaux            = $663399;  $FF663399  "#993366"  "rgb(153, 51,102)"  "rgba(153, 51,102,255)"  "Bordeaux"
#LOff_Paleyellow          = $CCFFFF;  $FFCCFFFF  "#FFFFCC"  "rgb(255,255,204)"  "rgba(255,255,204,255)"  "Paleyellow"
#LOff_Palegreen           = $CCFFCC;  $FFCCFFCC  "#CCFFCC"  "rgb(204,255,204)"  "rgba(204,255,204,255)"  "Palegreen"
#LOff_Darkviolet          = $660066;  $FF660066  "#660066"  "rgb(102,  0,102)"  "rgba(102,  0,102,255)"  "Darkviolet"
#LOff_Salmon              = $8080FF;  $FF8080FF  "#FF8080"  "rgb(255,128,128)"  "rgba(255,128,128,255)"  "Salmon"
#LOff_Seablue             = $CC6600;  $FFCC6600  "#0066CC"  "rgb(  0,102,204)"  "rgba(  0,102,204,255)"  "Seablue"
#LOff_Chart1              = $864500;  $FF864500  "#004586"  "rgb(  0, 69,134)"  "rgba(  0, 69,134,255)"  "Chart1"
#LOff_Chart2              = $0E42FF;  $FF0E42FF  "#FF420E"  "rgb(255, 66, 14)"  "rgba(255, 66, 14,255)"  "Chart2"
#LOff_Chart3              = $20D3FF;  $FF20D3FF  "#FFD320"  "rgb(255,211, 32)"  "rgba(255,211, 32,255)"  "Chart3"
#LOff_Chart4              = $1C9D57;  $FF1C9D57  "#579D1C"  "rgb( 87,157, 28)"  "rgba( 87,157, 28,255)"  "Chart4"
#LOff_Chart5              = $21007E;  $FF21007E  "#7E0021"  "rgb(126,  0, 33)"  "rgba(126,  0, 33,255)"  "Chart5"
#LOff_Chart6              = $FFCA83;  $FFFFCA83  "#83CAFF"  "rgb(131,202,255)"  "rgba(131,202,255,255)"  "Chart6"
#LOff_Chart7              = $044031;  $FF044031  "#314004"  "rgb( 49, 64,  4)"  "rgba( 49, 64,  4,255)"  "Chart7"
#LOff_Chart8              = $00CFAE;  $FF00CFAE  "#AECF00"  "rgb(174,207,  0)"  "rgba(174,207,  0,255)"  "Chart8"
#LOff_Chart9              = $6F1F4B;  $FF6F1F4B  "#4B1F6F"  "rgb( 75, 31,111)"  "rgba( 75, 31,111,255)"  "Chart9"
#LOff_Chart10             = $0E95FF;  $FF0E95FF  "#FF950E"  "rgb(255,149, 14)"  "rgba(255,149, 14,255)"  "Chart10"
#LOff_Chart11             = $0B00C5;  $FF0B00C5  "#C5000B"  "rgb(197,  0, 11)"  "rgba(197,  0, 11,255)"  "Chart11"
#LOff_Chart12             = $D18400;  $FFD18400  "#0084D1"  "rgb(  0,132,209)"  "rgba(  0,132,209,255)"  "Chart12"
#LOff_TangoSkyBlue1       = $CF9F72;  $FFCF9F72  "#729FCF"  "rgb(114,159,207)"  "rgba(114,159,207,255)"  "TangoSkyBlue1"
#LOff_TangoSkyBlue2       = $A46534;  $FFA46534  "#3465A4"  "rgb( 52,101,164)"  "rgba( 52,101,164,255)"  "TangoSkyBlue2"
#LOff_UbuntuOrange        = $1448DD;  $FF1448DD  "#DD4814"  "rgb(221, 72, 20)"  "rgba(221, 72, 20,255)"  "UbuntuOrange"
#LOff_UbuntuWarmGrey      = $9FA7AE;  $FF9FA7AE  "#AEA79F"  "rgb(174,167,159)"  "rgba(174,167,159,255)"  "UbuntuWarmGrey"
#LOff_UbuntuCoolGrey      = $333333;  $FF333333  "#333333"  "rgb( 51, 51, 51)"  "rgba( 51, 51, 51,255)"  "UbuntuCoolGrey"
#LOff_UbuntuLightAubergine= $6F2177;  $FF6F2177  "#77216F"  "rgb(119, 33,111)"  "rgba(119, 33,111,255)"  "UbuntuLightAubergine"
#LOff_UbuntuMidAubergine  = $50275E;  $FF50275E  "#5E2750"  "rgb( 94, 39, 80)"  "rgba( 94, 39, 80,255)"  "UbuntuMidAubergine"
#LOff_UbuntuDarkAubergine = $1E002C;  $FF1E002C  "#2C001E"  "rgb( 44,  0, 30)"  "rgba( 44,  0, 30,255)"  "UbuntuDarkAubergine"
#LOff_CanonicalAubergine  = $532977;  $FF532977  "#772953"  "rgb(119, 41, 83)"  "rgba(119, 41, 83,255)"  "CanonicalAubergine"

;-xkcd-Color, 
;  see http://xkcd.com/color/rgb.txt
;xkcd-color              PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              xkcd-Colorname:
#XKCD_CloudyBlue          = $D9C2AC;  $FFD9C2AC  "#ACC2D9"  "rgb(172,194,217)"  "rgba(172,194,217,255)"  "CloudyBlue"
#XKCD_DarkPastelGreen     = $57AE56;  $FF57AE56  "#56AE57"  "rgb( 86,174, 87)"  "rgba( 86,174, 87,255)"  "DarkPastelGreen"
#XKCD_Dust                = $6E99B2;  $FF6E99B2  "#B2996E"  "rgb(178,153,110)"  "rgba(178,153,110,255)"  "Dust"
#XKCD_ElectricLime        = $04FFA8;  $FF04FFA8  "#A8FF04"  "rgb(168,255,  4)"  "rgba(168,255,  4,255)"  "ElectricLime"
#XKCD_FreshGreen          = $4FD869;  $FF4FD869  "#69D84F"  "rgb(105,216, 79)"  "rgba(105,216, 79,255)"  "FreshGreen"
#XKCD_LightEggplant       = $854589;  $FF854589  "#894585"  "rgb(137, 69,133)"  "rgba(137, 69,133,255)"  "LightEggplant"
#XKCD_NastyGreen          = $3FB270;  $FF3FB270  "#70B23F"  "rgb(112,178, 63)"  "rgba(112,178, 63,255)"  "NastyGreen"
#XKCD_ReallyLightBlue     = $FFFFD4;  $FFFFFFD4  "#D4FFFF"  "rgb(212,255,255)"  "rgba(212,255,255,255)"  "ReallyLightBlue"
#XKCD_Tea                 = $7CAB65;  $FF7CAB65  "#65AB7C"  "rgb(101,171,124)"  "rgba(101,171,124,255)"  "Tea"
#XKCD_WarmPurple          = $8F2E95;  $FF8F2E95  "#952E8F"  "rgb(149, 46,143)"  "rgba(149, 46,143,255)"  "WarmPurple"
#XKCD_YellowishTan        = $81FCFC;  $FF81FCFC  "#FCFC81"  "rgb(252,252,129)"  "rgba(252,252,129,255)"  "YellowishTan"
#XKCD_Cement              = $91A3A5;  $FF91A3A5  "#A5A391"  "rgb(165,163,145)"  "rgba(165,163,145,255)"  "Cement"
#XKCD_DarkGrassGreen      = $048038;  $FF048038  "#388004"  "rgb( 56,128,  4)"  "rgba( 56,128,  4,255)"  "DarkGrassGreen"
#XKCD_DustyTeal           = $85904C;  $FF85904C  "#4C9085"  "rgb( 76,144,133)"  "rgba( 76,144,133,255)"  "DustyTeal"
#XKCD_GreyTeal            = $8A9B5E;  $FF8A9B5E  "#5E9B8A"  "rgb( 94,155,138)"  "rgba( 94,155,138,255)"  "GreyTeal"
#XKCD_MacaroniAndCheese   = $35B4EF;  $FF35B4EF  "#EFB435"  "rgb(239,180, 53)"  "rgba(239,180, 53,255)"  "MacaroniAndCheese"
#XKCD_PinkishTan          = $829BD9;  $FF829BD9  "#D99B82"  "rgb(217,155,130)"  "rgba(217,155,130,255)"  "PinkishTan"
#XKCD_Spruce              = $385F0A;  $FF385F0A  "#0A5F38"  "rgb( 10, 95, 56)"  "rgba( 10, 95, 56,255)"  "Spruce"
#XKCD_StrongBlue          = $F7060C;  $FFF7060C  "#0C06F7"  "rgb( 12,  6,247)"  "rgba( 12,  6,247,255)"  "StrongBlue"
#XKCD_ToxicGreen          = $2ADE61;  $FF2ADE61  "#61DE2A"  "rgb( 97,222, 42)"  "rgba( 97,222, 42,255)"  "ToxicGreen"
#XKCD_WindowsBlue         = $BF7837;  $FFBF7837  "#3778BF"  "rgb( 55,120,191)"  "rgba( 55,120,191,255)"  "WindowsBlue"
#XKCD_BlueBlue            = $C74222;  $FFC74222  "#2242C7"  "rgb( 34, 66,199)"  "rgba( 34, 66,199,255)"  "BlueBlue"
#XKCD_BlueNPurple         = $C63C53;  $FFC63C53  "#533CC6"  "rgb( 83, 60,198)"  "rgba( 83, 60,198,255)"  "BlueNPurple"
#XKCD_Booger              = $3CB59B;  $FF3CB59B  "#9BB53C"  "rgb(155,181, 60)"  "rgba(155,181, 60,255)"  "Booger"
#XKCD_BrightSeaGreen      = $A6FF05;  $FFA6FF05  "#05FFA6"  "rgb(  5,255,166)"  "rgba(  5,255,166,255)"  "BrightSeaGreen"
#XKCD_DarkGreenBlue       = $57631F;  $FF57631F  "#1F6357"  "rgb( 31, 99, 87)"  "rgba( 31, 99, 87,255)"  "DarkGreenBlue"
#XKCD_DeepTurquoise       = $747301;  $FF747301  "#017374"  "rgb(  1,115,116)"  "rgba(  1,115,116,255)"  "DeepTurquoise"
#XKCD_GreenTeal           = $77B50C;  $FF77B50C  "#0CB577"  "rgb( 12,181,119)"  "rgba( 12,181,119,255)"  "GreenTeal"
#XKCD_StrongPink          = $8907FF;  $FF8907FF  "#FF0789"  "rgb(255,  7,137)"  "rgba(255,  7,137,255)"  "StrongPink"
#XKCD_Bland               = $8BA8AF;  $FF8BA8AF  "#AFA88B"  "rgb(175,168,139)"  "rgba(175,168,139,255)"  "Bland"
#XKCD_DeepAqua            = $7F7808;  $FF7F7808  "#08787F"  "rgb(  8,120,127)"  "rgba(  8,120,127,255)"  "DeepAqua"
#XKCD_LavenderPink        = $D785DD;  $FFD785DD  "#DD85D7"  "rgb(221,133,215)"  "rgba(221,133,215,255)"  "LavenderPink"
#XKCD_LightMossGreen      = $75C8A6;  $FF75C8A6  "#A6C875"  "rgb(166,200,117)"  "rgba(166,200,117,255)"  "LightMossGreen"
#XKCD_LightSeafoamGreen   = $B5FFA7;  $FFB5FFA7  "#A7FFB5"  "rgb(167,255,181)"  "rgba(167,255,181,255)"  "LightSeafoamGreen"
#XKCD_OliveYellow         = $09B7C2;  $FF09B7C2  "#C2B709"  "rgb(194,183,  9)"  "rgba(194,183,  9,255)"  "OliveYellow"
#XKCD_PigPink             = $A58EE7;  $FFA58EE7  "#E78EA5"  "rgb(231,142,165)"  "rgba(231,142,165,255)"  "PigPink"
#XKCD_DeepLilac           = $BD6E96;  $FFBD6E96  "#966EBD"  "rgb(150,110,189)"  "rgba(150,110,189,255)"  "DeepLilac"
#XKCD_Desert              = $60ADCC;  $FF60ADCC  "#CCAD60"  "rgb(204,173, 96)"  "rgba(204,173, 96,255)"  "Desert"
#XKCD_DustyLavender       = $A886AC;  $FFA886AC  "#AC86A8"  "rgb(172,134,168)"  "rgba(172,134,168,255)"  "DustyLavender"
#XKCD_PurpleyGrey         = $947E94;  $FF947E94  "#947E94"  "rgb(148,126,148)"  "rgba(148,126,148,255)"  "PurpleyGrey"
#XKCD_Purply              = $B23F98;  $FFB23F98  "#983FB2"  "rgb(152, 63,178)"  "rgba(152, 63,178,255)"  "Purply"
#XKCD_CandyPink           = $E963FF;  $FFE963FF  "#FF63E9"  "rgb(255, 99,233)"  "rgba(255, 99,233,255)"  "CandyPink"
#XKCD_LightPastelGreen    = $A5FBB2;  $FFA5FBB2  "#B2FBA5"  "rgb(178,251,165)"  "rgba(178,251,165,255)"  "LightPastelGreen"
#XKCD_BoringGreen         = $65B363;  $FF65B363  "#63B365"  "rgb( 99,179,101)"  "rgba( 99,179,101,255)"  "BoringGreen"
#XKCD_KiwiGreen           = $3FE58E;  $FF3FE58E  "#8EE53F"  "rgb(142,229, 63)"  "rgba(142,229, 63,255)"  "KiwiGreen"
#XKCD_LightGreyGreen      = $A1E1B7;  $FFA1E1B7  "#B7E1A1"  "rgb(183,225,161)"  "rgba(183,225,161,255)"  "LightGreyGreen"
#XKCD_OrangePink          = $526FFF;  $FF526FFF  "#FF6F52"  "rgb(255,111, 82)"  "rgba(255,111, 82,255)"  "OrangePink"
#XKCD_TeaGreen            = $A3F8BD;  $FFA3F8BD  "#BDF8A3"  "rgb(189,248,163)"  "rgba(189,248,163,255)"  "TeaGreen"
#XKCD_VeryLightBrown      = $83B6D3;  $FF83B6D3  "#D3B683"  "rgb(211,182,131)"  "rgba(211,182,131,255)"  "VeryLightBrown"
#XKCD_EggShell            = $C4FCFF;  $FFC4FCFF  "#FFFCC4"  "rgb(255,252,196)"  "rgba(255,252,196,255)"  "EggShell"
#XKCD_EggplantPurple      = $410543;  $FF410543  "#430541"  "rgb( 67,  5, 65)"  "rgba( 67,  5, 65,255)"  "EggplantPurple"
#XKCD_PowderPink          = $D0B2FF;  $FFD0B2FF  "#FFB2D0"  "rgb(255,178,208)"  "rgba(255,178,208,255)"  "PowderPink"
#XKCD_ReddishGrey         = $707599;  $FF707599  "#997570"  "rgb(153,117,112)"  "rgba(153,117,112,255)"  "ReddishGrey"
#XKCD_BabyShitBrown       = $0D90AD;  $FF0D90AD  "#AD900D"  "rgb(173,144, 13)"  "rgba(173,144, 13,255)"  "BabyShitBrown"
#XKCD_Liliac              = $FD8EC4;  $FFFD8EC4  "#C48EFD"  "rgb(196,142,253)"  "rgba(196,142,253,255)"  "Liliac"
#XKCD_StormyBlue          = $9C7B50;  $FF9C7B50  "#507B9C"  "rgb( 80,123,156)"  "rgba( 80,123,156,255)"  "StormyBlue"
#XKCD_UglyBrown           = $03717D;  $FF03717D  "#7D7103"  "rgb(125,113,  3)"  "rgba(125,113,  3,255)"  "UglyBrown"
#XKCD_Custard             = $78FDFF;  $FF78FDFF  "#FFFD78"  "rgb(255,253,120)"  "rgba(255,253,120,255)"  "Custard"
#XKCD_DarkishPink         = $7D46DA;  $FF7D46DA  "#DA467D"  "rgb(218, 70,125)"  "rgba(218, 70,125,255)"  "DarkishPink"
#XKCD_DeepBrown           = $000241;  $FF000241  "#410200"  "rgb( 65,  2,  0)"  "rgba( 65,  2,  0,255)"  "DeepBrown"
#XKCD_GreenishBeige       = $79D1C9;  $FF79D1C9  "#C9D179"  "rgb(201,209,121)"  "rgba(201,209,121,255)"  "GreenishBeige"
#XKCD_Manilla             = $86FAFF;  $FF86FAFF  "#FFFA86"  "rgb(255,250,134)"  "rgba(255,250,134,255)"  "Manilla"
#XKCD_OffBlue             = $AE8456;  $FFAE8456  "#5684AE"  "rgb( 86,132,174)"  "rgba( 86,132,174,255)"  "OffBlue"
#XKCD_BattleshipGrey      = $857C6B;  $FF857C6B  "#6B7C85"  "rgb(107,124,133)"  "rgba(107,124,133,255)"  "BattleshipGrey"
#XKCD_BrownyGreen         = $0A6C6F;  $FF0A6C6F  "#6F6C0A"  "rgb(111,108, 10)"  "rgba(111,108, 10,255)"  "BrownyGreen"
#XKCD_Bruise              = $71407E;  $FF71407E  "#7E4071"  "rgb(126, 64,113)"  "rgba(126, 64,113,255)"  "Bruise"
#XKCD_KelleyGreen         = $379300;  $FF379300  "#009337"  "rgb(  0,147, 55)"  "rgba(  0,147, 55,255)"  "KelleyGreen"
#XKCD_SicklyYellow        = $29E4D0;  $FF29E4D0  "#D0E429"  "rgb(208,228, 41)"  "rgba(208,228, 41,255)"  "SicklyYellow"
#XKCD_SunnyYellow         = $17F9FF;  $FF17F9FF  "#FFF917"  "rgb(255,249, 23)"  "rgba(255,249, 23,255)"  "SunnyYellow"
#XKCD_Azul                = $EC5D1D;  $FFEC5D1D  "#1D5DEC"  "rgb( 29, 93,236)"  "rgba( 29, 93,236,255)"  "Azul"
#XKCD_Darkgreen           = $074905;  $FF074905  "#054907"  "rgb(  5, 73,  7)"  "rgba(  5, 73,  7,255)"  "Darkgreen"
#XKCD_Greenyellow         = $08CEB5;  $FF08CEB5  "#B5CE08"  "rgb(181,206,  8)"  "rgba(181,206,  8,255)"  "Greenyellow"
#XKCD_Lichen              = $7BB68F;  $FF7BB68F  "#8FB67B"  "rgb(143,182,123)"  "rgba(143,182,123,255)"  "Lichen"
#XKCD_LightLightGreen     = $B0FFC8;  $FFB0FFC8  "#C8FFB0"  "rgb(200,255,176)"  "rgba(200,255,176,255)"  "LightLightGreen"
#XKCD_PaleGold            = $6CDEFD;  $FF6CDEFD  "#FDDE6C"  "rgb(253,222,108)"  "rgba(253,222,108,255)"  "PaleGold"
#XKCD_SunYellow           = $22DFFF;  $FF22DFFF  "#FFDF22"  "rgb(255,223, 34)"  "rgba(255,223, 34,255)"  "SunYellow"
#XKCD_TanGreen            = $70BEA9;  $FF70BEA9  "#A9BE70"  "rgb(169,190,112)"  "rgba(169,190,112,255)"  "TanGreen"
#XKCD_Burple              = $E33268;  $FFE33268  "#6832E3"  "rgb(104, 50,227)"  "rgba(104, 50,227,255)"  "Burple"
#XKCD_Butterscotch        = $47B1FD;  $FF47B1FD  "#FDB147"  "rgb(253,177, 71)"  "rgba(253,177, 71,255)"  "Butterscotch"
#XKCD_Toupe               = $7DACC7;  $FF7DACC7  "#C7AC7D"  "rgb(199,172,125)"  "rgba(199,172,125,255)"  "Toupe"
#XKCD_DarkCream           = $9AF3FF;  $FF9AF3FF  "#FFF39A"  "rgb(255,243,154)"  "rgba(255,243,154,255)"  "DarkCream"
#XKCD_IndianRed           = $040E85;  $FF040E85  "#850E04"  "rgb(133, 14,  4)"  "rgba(133, 14,  4,255)"  "IndianRed"
#XKCD_LightLavendar       = $FEC0EF;  $FFFEC0EF  "#EFC0FE"  "rgb(239,192,254)"  "rgba(239,192,254,255)"  "LightLavendar"
#XKCD_PoisonGreen         = $14FD40;  $FF14FD40  "#40FD14"  "rgb( 64,253, 20)"  "rgba( 64,253, 20,255)"  "PoisonGreen"
#XKCD_BabyPukeGreen       = $06C4B6;  $FF06C4B6  "#B6C406"  "rgb(182,196,  6)"  "rgba(182,196,  6,255)"  "BabyPukeGreen"
#XKCD_BrightYellowGreen   = $00FF9D;  $FF00FF9D  "#9DFF00"  "rgb(157,255,  0)"  "rgba(157,255,  0,255)"  "BrightYellowGreen"
#XKCD_CharcoalGrey        = $42413C;  $FF42413C  "#3C4142"  "rgb( 60, 65, 66)"  "rgba( 60, 65, 66,255)"  "CharcoalGrey"
#XKCD_Squash              = $15ABF2;  $FF15ABF2  "#F2AB15"  "rgb(242,171, 21)"  "rgba(242,171, 21,255)"  "Squash"
#XKCD_Cinnamon            = $064FAC;  $FF064FAC  "#AC4F06"  "rgb(172, 79,  6)"  "rgba(172, 79,  6,255)"  "Cinnamon"
#XKCD_LightPeaGreen       = $82FEC4;  $FF82FEC4  "#C4FE82"  "rgb(196,254,130)"  "rgba(196,254,130,255)"  "LightPeaGreen"
#XKCD_RadioactiveGreen    = $1FFA2C;  $FF1FFA2C  "#2CFA1F"  "rgb( 44,250, 31)"  "rgba( 44,250, 31,255)"  "RadioactiveGreen"
#XKCD_RawSienna           = $00629A;  $FF00629A  "#9A6200"  "rgb(154, 98,  0)"  "rgba(154, 98,  0,255)"  "RawSienna"
#XKCD_BabyPurple          = $F79BCA;  $FFF79BCA  "#CA9BF7"  "rgb(202,155,247)"  "rgba(202,155,247,255)"  "BabyPurple"
#XKCD_Cocoa               = $425F87;  $FF425F87  "#875F42"  "rgb(135, 95, 66)"  "rgba(135, 95, 66,255)"  "Cocoa"
#XKCD_LightRoyalBlue      = $FE2E3A;  $FFFE2E3A  "#3A2EFE"  "rgb( 58, 46,254)"  "rgba( 58, 46,254,255)"  "LightRoyalBlue"
#XKCD_Orangeish           = $498DFD;  $FF498DFD  "#FD8D49"  "rgb(253,141, 73)"  "rgba(253,141, 73,255)"  "Orangeish"
#XKCD_RustBrown           = $03318B;  $FF03318B  "#8B3103"  "rgb(139, 49,  3)"  "rgba(139, 49,  3,255)"  "RustBrown"
#XKCD_SandBrown           = $60A5CB;  $FF60A5CB  "#CBA560"  "rgb(203,165, 96)"  "rgba(203,165, 96,255)"  "SandBrown"
#XKCD_Swamp               = $398369;  $FF398369  "#698339"  "rgb(105,131, 57)"  "rgba(105,131, 57,255)"  "Swamp"
#XKCD_TealishGreen        = $73DC0C;  $FF73DC0C  "#0CDC73"  "rgb( 12,220,115)"  "rgba( 12,220,115,255)"  "TealishGreen"
#XKCD_BurntSiena          = $0352B7;  $FF0352B7  "#B75203"  "rgb(183, 82,  3)"  "rgba(183, 82,  3,255)"  "BurntSiena"
#XKCD_Camo                = $4E8F7F;  $FF4E8F7F  "#7F8F4E"  "rgb(127,143, 78)"  "rgba(127,143, 78,255)"  "Camo"
#XKCD_DuskBlue            = $8D5326;  $FF8D5326  "#26538D"  "rgb( 38, 83,141)"  "rgba( 38, 83,141,255)"  "DuskBlue"
#XKCD_Fern                = $50A963;  $FF50A963  "#63A950"  "rgb( 99,169, 80)"  "rgba( 99,169, 80,255)"  "Fern"
#XKCD_OldRose             = $897FC8;  $FF897FC8  "#C87F89"  "rgb(200,127,137)"  "rgba(200,127,137,255)"  "OldRose"
#XKCD_PaleLightGreen      = $99FCB1;  $FF99FCB1  "#B1FC99"  "rgb(177,252,153)"  "rgba(177,252,153,255)"  "PaleLightGreen"
#XKCD_PeachyPink          = $8A9AFF;  $FF8A9AFF  "#FF9A8A"  "rgb(255,154,138)"  "rgba(255,154,138,255)"  "PeachyPink"
#XKCD_RosyPink            = $8E68F6;  $FF8E68F6  "#F6688E"  "rgb(246,104,142)"  "rgba(246,104,142,255)"  "RosyPink"
#XKCD_LightBluishGreen    = $A8FD76;  $FFA8FD76  "#76FDA8"  "rgb(118,253,168)"  "rgba(118,253,168,255)"  "LightBluishGreen"
#XKCD_LightBrightGreen    = $5CFE53;  $FF5CFE53  "#53FE5C"  "rgb( 83,254, 92)"  "rgba( 83,254, 92,255)"  "LightBrightGreen"
#XKCD_LightNeonGreen      = $54FD4E;  $FF54FD4E  "#4EFD54"  "rgb( 78,253, 84)"  "rgba( 78,253, 84,255)"  "LightNeonGreen"
#XKCD_LightSeafoam        = $BFFEA0;  $FFBFFEA0  "#A0FEBF"  "rgb(160,254,191)"  "rgba(160,254,191,255)"  "LightSeafoam"
#XKCD_TiffanyBlue         = $DAF27B;  $FFDAF27B  "#7BF2DA"  "rgb(123,242,218)"  "rgba(123,242,218,255)"  "TiffanyBlue"
#XKCD_WashedOutGreen      = $A6F5BC;  $FFA6F5BC  "#BCF5A6"  "rgb(188,245,166)"  "rgba(188,245,166,255)"  "WashedOutGreen"
#XKCD_BrownyOrange        = $026BCA;  $FF026BCA  "#CA6B02"  "rgb(202,107,  2)"  "rgba(202,107,  2,255)"  "BrownyOrange"
#XKCD_NiceBlue            = $B07A10;  $FFB07A10  "#107AB0"  "rgb( 16,122,176)"  "rgba( 16,122,176,255)"  "NiceBlue"
#XKCD_Sapphire            = $AB3821;  $FFAB3821  "#2138AB"  "rgb( 33, 56,171)"  "rgba( 33, 56,171,255)"  "Sapphire"
#XKCD_GreyishTeal         = $919F71;  $FF919F71  "#719F91"  "rgb(113,159,145)"  "rgba(113,159,145,255)"  "GreyishTeal"
#XKCD_OrangeyYellow       = $15B9FD;  $FF15B9FD  "#FDB915"  "rgb(253,185, 21)"  "rgba(253,185, 21,255)"  "OrangeyYellow"
#XKCD_Parchment           = $AFFCFE;  $FFAFFCFE  "#FEFCAF"  "rgb(254,252,175)"  "rgba(254,252,175,255)"  "Parchment"
#XKCD_Straw               = $79F6FC;  $FF79F6FC  "#FCF679"  "rgb(252,246,121)"  "rgba(252,246,121,255)"  "Straw"
#XKCD_VeryDarkBrown       = $00021D;  $FF00021D  "#1D0200"  "rgb( 29,  2,  0)"  "rgba( 29,  2,  0,255)"  "VeryDarkBrown"
#XKCD_Terracota           = $4368CB;  $FF4368CB  "#CB6843"  "rgb(203,104, 67)"  "rgba(203,104, 67,255)"  "Terracota"
#XKCD_UglyBlue            = $8A6631;  $FF8A6631  "#31668A"  "rgb( 49,102,138)"  "rgba( 49,102,138,255)"  "UglyBlue"
#XKCD_ClearBlue           = $FD7A24;  $FFFD7A24  "#247AFD"  "rgb( 36,122,253)"  "rgba( 36,122,253,255)"  "ClearBlue"
#XKCD_Creme               = $B6FFFF;  $FFB6FFFF  "#FFFFB6"  "rgb(255,255,182)"  "rgba(255,255,182,255)"  "Creme"
#XKCD_FoamGreen           = $A9FD90;  $FFA9FD90  "#90FDA9"  "rgb(144,253,169)"  "rgba(144,253,169,255)"  "FoamGreen"
#XKCD_Greygreen           = $7DA186;  $FF7DA186  "#86A17D"  "rgb(134,161,125)"  "rgba(134,161,125,255)"  "Greygreen"
#XKCD_LightGold           = $5CDCFD;  $FF5CDCFD  "#FDDC5C"  "rgb(253,220, 92)"  "rgba(253,220, 92,255)"  "LightGold"
#XKCD_SeafoamBlue         = $B6D178;  $FFB6D178  "#78D1B6"  "rgb(120,209,182)"  "rgba(120,209,182,255)"  "SeafoamBlue"
#XKCD_Topaz               = $AFBB13;  $FFAFBB13  "#13BBAF"  "rgb( 19,187,175)"  "rgba( 19,187,175,255)"  "Topaz"
#XKCD_VioletPink          = $FC5FFB;  $FFFC5FFB  "#FB5FFC"  "rgb(251, 95,252)"  "rgba(251, 95,252,255)"  "VioletPink"
#XKCD_Wintergreen         = $86F920;  $FF86F920  "#20F986"  "rgb( 32,249,134)"  "rgba( 32,249,134,255)"  "Wintergreen"
#XKCD_YellowTan           = $6EE3FF;  $FF6EE3FF  "#FFE36E"  "rgb(255,227,110)"  "rgba(255,227,110,255)"  "YellowTan"
#XKCD_DarkFuchsia         = $59079D;  $FF59079D  "#9D0759"  "rgb(157,  7, 89)"  "rgba(157,  7, 89,255)"  "DarkFuchsia"
#XKCD_IndigoBlue          = $B1183A;  $FFB1183A  "#3A18B1"  "rgb( 58, 24,177)"  "rgba( 58, 24,177,255)"  "IndigoBlue"
#XKCD_LightYellowishGreen = $89FFC2;  $FF89FFC2  "#C2FF89"  "rgb(194,255,137)"  "rgba(194,255,137,255)"  "LightYellowishGreen"
#XKCD_PaleMagenta         = $AD67D7;  $FFAD67D7  "#D767AD"  "rgb(215,103,173)"  "rgba(215,103,173,255)"  "PaleMagenta"
#XKCD_RichPurple          = $580072;  $FF580072  "#720058"  "rgb(114,  0, 88)"  "rgba(114,  0, 88,255)"  "RichPurple"
#XKCD_SunflowerYellow     = $03DAFF;  $FF03DAFF  "#FFDA03"  "rgb(255,218,  3)"  "rgba(255,218,  3,255)"  "SunflowerYellow"
#XKCD_Greenblue           = $8DC001;  $FF8DC001  "#01C08D"  "rgb(  1,192,141)"  "rgba(  1,192,141,255)"  "Greenblue"
#XKCD_Leather             = $3474AC;  $FF3474AC  "#AC7434"  "rgb(172,116, 52)"  "rgba(172,116, 52,255)"  "Leather"
#XKCD_RacingGreen         = $004601;  $FF004601  "#014600"  "rgb(  1, 70,  0)"  "rgba(  1, 70,  0,255)"  "RacingGreen"
#XKCD_VividPurple         = $FA0099;  $FFFA0099  "#9900FA"  "rgb(153,  0,250)"  "rgba(153,  0,250,255)"  "VividPurple"
#XKCD_DarkRoyalBlue       = $6F0602;  $FF6F0602  "#02066F"  "rgb(  2,  6,111)"  "rgba(  2,  6,111,255)"  "DarkRoyalBlue"
#XKCD_Hazel               = $18768E;  $FF18768E  "#8E7618"  "rgb(142,118, 24)"  "rgba(142,118, 24,255)"  "Hazel"
#XKCD_MutedPink           = $8F76D1;  $FF8F76D1  "#D1768F"  "rgb(209,118,143)"  "rgba(209,118,143,255)"  "MutedPink"
#XKCD_BoogerGreen         = $03B496;  $FF03B496  "#96B403"  "rgb(150,180,  3)"  "rgba(150,180,  3,255)"  "BoogerGreen"
#XKCD_Canary              = $63FFFD;  $FF63FFFD  "#FDFF63"  "rgb(253,255, 99)"  "rgba(253,255, 99,255)"  "Canary"
#XKCD_CoolGrey            = $A6A395;  $FFA6A395  "#95A3A6"  "rgb(149,163,166)"  "rgba(149,163,166,255)"  "CoolGrey"
#XKCD_DarkTaupe           = $4E687F;  $FF4E687F  "#7F684E"  "rgb(127,104, 78)"  "rgba(127,104, 78,255)"  "DarkTaupe"
#XKCD_DarkishPurple       = $731975;  $FF731975  "#751973"  "rgb(117, 25,115)"  "rgba(117, 25,115,255)"  "DarkishPurple"
#XKCD_TrueGreen           = $049408;  $FF049408  "#089404"  "rgb(  8,148,  4)"  "rgba(  8,148,  4,255)"  "TrueGreen"
#XKCD_CoralPink           = $6361FF;  $FF6361FF  "#FF6163"  "rgb(255, 97, 99)"  "rgba(255, 97, 99,255)"  "CoralPink"
#XKCD_DarkSage            = $568559;  $FF568559  "#598556"  "rgb( 89,133, 86)"  "rgba( 89,133, 86,255)"  "DarkSage"
#XKCD_DarkSlateBlue       = $614721;  $FF614721  "#214761"  "rgb( 33, 71, 97)"  "rgba( 33, 71, 97,255)"  "DarkSlateBlue"
#XKCD_FlatBlue            = $A8733C;  $FFA8733C  "#3C73A8"  "rgb( 60,115,168)"  "rgba( 60,115,168,255)"  "FlatBlue"
#XKCD_Mushroom            = $889EBA;  $FF889EBA  "#BA9E88"  "rgb(186,158,136)"  "rgba(186,158,136,255)"  "Mushroom"
#XKCD_RichBlue            = $F91B02;  $FFF91B02  "#021BF9"  "rgb(  2, 27,249)"  "rgba(  2, 27,249,255)"  "RichBlue"
#XKCD_DirtyPurple         = $654A73;  $FF654A73  "#734A65"  "rgb(115, 74,101)"  "rgba(115, 74,101,255)"  "DirtyPurple"
#XKCD_Greenblue1          = $8BC423;  $FF8BC423  "#23C48B"  "rgb( 35,196,139)"  "rgba( 35,196,139,255)"  "Greenblue1"
#XKCD_IckyGreen           = $22AE8F;  $FF22AE8F  "#8FAE22"  "rgb(143,174, 34)"  "rgba(143,174, 34,255)"  "IckyGreen"
#XKCD_LightKhaki          = $A2F2E6;  $FFA2F2E6  "#E6F2A2"  "rgb(230,242,162)"  "rgba(230,242,162,255)"  "LightKhaki"
#XKCD_WarmBlue            = $DB574B;  $FFDB574B  "#4B57DB"  "rgb( 75, 87,219)"  "rgba( 75, 87,219,255)"  "WarmBlue"
#XKCD_DarkHotPink         = $6601D9;  $FF6601D9  "#D90166"  "rgb(217,  1,102)"  "rgba(217,  1,102,255)"  "DarkHotPink"
#XKCD_DeepSeaBlue         = $825401;  $FF825401  "#015482"  "rgb(  1, 84,130)"  "rgba(  1, 84,130,255)"  "DeepSeaBlue"
#XKCD_Carmine             = $16029D;  $FF16029D  "#9D0216"  "rgb(157,  2, 22)"  "rgba(157,  2, 22,255)"  "Carmine"
#XKCD_DarkYellowGreen     = $028F72;  $FF028F72  "#728F02"  "rgb(114,143,  2)"  "rgba(114,143,  2,255)"  "DarkYellowGreen"
#XKCD_PalePeach           = $ADE5FF;  $FFADE5FF  "#FFE5AD"  "rgb(255,229,173)"  "rgba(255,229,173,255)"  "PalePeach"
#XKCD_PlumPurple          = $50054E;  $FF50054E  "#4E0550"  "rgb( 78,  5, 80)"  "rgba( 78,  5, 80,255)"  "PlumPurple"
#XKCD_GoldenRod           = $08BCF9;  $FF08BCF9  "#F9BC08"  "rgb(249,188,  8)"  "rgba(249,188,  8,255)"  "GoldenRod"
#XKCD_NeonRed             = $3A07FF;  $FF3A07FF  "#FF073A"  "rgb(255,  7, 58)"  "rgba(255,  7, 58,255)"  "NeonRed"
#XKCD_OldPink             = $8679C7;  $FF8679C7  "#C77986"  "rgb(199,121,134)"  "rgba(199,121,134,255)"  "OldPink"
#XKCD_VeryPaleBlue        = $FEFFD6;  $FFFEFFD6  "#D6FFFE"  "rgb(214,255,254)"  "rgba(214,255,254,255)"  "VeryPaleBlue"
#XKCD_BloodOrange         = $034BFE;  $FF034BFE  "#FE4B03"  "rgb(254, 75,  3)"  "rgba(254, 75,  3,255)"  "BloodOrange"
#XKCD_Grapefruit          = $5659FD;  $FF5659FD  "#FD5956"  "rgb(253, 89, 86)"  "rgba(253, 89, 86,255)"  "Grapefruit"
#XKCD_SandYellow          = $66E1FC;  $FF66E1FC  "#FCE166"  "rgb(252,225,102)"  "rgba(252,225,102,255)"  "SandYellow"
#XKCD_ClayBrown           = $3D71B2;  $FF3D71B2  "#B2713D"  "rgb(178,113, 61)"  "rgba(178,113, 61,255)"  "ClayBrown"
#XKCD_DarkBlueGrey        = $4D3B1F;  $FF4D3B1F  "#1F3B4D"  "rgb( 31, 59, 77)"  "rgba( 31, 59, 77,255)"  "DarkBlueGrey"
#XKCD_FlatGreen           = $4C9D69;  $FF4C9D69  "#699D4C"  "rgb(105,157, 76)"  "rgba(105,157, 76,255)"  "FlatGreen"
#XKCD_LightGreenBlue      = $A2FC56;  $FFA2FC56  "#56FCA2"  "rgb( 86,252,162)"  "rgba( 86,252,162,255)"  "LightGreenBlue"
#XKCD_WarmPink            = $8155FB;  $FF8155FB  "#FB5581"  "rgb(251, 85,129)"  "rgba(251, 85,129,255)"  "WarmPink"
#XKCD_DodgerBlue          = $FC823E;  $FFFC823E  "#3E82FC"  "rgb( 62,130,252)"  "rgba( 62,130,252,255)"  "DodgerBlue"
#XKCD_GrossGreen          = $16BFA0;  $FF16BFA0  "#A0BF16"  "rgb(160,191, 22)"  "rgba(160,191, 22,255)"  "GrossGreen"
#XKCD_Ice                 = $FAFFD6;  $FFFAFFD6  "#D6FFFA"  "rgb(214,255,250)"  "rgba(214,255,250,255)"  "Ice"
#XKCD_MetallicBlue        = $8E734F;  $FF8E734F  "#4F738E"  "rgb( 79,115,142)"  "rgba( 79,115,142,255)"  "MetallicBlue"
#XKCD_PaleSalmon          = $9AB1FF;  $FF9AB1FF  "#FFB19A"  "rgb(255,177,154)"  "rgba(255,177,154,255)"  "PaleSalmon"
#XKCD_SapGreen            = $158B5C;  $FF158B5C  "#5C8B15"  "rgb( 92,139, 21)"  "rgba( 92,139, 21,255)"  "SapGreen"
#XKCD_Algae               = $68AC54;  $FF68AC54  "#54AC68"  "rgb( 84,172,104)"  "rgba( 84,172,104,255)"  "Algae"
#XKCD_BlueyGrey           = $B0A089;  $FFB0A089  "#89A0B0"  "rgb(137,160,176)"  "rgba(137,160,176,255)"  "BlueyGrey"
#XKCD_GreenyGrey          = $7AA07E;  $FF7AA07E  "#7EA07A"  "rgb(126,160,122)"  "rgba(126,160,122,255)"  "GreenyGrey"
#XKCD_HighlighterGreen    = $06FC1B;  $FF06FC1B  "#1BFC06"  "rgb( 27,252,  6)"  "rgba( 27,252,  6,255)"  "HighlighterGreen"
#XKCD_LightLightBlue      = $FBFFCA;  $FFFBFFCA  "#CAFFFB"  "rgb(202,255,251)"  "rgba(202,255,251,255)"  "LightLightBlue"
#XKCD_LightMint           = $BBFFB6;  $FFBBFFB6  "#B6FFBB"  "rgb(182,255,187)"  "rgba(182,255,187,255)"  "LightMint"
#XKCD_RawUmber            = $095EA7;  $FF095EA7  "#A75E09"  "rgb(167, 94,  9)"  "rgba(167, 94,  9,255)"  "RawUmber"
#XKCD_VividBlue           = $FF2E15;  $FFFF2E15  "#152EFF"  "rgb( 21, 46,255)"  "rgba( 21, 46,255,255)"  "VividBlue"
#XKCD_DeepLavender        = $B75E8D;  $FFB75E8D  "#8D5EB7"  "rgb(141, 94,183)"  "rgba(141, 94,183,255)"  "DeepLavender"
#XKCD_DullTeal            = $8F9E5F;  $FF8F9E5F  "#5F9E8F"  "rgb( 95,158,143)"  "rgba( 95,158,143,255)"  "DullTeal"
#XKCD_LightGreenishBlue   = $B4F763;  $FFB4F763  "#63F7B4"  "rgb( 99,247,180)"  "rgba( 99,247,180,255)"  "LightGreenishBlue"
#XKCD_MudGreen            = $026660;  $FF026660  "#606602"  "rgb( 96,102,  2)"  "rgba( 96,102,  2,255)"  "MudGreen"
#XKCD_Pinky               = $AA86FC;  $FFAA86FC  "#FC86AA"  "rgb(252,134,170)"  "rgba(252,134,170,255)"  "Pinky"
#XKCD_RedWine             = $34008C;  $FF34008C  "#8C0034"  "rgb(140,  0, 52)"  "rgba(140,  0, 52,255)"  "RedWine"
#XKCD_ShitGreen           = $008075;  $FF008075  "#758000"  "rgb(117,128,  0)"  "rgba(117,128,  0,255)"  "ShitGreen"
#XKCD_TanBrown            = $4C7EAB;  $FF4C7EAB  "#AB7E4C"  "rgb(171,126, 76)"  "rgba(171,126, 76,255)"  "TanBrown"
#XKCD_Darkblue            = $640703;  $FF640703  "#030764"  "rgb(  3,  7,100)"  "rgba(  3,  7,100,255)"  "Darkblue"
#XKCD_Rosa                = $A486FE;  $FFA486FE  "#FE86A4"  "rgb(254,134,164)"  "rgba(254,134,164,255)"  "Rosa"
#XKCD_Lipstick            = $4E17D5;  $FF4E17D5  "#D5174E"  "rgb(213, 23, 78)"  "rgba(213, 23, 78,255)"  "Lipstick"
#XKCD_PaleMauve           = $FCD0FE;  $FFFCD0FE  "#FED0FC"  "rgb(254,208,252)"  "rgba(254,208,252,255)"  "PaleMauve"
#XKCD_Claret              = $180068;  $FF180068  "#680018"  "rgb(104,  0, 24)"  "rgba(104,  0, 24,255)"  "Claret"
#XKCD_Dandelion           = $08DFFE;  $FF08DFFE  "#FEDF08"  "rgb(254,223,  8)"  "rgba(254,223,  8,255)"  "Dandelion"
#XKCD_Orangered           = $0F42FE;  $FF0F42FE  "#FE420F"  "rgb(254, 66, 15)"  "rgba(254, 66, 15,255)"  "Orangered"
#XKCD_PoopGreen           = $007C6F;  $FF007C6F  "#6F7C00"  "rgb(111,124,  0)"  "rgba(111,124,  0,255)"  "PoopGreen"
#XKCD_Ruby                = $4701CA;  $FF4701CA  "#CA0147"  "rgb(202,  1, 71)"  "rgba(202,  1, 71,255)"  "Ruby"
#XKCD_Dark                = $31241B;  $FF31241B  "#1B2431"  "rgb( 27, 36, 49)"  "rgba( 27, 36, 49,255)"  "Dark"
#XKCD_GreenishTurquoise   = $B0FB00;  $FFB0FB00  "#00FBB0"  "rgb(  0,251,176)"  "rgba(  0,251,176,255)"  "GreenishTurquoise"
#XKCD_PastelRed           = $5658DB;  $FF5658DB  "#DB5856"  "rgb(219, 88, 86)"  "rgba(219, 88, 86,255)"  "PastelRed"
#XKCD_PissYellow          = $18D6DD;  $FF18D6DD  "#DDD618"  "rgb(221,214, 24)"  "rgba(221,214, 24,255)"  "PissYellow"
#XKCD_BrightCyan          = $FEFD41;  $FFFEFD41  "#41FDFE"  "rgb( 65,253,254)"  "rgba( 65,253,254,255)"  "BrightCyan"
#XKCD_DarkCoral           = $4E52CF;  $FF4E52CF  "#CF524E"  "rgb(207, 82, 78)"  "rgba(207, 82, 78,255)"  "DarkCoral"
#XKCD_AlgaeGreen          = $6FC321;  $FF6FC321  "#21C36F"  "rgb( 33,195,111)"  "rgba( 33,195,111,255)"  "AlgaeGreen"
#XKCD_DarkishRed          = $0803A9;  $FF0803A9  "#A90308"  "rgb(169,  3,  8)"  "rgba(169,  3,  8,255)"  "DarkishRed"
#XKCD_ReddyBrown          = $05106E;  $FF05106E  "#6E1005"  "rgb(110, 16,  5)"  "rgba(110, 16,  5,255)"  "ReddyBrown"
#XKCD_BlushPink           = $8C82FE;  $FF8C82FE  "#FE828C"  "rgb(254,130,140)"  "rgba(254,130,140,255)"  "BlushPink"
#XKCD_CamouflageGreen     = $13614B;  $FF13614B  "#4B6113"  "rgb( 75, 97, 19)"  "rgba( 75, 97, 19,255)"  "CamouflageGreen"
#XKCD_LawnGreen           = $09A44D;  $FF09A44D  "#4DA409"  "rgb( 77,164,  9)"  "rgba( 77,164,  9,255)"  "LawnGreen"
#XKCD_Putty               = $8AAEBE;  $FF8AAEBE  "#BEAE8A"  "rgb(190,174,138)"  "rgba(190,174,138,255)"  "Putty"
#XKCD_VibrantBlue         = $F83903;  $FFF83903  "#0339F8"  "rgb(  3, 57,248)"  "rgba(  3, 57,248,255)"  "VibrantBlue"
#XKCD_DarkSand            = $598FA8;  $FF598FA8  "#A88F59"  "rgb(168,143, 89)"  "rgba(168,143, 89,255)"  "DarkSand"
#XKCD_Purpleblue          = $D0215D;  $FFD0215D  "#5D21D0"  "rgb( 93, 33,208)"  "rgba( 93, 33,208,255)"  "Purpleblue"
#XKCD_Saffron             = $09B2FE;  $FF09B2FE  "#FEB209"  "rgb(254,178,  9)"  "rgba(254,178,  9,255)"  "Saffron"
#XKCD_Twilight            = $8B514E;  $FF8B514E  "#4E518B"  "rgb( 78, 81,139)"  "rgba( 78, 81,139,255)"  "Twilight"
#XKCD_WarmBrown           = $024E96;  $FF024E96  "#964E02"  "rgb(150, 78,  2)"  "rgba(150, 78,  2,255)"  "WarmBrown"
#XKCD_Bluegrey            = $B2A385;  $FFB2A385  "#85A3B2"  "rgb(133,163,178)"  "rgba(133,163,178,255)"  "Bluegrey"
#XKCD_BubbleGumPink       = $AF69FF;  $FFAF69FF  "#FF69AF"  "rgb(255,105,175)"  "rgba(255,105,175,255)"  "BubbleGumPink"
#XKCD_DuckEggBlue         = $F4FBC3;  $FFF4FBC3  "#C3FBF4"  "rgb(195,251,244)"  "rgba(195,251,244,255)"  "DuckEggBlue"
#XKCD_GreenishCyan        = $B7FE2A;  $FFB7FE2A  "#2AFEB7"  "rgb( 42,254,183)"  "rgba( 42,254,183,255)"  "GreenishCyan"
#XKCD_Petrol              = $6A5F00;  $FF6A5F00  "#005F6A"  "rgb(  0, 95,106)"  "rgba(  0, 95,106,255)"  "Petrol"
#XKCD_Royal               = $93170C;  $FF93170C  "#0C1793"  "rgb( 12, 23,147)"  "rgba( 12, 23,147,255)"  "Royal"
#XKCD_Butter              = $81FFFF;  $FF81FFFF  "#FFFF81"  "rgb(255,255,129)"  "rgba(255,255,129,255)"  "Butter"
#XKCD_DustyOrange         = $3A83F0;  $FF3A83F0  "#F0833A"  "rgb(240,131, 58)"  "rgba(240,131, 58,255)"  "DustyOrange"
#XKCD_OffYellow           = $3FF3F1;  $FF3FF3F1  "#F1F33F"  "rgb(241,243, 63)"  "rgba(241,243, 63,255)"  "OffYellow"
#XKCD_PaleOliveGreen      = $7BD2B1;  $FF7BD2B1  "#B1D27B"  "rgb(177,210,123)"  "rgba(177,210,123,255)"  "PaleOliveGreen"
#XKCD_Orangish            = $4A82FC;  $FF4A82FC  "#FC824A"  "rgb(252,130, 74)"  "rgba(252,130, 74,255)"  "Orangish"
#XKCD_Leaf                = $34AA71;  $FF34AA71  "#71AA34"  "rgb(113,170, 52)"  "rgba(113,170, 52,255)"  "Leaf"
#XKCD_LightBlueGrey       = $E2C9B7;  $FFE2C9B7  "#B7C9E2"  "rgb(183,201,226)"  "rgba(183,201,226,255)"  "LightBlueGrey"
#XKCD_DriedBlood          = $01014B;  $FF01014B  "#4B0101"  "rgb( 75,  1,  1)"  "rgba( 75,  1,  1,255)"  "DriedBlood"
#XKCD_LightishPurple      = $E652A5;  $FFE652A5  "#A552E6"  "rgb(165, 82,230)"  "rgba(165, 82,230,255)"  "LightishPurple"
#XKCD_RustyRed            = $0D2FAF;  $FF0D2FAF  "#AF2F0D"  "rgb(175, 47, 13)"  "rgba(175, 47, 13,255)"  "RustyRed"
#XKCD_LavenderBlue        = $F8888B;  $FFF8888B  "#8B88F8"  "rgb(139,136,248)"  "rgba(139,136,248,255)"  "LavenderBlue"
#XKCD_LightGrassGreen     = $64F79A;  $FF64F79A  "#9AF764"  "rgb(154,247,100)"  "rgba(154,247,100,255)"  "LightGrassGreen"
#XKCD_LightMintGreen      = $B2FBA6;  $FFB2FBA6  "#A6FBB2"  "rgb(166,251,178)"  "rgba(166,251,178,255)"  "LightMintGreen"
#XKCD_Sunflower           = $12C5FF;  $FF12C5FF  "#FFC512"  "rgb(255,197, 18)"  "rgba(255,197, 18,255)"  "Sunflower"
#XKCD_Velvet              = $510875;  $FF510875  "#750851"  "rgb(117,  8, 81)"  "rgba(117,  8, 81,255)"  "Velvet"
#XKCD_BrickOrange         = $094AC1;  $FF094AC1  "#C14A09"  "rgb(193, 74,  9)"  "rgba(193, 74,  9,255)"  "BrickOrange"
#XKCD_LightishRed         = $4A2FFE;  $FF4A2FFE  "#FE2F4A"  "rgb(254, 47, 74)"  "rgba(254, 47, 74,255)"  "LightishRed"
#XKCD_PureBlue            = $E20302;  $FFE20302  "#0203E2"  "rgb(  2,  3,226)"  "rgba(  2,  3,226,255)"  "PureBlue"
#XKCD_TwilightBlue        = $7A430A;  $FF7A430A  "#0A437A"  "rgb( 10, 67,122)"  "rgba( 10, 67,122,255)"  "TwilightBlue"
#XKCD_VioletRed           = $5500A5;  $FF5500A5  "#A50055"  "rgb(165,  0, 85)"  "rgba(165,  0, 85,255)"  "VioletRed"
#XKCD_YellowyBrown        = $0C8BAE;  $FF0C8BAE  "#AE8B0C"  "rgb(174,139, 12)"  "rgba(174,139, 12,255)"  "YellowyBrown"
#XKCD_Carnation           = $8F79FD;  $FF8F79FD  "#FD798F"  "rgb(253,121,143)"  "rgba(253,121,143,255)"  "Carnation"
#XKCD_MuddyYellow         = $05ACBF;  $FF05ACBF  "#BFAC05"  "rgb(191,172,  5)"  "rgba(191,172,  5,255)"  "MuddyYellow"
#XKCD_DarkSeafoamGreen    = $76AF3E;  $FF76AF3E  "#3EAF76"  "rgb( 62,175,118)"  "rgba( 62,175,118,255)"  "DarkSeafoamGreen"
#XKCD_DeepRose            = $6747C7;  $FF6747C7  "#C74767"  "rgb(199, 71,103)"  "rgba(199, 71,103,255)"  "DeepRose"
#XKCD_DustyRed            = $4E48B9;  $FF4E48B9  "#B9484E"  "rgb(185, 72, 78)"  "rgba(185, 72, 78,255)"  "DustyRed"
#XKCD_Greyblue            = $8E7D64;  $FF8E7D64  "#647D8E"  "rgb(100,125,142)"  "rgba(100,125,142,255)"  "Greyblue"
#XKCD_LemonLime           = $28FEBF;  $FF28FEBF  "#BFFE28"  "rgb(191,254, 40)"  "rgba(191,254, 40,255)"  "LemonLime"
#XKCD_Purplepink          = $DE25D7;  $FFDE25D7  "#D725DE"  "rgb(215, 37,222)"  "rgba(215, 37,222,255)"  "Purplepink"
#XKCD_BrownYellow         = $0597B2;  $FF0597B2  "#B29705"  "rgb(178,151,  5)"  "rgba(178,151,  5,255)"  "BrownYellow"
#XKCD_PurpleBrown         = $3F3A67;  $FF3F3A67  "#673A3F"  "rgb(103, 58, 63)"  "rgba(103, 58, 63,255)"  "PurpleBrown"
#XKCD_Wisteria            = $C27DA8;  $FFC27DA8  "#A87DC2"  "rgb(168,125,194)"  "rgba(168,125,194,255)"  "Wisteria"
#XKCD_BananaYellow        = $4BFEFA;  $FF4BFEFA  "#FAFE4B"  "rgb(250,254, 75)"  "rgba(250,254, 75,255)"  "BananaYellow"
#XKCD_LipstickRed         = $2F02C0;  $FF2F02C0  "#C0022F"  "rgb(192,  2, 47)"  "rgba(192,  2, 47,255)"  "LipstickRed"
#XKCD_WaterBlue           = $CC870E;  $FFCC870E  "#0E87CC"  "rgb( 14,135,204)"  "rgba( 14,135,204,255)"  "WaterBlue"
#XKCD_BrownGrey           = $68848D;  $FF68848D  "#8D8468"  "rgb(141,132,104)"  "rgba(141,132,104,255)"  "BrownGrey"
#XKCD_VibrantPurple       = $DE03AD;  $FFDE03AD  "#AD03DE"  "rgb(173,  3,222)"  "rgba(173,  3,222,255)"  "VibrantPurple"
#XKCD_BabyGreen           = $9EFF8C;  $FF9EFF8C  "#8CFF9E"  "rgb(140,255,158)"  "rgba(140,255,158,255)"  "BabyGreen"
#XKCD_BarfGreen           = $02AC94;  $FF02AC94  "#94AC02"  "rgb(148,172,  2)"  "rgba(148,172,  2,255)"  "BarfGreen"
#XKCD_EggshellBlue        = $F7FFC4;  $FFF7FFC4  "#C4FFF7"  "rgb(196,255,247)"  "rgba(196,255,247,255)"  "EggshellBlue"
#XKCD_SandyYellow         = $73EEFD;  $FF73EEFD  "#FDEE73"  "rgb(253,238,115)"  "rgba(253,238,115,255)"  "SandyYellow"
#XKCD_CoolGreen           = $64B833;  $FF64B833  "#33B864"  "rgb( 51,184,100)"  "rgba( 51,184,100,255)"  "CoolGreen"
#XKCD_Pale                = $D0F9FF;  $FFD0F9FF  "#FFF9D0"  "rgb(255,249,208)"  "rgba(255,249,208,255)"  "Pale"
#XKCD_Bluegrey1           = $A38D75;  $FFA38D75  "#758DA3"  "rgb(117,141,163)"  "rgba(117,141,163,255)"  "Bluegrey1"
#XKCD_HotMagenta          = $C904F5;  $FFC904F5  "#F504C9"  "rgb(245,  4,201)"  "rgba(245,  4,201,255)"  "HotMagenta"
#XKCD_Greyblue2           = $B5A177;  $FFB5A177  "#77A1B5"  "rgb(119,161,181)"  "rgba(119,161,181,255)"  "Greyblue2"
#XKCD_Purpley             = $E45687;  $FFE45687  "#8756E4"  "rgb(135, 86,228)"  "rgba(135, 86,228,255)"  "Purpley"
#XKCD_BabyShitGreen       = $179788;  $FF179788  "#889717"  "rgb(136,151, 23)"  "rgba(136,151, 23,255)"  "BabyShitGreen"
#XKCD_BrownishPink        = $797EC2;  $FF797EC2  "#C27E79"  "rgb(194,126,121)"  "rgba(194,126,121,255)"  "BrownishPink"
#XKCD_DarkAquamarine      = $717301;  $FF717301  "#017371"  "rgb(  1,115,113)"  "rgba(  1,115,113,255)"  "DarkAquamarine"
#XKCD_Diarrhea            = $03839F;  $FF03839F  "#9F8303"  "rgb(159,131,  3)"  "rgba(159,131,  3,255)"  "Diarrhea"
#XKCD_LightMustard        = $60D5F7;  $FF60D5F7  "#F7D560"  "rgb(247,213, 96)"  "rgba(247,213, 96,255)"  "LightMustard"
#XKCD_PaleSkyBlue         = $FEF6BD;  $FFFEF6BD  "#BDF6FE"  "rgb(189,246,254)"  "rgba(189,246,254,255)"  "PaleSkyBlue"
#XKCD_TurtleGreen         = $4FB875;  $FF4FB875  "#75B84F"  "rgb(117,184, 79)"  "rgba(117,184, 79,255)"  "TurtleGreen"
#XKCD_BrightOlive         = $04BB9C;  $FF04BB9C  "#9CBB04"  "rgb(156,187,  4)"  "rgba(156,187,  4,255)"  "BrightOlive"
#XKCD_DarkGreyBlue        = $5B4629;  $FF5B4629  "#29465B"  "rgb( 41, 70, 91)"  "rgba( 41, 70, 91,255)"  "DarkGreyBlue"
#XKCD_GreenyBrown         = $066069;  $FF066069  "#696006"  "rgb(105, 96,  6)"  "rgba(105, 96,  6,255)"  "GreenyBrown"
#XKCD_LemonGreen          = $02F8AD;  $FF02F8AD  "#ADF802"  "rgb(173,248,  2)"  "rgba(173,248,  2,255)"  "LemonGreen"
#XKCD_LightPeriwinkle     = $FCC6C1;  $FFFCC6C1  "#C1C6FC"  "rgb(193,198,252)"  "rgba(193,198,252,255)"  "LightPeriwinkle"
#XKCD_SeaweedGreen        = $6BAD35;  $FF6BAD35  "#35AD6B"  "rgb( 53,173,107)"  "rgba( 53,173,107,255)"  "SeaweedGreen"
#XKCD_SunshineYellow      = $37FDFF;  $FF37FDFF  "#FFFD37"  "rgb(255,253, 55)"  "rgba(255,253, 55,255)"  "SunshineYellow"
#XKCD_UglyPurple          = $A042A4;  $FFA042A4  "#A442A0"  "rgb(164, 66,160)"  "rgba(164, 66,160,255)"  "UglyPurple"
#XKCD_MediumPink          = $9661F3;  $FF9661F3  "#F36196"  "rgb(243, 97,150)"  "rgba(243, 97,150,255)"  "MediumPink"
#XKCD_PukeBrown           = $067794;  $FF067794  "#947706"  "rgb(148,119,  6)"  "rgba(148,119,  6,255)"  "PukeBrown"
#XKCD_VeryLightPink       = $F2F4FF;  $FFF2F4FF  "#FFF4F2"  "rgb(255,244,242)"  "rgba(255,244,242,255)"  "VeryLightPink"
#XKCD_Viridian            = $67911E;  $FF67911E  "#1E9167"  "rgb( 30,145,103)"  "rgba( 30,145,103,255)"  "Viridian"
#XKCD_Bile                = $06C3B5;  $FF06C3B5  "#B5C306"  "rgb(181,195,  6)"  "rgba(181,195,  6,255)"  "Bile"
#XKCD_FadedYellow         = $7FFFFE;  $FF7FFFFE  "#FEFF7F"  "rgb(254,255,127)"  "rgba(254,255,127,255)"  "FadedYellow"
#XKCD_VeryPaleGreen       = $BCFDCF;  $FFBCFDCF  "#CFFDBC"  "rgb(207,253,188)"  "rgba(207,253,188,255)"  "VeryPaleGreen"
#XKCD_VibrantGreen        = $08DD0A;  $FF08DD0A  "#0ADD08"  "rgb( 10,221,  8)"  "rgba( 10,221,  8,255)"  "VibrantGreen"
#XKCD_BrightLime          = $05FD87;  $FF05FD87  "#87FD05"  "rgb(135,253,  5)"  "rgba(135,253,  5,255)"  "BrightLime"
#XKCD_Spearmint           = $76F81E;  $FF76F81E  "#1EF876"  "rgb( 30,248,118)"  "rgba( 30,248,118,255)"  "Spearmint"
#XKCD_LightAquamarine     = $C7FD7B;  $FFC7FD7B  "#7BFDC7"  "rgb(123,253,199)"  "rgba(123,253,199,255)"  "LightAquamarine"
#XKCD_LightSage           = $ACECBC;  $FFACECBC  "#BCECAC"  "rgb(188,236,172)"  "rgba(188,236,172,255)"  "LightSage"
#XKCD_Yellowgreen         = $0FF9BB;  $FF0FF9BB  "#BBF90F"  "rgb(187,249, 15)"  "rgba(187,249, 15,255)"  "Yellowgreen"
#XKCD_BabyPoo             = $0490AB;  $FF0490AB  "#AB9004"  "rgb(171,144,  4)"  "rgba(171,144,  4,255)"  "BabyPoo"
#XKCD_DarkSeafoam         = $7AB51F;  $FF7AB51F  "#1FB57A"  "rgb( 31,181,122)"  "rgba( 31,181,122,255)"  "DarkSeafoam"
#XKCD_DeepTeal            = $5A5500;  $FF5A5500  "#00555A"  "rgb(  0, 85, 90)"  "rgba(  0, 85, 90,255)"  "DeepTeal"
#XKCD_Heather             = $AC84A4;  $FFAC84A4  "#A484AC"  "rgb(164,132,172)"  "rgba(164,132,172,255)"  "Heather"
#XKCD_RustOrange          = $0855C4;  $FF0855C4  "#C45508"  "rgb(196, 85,  8)"  "rgba(196, 85,  8,255)"  "RustOrange"
#XKCD_DirtyBlue           = $9D823F;  $FF9D823F  "#3F829D"  "rgb( 63,130,157)"  "rgba( 63,130,157,255)"  "DirtyBlue"
#XKCD_FernGreen           = $448D54;  $FF448D54  "#548D44"  "rgb( 84,141, 68)"  "rgba( 84,141, 68,255)"  "FernGreen"
#XKCD_BrightLilac         = $FB5EC9;  $FFFB5EC9  "#C95EFB"  "rgb(201, 94,251)"  "rgba(201, 94,251,255)"  "BrightLilac"
#XKCD_WeirdGreen          = $7FE53A;  $FF7FE53A  "#3AE57F"  "rgb( 58,229,127)"  "rgba( 58,229,127,255)"  "WeirdGreen"
#XKCD_PeacockBlue         = $956701;  $FF956701  "#016795"  "rgb(  1,103,149)"  "rgba(  1,103,149,255)"  "PeacockBlue"
#XKCD_AvocadoGreen        = $22A987;  $FF22A987  "#87A922"  "rgb(135,169, 34)"  "rgba(135,169, 34,255)"  "AvocadoGreen"
#XKCD_FadedOrange         = $4D94F0;  $FF4D94F0  "#F0944D"  "rgb(240,148, 77)"  "rgba(240,148, 77,255)"  "FadedOrange"
#XKCD_GrapePurple         = $51145D;  $FF51145D  "#5D1451"  "rgb( 93, 20, 81)"  "rgba( 93, 20, 81,255)"  "GrapePurple"
#XKCD_HotGreen            = $29FF25;  $FF29FF25  "#25FF29"  "rgb( 37,255, 41)"  "rgba( 37,255, 41,255)"  "HotGreen"
#XKCD_LimeYellow          = $1DFED0;  $FF1DFED0  "#D0FE1D"  "rgb(208,254, 29)"  "rgba(208,254, 29,255)"  "LimeYellow"
#XKCD_Mango               = $2BA6FF;  $FF2BA6FF  "#FFA62B"  "rgb(255,166, 43)"  "rgba(255,166, 43,255)"  "Mango"
#XKCD_Shamrock            = $4CB401;  $FF4CB401  "#01B44C"  "rgb(  1,180, 76)"  "rgba(  1,180, 76,255)"  "Shamrock"
#XKCD_Bubblegum           = $B56CFF;  $FFB56CFF  "#FF6CB5"  "rgb(255,108,181)"  "rgba(255,108,181,255)"  "Bubblegum"
#XKCD_PurplishBrown       = $47426B;  $FF47426B  "#6B4247"  "rgb(107, 66, 71)"  "rgba(107, 66, 71,255)"  "PurplishBrown"
#XKCD_VomitYellow         = $0CC1C7;  $FF0CC1C7  "#C7C10C"  "rgb(199,193, 12)"  "rgba(199,193, 12,255)"  "VomitYellow"
#XKCD_PaleCyan            = $FAFFB7;  $FFFAFFB7  "#B7FFFA"  "rgb(183,255,250)"  "rgba(183,255,250,255)"  "PaleCyan"
#XKCD_KeyLime             = $6EFFAE;  $FF6EFFAE  "#AEFF6E"  "rgb(174,255,110)"  "rgba(174,255,110,255)"  "KeyLime"
#XKCD_TomatoRed           = $012DEC;  $FF012DEC  "#EC2D01"  "rgb(236, 45,  1)"  "rgba(236, 45,  1,255)"  "TomatoRed"
#XKCD_Lightgreen          = $7BFF76;  $FF7BFF76  "#76FF7B"  "rgb(118,255,123)"  "rgba(118,255,123,255)"  "Lightgreen"
#XKCD_Merlot              = $390073;  $FF390073  "#730039"  "rgb(115,  0, 57)"  "rgba(115,  0, 57,255)"  "Merlot"
#XKCD_NightBlue           = $480304;  $FF480304  "#040348"  "rgb(  4,  3, 72)"  "rgba(  4,  3, 72,255)"  "NightBlue"
#XKCD_PurpleishPink       = $C84EDF;  $FFC84EDF  "#DF4EC8"  "rgb(223, 78,200)"  "rgba(223, 78,200,255)"  "PurpleishPink"
#XKCD_Apple               = $3CCB6E;  $FF3CCB6E  "#6ECB3C"  "rgb(110,203, 60)"  "rgba(110,203, 60,255)"  "Apple"
#XKCD_BabyPoopGreen       = $05988F;  $FF05988F  "#8F9805"  "rgb(143,152,  5)"  "rgba(143,152,  5,255)"  "BabyPoopGreen"
#XKCD_GreenApple          = $1FDC5E;  $FF1FDC5E  "#5EDC1F"  "rgb( 94,220, 31)"  "rgba( 94,220, 31,255)"  "GreenApple"
#XKCD_Heliotrope          = $F54FD9;  $FFF54FD9  "#D94FF5"  "rgb(217, 79,245)"  "rgba(217, 79,245,255)"  "Heliotrope"
#XKCD_Yellowgreen2        = $3DFDC8;  $FF3DFDC8  "#C8FD3D"  "rgb(200,253, 61)"  "rgba(200,253, 61,255)"  "Yellowgreen2"
#XKCD_AlmostBlack         = $0D0D07;  $FF0D0D07  "#070D0D"  "rgb(  7, 13, 13)"  "rgba(  7, 13, 13,255)"  "AlmostBlack"
#XKCD_CoolBlue            = $B88449;  $FFB88449  "#4984B8"  "rgb( 73,132,184)"  "rgba( 73,132,184,255)"  "CoolBlue"
#XKCD_LeafyGreen          = $3BB751;  $FF3BB751  "#51B73B"  "rgb( 81,183, 59)"  "rgba( 81,183, 59,255)"  "LeafyGreen"
#XKCD_MustardBrown        = $047EAC;  $FF047EAC  "#AC7E04"  "rgb(172,126,  4)"  "rgba(172,126,  4,255)"  "MustardBrown"
#XKCD_Dusk                = $81544E;  $FF81544E  "#4E5481"  "rgb( 78, 84,129)"  "rgba( 78, 84,129,255)"  "Dusk"
#XKCD_DullBrown           = $4B6E87;  $FF4B6E87  "#876E4B"  "rgb(135,110, 75)"  "rgba(135,110, 75,255)"  "DullBrown"
#XKCD_FrogGreen           = $08BC58;  $FF08BC58  "#58BC08"  "rgb( 88,188,  8)"  "rgba( 88,188,  8,255)"  "FrogGreen"
#XKCD_VividGreen          = $10EF2F;  $FF10EF2F  "#2FEF10"  "rgb( 47,239, 16)"  "rgba( 47,239, 16,255)"  "VividGreen"
#XKCD_BrightLightGreen    = $54FE2D;  $FF54FE2D  "#2DFE54"  "rgb( 45,254, 84)"  "rgba( 45,254, 84,255)"  "BrightLightGreen"
#XKCD_FluroGreen          = $02FF0A;  $FF02FF0A  "#0AFF02"  "rgb( 10,255,  2)"  "rgba( 10,255,  2,255)"  "FluroGreen"
#XKCD_Kiwi                = $43EF9C;  $FF43EF9C  "#9CEF43"  "rgb(156,239, 67)"  "rgba(156,239, 67,255)"  "Kiwi"
#XKCD_Seaweed             = $7BD118;  $FF7BD118  "#18D17B"  "rgb( 24,209,123)"  "rgba( 24,209,123,255)"  "Seaweed"
#XKCD_NavyGreen           = $0A5335;  $FF0A5335  "#35530A"  "rgb( 53, 83, 10)"  "rgba( 53, 83, 10,255)"  "NavyGreen"
#XKCD_UltramarineBlue     = $DB0518;  $FFDB0518  "#1805DB"  "rgb( 24,  5,219)"  "rgba( 24,  5,219,255)"  "UltramarineBlue"
#XKCD_Iris                = $C45862;  $FFC45862  "#6258C4"  "rgb( 98, 88,196)"  "rgba( 98, 88,196,255)"  "Iris"
#XKCD_PastelOrange        = $4F96FF;  $FF4F96FF  "#FF964F"  "rgb(255,150, 79)"  "rgba(255,150, 79,255)"  "PastelOrange"
#XKCD_YellowishOrange     = $0FABFF;  $FF0FABFF  "#FFAB0F"  "rgb(255,171, 15)"  "rgba(255,171, 15,255)"  "YellowishOrange"
#XKCD_Perrywinkle         = $E78C8F;  $FFE78C8F  "#8F8CE7"  "rgb(143,140,231)"  "rgba(143,140,231,255)"  "Perrywinkle"
#XKCD_Tealish             = $A8BC24;  $FFA8BC24  "#24BCA8"  "rgb( 36,188,168)"  "rgba( 36,188,168,255)"  "Tealish"
#XKCD_DarkPlum            = $2C013F;  $FF2C013F  "#3F012C"  "rgb( 63,  1, 44)"  "rgba( 63,  1, 44,255)"  "DarkPlum"
#XKCD_Pear                = $5FF8CB;  $FF5FF8CB  "#CBF85F"  "rgb(203,248, 95)"  "rgba(203,248, 95,255)"  "Pear"
#XKCD_PinkishOrange       = $4C72FF;  $FF4C72FF  "#FF724C"  "rgb(255,114, 76)"  "rgba(255,114, 76,255)"  "PinkishOrange"
#XKCD_MidnightPurple      = $370128;  $FF370128  "#280137"  "rgb( 40,  1, 55)"  "rgba( 40,  1, 55,255)"  "MidnightPurple"
#XKCD_LightUrple          = $F66FB3;  $FFF66FB3  "#B36FF6"  "rgb(179,111,246)"  "rgba(179,111,246,255)"  "LightUrple"
#XKCD_DarkMint            = $72C048;  $FF72C048  "#48C072"  "rgb( 72,192,114)"  "rgba( 72,192,114,255)"  "DarkMint"
#XKCD_GreenishTan         = $7ACBBC;  $FF7ACBBC  "#BCCB7A"  "rgb(188,203,122)"  "rgba(188,203,122,255)"  "GreenishTan"
#XKCD_LightBurgundy       = $5B41A8;  $FF5B41A8  "#A8415B"  "rgb(168, 65, 91)"  "rgba(168, 65, 91,255)"  "LightBurgundy"
#XKCD_TurquoiseBlue       = $C4B106;  $FFC4B106  "#06B1C4"  "rgb(  6,177,196)"  "rgba(  6,177,196,255)"  "TurquoiseBlue"
#XKCD_UglyPink            = $8475CD;  $FF8475CD  "#CD7584"  "rgb(205,117,132)"  "rgba(205,117,132,255)"  "UglyPink"
#XKCD_Sandy               = $7ADAF1;  $FF7ADAF1  "#F1DA7A"  "rgb(241,218,122)"  "rgba(241,218,122,255)"  "Sandy"
#XKCD_ElectricPink        = $9004FF;  $FF9004FF  "#FF0490"  "rgb(255,  4,144)"  "rgba(255,  4,144,255)"  "ElectricPink"
#XKCD_MutedPurple         = $875B80;  $FF875B80  "#805B87"  "rgb(128, 91,135)"  "rgba(128, 91,135,255)"  "MutedPurple"
#XKCD_MidGreen            = $47A750;  $FF47A750  "#50A747"  "rgb( 80,167, 71)"  "rgba( 80,167, 71,255)"  "MidGreen"
#XKCD_Greyish             = $95A4A8;  $FF95A4A8  "#A8A495"  "rgb(168,164,149)"  "rgba(168,164,149,255)"  "Greyish"
#XKCD_NeonYellow          = $04FFCF;  $FF04FFCF  "#CFFF04"  "rgb(207,255,  4)"  "rgba(207,255,  4,255)"  "NeonYellow"
#XKCD_Banana              = $7EFFFF;  $FF7EFFFF  "#FFFF7E"  "rgb(255,255,126)"  "rgba(255,255,126,255)"  "Banana"
#XKCD_CarnationPink       = $A77FFF;  $FFA77FFF  "#FF7FA7"  "rgb(255,127,167)"  "rgba(255,127,167,255)"  "CarnationPink"
#XKCD_Tomato              = $2640EF;  $FF2640EF  "#EF4026"  "rgb(239, 64, 38)"  "rgba(239, 64, 38,255)"  "Tomato"
#XKCD_Sea                 = $92993C;  $FF92993C  "#3C9992"  "rgb( 60,153,146)"  "rgba( 60,153,146,255)"  "Sea"
#XKCD_MuddyBrown          = $066888;  $FF066888  "#886806"  "rgb(136,104,  6)"  "rgba(136,104,  6,255)"  "MuddyBrown"
#XKCD_TurquoiseGreen      = $89F404;  $FF89F404  "#04F489"  "rgb(  4,244,137)"  "rgba(  4,244,137,255)"  "TurquoiseGreen"
#XKCD_Buff                = $9EF6FE;  $FF9EF6FE  "#FEF69E"  "rgb(254,246,158)"  "rgba(254,246,158,255)"  "Buff"
#XKCD_Fawn                = $7BAFCF;  $FF7BAFCF  "#CFAF7B"  "rgb(207,175,123)"  "rgba(207,175,123,255)"  "Fawn"
#XKCD_MutedBlue           = $9F713B;  $FF9F713B  "#3B719F"  "rgb( 59,113,159)"  "rgba( 59,113,159,255)"  "MutedBlue"
#XKCD_PaleRose            = $C5C1FD;  $FFC5C1FD  "#FDC1C5"  "rgb(253,193,197)"  "rgba(253,193,197,255)"  "PaleRose"
#XKCD_DarkMintGreen       = $73C020;  $FF73C020  "#20C073"  "rgb( 32,192,115)"  "rgba( 32,192,115,255)"  "DarkMintGreen"
#XKCD_Amethyst            = $C05F9B;  $FFC05F9B  "#9B5FC0"  "rgb(155, 95,192)"  "rgba(155, 95,192,255)"  "Amethyst"
#XKCD_Bluegreen           = $8E9B0F;  $FF8E9B0F  "#0F9B8E"  "rgb( 15,155,142)"  "rgba( 15,155,142,255)"  "Bluegreen"
#XKCD_Chestnut            = $022874;  $FF022874  "#742802"  "rgb(116, 40,  2)"  "rgba(116, 40,  2,255)"  "Chestnut"
#XKCD_SickGreen           = $2CB99D;  $FF2CB99D  "#9DB92C"  "rgb(157,185, 44)"  "rgba(157,185, 44,255)"  "SickGreen"
#XKCD_Pea                 = $20BFA4;  $FF20BFA4  "#A4BF20"  "rgb(164,191, 32)"  "rgba(164,191, 32,255)"  "Pea"
#XKCD_RustyOrange         = $0959CD;  $FF0959CD  "#CD5909"  "rgb(205, 89,  9)"  "rgba(205, 89,  9,255)"  "RustyOrange"
#XKCD_Stone               = $87A5AD;  $FF87A5AD  "#ADA587"  "rgb(173,165,135)"  "rgba(173,165,135,255)"  "Stone"
#XKCD_RoseRed             = $3C01BE;  $FF3C01BE  "#BE013C"  "rgb(190,  1, 60)"  "rgba(190,  1, 60,255)"  "RoseRed"
#XKCD_PaleAqua            = $EBFFB8;  $FFEBFFB8  "#B8FFEB"  "rgb(184,255,235)"  "rgba(184,255,235,255)"  "PaleAqua"
#XKCD_DeepOrange          = $014DDC;  $FF014DDC  "#DC4D01"  "rgb(220, 77,  1)"  "rgba(220, 77,  1,255)"  "DeepOrange"
#XKCD_Earth               = $3E65A2;  $FF3E65A2  "#A2653E"  "rgb(162,101, 62)"  "rgba(162,101, 62,255)"  "Earth"
#XKCD_MossyGreen          = $278B63;  $FF278B63  "#638B27"  "rgb( 99,139, 39)"  "rgba( 99,139, 39,255)"  "MossyGreen"
#XKCD_GrassyGreen         = $039C41;  $FF039C41  "#419C03"  "rgb( 65,156,  3)"  "rgba( 65,156,  3,255)"  "GrassyGreen"
#XKCD_PaleLimeGreen       = $65FFB1;  $FF65FFB1  "#B1FF65"  "rgb(177,255,101)"  "rgba(177,255,101,255)"  "PaleLimeGreen"
#XKCD_LightGreyBlue       = $D4BC9D;  $FFD4BC9D  "#9DBCD4"  "rgb(157,188,212)"  "rgba(157,188,212,255)"  "LightGreyBlue"
#XKCD_PaleGrey            = $FEFDFD;  $FFFEFDFD  "#FDFDFE"  "rgb(253,253,254)"  "rgba(253,253,254,255)"  "PaleGrey"
#XKCD_Asparagus           = $56AB77;  $FF56AB77  "#77AB56"  "rgb(119,171, 86)"  "rgba(119,171, 86,255)"  "Asparagus"
#XKCD_Blueberry           = $964146;  $FF964146  "#464196"  "rgb( 70, 65,150)"  "rgba( 70, 65,150,255)"  "Blueberry"
#XKCD_PurpleRed           = $470199;  $FF470199  "#990147"  "rgb(153,  1, 71)"  "rgba(153,  1, 71,255)"  "PurpleRed"
#XKCD_PaleLime            = $73FDBE;  $FF73FDBE  "#BEFD73"  "rgb(190,253,115)"  "rgba(190,253,115,255)"  "PaleLime"
#XKCD_GreenishTeal        = $84BF32;  $FF84BF32  "#32BF84"  "rgb( 50,191,132)"  "rgba( 50,191,132,255)"  "GreenishTeal"
#XKCD_Caramel             = $096FAF;  $FF096FAF  "#AF6F09"  "rgb(175,111,  9)"  "rgba(175,111,  9,255)"  "Caramel"
#XKCD_DeepMagenta         = $5C02A0;  $FF5C02A0  "#A0025C"  "rgb(160,  2, 92)"  "rgba(160,  2, 92,255)"  "DeepMagenta"
#XKCD_LightPeach          = $B1D8FF;  $FFB1D8FF  "#FFD8B1"  "rgb(255,216,177)"  "rgba(255,216,177,255)"  "LightPeach"
#XKCD_MilkChocolate       = $1E4E7F;  $FF1E4E7F  "#7F4E1E"  "rgb(127, 78, 30)"  "rgba(127, 78, 30,255)"  "MilkChocolate"
#XKCD_Ocher               = $0C9BBF;  $FF0C9BBF  "#BF9B0C"  "rgb(191,155, 12)"  "rgba(191,155, 12,255)"  "Ocher"
#XKCD_OffGreen            = $53A36B;  $FF53A36B  "#6BA353"  "rgb(107,163, 83)"  "rgba(107,163, 83,255)"  "OffGreen"
#XKCD_PurplyPink          = $E675F0;  $FFE675F0  "#F075E6"  "rgb(240,117,230)"  "rgba(240,117,230,255)"  "PurplyPink"
#XKCD_Lightblue           = $F6C87B;  $FFF6C87B  "#7BC8F6"  "rgb(123,200,246)"  "rgba(123,200,246,255)"  "Lightblue"
#XKCD_DuskyBlue           = $945F47;  $FF945F47  "#475F94"  "rgb( 71, 95,148)"  "rgba( 71, 95,148,255)"  "DuskyBlue"
#XKCD_Golden              = $03BFF5;  $FF03BFF5  "#F5BF03"  "rgb(245,191,  3)"  "rgba(245,191,  3,255)"  "Golden"
#XKCD_LightBeige          = $B6FEFF;  $FFB6FEFF  "#FFFEB6"  "rgb(255,254,182)"  "rgba(255,254,182,255)"  "LightBeige"
#XKCD_ButterYellow        = $74FDFF;  $FF74FDFF  "#FFFD74"  "rgb(255,253,116)"  "rgba(255,253,116,255)"  "ButterYellow"
#XKCD_DuskyPurple         = $7B5B89;  $FF7B5B89  "#895B7B"  "rgb(137, 91,123)"  "rgba(137, 91,123,255)"  "DuskyPurple"
#XKCD_FrenchBlue          = $AD6B43;  $FFAD6B43  "#436BAD"  "rgb( 67,107,173)"  "rgba( 67,107,173,255)"  "FrenchBlue"
#XKCD_UglyYellow          = $01C1D0;  $FF01C1D0  "#D0C101"  "rgb(208,193,  1)"  "rgba(208,193,  1,255)"  "UglyYellow"
#XKCD_GreenyYellow        = $08F8C6;  $FF08F8C6  "#C6F808"  "rgb(198,248,  8)"  "rgba(198,248,  8,255)"  "GreenyYellow"
#XKCD_OrangishRed         = $0536F4;  $FF0536F4  "#F43605"  "rgb(244, 54,  5)"  "rgba(244, 54,  5,255)"  "OrangishRed"
#XKCD_ShamrockGreen       = $4DC102;  $FF4DC102  "#02C14D"  "rgb(  2,193, 77)"  "rgba(  2,193, 77,255)"  "ShamrockGreen"
#XKCD_OrangishBrown       = $035FB2;  $FF035FB2  "#B25F03"  "rgb(178, 95,  3)"  "rgba(178, 95,  3,255)"  "OrangishBrown"
#XKCD_TreeGreen           = $197E2A;  $FF197E2A  "#2A7E19"  "rgb( 42,126, 25)"  "rgba( 42,126, 25,255)"  "TreeGreen"
#XKCD_DeepViolet          = $480649;  $FF480649  "#490648"  "rgb( 73,  6, 72)"  "rgba( 73,  6, 72,255)"  "DeepViolet"
#XKCD_Gunmetal            = $676253;  $FF676253  "#536267"  "rgb( 83, 98,103)"  "rgba( 83, 98,103,255)"  "Gunmetal"
#XKCD_Bluepurple          = $EF065A;  $FFEF065A  "#5A06EF"  "rgb( 90,  6,239)"  "rgba( 90,  6,239,255)"  "Bluepurple"
#XKCD_Cherry              = $3402CF;  $FF3402CF  "#CF0234"  "rgb(207,  2, 52)"  "rgba(207,  2, 52,255)"  "Cherry"
#XKCD_SandyBrown          = $61A6C4;  $FF61A6C4  "#C4A661"  "rgb(196,166, 97)"  "rgba(196,166, 97,255)"  "SandyBrown"
#XKCD_WarmGrey            = $848A97;  $FF848A97  "#978A84"  "rgb(151,138,132)"  "rgba(151,138,132,255)"  "WarmGrey"
#XKCD_DarkIndigo          = $54091F;  $FF54091F  "#1F0954"  "rgb( 31,  9, 84)"  "rgba( 31,  9, 84,255)"  "DarkIndigo"
#XKCD_Midnight            = $2D0103;  $FF2D0103  "#03012D"  "rgb(  3,  1, 45)"  "rgba(  3,  1, 45,255)"  "Midnight"
#XKCD_BlueyGreen          = $79B12B;  $FF79B12B  "#2BB179"  "rgb( 43,177,121)"  "rgba( 43,177,121,255)"  "BlueyGreen"
#XKCD_GreyPink            = $9B90C3;  $FF9B90C3  "#C3909B"  "rgb(195,144,155)"  "rgba(195,144,155,255)"  "GreyPink"
#XKCD_SoftPurple          = $B56FA6;  $FFB56FA6  "#A66FB5"  "rgb(166,111,181)"  "rgba(166,111,181,255)"  "SoftPurple"
#XKCD_Blood               = $010077;  $FF010077  "#770001"  "rgb(119,  0,  1)"  "rgba(119,  0,  1,255)"  "Blood"
#XKCD_BrownRed            = $052B92;  $FF052B92  "#922B05"  "rgb(146, 43,  5)"  "rgba(146, 43,  5,255)"  "BrownRed"
#XKCD_MediumGrey          = $7C7F7D;  $FF7C7F7D  "#7D7F7C"  "rgb(125,127,124)"  "rgba(125,127,124,255)"  "MediumGrey"
#XKCD_Berry               = $4B0F99;  $FF4B0F99  "#990F4B"  "rgb(153, 15, 75)"  "rgba(153, 15, 75,255)"  "Berry"
#XKCD_Poo                 = $03738F;  $FF03738F  "#8F7303"  "rgb(143,115,  3)"  "rgba(143,115,  3,255)"  "Poo"
#XKCD_PurpleyPink         = $B93CC8;  $FFB93CC8  "#C83CB9"  "rgb(200, 60,185)"  "rgba(200, 60,185,255)"  "PurpleyPink"
#XKCD_LightSalmon         = $93A9FE;  $FF93A9FE  "#FEA993"  "rgb(254,169,147)"  "rgba(254,169,147,255)"  "LightSalmon"
#XKCD_Snot                = $0DBBAC;  $FF0DBBAC  "#ACBB0D"  "rgb(172,187, 13)"  "rgba(172,187, 13,255)"  "Snot"
#XKCD_EasterPurple        = $FE71C0;  $FFFE71C0  "#C071FE"  "rgb(192,113,254)"  "rgba(192,113,254,255)"  "EasterPurple"
#XKCD_LightYellowGreen    = $7FFDCC;  $FF7FFDCC  "#CCFD7F"  "rgb(204,253,127)"  "rgba(204,253,127,255)"  "LightYellowGreen"
#XKCD_DarkNavyBlue        = $2E0200;  $FF2E0200  "#00022E"  "rgb(  0,  2, 46)"  "rgba(  0,  2, 46,255)"  "DarkNavyBlue"
#XKCD_Drab                = $448382;  $FF448382  "#828344"  "rgb(130,131, 68)"  "rgba(130,131, 68,255)"  "Drab"
#XKCD_LightRose           = $CBC5FF;  $FFCBC5FF  "#FFC5CB"  "rgb(255,197,203)"  "rgba(255,197,203,255)"  "LightRose"
#XKCD_Rouge               = $3912AB;  $FF3912AB  "#AB1239"  "rgb(171, 18, 57)"  "rgba(171, 18, 57,255)"  "Rouge"
#XKCD_PurplishRed         = $4B05B0;  $FF4B05B0  "#B0054B"  "rgb(176,  5, 75)"  "rgba(176,  5, 75,255)"  "PurplishRed"
#XKCD_SlimeGreen          = $04CC99;  $FF04CC99  "#99CC04"  "rgb(153,204,  4)"  "rgba(153,204,  4,255)"  "SlimeGreen"
#XKCD_BabyPoop            = $007C93;  $FF007C93  "#937C00"  "rgb(147,124,  0)"  "rgba(147,124,  0,255)"  "BabyPoop"
#XKCD_IrishGreen          = $299501;  $FF299501  "#019529"  "rgb(  1,149, 41)"  "rgba(  1,149, 41,255)"  "IrishGreen"
#XKCD_Pinkpurple          = $E71DEF;  $FFE71DEF  "#EF1DE7"  "rgb(239, 29,231)"  "rgba(239, 29,231,255)"  "Pinkpurple"
#XKCD_DarkNavy            = $350400;  $FF350400  "#000435"  "rgb(  0,  4, 53)"  "rgba(  0,  4, 53,255)"  "DarkNavy"
#XKCD_GreenyBlue          = $95B342;  $FF95B342  "#42B395"  "rgb( 66,179,149)"  "rgba( 66,179,149,255)"  "GreenyBlue"
#XKCD_LightPlum           = $83579D;  $FF83579D  "#9D5783"  "rgb(157, 87,131)"  "rgba(157, 87,131,255)"  "LightPlum"
#XKCD_PinkishGrey         = $A9ACC8;  $FFA9ACC8  "#C8ACA9"  "rgb(200,172,169)"  "rgba(200,172,169,255)"  "PinkishGrey"
#XKCD_DirtyOrange         = $0676C8;  $FF0676C8  "#C87606"  "rgb(200,118,  6)"  "rgba(200,118,  6,255)"  "DirtyOrange"
#XKCD_RustRed             = $0427AA;  $FF0427AA  "#AA2704"  "rgb(170, 39,  4)"  "rgba(170, 39,  4,255)"  "RustRed"
#XKCD_PaleLilac           = $FFCBE4;  $FFFFCBE4  "#E4CBFF"  "rgb(228,203,255)"  "rgba(228,203,255,255)"  "PaleLilac"
#XKCD_OrangeyRed          = $2442FA;  $FF2442FA  "#FA4224"  "rgb(250, 66, 36)"  "rgba(250, 66, 36,255)"  "OrangeyRed"
#XKCD_PrimaryBlue         = $F90408;  $FFF90408  "#0804F9"  "rgb(  8,  4,249)"  "rgba(  8,  4,249,255)"  "PrimaryBlue"
#XKCD_KermitGreen         = $00B25C;  $FF00B25C  "#5CB200"  "rgb( 92,178,  0)"  "rgba( 92,178,  0,255)"  "KermitGreen"
#XKCD_BrownishPurple      = $4E4276;  $FF4E4276  "#76424E"  "rgb(118, 66, 78)"  "rgba(118, 66, 78,255)"  "BrownishPurple"
#XKCD_MurkyGreen          = $0E7A6C;  $FF0E7A6C  "#6C7A0E"  "rgb(108,122, 14)"  "rgba(108,122, 14,255)"  "MurkyGreen"
#XKCD_Wheat               = $7EDDFB;  $FF7EDDFB  "#FBDD7E"  "rgb(251,221,126)"  "rgba(251,221,126,255)"  "Wheat"
#XKCD_VeryDarkPurple      = $34012A;  $FF34012A  "#2A0134"  "rgb( 42,  1, 52)"  "rgba( 42,  1, 52,255)"  "VeryDarkPurple"
#XKCD_BottleGreen         = $054A04;  $FF054A04  "#044A05"  "rgb(  4, 74,  5)"  "rgba(  4, 74,  5,255)"  "BottleGreen"
#XKCD_Watermelon          = $5946FD;  $FF5946FD  "#FD4659"  "rgb(253, 70, 89)"  "rgba(253, 70, 89,255)"  "Watermelon"
#XKCD_DeepSkyBlue         = $F8750D;  $FFF8750D  "#0D75F8"  "rgb( 13,117,248)"  "rgba( 13,117,248,255)"  "DeepSkyBlue"
#XKCD_FireEngineRed       = $0200FE;  $FF0200FE  "#FE0002"  "rgb(254,  0,  2)"  "rgba(254,  0,  2,255)"  "FireEngineRed"
#XKCD_YellowOchre         = $069DCB;  $FF069DCB  "#CB9D06"  "rgb(203,157,  6)"  "rgba(203,157,  6,255)"  "YellowOchre"
#XKCD_PumpkinOrange       = $077DFB;  $FF077DFB  "#FB7D07"  "rgb(251,125,  7)"  "rgba(251,125,  7,255)"  "PumpkinOrange"
#XKCD_PaleOlive           = $81CCB9;  $FF81CCB9  "#B9CC81"  "rgb(185,204,129)"  "rgba(185,204,129,255)"  "PaleOlive"
#XKCD_LightLilac          = $FFC8ED;  $FFFFC8ED  "#EDC8FF"  "rgb(237,200,255)"  "rgba(237,200,255,255)"  "LightLilac"
#XKCD_LightishGreen       = $60E161;  $FF60E161  "#61E160"  "rgb( 97,225, 96)"  "rgba( 97,225, 96,255)"  "LightishGreen"
#XKCD_CarolinaBlue        = $FEB88A;  $FFFEB88A  "#8AB8FE"  "rgb(138,184,254)"  "rgba(138,184,254,255)"  "CarolinaBlue"
#XKCD_Mulberry            = $4E0A92;  $FF4E0A92  "#920A4E"  "rgb(146, 10, 78)"  "rgba(146, 10, 78,255)"  "Mulberry"
#XKCD_ShockingPink        = $A202FE;  $FFA202FE  "#FE02A2"  "rgb(254,  2,162)"  "rgba(254,  2,162,255)"  "ShockingPink"
#XKCD_Auburn              = $01309A;  $FF01309A  "#9A3001"  "rgb(154, 48,  1)"  "rgba(154, 48,  1,255)"  "Auburn"
#XKCD_BrightLimeGreen     = $08FE65;  $FF08FE65  "#65FE08"  "rgb(101,254,  8)"  "rgba(101,254,  8,255)"  "BrightLimeGreen"
#XKCD_Celadon             = $B7FDBE;  $FFB7FDBE  "#BEFDB7"  "rgb(190,253,183)"  "rgba(190,253,183,255)"  "Celadon"
#XKCD_PinkishBrown        = $6172B1;  $FF6172B1  "#B17261"  "rgb(177,114, 97)"  "rgba(177,114, 97,255)"  "PinkishBrown"
#XKCD_PooBrown            = $015F88;  $FF015F88  "#885F01"  "rgb(136, 95,  1)"  "rgba(136, 95,  1,255)"  "PooBrown"
#XKCD_BrightSkyBlue       = $FECC02;  $FFFECC02  "#02CCFE"  "rgb(  2,204,254)"  "rgba(  2,204,254,255)"  "BrightSkyBlue"
#XKCD_Celery              = $95FDC1;  $FF95FDC1  "#C1FD95"  "rgb(193,253,149)"  "rgba(193,253,149,255)"  "Celery"
#XKCD_DirtBrown           = $396583;  $FF396583  "#836539"  "rgb(131,101, 57)"  "rgba(131,101, 57,255)"  "DirtBrown"
#XKCD_Strawberry          = $4329FB;  $FF4329FB  "#FB2943"  "rgb(251, 41, 67)"  "rgba(251, 41, 67,255)"  "Strawberry"
#XKCD_DarkLime            = $01B784;  $FF01B784  "#84B701"  "rgb(132,183,  1)"  "rgba(132,183,  1,255)"  "DarkLime"
#XKCD_Copper              = $2563B6;  $FF2563B6  "#B66325"  "rgb(182, 99, 37)"  "rgba(182, 99, 37,255)"  "Copper"
#XKCD_MediumBrown         = $12517F;  $FF12517F  "#7F5112"  "rgb(127, 81, 18)"  "rgba(127, 81, 18,255)"  "MediumBrown"
#XKCD_MutedGreen          = $52A05F;  $FF52A05F  "#5FA052"  "rgb( 95,160, 82)"  "rgba( 95,160, 82,255)"  "MutedGreen"
#XKCD_RobinsEgg           = $FDED6D;  $FFFDED6D  "#6DEDFD"  "rgb(109,237,253)"  "rgba(109,237,253,255)"  "RobinsEgg"
#XKCD_BrightAqua          = $EAF90B;  $FFEAF90B  "#0BF9EA"  "rgb( 11,249,234)"  "rgba( 11,249,234,255)"  "BrightAqua"
#XKCD_BrightLavender      = $FF60C7;  $FFFF60C7  "#C760FF"  "rgb(199, 96,255)"  "rgba(199, 96,255,255)"  "BrightLavender"
#XKCD_Ivory               = $CBFFFF;  $FFCBFFFF  "#FFFFCB"  "rgb(255,255,203)"  "rgba(255,255,203,255)"  "Ivory"
#XKCD_VeryLightPurple     = $FCCEF6;  $FFFCCEF6  "#F6CEFC"  "rgb(246,206,252)"  "rgba(246,206,252,255)"  "VeryLightPurple"
#XKCD_LightNavy           = $845015;  $FF845015  "#155084"  "rgb( 21, 80,132)"  "rgba( 21, 80,132,255)"  "LightNavy"
#XKCD_PinkRed             = $4F05F5;  $FF4F05F5  "#F5054F"  "rgb(245,  5, 79)"  "rgba(245,  5, 79,255)"  "PinkRed"
#XKCD_OliveBrown          = $035464;  $FF035464  "#645403"  "rgb(100, 84,  3)"  "rgba(100, 84,  3,255)"  "OliveBrown"
#XKCD_PoopBrown           = $01597A;  $FF01597A  "#7A5901"  "rgb(122, 89,  1)"  "rgba(122, 89,  1,255)"  "PoopBrown"
#XKCD_MustardGreen        = $04B5A8;  $FF04B5A8  "#A8B504"  "rgb(168,181,  4)"  "rgba(168,181,  4,255)"  "MustardGreen"
#XKCD_OceanGreen          = $73993D;  $FF73993D  "#3D9973"  "rgb( 61,153,115)"  "rgba( 61,153,115,255)"  "OceanGreen"
#XKCD_VeryDarkBlue        = $330100;  $FF330100  "#000133"  "rgb(  0,  1, 51)"  "rgba(  0,  1, 51,255)"  "VeryDarkBlue"
#XKCD_DustyGreen          = $73A976;  $FF73A976  "#76A973"  "rgb(118,169,115)"  "rgba(118,169,115,255)"  "DustyGreen"
#XKCD_LightNavyBlue       = $885A2E;  $FF885A2E  "#2E5A88"  "rgb( 46, 90,136)"  "rgba( 46, 90,136,255)"  "LightNavyBlue"
#XKCD_MintyGreen          = $7DF70B;  $FF7DF70B  "#0BF77D"  "rgb( 11,247,125)"  "rgba( 11,247,125,255)"  "MintyGreen"
#XKCD_Adobe               = $486CBD;  $FF486CBD  "#BD6C48"  "rgb(189,108, 72)"  "rgba(189,108, 72,255)"  "Adobe"
#XKCD_Barney              = $B81DAC;  $FFB81DAC  "#AC1DB8"  "rgb(172, 29,184)"  "rgba(172, 29,184,255)"  "Barney"
#XKCD_JadeGreen           = $6AAF2B;  $FF6AAF2B  "#2BAF6A"  "rgb( 43,175,106)"  "rgba( 43,175,106,255)"  "JadeGreen"
#XKCD_BrightLightBlue     = $FDF726;  $FFFDF726  "#26F7FD"  "rgb( 38,247,253)"  "rgba( 38,247,253,255)"  "BrightLightBlue"
#XKCD_LightLime           = $6CFDAE;  $FF6CFDAE  "#AEFD6C"  "rgb(174,253,108)"  "rgba(174,253,108,255)"  "LightLime"
#XKCD_DarkKhaki           = $558F9B;  $FF558F9B  "#9B8F55"  "rgb(155,143, 85)"  "rgba(155,143, 85,255)"  "DarkKhaki"
#XKCD_OrangeYellow        = $01ADFF;  $FF01ADFF  "#FFAD01"  "rgb(255,173,  1)"  "rgba(255,173,  1,255)"  "OrangeYellow"
#XKCD_Ocre                = $049CC6;  $FF049CC6  "#C69C04"  "rgb(198,156,  4)"  "rgba(198,156,  4,255)"  "Ocre"
#XKCD_Maize               = $54D0F4;  $FF54D0F4  "#F4D054"  "rgb(244,208, 84)"  "rgba(244,208, 84,255)"  "Maize"
#XKCD_FadedPink           = $AC9DDE;  $FFAC9DDE  "#DE9DAC"  "rgb(222,157,172)"  "rgba(222,157,172,255)"  "FadedPink"
#XKCD_BritishRacingGreen  = $0D4805;  $FF0D4805  "#05480D"  "rgb(  5, 72, 13)"  "rgba(  5, 72, 13,255)"  "BritishRacingGreen"
#XKCD_Sandstone           = $74AEC9;  $FF74AEC9  "#C9AE74"  "rgb(201,174,116)"  "rgba(201,174,116,255)"  "Sandstone"
#XKCD_MudBrown            = $0F4660;  $FF0F4660  "#60460F"  "rgb( 96, 70, 15)"  "rgba( 96, 70, 15,255)"  "MudBrown"
#XKCD_LightSeaGreen       = $B0F698;  $FFB0F698  "#98F6B0"  "rgb(152,246,176)"  "rgba(152,246,176,255)"  "LightSeaGreen"
#XKCD_RobinEggBlue        = $FEF18A;  $FFFEF18A  "#8AF1FE"  "rgb(138,241,254)"  "rgba(138,241,254,255)"  "RobinEggBlue"
#XKCD_AquaMarine          = $BBE82E;  $FFBBE82E  "#2EE8BB"  "rgb( 46,232,187)"  "rgba( 46,232,187,255)"  "AquaMarine"
#XKCD_DarkSeaGreen        = $5D8711;  $FF5D8711  "#11875D"  "rgb( 17,135, 93)"  "rgba( 17,135, 93,255)"  "DarkSeaGreen"
#XKCD_SoftPink            = $C0B0FD;  $FFC0B0FD  "#FDB0C0"  "rgb(253,176,192)"  "rgba(253,176,192,255)"  "SoftPink"
#XKCD_OrangeyBrown        = $0260B1;  $FF0260B1  "#B16002"  "rgb(177, 96,  2)"  "rgba(177, 96,  2,255)"  "OrangeyBrown"
#XKCD_CherryRed           = $2A02F7;  $FF2A02F7  "#F7022A"  "rgb(247,  2, 42)"  "rgba(247,  2, 42,255)"  "CherryRed"
#XKCD_BurntYellow         = $09ABD5;  $FF09ABD5  "#D5AB09"  "rgb(213,171,  9)"  "rgba(213,171,  9,255)"  "BurntYellow"
#XKCD_BrownishGrey        = $5F7786;  $FF5F7786  "#86775F"  "rgb(134,119, 95)"  "rgba(134,119, 95,255)"  "BrownishGrey"
#XKCD_Camel               = $599FC6;  $FF599FC6  "#C69F59"  "rgb(198,159, 89)"  "rgba(198,159, 89,255)"  "Camel"
#XKCD_PurplishGrey        = $7F687A;  $FF7F687A  "#7A687F"  "rgb(122,104,127)"  "rgba(122,104,127,255)"  "PurplishGrey"
#XKCD_Marine              = $602E04;  $FF602E04  "#042E60"  "rgb(  4, 46, 96)"  "rgba(  4, 46, 96,255)"  "Marine"
#XKCD_GreyishPink         = $948DC8;  $FF948DC8  "#C88D94"  "rgb(200,141,148)"  "rgba(200,141,148,255)"  "GreyishPink"
#XKCD_PaleTurquoise       = $D5FBA5;  $FFD5FBA5  "#A5FBD5"  "rgb(165,251,213)"  "rgba(165,251,213,255)"  "PaleTurquoise"
#XKCD_PastelYellow        = $71FEFF;  $FF71FEFF  "#FFFE71"  "rgb(255,254,113)"  "rgba(255,254,113,255)"  "PastelYellow"
#XKCD_BlueyPurple         = $C74162;  $FFC74162  "#6241C7"  "rgb( 98, 65,199)"  "rgba( 98, 65,199,255)"  "BlueyPurple"
#XKCD_CanaryYellow        = $40FEFF;  $FF40FEFF  "#FFFE40"  "rgb(255,254, 64)"  "rgba(255,254, 64,255)"  "CanaryYellow"
#XKCD_FadedRed            = $4E49D3;  $FF4E49D3  "#D3494E"  "rgb(211, 73, 78)"  "rgba(211, 73, 78,255)"  "FadedRed"
#XKCD_Sepia               = $2B5E98;  $FF2B5E98  "#985E2B"  "rgb(152, 94, 43)"  "rgba(152, 94, 43,255)"  "Sepia"
#XKCD_Coffee              = $4C81A6;  $FF4C81A6  "#A6814C"  "rgb(166,129, 76)"  "rgba(166,129, 76,255)"  "Coffee"
#XKCD_BrightMagenta       = $E808FF;  $FFE808FF  "#FF08E8"  "rgb(255,  8,232)"  "rgba(255,  8,232,255)"  "BrightMagenta"
#XKCD_Mocha               = $51769D;  $FF51769D  "#9D7651"  "rgb(157,118, 81)"  "rgba(157,118, 81,255)"  "Mocha"
#XKCD_Ecru                = $CAFFFE;  $FFCAFFFE  "#FEFFCA"  "rgb(254,255,202)"  "rgba(254,255,202,255)"  "Ecru"
#XKCD_Purpleish           = $8D5698;  $FF8D5698  "#98568D"  "rgb(152, 86,141)"  "rgba(152, 86,141,255)"  "Purpleish"
#XKCD_Cranberry           = $3A009E;  $FF3A009E  "#9E003A"  "rgb(158,  0, 58)"  "rgba(158,  0, 58,255)"  "Cranberry"
#XKCD_DarkishGreen        = $377C28;  $FF377C28  "#287C37"  "rgb( 40,124, 55)"  "rgba( 40,124, 55,255)"  "DarkishGreen"
#XKCD_BrownOrange         = $0269B9;  $FF0269B9  "#B96902"  "rgb(185,105,  2)"  "rgba(185,105,  2,255)"  "BrownOrange"
#XKCD_DuskyRose           = $7368BA;  $FF7368BA  "#BA6873"  "rgb(186,104,115)"  "rgba(186,104,115,255)"  "DuskyRose"
#XKCD_Melon               = $5578FF;  $FF5578FF  "#FF7855"  "rgb(255,120, 85)"  "rgba(255,120, 85,255)"  "Melon"
#XKCD_SicklyGreen         = $1CB294;  $FF1CB294  "#94B21C"  "rgb(148,178, 28)"  "rgba(148,178, 28,255)"  "SicklyGreen"
#XKCD_Silver              = $C7C9C5;  $FFC7C9C5  "#C5C9C7"  "rgb(197,201,199)"  "rgba(197,201,199,255)"  "Silver"
#XKCD_PurplyBlue          = $EE1A66;  $FFEE1A66  "#661AEE"  "rgb(102, 26,238)"  "rgba(102, 26,238,255)"  "PurplyBlue"
#XKCD_PurpleishBlue       = $EF4061;  $FFEF4061  "#6140EF"  "rgb( 97, 64,239)"  "rgba( 97, 64,239,255)"  "PurpleishBlue"
#XKCD_HospitalGreen       = $AAE59B;  $FFAAE59B  "#9BE5AA"  "rgb(155,229,170)"  "rgba(155,229,170,255)"  "HospitalGreen"
#XKCD_ShitBrown           = $04587B;  $FF04587B  "#7B5804"  "rgb(123, 88,  4)"  "rgba(123, 88,  4,255)"  "ShitBrown"
#XKCD_MidBlue             = $B36A27;  $FFB36A27  "#276AB3"  "rgb( 39,106,179)"  "rgba( 39,106,179,255)"  "MidBlue"
#XKCD_Amber               = $08B3FE;  $FF08B3FE  "#FEB308"  "rgb(254,179,  8)"  "rgba(254,179,  8,255)"  "Amber"
#XKCD_EasterGreen         = $7EFD8C;  $FF7EFD8C  "#8CFD7E"  "rgb(140,253,126)"  "rgba(140,253,126,255)"  "EasterGreen"
#XKCD_SoftBlue            = $EA8864;  $FFEA8864  "#6488EA"  "rgb(100,136,234)"  "rgba(100,136,234,255)"  "SoftBlue"
#XKCD_CeruleanBlue        = $EE6E05;  $FFEE6E05  "#056EEE"  "rgb(  5,110,238)"  "rgba(  5,110,238,255)"  "CeruleanBlue"
#XKCD_GoldenBrown         = $017AB2;  $FF017AB2  "#B27A01"  "rgb(178,122,  1)"  "rgba(178,122,  1,255)"  "GoldenBrown"
#XKCD_BrightTurquoise     = $F9FE0F;  $FFF9FE0F  "#0FFEF9"  "rgb( 15,254,249)"  "rgba( 15,254,249,255)"  "BrightTurquoise"
#XKCD_RedPink             = $552AFA;  $FF552AFA  "#FA2A55"  "rgb(250, 42, 85)"  "rgba(250, 42, 85,255)"  "RedPink"
#XKCD_RedPurple           = $470782;  $FF470782  "#820747"  "rgb(130,  7, 71)"  "rgba(130,  7, 71,255)"  "RedPurple"
#XKCD_GreyishBrown        = $4F6A7A;  $FF4F6A7A  "#7A6A4F"  "rgb(122,106, 79)"  "rgba(122,106, 79,255)"  "GreyishBrown"
#XKCD_Vermillion          = $0C32F4;  $FF0C32F4  "#F4320C"  "rgb(244, 50, 12)"  "rgba(244, 50, 12,255)"  "Vermillion"
#XKCD_Russet              = $0539A1;  $FF0539A1  "#A13905"  "rgb(161, 57,  5)"  "rgba(161, 57,  5,255)"  "Russet"
#XKCD_SteelGrey           = $8A826F;  $FF8A826F  "#6F828A"  "rgb(111,130,138)"  "rgba(111,130,138,255)"  "SteelGrey"
#XKCD_LighterPurple       = $F45AA5;  $FFF45AA5  "#A55AF4"  "rgb(165, 90,244)"  "rgba(165, 90,244,255)"  "LighterPurple"
#XKCD_BrightViolet        = $FD0AAD;  $FFFD0AAD  "#AD0AFD"  "rgb(173, 10,253)"  "rgba(173, 10,253,255)"  "BrightViolet"
#XKCD_PrussianBlue        = $774500;  $FF774500  "#004577"  "rgb(  0, 69,119)"  "rgba(  0, 69,119,255)"  "PrussianBlue"
#XKCD_SlateGreen          = $6D8D65;  $FF6D8D65  "#658D6D"  "rgb(101,141,109)"  "rgba(101,141,109,255)"  "SlateGreen"
#XKCD_DirtyPink           = $807BCA;  $FF807BCA  "#CA7B80"  "rgb(202,123,128)"  "rgba(202,123,128,255)"  "DirtyPink"
#XKCD_DarkBlueGreen       = $495200;  $FF495200  "#005249"  "rgb(  0, 82, 73)"  "rgba(  0, 82, 73,255)"  "DarkBlueGreen"
#XKCD_Pine                = $345D2B;  $FF345D2B  "#2B5D34"  "rgb( 43, 93, 52)"  "rgba( 43, 93, 52,255)"  "Pine"
#XKCD_YellowyGreen        = $28F1BF;  $FF28F1BF  "#BFF128"  "rgb(191,241, 40)"  "rgba(191,241, 40,255)"  "YellowyGreen"
#XKCD_DarkGold            = $1094B5;  $FF1094B5  "#B59410"  "rgb(181,148, 16)"  "rgba(181,148, 16,255)"  "DarkGold"
#XKCD_Bluish              = $BB7629;  $FFBB7629  "#2976BB"  "rgb( 41,118,187)"  "rgba( 41,118,187,255)"  "Bluish"
#XKCD_DarkishBlue         = $824101;  $FF824101  "#014182"  "rgb(  1, 65,130)"  "rgba(  1, 65,130,255)"  "DarkishBlue"
#XKCD_DullRed             = $3F3FBB;  $FF3F3FBB  "#BB3F3F"  "rgb(187, 63, 63)"  "rgba(187, 63, 63,255)"  "DullRed"
#XKCD_PinkyRed            = $4726FC;  $FF4726FC  "#FC2647"  "rgb(252, 38, 71)"  "rgba(252, 38, 71,255)"  "PinkyRed"
#XKCD_Bronze              = $0079A8;  $FF0079A8  "#A87900"  "rgb(168,121,  0)"  "rgba(168,121,  0,255)"  "Bronze"
#XKCD_PaleTeal            = $B2CB82;  $FFB2CB82  "#82CBB2"  "rgb(130,203,178)"  "rgba(130,203,178,255)"  "PaleTeal"
#XKCD_MilitaryGreen       = $3E7C66;  $FF3E7C66  "#667C3E"  "rgb(102,124, 62)"  "rgba(102,124, 62,255)"  "MilitaryGreen"
#XKCD_BarbiePink          = $A546FE;  $FFA546FE  "#FE46A5"  "rgb(254, 70,165)"  "rgba(254, 70,165,255)"  "BarbiePink"
#XKCD_BubblegumPink_      = $CC83FE;  $FFCC83FE  "#FE83CC"  "rgb(254,131,204)"  "rgba(254,131,204,255)"  "BubblegumPink_"
#XKCD_PeaSoupGreen        = $17A694;  $FF17A694  "#94A617"  "rgb(148,166, 23)"  "rgba(148,166, 23,255)"  "PeaSoupGreen"
#XKCD_DarkMustard         = $0589A8;  $FF0589A8  "#A88905"  "rgb(168,137,  5)"  "rgba(168,137,  5,255)"  "DarkMustard"
#XKCD_Shit                = $005F7F;  $FF005F7F  "#7F5F00"  "rgb(127, 95,  0)"  "rgba(127, 95,  0,255)"  "Shit"
#XKCD_MediumPurple        = $A2439E;  $FFA2439E  "#9E43A2"  "rgb(158, 67,162)"  "rgba(158, 67,162,255)"  "MediumPurple"
#XKCD_VeryDarkGreen       = $032E06;  $FF032E06  "#062E03"  "rgb(  6, 46,  3)"  "rgba(  6, 46,  3,255)"  "VeryDarkGreen"
#XKCD_Dirt                = $456E8A;  $FF456E8A  "#8A6E45"  "rgb(138,110, 69)"  "rgba(138,110, 69,255)"  "Dirt"
#XKCD_DuskyPink           = $8B7ACC;  $FF8B7ACC  "#CC7A8B"  "rgb(204,122,139)"  "rgba(204,122,139,255)"  "DuskyPink"
#XKCD_RedViolet           = $68019E;  $FF68019E  "#9E0168"  "rgb(158,  1,104)"  "rgba(158,  1,104,255)"  "RedViolet"
#XKCD_LemonYellow         = $38FFFD;  $FF38FFFD  "#FDFF38"  "rgb(253,255, 56)"  "rgba(253,255, 56,255)"  "LemonYellow"
#XKCD_Pistachio           = $8BFAC0;  $FF8BFAC0  "#C0FA8B"  "rgb(192,250,139)"  "rgba(192,250,139,255)"  "Pistachio"
#XKCD_DullYellow          = $5BDCEE;  $FF5BDCEE  "#EEDC5B"  "rgb(238,220, 91)"  "rgba(238,220, 91,255)"  "DullYellow"
#XKCD_DarkLimeGreen       = $01BD7E;  $FF01BD7E  "#7EBD01"  "rgb(126,189,  1)"  "rgba(126,189,  1,255)"  "DarkLimeGreen"
#XKCD_DenimBlue           = $925B3B;  $FF925B3B  "#3B5B92"  "rgb( 59, 91,146)"  "rgba( 59, 91,146,255)"  "DenimBlue"
#XKCD_TealBlue            = $9F8801;  $FF9F8801  "#01889F"  "rgb(  1,136,159)"  "rgba(  1,136,159,255)"  "TealBlue"
#XKCD_LightishBlue        = $FD7A3D;  $FFFD7A3D  "#3D7AFD"  "rgb( 61,122,253)"  "rgba( 61,122,253,255)"  "LightishBlue"
#XKCD_PurpleyBlue         = $E7345F;  $FFE7345F  "#5F34E7"  "rgb( 95, 52,231)"  "rgba( 95, 52,231,255)"  "PurpleyBlue"
#XKCD_LightIndigo         = $CF5A6D;  $FFCF5A6D  "#6D5ACF"  "rgb(109, 90,207)"  "rgba(109, 90,207,255)"  "LightIndigo"
#XKCD_SwampGreen          = $008574;  $FF008574  "#748500"  "rgb(116,133,  0)"  "rgba(116,133,  0,255)"  "SwampGreen"
#XKCD_BrownGreen          = $116C70;  $FF116C70  "#706C11"  "rgb(112,108, 17)"  "rgba(112,108, 17,255)"  "BrownGreen"
#XKCD_DarkMaroon          = $08003C;  $FF08003C  "#3C0008"  "rgb( 60,  0,  8)"  "rgba( 60,  0,  8,255)"  "DarkMaroon"
#XKCD_HotPurple           = $F500CB;  $FFF500CB  "#CB00F5"  "rgb(203,  0,245)"  "rgba(203,  0,245,255)"  "HotPurple"
#XKCD_DarkForestGreen     = $042D00;  $FF042D00  "#002D04"  "rgb(  0, 45,  4)"  "rgba(  0, 45,  4,255)"  "DarkForestGreen"
#XKCD_FadedBlue           = $BB8C65;  $FFBB8C65  "#658CBB"  "rgb(101,140,187)"  "rgba(101,140,187,255)"  "FadedBlue"
#XKCD_DrabGreen           = $519574;  $FF519574  "#749551"  "rgb(116,149, 81)"  "rgba(116,149, 81,255)"  "DrabGreen"
#XKCD_LightLimeGreen      = $66FFB9;  $FF66FFB9  "#B9FF66"  "rgb(185,255,102)"  "rgba(185,255,102,255)"  "LightLimeGreen"
#XKCD_SnotGreen           = $00C19D;  $FF00C19D  "#9DC100"  "rgb(157,193,  0)"  "rgba(157,193,  0,255)"  "SnotGreen"
#XKCD_Yellowish           = $66EEFA;  $FF66EEFA  "#FAEE66"  "rgb(250,238,102)"  "rgba(250,238,102,255)"  "Yellowish"
#XKCD_LightBlueGreen      = $B3FB7E;  $FFB3FB7E  "#7EFBB3"  "rgb(126,251,179)"  "rgba(126,251,179,255)"  "LightBlueGreen"
#XKCD_Bordeaux            = $2C007B;  $FF2C007B  "#7B002C"  "rgb(123,  0, 44)"  "rgba(123,  0, 44,255)"  "Bordeaux"
#XKCD_LightMauve          = $A192C2;  $FFA192C2  "#C292A1"  "rgb(194,146,161)"  "rgba(194,146,161,255)"  "LightMauve"
#XKCD_Ocean               = $927B01;  $FF927B01  "#017B92"  "rgb(  1,123,146)"  "rgba(  1,123,146,255)"  "Ocean"
#XKCD_Marigold            = $06C0FC;  $FF06C0FC  "#FCC006"  "rgb(252,192,  6)"  "rgba(252,192,  6,255)"  "Marigold"
#XKCD_MuddyGreen          = $327465;  $FF327465  "#657432"  "rgb(101,116, 50)"  "rgba(101,116, 50,255)"  "MuddyGreen"
#XKCD_DullOrange          = $3B86D8;  $FF3B86D8  "#D8863B"  "rgb(216,134, 59)"  "rgba(216,134, 59,255)"  "DullOrange"
#XKCD_Steel               = $958573;  $FF958573  "#738595"  "rgb(115,133,149)"  "rgba(115,133,149,255)"  "Steel"
#XKCD_ElectricPurple      = $FF23AA;  $FFFF23AA  "#AA23FF"  "rgb(170, 35,255)"  "rgba(170, 35,255,255)"  "ElectricPurple"
#XKCD_FluorescentGreen    = $08FF08;  $FF08FF08  "#08FF08"  "rgb(  8,255,  8)"  "rgba(  8,255,  8,255)"  "FluorescentGreen"
#XKCD_YellowishBrown      = $017A9B;  $FF017A9B  "#9B7A01"  "rgb(155,122,  1)"  "rgba(155,122,  1,255)"  "YellowishBrown"
#XKCD_Blush               = $8E9EF2;  $FF8E9EF2  "#F29E8E"  "rgb(242,158,142)"  "rgba(242,158,142,255)"  "Blush"
#XKCD_SoftGreen           = $76C26F;  $FF76C26F  "#6FC276"  "rgb(111,194,118)"  "rgba(111,194,118,255)"  "SoftGreen"
#XKCD_BrightOrange        = $005BFF;  $FF005BFF  "#FF5B00"  "rgb(255, 91,  0)"  "rgba(255, 91,  0,255)"  "BrightOrange"
#XKCD_Lemon               = $52FFFD;  $FF52FFFD  "#FDFF52"  "rgb(253,255, 82)"  "rgba(253,255, 82,255)"  "Lemon"
#XKCD_PurpleGrey          = $856F86;  $FF856F86  "#866F85"  "rgb(134,111,133)"  "rgba(134,111,133,255)"  "PurpleGrey"
#XKCD_AcidGreen           = $09FE8F;  $FF09FE8F  "#8FFE09"  "rgb(143,254,  9)"  "rgba(143,254,  9,255)"  "AcidGreen"
#XKCD_PaleLavender        = $FECFEE;  $FFFECFEE  "#EECFFE"  "rgb(238,207,254)"  "rgba(238,207,254,255)"  "PaleLavender"
#XKCD_VioletBlue          = $C90A51;  $FFC90A51  "#510AC9"  "rgb( 81, 10,201)"  "rgba( 81, 10,201,255)"  "VioletBlue"
#XKCD_LightForestGreen    = $53914F;  $FF53914F  "#4F9153"  "rgb( 79,145, 83)"  "rgba( 79,145, 83,255)"  "LightForestGreen"
#XKCD_BurntRed            = $05239F;  $FF05239F  "#9F2305"  "rgb(159, 35,  5)"  "rgba(159, 35,  5,255)"  "BurntRed"
#XKCD_KhakiGreen          = $398672;  $FF398672  "#728639"  "rgb(114,134, 57)"  "rgba(114,134, 57,255)"  "KhakiGreen"
#XKCD_Cerise              = $620CDE;  $FF620CDE  "#DE0C62"  "rgb(222, 12, 98)"  "rgba(222, 12, 98,255)"  "Cerise"
#XKCD_FadedPurple         = $996E91;  $FF996E91  "#916E99"  "rgb(145,110,153)"  "rgba(145,110,153,255)"  "FadedPurple"
#XKCD_Apricot             = $6DB1FF;  $FF6DB1FF  "#FFB16D"  "rgb(255,177,109)"  "rgba(255,177,109,255)"  "Apricot"
#XKCD_DarkOliveGreen      = $034D3C;  $FF034D3C  "#3C4D03"  "rgb( 60, 77,  3)"  "rgba( 60, 77,  3,255)"  "DarkOliveGreen"
#XKCD_GreyBrown           = $53707F;  $FF53707F  "#7F7053"  "rgb(127,112, 83)"  "rgba(127,112, 83,255)"  "GreyBrown"
#XKCD_GreenGrey           = $6F9277;  $FF6F9277  "#77926F"  "rgb(119,146,111)"  "rgba(119,146,111,255)"  "GreenGrey"
#XKCD_TrueBlue            = $CC0F01;  $FFCC0F01  "#010FCC"  "rgb(  1, 15,204)"  "rgba(  1, 15,204,255)"  "TrueBlue"
#XKCD_PaleViolet          = $FAAECE;  $FFFAAECE  "#CEAEFA"  "rgb(206,174,250)"  "rgba(206,174,250,255)"  "PaleViolet"
#XKCD_PeriwinkleBlue      = $FB998F;  $FFFB998F  "#8F99FB"  "rgb(143,153,251)"  "rgba(143,153,251,255)"  "PeriwinkleBlue"
#XKCD_LightSkyBlue        = $FFFCC6;  $FFFFFCC6  "#C6FCFF"  "rgb(198,252,255)"  "rgba(198,252,255,255)"  "LightSkyBlue"
#XKCD_Blurple             = $CC3955;  $FFCC3955  "#5539CC"  "rgb( 85, 57,204)"  "rgba( 85, 57,204,255)"  "Blurple"
#XKCD_GreenBrown          = $034E54;  $FF034E54  "#544E03"  "rgb( 84, 78,  3)"  "rgba( 84, 78,  3,255)"  "GreenBrown"
#XKCD_Bluegreen2          = $797A01;  $FF797A01  "#017A79"  "rgb(  1,122,121)"  "rgba(  1,122,121,255)"  "Bluegreen2"
#XKCD_BrightTeal          = $C6F901;  $FFC6F901  "#01F9C6"  "rgb(  1,249,198)"  "rgba(  1,249,198,255)"  "BrightTeal"
#XKCD_BrownishYellow      = $03B0C9;  $FF03B0C9  "#C9B003"  "rgb(201,176,  3)"  "rgba(201,176,  3,255)"  "BrownishYellow"
#XKCD_PeaSoup             = $019992;  $FF019992  "#929901"  "rgb(146,153,  1)"  "rgba(146,153,  1,255)"  "PeaSoup"
#XKCD_Forest              = $09550B;  $FF09550B  "#0B5509"  "rgb( 11, 85,  9)"  "rgba( 11, 85,  9,255)"  "Forest"
#XKCD_BarneyPurple        = $9804A0;  $FF9804A0  "#A00498"  "rgb(160,  4,152)"  "rgba(160,  4,152,255)"  "BarneyPurple"
#XKCD_Ultramarine         = $B10020;  $FFB10020  "#2000B1"  "rgb( 32,  0,177)"  "rgba( 32,  0,177,255)"  "Ultramarine"
#XKCD_Purplish            = $8C5694;  $FF8C5694  "#94568C"  "rgb(148, 86,140)"  "rgba(148, 86,140,255)"  "Purplish"
#XKCD_PukeYellow          = $0EBEC2;  $FF0EBEC2  "#C2BE0E"  "rgb(194,190, 14)"  "rgba(194,190, 14,255)"  "PukeYellow"
#XKCD_BluishGrey          = $978B74;  $FF978B74  "#748B97"  "rgb(116,139,151)"  "rgba(116,139,151,255)"  "BluishGrey"
#XKCD_DarkPeriwinkle      = $D15F66;  $FFD15F66  "#665FD1"  "rgb(102, 95,209)"  "rgba(102, 95,209,255)"  "DarkPeriwinkle"
#XKCD_DarkLilac           = $A56D9C;  $FFA56D9C  "#9C6DA5"  "rgb(156,109,165)"  "rgba(156,109,165,255)"  "DarkLilac"
#XKCD_Reddish             = $4042C4;  $FF4042C4  "#C44240"  "rgb(196, 66, 64)"  "rgba(196, 66, 64,255)"  "Reddish"
#XKCD_LightMaroon         = $5748A2;  $FF5748A2  "#A24857"  "rgb(162, 72, 87)"  "rgba(162, 72, 87,255)"  "LightMaroon"
#XKCD_DustyPurple         = $875F82;  $FF875F82  "#825F87"  "rgb(130, 95,135)"  "rgba(130, 95,135,255)"  "DustyPurple"
#XKCD_TerraCotta          = $3B64C9;  $FF3B64C9  "#C9643B"  "rgb(201,100, 59)"  "rgba(201,100, 59,255)"  "TerraCotta"
#XKCD_Avocado             = $34B190;  $FF34B190  "#90B134"  "rgb(144,177, 52)"  "rgba(144,177, 52,255)"  "Avocado"
#XKCD_MarineBlue          = $6A3801;  $FF6A3801  "#01386A"  "rgb(  1, 56,106)"  "rgba(  1, 56,106,255)"  "MarineBlue"
#XKCD_TealGreen           = $6FA325;  $FF6FA325  "#25A36F"  "rgb( 37,163,111)"  "rgba( 37,163,111,255)"  "TealGreen"
#XKCD_SlateGrey           = $6D6559;  $FF6D6559  "#59656D"  "rgb( 89,101,109)"  "rgba( 89,101,109,255)"  "SlateGrey"
#XKCD_LighterGreen        = $63FD75;  $FF63FD75  "#75FD63"  "rgb(117,253, 99)"  "rgba(117,253, 99,255)"  "LighterGreen"
#XKCD_ElectricGreen       = $0DFC21;  $FF0DFC21  "#21FC0D"  "rgb( 33,252, 13)"  "rgba( 33,252, 13,255)"  "ElectricGreen"
#XKCD_DustyBlue           = $AD865A;  $FFAD865A  "#5A86AD"  "rgb( 90,134,173)"  "rgba( 90,134,173,255)"  "DustyBlue"
#XKCD_GoldenYellow        = $15C6FE;  $FF15C6FE  "#FEC615"  "rgb(254,198, 21)"  "rgba(254,198, 21,255)"  "GoldenYellow"
#XKCD_BrightYellow        = $01FDFF;  $FF01FDFF  "#FFFD01"  "rgb(255,253,  1)"  "rgba(255,253,  1,255)"  "BrightYellow"
#XKCD_LightLavender       = $FEC5DF;  $FFFEC5DF  "#DFC5FE"  "rgb(223,197,254)"  "rgba(223,197,254,255)"  "LightLavender"
#XKCD_Umber               = $0064B2;  $FF0064B2  "#B26400"  "rgb(178,100,  0)"  "rgba(178,100,  0,255)"  "Umber"
#XKCD_Poop                = $005E7F;  $FF005E7F  "#7F5E00"  "rgb(127, 94,  0)"  "rgba(127, 94,  0,255)"  "Poop"
#XKCD_DarkPeach           = $5D7EDE;  $FF5D7EDE  "#DE7E5D"  "rgb(222,126, 93)"  "rgba(222,126, 93,255)"  "DarkPeach"
#XKCD_JungleGreen         = $438204;  $FF438204  "#048243"  "rgb(  4,130, 67)"  "rgba(  4,130, 67,255)"  "JungleGreen"
#XKCD_Eggshell_           = $D4FFFF;  $FFD4FFFF  "#FFFFD4"  "rgb(255,255,212)"  "rgba(255,255,212,255)"  "Eggshell_"
#XKCD_Denim               = $8C633B;  $FF8C633B  "#3B638C"  "rgb( 59, 99,140)"  "rgba( 59, 99,140,255)"  "Denim"
#XKCD_YellowBrown         = $0094B7;  $FF0094B7  "#B79400"  "rgb(183,148,  0)"  "rgba(183,148,  0,255)"  "YellowBrown"
#XKCD_DullPurple          = $7E5984;  $FF7E5984  "#84597E"  "rgb(132, 89,126)"  "rgba(132, 89,126,255)"  "DullPurple"
#XKCD_ChocolateBrown      = $001941;  $FF001941  "#411900"  "rgb( 65, 25,  0)"  "rgba( 65, 25,  0,255)"  "ChocolateBrown"
#XKCD_WineRed             = $23037B;  $FF23037B  "#7B0323"  "rgb(123,  3, 35)"  "rgba(123,  3, 35,255)"  "WineRed"
#XKCD_NeonBlue            = $FFD904;  $FFFFD904  "#04D9FF"  "rgb(  4,217,255)"  "rgba(  4,217,255,255)"  "NeonBlue"
#XKCD_DirtyGreen          = $2C7E66;  $FF2C7E66  "#667E2C"  "rgb(102,126, 44)"  "rgba(102,126, 44,255)"  "DirtyGreen"
#XKCD_LightTan            = $ACEEFB;  $FFACEEFB  "#FBEEAC"  "rgb(251,238,172)"  "rgba(251,238,172,255)"  "LightTan"
#XKCD_IceBlue             = $FEFFD7;  $FFFEFFD7  "#D7FFFE"  "rgb(215,255,254)"  "rgba(215,255,254,255)"  "IceBlue"
#XKCD_CadetBlue           = $96744E;  $FF96744E  "#4E7496"  "rgb( 78,116,150)"  "rgba( 78,116,150,255)"  "CadetBlue"
#XKCD_DarkMauve           = $624C87;  $FF624C87  "#874C62"  "rgb(135, 76, 98)"  "rgba(135, 76, 98,255)"  "DarkMauve"
#XKCD_VeryLightBlue       = $FFFFD5;  $FFFFFFD5  "#D5FFFF"  "rgb(213,255,255)"  "rgba(213,255,255,255)"  "VeryLightBlue"
#XKCD_GreyPurple          = $8C6D82;  $FF8C6D82  "#826D8C"  "rgb(130,109,140)"  "rgba(130,109,140,255)"  "GreyPurple"
#XKCD_PastelPink          = $CDBAFF;  $FFCDBAFF  "#FFBACD"  "rgb(255,186,205)"  "rgba(255,186,205,255)"  "PastelPink"
#XKCD_VeryLightGreen      = $BDFFD1;  $FFBDFFD1  "#D1FFBD"  "rgb(209,255,189)"  "rgba(209,255,189,255)"  "VeryLightGreen"
#XKCD_DarkSkyBlue         = $E48E44;  $FFE48E44  "#448EE4"  "rgb( 68,142,228)"  "rgba( 68,142,228,255)"  "DarkSkyBlue"
#XKCD_Evergreen           = $2A4705;  $FF2A4705  "#05472A"  "rgb(  5, 71, 42)"  "rgba(  5, 71, 42,255)"  "Evergreen"
#XKCD_DullPink            = $9D86D5;  $FF9D86D5  "#D5869D"  "rgb(213,134,157)"  "rgba(213,134,157,255)"  "DullPink"
#XKCD_Aubergine           = $34073D;  $FF34073D  "#3D0734"  "rgb( 61,  7, 52)"  "rgba( 61,  7, 52,255)"  "Aubergine"
#XKCD_Mahogany            = $00014A;  $FF00014A  "#4A0100"  "rgb( 74,  1,  0)"  "rgba( 74,  1,  0,255)"  "Mahogany"
#XKCD_ReddishOrange       = $1C48F8;  $FF1C48F8  "#F8481C"  "rgb(248, 72, 28)"  "rgba(248, 72, 28,255)"  "ReddishOrange"
#XKCD_DeepGreen           = $0F5902;  $FF0F5902  "#02590F"  "rgb(  2, 89, 15)"  "rgba(  2, 89, 15,255)"  "DeepGreen"
#XKCD_VomitGreen          = $03A289;  $FF03A289  "#89A203"  "rgb(137,162,  3)"  "rgba(137,162,  3,255)"  "VomitGreen"
#XKCD_PurplePink_         = $D83FE0;  $FFD83FE0  "#E03FD8"  "rgb(224, 63,216)"  "rgba(224, 63,216,255)"  "PurplePink_"
#XKCD_DustyPink           = $948AD5;  $FF948AD5  "#D58A94"  "rgb(213,138,148)"  "rgba(213,138,148,255)"  "DustyPink"
#XKCD_FadedGreen          = $74B27B;  $FF74B27B  "#7BB274"  "rgb(123,178,116)"  "rgba(123,178,116,255)"  "FadedGreen"
#XKCD_CamoGreen           = $256552;  $FF256552  "#526525"  "rgb( 82,101, 37)"  "rgba( 82,101, 37,255)"  "CamoGreen"
#XKCD_PinkyPurple         = $BE4CC9;  $FFBE4CC9  "#C94CBE"  "rgb(201, 76,190)"  "rgba(201, 76,190,255)"  "PinkyPurple"
#XKCD_PinkPurple_         = $DA4BDB;  $FFDA4BDB  "#DB4BDA"  "rgb(219, 75,218)"  "rgba(219, 75,218,255)"  "PinkPurple_"
#XKCD_BrownishRed         = $23369E;  $FF23369E  "#9E3623"  "rgb(158, 54, 35)"  "rgba(158, 54, 35,255)"  "BrownishRed"
#XKCD_DarkRose            = $5D48B5;  $FF5D48B5  "#B5485D"  "rgb(181, 72, 93)"  "rgba(181, 72, 93,255)"  "DarkRose"
#XKCD_Mud                 = $125C73;  $FF125C73  "#735C12"  "rgb(115, 92, 18)"  "rgba(115, 92, 18,255)"  "Mud"
#XKCD_Brownish            = $576D9C;  $FF576D9C  "#9C6D57"  "rgb(156,109, 87)"  "rgba(156,109, 87,255)"  "Brownish"
#XKCD_EmeraldGreen        = $1E8F02;  $FF1E8F02  "#028F1E"  "rgb(  2,143, 30)"  "rgba(  2,143, 30,255)"  "EmeraldGreen"
#XKCD_PaleBrown           = $6E91B1;  $FF6E91B1  "#B1916E"  "rgb(177,145,110)"  "rgba(177,145,110,255)"  "PaleBrown"
#XKCD_DullBlue            = $9C7549;  $FF9C7549  "#49759C"  "rgb( 73,117,156)"  "rgba( 73,117,156,255)"  "DullBlue"
#XKCD_BurntUmber          = $0E45A0;  $FF0E45A0  "#A0450E"  "rgb(160, 69, 14)"  "rgba(160, 69, 14,255)"  "BurntUmber"
#XKCD_MediumGreen         = $48AD39;  $FF48AD39  "#39AD48"  "rgb( 57,173, 72)"  "rgba( 57,173, 72,255)"  "MediumGreen"
#XKCD_Clay                = $506AB6;  $FF506AB6  "#B66A50"  "rgb(182,106, 80)"  "rgba(182,106, 80,255)"  "Clay"
#XKCD_LightAqua           = $DBFF8C;  $FFDBFF8C  "#8CFFDB"  "rgb(140,255,219)"  "rgba(140,255,219,255)"  "LightAqua"
#XKCD_LightOliveGreen     = $5CBEA4;  $FF5CBEA4  "#A4BE5C"  "rgb(164,190, 92)"  "rgba(164,190, 92,255)"  "LightOliveGreen"
#XKCD_BrownishOrange      = $2377CB;  $FF2377CB  "#CB7723"  "rgb(203,119, 35)"  "rgba(203,119, 35,255)"  "BrownishOrange"
#XKCD_DarkAqua            = $6B6905;  $FF6B6905  "#05696B"  "rgb(  5,105,107)"  "rgba(  5,105,107,255)"  "DarkAqua"
#XKCD_PurplishPink        = $AE5DCE;  $FFAE5DCE  "#CE5DAE"  "rgb(206, 93,174)"  "rgba(206, 93,174,255)"  "PurplishPink"
#XKCD_DarkSalmon          = $535AC8;  $FF535AC8  "#C85A53"  "rgb(200, 90, 83)"  "rgba(200, 90, 83,255)"  "DarkSalmon"
#XKCD_GreenishGrey        = $8DAE96;  $FF8DAE96  "#96AE8D"  "rgb(150,174,141)"  "rgba(150,174,141,255)"  "GreenishGrey"
#XKCD_Jade                = $74A71F;  $FF74A71F  "#1FA774"  "rgb( 31,167,116)"  "rgba( 31,167,116,255)"  "Jade"
#XKCD_UglyGreen           = $03977A;  $FF03977A  "#7A9703"  "rgb(122,151,  3)"  "rgba(122,151,  3,255)"  "UglyGreen"
#XKCD_DarkBeige           = $6293AC;  $FF6293AC  "#AC9362"  "rgb(172,147, 98)"  "rgba(172,147, 98,255)"  "DarkBeige"
#XKCD_Emerald             = $49A001;  $FF49A001  "#01A049"  "rgb(  1,160, 73)"  "rgba(  1,160, 73,255)"  "Emerald"
#XKCD_PaleRed             = $4D54D9;  $FF4D54D9  "#D9544D"  "rgb(217, 84, 77)"  "rgba(217, 84, 77,255)"  "PaleRed"
#XKCD_LightMagenta        = $F75FFA;  $FFF75FFA  "#FA5FF7"  "rgb(250, 95,247)"  "rgba(250, 95,247,255)"  "LightMagenta"
#XKCD_Sky                 = $FCCA82;  $FFFCCA82  "#82CAFC"  "rgb(130,202,252)"  "rgba(130,202,252,255)"  "Sky"
#XKCD_LightCyan           = $FCFFAC;  $FFFCFFAC  "#ACFFFC"  "rgb(172,255,252)"  "rgba(172,255,252,255)"  "LightCyan"
#XKCD_YellowOrange        = $01B0FC;  $FF01B0FC  "#FCB001"  "rgb(252,176,  1)"  "rgba(252,176,  1,255)"  "YellowOrange"
#XKCD_ReddishPurple       = $510991;  $FF510991  "#910951"  "rgb(145,  9, 81)"  "rgba(145,  9, 81,255)"  "ReddishPurple"
#XKCD_ReddishPink         = $542CFE;  $FF542CFE  "#FE2C54"  "rgb(254, 44, 84)"  "rgba(254, 44, 84,255)"  "ReddishPink"
#XKCD_Orchid              = $C475C8;  $FFC475C8  "#C875C4"  "rgb(200,117,196)"  "rgba(200,117,196,255)"  "Orchid"
#XKCD_DirtyYellow         = $0AC5CD;  $FF0AC5CD  "#CDC50A"  "rgb(205,197, 10)"  "rgba(205,197, 10,255)"  "DirtyYellow"
#XKCD_OrangeRed_          = $1E41FD;  $FF1E41FD  "#FD411E"  "rgb(253, 65, 30)"  "rgba(253, 65, 30,255)"  "OrangeRed_"
#XKCD_DeepRed             = $00029A;  $FF00029A  "#9A0200"  "rgb(154,  2,  0)"  "rgba(154,  2,  0,255)"  "DeepRed"
#XKCD_OrangeBrown         = $0064BE;  $FF0064BE  "#BE6400"  "rgb(190,100,  0)"  "rgba(190,100,  0,255)"  "OrangeBrown"
#XKCD_CobaltBlue          = $A70A03;  $FFA70A03  "#030AA7"  "rgb(  3, 10,167)"  "rgba(  3, 10,167,255)"  "CobaltBlue"
#XKCD_NeonPink            = $9A01FE;  $FF9A01FE  "#FE019A"  "rgb(254,  1,154)"  "rgba(254,  1,154,255)"  "NeonPink"
#XKCD_RosePink            = $9A87F7;  $FF9A87F7  "#F7879A"  "rgb(247,135,154)"  "rgba(247,135,154,255)"  "RosePink"
#XKCD_GreyishPurple       = $917188;  $FF917188  "#887191"  "rgb(136,113,145)"  "rgba(136,113,145,255)"  "GreyishPurple"
#XKCD_Raspberry           = $4901B0;  $FF4901B0  "#B00149"  "rgb(176,  1, 73)"  "rgba(176,  1, 73,255)"  "Raspberry"
#XKCD_AquaGreen           = $93E112;  $FF93E112  "#12E193"  "rgb( 18,225,147)"  "rgba( 18,225,147,255)"  "AquaGreen"
#XKCD_SalmonPink          = $7C7BFE;  $FF7C7BFE  "#FE7B7C"  "rgb(254,123,124)"  "rgba(254,123,124,255)"  "SalmonPink"
#XKCD_Tangerine           = $0894FF;  $FF0894FF  "#FF9408"  "rgb(255,148,  8)"  "rgba(255,148,  8,255)"  "Tangerine"
#XKCD_BrownishGreen       = $096E6A;  $FF096E6A  "#6A6E09"  "rgb(106,110,  9)"  "rgba(106,110,  9,255)"  "BrownishGreen"
#XKCD_RedBrown            = $162E8B;  $FF162E8B  "#8B2E16"  "rgb(139, 46, 22)"  "rgba(139, 46, 22,255)"  "RedBrown"
#XKCD_GreenishBrown       = $126169;  $FF126169  "#696112"  "rgb(105, 97, 18)"  "rgba(105, 97, 18,255)"  "GreenishBrown"
#XKCD_Pumpkin             = $0177E1;  $FF0177E1  "#E17701"  "rgb(225,119,  1)"  "rgba(225,119,  1,255)"  "Pumpkin"
#XKCD_PineGreen           = $1E480A;  $FF1E480A  "#0A481E"  "rgb( 10, 72, 30)"  "rgba( 10, 72, 30,255)"  "PineGreen"
#XKCD_Charcoal            = $373834;  $FF373834  "#343837"  "rgb( 52, 56, 55)"  "rgba( 52, 56, 55,255)"  "Charcoal"
#XKCD_BabyPink            = $CEB7FF;  $FFCEB7FF  "#FFB7CE"  "rgb(255,183,206)"  "rgba(255,183,206,255)"  "BabyPink"
#XKCD_Cornflower          = $F7796A;  $FFF7796A  "#6A79F7"  "rgb(106,121,247)"  "rgba(106,121,247,255)"  "Cornflower"
#XKCD_BlueViolet          = $E9065D;  $FFE9065D  "#5D06E9"  "rgb( 93,  6,233)"  "rgba( 93,  6,233,255)"  "BlueViolet"
#XKCD_Chocolate           = $021C3D;  $FF021C3D  "#3D1C02"  "rgb( 61, 28,  2)"  "rgba( 61, 28,  2,255)"  "Chocolate"
#XKCD_GreyishGreen        = $7DA682;  $FF7DA682  "#82A67D"  "rgb(130,166,125)"  "rgba(130,166,125,255)"  "GreyishGreen"
#XKCD_Scarlet             = $1901BE;  $FF1901BE  "#BE0119"  "rgb(190,  1, 25)"  "rgba(190,  1, 25,255)"  "Scarlet"
#XKCD_GreenYellow_        = $27FFC9;  $FF27FFC9  "#C9FF27"  "rgb(201,255, 39)"  "rgba(201,255, 39,255)"  "GreenYellow_"
#XKCD_DarkOlive           = $023E37;  $FF023E37  "#373E02"  "rgb( 55, 62,  2)"  "rgba( 55, 62,  2,255)"  "DarkOlive"
#XKCD_Sienna              = $1E56A9;  $FF1E56A9  "#A9561E"  "rgb(169, 86, 30)"  "rgba(169, 86, 30,255)"  "Sienna"
#XKCD_PastelPurple        = $FFA0CA;  $FFFFA0CA  "#CAA0FF"  "rgb(202,160,255)"  "rgba(202,160,255,255)"  "PastelPurple"
#XKCD_Terracotta_         = $4166CA;  $FF4166CA  "#CA6641"  "rgb(202,102, 65)"  "rgba(202,102, 65,255)"  "Terracotta_"
#XKCD_AquaBlue            = $E9D802;  $FFE9D802  "#02D8E9"  "rgb(  2,216,233)"  "rgba(  2,216,233,255)"  "AquaBlue"
#XKCD_SageGreen           = $78B388;  $FF78B388  "#88B378"  "rgb(136,179,120)"  "rgba(136,179,120,255)"  "SageGreen"
#XKCD_BloodRed            = $020098;  $FF020098  "#980002"  "rgb(152,  0,  2)"  "rgba(152,  0,  2,255)"  "BloodRed"
#XKCD_DeepPink            = $6201CB;  $FF6201CB  "#CB0162"  "rgb(203,  1, 98)"  "rgba(203,  1, 98,255)"  "DeepPink"
#XKCD_Grass               = $2DAC5C;  $FF2DAC5C  "#5CAC2D"  "rgb( 92,172, 45)"  "rgba( 92,172, 45,255)"  "Grass"
#XKCD_Moss                = $589976;  $FF589976  "#769958"  "rgb(118,153, 88)"  "rgba(118,153, 88,255)"  "Moss"
#XKCD_PastelBlue          = $FEBFA2;  $FFFEBFA2  "#A2BFFE"  "rgb(162,191,254)"  "rgba(162,191,254,255)"  "PastelBlue"
#XKCD_BluishGreen         = $74A610;  $FF74A610  "#10A674"  "rgb( 16,166,116)"  "rgba( 16,166,116,255)"  "BluishGreen"
#XKCD_GreenBlue2          = $8BB406;  $FF8BB406  "#06B48B"  "rgb(  6,180,139)"  "rgba(  6,180,139,255)"  "GreenBlue2"
#XKCD_DarkTan             = $4A88AF;  $FF4A88AF  "#AF884A"  "rgb(175,136, 74)"  "rgba(175,136, 74,255)"  "DarkTan"
#XKCD_GreenishBlue        = $878B0B;  $FF878B0B  "#0B8B87"  "rgb( 11,139,135)"  "rgba( 11,139,135,255)"  "GreenishBlue"
#XKCD_PaleOrange          = $56A7FF;  $FF56A7FF  "#FFA756"  "rgb(255,167, 86)"  "rgba(255,167, 86,255)"  "PaleOrange"
#XKCD_Vomit               = $15A4A2;  $FF15A4A2  "#A2A415"  "rgb(162,164, 21)"  "rgba(162,164, 21,255)"  "Vomit"
#XKCD_ForrestGreen        = $064415;  $FF064415  "#154406"  "rgb( 21, 68,  6)"  "rgba( 21, 68,  6,255)"  "ForrestGreen"
#XKCD_DarkLavender        = $986785;  $FF986785  "#856798"  "rgb(133,103,152)"  "rgba(133,103,152,255)"  "DarkLavender"
#XKCD_DarkViolet          = $3F0134;  $FF3F0134  "#34013F"  "rgb( 52,  1, 63)"  "rgba( 52,  1, 63,255)"  "DarkViolet"
#XKCD_PurpleBlue_         = $E92D63;  $FFE92D63  "#632DE9"  "rgb( 99, 45,233)"  "rgba( 99, 45,233,255)"  "PurpleBlue_"
#XKCD_DarkCyan            = $8A880A;  $FF8A880A  "#0A888A"  "rgb( 10,136,138)"  "rgba( 10,136,138,255)"  "DarkCyan"
#XKCD_OliveDrab           = $32766F;  $FF32766F  "#6F7632"  "rgb(111,118, 50)"  "rgba(111,118, 50,255)"  "OliveDrab"
#XKCD_Pinkish             = $7E6AD4;  $FF7E6AD4  "#D46A7E"  "rgb(212,106,126)"  "rgba(212,106,126,255)"  "Pinkish"
#XKCD_Cobalt              = $8F481E;  $FF8F481E  "#1E488F"  "rgb( 30, 72,143)"  "rgba( 30, 72,143,255)"  "Cobalt"
#XKCD_NeonPurple          = $FE13BC;  $FFFE13BC  "#BC13FE"  "rgb(188, 19,254)"  "rgba(188, 19,254,255)"  "NeonPurple"
#XKCD_LightTurquoise      = $CCF47E;  $FFCCF47E  "#7EF4CC"  "rgb(126,244,204)"  "rgba(126,244,204,255)"  "LightTurquoise"
#XKCD_AppleGreen          = $26CD76;  $FF26CD76  "#76CD26"  "rgb(118,205, 38)"  "rgba(118,205, 38,255)"  "AppleGreen"
#XKCD_DullGreen           = $62A674;  $FF62A674  "#74A662"  "rgb(116,166, 98)"  "rgba(116,166, 98,255)"  "DullGreen"
#XKCD_Wine                = $3F0180;  $FF3F0180  "#80013F"  "rgb(128,  1, 63)"  "rgba(128,  1, 63,255)"  "Wine"
#XKCD_PowderBlue          = $FCD1B1;  $FFFCD1B1  "#B1D1FC"  "rgb(177,209,252)"  "rgba(177,209,252,255)"  "PowderBlue"
#XKCD_OffWhite            = $E4FFFF;  $FFE4FFFF  "#FFFFE4"  "rgb(255,255,228)"  "rgba(255,255,228,255)"  "OffWhite"
#XKCD_ElectricBlue        = $FF5206;  $FFFF5206  "#0652FF"  "rgb(  6, 82,255)"  "rgba(  6, 82,255,255)"  "ElectricBlue"
#XKCD_DarkTurquoise       = $5A5C04;  $FF5A5C04  "#045C5A"  "rgb(  4, 92, 90)"  "rgba(  4, 92, 90,255)"  "DarkTurquoise"
#XKCD_BluePurple1         = $CE2957;  $FFCE2957  "#5729CE"  "rgb( 87, 41,206)"  "rgba( 87, 41,206,255)"  "BluePurple1"
#XKCD_Azure               = $F39A06;  $FFF39A06  "#069AF3"  "rgb(  6,154,243)"  "rgba(  6,154,243,255)"  "Azure"
#XKCD_BrightRed           = $0D00FF;  $FF0D00FF  "#FF000D"  "rgb(255,  0, 13)"  "rgba(255,  0, 13,255)"  "BrightRed"
#XKCD_PinkishRed          = $450CF1;  $FF450CF1  "#F10C45"  "rgb(241, 12, 69)"  "rgba(241, 12, 69,255)"  "PinkishRed"
#XKCD_CornflowerBlue      = $D77051;  $FFD77051  "#5170D7"  "rgb( 81,112,215)"  "rgba( 81,112,215,255)"  "CornflowerBlue"
#XKCD_LightOlive          = $69BFAC;  $FF69BFAC  "#ACBF69"  "rgb(172,191,105)"  "rgba(172,191,105,255)"  "LightOlive"
#XKCD_Grape               = $61346C;  $FF61346C  "#6C3461"  "rgb(108, 52, 97)"  "rgba(108, 52, 97,255)"  "Grape"
#XKCD_GreyishBlue         = $9D815E;  $FF9D815E  "#5E819D"  "rgb( 94,129,157)"  "rgba( 94,129,157,255)"  "GreyishBlue"
#XKCD_PurplishBlue        = $F91E60;  $FFF91E60  "#601EF9"  "rgb( 96, 30,249)"  "rgba( 96, 30,249,255)"  "PurplishBlue"
#XKCD_YellowishGreen      = $16DDB0;  $FF16DDB0  "#B0DD16"  "rgb(176,221, 22)"  "rgba(176,221, 22,255)"  "YellowishGreen"
#XKCD_GreenishYellow      = $02FDCD;  $FF02FDCD  "#CDFD02"  "rgb(205,253,  2)"  "rgba(205,253,  2,255)"  "GreenishYellow"
#XKCD_MediumBlue          = $BB6F2C;  $FFBB6F2C  "#2C6FBB"  "rgb( 44,111,187)"  "rgba( 44,111,187,255)"  "MediumBlue"
#XKCD_DustyRose           = $7A73C0;  $FF7A73C0  "#C0737A"  "rgb(192,115,122)"  "rgba(192,115,122,255)"  "DustyRose"
#XKCD_LightViolet         = $FCB4D6;  $FFFCB4D6  "#D6B4FC"  "rgb(214,180,252)"  "rgba(214,180,252,255)"  "LightViolet"
#XKCD_MidnightBlue        = $350002;  $FF350002  "#020035"  "rgb(  2,  0, 53)"  "rgba(  2,  0, 53,255)"  "MidnightBlue"
#XKCD_BluishPurple        = $E73B70;  $FFE73B70  "#703BE7"  "rgb(112, 59,231)"  "rgba(112, 59,231,255)"  "BluishPurple"
#XKCD_RedOrange           = $063CFD;  $FF063CFD  "#FD3C06"  "rgb(253, 60,  6)"  "rgba(253, 60,  6,255)"  "RedOrange"
#XKCD_DarkMagenta         = $560096;  $FF560096  "#960056"  "rgb(150,  0, 86)"  "rgba(150,  0, 86,255)"  "DarkMagenta"
#XKCD_Greenish            = $68A340;  $FF68A340  "#40A368"  "rgb( 64,163,104)"  "rgba( 64,163,104,255)"  "Greenish"
#XKCD_OceanBlue           = $9C7103;  $FF9C7103  "#03719C"  "rgb(  3,113,156)"  "rgba(  3,113,156,255)"  "OceanBlue"
#XKCD_Coral               = $505AFC;  $FF505AFC  "#FC5A50"  "rgb(252, 90, 80)"  "rgba(252, 90, 80,255)"  "Coral"
#XKCD_Cream               = $C2FFFF;  $FFC2FFFF  "#FFFFC2"  "rgb(255,255,194)"  "rgba(255,255,194,255)"  "Cream"
#XKCD_ReddishBrown        = $0A2B7F;  $FF0A2B7F  "#7F2B0A"  "rgb(127, 43, 10)"  "rgba(127, 43, 10,255)"  "ReddishBrown"
#XKCD_BurntSienna         = $0F4EB0;  $FF0F4EB0  "#B04E0F"  "rgb(176, 78, 15)"  "rgba(176, 78, 15,255)"  "BurntSienna"
#XKCD_Brick               = $2336A0;  $FF2336A0  "#A03623"  "rgb(160, 54, 35)"  "rgba(160, 54, 35,255)"  "Brick"
#XKCD_Sage                = $73AE87;  $FF73AE87  "#87AE73"  "rgb(135,174,115)"  "rgba(135,174,115,255)"  "Sage"
#XKCD_GreyGreen_          = $739B78;  $FF739B78  "#789B73"  "rgb(120,155,115)"  "rgba(120,155,115,255)"  "GreyGreen_"
#XKCD_White               = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(255,255,255)"  "rgba(255,255,255,255)"  "White"
#XKCD_RobinsEggBlue       = $F9EF98;  $FFF9EF98  "#98EFF9"  "rgb(152,239,249)"  "rgba(152,239,249,255)"  "RobinsEggBlue"
#XKCD_MossGreen           = $388B65;  $FF388B65  "#658B38"  "rgb(101,139, 56)"  "rgba(101,139, 56,255)"  "MossGreen"
#XKCD_SteelBlue           = $9A7D5A;  $FF9A7D5A  "#5A7D9A"  "rgb( 90,125,154)"  "rgba( 90,125,154,255)"  "SteelBlue"
#XKCD_Eggplant            = $350838;  $FF350838  "#380835"  "rgb( 56,  8, 53)"  "rgba( 56,  8, 53,255)"  "Eggplant"
#XKCD_LightYellow         = $7AFEFF;  $FF7AFEFF  "#FFFE7A"  "rgb(255,254,122)"  "rgba(255,254,122,255)"  "LightYellow"
#XKCD_LeafGreen           = $04A95C;  $FF04A95C  "#5CA904"  "rgb( 92,169,  4)"  "rgba( 92,169,  4,255)"  "LeafGreen"
#XKCD_LightGrey           = $D6DCD8;  $FFD6DCD8  "#D8DCD6"  "rgb(216,220,214)"  "rgba(216,220,214,255)"  "LightGrey"
#XKCD_Puke                = $02A5A5;  $FF02A5A5  "#A5A502"  "rgb(165,165,  2)"  "rgba(165,165,  2,255)"  "Puke"
#XKCD_PinkishPurple       = $D748D6;  $FFD748D6  "#D648D7"  "rgb(214, 72,215)"  "rgba(214, 72,215,255)"  "PinkishPurple"
#XKCD_SeaBlue             = $957404;  $FF957404  "#047495"  "rgb(  4,116,149)"  "rgba(  4,116,149,255)"  "SeaBlue"
#XKCD_PalePurple          = $D490B7;  $FFD490B7  "#B790D4"  "rgb(183,144,212)"  "rgba(183,144,212,255)"  "PalePurple"
#XKCD_SlateBlue           = $997C5B;  $FF997C5B  "#5B7C99"  "rgb( 91,124,153)"  "rgba( 91,124,153,255)"  "SlateBlue"
#XKCD_BlueGrey2           = $8E7C60;  $FF8E7C60  "#607C8E"  "rgb( 96,124,142)"  "rgba( 96,124,142,255)"  "BlueGrey2"
#XKCD_HunterGreen         = $08400B;  $FF08400B  "#0B4008"  "rgb( 11, 64,  8)"  "rgba( 11, 64,  8,255)"  "HunterGreen"
#XKCD_Fuchsia             = $D90DED;  $FFD90DED  "#ED0DD9"  "rgb(237, 13,217)"  "rgba(237, 13,217,255)"  "Fuchsia"
#XKCD_Crimson             = $0F008C;  $FF0F008C  "#8C000F"  "rgb(140,  0, 15)"  "rgba(140,  0, 15,255)"  "Crimson"
#XKCD_PaleYellow          = $84FFFF;  $FF84FFFF  "#FFFF84"  "rgb(255,255,132)"  "rgba(255,255,132,255)"  "PaleYellow"
#XKCD_Ochre               = $0590BF;  $FF0590BF  "#BF9005"  "rgb(191,144,  5)"  "rgba(191,144,  5,255)"  "Ochre"
#XKCD_MustardYellow       = $0ABDD2;  $FF0ABDD2  "#D2BD0A"  "rgb(210,189, 10)"  "rgba(210,189, 10,255)"  "MustardYellow"
#XKCD_LightRed            = $4C47FF;  $FF4C47FF  "#FF474C"  "rgb(255, 71, 76)"  "rgba(255, 71, 76,255)"  "LightRed"
#XKCD_Cerulean            = $D18504;  $FFD18504  "#0485D1"  "rgb(  4,133,209)"  "rgba(  4,133,209,255)"  "Cerulean"
#XKCD_PalePink            = $DCCFFF;  $FFDCCFFF  "#FFCFDC"  "rgb(255,207,220)"  "rgba(255,207,220,255)"  "PalePink"
#XKCD_DeepBlue            = $730204;  $FF730204  "#040273"  "rgb(  4,  2,115)"  "rgba(  4,  2,115,255)"  "DeepBlue"
#XKCD_Rust                = $093CA8;  $FF093CA8  "#A83C09"  "rgb(168, 60,  9)"  "rgba(168, 60,  9,255)"  "Rust"
#XKCD_LightTeal           = $C1E490;  $FFC1E490  "#90E4C1"  "rgb(144,228,193)"  "rgba(144,228,193,255)"  "LightTeal"
#XKCD_Slate               = $726551;  $FF726551  "#516572"  "rgb( 81,101,114)"  "rgba( 81,101,114,255)"  "Slate"
#XKCD_Goldenrod1          = $05C2FA;  $FF05C2FA  "#FAC205"  "rgb(250,194,  5)"  "rgba(250,194,  5,255)"  "Goldenrod1"
#XKCD_DarkYellow          = $0AB6D5;  $FF0AB6D5  "#D5B60A"  "rgb(213,182, 10)"  "rgba(213,182, 10,255)"  "DarkYellow"
#XKCD_DarkGrey            = $373736;  $FF373736  "#363737"  "rgb( 54, 55, 55)"  "rgba( 54, 55, 55,255)"  "DarkGrey"
#XKCD_ArmyGreen           = $165D4B;  $FF165D4B  "#4B5D16"  "rgb( 75, 93, 22)"  "rgba( 75, 93, 22,255)"  "ArmyGreen"
#XKCD_GreyBlue1           = $A48B6B;  $FFA48B6B  "#6B8BA4"  "rgb(107,139,164)"  "rgba(107,139,164,255)"  "GreyBlue1"
#XKCD_Seafoam             = $ADF980;  $FFADF980  "#80F9AD"  "rgb(128,249,173)"  "rgba(128,249,173,255)"  "Seafoam"
#XKCD_Puce                = $527EA5;  $FF527EA5  "#A57E52"  "rgb(165,126, 82)"  "rgba(165,126, 82,255)"  "Puce"
#XKCD_SpringGreen         = $71F9A9;  $FF71F9A9  "#A9F971"  "rgb(169,249,113)"  "rgba(169,249,113,255)"  "SpringGreen"
#XKCD_DarkOrange          = $0251C6;  $FF0251C6  "#C65102"  "rgb(198, 81,  2)"  "rgba(198, 81,  2,255)"  "DarkOrange"
#XKCD_Sand                = $76CAE2;  $FF76CAE2  "#E2CA76"  "rgb(226,202,118)"  "rgba(226,202,118,255)"  "Sand"
#XKCD_PastelGreen         = $9DFFB0;  $FF9DFFB0  "#B0FF9D"  "rgb(176,255,157)"  "rgba(176,255,157,255)"  "PastelGreen"
#XKCD_Mint                = $B0FE9F;  $FFB0FE9F  "#9FFEB0"  "rgb(159,254,176)"  "rgba(159,254,176,255)"  "Mint"
#XKCD_LightOrange         = $48AAFD;  $FF48AAFD  "#FDAA48"  "rgb(253,170, 72)"  "rgba(253,170, 72,255)"  "LightOrange"
#XKCD_BrightPink          = $B101FE;  $FFB101FE  "#FE01B1"  "rgb(254,  1,177)"  "rgba(254,  1,177,255)"  "BrightPink"
#XKCD_Chartreuse          = $0AF8C1;  $FF0AF8C1  "#C1F80A"  "rgb(193,248, 10)"  "rgba(193,248, 10,255)"  "Chartreuse"
#XKCD_DeepPurple          = $3F0136;  $FF3F0136  "#36013F"  "rgb( 54,  1, 63)"  "rgba( 54,  1, 63,255)"  "DeepPurple"
#XKCD_DarkBrown           = $021C34;  $FF021C34  "#341C02"  "rgb( 52, 28,  2)"  "rgba( 52, 28,  2,255)"  "DarkBrown"
#XKCD_Taupe               = $81A2B9;  $FF81A2B9  "#B9A281"  "rgb(185,162,129)"  "rgba(185,162,129,255)"  "Taupe"
#XKCD_PeaGreen            = $12AB8E;  $FF12AB8E  "#8EAB12"  "rgb(142,171, 18)"  "rgba(142,171, 18,255)"  "PeaGreen"
#XKCD_PukeGreen           = $07AE9A;  $FF07AE9A  "#9AAE07"  "rgb(154,174,  7)"  "rgba(154,174,  7,255)"  "PukeGreen"
#XKCD_KellyGreen          = $2EAB02;  $FF2EAB02  "#02AB2E"  "rgb(  2,171, 46)"  "rgba(  2,171, 46,255)"  "KellyGreen"
#XKCD_SeafoamGreen        = $ABF97A;  $FFABF97A  "#7AF9AB"  "rgb(122,249,171)"  "rgba(122,249,171,255)"  "SeafoamGreen"
#XKCD_BlueGreen1          = $6D7E13;  $FF6D7E13  "#137E6D"  "rgb( 19,126,109)"  "rgba( 19,126,109,255)"  "BlueGreen1"
#XKCD_Khaki               = $62A6AA;  $FF62A6AA  "#AAA662"  "rgb(170,166, 98)"  "rgba(170,166, 98,255)"  "Khaki"
#XKCD_Burgundy            = $230061;  $FF230061  "#610023"  "rgb( 97,  0, 35)"  "rgba( 97,  0, 35,255)"  "Burgundy"
#XKCD_DarkTeal            = $4E4D01;  $FF4E4D01  "#014D4E"  "rgb(  1, 77, 78)"  "rgba(  1, 77, 78,255)"  "DarkTeal"
#XKCD_BrickRed            = $02148F;  $FF02148F  "#8F1402"  "rgb(143, 20,  2)"  "rgba(143, 20,  2,255)"  "BrickRed"
#XKCD_RoyalPurple         = $6E004B;  $FF6E004B  "#4B006E"  "rgb( 75,  0,110)"  "rgba( 75,  0,110,255)"  "RoyalPurple"
#XKCD_Plum                = $410F58;  $FF410F58  "#580F41"  "rgb( 88, 15, 65)"  "rgba( 88, 15, 65,255)"  "Plum"
#XKCD_MintGreen           = $9FFF8F;  $FF9FFF8F  "#8FFF9F"  "rgb(143,255,159)"  "rgba(143,255,159,255)"  "MintGreen"
#XKCD_Gold                = $0CB4DB;  $FF0CB4DB  "#DBB40C"  "rgb(219,180, 12)"  "rgba(219,180, 12,255)"  "Gold"
#XKCD_BabyBlue            = $FECFA2;  $FFFECFA2  "#A2CFFE"  "rgb(162,207,254)"  "rgba(162,207,254,255)"  "BabyBlue"
#XKCD_YellowGreen1        = $2DFBC0;  $FF2DFBC0  "#C0FB2D"  "rgb(192,251, 45)"  "rgba(192,251, 45,255)"  "YellowGreen1"
#XKCD_BrightPurple        = $FD03BE;  $FFFD03BE  "#BE03FD"  "rgb(190,  3,253)"  "rgba(190,  3,253,255)"  "BrightPurple"
#XKCD_DarkRed             = $000084;  $FF000084  "#840000"  "rgb(132,  0,  0)"  "rgba(132,  0,  0,255)"  "DarkRed"
#XKCD_PaleBlue            = $FEFED0;  $FFFEFED0  "#D0FEFE"  "rgb(208,254,254)"  "rgba(208,254,254,255)"  "PaleBlue"
#XKCD_GrassGreen          = $0B9B3F;  $FF0B9B3F  "#3F9B0B"  "rgb( 63,155, 11)"  "rgba( 63,155, 11,255)"  "GrassGreen"
#XKCD_Navy                = $3E1501;  $FF3E1501  "#01153E"  "rgb(  1, 21, 62)"  "rgba(  1, 21, 62,255)"  "Navy"
#XKCD_Aquamarine_         = $B2D804;  $FFB2D804  "#04D8B2"  "rgb(  4,216,178)"  "rgba(  4,216,178,255)"  "Aquamarine_"
#XKCD_BurntOrange         = $014EC0;  $FF014EC0  "#C04E01"  "rgb(192, 78,  1)"  "rgba(192, 78,  1,255)"  "BurntOrange"
#XKCD_NeonGreen           = $0CFF0C;  $FF0CFF0C  "#0CFF0C"  "rgb( 12,255, 12)"  "rgba( 12,255, 12,255)"  "NeonGreen"
#XKCD_BrightBlue          = $FC6501;  $FFFC6501  "#0165FC"  "rgb(  1,101,252)"  "rgba(  1,101,252,255)"  "BrightBlue"
#XKCD_Rose                = $7562CF;  $FF7562CF  "#CF6275"  "rgb(207, 98,117)"  "rgba(207, 98,117,255)"  "Rose"
#XKCD_LightPink           = $DFD1FF;  $FFDFD1FF  "#FFD1DF"  "rgb(255,209,223)"  "rgba(255,209,223,255)"  "LightPink"
#XKCD_Mustard             = $01B3CE;  $FF01B3CE  "#CEB301"  "rgb(206,179,  1)"  "rgba(206,179,  1,255)"  "Mustard"
#XKCD_Indigo              = $820238;  $FF820238  "#380282"  "rgb( 56,  2,130)"  "rgba( 56,  2,130,255)"  "Indigo"
#XKCD_Lime                = $32FFAA;  $FF32FFAA  "#AAFF32"  "rgb(170,255, 50)"  "rgba(170,255, 50,255)"  "Lime"
#XKCD_SeaGreen            = $A1FC53;  $FFA1FC53  "#53FCA1"  "rgb( 83,252,161)"  "rgba( 83,252,161,255)"  "SeaGreen"
#XKCD_Periwinkle          = $FE828E;  $FFFE828E  "#8E82FE"  "rgb(142,130,254)"  "rgba(142,130,254,255)"  "Periwinkle"
#XKCD_DarkPink            = $6B41CB;  $FF6B41CB  "#CB416B"  "rgb(203, 65,107)"  "rgba(203, 65,107,255)"  "DarkPink"
#XKCD_OliveGreen          = $047A67;  $FF047A67  "#677A04"  "rgb(103,122,  4)"  "rgba(103,122,  4,255)"  "OliveGreen"
#XKCD_Peach               = $7CB0FF;  $FF7CB0FF  "#FFB07C"  "rgb(255,176,124)"  "rgba(255,176,124,255)"  "Peach"
#XKCD_PaleGreen           = $B5FDC7;  $FFB5FDC7  "#C7FDB5"  "rgb(199,253,181)"  "rgba(199,253,181,255)"  "PaleGreen"
#XKCD_LightBrown          = $5081AD;  $FF5081AD  "#AD8150"  "rgb(173,129, 80)"  "rgba(173,129, 80,255)"  "LightBrown"
#XKCD_HotPink             = $8D02FF;  $FF8D02FF  "#FF028D"  "rgb(255,  2,141)"  "rgba(255,  2,141,255)"  "HotPink"
#XKCD_Black               = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "Black"
#XKCD_Lilac               = $FDA2CE;  $FFFDA2CE  "#CEA2FD"  "rgb(206,162,253)"  "rgba(206,162,253,255)"  "Lilac"
#XKCD_NavyBlue            = $461100;  $FF461100  "#001146"  "rgb(  0, 17, 70)"  "rgba(  0, 17, 70,255)"  "NavyBlue"
#XKCD_RoyalBlue           = $AA0405;  $FFAA0405  "#0504AA"  "rgb(  5,  4,170)"  "rgba(  5,  4,170,255)"  "RoyalBlue"
#XKCD_Beige               = $A6DAE6;  $FFA6DAE6  "#E6DAA6"  "rgb(230,218,166)"  "rgba(230,218,166,255)"  "Beige"
#XKCD_Salmon              = $6C79FF;  $FF6C79FF  "#FF796C"  "rgb(255,121,108)"  "rgba(255,121,108,255)"  "Salmon"
#XKCD_Olive               = $0E756E;  $FF0E756E  "#6E750E"  "rgb(110,117, 14)"  "rgba(110,117, 14,255)"  "Olive"
#XKCD_Maroon              = $210065;  $FF210065  "#650021"  "rgb(101,  0, 33)"  "rgba(101,  0, 33,255)"  "Maroon"
#XKCD_BrightGreen         = $07FF01;  $FF07FF01  "#01FF07"  "rgb(  1,255,  7)"  "rgba(  1,255,  7,255)"  "BrightGreen"
#XKCD_DarkPurple          = $3E0635;  $FF3E0635  "#35063E"  "rgb( 53,  6, 62)"  "rgba( 53,  6, 62,255)"  "DarkPurple"
#XKCD_Mauve               = $8171AE;  $FF8171AE  "#AE7181"  "rgb(174,113,129)"  "rgba(174,113,129,255)"  "Mauve"
#XKCD_ForestGreen         = $0C4706;  $FF0C4706  "#06470C"  "rgb(  6, 71, 12)"  "rgba(  6, 71, 12,255)"  "ForestGreen"
#XKCD_Aqua                = $C9EA13;  $FFC9EA13  "#13EAC9"  "rgb( 19,234,201)"  "rgba( 19,234,201,255)"  "Aqua"
#XKCD_Cyan                = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(  0,255,255)"  "rgba(  0,255,255,255)"  "Cyan"
#XKCD_Tan                 = $6FB2D1;  $FF6FB2D1  "#D1B26F"  "rgb(209,178,111)"  "rgba(209,178,111,255)"  "Tan"
#XKCD_DarkBlue_           = $5B0300;  $FF5B0300  "#00035B"  "rgb(  0,  3, 91)"  "rgba(  0,  3, 91,255)"  "DarkBlue_"
#XKCD_Lavender            = $EF9FC7;  $FFEF9FC7  "#C79FEF"  "rgb(199,159,239)"  "rgba(199,159,239,255)"  "Lavender"
#XKCD_Turquoise           = $ACC206;  $FFACC206  "#06C2AC"  "rgb(  6,194,172)"  "rgba(  6,194,172,255)"  "Turquoise"
#XKCD_DarkGreen_          = $003503;  $FF003503  "#033500"  "rgb(  3, 53,  0)"  "rgba(  3, 53,  0,255)"  "DarkGreen_"
#XKCD_Violet              = $EA0E9A;  $FFEA0E9A  "#9A0EEA"  "rgb(154, 14,234)"  "rgba(154, 14,234,255)"  "Violet"
#XKCD_LightPurple         = $F677BF;  $FFF677BF  "#BF77F6"  "rgb(191,119,246)"  "rgba(191,119,246,255)"  "LightPurple"
#XKCD_LimeGreen           = $05FE89;  $FF05FE89  "#89FE05"  "rgb(137,254,  5)"  "rgba(137,254,  5,255)"  "LimeGreen"
#XKCD_Grey                = $919592;  $FF919592  "#929591"  "rgb(146,149,145)"  "rgba(146,149,145,255)"  "Grey"
#XKCD_SkyBlue             = $FDBB75;  $FFFDBB75  "#75BBFD"  "rgb(117,187,253)"  "rgba(117,187,253,255)"  "SkyBlue"
#XKCD_Yellow              = $14FFFF;  $FF14FFFF  "#FFFF14"  "rgb(255,255, 20)"  "rgba(255,255, 20,255)"  "Yellow"
#XKCD_Magenta             = $7800C2;  $FF7800C2  "#C20078"  "rgb(194,  0,120)"  "rgba(194,  0,120,255)"  "Magenta"
#XKCD_LightGreen_         = $7BF996;  $FF7BF996  "#96F97B"  "rgb(150,249,123)"  "rgba(150,249,123,255)"  "LightGreen_"
#XKCD_Orange              = $0673F9;  $FF0673F9  "#F97306"  "rgb(249,115,  6)"  "rgba(249,115,  6,255)"  "Orange"
#XKCD_Teal                = $869302;  $FF869302  "#029386"  "rgb(  2,147,134)"  "rgba(  2,147,134,255)"  "Teal"
#XKCD_LightBlue_          = $FCD095;  $FFFCD095  "#95D0FC"  "rgb(149,208,252)"  "rgba(149,208,252,255)"  "LightBlue_"
#XKCD_Red                 = $0000E5;  $FF0000E5  "#E50000"  "rgb(229,  0,  0)"  "rgba(229,  0,  0,255)"  "Red"
#XKCD_Brown               = $003765;  $FF003765  "#653700"  "rgb(101, 55,  0)"  "rgba(101, 55,  0,255)"  "Brown"
#XKCD_Pink                = $C081FF;  $FFC081FF  "#FF81C0"  "rgb(255,129,192)"  "rgba(255,129,192,255)"  "Pink"
#XKCD_Blue                = $DF4303;  $FFDF4303  "#0343DF"  "rgb(  3, 67,223)"  "rgba(  3, 67,223,255)"  "Blue"
#XKCD_Green               = $1AB015;  $FF1AB015  "#15B01A"  "rgb( 21,176, 26)"  "rgba( 21,176, 26,255)"  "Green"
#XKCD_Purple              = $9C1E7E;  $FF9C1E7E  "#7E1E9C"  "rgb(126, 30,156)"  "rgba(126, 30,156,255)"  "Purple"

;-WIKI-Color, wild! collection (duplicates w. different names & seriousness?)
;  see https://en.wikipedia.org/wiki/List_of_colors:_A%E2%80%93F
;WIKI-color                                    PB-Color:   "+Alpha:   API-Color: RGB-Color:          RGBA-Color:              WIKI-Colorname:
#WIKI_AbsoluteZero                             = $BA4800;  $FFBA4800  "#0048BA"  "rgb(186, 72,186)"  "rgba(186, 72,186,255)"  "AbsoluteZero"
#WIKI_Acajou                                   = $272F4C;  $FF272F4C  "#4C2F27"  "rgb(499, 47, 39)"  "rgba(499, 47, 39,255)"  "Acajou"
#WIKI_AcidGreen                                = $1ABFB0;  $FF1ABFB0  "#B0BF1A"  "rgb(115,191, 26)"  "rgba(115,191, 26,255)"  "AcidGreen"
#WIKI_Aero                                     = $E8B97C;  $FFE8B97C  "#7CB9E8"  "rgb(817,185,232)"  "rgba(817,185,232,255)"  "Aero"
#WIKI_AeroBlue                                 = $E5FFC9;  $FFE5FFC9  "#C9FFE5"  "rgb(132,255,229)"  "rgba(132,255,229,255)"  "AeroBlue"
#WIKI_AfricanViolet                            = $BE84B2;  $FFBE84B2  "#B284BE"  "rgb(116,132,190)"  "rgba(116,132,190,255)"  "AfricanViolet"
#WIKI_AirForceBlue_Raf                         = $A88A5D;  $FFA88A5D  "#5D8AA8"  "rgb(613,138,168)"  "rgba(613,138,168,255)"  "AirForceBlue_Raf"
#WIKI_AirForceBlue_Usaf                        = $8F3000;  $FF8F3000  "#00308F"  "rgb(124, 48,143)"  "rgba(124, 48,143,255)"  "AirForceBlue_Usaf"
#WIKI_AirSuperiorityBlue                       = $C1A072;  $FFC1A072  "#72A0C1"  "rgb(751,160,193)"  "rgba(751,160,193,255)"  "AirSuperiorityBlue"
#WIKI_AlabamaCrimson                           = $2A00AF;  $FF2A00AF  "#AF002A"  "rgb(114,  0, 42)"  "rgba(114,  0, 42,255)"  "AlabamaCrimson"
#WIKI_Alabaster                                = $E6F0F2;  $FFE6F0F2  "#F2F0E6"  "rgb(159,240,230)"  "rgba(159,240,230,255)"  "Alabaster"
#WIKI_AliceBlue                                = $FFF8F0;  $FFFFF8F0  "#F0F8FF"  "rgb(157,248,255)"  "rgba(157,248,255,255)"  "AliceBlue"
#WIKI_AlienArmpit                              = $02DE84;  $FF02DE84  "#84DE02"  "rgb(870,222,  2)"  "rgba(870,222,  2,255)"  "AlienArmpit"
#WIKI_AlizarinCrimson                          = $3626E3;  $FF3626E3  "#E32636"  "rgb(148, 38, 54)"  "rgba(148, 38, 54,255)"  "AlizarinCrimson"
#WIKI_AlloyOrange                              = $1062C4;  $FF1062C4  "#C46210"  "rgb(128, 98, 16)"  "rgba(128, 98, 16,255)"  "AlloyOrange"
#WIKI_Almond                                   = $CDDEEF;  $FFCDDEEF  "#EFDECD"  "rgb(157,222,205)"  "rgba(157,222,205,255)"  "Almond"
#WIKI_Amaranth                                 = $502BE5;  $FF502BE5  "#E52B50"  "rgb(150, 43, 80)"  "rgba(150, 43, 80,255)"  "Amaranth"
#WIKI_AmaranthDeepPurple                       = $682B9F;  $FF682B9F  "#9F2B68"  "rgb(104, 43,104)"  "rgba(104, 43,104,255)"  "AmaranthDeepPurple"
#WIKI_AmaranthPink                             = $BB9CF1;  $FFBB9CF1  "#F19CBB"  "rgb(158,156,187)"  "rgba(158,156,187,255)"  "AmaranthPink"
#WIKI_AmaranthPurple                           = $4F27AB;  $FF4F27AB  "#AB274F"  "rgb(112, 39, 79)"  "rgba(112, 39, 79,255)"  "AmaranthPurple"
#WIKI_AmaranthRed                              = $2D21D3;  $FF2D21D3  "#D3212D"  "rgb(138, 33, 45)"  "rgba(138, 33, 45,255)"  "AmaranthRed"
#WIKI_Amazon                                   = $577A3B;  $FF577A3B  "#3B7A57"  "rgb(389,122, 87)"  "rgba(389,122, 87,255)"  "Amazon"
#WIKI_Amazonite                                = $B0C400;  $FFB0C400  "#00C4B0"  "rgb(503,196,176)"  "rgba(503,196,176,255)"  "Amazonite"
#WIKI_Amber                                    = $00BFFF;  $FF00BFFF  "#FFBF00"  "rgb(167,191,  0)"  "rgba(167,191,  0,255)"  "Amber"
#WIKI_Amber_Sae_Ece                            = $007EFF;  $FF007EFF  "#FF7E00"  "rgb(167,126,  0)"  "rgba(167,126,  0,255)"  "Amber_Sae_Ece"
#WIKI_AmericanRose                             = $3E03FF;  $FF3E03FF  "#FF033E"  "rgb(167,  3, 62)"  "rgba(167,  3, 62,255)"  "AmericanRose"
#WIKI_Amethyst                                 = $CC6699;  $FFCC6699  "#9966CC"  "rgb(100,102,204)"  "rgba(100,102,204,255)"  "Amethyst"
#WIKI_AndroidGreen                             = $39C6A4;  $FF39C6A4  "#A4C639"  "rgb(107,198, 57)"  "rgba(107,198, 57,255)"  "AndroidGreen"
#WIKI_AntiFlashWhite                           = $F4F3F2;  $FFF4F3F2  "#F2F3F4"  "rgb(159,243,244)"  "rgba(159,243,244,255)"  "AntiFlashWhite"
#WIKI_AntiqueBrass                             = $7595CD;  $FF7595CD  "#CD9575"  "rgb(134,149,117)"  "rgba(134,149,117,255)"  "AntiqueBrass"
#WIKI_AntiqueBronze                            = $1E5D66;  $FF1E5D66  "#665D1E"  "rgb(670, 93, 30)"  "rgba(670, 93, 30,255)"  "AntiqueBronze"
#WIKI_AntiqueFuchsia                           = $835C91;  $FF835C91  "#915C83"  "rgb(952, 92,131)"  "rgba(952, 92,131,255)"  "AntiqueFuchsia"
#WIKI_AntiqueRuby                              = $2D1B84;  $FF2D1B84  "#841B2D"  "rgb(865, 27, 45)"  "rgba(865, 27, 45,255)"  "AntiqueRuby"
#WIKI_AntiqueWhite                             = $D7EBFA;  $FFD7EBFA  "#FAEBD7"  "rgb(164,235,215)"  "rgba(164,235,215,255)"  "AntiqueWhite"
#WIKI_Ao_English                               = $008000;  $FF008000  "#008000"  "rgb(327,128,  0)"  "rgba(327,128,  0,255)"  "Ao_English"
#WIKI_AppleGreen                               = $00B68D;  $FF00B68D  "#8DB600"  "rgb(928,182,  0)"  "rgba(928,182,  0,255)"  "AppleGreen"
#WIKI_Apricot                                  = $B1CEFB;  $FFB1CEFB  "#FBCEB1"  "rgb(165,206,177)"  "rgba(165,206,177,255)"  "Apricot"
#WIKI_Aqua                                     = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(655,255,255)"  "rgba(655,255,255,255)"  "Aqua"
#WIKI_Aquamarine                               = $D4FF7F;  $FFD4FF7F  "#7FFFD4"  "rgb(838,255,212)"  "rgba(838,255,212,255)"  "Aquamarine"
#WIKI_ArcticLime                               = $14FFD0;  $FF14FFD0  "#D0FF14"  "rgb(136,255, 20)"  "rgba(136,255, 20,255)"  "ArcticLime"
#WIKI_ArmyGreen                                = $20534B;  $FF20534B  "#4B5320"  "rgb(493, 83, 32)"  "rgba(493, 83, 32,255)"  "ArmyGreen"
#WIKI_Arsenic                                  = $4B443B;  $FF4B443B  "#3B444B"  "rgb(388, 68, 75)"  "rgba(388, 68, 75,255)"  "Arsenic"
#WIKI_Artichoke                                = $79978F;  $FF79978F  "#8F9779"  "rgb(941,151,121)"  "rgba(941,151,121,255)"  "Artichoke"
#WIKI_ArylideYellow                            = $6BD6E9;  $FF6BD6E9  "#E9D66B"  "rgb(153,214,107)"  "rgba(153,214,107,255)"  "ArylideYellow"
#WIKI_AshGrey                                  = $B5BEB2;  $FFB5BEB2  "#B2BEB5"  "rgb(117,190,181)"  "rgba(117,190,181,255)"  "AshGrey"
#WIKI_Asparagus                                = $6BA987;  $FF6BA987  "#87A96B"  "rgb(889,169,107)"  "rgba(889,169,107,255)"  "Asparagus"
#WIKI_AtomicTangerine                          = $6699FF;  $FF6699FF  "#FF9966"  "rgb(167,153,102)"  "rgba(167,153,102,255)"  "AtomicTangerine"
#WIKI_Auburn                                   = $2A2AA5;  $FF2A2AA5  "#A52A2A"  "rgb(108, 42, 42)"  "rgba(108, 42, 42,255)"  "Auburn"
#WIKI_Aureolin                                 = $00EEFD;  $FF00EEFD  "#FDEE00"  "rgb(166,238,  0)"  "rgba(166,238,  0,255)"  "Aureolin"
#WIKI_Aurometalsaurus                          = $807F6E;  $FF807F6E  "#6E7F80"  "rgb(724,127,128)"  "rgba(724,127,128,255)"  "Aurometalsaurus"
#WIKI_Avocado                                  = $038256;  $FF038256  "#568203"  "rgb(566,130,  3)"  "rgba(566,130,  3,255)"  "Avocado"
#WIKI_AztecGold                                = $5399C3;  $FF5399C3  "#C39953"  "rgb(128,153, 83)"  "rgba(128,153, 83,255)"  "AztecGold"
#WIKI_Azure                                    = $FF7F00;  $FFFF7F00  "#007FFF"  "rgb(327,127,255)"  "rgba(327,127,255,255)"  "Azure"
#WIKI_Azure_WebColor                           = $FFFFF0;  $FFFFFFF0  "#F0FFFF"  "rgb(157,255,255)"  "rgba(157,255,255,255)"  "Azure_WebColor"
#WIKI_AzureMist                                = $FFFFF0;  $FFFFFFF0  "#F0FFFF"  "rgb(157,255,255)"  "rgba(157,255,255,255)"  "AzureMist"
#WIKI_AzureishWhite                            = $F4E9DB;  $FFF4E9DB  "#DBE9F4"  "rgb(144,233,244)"  "rgba(144,233,244,255)"  "AzureishWhite"
#WIKI_BabyBlue                                 = $F0CF89;  $FFF0CF89  "#89CFF0"  "rgb(903,207,240)"  "rgba(903,207,240,255)"  "BabyBlue"
#WIKI_BabyBlueEyes                             = $F1CAA1;  $FFF1CAA1  "#A1CAF1"  "rgb(106,202,241)"  "rgba(106,202,241,255)"  "BabyBlueEyes"
#WIKI_BabyPink                                 = $C2C2F4;  $FFC2C2F4  "#F4C2C2"  "rgb(160,194,194)"  "rgba(160,194,194,255)"  "BabyPink"
#WIKI_BabyPowder                               = $FAFEFE;  $FFFAFEFE  "#FEFEFA"  "rgb(167,254,250)"  "rgba(167,254,250,255)"  "BabyPowder"
#WIKI_BakerMillerPink                          = $AF91FF;  $FFAF91FF  "#FF91AF"  "rgb(167,145,175)"  "rgba(167,145,175,255)"  "BakerMillerPink"
#WIKI_BallBlue                                 = $CDAB21;  $FFCDAB21  "#21ABCD"  "rgb(220,171,205)"  "rgba(220,171,205,255)"  "BallBlue"
#WIKI_BananaMania                              = $B5E7FA;  $FFB5E7FA  "#FAE7B5"  "rgb(164,231,181)"  "rgba(164,231,181,255)"  "BananaMania"
#WIKI_BananaYellow                             = $35E1FF;  $FF35E1FF  "#FFE135"  "rgb(167,225, 53)"  "rgba(167,225, 53,255)"  "BananaYellow"
#WIKI_BangladeshGreen                          = $4E6A00;  $FF4E6A00  "#006A4E"  "rgb(272,106, 78)"  "rgba(272,106, 78,255)"  "BangladeshGreen"
#WIKI_BarbiePink                               = $8A21E0;  $FF8A21E0  "#E0218A"  "rgb(146, 33,138)"  "rgba(146, 33,138,255)"  "BarbiePink"
#WIKI_BarnRed                                  = $020A7C;  $FF020A7C  "#7C0A02"  "rgb(812, 10,  2)"  "rgba(812, 10,  2,255)"  "BarnRed"
#WIKI_BatteryChargedBlue                       = $D6AC1D;  $FFD6AC1D  "#1DACD6"  "rgb(194,172,214)"  "rgba(194,172,214,255)"  "BatteryChargedBlue"
#WIKI_BattleshipGrey                           = $828484;  $FF828484  "#848482"  "rgb(868,132,130)"  "rgba(868,132,130,255)"  "BattleshipGrey"
#WIKI_Bazaar                                   = $7B7798;  $FF7B7798  "#98777B"  "rgb(999,119,123)"  "rgba(999,119,123,255)"  "Bazaar"
#WIKI_BeauBlue                                 = $E6D4BC;  $FFE6D4BC  "#BCD4E6"  "rgb(123,212,230)"  "rgba(123,212,230,255)"  "BeauBlue"
#WIKI_Beaver                                   = $70819F;  $FF70819F  "#9F8170"  "rgb(104,129,112)"  "rgba(104,129,112,255)"  "Beaver"
#WIKI_Begonia                                  = $796EFA;  $FF796EFA  "#FA6E79"  "rgb(164,110,121)"  "rgba(164,110,121,255)"  "Begonia"
#WIKI_Beige                                    = $DCF5F5;  $FFDCF5F5  "#F5F5DC"  "rgb(161,245,220)"  "rgba(161,245,220,255)"  "Beige"
#WIKI_BdazzledBlue                             = $94582E;  $FF94582E  "#2E5894"  "rgb(303, 88,148)"  "rgba(303, 88,148,255)"  "BdazzledBlue"
#WIKI_BigDipOruby                              = $42259C;  $FF42259C  "#9C2542"  "rgb(102, 37, 66)"  "rgba(102, 37, 66,255)"  "BigDipOruby"
#WIKI_BigFootFeet                              = $5A8EE8;  $FF5A8EE8  "#E88E5A"  "rgb(152,142, 90)"  "rgba(152,142, 90,255)"  "BigFootFeet"
#WIKI_Bisque                                   = $C4E4FF;  $FFC4E4FF  "#FFE4C4"  "rgb(167,228,196)"  "rgba(167,228,196,255)"  "Bisque"
#WIKI_Bistre                                   = $1F2B3D;  $FF1F2B3D  "#3D2B1F"  "rgb(400, 43, 31)"  "rgba(400, 43, 31,255)"  "Bistre"
#WIKI_BistreBrown                              = $177196;  $FF177196  "#967117"  "rgb(985,113, 23)"  "rgba(985,113, 23,255)"  "BistreBrown"
#WIKI_BitterLemon                              = $0DE0CA;  $FF0DE0CA  "#CAE00D"  "rgb(132,224, 13)"  "rgba(132,224, 13,255)"  "BitterLemon"
#WIKI_BitterLime                               = $00FFBF;  $FF00FFBF  "#BFFF00"  "rgb(125,255,  0)"  "rgba(125,255,  0,255)"  "BitterLime"
#WIKI_Bittersweet                              = $5E6FFE;  $FF5E6FFE  "#FE6F5E"  "rgb(166,111, 94)"  "rgba(166,111, 94,255)"  "Bittersweet"
#WIKI_BittersweetShimmer                       = $514FBF;  $FF514FBF  "#BF4F51"  "rgb(125, 79, 81)"  "rgba(125, 79, 81,255)"  "BittersweetShimmer"
#WIKI_Black                                    = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "Black"
#WIKI_BlackBean                                = $020C3D;  $FF020C3D  "#3D0C02"  "rgb(400, 12,  2)"  "rgba(400, 12,  2,255)"  "BlackBean"
#WIKI_BlackCoral                               = $6F6254;  $FF6F6254  "#54626F"  "rgb(553, 98,111)"  "rgba(553, 98,111,255)"  "BlackCoral"
#WIKI_BlackLeatherJacket                       = $293525;  $FF293525  "#253529"  "rgb(243, 53, 41)"  "rgba(243, 53, 41,255)"  "BlackLeatherJacket"
#WIKI_BlackOlive                               = $363C3B;  $FF363C3B  "#3B3C36"  "rgb(388, 60, 54)"  "rgba(388, 60, 54,255)"  "BlackOlive"
#WIKI_BlackShadows                             = $B2AFBF;  $FFB2AFBF  "#BFAFB2"  "rgb(125,175,178)"  "rgba(125,175,178,255)"  "BlackShadows"
#WIKI_BlanchedAlmond                           = $CDEBFF;  $FFCDEBFF  "#FFEBCD"  "rgb(167,235,205)"  "rgba(167,235,205,255)"  "BlanchedAlmond"
#WIKI_BlastOffBronze                           = $6471A5;  $FF6471A5  "#A57164"  "rgb(108,113,100)"  "rgba(108,113,100,255)"  "BlastOffBronze"
#WIKI_BleuDeFrance                             = $E78C31;  $FFE78C31  "#318CE7"  "rgb(324,140,231)"  "rgba(324,140,231,255)"  "BleuDeFrance"
#WIKI_BlizzardBlue                             = $EEE5AC;  $FFEEE5AC  "#ACE5EE"  "rgb(113,229,238)"  "rgba(113,229,238,255)"  "BlizzardBlue"
#WIKI_Blond                                    = $BEF0FA;  $FFBEF0FA  "#FAF0BE"  "rgb(164,240,190)"  "rgba(164,240,190,255)"  "Blond"
#WIKI_Blue                                     = $FF0000;  $FFFF0000  "#0000FF"  "rgb(255,  0,255)"  "rgba(255,  0,255,255)"  "Blue"
#WIKI_Blue_Crayola                             = $FE751F;  $FFFE751F  "#1F75FE"  "rgb(206,117,254)"  "rgba(206,117,254,255)"  "Blue_Crayola"
#WIKI_Blue_Munsell                             = $AF9300;  $FFAF9300  "#0093AF"  "rgb(378,147,175)"  "rgba(378,147,175,255)"  "Blue_Munsell"
#WIKI_Blue_Ncs                                 = $BD8700;  $FFBD8700  "#0087BD"  "rgb(347,135,189)"  "rgba(347,135,189,255)"  "Blue_Ncs"
#WIKI_Blue_Pantone                             = $A81800;  $FFA81800  "#0018A8"  "rgb(631, 24,168)"  "rgba(631, 24,168,255)"  "Blue_Pantone"
#WIKI_Blue_Pigment                             = $993333;  $FF993333  "#333399"  "rgb(335, 51,153)"  "rgba(335, 51,153,255)"  "Blue_Pigment"
#WIKI_Blue_Ryb                                 = $FE4702;  $FFFE4702  "#0247FE"  "rgb(149, 71,254)"  "rgba(149, 71,254,255)"  "Blue_Ryb"
#WIKI_BlueBell                                 = $D0A2A2;  $FFD0A2A2  "#A2A2D0"  "rgb(106,162,208)"  "rgba(106,162,208,255)"  "BlueBell"
#WIKI_BlueBolt                                 = $FBB900;  $FFFBB900  "#00B9FB"  "rgb(476,185,251)"  "rgba(476,185,251,255)"  "BlueBolt"
#WIKI_BlueGray                                 = $CC9966;  $FFCC9966  "#6699CC"  "rgb(672,153,204)"  "rgba(672,153,204,255)"  "BlueGray"
#WIKI_BlueGreen                                = $BA980D;  $FFBA980D  "#0D98BA"  "rgb(891,152,186)"  "rgba(891,152,186,255)"  "BlueGreen"
#WIKI_BlueJeans                                = $ECAD5D;  $FFECAD5D  "#5DADEC"  "rgb(613,173,236)"  "rgba(613,173,236,255)"  "BlueJeans"
#WIKI_BlueLagoon                               = $EEE5AC;  $FFEEE5AC  "#ACE5EE"  "rgb(113,229,238)"  "rgba(113,229,238,255)"  "BlueLagoon"
#WIKI_BlueVioletViolet                         = $923555;  $FF923555  "#553592"  "rgb(558, 53,146)"  "rgba(558, 53,146,255)"  "BlueVioletViolet"
#WIKI_BlueSapphire                             = $806112;  $FF806112  "#126180"  "rgb(120, 97,128)"  "rgba(120, 97,128,255)"  "BlueSapphire"
#WIKI_BlueViolet                               = $E22B8A;  $FFE22B8A  "#8A2BE2"  "rgb(905, 43,226)"  "rgba(905, 43,226,255)"  "BlueViolet"
#WIKI_BlueYonder                               = $A77250;  $FFA77250  "#5072A7"  "rgb(527,114,167)"  "rgba(527,114,167,255)"  "BlueYonder"
#WIKI_Blueberry                                = $F7864F;  $FFF7864F  "#4F86F7"  "rgb(521,134,247)"  "rgba(521,134,247,255)"  "Blueberry"
#WIKI_Bluebonnet                               = $F01C1C;  $FFF01C1C  "#1C1CF0"  "rgb(184, 28,240)"  "rgba(184, 28,240,255)"  "Bluebonnet"
#WIKI_Blush                                    = $835DDE;  $FF835DDE  "#DE5D83"  "rgb(145, 93,131)"  "rgba(145, 93,131,255)"  "Blush"
#WIKI_Bole                                     = $3B4479;  $FF3B4479  "#79443B"  "rgb(794, 68, 59)"  "rgba(794, 68, 59,255)"  "Bole"
#WIKI_BondiBlue                                = $B69500;  $FFB69500  "#0095B6"  "rgb(383,149,182)"  "rgba(383,149,182,255)"  "BondiBlue"
#WIKI_Bone                                     = $C9DAE3;  $FFC9DAE3  "#E3DAC9"  "rgb(149,218,201)"  "rgba(149,218,201,255)"  "Bone"
#WIKI_BoogerBuster                             = $6AE2DD;  $FF6AE2DD  "#DDE26A"  "rgb(145,226,106)"  "rgba(145,226,106,255)"  "BoogerBuster"
#WIKI_BostonUniversityRed                      = $0000CC;  $FF0000CC  "#CC0000"  "rgb(133,  0,  0)"  "rgba(133,  0,  0,255)"  "BostonUniversityRed"
#WIKI_BottleGreen                              = $4E6A00;  $FF4E6A00  "#006A4E"  "rgb(272,106, 78)"  "rgba(272,106, 78,255)"  "BottleGreen"
#WIKI_Boysenberry                              = $603287;  $FF603287  "#873260"  "rgb(886, 50, 96)"  "rgba(886, 50, 96,255)"  "Boysenberry"
#WIKI_BrandeisBlue                             = $FF7000;  $FFFF7000  "#0070FF"  "rgb(289,112,255)"  "rgba(289,112,255,255)"  "BrandeisBlue"
#WIKI_Brass                                    = $42A6B5;  $FF42A6B5  "#B5A642"  "rgb(119,166, 66)"  "rgba(119,166, 66,255)"  "Brass"
#WIKI_BrickRed                                 = $5441CB;  $FF5441CB  "#CB4154"  "rgb(133, 65, 84)"  "rgba(133, 65, 84,255)"  "BrickRed"
#WIKI_BrightCerulean                           = $D6AC1D;  $FFD6AC1D  "#1DACD6"  "rgb(194,172,214)"  "rgba(194,172,214,255)"  "BrightCerulean"
#WIKI_BrightGreen                              = $00FF66;  $FF00FF66  "#66FF00"  "rgb(674,255,  0)"  "rgba(674,255,  0,255)"  "BrightGreen"
#WIKI_BrightLavender                           = $E494BF;  $FFE494BF  "#BF94E4"  "rgb(125,148,228)"  "rgba(125,148,228,255)"  "BrightLavender"
#WIKI_BrightLilac                              = $EF91D8;  $FFEF91D8  "#D891EF"  "rgb(141,145,239)"  "rgba(141,145,239,255)"  "BrightLilac"
#WIKI_BrightMaroon                             = $4821C3;  $FF4821C3  "#C32148"  "rgb(127, 33, 72)"  "rgba(127, 33, 72,255)"  "BrightMaroon"
#WIKI_BrightNavyBlue                           = $D27419;  $FFD27419  "#1974D2"  "rgb(166,116,210)"  "rgba(166,116,210,255)"  "BrightNavyBlue"
#WIKI_BrightPink                               = $7F00FF;  $FF7F00FF  "#FF007F"  "rgb(167,  0,127)"  "rgba(167,  0,127,255)"  "BrightPink"
#WIKI_BrightTurquoise                          = $DEE808;  $FFDEE808  "#08E8DE"  "rgb(583,232,222)"  "rgba(583,232,222,255)"  "BrightTurquoise"
#WIKI_BrightUbe                                = $E89FD1;  $FFE89FD1  "#D19FE8"  "rgb(137,159,232)"  "rgba(137,159,232,255)"  "BrightUbe"
#WIKI_BrightYellow_Crayola                     = $1DAAFF;  $FF1DAAFF  "#FFAA1D"  "rgb(167,170, 29)"  "rgba(167,170, 29,255)"  "BrightYellow_Crayola"
#WIKI_BrilliantAzure                           = $FF9933;  $FFFF9933  "#3399FF"  "rgb(338,153,255)"  "rgba(338,153,255,255)"  "BrilliantAzure"
#WIKI_BrilliantLavender                        = $FFBBF4;  $FFFFBBF4  "#F4BBFF"  "rgb(160,187,255)"  "rgba(160,187,255,255)"  "BrilliantLavender"
#WIKI_BrilliantRose                            = $A355FF;  $FFA355FF  "#FF55A3"  "rgb(167, 85,163)"  "rgba(167, 85,163,255)"  "BrilliantRose"
#WIKI_BrinkPink                                = $7F60FB;  $FF7F60FB  "#FB607F"  "rgb(164, 96,127)"  "rgba(164, 96,127,255)"  "BrinkPink"
#WIKI_BritishRacingGreen                       = $254200;  $FF254200  "#004225"  "rgb(169, 66, 37)"  "rgba(169, 66, 37,255)"  "BritishRacingGreen"
#WIKI_Bronze                                   = $327FCD;  $FF327FCD  "#CD7F32"  "rgb(134,127, 50)"  "rgba(134,127, 50,255)"  "Bronze"
#WIKI_BronzeYellow                             = $007073;  $FF007073  "#737000"  "rgb(756,112,  0)"  "rgba(756,112,  0,255)"  "BronzeYellow"
#WIKI_Brown_Traditional                        = $004B96;  $FF004B96  "#964B00"  "rgb(984, 75,  0)"  "rgba(984, 75,  0,255)"  "Brown_Traditional"
#WIKI_Brown_Web                                = $2A2AA5;  $FF2A2AA5  "#A52A2A"  "rgb(108, 42, 42)"  "rgba(108, 42, 42,255)"  "Brown_Web"
#WIKI_BrownNose                                = $23446B;  $FF23446B  "#6B4423"  "rgb(702, 68, 35)"  "rgba(702, 68, 35,255)"  "BrownNose"
#WIKI_BrownSugar                               = $4D6EAF;  $FF4D6EAF  "#AF6E4D"  "rgb(114,110, 77)"  "rgba(114,110, 77,255)"  "BrownSugar"
#WIKI_BrownYellow                              = $6699cc;  $FF6699cc  "#cc9966"  "rgb(134,153,102)"  "rgba(134,153,102,255)"  "BrownYellow"
#WIKI_BrunswickGreen                           = $3E4D1B;  $FF3E4D1B  "#1B4D3E"  "rgb(178, 77, 62)"  "rgba(178, 77, 62,255)"  "BrunswickGreen"
#WIKI_BubbleGum                                = $CCC1FF;  $FFCCC1FF  "#FFC1CC"  "rgb(167,193,204)"  "rgba(167,193,204,255)"  "BubbleGum"
#WIKI_Bubbles                                  = $FFFEE7;  $FFFFFEE7  "#E7FEFF"  "rgb(152,254,255)"  "rgba(152,254,255,255)"  "Bubbles"
#WIKI_BudGreen                                 = $61B67B;  $FF61B67B  "#7BB661"  "rgb(810,182, 97)"  "rgba(810,182, 97,255)"  "BudGreen"
#WIKI_Buff                                     = $82DCF0;  $FF82DCF0  "#F0DC82"  "rgb(157,220,130)"  "rgba(157,220,130,255)"  "Buff"
#WIKI_BulgarianRose                            = $070648;  $FF070648  "#480607"  "rgb(472,  6,  7)"  "rgba(472,  6,  7,255)"  "BulgarianRose"
#WIKI_Burgundy                                 = $200080;  $FF200080  "#800020"  "rgb(838,  0, 32)"  "rgba(838,  0, 32,255)"  "Burgundy"
#WIKI_Burlywood                                = $87B8DE;  $FF87B8DE  "#DEB887"  "rgb(145,184,135)"  "rgba(145,184,135,255)"  "Burlywood"
#WIKI_BurnishedBrown                           = $747AA1;  $FF747AA1  "#A17A74"  "rgb(105,122,116)"  "rgba(105,122,116,255)"  "BurnishedBrown"
#WIKI_BurntOrange                              = $0055CC;  $FF0055CC  "#CC5500"  "rgb(133, 85,  0)"  "rgba(133, 85,  0,255)"  "BurntOrange"
#WIKI_BurntSienna                              = $5174E9;  $FF5174E9  "#E97451"  "rgb(152,116, 81)"  "rgba(152,116, 81,255)"  "BurntSienna"
#WIKI_BurntUmber                               = $24338A;  $FF24338A  "#8A3324"  "rgb(905, 51, 36)"  "rgba(905, 51, 36,255)"  "BurntUmber"
#WIKI_Byzantine                                = $A433BD;  $FFA433BD  "#BD33A4"  "rgb(123, 51,164)"  "rgba(123, 51,164,255)"  "Byzantine"
#WIKI_Byzantium                                = $632970;  $FF632970  "#702963"  "rgb(735, 41, 99)"  "rgba(735, 41, 99,255)"  "Byzantium"
#WIKI_Cadet                                    = $726853;  $FF726853  "#536872"  "rgb(546,104,114)"  "rgba(546,104,114,255)"  "Cadet"
#WIKI_CadetBlue                                = $A09E5F;  $FFA09E5F  "#5F9EA0"  "rgb(626,158,160)"  "rgba(626,158,160,255)"  "CadetBlue"
#WIKI_CadetGrey                                = $B0A391;  $FFB0A391  "#91A3B0"  "rgb(954,163,176)"  "rgba(954,163,176,255)"  "CadetGrey"
#WIKI_CadmiumGreen                             = $3C6B00;  $FF3C6B00  "#006B3C"  "rgb(274,107, 60)"  "rgba(274,107, 60,255)"  "CadmiumGreen"
#WIKI_CadmiumOrange                            = $2D87ED;  $FF2D87ED  "#ED872D"  "rgb(155,135, 45)"  "rgba(155,135, 45,255)"  "CadmiumOrange"
#WIKI_CadmiumRed                               = $2200E3;  $FF2200E3  "#E30022"  "rgb(148,  0, 34)"  "rgba(148,  0, 34,255)"  "CadmiumRed"
#WIKI_CadmiumYellow                            = $00F6FF;  $FF00F6FF  "#FFF600"  "rgb(167,246,  0)"  "rgba(167,246,  0,255)"  "CadmiumYellow"
#WIKI_CafeAuLait                               = $5B7BA6;  $FF5B7BA6  "#A67B5B"  "rgb(109,123, 91)"  "rgba(109,123, 91,255)"  "CafeAuLait"
#WIKI_CafeNoir                                 = $21364B;  $FF21364B  "#4B3621"  "rgb(492, 54, 33)"  "rgba(492, 54, 33,255)"  "CafeNoir"
#WIKI_CalPolyPomonaGreen                       = $2B4D1E;  $FF2B4D1E  "#1E4D2B"  "rgb(198, 77, 43)"  "rgba(198, 77, 43,255)"  "CalPolyPomonaGreen"
#WIKI_CambridgeBlue                            = $ADC1A3;  $FFADC1A3  "#A3C1AD"  "rgb(107,193,173)"  "rgba(107,193,173,255)"  "CambridgeBlue"
#WIKI_Camel                                    = $6B9AC1;  $FF6B9AC1  "#C19A6B"  "rgb(126,154,107)"  "rgba(126,154,107,255)"  "Camel"
#WIKI_CameoPink                                = $CCBBEF;  $FFCCBBEF  "#EFBBCC"  "rgb(157,187,204)"  "rgba(157,187,204,255)"  "CameoPink"
#WIKI_CamouflageGreen                          = $6B8678;  $FF6B8678  "#78866B"  "rgb(789,134,107)"  "rgba(789,134,107,255)"  "CamouflageGreen"
#WIKI_Canary                                   = $99FFFF;  $FF99FFFF  "#FFFF99"  "rgb(167,255,153)"  "rgba(167,255,153,255)"  "Canary"
#WIKI_CanaryYellow                             = $00EFFF;  $FF00EFFF  "#FFEF00"  "rgb(167,239,  0)"  "rgba(167,239,  0,255)"  "CanaryYellow"
#WIKI_CandyAppleRed                            = $0008FF;  $FF0008FF  "#FF0800"  "rgb(167,  8,  0)"  "rgba(167,  8,  0,255)"  "CandyAppleRed"
#WIKI_CandyPink                                = $7A71E4;  $FF7A71E4  "#E4717A"  "rgb(149,113,122)"  "rgba(149,113,122,255)"  "CandyPink"
#WIKI_Capri                                    = $FFBF00;  $FFFFBF00  "#00BFFF"  "rgb(491,191,255)"  "rgba(491,191,255,255)"  "Capri"
#WIKI_CaputMortuum                             = $202759;  $FF202759  "#592720"  "rgb(584, 39, 32)"  "rgba(584, 39, 32,255)"  "CaputMortuum"
#WIKI_Cardinal                                 = $3A1EC4;  $FF3A1EC4  "#C41E3A"  "rgb(128, 30, 58)"  "rgba(128, 30, 58,255)"  "Cardinal"
#WIKI_CaribbeanGreen                           = $99CC00;  $FF99CC00  "#00CC99"  "rgb(523,204,153)"  "rgba(523,204,153,255)"  "CaribbeanGreen"
#WIKI_Carmine                                  = $180096;  $FF180096  "#960018"  "rgb(983,  0, 24)"  "rgba(983,  0, 24,255)"  "Carmine"
#WIKI_Carmine_Mp                               = $4000D7;  $FF4000D7  "#D70040"  "rgb(140,  0, 64)"  "rgba(140,  0, 64,255)"  "Carmine_Mp"
#WIKI_CarminePink                              = $424CEB;  $FF424CEB  "#EB4C42"  "rgb(154, 76, 66)"  "rgba(154, 76, 66,255)"  "CarminePink"
#WIKI_CarmineRed                               = $3800FF;  $FF3800FF  "#FF0038"  "rgb(167,  0, 56)"  "rgba(167,  0, 56,255)"  "CarmineRed"
#WIKI_CarnationPink                            = $C9A6FF;  $FFC9A6FF  "#FFA6C9"  "rgb(167,166,201)"  "rgba(167,166,201,255)"  "CarnationPink"
#WIKI_Carnelian                                = $1B1BB3;  $FF1B1BB3  "#B31B1B"  "rgb(117, 27, 27)"  "rgba(117, 27, 27,255)"  "Carnelian"
#WIKI_CarolinaBlue                             = $D3A056;  $FFD3A056  "#56A0D3"  "rgb(567,160,211)"  "rgba(567,160,211,255)"  "CarolinaBlue"
#WIKI_CarrotOrange                             = $2191ED;  $FF2191ED  "#ED9121"  "rgb(155,145, 33)"  "rgba(155,145, 33,255)"  "CarrotOrange"
#WIKI_CastletonGreen                           = $3F5600;  $FF3F5600  "#00563F"  "rgb(220, 86, 63)"  "rgba(220, 86, 63,255)"  "CastletonGreen"
#WIKI_CatalinaBlue                             = $782A06;  $FF782A06  "#062A78"  "rgb(404, 42,120)"  "rgba(404, 42,120,255)"  "CatalinaBlue"
#WIKI_Catawba                                  = $423670;  $FF423670  "#703642"  "rgb(735, 54, 66)"  "rgba(735, 54, 66,255)"  "Catawba"
#WIKI_CedarChest                               = $495AC9;  $FF495AC9  "#C95A49"  "rgb(131, 90, 73)"  "rgba(131, 90, 73,255)"  "CedarChest"
#WIKI_Ceil                                     = $CFA192;  $FFCFA192  "#92A1CF"  "rgb(960,161,207)"  "rgba(960,161,207,255)"  "Ceil"
#WIKI_Celadon                                  = $AFE1AC;  $FFAFE1AC  "#ACE1AF"  "rgb(113,225,175)"  "rgba(113,225,175,255)"  "Celadon"
#WIKI_CeladonBlue                              = $A77B00;  $FFA77B00  "#007BA7"  "rgb(316,123,167)"  "rgba(316,123,167,255)"  "CeladonBlue"
#WIKI_CeladonGreen                             = $7C842F;  $FF7C842F  "#2F847C"  "rgb(311,132,124)"  "rgba(311,132,124,255)"  "CeladonGreen"
#WIKI_Celeste                                  = $FFFFB2;  $FFFFFFB2  "#B2FFFF"  "rgb(117,255,255)"  "rgba(117,255,255,255)"  "Celeste"
#WIKI_CelestialBlue                            = $D09749;  $FFD09749  "#4997D0"  "rgb(482,151,208)"  "rgba(482,151,208,255)"  "CelestialBlue"
#WIKI_Cerise                                   = $6331DE;  $FF6331DE  "#DE3163"  "rgb(145, 49, 99)"  "rgba(145, 49, 99,255)"  "Cerise"
#WIKI_CerisePink                               = $833BEC;  $FF833BEC  "#EC3B83"  "rgb(154, 59,131)"  "rgba(154, 59,131,255)"  "CerisePink"
#WIKI_Cerulean                                 = $A77B00;  $FFA77B00  "#007BA7"  "rgb(316,123,167)"  "rgba(316,123,167,255)"  "Cerulean"
#WIKI_CeruleanBlue                             = $BE522A;  $FFBE522A  "#2A52BE"  "rgb(277, 82,190)"  "rgba(277, 82,190,255)"  "CeruleanBlue"
#WIKI_CeruleanFrost                            = $C39B6D;  $FFC39B6D  "#6D9BC3"  "rgb(718,155,195)"  "rgba(718,155,195,255)"  "CeruleanFrost"
#WIKI_CgBlue                                   = $A57A00;  $FFA57A00  "#007AA5"  "rgb(313,122,165)"  "rgba(313,122,165,255)"  "CgBlue"
#WIKI_CgRed                                    = $313CE0;  $FF313CE0  "#E03C31"  "rgb(146, 60, 49)"  "rgba(146, 60, 49,255)"  "CgRed"
#WIKI_Chamoisee                                = $5A78A0;  $FF5A78A0  "#A0785A"  "rgb(105,120, 90)"  "rgba(105,120, 90,255)"  "Chamoisee"
#WIKI_Champagne                                = $CEE7F7;  $FFCEE7F7  "#F7E7CE"  "rgb(162,231,206)"  "rgba(162,231,206,255)"  "Champagne"
#WIKI_ChampagnePink                            = $CFDDF1;  $FFCFDDF1  "#F1DDCF"  "rgb(158,221,207)"  "rgba(158,221,207,255)"  "ChampagnePink"
#WIKI_Charcoal                                 = $4F4536;  $FF4F4536  "#36454F"  "rgb(355, 69, 79)"  "rgba(355, 69, 79,255)"  "Charcoal"
#WIKI_CharlestonGreen                          = $2B2B23;  $FF2B2B23  "#232B2B"  "rgb(230, 43, 43)"  "rgba(230, 43, 43,255)"  "CharlestonGreen"
#WIKI_CharmPink                                = $AC8FE6;  $FFAC8FE6  "#E68FAC"  "rgb(151,143,172)"  "rgba(151,143,172,255)"  "CharmPink"
#WIKI_Chartreuse_Traditional                   = $00FFDF;  $FF00FFDF  "#DFFF00"  "rgb(146,255,  0)"  "rgba(146,255,  0,255)"  "Chartreuse_Traditional"
#WIKI_Chartreuse_Web                           = $00FF7F;  $FF00FF7F  "#7FFF00"  "rgb(838,255,  0)"  "rgba(838,255,  0,255)"  "Chartreuse_Web"
#WIKI_Cherry                                   = $6331DE;  $FF6331DE  "#DE3163"  "rgb(145, 49, 99)"  "rgba(145, 49, 99,255)"  "Cherry"
#WIKI_CherryBlossomPink                        = $C5B7FF;  $FFC5B7FF  "#FFB7C5"  "rgb(167,183,197)"  "rgba(167,183,197,255)"  "CherryBlossomPink"
#WIKI_Chestnut                                 = $354595;  $FF354595  "#954535"  "rgb(978, 69, 53)"  "rgba(978, 69, 53,255)"  "Chestnut"
#WIKI_ChinaPink                                = $A16FDE;  $FFA16FDE  "#DE6FA1"  "rgb(145,111,161)"  "rgba(145,111,161,255)"  "ChinaPink"
#WIKI_ChinaRose                                = $6E51A8;  $FF6E51A8  "#A8516E"  "rgb(110, 81,110)"  "rgba(110, 81,110,255)"  "ChinaRose"
#WIKI_ChineseRed                               = $1E38AA;  $FF1E38AA  "#AA381E"  "rgb(111, 56, 30)"  "rgba(111, 56, 30,255)"  "ChineseRed"
#WIKI_ChineseViolet                            = $886085;  $FF886085  "#856088"  "rgb(874, 96,136)"  "rgba(874, 96,136,255)"  "ChineseViolet"
#WIKI_ChlorophyllGreen                         = $00FF4A;  $FF00FF4A  "#4AFF00"  "rgb(491,255,  0)"  "rgba(491,255,  0,255)"  "ChlorophyllGreen"
#WIKI_Chocolate_Traditional                    = $003F7B;  $FF003F7B  "#7B3F00"  "rgb(807, 63,  0)"  "rgba(807, 63,  0,255)"  "Chocolate_Traditional"
#WIKI_Chocolate_Web                            = $1E69D2;  $FF1E69D2  "#D2691E"  "rgb(137,105, 30)"  "rgba(137,105, 30,255)"  "Chocolate_Web"
#WIKI_ChromeYellow                             = $00A7FF;  $FF00A7FF  "#FFA700"  "rgb(167,167,  0)"  "rgba(167,167,  0,255)"  "ChromeYellow"
#WIKI_Cinereous                                = $7B8198;  $FF7B8198  "#98817B"  "rgb(999,129,123)"  "rgba(999,129,123,255)"  "Cinereous"
#WIKI_Cinnabar                                 = $3442E3;  $FF3442E3  "#E34234"  "rgb(148, 66, 52)"  "rgba(148, 66, 52,255)"  "Cinnabar"
#WIKI_CinnamonCitationneeded                   = $1E69D2;  $FF1E69D2  "#D2691E"  "rgb(137,105, 30)"  "rgba(137,105, 30,255)"  "CinnamonCitationneeded"
#WIKI_CinnamonSatin                            = $7E60CD;  $FF7E60CD  "#CD607E"  "rgb(134, 96,126)"  "rgba(134, 96,126,255)"  "CinnamonSatin"
#WIKI_Citrine                                  = $0AD0E4;  $FF0AD0E4  "#E4D00A"  "rgb(149,208, 10)"  "rgba(149,208, 10,255)"  "Citrine"
#WIKI_Citron                                   = $1FA99F;  $FF1FA99F  "#9FA91F"  "rgb(104,169, 31)"  "rgba(104,169, 31,255)"  "Citron"
#WIKI_Claret                                   = $34177F;  $FF34177F  "#7F1734"  "rgb(832, 23, 52)"  "rgba(832, 23, 52,255)"  "Claret"
#WIKI_ClassicRose                              = $E7CCFB;  $FFE7CCFB  "#FBCCE7"  "rgb(165,204,231)"  "rgba(165,204,231,255)"  "ClassicRose"
#WIKI_CobaltBlue                               = $AB4700;  $FFAB4700  "#0047AB"  "rgb(183, 71,171)"  "rgba(183, 71,171,255)"  "CobaltBlue"
#WIKI_CocoaBrown                               = $1E69D2;  $FF1E69D2  "#D2691E"  "rgb(137,105, 30)"  "rgba(137,105, 30,255)"  "CocoaBrown"
#WIKI_Coconut                                  = $3E5A96;  $FF3E5A96  "#965A3E"  "rgb(985, 90, 62)"  "rgba(985, 90, 62,255)"  "Coconut"
#WIKI_Coffee                                   = $374E6F;  $FF374E6F  "#6F4E37"  "rgb(729, 78, 55)"  "rgba(729, 78, 55,255)"  "Coffee"
#WIKI_ColumbiaBlue                             = $E2D8C4;  $FFE2D8C4  "#C4D8E2"  "rgb(129,216,226)"  "rgba(129,216,226,255)"  "ColumbiaBlue"
#WIKI_CongoPink                                = $7983F8;  $FF7983F8  "#F88379"  "rgb(162,131,121)"  "rgba(162,131,121,255)"  "CongoPink"
#WIKI_CoolBlack                                = $632E00;  $FF632E00  "#002E63"  "rgb(118, 46, 99)"  "rgba(118, 46, 99,255)"  "CoolBlack"
#WIKI_CoolGrey                                 = $AC928C;  $FFAC928C  "#8C92AC"  "rgb(921,146,172)"  "rgba(921,146,172,255)"  "CoolGrey"
#WIKI_Copper                                   = $3373B8;  $FF3373B8  "#B87333"  "rgb(120,115, 51)"  "rgba(120,115, 51,255)"  "Copper"
#WIKI_Copper_Crayola                           = $678ADA;  $FF678ADA  "#DA8A67"  "rgb(143,138,103)"  "rgba(143,138,103,255)"  "Copper_Crayola"
#WIKI_CopperPenny                              = $696FAD;  $FF696FAD  "#AD6F69"  "rgb(113,111,105)"  "rgba(113,111,105,255)"  "CopperPenny"
#WIKI_CopperRed                                = $516DCB;  $FF516DCB  "#CB6D51"  "rgb(133,109, 81)"  "rgba(133,109, 81,255)"  "CopperRed"
#WIKI_CopperRose                               = $666699;  $FF666699  "#996666"  "rgb(100,102,102)"  "rgba(100,102,102,255)"  "CopperRose"
#WIKI_Coquelicot                               = $0038FF;  $FF0038FF  "#FF3800"  "rgb(167, 56,  0)"  "rgba(167, 56,  0,255)"  "Coquelicot"
#WIKI_Coral                                    = $507FFF;  $FF507FFF  "#FF7F50"  "rgb(167,127, 80)"  "rgba(167,127, 80,255)"  "Coral"
#WIKI_CoralPink                                = $7983F8;  $FF7983F8  "#F88379"  "rgb(162,131,121)"  "rgba(162,131,121,255)"  "CoralPink"
#WIKI_CoralRed                                 = $4040FF;  $FF4040FF  "#FF4040"  "rgb(167, 64, 64)"  "rgba(167, 64, 64,255)"  "CoralRed"
#WIKI_CoralReef                                = $6E7CFD;  $FF6E7CFD  "#FD7C6E"  "rgb(166,124,110)"  "rgba(166,124,110,255)"  "CoralReef"
#WIKI_Cordovan                                 = $453F89;  $FF453F89  "#893F45"  "rgb(899, 63, 69)"  "rgba(899, 63, 69,255)"  "Cordovan"
#WIKI_Corn                                     = $5DECFB;  $FF5DECFB  "#FBEC5D"  "rgb(165,236, 93)"  "rgba(165,236, 93,255)"  "Corn"
#WIKI_CornellRed                               = $1B1BB3;  $FF1B1BB3  "#B31B1B"  "rgb(117, 27, 27)"  "rgba(117, 27, 27,255)"  "CornellRed"
#WIKI_CornflowerBlue                           = $ED9564;  $FFED9564  "#6495ED"  "rgb(659,149,237)"  "rgba(659,149,237,255)"  "CornflowerBlue"
#WIKI_Cornsilk                                 = $DCF8FF;  $FFDCF8FF  "#FFF8DC"  "rgb(167,248,220)"  "rgba(167,248,220,255)"  "Cornsilk"
#WIKI_CosmicCobalt                             = $882D2E;  $FF882D2E  "#2E2D88"  "rgb(302, 45,136)"  "rgba(302, 45,136,255)"  "CosmicCobalt"
#WIKI_CosmicLatte                              = $E7F8FF;  $FFE7F8FF  "#FFF8E7"  "rgb(167,248,231)"  "rgba(167,248,231,255)"  "CosmicLatte"
#WIKI_CoyoteBrown                              = $3C6181;  $FF3C6181  "#81613C"  "rgb(847, 97, 60)"  "rgba(847, 97, 60,255)"  "CoyoteBrown"
#WIKI_CottonCandy                              = $D9BCFF;  $FFD9BCFF  "#FFBCD9"  "rgb(167,188,217)"  "rgba(167,188,217,255)"  "CottonCandy"
#WIKI_Cream                                    = $D0FDFF;  $FFD0FDFF  "#FFFDD0"  "rgb(167,253,208)"  "rgba(167,253,208,255)"  "Cream"
#WIKI_Crimson                                  = $3C14DC;  $FF3C14DC  "#DC143C"  "rgb(144, 20, 60)"  "rgba(144, 20, 60,255)"  "Crimson"
#WIKI_CrimsonGlory                             = $3200BE;  $FF3200BE  "#BE0032"  "rgb(124,  0, 50)"  "rgba(124,  0, 50,255)"  "CrimsonGlory"
#WIKI_CrimsonRed                               = $000099;  $FF000099  "#990000"  "rgb(100,  0,  0)"  "rgba(100,  0,  0,255)"  "CrimsonRed"
#WIKI_Cultured                                 = $F5F5F5;  $FFF5F5F5  "#F5F5F5"  "rgb(161,245,245)"  "rgba(161,245,245,255)"  "Cultured"
#WIKI_Cyan                                     = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(655,255,255)"  "rgba(655,255,255,255)"  "Cyan"
#WIKI_CyanAzure                                = $B4824E;  $FFB4824E  "#4E82B4"  "rgb(514,130,180)"  "rgba(514,130,180,255)"  "CyanAzure"
#WIKI_CyanBlueAzure                            = $BF8246;  $FFBF8246  "#4682BF"  "rgb(462,130,191)"  "rgba(462,130,191,255)"  "CyanBlueAzure"
#WIKI_CyanCobaltBlue                           = $9C5828;  $FF9C5828  "#28589C"  "rgb(264, 88,156)"  "rgba(264, 88,156,255)"  "CyanCobaltBlue"
#WIKI_CyanCornflowerBlue                       = $C28B18;  $FFC28B18  "#188BC2"  "rgb(160,139,194)"  "rgba(160,139,194,255)"  "CyanCornflowerBlue"
#WIKI_Cyan_Process                             = $EBB700;  $FFEBB700  "#00B7EB"  "rgb(470,183,235)"  "rgba(470,183,235,255)"  "Cyan_Process"
#WIKI_CyberGrape                               = $7C4258;  $FF7C4258  "#58427C"  "rgb(578, 66,124)"  "rgba(578, 66,124,255)"  "CyberGrape"
#WIKI_CyberYellow                              = $00D3FF;  $FF00D3FF  "#FFD300"  "rgb(167,211,  0)"  "rgba(167,211,  0,255)"  "CyberYellow"
#WIKI_Cyclamen                                 = $A16FF5;  $FFA16FF5  "#F56FA1"  "rgb(160,111,161)"  "rgba(160,111,161,255)"  "Cyclamen"
#WIKI_Daffodil                                 = $31FFFF;  $FF31FFFF  "#FFFF31"  "rgb(167,255, 49)"  "rgba(167,255, 49,255)"  "Daffodil"
#WIKI_Dandelion                                = $30E1F0;  $FF30E1F0  "#F0E130"  "rgb(157,225, 48)"  "rgba(157,225, 48,255)"  "Dandelion"
#WIKI_DarkBlue                                 = $8B0000;  $FF8B0000  "#00008B"  "rgb(139,  0,139)"  "rgba(139,  0,139,255)"  "DarkBlue"
#WIKI_DarkBlueGray                             = $996666;  $FF996666  "#666699"  "rgb(671,102,153)"  "rgba(671,102,153,255)"  "DarkBlueGray"
#WIKI_DarkBrown                                = $214365;  $FF214365  "#654321"  "rgb(663, 67, 33)"  "rgba(663, 67, 33,255)"  "DarkBrown"
#WIKI_DarkBrownTangelo                         = $4E6588;  $FF4E6588  "#88654E"  "rgb(893,101, 78)"  "rgba(893,101, 78,255)"  "DarkBrownTangelo"
#WIKI_DarkByzantium                            = $54395D;  $FF54395D  "#5D3954"  "rgb(610, 57, 84)"  "rgba(610, 57, 84,255)"  "DarkByzantium"
#WIKI_DarkCandyAppleRed                        = $0000A4;  $FF0000A4  "#A40000"  "rgb(107,  0,  0)"  "rgba(107,  0,  0,255)"  "DarkCandyAppleRed"
#WIKI_DarkCerulean                             = $7E4508;  $FF7E4508  "#08457E"  "rgb(542, 69,126)"  "rgba(542, 69,126,255)"  "DarkCerulean"
#WIKI_DarkChestnut                             = $606998;  $FF606998  "#986960"  "rgb(998,105, 96)"  "rgba(998,105, 96,255)"  "DarkChestnut"
#WIKI_DarkCoral                                = $455BCD;  $FF455BCD  "#CD5B45"  "rgb(134, 91, 69)"  "rgba(134, 91, 69,255)"  "DarkCoral"
#WIKI_DarkCyan                                 = $8B8B00;  $FF8B8B00  "#008B8B"  "rgb(357,139,139)"  "rgba(357,139,139,255)"  "DarkCyan"
#WIKI_DarkElectricBlue                         = $786853;  $FF786853  "#536878"  "rgb(546,104,120)"  "rgba(546,104,120,255)"  "DarkElectricBlue"
#WIKI_DarkGoldenrod                            = $0B86B8;  $FF0B86B8  "#B8860B"  "rgb(120,134, 11)"  "rgba(120,134, 11,255)"  "DarkGoldenrod"
#WIKI_DarkGray_X11                             = $A9A9A9;  $FFA9A9A9  "#A9A9A9"  "rgb(111,169,169)"  "rgba(111,169,169,255)"  "DarkGray_X11"
#WIKI_DarkGreen                                = $203201;  $FF203201  "#013220"  "rgb(783, 50, 32)"  "rgba(783, 50, 32,255)"  "DarkGreen"
#WIKI_DarkGreen_X11                            = $006400;  $FF006400  "#006400"  "rgb(256,100,  0)"  "rgba(256,100,  0,255)"  "DarkGreen_X11"
#WIKI_DarkGunmetal                             = $2A261F;  $FF2A261F  "#1F262A"  "rgb(204, 38, 42)"  "rgba(204, 38, 42,255)"  "DarkGunmetal"
#WIKI_DarkImperialBlue                         = $6A4100;  $FF6A4100  "#00416A"  "rgb(167, 65,106)"  "rgba(167, 65,106,255)"  "DarkImperialBlue"
#WIKI_DarkImperialBlue_                        = $7E1400;  $FF7E1400  "#00147E"  "rgb(524, 20,126)"  "rgba(524, 20,126,255)"  "DarkImperialBlue_"
#WIKI_DarkJungleGreen                          = $21241A;  $FF21241A  "#1A2421"  "rgb(171, 36, 33)"  "rgba(171, 36, 33,255)"  "DarkJungleGreen"
#WIKI_DarkKhaki                                = $6BB7BD;  $FF6BB7BD  "#BDB76B"  "rgb(124,183,107)"  "rgba(124,183,107,255)"  "DarkKhaki"
#WIKI_DarkLava                                 = $323C48;  $FF323C48  "#483C32"  "rgb(473, 60, 50)"  "rgba(473, 60, 50,255)"  "DarkLava"
#WIKI_DarkLavender                             = $964F73;  $FF964F73  "#734F96"  "rgb(755, 79,150)"  "rgba(755, 79,150,255)"  "DarkLavender"
#WIKI_DarkLiver                                = $4F4B53;  $FF4F4B53  "#534B4F"  "rgb(545, 75, 79)"  "rgba(545, 75, 79,255)"  "DarkLiver"
#WIKI_DarkLiver_Horses                         = $373D54;  $FF373D54  "#543D37"  "rgb(552, 61, 55)"  "rgba(552, 61, 55,255)"  "DarkLiver_Horses"
#WIKI_DarkMagenta                              = $8B008B;  $FF8B008B  "#8B008B"  "rgb(910,  0,139)"  "rgba(910,  0,139,255)"  "DarkMagenta"
#WIKI_DarkMediumGray                           = $A9A9A9;  $FFA9A9A9  "#A9A9A9"  "rgb(111,169,169)"  "rgba(111,169,169,255)"  "DarkMediumGray"
#WIKI_DarkMidnightBlue                         = $663300;  $FF663300  "#003366"  "rgb(131, 51,102)"  "rgba(131, 51,102,255)"  "DarkMidnightBlue"
#WIKI_DarkMossGreen                            = $235D4A;  $FF235D4A  "#4A5D23"  "rgb(487, 93, 35)"  "rgba(487, 93, 35,255)"  "DarkMossGreen"
#WIKI_DarkOliveGreen                           = $2F6B55;  $FF2F6B55  "#556B2F"  "rgb(559,107, 47)"  "rgba(559,107, 47,255)"  "DarkOliveGreen"
#WIKI_DarkOrange                               = $008CFF;  $FF008CFF  "#FF8C00"  "rgb(167,140,  0)"  "rgba(167,140,  0,255)"  "DarkOrange"
#WIKI_DarkOrchid                               = $CC3299;  $FFCC3299  "#9932CC"  "rgb(100, 50,204)"  "rgba(100, 50,204,255)"  "DarkOrchid"
#WIKI_DarkPastelBlue                           = $CB9E77;  $FFCB9E77  "#779ECB"  "rgb(783,158,203)"  "rgba(783,158,203,255)"  "DarkPastelBlue"
#WIKI_DarkPastelGreen                          = $3CC003;  $FF3CC003  "#03C03C"  "rgb(245,192, 60)"  "rgba(245,192, 60,255)"  "DarkPastelGreen"
#WIKI_DarkPastelPurple                         = $D66F96;  $FFD66F96  "#966FD6"  "rgb(985,111,214)"  "rgba(985,111,214,255)"  "DarkPastelPurple"
#WIKI_DarkPastelRed                            = $223BC2;  $FF223BC2  "#C23B22"  "rgb(127, 59, 34)"  "rgba(127, 59, 34,255)"  "DarkPastelRed"
#WIKI_DarkPink                                 = $8054E7;  $FF8054E7  "#E75480"  "rgb(151, 84,128)"  "rgba(151, 84,128,255)"  "DarkPink"
#WIKI_DarkPowderBlue                           = $993300;  $FF993300  "#003399"  "rgb(132, 51,153)"  "rgba(132, 51,153,255)"  "DarkPowderBlue"
#WIKI_DarkPuce                                 = $3C3A4F;  $FF3C3A4F  "#4F3A3C"  "rgb(519, 58, 60)"  "rgba(519, 58, 60,255)"  "DarkPuce"
#WIKI_DarkPurple                               = $341930;  $FF341930  "#301934"  "rgb(315, 25, 52)"  "rgba(315, 25, 52,255)"  "DarkPurple"
#WIKI_DarkRaspberry                            = $572687;  $FF572687  "#872657"  "rgb(885, 38, 87)"  "rgba(885, 38, 87,255)"  "DarkRaspberry"
#WIKI_DarkRed                                  = $00008B;  $FF00008B  "#8B0000"  "rgb(910,  0,  0)"  "rgba(910,  0,  0,255)"  "DarkRed"
#WIKI_DarkSalmon                               = $7A96E9;  $FF7A96E9  "#E9967A"  "rgb(153,150,122)"  "rgba(153,150,122,255)"  "DarkSalmon"
#WIKI_DarkScarlet                              = $190356;  $FF190356  "#560319"  "rgb(563,  3, 25)"  "rgba(563,  3, 25,255)"  "DarkScarlet"
#WIKI_DarkSeaGreen                             = $8FBC8F;  $FF8FBC8F  "#8FBC8F"  "rgb(941,188,143)"  "rgba(941,188,143,255)"  "DarkSeaGreen"
#WIKI_DarkSienna                               = $14143C;  $FF14143C  "#3C1414"  "rgb(393, 20, 20)"  "rgba(393, 20, 20,255)"  "DarkSienna"
#WIKI_DarkSkyBlue                              = $D6BE8C;  $FFD6BE8C  "#8CBED6"  "rgb(922,190,214)"  "rgba(922,190,214,255)"  "DarkSkyBlue"
#WIKI_DarkSlateBlue                            = $8B3D48;  $FF8B3D48  "#483D8B"  "rgb(473, 61,139)"  "rgba(473, 61,139,255)"  "DarkSlateBlue"
#WIKI_DarkSlateGray                            = $4F4F2F;  $FF4F4F2F  "#2F4F4F"  "rgb(310, 79, 79)"  "rgba(310, 79, 79,255)"  "DarkSlateGray"
#WIKI_DarkSpringGreen                          = $457217;  $FF457217  "#177245"  "rgb(153,114, 69)"  "rgba(153,114, 69,255)"  "DarkSpringGreen"
#WIKI_DarkTan                                  = $518191;  $FF518191  "#918151"  "rgb(953,129, 81)"  "rgba(953,129, 81,255)"  "DarkTan"
#WIKI_DarkTangerine                            = $12A8FF;  $FF12A8FF  "#FFA812"  "rgb(167,168, 18)"  "rgba(167,168, 18,255)"  "DarkTangerine"
#WIKI_DarkTaupe                                = $323C48;  $FF323C48  "#483C32"  "rgb(473, 60, 50)"  "rgba(473, 60, 50,255)"  "DarkTaupe"
#WIKI_DarkTerraCotta                           = $5C4ECC;  $FF5C4ECC  "#CC4E5C"  "rgb(133, 78, 92)"  "rgba(133, 78, 92,255)"  "DarkTerraCotta"
#WIKI_DarkTurquoise                            = $D1CE00;  $FFD1CE00  "#00CED1"  "rgb(529,206,209)"  "rgba(529,206,209,255)"  "DarkTurquoise"
#WIKI_DarkVanilla                              = $A8BED1;  $FFA8BED1  "#D1BEA8"  "rgb(137,190,168)"  "rgba(137,190,168,255)"  "DarkVanilla"
#WIKI_DarkViolet                               = $D30094;  $FFD30094  "#9400D3"  "rgb(969,  0,211)"  "rgba(969,  0,211,255)"  "DarkViolet"
#WIKI_DarkYellow                               = $0C879B;  $FF0C879B  "#9B870C"  "rgb(101,135, 12)"  "rgba(101,135, 12,255)"  "DarkYellow"
#WIKI_DartmouthGreen                           = $3C7000;  $FF3C7000  "#00703C"  "rgb(287,112, 60)"  "rgba(287,112, 60,255)"  "DartmouthGreen"
#WIKI_DavysGrey                                = $555555;  $FF555555  "#555555"  "rgb(559, 85, 85)"  "rgba(559, 85, 85,255)"  "DavysGrey"
#WIKI_DebianRed                                = $530AD7;  $FF530AD7  "#D70A53"  "rgb(140, 10, 83)"  "rgba(140, 10, 83,255)"  "DebianRed"
#WIKI_DeepAquamarine                           = $6D8240;  $FF6D8240  "#40826D"  "rgb(422,130,109)"  "rgba(422,130,109,255)"  "DeepAquamarine"
#WIKI_DeepCarmine                              = $3E20A9;  $FF3E20A9  "#A9203E"  "rgb(110, 32, 62)"  "rgba(110, 32, 62,255)"  "DeepCarmine"
#WIKI_DeepCarminePink                          = $3830EF;  $FF3830EF  "#EF3038"  "rgb(156, 48, 56)"  "rgba(156, 48, 56,255)"  "DeepCarminePink"
#WIKI_DeepCarrotOrange                         = $2C69E9;  $FF2C69E9  "#E9692C"  "rgb(152,105, 44)"  "rgba(152,105, 44,255)"  "DeepCarrotOrange"
#WIKI_DeepCerise                               = $8732DA;  $FF8732DA  "#DA3287"  "rgb(142, 50,135)"  "rgba(142, 50,135,255)"  "DeepCerise"
#WIKI_DeepChampagne                            = $A5D6FA;  $FFA5D6FA  "#FAD6A5"  "rgb(164,214,165)"  "rgba(164,214,165,255)"  "DeepChampagne"
#WIKI_DeepChestnut                             = $484EB9;  $FF484EB9  "#B94E48"  "rgb(121, 78, 72)"  "rgba(121, 78, 72,255)"  "DeepChestnut"
#WIKI_DeepCoffee                               = $414270;  $FF414270  "#704241"  "rgb(735, 66, 65)"  "rgba(735, 66, 65,255)"  "DeepCoffee"
#WIKI_DeepFuchsia                              = $C154C1;  $FFC154C1  "#C154C1"  "rgb(126, 84,193)"  "rgba(126, 84,193,255)"  "DeepFuchsia"
#WIKI_DeepGreen                                = $086605;  $FF086605  "#056608"  "rgb(353,102,  8)"  "rgba(353,102,  8,255)"  "DeepGreen"
#WIKI_DeepGreenCyanTurquoise                   = $617C0E;  $FF617C0E  "#0E7C61"  "rgb(949,124, 97)"  "rgba(949,124, 97,255)"  "DeepGreenCyanTurquoise"
#WIKI_DeepJungleGreen                          = $494B00;  $FF494B00  "#004B49"  "rgb(192, 75, 73)"  "rgba(192, 75, 73,255)"  "DeepJungleGreen"
#WIKI_DeepKoamaru                              = $663333;  $FF663333  "#333366"  "rgb(335, 51,102)"  "rgba(335, 51,102,255)"  "DeepKoamaru"
#WIKI_DeepLemon                                = $1AC7F5;  $FF1AC7F5  "#F5C71A"  "rgb(161,199, 26)"  "rgba(161,199, 26,255)"  "DeepLemon"
#WIKI_DeepLilac                                = $BB5599;  $FFBB5599  "#9955BB"  "rgb(100, 85,187)"  "rgba(100, 85,187,255)"  "DeepLilac"
#WIKI_DeepMagenta                              = $CC00CC;  $FFCC00CC  "#CC00CC"  "rgb(133,  0,204)"  "rgba(133,  0,204,255)"  "DeepMagenta"
#WIKI_DeepMaroon                               = $000082;  $FF000082  "#820000"  "rgb(851,  0,  0)"  "rgba(851,  0,  0,255)"  "DeepMaroon"
#WIKI_DeepMauve                                = $D473D4;  $FFD473D4  "#D473D4"  "rgb(139,115,212)"  "rgba(139,115,212,255)"  "DeepMauve"
#WIKI_DeepMossGreen                            = $3B5E35;  $FF3B5E35  "#355E3B"  "rgb(349, 94, 59)"  "rgba(349, 94, 59,255)"  "DeepMossGreen"
#WIKI_DeepPeach                                = $A4CBFF;  $FFA4CBFF  "#FFCBA4"  "rgb(167,203,164)"  "rgba(167,203,164,255)"  "DeepPeach"
#WIKI_DeepPink                                 = $9314FF;  $FF9314FF  "#FF1493"  "rgb(167, 20,147)"  "rgba(167, 20,147,255)"  "DeepPink"
#WIKI_DeepPuce                                 = $685CA9;  $FF685CA9  "#A95C68"  "rgb(110, 92,104)"  "rgba(110, 92,104,255)"  "DeepPuce"
#WIKI_DeepRed                                  = $010185;  $FF010185  "#850101"  "rgb(871,  1,  1)"  "rgba(871,  1,  1,255)"  "DeepRed"
#WIKI_DeepRuby                                 = $5B3F84;  $FF5B3F84  "#843F5B"  "rgb(866, 63, 91)"  "rgba(866, 63, 91,255)"  "DeepRuby"
#WIKI_DeepSaffron                              = $3399FF;  $FF3399FF  "#FF9933"  "rgb(167,153, 51)"  "rgba(167,153, 51,255)"  "DeepSaffron"
#WIKI_DeepSkyBlue                              = $FFBF00;  $FFFFBF00  "#00BFFF"  "rgb(491,191,255)"  "rgba(491,191,255,255)"  "DeepSkyBlue"
#WIKI_DeepSpaceSparkle                         = $6C644A;  $FF6C644A  "#4A646C"  "rgb(487,100,108)"  "rgba(487,100,108,255)"  "DeepSpaceSparkle"
#WIKI_DeepSpringBud                            = $2F6B55;  $FF2F6B55  "#556B2F"  "rgb(559,107, 47)"  "rgba(559,107, 47,255)"  "DeepSpringBud"
#WIKI_DeepTaupe                                = $605E7E;  $FF605E7E  "#7E5E60"  "rgb(828, 94, 96)"  "rgba(828, 94, 96,255)"  "DeepTaupe"
#WIKI_DeepTuscanRed                            = $4D4266;  $FF4D4266  "#66424D"  "rgb(670, 66, 77)"  "rgba(670, 66, 77,255)"  "DeepTuscanRed"
#WIKI_DeepViolet                               = $660033;  $FF660033  "#330066"  "rgb(334,  0,102)"  "rgba(334,  0,102,255)"  "DeepViolet"
#WIKI_Deer                                     = $5987BA;  $FF5987BA  "#BA8759"  "rgb(122,135, 89)"  "rgba(122,135, 89,255)"  "Deer"
#WIKI_Denim                                    = $BD6015;  $FFBD6015  "#1560BD"  "rgb(140, 96,189)"  "rgba(140, 96,189,255)"  "Denim"
#WIKI_DenimBlue                                = $B64322;  $FFB64322  "#2243B6"  "rgb(224, 67,182)"  "rgba(224, 67,182,255)"  "DenimBlue"
#WIKI_DesaturatedCyan                          = $999966;  $FF999966  "#669999"  "rgb(672,153,153)"  "rgba(672,153,153,255)"  "DesaturatedCyan"
#WIKI_Desert                                   = $6B9AC1;  $FF6B9AC1  "#C19A6B"  "rgb(126,154,107)"  "rgba(126,154,107,255)"  "Desert"
#WIKI_DesertSand                               = $AFC9ED;  $FFAFC9ED  "#EDC9AF"  "rgb(155,201,175)"  "rgba(155,201,175,255)"  "DesertSand"
#WIKI_Desire                                   = $533CEA;  $FF533CEA  "#EA3C53"  "rgb(153, 60, 83)"  "rgba(153, 60, 83,255)"  "Desire"
#WIKI_Diamond                                  = $FFF2B9;  $FFFFF2B9  "#B9F2FF"  "rgb(121,242,255)"  "rgba(121,242,255,255)"  "Diamond"
#WIKI_DimGray                                  = $696969;  $FF696969  "#696969"  "rgb(690,105,105)"  "rgba(690,105,105,255)"  "DimGray"
#WIKI_DingyDungeon                             = $5131C5;  $FF5131C5  "#C53151"  "rgb(129, 49, 81)"  "rgba(129, 49, 81,255)"  "DingyDungeon"
#WIKI_Dirt                                     = $53769B;  $FF53769B  "#9B7653"  "rgb(101,118, 83)"  "rgba(101,118, 83,255)"  "Dirt"
#WIKI_DodgerBlue                               = $FF901E;  $FFFF901E  "#1E90FF"  "rgb(200,144,255)"  "rgba(200,144,255,255)"  "DodgerBlue"
#WIKI_DogwoodRose                              = $6818D7;  $FF6818D7  "#D71868"  "rgb(140, 24,104)"  "rgba(140, 24,104,255)"  "DogwoodRose"
#WIKI_DollarBill                               = $65BB85;  $FF65BB85  "#85BB65"  "rgb(876,187,101)"  "rgba(876,187,101,255)"  "DollarBill"
#WIKI_DolphinGray                              = $848E82;  $FF848E82  "#828E84"  "rgb(855,142,132)"  "rgba(855,142,132,255)"  "DolphinGray"
#WIKI_DonkeyBrown                              = $284C66;  $FF284C66  "#664C28"  "rgb(670, 76, 40)"  "rgba(670, 76, 40,255)"  "DonkeyBrown"
#WIKI_Drab                                     = $177196;  $FF177196  "#967117"  "rgb(985,113, 23)"  "rgba(985,113, 23,255)"  "Drab"
#WIKI_DukeBlue                                 = $9C0000;  $FF9C0000  "#00009C"  "rgb(156,  0,156)"  "rgba(156,  0,156,255)"  "DukeBlue"
#WIKI_DustStorm                                = $C9CCE5;  $FFC9CCE5  "#E5CCC9"  "rgb(150,204,201)"  "rgba(150,204,201,255)"  "DustStorm"
#WIKI_DutchWhite                               = $BBDFEF;  $FFBBDFEF  "#EFDFBB"  "rgb(157,223,187)"  "rgba(157,223,187,255)"  "DutchWhite"
#WIKI_EarthYellow                              = $5FA9E1;  $FF5FA9E1  "#E1A95F"  "rgb(147,169, 95)"  "rgba(147,169, 95,255)"  "EarthYellow"
#WIKI_Ebony                                    = $505D55;  $FF505D55  "#555D50"  "rgb(559, 93, 80)"  "rgba(559, 93, 80,255)"  "Ebony"
#WIKI_Ecru                                     = $80B2C2;  $FF80B2C2  "#C2B280"  "rgb(127,178,128)"  "rgba(127,178,128,255)"  "Ecru"
#WIKI_EerieBlack                               = $1B1B1B;  $FF1B1B1B  "#1B1B1B"  "rgb(177, 27, 27)"  "rgba(177, 27, 27,255)"  "EerieBlack"
#WIKI_Eggplant                                 = $514061;  $FF514061  "#614051"  "rgb(637, 64, 81)"  "rgba(637, 64, 81,255)"  "Eggplant"
#WIKI_Eggshell                                 = $D6EAF0;  $FFD6EAF0  "#F0EAD6"  "rgb(157,234,214)"  "rgba(157,234,214,255)"  "Eggshell"
#WIKI_EgyptianBlue                             = $A63410;  $FFA63410  "#1034A6"  "rgb(106, 52,166)"  "rgba(106, 52,166,255)"  "EgyptianBlue"
#WIKI_ElectricBlue                             = $FFF97D;  $FFFFF97D  "#7DF9FF"  "rgb(825,249,255)"  "rgba(825,249,255,255)"  "ElectricBlue"
#WIKI_ElectricCrimson                          = $3F00FF;  $FF3F00FF  "#FF003F"  "rgb(167,  0, 63)"  "rgba(167,  0, 63,255)"  "ElectricCrimson"
#WIKI_ElectricCyan                             = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(655,255,255)"  "rgba(655,255,255,255)"  "ElectricCyan"
#WIKI_ElectricGreen                            = $00FF00;  $FF00FF00  "#00FF00"  "rgb(652,255,  0)"  "rgba(652,255,  0,255)"  "ElectricGreen"
#WIKI_ElectricIndigo                           = $FF006F;  $FFFF006F  "#6F00FF"  "rgb(727,  0,255)"  "rgba(727,  0,255,255)"  "ElectricIndigo"
#WIKI_ElectricLavender                         = $FFBBF4;  $FFFFBBF4  "#F4BBFF"  "rgb(160,187,255)"  "rgba(160,187,255,255)"  "ElectricLavender"
#WIKI_ElectricLime                             = $00FFCC;  $FF00FFCC  "#CCFF00"  "rgb(134,255,  0)"  "rgba(134,255,  0,255)"  "ElectricLime"
#WIKI_ElectricPurple                           = $FF00BF;  $FFFF00BF  "#BF00FF"  "rgb(125,  0,255)"  "rgba(125,  0,255,255)"  "ElectricPurple"
#WIKI_ElectricUltramarine                      = $FF003F;  $FFFF003F  "#3F00FF"  "rgb(412,  0,255)"  "rgba(412,  0,255,255)"  "ElectricUltramarine"
#WIKI_ElectricViolet                           = $FF008F;  $FFFF008F  "#8F00FF"  "rgb(937,  0,255)"  "rgba(937,  0,255,255)"  "ElectricViolet"
#WIKI_ElectricYellow                           = $33FFFF;  $FF33FFFF  "#FFFF33"  "rgb(167,255, 51)"  "rgba(167,255, 51,255)"  "ElectricYellow"
#WIKI_Emerald                                  = $78C850;  $FF78C850  "#50C878"  "rgb(529,200,120)"  "rgba(529,200,120,255)"  "Emerald"
#WIKI_Eminence                                 = $82306C;  $FF82306C  "#6C3082"  "rgb(709, 48,130)"  "rgba(709, 48,130,255)"  "Eminence"
#WIKI_EnglishGreen                             = $3E4D1B;  $FF3E4D1B  "#1B4D3E"  "rgb(178, 77, 62)"  "rgba(178, 77, 62,255)"  "EnglishGreen"
#WIKI_EnglishLavender                          = $9583B4;  $FF9583B4  "#B48395"  "rgb(118,131,149)"  "rgba(118,131,149,255)"  "EnglishLavender"
#WIKI_EnglishRed                               = $524BAB;  $FF524BAB  "#AB4B52"  "rgb(112, 75, 82)"  "rgba(112, 75, 82,255)"  "EnglishRed"
#WIKI_EnglishVermillion                        = $4B47CC;  $FF4B47CC  "#CC474B"  "rgb(133, 71, 75)"  "rgba(133, 71, 75,255)"  "EnglishVermillion"
#WIKI_EnglishViolet                            = $5C3C56;  $FF5C3C56  "#563C5C"  "rgb(565, 60, 92)"  "rgba(565, 60, 92,255)"  "EnglishViolet"
#WIKI_EtonBlue                                 = $A2C896;  $FFA2C896  "#96C8A2"  "rgb(988,200,162)"  "rgba(988,200,162,255)"  "EtonBlue"
#WIKI_Eucalyptus                               = $A8D744;  $FFA8D744  "#44D7A8"  "rgb(451,215,168)"  "rgba(451,215,168,255)"  "Eucalyptus"
#WIKI_Fallow                                   = $6B9AC1;  $FF6B9AC1  "#C19A6B"  "rgb(126,154,107)"  "rgba(126,154,107,255)"  "Fallow"
#WIKI_FaluRed                                  = $181880;  $FF181880  "#801818"  "rgb(839, 24, 24)"  "rgba(839, 24, 24,255)"  "FaluRed"
#WIKI_Fandango                                 = $8933B5;  $FF8933B5  "#B53389"  "rgb(118, 51,137)"  "rgba(118, 51,137,255)"  "Fandango"
#WIKI_FandangoPink                             = $8552DE;  $FF8552DE  "#DE5285"  "rgb(145, 82,133)"  "rgba(145, 82,133,255)"  "FandangoPink"
#WIKI_FashionFuchsia                           = $A100F4;  $FFA100F4  "#F400A1"  "rgb(159,  0,161)"  "rgba(159,  0,161,255)"  "FashionFuchsia"
#WIKI_Fawn                                     = $70AAE5;  $FF70AAE5  "#E5AA70"  "rgb(150,170,112)"  "rgba(150,170,112,255)"  "Fawn"
#WIKI_Feldgrau                                 = $535D4D;  $FF535D4D  "#4D5D53"  "rgb(507, 93, 83)"  "rgba(507, 93, 83,255)"  "Feldgrau"
#WIKI_Feldspar                                 = $B1D5FD;  $FFB1D5FD  "#FDD5B1"  "rgb(166,213,177)"  "rgba(166,213,177,255)"  "Feldspar"
#WIKI_FernGreen                                = $42794F;  $FF42794F  "#4F7942"  "rgb(520,121, 66)"  "rgba(520,121, 66,255)"  "FernGreen"
#WIKI_FerrariRed                               = $0028FF;  $FF0028FF  "#FF2800"  "rgb(167, 40,  0)"  "rgba(167, 40,  0,255)"  "FerrariRed"
#WIKI_FieldDrab                                = $1E546C;  $FF1E546C  "#6C541E"  "rgb(709, 84, 30)"  "rgba(709, 84, 30,255)"  "FieldDrab"
#WIKI_FieryRose                                = $7054FF;  $FF7054FF  "#FF5470"  "rgb(167, 84,112)"  "rgba(167, 84,112,255)"  "FieryRose"
#WIKI_Firebrick                                = $2222B2;  $FF2222B2  "#B22222"  "rgb(116, 34, 34)"  "rgba(116, 34, 34,255)"  "Firebrick"
#WIKI_FireEngineRed                            = $2920CE;  $FF2920CE  "#CE2029"  "rgb(135, 32, 41)"  "rgba(135, 32, 41,255)"  "FireEngineRed"
#WIKI_Flame                                    = $2258E2;  $FF2258E2  "#E25822"  "rgb(148, 88, 34)"  "rgba(148, 88, 34,255)"  "Flame"
#WIKI_FlamingoPink                             = $AC8EFC;  $FFAC8EFC  "#FC8EAC"  "rgb(165,142,172)"  "rgba(165,142,172,255)"  "FlamingoPink"
#WIKI_Flattery                                 = $23446B;  $FF23446B  "#6B4423"  "rgb(702, 68, 35)"  "rgba(702, 68, 35,255)"  "Flattery"
#WIKI_Flavescent                               = $8EE9F7;  $FF8EE9F7  "#F7E98E"  "rgb(162,233,142)"  "rgba(162,233,142,255)"  "Flavescent"
#WIKI_Flax                                     = $82DCEE;  $FF82DCEE  "#EEDC82"  "rgb(156,220,130)"  "rgba(156,220,130,255)"  "Flax"
#WIKI_Flirt                                    = $6D00A2;  $FF6D00A2  "#A2006D"  "rgb(106,  0,109)"  "rgba(106,  0,109,255)"  "Flirt"
#WIKI_FloralWhite                              = $F0FAFF;  $FFF0FAFF  "#FFFAF0"  "rgb(167,250,240)"  "rgba(167,250,240,255)"  "FloralWhite"
#WIKI_FluorescentOrange                        = $00BFFF;  $FF00BFFF  "#FFBF00"  "rgb(167,191,  0)"  "rgba(167,191,  0,255)"  "FluorescentOrange"
#WIKI_FluorescentPink                          = $9314FF;  $FF9314FF  "#FF1493"  "rgb(167, 20,147)"  "rgba(167, 20,147,255)"  "FluorescentPink"
#WIKI_FluorescentYellow                        = $00FFCC;  $FF00FFCC  "#CCFF00"  "rgb(134,255,  0)"  "rgba(134,255,  0,255)"  "FluorescentYellow"
#WIKI_Folly                                    = $4F00FF;  $FF4F00FF  "#FF004F"  "rgb(167,  0, 79)"  "rgba(167,  0, 79,255)"  "Folly"
#WIKI_ForestGreen_Traditional                  = $214401;  $FF214401  "#014421"  "rgb(829, 68, 33)"  "rgba(829, 68, 33,255)"  "ForestGreen_Traditional"
#WIKI_ForestGreen_Web                          = $228B22;  $FF228B22  "#228B22"  "rgb(226,139, 34)"  "rgba(226,139, 34,255)"  "ForestGreen_Web"
#WIKI_FrenchBeige                              = $5B7BA6;  $FF5B7BA6  "#A67B5B"  "rgb(109,123, 91)"  "rgba(109,123, 91,255)"  "FrenchBeige"
#WIKI_FrenchBistre                             = $4D6D85;  $FF4D6D85  "#856D4D"  "rgb(874,109, 77)"  "rgba(874,109, 77,255)"  "FrenchBistre"
#WIKI_FrenchBlue                               = $BB7200;  $FFBB7200  "#0072BB"  "rgb(293,114,187)"  "rgba(293,114,187,255)"  "FrenchBlue"
#WIKI_FrenchFuchsia                            = $923FFD;  $FF923FFD  "#FD3F92"  "rgb(165, 63,146)"  "rgba(165, 63,146,255)"  "FrenchFuchsia"
#WIKI_FrenchLilac                              = $8E6086;  $FF8E6086  "#86608E"  "rgb(880, 96,142)"  "rgba(880, 96,142,255)"  "FrenchLilac"
#WIKI_FrenchLime                               = $38FD9E;  $FF38FD9E  "#9EFD38"  "rgb(104,253, 56)"  "rgba(104,253, 56,255)"  "FrenchLime"
#WIKI_FrenchMauve                              = $D473D4;  $FFD473D4  "#D473D4"  "rgb(139,115,212)"  "rgba(139,115,212,255)"  "FrenchMauve"
#WIKI_FrenchPink                               = $9E6CFD;  $FF9E6CFD  "#FD6C9E"  "rgb(166,108,158)"  "rgba(166,108,158,255)"  "FrenchPink"
#WIKI_FrenchPlum                               = $531481;  $FF531481  "#811453"  "rgb(845, 20, 83)"  "rgba(845, 20, 83,255)"  "FrenchPlum"
#WIKI_FrenchPuce                               = $09164E;  $FF09164E  "#4E1609"  "rgb(511, 22,  9)"  "rgba(511, 22,  9,255)"  "FrenchPuce"
#WIKI_FrenchRaspberry                          = $482CC7;  $FF482CC7  "#C72C48"  "rgb(130, 44, 72)"  "rgba(130, 44, 72,255)"  "FrenchRaspberry"
#WIKI_FrenchRose                               = $8A4AF6;  $FF8A4AF6  "#F64A8A"  "rgb(161, 74,138)"  "rgba(161, 74,138,255)"  "FrenchRose"
#WIKI_FrenchSkyBlue                            = $FEB577;  $FFFEB577  "#77B5FE"  "rgb(784,181,254)"  "rgba(784,181,254,255)"  "FrenchSkyBlue"
#WIKI_FrenchViolet                             = $CE0688;  $FFCE0688  "#8806CE"  "rgb(891,  6,206)"  "rgba(891,  6,206,255)"  "FrenchViolet"
#WIKI_FrenchWine                               = $441EAC;  $FF441EAC  "#AC1E44"  "rgb(112, 30, 68)"  "rgba(112, 30, 68,255)"  "FrenchWine"
#WIKI_FreshAir                                 = $FFE7A6;  $FFFFE7A6  "#A6E7FF"  "rgb(109,231,255)"  "rgba(109,231,255,255)"  "FreshAir"
#WIKI_Frostbite                                = $A736E9;  $FFA736E9  "#E936A7"  "rgb(152, 54,167)"  "rgba(152, 54,167,255)"  "Frostbite"
#WIKI_Fuchsia                                  = $FF00FF;  $FFFF00FF  "#FF00FF"  "rgb(167,  0,255)"  "rgba(167,  0,255,255)"  "Fuchsia"
#WIKI_Fuchsia_Crayola                          = $C154C1;  $FFC154C1  "#C154C1"  "rgb(126, 84,193)"  "rgba(126, 84,193,255)"  "Fuchsia_Crayola"
#WIKI_FuchsiaPink                              = $FF77FF;  $FFFF77FF  "#FF77FF"  "rgb(167,119,255)"  "rgba(167,119,255,255)"  "FuchsiaPink"
#WIKI_FuchsiaPurple                            = $7B39CC;  $FF7B39CC  "#CC397B"  "rgb(133, 57,123)"  "rgba(133, 57,123,255)"  "FuchsiaPurple"
#WIKI_FuchsiaRose                              = $7543C7;  $FF7543C7  "#C74375"  "rgb(130, 67,117)"  "rgba(130, 67,117,255)"  "FuchsiaRose"
#WIKI_Fulvous                                  = $0084E4;  $FF0084E4  "#E48400"  "rgb(149,132,  0)"  "rgba(149,132,  0,255)"  "Fulvous"
#WIKI_FuzzyWuzzy                               = $6666CC;  $FF6666CC  "#CC6666"  "rgb(133,102,102)"  "rgba(133,102,102,255)"  "FuzzyWuzzy"
#WIKI_Gainsboro                                = $DCDCDC;  $FFDCDCDC  "#DCDCDC"  "rgb(144,220,220)"  "rgba(144,220,220,255)"  "Gainsboro"
#WIKI_Gamboge                                  = $0F9BE4;  $FF0F9BE4  "#E49B0F"  "rgb(149,155, 15)"  "rgba(149,155, 15,255)"  "Gamboge"
#WIKI_GambogeOrange_Brown                      = $006699;  $FF006699  "#996600"  "rgb(100,102,  0)"  "rgba(100,102,  0,255)"  "GambogeOrange_Brown"
#WIKI_GargoyleGas                              = $46DFFF;  $FF46DFFF  "#FFDF46"  "rgb(167,223, 70)"  "rgba(167,223, 70,255)"  "GargoyleGas"
#WIKI_GenericViridian                          = $667F00;  $FF667F00  "#007F66"  "rgb(326,127,102)"  "rgba(326,127,102,255)"  "GenericViridian"
#WIKI_GhostWhite                               = $FFF8F8;  $FFFFF8F8  "#F8F8FF"  "rgb(163,248,255)"  "rgba(163,248,255,255)"  "GhostWhite"
#WIKI_GiantsClub                               = $525CB0;  $FF525CB0  "#B05C52"  "rgb(115, 92, 82)"  "rgba(115, 92, 82,255)"  "GiantsClub"
#WIKI_GiantsOrange                             = $1D5AFE;  $FF1D5AFE  "#FE5A1D"  "rgb(166, 90, 29)"  "rgba(166, 90, 29,255)"  "GiantsOrange"
#WIKI_Ginger                                   = $0065B0;  $FF0065B0  "#B06500"  "rgb(115,101,  0)"  "rgba(115,101,  0,255)"  "Ginger"
#WIKI_Glaucous                                 = $B68260;  $FFB68260  "#6082B6"  "rgb(632,130,182)"  "rgba(632,130,182,255)"  "Glaucous"
#WIKI_Glitter                                  = $FAE8E6;  $FFFAE8E6  "#E6E8FA"  "rgb(151,232,250)"  "rgba(151,232,250,255)"  "Glitter"
#WIKI_GlossyGrape                              = $B392AB;  $FFB392AB  "#AB92B3"  "rgb(112,146,179)"  "rgba(112,146,179,255)"  "GlossyGrape"
#WIKI_GoGreen                                  = $66AB00;  $FF66AB00  "#00AB66"  "rgb(438,171,102)"  "rgba(438,171,102,255)"  "GoGreen"
#WIKI_Gold_Metallic                            = $37AFD4;  $FF37AFD4  "#D4AF37"  "rgb(139,175, 55)"  "rgba(139,175, 55,255)"  "Gold_Metallic"
#WIKI_Gold_Web_Golden                          = $00D7FF;  $FF00D7FF  "#FFD700"  "rgb(167,215,  0)"  "rgba(167,215,  0,255)"  "Gold_Web_Golden"
#WIKI_GoldFusion                               = $4E7585;  $FF4E7585  "#85754E"  "rgb(874,117, 78)"  "rgba(874,117, 78,255)"  "GoldFusion"
#WIKI_GoldenBrown                              = $156599;  $FF156599  "#996515"  "rgb(100,101, 21)"  "rgba(100,101, 21,255)"  "GoldenBrown"
#WIKI_GoldenPoppy                              = $00C2FC;  $FF00C2FC  "#FCC200"  "rgb(165,194,  0)"  "rgba(165,194,  0,255)"  "GoldenPoppy"
#WIKI_GoldenYellow                             = $00DFFF;  $FF00DFFF  "#FFDF00"  "rgb(167,223,  0)"  "rgba(167,223,  0,255)"  "GoldenYellow"
#WIKI_Goldenrod                                = $20A5DA;  $FF20A5DA  "#DAA520"  "rgb(143,165, 32)"  "rgba(143,165, 32,255)"  "Goldenrod"
#WIKI_GraniteGray                              = $676767;  $FF676767  "#676767"  "rgb(677,103,103)"  "rgba(677,103,103,255)"  "GraniteGray"
#WIKI_GrannySmithApple                         = $A0E4A8;  $FFA0E4A8  "#A8E4A0"  "rgb(110,228,160)"  "rgba(110,228,160,255)"  "GrannySmithApple"
#WIKI_Grape                                    = $A82D6F;  $FFA82D6F  "#6F2DA8"  "rgb(728, 45,168)"  "rgba(728, 45,168,255)"  "Grape"
#WIKI_Gray                                     = $808080;  $FF808080  "#808080"  "rgb(842,128,128)"  "rgba(842,128,128,255)"  "Gray"
#WIKI_Gray_HtmlcssGray                         = $808080;  $FF808080  "#808080"  "rgb(842,128,128)"  "rgba(842,128,128,255)"  "Gray_HtmlcssGray"
#WIKI_Gray_X11Gray                             = $BEBEBE;  $FFBEBEBE  "#BEBEBE"  "rgb(125,190,190)"  "rgba(125,190,190,255)"  "Gray_X11Gray"
#WIKI_GrayAsparagus                            = $455946;  $FF455946  "#465945"  "rgb(461, 89, 69)"  "rgba(461, 89, 69,255)"  "GrayAsparagus"
#WIKI_GrayBlue                                 = $AC928C;  $FFAC928C  "#8C92AC"  "rgb(921,146,172)"  "rgba(921,146,172,255)"  "GrayBlue"
#WIKI_Green_ColorWheel_X11                     = $00FF00;  $FF00FF00  "#00FF00"  "rgb(652,255,  0)"  "rgba(652,255,  0,255)"  "Green_ColorWheel_X11"
#WIKI_Green_Crayola                            = $78AC1C;  $FF78AC1C  "#1CAC78"  "rgb(187,172,120)"  "rgba(187,172,120,255)"  "Green_Crayola"
#WIKI_Green_HtmlcssColor                       = $008000;  $FF008000  "#008000"  "rgb(327,128,  0)"  "rgba(327,128,  0,255)"  "Green_HtmlcssColor"
#WIKI_Green_Munsell                            = $77A800;  $FF77A800  "#00A877"  "rgb(431,168,119)"  "rgba(431,168,119,255)"  "Green_Munsell"
#WIKI_Green_Ncs                                = $6B9F00;  $FF6B9F00  "#009F6B"  "rgb(408,159,107)"  "rgba(408,159,107,255)"  "Green_Ncs"
#WIKI_Green_Pantone                            = $43AD00;  $FF43AD00  "#00AD43"  "rgb(443,173, 67)"  "rgba(443,173, 67,255)"  "Green_Pantone"
#WIKI_Green_Pigment                            = $50A500;  $FF50A500  "#00A550"  "rgb(423,165, 80)"  "rgba(423,165, 80,255)"  "Green_Pigment"
#WIKI_Green_Ryb                                = $32B066;  $FF32B066  "#66B032"  "rgb(672,176, 50)"  "rgba(672,176, 50,255)"  "Green_Ryb"
#WIKI_GreenBlue                                = $B46411;  $FFB46411  "#1164B4"  "rgb(113,100,180)"  "rgba(113,100,180,255)"  "GreenBlue"
#WIKI_GreenCyan                                = $669900;  $FF669900  "#009966"  "rgb(392,153,102)"  "rgba(392,153,102,255)"  "GreenCyan"
#WIKI_GreenLizard                              = $32F4A7;  $FF32F4A7  "#A7F432"  "rgb(110,244, 50)"  "rgba(110,244, 50,255)"  "GreenLizard"
#WIKI_GreenSheen                               = $A1AE6E;  $FFA1AE6E  "#6EAEA1"  "rgb(725,174,161)"  "rgba(725,174,161,255)"  "GreenSheen"
#WIKI_GreenYellow                              = $2FFFAD;  $FF2FFFAD  "#ADFF2F"  "rgb(114,255, 47)"  "rgba(114,255, 47,255)"  "GreenYellow"
#WIKI_Grizzly                                  = $185888;  $FF185888  "#885818"  "rgb(893, 88, 24)"  "rgba(893, 88, 24,255)"  "Grizzly"
#WIKI_Grullo                                   = $869AA9;  $FF869AA9  "#A99A86"  "rgb(111,154,134)"  "rgba(111,154,134,255)"  "Grullo"
#WIKI_GuppieGreen                              = $7FFF00;  $FF7FFF00  "#00FF7F"  "rgb(654,255,127)"  "rgba(654,255,127,255)"  "GuppieGreen"
#WIKI_Gunmetal                                 = $39342a;  $FF39342a  "#2a3439"  "rgb(276, 52, 57)"  "rgba(276, 52, 57,255)"  "Gunmetal"
#WIKI_HalayaUbe                                = $543866;  $FF543866  "#663854"  "rgb(669, 56, 84)"  "rgba(669, 56, 84,255)"  "HalayaUbe"
#WIKI_HanBlue                                  = $CF6C44;  $FFCF6C44  "#446CCF"  "rgb(448,108,207)"  "rgba(448,108,207,255)"  "HanBlue"
#WIKI_HanPurple                                = $FA1852;  $FFFA1852  "#5218FA"  "rgb(538, 24,250)"  "rgba(538, 24,250,255)"  "HanPurple"
#WIKI_HansaYellow                              = $6BD6E9;  $FF6BD6E9  "#E9D66B"  "rgb(153,214,107)"  "rgba(153,214,107,255)"  "HansaYellow"
#WIKI_Harlequin                                = $00FF3F;  $FF00FF3F  "#3FFF00"  "rgb(419,255,  0)"  "rgba(419,255,  0,255)"  "Harlequin"
#WIKI_HarlequinGreen                           = $18CB46;  $FF18CB46  "#46CB18"  "rgb(463,203, 24)"  "rgba(463,203, 24,255)"  "HarlequinGreen"
#WIKI_HarvardCrimson                           = $1600C9;  $FF1600C9  "#C90016"  "rgb(131,  0, 22)"  "rgba(131,  0, 22,255)"  "HarvardCrimson"
#WIKI_HarvestGold                              = $0091DA;  $FF0091DA  "#DA9100"  "rgb(143,145,  0)"  "rgba(143,145,  0,255)"  "HarvestGold"
#WIKI_HeartGold                                = $008080;  $FF008080  "#808000"  "rgb(842,128,  0)"  "rgba(842,128,  0,255)"  "HeartGold"
#WIKI_HeatWave                                 = $007AFF;  $FF007AFF  "#FF7A00"  "rgb(167,122,  0)"  "rgba(167,122,  0,255)"  "HeatWave"
#WIKI_HeidelbergRed                            = $180096;  $FF180096  "#960018"  "rgb(983,  0, 24)"  "rgba(983,  0, 24,255)"  "HeidelbergRed"
#WIKI_Heliotrope                               = $FF73DF;  $FFFF73DF  "#DF73FF"  "rgb(146,115,255)"  "rgba(146,115,255,255)"  "Heliotrope"
#WIKI_HeliotropeGray                           = $A998AA;  $FFA998AA  "#AA98A9"  "rgb(111,152,169)"  "rgba(111,152,169,255)"  "HeliotropeGray"
#WIKI_HeliotropeMagenta                        = $BB00AA;  $FFBB00AA  "#AA00BB"  "rgb(111,  0,187)"  "rgba(111,  0,187,255)"  "HeliotropeMagenta"
#WIKI_HollywoodCerise                          = $A100F4;  $FFA100F4  "#F400A1"  "rgb(159,  0,161)"  "rgba(159,  0,161,255)"  "HollywoodCerise"
#WIKI_Honeydew                                 = $F0FFF0;  $FFF0FFF0  "#F0FFF0"  "rgb(157,255,240)"  "rgba(157,255,240,255)"  "Honeydew"
#WIKI_HonoluluBlue                             = $B06D00;  $FFB06D00  "#006DB0"  "rgb(280,109,176)"  "rgba(280,109,176,255)"  "HonoluluBlue"
#WIKI_HookersGreen                             = $6B7949;  $FF6B7949  "#49796B"  "rgb(481,121,107)"  "rgba(481,121,107,255)"  "HookersGreen"
#WIKI_HotMagenta                               = $CE1DFF;  $FFCE1DFF  "#FF1DCE"  "rgb(167, 29,206)"  "rgba(167, 29,206,255)"  "HotMagenta"
#WIKI_HotPink                                  = $B469FF;  $FFB469FF  "#FF69B4"  "rgb(167,105,180)"  "rgba(167,105,180,255)"  "HotPink"
#WIKI_HunterGreen                              = $3B5E35;  $FF3B5E35  "#355E3B"  "rgb(349, 94, 59)"  "rgba(349, 94, 59,255)"  "HunterGreen"
#WIKI_Iceberg                                  = $D2A671;  $FFD2A671  "#71A6D2"  "rgb(744,166,210)"  "rgba(744,166,210,255)"  "Iceberg"
#WIKI_Icterine                                 = $5EF7FC;  $FF5EF7FC  "#FCF75E"  "rgb(165,247, 94)"  "rgba(165,247, 94,255)"  "Icterine"
#WIKI_IguanaGreen                              = $78BC71;  $FF78BC71  "#71BC78"  "rgb(745,188,120)"  "rgba(745,188,120,255)"  "IguanaGreen"
#WIKI_IlluminatingEmerald                      = $779131;  $FF779131  "#319177"  "rgb(324,145,119)"  "rgba(324,145,119,255)"  "IlluminatingEmerald"
#WIKI_Imperial                                 = $6B2F60;  $FF6B2F60  "#602F6B"  "rgb(630, 47,107)"  "rgba(630, 47,107,255)"  "Imperial"
#WIKI_ImperialBlue                             = $952300;  $FF952300  "#002395"  "rgb(910, 35,149)"  "rgba(910, 35,149,255)"  "ImperialBlue"
#WIKI_ImperialPurple                           = $3C0266;  $FF3C0266  "#66023C"  "rgb(668,  2, 60)"  "rgba(668,  2, 60,255)"  "ImperialPurple"
#WIKI_ImperialRed                              = $3929ED;  $FF3929ED  "#ED2939"  "rgb(155, 41, 57)"  "rgba(155, 41, 57,255)"  "ImperialRed"
#WIKI_Inchworm                                 = $5DECB2;  $FF5DECB2  "#B2EC5D"  "rgb(117,236, 93)"  "rgba(117,236, 93,255)"  "Inchworm"
#WIKI_Independence                             = $6D514C;  $FF6D514C  "#4C516D"  "rgb(500, 81,109)"  "rgba(500, 81,109,255)"  "Independence"
#WIKI_IndiaGreen                               = $088813;  $FF088813  "#138808"  "rgb(128,136,  8)"  "rgba(128,136,  8,255)"  "IndiaGreen"
#WIKI_IndianRed                                = $5C5CCD;  $FF5C5CCD  "#CD5C5C"  "rgb(134, 92, 92)"  "rgba(134, 92, 92,255)"  "IndianRed"
#WIKI_IndianYellow                             = $57A8E3;  $FF57A8E3  "#E3A857"  "rgb(149,168, 87)"  "rgba(149,168, 87,255)"  "IndianYellow"
#WIKI_Indigo                                   = $82004B;  $FF82004B  "#4B0082"  "rgb(491,  0,130)"  "rgba(491,  0,130,255)"  "Indigo"
#WIKI_IndigoDye                                = $921F09;  $FF921F09  "#091F92"  "rgb(597, 31,146)"  "rgba(597, 31,146,255)"  "IndigoDye"
#WIKI_Indigo_Web_                              = $82004B;  $FF82004B  "#4B0082"  "rgb(491,  0,130)"  "rgba(491,  0,130,255)"  "Indigo_Web_"
#WIKI_InfraRed                                 = $6C49FF;  $FF6C49FF  "#FF496C"  "rgb(167, 73,108)"  "rgba(167, 73,108,255)"  "InfraRed"
#WIKI_InterdimensionalBlue                     = $CC0C36;  $FFCC0C36  "#360CCC"  "rgb(354, 12,204)"  "rgba(354, 12,204,255)"  "InterdimensionalBlue"
#WIKI_InternationalKleinBlue                   = $A72F00;  $FFA72F00  "#002FA7"  "rgb(121, 47,167)"  "rgba(121, 47,167,255)"  "InternationalKleinBlue"
#WIKI_InternationalOrange_Aerospace            = $004FFF;  $FF004FFF  "#FF4F00"  "rgb(167, 79,  0)"  "rgba(167, 79,  0,255)"  "InternationalOrange_Aerospace"
#WIKI_InternationalOrange_Engineering          = $0C16BA;  $FF0C16BA  "#BA160C"  "rgb(121, 22, 12)"  "rgba(121, 22, 12,255)"  "InternationalOrange_Engineering"
#WIKI_InternationalOrange_EngineeringGatebridge= $2C36C0;  $FF2C36C0  "#C0362C"  "rgb(125, 54, 44)"  "rgba(125, 54, 44,255)"  "InternationalOrange_EngineeringGatebridge"
#WIKI_Iris                                     = $CF4F5A;  $FFCF4F5A  "#5A4FCF"  "rgb(591, 79,207)"  "rgba(591, 79,207,255)"  "Iris"
#WIKI_Irresistible                             = $6C44B3;  $FF6C44B3  "#B3446C"  "rgb(117, 68,108)"  "rgba(117, 68,108,255)"  "Irresistible"
#WIKI_Isabelline                               = $ECF0F4;  $FFECF0F4  "#F4F0EC"  "rgb(160,240,236)"  "rgba(160,240,236,255)"  "Isabelline"
#WIKI_IslamicGreen                             = $009000;  $FF009000  "#009000"  "rgb(368,144,  0)"  "rgba(368,144,  0,255)"  "IslamicGreen"
#WIKI_ItalianSkyBlue                           = $FFFFB2;  $FFFFFFB2  "#B2FFFF"  "rgb(117,255,255)"  "rgba(117,255,255,255)"  "ItalianSkyBlue"
#WIKI_Ivory                                    = $F0FFFF;  $FFF0FFFF  "#FFFFF0"  "rgb(167,255,240)"  "rgba(167,255,240,255)"  "Ivory"
#WIKI_Jade                                     = $6BA800;  $FF6BA800  "#00A86B"  "rgb(431,168,107)"  "rgba(431,168,107,255)"  "Jade"
#WIKI_JapaneseCarmine                          = $33299D;  $FF33299D  "#9D2933"  "rgb(102, 41, 51)"  "rgba(102, 41, 51,255)"  "JapaneseCarmine"
#WIKI_JapaneseIndigo                           = $484326;  $FF484326  "#264348"  "rgb(250, 67, 72)"  "rgba(250, 67, 72,255)"  "JapaneseIndigo"
#WIKI_JapaneseViolet                           = $56325B;  $FF56325B  "#5B3256"  "rgb(597, 50, 86)"  "rgba(597, 50, 86,255)"  "JapaneseViolet"
#WIKI_Jasmine                                  = $7EDEF8;  $FF7EDEF8  "#F8DE7E"  "rgb(163,222,126)"  "rgba(163,222,126,255)"  "Jasmine"
#WIKI_Jasper                                   = $3E3BD7;  $FF3E3BD7  "#D73B3E"  "rgb(141, 59, 62)"  "rgba(141, 59, 62,255)"  "Jasper"
#WIKI_JazzberryJam                             = $5E0BA5;  $FF5E0BA5  "#A50B5E"  "rgb(108, 11, 94)"  "rgba(108, 11, 94,255)"  "JazzberryJam"
#WIKI_JellyBean                                = $4E61DA;  $FF4E61DA  "#DA614E"  "rgb(143, 97, 78)"  "rgba(143, 97, 78,255)"  "JellyBean"
#WIKI_Jet                                      = $343434;  $FF343434  "#343434"  "rgb(342, 52, 52)"  "rgba(342, 52, 52,255)"  "Jet"
#WIKI_Jonquil                                  = $16CAF4;  $FF16CAF4  "#F4CA16"  "rgb(160,202, 22)"  "rgba(160,202, 22,255)"  "Jonquil"
#WIKI_JordyBlue                                = $F1B98A;  $FFF1B98A  "#8AB9F1"  "rgb(909,185,241)"  "rgba(909,185,241,255)"  "JordyBlue"
#WIKI_JuneBud                                  = $57DABD;  $FF57DABD  "#BDDA57"  "rgb(124,218, 87)"  "rgba(124,218, 87,255)"  "JuneBud"
#WIKI_JungleGreen                              = $87AB29;  $FF87AB29  "#29AB87"  "rgb(273,171,135)"  "rgba(273,171,135,255)"  "JungleGreen"
#WIKI_KellyGreen                               = $17BB4C;  $FF17BB4C  "#4CBB17"  "rgb(502,187, 23)"  "rgba(502,187, 23,255)"  "KellyGreen"
#WIKI_KenyanCopper                             = $051C7C;  $FF051C7C  "#7C1C05"  "rgb(813, 28,  5)"  "rgba(813, 28,  5,255)"  "KenyanCopper"
#WIKI_Keppel                                   = $9EB03A;  $FF9EB03A  "#3AB09E"  "rgb(384,176,158)"  "rgba(384,176,158,255)"  "Keppel"
#WIKI_KeyLime                                  = $8CF4E8;  $FF8CF4E8  "#E8F48C"  "rgb(152,244,140)"  "rgba(152,244,140,255)"  "KeyLime"
#WIKI_Khaki_Htmlcss                            = $91B0C3;  $FF91B0C3  "#C3B091"  "rgb(128,176,145)"  "rgba(128,176,145,255)"  "Khaki_Htmlcss"
#WIKI_Khaki_X11_Light                          = $8CE6F0;  $FF8CE6F0  "#F0E68C"  "rgb(157,230,140)"  "rgba(157,230,140,255)"  "Khaki_X11_Light"
#WIKI_Kiwi                                     = $3FE58E;  $FF3FE58E  "#8EE53F"  "rgb(936,229, 63)"  "rgba(936,229, 63,255)"  "Kiwi"
#WIKI_Kobe                                     = $172D88;  $FF172D88  "#882D17"  "rgb(892, 45, 23)"  "rgba(892, 45, 23,255)"  "Kobe"
#WIKI_Kobi                                     = $C49FE7;  $FFC49FE7  "#E79FC4"  "rgb(151,159,196)"  "rgba(151,159,196,255)"  "Kobi"
#WIKI_Kobicha                                  = $23446B;  $FF23446B  "#6B4423"  "rgb(702, 68, 35)"  "rgba(702, 68, 35,255)"  "Kobicha"
#WIKI_KombuGreen                               = $304235;  $FF304235  "#354230"  "rgb(349, 66, 48)"  "rgba(349, 66, 48,255)"  "KombuGreen"
#WIKI_KsuPurple                                = $882851;  $FF882851  "#512888"  "rgb(531, 40,136)"  "rgba(531, 40,136,255)"  "KsuPurple"
#WIKI_KuCrimson                                = $0D00E8;  $FF0D00E8  "#E8000D"  "rgb(152,  0, 13)"  "rgba(152,  0, 13,255)"  "KuCrimson"
#WIKI_LaSalleGreen                             = $307808;  $FF307808  "#087830"  "rgb(555,120, 48)"  "rgba(555,120, 48,255)"  "LaSalleGreen"
#WIKI_LanguidLavender                          = $DDCAD6;  $FFDDCAD6  "#D6CADD"  "rgb(140,202,221)"  "rgba(140,202,221,255)"  "LanguidLavender"
#WIKI_LapisLazuli                              = $9C6126;  $FF9C6126  "#26619C"  "rgb(251, 97,156)"  "rgba(251, 97,156,255)"  "LapisLazuli"
#WIKI_LaserLemon                               = $66FFFF;  $FF66FFFF  "#FFFF66"  "rgb(167,255,102)"  "rgba(167,255,102,255)"  "LaserLemon"
#WIKI_LaurelGreen                              = $9DBAA9;  $FF9DBAA9  "#A9BA9D"  "rgb(111,186,157)"  "rgba(111,186,157,255)"  "LaurelGreen"
#WIKI_Lava                                     = $2010CF;  $FF2010CF  "#CF1020"  "rgb(135, 16, 32)"  "rgba(135, 16, 32,255)"  "Lava"
#WIKI_Lavender_Floral                          = $DC7EB5;  $FFDC7EB5  "#B57EDC"  "rgb(118,126,220)"  "rgba(118,126,220,255)"  "Lavender_Floral"
#WIKI_Lavender_Web                             = $FAE6E6;  $FFFAE6E6  "#E6E6FA"  "rgb(151,230,250)"  "rgba(151,230,250,255)"  "Lavender_Web"
#WIKI_LavenderBlue                             = $FFCCCC;  $FFFFCCCC  "#CCCCFF"  "rgb(134,204,255)"  "rgba(134,204,255,255)"  "LavenderBlue"
#WIKI_LavenderBlush                            = $F5F0FF;  $FFF5F0FF  "#FFF0F5"  "rgb(167,240,245)"  "rgba(167,240,245,255)"  "LavenderBlush"
#WIKI_LavenderGray                             = $D0C3C4;  $FFD0C3C4  "#C4C3D0"  "rgb(128,195,208)"  "rgba(128,195,208,255)"  "LavenderGray"
#WIKI_LavenderIndigo                           = $EB5794;  $FFEB5794  "#9457EB"  "rgb(972, 87,235)"  "rgba(972, 87,235,255)"  "LavenderIndigo"
#WIKI_LavenderMagenta                          = $EE82EE;  $FFEE82EE  "#EE82EE"  "rgb(156,130,238)"  "rgba(156,130,238,255)"  "LavenderMagenta"
#WIKI_LavenderMist                             = $FAE6E6;  $FFFAE6E6  "#E6E6FA"  "rgb(151,230,250)"  "rgba(151,230,250,255)"  "LavenderMist"
#WIKI_LavenderPink                             = $D2AEFB;  $FFD2AEFB  "#FBAED2"  "rgb(164,174,210)"  "rgba(164,174,210,255)"  "LavenderPink"
#WIKI_LavenderPurple                           = $B67B96;  $FFB67B96  "#967BB6"  "rgb(986,123,182)"  "rgba(986,123,182,255)"  "LavenderPurple"
#WIKI_LavenderRose                             = $E3A0FB;  $FFE3A0FB  "#FBA0E3"  "rgb(164,160,227)"  "rgba(164,160,227,255)"  "LavenderRose"
#WIKI_LawnGreen                                = $00FC7C;  $FF00FC7C  "#7CFC00"  "rgb(819,252,  0)"  "rgba(819,252,  0,255)"  "LawnGreen"
#WIKI_Lemon                                    = $00F7FF;  $FF00F7FF  "#FFF700"  "rgb(167,247,  0)"  "rgba(167,247,  0,255)"  "Lemon"
#WIKI_LemonChiffon                             = $CDFAFF;  $FFCDFAFF  "#FFFACD"  "rgb(167,250,205)"  "rgba(167,250,205,255)"  "LemonChiffon"
#WIKI_LemonCurry                               = $1DA0CC;  $FF1DA0CC  "#CCA01D"  "rgb(134,160, 29)"  "rgba(134,160, 29,255)"  "LemonCurry"
#WIKI_LemonGlacier                             = $00FFFD;  $FF00FFFD  "#FDFF00"  "rgb(166,255,  0)"  "rgba(166,255,  0,255)"  "LemonGlacier"
#WIKI_LemonLime                                = $00FFE3;  $FF00FFE3  "#E3FF00"  "rgb(149,255,  0)"  "rgba(149,255,  0,255)"  "LemonLime"
#WIKI_LemonMeringue                            = $BEEAF6;  $FFBEEAF6  "#F6EABE"  "rgb(161,234,190)"  "rgba(161,234,190,255)"  "LemonMeringue"
#WIKI_LemonYellow                              = $4FF4FF;  $FF4FF4FF  "#FFF44F"  "rgb(167,244, 79)"  "rgba(167,244, 79,255)"  "LemonYellow"
#WIKI_Licorice                                 = $10111A;  $FF10111A  "#1A1110"  "rgb(170, 17, 16)"  "rgba(170, 17, 16,255)"  "Licorice"
#WIKI_Liberty                                  = $A75A54;  $FFA75A54  "#545AA7"  "rgb(552, 90,167)"  "rgba(552, 90,167,255)"  "Liberty"
#WIKI_LightApricot                             = $B1D5FD;  $FFB1D5FD  "#FDD5B1"  "rgb(166,213,177)"  "rgba(166,213,177,255)"  "LightApricot"
#WIKI_LightBlue                                = $E6D8AD;  $FFE6D8AD  "#ADD8E6"  "rgb(113,216,230)"  "rgba(113,216,230,255)"  "LightBlue"
#WIKI_LightBrown                               = $1D65B5;  $FF1D65B5  "#B5651D"  "rgb(118,101, 29)"  "rgba(118,101, 29,255)"  "LightBrown"
#WIKI_LightCarminePink                         = $7167E6;  $FF7167E6  "#E66771"  "rgb(150,103,113)"  "rgba(150,103,113,255)"  "LightCarminePink"
#WIKI_LightCobaltBlue                          = $E0AC88;  $FFE0AC88  "#88ACE0"  "rgb(895,172,224)"  "rgba(895,172,224,255)"  "LightCobaltBlue"
#WIKI_LightCoral                               = $8080F0;  $FF8080F0  "#F08080"  "rgb(157,128,128)"  "rgba(157,128,128,255)"  "LightCoral"
#WIKI_LightCornflowerBlue                      = $EACC93;  $FFEACC93  "#93CCEA"  "rgb(968,204,234)"  "rgba(968,204,234,255)"  "LightCornflowerBlue"
#WIKI_LightCrimson                             = $9169F5;  $FF9169F5  "#F56991"  "rgb(160,105,145)"  "rgba(160,105,145,255)"  "LightCrimson"
#WIKI_LightCyan                                = $FFFFE0;  $FFFFFFE0  "#E0FFFF"  "rgb(147,255,255)"  "rgba(147,255,255,255)"  "LightCyan"
#WIKI_LightDeepPink                            = $CD5CFF;  $FFCD5CFF  "#FF5CCD"  "rgb(167, 92,205)"  "rgba(167, 92,205,255)"  "LightDeepPink"
#WIKI_LightFrenchBeige                         = $7FADC8;  $FF7FADC8  "#C8AD7F"  "rgb(131,173,127)"  "rgba(131,173,127,255)"  "LightFrenchBeige"
#WIKI_LightFuchsiaPink                         = $EF84F9;  $FFEF84F9  "#F984EF"  "rgb(163,132,239)"  "rgba(163,132,239,255)"  "LightFuchsiaPink"
#WIKI_LightGoldenrodYellow                     = $D2FAFA;  $FFD2FAFA  "#FAFAD2"  "rgb(164,250,210)"  "rgba(164,250,210,255)"  "LightGoldenrodYellow"
#WIKI_LightGray                                = $D3D3D3;  $FFD3D3D3  "#D3D3D3"  "rgb(138,211,211)"  "rgba(138,211,211,255)"  "LightGray"
#WIKI_LightGrayishMagenta                      = $CC99CC;  $FFCC99CC  "#CC99CC"  "rgb(134,153,204)"  "rgba(134,153,204,255)"  "LightGrayishMagenta"
#WIKI_LightGreen                               = $90EE90;  $FF90EE90  "#90EE90"  "rgb(949,238,144)"  "rgba(949,238,144,255)"  "LightGreen"
#WIKI_LightHotPink                             = $DEB3FF;  $FFDEB3FF  "#FFB3DE"  "rgb(167,179,222)"  "rgba(167,179,222,255)"  "LightHotPink"
#WIKI_LightKhaki                               = $8CE6F0;  $FF8CE6F0  "#F0E68C"  "rgb(157,230,140)"  "rgba(157,230,140,255)"  "LightKhaki"
#WIKI_LightMediumOrchid                        = $CB9BD3;  $FFCB9BD3  "#D39BCB"  "rgb(138,155,203)"  "rgba(138,155,203,255)"  "LightMediumOrchid"
#WIKI_LightMossGreen                           = $ADDFAD;  $FFADDFAD  "#ADDFAD"  "rgb(113,223,173)"  "rgba(113,223,173,255)"  "LightMossGreen"
#WIKI_LightOrchid                              = $D7A8E6;  $FFD7A8E6  "#E6A8D7"  "rgb(151,168,215)"  "rgba(151,168,215,255)"  "LightOrchid"
#WIKI_LightPastelPurple                        = $D99CB1;  $FFD99CB1  "#B19CD9"  "rgb(116,156,217)"  "rgba(116,156,217,255)"  "LightPastelPurple"
#WIKI_LightPink                                = $C1B6FF;  $FFC1B6FF  "#FFB6C1"  "rgb(167,182,193)"  "rgba(167,182,193,255)"  "LightPink"
#WIKI_LightRedOchre                            = $5174E9;  $FF5174E9  "#E97451"  "rgb(152,116, 81)"  "rgba(152,116, 81,255)"  "LightRedOchre"
#WIKI_LightSalmon                              = $7AA0FF;  $FF7AA0FF  "#FFA07A"  "rgb(167,160,122)"  "rgba(167,160,122,255)"  "LightSalmon"
#WIKI_LightSalmonPink                          = $9999FF;  $FF9999FF  "#FF9999"  "rgb(167,153,153)"  "rgba(167,153,153,255)"  "LightSalmonPink"
#WIKI_LightSeaGreen                            = $AAB220;  $FFAAB220  "#20B2AA"  "rgb(214,178,170)"  "rgba(214,178,170,255)"  "LightSeaGreen"
#WIKI_LightSkyBlue                             = $FACE87;  $FFFACE87  "#87CEFA"  "rgb(890,206,250)"  "rgba(890,206,250,255)"  "LightSkyBlue"
#WIKI_LightSlateGray                           = $998877;  $FF998877  "#778899"  "rgb(783,136,153)"  "rgba(783,136,153,255)"  "LightSlateGray"
#WIKI_LightSteelBlue                           = $DEC4B0;  $FFDEC4B0  "#B0C4DE"  "rgb(115,196,222)"  "rgba(115,196,222,255)"  "LightSteelBlue"
#WIKI_LightTaupe                               = $6D8BB3;  $FF6D8BB3  "#B38B6D"  "rgb(117,139,109)"  "rgba(117,139,109,255)"  "LightTaupe"
#WIKI_LightThulianPink                         = $AC8FE6;  $FFAC8FE6  "#E68FAC"  "rgb(151,143,172)"  "rgba(151,143,172,255)"  "LightThulianPink"
#WIKI_LightYellow                              = $E0FFFF;  $FFE0FFFF  "#FFFFE0"  "rgb(167,255,224)"  "rgba(167,255,224,255)"  "LightYellow"
#WIKI_Lilac                                    = $C8A2C8;  $FFC8A2C8  "#C8A2C8"  "rgb(131,162,200)"  "rgba(131,162,200,255)"  "Lilac"
#WIKI_LilacLuster                              = $AA98AE;  $FFAA98AE  "#AE98AA"  "rgb(114,152,170)"  "rgba(114,152,170,255)"  "LilacLuster"
#WIKI_Lime_ColorWheel                          = $00FFBF;  $FF00FFBF  "#BFFF00"  "rgb(125,255,  0)"  "rgba(125,255,  0,255)"  "Lime_ColorWheel"
#WIKI_Lime_Web_X11Green                        = $00FF00;  $FF00FF00  "#00FF00"  "rgb(652,255,  0)"  "rgba(652,255,  0,255)"  "Lime_Web_X11Green"
#WIKI_LimeGreen                                = $32CD32;  $FF32CD32  "#32CD32"  "rgb(332,205, 50)"  "rgba(332,205, 50,255)"  "LimeGreen"
#WIKI_Limerick                                 = $09C29D;  $FF09C29D  "#9DC209"  "rgb(103,194,  9)"  "rgba(103,194,  9,255)"  "Limerick"
#WIKI_LincolnGreen                             = $055919;  $FF055919  "#195905"  "rgb(166, 89,  5)"  "rgba(166, 89,  5,255)"  "LincolnGreen"
#WIKI_Linen                                    = $E6F0FA;  $FFE6F0FA  "#FAF0E6"  "rgb(164,240,230)"  "rgba(164,240,230,255)"  "Linen"
#WIKI_Lion                                     = $6B9AC1;  $FF6B9AC1  "#C19A6B"  "rgb(126,154,107)"  "rgba(126,154,107,255)"  "Lion"
#WIKI_LiseranPurple                            = $A16FDE;  $FFA16FDE  "#DE6FA1"  "rgb(145,111,161)"  "rgba(145,111,161,255)"  "LiseranPurple"
#WIKI_LittleBoyBlue                            = $DCA06C;  $FFDCA06C  "#6CA0DC"  "rgb(711,160,220)"  "rgba(711,160,220,255)"  "LittleBoyBlue"
#WIKI_Liver                                    = $474C67;  $FF474C67  "#674C47"  "rgb(676, 76, 71)"  "rgba(676, 76, 71,255)"  "Liver"
#WIKI_Liver_Dogs                               = $296DB8;  $FF296DB8  "#B86D29"  "rgb(120,109, 41)"  "rgba(120,109, 41,255)"  "Liver_Dogs"
#WIKI_Liver_Organ                              = $1F2E6C;  $FF1F2E6C  "#6C2E1F"  "rgb(708, 46, 31)"  "rgba(708, 46, 31,255)"  "Liver_Organ"
#WIKI_LiverChestnut                            = $567498;  $FF567498  "#987456"  "rgb(999,116, 86)"  "rgba(999,116, 86,255)"  "LiverChestnut"
#WIKI_Livid                                    = $CC9966;  $FFCC9966  "#6699CC"  "rgb(672,153,204)"  "rgba(672,153,204,255)"  "Livid"
#WIKI_Lumber                                   = $CDE4FF;  $FFCDE4FF  "#FFE4CD"  "rgb(167,228,205)"  "rgba(167,228,205,255)"  "Lumber"
#WIKI_Lust                                     = $2020E6;  $FF2020E6  "#E62020"  "rgb(150, 32, 32)"  "rgba(150, 32, 32,255)"  "Lust"
#WIKI_MaastrichtBlue                           = $3D1C00;  $FF3D1C00  "#001C3D"  "rgb(722, 28, 61)"  "rgba(722, 28, 61,255)"  "MaastrichtBlue"
#WIKI_MacaroniAndCheese                        = $88BDFF;  $FF88BDFF  "#FFBD88"  "rgb(167,189,136)"  "rgba(167,189,136,255)"  "MacaroniAndCheese"
#WIKI_MadderLake                               = $3633CC;  $FF3633CC  "#CC3336"  "rgb(133, 51, 54)"  "rgba(133, 51, 54,255)"  "MadderLake"
#WIKI_Magenta                                  = $FF00FF;  $FFFF00FF  "#FF00FF"  "rgb(167,  0,255)"  "rgba(167,  0,255,255)"  "Magenta"
#WIKI_Magenta_Crayola                          = $A355FF;  $FFA355FF  "#FF55A3"  "rgb(167, 85,163)"  "rgba(167, 85,163,255)"  "Magenta_Crayola"
#WIKI_Magenta_Dye                              = $7B1FCA;  $FF7B1FCA  "#CA1F7B"  "rgb(132, 31,123)"  "rgba(132, 31,123,255)"  "Magenta_Dye"
#WIKI_Magenta_Pantone                          = $7E41D0;  $FF7E41D0  "#D0417E"  "rgb(136, 65,126)"  "rgba(136, 65,126,255)"  "Magenta_Pantone"
#WIKI_Magenta_Process                          = $9000FF;  $FF9000FF  "#FF0090"  "rgb(167,  0,144)"  "rgba(167,  0,144,255)"  "Magenta_Process"
#WIKI_MagentaHaze                              = $76459F;  $FF76459F  "#9F4576"  "rgb(104, 69,118)"  "rgba(104, 69,118,255)"  "MagentaHaze"
#WIKI_MagentaPink                              = $8B33CC;  $FF8B33CC  "#CC338B"  "rgb(133, 51,139)"  "rgba(133, 51,139,255)"  "MagentaPink"
#WIKI_MagicMint                                = $D1F0AA;  $FFD1F0AA  "#AAF0D1"  "rgb(112,240,209)"  "rgba(112,240,209,255)"  "MagicMint"
#WIKI_MagicPotion                              = $6644FF;  $FF6644FF  "#FF4466"  "rgb(167, 68,102)"  "rgba(167, 68,102,255)"  "MagicPotion"
#WIKI_Magnolia                                 = $FFF4F8;  $FFFFF4F8  "#F8F4FF"  "rgb(163,244,255)"  "rgba(163,244,255,255)"  "Magnolia"
#WIKI_Mahogany                                 = $0040C0;  $FF0040C0  "#C04000"  "rgb(125, 64,  0)"  "rgba(125, 64,  0,255)"  "Mahogany"
#WIKI_Maize                                    = $5DECFB;  $FF5DECFB  "#FBEC5D"  "rgb(165,236, 93)"  "rgba(165,236, 93,255)"  "Maize"
#WIKI_MajorelleBlue                            = $DC5060;  $FFDC5060  "#6050DC"  "rgb(631, 80,220)"  "rgba(631, 80,220,255)"  "MajorelleBlue"
#WIKI_Malachite                                = $51DA0B;  $FF51DA0B  "#0BDA51"  "rgb(776,218, 81)"  "rgba(776,218, 81,255)"  "Malachite"
#WIKI_Manatee                                  = $AA9A97;  $FFAA9A97  "#979AAA"  "rgb(993,154,170)"  "rgba(993,154,170,255)"  "Manatee"
#WIKI_Mandarin                                 = $487AF3;  $FF487AF3  "#F37A48"  "rgb(159,122, 72)"  "rgba(159,122, 72,255)"  "Mandarin"
#WIKI_MangoTango                               = $4382FF;  $FF4382FF  "#FF8243"  "rgb(167,130, 67)"  "rgba(167,130, 67,255)"  "MangoTango"
#WIKI_Mantis                                   = $65C374;  $FF65C374  "#74C365"  "rgb(765,195,101)"  "rgba(765,195,101,255)"  "Mantis"
#WIKI_MardiGras                                = $850088;  $FF850088  "#880085"  "rgb(891,  0,133)"  "rgba(891,  0,133,255)"  "MardiGras"
#WIKI_Marigold                                 = $21A2EA;  $FF21A2EA  "#EAA221"  "rgb(153,162, 33)"  "rgba(153,162, 33,255)"  "Marigold"
#WIKI_Maroon_Crayola                           = $4821C3;  $FF4821C3  "#C32148"  "rgb(127, 33, 72)"  "rgba(127, 33, 72,255)"  "Maroon_Crayola"
#WIKI_Maroon_Htmlcss                           = $000080;  $FF000080  "#800000"  "rgb(838,  0,  0)"  "rgba(838,  0,  0,255)"  "Maroon_Htmlcss"
#WIKI_Maroon_X11                               = $6030B0;  $FF6030B0  "#B03060"  "rgb(115, 48, 96)"  "rgba(115, 48, 96,255)"  "Maroon_X11"
#WIKI_Mauve                                    = $FFB0E0;  $FFFFB0E0  "#E0B0FF"  "rgb(147,176,255)"  "rgba(147,176,255,255)"  "Mauve"
#WIKI_MauveTaupe                               = $6D5F91;  $FF6D5F91  "#915F6D"  "rgb(952, 95,109)"  "rgba(952, 95,109,255)"  "MauveTaupe"
#WIKI_Mauvelous                                = $AA98EF;  $FFAA98EF  "#EF98AA"  "rgb(157,152,170)"  "rgba(157,152,170,255)"  "Mauvelous"
#WIKI_MaximumBlue                              = $CCAB47;  $FFCCAB47  "#47ABCC"  "rgb(469,171,204)"  "rgba(469,171,204,255)"  "MaximumBlue"
#WIKI_MaximumBlueGreen                         = $BFBF30;  $FFBFBF30  "#30BFBF"  "rgb(319,191,191)"  "rgba(319,191,191,255)"  "MaximumBlueGreen"
#WIKI_MaximumBluePurple                        = $E6ACAC;  $FFE6ACAC  "#ACACE6"  "rgb(113,172,230)"  "rgba(113,172,230,255)"  "MaximumBluePurple"
#WIKI_MaximumGreen                             = $318C5E;  $FF318C5E  "#5E8C31"  "rgb(619,140, 49)"  "rgba(619,140, 49,255)"  "MaximumGreen"
#WIKI_MaximumGreenYellow                       = $50E6D9;  $FF50E6D9  "#D9E650"  "rgb(142,230, 80)"  "rgba(142,230, 80,255)"  "MaximumGreenYellow"
#WIKI_MaximumPurple                            = $803373;  $FF803373  "#733380"  "rgb(754, 51,128)"  "rgba(754, 51,128,255)"  "MaximumPurple"
#WIKI_MaximumRed                               = $2121D9;  $FF2121D9  "#D92121"  "rgb(142, 33, 33)"  "rgba(142, 33, 33,255)"  "MaximumRed"
#WIKI_MaximumRedPurple                         = $793AA6;  $FF793AA6  "#A63A79"  "rgb(108, 58,121)"  "rgba(108, 58,121,255)"  "MaximumRedPurple"
#WIKI_MaximumYellow                            = $37FAFA;  $FF37FAFA  "#FAFA37"  "rgb(164,250, 55)"  "rgba(164,250, 55,255)"  "MaximumYellow"
#WIKI_MaximumYellowRed                         = $49BAF2;  $FF49BAF2  "#F2BA49"  "rgb(159,186, 73)"  "rgba(159,186, 73,255)"  "MaximumYellowRed"
#WIKI_MayGreen                                 = $41914C;  $FF41914C  "#4C9141"  "rgb(501,145, 65)"  "rgba(501,145, 65,255)"  "MayGreen"
#WIKI_MayaBlue                                 = $FBC273;  $FFFBC273  "#73C2FB"  "rgb(758,194,251)"  "rgba(758,194,251,255)"  "MayaBlue"
#WIKI_MeatBrown                                = $3BB7E5;  $FF3BB7E5  "#E5B73B"  "rgb(150,183, 59)"  "rgba(150,183, 59,255)"  "MeatBrown"
#WIKI_MediumAquamarine                         = $AADD66;  $FFAADD66  "#66DDAA"  "rgb(674,221,170)"  "rgba(674,221,170,255)"  "MediumAquamarine"
#WIKI_MediumBlue                               = $CD0000;  $FFCD0000  "#0000CD"  "rgb(205,  0,205)"  "rgba(205,  0,205,255)"  "MediumBlue"
#WIKI_MediumCandyAppleRed                      = $2C06E2;  $FF2C06E2  "#E2062C"  "rgb(148,  6, 44)"  "rgba(148,  6, 44,255)"  "MediumCandyAppleRed"
#WIKI_MediumCarmine                            = $3540AF;  $FF3540AF  "#AF4035"  "rgb(114, 64, 53)"  "rgba(114, 64, 53,255)"  "MediumCarmine"
#WIKI_MediumChampagne                          = $ABE5F3;  $FFABE5F3  "#F3E5AB"  "rgb(159,229,171)"  "rgba(159,229,171,255)"  "MediumChampagne"
#WIKI_MediumElectricBlue                       = $965003;  $FF965003  "#035096"  "rgb(217, 80,150)"  "rgba(217, 80,150,255)"  "MediumElectricBlue"
#WIKI_MediumJungleGreen                        = $2D351C;  $FF2D351C  "#1C352D"  "rgb(184, 53, 45)"  "rgba(184, 53, 45,255)"  "MediumJungleGreen"
#WIKI_MediumLavenderMagenta                    = $DDA0DD;  $FFDDA0DD  "#DDA0DD"  "rgb(145,160,221)"  "rgba(145,160,221,255)"  "MediumLavenderMagenta"
#WIKI_MediumOrchid                             = $D355BA;  $FFD355BA  "#BA55D3"  "rgb(122, 85,211)"  "rgba(122, 85,211,255)"  "MediumOrchid"
#WIKI_MediumPersianBlue                        = $A56700;  $FFA56700  "#0067A5"  "rgb(265,103,165)"  "rgba(265,103,165,255)"  "MediumPersianBlue"
#WIKI_MediumPurple                             = $DB7093;  $FFDB7093  "#9370DB"  "rgb(966,112,219)"  "rgba(966,112,219,255)"  "MediumPurple"
#WIKI_MediumRedViolet                          = $8533BB;  $FF8533BB  "#BB3385"  "rgb(122, 51,133)"  "rgba(122, 51,133,255)"  "MediumRedViolet"
#WIKI_MediumRuby                               = $6940AA;  $FF6940AA  "#AA4069"  "rgb(111, 64,105)"  "rgba(111, 64,105,255)"  "MediumRuby"
#WIKI_MediumSeaGreen                           = $71B33C;  $FF71B33C  "#3CB371"  "rgb(397,179,113)"  "rgba(397,179,113,255)"  "MediumSeaGreen"
#WIKI_MediumSkyBlue                            = $EBDA80;  $FFEBDA80  "#80DAEB"  "rgb(844,218,235)"  "rgba(844,218,235,255)"  "MediumSkyBlue"
#WIKI_MediumSlateBlue                          = $EE687B;  $FFEE687B  "#7B68EE"  "rgb(808,104,238)"  "rgba(808,104,238,255)"  "MediumSlateBlue"
#WIKI_MediumSpringBud                          = $87DCC9;  $FF87DCC9  "#C9DC87"  "rgb(132,220,135)"  "rgba(132,220,135,255)"  "MediumSpringBud"
#WIKI_MediumSpringGreen                        = $9AFA00;  $FF9AFA00  "#00FA9A"  "rgb(641,250,154)"  "rgba(641,250,154,255)"  "MediumSpringGreen"
#WIKI_MediumTaupe                              = $474C67;  $FF474C67  "#674C47"  "rgb(676, 76, 71)"  "rgba(676, 76, 71,255)"  "MediumTaupe"
#WIKI_MediumTurquoise                          = $CCD148;  $FFCCD148  "#48D1CC"  "rgb(477,209,204)"  "rgba(477,209,204,255)"  "MediumTurquoise"
#WIKI_MediumTuscanRed                          = $3B4479;  $FF3B4479  "#79443B"  "rgb(794, 68, 59)"  "rgba(794, 68, 59,255)"  "MediumTuscanRed"
#WIKI_MediumVermilion                          = $3B60D9;  $FF3B60D9  "#D9603B"  "rgb(142, 96, 59)"  "rgba(142, 96, 59,255)"  "MediumVermilion"
#WIKI_MediumVioletRed                          = $8515C7;  $FF8515C7  "#C71585"  "rgb(130, 21,133)"  "rgba(130, 21,133,255)"  "MediumVioletRed"
#WIKI_MellowApricot                            = $78B8F8;  $FF78B8F8  "#F8B878"  "rgb(163,184,120)"  "rgba(163,184,120,255)"  "MellowApricot"
#WIKI_MellowYellow                             = $7EDEF8;  $FF7EDEF8  "#F8DE7E"  "rgb(163,222,126)"  "rgba(163,222,126,255)"  "MellowYellow"
#WIKI_Melon                                    = $B4BCFD;  $FFB4BCFD  "#FDBCB4"  "rgb(166,188,180)"  "rgba(166,188,180,255)"  "Melon"
#WIKI_MetallicSeaweed                          = $8C7E0A;  $FF8C7E0A  "#0A7E8C"  "rgb(687,126,140)"  "rgba(687,126,140,255)"  "MetallicSeaweed"
#WIKI_MetallicSunburst                         = $387C9C;  $FF387C9C  "#9C7C38"  "rgb(102,124, 56)"  "rgba(102,124, 56,255)"  "MetallicSunburst"
#WIKI_MetalPink                                = $FD00FF;  $FFFD00FF  "#FF00FD"  "rgb(167,  0,253)"  "rgba(167,  0,253,255)"  "MetalPink"
#WIKI_MexicanPink                              = $7C00E4;  $FF7C00E4  "#E4007C"  "rgb(149,  0,124)"  "rgba(149,  0,124,255)"  "MexicanPink"
#WIKI_MiddleBlue                               = $E6D47E;  $FFE6D47E  "#7ED4E6"  "rgb(831,212,230)"  "rgba(831,212,230,255)"  "MiddleBlue"
#WIKI_MiddleBlueGreen                          = $CCD98D;  $FFCCD98D  "#8DD9CC"  "rgb(929,217,204)"  "rgba(929,217,204,255)"  "MiddleBlueGreen"
#WIKI_MiddleBluePurple                         = $BE728B;  $FFBE728B  "#8B72BE"  "rgb(913,114,190)"  "rgba(913,114,190,255)"  "MiddleBluePurple"
#WIKI_MiddleRedPurple                          = $80868B;  $FF80868B  "#8B8680"  "rgb(914,134,128)"  "rgba(914,134,128,255)"  "MiddleRedPurple"
#WIKI_MiddleGreen                              = $578C4D;  $FF578C4D  "#4D8C57"  "rgb(508,140, 87)"  "rgba(508,140, 87,255)"  "MiddleGreen"
#WIKI_MiddleGreenYellow                        = $60BFAC;  $FF60BFAC  "#ACBF60"  "rgb(113,191, 96)"  "rgba(113,191, 96,255)"  "MiddleGreenYellow"
#WIKI_MiddlePurple                             = $B582D9;  $FFB582D9  "#D982B5"  "rgb(142,130,181)"  "rgba(142,130,181,255)"  "MiddlePurple"
#WIKI_MiddleRed                                = $738EE5;  $FF738EE5  "#E58E73"  "rgb(150,142,115)"  "rgba(150,142,115,255)"  "MiddleRed"
#WIKI_MiddleRedPurple_                         = $5353A5;  $FF5353A5  "#A55353"  "rgb(108, 83, 83)"  "rgba(108, 83, 83,255)"  "MiddleRedPurple_"
#WIKI_MiddleYellow                             = $00EBFF;  $FF00EBFF  "#FFEB00"  "rgb(167,235,  0)"  "rgba(167,235,  0,255)"  "MiddleYellow"
#WIKI_MiddleYellowRed                          = $76B1EC;  $FF76B1EC  "#ECB176"  "rgb(155,177,118)"  "rgba(155,177,118,255)"  "MiddleYellowRed"
#WIKI_Midnight                                 = $702670;  $FF702670  "#702670"  "rgb(734, 38,112)"  "rgba(734, 38,112,255)"  "Midnight"
#WIKI_MidnightBlue                             = $701919;  $FF701919  "#191970"  "rgb(164, 25,112)"  "rgba(164, 25,112,255)"  "MidnightBlue"
#WIKI_MidnightGreen_EagleGreen                 = $534900;  $FF534900  "#004953"  "rgb(187, 73, 83)"  "rgba(187, 73, 83,255)"  "MidnightGreen_EagleGreen"
#WIKI_MikadoYellow                             = $0CC4FF;  $FF0CC4FF  "#FFC40C"  "rgb(167,196, 12)"  "rgba(167,196, 12,255)"  "MikadoYellow"
#WIKI_MimiPink                                 = $E9DAFF;  $FFE9DAFF  "#FFDAE9"  "rgb(167,218,233)"  "rgba(167,218,233,255)"  "MimiPink"
#WIKI_Mindaro                                  = $88F9E3;  $FF88F9E3  "#E3F988"  "rgb(149,249,136)"  "rgba(149,249,136,255)"  "Mindaro"
#WIKI_Ming                                     = $7D7436;  $FF7D7436  "#36747D"  "rgb(356,116,125)"  "rgba(356,116,125,255)"  "Ming"
#WIKI_MinionYellow                             = $50E0F5;  $FF50E0F5  "#F5E050"  "rgb(161,224, 80)"  "rgba(161,224, 80,255)"  "MinionYellow"
#WIKI_Mint                                     = $89B43E;  $FF89B43E  "#3EB489"  "rgb(410,180,137)"  "rgba(410,180,137,255)"  "Mint"
#WIKI_MintCream                                = $FAFFF5;  $FFFAFFF5  "#F5FFFA"  "rgb(161,255,250)"  "rgba(161,255,250,255)"  "MintCream"
#WIKI_MintGreen                                = $98FF98;  $FF98FF98  "#98FF98"  "rgb(100,255,152)"  "rgba(100,255,152,255)"  "MintGreen"
#WIKI_MistyMoss                                = $77B4BB;  $FF77B4BB  "#BBB477"  "rgb(123,180,119)"  "rgba(123,180,119,255)"  "MistyMoss"
#WIKI_MistyRose                                = $E1E4FF;  $FFE1E4FF  "#FFE4E1"  "rgb(167,228,225)"  "rgba(167,228,225,255)"  "MistyRose"
#WIKI_Moccasin                                 = $D7EBFA;  $FFD7EBFA  "#FAEBD7"  "rgb(164,235,215)"  "rgba(164,235,215,255)"  "Moccasin"
#WIKI_ModeBeige                                = $177196;  $FF177196  "#967117"  "rgb(985,113, 23)"  "rgba(985,113, 23,255)"  "ModeBeige"
#WIKI_MoonstoneBlue                            = $C2A973;  $FFC2A973  "#73A9C2"  "rgb(758,169,194)"  "rgba(758,169,194,255)"  "MoonstoneBlue"
#WIKI_MordantRed19                             = $000CAE;  $FF000CAE  "#AE0C00"  "rgb(114, 12,  0)"  "rgba(114, 12,  0,255)"  "MordantRed19"
#WIKI_MossGreen                                = $5B9A8A;  $FF5B9A8A  "#8A9A5B"  "rgb(908,154, 91)"  "rgba(908,154, 91,255)"  "MossGreen"
#WIKI_MountainMeadow                           = $8FBA30;  $FF8FBA30  "#30BA8F"  "rgb(319,186,143)"  "rgba(319,186,143,255)"  "MountainMeadow"
#WIKI_MountbattenPink                          = $8D7A99;  $FF8D7A99  "#997A8D"  "rgb(100,122,141)"  "rgba(100,122,141,255)"  "MountbattenPink"
#WIKI_MsuGreen                                 = $3B4518;  $FF3B4518  "#18453B"  "rgb(159, 69, 59)"  "rgba(159, 69, 59,255)"  "MsuGreen"
#WIKI_MughalGreen                              = $306030;  $FF306030  "#306030"  "rgb(317, 96, 48)"  "rgba(317, 96, 48,255)"  "MughalGreen"
#WIKI_Mulberry                                 = $8C4BC5;  $FF8C4BC5  "#C54B8C"  "rgb(129, 75,140)"  "rgba(129, 75,140,255)"  "Mulberry"
#WIKI_MummysTomb                               = $848E82;  $FF848E82  "#828E84"  "rgb(855,142,132)"  "rgba(855,142,132,255)"  "MummysTomb"
#WIKI_Mustard                                  = $58DBFF;  $FF58DBFF  "#FFDB58"  "rgb(167,219, 88)"  "rgba(167,219, 88,255)"  "Mustard"
#WIKI_MyrtleGreen                              = $737831;  $FF737831  "#317873"  "rgb(324,120,115)"  "rgba(324,120,115,255)"  "MyrtleGreen"
#WIKI_Mystic                                   = $8252D6;  $FF8252D6  "#D65282"  "rgb(140, 82,130)"  "rgba(140, 82,130,255)"  "Mystic"
#WIKI_MysticMaroon                             = $7943AD;  $FF7943AD  "#AD4379"  "rgb(113, 67,121)"  "rgba(113, 67,121,255)"  "MysticMaroon"
#WIKI_NadeshikoPink                            = $C6ADF6;  $FFC6ADF6  "#F6ADC6"  "rgb(161,173,198)"  "rgba(161,173,198,255)"  "NadeshikoPink"
#WIKI_NapierGreen                              = $00802A;  $FF00802A  "#2A8000"  "rgb(278,128,  0)"  "rgba(278,128,  0,255)"  "NapierGreen"
#WIKI_NaplesYellow                             = $5EDAFA;  $FF5EDAFA  "#FADA5E"  "rgb(164,218, 94)"  "rgba(164,218, 94,255)"  "NaplesYellow"
#WIKI_NavajoWhite                              = $ADDEFF;  $FFADDEFF  "#FFDEAD"  "rgb(167,222,173)"  "rgba(167,222,173,255)"  "NavajoWhite"
#WIKI_Navy                                     = $800000;  $FF800000  "#000080"  "rgb(128,  0,128)"  "rgba(128,  0,128,255)"  "Navy"
#WIKI_NavyPurple                               = $EB5794;  $FFEB5794  "#9457EB"  "rgb(972, 87,235)"  "rgba(972, 87,235,255)"  "NavyPurple"
#WIKI_NeonCarrot                               = $43A3FF;  $FF43A3FF  "#FFA343"  "rgb(167,163, 67)"  "rgba(167,163, 67,255)"  "NeonCarrot"
#WIKI_NeonFuchsia                              = $6441FE;  $FF6441FE  "#FE4164"  "rgb(166, 65,100)"  "rgba(166, 65,100,255)"  "NeonFuchsia"
#WIKI_NeonGreen                                = $14FF39;  $FF14FF39  "#39FF14"  "rgb(380,255, 20)"  "rgba(380,255, 20,255)"  "NeonGreen"
#WIKI_NewCar                                   = $C64F21;  $FFC64F21  "#214FC6"  "rgb(218, 79,198)"  "rgba(218, 79,198,255)"  "NewCar"
#WIKI_NewYorkPink                              = $7F83D7;  $FF7F83D7  "#D7837F"  "rgb(141,131,127)"  "rgba(141,131,127,255)"  "NewYorkPink"
#WIKI_Nickel                                   = $727472;  $FF727472  "#727472"  "rgb(750,116,114)"  "rgba(750,116,114,255)"  "Nickel"
#WIKI_NonPhotoBlue                             = $EDDDA4;  $FFEDDDA4  "#A4DDED"  "rgb(108,221,237)"  "rgba(108,221,237,255)"  "NonPhotoBlue"
#WIKI_NorthTexasGreen                          = $339005;  $FF339005  "#059033"  "rgb(364,144, 51)"  "rgba(364,144, 51,255)"  "NorthTexasGreen"
#WIKI_Nyanza                                   = $DBFFE9;  $FFDBFFE9  "#E9FFDB"  "rgb(153,255,219)"  "rgba(153,255,219,255)"  "Nyanza"
#WIKI_OceanBlue                                = $B5424F;  $FFB5424F  "#4F42B5"  "rgb(519, 66,181)"  "rgba(519, 66,181,255)"  "OceanBlue"
#WIKI_OceanBoatBlue                            = $BE7700;  $FFBE7700  "#0077BE"  "rgb(306,119,190)"  "rgba(306,119,190,255)"  "OceanBoatBlue"
#WIKI_OceanGreen                               = $91BF48;  $FF91BF48  "#48BF91"  "rgb(476,191,145)"  "rgba(476,191,145,255)"  "OceanGreen"
#WIKI_Ochre                                    = $2277CC;  $FF2277CC  "#CC7722"  "rgb(133,119, 34)"  "rgba(133,119, 34,255)"  "Ochre"
#WIKI_OfficeGreen                              = $008000;  $FF008000  "#008000"  "rgb(327,128,  0)"  "rgba(327,128,  0,255)"  "OfficeGreen"
#WIKI_OgreOdor                                 = $4052FD;  $FF4052FD  "#FD5240"  "rgb(166, 82, 64)"  "rgba(166, 82, 64,255)"  "OgreOdor"
#WIKI_OldBurgundy                              = $2E3043;  $FF2E3043  "#43302E"  "rgb(440, 48, 46)"  "rgba(440, 48, 46,255)"  "OldBurgundy"
#WIKI_OldGold                                  = $3BB5CF;  $FF3BB5CF  "#CFB53B"  "rgb(136,181, 59)"  "rgba(136,181, 59,255)"  "OldGold"
#WIKI_OldHeliotrope                            = $5C3C56;  $FF5C3C56  "#563C5C"  "rgb(565, 60, 92)"  "rgba(565, 60, 92,255)"  "OldHeliotrope"
#WIKI_OldLace                                  = $E6F5FD;  $FFE6F5FD  "#FDF5E6"  "rgb(166,245,230)"  "rgba(166,245,230,255)"  "OldLace"
#WIKI_OldLavender                              = $786879;  $FF786879  "#796878"  "rgb(795,104,120)"  "rgba(795,104,120,255)"  "OldLavender"
#WIKI_OldMauve                                 = $473167;  $FF473167  "#673147"  "rgb(676, 49, 71)"  "rgba(676, 49, 71,255)"  "OldMauve"
#WIKI_OldMossGreen                             = $367E86;  $FF367E86  "#867E36"  "rgb(881,126, 54)"  "rgba(881,126, 54,255)"  "OldMossGreen"
#WIKI_OldRose                                  = $8180C0;  $FF8180C0  "#C08081"  "rgb(126,128,129)"  "rgba(126,128,129,255)"  "OldRose"
#WIKI_OldSilver                                = $828484;  $FF828484  "#848482"  "rgb(868,132,130)"  "rgba(868,132,130,255)"  "OldSilver"
#WIKI_Olive                                    = $008080;  $FF008080  "#808000"  "rgb(842,128,  0)"  "rgba(842,128,  0,255)"  "Olive"
#WIKI_OliveDrab3                               = $238E6B;  $FF238E6B  "#6B8E23"  "rgb(704,142, 35)"  "rgba(704,142, 35,255)"  "OliveDrab3"
#WIKI_OliveDrab7                               = $1F343C;  $FF1F343C  "#3C341F"  "rgb(394, 52, 31)"  "rgba(394, 52, 31,255)"  "OliveDrab7"
#WIKI_Olivine                                  = $73B99A;  $FF73B99A  "#9AB973"  "rgb(101,185,115)"  "rgba(101,185,115,255)"  "Olivine"
#WIKI_Onyx                                     = $393835;  $FF393835  "#353839"  "rgb(348, 56, 57)"  "rgba(348, 56, 57,255)"  "Onyx"
#WIKI_OperaMauve                               = $A784B7;  $FFA784B7  "#B784A7"  "rgb(120,132,167)"  "rgba(120,132,167,255)"  "OperaMauve"
#WIKI_Orange_ColorWheel                        = $007FFF;  $FF007FFF  "#FF7F00"  "rgb(167,127,  0)"  "rgba(167,127,  0,255)"  "Orange_ColorWheel"
#WIKI_Orange_Crayola                           = $3875FF;  $FF3875FF  "#FF7538"  "rgb(167,117, 56)"  "rgba(167,117, 56,255)"  "Orange_Crayola"
#WIKI_Orange_Pantone                           = $0058FF;  $FF0058FF  "#FF5800"  "rgb(167, 88,  0)"  "rgba(167, 88,  0,255)"  "Orange_Pantone"
#WIKI_Orange_Ryb                               = $0299FB;  $FF0299FB  "#FB9902"  "rgb(164,153,  2)"  "rgba(164,153,  2,255)"  "Orange_Ryb"
#WIKI_Orange_Web                               = $00A5FF;  $FF00A5FF  "#FFA500"  "rgb(167,165,  0)"  "rgba(167,165,  0,255)"  "Orange_Web"
#WIKI_OrangePeel                               = $009FFF;  $FF009FFF  "#FF9F00"  "rgb(167,159,  0)"  "rgba(167,159,  0,255)"  "OrangePeel"
#WIKI_OrangeRed                                = $0045FF;  $FF0045FF  "#FF4500"  "rgb(167, 69,  0)"  "rgba(167, 69,  0,255)"  "OrangeRed"
#WIKI_OrangeSoda                               = $3D5BFA;  $FF3D5BFA  "#FA5B3D"  "rgb(164, 91, 61)"  "rgba(164, 91, 61,255)"  "OrangeSoda"
#WIKI_OrangeYellow                             = $68D5F8;  $FF68D5F8  "#F8D568"  "rgb(163,213,104)"  "rgba(163,213,104,255)"  "OrangeYellow"
#WIKI_Orchid                                   = $D670DA;  $FFD670DA  "#DA70D6"  "rgb(143,112,214)"  "rgba(143,112,214,255)"  "Orchid"
#WIKI_OrchidPink                               = $CDBDF2;  $FFCDBDF2  "#F2BDCD"  "rgb(159,189,205)"  "rgba(159,189,205,255)"  "OrchidPink"
#WIKI_OriolesOrange                            = $144FFB;  $FF144FFB  "#FB4F14"  "rgb(164, 79, 20)"  "rgba(164, 79, 20,255)"  "OriolesOrange"
#WIKI_OtterBrown                               = $214365;  $FF214365  "#654321"  "rgb(663, 67, 33)"  "rgba(663, 67, 33,255)"  "OtterBrown"
#WIKI_OuterSpace                               = $4C4A41;  $FF4C4A41  "#414A4C"  "rgb(427, 74, 76)"  "rgba(427, 74, 76,255)"  "OuterSpace"
#WIKI_OutrageousOrange                         = $4A6EFF;  $FF4A6EFF  "#FF6E4A"  "rgb(167,110, 74)"  "rgba(167,110, 74,255)"  "OutrageousOrange"
#WIKI_OxfordBlue                               = $472100;  $FF472100  "#002147"  "rgb(851, 33, 71)"  "rgba(851, 33, 71,255)"  "OxfordBlue"
#WIKI_OuCrimsonRed                             = $000099;  $FF000099  "#990000"  "rgb(100,  0,  0)"  "rgba(100,  0,  0,255)"  "OuCrimsonRed"
#WIKI_PacificBlue                              = $C9A91C;  $FFC9A91C  "#1CA9C9"  "rgb(187,169,201)"  "rgba(187,169,201,255)"  "PacificBlue"
#WIKI_PakistanGreen                            = $006600;  $FF006600  "#006600"  "rgb(261,102,  0)"  "rgba(261,102,  0,255)"  "PakistanGreen"
#WIKI_PalatinateBlue                           = $E23B27;  $FFE23B27  "#273BE2"  "rgb(257, 59,226)"  "rgba(257, 59,226,255)"  "PalatinateBlue"
#WIKI_PalatinatePurple                         = $602868;  $FF602868  "#682860"  "rgb(682, 40, 96)"  "rgba(682, 40, 96,255)"  "PalatinatePurple"
#WIKI_PaleAqua                                 = $E6D4BC;  $FFE6D4BC  "#BCD4E6"  "rgb(123,212,230)"  "rgba(123,212,230,255)"  "PaleAqua"
#WIKI_PaleBlue                                 = $EEEEAF;  $FFEEEEAF  "#AFEEEE"  "rgb(115,238,238)"  "rgba(115,238,238,255)"  "PaleBlue"
#WIKI_PaleBrown                                = $547698;  $FF547698  "#987654"  "rgb(999,118, 84)"  "rgba(999,118, 84,255)"  "PaleBrown"
#WIKI_PaleCarmine                              = $3540AF;  $FF3540AF  "#AF4035"  "rgb(114, 64, 53)"  "rgba(114, 64, 53,255)"  "PaleCarmine"
#WIKI_PaleCerulean                             = $E2C49B;  $FFE2C49B  "#9BC4E2"  "rgb(102,196,226)"  "rgba(102,196,226,255)"  "PaleCerulean"
#WIKI_PaleChestnut                             = $AFADDD;  $FFAFADDD  "#DDADAF"  "rgb(145,173,175)"  "rgba(145,173,175,255)"  "PaleChestnut"
#WIKI_PaleCopper                               = $678ADA;  $FF678ADA  "#DA8A67"  "rgb(143,138,103)"  "rgba(143,138,103,255)"  "PaleCopper"
#WIKI_PaleCornflowerBlue                       = $EFCDAB;  $FFEFCDAB  "#ABCDEF"  "rgb(112,205,239)"  "rgba(112,205,239,255)"  "PaleCornflowerBlue"
#WIKI_PaleCyan                                 = $F8D387;  $FFF8D387  "#87D3F8"  "rgb(890,211,248)"  "rgba(890,211,248,255)"  "PaleCyan"
#WIKI_PaleGold                                 = $8ABEE6;  $FF8ABEE6  "#E6BE8A"  "rgb(151,190,138)"  "rgba(151,190,138,255)"  "PaleGold"
#WIKI_PaleGoldenrod                            = $AAE8EE;  $FFAAE8EE  "#EEE8AA"  "rgb(156,232,170)"  "rgba(156,232,170,255)"  "PaleGoldenrod"
#WIKI_PaleGreen                                = $98FB98;  $FF98FB98  "#98FB98"  "rgb(100,251,152)"  "rgba(100,251,152,255)"  "PaleGreen"
#WIKI_PaleLavender                             = $FFD0DC;  $FFFFD0DC  "#DCD0FF"  "rgb(144,208,255)"  "rgba(144,208,255,255)"  "PaleLavender"
#WIKI_PaleMagenta                              = $E584F9;  $FFE584F9  "#F984E5"  "rgb(163,132,229)"  "rgba(163,132,229,255)"  "PaleMagenta"
#WIKI_PaleMagentaPink                          = $CC99FF;  $FFCC99FF  "#FF99CC"  "rgb(167,153,204)"  "rgba(167,153,204,255)"  "PaleMagentaPink"
#WIKI_PalePink                                 = $DDDAFA;  $FFDDDAFA  "#FADADD"  "rgb(164,218,221)"  "rgba(164,218,221,255)"  "PalePink"
#WIKI_PalePlum                                 = $DDA0DD;  $FFDDA0DD  "#DDA0DD"  "rgb(145,160,221)"  "rgba(145,160,221,255)"  "PalePlum"
#WIKI_PaleRedViolet                            = $9370DB;  $FF9370DB  "#DB7093"  "rgb(143,112,147)"  "rgba(143,112,147,255)"  "PaleRedViolet"
#WIKI_PaleRobinEggBlue                         = $D1DE96;  $FFD1DE96  "#96DED1"  "rgb(988,222,209)"  "rgba(988,222,209,255)"  "PaleRobinEggBlue"
#WIKI_PaleSilver                               = $BBC0C9;  $FFBBC0C9  "#C9C0BB"  "rgb(132,192,187)"  "rgba(132,192,187,255)"  "PaleSilver"
#WIKI_PaleSpringBud                            = $BDEBEC;  $FFBDEBEC  "#ECEBBD"  "rgb(155,235,189)"  "rgba(155,235,189,255)"  "PaleSpringBud"
#WIKI_PaleTaupe                                = $7E98BC;  $FF7E98BC  "#BC987E"  "rgb(123,152,126)"  "rgba(123,152,126,255)"  "PaleTaupe"
#WIKI_PaleTurquoise                            = $EEEEAF;  $FFEEEEAF  "#AFEEEE"  "rgb(115,238,238)"  "rgba(115,238,238,255)"  "PaleTurquoise"
#WIKI_PaleViolet                               = $FF99CC;  $FFFF99CC  "#CC99FF"  "rgb(134,153,255)"  "rgba(134,153,255,255)"  "PaleViolet"
#WIKI_PaleVioletRed                            = $9370DB;  $FF9370DB  "#DB7093"  "rgb(143,112,147)"  "rgba(143,112,147,255)"  "PaleVioletRed"
#WIKI_PalmLeaf                                 = $40996F;  $FF40996F  "#6F9940"  "rgb(731,153, 64)"  "rgba(731,153, 64,255)"  "PalmLeaf"
#WIKI_PansyPurple                              = $4A1878;  $FF4A1878  "#78184A"  "rgb(787, 24, 74)"  "rgba(787, 24, 74,255)"  "PansyPurple"
#WIKI_PaoloVeroneseGreen                       = $7D9B00;  $FF7D9B00  "#009B7D"  "rgb(398,155,125)"  "rgba(398,155,125,255)"  "PaoloVeroneseGreen"
#WIKI_PapayaWhip                               = $D5EFFF;  $FFD5EFFF  "#FFEFD5"  "rgb(167,239,213)"  "rgba(167,239,213,255)"  "PapayaWhip"
#WIKI_ParadisePink                             = $623EE6;  $FF623EE6  "#E63E62"  "rgb(150, 62, 98)"  "rgba(150, 62, 98,255)"  "ParadisePink"
#WIKI_ParisGreen                               = $78C850;  $FF78C850  "#50C878"  "rgb(529,200,120)"  "rgba(529,200,120,255)"  "ParisGreen"
#WIKI_ParrotPink                               = $A098D9;  $FFA098D9  "#D998A0"  "rgb(142,152,160)"  "rgba(142,152,160,255)"  "ParrotPink"
#WIKI_PastelBlue                               = $CFC6AE;  $FFCFC6AE  "#AEC6CF"  "rgb(114,198,207)"  "rgba(114,198,207,255)"  "PastelBlue"
#WIKI_PastelBrown                              = $536983;  $FF536983  "#836953"  "rgb(861,105, 83)"  "rgba(861,105, 83,255)"  "PastelBrown"
#WIKI_PastelGray                               = $C4CFCF;  $FFC4CFCF  "#CFCFC4"  "rgb(136,207,196)"  "rgba(136,207,196,255)"  "PastelGray"
#WIKI_PastelGreen                              = $77DD77;  $FF77DD77  "#77DD77"  "rgb(785,221,119)"  "rgba(785,221,119,255)"  "PastelGreen"
#WIKI_PastelMagenta                            = $C29AF4;  $FFC29AF4  "#F49AC2"  "rgb(160,154,194)"  "rgba(160,154,194,255)"  "PastelMagenta"
#WIKI_PastelOrange                             = $47B3FF;  $FF47B3FF  "#FFB347"  "rgb(167,179, 71)"  "rgba(167,179, 71,255)"  "PastelOrange"
#WIKI_PastelPink                               = $A4A5DE;  $FFA4A5DE  "#DEA5A4"  "rgb(145,165,164)"  "rgba(145,165,164,255)"  "PastelPink"
#WIKI_PastelPurple                             = $B59EB3;  $FFB59EB3  "#B39EB5"  "rgb(117,158,181)"  "rgba(117,158,181,255)"  "PastelPurple"
#WIKI_PastelRed                                = $6169FF;  $FF6169FF  "#FF6961"  "rgb(167,105, 97)"  "rgba(167,105, 97,255)"  "PastelRed"
#WIKI_PastelViolet                             = $C999CB;  $FFC999CB  "#CB99C9"  "rgb(133,153,201)"  "rgba(133,153,201,255)"  "PastelViolet"
#WIKI_PastelYellow                             = $96FDFD;  $FF96FDFD  "#FDFD96"  "rgb(166,253,150)"  "rgba(166,253,150,255)"  "PastelYellow"
#WIKI_Patriarch                                = $800080;  $FF800080  "#800080"  "rgb(838,  0,128)"  "rgba(838,  0,128,255)"  "Patriarch"
#WIKI_PaynesGrey                               = $786853;  $FF786853  "#536878"  "rgb(546,104,120)"  "rgba(546,104,120,255)"  "PaynesGrey"
#WIKI_Peach                                    = $B4E5FF;  $FFB4E5FF  "#FFE5B4"  "rgb(167,229,180)"  "rgba(167,229,180,255)"  "Peach"
#WIKI_Peach_                                   = $A4CBFF;  $FFA4CBFF  "#FFCBA4"  "rgb(167,203,164)"  "rgba(167,203,164,255)"  "Peach_"
#WIKI_PeachOrange                              = $99CCFF;  $FF99CCFF  "#FFCC99"  "rgb(167,204,153)"  "rgba(167,204,153,255)"  "PeachOrange"
#WIKI_PeachPuff                                = $B9DAFF;  $FFB9DAFF  "#FFDAB9"  "rgb(167,218,185)"  "rgba(167,218,185,255)"  "PeachPuff"
#WIKI_PeachYellow                              = $ADDFFA;  $FFADDFFA  "#FADFAD"  "rgb(164,223,173)"  "rgba(164,223,173,255)"  "PeachYellow"
#WIKI_Pear                                     = $31E2D1;  $FF31E2D1  "#D1E231"  "rgb(137,226, 49)"  "rgba(137,226, 49,255)"  "Pear"
#WIKI_Pearl                                    = $C8E0EA;  $FFC8E0EA  "#EAE0C8"  "rgb(153,224,200)"  "rgba(153,224,200,255)"  "Pearl"
#WIKI_PearlAqua                                = $C0D888;  $FFC0D888  "#88D8C0"  "rgb(896,216,192)"  "rgba(896,216,192,255)"  "PearlAqua"
#WIKI_PearlyPurple                             = $A268B7;  $FFA268B7  "#B768A2"  "rgb(120,104,162)"  "rgba(120,104,162,255)"  "PearlyPurple"
#WIKI_Peridot                                  = $00E2E6;  $FF00E2E6  "#E6E200"  "rgb(151,226,  0)"  "rgba(151,226,  0,255)"  "Peridot"
#WIKI_Periwinkle                               = $FFCCCC;  $FFFFCCCC  "#CCCCFF"  "rgb(134,204,255)"  "rgba(134,204,255,255)"  "Periwinkle"
#WIKI_PermanentGeraniumLake                    = $2C2CE1;  $FF2C2CE1  "#E12C2C"  "rgb(147, 44, 44)"  "rgba(147, 44, 44,255)"  "PermanentGeraniumLake"
#WIKI_PersianBlue                              = $BB391C;  $FFBB391C  "#1C39BB"  "rgb(184, 57,187)"  "rgba(184, 57,187,255)"  "PersianBlue"
#WIKI_PersianGreen                             = $93A600;  $FF93A600  "#00A693"  "rgb(426,166,147)"  "rgba(426,166,147,255)"  "PersianGreen"
#WIKI_PersianIndigo                            = $7A1232;  $FF7A1232  "#32127A"  "rgb(328, 18,122)"  "rgba(328, 18,122,255)"  "PersianIndigo"
#WIKI_PersianOrange                            = $5890D9;  $FF5890D9  "#D99058"  "rgb(142,144, 88)"  "rgba(142,144, 88,255)"  "PersianOrange"
#WIKI_PersianPink                              = $BE7FF7;  $FFBE7FF7  "#F77FBE"  "rgb(162,127,190)"  "rgba(162,127,190,255)"  "PersianPink"
#WIKI_PersianPlum                              = $1C1C70;  $FF1C1C70  "#701C1C"  "rgb(734, 28, 28)"  "rgba(734, 28, 28,255)"  "PersianPlum"
#WIKI_PersianRed                               = $3333CC;  $FF3333CC  "#CC3333"  "rgb(133, 51, 51)"  "rgba(133, 51, 51,255)"  "PersianRed"
#WIKI_PersianRose                              = $A228FE;  $FFA228FE  "#FE28A2"  "rgb(166, 40,162)"  "rgba(166, 40,162,255)"  "PersianRose"
#WIKI_Persimmon                                = $0058EC;  $FF0058EC  "#EC5800"  "rgb(154, 88,  0)"  "rgba(154, 88,  0,255)"  "Persimmon"
#WIKI_Peru                                     = $3F85CD;  $FF3F85CD  "#CD853F"  "rgb(134,133, 63)"  "rgba(134,133, 63,255)"  "Peru"
#WIKI_PewterBlue                               = $B7A88B;  $FFB7A88B  "#8BA8B7"  "rgb(915,168,183)"  "rgba(915,168,183,255)"  "PewterBlue"
#WIKI_Phlox                                    = $FF00DF;  $FFFF00DF  "#DF00FF"  "rgb(146,  0,255)"  "rgba(146,  0,255,255)"  "Phlox"
#WIKI_PhthaloBlue                              = $890F00;  $FF890F00  "#000F89"  "rgb(397, 15,137)"  "rgba(397, 15,137,255)"  "PhthaloBlue"
#WIKI_PhthaloGreen                             = $243512;  $FF243512  "#123524"  "rgb(119, 53, 36)"  "rgba(119, 53, 36,255)"  "PhthaloGreen"
#WIKI_PictonBlue                               = $E8B145;  $FFE8B145  "#45B1E8"  "rgb(456,177,232)"  "rgba(456,177,232,255)"  "PictonBlue"
#WIKI_PictorialCarmine                         = $4E0BC3;  $FF4E0BC3  "#C30B4E"  "rgb(127, 11, 78)"  "rgba(127, 11, 78,255)"  "PictorialCarmine"
#WIKI_PiggyPink                                = $E6DDFD;  $FFE6DDFD  "#FDDDE6"  "rgb(166,221,230)"  "rgba(166,221,230,255)"  "PiggyPink"
#WIKI_PineGreen                                = $6F7901;  $FF6F7901  "#01796F"  "rgb(966,121,111)"  "rgba(966,121,111,255)"  "PineGreen"
#WIKI_Pineapple                                = $5C3C56;  $FF5C3C56  "#563C5C"  "rgb(565, 60, 92)"  "rgba(565, 60, 92,255)"  "Pineapple"
#WIKI_Pink                                     = $CBC0FF;  $FFCBC0FF  "#FFC0CB"  "rgb(167,192,203)"  "rgba(167,192,203,255)"  "Pink"
#WIKI_Pink_Pantone                             = $9448D7;  $FF9448D7  "#D74894"  "rgb(141, 72,148)"  "rgba(141, 72,148,255)"  "Pink_Pantone"
#WIKI_PinkFlamingo                             = $FD74FC;  $FFFD74FC  "#FC74FD"  "rgb(165,116,253)"  "rgba(165,116,253,255)"  "PinkFlamingo"
#WIKI_PinkLace                                 = $F4DDFF;  $FFF4DDFF  "#FFDDF4"  "rgb(167,221,244)"  "rgba(167,221,244,255)"  "PinkLace"
#WIKI_PinkLavender                             = $D1B2D8;  $FFD1B2D8  "#D8B2D1"  "rgb(142,178,209)"  "rgba(142,178,209,255)"  "PinkLavender"
#WIKI_PinkOrange                               = $6699FF;  $FF6699FF  "#FF9966"  "rgb(167,153,102)"  "rgba(167,153,102,255)"  "PinkOrange"
#WIKI_PinkPearl                                = $CFACE7;  $FFCFACE7  "#E7ACCF"  "rgb(151,172,207)"  "rgba(151,172,207,255)"  "PinkPearl"
#WIKI_PinkRaspberry                            = $360098;  $FF360098  "#980036"  "rgb(996,  0, 54)"  "rgba(996,  0, 54,255)"  "PinkRaspberry"
#WIKI_PinkSherbet                              = $A78FF7;  $FFA78FF7  "#F78FA7"  "rgb(162,143,167)"  "rgba(162,143,167,255)"  "PinkSherbet"
#WIKI_Pistachio                                = $72C593;  $FF72C593  "#93C572"  "rgb(968,197,114)"  "rgba(968,197,114,255)"  "Pistachio"
#WIKI_PixiePowder                              = $851239;  $FF851239  "#391285"  "rgb(374, 18,133)"  "rgba(374, 18,133,255)"  "PixiePowder"
#WIKI_Platinum                                 = $E2E4E5;  $FFE2E4E5  "#E5E4E2"  "rgb(150,228,226)"  "rgba(150,228,226,255)"  "Platinum"
#WIKI_Plum                                     = $85458E;  $FF85458E  "#8E4585"  "rgb(932, 69,133)"  "rgba(932, 69,133,255)"  "Plum"
#WIKI_Plum_Web                                 = $DDA0DD;  $FFDDA0DD  "#DDA0DD"  "rgb(145,160,221)"  "rgba(145,160,221,255)"  "Plum_Web"
#WIKI_PlumpPurple                              = $B24659;  $FFB24659  "#5946B2"  "rgb(585, 70,178)"  "rgba(585, 70,178,255)"  "PlumpPurple"
#WIKI_PolishedPine                             = $93A45D;  $FF93A45D  "#5DA493"  "rgb(613,164,147)"  "rgba(613,164,147,255)"  "PolishedPine"
#WIKI_PompAndPower                             = $8E6086;  $FF8E6086  "#86608E"  "rgb(880, 96,142)"  "rgba(880, 96,142,255)"  "PompAndPower"
#WIKI_Popstar                                  = $624FBE;  $FF624FBE  "#BE4F62"  "rgb(124, 79, 98)"  "rgba(124, 79, 98,255)"  "Popstar"
#WIKI_PortlandOrange                           = $365AFF;  $FF365AFF  "#FF5A36"  "rgb(167, 90, 54)"  "rgba(167, 90, 54,255)"  "PortlandOrange"
#WIKI_PowderBlue                               = $E6E0B0;  $FFE6E0B0  "#B0E0E6"  "rgb(115,224,230)"  "rgba(115,224,230,255)"  "PowderBlue"
#WIKI_PrincessPerfume                          = $CF85FF;  $FFCF85FF  "#FF85CF"  "rgb(167,133,207)"  "rgba(167,133,207,255)"  "PrincessPerfume"
#WIKI_PrincetonOrange                          = $2580F5;  $FF2580F5  "#F58025"  "rgb(160,128, 37)"  "rgba(160,128, 37,255)"  "PrincetonOrange"
#WIKI_Prune                                    = $1C1C70;  $FF1C1C70  "#701C1C"  "rgb(734, 28, 28)"  "rgba(734, 28, 28,255)"  "Prune"
#WIKI_PrussianBlue                             = $533100;  $FF533100  "#003153"  "rgb(126, 49, 83)"  "rgba(126, 49, 83,255)"  "PrussianBlue"
#WIKI_PsychedelicPurple                        = $FF00DF;  $FFFF00DF  "#DF00FF"  "rgb(146,  0,255)"  "rgba(146,  0,255,255)"  "PsychedelicPurple"
#WIKI_Puce                                     = $9988CC;  $FF9988CC  "#CC8899"  "rgb(134,136,153)"  "rgba(134,136,153,255)"  "Puce"
#WIKI_PuceRed                                  = $372F72;  $FF372F72  "#722F37"  "rgb(748, 47, 55)"  "rgba(748, 47, 55,255)"  "PuceRed"
#WIKI_PullmanBrown_UpsBrown                    = $174164;  $FF174164  "#644117"  "rgb(657, 65, 23)"  "rgba(657, 65, 23,255)"  "PullmanBrown_UpsBrown"
#WIKI_PullmanGreen                             = $1C333B;  $FF1C333B  "#3B331C"  "rgb(387, 51, 28)"  "rgba(387, 51, 28,255)"  "PullmanGreen"
#WIKI_Pumpkin                                  = $1875FF;  $FF1875FF  "#FF7518"  "rgb(167,117, 24)"  "rgba(167,117, 24,255)"  "Pumpkin"
#WIKI_Purple_Html                              = $800080;  $FF800080  "#800080"  "rgb(838,  0,128)"  "rgba(838,  0,128,255)"  "Purple_Html"
#WIKI_Purple_Munsell                           = $C5009F;  $FFC5009F  "#9F00C5"  "rgb(104,  0,197)"  "rgba(104,  0,197,255)"  "Purple_Munsell"
#WIKI_Purple_X11                               = $F020A0;  $FFF020A0  "#A020F0"  "rgb(104, 32,240)"  "rgba(104, 32,240,255)"  "Purple_X11"
#WIKI_PurpleHeart                              = $9C3569;  $FF9C3569  "#69359C"  "rgb(689, 53,156)"  "rgba(689, 53,156,255)"  "PurpleHeart"
#WIKI_PurpleMountainMajesty                    = $B67896;  $FFB67896  "#9678B6"  "rgb(986,120,182)"  "rgba(986,120,182,255)"  "PurpleMountainMajesty"
#WIKI_PurpleNavy                               = $80514E;  $FF80514E  "#4E5180"  "rgb(513, 81,128)"  "rgba(513, 81,128,255)"  "PurpleNavy"
#WIKI_PurplePizzazz                            = $DA4EFE;  $FFDA4EFE  "#FE4EDA"  "rgb(166, 78,218)"  "rgba(166, 78,218,255)"  "PurplePizzazz"
#WIKI_PurplePlum                               = $B6519C;  $FFB6519C  "#9C51B6"  "rgb(102, 81,182)"  "rgba(102, 81,182,255)"  "PurplePlum"
#WIKI_PurpleTaupe                              = $4D4050;  $FF4D4050  "#50404D"  "rgb(525, 64, 77)"  "rgba(525, 64, 77,255)"  "PurpleTaupe"
#WIKI_Purpureus                                = $AE4E9A;  $FFAE4E9A  "#9A4EAE"  "rgb(101, 78,174)"  "rgba(101, 78,174,255)"  "Purpureus"
#WIKI_Quartz                                   = $4F4851;  $FF4F4851  "#51484F"  "rgb(532, 72, 79)"  "rgba(532, 72, 79,255)"  "Quartz"
#WIKI_QueenBlue                                = $956B43;  $FF956B43  "#436B95"  "rgb(441,107,149)"  "rgba(441,107,149,255)"  "QueenBlue"
#WIKI_QueenPink                                = $D7CCE8;  $FFD7CCE8  "#E8CCD7"  "rgb(152,204,215)"  "rgba(152,204,215,255)"  "QueenPink"
#WIKI_QuickSilver                              = $A6A6A6;  $FFA6A6A6  "#A6A6A6"  "rgb(109,166,166)"  "rgba(109,166,166,255)"  "QuickSilver"
#WIKI_QuinacridoneMagenta                      = $593A8E;  $FF593A8E  "#8E3A59"  "rgb(932, 58, 89)"  "rgba(932, 58, 89,255)"  "QuinacridoneMagenta"
#WIKI_Rackley                                  = $A88A5D;  $FFA88A5D  "#5D8AA8"  "rgb(613,138,168)"  "rgba(613,138,168,255)"  "Rackley"
#WIKI_RadicalRed                               = $5E35FF;  $FF5E35FF  "#FF355E"  "rgb(167, 53, 94)"  "rgba(167, 53, 94,255)"  "RadicalRed"
#WIKI_RaisinBlack                              = $242124;  $FF242124  "#242124"  "rgb(236, 33, 36)"  "rgba(236, 33, 36,255)"  "RaisinBlack"
#WIKI_Rajah                                    = $60ABFB;  $FF60ABFB  "#FBAB60"  "rgb(164,171, 96)"  "rgba(164,171, 96,255)"  "Rajah"
#WIKI_Raspberry                                = $5D0BE3;  $FF5D0BE3  "#E30B5D"  "rgb(148, 11, 93)"  "rgba(148, 11, 93,255)"  "Raspberry"
#WIKI_RaspberryGlace                           = $6D5F91;  $FF6D5F91  "#915F6D"  "rgb(952, 95,109)"  "rgba(952, 95,109,255)"  "RaspberryGlace"
#WIKI_RaspberryPink                            = $9850E2;  $FF9850E2  "#E25098"  "rgb(148, 80,152)"  "rgba(148, 80,152,255)"  "RaspberryPink"
#WIKI_RaspberryRose                            = $6C44B3;  $FF6C44B3  "#B3446C"  "rgb(117, 68,108)"  "rgba(117, 68,108,255)"  "RaspberryRose"
#WIKI_RawSienna                                = $598AD6;  $FF598AD6  "#D68A59"  "rgb(140,138, 89)"  "rgba(140,138, 89,255)"  "RawSienna"
#WIKI_RawUmber                                 = $446682;  $FF446682  "#826644"  "rgb(854,102, 68)"  "rgba(854,102, 68,255)"  "RawUmber"
#WIKI_RazzleDazzleRose                         = $CC33FF;  $FFCC33FF  "#FF33CC"  "rgb(167, 51,204)"  "rgba(167, 51,204,255)"  "RazzleDazzleRose"
#WIKI_Razzmatazz                               = $6B25E3;  $FF6B25E3  "#E3256B"  "rgb(148, 37,107)"  "rgba(148, 37,107,255)"  "Razzmatazz"
#WIKI_RazzmicBerry                             = $854E8D;  $FF854E8D  "#8D4E85"  "rgb(926, 78,133)"  "rgba(926, 78,133,255)"  "RazzmicBerry"
#WIKI_RebeccaPurple                            = $993366;  $FF993366  "#663399"  "rgb(669, 51,153)"  "rgba(669, 51,153,255)"  "RebeccaPurple"
#WIKI_Red                                      = $0000FF;  $FF0000FF  "#FF0000"  "rgb(167,  0,  0)"  "rgba(167,  0,  0,255)"  "Red"
#WIKI_Red_Crayola                              = $4D20EE;  $FF4D20EE  "#EE204D"  "rgb(156, 32, 77)"  "rgba(156, 32, 77,255)"  "Red_Crayola"
#WIKI_Red_Munsell                              = $3C00F2;  $FF3C00F2  "#F2003C"  "rgb(158,  0, 60)"  "rgba(158,  0, 60,255)"  "Red_Munsell"
#WIKI_Red_Ncs                                  = $3302C4;  $FF3302C4  "#C40233"  "rgb(128,  2, 51)"  "rgba(128,  2, 51,255)"  "Red_Ncs"
#WIKI_Red_Pantone                              = $3929ED;  $FF3929ED  "#ED2939"  "rgb(155, 41, 57)"  "rgba(155, 41, 57,255)"  "Red_Pantone"
#WIKI_Red_Pigment                              = $241CED;  $FF241CED  "#ED1C24"  "rgb(155, 28, 36)"  "rgba(155, 28, 36,255)"  "Red_Pigment"
#WIKI_Red_Ryb                                  = $1227FE;  $FF1227FE  "#FE2712"  "rgb(166, 39, 18)"  "rgba(166, 39, 18,255)"  "Red_Ryb"
#WIKI_RedBrown                                 = $2A2AA5;  $FF2A2AA5  "#A52A2A"  "rgb(108, 42, 42)"  "rgba(108, 42, 42,255)"  "RedBrown"
#WIKI_RedDevil                                 = $110186;  $FF110186  "#860111"  "rgb(878,  1, 17)"  "rgba(878,  1, 17,255)"  "RedDevil"
#WIKI_RedOrange                                = $4953FF;  $FF4953FF  "#FF5349"  "rgb(167, 83, 73)"  "rgba(167, 83, 73,255)"  "RedOrange"
#WIKI_RedPurple                                = $7800E4;  $FF7800E4  "#E40078"  "rgb(149,  0,120)"  "rgba(149,  0,120,255)"  "RedPurple"
#WIKI_RedSalsa                                 = $4A3AFD;  $FF4A3AFD  "#FD3A4A"  "rgb(165, 58, 74)"  "rgba(165, 58, 74,255)"  "RedSalsa"
#WIKI_RedViolet                                = $8515C7;  $FF8515C7  "#C71585"  "rgb(130, 21,133)"  "rgba(130, 21,133,255)"  "RedViolet"
#WIKI_Redwood                                  = $525AA4;  $FF525AA4  "#A45A52"  "rgb(107, 90, 82)"  "rgba(107, 90, 82,255)"  "Redwood"
#WIKI_Regalia                                  = $802D52;  $FF802D52  "#522D80"  "rgb(538, 45,128)"  "rgba(538, 45,128,255)"  "Regalia"
#WIKI_RegistrationBlack                        = $000000;  $FF000000  "#000000"  "rgb(  0,  0,  0)"  "rgba(  0,  0,  0,255)"  "RegistrationBlack"
#WIKI_ResolutionBlue                           = $872300;  $FF872300  "#002387"  "rgb(909, 35,135)"  "rgba(909, 35,135,255)"  "ResolutionBlue"
#WIKI_Rhythm                                   = $967677;  $FF967677  "#777696"  "rgb(782,118,150)"  "rgba(782,118,150,255)"  "Rhythm"
#WIKI_RichBlack                                = $404000;  $FF404000  "#004040"  "rgb(164, 64, 64)"  "rgba(164, 64, 64,255)"  "RichBlack"
#WIKI_RichBlack_Fogra29                        = $130B01;  $FF130B01  "#010B13"  "rgb(683, 11, 19)"  "rgba(683, 11, 19,255)"  "RichBlack_Fogra29"
#WIKI_RichBlack_Fogra39                        = $030201;  $FF030201  "#010203"  "rgb(660,  2,  3)"  "rgba(660,  2,  3,255)"  "RichBlack_Fogra39"
#WIKI_RichBrilliantLavender                    = $FEA7F1;  $FFFEA7F1  "#F1A7FE"  "rgb(158,167,254)"  "rgba(158,167,254,255)"  "RichBrilliantLavender"
#WIKI_RichCarmine                              = $4000D7;  $FF4000D7  "#D70040"  "rgb(140,  0, 64)"  "rgba(140,  0, 64,255)"  "RichCarmine"
#WIKI_RichElectricBlue                         = $D09208;  $FFD09208  "#0892D0"  "rgb(561,146,208)"  "rgba(561,146,208,255)"  "RichElectricBlue"
#WIKI_RichLavender                             = $CF6BA7;  $FFCF6BA7  "#A76BCF"  "rgb(109,107,207)"  "rgba(109,107,207,255)"  "RichLavender"
#WIKI_RichLilac                                = $D266B6;  $FFD266B6  "#B666D2"  "rgb(119,102,210)"  "rgba(119,102,210,255)"  "RichLilac"
#WIKI_RichMaroon                               = $6030B0;  $FF6030B0  "#B03060"  "rgb(115, 48, 96)"  "rgba(115, 48, 96,255)"  "RichMaroon"
#WIKI_RifleGreen                               = $384C44;  $FF384C44  "#444C38"  "rgb(447, 76, 56)"  "rgba(447, 76, 56,255)"  "RifleGreen"
#WIKI_RoastCoffee                              = $414270;  $FF414270  "#704241"  "rgb(735, 66, 65)"  "rgba(735, 66, 65,255)"  "RoastCoffee"
#WIKI_RobinEggBlue                             = $CCCC00;  $FFCCCC00  "#00CCCC"  "rgb(524,204,204)"  "rgba(524,204,204,255)"  "RobinEggBlue"
#WIKI_RocketMetallic                           = $807F8A;  $FF807F8A  "#8A7F80"  "rgb(907,127,128)"  "rgba(907,127,128,255)"  "RocketMetallic"
#WIKI_RomanSilver                              = $968983;  $FF968983  "#838996"  "rgb(862,137,150)"  "rgba(862,137,150,255)"  "RomanSilver"
#WIKI_Rose                                     = $7F00FF;  $FF7F00FF  "#FF007F"  "rgb(167,  0,127)"  "rgba(167,  0,127,255)"  "Rose"
#WIKI_RoseBonbon                               = $9E42F9;  $FF9E42F9  "#F9429E"  "rgb(163, 66,158)"  "rgba(163, 66,158,255)"  "RoseBonbon"
#WIKI_RoseDust                                 = $6F5E9E;  $FF6F5E9E  "#9E5E6F"  "rgb(103, 94,111)"  "rgba(103, 94,111,255)"  "RoseDust"
#WIKI_RoseEbony                                = $464867;  $FF464867  "#674846"  "rgb(676, 72, 70)"  "rgba(676, 72, 70,255)"  "RoseEbony"
#WIKI_RoseGold                                 = $796EB7;  $FF796EB7  "#B76E79"  "rgb(120,110,121)"  "rgba(120,110,121,255)"  "RoseGold"
#WIKI_RoseMadder                               = $3626E3;  $FF3626E3  "#E32636"  "rgb(148, 38, 54)"  "rgba(148, 38, 54,255)"  "RoseMadder"
#WIKI_RosePink                                 = $CC66FF;  $FFCC66FF  "#FF66CC"  "rgb(167,102,204)"  "rgba(167,102,204,255)"  "RosePink"
#WIKI_RoseQuartz                               = $A998AA;  $FFA998AA  "#AA98A9"  "rgb(111,152,169)"  "rgba(111,152,169,255)"  "RoseQuartz"
#WIKI_RoseRed                                  = $561EC2;  $FF561EC2  "#C21E56"  "rgb(127, 30, 86)"  "rgba(127, 30, 86,255)"  "RoseRed"
#WIKI_RoseTaupe                                = $5D5D90;  $FF5D5D90  "#905D5D"  "rgb(946, 93, 93)"  "rgba(946, 93, 93,255)"  "RoseTaupe"
#WIKI_RoseVale                                 = $524EAB;  $FF524EAB  "#AB4E52"  "rgb(112, 78, 82)"  "rgba(112, 78, 82,255)"  "RoseVale"
#WIKI_Rosewood                                 = $0B0065;  $FF0B0065  "#65000B"  "rgb(661,  0, 11)"  "rgba(661,  0, 11,255)"  "Rosewood"
#WIKI_RossoCorsa                               = $0000D4;  $FF0000D4  "#D40000"  "rgb(138,  0,  0)"  "rgba(138,  0,  0,255)"  "RossoCorsa"
#WIKI_RosyBrown                                = $8F8FBC;  $FF8F8FBC  "#BC8F8F"  "rgb(123,143,143)"  "rgba(123,143,143,255)"  "RosyBrown"
#WIKI_RoyalAzure                               = $A83800;  $FFA83800  "#0038A8"  "rgb(145, 56,168)"  "rgba(145, 56,168,255)"  "RoyalAzure"
#WIKI_RoyalBlue                                = $662300;  $FF662300  "#002366"  "rgb(906, 35,102)"  "rgba(906, 35,102,255)"  "RoyalBlue"
#WIKI_RoyalBlue_                               = $E16941;  $FFE16941  "#4169E1"  "rgb(428,105,225)"  "rgba(428,105,225,255)"  "RoyalBlue_"
#WIKI_RoyalFuchsia                             = $922CCA;  $FF922CCA  "#CA2C92"  "rgb(132, 44,146)"  "rgba(132, 44,146,255)"  "RoyalFuchsia"
#WIKI_RoyalPurple                              = $A95178;  $FFA95178  "#7851A9"  "rgb(788, 81,169)"  "rgba(788, 81,169,255)"  "RoyalPurple"
#WIKI_RoyalYellow                              = $5EDAFA;  $FF5EDAFA  "#FADA5E"  "rgb(164,218, 94)"  "rgba(164,218, 94,255)"  "RoyalYellow"
#WIKI_Ruber                                    = $7646CE;  $FF7646CE  "#CE4676"  "rgb(135, 70,118)"  "rgba(135, 70,118,255)"  "Ruber"
#WIKI_RubineRed                                = $5600D1;  $FF5600D1  "#D10056"  "rgb(136,  0, 86)"  "rgba(136,  0, 86,255)"  "RubineRed"
#WIKI_Ruby                                     = $5F11E0;  $FF5F11E0  "#E0115F"  "rgb(146, 17, 95)"  "rgba(146, 17, 95,255)"  "Ruby"
#WIKI_RubyRed                                  = $1E119B;  $FF1E119B  "#9B111E"  "rgb(101, 17, 30)"  "rgba(101, 17, 30,255)"  "RubyRed"
#WIKI_Ruddy                                    = $2800FF;  $FF2800FF  "#FF0028"  "rgb(167,  0, 40)"  "rgba(167,  0, 40,255)"  "Ruddy"
#WIKI_RuddyBrown                               = $2865BB;  $FF2865BB  "#BB6528"  "rgb(122,101, 40)"  "rgba(122,101, 40,255)"  "RuddyBrown"
#WIKI_RuddyPink                                = $968EE1;  $FF968EE1  "#E18E96"  "rgb(147,142,150)"  "rgba(147,142,150,255)"  "RuddyPink"
#WIKI_Rufous                                   = $071CA8;  $FF071CA8  "#A81C07"  "rgb(110, 28,  7)"  "rgba(110, 28,  7,255)"  "Rufous"
#WIKI_Russet                                   = $1B4680;  $FF1B4680  "#80461B"  "rgb(840, 70, 27)"  "rgba(840, 70, 27,255)"  "Russet"
#WIKI_RussianGreen                             = $679267;  $FF679267  "#679267"  "rgb(678,146,103)"  "rgba(678,146,103,255)"  "RussianGreen"
#WIKI_RussianViolet                            = $4D1732;  $FF4D1732  "#32174D"  "rgb(328, 23, 77)"  "rgba(328, 23, 77,255)"  "RussianViolet"
#WIKI_Rust                                     = $0E41B7;  $FF0E41B7  "#B7410E"  "rgb(120, 65, 14)"  "rgba(120, 65, 14,255)"  "Rust"
#WIKI_RustyRed                                 = $432CDA;  $FF432CDA  "#DA2C43"  "rgb(142, 44, 67)"  "rgba(142, 44, 67,255)"  "RustyRed"
#WIKI_SacramentoStateGreen                     = $3F5600;  $FF3F5600  "#00563F"  "rgb(220, 86, 63)"  "rgba(220, 86, 63,255)"  "SacramentoStateGreen"
#WIKI_SaddleBrown                              = $13458B;  $FF13458B  "#8B4513"  "rgb(912, 69, 19)"  "rgba(912, 69, 19,255)"  "SaddleBrown"
#WIKI_SafetyOrange                             = $0078FF;  $FF0078FF  "#FF7800"  "rgb(167,120,  0)"  "rgba(167,120,  0,255)"  "SafetyOrange"
#WIKI_SafetyOrange_BlazeOrange                 = $0067FF;  $FF0067FF  "#FF6700"  "rgb(167,103,  0)"  "rgba(167,103,  0,255)"  "SafetyOrange_BlazeOrange"
#WIKI_SafetyYellow                             = $02D2EE;  $FF02D2EE  "#EED202"  "rgb(156,210,  2)"  "rgba(156,210,  2,255)"  "SafetyYellow"
#WIKI_Saffron                                  = $30C4F4;  $FF30C4F4  "#F4C430"  "rgb(160,196, 48)"  "rgba(160,196, 48,255)"  "Saffron"
#WIKI_Sage                                     = $8AB8BC;  $FF8AB8BC  "#BCB88A"  "rgb(123,184,138)"  "rgba(123,184,138,255)"  "Sage"
#WIKI_StPatricksBlue                           = $7A2923;  $FF7A2923  "#23297A"  "rgb(230, 41,122)"  "rgba(230, 41,122,255)"  "StPatricksBlue"
#WIKI_Salmon                                   = $7280FA;  $FF7280FA  "#FA8072"  "rgb(164,128,114)"  "rgba(164,128,114,255)"  "Salmon"
#WIKI_SalmonPink                               = $A491FF;  $FFA491FF  "#FF91A4"  "rgb(167,145,164)"  "rgba(167,145,164,255)"  "SalmonPink"
#WIKI_Sand                                     = $80B2C2;  $FF80B2C2  "#C2B280"  "rgb(127,178,128)"  "rgba(127,178,128,255)"  "Sand"
#WIKI_SandDune                                 = $177196;  $FF177196  "#967117"  "rgb(985,113, 23)"  "rgba(985,113, 23,255)"  "SandDune"
#WIKI_Sandstorm                                = $40D5EC;  $FF40D5EC  "#ECD540"  "rgb(155,213, 64)"  "rgba(155,213, 64,255)"  "Sandstorm"
#WIKI_SandyBrown                               = $60A4F4;  $FF60A4F4  "#F4A460"  "rgb(160,164, 96)"  "rgba(160,164, 96,255)"  "SandyBrown"
#WIKI_SandyTan                                 = $B5D9FD;  $FFB5D9FD  "#FDD9B5"  "rgb(166,217,181)"  "rgba(166,217,181,255)"  "SandyTan"
#WIKI_SandyTaupe                               = $177196;  $FF177196  "#967117"  "rgb(985,113, 23)"  "rgba(985,113, 23,255)"  "SandyTaupe"
#WIKI_Sangria                                  = $0A0092;  $FF0A0092  "#92000A"  "rgb(956,  0, 10)"  "rgba(956,  0, 10,255)"  "Sangria"
#WIKI_SapGreen                                 = $2A7D50;  $FF2A7D50  "#507D2A"  "rgb(527,125, 42)"  "rgba(527,125, 42,255)"  "SapGreen"
#WIKI_Sapphire                                 = $BA520F;  $FFBA520F  "#0F52BA"  "rgb(100, 82,186)"  "rgba(100, 82,186,255)"  "Sapphire"
#WIKI_SapphireBlue                             = $A56700;  $FFA56700  "#0067A5"  "rgb(265,103,165)"  "rgba(265,103,165,255)"  "SapphireBlue"
#WIKI_SasquatchSocks                           = $8146FF;  $FF8146FF  "#FF4681"  "rgb(167, 70,129)"  "rgba(167, 70,129,255)"  "SasquatchSocks"
#WIKI_SatinSheenGold                           = $35A1CB;  $FF35A1CB  "#CBA135"  "rgb(133,161, 53)"  "rgba(133,161, 53,255)"  "SatinSheenGold"
#WIKI_Scarlet                                  = $0024FF;  $FF0024FF  "#FF2400"  "rgb(167, 36,  0)"  "rgba(167, 36,  0,255)"  "Scarlet"
#WIKI_Scarlet_                                 = $350EFD;  $FF350EFD  "#FD0E35"  "rgb(165, 14, 53)"  "rgba(165, 14, 53,255)"  "Scarlet_"
#WIKI_SchaussPink                              = $AF91FF;  $FFAF91FF  "#FF91AF"  "rgb(167,145,175)"  "rgba(167,145,175,255)"  "SchaussPink"
#WIKI_SchoolBusYellow                          = $00D8FF;  $FF00D8FF  "#FFD800"  "rgb(167,216,  0)"  "rgba(167,216,  0,255)"  "SchoolBusYellow"
#WIKI_ScreaminGreen                            = $66FF66;  $FF66FF66  "#66FF66"  "rgb(675,255,102)"  "rgba(675,255,102,255)"  "ScreaminGreen"
#WIKI_SeaBlue                                  = $946900;  $FF946900  "#006994"  "rgb(270,105,148)"  "rgba(270,105,148,255)"  "SeaBlue"
#WIKI_SeaFoamGreen                             = $BFE29F;  $FFBFE29F  "#9FE2BF"  "rgb(104,226,191)"  "rgba(104,226,191,255)"  "SeaFoamGreen"
#WIKI_SeaGreen                                 = $578B2E;  $FF578B2E  "#2E8B57"  "rgb(305,139, 87)"  "rgba(305,139, 87,255)"  "SeaGreen"
#WIKI_SeaSerpent                               = $CFC74B;  $FFCFC74B  "#4BC7CF"  "rgb(496,199,207)"  "rgba(496,199,207,255)"  "SeaSerpent"
#WIKI_SealBrown                                = $0B2659;  $FF0B2659  "#59260B"  "rgb(584, 38, 11)"  "rgba(584, 38, 11,255)"  "SealBrown"
#WIKI_Seashell                                 = $EEF5FF;  $FFEEF5FF  "#FFF5EE"  "rgb(167,245,238)"  "rgba(167,245,238,255)"  "Seashell"
#WIKI_SelectiveYellow                          = $00BAFF;  $FF00BAFF  "#FFBA00"  "rgb(167,186,  0)"  "rgba(167,186,  0,255)"  "SelectiveYellow"
#WIKI_Sepia                                    = $144270;  $FF144270  "#704214"  "rgb(735, 66, 20)"  "rgba(735, 66, 20,255)"  "Sepia"
#WIKI_Shadow                                   = $5D798A;  $FF5D798A  "#8A795D"  "rgb(907,121, 93)"  "rgba(907,121, 93,255)"  "Shadow"
#WIKI_ShadowBlue                               = $A58B77;  $FFA58B77  "#778BA5"  "rgb(783,139,165)"  "rgba(783,139,165,255)"  "ShadowBlue"
#WIKI_Shampoo                                  = $F1CFFF;  $FFF1CFFF  "#FFCFF1"  "rgb(167,207,241)"  "rgba(167,207,241,255)"  "Shampoo"
#WIKI_ShamrockGreen                            = $609E00;  $FF609E00  "#009E60"  "rgb(405,158, 96)"  "rgba(405,158, 96,255)"  "ShamrockGreen"
#WIKI_SheenGreen                               = $00D48F;  $FF00D48F  "#8FD400"  "rgb(942,212,  0)"  "rgba(942,212,  0,255)"  "SheenGreen"
#WIKI_ShimmeringBlush                          = $9586D9;  $FF9586D9  "#D98695"  "rgb(142,134,149)"  "rgba(142,134,149,255)"  "ShimmeringBlush"
#WIKI_ShinyShamrock                            = $78A75F;  $FF78A75F  "#5FA778"  "rgb(626,167,120)"  "rgba(626,167,120,255)"  "ShinyShamrock"
#WIKI_ShockingPink                             = $C00FFC;  $FFC00FFC  "#FC0FC0"  "rgb(165, 15,192)"  "rgba(165, 15,192,255)"  "ShockingPink"
#WIKI_ShockingPink_Crayola                     = $FF6FFF;  $FFFF6FFF  "#FF6FFF"  "rgb(167,111,255)"  "rgba(167,111,255,255)"  "ShockingPink_Crayola"
#WIKI_Sienna                                   = $172D88;  $FF172D88  "#882D17"  "rgb(892, 45, 23)"  "rgba(892, 45, 23,255)"  "Sienna"
#WIKI_Silver                                   = $C0C0C0;  $FFC0C0C0  "#C0C0C0"  "rgb(126,192,192)"  "rgba(126,192,192,255)"  "Silver"
#WIKI_SilverChalice                            = $ACACAC;  $FFACACAC  "#ACACAC"  "rgb(113,172,172)"  "rgba(113,172,172,255)"  "SilverChalice"
#WIKI_SilverLakeBlue                           = $BA895D;  $FFBA895D  "#5D89BA"  "rgb(613,137,186)"  "rgba(613,137,186,255)"  "SilverLakeBlue"
#WIKI_SilverPink                               = $ADAEC4;  $FFADAEC4  "#C4AEAD"  "rgb(128,174,173)"  "rgba(128,174,173,255)"  "SilverPink"
#WIKI_SilverSand                               = $C2C1BF;  $FFC2C1BF  "#BFC1C2"  "rgb(125,193,194)"  "rgba(125,193,194,255)"  "SilverSand"
#WIKI_Sinopia                                  = $0B41CB;  $FF0B41CB  "#CB410B"  "rgb(133, 65, 11)"  "rgba(133, 65, 11,255)"  "Sinopia"
#WIKI_SizzlingRed                              = $5538FF;  $FF5538FF  "#FF3855"  "rgb(167, 56, 85)"  "rgba(167, 56, 85,255)"  "SizzlingRed"
#WIKI_SizzlingSunrise                          = $00DBFF;  $FF00DBFF  "#FFDB00"  "rgb(167,219,  0)"  "rgba(167,219,  0,255)"  "SizzlingSunrise"
#WIKI_Skobeloff                                = $747400;  $FF747400  "#007474"  "rgb(298,116,116)"  "rgba(298,116,116,255)"  "Skobeloff"
#WIKI_SkyBlue                                  = $EBCE87;  $FFEBCE87  "#87CEEB"  "rgb(890,206,235)"  "rgba(890,206,235,255)"  "SkyBlue"
#WIKI_SkyMagenta                               = $AF71CF;  $FFAF71CF  "#CF71AF"  "rgb(135,113,175)"  "rgba(135,113,175,255)"  "SkyMagenta"
#WIKI_SlateBlue                                = $CD5A6A;  $FFCD5A6A  "#6A5ACD"  "rgb(697, 90,205)"  "rgba(697, 90,205,255)"  "SlateBlue"
#WIKI_SlateGray                                = $908070;  $FF908070  "#708090"  "rgb(737,128,144)"  "rgba(737,128,144,255)"  "SlateGray"
#WIKI_Smalt_DarkPowderBlue                     = $993300;  $FF993300  "#003399"  "rgb(132, 51,153)"  "rgba(132, 51,153,255)"  "Smalt_DarkPowderBlue"
#WIKI_SlimyGreen                               = $179629;  $FF179629  "#299617"  "rgb(272,150, 23)"  "rgba(272,150, 23,255)"  "SlimyGreen"
#WIKI_SmashedPumpkin                           = $3A6DFF;  $FF3A6DFF  "#FF6D3A"  "rgb(167,109, 58)"  "rgba(167,109, 58,255)"  "SmashedPumpkin"
#WIKI_Smitten                                  = $8641C8;  $FF8641C8  "#C84186"  "rgb(131, 65,134)"  "rgba(131, 65,134,255)"  "Smitten"
#WIKI_Smoke                                    = $768273;  $FF768273  "#738276"  "rgb(757,130,118)"  "rgba(757,130,118,255)"  "Smoke"
#WIKI_SmokeyTopaz                              = $0D2A83;  $FF0D2A83  "#832A0D"  "rgb(859, 42, 13)"  "rgba(859, 42, 13,255)"  "SmokeyTopaz"
#WIKI_SmokyBlack                               = $080C10;  $FF080C10  "#100C08"  "rgb(105, 12,  8)"  "rgba(105, 12,  8,255)"  "SmokyBlack"
#WIKI_SmokyTopaz                               = $413D93;  $FF413D93  "#933D41"  "rgb(964, 61, 65)"  "rgba(964, 61, 65,255)"  "SmokyTopaz"
#WIKI_Snow                                     = $FAFAFF;  $FFFAFAFF  "#FFFAFA"  "rgb(167,250,250)"  "rgba(167,250,250,255)"  "Snow"
#WIKI_Soap                                     = $EFC8CE;  $FFEFC8CE  "#CEC8EF"  "rgb(135,200,239)"  "rgba(135,200,239,255)"  "Soap"
#WIKI_SolidPink                                = $433889;  $FF433889  "#893843"  "rgb(899, 56, 67)"  "rgba(899, 56, 67,255)"  "SolidPink"
#WIKI_SonicSilver                              = $757575;  $FF757575  "#757575"  "rgb(769,117,117)"  "rgba(769,117,117,255)"  "SonicSilver"
#WIKI_SpartanCrimson                           = $16139E;  $FF16139E  "#9E1316"  "rgb(103, 19, 22)"  "rgba(103, 19, 22,255)"  "SpartanCrimson"
#WIKI_SpaceCadet                               = $51291D;  $FF51291D  "#1D2951"  "rgb(191, 41, 81)"  "rgba(191, 41, 81,255)"  "SpaceCadet"
#WIKI_SpanishBistre                            = $327580;  $FF327580  "#807532"  "rgb(841,117, 50)"  "rgba(841,117, 50,255)"  "SpanishBistre"
#WIKI_SpanishBlue                              = $B87000;  $FFB87000  "#0070B8"  "rgb(288,112,184)"  "rgba(288,112,184,255)"  "SpanishBlue"
#WIKI_SpanishCarmine                           = $4700D1;  $FF4700D1  "#D10047"  "rgb(136,  0, 71)"  "rgba(136,  0, 71,255)"  "SpanishCarmine"
#WIKI_SpanishCrimson                           = $4C1AE5;  $FF4C1AE5  "#E51A4C"  "rgb(150, 26, 76)"  "rgba(150, 26, 76,255)"  "SpanishCrimson"
#WIKI_SpanishGray                              = $989898;  $FF989898  "#989898"  "rgb(100,152,152)"  "rgba(100,152,152,255)"  "SpanishGray"
#WIKI_SpanishGreen                             = $509100;  $FF509100  "#009150"  "rgb(372,145, 80)"  "rgba(372,145, 80,255)"  "SpanishGreen"
#WIKI_SpanishOrange                            = $0061E8;  $FF0061E8  "#E86100"  "rgb(152, 97,  0)"  "rgba(152, 97,  0,255)"  "SpanishOrange"
#WIKI_SpanishPink                              = $BEBFF7;  $FFBEBFF7  "#F7BFBE"  "rgb(162,191,190)"  "rgba(162,191,190,255)"  "SpanishPink"
#WIKI_SpanishRed                               = $2600E6;  $FF2600E6  "#E60026"  "rgb(150,  0, 38)"  "rgba(150,  0, 38,255)"  "SpanishRed"
#WIKI_SpanishSkyBlue                           = $FFFF00;  $FFFFFF00  "#00FFFF"  "rgb(655,255,255)"  "rgba(655,255,255,255)"  "SpanishSkyBlue"
#WIKI_SpanishViolet                            = $82284C;  $FF82284C  "#4C2882"  "rgb(499, 40,130)"  "rgba(499, 40,130,255)"  "SpanishViolet"
#WIKI_SpanishViridian                          = $5C7F00;  $FF5C7F00  "#007F5C"  "rgb(326,127, 92)"  "rgba(326,127, 92,255)"  "SpanishViridian"
#WIKI_SpicyMix                                 = $4D5f8B;  $FF4D5f8B  "#8B5f4D"  "rgb(913, 95, 77)"  "rgba(913, 95, 77,255)"  "SpicyMix"
#WIKI_SpiroDiscoBall                           = $FCC00F;  $FFFCC00F  "#0FC0FC"  "rgb(103,192,252)"  "rgba(103,192,252,255)"  "SpiroDiscoBall"
#WIKI_SpringBud                                = $00FCA7;  $FF00FCA7  "#A7FC00"  "rgb(110,252,  0)"  "rgba(110,252,  0,255)"  "SpringBud"
#WIKI_SpringFrost                              = $2AFF87;  $FF2AFF87  "#87FF2A"  "rgb(891,255, 42)"  "rgba(891,255, 42,255)"  "SpringFrost"
#WIKI_SpringGreen                              = $7FFF00;  $FF7FFF00  "#00FF7F"  "rgb(654,255,127)"  "rgba(654,255,127,255)"  "SpringGreen"
#WIKI_StarCommandBlue                          = $B87B00;  $FFB87B00  "#007BB8"  "rgb(316,123,184)"  "rgba(316,123,184,255)"  "StarCommandBlue"
#WIKI_SteelBlue                                = $B48246;  $FFB48246  "#4682B4"  "rgb(462,130,180)"  "rgba(462,130,180,255)"  "SteelBlue"
#WIKI_SteelPink                                = $CC33CC;  $FFCC33CC  "#CC33CC"  "rgb(133, 51,204)"  "rgba(133, 51,204,255)"  "SteelPink"
#WIKI_SteelTeal                                = $8B8A5F;  $FF8B8A5F  "#5F8A8B"  "rgb(626,138,139)"  "rgba(626,138,139,255)"  "SteelTeal"
#WIKI_StilDeGrainYellow                        = $5EDAFA;  $FF5EDAFA  "#FADA5E"  "rgb(164,218, 94)"  "rgba(164,218, 94,255)"  "StilDeGrainYellow"
#WIKI_Stizza                                   = $000099;  $FF000099  "#990000"  "rgb(100,  0,  0)"  "rgba(100,  0,  0,255)"  "Stizza"
#WIKI_Stormcloud                               = $6A664F;  $FF6A664F  "#4F666A"  "rgb(520,102,106)"  "rgba(520,102,106,255)"  "Stormcloud"
#WIKI_Straw                                    = $6FD9E4;  $FF6FD9E4  "#E4D96F"  "rgb(149,217,111)"  "rgba(149,217,111,255)"  "Straw"
#WIKI_Strawberry                               = $8D5AFC;  $FF8D5AFC  "#FC5A8D"  "rgb(165, 90,141)"  "rgba(165, 90,141,255)"  "Strawberry"
#WIKI_SugarPlum                                = $754E91;  $FF754E91  "#914E75"  "rgb(952, 78,117)"  "rgba(952, 78,117,255)"  "SugarPlum"
#WIKI_SunburntCyclops                          = $4C40FF;  $FF4C40FF  "#FF404C"  "rgb(167, 64, 76)"  "rgba(167, 64, 76,255)"  "SunburntCyclops"
#WIKI_Sunglow                                  = $33CCFF;  $FF33CCFF  "#FFCC33"  "rgb(167,204, 51)"  "rgba(167,204, 51,255)"  "Sunglow"
#WIKI_Sunny                                    = $7AF2F2;  $FF7AF2F2  "#F2F27A"  "rgb(159,242,122)"  "rgba(159,242,122,255)"  "Sunny"
#WIKI_Sunray                                   = $57ABE3;  $FF57ABE3  "#E3AB57"  "rgb(149,171, 87)"  "rgba(149,171, 87,255)"  "Sunray"
#WIKI_Sunset                                   = $A5D6FA;  $FFA5D6FA  "#FAD6A5"  "rgb(164,214,165)"  "rgba(164,214,165,255)"  "Sunset"
#WIKI_SunsetOrange                             = $535EFD;  $FF535EFD  "#FD5E53"  "rgb(166, 94, 83)"  "rgba(166, 94, 83,255)"  "SunsetOrange"
#WIKI_SuperPink                                = $A96BCF;  $FFA96BCF  "#CF6BA9"  "rgb(135,107,169)"  "rgba(135,107,169,255)"  "SuperPink"
#WIKI_SweetBrown                               = $3137A8;  $FF3137A8  "#A83731"  "rgb(110, 55, 49)"  "rgba(110, 55, 49,255)"  "SweetBrown"
#WIKI_Tan                                      = $8CB4D2;  $FF8CB4D2  "#D2B48C"  "rgb(138,180,140)"  "rgba(138,180,140,255)"  "Tan"
#WIKI_Tangelo                                  = $004DF9;  $FF004DF9  "#F94D00"  "rgb(163, 77,  0)"  "rgba(163, 77,  0,255)"  "Tangelo"
#WIKI_Tangerine                                = $0085F2;  $FF0085F2  "#F28500"  "rgb(158,133,  0)"  "rgba(158,133,  0,255)"  "Tangerine"
#WIKI_TangerineYellow                          = $00CCFF;  $FF00CCFF  "#FFCC00"  "rgb(167,204,  0)"  "rgba(167,204,  0,255)"  "TangerineYellow"
#WIKI_TangoPink                                = $7A71E4;  $FF7A71E4  "#E4717A"  "rgb(149,113,122)"  "rgba(149,113,122,255)"  "TangoPink"
#WIKI_TartOrange                               = $464DFB;  $FF464DFB  "#FB4D46"  "rgb(164, 77, 70)"  "rgba(164, 77, 70,255)"  "TartOrange"
#WIKI_Taupe                                    = $323C48;  $FF323C48  "#483C32"  "rgb(473, 60, 50)"  "rgba(473, 60, 50,255)"  "Taupe"
#WIKI_TaupeGray                                = $89858B;  $FF89858B  "#8B8589"  "rgb(914,133,137)"  "rgba(914,133,137,255)"  "TaupeGray"
#WIKI_TeaGreen                                 = $C0F0D0;  $FFC0F0D0  "#D0F0C0"  "rgb(136,240,192)"  "rgba(136,240,192,255)"  "TeaGreen"
#WIKI_TeaRose                                  = $7983F8;  $FF7983F8  "#F88379"  "rgb(162,131,121)"  "rgba(162,131,121,255)"  "TeaRose"
#WIKI_TeaRose_                                 = $C2C2F4;  $FFC2C2F4  "#F4C2C2"  "rgb(160,194,194)"  "rgba(160,194,194,255)"  "TeaRose_"
#WIKI_Teal                                     = $808000;  $FF808000  "#008080"  "rgb(328,128,128)"  "rgba(328,128,128,255)"  "Teal"
#WIKI_TealBlue                                 = $887536;  $FF887536  "#367588"  "rgb(356,117,136)"  "rgba(356,117,136,255)"  "TealBlue"
#WIKI_TealDeer                                 = $B3E699;  $FFB3E699  "#99E6B3"  "rgb(100,230,179)"  "rgba(100,230,179,255)"  "TealDeer"
#WIKI_TealGreen                                = $7F8200;  $FF7F8200  "#00827F"  "rgb(334,130,127)"  "rgba(334,130,127,255)"  "TealGreen"
#WIKI_Telemagenta                              = $7634CF;  $FF7634CF  "#CF3476"  "rgb(135, 52,118)"  "rgba(135, 52,118,255)"  "Telemagenta"
#WIKI_Tenne                                    = $0057CD;  $FF0057CD  "#CD5700"  "rgb(134, 87,  0)"  "rgba(134, 87,  0,255)"  "Tenne"
#WIKI_TerraCotta                               = $5B72E2;  $FF5B72E2  "#E2725B"  "rgb(148,114, 91)"  "rgba(148,114, 91,255)"  "TerraCotta"
#WIKI_Thistle                                  = $D8BFD8;  $FFD8BFD8  "#D8BFD8"  "rgb(142,191,216)"  "rgba(142,191,216,255)"  "Thistle"
#WIKI_ThulianPink                              = $A16FDE;  $FFA16FDE  "#DE6FA1"  "rgb(145,111,161)"  "rgba(145,111,161,255)"  "ThulianPink"
#WIKI_TickleMePink                             = $AC89FC;  $FFAC89FC  "#FC89AC"  "rgb(165,137,172)"  "rgba(165,137,172,255)"  "TickleMePink"
#WIKI_TiffanyBlue                              = $B5BA0A;  $FFB5BA0A  "#0ABAB5"  "rgb(703,186,181)"  "rgba(703,186,181,255)"  "TiffanyBlue"
#WIKI_TigersEye                                = $3C8DE0;  $FF3C8DE0  "#E08D3C"  "rgb(147,141, 60)"  "rgba(147,141, 60,255)"  "TigersEye"
#WIKI_Timberwolf                               = $D2D7DB;  $FFD2D7DB  "#DBD7D2"  "rgb(144,215,210)"  "rgba(144,215,210,255)"  "Timberwolf"
#WIKI_TitaniumYellow                           = $00E6EE;  $FF00E6EE  "#EEE600"  "rgb(156,230,  0)"  "rgba(156,230,  0,255)"  "TitaniumYellow"
#WIKI_Tomato                                   = $4763FF;  $FF4763FF  "#FF6347"  "rgb(167, 99, 71)"  "rgba(167, 99, 71,255)"  "Tomato"
#WIKI_Toolbox                                  = $C06C74;  $FFC06C74  "#746CC0"  "rgb(763,108,192)"  "rgba(763,108,192,255)"  "Toolbox"
#WIKI_Topaz                                    = $7CC8FF;  $FF7CC8FF  "#FFC87C"  "rgb(167,200,124)"  "rgba(167,200,124,255)"  "Topaz"
#WIKI_TractorRed                               = $350EFD;  $FF350EFD  "#FD0E35"  "rgb(165, 14, 53)"  "rgba(165, 14, 53,255)"  "TractorRed"
#WIKI_TrolleyGrey                              = $808080;  $FF808080  "#808080"  "rgb(842,128,128)"  "rgba(842,128,128,255)"  "TrolleyGrey"
#WIKI_TropicalRainForest                       = $5E7500;  $FF5E7500  "#00755E"  "rgb(300,117, 94)"  "rgba(300,117, 94,255)"  "TropicalRainForest"
#WIKI_TropicalViolet                           = $DEA4CD;  $FFDEA4CD  "#CDA4DE"  "rgb(134,164,222)"  "rgba(134,164,222,255)"  "TropicalViolet"
#WIKI_TrueBlue                                 = $CF7300;  $FFCF7300  "#0073CF"  "rgb(296,115,207)"  "rgba(296,115,207,255)"  "TrueBlue"
#WIKI_TuftsBlue                                = $C17D41;  $FFC17D41  "#417DC1"  "rgb(429,125,193)"  "rgba(429,125,193,255)"  "TuftsBlue"
#WIKI_Tulip                                    = $8D87FF;  $FF8D87FF  "#FF878D"  "rgb(167,135,141)"  "rgba(167,135,141,255)"  "Tulip"
#WIKI_Tumbleweed                               = $88AADE;  $FF88AADE  "#DEAA88"  "rgb(145,170,136)"  "rgba(145,170,136,255)"  "Tumbleweed"
#WIKI_TurkishRose                              = $8172B5;  $FF8172B5  "#B57281"  "rgb(118,114,129)"  "rgba(118,114,129,255)"  "TurkishRose"
#WIKI_Turquoise                                = $D0E040;  $FFD0E040  "#40E0D0"  "rgb(425,224,208)"  "rgba(425,224,208,255)"  "Turquoise"
#WIKI_TurquoiseBlue                            = $EFFF00;  $FFEFFF00  "#00FFEF"  "rgb(655,255,239)"  "rgba(655,255,239,255)"  "TurquoiseBlue"
#WIKI_TurquoiseGreen                           = $B4D6A0;  $FFB4D6A0  "#A0D6B4"  "rgb(105,214,180)"  "rgba(105,214,180,255)"  "TurquoiseGreen"
#WIKI_TurquoiseSurf                            = $CDC500;  $FFCDC500  "#00C5CD"  "rgb(506,197,205)"  "rgba(506,197,205,255)"  "TurquoiseSurf"
#WIKI_TurtleGreen                              = $5B9A8A;  $FF5B9A8A  "#8A9A5B"  "rgb(908,154, 91)"  "rgba(908,154, 91,255)"  "TurtleGreen"
#WIKI_Tuscan                                   = $A5D6FA;  $FFA5D6FA  "#FAD6A5"  "rgb(164,214,165)"  "rgba(164,214,165,255)"  "Tuscan"
#WIKI_TuscanBrown                              = $374E6F;  $FF374E6F  "#6F4E37"  "rgb(729, 78, 55)"  "rgba(729, 78, 55,255)"  "TuscanBrown"
#WIKI_TuscanRed                                = $48487C;  $FF48487C  "#7C4848"  "rgb(814, 72, 72)"  "rgba(814, 72, 72,255)"  "TuscanRed"
#WIKI_TuscanTan                                = $5B7BA6;  $FF5B7BA6  "#A67B5B"  "rgb(109,123, 91)"  "rgba(109,123, 91,255)"  "TuscanTan"
#WIKI_Tuscany                                  = $9999C0;  $FF9999C0  "#C09999"  "rgb(126,153,153)"  "rgba(126,153,153,255)"  "Tuscany"
#WIKI_TwilightLavender                         = $6B498A;  $FF6B498A  "#8A496B"  "rgb(906, 73,107)"  "rgba(906, 73,107,255)"  "TwilightLavender"
#WIKI_TyrianPurple                             = $3C0266;  $FF3C0266  "#66023C"  "rgb(668,  2, 60)"  "rgba(668,  2, 60,255)"  "TyrianPurple"
#WIKI_UaBlue                                   = $AA3300;  $FFAA3300  "#0033AA"  "rgb(132, 51,170)"  "rgba(132, 51,170,255)"  "UaBlue"
#WIKI_UaRed                                    = $4C00D9;  $FF4C00D9  "#D9004C"  "rgb(142,  0, 76)"  "rgba(142,  0, 76,255)"  "UaRed"
#WIKI_Ube                                      = $C37888;  $FFC37888  "#8878C3"  "rgb(894,120,195)"  "rgba(894,120,195,255)"  "Ube"
#WIKI_UclaBlue                                 = $956853;  $FF956853  "#536895"  "rgb(546,104,149)"  "rgba(546,104,149,255)"  "UclaBlue"
#WIKI_UclaGold                                 = $00B3FF;  $FF00B3FF  "#FFB300"  "rgb(167,179,  0)"  "rgba(167,179,  0,255)"  "UclaGold"
#WIKI_UfoGreen                                 = $70D03C;  $FF70D03C  "#3CD070"  "rgb(398,208,112)"  "rgba(398,208,112,255)"  "UfoGreen"
#WIKI_Ultramarine                              = $FF003F;  $FFFF003F  "#3F00FF"  "rgb(412,  0,255)"  "rgba(412,  0,255,255)"  "Ultramarine"
#WIKI_UltramarineBlue                          = $F56641;  $FFF56641  "#4166F5"  "rgb(428,102,245)"  "rgba(428,102,245,255)"  "UltramarineBlue"
#WIKI_UltraPink                                = $FF6FFF;  $FFFF6FFF  "#FF6FFF"  "rgb(167,111,255)"  "rgba(167,111,255,255)"  "UltraPink"
#WIKI_UltraRed                                 = $856CFC;  $FF856CFC  "#FC6C85"  "rgb(165,108,133)"  "rgba(165,108,133,255)"  "UltraRed"
#WIKI_Umber                                    = $475163;  $FF475163  "#635147"  "rgb(650, 81, 71)"  "rgba(650, 81, 71,255)"  "Umber"
#WIKI_UnbleachedSilk                           = $CADDFF;  $FFCADDFF  "#FFDDCA"  "rgb(167,221,202)"  "rgba(167,221,202,255)"  "UnbleachedSilk"
#WIKI_UnitedNationsBlue                        = $E5925B;  $FFE5925B  "#5B92E5"  "rgb(600,146,229)"  "rgba(600,146,229,255)"  "UnitedNationsBlue"
#WIKI_UniversityOfCaliforniaGold               = $2787B7;  $FF2787B7  "#B78727"  "rgb(120,135, 39)"  "rgba(120,135, 39,255)"  "UniversityOfCaliforniaGold"
#WIKI_UnmellowYellow                           = $66FFFF;  $FF66FFFF  "#FFFF66"  "rgb(167,255,102)"  "rgba(167,255,102,255)"  "UnmellowYellow"
#WIKI_UpForestGreen                            = $214401;  $FF214401  "#014421"  "rgb(829, 68, 33)"  "rgba(829, 68, 33,255)"  "UpForestGreen"
#WIKI_UpMaroon                                 = $13117B;  $FF13117B  "#7B1113"  "rgb(806, 17, 19)"  "rgba(806, 17, 19,255)"  "UpMaroon"
#WIKI_UpsdellRed                               = $2920AE;  $FF2920AE  "#AE2029"  "rgb(114, 32, 41)"  "rgba(114, 32, 41,255)"  "UpsdellRed"
#WIKI_Urobilin                                 = $21ADE1;  $FF21ADE1  "#E1AD21"  "rgb(147,173, 33)"  "rgba(147,173, 33,255)"  "Urobilin"
#WIKI_UsafaBlue                                = $984F00;  $FF984F00  "#004F98"  "rgb(203, 79,152)"  "rgba(203, 79,152,255)"  "UsafaBlue"
#WIKI_UscCardinal                              = $000099;  $FF000099  "#990000"  "rgb(100,  0,  0)"  "rgba(100,  0,  0,255)"  "UscCardinal"
#WIKI_UscGold                                  = $00CCFF;  $FF00CCFF  "#FFCC00"  "rgb(167,204,  0)"  "rgba(167,204,  0,255)"  "UscGold"
#WIKI_UniversityOfTennesseeOrange              = $007FF7;  $FF007FF7  "#F77F00"  "rgb(162,127,  0)"  "rgba(162,127,  0,255)"  "UniversityOfTennesseeOrange"
#WIKI_UtahCrimson                              = $3F00D3;  $FF3F00D3  "#D3003F"  "rgb(138,  0, 63)"  "rgba(138,  0, 63,255)"  "UtahCrimson"
#WIKI_VanDykeBrown                             = $284266;  $FF284266  "#664228"  "rgb(670, 66, 40)"  "rgba(670, 66, 40,255)"  "VanDykeBrown"
#WIKI_Vanilla                                  = $ABE5F3;  $FFABE5F3  "#F3E5AB"  "rgb(159,229,171)"  "rgba(159,229,171,255)"  "Vanilla"
#WIKI_VanillaIce                               = $A98FF3;  $FFA98FF3  "#F38FA9"  "rgb(159,143,169)"  "rgba(159,143,169,255)"  "VanillaIce"
#WIKI_VegasGold                                = $58B3C5;  $FF58B3C5  "#C5B358"  "rgb(129,179, 88)"  "rgba(129,179, 88,255)"  "VegasGold"
#WIKI_VenetianRed                              = $1508C8;  $FF1508C8  "#C80815"  "rgb(131,  8, 21)"  "rgba(131,  8, 21,255)"  "VenetianRed"
#WIKI_Verdigris                                = $AEB343;  $FFAEB343  "#43B3AE"  "rgb(443,179,174)"  "rgba(443,179,174,255)"  "Verdigris"
#WIKI_Vermilion                                = $3442E3;  $FF3442E3  "#E34234"  "rgb(148, 66, 52)"  "rgba(148, 66, 52,255)"  "Vermilion"
#WIKI_Vermilion_                               = $1E38D9;  $FF1E38D9  "#D9381E"  "rgb(142, 56, 30)"  "rgba(142, 56, 30,255)"  "Vermilion_"
#WIKI_Veronica                                 = $F020A0;  $FFF020A0  "#A020F0"  "rgb(104, 32,240)"  "rgba(104, 32,240,255)"  "Veronica"
#WIKI_VeryLightAzure                           = $FBBB74;  $FFFBBB74  "#74BBFB"  "rgb(765,187,251)"  "rgba(765,187,251,255)"  "VeryLightAzure"
#WIKI_VeryLightBlue                            = $FF6666;  $FFFF6666  "#6666FF"  "rgb(671,102,255)"  "rgba(671,102,255,255)"  "VeryLightBlue"
#WIKI_VeryLightMalachiteGreen                  = $86E964;  $FF86E964  "#64E986"  "rgb(661,233,134)"  "rgba(661,233,134,255)"  "VeryLightMalachiteGreen"
#WIKI_VeryLightTangelo                         = $77B0FF;  $FF77B0FF  "#FFB077"  "rgb(167,176,119)"  "rgba(167,176,119,255)"  "VeryLightTangelo"
#WIKI_VeryPaleOrange                           = $BFDFFF;  $FFBFDFFF  "#FFDFBF"  "rgb(167,223,191)"  "rgba(167,223,191,255)"  "VeryPaleOrange"
#WIKI_VeryPaleYellow                           = $BFFFFF;  $FFBFFFFF  "#FFFFBF"  "rgb(167,255,191)"  "rgba(167,255,191,255)"  "VeryPaleYellow"
#WIKI_Violet                                   = $FF008F;  $FFFF008F  "#8F00FF"  "rgb(937,  0,255)"  "rgba(937,  0,255,255)"  "Violet"
#WIKI_Violet_ColorWheel                        = $FF007F;  $FFFF007F  "#7F00FF"  "rgb(832,  0,255)"  "rgba(832,  0,255,255)"  "Violet_ColorWheel"
#WIKI_Violet_Ryb                               = $AF0186;  $FFAF0186  "#8601AF"  "rgb(878,  1,175)"  "rgba(878,  1,175,255)"  "Violet_Ryb"
#WIKI_Violet_Web                               = $EE82EE;  $FFEE82EE  "#EE82EE"  "rgb(156,130,238)"  "rgba(156,130,238,255)"  "Violet_Web"
#WIKI_VioletBlue                               = $B24A32;  $FFB24A32  "#324AB2"  "rgb(329, 74,178)"  "rgba(329, 74,178,255)"  "VioletBlue"
#WIKI_VioletRed                                = $9453F7;  $FF9453F7  "#F75394"  "rgb(162, 83,148)"  "rgba(162, 83,148,255)"  "VioletRed"
#WIKI_Viridian                                 = $6D8240;  $FF6D8240  "#40826D"  "rgb(422,130,109)"  "rgba(422,130,109,255)"  "Viridian"
#WIKI_ViridianGreen                            = $989600;  $FF989600  "#009698"  "rgb(385,150,152)"  "rgba(385,150,152,255)"  "ViridianGreen"
#WIKI_VistaBlue                                = $D99E7C;  $FFD99E7C  "#7C9ED9"  "rgb(816,158,217)"  "rgba(816,158,217,255)"  "VistaBlue"
#WIKI_VividAmber                               = $0099CC;  $FF0099CC  "#CC9900"  "rgb(134,153,  0)"  "rgba(134,153,  0,255)"  "VividAmber"
#WIKI_VividAuburn                              = $242792;  $FF242792  "#922724"  "rgb(957, 39, 36)"  "rgba(957, 39, 36,255)"  "VividAuburn"
#WIKI_VividBurgundy                            = $351D9F;  $FF351D9F  "#9F1D35"  "rgb(104, 29, 53)"  "rgba(104, 29, 53,255)"  "VividBurgundy"
#WIKI_VividCerise                              = $811DDA;  $FF811DDA  "#DA1D81"  "rgb(142, 29,129)"  "rgba(142, 29,129,255)"  "VividCerise"
#WIKI_VividCerulean                            = $EEAA00;  $FFEEAA00  "#00AAEE"  "rgb(437,170,238)"  "rgba(437,170,238,255)"  "VividCerulean"
#WIKI_VividCrimson                             = $3300CC;  $FF3300CC  "#CC0033"  "rgb(133,  0, 51)"  "rgba(133,  0, 51,255)"  "VividCrimson"
#WIKI_VividGamboge                             = $0099FF;  $FF0099FF  "#FF9900"  "rgb(167,153,  0)"  "rgba(167,153,  0,255)"  "VividGamboge"
#WIKI_VividLimeGreen                           = $08D6A6;  $FF08D6A6  "#A6D608"  "rgb(109,214,  8)"  "rgba(109,214,  8,255)"  "VividLimeGreen"
#WIKI_VividMalachite                           = $33CC00;  $FF33CC00  "#00CC33"  "rgb(522,204, 51)"  "rgba(522,204, 51,255)"  "VividMalachite"
#WIKI_VividMulberry                            = $E30CB8;  $FFE30CB8  "#B80CE3"  "rgb(120, 12,227)"  "rgba(120, 12,227,255)"  "VividMulberry"
#WIKI_VividOrange                              = $005FFF;  $FF005FFF  "#FF5F00"  "rgb(167, 95,  0)"  "rgba(167, 95,  0,255)"  "VividOrange"
#WIKI_VividOrangePeel                          = $00A0FF;  $FF00A0FF  "#FFA000"  "rgb(167,160,  0)"  "rgba(167,160,  0,255)"  "VividOrangePeel"
#WIKI_VividOrchid                              = $FF00CC;  $FFFF00CC  "#CC00FF"  "rgb(133,  0,255)"  "rgba(133,  0,255,255)"  "VividOrchid"
#WIKI_VividRaspberry                           = $6C00FF;  $FF6C00FF  "#FF006C"  "rgb(167,  0,108)"  "rgba(167,  0,108,255)"  "VividRaspberry"
#WIKI_VividRed                                 = $1A0DF7;  $FF1A0DF7  "#F70D1A"  "rgb(161, 13, 26)"  "rgba(161, 13, 26,255)"  "VividRed"
#WIKI_VividRedTangelo                          = $2461DF;  $FF2461DF  "#DF6124"  "rgb(146, 97, 36)"  "rgba(146, 97, 36,255)"  "VividRedTangelo"
#WIKI_VividSkyBlue                             = $FFCC00;  $FFFFCC00  "#00CCFF"  "rgb(524,204,255)"  "rgba(524,204,255,255)"  "VividSkyBlue"
#WIKI_VividTangelo                             = $2774F0;  $FF2774F0  "#F07427"  "rgb(157,116, 39)"  "rgba(157,116, 39,255)"  "VividTangelo"
#WIKI_VividTangerine                           = $89A0FF;  $FF89A0FF  "#FFA089"  "rgb(167,160,137)"  "rgba(167,160,137,255)"  "VividTangerine"
#WIKI_VividVermilion                           = $2460E5;  $FF2460E5  "#E56024"  "rgb(150, 96, 36)"  "rgba(150, 96, 36,255)"  "VividVermilion"
#WIKI_VividViolet                              = $FF009F;  $FFFF009F  "#9F00FF"  "rgb(104,  0,255)"  "rgba(104,  0,255,255)"  "VividViolet"
#WIKI_VividYellow                              = $02E3FF;  $FF02E3FF  "#FFE302"  "rgb(167,227,  2)"  "rgba(167,227,  2,255)"  "VividYellow"
#WIKI_Volt                                     = $00FFCE;  $FF00FFCE  "#CEFF00"  "rgb(135,255,  0)"  "rgba(135,255,  0,255)"  "Volt"
#WIKI_WageningenGreen                          = $33B234;  $FF33B234  "#34B233"  "rgb(345,178, 51)"  "rgba(345,178, 51,255)"  "WageningenGreen"
#WIKI_WarmBlack                                = $424200;  $FF424200  "#004242"  "rgb(169, 66, 66)"  "rgba(169, 66, 66,255)"  "WarmBlack"
#WIKI_Waterspout                               = $F9F4A4;  $FFF9F4A4  "#A4F4F9"  "rgb(108,244,249)"  "rgba(108,244,249,255)"  "Waterspout"
#WIKI_WeldonBlue                               = $AB987C;  $FFAB987C  "#7C98AB"  "rgb(816,152,171)"  "rgba(816,152,171,255)"  "WeldonBlue"
#WIKI_Wenge                                    = $525464;  $FF525464  "#645452"  "rgb(657, 84, 82)"  "rgba(657, 84, 82,255)"  "Wenge"
#WIKI_Wheat                                    = $B3DEF5;  $FFB3DEF5  "#F5DEB3"  "rgb(161,222,179)"  "rgba(161,222,179,255)"  "Wheat"
#WIKI_White                                    = $FFFFFF;  $FFFFFFFF  "#FFFFFF"  "rgb(167,255,255)"  "rgba(167,255,255,255)"  "White"
#WIKI_WhiteSmoke                               = $F5F5F5;  $FFF5F5F5  "#F5F5F5"  "rgb(161,245,245)"  "rgba(161,245,245,255)"  "WhiteSmoke"
#WIKI_WildBlueYonder                           = $D0ADA2;  $FFD0ADA2  "#A2ADD0"  "rgb(106,173,208)"  "rgba(106,173,208,255)"  "WildBlueYonder"
#WIKI_WildOrchid                               = $A270D4;  $FFA270D4  "#D470A2"  "rgb(139,112,162)"  "rgba(139,112,162,255)"  "WildOrchid"
#WIKI_WildStrawberry                           = $A443FF;  $FFA443FF  "#FF43A4"  "rgb(167, 67,164)"  "rgba(167, 67,164,255)"  "WildStrawberry"
#WIKI_WildWatermelon                           = $856CFC;  $FF856CFC  "#FC6C85"  "rgb(165,108,133)"  "rgba(165,108,133,255)"  "WildWatermelon"
#WIKI_WillpowerOrange                          = $0058FD;  $FF0058FD  "#FD5800"  "rgb(166, 88,  0)"  "rgba(166, 88,  0,255)"  "WillpowerOrange"
#WIKI_WindsorTan                               = $0255A7;  $FF0255A7  "#A75502"  "rgb(109, 85,  2)"  "rgba(109, 85,  2,255)"  "WindsorTan"
#WIKI_Wine                                     = $372F72;  $FF372F72  "#722F37"  "rgb(748, 47, 55)"  "rgba(748, 47, 55,255)"  "Wine"
#WIKI_WineDregs                                = $473167;  $FF473167  "#673147"  "rgb(676, 49, 71)"  "rgba(676, 49, 71,255)"  "WineDregs"
#WIKI_WinterSky                                = $7C00FF;  $FF7C00FF  "#FF007C"  "rgb(167,  0,124)"  "rgba(167,  0,124,255)"  "WinterSky"
#WIKI_WinterWizard                             = $FFE6A0;  $FFFFE6A0  "#A0E6FF"  "rgb(105,230,255)"  "rgba(105,230,255,255)"  "WinterWizard"
#WIKI_WintergreenDream                         = $7D8856;  $FF7D8856  "#56887D"  "rgb(567,136,125)"  "rgba(567,136,125,255)"  "WintergreenDream"
#WIKI_Wisteria                                 = $DCA0C9;  $FFDCA0C9  "#C9A0DC"  "rgb(132,160,220)"  "rgba(132,160,220,255)"  "Wisteria"
#WIKI_WoodBrown                                = $6B9AC1;  $FF6B9AC1  "#C19A6B"  "rgb(126,154,107)"  "rgba(126,154,107,255)"  "WoodBrown"
#WIKI_Xanadu                                   = $788673;  $FF788673  "#738678"  "rgb(757,134,120)"  "rgba(757,134,120,255)"  "Xanadu"
#WIKI_YaleBlue                                 = $924D0F;  $FF924D0F  "#0F4D92"  "rgb(100, 77,146)"  "rgba(100, 77,146,255)"  "YaleBlue"
#WIKI_YankeesBlue                              = $41281C;  $FF41281C  "#1C2841"  "rgb(184, 40, 65)"  "rgba(184, 40, 65,255)"  "YankeesBlue"
#WIKI_Yellow                                   = $00FFFF;  $FF00FFFF  "#FFFF00"  "rgb(167,255,  0)"  "rgba(167,255,  0,255)"  "Yellow"
#WIKI_Yellow_Crayola                           = $83E8FC;  $FF83E8FC  "#FCE883"  "rgb(165,232,131)"  "rgba(165,232,131,255)"  "Yellow_Crayola"
#WIKI_Yellow_Munsell                           = $00CCEF;  $FF00CCEF  "#EFCC00"  "rgb(157,204,  0)"  "rgba(157,204,  0,255)"  "Yellow_Munsell"
#WIKI_Yellow_Ncs                               = $00D3FF;  $FF00D3FF  "#FFD300"  "rgb(167,211,  0)"  "rgba(167,211,  0,255)"  "Yellow_Ncs"
#WIKI_Yellow_Pantone                           = $00DFFE;  $FF00DFFE  "#FEDF00"  "rgb(167,223,  0)"  "rgba(167,223,  0,255)"  "Yellow_Pantone"
#WIKI_Yellow_Process                           = $00EFFF;  $FF00EFFF  "#FFEF00"  "rgb(167,239,  0)"  "rgba(167,239,  0,255)"  "Yellow_Process"
#WIKI_Yellow_Ryb                               = $33FEFE;  $FF33FEFE  "#FEFE33"  "rgb(167,254, 51)"  "rgba(167,254, 51,255)"  "Yellow_Ryb"
#WIKI_YellowGreen                              = $32CD9A;  $FF32CD9A  "#9ACD32"  "rgb(101,205, 50)"  "rgba(101,205, 50,255)"  "YellowGreen"
#WIKI_YellowOrange                             = $42AEFF;  $FF42AEFF  "#FFAE42"  "rgb(167,174, 66)"  "rgba(167,174, 66,255)"  "YellowOrange"
#WIKI_YellowRose                               = $00F0FF;  $FF00F0FF  "#FFF000"  "rgb(167,240,  0)"  "rgba(167,240,  0,255)"  "YellowRose"
#WIKI_YellowSunshine                           = $00F7FF;  $FF00F7FF  "#FFF700"  "rgb(167,247,  0)"  "rgba(167,247,  0,255)"  "YellowSunshine"
#WIKI_Zaffre                                   = $A81400;  $FFA81400  "#0014A8"  "rgb(528, 20,168)"  "rgba(528, 20,168,255)"  "Zaffre"
#WIKI_ZinnwalditeBrown                         = $08162C;  $FF08162C  "#2C1608"  "rgb(288, 22,  8)"  "rgba(288, 22,  8,255)"  "ZinnwalditeBrown"
#WIKI_Zomp                                     = $8EA739;  $FF8EA739  "#39A78E"  "rgb(377,167,142)"  "rgba(377,167,142,255)"  "Zomp"
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 22
; EnableUnicode
; EnableXP